#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 5875
#define LARGE_STATE_COUNT 2125
#define SYMBOL_COUNT 349
#define ALIAS_COUNT 4
#define TOKEN_COUNT 159
#define EXTERNAL_TOKEN_COUNT 30
#define FIELD_COUNT 32
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 125

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_program_token1 = 2,
  anon_sym___END__ = 3,
  anon_sym_ = 4,
  sym_uninterpreted = 5,
  anon_sym_BEGIN = 6,
  anon_sym_LBRACE = 7,
  anon_sym_RBRACE = 8,
  anon_sym_END = 9,
  anon_sym_def = 10,
  anon_sym_LPAREN = 11,
  anon_sym_RPAREN = 12,
  anon_sym_DOT = 13,
  anon_sym_COLON_COLON = 14,
  anon_sym_end = 15,
  anon_sym_rescue = 16,
  anon_sym_EQ = 17,
  anon_sym_COMMA = 18,
  anon_sym_PIPE = 19,
  anon_sym_SEMI = 20,
  anon_sym_DOT_DOT_DOT = 21,
  anon_sym_STAR = 22,
  anon_sym_STAR_STAR = 23,
  anon_sym_nil = 24,
  anon_sym_AMP = 25,
  anon_sym_COLON = 26,
  anon_sym_class = 27,
  anon_sym_LT = 28,
  anon_sym_module = 29,
  anon_sym_return = 30,
  anon_sym_yield = 31,
  anon_sym_break = 32,
  anon_sym_next = 33,
  anon_sym_redo = 34,
  anon_sym_retry = 35,
  anon_sym_if = 36,
  anon_sym_unless = 37,
  anon_sym_while = 38,
  anon_sym_until = 39,
  anon_sym_for = 40,
  anon_sym_in = 41,
  anon_sym_do = 42,
  anon_sym_case = 43,
  anon_sym_when = 44,
  anon_sym_EQ_GT = 45,
  anon_sym_LBRACK = 46,
  anon_sym_RBRACK = 47,
  anon_sym_LBRACK2 = 48,
  anon_sym_LPAREN2 = 49,
  anon_sym_DOT_DOT = 50,
  sym_line = 51,
  sym_file = 52,
  sym_encoding = 53,
  anon_sym_CARET = 54,
  anon_sym_elsif = 55,
  anon_sym_else = 56,
  anon_sym_then = 57,
  anon_sym_begin = 58,
  anon_sym_ensure = 59,
  anon_sym_COLON_COLON2 = 60,
  anon_sym_AMP_DOT = 61,
  anon_sym_PLUS_EQ = 62,
  anon_sym_DASH_EQ = 63,
  anon_sym_STAR_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_SLASH_EQ = 66,
  anon_sym_PIPE_PIPE_EQ = 67,
  anon_sym_PIPE_EQ = 68,
  anon_sym_AMP_AMP_EQ = 69,
  anon_sym_AMP_EQ = 70,
  anon_sym_PERCENT_EQ = 71,
  anon_sym_GT_GT_EQ = 72,
  anon_sym_LT_LT_EQ = 73,
  anon_sym_CARET_EQ = 74,
  anon_sym_QMARK = 75,
  anon_sym_COLON2 = 76,
  anon_sym_and = 77,
  anon_sym_or = 78,
  anon_sym_PIPE_PIPE = 79,
  anon_sym_AMP_AMP = 80,
  anon_sym_LT_LT = 81,
  anon_sym_GT_GT = 82,
  anon_sym_LT_EQ = 83,
  anon_sym_GT = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_PLUS = 86,
  anon_sym_SLASH = 87,
  anon_sym_PERCENT = 88,
  anon_sym_EQ_EQ = 89,
  anon_sym_BANG_EQ = 90,
  anon_sym_EQ_EQ_EQ = 91,
  anon_sym_LT_EQ_GT = 92,
  anon_sym_EQ_TILDE = 93,
  anon_sym_BANG_TILDE = 94,
  anon_sym_defined_QMARK = 95,
  anon_sym_not = 96,
  anon_sym_BANG = 97,
  anon_sym_TILDE = 98,
  anon_sym_DASH = 99,
  anon_sym_PLUS_AT = 100,
  anon_sym_DASH_AT = 101,
  anon_sym_TILDE_AT = 102,
  anon_sym_LBRACK_RBRACK = 103,
  anon_sym_LBRACK_RBRACK_EQ = 104,
  anon_sym_BQUOTE = 105,
  anon_sym_EQ2 = 106,
  anon_sym_undef = 107,
  anon_sym_alias = 108,
  sym_comment = 109,
  sym_integer = 110,
  sym_float = 111,
  anon_sym_i = 112,
  anon_sym_ri = 113,
  anon_sym_r = 114,
  sym_super = 115,
  sym_self = 116,
  sym_true = 117,
  sym_false = 118,
  sym_constant = 119,
  aux_sym_constant_suffix_token1 = 120,
  aux_sym_identifier_suffix_token1 = 121,
  sym_instance_variable = 122,
  sym_class_variable = 123,
  sym_global_variable = 124,
  sym_character = 125,
  anon_sym_POUND_LBRACE = 126,
  aux_sym_string_array_token1 = 127,
  sym_escape_sequence = 128,
  anon_sym_DASH_GT = 129,
  sym__line_break = 130,
  sym__no_line_break = 131,
  sym_simple_symbol = 132,
  sym__string_start = 133,
  sym__symbol_start = 134,
  sym__subshell_start = 135,
  sym__regex_start = 136,
  sym__string_array_start = 137,
  sym__symbol_array_start = 138,
  sym__heredoc_body_start = 139,
  sym_string_content = 140,
  sym_heredoc_content = 141,
  sym__string_end = 142,
  sym_heredoc_end = 143,
  sym_heredoc_beginning = 144,
  sym__block_ampersand = 145,
  sym__splat_star = 146,
  sym__unary_minus = 147,
  sym__unary_minus_num = 148,
  sym__binary_minus = 149,
  sym__binary_star = 150,
  sym__singleton_class_left_angle_left_langle = 151,
  sym_hash_key_symbol = 152,
  sym__identifier_suffix = 153,
  sym__constant_suffix = 154,
  sym__hash_splat_star_star = 155,
  sym__binary_star_star = 156,
  sym__element_reference_bracket = 157,
  sym__short_interpolation = 158,
  sym_program = 159,
  sym_block_body = 160,
  sym__statements = 161,
  sym_begin_block = 162,
  sym_end_block = 163,
  sym__statement = 164,
  sym_method = 165,
  sym_singleton_method = 166,
  sym__method_rest = 167,
  sym_rescue_modifier_arg = 168,
  sym_rescue_modifier_expression = 169,
  sym__body_expr = 170,
  sym_parameters = 171,
  sym_bare_parameters = 172,
  sym_block_parameters = 173,
  sym__formal_parameter = 174,
  sym__simple_formal_parameter = 175,
  sym_forward_parameter = 176,
  sym_splat_parameter = 177,
  sym_hash_splat_parameter = 178,
  sym_hash_splat_nil = 179,
  sym_block_parameter = 180,
  sym_keyword_parameter = 181,
  sym_optional_parameter = 182,
  sym_class = 183,
  sym_superclass = 184,
  sym_singleton_class = 185,
  sym_module = 186,
  sym_return_command = 187,
  sym_yield_command = 188,
  sym_break_command = 189,
  sym_next_command = 190,
  sym_return = 191,
  sym_yield = 192,
  sym_break = 193,
  sym_next = 194,
  sym_redo = 195,
  sym_retry = 196,
  sym_if_modifier = 197,
  sym_unless_modifier = 198,
  sym_while_modifier = 199,
  sym_until_modifier = 200,
  sym_rescue_modifier = 201,
  sym_while = 202,
  sym_until = 203,
  sym_for = 204,
  sym_in = 205,
  sym_do = 206,
  sym_case = 207,
  sym_case_match = 208,
  sym_when = 209,
  sym_in_clause = 210,
  sym_pattern = 211,
  sym__guard = 212,
  sym_if_guard = 213,
  sym_unless_guard = 214,
  sym__pattern_top_expr_body = 215,
  sym__array_pattern_n = 216,
  sym__pattern_expr = 217,
  sym_as_pattern = 218,
  sym__pattern_expr_alt = 219,
  sym_alternative_pattern = 220,
  sym__array_pattern_body = 221,
  sym_array_pattern = 222,
  sym__find_pattern_body = 223,
  sym_find_pattern = 224,
  sym__hash_pattern_body = 225,
  sym_keyword_pattern = 226,
  sym__hash_pattern_any_rest = 227,
  sym_hash_pattern = 228,
  sym__pattern_expr_basic = 229,
  sym_parenthesized_pattern = 230,
  sym__pattern_value = 231,
  sym__pattern_range = 232,
  sym__pattern_primitive = 233,
  sym__pattern_lambda = 234,
  sym__pattern_literal = 235,
  sym__keyword_variable = 236,
  sym_variable_reference_pattern = 237,
  sym_expression_reference_pattern = 238,
  sym__pattern_constant = 239,
  sym__pattern_constant_resolution = 240,
  sym_if = 241,
  sym_unless = 242,
  sym_elsif = 243,
  sym_else = 244,
  sym_then = 245,
  sym_begin = 246,
  sym_ensure = 247,
  sym_rescue = 248,
  sym_exceptions = 249,
  sym_exception_variable = 250,
  sym_body_statement = 251,
  sym__body_statement = 252,
  sym__expression = 253,
  sym_match_pattern = 254,
  sym_test_pattern = 255,
  sym__arg = 256,
  sym__unary_minus_pow = 257,
  sym__pow = 258,
  sym__primary = 259,
  sym_parenthesized_statements = 260,
  sym_element_reference = 261,
  sym_scope_resolution = 262,
  sym__call = 263,
  sym_command_call = 264,
  sym_command_call_with_block = 265,
  sym__chained_command_call = 266,
  sym_call = 267,
  sym_command_argument_list = 268,
  sym_argument_list = 269,
  sym__argument_list_with_trailing_comma = 270,
  sym__argument = 271,
  sym_forward_argument = 272,
  sym_splat_argument = 273,
  sym_hash_splat_argument = 274,
  sym_block_argument = 275,
  sym_do_block = 276,
  sym_block = 277,
  sym_assignment = 278,
  sym_command_assignment = 279,
  sym_operator_assignment = 280,
  sym_command_operator_assignment = 281,
  sym_conditional = 282,
  sym_range = 283,
  sym_binary = 284,
  sym_command_binary = 285,
  sym_unary = 286,
  sym_command_unary = 287,
  sym_parenthesized_unary = 288,
  sym_unary_literal = 289,
  sym__literal = 290,
  sym__numeric = 291,
  sym__simple_numeric = 292,
  sym_right_assignment_list = 293,
  sym_left_assignment_list = 294,
  sym__mlhs = 295,
  sym_destructured_left_assignment = 296,
  sym_rest_assignment = 297,
  sym__function_identifier = 298,
  sym__function_identifier_call = 299,
  sym__lhs = 300,
  sym__variable = 301,
  sym_operator = 302,
  sym__method_name = 303,
  sym__nonlocal_variable = 304,
  sym_setter = 305,
  sym_undef = 306,
  sym_alias = 307,
  sym__int_or_float = 308,
  sym_complex = 309,
  sym_rational = 310,
  sym_nil = 311,
  sym_constant_suffix = 312,
  sym_identifier_suffix = 313,
  sym_chained_string = 314,
  sym_interpolation = 315,
  sym_string = 316,
  sym_subshell = 317,
  sym_string_array = 318,
  sym_symbol_array = 319,
  sym_delimited_symbol = 320,
  sym_regex = 321,
  sym_heredoc_body = 322,
  aux_sym__literal_contents = 323,
  sym_array = 324,
  sym_hash = 325,
  sym_pair = 326,
  sym_lambda = 327,
  sym_empty_statement = 328,
  sym__terminator = 329,
  aux_sym__statements_repeat1 = 330,
  aux_sym_parameters_repeat1 = 331,
  aux_sym_block_parameters_repeat1 = 332,
  aux_sym_case_repeat1 = 333,
  aux_sym_case_match_repeat1 = 334,
  aux_sym_when_repeat1 = 335,
  aux_sym__array_pattern_n_repeat1 = 336,
  aux_sym_alternative_pattern_repeat1 = 337,
  aux_sym__hash_pattern_body_repeat1 = 338,
  aux_sym_exceptions_repeat1 = 339,
  aux_sym__body_statement_repeat1 = 340,
  aux_sym_command_argument_list_repeat1 = 341,
  aux_sym__mlhs_repeat1 = 342,
  aux_sym_undef_repeat1 = 343,
  aux_sym_chained_string_repeat1 = 344,
  aux_sym_string_array_repeat1 = 345,
  aux_sym_symbol_array_repeat1 = 346,
  aux_sym_heredoc_body_repeat1 = 347,
  aux_sym_hash_repeat1 = 348,
  alias_sym_bare_string = 349,
  alias_sym_bare_symbol = 350,
  alias_sym_destructured_parameter = 351,
  alias_sym_lambda_parameters = 352,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_program_token1] = "program_token1",
  [anon_sym___END__] = "__END__",
  [anon_sym_] = "uninterpreted",
  [sym_uninterpreted] = "uninterpreted",
  [anon_sym_BEGIN] = "BEGIN",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_END] = "END",
  [anon_sym_def] = "def",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_end] = "end",
  [anon_sym_rescue] = "rescue",
  [anon_sym_EQ] = "=",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_SEMI] = ";",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_nil] = "nil",
  [anon_sym_AMP] = "&",
  [anon_sym_COLON] = ":",
  [anon_sym_class] = "class",
  [anon_sym_LT] = "<",
  [anon_sym_module] = "module",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_break] = "break",
  [anon_sym_next] = "next",
  [anon_sym_redo] = "redo",
  [anon_sym_retry] = "retry",
  [anon_sym_if] = "if",
  [anon_sym_unless] = "unless",
  [anon_sym_while] = "while",
  [anon_sym_until] = "until",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_do] = "do",
  [anon_sym_case] = "case",
  [anon_sym_when] = "when",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_DOT_DOT] = "..",
  [sym_line] = "line",
  [sym_file] = "file",
  [sym_encoding] = "encoding",
  [anon_sym_CARET] = "^",
  [anon_sym_elsif] = "elsif",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_begin] = "begin",
  [anon_sym_ensure] = "ensure",
  [anon_sym_COLON_COLON2] = "::",
  [anon_sym_AMP_DOT] = "&.",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON2] = ":",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_defined_QMARK] = "defined\?",
  [anon_sym_not] = "not",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_AT] = "+@",
  [anon_sym_DASH_AT] = "-@",
  [anon_sym_TILDE_AT] = "~@",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK_RBRACK_EQ] = "[]=",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_EQ2] = "=",
  [anon_sym_undef] = "undef",
  [anon_sym_alias] = "alias",
  [sym_comment] = "comment",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [anon_sym_i] = "i",
  [anon_sym_ri] = "ri",
  [anon_sym_r] = "r",
  [sym_super] = "super",
  [sym_self] = "self",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_constant] = "constant",
  [aux_sym_constant_suffix_token1] = "constant_suffix_token1",
  [aux_sym_identifier_suffix_token1] = "identifier_suffix_token1",
  [sym_instance_variable] = "instance_variable",
  [sym_class_variable] = "class_variable",
  [sym_global_variable] = "global_variable",
  [sym_character] = "character",
  [anon_sym_POUND_LBRACE] = "#{",
  [aux_sym_string_array_token1] = "string_array_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_DASH_GT] = "->",
  [sym__line_break] = "_line_break",
  [sym__no_line_break] = "_no_line_break",
  [sym_simple_symbol] = "simple_symbol",
  [sym__string_start] = "\"",
  [sym__symbol_start] = ":\"",
  [sym__subshell_start] = "`",
  [sym__regex_start] = "/",
  [sym__string_array_start] = "%w(",
  [sym__symbol_array_start] = "%i(",
  [sym__heredoc_body_start] = "_heredoc_body_start",
  [sym_string_content] = "string_content",
  [sym_heredoc_content] = "heredoc_content",
  [sym__string_end] = ")",
  [sym_heredoc_end] = "heredoc_end",
  [sym_heredoc_beginning] = "heredoc_beginning",
  [sym__block_ampersand] = "&",
  [sym__splat_star] = "*",
  [sym__unary_minus] = "-",
  [sym__unary_minus_num] = "-",
  [sym__binary_minus] = "-",
  [sym__binary_star] = "*",
  [sym__singleton_class_left_angle_left_langle] = "<<",
  [sym_hash_key_symbol] = "hash_key_symbol",
  [sym__identifier_suffix] = "_identifier_suffix",
  [sym__constant_suffix] = "_constant_suffix",
  [sym__hash_splat_star_star] = "**",
  [sym__binary_star_star] = "**",
  [sym__element_reference_bracket] = "[",
  [sym__short_interpolation] = "_short_interpolation",
  [sym_program] = "program",
  [sym_block_body] = "block_body",
  [sym__statements] = "_statements",
  [sym_begin_block] = "begin_block",
  [sym_end_block] = "end_block",
  [sym__statement] = "_statement",
  [sym_method] = "method",
  [sym_singleton_method] = "singleton_method",
  [sym__method_rest] = "_method_rest",
  [sym_rescue_modifier_arg] = "rescue_modifier",
  [sym_rescue_modifier_expression] = "rescue_modifier",
  [sym__body_expr] = "_body_expr",
  [sym_parameters] = "method_parameters",
  [sym_bare_parameters] = "method_parameters",
  [sym_block_parameters] = "block_parameters",
  [sym__formal_parameter] = "_formal_parameter",
  [sym__simple_formal_parameter] = "_simple_formal_parameter",
  [sym_forward_parameter] = "forward_parameter",
  [sym_splat_parameter] = "splat_parameter",
  [sym_hash_splat_parameter] = "hash_splat_parameter",
  [sym_hash_splat_nil] = "hash_splat_nil",
  [sym_block_parameter] = "block_parameter",
  [sym_keyword_parameter] = "keyword_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_class] = "class",
  [sym_superclass] = "superclass",
  [sym_singleton_class] = "singleton_class",
  [sym_module] = "module",
  [sym_return_command] = "return",
  [sym_yield_command] = "yield",
  [sym_break_command] = "break",
  [sym_next_command] = "next",
  [sym_return] = "return",
  [sym_yield] = "yield",
  [sym_break] = "break",
  [sym_next] = "next",
  [sym_redo] = "redo",
  [sym_retry] = "retry",
  [sym_if_modifier] = "if_modifier",
  [sym_unless_modifier] = "unless_modifier",
  [sym_while_modifier] = "while_modifier",
  [sym_until_modifier] = "until_modifier",
  [sym_rescue_modifier] = "rescue_modifier",
  [sym_while] = "while",
  [sym_until] = "until",
  [sym_for] = "for",
  [sym_in] = "in",
  [sym_do] = "do",
  [sym_case] = "case",
  [sym_case_match] = "case_match",
  [sym_when] = "when",
  [sym_in_clause] = "in_clause",
  [sym_pattern] = "pattern",
  [sym__guard] = "_guard",
  [sym_if_guard] = "if_guard",
  [sym_unless_guard] = "unless_guard",
  [sym__pattern_top_expr_body] = "_pattern_top_expr_body",
  [sym__array_pattern_n] = "_array_pattern_n",
  [sym__pattern_expr] = "_pattern_expr",
  [sym_as_pattern] = "as_pattern",
  [sym__pattern_expr_alt] = "_pattern_expr_alt",
  [sym_alternative_pattern] = "alternative_pattern",
  [sym__array_pattern_body] = "_array_pattern_body",
  [sym_array_pattern] = "array_pattern",
  [sym__find_pattern_body] = "_find_pattern_body",
  [sym_find_pattern] = "find_pattern",
  [sym__hash_pattern_body] = "_hash_pattern_body",
  [sym_keyword_pattern] = "keyword_pattern",
  [sym__hash_pattern_any_rest] = "_hash_pattern_any_rest",
  [sym_hash_pattern] = "hash_pattern",
  [sym__pattern_expr_basic] = "_pattern_expr_basic",
  [sym_parenthesized_pattern] = "parenthesized_pattern",
  [sym__pattern_value] = "_pattern_value",
  [sym__pattern_range] = "range",
  [sym__pattern_primitive] = "_pattern_primitive",
  [sym__pattern_lambda] = "_pattern_lambda",
  [sym__pattern_literal] = "_pattern_literal",
  [sym__keyword_variable] = "_keyword_variable",
  [sym_variable_reference_pattern] = "variable_reference_pattern",
  [sym_expression_reference_pattern] = "expression_reference_pattern",
  [sym__pattern_constant] = "_pattern_constant",
  [sym__pattern_constant_resolution] = "scope_resolution",
  [sym_if] = "if",
  [sym_unless] = "unless",
  [sym_elsif] = "elsif",
  [sym_else] = "else",
  [sym_then] = "then",
  [sym_begin] = "begin",
  [sym_ensure] = "ensure",
  [sym_rescue] = "rescue",
  [sym_exceptions] = "exceptions",
  [sym_exception_variable] = "exception_variable",
  [sym_body_statement] = "body_statement",
  [sym__body_statement] = "_body_statement",
  [sym__expression] = "_expression",
  [sym_match_pattern] = "match_pattern",
  [sym_test_pattern] = "test_pattern",
  [sym__arg] = "_arg",
  [sym__unary_minus_pow] = "unary",
  [sym__pow] = "binary",
  [sym__primary] = "_primary",
  [sym_parenthesized_statements] = "parenthesized_statements",
  [sym_element_reference] = "element_reference",
  [sym_scope_resolution] = "scope_resolution",
  [sym__call] = "_call",
  [sym_command_call] = "call",
  [sym_command_call_with_block] = "call",
  [sym__chained_command_call] = "_chained_command_call",
  [sym_call] = "call",
  [sym_command_argument_list] = "argument_list",
  [sym_argument_list] = "argument_list",
  [sym__argument_list_with_trailing_comma] = "_argument_list_with_trailing_comma",
  [sym__argument] = "_argument",
  [sym_forward_argument] = "forward_argument",
  [sym_splat_argument] = "splat_argument",
  [sym_hash_splat_argument] = "hash_splat_argument",
  [sym_block_argument] = "block_argument",
  [sym_do_block] = "do_block",
  [sym_block] = "block",
  [sym_assignment] = "assignment",
  [sym_command_assignment] = "assignment",
  [sym_operator_assignment] = "operator_assignment",
  [sym_command_operator_assignment] = "operator_assignment",
  [sym_conditional] = "conditional",
  [sym_range] = "range",
  [sym_binary] = "binary",
  [sym_command_binary] = "binary",
  [sym_unary] = "unary",
  [sym_command_unary] = "unary",
  [sym_parenthesized_unary] = "unary",
  [sym_unary_literal] = "unary",
  [sym__literal] = "_literal",
  [sym__numeric] = "_numeric",
  [sym__simple_numeric] = "_simple_numeric",
  [sym_right_assignment_list] = "right_assignment_list",
  [sym_left_assignment_list] = "left_assignment_list",
  [sym__mlhs] = "_mlhs",
  [sym_destructured_left_assignment] = "destructured_left_assignment",
  [sym_rest_assignment] = "rest_assignment",
  [sym__function_identifier] = "_function_identifier",
  [sym__function_identifier_call] = "call",
  [sym__lhs] = "_lhs",
  [sym__variable] = "_variable",
  [sym_operator] = "operator",
  [sym__method_name] = "_method_name",
  [sym__nonlocal_variable] = "_nonlocal_variable",
  [sym_setter] = "setter",
  [sym_undef] = "undef",
  [sym_alias] = "alias",
  [sym__int_or_float] = "_int_or_float",
  [sym_complex] = "complex",
  [sym_rational] = "rational",
  [sym_nil] = "nil",
  [sym_constant_suffix] = "hash_key_symbol",
  [sym_identifier_suffix] = "hash_key_symbol",
  [sym_chained_string] = "chained_string",
  [sym_interpolation] = "interpolation",
  [sym_string] = "string",
  [sym_subshell] = "subshell",
  [sym_string_array] = "string_array",
  [sym_symbol_array] = "symbol_array",
  [sym_delimited_symbol] = "delimited_symbol",
  [sym_regex] = "regex",
  [sym_heredoc_body] = "heredoc_body",
  [aux_sym__literal_contents] = "_literal_contents",
  [sym_array] = "array",
  [sym_hash] = "hash",
  [sym_pair] = "pair",
  [sym_lambda] = "lambda",
  [sym_empty_statement] = "empty_statement",
  [sym__terminator] = "_terminator",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_block_parameters_repeat1] = "block_parameters_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_case_match_repeat1] = "case_match_repeat1",
  [aux_sym_when_repeat1] = "when_repeat1",
  [aux_sym__array_pattern_n_repeat1] = "_array_pattern_n_repeat1",
  [aux_sym_alternative_pattern_repeat1] = "alternative_pattern_repeat1",
  [aux_sym__hash_pattern_body_repeat1] = "_hash_pattern_body_repeat1",
  [aux_sym_exceptions_repeat1] = "exceptions_repeat1",
  [aux_sym__body_statement_repeat1] = "_body_statement_repeat1",
  [aux_sym_command_argument_list_repeat1] = "command_argument_list_repeat1",
  [aux_sym__mlhs_repeat1] = "_mlhs_repeat1",
  [aux_sym_undef_repeat1] = "undef_repeat1",
  [aux_sym_chained_string_repeat1] = "chained_string_repeat1",
  [aux_sym_string_array_repeat1] = "string_array_repeat1",
  [aux_sym_symbol_array_repeat1] = "symbol_array_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_hash_repeat1] = "hash_repeat1",
  [alias_sym_bare_string] = "bare_string",
  [alias_sym_bare_symbol] = "bare_symbol",
  [alias_sym_destructured_parameter] = "destructured_parameter",
  [alias_sym_lambda_parameters] = "lambda_parameters",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_program_token1] = aux_sym_program_token1,
  [anon_sym___END__] = anon_sym___END__,
  [anon_sym_] = sym_uninterpreted,
  [sym_uninterpreted] = sym_uninterpreted,
  [anon_sym_BEGIN] = anon_sym_BEGIN,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_END] = anon_sym_END,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_rescue] = anon_sym_rescue,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_nil] = anon_sym_nil,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_next] = anon_sym_next,
  [anon_sym_redo] = anon_sym_redo,
  [anon_sym_retry] = anon_sym_retry,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_unless] = anon_sym_unless,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACK2] = anon_sym_LBRACK,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [sym_line] = sym_line,
  [sym_file] = sym_file,
  [sym_encoding] = sym_encoding,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_elsif] = anon_sym_elsif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_ensure] = anon_sym_ensure,
  [anon_sym_COLON_COLON2] = anon_sym_COLON_COLON,
  [anon_sym_AMP_DOT] = anon_sym_AMP_DOT,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON2] = anon_sym_COLON,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_EQ_TILDE] = anon_sym_EQ_TILDE,
  [anon_sym_BANG_TILDE] = anon_sym_BANG_TILDE,
  [anon_sym_defined_QMARK] = anon_sym_defined_QMARK,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS_AT] = anon_sym_PLUS_AT,
  [anon_sym_DASH_AT] = anon_sym_DASH_AT,
  [anon_sym_TILDE_AT] = anon_sym_TILDE_AT,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_LBRACK_RBRACK_EQ] = anon_sym_LBRACK_RBRACK_EQ,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_EQ2] = anon_sym_EQ,
  [anon_sym_undef] = anon_sym_undef,
  [anon_sym_alias] = anon_sym_alias,
  [sym_comment] = sym_comment,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [anon_sym_i] = anon_sym_i,
  [anon_sym_ri] = anon_sym_ri,
  [anon_sym_r] = anon_sym_r,
  [sym_super] = sym_super,
  [sym_self] = sym_self,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_constant] = sym_constant,
  [aux_sym_constant_suffix_token1] = aux_sym_constant_suffix_token1,
  [aux_sym_identifier_suffix_token1] = aux_sym_identifier_suffix_token1,
  [sym_instance_variable] = sym_instance_variable,
  [sym_class_variable] = sym_class_variable,
  [sym_global_variable] = sym_global_variable,
  [sym_character] = sym_character,
  [anon_sym_POUND_LBRACE] = anon_sym_POUND_LBRACE,
  [aux_sym_string_array_token1] = aux_sym_string_array_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym__line_break] = sym__line_break,
  [sym__no_line_break] = sym__no_line_break,
  [sym_simple_symbol] = sym_simple_symbol,
  [sym__string_start] = sym__string_start,
  [sym__symbol_start] = sym__symbol_start,
  [sym__subshell_start] = anon_sym_BQUOTE,
  [sym__regex_start] = anon_sym_SLASH,
  [sym__string_array_start] = sym__string_array_start,
  [sym__symbol_array_start] = sym__symbol_array_start,
  [sym__heredoc_body_start] = sym__heredoc_body_start,
  [sym_string_content] = sym_string_content,
  [sym_heredoc_content] = sym_heredoc_content,
  [sym__string_end] = anon_sym_RPAREN,
  [sym_heredoc_end] = sym_heredoc_end,
  [sym_heredoc_beginning] = sym_heredoc_beginning,
  [sym__block_ampersand] = anon_sym_AMP,
  [sym__splat_star] = anon_sym_STAR,
  [sym__unary_minus] = anon_sym_DASH,
  [sym__unary_minus_num] = anon_sym_DASH,
  [sym__binary_minus] = anon_sym_DASH,
  [sym__binary_star] = anon_sym_STAR,
  [sym__singleton_class_left_angle_left_langle] = anon_sym_LT_LT,
  [sym_hash_key_symbol] = sym_hash_key_symbol,
  [sym__identifier_suffix] = sym__identifier_suffix,
  [sym__constant_suffix] = sym__constant_suffix,
  [sym__hash_splat_star_star] = anon_sym_STAR_STAR,
  [sym__binary_star_star] = anon_sym_STAR_STAR,
  [sym__element_reference_bracket] = anon_sym_LBRACK,
  [sym__short_interpolation] = sym__short_interpolation,
  [sym_program] = sym_program,
  [sym_block_body] = sym_block_body,
  [sym__statements] = sym__statements,
  [sym_begin_block] = sym_begin_block,
  [sym_end_block] = sym_end_block,
  [sym__statement] = sym__statement,
  [sym_method] = sym_method,
  [sym_singleton_method] = sym_singleton_method,
  [sym__method_rest] = sym__method_rest,
  [sym_rescue_modifier_arg] = sym_rescue_modifier,
  [sym_rescue_modifier_expression] = sym_rescue_modifier,
  [sym__body_expr] = sym__body_expr,
  [sym_parameters] = sym_parameters,
  [sym_bare_parameters] = sym_parameters,
  [sym_block_parameters] = sym_block_parameters,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym__simple_formal_parameter] = sym__simple_formal_parameter,
  [sym_forward_parameter] = sym_forward_parameter,
  [sym_splat_parameter] = sym_splat_parameter,
  [sym_hash_splat_parameter] = sym_hash_splat_parameter,
  [sym_hash_splat_nil] = sym_hash_splat_nil,
  [sym_block_parameter] = sym_block_parameter,
  [sym_keyword_parameter] = sym_keyword_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym_class] = sym_class,
  [sym_superclass] = sym_superclass,
  [sym_singleton_class] = sym_singleton_class,
  [sym_module] = sym_module,
  [sym_return_command] = sym_return,
  [sym_yield_command] = sym_yield,
  [sym_break_command] = sym_break,
  [sym_next_command] = sym_next,
  [sym_return] = sym_return,
  [sym_yield] = sym_yield,
  [sym_break] = sym_break,
  [sym_next] = sym_next,
  [sym_redo] = sym_redo,
  [sym_retry] = sym_retry,
  [sym_if_modifier] = sym_if_modifier,
  [sym_unless_modifier] = sym_unless_modifier,
  [sym_while_modifier] = sym_while_modifier,
  [sym_until_modifier] = sym_until_modifier,
  [sym_rescue_modifier] = sym_rescue_modifier,
  [sym_while] = sym_while,
  [sym_until] = sym_until,
  [sym_for] = sym_for,
  [sym_in] = sym_in,
  [sym_do] = sym_do,
  [sym_case] = sym_case,
  [sym_case_match] = sym_case_match,
  [sym_when] = sym_when,
  [sym_in_clause] = sym_in_clause,
  [sym_pattern] = sym_pattern,
  [sym__guard] = sym__guard,
  [sym_if_guard] = sym_if_guard,
  [sym_unless_guard] = sym_unless_guard,
  [sym__pattern_top_expr_body] = sym__pattern_top_expr_body,
  [sym__array_pattern_n] = sym__array_pattern_n,
  [sym__pattern_expr] = sym__pattern_expr,
  [sym_as_pattern] = sym_as_pattern,
  [sym__pattern_expr_alt] = sym__pattern_expr_alt,
  [sym_alternative_pattern] = sym_alternative_pattern,
  [sym__array_pattern_body] = sym__array_pattern_body,
  [sym_array_pattern] = sym_array_pattern,
  [sym__find_pattern_body] = sym__find_pattern_body,
  [sym_find_pattern] = sym_find_pattern,
  [sym__hash_pattern_body] = sym__hash_pattern_body,
  [sym_keyword_pattern] = sym_keyword_pattern,
  [sym__hash_pattern_any_rest] = sym__hash_pattern_any_rest,
  [sym_hash_pattern] = sym_hash_pattern,
  [sym__pattern_expr_basic] = sym__pattern_expr_basic,
  [sym_parenthesized_pattern] = sym_parenthesized_pattern,
  [sym__pattern_value] = sym__pattern_value,
  [sym__pattern_range] = sym_range,
  [sym__pattern_primitive] = sym__pattern_primitive,
  [sym__pattern_lambda] = sym__pattern_lambda,
  [sym__pattern_literal] = sym__pattern_literal,
  [sym__keyword_variable] = sym__keyword_variable,
  [sym_variable_reference_pattern] = sym_variable_reference_pattern,
  [sym_expression_reference_pattern] = sym_expression_reference_pattern,
  [sym__pattern_constant] = sym__pattern_constant,
  [sym__pattern_constant_resolution] = sym_scope_resolution,
  [sym_if] = sym_if,
  [sym_unless] = sym_unless,
  [sym_elsif] = sym_elsif,
  [sym_else] = sym_else,
  [sym_then] = sym_then,
  [sym_begin] = sym_begin,
  [sym_ensure] = sym_ensure,
  [sym_rescue] = sym_rescue,
  [sym_exceptions] = sym_exceptions,
  [sym_exception_variable] = sym_exception_variable,
  [sym_body_statement] = sym_body_statement,
  [sym__body_statement] = sym__body_statement,
  [sym__expression] = sym__expression,
  [sym_match_pattern] = sym_match_pattern,
  [sym_test_pattern] = sym_test_pattern,
  [sym__arg] = sym__arg,
  [sym__unary_minus_pow] = sym_unary,
  [sym__pow] = sym_binary,
  [sym__primary] = sym__primary,
  [sym_parenthesized_statements] = sym_parenthesized_statements,
  [sym_element_reference] = sym_element_reference,
  [sym_scope_resolution] = sym_scope_resolution,
  [sym__call] = sym__call,
  [sym_command_call] = sym_call,
  [sym_command_call_with_block] = sym_call,
  [sym__chained_command_call] = sym__chained_command_call,
  [sym_call] = sym_call,
  [sym_command_argument_list] = sym_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym__argument_list_with_trailing_comma] = sym__argument_list_with_trailing_comma,
  [sym__argument] = sym__argument,
  [sym_forward_argument] = sym_forward_argument,
  [sym_splat_argument] = sym_splat_argument,
  [sym_hash_splat_argument] = sym_hash_splat_argument,
  [sym_block_argument] = sym_block_argument,
  [sym_do_block] = sym_do_block,
  [sym_block] = sym_block,
  [sym_assignment] = sym_assignment,
  [sym_command_assignment] = sym_assignment,
  [sym_operator_assignment] = sym_operator_assignment,
  [sym_command_operator_assignment] = sym_operator_assignment,
  [sym_conditional] = sym_conditional,
  [sym_range] = sym_range,
  [sym_binary] = sym_binary,
  [sym_command_binary] = sym_binary,
  [sym_unary] = sym_unary,
  [sym_command_unary] = sym_unary,
  [sym_parenthesized_unary] = sym_unary,
  [sym_unary_literal] = sym_unary,
  [sym__literal] = sym__literal,
  [sym__numeric] = sym__numeric,
  [sym__simple_numeric] = sym__simple_numeric,
  [sym_right_assignment_list] = sym_right_assignment_list,
  [sym_left_assignment_list] = sym_left_assignment_list,
  [sym__mlhs] = sym__mlhs,
  [sym_destructured_left_assignment] = sym_destructured_left_assignment,
  [sym_rest_assignment] = sym_rest_assignment,
  [sym__function_identifier] = sym__function_identifier,
  [sym__function_identifier_call] = sym_call,
  [sym__lhs] = sym__lhs,
  [sym__variable] = sym__variable,
  [sym_operator] = sym_operator,
  [sym__method_name] = sym__method_name,
  [sym__nonlocal_variable] = sym__nonlocal_variable,
  [sym_setter] = sym_setter,
  [sym_undef] = sym_undef,
  [sym_alias] = sym_alias,
  [sym__int_or_float] = sym__int_or_float,
  [sym_complex] = sym_complex,
  [sym_rational] = sym_rational,
  [sym_nil] = sym_nil,
  [sym_constant_suffix] = sym_hash_key_symbol,
  [sym_identifier_suffix] = sym_hash_key_symbol,
  [sym_chained_string] = sym_chained_string,
  [sym_interpolation] = sym_interpolation,
  [sym_string] = sym_string,
  [sym_subshell] = sym_subshell,
  [sym_string_array] = sym_string_array,
  [sym_symbol_array] = sym_symbol_array,
  [sym_delimited_symbol] = sym_delimited_symbol,
  [sym_regex] = sym_regex,
  [sym_heredoc_body] = sym_heredoc_body,
  [aux_sym__literal_contents] = aux_sym__literal_contents,
  [sym_array] = sym_array,
  [sym_hash] = sym_hash,
  [sym_pair] = sym_pair,
  [sym_lambda] = sym_lambda,
  [sym_empty_statement] = sym_empty_statement,
  [sym__terminator] = sym__terminator,
  [aux_sym__statements_repeat1] = aux_sym__statements_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_block_parameters_repeat1] = aux_sym_block_parameters_repeat1,
  [aux_sym_case_repeat1] = aux_sym_case_repeat1,
  [aux_sym_case_match_repeat1] = aux_sym_case_match_repeat1,
  [aux_sym_when_repeat1] = aux_sym_when_repeat1,
  [aux_sym__array_pattern_n_repeat1] = aux_sym__array_pattern_n_repeat1,
  [aux_sym_alternative_pattern_repeat1] = aux_sym_alternative_pattern_repeat1,
  [aux_sym__hash_pattern_body_repeat1] = aux_sym__hash_pattern_body_repeat1,
  [aux_sym_exceptions_repeat1] = aux_sym_exceptions_repeat1,
  [aux_sym__body_statement_repeat1] = aux_sym__body_statement_repeat1,
  [aux_sym_command_argument_list_repeat1] = aux_sym_command_argument_list_repeat1,
  [aux_sym__mlhs_repeat1] = aux_sym__mlhs_repeat1,
  [aux_sym_undef_repeat1] = aux_sym_undef_repeat1,
  [aux_sym_chained_string_repeat1] = aux_sym_chained_string_repeat1,
  [aux_sym_string_array_repeat1] = aux_sym_string_array_repeat1,
  [aux_sym_symbol_array_repeat1] = aux_sym_symbol_array_repeat1,
  [aux_sym_heredoc_body_repeat1] = aux_sym_heredoc_body_repeat1,
  [aux_sym_hash_repeat1] = aux_sym_hash_repeat1,
  [alias_sym_bare_string] = alias_sym_bare_string,
  [alias_sym_bare_symbol] = alias_sym_bare_symbol,
  [alias_sym_destructured_parameter] = alias_sym_destructured_parameter,
  [alias_sym_lambda_parameters] = alias_sym_lambda_parameters,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym___END__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_] = {
    .visible = true,
    .named = true,
  },
  [sym_uninterpreted] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BEGIN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rescue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_next] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_redo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_retry] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_line] = {
    .visible = true,
    .named = true,
  },
  [sym_file] = {
    .visible = true,
    .named = true,
  },
  [sym_encoding] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ensure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ri] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_constant_suffix_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_identifier_suffix_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_instance_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_class_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_global_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_array_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__line_break] = {
    .visible = false,
    .named = true,
  },
  [sym__no_line_break] = {
    .visible = false,
    .named = true,
  },
  [sym_simple_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_start] = {
    .visible = true,
    .named = false,
  },
  [sym__subshell_start] = {
    .visible = true,
    .named = false,
  },
  [sym__regex_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__heredoc_body_start] = {
    .visible = false,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_content] = {
    .visible = true,
    .named = true,
  },
  [sym__string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_beginning] = {
    .visible = true,
    .named = true,
  },
  [sym__block_ampersand] = {
    .visible = true,
    .named = false,
  },
  [sym__splat_star] = {
    .visible = true,
    .named = false,
  },
  [sym__unary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__unary_minus_num] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_star] = {
    .visible = true,
    .named = false,
  },
  [sym__singleton_class_left_angle_left_langle] = {
    .visible = true,
    .named = false,
  },
  [sym_hash_key_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_suffix] = {
    .visible = false,
    .named = true,
  },
  [sym__constant_suffix] = {
    .visible = false,
    .named = true,
  },
  [sym__hash_splat_star_star] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_star_star] = {
    .visible = true,
    .named = false,
  },
  [sym__element_reference_bracket] = {
    .visible = true,
    .named = false,
  },
  [sym__short_interpolation] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_block_body] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym_begin_block] = {
    .visible = true,
    .named = true,
  },
  [sym_end_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_method] = {
    .visible = true,
    .named = true,
  },
  [sym__method_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_rescue_modifier_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__body_expr] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_bare_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_forward_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_return_command] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_command] = {
    .visible = true,
    .named = true,
  },
  [sym_break_command] = {
    .visible = true,
    .named = true,
  },
  [sym_next_command] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_redo] = {
    .visible = true,
    .named = true,
  },
  [sym_retry] = {
    .visible = true,
    .named = true,
  },
  [sym_if_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_until_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_until] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_case_match] = {
    .visible = true,
    .named = true,
  },
  [sym_when] = {
    .visible = true,
    .named = true,
  },
  [sym_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__guard] = {
    .visible = false,
    .named = true,
  },
  [sym_if_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_guard] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_top_expr_body] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__array_pattern_n] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_expr] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_expr_alt] = {
    .visible = false,
    .named = true,
  },
  [sym_alternative_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__array_pattern_body] = {
    .visible = false,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__find_pattern_body] = {
    .visible = false,
    .named = true,
  },
  [sym_find_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_pattern_body] = {
    .visible = false,
    .named = true,
  },
  [sym_keyword_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_pattern_any_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_hash_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_expr_basic] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_value] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_range] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_primitive] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__pattern_lambda] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__keyword_variable] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_constant] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__pattern_constant_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_unless] = {
    .visible = true,
    .named = true,
  },
  [sym_elsif] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_then] = {
    .visible = true,
    .named = true,
  },
  [sym_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_ensure] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptions] = {
    .visible = true,
    .named = true,
  },
  [sym_exception_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_body_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__body_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_test_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__unary_minus_pow] = {
    .visible = true,
    .named = true,
  },
  [sym__pow] = {
    .visible = true,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_statements] = {
    .visible = true,
    .named = true,
  },
  [sym_element_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_scope_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym__call] = {
    .visible = false,
    .named = true,
  },
  [sym_command_call] = {
    .visible = true,
    .named = true,
  },
  [sym_command_call_with_block] = {
    .visible = true,
    .named = true,
  },
  [sym__chained_command_call] = {
    .visible = false,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_command_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list_with_trailing_comma] = {
    .visible = false,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_forward_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_do_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_command_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_command_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_command_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_command_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym__numeric] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_numeric] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_right_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym_left_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__mlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_left_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__function_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__function_identifier_call] = {
    .visible = true,
    .named = true,
  },
  [sym__lhs] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__variable] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__method_name] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__nonlocal_variable] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_setter] = {
    .visible = true,
    .named = true,
  },
  [sym_undef] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym__int_or_float] = {
    .visible = false,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_chained_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_string_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol_array] = {
    .visible = true,
    .named = true,
  },
  [sym_delimited_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__literal_contents] = {
    .visible = false,
    .named = false,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_hash] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__terminator] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_match_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_when_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__array_pattern_n_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alternative_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__hash_pattern_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exceptions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__body_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__mlhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_undef_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_chained_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_symbol_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hash_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_bare_string] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_bare_symbol] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_destructured_parameter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_alternatives = 3,
  field_arguments = 4,
  field_begin = 5,
  field_block = 6,
  field_body = 7,
  field_class = 8,
  field_clauses = 9,
  field_condition = 10,
  field_consequence = 11,
  field_else = 12,
  field_end = 13,
  field_exceptions = 14,
  field_guard = 15,
  field_handler = 16,
  field_key = 17,
  field_left = 18,
  field_locals = 19,
  field_method = 20,
  field_name = 21,
  field_object = 22,
  field_operand = 23,
  field_operator = 24,
  field_parameters = 25,
  field_pattern = 26,
  field_receiver = 27,
  field_right = 28,
  field_scope = 29,
  field_superclass = 30,
  field_value = 31,
  field_variable = 32,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_alternatives] = "alternatives",
  [field_arguments] = "arguments",
  [field_begin] = "begin",
  [field_block] = "block",
  [field_body] = "body",
  [field_class] = "class",
  [field_clauses] = "clauses",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_else] = "else",
  [field_end] = "end",
  [field_exceptions] = "exceptions",
  [field_guard] = "guard",
  [field_handler] = "handler",
  [field_key] = "key",
  [field_left] = "left",
  [field_locals] = "locals",
  [field_method] = "method",
  [field_name] = "name",
  [field_object] = "object",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_receiver] = "receiver",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_superclass] = "superclass",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 3},
  [4] = {.index = 5, .length = 1},
  [5] = {.index = 6, .length = 1},
  [11] = {.index = 7, .length = 2},
  [12] = {.index = 9, .length = 5},
  [13] = {.index = 14, .length = 3},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 18, .length = 2},
  [16] = {.index = 20, .length = 1},
  [17] = {.index = 21, .length = 2},
  [18] = {.index = 23, .length = 4},
  [19] = {.index = 27, .length = 4},
  [20] = {.index = 31, .length = 2},
  [21] = {.index = 33, .length = 2},
  [28] = {.index = 35, .length = 1},
  [29] = {.index = 35, .length = 1},
  [30] = {.index = 36, .length = 1},
  [31] = {.index = 37, .length = 2},
  [32] = {.index = 39, .length = 2},
  [33] = {.index = 41, .length = 1},
  [34] = {.index = 42, .length = 1},
  [35] = {.index = 43, .length = 2},
  [37] = {.index = 45, .length = 2},
  [38] = {.index = 47, .length = 2},
  [39] = {.index = 49, .length = 2},
  [40] = {.index = 51, .length = 3},
  [41] = {.index = 54, .length = 3},
  [42] = {.index = 57, .length = 2},
  [46] = {.index = 59, .length = 3},
  [47] = {.index = 62, .length = 2},
  [48] = {.index = 64, .length = 1},
  [49] = {.index = 65, .length = 3},
  [50] = {.index = 68, .length = 3},
  [51] = {.index = 71, .length = 2},
  [52] = {.index = 73, .length = 5},
  [53] = {.index = 78, .length = 2},
  [54] = {.index = 80, .length = 3},
  [57] = {.index = 83, .length = 2},
  [58] = {.index = 83, .length = 2},
  [59] = {.index = 85, .length = 4},
  [60] = {.index = 89, .length = 2},
  [61] = {.index = 91, .length = 3},
  [62] = {.index = 94, .length = 2},
  [63] = {.index = 96, .length = 2},
  [64] = {.index = 98, .length = 1},
  [65] = {.index = 99, .length = 3},
  [66] = {.index = 102, .length = 1},
  [67] = {.index = 103, .length = 2},
  [68] = {.index = 105, .length = 1},
  [69] = {.index = 106, .length = 2},
  [70] = {.index = 108, .length = 2},
  [71] = {.index = 110, .length = 2},
  [72] = {.index = 112, .length = 1},
  [73] = {.index = 113, .length = 2},
  [74] = {.index = 115, .length = 1},
  [75] = {.index = 116, .length = 1},
  [76] = {.index = 117, .length = 2},
  [78] = {.index = 119, .length = 2},
  [79] = {.index = 121, .length = 4},
  [80] = {.index = 125, .length = 3},
  [81] = {.index = 128, .length = 2},
  [82] = {.index = 130, .length = 2},
  [83] = {.index = 132, .length = 2},
  [84] = {.index = 134, .length = 3},
  [85] = {.index = 137, .length = 2},
  [86] = {.index = 139, .length = 2},
  [87] = {.index = 141, .length = 3},
  [88] = {.index = 144, .length = 2},
  [89] = {.index = 146, .length = 2},
  [90] = {.index = 148, .length = 2},
  [91] = {.index = 150, .length = 3},
  [92] = {.index = 153, .length = 3},
  [93] = {.index = 156, .length = 2},
  [94] = {.index = 45, .length = 2},
  [95] = {.index = 158, .length = 1},
  [96] = {.index = 159, .length = 1},
  [97] = {.index = 160, .length = 2},
  [98] = {.index = 162, .length = 1},
  [99] = {.index = 163, .length = 2},
  [100] = {.index = 165, .length = 1},
  [101] = {.index = 166, .length = 3},
  [102] = {.index = 169, .length = 4},
  [103] = {.index = 173, .length = 3},
  [104] = {.index = 176, .length = 2},
  [105] = {.index = 178, .length = 3},
  [106] = {.index = 181, .length = 2},
  [107] = {.index = 183, .length = 3},
  [108] = {.index = 186, .length = 3},
  [109] = {.index = 189, .length = 2},
  [110] = {.index = 191, .length = 3},
  [111] = {.index = 194, .length = 1},
  [112] = {.index = 195, .length = 2},
  [113] = {.index = 197, .length = 2},
  [114] = {.index = 199, .length = 3},
  [115] = {.index = 202, .length = 1},
  [116] = {.index = 203, .length = 1},
  [117] = {.index = 204, .length = 2},
  [118] = {.index = 206, .length = 2},
  [119] = {.index = 208, .length = 2},
  [120] = {.index = 210, .length = 2},
  [121] = {.index = 212, .length = 1},
  [122] = {.index = 213, .length = 2},
  [123] = {.index = 215, .length = 1},
  [124] = {.index = 216, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_operand, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [2] =
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [5] =
    {field_method, 0},
  [6] =
    {field_method, 0, .inherited = true},
  [7] =
    {field_operand, 1},
    {field_operator, 0},
  [9] =
    {field_left, 1, .inherited = true},
    {field_operand, 1},
    {field_operator, 0},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [14] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
  [17] =
    {field_name, 1},
  [18] =
    {field_end, 1},
    {field_operator, 0},
  [20] =
    {field_body, 1},
  [21] =
    {field_begin, 0},
    {field_operator, 1},
  [23] =
    {field_arguments, 1},
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [27] =
    {field_block, 1},
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [31] =
    {field_arguments, 1},
    {field_method, 0},
  [33] =
    {field_block, 1},
    {field_method, 0},
  [35] =
    {field_key, 0},
  [36] =
    {field_name, 0},
  [37] =
    {field_body, 1, .inherited = true},
    {field_name, 0},
  [39] =
    {field_body, 2},
    {field_condition, 1},
  [41] =
    {field_value, 1},
  [42] =
    {field_clauses, 0},
  [43] =
    {field_alias, 2},
    {field_name, 1},
  [45] =
    {field_body, 2},
    {field_parameters, 1},
  [47] =
    {field_body, 0},
    {field_handler, 2},
  [49] =
    {field_body, 0},
    {field_condition, 2},
  [51] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [54] =
    {field_begin, 0},
    {field_end, 2},
    {field_operator, 1},
  [57] =
    {field_pattern, 2},
    {field_value, 0},
  [59] =
    {field_begin, 0, .inherited = true},
    {field_end, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [62] =
    {field_name, 0, .inherited = true},
    {field_scope, 0, .inherited = true},
  [64] =
    {field_object, 0},
  [65] =
    {field_method, 2},
    {field_operator, 1},
    {field_receiver, 0},
  [68] =
    {field_arguments, 2},
    {field_operator, 1},
    {field_receiver, 0},
  [71] =
    {field_name, 2},
    {field_scope, 0},
  [73] =
    {field_arguments, 1},
    {field_block, 2},
    {field_method, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_receiver, 0, .inherited = true},
  [78] =
    {field_left, 0},
    {field_right, 2},
  [80] =
    {field_arguments, 1},
    {field_block, 2},
    {field_method, 0},
  [83] =
    {field_key, 0},
    {field_value, 2},
  [85] =
    {field_body, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_object, 1},
    {field_parameters, 3, .inherited = true},
  [89] =
    {field_name, 0},
    {field_parameters, 1},
  [91] =
    {field_body, 2, .inherited = true},
    {field_name, 0},
    {field_parameters, 1},
  [94] =
    {field_body, 2},
    {field_name, 1},
  [96] =
    {field_condition, 1},
    {field_consequence, 2},
  [98] =
    {field_condition, 1},
  [99] =
    {field_body, 3},
    {field_pattern, 1},
    {field_value, 2},
  [102] =
    {field_value, 2},
  [103] =
    {field_body, 2},
    {field_pattern, 1},
  [105] =
    {field_pattern, 1},
  [106] =
    {field_clauses, 2, .inherited = true},
    {field_value, 1},
  [108] =
    {field_clauses, 0, .inherited = true},
    {field_clauses, 1, .inherited = true},
  [110] =
    {field_body, 2},
    {field_exceptions, 1},
  [112] =
    {field_exceptions, 1},
  [113] =
    {field_body, 2},
    {field_variable, 1},
  [115] =
    {field_variable, 1},
  [116] =
    {field_parameters, 1},
  [117] =
    {field_name, 0},
    {field_value, 2},
  [119] =
    {field_alternatives, 0},
    {field_alternatives, 1, .inherited = true},
  [121] =
    {field_arguments, 2},
    {field_block, 3},
    {field_operator, 1},
    {field_receiver, 0},
  [125] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1},
  [128] =
    {field_body, 2},
    {field_name, 0},
  [130] =
    {field_name, 1},
    {field_superclass, 2},
  [132] =
    {field_body, 3},
    {field_name, 1},
  [134] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [137] =
    {field_alternative, 3},
    {field_condition, 1},
  [139] =
    {field_clauses, 3, .inherited = true},
    {field_value, 2},
  [141] =
    {field_body, 3},
    {field_pattern, 1},
    {field_pattern, 2, .inherited = true},
  [144] =
    {field_pattern, 1},
    {field_pattern, 2, .inherited = true},
  [146] =
    {field_pattern, 0, .inherited = true},
    {field_pattern, 1, .inherited = true},
  [148] =
    {field_clauses, 3, .inherited = true},
    {field_value, 1},
  [150] =
    {field_clauses, 2, .inherited = true},
    {field_else, 3},
    {field_value, 1},
  [153] =
    {field_body, 3},
    {field_exceptions, 1},
    {field_variable, 2},
  [156] =
    {field_exceptions, 1},
    {field_variable, 2},
  [158] =
    {field_parameters, 2},
  [159] =
    {field_body, 2},
  [160] =
    {field_name, 2},
    {field_value, 0},
  [162] =
    {field_alternatives, 1},
  [163] =
    {field_alternatives, 0, .inherited = true},
    {field_alternatives, 1, .inherited = true},
  [165] =
    {field_class, 0},
  [166] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [169] =
    {field_body, 5, .inherited = true},
    {field_name, 5, .inherited = true},
    {field_object, 2},
    {field_parameters, 5, .inherited = true},
  [173] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 1},
  [176] =
    {field_body, 4},
    {field_value, 2},
  [178] =
    {field_body, 4},
    {field_name, 1},
    {field_superclass, 2},
  [181] =
    {field_clauses, 4, .inherited = true},
    {field_value, 2},
  [183] =
    {field_clauses, 3, .inherited = true},
    {field_else, 4},
    {field_value, 2},
  [186] =
    {field_body, 3},
    {field_guard, 2},
    {field_pattern, 1},
  [189] =
    {field_guard, 2},
    {field_pattern, 1},
  [191] =
    {field_clauses, 3, .inherited = true},
    {field_else, 4},
    {field_value, 1},
  [194] =
    {field_locals, 2},
  [195] =
    {field_body, 3},
    {field_parameters, 1},
  [197] =
    {field_body, 3},
    {field_parameters, 2},
  [199] =
    {field_clauses, 4, .inherited = true},
    {field_else, 5},
    {field_value, 2},
  [202] =
    {field_locals, 3},
  [203] =
    {field_locals, 1},
  [204] =
    {field_locals, 2},
    {field_locals, 3, .inherited = true},
  [206] =
    {field_locals, 0, .inherited = true},
    {field_locals, 1, .inherited = true},
  [208] =
    {field_body, 4},
    {field_parameters, 2},
  [210] =
    {field_locals, 3},
    {field_locals, 4, .inherited = true},
  [212] =
    {field_locals, 4},
  [213] =
    {field_locals, 4},
    {field_locals, 5, .inherited = true},
  [215] =
    {field_locals, 5},
  [216] =
    {field_locals, 5},
    {field_locals, 6, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [0] = sym_call,
  },
  [3] = {
    [0] = sym_call,
  },
  [6] = {
    [0] = sym_constant,
  },
  [7] = {
    [0] = sym_identifier,
  },
  [8] = {
    [1] = sym__string_start,
  },
  [9] = {
    [1] = anon_sym_BQUOTE,
  },
  [10] = {
    [1] = anon_sym_SLASH,
  },
  [22] = {
    [0] = sym_rational,
  },
  [23] = {
    [2] = sym__string_start,
  },
  [24] = {
    [2] = anon_sym_BQUOTE,
  },
  [25] = {
    [2] = anon_sym_SLASH,
  },
  [26] = {
    [1] = alias_sym_bare_string,
  },
  [27] = {
    [1] = alias_sym_bare_symbol,
  },
  [29] = {
    [0] = sym_hash_key_symbol,
  },
  [36] = {
    [0] = alias_sym_destructured_parameter,
  },
  [37] = {
    [1] = alias_sym_lambda_parameters,
  },
  [43] = {
    [0] = sym_array_pattern,
  },
  [44] = {
    [0] = sym_find_pattern,
  },
  [45] = {
    [0] = sym_hash_pattern,
  },
  [55] = {
    [2] = alias_sym_bare_string,
  },
  [56] = {
    [2] = alias_sym_bare_symbol,
  },
  [58] = {
    [0] = sym_hash_key_symbol,
  },
  [77] = {
    [1] = sym_splat_parameter,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_parameters, 3,
    sym_parameters,
    alias_sym_destructured_parameter,
    alias_sym_lambda_parameters,
  sym_bare_parameters, 2,
    sym_parameters,
    alias_sym_lambda_parameters,
  sym__array_pattern_n, 2,
    sym__array_pattern_n,
    sym_array_pattern,
  sym__find_pattern_body, 2,
    sym__find_pattern_body,
    sym_find_pattern,
  sym__hash_pattern_body, 2,
    sym__hash_pattern_body,
    sym_hash_pattern,
  sym__call, 2,
    sym__call,
    sym_call,
  sym__chained_command_call, 2,
    sym__chained_command_call,
    sym_call,
  sym__int_or_float, 2,
    sym__int_or_float,
    sym_rational,
  sym_constant_suffix, 2,
    sym_hash_key_symbol,
    sym_constant,
  sym_identifier_suffix, 2,
    sym_hash_key_symbol,
    sym_identifier,
  aux_sym__literal_contents, 3,
    aux_sym__literal_contents,
    alias_sym_bare_string,
    alias_sym_bare_symbol,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 3,
  [5] = 3,
  [6] = 2,
  [7] = 2,
  [8] = 2,
  [9] = 3,
  [10] = 3,
  [11] = 2,
  [12] = 3,
  [13] = 2,
  [14] = 3,
  [15] = 2,
  [16] = 3,
  [17] = 2,
  [18] = 3,
  [19] = 2,
  [20] = 3,
  [21] = 3,
  [22] = 3,
  [23] = 2,
  [24] = 2,
  [25] = 2,
  [26] = 3,
  [27] = 2,
  [28] = 3,
  [29] = 2,
  [30] = 2,
  [31] = 3,
  [32] = 2,
  [33] = 3,
  [34] = 2,
  [35] = 3,
  [36] = 2,
  [37] = 3,
  [38] = 3,
  [39] = 2,
  [40] = 2,
  [41] = 3,
  [42] = 42,
  [43] = 42,
  [44] = 42,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 46,
  [50] = 45,
  [51] = 47,
  [52] = 48,
  [53] = 42,
  [54] = 42,
  [55] = 42,
  [56] = 46,
  [57] = 45,
  [58] = 47,
  [59] = 42,
  [60] = 48,
  [61] = 42,
  [62] = 47,
  [63] = 42,
  [64] = 42,
  [65] = 42,
  [66] = 48,
  [67] = 45,
  [68] = 42,
  [69] = 42,
  [70] = 46,
  [71] = 42,
  [72] = 42,
  [73] = 48,
  [74] = 45,
  [75] = 47,
  [76] = 46,
  [77] = 42,
  [78] = 42,
  [79] = 42,
  [80] = 47,
  [81] = 48,
  [82] = 47,
  [83] = 46,
  [84] = 46,
  [85] = 45,
  [86] = 48,
  [87] = 45,
  [88] = 46,
  [89] = 47,
  [90] = 46,
  [91] = 45,
  [92] = 45,
  [93] = 48,
  [94] = 47,
  [95] = 42,
  [96] = 48,
  [97] = 46,
  [98] = 48,
  [99] = 46,
  [100] = 45,
  [101] = 47,
  [102] = 46,
  [103] = 45,
  [104] = 47,
  [105] = 48,
  [106] = 42,
  [107] = 45,
  [108] = 47,
  [109] = 48,
  [110] = 48,
  [111] = 47,
  [112] = 46,
  [113] = 45,
  [114] = 114,
  [115] = 114,
  [116] = 114,
  [117] = 114,
  [118] = 118,
  [119] = 118,
  [120] = 118,
  [121] = 118,
  [122] = 118,
  [123] = 123,
  [124] = 123,
  [125] = 123,
  [126] = 126,
  [127] = 126,
  [128] = 128,
  [129] = 126,
  [130] = 128,
  [131] = 128,
  [132] = 132,
  [133] = 132,
  [134] = 132,
  [135] = 135,
  [136] = 135,
  [137] = 135,
  [138] = 138,
  [139] = 135,
  [140] = 135,
  [141] = 138,
  [142] = 135,
  [143] = 135,
  [144] = 138,
  [145] = 135,
  [146] = 135,
  [147] = 138,
  [148] = 135,
  [149] = 135,
  [150] = 138,
  [151] = 135,
  [152] = 135,
  [153] = 138,
  [154] = 135,
  [155] = 135,
  [156] = 135,
  [157] = 135,
  [158] = 135,
  [159] = 135,
  [160] = 135,
  [161] = 135,
  [162] = 135,
  [163] = 135,
  [164] = 135,
  [165] = 138,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 166,
  [170] = 167,
  [171] = 166,
  [172] = 167,
  [173] = 168,
  [174] = 168,
  [175] = 166,
  [176] = 167,
  [177] = 168,
  [178] = 166,
  [179] = 167,
  [180] = 167,
  [181] = 168,
  [182] = 166,
  [183] = 168,
  [184] = 166,
  [185] = 167,
  [186] = 168,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 187,
  [191] = 187,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 197,
  [199] = 192,
  [200] = 192,
  [201] = 188,
  [202] = 202,
  [203] = 203,
  [204] = 197,
  [205] = 202,
  [206] = 197,
  [207] = 197,
  [208] = 196,
  [209] = 196,
  [210] = 202,
  [211] = 193,
  [212] = 197,
  [213] = 194,
  [214] = 192,
  [215] = 195,
  [216] = 192,
  [217] = 197,
  [218] = 203,
  [219] = 192,
  [220] = 193,
  [221] = 189,
  [222] = 192,
  [223] = 194,
  [224] = 195,
  [225] = 203,
  [226] = 226,
  [227] = 189,
  [228] = 228,
  [229] = 226,
  [230] = 226,
  [231] = 228,
  [232] = 232,
  [233] = 233,
  [234] = 233,
  [235] = 233,
  [236] = 233,
  [237] = 233,
  [238] = 233,
  [239] = 233,
  [240] = 233,
  [241] = 241,
  [242] = 189,
  [243] = 243,
  [244] = 244,
  [245] = 188,
  [246] = 246,
  [247] = 247,
  [248] = 189,
  [249] = 249,
  [250] = 249,
  [251] = 189,
  [252] = 188,
  [253] = 249,
  [254] = 246,
  [255] = 246,
  [256] = 256,
  [257] = 188,
  [258] = 258,
  [259] = 189,
  [260] = 260,
  [261] = 189,
  [262] = 188,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 263,
  [267] = 263,
  [268] = 268,
  [269] = 269,
  [270] = 188,
  [271] = 271,
  [272] = 268,
  [273] = 273,
  [274] = 268,
  [275] = 268,
  [276] = 268,
  [277] = 277,
  [278] = 189,
  [279] = 189,
  [280] = 268,
  [281] = 281,
  [282] = 268,
  [283] = 283,
  [284] = 189,
  [285] = 228,
  [286] = 188,
  [287] = 189,
  [288] = 189,
  [289] = 188,
  [290] = 188,
  [291] = 188,
  [292] = 189,
  [293] = 293,
  [294] = 293,
  [295] = 293,
  [296] = 188,
  [297] = 188,
  [298] = 293,
  [299] = 189,
  [300] = 293,
  [301] = 189,
  [302] = 293,
  [303] = 228,
  [304] = 188,
  [305] = 232,
  [306] = 189,
  [307] = 189,
  [308] = 241,
  [309] = 293,
  [310] = 310,
  [311] = 189,
  [312] = 312,
  [313] = 312,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 312,
  [318] = 312,
  [319] = 189,
  [320] = 320,
  [321] = 321,
  [322] = 312,
  [323] = 312,
  [324] = 310,
  [325] = 188,
  [326] = 315,
  [327] = 312,
  [328] = 312,
  [329] = 314,
  [330] = 315,
  [331] = 310,
  [332] = 312,
  [333] = 312,
  [334] = 314,
  [335] = 228,
  [336] = 312,
  [337] = 312,
  [338] = 312,
  [339] = 188,
  [340] = 228,
  [341] = 228,
  [342] = 188,
  [343] = 189,
  [344] = 189,
  [345] = 189,
  [346] = 228,
  [347] = 189,
  [348] = 228,
  [349] = 189,
  [350] = 189,
  [351] = 188,
  [352] = 189,
  [353] = 188,
  [354] = 188,
  [355] = 228,
  [356] = 228,
  [357] = 189,
  [358] = 189,
  [359] = 228,
  [360] = 189,
  [361] = 189,
  [362] = 188,
  [363] = 363,
  [364] = 363,
  [365] = 363,
  [366] = 188,
  [367] = 189,
  [368] = 189,
  [369] = 189,
  [370] = 189,
  [371] = 188,
  [372] = 188,
  [373] = 228,
  [374] = 188,
  [375] = 189,
  [376] = 189,
  [377] = 189,
  [378] = 378,
  [379] = 188,
  [380] = 378,
  [381] = 381,
  [382] = 189,
  [383] = 383,
  [384] = 378,
  [385] = 385,
  [386] = 383,
  [387] = 381,
  [388] = 385,
  [389] = 383,
  [390] = 381,
  [391] = 385,
  [392] = 392,
  [393] = 189,
  [394] = 189,
  [395] = 189,
  [396] = 188,
  [397] = 189,
  [398] = 398,
  [399] = 399,
  [400] = 398,
  [401] = 399,
  [402] = 189,
  [403] = 403,
  [404] = 403,
  [405] = 189,
  [406] = 188,
  [407] = 403,
  [408] = 408,
  [409] = 398,
  [410] = 410,
  [411] = 411,
  [412] = 399,
  [413] = 403,
  [414] = 414,
  [415] = 189,
  [416] = 416,
  [417] = 416,
  [418] = 416,
  [419] = 416,
  [420] = 416,
  [421] = 416,
  [422] = 416,
  [423] = 416,
  [424] = 416,
  [425] = 416,
  [426] = 416,
  [427] = 416,
  [428] = 416,
  [429] = 416,
  [430] = 430,
  [431] = 430,
  [432] = 430,
  [433] = 430,
  [434] = 430,
  [435] = 430,
  [436] = 430,
  [437] = 430,
  [438] = 430,
  [439] = 430,
  [440] = 430,
  [441] = 430,
  [442] = 430,
  [443] = 430,
  [444] = 430,
  [445] = 430,
  [446] = 430,
  [447] = 430,
  [448] = 430,
  [449] = 430,
  [450] = 430,
  [451] = 430,
  [452] = 430,
  [453] = 430,
  [454] = 430,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 457,
  [459] = 459,
  [460] = 460,
  [461] = 188,
  [462] = 462,
  [463] = 455,
  [464] = 457,
  [465] = 457,
  [466] = 457,
  [467] = 457,
  [468] = 457,
  [469] = 457,
  [470] = 457,
  [471] = 457,
  [472] = 456,
  [473] = 457,
  [474] = 457,
  [475] = 457,
  [476] = 457,
  [477] = 457,
  [478] = 457,
  [479] = 457,
  [480] = 457,
  [481] = 457,
  [482] = 457,
  [483] = 457,
  [484] = 457,
  [485] = 457,
  [486] = 457,
  [487] = 457,
  [488] = 459,
  [489] = 462,
  [490] = 460,
  [491] = 188,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 495,
  [499] = 499,
  [500] = 500,
  [501] = 493,
  [502] = 494,
  [503] = 495,
  [504] = 499,
  [505] = 505,
  [506] = 500,
  [507] = 493,
  [508] = 494,
  [509] = 495,
  [510] = 499,
  [511] = 500,
  [512] = 493,
  [513] = 494,
  [514] = 495,
  [515] = 515,
  [516] = 500,
  [517] = 493,
  [518] = 515,
  [519] = 494,
  [520] = 499,
  [521] = 500,
  [522] = 493,
  [523] = 494,
  [524] = 495,
  [525] = 493,
  [526] = 495,
  [527] = 505,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 492,
  [533] = 515,
  [534] = 528,
  [535] = 500,
  [536] = 499,
  [537] = 493,
  [538] = 494,
  [539] = 495,
  [540] = 499,
  [541] = 500,
  [542] = 493,
  [543] = 494,
  [544] = 495,
  [545] = 500,
  [546] = 505,
  [547] = 528,
  [548] = 493,
  [549] = 500,
  [550] = 493,
  [551] = 500,
  [552] = 493,
  [553] = 499,
  [554] = 494,
  [555] = 495,
  [556] = 529,
  [557] = 530,
  [558] = 499,
  [559] = 515,
  [560] = 494,
  [561] = 495,
  [562] = 499,
  [563] = 515,
  [564] = 529,
  [565] = 499,
  [566] = 500,
  [567] = 493,
  [568] = 494,
  [569] = 495,
  [570] = 500,
  [571] = 493,
  [572] = 499,
  [573] = 494,
  [574] = 499,
  [575] = 495,
  [576] = 500,
  [577] = 493,
  [578] = 494,
  [579] = 495,
  [580] = 494,
  [581] = 499,
  [582] = 499,
  [583] = 499,
  [584] = 499,
  [585] = 499,
  [586] = 499,
  [587] = 499,
  [588] = 495,
  [589] = 500,
  [590] = 500,
  [591] = 530,
  [592] = 493,
  [593] = 494,
  [594] = 594,
  [595] = 495,
  [596] = 493,
  [597] = 494,
  [598] = 495,
  [599] = 500,
  [600] = 500,
  [601] = 493,
  [602] = 494,
  [603] = 495,
  [604] = 492,
  [605] = 494,
  [606] = 499,
  [607] = 500,
  [608] = 493,
  [609] = 494,
  [610] = 495,
  [611] = 499,
  [612] = 594,
  [613] = 500,
  [614] = 493,
  [615] = 494,
  [616] = 495,
  [617] = 515,
  [618] = 499,
  [619] = 500,
  [620] = 493,
  [621] = 494,
  [622] = 495,
  [623] = 500,
  [624] = 493,
  [625] = 494,
  [626] = 499,
  [627] = 499,
  [628] = 500,
  [629] = 500,
  [630] = 493,
  [631] = 494,
  [632] = 495,
  [633] = 500,
  [634] = 493,
  [635] = 494,
  [636] = 495,
  [637] = 500,
  [638] = 493,
  [639] = 494,
  [640] = 495,
  [641] = 499,
  [642] = 495,
  [643] = 643,
  [644] = 643,
  [645] = 643,
  [646] = 643,
  [647] = 643,
  [648] = 455,
  [649] = 456,
  [650] = 456,
  [651] = 455,
  [652] = 459,
  [653] = 653,
  [654] = 462,
  [655] = 460,
  [656] = 188,
  [657] = 462,
  [658] = 658,
  [659] = 460,
  [660] = 459,
  [661] = 188,
  [662] = 456,
  [663] = 455,
  [664] = 455,
  [665] = 455,
  [666] = 456,
  [667] = 456,
  [668] = 456,
  [669] = 669,
  [670] = 669,
  [671] = 460,
  [672] = 462,
  [673] = 669,
  [674] = 455,
  [675] = 459,
  [676] = 460,
  [677] = 669,
  [678] = 669,
  [679] = 462,
  [680] = 456,
  [681] = 669,
  [682] = 669,
  [683] = 459,
  [684] = 460,
  [685] = 188,
  [686] = 462,
  [687] = 188,
  [688] = 669,
  [689] = 669,
  [690] = 188,
  [691] = 456,
  [692] = 455,
  [693] = 669,
  [694] = 669,
  [695] = 669,
  [696] = 459,
  [697] = 455,
  [698] = 669,
  [699] = 669,
  [700] = 462,
  [701] = 460,
  [702] = 462,
  [703] = 456,
  [704] = 462,
  [705] = 459,
  [706] = 459,
  [707] = 188,
  [708] = 188,
  [709] = 459,
  [710] = 455,
  [711] = 188,
  [712] = 460,
  [713] = 460,
  [714] = 714,
  [715] = 715,
  [716] = 715,
  [717] = 188,
  [718] = 455,
  [719] = 719,
  [720] = 719,
  [721] = 459,
  [722] = 462,
  [723] = 714,
  [724] = 456,
  [725] = 715,
  [726] = 714,
  [727] = 460,
  [728] = 188,
  [729] = 719,
  [730] = 730,
  [731] = 730,
  [732] = 730,
  [733] = 730,
  [734] = 730,
  [735] = 730,
  [736] = 730,
  [737] = 730,
  [738] = 730,
  [739] = 730,
  [740] = 730,
  [741] = 730,
  [742] = 730,
  [743] = 730,
  [744] = 730,
  [745] = 730,
  [746] = 730,
  [747] = 730,
  [748] = 730,
  [749] = 730,
  [750] = 730,
  [751] = 730,
  [752] = 730,
  [753] = 459,
  [754] = 730,
  [755] = 730,
  [756] = 730,
  [757] = 730,
  [758] = 730,
  [759] = 730,
  [760] = 730,
  [761] = 730,
  [762] = 730,
  [763] = 763,
  [764] = 730,
  [765] = 730,
  [766] = 730,
  [767] = 730,
  [768] = 730,
  [769] = 730,
  [770] = 730,
  [771] = 730,
  [772] = 730,
  [773] = 730,
  [774] = 730,
  [775] = 730,
  [776] = 730,
  [777] = 730,
  [778] = 188,
  [779] = 779,
  [780] = 780,
  [781] = 460,
  [782] = 782,
  [783] = 779,
  [784] = 779,
  [785] = 785,
  [786] = 785,
  [787] = 785,
  [788] = 785,
  [789] = 785,
  [790] = 785,
  [791] = 779,
  [792] = 785,
  [793] = 785,
  [794] = 785,
  [795] = 785,
  [796] = 785,
  [797] = 785,
  [798] = 785,
  [799] = 785,
  [800] = 785,
  [801] = 785,
  [802] = 785,
  [803] = 785,
  [804] = 785,
  [805] = 785,
  [806] = 785,
  [807] = 785,
  [808] = 785,
  [809] = 785,
  [810] = 785,
  [811] = 785,
  [812] = 785,
  [813] = 785,
  [814] = 785,
  [815] = 815,
  [816] = 815,
  [817] = 817,
  [818] = 817,
  [819] = 815,
  [820] = 817,
  [821] = 815,
  [822] = 815,
  [823] = 817,
  [824] = 815,
  [825] = 817,
  [826] = 817,
  [827] = 815,
  [828] = 817,
  [829] = 815,
  [830] = 815,
  [831] = 815,
  [832] = 817,
  [833] = 815,
  [834] = 815,
  [835] = 815,
  [836] = 817,
  [837] = 815,
  [838] = 815,
  [839] = 815,
  [840] = 817,
  [841] = 815,
  [842] = 815,
  [843] = 815,
  [844] = 815,
  [845] = 817,
  [846] = 817,
  [847] = 815,
  [848] = 815,
  [849] = 815,
  [850] = 815,
  [851] = 817,
  [852] = 815,
  [853] = 815,
  [854] = 815,
  [855] = 817,
  [856] = 817,
  [857] = 815,
  [858] = 817,
  [859] = 815,
  [860] = 815,
  [861] = 815,
  [862] = 817,
  [863] = 815,
  [864] = 815,
  [865] = 815,
  [866] = 815,
  [867] = 815,
  [868] = 815,
  [869] = 817,
  [870] = 817,
  [871] = 817,
  [872] = 817,
  [873] = 815,
  [874] = 817,
  [875] = 817,
  [876] = 815,
  [877] = 815,
  [878] = 815,
  [879] = 815,
  [880] = 815,
  [881] = 815,
  [882] = 815,
  [883] = 815,
  [884] = 817,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 885,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 886,
  [902] = 902,
  [903] = 898,
  [904] = 904,
  [905] = 899,
  [906] = 906,
  [907] = 907,
  [908] = 900,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 887,
  [913] = 888,
  [914] = 889,
  [915] = 890,
  [916] = 885,
  [917] = 892,
  [918] = 893,
  [919] = 894,
  [920] = 895,
  [921] = 896,
  [922] = 897,
  [923] = 923,
  [924] = 924,
  [925] = 898,
  [926] = 904,
  [927] = 899,
  [928] = 906,
  [929] = 906,
  [930] = 907,
  [931] = 907,
  [932] = 900,
  [933] = 909,
  [934] = 910,
  [935] = 911,
  [936] = 906,
  [937] = 887,
  [938] = 888,
  [939] = 889,
  [940] = 890,
  [941] = 885,
  [942] = 892,
  [943] = 943,
  [944] = 893,
  [945] = 894,
  [946] = 895,
  [947] = 896,
  [948] = 897,
  [949] = 923,
  [950] = 898,
  [951] = 904,
  [952] = 899,
  [953] = 900,
  [954] = 909,
  [955] = 910,
  [956] = 911,
  [957] = 900,
  [958] = 909,
  [959] = 910,
  [960] = 887,
  [961] = 888,
  [962] = 889,
  [963] = 890,
  [964] = 911,
  [965] = 885,
  [966] = 892,
  [967] = 943,
  [968] = 893,
  [969] = 894,
  [970] = 895,
  [971] = 896,
  [972] = 897,
  [973] = 923,
  [974] = 898,
  [975] = 904,
  [976] = 899,
  [977] = 900,
  [978] = 909,
  [979] = 910,
  [980] = 911,
  [981] = 981,
  [982] = 887,
  [983] = 888,
  [984] = 889,
  [985] = 890,
  [986] = 885,
  [987] = 892,
  [988] = 893,
  [989] = 894,
  [990] = 895,
  [991] = 896,
  [992] = 897,
  [993] = 887,
  [994] = 888,
  [995] = 889,
  [996] = 898,
  [997] = 904,
  [998] = 899,
  [999] = 900,
  [1000] = 909,
  [1001] = 910,
  [1002] = 911,
  [1003] = 887,
  [1004] = 888,
  [1005] = 889,
  [1006] = 890,
  [1007] = 885,
  [1008] = 892,
  [1009] = 893,
  [1010] = 894,
  [1011] = 895,
  [1012] = 896,
  [1013] = 897,
  [1014] = 898,
  [1015] = 899,
  [1016] = 890,
  [1017] = 885,
  [1018] = 892,
  [1019] = 887,
  [1020] = 888,
  [1021] = 889,
  [1022] = 890,
  [1023] = 1023,
  [1024] = 885,
  [1025] = 892,
  [1026] = 943,
  [1027] = 893,
  [1028] = 894,
  [1029] = 895,
  [1030] = 896,
  [1031] = 893,
  [1032] = 894,
  [1033] = 906,
  [1034] = 895,
  [1035] = 907,
  [1036] = 900,
  [1037] = 909,
  [1038] = 910,
  [1039] = 911,
  [1040] = 897,
  [1041] = 896,
  [1042] = 923,
  [1043] = 887,
  [1044] = 888,
  [1045] = 889,
  [1046] = 890,
  [1047] = 885,
  [1048] = 892,
  [1049] = 893,
  [1050] = 894,
  [1051] = 895,
  [1052] = 896,
  [1053] = 897,
  [1054] = 923,
  [1055] = 924,
  [1056] = 924,
  [1057] = 907,
  [1058] = 898,
  [1059] = 904,
  [1060] = 899,
  [1061] = 906,
  [1062] = 907,
  [1063] = 900,
  [1064] = 909,
  [1065] = 910,
  [1066] = 911,
  [1067] = 887,
  [1068] = 888,
  [1069] = 889,
  [1070] = 890,
  [1071] = 885,
  [1072] = 892,
  [1073] = 943,
  [1074] = 893,
  [1075] = 894,
  [1076] = 895,
  [1077] = 896,
  [1078] = 897,
  [1079] = 923,
  [1080] = 898,
  [1081] = 904,
  [1082] = 899,
  [1083] = 900,
  [1084] = 909,
  [1085] = 910,
  [1086] = 911,
  [1087] = 887,
  [1088] = 888,
  [1089] = 889,
  [1090] = 890,
  [1091] = 885,
  [1092] = 892,
  [1093] = 943,
  [1094] = 893,
  [1095] = 894,
  [1096] = 895,
  [1097] = 896,
  [1098] = 897,
  [1099] = 898,
  [1100] = 904,
  [1101] = 899,
  [1102] = 900,
  [1103] = 909,
  [1104] = 910,
  [1105] = 911,
  [1106] = 887,
  [1107] = 888,
  [1108] = 889,
  [1109] = 890,
  [1110] = 885,
  [1111] = 892,
  [1112] = 943,
  [1113] = 893,
  [1114] = 894,
  [1115] = 895,
  [1116] = 896,
  [1117] = 897,
  [1118] = 898,
  [1119] = 904,
  [1120] = 899,
  [1121] = 900,
  [1122] = 909,
  [1123] = 910,
  [1124] = 911,
  [1125] = 887,
  [1126] = 888,
  [1127] = 889,
  [1128] = 890,
  [1129] = 885,
  [1130] = 892,
  [1131] = 893,
  [1132] = 894,
  [1133] = 895,
  [1134] = 896,
  [1135] = 897,
  [1136] = 898,
  [1137] = 899,
  [1138] = 906,
  [1139] = 907,
  [1140] = 900,
  [1141] = 909,
  [1142] = 910,
  [1143] = 911,
  [1144] = 887,
  [1145] = 888,
  [1146] = 889,
  [1147] = 890,
  [1148] = 885,
  [1149] = 892,
  [1150] = 893,
  [1151] = 894,
  [1152] = 895,
  [1153] = 896,
  [1154] = 897,
  [1155] = 923,
  [1156] = 898,
  [1157] = 904,
  [1158] = 899,
  [1159] = 898,
  [1160] = 906,
  [1161] = 907,
  [1162] = 904,
  [1163] = 899,
  [1164] = 900,
  [1165] = 909,
  [1166] = 910,
  [1167] = 911,
  [1168] = 887,
  [1169] = 888,
  [1170] = 889,
  [1171] = 890,
  [1172] = 885,
  [1173] = 892,
  [1174] = 943,
  [1175] = 893,
  [1176] = 894,
  [1177] = 895,
  [1178] = 896,
  [1179] = 897,
  [1180] = 923,
  [1181] = 898,
  [1182] = 899,
  [1183] = 900,
  [1184] = 909,
  [1185] = 910,
  [1186] = 911,
  [1187] = 887,
  [1188] = 888,
  [1189] = 889,
  [1190] = 890,
  [1191] = 885,
  [1192] = 892,
  [1193] = 893,
  [1194] = 894,
  [1195] = 895,
  [1196] = 896,
  [1197] = 897,
  [1198] = 898,
  [1199] = 899,
  [1200] = 900,
  [1201] = 909,
  [1202] = 910,
  [1203] = 911,
  [1204] = 887,
  [1205] = 888,
  [1206] = 889,
  [1207] = 890,
  [1208] = 885,
  [1209] = 892,
  [1210] = 893,
  [1211] = 894,
  [1212] = 895,
  [1213] = 896,
  [1214] = 897,
  [1215] = 898,
  [1216] = 899,
  [1217] = 900,
  [1218] = 909,
  [1219] = 910,
  [1220] = 911,
  [1221] = 887,
  [1222] = 888,
  [1223] = 889,
  [1224] = 890,
  [1225] = 885,
  [1226] = 892,
  [1227] = 893,
  [1228] = 894,
  [1229] = 895,
  [1230] = 896,
  [1231] = 897,
  [1232] = 898,
  [1233] = 899,
  [1234] = 906,
  [1235] = 907,
  [1236] = 900,
  [1237] = 909,
  [1238] = 910,
  [1239] = 911,
  [1240] = 887,
  [1241] = 888,
  [1242] = 889,
  [1243] = 890,
  [1244] = 892,
  [1245] = 893,
  [1246] = 894,
  [1247] = 895,
  [1248] = 896,
  [1249] = 897,
  [1250] = 923,
  [1251] = 898,
  [1252] = 904,
  [1253] = 899,
  [1254] = 906,
  [1255] = 907,
  [1256] = 900,
  [1257] = 909,
  [1258] = 910,
  [1259] = 911,
  [1260] = 887,
  [1261] = 888,
  [1262] = 889,
  [1263] = 890,
  [1264] = 885,
  [1265] = 892,
  [1266] = 893,
  [1267] = 894,
  [1268] = 895,
  [1269] = 896,
  [1270] = 897,
  [1271] = 898,
  [1272] = 899,
  [1273] = 900,
  [1274] = 909,
  [1275] = 910,
  [1276] = 911,
  [1277] = 887,
  [1278] = 888,
  [1279] = 889,
  [1280] = 890,
  [1281] = 885,
  [1282] = 892,
  [1283] = 893,
  [1284] = 894,
  [1285] = 895,
  [1286] = 896,
  [1287] = 897,
  [1288] = 898,
  [1289] = 899,
  [1290] = 900,
  [1291] = 909,
  [1292] = 910,
  [1293] = 911,
  [1294] = 887,
  [1295] = 888,
  [1296] = 889,
  [1297] = 890,
  [1298] = 885,
  [1299] = 892,
  [1300] = 893,
  [1301] = 894,
  [1302] = 895,
  [1303] = 896,
  [1304] = 897,
  [1305] = 898,
  [1306] = 899,
  [1307] = 906,
  [1308] = 907,
  [1309] = 909,
  [1310] = 910,
  [1311] = 911,
  [1312] = 887,
  [1313] = 888,
  [1314] = 889,
  [1315] = 890,
  [1316] = 885,
  [1317] = 892,
  [1318] = 893,
  [1319] = 894,
  [1320] = 895,
  [1321] = 896,
  [1322] = 897,
  [1323] = 898,
  [1324] = 904,
  [1325] = 899,
  [1326] = 906,
  [1327] = 907,
  [1328] = 900,
  [1329] = 909,
  [1330] = 910,
  [1331] = 911,
  [1332] = 887,
  [1333] = 888,
  [1334] = 889,
  [1335] = 890,
  [1336] = 885,
  [1337] = 892,
  [1338] = 943,
  [1339] = 893,
  [1340] = 894,
  [1341] = 895,
  [1342] = 896,
  [1343] = 897,
  [1344] = 898,
  [1345] = 899,
  [1346] = 900,
  [1347] = 909,
  [1348] = 910,
  [1349] = 911,
  [1350] = 887,
  [1351] = 888,
  [1352] = 889,
  [1353] = 890,
  [1354] = 885,
  [1355] = 892,
  [1356] = 893,
  [1357] = 894,
  [1358] = 895,
  [1359] = 896,
  [1360] = 897,
  [1361] = 898,
  [1362] = 899,
  [1363] = 900,
  [1364] = 909,
  [1365] = 910,
  [1366] = 911,
  [1367] = 887,
  [1368] = 888,
  [1369] = 889,
  [1370] = 890,
  [1371] = 885,
  [1372] = 892,
  [1373] = 893,
  [1374] = 894,
  [1375] = 895,
  [1376] = 896,
  [1377] = 897,
  [1378] = 898,
  [1379] = 899,
  [1380] = 906,
  [1381] = 907,
  [1382] = 900,
  [1383] = 909,
  [1384] = 910,
  [1385] = 911,
  [1386] = 887,
  [1387] = 888,
  [1388] = 889,
  [1389] = 890,
  [1390] = 885,
  [1391] = 892,
  [1392] = 893,
  [1393] = 894,
  [1394] = 895,
  [1395] = 896,
  [1396] = 897,
  [1397] = 898,
  [1398] = 904,
  [1399] = 899,
  [1400] = 900,
  [1401] = 906,
  [1402] = 907,
  [1403] = 900,
  [1404] = 909,
  [1405] = 910,
  [1406] = 911,
  [1407] = 887,
  [1408] = 888,
  [1409] = 889,
  [1410] = 890,
  [1411] = 885,
  [1412] = 892,
  [1413] = 893,
  [1414] = 894,
  [1415] = 895,
  [1416] = 896,
  [1417] = 897,
  [1418] = 909,
  [1419] = 910,
  [1420] = 911,
  [1421] = 898,
  [1422] = 899,
  [1423] = 900,
  [1424] = 909,
  [1425] = 910,
  [1426] = 911,
  [1427] = 887,
  [1428] = 888,
  [1429] = 889,
  [1430] = 890,
  [1431] = 885,
  [1432] = 892,
  [1433] = 893,
  [1434] = 894,
  [1435] = 895,
  [1436] = 896,
  [1437] = 897,
  [1438] = 898,
  [1439] = 899,
  [1440] = 906,
  [1441] = 907,
  [1442] = 900,
  [1443] = 909,
  [1444] = 910,
  [1445] = 911,
  [1446] = 887,
  [1447] = 888,
  [1448] = 889,
  [1449] = 890,
  [1450] = 885,
  [1451] = 892,
  [1452] = 893,
  [1453] = 894,
  [1454] = 895,
  [1455] = 896,
  [1456] = 897,
  [1457] = 898,
  [1458] = 899,
  [1459] = 906,
  [1460] = 907,
  [1461] = 900,
  [1462] = 909,
  [1463] = 910,
  [1464] = 911,
  [1465] = 887,
  [1466] = 888,
  [1467] = 889,
  [1468] = 890,
  [1469] = 885,
  [1470] = 892,
  [1471] = 893,
  [1472] = 894,
  [1473] = 895,
  [1474] = 896,
  [1475] = 897,
  [1476] = 897,
  [1477] = 887,
  [1478] = 888,
  [1479] = 898,
  [1480] = 899,
  [1481] = 900,
  [1482] = 909,
  [1483] = 910,
  [1484] = 911,
  [1485] = 887,
  [1486] = 888,
  [1487] = 889,
  [1488] = 890,
  [1489] = 885,
  [1490] = 892,
  [1491] = 893,
  [1492] = 894,
  [1493] = 895,
  [1494] = 896,
  [1495] = 897,
  [1496] = 898,
  [1497] = 899,
  [1498] = 889,
  [1499] = 906,
  [1500] = 907,
  [1501] = 900,
  [1502] = 909,
  [1503] = 910,
  [1504] = 911,
  [1505] = 887,
  [1506] = 888,
  [1507] = 889,
  [1508] = 890,
  [1509] = 885,
  [1510] = 892,
  [1511] = 893,
  [1512] = 894,
  [1513] = 895,
  [1514] = 896,
  [1515] = 897,
  [1516] = 890,
  [1517] = 898,
  [1518] = 899,
  [1519] = 906,
  [1520] = 907,
  [1521] = 900,
  [1522] = 909,
  [1523] = 910,
  [1524] = 911,
  [1525] = 887,
  [1526] = 888,
  [1527] = 889,
  [1528] = 890,
  [1529] = 885,
  [1530] = 892,
  [1531] = 893,
  [1532] = 894,
  [1533] = 895,
  [1534] = 896,
  [1535] = 897,
  [1536] = 885,
  [1537] = 892,
  [1538] = 943,
  [1539] = 893,
  [1540] = 898,
  [1541] = 899,
  [1542] = 894,
  [1543] = 906,
  [1544] = 907,
  [1545] = 900,
  [1546] = 909,
  [1547] = 910,
  [1548] = 911,
  [1549] = 887,
  [1550] = 888,
  [1551] = 889,
  [1552] = 890,
  [1553] = 885,
  [1554] = 892,
  [1555] = 893,
  [1556] = 894,
  [1557] = 895,
  [1558] = 896,
  [1559] = 897,
  [1560] = 895,
  [1561] = 896,
  [1562] = 898,
  [1563] = 899,
  [1564] = 906,
  [1565] = 907,
  [1566] = 900,
  [1567] = 909,
  [1568] = 910,
  [1569] = 911,
  [1570] = 887,
  [1571] = 888,
  [1572] = 889,
  [1573] = 890,
  [1574] = 885,
  [1575] = 892,
  [1576] = 893,
  [1577] = 894,
  [1578] = 895,
  [1579] = 896,
  [1580] = 897,
  [1581] = 897,
  [1582] = 898,
  [1583] = 899,
  [1584] = 906,
  [1585] = 907,
  [1586] = 909,
  [1587] = 910,
  [1588] = 911,
  [1589] = 887,
  [1590] = 888,
  [1591] = 889,
  [1592] = 890,
  [1593] = 885,
  [1594] = 892,
  [1595] = 893,
  [1596] = 894,
  [1597] = 895,
  [1598] = 896,
  [1599] = 897,
  [1600] = 898,
  [1601] = 899,
  [1602] = 906,
  [1603] = 907,
  [1604] = 899,
  [1605] = 923,
  [1606] = 906,
  [1607] = 907,
  [1608] = 909,
  [1609] = 910,
  [1610] = 911,
  [1611] = 887,
  [1612] = 888,
  [1613] = 889,
  [1614] = 890,
  [1615] = 885,
  [1616] = 892,
  [1617] = 893,
  [1618] = 894,
  [1619] = 895,
  [1620] = 896,
  [1621] = 897,
  [1622] = 898,
  [1623] = 899,
  [1624] = 906,
  [1625] = 907,
  [1626] = 923,
  [1627] = 906,
  [1628] = 907,
  [1629] = 909,
  [1630] = 910,
  [1631] = 911,
  [1632] = 887,
  [1633] = 888,
  [1634] = 889,
  [1635] = 890,
  [1636] = 885,
  [1637] = 892,
  [1638] = 893,
  [1639] = 894,
  [1640] = 895,
  [1641] = 896,
  [1642] = 897,
  [1643] = 898,
  [1644] = 899,
  [1645] = 906,
  [1646] = 907,
  [1647] = 906,
  [1648] = 907,
  [1649] = 909,
  [1650] = 910,
  [1651] = 911,
  [1652] = 887,
  [1653] = 888,
  [1654] = 889,
  [1655] = 890,
  [1656] = 885,
  [1657] = 892,
  [1658] = 893,
  [1659] = 894,
  [1660] = 895,
  [1661] = 896,
  [1662] = 897,
  [1663] = 898,
  [1664] = 899,
  [1665] = 906,
  [1666] = 907,
  [1667] = 906,
  [1668] = 907,
  [1669] = 906,
  [1670] = 907,
  [1671] = 906,
  [1672] = 907,
  [1673] = 906,
  [1674] = 907,
  [1675] = 906,
  [1676] = 907,
  [1677] = 906,
  [1678] = 907,
  [1679] = 906,
  [1680] = 907,
  [1681] = 906,
  [1682] = 907,
  [1683] = 906,
  [1684] = 907,
  [1685] = 898,
  [1686] = 904,
  [1687] = 906,
  [1688] = 907,
  [1689] = 899,
  [1690] = 907,
  [1691] = 906,
  [1692] = 907,
  [1693] = 907,
  [1694] = 906,
  [1695] = 907,
  [1696] = 900,
  [1697] = 1023,
  [1698] = 900,
  [1699] = 909,
  [1700] = 910,
  [1701] = 911,
  [1702] = 900,
  [1703] = 906,
  [1704] = 981,
  [1705] = 906,
  [1706] = 900,
  [1707] = 900,
  [1708] = 900,
  [1709] = 909,
  [1710] = 910,
  [1711] = 911,
  [1712] = 1023,
  [1713] = 887,
  [1714] = 888,
  [1715] = 889,
  [1716] = 890,
  [1717] = 885,
  [1718] = 1023,
  [1719] = 1023,
  [1720] = 1023,
  [1721] = 1023,
  [1722] = 1023,
  [1723] = 1023,
  [1724] = 1023,
  [1725] = 1023,
  [1726] = 1023,
  [1727] = 1023,
  [1728] = 1023,
  [1729] = 1023,
  [1730] = 1023,
  [1731] = 1023,
  [1732] = 1023,
  [1733] = 1023,
  [1734] = 1023,
  [1735] = 1023,
  [1736] = 1023,
  [1737] = 1023,
  [1738] = 1023,
  [1739] = 1023,
  [1740] = 1023,
  [1741] = 1023,
  [1742] = 1023,
  [1743] = 1023,
  [1744] = 892,
  [1745] = 893,
  [1746] = 902,
  [1747] = 1023,
  [1748] = 894,
  [1749] = 895,
  [1750] = 896,
  [1751] = 897,
  [1752] = 1752,
  [1753] = 923,
  [1754] = 900,
  [1755] = 909,
  [1756] = 910,
  [1757] = 911,
  [1758] = 887,
  [1759] = 888,
  [1760] = 889,
  [1761] = 890,
  [1762] = 898,
  [1763] = 885,
  [1764] = 892,
  [1765] = 893,
  [1766] = 894,
  [1767] = 895,
  [1768] = 896,
  [1769] = 897,
  [1770] = 898,
  [1771] = 904,
  [1772] = 899,
  [1773] = 907,
  [1774] = 899,
  [1775] = 900,
  [1776] = 887,
  [1777] = 888,
  [1778] = 889,
  [1779] = 890,
  [1780] = 885,
  [1781] = 892,
  [1782] = 893,
  [1783] = 894,
  [1784] = 895,
  [1785] = 896,
  [1786] = 897,
  [1787] = 898,
  [1788] = 904,
  [1789] = 909,
  [1790] = 910,
  [1791] = 911,
  [1792] = 900,
  [1793] = 909,
  [1794] = 910,
  [1795] = 911,
  [1796] = 887,
  [1797] = 888,
  [1798] = 889,
  [1799] = 890,
  [1800] = 885,
  [1801] = 892,
  [1802] = 893,
  [1803] = 894,
  [1804] = 895,
  [1805] = 896,
  [1806] = 897,
  [1807] = 898,
  [1808] = 899,
  [1809] = 899,
  [1810] = 906,
  [1811] = 907,
  [1812] = 909,
  [1813] = 910,
  [1814] = 911,
  [1815] = 887,
  [1816] = 888,
  [1817] = 889,
  [1818] = 890,
  [1819] = 885,
  [1820] = 892,
  [1821] = 893,
  [1822] = 894,
  [1823] = 895,
  [1824] = 896,
  [1825] = 897,
  [1826] = 898,
  [1827] = 899,
  [1828] = 906,
  [1829] = 907,
  [1830] = 906,
  [1831] = 907,
  [1832] = 906,
  [1833] = 900,
  [1834] = 1023,
  [1835] = 1023,
  [1836] = 902,
  [1837] = 1023,
  [1838] = 1023,
  [1839] = 1023,
  [1840] = 1023,
  [1841] = 1023,
  [1842] = 1023,
  [1843] = 1023,
  [1844] = 1023,
  [1845] = 1023,
  [1846] = 1023,
  [1847] = 1023,
  [1848] = 1023,
  [1849] = 1023,
  [1850] = 1023,
  [1851] = 886,
  [1852] = 924,
  [1853] = 900,
  [1854] = 909,
  [1855] = 910,
  [1856] = 911,
  [1857] = 886,
  [1858] = 886,
  [1859] = 886,
  [1860] = 886,
  [1861] = 886,
  [1862] = 886,
  [1863] = 886,
  [1864] = 886,
  [1865] = 886,
  [1866] = 886,
  [1867] = 886,
  [1868] = 886,
  [1869] = 886,
  [1870] = 886,
  [1871] = 886,
  [1872] = 886,
  [1873] = 886,
  [1874] = 886,
  [1875] = 886,
  [1876] = 886,
  [1877] = 886,
  [1878] = 900,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1884,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1881,
  [1889] = 1889,
  [1890] = 981,
  [1891] = 981,
  [1892] = 1886,
  [1893] = 1881,
  [1894] = 1885,
  [1895] = 1879,
  [1896] = 1880,
  [1897] = 1881,
  [1898] = 1883,
  [1899] = 1884,
  [1900] = 1882,
  [1901] = 1887,
  [1902] = 1902,
  [1903] = 981,
  [1904] = 981,
  [1905] = 981,
  [1906] = 1906,
  [1907] = 1889,
  [1908] = 1908,
  [1909] = 981,
  [1910] = 1881,
  [1911] = 981,
  [1912] = 1881,
  [1913] = 981,
  [1914] = 981,
  [1915] = 1883,
  [1916] = 981,
  [1917] = 1917,
  [1918] = 1885,
  [1919] = 1884,
  [1920] = 1882,
  [1921] = 1886,
  [1922] = 1881,
  [1923] = 1881,
  [1924] = 1880,
  [1925] = 981,
  [1926] = 1881,
  [1927] = 1887,
  [1928] = 1879,
  [1929] = 1929,
  [1930] = 1889,
  [1931] = 1906,
  [1932] = 1932,
  [1933] = 1933,
  [1934] = 1885,
  [1935] = 1935,
  [1936] = 1935,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1938,
  [1940] = 1886,
  [1941] = 1937,
  [1942] = 1938,
  [1943] = 1943,
  [1944] = 1884,
  [1945] = 1883,
  [1946] = 1946,
  [1947] = 1947,
  [1948] = 1947,
  [1949] = 1947,
  [1950] = 1885,
  [1951] = 1937,
  [1952] = 1952,
  [1953] = 1935,
  [1954] = 1952,
  [1955] = 1937,
  [1956] = 1952,
  [1957] = 1957,
  [1958] = 1886,
  [1959] = 1935,
  [1960] = 1883,
  [1961] = 1884,
  [1962] = 1935,
  [1963] = 1937,
  [1964] = 1885,
  [1965] = 1937,
  [1966] = 1935,
  [1967] = 1937,
  [1968] = 1937,
  [1969] = 1937,
  [1970] = 1935,
  [1971] = 1937,
  [1972] = 1935,
  [1973] = 1935,
  [1974] = 1935,
  [1975] = 1886,
  [1976] = 1937,
  [1977] = 1935,
  [1978] = 1935,
  [1979] = 1937,
  [1980] = 1884,
  [1981] = 1883,
  [1982] = 1937,
  [1983] = 1935,
  [1984] = 1984,
  [1985] = 1985,
  [1986] = 1986,
  [1987] = 1987,
  [1988] = 1988,
  [1989] = 1987,
  [1990] = 1988,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 1984,
  [1995] = 1992,
  [1996] = 1991,
  [1997] = 1991,
  [1998] = 1992,
  [1999] = 1991,
  [2000] = 1991,
  [2001] = 1992,
  [2002] = 1992,
  [2003] = 1886,
  [2004] = 2004,
  [2005] = 1985,
  [2006] = 1880,
  [2007] = 1885,
  [2008] = 1986,
  [2009] = 1883,
  [2010] = 1884,
  [2011] = 1984,
  [2012] = 1881,
  [2013] = 2013,
  [2014] = 1984,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 2016,
  [2018] = 2013,
  [2019] = 1984,
  [2020] = 1986,
  [2021] = 1985,
  [2022] = 2022,
  [2023] = 2023,
  [2024] = 1886,
  [2025] = 1880,
  [2026] = 1885,
  [2027] = 2027,
  [2028] = 2028,
  [2029] = 2029,
  [2030] = 1883,
  [2031] = 1884,
  [2032] = 2004,
  [2033] = 1986,
  [2034] = 1884,
  [2035] = 1986,
  [2036] = 1881,
  [2037] = 1885,
  [2038] = 2038,
  [2039] = 1880,
  [2040] = 1887,
  [2041] = 1881,
  [2042] = 1883,
  [2043] = 1886,
  [2044] = 1879,
  [2045] = 1985,
  [2046] = 1906,
  [2047] = 1882,
  [2048] = 1985,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 2050,
  [2052] = 2052,
  [2053] = 2053,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 2023,
  [2057] = 2057,
  [2058] = 1886,
  [2059] = 2059,
  [2060] = 2060,
  [2061] = 1883,
  [2062] = 1884,
  [2063] = 2063,
  [2064] = 2004,
  [2065] = 1880,
  [2066] = 1885,
  [2067] = 2067,
  [2068] = 2068,
  [2069] = 2069,
  [2070] = 2070,
  [2071] = 2071,
  [2072] = 2072,
  [2073] = 2067,
  [2074] = 2074,
  [2075] = 2075,
  [2076] = 2076,
  [2077] = 2077,
  [2078] = 2078,
  [2079] = 2079,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 2082,
  [2083] = 2083,
  [2084] = 2029,
  [2085] = 2067,
  [2086] = 2067,
  [2087] = 2027,
  [2088] = 2028,
  [2089] = 2083,
  [2090] = 2083,
  [2091] = 2015,
  [2092] = 2083,
  [2093] = 2082,
  [2094] = 2083,
  [2095] = 2067,
  [2096] = 2067,
  [2097] = 2082,
  [2098] = 2082,
  [2099] = 2038,
  [2100] = 2100,
  [2101] = 2101,
  [2102] = 2080,
  [2103] = 2100,
  [2104] = 2074,
  [2105] = 2077,
  [2106] = 2075,
  [2107] = 2081,
  [2108] = 2076,
  [2109] = 2100,
  [2110] = 2101,
  [2111] = 2069,
  [2112] = 2100,
  [2113] = 2070,
  [2114] = 2078,
  [2115] = 2072,
  [2116] = 2100,
  [2117] = 2079,
  [2118] = 2071,
  [2119] = 2060,
  [2120] = 2038,
  [2121] = 2067,
  [2122] = 2067,
  [2123] = 2082,
  [2124] = 2124,
  [2125] = 2016,
  [2126] = 2013,
  [2127] = 2067,
  [2128] = 2060,
  [2129] = 2067,
  [2130] = 2082,
  [2131] = 2082,
  [2132] = 1906,
  [2133] = 2082,
  [2134] = 2022,
  [2135] = 2067,
  [2136] = 2067,
  [2137] = 2137,
  [2138] = 2137,
  [2139] = 1906,
  [2140] = 1881,
  [2141] = 2141,
  [2142] = 2141,
  [2143] = 2137,
  [2144] = 2137,
  [2145] = 2022,
  [2146] = 2137,
  [2147] = 2147,
  [2148] = 1887,
  [2149] = 1879,
  [2150] = 1881,
  [2151] = 1882,
  [2152] = 1883,
  [2153] = 1884,
  [2154] = 2154,
  [2155] = 1880,
  [2156] = 1885,
  [2157] = 1886,
  [2158] = 2082,
  [2159] = 2159,
  [2160] = 2082,
  [2161] = 2161,
  [2162] = 2067,
  [2163] = 2163,
  [2164] = 2067,
  [2165] = 2082,
  [2166] = 2067,
  [2167] = 2067,
  [2168] = 2013,
  [2169] = 2016,
  [2170] = 2038,
  [2171] = 2171,
  [2172] = 1885,
  [2173] = 1886,
  [2174] = 2174,
  [2175] = 2022,
  [2176] = 2176,
  [2177] = 2053,
  [2178] = 2178,
  [2179] = 2179,
  [2180] = 2179,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2176,
  [2184] = 2184,
  [2185] = 2023,
  [2186] = 2186,
  [2187] = 2052,
  [2188] = 2178,
  [2189] = 2038,
  [2190] = 2049,
  [2191] = 2054,
  [2192] = 2192,
  [2193] = 2055,
  [2194] = 2194,
  [2195] = 2054,
  [2196] = 1884,
  [2197] = 2197,
  [2198] = 2082,
  [2199] = 2124,
  [2200] = 2038,
  [2201] = 1883,
  [2202] = 2202,
  [2203] = 2203,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 2214,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2222,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2060,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2067,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 1881,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 1906,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2082,
  [2258] = 2067,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2067,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2067,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2067,
  [2273] = 2067,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2082,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2339,
  [2352] = 2060,
  [2353] = 2353,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2339,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2067,
  [2370] = 2197,
  [2371] = 2067,
  [2372] = 2067,
  [2373] = 2054,
  [2374] = 2082,
  [2375] = 2082,
  [2376] = 2060,
  [2377] = 2082,
  [2378] = 2082,
  [2379] = 2067,
  [2380] = 1902,
  [2381] = 2381,
  [2382] = 2381,
  [2383] = 2381,
  [2384] = 2022,
  [2385] = 2381,
  [2386] = 2067,
  [2387] = 2387,
  [2388] = 2381,
  [2389] = 2389,
  [2390] = 2067,
  [2391] = 2391,
  [2392] = 1906,
  [2393] = 2082,
  [2394] = 2381,
  [2395] = 2268,
  [2396] = 2396,
  [2397] = 2082,
  [2398] = 2398,
  [2399] = 2381,
  [2400] = 2381,
  [2401] = 2381,
  [2402] = 2381,
  [2403] = 2381,
  [2404] = 2381,
  [2405] = 2381,
  [2406] = 2381,
  [2407] = 2381,
  [2408] = 2381,
  [2409] = 2381,
  [2410] = 2082,
  [2411] = 2381,
  [2412] = 2381,
  [2413] = 2067,
  [2414] = 2381,
  [2415] = 2381,
  [2416] = 2381,
  [2417] = 2381,
  [2418] = 2381,
  [2419] = 2067,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2425,
  [2426] = 2082,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 2429,
  [2430] = 2430,
  [2431] = 2431,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2434,
  [2435] = 2435,
  [2436] = 2067,
  [2437] = 981,
  [2438] = 2438,
  [2439] = 2439,
  [2440] = 2440,
  [2441] = 2441,
  [2442] = 2442,
  [2443] = 2067,
  [2444] = 2444,
  [2445] = 2445,
  [2446] = 2082,
  [2447] = 2447,
  [2448] = 2448,
  [2449] = 2082,
  [2450] = 2450,
  [2451] = 2268,
  [2452] = 1908,
  [2453] = 2424,
  [2454] = 2454,
  [2455] = 2387,
  [2456] = 2067,
  [2457] = 2396,
  [2458] = 2067,
  [2459] = 2067,
  [2460] = 2396,
  [2461] = 2124,
  [2462] = 2420,
  [2463] = 2197,
  [2464] = 2341,
  [2465] = 2208,
  [2466] = 2067,
  [2467] = 2082,
  [2468] = 2287,
  [2469] = 2387,
  [2470] = 2398,
  [2471] = 2067,
  [2472] = 2286,
  [2473] = 2364,
  [2474] = 2303,
  [2475] = 2067,
  [2476] = 2349,
  [2477] = 2427,
  [2478] = 2054,
  [2479] = 2421,
  [2480] = 2424,
  [2481] = 2439,
  [2482] = 2067,
  [2483] = 2447,
  [2484] = 2429,
  [2485] = 2441,
  [2486] = 2435,
  [2487] = 2440,
  [2488] = 2067,
  [2489] = 2444,
  [2490] = 2431,
  [2491] = 2425,
  [2492] = 2423,
  [2493] = 2433,
  [2494] = 2067,
  [2495] = 2445,
  [2496] = 2454,
  [2497] = 2434,
  [2498] = 2430,
  [2499] = 2067,
  [2500] = 2438,
  [2501] = 2268,
  [2502] = 2424,
  [2503] = 2202,
  [2504] = 2422,
  [2505] = 2448,
  [2506] = 2450,
  [2507] = 2442,
  [2508] = 2428,
  [2509] = 2509,
  [2510] = 2509,
  [2511] = 2511,
  [2512] = 2509,
  [2513] = 2424,
  [2514] = 2511,
  [2515] = 2511,
  [2516] = 2509,
  [2517] = 2067,
  [2518] = 2433,
  [2519] = 2425,
  [2520] = 2421,
  [2521] = 2427,
  [2522] = 2431,
  [2523] = 2434,
  [2524] = 2435,
  [2525] = 2454,
  [2526] = 2438,
  [2527] = 2439,
  [2528] = 2440,
  [2529] = 2444,
  [2530] = 2530,
  [2531] = 2445,
  [2532] = 2387,
  [2533] = 2511,
  [2534] = 2511,
  [2535] = 2509,
  [2536] = 2422,
  [2537] = 2509,
  [2538] = 2448,
  [2539] = 2450,
  [2540] = 2442,
  [2541] = 2511,
  [2542] = 2509,
  [2543] = 2428,
  [2544] = 2509,
  [2545] = 2511,
  [2546] = 2509,
  [2547] = 2511,
  [2548] = 2509,
  [2549] = 2511,
  [2550] = 2509,
  [2551] = 2124,
  [2552] = 2509,
  [2553] = 2511,
  [2554] = 2509,
  [2555] = 2511,
  [2556] = 2509,
  [2557] = 2511,
  [2558] = 2509,
  [2559] = 2067,
  [2560] = 2067,
  [2561] = 2424,
  [2562] = 2511,
  [2563] = 2509,
  [2564] = 2441,
  [2565] = 2067,
  [2566] = 2423,
  [2567] = 2511,
  [2568] = 2511,
  [2569] = 2509,
  [2570] = 2511,
  [2571] = 2509,
  [2572] = 2398,
  [2573] = 2511,
  [2574] = 2124,
  [2575] = 2509,
  [2576] = 2511,
  [2577] = 2509,
  [2578] = 2396,
  [2579] = 2511,
  [2580] = 2420,
  [2581] = 2511,
  [2582] = 2509,
  [2583] = 2511,
  [2584] = 2509,
  [2585] = 2447,
  [2586] = 2511,
  [2587] = 2509,
  [2588] = 2197,
  [2589] = 2511,
  [2590] = 2509,
  [2591] = 2511,
  [2592] = 2427,
  [2593] = 2396,
  [2594] = 2434,
  [2595] = 2387,
  [2596] = 2596,
  [2597] = 2597,
  [2598] = 2423,
  [2599] = 2599,
  [2600] = 2600,
  [2601] = 2601,
  [2602] = 2420,
  [2603] = 2398,
  [2604] = 2604,
  [2605] = 2605,
  [2606] = 2606,
  [2607] = 2425,
  [2608] = 2608,
  [2609] = 2454,
  [2610] = 2431,
  [2611] = 2611,
  [2612] = 2421,
  [2613] = 2430,
  [2614] = 2604,
  [2615] = 2596,
  [2616] = 2605,
  [2617] = 2611,
  [2618] = 2429,
  [2619] = 2439,
  [2620] = 2440,
  [2621] = 2444,
  [2622] = 2445,
  [2623] = 2422,
  [2624] = 2448,
  [2625] = 2450,
  [2626] = 2442,
  [2627] = 2433,
  [2628] = 2428,
  [2629] = 2629,
  [2630] = 2435,
  [2631] = 2447,
  [2632] = 2438,
  [2633] = 2430,
  [2634] = 2396,
  [2635] = 2447,
  [2636] = 2433,
  [2637] = 2637,
  [2638] = 2268,
  [2639] = 2424,
  [2640] = 2391,
  [2641] = 2425,
  [2642] = 2421,
  [2643] = 2427,
  [2644] = 2431,
  [2645] = 2434,
  [2646] = 2435,
  [2647] = 2454,
  [2648] = 2438,
  [2649] = 2439,
  [2650] = 2440,
  [2651] = 2444,
  [2652] = 2445,
  [2653] = 2423,
  [2654] = 2398,
  [2655] = 2422,
  [2656] = 2396,
  [2657] = 2448,
  [2658] = 2420,
  [2659] = 2450,
  [2660] = 2442,
  [2661] = 2428,
  [2662] = 2424,
  [2663] = 2663,
  [2664] = 2387,
  [2665] = 2665,
  [2666] = 2530,
  [2667] = 2141,
  [2668] = 2668,
  [2669] = 2669,
  [2670] = 2387,
  [2671] = 2197,
  [2672] = 2530,
  [2673] = 2429,
  [2674] = 2441,
  [2675] = 2389,
  [2676] = 2421,
  [2677] = 2427,
  [2678] = 2423,
  [2679] = 2599,
  [2680] = 2600,
  [2681] = 2431,
  [2682] = 2442,
  [2683] = 2425,
  [2684] = 2387,
  [2685] = 2420,
  [2686] = 2429,
  [2687] = 2396,
  [2688] = 2439,
  [2689] = 2440,
  [2690] = 2450,
  [2691] = 2197,
  [2692] = 2601,
  [2693] = 2433,
  [2694] = 2597,
  [2695] = 2387,
  [2696] = 2448,
  [2697] = 2434,
  [2698] = 2435,
  [2699] = 2438,
  [2700] = 2454,
  [2701] = 2444,
  [2702] = 2430,
  [2703] = 2428,
  [2704] = 2445,
  [2705] = 2422,
  [2706] = 2396,
  [2707] = 2606,
  [2708] = 2398,
  [2709] = 2202,
  [2710] = 2447,
  [2711] = 2629,
  [2712] = 2161,
  [2713] = 2163,
  [2714] = 2431,
  [2715] = 2434,
  [2716] = 2433,
  [2717] = 2444,
  [2718] = 2184,
  [2719] = 2424,
  [2720] = 2435,
  [2721] = 2454,
  [2722] = 2438,
  [2723] = 2439,
  [2724] = 2668,
  [2725] = 2440,
  [2726] = 2444,
  [2727] = 2186,
  [2728] = 2421,
  [2729] = 2445,
  [2730] = 2425,
  [2731] = 2434,
  [2732] = 2427,
  [2733] = 2423,
  [2734] = 2435,
  [2735] = 2159,
  [2736] = 2176,
  [2737] = 2147,
  [2738] = 2422,
  [2739] = 2447,
  [2740] = 2448,
  [2741] = 2454,
  [2742] = 2445,
  [2743] = 2606,
  [2744] = 2629,
  [2745] = 2425,
  [2746] = 2423,
  [2747] = 2171,
  [2748] = 2192,
  [2749] = 2637,
  [2750] = 2450,
  [2751] = 2663,
  [2752] = 2599,
  [2753] = 2600,
  [2754] = 2601,
  [2755] = 2154,
  [2756] = 2422,
  [2757] = 2159,
  [2758] = 2178,
  [2759] = 2447,
  [2760] = 2438,
  [2761] = 2428,
  [2762] = 2433,
  [2763] = 2181,
  [2764] = 2669,
  [2765] = 2439,
  [2766] = 2665,
  [2767] = 2421,
  [2768] = 2161,
  [2769] = 2450,
  [2770] = 2430,
  [2771] = 2431,
  [2772] = 2194,
  [2773] = 2424,
  [2774] = 2429,
  [2775] = 2179,
  [2776] = 2448,
  [2777] = 2440,
  [2778] = 2442,
  [2779] = 2441,
  [2780] = 2268,
  [2781] = 2428,
  [2782] = 2427,
  [2783] = 2442,
  [2784] = 1885,
  [2785] = 2530,
  [2786] = 2421,
  [2787] = 2425,
  [2788] = 2197,
  [2789] = 2444,
  [2790] = 2428,
  [2791] = 2203,
  [2792] = 2424,
  [2793] = 2387,
  [2794] = 2387,
  [2795] = 2427,
  [2796] = 2396,
  [2797] = 2420,
  [2798] = 1884,
  [2799] = 2182,
  [2800] = 2431,
  [2801] = 2434,
  [2802] = 2441,
  [2803] = 2440,
  [2804] = 2339,
  [2805] = 2454,
  [2806] = 2450,
  [2807] = 2197,
  [2808] = 2396,
  [2809] = 1886,
  [2810] = 2424,
  [2811] = 2398,
  [2812] = 2445,
  [2813] = 2433,
  [2814] = 2442,
  [2815] = 2420,
  [2816] = 2387,
  [2817] = 2423,
  [2818] = 2422,
  [2819] = 2448,
  [2820] = 2141,
  [2821] = 2396,
  [2822] = 2398,
  [2823] = 2339,
  [2824] = 2174,
  [2825] = 2637,
  [2826] = 2438,
  [2827] = 1883,
  [2828] = 2447,
  [2829] = 2439,
  [2830] = 2435,
  [2831] = 2216,
  [2832] = 2251,
  [2833] = 2252,
  [2834] = 2262,
  [2835] = 2268,
  [2836] = 2159,
  [2837] = 2364,
  [2838] = 2306,
  [2839] = 2230,
  [2840] = 2305,
  [2841] = 2295,
  [2842] = 2344,
  [2843] = 2299,
  [2844] = 2291,
  [2845] = 2259,
  [2846] = 2215,
  [2847] = 2348,
  [2848] = 2353,
  [2849] = 2629,
  [2850] = 2444,
  [2851] = 2202,
  [2852] = 2429,
  [2853] = 2197,
  [2854] = 2354,
  [2855] = 2357,
  [2856] = 2423,
  [2857] = 2307,
  [2858] = 2599,
  [2859] = 2600,
  [2860] = 2238,
  [2861] = 2422,
  [2862] = 2228,
  [2863] = 2448,
  [2864] = 2242,
  [2865] = 2222,
  [2866] = 2223,
  [2867] = 2226,
  [2868] = 2445,
  [2869] = 2232,
  [2870] = 2293,
  [2871] = 2247,
  [2872] = 2270,
  [2873] = 2271,
  [2874] = 2282,
  [2875] = 2284,
  [2876] = 2288,
  [2877] = 2294,
  [2878] = 2312,
  [2879] = 2274,
  [2880] = 2325,
  [2881] = 2275,
  [2882] = 2213,
  [2883] = 2332,
  [2884] = 2313,
  [2885] = 2276,
  [2886] = 2336,
  [2887] = 2327,
  [2888] = 2341,
  [2889] = 2208,
  [2890] = 2333,
  [2891] = 2450,
  [2892] = 2442,
  [2893] = 2286,
  [2894] = 2287,
  [2895] = 2367,
  [2896] = 2323,
  [2897] = 2601,
  [2898] = 2433,
  [2899] = 2355,
  [2900] = 2277,
  [2901] = 2278,
  [2902] = 2310,
  [2903] = 2285,
  [2904] = 2219,
  [2905] = 2301,
  [2906] = 2234,
  [2907] = 2320,
  [2908] = 2304,
  [2909] = 2308,
  [2910] = 2321,
  [2911] = 2422,
  [2912] = 2448,
  [2913] = 2450,
  [2914] = 2442,
  [2915] = 2428,
  [2916] = 2366,
  [2917] = 2441,
  [2918] = 2423,
  [2919] = 2447,
  [2920] = 2433,
  [2921] = 2311,
  [2922] = 2296,
  [2923] = 2314,
  [2924] = 2324,
  [2925] = 2250,
  [2926] = 2309,
  [2927] = 2297,
  [2928] = 2202,
  [2929] = 2246,
  [2930] = 2268,
  [2931] = 2342,
  [2932] = 2212,
  [2933] = 2315,
  [2934] = 2608,
  [2935] = 2343,
  [2936] = 2597,
  [2937] = 2346,
  [2938] = 2264,
  [2939] = 2345,
  [2940] = 2350,
  [2941] = 2205,
  [2942] = 2428,
  [2943] = 2298,
  [2944] = 2329,
  [2945] = 2447,
  [2946] = 2236,
  [2947] = 2316,
  [2948] = 2317,
  [2949] = 2221,
  [2950] = 2227,
  [2951] = 2359,
  [2952] = 2229,
  [2953] = 2249,
  [2954] = 2254,
  [2955] = 2255,
  [2956] = 2256,
  [2957] = 2338,
  [2958] = 2322,
  [2959] = 2224,
  [2960] = 2340,
  [2961] = 2330,
  [2962] = 2360,
  [2963] = 2326,
  [2964] = 2606,
  [2965] = 2210,
  [2966] = 2425,
  [2967] = 2245,
  [2968] = 2292,
  [2969] = 2337,
  [2970] = 2161,
  [2971] = 2279,
  [2972] = 2349,
  [2973] = 2302,
  [2974] = 2265,
  [2975] = 2303,
  [2976] = 2300,
  [2977] = 2267,
  [2978] = 2424,
  [2979] = 2425,
  [2980] = 2421,
  [2981] = 2427,
  [2982] = 2431,
  [2983] = 2434,
  [2984] = 2435,
  [2985] = 2454,
  [2986] = 2438,
  [2987] = 2439,
  [2988] = 2440,
  [2989] = 2444,
  [2990] = 2445,
  [2991] = 2430,
  [2992] = 2334,
  [2993] = 2283,
  [2994] = 2243,
  [2995] = 2424,
  [2996] = 2260,
  [2997] = 2429,
  [2998] = 2430,
  [2999] = 2318,
  [3000] = 2209,
  [3001] = 2331,
  [3002] = 2335,
  [3003] = 2207,
  [3004] = 2356,
  [3005] = 2237,
  [3006] = 2225,
  [3007] = 2261,
  [3008] = 2319,
  [3009] = 2269,
  [3010] = 2233,
  [3011] = 2204,
  [3012] = 2248,
  [3013] = 2440,
  [3014] = 2218,
  [3015] = 2280,
  [3016] = 2290,
  [3017] = 2421,
  [3018] = 2427,
  [3019] = 2289,
  [3020] = 2431,
  [3021] = 2434,
  [3022] = 2328,
  [3023] = 2361,
  [3024] = 2435,
  [3025] = 2365,
  [3026] = 2206,
  [3027] = 2217,
  [3028] = 2454,
  [3029] = 2211,
  [3030] = 2362,
  [3031] = 2363,
  [3032] = 2244,
  [3033] = 2438,
  [3034] = 2439,
  [3035] = 2368,
  [3036] = 2214,
  [3037] = 2387,
  [3038] = 2438,
  [3039] = 2439,
  [3040] = 2440,
  [3041] = 2444,
  [3042] = 2445,
  [3043] = 2422,
  [3044] = 2448,
  [3045] = 2178,
  [3046] = 2239,
  [3047] = 2450,
  [3048] = 2442,
  [3049] = 2176,
  [3050] = 2433,
  [3051] = 2428,
  [3052] = 2220,
  [3053] = 2424,
  [3054] = 2239,
  [3055] = 2281,
  [3056] = 2241,
  [3057] = 2454,
  [3058] = 2424,
  [3059] = 2420,
  [3060] = 2197,
  [3061] = 2398,
  [3062] = 2447,
  [3063] = 2197,
  [3064] = 2396,
  [3065] = 2425,
  [3066] = 2387,
  [3067] = 2530,
  [3068] = 2179,
  [3069] = 2281,
  [3070] = 2241,
  [3071] = 2424,
  [3072] = 2421,
  [3073] = 2530,
  [3074] = 2220,
  [3075] = 2427,
  [3076] = 2396,
  [3077] = 2423,
  [3078] = 2431,
  [3079] = 2434,
  [3080] = 2387,
  [3081] = 2441,
  [3082] = 2435,
  [3083] = 2202,
  [3084] = 2435,
  [3085] = 3085,
  [3086] = 2421,
  [3087] = 2398,
  [3088] = 2429,
  [3089] = 2427,
  [3090] = 3085,
  [3091] = 3091,
  [3092] = 2431,
  [3093] = 3085,
  [3094] = 3085,
  [3095] = 2396,
  [3096] = 2420,
  [3097] = 2428,
  [3098] = 3085,
  [3099] = 2398,
  [3100] = 2629,
  [3101] = 2197,
  [3102] = 3091,
  [3103] = 2398,
  [3104] = 2665,
  [3105] = 2434,
  [3106] = 2423,
  [3107] = 2387,
  [3108] = 2606,
  [3109] = 3091,
  [3110] = 2454,
  [3111] = 2450,
  [3112] = 3091,
  [3113] = 2425,
  [3114] = 2669,
  [3115] = 3091,
  [3116] = 2599,
  [3117] = 2601,
  [3118] = 2668,
  [3119] = 2387,
  [3120] = 3085,
  [3121] = 3091,
  [3122] = 3085,
  [3123] = 2420,
  [3124] = 3091,
  [3125] = 2637,
  [3126] = 3085,
  [3127] = 3085,
  [3128] = 2441,
  [3129] = 3091,
  [3130] = 3091,
  [3131] = 2268,
  [3132] = 2597,
  [3133] = 2438,
  [3134] = 3091,
  [3135] = 3091,
  [3136] = 2600,
  [3137] = 2433,
  [3138] = 3138,
  [3139] = 2439,
  [3140] = 3085,
  [3141] = 2197,
  [3142] = 3091,
  [3143] = 3091,
  [3144] = 2440,
  [3145] = 2268,
  [3146] = 2422,
  [3147] = 2448,
  [3148] = 2433,
  [3149] = 3091,
  [3150] = 3091,
  [3151] = 2396,
  [3152] = 2420,
  [3153] = 2444,
  [3154] = 2663,
  [3155] = 2387,
  [3156] = 2445,
  [3157] = 2430,
  [3158] = 3091,
  [3159] = 2387,
  [3160] = 3085,
  [3161] = 3091,
  [3162] = 2447,
  [3163] = 2396,
  [3164] = 3085,
  [3165] = 2442,
  [3166] = 2445,
  [3167] = 2599,
  [3168] = 2425,
  [3169] = 2391,
  [3170] = 2389,
  [3171] = 2600,
  [3172] = 2441,
  [3173] = 2398,
  [3174] = 2339,
  [3175] = 2422,
  [3176] = 2448,
  [3177] = 2450,
  [3178] = 2442,
  [3179] = 2428,
  [3180] = 2433,
  [3181] = 2447,
  [3182] = 2421,
  [3183] = 2427,
  [3184] = 2431,
  [3185] = 2434,
  [3186] = 2450,
  [3187] = 2435,
  [3188] = 2454,
  [3189] = 2442,
  [3190] = 2438,
  [3191] = 2439,
  [3192] = 2440,
  [3193] = 2444,
  [3194] = 2422,
  [3195] = 2448,
  [3196] = 2450,
  [3197] = 2442,
  [3198] = 2428,
  [3199] = 2424,
  [3200] = 2343,
  [3201] = 2424,
  [3202] = 2361,
  [3203] = 2441,
  [3204] = 2601,
  [3205] = 2445,
  [3206] = 1883,
  [3207] = 1884,
  [3208] = 2433,
  [3209] = 2339,
  [3210] = 2420,
  [3211] = 2424,
  [3212] = 2423,
  [3213] = 2429,
  [3214] = 1885,
  [3215] = 1886,
  [3216] = 1882,
  [3217] = 2430,
  [3218] = 2398,
  [3219] = 2629,
  [3220] = 2424,
  [3221] = 2424,
  [3222] = 2220,
  [3223] = 2387,
  [3224] = 2387,
  [3225] = 2241,
  [3226] = 2422,
  [3227] = 2448,
  [3228] = 2281,
  [3229] = 2239,
  [3230] = 2530,
  [3231] = 2441,
  [3232] = 2391,
  [3233] = 2389,
  [3234] = 2425,
  [3235] = 2423,
  [3236] = 2387,
  [3237] = 2421,
  [3238] = 2427,
  [3239] = 2431,
  [3240] = 2434,
  [3241] = 2435,
  [3242] = 2454,
  [3243] = 2438,
  [3244] = 2439,
  [3245] = 2440,
  [3246] = 2444,
  [3247] = 2445,
  [3248] = 2433,
  [3249] = 2420,
  [3250] = 2606,
  [3251] = 2429,
  [3252] = 2430,
  [3253] = 2398,
  [3254] = 2424,
  [3255] = 2396,
  [3256] = 2396,
  [3257] = 2420,
  [3258] = 2268,
  [3259] = 2441,
  [3260] = 3260,
  [3261] = 2425,
  [3262] = 2423,
  [3263] = 2421,
  [3264] = 2427,
  [3265] = 2431,
  [3266] = 2434,
  [3267] = 2435,
  [3268] = 2454,
  [3269] = 2438,
  [3270] = 2439,
  [3271] = 2440,
  [3272] = 2444,
  [3273] = 2433,
  [3274] = 2268,
  [3275] = 2425,
  [3276] = 2423,
  [3277] = 2447,
  [3278] = 2421,
  [3279] = 2427,
  [3280] = 2431,
  [3281] = 2434,
  [3282] = 2435,
  [3283] = 2454,
  [3284] = 2438,
  [3285] = 2439,
  [3286] = 2440,
  [3287] = 2444,
  [3288] = 2445,
  [3289] = 3289,
  [3290] = 1880,
  [3291] = 3291,
  [3292] = 2428,
  [3293] = 2422,
  [3294] = 2448,
  [3295] = 2450,
  [3296] = 2442,
  [3297] = 2428,
  [3298] = 2396,
  [3299] = 2433,
  [3300] = 2447,
  [3301] = 2530,
  [3302] = 2387,
  [3303] = 2429,
  [3304] = 2430,
  [3305] = 2396,
  [3306] = 2447,
  [3307] = 2422,
  [3308] = 2448,
  [3309] = 2450,
  [3310] = 2424,
  [3311] = 3311,
  [3312] = 3311,
  [3313] = 2424,
  [3314] = 2442,
  [3315] = 2425,
  [3316] = 2423,
  [3317] = 3311,
  [3318] = 2447,
  [3319] = 3319,
  [3320] = 2349,
  [3321] = 2428,
  [3322] = 2441,
  [3323] = 3311,
  [3324] = 2396,
  [3325] = 2429,
  [3326] = 2425,
  [3327] = 2423,
  [3328] = 2637,
  [3329] = 2447,
  [3330] = 2421,
  [3331] = 2427,
  [3332] = 2431,
  [3333] = 2434,
  [3334] = 2435,
  [3335] = 2454,
  [3336] = 2438,
  [3337] = 2439,
  [3338] = 2440,
  [3339] = 2444,
  [3340] = 2445,
  [3341] = 2159,
  [3342] = 2364,
  [3343] = 2286,
  [3344] = 2429,
  [3345] = 2398,
  [3346] = 2430,
  [3347] = 2287,
  [3348] = 3311,
  [3349] = 2668,
  [3350] = 2669,
  [3351] = 2208,
  [3352] = 2303,
  [3353] = 2341,
  [3354] = 2663,
  [3355] = 2391,
  [3356] = 2389,
  [3357] = 2421,
  [3358] = 2424,
  [3359] = 2424,
  [3360] = 2268,
  [3361] = 2427,
  [3362] = 2665,
  [3363] = 2420,
  [3364] = 2450,
  [3365] = 2442,
  [3366] = 2433,
  [3367] = 2428,
  [3368] = 2447,
  [3369] = 2431,
  [3370] = 2423,
  [3371] = 2599,
  [3372] = 2600,
  [3373] = 2434,
  [3374] = 2435,
  [3375] = 2629,
  [3376] = 2454,
  [3377] = 2438,
  [3378] = 2396,
  [3379] = 2421,
  [3380] = 2427,
  [3381] = 2431,
  [3382] = 2434,
  [3383] = 2435,
  [3384] = 2454,
  [3385] = 2438,
  [3386] = 2439,
  [3387] = 2440,
  [3388] = 2444,
  [3389] = 2445,
  [3390] = 2439,
  [3391] = 2440,
  [3392] = 2444,
  [3393] = 2433,
  [3394] = 2445,
  [3395] = 2422,
  [3396] = 2448,
  [3397] = 2450,
  [3398] = 2442,
  [3399] = 2428,
  [3400] = 2430,
  [3401] = 2422,
  [3402] = 2429,
  [3403] = 2430,
  [3404] = 2339,
  [3405] = 2597,
  [3406] = 2601,
  [3407] = 2606,
  [3408] = 2425,
  [3409] = 3319,
  [3410] = 3319,
  [3411] = 2448,
  [3412] = 2454,
  [3413] = 2433,
  [3414] = 1885,
  [3415] = 2424,
  [3416] = 1886,
  [3417] = 2387,
  [3418] = 2429,
  [3419] = 2430,
  [3420] = 2387,
  [3421] = 2268,
  [3422] = 2147,
  [3423] = 2601,
  [3424] = 2154,
  [3425] = 2163,
  [3426] = 2425,
  [3427] = 2423,
  [3428] = 2421,
  [3429] = 2427,
  [3430] = 2431,
  [3431] = 2434,
  [3432] = 2435,
  [3433] = 2454,
  [3434] = 2438,
  [3435] = 2439,
  [3436] = 2440,
  [3437] = 2444,
  [3438] = 2445,
  [3439] = 2387,
  [3440] = 2530,
  [3441] = 2447,
  [3442] = 2421,
  [3443] = 2427,
  [3444] = 2431,
  [3445] = 2434,
  [3446] = 2435,
  [3447] = 2637,
  [3448] = 2600,
  [3449] = 2439,
  [3450] = 2440,
  [3451] = 2444,
  [3452] = 2445,
  [3453] = 2387,
  [3454] = 2606,
  [3455] = 2425,
  [3456] = 2391,
  [3457] = 2389,
  [3458] = 2422,
  [3459] = 2448,
  [3460] = 2450,
  [3461] = 2442,
  [3462] = 2433,
  [3463] = 2428,
  [3464] = 2447,
  [3465] = 2396,
  [3466] = 2441,
  [3467] = 2422,
  [3468] = 2448,
  [3469] = 2450,
  [3470] = 2442,
  [3471] = 2428,
  [3472] = 2387,
  [3473] = 2629,
  [3474] = 2424,
  [3475] = 2423,
  [3476] = 2597,
  [3477] = 2599,
  [3478] = 2438,
  [3479] = 2396,
  [3480] = 2396,
  [3481] = 3481,
  [3482] = 3482,
  [3483] = 3483,
  [3484] = 2420,
  [3485] = 2433,
  [3486] = 2442,
  [3487] = 2428,
  [3488] = 2434,
  [3489] = 2435,
  [3490] = 2425,
  [3491] = 2423,
  [3492] = 2454,
  [3493] = 2424,
  [3494] = 2438,
  [3495] = 2420,
  [3496] = 2439,
  [3497] = 2440,
  [3498] = 2530,
  [3499] = 2396,
  [3500] = 2444,
  [3501] = 1937,
  [3502] = 2398,
  [3503] = 2424,
  [3504] = 1935,
  [3505] = 2398,
  [3506] = 2601,
  [3507] = 2530,
  [3508] = 2387,
  [3509] = 2387,
  [3510] = 2441,
  [3511] = 2445,
  [3512] = 2447,
  [3513] = 2421,
  [3514] = 2427,
  [3515] = 2431,
  [3516] = 2663,
  [3517] = 2665,
  [3518] = 2387,
  [3519] = 2668,
  [3520] = 2669,
  [3521] = 2420,
  [3522] = 2398,
  [3523] = 2422,
  [3524] = 2396,
  [3525] = 2433,
  [3526] = 2637,
  [3527] = 2448,
  [3528] = 2396,
  [3529] = 2420,
  [3530] = 2398,
  [3531] = 2450,
  [3532] = 2387,
  [3533] = 2396,
  [3534] = 2433,
  [3535] = 2420,
  [3536] = 2440,
  [3537] = 2608,
  [3538] = 3538,
  [3539] = 2433,
  [3540] = 2220,
  [3541] = 2606,
  [3542] = 2420,
  [3543] = 2637,
  [3544] = 2433,
  [3545] = 2438,
  [3546] = 2241,
  [3547] = 2396,
  [3548] = 2281,
  [3549] = 2239,
  [3550] = 2428,
  [3551] = 2422,
  [3552] = 2430,
  [3553] = 2448,
  [3554] = 2439,
  [3555] = 2450,
  [3556] = 2442,
  [3557] = 2424,
  [3558] = 2433,
  [3559] = 2425,
  [3560] = 2423,
  [3561] = 2174,
  [3562] = 2441,
  [3563] = 2398,
  [3564] = 2447,
  [3565] = 2629,
  [3566] = 2599,
  [3567] = 2600,
  [3568] = 2441,
  [3569] = 2429,
  [3570] = 2430,
  [3571] = 2425,
  [3572] = 2182,
  [3573] = 2423,
  [3574] = 2629,
  [3575] = 2608,
  [3576] = 2421,
  [3577] = 2427,
  [3578] = 2431,
  [3579] = 2434,
  [3580] = 2435,
  [3581] = 2433,
  [3582] = 2454,
  [3583] = 2438,
  [3584] = 2439,
  [3585] = 2440,
  [3586] = 2444,
  [3587] = 2445,
  [3588] = 2422,
  [3589] = 2448,
  [3590] = 2450,
  [3591] = 2442,
  [3592] = 2422,
  [3593] = 2448,
  [3594] = 2450,
  [3595] = 2442,
  [3596] = 2428,
  [3597] = 2425,
  [3598] = 2387,
  [3599] = 2447,
  [3600] = 2423,
  [3601] = 2421,
  [3602] = 2427,
  [3603] = 2431,
  [3604] = 2434,
  [3605] = 2425,
  [3606] = 2597,
  [3607] = 2428,
  [3608] = 2435,
  [3609] = 2454,
  [3610] = 2438,
  [3611] = 2421,
  [3612] = 2427,
  [3613] = 2431,
  [3614] = 2396,
  [3615] = 2606,
  [3616] = 2396,
  [3617] = 2434,
  [3618] = 2398,
  [3619] = 2435,
  [3620] = 2454,
  [3621] = 2424,
  [3622] = 2423,
  [3623] = 2439,
  [3624] = 2601,
  [3625] = 2438,
  [3626] = 2439,
  [3627] = 2440,
  [3628] = 2444,
  [3629] = 2440,
  [3630] = 2530,
  [3631] = 2429,
  [3632] = 2447,
  [3633] = 2422,
  [3634] = 2448,
  [3635] = 2450,
  [3636] = 2442,
  [3637] = 2428,
  [3638] = 2424,
  [3639] = 2445,
  [3640] = 2433,
  [3641] = 2420,
  [3642] = 2429,
  [3643] = 2430,
  [3644] = 2597,
  [3645] = 2444,
  [3646] = 2445,
  [3647] = 2422,
  [3648] = 2448,
  [3649] = 2430,
  [3650] = 2450,
  [3651] = 2442,
  [3652] = 2387,
  [3653] = 2599,
  [3654] = 2421,
  [3655] = 2427,
  [3656] = 2445,
  [3657] = 2428,
  [3658] = 2431,
  [3659] = 2441,
  [3660] = 2424,
  [3661] = 2434,
  [3662] = 2435,
  [3663] = 2387,
  [3664] = 2444,
  [3665] = 2396,
  [3666] = 2600,
  [3667] = 2447,
  [3668] = 2433,
  [3669] = 2387,
  [3670] = 2387,
  [3671] = 2387,
  [3672] = 2398,
  [3673] = 2429,
  [3674] = 3674,
  [3675] = 2425,
  [3676] = 2423,
  [3677] = 2447,
  [3678] = 2421,
  [3679] = 2427,
  [3680] = 2431,
  [3681] = 2434,
  [3682] = 2435,
  [3683] = 2454,
  [3684] = 2438,
  [3685] = 2439,
  [3686] = 2440,
  [3687] = 2444,
  [3688] = 2445,
  [3689] = 2454,
  [3690] = 2530,
  [3691] = 2601,
  [3692] = 2429,
  [3693] = 2427,
  [3694] = 2441,
  [3695] = 2439,
  [3696] = 2428,
  [3697] = 2440,
  [3698] = 2444,
  [3699] = 2447,
  [3700] = 2431,
  [3701] = 2434,
  [3702] = 2435,
  [3703] = 2454,
  [3704] = 2396,
  [3705] = 2438,
  [3706] = 2423,
  [3707] = 2439,
  [3708] = 2440,
  [3709] = 2447,
  [3710] = 2421,
  [3711] = 2427,
  [3712] = 2431,
  [3713] = 2434,
  [3714] = 2435,
  [3715] = 2454,
  [3716] = 2438,
  [3717] = 2439,
  [3718] = 2440,
  [3719] = 2444,
  [3720] = 2445,
  [3721] = 2439,
  [3722] = 2440,
  [3723] = 2445,
  [3724] = 2444,
  [3725] = 2430,
  [3726] = 2444,
  [3727] = 2427,
  [3728] = 2445,
  [3729] = 2431,
  [3730] = 2444,
  [3731] = 2447,
  [3732] = 2608,
  [3733] = 2396,
  [3734] = 2445,
  [3735] = 2600,
  [3736] = 2428,
  [3737] = 2447,
  [3738] = 2629,
  [3739] = 2424,
  [3740] = 2429,
  [3741] = 2424,
  [3742] = 2425,
  [3743] = 2396,
  [3744] = 2422,
  [3745] = 2448,
  [3746] = 2424,
  [3747] = 2450,
  [3748] = 2601,
  [3749] = 2433,
  [3750] = 2445,
  [3751] = 2428,
  [3752] = 2434,
  [3753] = 2435,
  [3754] = 2435,
  [3755] = 2454,
  [3756] = 2454,
  [3757] = 2398,
  [3758] = 2422,
  [3759] = 2448,
  [3760] = 2450,
  [3761] = 2423,
  [3762] = 2442,
  [3763] = 2440,
  [3764] = 2421,
  [3765] = 2424,
  [3766] = 2442,
  [3767] = 2438,
  [3768] = 2425,
  [3769] = 2429,
  [3770] = 2530,
  [3771] = 2398,
  [3772] = 2428,
  [3773] = 2606,
  [3774] = 2442,
  [3775] = 2438,
  [3776] = 2425,
  [3777] = 2422,
  [3778] = 2448,
  [3779] = 2450,
  [3780] = 2442,
  [3781] = 2433,
  [3782] = 2428,
  [3783] = 2441,
  [3784] = 2425,
  [3785] = 2423,
  [3786] = 2597,
  [3787] = 2424,
  [3788] = 2422,
  [3789] = 2448,
  [3790] = 2447,
  [3791] = 2423,
  [3792] = 2421,
  [3793] = 2421,
  [3794] = 2420,
  [3795] = 2424,
  [3796] = 2427,
  [3797] = 2431,
  [3798] = 2434,
  [3799] = 2450,
  [3800] = 2435,
  [3801] = 2454,
  [3802] = 2599,
  [3803] = 2442,
  [3804] = 2438,
  [3805] = 2421,
  [3806] = 2425,
  [3807] = 2423,
  [3808] = 2430,
  [3809] = 2530,
  [3810] = 2396,
  [3811] = 2420,
  [3812] = 2433,
  [3813] = 2427,
  [3814] = 2431,
  [3815] = 2434,
  [3816] = 2439,
  [3817] = 2450,
  [3818] = 2422,
  [3819] = 2448,
  [3820] = 2430,
  [3821] = 2530,
  [3822] = 2447,
  [3823] = 2429,
  [3824] = 2606,
  [3825] = 2431,
  [3826] = 2434,
  [3827] = 2430,
  [3828] = 2435,
  [3829] = 2430,
  [3830] = 2387,
  [3831] = 2454,
  [3832] = 2637,
  [3833] = 2668,
  [3834] = 2669,
  [3835] = 2597,
  [3836] = 2599,
  [3837] = 2600,
  [3838] = 2423,
  [3839] = 2429,
  [3840] = 2424,
  [3841] = 2433,
  [3842] = 2438,
  [3843] = 2439,
  [3844] = 2447,
  [3845] = 2448,
  [3846] = 2440,
  [3847] = 2444,
  [3848] = 2396,
  [3849] = 2445,
  [3850] = 2629,
  [3851] = 2447,
  [3852] = 2530,
  [3853] = 2424,
  [3854] = 2425,
  [3855] = 2425,
  [3856] = 2597,
  [3857] = 2423,
  [3858] = 2601,
  [3859] = 2433,
  [3860] = 2424,
  [3861] = 2421,
  [3862] = 2427,
  [3863] = 2431,
  [3864] = 2422,
  [3865] = 2448,
  [3866] = 2450,
  [3867] = 2450,
  [3868] = 2442,
  [3869] = 2601,
  [3870] = 2423,
  [3871] = 2599,
  [3872] = 2434,
  [3873] = 2427,
  [3874] = 2600,
  [3875] = 2424,
  [3876] = 2428,
  [3877] = 2433,
  [3878] = 2422,
  [3879] = 2435,
  [3880] = 2421,
  [3881] = 2448,
  [3882] = 2387,
  [3883] = 2450,
  [3884] = 2442,
  [3885] = 2428,
  [3886] = 2454,
  [3887] = 2438,
  [3888] = 2439,
  [3889] = 2427,
  [3890] = 2440,
  [3891] = 2428,
  [3892] = 2431,
  [3893] = 2444,
  [3894] = 2434,
  [3895] = 2435,
  [3896] = 2387,
  [3897] = 2637,
  [3898] = 2663,
  [3899] = 2665,
  [3900] = 2668,
  [3901] = 2669,
  [3902] = 2454,
  [3903] = 2438,
  [3904] = 2439,
  [3905] = 2422,
  [3906] = 2440,
  [3907] = 2444,
  [3908] = 2445,
  [3909] = 2441,
  [3910] = 3910,
  [3911] = 2441,
  [3912] = 2606,
  [3913] = 2387,
  [3914] = 2445,
  [3915] = 2425,
  [3916] = 2663,
  [3917] = 2601,
  [3918] = 2421,
  [3919] = 2629,
  [3920] = 2665,
  [3921] = 2442,
  [3922] = 2427,
  [3923] = 2441,
  [3924] = 2396,
  [3925] = 2422,
  [3926] = 2450,
  [3927] = 2442,
  [3928] = 2428,
  [3929] = 2606,
  [3930] = 2606,
  [3931] = 2425,
  [3932] = 2430,
  [3933] = 2597,
  [3934] = 2450,
  [3935] = 2442,
  [3936] = 2420,
  [3937] = 2637,
  [3938] = 2663,
  [3939] = 2665,
  [3940] = 2668,
  [3941] = 2669,
  [3942] = 2398,
  [3943] = 2597,
  [3944] = 2599,
  [3945] = 2600,
  [3946] = 2396,
  [3947] = 2629,
  [3948] = 2424,
  [3949] = 2425,
  [3950] = 2421,
  [3951] = 2427,
  [3952] = 2431,
  [3953] = 2434,
  [3954] = 2435,
  [3955] = 2454,
  [3956] = 2438,
  [3957] = 2439,
  [3958] = 2440,
  [3959] = 2444,
  [3960] = 2445,
  [3961] = 2423,
  [3962] = 2599,
  [3963] = 2600,
  [3964] = 2429,
  [3965] = 2424,
  [3966] = 2447,
  [3967] = 2423,
  [3968] = 2447,
  [3969] = 2433,
  [3970] = 2421,
  [3971] = 2431,
  [3972] = 2434,
  [3973] = 2435,
  [3974] = 2454,
  [3975] = 2438,
  [3976] = 2439,
  [3977] = 2428,
  [3978] = 2440,
  [3979] = 2444,
  [3980] = 2422,
  [3981] = 2448,
  [3982] = 2445,
  [3983] = 2629,
  [3984] = 2396,
  [3985] = 2448,
  [3986] = 2421,
  [3987] = 2387,
  [3988] = 2433,
  [3989] = 2663,
  [3990] = 2665,
  [3991] = 2420,
  [3992] = 2668,
  [3993] = 2669,
  [3994] = 2447,
  [3995] = 2396,
  [3996] = 2387,
  [3997] = 2663,
  [3998] = 2396,
  [3999] = 3999,
  [4000] = 2668,
  [4001] = 2669,
  [4002] = 2601,
  [4003] = 2387,
  [4004] = 2387,
  [4005] = 2663,
  [4006] = 2665,
  [4007] = 2421,
  [4008] = 2427,
  [4009] = 2431,
  [4010] = 2434,
  [4011] = 2435,
  [4012] = 2454,
  [4013] = 2438,
  [4014] = 2439,
  [4015] = 2440,
  [4016] = 2444,
  [4017] = 2445,
  [4018] = 2637,
  [4019] = 2433,
  [4020] = 2422,
  [4021] = 2448,
  [4022] = 2450,
  [4023] = 2442,
  [4024] = 2428,
  [4025] = 2600,
  [4026] = 2637,
  [4027] = 2431,
  [4028] = 2434,
  [4029] = 2435,
  [4030] = 2454,
  [4031] = 2438,
  [4032] = 2439,
  [4033] = 2440,
  [4034] = 2444,
  [4035] = 2445,
  [4036] = 2422,
  [4037] = 2448,
  [4038] = 2450,
  [4039] = 2442,
  [4040] = 2428,
  [4041] = 2447,
  [4042] = 2425,
  [4043] = 1882,
  [4044] = 2425,
  [4045] = 2433,
  [4046] = 2601,
  [4047] = 2423,
  [4048] = 2447,
  [4049] = 2423,
  [4050] = 2429,
  [4051] = 2398,
  [4052] = 2430,
  [4053] = 2668,
  [4054] = 2629,
  [4055] = 2606,
  [4056] = 2669,
  [4057] = 2599,
  [4058] = 2427,
  [4059] = 2434,
  [4060] = 2429,
  [4061] = 2606,
  [4062] = 2421,
  [4063] = 2427,
  [4064] = 2431,
  [4065] = 2434,
  [4066] = 2425,
  [4067] = 2435,
  [4068] = 2454,
  [4069] = 2438,
  [4070] = 2439,
  [4071] = 2440,
  [4072] = 2444,
  [4073] = 2447,
  [4074] = 2445,
  [4075] = 4075,
  [4076] = 2599,
  [4077] = 2600,
  [4078] = 2422,
  [4079] = 2448,
  [4080] = 2361,
  [4081] = 2433,
  [4082] = 2421,
  [4083] = 2427,
  [4084] = 2431,
  [4085] = 2445,
  [4086] = 2637,
  [4087] = 2434,
  [4088] = 2668,
  [4089] = 2435,
  [4090] = 2454,
  [4091] = 2438,
  [4092] = 2439,
  [4093] = 2440,
  [4094] = 2669,
  [4095] = 2444,
  [4096] = 2665,
  [4097] = 4075,
  [4098] = 2425,
  [4099] = 2396,
  [4100] = 2396,
  [4101] = 2398,
  [4102] = 2428,
  [4103] = 2423,
  [4104] = 2447,
  [4105] = 4105,
  [4106] = 2665,
  [4107] = 2425,
  [4108] = 2430,
  [4109] = 2442,
  [4110] = 2343,
  [4111] = 2438,
  [4112] = 2420,
  [4113] = 2637,
  [4114] = 2445,
  [4115] = 2447,
  [4116] = 2440,
  [4117] = 2444,
  [4118] = 2422,
  [4119] = 2448,
  [4120] = 2423,
  [4121] = 2450,
  [4122] = 2422,
  [4123] = 2442,
  [4124] = 2448,
  [4125] = 2663,
  [4126] = 2433,
  [4127] = 4127,
  [4128] = 2428,
  [4129] = 2439,
  [4130] = 4130,
  [4131] = 2421,
  [4132] = 2427,
  [4133] = 2431,
  [4134] = 2430,
  [4135] = 2450,
  [4136] = 2435,
  [4137] = 2454,
  [4138] = 2428,
  [4139] = 2161,
  [4140] = 2450,
  [4141] = 4127,
  [4142] = 4130,
  [4143] = 2442,
  [4144] = 2629,
  [4145] = 4075,
  [4146] = 2423,
  [4147] = 2447,
  [4148] = 2440,
  [4149] = 2444,
  [4150] = 2434,
  [4151] = 2445,
  [4152] = 2450,
  [4153] = 2435,
  [4154] = 2454,
  [4155] = 2422,
  [4156] = 2448,
  [4157] = 2450,
  [4158] = 2442,
  [4159] = 2442,
  [4160] = 2438,
  [4161] = 2428,
  [4162] = 2422,
  [4163] = 2448,
  [4164] = 2637,
  [4165] = 2439,
  [4166] = 2440,
  [4167] = 2444,
  [4168] = 4130,
  [4169] = 2425,
  [4170] = 4127,
  [4171] = 2439,
  [4172] = 2423,
  [4173] = 4173,
  [4174] = 2429,
  [4175] = 2425,
  [4176] = 2433,
  [4177] = 2423,
  [4178] = 2430,
  [4179] = 2433,
  [4180] = 3538,
  [4181] = 2428,
  [4182] = 2421,
  [4183] = 2447,
  [4184] = 2427,
  [4185] = 2421,
  [4186] = 2427,
  [4187] = 2431,
  [4188] = 2434,
  [4189] = 2435,
  [4190] = 2454,
  [4191] = 3674,
  [4192] = 2431,
  [4193] = 2438,
  [4194] = 4127,
  [4195] = 4130,
  [4196] = 2445,
  [4197] = 2234,
  [4198] = 4198,
  [4199] = 4198,
  [4200] = 4198,
  [4201] = 4198,
  [4202] = 4198,
  [4203] = 4198,
  [4204] = 4198,
  [4205] = 4205,
  [4206] = 4198,
  [4207] = 4198,
  [4208] = 4198,
  [4209] = 4198,
  [4210] = 4198,
  [4211] = 4198,
  [4212] = 4198,
  [4213] = 4198,
  [4214] = 4198,
  [4215] = 4198,
  [4216] = 4198,
  [4217] = 2439,
  [4218] = 4198,
  [4219] = 4205,
  [4220] = 2440,
  [4221] = 2444,
  [4222] = 2431,
  [4223] = 2445,
  [4224] = 4198,
  [4225] = 4198,
  [4226] = 4198,
  [4227] = 2421,
  [4228] = 4198,
  [4229] = 4229,
  [4230] = 4230,
  [4231] = 2434,
  [4232] = 2427,
  [4233] = 2182,
  [4234] = 2319,
  [4235] = 2320,
  [4236] = 2321,
  [4237] = 2322,
  [4238] = 4198,
  [4239] = 2326,
  [4240] = 2450,
  [4241] = 2435,
  [4242] = 4198,
  [4243] = 2454,
  [4244] = 2425,
  [4245] = 2423,
  [4246] = 4246,
  [4247] = 4198,
  [4248] = 2442,
  [4249] = 2366,
  [4250] = 2367,
  [4251] = 4198,
  [4252] = 4198,
  [4253] = 2428,
  [4254] = 4254,
  [4255] = 2332,
  [4256] = 4198,
  [4257] = 4198,
  [4258] = 4198,
  [4259] = 4198,
  [4260] = 4198,
  [4261] = 4198,
  [4262] = 4198,
  [4263] = 4205,
  [4264] = 2238,
  [4265] = 4198,
  [4266] = 4198,
  [4267] = 2304,
  [4268] = 4198,
  [4269] = 4198,
  [4270] = 2336,
  [4271] = 2447,
  [4272] = 4198,
  [4273] = 2308,
  [4274] = 2422,
  [4275] = 2448,
  [4276] = 4198,
  [4277] = 4198,
  [4278] = 2311,
  [4279] = 2174,
  [4280] = 2314,
  [4281] = 4198,
  [4282] = 4282,
  [4283] = 4198,
  [4284] = 4198,
  [4285] = 4205,
  [4286] = 4286,
  [4287] = 4205,
  [4288] = 4205,
  [4289] = 4205,
  [4290] = 4205,
  [4291] = 4198,
  [4292] = 4205,
  [4293] = 4205,
  [4294] = 4205,
  [4295] = 4205,
  [4296] = 4205,
  [4297] = 4205,
  [4298] = 4205,
  [4299] = 4205,
  [4300] = 4205,
  [4301] = 4205,
  [4302] = 4205,
  [4303] = 4205,
  [4304] = 4205,
  [4305] = 4205,
  [4306] = 2324,
  [4307] = 4205,
  [4308] = 2637,
  [4309] = 4205,
  [4310] = 2438,
  [4311] = 4311,
  [4312] = 2245,
  [4313] = 2304,
  [4314] = 2308,
  [4315] = 2311,
  [4316] = 2314,
  [4317] = 2292,
  [4318] = 2227,
  [4319] = 2229,
  [4320] = 2324,
  [4321] = 2334,
  [4322] = 2302,
  [4323] = 2318,
  [4324] = 2335,
  [4325] = 2319,
  [4326] = 2320,
  [4327] = 2289,
  [4328] = 2321,
  [4329] = 2331,
  [4330] = 2322,
  [4331] = 2207,
  [4332] = 2326,
  [4333] = 2230,
  [4334] = 2365,
  [4335] = 2366,
  [4336] = 2367,
  [4337] = 2234,
  [4338] = 4338,
  [4339] = 2238,
  [4340] = 2228,
  [4341] = 2214,
  [4342] = 2345,
  [4343] = 2306,
  [4344] = 2305,
  [4345] = 4345,
  [4346] = 2336,
  [4347] = 2310,
  [4348] = 4348,
  [4349] = 4349,
  [4350] = 2053,
  [4351] = 2206,
  [4352] = 2291,
  [4353] = 2328,
  [4354] = 2337,
  [4355] = 2332,
  [4356] = 2244,
  [4357] = 2251,
  [4358] = 2221,
  [4359] = 2252,
  [4360] = 2205,
  [4361] = 2224,
  [4362] = 2262,
  [4363] = 4363,
  [4364] = 4364,
  [4365] = 4365,
  [4366] = 4366,
  [4367] = 4367,
  [4368] = 4368,
  [4369] = 4369,
  [4370] = 4370,
  [4371] = 4371,
  [4372] = 4372,
  [4373] = 4373,
  [4374] = 4374,
  [4375] = 4375,
  [4376] = 4376,
  [4377] = 4377,
  [4378] = 4378,
  [4379] = 4379,
  [4380] = 4380,
  [4381] = 4381,
  [4382] = 4382,
  [4383] = 4383,
  [4384] = 4384,
  [4385] = 4385,
  [4386] = 4386,
  [4387] = 4371,
  [4388] = 4388,
  [4389] = 4386,
  [4390] = 4390,
  [4391] = 3289,
  [4392] = 4392,
  [4393] = 4393,
  [4394] = 1880,
  [4395] = 3291,
  [4396] = 1883,
  [4397] = 1884,
  [4398] = 1885,
  [4399] = 3674,
  [4400] = 3538,
  [4401] = 1886,
  [4402] = 4402,
  [4403] = 4403,
  [4404] = 4404,
  [4405] = 4405,
  [4406] = 4406,
  [4407] = 4407,
  [4408] = 4408,
  [4409] = 4409,
  [4410] = 4410,
  [4411] = 4411,
  [4412] = 4412,
  [4413] = 4413,
  [4414] = 4414,
  [4415] = 4415,
  [4416] = 4416,
  [4417] = 4417,
  [4418] = 4418,
  [4419] = 4419,
  [4420] = 4420,
  [4421] = 4421,
  [4422] = 4422,
  [4423] = 4423,
  [4424] = 4424,
  [4425] = 4425,
  [4426] = 4426,
  [4427] = 4427,
  [4428] = 4428,
  [4429] = 4429,
  [4430] = 4430,
  [4431] = 4431,
  [4432] = 4432,
  [4433] = 4433,
  [4434] = 4434,
  [4435] = 4435,
  [4436] = 4436,
  [4437] = 4437,
  [4438] = 4438,
  [4439] = 4439,
  [4440] = 4440,
  [4441] = 4441,
  [4442] = 4442,
  [4443] = 4443,
  [4444] = 4444,
  [4445] = 4445,
  [4446] = 3674,
  [4447] = 3674,
  [4448] = 3538,
  [4449] = 3538,
  [4450] = 4450,
  [4451] = 4451,
  [4452] = 4452,
  [4453] = 4453,
  [4454] = 4454,
  [4455] = 4455,
  [4456] = 4456,
  [4457] = 4457,
  [4458] = 4458,
  [4459] = 4459,
  [4460] = 4460,
  [4461] = 4461,
  [4462] = 4462,
  [4463] = 4463,
  [4464] = 4464,
  [4465] = 4465,
  [4466] = 4465,
  [4467] = 4465,
  [4468] = 4468,
  [4469] = 4469,
  [4470] = 4465,
  [4471] = 4465,
  [4472] = 4465,
  [4473] = 4465,
  [4474] = 4465,
  [4475] = 4465,
  [4476] = 4465,
  [4477] = 4465,
  [4478] = 4478,
  [4479] = 4465,
  [4480] = 4465,
  [4481] = 4465,
  [4482] = 4465,
  [4483] = 4465,
  [4484] = 4465,
  [4485] = 4465,
  [4486] = 4465,
  [4487] = 4465,
  [4488] = 4465,
  [4489] = 4465,
  [4490] = 4465,
  [4491] = 4363,
  [4492] = 4465,
  [4493] = 4493,
  [4494] = 4494,
  [4495] = 4493,
  [4496] = 4493,
  [4497] = 4493,
  [4498] = 4498,
  [4499] = 4499,
  [4500] = 4493,
  [4501] = 4385,
  [4502] = 4502,
  [4503] = 4493,
  [4504] = 4454,
  [4505] = 4505,
  [4506] = 4464,
  [4507] = 4461,
  [4508] = 4493,
  [4509] = 4509,
  [4510] = 4402,
  [4511] = 4511,
  [4512] = 4468,
  [4513] = 4513,
  [4514] = 3138,
  [4515] = 4469,
  [4516] = 2343,
  [4517] = 4517,
  [4518] = 4518,
  [4519] = 2361,
  [4520] = 4518,
  [4521] = 4521,
  [4522] = 4522,
  [4523] = 4523,
  [4524] = 4469,
  [4525] = 4525,
  [4526] = 4523,
  [4527] = 4527,
  [4528] = 4417,
  [4529] = 4429,
  [4530] = 4530,
  [4531] = 4422,
  [4532] = 4445,
  [4533] = 4412,
  [4534] = 4534,
  [4535] = 4525,
  [4536] = 4536,
  [4537] = 4468,
  [4538] = 4538,
  [4539] = 4539,
  [4540] = 4450,
  [4541] = 2161,
  [4542] = 1882,
  [4543] = 4543,
  [4544] = 4544,
  [4545] = 4539,
  [4546] = 4538,
  [4547] = 4544,
  [4548] = 4543,
  [4549] = 4543,
  [4550] = 4539,
  [4551] = 4544,
  [4552] = 4552,
  [4553] = 4462,
  [4554] = 4461,
  [4555] = 4455,
  [4556] = 4552,
  [4557] = 4451,
  [4558] = 4458,
  [4559] = 4559,
  [4560] = 4452,
  [4561] = 4459,
  [4562] = 4363,
  [4563] = 4552,
  [4564] = 4460,
  [4565] = 4453,
  [4566] = 4457,
  [4567] = 4456,
  [4568] = 4464,
  [4569] = 4454,
  [4570] = 4552,
  [4571] = 4463,
  [4572] = 4572,
  [4573] = 4385,
  [4574] = 4468,
  [4575] = 2161,
  [4576] = 4469,
  [4577] = 2161,
  [4578] = 2314,
  [4579] = 4173,
  [4580] = 4363,
  [4581] = 2174,
  [4582] = 2234,
  [4583] = 2182,
  [4584] = 4286,
  [4585] = 2336,
  [4586] = 2016,
  [4587] = 4254,
  [4588] = 4229,
  [4589] = 2238,
  [4590] = 4230,
  [4591] = 2319,
  [4592] = 2320,
  [4593] = 2304,
  [4594] = 2321,
  [4595] = 2322,
  [4596] = 2308,
  [4597] = 2013,
  [4598] = 2326,
  [4599] = 4461,
  [4600] = 2311,
  [4601] = 4246,
  [4602] = 2324,
  [4603] = 2332,
  [4604] = 4464,
  [4605] = 4454,
  [4606] = 4402,
  [4607] = 2366,
  [4608] = 2367,
  [4609] = 2331,
  [4610] = 2343,
  [4611] = 4349,
  [4612] = 2361,
  [4613] = 2334,
  [4614] = 2335,
  [4615] = 2332,
  [4616] = 2306,
  [4617] = 2336,
  [4618] = 2224,
  [4619] = 2245,
  [4620] = 2292,
  [4621] = 2302,
  [4622] = 2318,
  [4623] = 2230,
  [4624] = 4417,
  [4625] = 2207,
  [4626] = 2205,
  [4627] = 4412,
  [4628] = 2251,
  [4629] = 2252,
  [4630] = 2305,
  [4631] = 2214,
  [4632] = 2221,
  [4633] = 2227,
  [4634] = 2262,
  [4635] = 2229,
  [4636] = 2328,
  [4637] = 2337,
  [4638] = 2304,
  [4639] = 2345,
  [4640] = 2311,
  [4641] = 2314,
  [4642] = 2324,
  [4643] = 2319,
  [4644] = 4385,
  [4645] = 2320,
  [4646] = 2321,
  [4647] = 2322,
  [4648] = 4345,
  [4649] = 2206,
  [4650] = 2326,
  [4651] = 2291,
  [4652] = 2053,
  [4653] = 2013,
  [4654] = 2366,
  [4655] = 2016,
  [4656] = 2367,
  [4657] = 2310,
  [4658] = 4338,
  [4659] = 2289,
  [4660] = 2234,
  [4661] = 4445,
  [4662] = 4311,
  [4663] = 4468,
  [4664] = 4469,
  [4665] = 2238,
  [4666] = 2228,
  [4667] = 4363,
  [4668] = 4348,
  [4669] = 2244,
  [4670] = 2365,
  [4671] = 4450,
  [4672] = 4422,
  [4673] = 2308,
  [4674] = 4464,
  [4675] = 4468,
  [4676] = 4511,
  [4677] = 4402,
  [4678] = 4517,
  [4679] = 4534,
  [4680] = 4521,
  [4681] = 4513,
  [4682] = 4527,
  [4683] = 4530,
  [4684] = 4469,
  [4685] = 4536,
  [4686] = 4686,
  [4687] = 4461,
  [4688] = 4402,
  [4689] = 4454,
  [4690] = 4385,
  [4691] = 4522,
  [4692] = 3138,
  [4693] = 1879,
  [4694] = 4378,
  [4695] = 4365,
  [4696] = 4390,
  [4697] = 4388,
  [4698] = 4417,
  [4699] = 4699,
  [4700] = 4445,
  [4701] = 4375,
  [4702] = 1885,
  [4703] = 1886,
  [4704] = 4370,
  [4705] = 1882,
  [4706] = 4434,
  [4707] = 4432,
  [4708] = 4412,
  [4709] = 4709,
  [4710] = 4453,
  [4711] = 4384,
  [4712] = 4457,
  [4713] = 4572,
  [4714] = 4458,
  [4715] = 1883,
  [4716] = 4709,
  [4717] = 1884,
  [4718] = 4455,
  [4719] = 4373,
  [4720] = 1882,
  [4721] = 3291,
  [4722] = 4372,
  [4723] = 4422,
  [4724] = 4377,
  [4725] = 4451,
  [4726] = 4369,
  [4727] = 4381,
  [4728] = 4376,
  [4729] = 1881,
  [4730] = 4709,
  [4731] = 4709,
  [4732] = 4559,
  [4733] = 4709,
  [4734] = 4429,
  [4735] = 4374,
  [4736] = 4422,
  [4737] = 4368,
  [4738] = 4364,
  [4739] = 4460,
  [4740] = 4468,
  [4741] = 4469,
  [4742] = 4382,
  [4743] = 4459,
  [4744] = 4383,
  [4745] = 4452,
  [4746] = 3289,
  [4747] = 4380,
  [4748] = 4445,
  [4749] = 1883,
  [4750] = 4366,
  [4751] = 4412,
  [4752] = 1885,
  [4753] = 1887,
  [4754] = 1886,
  [4755] = 4463,
  [4756] = 4379,
  [4757] = 1884,
  [4758] = 1880,
  [4759] = 4462,
  [4760] = 4367,
  [4761] = 4456,
  [4762] = 1880,
  [4763] = 4536,
  [4764] = 4371,
  [4765] = 4386,
  [4766] = 1884,
  [4767] = 4386,
  [4768] = 4393,
  [4769] = 4769,
  [4770] = 2141,
  [4771] = 4521,
  [4772] = 4431,
  [4773] = 4773,
  [4774] = 4774,
  [4775] = 3138,
  [4776] = 4469,
  [4777] = 4773,
  [4778] = 4774,
  [4779] = 4454,
  [4780] = 4773,
  [4781] = 1880,
  [4782] = 4406,
  [4783] = 4527,
  [4784] = 4417,
  [4785] = 1885,
  [4786] = 1879,
  [4787] = 4787,
  [4788] = 4788,
  [4789] = 4464,
  [4790] = 4392,
  [4791] = 4774,
  [4792] = 4787,
  [4793] = 4788,
  [4794] = 1887,
  [4795] = 1882,
  [4796] = 4788,
  [4797] = 1886,
  [4798] = 1881,
  [4799] = 4468,
  [4800] = 4403,
  [4801] = 4801,
  [4802] = 4534,
  [4803] = 4461,
  [4804] = 4371,
  [4805] = 4787,
  [4806] = 4405,
  [4807] = 1883,
  [4808] = 4522,
  [4809] = 4530,
  [4810] = 4458,
  [4811] = 4811,
  [4812] = 4812,
  [4813] = 4813,
  [4814] = 4811,
  [4815] = 4453,
  [4816] = 4816,
  [4817] = 4812,
  [4818] = 4468,
  [4819] = 4469,
  [4820] = 4820,
  [4821] = 4821,
  [4822] = 4427,
  [4823] = 4454,
  [4824] = 4461,
  [4825] = 4415,
  [4826] = 4813,
  [4827] = 4458,
  [4828] = 4436,
  [4829] = 4464,
  [4830] = 4460,
  [4831] = 4811,
  [4832] = 4456,
  [4833] = 4816,
  [4834] = 4820,
  [4835] = 4821,
  [4836] = 4457,
  [4837] = 4459,
  [4838] = 4437,
  [4839] = 4816,
  [4840] = 4462,
  [4841] = 4413,
  [4842] = 4451,
  [4843] = 4812,
  [4844] = 4411,
  [4845] = 4463,
  [4846] = 4464,
  [4847] = 4821,
  [4848] = 4452,
  [4849] = 4461,
  [4850] = 4454,
  [4851] = 4813,
  [4852] = 4813,
  [4853] = 4404,
  [4854] = 4452,
  [4855] = 4811,
  [4856] = 4820,
  [4857] = 4811,
  [4858] = 4813,
  [4859] = 4816,
  [4860] = 4439,
  [4861] = 4816,
  [4862] = 4820,
  [4863] = 4457,
  [4864] = 4820,
  [4865] = 4865,
  [4866] = 4866,
  [4867] = 4443,
  [4868] = 4868,
  [4869] = 4865,
  [4870] = 4870,
  [4871] = 4423,
  [4872] = 4418,
  [4873] = 4444,
  [4874] = 4440,
  [4875] = 4460,
  [4876] = 4426,
  [4877] = 4453,
  [4878] = 4461,
  [4879] = 4441,
  [4880] = 4442,
  [4881] = 4456,
  [4882] = 4409,
  [4883] = 4410,
  [4884] = 4461,
  [4885] = 4870,
  [4886] = 2053,
  [4887] = 4887,
  [4888] = 4416,
  [4889] = 4438,
  [4890] = 4890,
  [4891] = 2055,
  [4892] = 4464,
  [4893] = 4425,
  [4894] = 4433,
  [4895] = 2052,
  [4896] = 4419,
  [4897] = 4897,
  [4898] = 4868,
  [4899] = 4454,
  [4900] = 4900,
  [4901] = 4890,
  [4902] = 4866,
  [4903] = 4903,
  [4904] = 4420,
  [4905] = 4428,
  [4906] = 4868,
  [4907] = 2023,
  [4908] = 4407,
  [4909] = 4890,
  [4910] = 4910,
  [4911] = 4424,
  [4912] = 4866,
  [4913] = 4913,
  [4914] = 2178,
  [4915] = 2179,
  [4916] = 4459,
  [4917] = 4464,
  [4918] = 4865,
  [4919] = 4454,
  [4920] = 4468,
  [4921] = 4921,
  [4922] = 4469,
  [4923] = 4890,
  [4924] = 4866,
  [4925] = 4897,
  [4926] = 2049,
  [4927] = 2176,
  [4928] = 4868,
  [4929] = 4929,
  [4930] = 4865,
  [4931] = 4462,
  [4932] = 4463,
  [4933] = 4430,
  [4934] = 4870,
  [4935] = 4890,
  [4936] = 4866,
  [4937] = 4408,
  [4938] = 4868,
  [4939] = 4865,
  [4940] = 4414,
  [4941] = 4451,
  [4942] = 4421,
  [4943] = 4435,
  [4944] = 4468,
  [4945] = 4469,
  [4946] = 4946,
  [4947] = 4947,
  [4948] = 4948,
  [4949] = 2161,
  [4950] = 4950,
  [4951] = 4951,
  [4952] = 4948,
  [4953] = 4953,
  [4954] = 4954,
  [4955] = 4955,
  [4956] = 4956,
  [4957] = 4957,
  [4958] = 4958,
  [4959] = 4959,
  [4960] = 4921,
  [4961] = 2163,
  [4962] = 4954,
  [4963] = 4454,
  [4964] = 4964,
  [4965] = 2053,
  [4966] = 4954,
  [4967] = 4967,
  [4968] = 4968,
  [4969] = 4461,
  [4970] = 4955,
  [4971] = 4971,
  [4972] = 4972,
  [4973] = 4959,
  [4974] = 4974,
  [4975] = 4975,
  [4976] = 4954,
  [4977] = 4977,
  [4978] = 4964,
  [4979] = 4979,
  [4980] = 4954,
  [4981] = 4954,
  [4982] = 4979,
  [4983] = 4983,
  [4984] = 4948,
  [4985] = 4985,
  [4986] = 4967,
  [4987] = 4974,
  [4988] = 4975,
  [4989] = 4971,
  [4990] = 4954,
  [4991] = 2049,
  [4992] = 4955,
  [4993] = 4971,
  [4994] = 4954,
  [4995] = 4954,
  [4996] = 4954,
  [4997] = 4997,
  [4998] = 4998,
  [4999] = 4983,
  [5000] = 4954,
  [5001] = 4985,
  [5002] = 4967,
  [5003] = 5003,
  [5004] = 2023,
  [5005] = 4956,
  [5006] = 4954,
  [5007] = 4461,
  [5008] = 2055,
  [5009] = 4464,
  [5010] = 5003,
  [5011] = 4948,
  [5012] = 4964,
  [5013] = 4956,
  [5014] = 4985,
  [5015] = 4954,
  [5016] = 4464,
  [5017] = 4956,
  [5018] = 4956,
  [5019] = 2147,
  [5020] = 4954,
  [5021] = 4979,
  [5022] = 4959,
  [5023] = 4954,
  [5024] = 4954,
  [5025] = 4957,
  [5026] = 4469,
  [5027] = 4983,
  [5028] = 4954,
  [5029] = 4964,
  [5030] = 4967,
  [5031] = 4979,
  [5032] = 4954,
  [5033] = 4983,
  [5034] = 4955,
  [5035] = 4971,
  [5036] = 4972,
  [5037] = 4959,
  [5038] = 4954,
  [5039] = 5003,
  [5040] = 5040,
  [5041] = 4954,
  [5042] = 4954,
  [5043] = 4954,
  [5044] = 4454,
  [5045] = 5003,
  [5046] = 4964,
  [5047] = 4979,
  [5048] = 4983,
  [5049] = 4954,
  [5050] = 5003,
  [5051] = 4954,
  [5052] = 4954,
  [5053] = 4985,
  [5054] = 4967,
  [5055] = 4954,
  [5056] = 4974,
  [5057] = 4975,
  [5058] = 4954,
  [5059] = 4954,
  [5060] = 2154,
  [5061] = 5040,
  [5062] = 4957,
  [5063] = 4954,
  [5064] = 4954,
  [5065] = 5065,
  [5066] = 4955,
  [5067] = 4971,
  [5068] = 4972,
  [5069] = 4959,
  [5070] = 4954,
  [5071] = 4985,
  [5072] = 4967,
  [5073] = 4974,
  [5074] = 4985,
  [5075] = 4975,
  [5076] = 4954,
  [5077] = 4972,
  [5078] = 2052,
  [5079] = 4974,
  [5080] = 4954,
  [5081] = 4954,
  [5082] = 4954,
  [5083] = 4975,
  [5084] = 5084,
  [5085] = 4954,
  [5086] = 4954,
  [5087] = 4954,
  [5088] = 4954,
  [5089] = 4954,
  [5090] = 4954,
  [5091] = 4954,
  [5092] = 4954,
  [5093] = 4971,
  [5094] = 5040,
  [5095] = 4954,
  [5096] = 4954,
  [5097] = 4957,
  [5098] = 4954,
  [5099] = 4954,
  [5100] = 4967,
  [5101] = 5040,
  [5102] = 5040,
  [5103] = 4955,
  [5104] = 4971,
  [5105] = 4957,
  [5106] = 4972,
  [5107] = 4948,
  [5108] = 4468,
  [5109] = 5109,
  [5110] = 5110,
  [5111] = 5111,
  [5112] = 4469,
  [5113] = 5113,
  [5114] = 5114,
  [5115] = 4468,
  [5116] = 4469,
  [5117] = 5117,
  [5118] = 5118,
  [5119] = 5110,
  [5120] = 4468,
  [5121] = 5121,
  [5122] = 5122,
  [5123] = 4464,
  [5124] = 5124,
  [5125] = 5109,
  [5126] = 5126,
  [5127] = 5127,
  [5128] = 5117,
  [5129] = 5129,
  [5130] = 5130,
  [5131] = 5129,
  [5132] = 5132,
  [5133] = 5133,
  [5134] = 2059,
  [5135] = 2398,
  [5136] = 5136,
  [5137] = 5109,
  [5138] = 5130,
  [5139] = 5126,
  [5140] = 5140,
  [5141] = 5126,
  [5142] = 4468,
  [5143] = 5143,
  [5144] = 2171,
  [5145] = 5118,
  [5146] = 2192,
  [5147] = 2181,
  [5148] = 5118,
  [5149] = 2219,
  [5150] = 5118,
  [5151] = 5151,
  [5152] = 2194,
  [5153] = 2057,
  [5154] = 5110,
  [5155] = 2184,
  [5156] = 4461,
  [5157] = 5130,
  [5158] = 1882,
  [5159] = 4469,
  [5160] = 5160,
  [5161] = 2186,
  [5162] = 5162,
  [5163] = 5163,
  [5164] = 2063,
  [5165] = 5165,
  [5166] = 5114,
  [5167] = 5167,
  [5168] = 5168,
  [5169] = 2232,
  [5170] = 5165,
  [5171] = 5118,
  [5172] = 5114,
  [5173] = 5140,
  [5174] = 5121,
  [5175] = 5167,
  [5176] = 5117,
  [5177] = 5129,
  [5178] = 4454,
  [5179] = 5136,
  [5180] = 5140,
  [5181] = 5167,
  [5182] = 5121,
  [5183] = 5136,
  [5184] = 5165,
  [5185] = 5160,
  [5186] = 5186,
  [5187] = 5187,
  [5188] = 5188,
  [5189] = 4407,
  [5190] = 2174,
  [5191] = 5188,
  [5192] = 5192,
  [5193] = 1882,
  [5194] = 5143,
  [5195] = 5195,
  [5196] = 5195,
  [5197] = 5195,
  [5198] = 5198,
  [5199] = 5199,
  [5200] = 2182,
  [5201] = 5133,
  [5202] = 5202,
  [5203] = 5203,
  [5204] = 1882,
  [5205] = 5205,
  [5206] = 5198,
  [5207] = 5198,
  [5208] = 5208,
  [5209] = 5209,
  [5210] = 5210,
  [5211] = 2203,
  [5212] = 5199,
  [5213] = 5160,
  [5214] = 5214,
  [5215] = 5215,
  [5216] = 5133,
  [5217] = 5217,
  [5218] = 5188,
  [5219] = 5219,
  [5220] = 5199,
  [5221] = 2303,
  [5222] = 2221,
  [5223] = 2228,
  [5224] = 2295,
  [5225] = 5225,
  [5226] = 2346,
  [5227] = 4349,
  [5228] = 2345,
  [5229] = 2205,
  [5230] = 2269,
  [5231] = 2214,
  [5232] = 2280,
  [5233] = 2343,
  [5234] = 2365,
  [5235] = 2206,
  [5236] = 2244,
  [5237] = 2251,
  [5238] = 2252,
  [5239] = 2262,
  [5240] = 2353,
  [5241] = 5225,
  [5242] = 4468,
  [5243] = 5243,
  [5244] = 2215,
  [5245] = 2216,
  [5246] = 2222,
  [5247] = 2227,
  [5248] = 2223,
  [5249] = 2296,
  [5250] = 2226,
  [5251] = 2354,
  [5252] = 2297,
  [5253] = 4468,
  [5254] = 2298,
  [5255] = 4469,
  [5256] = 2282,
  [5257] = 2284,
  [5258] = 2288,
  [5259] = 2294,
  [5260] = 2312,
  [5261] = 2325,
  [5262] = 2309,
  [5263] = 2332,
  [5264] = 5264,
  [5265] = 2015,
  [5266] = 2315,
  [5267] = 5267,
  [5268] = 4469,
  [5269] = 5269,
  [5270] = 5270,
  [5271] = 2336,
  [5272] = 2316,
  [5273] = 5273,
  [5274] = 2310,
  [5275] = 4454,
  [5276] = 2230,
  [5277] = 2305,
  [5278] = 4951,
  [5279] = 2357,
  [5280] = 5280,
  [5281] = 5281,
  [5282] = 2256,
  [5283] = 5283,
  [5284] = 2340,
  [5285] = 2255,
  [5286] = 2317,
  [5287] = 2359,
  [5288] = 2360,
  [5289] = 2350,
  [5290] = 2246,
  [5291] = 2342,
  [5292] = 5269,
  [5293] = 2362,
  [5294] = 2363,
  [5295] = 2236,
  [5296] = 2366,
  [5297] = 2361,
  [5298] = 2338,
  [5299] = 2293,
  [5300] = 2229,
  [5301] = 2210,
  [5302] = 5302,
  [5303] = 2224,
  [5304] = 2245,
  [5305] = 2292,
  [5306] = 2302,
  [5307] = 2318,
  [5308] = 2331,
  [5309] = 2337,
  [5310] = 2319,
  [5311] = 5311,
  [5312] = 5312,
  [5313] = 2367,
  [5314] = 2291,
  [5315] = 5273,
  [5316] = 5188,
  [5317] = 5283,
  [5318] = 2327,
  [5319] = 5319,
  [5320] = 2333,
  [5321] = 2356,
  [5322] = 2250,
  [5323] = 5323,
  [5324] = 5324,
  [5325] = 2259,
  [5326] = 5311,
  [5327] = 2320,
  [5328] = 2234,
  [5329] = 2225,
  [5330] = 2233,
  [5331] = 5331,
  [5332] = 2321,
  [5333] = 2243,
  [5334] = 2204,
  [5335] = 2248,
  [5336] = 2290,
  [5337] = 2211,
  [5338] = 2212,
  [5339] = 2213,
  [5340] = 2322,
  [5341] = 2218,
  [5342] = 5283,
  [5343] = 5343,
  [5344] = 2344,
  [5345] = 2217,
  [5346] = 2299,
  [5347] = 2307,
  [5348] = 2323,
  [5349] = 2326,
  [5350] = 2355,
  [5351] = 5273,
  [5352] = 5273,
  [5353] = 2237,
  [5354] = 2238,
  [5355] = 2348,
  [5356] = 2306,
  [5357] = 5357,
  [5358] = 5358,
  [5359] = 5359,
  [5360] = 5360,
  [5361] = 5361,
  [5362] = 5359,
  [5363] = 2249,
  [5364] = 5225,
  [5365] = 2368,
  [5366] = 5273,
  [5367] = 2289,
  [5368] = 2260,
  [5369] = 5273,
  [5370] = 5370,
  [5371] = 2261,
  [5372] = 2279,
  [5373] = 2254,
  [5374] = 2329,
  [5375] = 2330,
  [5376] = 5311,
  [5377] = 5302,
  [5378] = 2283,
  [5379] = 2328,
  [5380] = 2242,
  [5381] = 2300,
  [5382] = 2247,
  [5383] = 2270,
  [5384] = 5273,
  [5385] = 2271,
  [5386] = 2274,
  [5387] = 2275,
  [5388] = 2276,
  [5389] = 2277,
  [5390] = 2278,
  [5391] = 2285,
  [5392] = 2301,
  [5393] = 2267,
  [5394] = 2304,
  [5395] = 2308,
  [5396] = 5319,
  [5397] = 5397,
  [5398] = 2311,
  [5399] = 2314,
  [5400] = 2324,
  [5401] = 2334,
  [5402] = 2335,
  [5403] = 2207,
  [5404] = 2209,
  [5405] = 2313,
  [5406] = 5406,
  [5407] = 5407,
  [5408] = 5408,
  [5409] = 5124,
  [5410] = 5410,
  [5411] = 5411,
  [5412] = 5412,
  [5413] = 5413,
  [5414] = 5414,
  [5415] = 5415,
  [5416] = 5414,
  [5417] = 5417,
  [5418] = 5418,
  [5419] = 5419,
  [5420] = 5420,
  [5421] = 5418,
  [5422] = 5422,
  [5423] = 5423,
  [5424] = 5424,
  [5425] = 5425,
  [5426] = 5426,
  [5427] = 5163,
  [5428] = 5424,
  [5429] = 5417,
  [5430] = 2059,
  [5431] = 5127,
  [5432] = 5407,
  [5433] = 5162,
  [5434] = 5434,
  [5435] = 5420,
  [5436] = 5414,
  [5437] = 5415,
  [5438] = 5425,
  [5439] = 5420,
  [5440] = 5440,
  [5441] = 5441,
  [5442] = 5442,
  [5443] = 5442,
  [5444] = 5168,
  [5445] = 5445,
  [5446] = 5413,
  [5447] = 5411,
  [5448] = 5424,
  [5449] = 5423,
  [5450] = 5422,
  [5451] = 5451,
  [5452] = 5407,
  [5453] = 5423,
  [5454] = 5410,
  [5455] = 5455,
  [5456] = 5413,
  [5457] = 5457,
  [5458] = 5425,
  [5459] = 5413,
  [5460] = 5440,
  [5461] = 5414,
  [5462] = 2063,
  [5463] = 5463,
  [5464] = 5464,
  [5465] = 5225,
  [5466] = 5451,
  [5467] = 5413,
  [5468] = 5455,
  [5469] = 5469,
  [5470] = 5470,
  [5471] = 5440,
  [5472] = 5423,
  [5473] = 5455,
  [5474] = 2057,
  [5475] = 5463,
  [5476] = 5410,
  [5477] = 5420,
  [5478] = 5424,
  [5479] = 5479,
  [5480] = 5423,
  [5481] = 5132,
  [5482] = 5482,
  [5483] = 5482,
  [5484] = 5406,
  [5485] = 5424,
  [5486] = 5414,
  [5487] = 5420,
  [5488] = 5417,
  [5489] = 5489,
  [5490] = 5490,
  [5491] = 5489,
  [5492] = 5492,
  [5493] = 5489,
  [5494] = 5494,
  [5495] = 5495,
  [5496] = 5489,
  [5497] = 1879,
  [5498] = 5492,
  [5499] = 5499,
  [5500] = 5489,
  [5501] = 5492,
  [5502] = 5492,
  [5503] = 5489,
  [5504] = 5489,
  [5505] = 5492,
  [5506] = 5489,
  [5507] = 5494,
  [5508] = 5508,
  [5509] = 5495,
  [5510] = 5492,
  [5511] = 5511,
  [5512] = 5492,
  [5513] = 5492,
  [5514] = 5514,
  [5515] = 5489,
  [5516] = 5492,
  [5517] = 5514,
  [5518] = 5489,
  [5519] = 5492,
  [5520] = 5520,
  [5521] = 5489,
  [5522] = 5492,
  [5523] = 5489,
  [5524] = 5492,
  [5525] = 5489,
  [5526] = 5526,
  [5527] = 5492,
  [5528] = 5489,
  [5529] = 5492,
  [5530] = 5489,
  [5531] = 5492,
  [5532] = 5489,
  [5533] = 5492,
  [5534] = 5489,
  [5535] = 5492,
  [5536] = 5489,
  [5537] = 5489,
  [5538] = 5492,
  [5539] = 5489,
  [5540] = 5492,
  [5541] = 5489,
  [5542] = 5492,
  [5543] = 5489,
  [5544] = 5492,
  [5545] = 5492,
  [5546] = 5489,
  [5547] = 5489,
  [5548] = 5492,
  [5549] = 5492,
  [5550] = 5494,
  [5551] = 5551,
  [5552] = 5552,
  [5553] = 5553,
  [5554] = 5554,
  [5555] = 5555,
  [5556] = 5556,
  [5557] = 5557,
  [5558] = 5555,
  [5559] = 5556,
  [5560] = 5560,
  [5561] = 5561,
  [5562] = 5561,
  [5563] = 5553,
  [5564] = 5564,
  [5565] = 5565,
  [5566] = 5566,
  [5567] = 5567,
  [5568] = 5556,
  [5569] = 5569,
  [5570] = 5570,
  [5571] = 5561,
  [5572] = 5572,
  [5573] = 5573,
  [5574] = 5553,
  [5575] = 5561,
  [5576] = 5553,
  [5577] = 5577,
  [5578] = 5578,
  [5579] = 5579,
  [5580] = 5580,
  [5581] = 1885,
  [5582] = 5555,
  [5583] = 5557,
  [5584] = 5584,
  [5585] = 5579,
  [5586] = 5561,
  [5587] = 5553,
  [5588] = 5588,
  [5589] = 5553,
  [5590] = 5590,
  [5591] = 5591,
  [5592] = 5592,
  [5593] = 5561,
  [5594] = 5594,
  [5595] = 1886,
  [5596] = 5553,
  [5597] = 5554,
  [5598] = 5598,
  [5599] = 5599,
  [5600] = 5560,
  [5601] = 5598,
  [5602] = 5553,
  [5603] = 5561,
  [5604] = 5604,
  [5605] = 5557,
  [5606] = 5606,
  [5607] = 5607,
  [5608] = 5561,
  [5609] = 5553,
  [5610] = 5610,
  [5611] = 5554,
  [5612] = 5612,
  [5613] = 5613,
  [5614] = 5578,
  [5615] = 5553,
  [5616] = 5616,
  [5617] = 5612,
  [5618] = 5618,
  [5619] = 5619,
  [5620] = 5620,
  [5621] = 5621,
  [5622] = 5553,
  [5623] = 5606,
  [5624] = 5588,
  [5625] = 5625,
  [5626] = 5625,
  [5627] = 5599,
  [5628] = 5570,
  [5629] = 5629,
  [5630] = 5561,
  [5631] = 5631,
  [5632] = 5632,
  [5633] = 5633,
  [5634] = 5606,
  [5635] = 5635,
  [5636] = 5553,
  [5637] = 5637,
  [5638] = 5638,
  [5639] = 5637,
  [5640] = 5640,
  [5641] = 5552,
  [5642] = 5564,
  [5643] = 5561,
  [5644] = 5566,
  [5645] = 5645,
  [5646] = 5553,
  [5647] = 5647,
  [5648] = 5613,
  [5649] = 5554,
  [5650] = 5632,
  [5651] = 5651,
  [5652] = 5652,
  [5653] = 5653,
  [5654] = 5654,
  [5655] = 5655,
  [5656] = 5564,
  [5657] = 5638,
  [5658] = 5604,
  [5659] = 5659,
  [5660] = 5555,
  [5661] = 5557,
  [5662] = 5662,
  [5663] = 5590,
  [5664] = 5561,
  [5665] = 5570,
  [5666] = 5666,
  [5667] = 5580,
  [5668] = 5551,
  [5669] = 5669,
  [5670] = 5553,
  [5671] = 5671,
  [5672] = 5557,
  [5673] = 5561,
  [5674] = 5573,
  [5675] = 5572,
  [5676] = 5561,
  [5677] = 5598,
  [5678] = 5599,
  [5679] = 5553,
  [5680] = 5554,
  [5681] = 5560,
  [5682] = 5604,
  [5683] = 5579,
  [5684] = 5573,
  [5685] = 5561,
  [5686] = 5686,
  [5687] = 5579,
  [5688] = 5655,
  [5689] = 5554,
  [5690] = 5690,
  [5691] = 5631,
  [5692] = 5570,
  [5693] = 5693,
  [5694] = 5694,
  [5695] = 5553,
  [5696] = 5620,
  [5697] = 5553,
  [5698] = 5591,
  [5699] = 5590,
  [5700] = 5584,
  [5701] = 5701,
  [5702] = 5591,
  [5703] = 5573,
  [5704] = 5655,
  [5705] = 5560,
  [5706] = 5577,
  [5707] = 5653,
  [5708] = 5561,
  [5709] = 5694,
  [5710] = 5710,
  [5711] = 5637,
  [5712] = 5693,
  [5713] = 5621,
  [5714] = 5590,
  [5715] = 5619,
  [5716] = 5606,
  [5717] = 5561,
  [5718] = 5553,
  [5719] = 5577,
  [5720] = 5553,
  [5721] = 5591,
  [5722] = 5556,
  [5723] = 5693,
  [5724] = 5724,
  [5725] = 5725,
  [5726] = 5553,
  [5727] = 5561,
  [5728] = 5728,
  [5729] = 5729,
  [5730] = 5625,
  [5731] = 5553,
  [5732] = 5553,
  [5733] = 5584,
  [5734] = 5734,
  [5735] = 5735,
  [5736] = 5560,
  [5737] = 5577,
  [5738] = 5553,
  [5739] = 5553,
  [5740] = 5553,
  [5741] = 5553,
  [5742] = 5573,
  [5743] = 5553,
  [5744] = 5561,
  [5745] = 5745,
  [5746] = 5637,
  [5747] = 5561,
  [5748] = 5553,
  [5749] = 5578,
  [5750] = 5553,
  [5751] = 5553,
  [5752] = 5566,
  [5753] = 5655,
  [5754] = 5553,
  [5755] = 5579,
  [5756] = 5553,
  [5757] = 5757,
  [5758] = 5569,
  [5759] = 5553,
  [5760] = 5671,
  [5761] = 5607,
  [5762] = 5553,
  [5763] = 5724,
  [5764] = 5725,
  [5765] = 5745,
  [5766] = 5553,
  [5767] = 5631,
  [5768] = 5553,
  [5769] = 5592,
  [5770] = 5554,
  [5771] = 5553,
  [5772] = 5640,
  [5773] = 5662,
  [5774] = 5553,
  [5775] = 5560,
  [5776] = 5578,
  [5777] = 5553,
  [5778] = 5577,
  [5779] = 5662,
  [5780] = 5561,
  [5781] = 5745,
  [5782] = 5613,
  [5783] = 5555,
  [5784] = 5572,
  [5785] = 5637,
  [5786] = 5553,
  [5787] = 5557,
  [5788] = 5666,
  [5789] = 5620,
  [5790] = 5790,
  [5791] = 5580,
  [5792] = 5655,
  [5793] = 5633,
  [5794] = 5710,
  [5795] = 5565,
  [5796] = 5590,
  [5797] = 5567,
  [5798] = 5573,
  [5799] = 5579,
  [5800] = 5616,
  [5801] = 5728,
  [5802] = 5645,
  [5803] = 5560,
  [5804] = 5553,
  [5805] = 5805,
  [5806] = 5606,
  [5807] = 5807,
  [5808] = 5561,
  [5809] = 5809,
  [5810] = 5655,
  [5811] = 5553,
  [5812] = 5640,
  [5813] = 5621,
  [5814] = 5556,
  [5815] = 5607,
  [5816] = 5816,
  [5817] = 5590,
  [5818] = 5554,
  [5819] = 5555,
  [5820] = 5590,
  [5821] = 5619,
  [5822] = 5588,
  [5823] = 5651,
  [5824] = 5554,
  [5825] = 5553,
  [5826] = 5637,
  [5827] = 5554,
  [5828] = 5828,
  [5829] = 5561,
  [5830] = 5654,
  [5831] = 5669,
  [5832] = 5638,
  [5833] = 5816,
  [5834] = 5555,
  [5835] = 5666,
  [5836] = 5557,
  [5837] = 5647,
  [5838] = 5553,
  [5839] = 5552,
  [5840] = 5655,
  [5841] = 5553,
  [5842] = 5828,
  [5843] = 5554,
  [5844] = 5637,
  [5845] = 5809,
  [5846] = 5554,
  [5847] = 5573,
  [5848] = 5745,
  [5849] = 5561,
  [5850] = 5701,
  [5851] = 5561,
  [5852] = 5591,
  [5853] = 5579,
  [5854] = 5828,
  [5855] = 5654,
  [5856] = 5553,
  [5857] = 5669,
  [5858] = 5816,
  [5859] = 5651,
  [5860] = 5671,
  [5861] = 5861,
  [5862] = 5745,
  [5863] = 5861,
  [5864] = 5861,
  [5865] = 5561,
  [5866] = 5578,
  [5867] = 5612,
  [5868] = 5592,
  [5869] = 5632,
  [5870] = 5652,
  [5871] = 5633,
  [5872] = 5872,
  [5873] = 5873,
  [5874] = 5874,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 279,
        '+', 335,
        ',', 271,
        '-', 353,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 361,
        '>', 330,
        '?', 317,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(172);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == 'd') ADVANCE(404);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`') ADVANCE(409);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(133);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead != 0) ADVANCE(1);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(79);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(79);
      if (lookahead == '\r') SKIP(2);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(78);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(78);
      if (lookahead == '\r') SKIP(4);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(80);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(80);
      if (lookahead == '\r') SKIP(6);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(81);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(81);
      if (lookahead == '\r') SKIP(8);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(102);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(102);
      if (lookahead == '\r') SKIP(10);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(101);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(101);
      if (lookahead == '\r') SKIP(12);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(115);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(115);
      if (lookahead == '\r') SKIP(14);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(85);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(85);
      if (lookahead == '\r') SKIP(16);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(87);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(87);
      if (lookahead == '\r') SKIP(18);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(91);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(91);
      if (lookahead == '\r') SKIP(20);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(94);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(94);
      if (lookahead == '\r') SKIP(22);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(92);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(92);
      if (lookahead == '\r') SKIP(24);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(98);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(98);
      if (lookahead == '\r') SKIP(26);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(107);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(107);
      if (lookahead == '\r') SKIP(28);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(106);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(106);
      if (lookahead == '\r') SKIP(30);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(116);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(116);
      if (lookahead == '\r') SKIP(32);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(105);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(105);
      if (lookahead == '\r') SKIP(34);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(112);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(112);
      if (lookahead == '\r') SKIP(36);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(113);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(113);
      if (lookahead == '\r') SKIP(38);
      END_STATE();
    case 40:
      if (lookahead == '\n') ADVANCE(425);
      if (lookahead == '\r') ADVANCE(424);
      if (lookahead == 'u') ADVANCE(150);
      if (lookahead == 'x') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(428);
      if (lookahead != 0) ADVANCE(424);
      END_STATE();
    case 41:
      if (lookahead == '\n') ADVANCE(426);
      if (lookahead == '\r') ADVANCE(424);
      if (lookahead == 'u') ADVANCE(150);
      if (lookahead == 'x') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(428);
      if (lookahead != 0) ADVANCE(424);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(119);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(119);
      if (lookahead == '\r') SKIP(42);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(68);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(68);
      if (lookahead == '\r') SKIP(44);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(76);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(76);
      if (lookahead == '\r') SKIP(46);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(69);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(69);
      if (lookahead == '\r') SKIP(48);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(86);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(86);
      if (lookahead == '\r') SKIP(50);
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(90);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(90);
      if (lookahead == '\r') SKIP(52);
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(96);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(96);
      if (lookahead == '\r') SKIP(54);
      END_STATE();
    case 56:
      if (lookahead == '\n') SKIP(117);
      END_STATE();
    case 57:
      if (lookahead == '\n') SKIP(117);
      if (lookahead == '\r') SKIP(56);
      END_STATE();
    case 58:
      if (lookahead == '\n') SKIP(108);
      END_STATE();
    case 59:
      if (lookahead == '\n') SKIP(108);
      if (lookahead == '\r') SKIP(58);
      END_STATE();
    case 60:
      if (lookahead == '\n') SKIP(72);
      END_STATE();
    case 61:
      if (lookahead == '\n') SKIP(72);
      if (lookahead == '\r') SKIP(60);
      END_STATE();
    case 62:
      if (lookahead == '\n') SKIP(71);
      END_STATE();
    case 63:
      if (lookahead == '\n') SKIP(71);
      if (lookahead == '\r') SKIP(62);
      END_STATE();
    case 64:
      if (lookahead == '\n') SKIP(74);
      END_STATE();
    case 65:
      if (lookahead == '\n') SKIP(74);
      if (lookahead == '\r') SKIP(64);
      END_STATE();
    case 66:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(49);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(45);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 68:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(45);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(68);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        ')', 262,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(49);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 70:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(61);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 71:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 320,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(63);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 72:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(61);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 73:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 319,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(63);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 74:
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 284,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '/', 337,
        '0', 365,
        ':', 320,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(65);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(74);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 75:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '&', 124,
        '(', 296,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 264,
        '0', 365,
        ':', 128,
        ';', 275,
        '<', 289,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(47);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(76);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 76:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '&', 124,
        '(', 261,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 264,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 289,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(47);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(76);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 77:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '&', 124,
        '(', 261,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 264,
        '0', 365,
        ':', 128,
        ';', 275,
        '<', 289,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(47);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(76);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 78:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 138,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(5);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(78);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 79:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 142,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(3);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(79);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`') ADVANCE(396);
      END_STATE();
    case 80:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 267,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(7);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 81:
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        '*', 278,
        '+', 333,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        '=', 142,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(9);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(81);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 82:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(17);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(85);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 83:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(19);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(87);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 84:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 319,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(86);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 85:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(17);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(85);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 86:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 318,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(86);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 87:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(19);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(87);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 88:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(21);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(91);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 89:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 319,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(53);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(90);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 90:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 318,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(53);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(90);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 91:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(21);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(91);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 92:
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 284,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 125,
        '/', 337,
        ':', 318,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(25);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(92);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 93:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 282,
        '(', 261,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        ':', 286,
        '<', 291,
        '=', 132,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(94);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 94:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 282,
        '(', 261,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(94);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 95:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 282,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 361,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(96);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 96:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 282,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '@', 139,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(96);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 97:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '%', 339,
        '&', 282,
        '(', 296,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(98);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 98:
      ADVANCE_MAP(
        '!', 350,
        '#', 363,
        '%', 339,
        '&', 282,
        '*', 278,
        '+', 336,
        '-', 353,
        '.', 127,
        '/', 337,
        '<', 291,
        '=', 132,
        '>', 331,
        '[', 141,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(98);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 99:
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(422);
      END_STATE();
    case 100:
      if (lookahead == '#') ADVANCE(362);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') ADVANCE(41);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(100);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 138,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(13);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(101);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(380);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 102:
      ADVANCE_MAP(
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 267,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(11);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(102);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 103:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ':', 286,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(35);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(105);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 104:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ':', 286,
        ';', 275,
        '=', 270,
      );
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(106);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 105:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(35);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(105);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 106:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 125,
        ';', 275,
        '=', 270,
      );
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(106);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 107:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        ')', 262,
        '*', 278,
        ',', 271,
        '.', 265,
        ':', 129,
        ';', 275,
        '=', 270,
      );
      if (lookahead == '\\') SKIP(29);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(107);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 108:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        '*', 278,
        '.', 265,
        ':', 129,
        ';', 275,
        '=', 267,
      );
      if (lookahead == '\\') SKIP(59);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(108);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 109:
      ADVANCE_MAP(
        '#', 363,
        '&', 282,
        '(', 261,
        '*', 278,
        '.', 265,
        ':', 129,
        ';', 275,
        '=', 360,
      );
      if (lookahead == '\\') SKIP(59);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(108);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 110:
      ADVANCE_MAP(
        '#', 363,
        '&', 124,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(37);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 111:
      ADVANCE_MAP(
        '#', 363,
        '&', 124,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        '=', 267,
      );
      if (lookahead == '\\') SKIP(39);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(113);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 112:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(37);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 113:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == '=') ADVANCE(267);
      if (lookahead == '\\') SKIP(39);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(113);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 114:
      ADVANCE_MAP(
        '#', 363,
        '(', 296,
        ')', 262,
        ',', 271,
        ':', 288,
        ';', 275,
        '=', 138,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(33);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(116);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 115:
      ADVANCE_MAP(
        '#', 363,
        '(', 261,
        ')', 262,
        '*', 278,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 142,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(15);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(115);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 116:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ':') ADVANCE(129);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(33);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(116);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 117:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(57);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(117);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 118:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(360);
      if (lookahead == '\\') SKIP(57);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(117);
      if (lookahead > '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 119:
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(43);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(423);
      END_STATE();
    case 120:
      if (lookahead == '*') ADVANCE(281);
      END_STATE();
    case 121:
      if (lookahead == '*') ADVANCE(136);
      if (lookahead == '=') ADVANCE(305);
      END_STATE();
    case 122:
      if (lookahead == '-') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(414);
      if (lookahead == '!' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~') ADVANCE(413);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(415);
      END_STATE();
    case 123:
      if (lookahead == '-') ADVANCE(169);
      END_STATE();
    case 124:
      if (lookahead == '.') ADVANCE(302);
      END_STATE();
    case 125:
      if (lookahead == '.') ADVANCE(298);
      END_STATE();
    case 126:
      if (lookahead == '.') ADVANCE(276);
      END_STATE();
    case 127:
      if (lookahead == '.') ADVANCE(297);
      END_STATE();
    case 128:
      if (lookahead == ':') ADVANCE(301);
      END_STATE();
    case 129:
      if (lookahead == ':') ADVANCE(266);
      END_STATE();
    case 130:
      if (lookahead == '=') ADVANCE(342);
      if (lookahead == '~') ADVANCE(346);
      END_STATE();
    case 131:
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '>') ADVANCE(292);
      if (lookahead == 'b') ADVANCE(144);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 132:
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == 'b') ADVANCE(144);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 133:
      if (lookahead == '=') ADVANCE(145);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 134:
      if (lookahead == '=') ADVANCE(304);
      END_STATE();
    case 135:
      if (lookahead == '=') ADVANCE(304);
      if (lookahead == '>') ADVANCE(430);
      END_STATE();
    case 136:
      if (lookahead == '=') ADVANCE(306);
      END_STATE();
    case 137:
      if (lookahead == '>') ADVANCE(430);
      END_STATE();
    case 138:
      if (lookahead == '>') ADVANCE(292);
      if (lookahead == 'b') ADVANCE(144);
      END_STATE();
    case 139:
      if (lookahead == '@') ADVANCE(168);
      if (lookahead > '@' &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(411);
      END_STATE();
    case 140:
      if (lookahead == '\\') ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(416);
      END_STATE();
    case 141:
      if (lookahead == ']') ADVANCE(357);
      END_STATE();
    case 142:
      if (lookahead == 'b') ADVANCE(144);
      END_STATE();
    case 143:
      if (lookahead == 'd') ADVANCE(363);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(149);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 146:
      if (lookahead == 'g') ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == 'i') ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(1);
      END_STATE();
    case 149:
      if (lookahead == 'n') ADVANCE(143);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 150:
      if (lookahead == '{') ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(166);
      END_STATE();
    case 151:
      if (lookahead == '}') ADVANCE(416);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(151);
      END_STATE();
    case 152:
      if (lookahead == '}') ADVANCE(424);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(152);
      END_STATE();
    case 153:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(372);
      END_STATE();
    case 154:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(367);
      END_STATE();
    case 155:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(366);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(364);
      END_STATE();
    case 156:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(368);
      END_STATE();
    case 157:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(366);
      END_STATE();
    case 158:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(371);
      END_STATE();
    case 159:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(370);
      END_STATE();
    case 160:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(372);
      END_STATE();
    case 161:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(369);
      END_STATE();
    case 162:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(424);
      END_STATE();
    case 163:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(429);
      END_STATE();
    case 164:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(152);
      END_STATE();
    case 165:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      END_STATE();
    case 166:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(165);
      END_STATE();
    case 167:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(413);
      END_STATE();
    case 168:
      if (lookahead > '@' &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(412);
      END_STATE();
    case 169:
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(416);
      END_STATE();
    case 170:
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(418);
      END_STATE();
    case 171:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(207);
      END_STATE();
    case 172:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(207);
      if (lookahead == '\r') SKIP(171);
      END_STATE();
    case 173:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(214);
      END_STATE();
    case 174:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(214);
      if (lookahead == '\r') SKIP(173);
      END_STATE();
    case 175:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(215);
      END_STATE();
    case 176:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(215);
      if (lookahead == '\r') SKIP(175);
      END_STATE();
    case 177:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(223);
      END_STATE();
    case 178:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(223);
      if (lookahead == '\r') SKIP(177);
      END_STATE();
    case 179:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(231);
      END_STATE();
    case 180:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(231);
      if (lookahead == '\r') SKIP(179);
      END_STATE();
    case 181:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(218);
      END_STATE();
    case 182:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(218);
      if (lookahead == '\r') SKIP(181);
      END_STATE();
    case 183:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(219);
      END_STATE();
    case 184:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(219);
      if (lookahead == '\r') SKIP(183);
      END_STATE();
    case 185:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(221);
      END_STATE();
    case 186:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(221);
      if (lookahead == '\r') SKIP(185);
      END_STATE();
    case 187:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(228);
      END_STATE();
    case 188:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(228);
      if (lookahead == '\r') SKIP(187);
      END_STATE();
    case 189:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(229);
      END_STATE();
    case 190:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(229);
      if (lookahead == '\r') SKIP(189);
      END_STATE();
    case 191:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(227);
      END_STATE();
    case 192:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(227);
      if (lookahead == '\r') SKIP(191);
      END_STATE();
    case 193:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(234);
      END_STATE();
    case 194:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(234);
      if (lookahead == '\r') SKIP(193);
      END_STATE();
    case 195:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(233);
      END_STATE();
    case 196:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(233);
      if (lookahead == '\r') SKIP(195);
      END_STATE();
    case 197:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(209);
      END_STATE();
    case 198:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(209);
      if (lookahead == '\r') SKIP(197);
      END_STATE();
    case 199:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(222);
      END_STATE();
    case 200:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(222);
      if (lookahead == '\r') SKIP(199);
      END_STATE();
    case 201:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(235);
      END_STATE();
    case 202:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(235);
      if (lookahead == '\r') SKIP(201);
      END_STATE();
    case 203:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(211);
      END_STATE();
    case 204:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(211);
      if (lookahead == '\r') SKIP(203);
      END_STATE();
    case 205:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(213);
      END_STATE();
    case 206:
      if (eof) ADVANCE(237);
      if (lookahead == '\n') SKIP(213);
      if (lookahead == '\r') SKIP(205);
      END_STATE();
    case 207:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 362,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        ')', 262,
        '*', 279,
        '+', 335,
        ',', 271,
        '-', 353,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 320,
        ';', 275,
        '<', 290,
        '=', 269,
        '>', 330,
        '?', 317,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(172);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '`') ADVANCE(359);
      if (lookahead == 'd') ADVANCE(404);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(352);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`') ADVANCE(409);
      END_STATE();
    case 208:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 296,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(198);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 209:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 340,
        '&', 283,
        '(', 261,
        '*', 280,
        '+', 334,
        ',', 271,
        '-', 135,
        '.', 264,
        '/', 338,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(198);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 210:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 296,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(204);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 211:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(204);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 212:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 285,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 264,
        '/', 337,
        '0', 365,
        ':', 128,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(204);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 213:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 349,
        '#', 363,
        '$', 122,
        '%', 339,
        '&', 284,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '/', 337,
        '0', 365,
        ':', 129,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 317,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(206);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 214:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 138,
        '?', 140,
        '@', 139,
        'B', 374,
        'E', 377,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(174);
      if (lookahead == ']') ADVANCE(294);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`') ADVANCE(396);
      END_STATE();
    case 215:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 348,
        '#', 363,
        '$', 122,
        '(', 261,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 142,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(176);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '~') ADVANCE(351);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 216:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '(', 296,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(182);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 217:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '(', 296,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 287,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(184);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 218:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        ')', 262,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ':', 129,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(182);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 219:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 340,
        '&', 283,
        '*', 121,
        '+', 334,
        ',', 271,
        '-', 134,
        '.', 264,
        '/', 338,
        ';', 275,
        '<', 290,
        '=', 268,
        '>', 330,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(184);
      if (lookahead == '^') ADVANCE(300);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(273);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 220:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        '(', 296,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ':', 287,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(186);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 221:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 285,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 264,
        '/', 337,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(186);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 222:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '!', 130,
        '#', 363,
        '%', 339,
        '&', 284,
        ')', 262,
        '+', 333,
        ',', 271,
        '.', 125,
        '/', 337,
        ';', 275,
        '<', 291,
        '=', 131,
        '>', 331,
        '?', 316,
      );
      if (lookahead == '\\') SKIP(200);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(274);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 223:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '$', 122,
        '(', 261,
        '+', 333,
        ',', 271,
        '-', 137,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 267,
        '?', 140,
        '@', 139,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(178);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == 'd') ADVANCE(391);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 224:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '&', 124,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 267,
      );
      if (lookahead == '\\') SKIP(188);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 225:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '&', 124,
        '(', 296,
        '*', 120,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 142,
      );
      if (lookahead == '\\') SKIP(190);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 226:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '&', 124,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 128,
        ';', 275,
        '=', 138,
      );
      if (lookahead == '\\') SKIP(192);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 227:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(192);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 228:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(267);
      if (lookahead == '\\') SKIP(188);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 229:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '*') ADVANCE(120);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(190);
      if (lookahead == '_') ADVANCE(387);
      if (lookahead == '{') ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(379);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 230:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '(', 296,
        ')', 262,
        ',', 271,
        '.', 263,
        ':', 288,
        ';', 275,
        '=', 138,
        '[', 295,
      );
      if (lookahead == '\\') SKIP(194);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 231:
      if (eof) ADVANCE(237);
      ADVANCE_MAP(
        '#', 363,
        '(', 261,
        ')', 262,
        '*', 277,
        '+', 333,
        ',', 271,
        '-', 137,
        '.', 125,
        '0', 365,
        ':', 129,
        ';', 275,
        '=', 138,
        '[', 293,
      );
      if (lookahead == '\\') SKIP(180);
      if (lookahead == '^') ADVANCE(299);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(231);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(366);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(380);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 232:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == ':') ADVANCE(286);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(196);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 233:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(196);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 234:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ')') ADVANCE(262);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == '.') ADVANCE(263);
      if (lookahead == ':') ADVANCE(129);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '\\') SKIP(194);
      if (lookahead == '_') ADVANCE(400);
      if (lookahead == '{') ADVANCE(258);
      if (lookahead == '|') ADVANCE(272);
      if (lookahead == '}') ADVANCE(259);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 235:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(142);
      if (lookahead == '\\') SKIP(202);
      if (lookahead == '_') ADVANCE(400);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 236:
      if (eof) ADVANCE(237);
      if (lookahead == '#') ADVANCE(363);
      if (lookahead == ',') ADVANCE(271);
      if (lookahead == ';') ADVANCE(275);
      if (lookahead == '=') ADVANCE(360);
      if (lookahead == '\\') SKIP(202);
      if (lookahead == '_') ADVANCE(400);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (lookahead > '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_program_token1);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym___END__);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(238);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym___END__);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(238);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(246);
      if (lookahead == '\r') ADVANCE(243);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(246);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(256);
      if (lookahead != 0) ADVANCE(244);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n') ADVANCE(247);
      if (lookahead == '\r') ADVANCE(245);
      if (lookahead != 0) ADVANCE(245);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '#') ADVANCE(244);
      if (lookahead == '=') ADVANCE(248);
      if (lookahead == '\\') ADVANCE(242);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(246);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '=') ADVANCE(251);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'b') ADVANCE(250);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'd') ADVANCE(244);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'e') ADVANCE(252);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'e') ADVANCE(254);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'g') ADVANCE(253);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'i') ADVANCE(255);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'n') ADVANCE(249);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == 'n') ADVANCE(245);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_BEGIN);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(298);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(126);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '>') ADVANCE(292);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(292);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(309);
      if (lookahead == '|') ADVANCE(322);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(321);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(281);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(281);
      if (lookahead == '=') ADVANCE(305);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(136);
      if (lookahead == '=') ADVANCE(305);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(324);
      if (lookahead == '.') ADVANCE(302);
      if (lookahead == '=') ADVANCE(311);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(323);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(323);
      if (lookahead == '.') ADVANCE(302);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(301);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(266);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(326);
      if (lookahead == '=') ADVANCE(329);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(325);
      if (lookahead == '=') ADVANCE(329);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(276);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(315);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_COLON_COLON2);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_AMP_DOT);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\') ADVANCE(420);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(416);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(301);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(266);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(308);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(310);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(314);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(313);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(344);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(332);
      if (lookahead == '>') ADVANCE(328);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(332);
      if (lookahead == '>') ADVANCE(327);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(303);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '@') ADVANCE(354);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '@') ADVANCE(354);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(307);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(312);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(343);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_defined_QMARK);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(342);
      if (lookahead == '~') ADVANCE(346);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '~') ADVANCE(346);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '@') ADVANCE(356);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '@') ADVANCE(355);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_PLUS_AT);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_DASH_AT);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_TILDE_AT);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      if (lookahead == '=') ADVANCE(358);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK_EQ);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_EQ2);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_EQ2);
      if (lookahead == '=') ADVANCE(341);
      if (lookahead == '~') ADVANCE(345);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '{') ADVANCE(421);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(363);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(363);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(158);
      if (lookahead == '_') ADVANCE(155);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(153);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(366);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(364);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_integer);
      ADVANCE_MAP(
        '.', 158,
        '_', 157,
        'B', 154,
        'b', 154,
        'D', 159,
        'd', 159,
        'E', 153,
        'e', 153,
        'O', 156,
        'o', 156,
        'X', 161,
        'x', 161,
        '8', 366,
        '9', 366,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(364);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(158);
      if (lookahead == '_') ADVANCE(157);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(366);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(154);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(367);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(368);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(369);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(370);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(158);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(371);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(372);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'D') ADVANCE(260);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'E') ADVANCE(375);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'G') ADVANCE(376);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'I') ADVANCE(378);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'N') ADVANCE(373);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead == 'N') ADVANCE(257);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '?') ADVANCE(381);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(379);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(380);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(aux_sym_constant_suffix_token1);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(347);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(347);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'D') ADVANCE(389);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'E') ADVANCE(386);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'N') ADVANCE(384);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == '_') ADVANCE(385);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == '_') ADVANCE(239);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == '_') ADVANCE(388);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'd') ADVANCE(383);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'e') ADVANCE(393);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'e') ADVANCE(390);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'f') ADVANCE(394);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'i') ADVANCE(395);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead == 'n') ADVANCE(392);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '?') ADVANCE(410);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(396);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'D') ADVANCE(402);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(399);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'N') ADVANCE(397);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(398);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(240);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(401);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(382);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(406);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(403);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(407);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(408);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(405);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(409);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(aux_sym_identifier_suffix_token1);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym_instance_variable);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(411);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_class_variable);
      if (lookahead > '/' &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(412);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym_global_variable);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(414);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(415);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym_character);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '{') ADVANCE(151);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(419);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == 'C' ||
          lookahead == 'M') ADVANCE(123);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym_character);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(419);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym_character);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(417);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACE);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(422);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(aux_sym_string_array_token1);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(423);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(422);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(41);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(424);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(427);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(424);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\\') SKIP(1);
      if (lookahead == '_') ADVANCE(2);
      if (lookahead == 'a') ADVANCE(3);
      if (lookahead == 'b') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'd') ADVANCE(6);
      if (lookahead == 'e') ADVANCE(7);
      if (lookahead == 'f') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(9);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'n') ADVANCE(11);
      if (lookahead == 'o') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(13);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(19);
      if (lookahead == '\r') SKIP(20);
      END_STATE();
    case 2:
      if (lookahead == '_') ADVANCE(21);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(24);
      if (lookahead == 'r') ADVANCE(25);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(26);
      if (lookahead == 'l') ADVANCE(27);
      END_STATE();
    case 6:
      if (lookahead == 'e') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == 'l') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(31);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_i);
      if (lookahead == 'f') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(39);
      END_STATE();
    case 12:
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_r);
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'i') ADVANCE(42);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 'u') ADVANCE(44);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(45);
      if (lookahead == 'r') ADVANCE(46);
      END_STATE();
    case 16:
      if (lookahead == 'n') ADVANCE(47);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(48);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(49);
      END_STATE();
    case 19:
      if (lookahead == '\\') SKIP(1);
      if (lookahead == '_') ADVANCE(2);
      if (lookahead == 'a') ADVANCE(3);
      if (lookahead == 'b') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'd') ADVANCE(6);
      if (lookahead == 'e') ADVANCE(7);
      if (lookahead == 'f') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(50);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'n') ADVANCE(11);
      if (lookahead == 'o') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(51);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(19);
      END_STATE();
    case 21:
      if (lookahead == 'E') ADVANCE(52);
      if (lookahead == 'F') ADVANCE(53);
      if (lookahead == 'L') ADVANCE(54);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(55);
      END_STATE();
    case 23:
      if (lookahead == 'd') ADVANCE(56);
      END_STATE();
    case 24:
      if (lookahead == 'g') ADVANCE(57);
      END_STATE();
    case 25:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(59);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(60);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(61);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(62);
      END_STATE();
    case 31:
      if (lookahead == 'd') ADVANCE(63);
      if (lookahead == 's') ADVANCE(64);
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(65);
      END_STATE();
    case 33:
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 36:
      if (lookahead == 'd') ADVANCE(67);
      END_STATE();
    case 37:
      if (lookahead == 'x') ADVANCE(68);
      END_STATE();
    case 38:
      if (lookahead == 'l') ADVANCE(69);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 41:
      if (lookahead == 'd') ADVANCE(71);
      if (lookahead == 's') ADVANCE(72);
      if (lookahead == 't') ADVANCE(73);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_ri);
      END_STATE();
    case 43:
      if (lookahead == 'l') ADVANCE(74);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(75);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 46:
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 47:
      if (lookahead == 'd') ADVANCE(78);
      if (lookahead == 'l') ADVANCE(79);
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 48:
      if (lookahead == 'e') ADVANCE(81);
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 49:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 50:
      if (lookahead == 'f') ADVANCE(34);
      if (lookahead == 'n') ADVANCE(35);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(41);
      END_STATE();
    case 52:
      if (lookahead == 'N') ADVANCE(84);
      END_STATE();
    case 53:
      if (lookahead == 'I') ADVANCE(85);
      END_STATE();
    case 54:
      if (lookahead == 'I') ADVANCE(86);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(87);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(88);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(89);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 60:
      if (lookahead == 's') ADVANCE(91);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(92);
      if (lookahead == 'i') ADVANCE(93);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(94);
      END_STATE();
    case 65:
      if (lookahead == 's') ADVANCE(95);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 67:
      if (lookahead == 'u') ADVANCE(96);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 71:
      if (lookahead == 'o') ADVANCE(98);
      END_STATE();
    case 72:
      if (lookahead == 'c') ADVANCE(99);
      END_STATE();
    case 73:
      if (lookahead == 'r') ADVANCE(100);
      if (lookahead == 'u') ADVANCE(101);
      END_STATE();
    case 74:
      if (lookahead == 'f') ADVANCE(102);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(103);
      END_STATE();
    case 76:
      if (lookahead == 'n') ADVANCE(104);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(105);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(108);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(110);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(111);
      END_STATE();
    case 84:
      if (lookahead == 'C') ADVANCE(112);
      END_STATE();
    case 85:
      if (lookahead == 'L') ADVANCE(113);
      END_STATE();
    case 86:
      if (lookahead == 'N') ADVANCE(114);
      END_STATE();
    case 87:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 88:
      if (lookahead == 'n') ADVANCE(116);
      END_STATE();
    case 89:
      if (lookahead == 'k') ADVANCE(117);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 91:
      if (lookahead == 's') ADVANCE(118);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 93:
      if (lookahead == 'f') ADVANCE(119);
      END_STATE();
    case 94:
      if (lookahead == 'r') ADVANCE(120);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(122);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_next);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_redo);
      END_STATE();
    case 99:
      if (lookahead == 'u') ADVANCE(123);
      END_STATE();
    case 100:
      if (lookahead == 'y') ADVANCE(124);
      END_STATE();
    case 101:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 106:
      if (lookahead == 'f') ADVANCE(127);
      END_STATE();
    case 107:
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 108:
      if (lookahead == 'l') ADVANCE(129);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 111:
      if (lookahead == 'd') ADVANCE(131);
      END_STATE();
    case 112:
      if (lookahead == 'O') ADVANCE(132);
      END_STATE();
    case 113:
      if (lookahead == 'E') ADVANCE(133);
      END_STATE();
    case 114:
      if (lookahead == 'E') ADVANCE(134);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(135);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_retry);
      END_STATE();
    case 125:
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 128:
      if (lookahead == 's') ADVANCE(139);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 132:
      if (lookahead == 'D') ADVANCE(140);
      END_STATE();
    case 133:
      if (lookahead == '_') ADVANCE(141);
      END_STATE();
    case 134:
      if (lookahead == '_') ADVANCE(142);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_ensure);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_rescue);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_unless);
      END_STATE();
    case 140:
      if (lookahead == 'I') ADVANCE(143);
      END_STATE();
    case 141:
      if (lookahead == '_') ADVANCE(144);
      END_STATE();
    case 142:
      if (lookahead == '_') ADVANCE(145);
      END_STATE();
    case 143:
      if (lookahead == 'N') ADVANCE(146);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_file);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_line);
      END_STATE();
    case 146:
      if (lookahead == 'G') ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == '_') ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == '_') ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_encoding);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 214, .external_lex_state = 2},
  [2] = {.lex_state = 67, .external_lex_state = 3},
  [3] = {.lex_state = 67, .external_lex_state = 3},
  [4] = {.lex_state = 67, .external_lex_state = 3},
  [5] = {.lex_state = 67, .external_lex_state = 3},
  [6] = {.lex_state = 67, .external_lex_state = 3},
  [7] = {.lex_state = 67, .external_lex_state = 3},
  [8] = {.lex_state = 208, .external_lex_state = 3},
  [9] = {.lex_state = 208, .external_lex_state = 3},
  [10] = {.lex_state = 208, .external_lex_state = 3},
  [11] = {.lex_state = 208, .external_lex_state = 3},
  [12] = {.lex_state = 208, .external_lex_state = 3},
  [13] = {.lex_state = 208, .external_lex_state = 3},
  [14] = {.lex_state = 67, .external_lex_state = 3},
  [15] = {.lex_state = 67, .external_lex_state = 3},
  [16] = {.lex_state = 67, .external_lex_state = 3},
  [17] = {.lex_state = 67, .external_lex_state = 3},
  [18] = {.lex_state = 67, .external_lex_state = 3},
  [19] = {.lex_state = 67, .external_lex_state = 3},
  [20] = {.lex_state = 67, .external_lex_state = 4},
  [21] = {.lex_state = 67, .external_lex_state = 3},
  [22] = {.lex_state = 67, .external_lex_state = 3},
  [23] = {.lex_state = 67, .external_lex_state = 3},
  [24] = {.lex_state = 67, .external_lex_state = 3},
  [25] = {.lex_state = 67, .external_lex_state = 4},
  [26] = {.lex_state = 67, .external_lex_state = 3},
  [27] = {.lex_state = 67, .external_lex_state = 3},
  [28] = {.lex_state = 67, .external_lex_state = 4},
  [29] = {.lex_state = 67, .external_lex_state = 4},
  [30] = {.lex_state = 67, .external_lex_state = 3},
  [31] = {.lex_state = 67, .external_lex_state = 3},
  [32] = {.lex_state = 67, .external_lex_state = 3},
  [33] = {.lex_state = 67, .external_lex_state = 3},
  [34] = {.lex_state = 67, .external_lex_state = 4},
  [35] = {.lex_state = 67, .external_lex_state = 4},
  [36] = {.lex_state = 67, .external_lex_state = 4},
  [37] = {.lex_state = 67, .external_lex_state = 4},
  [38] = {.lex_state = 67, .external_lex_state = 4},
  [39] = {.lex_state = 67, .external_lex_state = 4},
  [40] = {.lex_state = 67, .external_lex_state = 4},
  [41] = {.lex_state = 67, .external_lex_state = 4},
  [42] = {.lex_state = 70, .external_lex_state = 3},
  [43] = {.lex_state = 70, .external_lex_state = 3},
  [44] = {.lex_state = 70, .external_lex_state = 3},
  [45] = {.lex_state = 70, .external_lex_state = 3},
  [46] = {.lex_state = 70, .external_lex_state = 3},
  [47] = {.lex_state = 70, .external_lex_state = 3},
  [48] = {.lex_state = 70, .external_lex_state = 3},
  [49] = {.lex_state = 70, .external_lex_state = 3},
  [50] = {.lex_state = 70, .external_lex_state = 3},
  [51] = {.lex_state = 70, .external_lex_state = 3},
  [52] = {.lex_state = 70, .external_lex_state = 3},
  [53] = {.lex_state = 210, .external_lex_state = 3},
  [54] = {.lex_state = 210, .external_lex_state = 3},
  [55] = {.lex_state = 210, .external_lex_state = 3},
  [56] = {.lex_state = 210, .external_lex_state = 3},
  [57] = {.lex_state = 210, .external_lex_state = 3},
  [58] = {.lex_state = 210, .external_lex_state = 3},
  [59] = {.lex_state = 70, .external_lex_state = 3},
  [60] = {.lex_state = 210, .external_lex_state = 3},
  [61] = {.lex_state = 70, .external_lex_state = 3},
  [62] = {.lex_state = 210, .external_lex_state = 3},
  [63] = {.lex_state = 70, .external_lex_state = 3},
  [64] = {.lex_state = 70, .external_lex_state = 4},
  [65] = {.lex_state = 70, .external_lex_state = 3},
  [66] = {.lex_state = 210, .external_lex_state = 3},
  [67] = {.lex_state = 210, .external_lex_state = 3},
  [68] = {.lex_state = 70, .external_lex_state = 3},
  [69] = {.lex_state = 70, .external_lex_state = 3},
  [70] = {.lex_state = 210, .external_lex_state = 3},
  [71] = {.lex_state = 70, .external_lex_state = 4},
  [72] = {.lex_state = 70, .external_lex_state = 3},
  [73] = {.lex_state = 70, .external_lex_state = 3},
  [74] = {.lex_state = 70, .external_lex_state = 3},
  [75] = {.lex_state = 70, .external_lex_state = 3},
  [76] = {.lex_state = 70, .external_lex_state = 3},
  [77] = {.lex_state = 70, .external_lex_state = 4},
  [78] = {.lex_state = 70, .external_lex_state = 3},
  [79] = {.lex_state = 70, .external_lex_state = 4},
  [80] = {.lex_state = 70, .external_lex_state = 4},
  [81] = {.lex_state = 70, .external_lex_state = 3},
  [82] = {.lex_state = 70, .external_lex_state = 3},
  [83] = {.lex_state = 70, .external_lex_state = 3},
  [84] = {.lex_state = 70, .external_lex_state = 3},
  [85] = {.lex_state = 70, .external_lex_state = 3},
  [86] = {.lex_state = 70, .external_lex_state = 3},
  [87] = {.lex_state = 70, .external_lex_state = 3},
  [88] = {.lex_state = 70, .external_lex_state = 4},
  [89] = {.lex_state = 70, .external_lex_state = 3},
  [90] = {.lex_state = 70, .external_lex_state = 3},
  [91] = {.lex_state = 70, .external_lex_state = 3},
  [92] = {.lex_state = 70, .external_lex_state = 4},
  [93] = {.lex_state = 70, .external_lex_state = 4},
  [94] = {.lex_state = 70, .external_lex_state = 3},
  [95] = {.lex_state = 70, .external_lex_state = 4},
  [96] = {.lex_state = 70, .external_lex_state = 3},
  [97] = {.lex_state = 70, .external_lex_state = 3},
  [98] = {.lex_state = 70, .external_lex_state = 4},
  [99] = {.lex_state = 70, .external_lex_state = 4},
  [100] = {.lex_state = 70, .external_lex_state = 4},
  [101] = {.lex_state = 70, .external_lex_state = 4},
  [102] = {.lex_state = 70, .external_lex_state = 4},
  [103] = {.lex_state = 70, .external_lex_state = 4},
  [104] = {.lex_state = 70, .external_lex_state = 4},
  [105] = {.lex_state = 70, .external_lex_state = 4},
  [106] = {.lex_state = 70, .external_lex_state = 4},
  [107] = {.lex_state = 70, .external_lex_state = 3},
  [108] = {.lex_state = 70, .external_lex_state = 3},
  [109] = {.lex_state = 70, .external_lex_state = 3},
  [110] = {.lex_state = 70, .external_lex_state = 4},
  [111] = {.lex_state = 70, .external_lex_state = 4},
  [112] = {.lex_state = 70, .external_lex_state = 4},
  [113] = {.lex_state = 70, .external_lex_state = 4},
  [114] = {.lex_state = 79, .external_lex_state = 2},
  [115] = {.lex_state = 79, .external_lex_state = 2},
  [116] = {.lex_state = 79, .external_lex_state = 2},
  [117] = {.lex_state = 79, .external_lex_state = 2},
  [118] = {.lex_state = 78, .external_lex_state = 5},
  [119] = {.lex_state = 78, .external_lex_state = 5},
  [120] = {.lex_state = 78, .external_lex_state = 5},
  [121] = {.lex_state = 78, .external_lex_state = 5},
  [122] = {.lex_state = 78, .external_lex_state = 5},
  [123] = {.lex_state = 75, .external_lex_state = 6},
  [124] = {.lex_state = 75, .external_lex_state = 6},
  [125] = {.lex_state = 75, .external_lex_state = 6},
  [126] = {.lex_state = 75, .external_lex_state = 6},
  [127] = {.lex_state = 75, .external_lex_state = 6},
  [128] = {.lex_state = 77, .external_lex_state = 6},
  [129] = {.lex_state = 75, .external_lex_state = 6},
  [130] = {.lex_state = 77, .external_lex_state = 6},
  [131] = {.lex_state = 77, .external_lex_state = 6},
  [132] = {.lex_state = 77, .external_lex_state = 6},
  [133] = {.lex_state = 77, .external_lex_state = 6},
  [134] = {.lex_state = 77, .external_lex_state = 6},
  [135] = {.lex_state = 80, .external_lex_state = 7},
  [136] = {.lex_state = 80, .external_lex_state = 7},
  [137] = {.lex_state = 80, .external_lex_state = 7},
  [138] = {.lex_state = 79, .external_lex_state = 7},
  [139] = {.lex_state = 80, .external_lex_state = 7},
  [140] = {.lex_state = 80, .external_lex_state = 7},
  [141] = {.lex_state = 79, .external_lex_state = 7},
  [142] = {.lex_state = 80, .external_lex_state = 7},
  [143] = {.lex_state = 80, .external_lex_state = 7},
  [144] = {.lex_state = 79, .external_lex_state = 7},
  [145] = {.lex_state = 80, .external_lex_state = 7},
  [146] = {.lex_state = 80, .external_lex_state = 7},
  [147] = {.lex_state = 79, .external_lex_state = 7},
  [148] = {.lex_state = 80, .external_lex_state = 7},
  [149] = {.lex_state = 80, .external_lex_state = 7},
  [150] = {.lex_state = 79, .external_lex_state = 7},
  [151] = {.lex_state = 80, .external_lex_state = 7},
  [152] = {.lex_state = 80, .external_lex_state = 7},
  [153] = {.lex_state = 79, .external_lex_state = 7},
  [154] = {.lex_state = 80, .external_lex_state = 7},
  [155] = {.lex_state = 80, .external_lex_state = 7},
  [156] = {.lex_state = 80, .external_lex_state = 7},
  [157] = {.lex_state = 80, .external_lex_state = 7},
  [158] = {.lex_state = 80, .external_lex_state = 7},
  [159] = {.lex_state = 80, .external_lex_state = 7},
  [160] = {.lex_state = 80, .external_lex_state = 7},
  [161] = {.lex_state = 80, .external_lex_state = 7},
  [162] = {.lex_state = 80, .external_lex_state = 7},
  [163] = {.lex_state = 80, .external_lex_state = 7},
  [164] = {.lex_state = 80, .external_lex_state = 7},
  [165] = {.lex_state = 79, .external_lex_state = 7},
  [166] = {.lex_state = 79, .external_lex_state = 2},
  [167] = {.lex_state = 79, .external_lex_state = 7},
  [168] = {.lex_state = 79, .external_lex_state = 7},
  [169] = {.lex_state = 79, .external_lex_state = 2},
  [170] = {.lex_state = 79, .external_lex_state = 7},
  [171] = {.lex_state = 79, .external_lex_state = 2},
  [172] = {.lex_state = 79, .external_lex_state = 7},
  [173] = {.lex_state = 79, .external_lex_state = 7},
  [174] = {.lex_state = 79, .external_lex_state = 7},
  [175] = {.lex_state = 79, .external_lex_state = 2},
  [176] = {.lex_state = 79, .external_lex_state = 7},
  [177] = {.lex_state = 79, .external_lex_state = 7},
  [178] = {.lex_state = 79, .external_lex_state = 2},
  [179] = {.lex_state = 79, .external_lex_state = 7},
  [180] = {.lex_state = 79, .external_lex_state = 7},
  [181] = {.lex_state = 79, .external_lex_state = 7},
  [182] = {.lex_state = 79, .external_lex_state = 2},
  [183] = {.lex_state = 79, .external_lex_state = 7},
  [184] = {.lex_state = 79, .external_lex_state = 2},
  [185] = {.lex_state = 79, .external_lex_state = 7},
  [186] = {.lex_state = 79, .external_lex_state = 7},
  [187] = {.lex_state = 79, .external_lex_state = 7},
  [188] = {.lex_state = 73, .external_lex_state = 8},
  [189] = {.lex_state = 73, .external_lex_state = 8},
  [190] = {.lex_state = 79, .external_lex_state = 7},
  [191] = {.lex_state = 79, .external_lex_state = 7},
  [192] = {.lex_state = 79, .external_lex_state = 2},
  [193] = {.lex_state = 79, .external_lex_state = 2},
  [194] = {.lex_state = 79, .external_lex_state = 2},
  [195] = {.lex_state = 79, .external_lex_state = 2},
  [196] = {.lex_state = 79, .external_lex_state = 2},
  [197] = {.lex_state = 79, .external_lex_state = 2},
  [198] = {.lex_state = 79, .external_lex_state = 2},
  [199] = {.lex_state = 79, .external_lex_state = 2},
  [200] = {.lex_state = 79, .external_lex_state = 2},
  [201] = {.lex_state = 73, .external_lex_state = 8},
  [202] = {.lex_state = 79, .external_lex_state = 2},
  [203] = {.lex_state = 79, .external_lex_state = 2},
  [204] = {.lex_state = 79, .external_lex_state = 2},
  [205] = {.lex_state = 79, .external_lex_state = 2},
  [206] = {.lex_state = 79, .external_lex_state = 2},
  [207] = {.lex_state = 79, .external_lex_state = 2},
  [208] = {.lex_state = 79, .external_lex_state = 2},
  [209] = {.lex_state = 79, .external_lex_state = 2},
  [210] = {.lex_state = 79, .external_lex_state = 2},
  [211] = {.lex_state = 79, .external_lex_state = 2},
  [212] = {.lex_state = 79, .external_lex_state = 2},
  [213] = {.lex_state = 79, .external_lex_state = 2},
  [214] = {.lex_state = 79, .external_lex_state = 2},
  [215] = {.lex_state = 79, .external_lex_state = 2},
  [216] = {.lex_state = 79, .external_lex_state = 2},
  [217] = {.lex_state = 79, .external_lex_state = 2},
  [218] = {.lex_state = 79, .external_lex_state = 2},
  [219] = {.lex_state = 79, .external_lex_state = 2},
  [220] = {.lex_state = 79, .external_lex_state = 2},
  [221] = {.lex_state = 73, .external_lex_state = 8},
  [222] = {.lex_state = 79, .external_lex_state = 2},
  [223] = {.lex_state = 79, .external_lex_state = 2},
  [224] = {.lex_state = 79, .external_lex_state = 2},
  [225] = {.lex_state = 79, .external_lex_state = 2},
  [226] = {.lex_state = 79, .external_lex_state = 2},
  [227] = {.lex_state = 73, .external_lex_state = 8},
  [228] = {.lex_state = 78, .external_lex_state = 9},
  [229] = {.lex_state = 79, .external_lex_state = 2},
  [230] = {.lex_state = 79, .external_lex_state = 2},
  [231] = {.lex_state = 78, .external_lex_state = 9},
  [232] = {.lex_state = 79, .external_lex_state = 2},
  [233] = {.lex_state = 79, .external_lex_state = 10},
  [234] = {.lex_state = 79, .external_lex_state = 10},
  [235] = {.lex_state = 79, .external_lex_state = 10},
  [236] = {.lex_state = 79, .external_lex_state = 10},
  [237] = {.lex_state = 79, .external_lex_state = 10},
  [238] = {.lex_state = 79, .external_lex_state = 10},
  [239] = {.lex_state = 79, .external_lex_state = 10},
  [240] = {.lex_state = 79, .external_lex_state = 10},
  [241] = {.lex_state = 79, .external_lex_state = 2},
  [242] = {.lex_state = 74, .external_lex_state = 11},
  [243] = {.lex_state = 79, .external_lex_state = 2},
  [244] = {.lex_state = 79, .external_lex_state = 2},
  [245] = {.lex_state = 74, .external_lex_state = 11},
  [246] = {.lex_state = 79, .external_lex_state = 2},
  [247] = {.lex_state = 79, .external_lex_state = 2},
  [248] = {.lex_state = 74, .external_lex_state = 11},
  [249] = {.lex_state = 79, .external_lex_state = 2},
  [250] = {.lex_state = 79, .external_lex_state = 2},
  [251] = {.lex_state = 212, .external_lex_state = 8},
  [252] = {.lex_state = 212, .external_lex_state = 8},
  [253] = {.lex_state = 79, .external_lex_state = 2},
  [254] = {.lex_state = 79, .external_lex_state = 2},
  [255] = {.lex_state = 79, .external_lex_state = 2},
  [256] = {.lex_state = 79, .external_lex_state = 7},
  [257] = {.lex_state = 74, .external_lex_state = 11},
  [258] = {.lex_state = 79, .external_lex_state = 2},
  [259] = {.lex_state = 74, .external_lex_state = 11},
  [260] = {.lex_state = 79, .external_lex_state = 2},
  [261] = {.lex_state = 212, .external_lex_state = 8},
  [262] = {.lex_state = 212, .external_lex_state = 8},
  [263] = {.lex_state = 79, .external_lex_state = 7},
  [264] = {.lex_state = 79, .external_lex_state = 2},
  [265] = {.lex_state = 79, .external_lex_state = 2},
  [266] = {.lex_state = 79, .external_lex_state = 7},
  [267] = {.lex_state = 79, .external_lex_state = 7},
  [268] = {.lex_state = 79, .external_lex_state = 2},
  [269] = {.lex_state = 79, .external_lex_state = 2},
  [270] = {.lex_state = 73, .external_lex_state = 12},
  [271] = {.lex_state = 79, .external_lex_state = 2},
  [272] = {.lex_state = 79, .external_lex_state = 2},
  [273] = {.lex_state = 79, .external_lex_state = 2},
  [274] = {.lex_state = 79, .external_lex_state = 2},
  [275] = {.lex_state = 79, .external_lex_state = 2},
  [276] = {.lex_state = 79, .external_lex_state = 2},
  [277] = {.lex_state = 79, .external_lex_state = 2},
  [278] = {.lex_state = 73, .external_lex_state = 12},
  [279] = {.lex_state = 212, .external_lex_state = 8},
  [280] = {.lex_state = 79, .external_lex_state = 2},
  [281] = {.lex_state = 79, .external_lex_state = 2},
  [282] = {.lex_state = 79, .external_lex_state = 2},
  [283] = {.lex_state = 79, .external_lex_state = 2},
  [284] = {.lex_state = 73, .external_lex_state = 8},
  [285] = {.lex_state = 215, .external_lex_state = 9},
  [286] = {.lex_state = 73, .external_lex_state = 12},
  [287] = {.lex_state = 73, .external_lex_state = 12},
  [288] = {.lex_state = 73, .external_lex_state = 12},
  [289] = {.lex_state = 73, .external_lex_state = 8},
  [290] = {.lex_state = 73, .external_lex_state = 12},
  [291] = {.lex_state = 73, .external_lex_state = 8},
  [292] = {.lex_state = 73, .external_lex_state = 8},
  [293] = {.lex_state = 79, .external_lex_state = 2},
  [294] = {.lex_state = 79, .external_lex_state = 2},
  [295] = {.lex_state = 79, .external_lex_state = 2},
  [296] = {.lex_state = 73, .external_lex_state = 8},
  [297] = {.lex_state = 213, .external_lex_state = 11},
  [298] = {.lex_state = 79, .external_lex_state = 2},
  [299] = {.lex_state = 73, .external_lex_state = 8},
  [300] = {.lex_state = 79, .external_lex_state = 2},
  [301] = {.lex_state = 73, .external_lex_state = 8},
  [302] = {.lex_state = 79, .external_lex_state = 2},
  [303] = {.lex_state = 215, .external_lex_state = 9},
  [304] = {.lex_state = 73, .external_lex_state = 12},
  [305] = {.lex_state = 214, .external_lex_state = 2},
  [306] = {.lex_state = 213, .external_lex_state = 11},
  [307] = {.lex_state = 73, .external_lex_state = 12},
  [308] = {.lex_state = 214, .external_lex_state = 2},
  [309] = {.lex_state = 79, .external_lex_state = 2},
  [310] = {.lex_state = 79, .external_lex_state = 2},
  [311] = {.lex_state = 213, .external_lex_state = 11},
  [312] = {.lex_state = 81, .external_lex_state = 2},
  [313] = {.lex_state = 81, .external_lex_state = 2},
  [314] = {.lex_state = 79, .external_lex_state = 2},
  [315] = {.lex_state = 79, .external_lex_state = 2},
  [316] = {.lex_state = 79, .external_lex_state = 2},
  [317] = {.lex_state = 81, .external_lex_state = 2},
  [318] = {.lex_state = 81, .external_lex_state = 2},
  [319] = {.lex_state = 73, .external_lex_state = 8},
  [320] = {.lex_state = 79, .external_lex_state = 2},
  [321] = {.lex_state = 79, .external_lex_state = 2},
  [322] = {.lex_state = 81, .external_lex_state = 2},
  [323] = {.lex_state = 81, .external_lex_state = 2},
  [324] = {.lex_state = 79, .external_lex_state = 2},
  [325] = {.lex_state = 213, .external_lex_state = 11},
  [326] = {.lex_state = 79, .external_lex_state = 2},
  [327] = {.lex_state = 81, .external_lex_state = 2},
  [328] = {.lex_state = 81, .external_lex_state = 2},
  [329] = {.lex_state = 79, .external_lex_state = 2},
  [330] = {.lex_state = 79, .external_lex_state = 2},
  [331] = {.lex_state = 79, .external_lex_state = 2},
  [332] = {.lex_state = 81, .external_lex_state = 2},
  [333] = {.lex_state = 81, .external_lex_state = 2},
  [334] = {.lex_state = 79, .external_lex_state = 2},
  [335] = {.lex_state = 78, .external_lex_state = 9},
  [336] = {.lex_state = 81, .external_lex_state = 2},
  [337] = {.lex_state = 81, .external_lex_state = 2},
  [338] = {.lex_state = 81, .external_lex_state = 2},
  [339] = {.lex_state = 73, .external_lex_state = 8},
  [340] = {.lex_state = 78, .external_lex_state = 5},
  [341] = {.lex_state = 78, .external_lex_state = 9},
  [342] = {.lex_state = 74, .external_lex_state = 13},
  [343] = {.lex_state = 73, .external_lex_state = 12},
  [344] = {.lex_state = 213, .external_lex_state = 11},
  [345] = {.lex_state = 74, .external_lex_state = 13},
  [346] = {.lex_state = 78, .external_lex_state = 9},
  [347] = {.lex_state = 73, .external_lex_state = 8},
  [348] = {.lex_state = 78, .external_lex_state = 9},
  [349] = {.lex_state = 73, .external_lex_state = 12},
  [350] = {.lex_state = 74, .external_lex_state = 11},
  [351] = {.lex_state = 74, .external_lex_state = 13},
  [352] = {.lex_state = 74, .external_lex_state = 13},
  [353] = {.lex_state = 74, .external_lex_state = 13},
  [354] = {.lex_state = 74, .external_lex_state = 11},
  [355] = {.lex_state = 78, .external_lex_state = 9},
  [356] = {.lex_state = 78, .external_lex_state = 5},
  [357] = {.lex_state = 74, .external_lex_state = 13},
  [358] = {.lex_state = 73, .external_lex_state = 8},
  [359] = {.lex_state = 78, .external_lex_state = 5},
  [360] = {.lex_state = 74, .external_lex_state = 11},
  [361] = {.lex_state = 73, .external_lex_state = 12},
  [362] = {.lex_state = 73, .external_lex_state = 12},
  [363] = {.lex_state = 79, .external_lex_state = 2},
  [364] = {.lex_state = 79, .external_lex_state = 2},
  [365] = {.lex_state = 79, .external_lex_state = 2},
  [366] = {.lex_state = 74, .external_lex_state = 11},
  [367] = {.lex_state = 74, .external_lex_state = 11},
  [368] = {.lex_state = 73, .external_lex_state = 12},
  [369] = {.lex_state = 74, .external_lex_state = 11},
  [370] = {.lex_state = 74, .external_lex_state = 13},
  [371] = {.lex_state = 74, .external_lex_state = 13},
  [372] = {.lex_state = 74, .external_lex_state = 11},
  [373] = {.lex_state = 78, .external_lex_state = 5},
  [374] = {.lex_state = 73, .external_lex_state = 12},
  [375] = {.lex_state = 73, .external_lex_state = 12},
  [376] = {.lex_state = 74, .external_lex_state = 11},
  [377] = {.lex_state = 73, .external_lex_state = 12},
  [378] = {.lex_state = 79, .external_lex_state = 2},
  [379] = {.lex_state = 74, .external_lex_state = 11},
  [380] = {.lex_state = 79, .external_lex_state = 2},
  [381] = {.lex_state = 79, .external_lex_state = 2},
  [382] = {.lex_state = 74, .external_lex_state = 13},
  [383] = {.lex_state = 79, .external_lex_state = 2},
  [384] = {.lex_state = 79, .external_lex_state = 2},
  [385] = {.lex_state = 79, .external_lex_state = 2},
  [386] = {.lex_state = 79, .external_lex_state = 2},
  [387] = {.lex_state = 79, .external_lex_state = 2},
  [388] = {.lex_state = 79, .external_lex_state = 2},
  [389] = {.lex_state = 79, .external_lex_state = 2},
  [390] = {.lex_state = 79, .external_lex_state = 2},
  [391] = {.lex_state = 79, .external_lex_state = 2},
  [392] = {.lex_state = 79, .external_lex_state = 2},
  [393] = {.lex_state = 74, .external_lex_state = 11},
  [394] = {.lex_state = 74, .external_lex_state = 13},
  [395] = {.lex_state = 74, .external_lex_state = 13},
  [396] = {.lex_state = 74, .external_lex_state = 13},
  [397] = {.lex_state = 74, .external_lex_state = 11},
  [398] = {.lex_state = 78, .external_lex_state = 5},
  [399] = {.lex_state = 78, .external_lex_state = 5},
  [400] = {.lex_state = 78, .external_lex_state = 5},
  [401] = {.lex_state = 78, .external_lex_state = 5},
  [402] = {.lex_state = 74, .external_lex_state = 13},
  [403] = {.lex_state = 78, .external_lex_state = 5},
  [404] = {.lex_state = 78, .external_lex_state = 5},
  [405] = {.lex_state = 74, .external_lex_state = 13},
  [406] = {.lex_state = 74, .external_lex_state = 13},
  [407] = {.lex_state = 78, .external_lex_state = 5},
  [408] = {.lex_state = 78, .external_lex_state = 5},
  [409] = {.lex_state = 78, .external_lex_state = 5},
  [410] = {.lex_state = 78, .external_lex_state = 14},
  [411] = {.lex_state = 78, .external_lex_state = 5},
  [412] = {.lex_state = 78, .external_lex_state = 5},
  [413] = {.lex_state = 78, .external_lex_state = 5},
  [414] = {.lex_state = 78, .external_lex_state = 2},
  [415] = {.lex_state = 74, .external_lex_state = 13},
  [416] = {.lex_state = 78, .external_lex_state = 5},
  [417] = {.lex_state = 78, .external_lex_state = 5},
  [418] = {.lex_state = 78, .external_lex_state = 5},
  [419] = {.lex_state = 78, .external_lex_state = 5},
  [420] = {.lex_state = 78, .external_lex_state = 5},
  [421] = {.lex_state = 78, .external_lex_state = 5},
  [422] = {.lex_state = 78, .external_lex_state = 5},
  [423] = {.lex_state = 78, .external_lex_state = 5},
  [424] = {.lex_state = 78, .external_lex_state = 5},
  [425] = {.lex_state = 78, .external_lex_state = 5},
  [426] = {.lex_state = 78, .external_lex_state = 5},
  [427] = {.lex_state = 78, .external_lex_state = 5},
  [428] = {.lex_state = 78, .external_lex_state = 5},
  [429] = {.lex_state = 78, .external_lex_state = 5},
  [430] = {.lex_state = 78, .external_lex_state = 15},
  [431] = {.lex_state = 78, .external_lex_state = 15},
  [432] = {.lex_state = 78, .external_lex_state = 15},
  [433] = {.lex_state = 78, .external_lex_state = 15},
  [434] = {.lex_state = 78, .external_lex_state = 15},
  [435] = {.lex_state = 78, .external_lex_state = 15},
  [436] = {.lex_state = 78, .external_lex_state = 15},
  [437] = {.lex_state = 78, .external_lex_state = 15},
  [438] = {.lex_state = 78, .external_lex_state = 15},
  [439] = {.lex_state = 78, .external_lex_state = 15},
  [440] = {.lex_state = 78, .external_lex_state = 15},
  [441] = {.lex_state = 78, .external_lex_state = 15},
  [442] = {.lex_state = 78, .external_lex_state = 15},
  [443] = {.lex_state = 78, .external_lex_state = 15},
  [444] = {.lex_state = 78, .external_lex_state = 15},
  [445] = {.lex_state = 78, .external_lex_state = 15},
  [446] = {.lex_state = 78, .external_lex_state = 15},
  [447] = {.lex_state = 78, .external_lex_state = 15},
  [448] = {.lex_state = 78, .external_lex_state = 15},
  [449] = {.lex_state = 78, .external_lex_state = 15},
  [450] = {.lex_state = 78, .external_lex_state = 15},
  [451] = {.lex_state = 78, .external_lex_state = 15},
  [452] = {.lex_state = 78, .external_lex_state = 15},
  [453] = {.lex_state = 78, .external_lex_state = 15},
  [454] = {.lex_state = 78, .external_lex_state = 15},
  [455] = {.lex_state = 78, .external_lex_state = 16},
  [456] = {.lex_state = 78, .external_lex_state = 16},
  [457] = {.lex_state = 78, .external_lex_state = 2},
  [458] = {.lex_state = 78, .external_lex_state = 2},
  [459] = {.lex_state = 78, .external_lex_state = 7},
  [460] = {.lex_state = 78, .external_lex_state = 7},
  [461] = {.lex_state = 78, .external_lex_state = 7},
  [462] = {.lex_state = 78, .external_lex_state = 7},
  [463] = {.lex_state = 78, .external_lex_state = 16},
  [464] = {.lex_state = 78, .external_lex_state = 2},
  [465] = {.lex_state = 78, .external_lex_state = 2},
  [466] = {.lex_state = 78, .external_lex_state = 2},
  [467] = {.lex_state = 78, .external_lex_state = 2},
  [468] = {.lex_state = 78, .external_lex_state = 2},
  [469] = {.lex_state = 78, .external_lex_state = 2},
  [470] = {.lex_state = 78, .external_lex_state = 2},
  [471] = {.lex_state = 78, .external_lex_state = 2},
  [472] = {.lex_state = 78, .external_lex_state = 16},
  [473] = {.lex_state = 78, .external_lex_state = 2},
  [474] = {.lex_state = 78, .external_lex_state = 2},
  [475] = {.lex_state = 78, .external_lex_state = 2},
  [476] = {.lex_state = 78, .external_lex_state = 2},
  [477] = {.lex_state = 78, .external_lex_state = 2},
  [478] = {.lex_state = 78, .external_lex_state = 2},
  [479] = {.lex_state = 78, .external_lex_state = 2},
  [480] = {.lex_state = 78, .external_lex_state = 2},
  [481] = {.lex_state = 78, .external_lex_state = 2},
  [482] = {.lex_state = 78, .external_lex_state = 2},
  [483] = {.lex_state = 78, .external_lex_state = 2},
  [484] = {.lex_state = 78, .external_lex_state = 2},
  [485] = {.lex_state = 78, .external_lex_state = 2},
  [486] = {.lex_state = 78, .external_lex_state = 2},
  [487] = {.lex_state = 78, .external_lex_state = 2},
  [488] = {.lex_state = 78, .external_lex_state = 7},
  [489] = {.lex_state = 78, .external_lex_state = 7},
  [490] = {.lex_state = 78, .external_lex_state = 7},
  [491] = {.lex_state = 78, .external_lex_state = 7},
  [492] = {.lex_state = 78, .external_lex_state = 2},
  [493] = {.lex_state = 78, .external_lex_state = 2},
  [494] = {.lex_state = 78, .external_lex_state = 2},
  [495] = {.lex_state = 78, .external_lex_state = 2},
  [496] = {.lex_state = 78, .external_lex_state = 2},
  [497] = {.lex_state = 78, .external_lex_state = 2},
  [498] = {.lex_state = 78, .external_lex_state = 2},
  [499] = {.lex_state = 78, .external_lex_state = 2},
  [500] = {.lex_state = 78, .external_lex_state = 2},
  [501] = {.lex_state = 78, .external_lex_state = 2},
  [502] = {.lex_state = 78, .external_lex_state = 2},
  [503] = {.lex_state = 78, .external_lex_state = 2},
  [504] = {.lex_state = 78, .external_lex_state = 2},
  [505] = {.lex_state = 78, .external_lex_state = 2},
  [506] = {.lex_state = 78, .external_lex_state = 2},
  [507] = {.lex_state = 78, .external_lex_state = 2},
  [508] = {.lex_state = 78, .external_lex_state = 2},
  [509] = {.lex_state = 78, .external_lex_state = 2},
  [510] = {.lex_state = 78, .external_lex_state = 2},
  [511] = {.lex_state = 78, .external_lex_state = 2},
  [512] = {.lex_state = 78, .external_lex_state = 2},
  [513] = {.lex_state = 78, .external_lex_state = 2},
  [514] = {.lex_state = 78, .external_lex_state = 2},
  [515] = {.lex_state = 78, .external_lex_state = 2},
  [516] = {.lex_state = 78, .external_lex_state = 2},
  [517] = {.lex_state = 78, .external_lex_state = 2},
  [518] = {.lex_state = 78, .external_lex_state = 2},
  [519] = {.lex_state = 78, .external_lex_state = 2},
  [520] = {.lex_state = 78, .external_lex_state = 2},
  [521] = {.lex_state = 78, .external_lex_state = 2},
  [522] = {.lex_state = 78, .external_lex_state = 2},
  [523] = {.lex_state = 78, .external_lex_state = 2},
  [524] = {.lex_state = 78, .external_lex_state = 2},
  [525] = {.lex_state = 78, .external_lex_state = 2},
  [526] = {.lex_state = 78, .external_lex_state = 2},
  [527] = {.lex_state = 78, .external_lex_state = 2},
  [528] = {.lex_state = 78, .external_lex_state = 2},
  [529] = {.lex_state = 78, .external_lex_state = 2},
  [530] = {.lex_state = 78, .external_lex_state = 2},
  [531] = {.lex_state = 78, .external_lex_state = 2},
  [532] = {.lex_state = 78, .external_lex_state = 2},
  [533] = {.lex_state = 78, .external_lex_state = 2},
  [534] = {.lex_state = 78, .external_lex_state = 2},
  [535] = {.lex_state = 78, .external_lex_state = 2},
  [536] = {.lex_state = 78, .external_lex_state = 2},
  [537] = {.lex_state = 78, .external_lex_state = 2},
  [538] = {.lex_state = 78, .external_lex_state = 2},
  [539] = {.lex_state = 78, .external_lex_state = 2},
  [540] = {.lex_state = 78, .external_lex_state = 2},
  [541] = {.lex_state = 78, .external_lex_state = 2},
  [542] = {.lex_state = 78, .external_lex_state = 2},
  [543] = {.lex_state = 78, .external_lex_state = 2},
  [544] = {.lex_state = 78, .external_lex_state = 2},
  [545] = {.lex_state = 78, .external_lex_state = 2},
  [546] = {.lex_state = 78, .external_lex_state = 2},
  [547] = {.lex_state = 78, .external_lex_state = 2},
  [548] = {.lex_state = 78, .external_lex_state = 2},
  [549] = {.lex_state = 78, .external_lex_state = 2},
  [550] = {.lex_state = 78, .external_lex_state = 2},
  [551] = {.lex_state = 78, .external_lex_state = 2},
  [552] = {.lex_state = 78, .external_lex_state = 2},
  [553] = {.lex_state = 78, .external_lex_state = 2},
  [554] = {.lex_state = 78, .external_lex_state = 2},
  [555] = {.lex_state = 78, .external_lex_state = 2},
  [556] = {.lex_state = 78, .external_lex_state = 2},
  [557] = {.lex_state = 78, .external_lex_state = 2},
  [558] = {.lex_state = 78, .external_lex_state = 2},
  [559] = {.lex_state = 78, .external_lex_state = 2},
  [560] = {.lex_state = 78, .external_lex_state = 2},
  [561] = {.lex_state = 78, .external_lex_state = 2},
  [562] = {.lex_state = 78, .external_lex_state = 2},
  [563] = {.lex_state = 78, .external_lex_state = 2},
  [564] = {.lex_state = 78, .external_lex_state = 2},
  [565] = {.lex_state = 78, .external_lex_state = 2},
  [566] = {.lex_state = 78, .external_lex_state = 2},
  [567] = {.lex_state = 78, .external_lex_state = 2},
  [568] = {.lex_state = 78, .external_lex_state = 2},
  [569] = {.lex_state = 78, .external_lex_state = 2},
  [570] = {.lex_state = 78, .external_lex_state = 2},
  [571] = {.lex_state = 78, .external_lex_state = 2},
  [572] = {.lex_state = 78, .external_lex_state = 2},
  [573] = {.lex_state = 78, .external_lex_state = 2},
  [574] = {.lex_state = 78, .external_lex_state = 2},
  [575] = {.lex_state = 78, .external_lex_state = 2},
  [576] = {.lex_state = 78, .external_lex_state = 2},
  [577] = {.lex_state = 78, .external_lex_state = 2},
  [578] = {.lex_state = 78, .external_lex_state = 2},
  [579] = {.lex_state = 78, .external_lex_state = 2},
  [580] = {.lex_state = 78, .external_lex_state = 2},
  [581] = {.lex_state = 78, .external_lex_state = 2},
  [582] = {.lex_state = 78, .external_lex_state = 2},
  [583] = {.lex_state = 78, .external_lex_state = 2},
  [584] = {.lex_state = 78, .external_lex_state = 2},
  [585] = {.lex_state = 78, .external_lex_state = 2},
  [586] = {.lex_state = 78, .external_lex_state = 2},
  [587] = {.lex_state = 78, .external_lex_state = 2},
  [588] = {.lex_state = 78, .external_lex_state = 2},
  [589] = {.lex_state = 78, .external_lex_state = 2},
  [590] = {.lex_state = 78, .external_lex_state = 2},
  [591] = {.lex_state = 78, .external_lex_state = 2},
  [592] = {.lex_state = 78, .external_lex_state = 2},
  [593] = {.lex_state = 78, .external_lex_state = 2},
  [594] = {.lex_state = 78, .external_lex_state = 2},
  [595] = {.lex_state = 78, .external_lex_state = 2},
  [596] = {.lex_state = 78, .external_lex_state = 2},
  [597] = {.lex_state = 78, .external_lex_state = 2},
  [598] = {.lex_state = 78, .external_lex_state = 2},
  [599] = {.lex_state = 78, .external_lex_state = 2},
  [600] = {.lex_state = 78, .external_lex_state = 2},
  [601] = {.lex_state = 78, .external_lex_state = 2},
  [602] = {.lex_state = 78, .external_lex_state = 2},
  [603] = {.lex_state = 78, .external_lex_state = 2},
  [604] = {.lex_state = 78, .external_lex_state = 2},
  [605] = {.lex_state = 78, .external_lex_state = 2},
  [606] = {.lex_state = 78, .external_lex_state = 2},
  [607] = {.lex_state = 78, .external_lex_state = 2},
  [608] = {.lex_state = 78, .external_lex_state = 2},
  [609] = {.lex_state = 78, .external_lex_state = 2},
  [610] = {.lex_state = 78, .external_lex_state = 2},
  [611] = {.lex_state = 78, .external_lex_state = 2},
  [612] = {.lex_state = 78, .external_lex_state = 2},
  [613] = {.lex_state = 78, .external_lex_state = 2},
  [614] = {.lex_state = 78, .external_lex_state = 2},
  [615] = {.lex_state = 78, .external_lex_state = 2},
  [616] = {.lex_state = 78, .external_lex_state = 2},
  [617] = {.lex_state = 78, .external_lex_state = 2},
  [618] = {.lex_state = 78, .external_lex_state = 2},
  [619] = {.lex_state = 78, .external_lex_state = 2},
  [620] = {.lex_state = 78, .external_lex_state = 2},
  [621] = {.lex_state = 78, .external_lex_state = 2},
  [622] = {.lex_state = 78, .external_lex_state = 2},
  [623] = {.lex_state = 78, .external_lex_state = 2},
  [624] = {.lex_state = 78, .external_lex_state = 2},
  [625] = {.lex_state = 78, .external_lex_state = 2},
  [626] = {.lex_state = 78, .external_lex_state = 2},
  [627] = {.lex_state = 78, .external_lex_state = 2},
  [628] = {.lex_state = 78, .external_lex_state = 2},
  [629] = {.lex_state = 78, .external_lex_state = 2},
  [630] = {.lex_state = 78, .external_lex_state = 2},
  [631] = {.lex_state = 78, .external_lex_state = 2},
  [632] = {.lex_state = 78, .external_lex_state = 2},
  [633] = {.lex_state = 78, .external_lex_state = 2},
  [634] = {.lex_state = 78, .external_lex_state = 2},
  [635] = {.lex_state = 78, .external_lex_state = 2},
  [636] = {.lex_state = 78, .external_lex_state = 2},
  [637] = {.lex_state = 78, .external_lex_state = 2},
  [638] = {.lex_state = 78, .external_lex_state = 2},
  [639] = {.lex_state = 78, .external_lex_state = 2},
  [640] = {.lex_state = 78, .external_lex_state = 2},
  [641] = {.lex_state = 78, .external_lex_state = 2},
  [642] = {.lex_state = 78, .external_lex_state = 2},
  [643] = {.lex_state = 81, .external_lex_state = 10},
  [644] = {.lex_state = 81, .external_lex_state = 10},
  [645] = {.lex_state = 81, .external_lex_state = 10},
  [646] = {.lex_state = 81, .external_lex_state = 10},
  [647] = {.lex_state = 81, .external_lex_state = 10},
  [648] = {.lex_state = 215, .external_lex_state = 16},
  [649] = {.lex_state = 215, .external_lex_state = 16},
  [650] = {.lex_state = 215, .external_lex_state = 16},
  [651] = {.lex_state = 215, .external_lex_state = 16},
  [652] = {.lex_state = 215, .external_lex_state = 7},
  [653] = {.lex_state = 78, .external_lex_state = 17},
  [654] = {.lex_state = 215, .external_lex_state = 7},
  [655] = {.lex_state = 215, .external_lex_state = 7},
  [656] = {.lex_state = 215, .external_lex_state = 7},
  [657] = {.lex_state = 215, .external_lex_state = 7},
  [658] = {.lex_state = 78, .external_lex_state = 2},
  [659] = {.lex_state = 215, .external_lex_state = 7},
  [660] = {.lex_state = 215, .external_lex_state = 7},
  [661] = {.lex_state = 215, .external_lex_state = 7},
  [662] = {.lex_state = 78, .external_lex_state = 16},
  [663] = {.lex_state = 78, .external_lex_state = 16},
  [664] = {.lex_state = 78, .external_lex_state = 14},
  [665] = {.lex_state = 78, .external_lex_state = 16},
  [666] = {.lex_state = 78, .external_lex_state = 16},
  [667] = {.lex_state = 78, .external_lex_state = 14},
  [668] = {.lex_state = 78, .external_lex_state = 14},
  [669] = {.lex_state = 78, .external_lex_state = 2},
  [670] = {.lex_state = 78, .external_lex_state = 2},
  [671] = {.lex_state = 78, .external_lex_state = 2},
  [672] = {.lex_state = 78, .external_lex_state = 2},
  [673] = {.lex_state = 78, .external_lex_state = 2},
  [674] = {.lex_state = 78, .external_lex_state = 14},
  [675] = {.lex_state = 78, .external_lex_state = 7},
  [676] = {.lex_state = 78, .external_lex_state = 7},
  [677] = {.lex_state = 78, .external_lex_state = 2},
  [678] = {.lex_state = 78, .external_lex_state = 2},
  [679] = {.lex_state = 78, .external_lex_state = 7},
  [680] = {.lex_state = 78, .external_lex_state = 16},
  [681] = {.lex_state = 78, .external_lex_state = 2},
  [682] = {.lex_state = 78, .external_lex_state = 2},
  [683] = {.lex_state = 78, .external_lex_state = 7},
  [684] = {.lex_state = 78, .external_lex_state = 7},
  [685] = {.lex_state = 78, .external_lex_state = 7},
  [686] = {.lex_state = 78, .external_lex_state = 7},
  [687] = {.lex_state = 78, .external_lex_state = 7},
  [688] = {.lex_state = 78, .external_lex_state = 2},
  [689] = {.lex_state = 78, .external_lex_state = 2},
  [690] = {.lex_state = 78, .external_lex_state = 2},
  [691] = {.lex_state = 78, .external_lex_state = 14},
  [692] = {.lex_state = 78, .external_lex_state = 14},
  [693] = {.lex_state = 78, .external_lex_state = 2},
  [694] = {.lex_state = 78, .external_lex_state = 2},
  [695] = {.lex_state = 78, .external_lex_state = 2},
  [696] = {.lex_state = 78, .external_lex_state = 2},
  [697] = {.lex_state = 78, .external_lex_state = 16},
  [698] = {.lex_state = 78, .external_lex_state = 2},
  [699] = {.lex_state = 78, .external_lex_state = 2},
  [700] = {.lex_state = 78, .external_lex_state = 2},
  [701] = {.lex_state = 78, .external_lex_state = 2},
  [702] = {.lex_state = 78, .external_lex_state = 2},
  [703] = {.lex_state = 78, .external_lex_state = 14},
  [704] = {.lex_state = 78, .external_lex_state = 7},
  [705] = {.lex_state = 78, .external_lex_state = 2},
  [706] = {.lex_state = 78, .external_lex_state = 2},
  [707] = {.lex_state = 78, .external_lex_state = 7},
  [708] = {.lex_state = 78, .external_lex_state = 2},
  [709] = {.lex_state = 78, .external_lex_state = 7},
  [710] = {.lex_state = 78, .external_lex_state = 14},
  [711] = {.lex_state = 78, .external_lex_state = 2},
  [712] = {.lex_state = 78, .external_lex_state = 2},
  [713] = {.lex_state = 78, .external_lex_state = 7},
  [714] = {.lex_state = 78, .external_lex_state = 10},
  [715] = {.lex_state = 78, .external_lex_state = 10},
  [716] = {.lex_state = 78, .external_lex_state = 10},
  [717] = {.lex_state = 78, .external_lex_state = 2},
  [718] = {.lex_state = 78, .external_lex_state = 14},
  [719] = {.lex_state = 78, .external_lex_state = 10},
  [720] = {.lex_state = 78, .external_lex_state = 10},
  [721] = {.lex_state = 78, .external_lex_state = 2},
  [722] = {.lex_state = 78, .external_lex_state = 2},
  [723] = {.lex_state = 78, .external_lex_state = 10},
  [724] = {.lex_state = 78, .external_lex_state = 14},
  [725] = {.lex_state = 78, .external_lex_state = 10},
  [726] = {.lex_state = 78, .external_lex_state = 10},
  [727] = {.lex_state = 78, .external_lex_state = 2},
  [728] = {.lex_state = 78, .external_lex_state = 7},
  [729] = {.lex_state = 78, .external_lex_state = 10},
  [730] = {.lex_state = 78, .external_lex_state = 15},
  [731] = {.lex_state = 78, .external_lex_state = 15},
  [732] = {.lex_state = 78, .external_lex_state = 15},
  [733] = {.lex_state = 78, .external_lex_state = 15},
  [734] = {.lex_state = 78, .external_lex_state = 15},
  [735] = {.lex_state = 78, .external_lex_state = 15},
  [736] = {.lex_state = 78, .external_lex_state = 15},
  [737] = {.lex_state = 78, .external_lex_state = 15},
  [738] = {.lex_state = 78, .external_lex_state = 15},
  [739] = {.lex_state = 78, .external_lex_state = 15},
  [740] = {.lex_state = 78, .external_lex_state = 15},
  [741] = {.lex_state = 78, .external_lex_state = 15},
  [742] = {.lex_state = 78, .external_lex_state = 15},
  [743] = {.lex_state = 78, .external_lex_state = 15},
  [744] = {.lex_state = 78, .external_lex_state = 15},
  [745] = {.lex_state = 78, .external_lex_state = 15},
  [746] = {.lex_state = 78, .external_lex_state = 15},
  [747] = {.lex_state = 78, .external_lex_state = 15},
  [748] = {.lex_state = 78, .external_lex_state = 15},
  [749] = {.lex_state = 78, .external_lex_state = 15},
  [750] = {.lex_state = 78, .external_lex_state = 15},
  [751] = {.lex_state = 78, .external_lex_state = 15},
  [752] = {.lex_state = 78, .external_lex_state = 15},
  [753] = {.lex_state = 78, .external_lex_state = 2},
  [754] = {.lex_state = 78, .external_lex_state = 15},
  [755] = {.lex_state = 78, .external_lex_state = 15},
  [756] = {.lex_state = 78, .external_lex_state = 15},
  [757] = {.lex_state = 78, .external_lex_state = 15},
  [758] = {.lex_state = 78, .external_lex_state = 15},
  [759] = {.lex_state = 78, .external_lex_state = 15},
  [760] = {.lex_state = 78, .external_lex_state = 15},
  [761] = {.lex_state = 78, .external_lex_state = 15},
  [762] = {.lex_state = 78, .external_lex_state = 15},
  [763] = {.lex_state = 78, .external_lex_state = 10},
  [764] = {.lex_state = 78, .external_lex_state = 15},
  [765] = {.lex_state = 78, .external_lex_state = 15},
  [766] = {.lex_state = 78, .external_lex_state = 15},
  [767] = {.lex_state = 78, .external_lex_state = 15},
  [768] = {.lex_state = 78, .external_lex_state = 15},
  [769] = {.lex_state = 78, .external_lex_state = 15},
  [770] = {.lex_state = 78, .external_lex_state = 15},
  [771] = {.lex_state = 78, .external_lex_state = 15},
  [772] = {.lex_state = 78, .external_lex_state = 15},
  [773] = {.lex_state = 78, .external_lex_state = 15},
  [774] = {.lex_state = 78, .external_lex_state = 15},
  [775] = {.lex_state = 78, .external_lex_state = 15},
  [776] = {.lex_state = 78, .external_lex_state = 15},
  [777] = {.lex_state = 78, .external_lex_state = 15},
  [778] = {.lex_state = 78, .external_lex_state = 2},
  [779] = {.lex_state = 78, .external_lex_state = 7},
  [780] = {.lex_state = 78, .external_lex_state = 15},
  [781] = {.lex_state = 78, .external_lex_state = 2},
  [782] = {.lex_state = 78, .external_lex_state = 15},
  [783] = {.lex_state = 78, .external_lex_state = 2},
  [784] = {.lex_state = 78, .external_lex_state = 2},
  [785] = {.lex_state = 78, .external_lex_state = 15},
  [786] = {.lex_state = 78, .external_lex_state = 15},
  [787] = {.lex_state = 78, .external_lex_state = 15},
  [788] = {.lex_state = 78, .external_lex_state = 15},
  [789] = {.lex_state = 78, .external_lex_state = 15},
  [790] = {.lex_state = 78, .external_lex_state = 15},
  [791] = {.lex_state = 78, .external_lex_state = 2},
  [792] = {.lex_state = 78, .external_lex_state = 15},
  [793] = {.lex_state = 78, .external_lex_state = 15},
  [794] = {.lex_state = 78, .external_lex_state = 15},
  [795] = {.lex_state = 78, .external_lex_state = 15},
  [796] = {.lex_state = 78, .external_lex_state = 15},
  [797] = {.lex_state = 78, .external_lex_state = 15},
  [798] = {.lex_state = 78, .external_lex_state = 15},
  [799] = {.lex_state = 78, .external_lex_state = 15},
  [800] = {.lex_state = 78, .external_lex_state = 15},
  [801] = {.lex_state = 78, .external_lex_state = 15},
  [802] = {.lex_state = 78, .external_lex_state = 15},
  [803] = {.lex_state = 78, .external_lex_state = 15},
  [804] = {.lex_state = 78, .external_lex_state = 15},
  [805] = {.lex_state = 78, .external_lex_state = 15},
  [806] = {.lex_state = 78, .external_lex_state = 15},
  [807] = {.lex_state = 78, .external_lex_state = 15},
  [808] = {.lex_state = 78, .external_lex_state = 15},
  [809] = {.lex_state = 78, .external_lex_state = 15},
  [810] = {.lex_state = 78, .external_lex_state = 15},
  [811] = {.lex_state = 78, .external_lex_state = 15},
  [812] = {.lex_state = 78, .external_lex_state = 15},
  [813] = {.lex_state = 78, .external_lex_state = 15},
  [814] = {.lex_state = 78, .external_lex_state = 15},
  [815] = {.lex_state = 78, .external_lex_state = 2},
  [816] = {.lex_state = 78, .external_lex_state = 2},
  [817] = {.lex_state = 78, .external_lex_state = 2},
  [818] = {.lex_state = 78, .external_lex_state = 2},
  [819] = {.lex_state = 78, .external_lex_state = 2},
  [820] = {.lex_state = 78, .external_lex_state = 2},
  [821] = {.lex_state = 78, .external_lex_state = 2},
  [822] = {.lex_state = 78, .external_lex_state = 2},
  [823] = {.lex_state = 78, .external_lex_state = 2},
  [824] = {.lex_state = 78, .external_lex_state = 2},
  [825] = {.lex_state = 78, .external_lex_state = 2},
  [826] = {.lex_state = 78, .external_lex_state = 2},
  [827] = {.lex_state = 78, .external_lex_state = 2},
  [828] = {.lex_state = 78, .external_lex_state = 2},
  [829] = {.lex_state = 78, .external_lex_state = 2},
  [830] = {.lex_state = 78, .external_lex_state = 2},
  [831] = {.lex_state = 78, .external_lex_state = 2},
  [832] = {.lex_state = 78, .external_lex_state = 2},
  [833] = {.lex_state = 78, .external_lex_state = 2},
  [834] = {.lex_state = 78, .external_lex_state = 2},
  [835] = {.lex_state = 78, .external_lex_state = 2},
  [836] = {.lex_state = 78, .external_lex_state = 2},
  [837] = {.lex_state = 78, .external_lex_state = 2},
  [838] = {.lex_state = 78, .external_lex_state = 2},
  [839] = {.lex_state = 78, .external_lex_state = 2},
  [840] = {.lex_state = 78, .external_lex_state = 2},
  [841] = {.lex_state = 78, .external_lex_state = 2},
  [842] = {.lex_state = 78, .external_lex_state = 2},
  [843] = {.lex_state = 78, .external_lex_state = 2},
  [844] = {.lex_state = 78, .external_lex_state = 2},
  [845] = {.lex_state = 78, .external_lex_state = 2},
  [846] = {.lex_state = 78, .external_lex_state = 2},
  [847] = {.lex_state = 78, .external_lex_state = 2},
  [848] = {.lex_state = 78, .external_lex_state = 2},
  [849] = {.lex_state = 78, .external_lex_state = 2},
  [850] = {.lex_state = 78, .external_lex_state = 2},
  [851] = {.lex_state = 78, .external_lex_state = 2},
  [852] = {.lex_state = 78, .external_lex_state = 2},
  [853] = {.lex_state = 78, .external_lex_state = 2},
  [854] = {.lex_state = 78, .external_lex_state = 2},
  [855] = {.lex_state = 78, .external_lex_state = 2},
  [856] = {.lex_state = 78, .external_lex_state = 2},
  [857] = {.lex_state = 78, .external_lex_state = 2},
  [858] = {.lex_state = 78, .external_lex_state = 2},
  [859] = {.lex_state = 78, .external_lex_state = 2},
  [860] = {.lex_state = 78, .external_lex_state = 2},
  [861] = {.lex_state = 78, .external_lex_state = 2},
  [862] = {.lex_state = 78, .external_lex_state = 2},
  [863] = {.lex_state = 78, .external_lex_state = 2},
  [864] = {.lex_state = 78, .external_lex_state = 2},
  [865] = {.lex_state = 78, .external_lex_state = 2},
  [866] = {.lex_state = 78, .external_lex_state = 2},
  [867] = {.lex_state = 78, .external_lex_state = 2},
  [868] = {.lex_state = 78, .external_lex_state = 2},
  [869] = {.lex_state = 78, .external_lex_state = 2},
  [870] = {.lex_state = 78, .external_lex_state = 2},
  [871] = {.lex_state = 78, .external_lex_state = 2},
  [872] = {.lex_state = 78, .external_lex_state = 2},
  [873] = {.lex_state = 78, .external_lex_state = 2},
  [874] = {.lex_state = 78, .external_lex_state = 2},
  [875] = {.lex_state = 78, .external_lex_state = 2},
  [876] = {.lex_state = 78, .external_lex_state = 2},
  [877] = {.lex_state = 78, .external_lex_state = 2},
  [878] = {.lex_state = 78, .external_lex_state = 2},
  [879] = {.lex_state = 78, .external_lex_state = 2},
  [880] = {.lex_state = 78, .external_lex_state = 2},
  [881] = {.lex_state = 78, .external_lex_state = 2},
  [882] = {.lex_state = 78, .external_lex_state = 2},
  [883] = {.lex_state = 78, .external_lex_state = 2},
  [884] = {.lex_state = 78, .external_lex_state = 2},
  [885] = {.lex_state = 78, .external_lex_state = 2},
  [886] = {.lex_state = 78, .external_lex_state = 2},
  [887] = {.lex_state = 78, .external_lex_state = 2},
  [888] = {.lex_state = 78, .external_lex_state = 2},
  [889] = {.lex_state = 78, .external_lex_state = 2},
  [890] = {.lex_state = 78, .external_lex_state = 2},
  [891] = {.lex_state = 78, .external_lex_state = 2},
  [892] = {.lex_state = 78, .external_lex_state = 2},
  [893] = {.lex_state = 78, .external_lex_state = 2},
  [894] = {.lex_state = 78, .external_lex_state = 2},
  [895] = {.lex_state = 78, .external_lex_state = 2},
  [896] = {.lex_state = 78, .external_lex_state = 2},
  [897] = {.lex_state = 78, .external_lex_state = 2},
  [898] = {.lex_state = 78, .external_lex_state = 2},
  [899] = {.lex_state = 78, .external_lex_state = 2},
  [900] = {.lex_state = 78, .external_lex_state = 2},
  [901] = {.lex_state = 78, .external_lex_state = 2},
  [902] = {.lex_state = 78, .external_lex_state = 2},
  [903] = {.lex_state = 78, .external_lex_state = 2},
  [904] = {.lex_state = 78, .external_lex_state = 2},
  [905] = {.lex_state = 78, .external_lex_state = 2},
  [906] = {.lex_state = 78, .external_lex_state = 2},
  [907] = {.lex_state = 78, .external_lex_state = 2},
  [908] = {.lex_state = 78, .external_lex_state = 2},
  [909] = {.lex_state = 78, .external_lex_state = 2},
  [910] = {.lex_state = 78, .external_lex_state = 2},
  [911] = {.lex_state = 78, .external_lex_state = 2},
  [912] = {.lex_state = 78, .external_lex_state = 2},
  [913] = {.lex_state = 78, .external_lex_state = 2},
  [914] = {.lex_state = 78, .external_lex_state = 2},
  [915] = {.lex_state = 78, .external_lex_state = 2},
  [916] = {.lex_state = 78, .external_lex_state = 2},
  [917] = {.lex_state = 78, .external_lex_state = 2},
  [918] = {.lex_state = 78, .external_lex_state = 2},
  [919] = {.lex_state = 78, .external_lex_state = 2},
  [920] = {.lex_state = 78, .external_lex_state = 2},
  [921] = {.lex_state = 78, .external_lex_state = 2},
  [922] = {.lex_state = 78, .external_lex_state = 2},
  [923] = {.lex_state = 78, .external_lex_state = 2},
  [924] = {.lex_state = 78, .external_lex_state = 2},
  [925] = {.lex_state = 78, .external_lex_state = 2},
  [926] = {.lex_state = 78, .external_lex_state = 2},
  [927] = {.lex_state = 78, .external_lex_state = 2},
  [928] = {.lex_state = 78, .external_lex_state = 2},
  [929] = {.lex_state = 78, .external_lex_state = 2},
  [930] = {.lex_state = 78, .external_lex_state = 2},
  [931] = {.lex_state = 78, .external_lex_state = 2},
  [932] = {.lex_state = 78, .external_lex_state = 2},
  [933] = {.lex_state = 78, .external_lex_state = 2},
  [934] = {.lex_state = 78, .external_lex_state = 2},
  [935] = {.lex_state = 78, .external_lex_state = 2},
  [936] = {.lex_state = 78, .external_lex_state = 2},
  [937] = {.lex_state = 78, .external_lex_state = 2},
  [938] = {.lex_state = 78, .external_lex_state = 2},
  [939] = {.lex_state = 78, .external_lex_state = 2},
  [940] = {.lex_state = 78, .external_lex_state = 2},
  [941] = {.lex_state = 78, .external_lex_state = 2},
  [942] = {.lex_state = 78, .external_lex_state = 2},
  [943] = {.lex_state = 78, .external_lex_state = 2},
  [944] = {.lex_state = 78, .external_lex_state = 2},
  [945] = {.lex_state = 78, .external_lex_state = 2},
  [946] = {.lex_state = 78, .external_lex_state = 2},
  [947] = {.lex_state = 78, .external_lex_state = 2},
  [948] = {.lex_state = 78, .external_lex_state = 2},
  [949] = {.lex_state = 78, .external_lex_state = 2},
  [950] = {.lex_state = 78, .external_lex_state = 2},
  [951] = {.lex_state = 78, .external_lex_state = 2},
  [952] = {.lex_state = 78, .external_lex_state = 2},
  [953] = {.lex_state = 78, .external_lex_state = 2},
  [954] = {.lex_state = 78, .external_lex_state = 2},
  [955] = {.lex_state = 78, .external_lex_state = 2},
  [956] = {.lex_state = 78, .external_lex_state = 2},
  [957] = {.lex_state = 78, .external_lex_state = 2},
  [958] = {.lex_state = 78, .external_lex_state = 2},
  [959] = {.lex_state = 78, .external_lex_state = 2},
  [960] = {.lex_state = 78, .external_lex_state = 2},
  [961] = {.lex_state = 78, .external_lex_state = 2},
  [962] = {.lex_state = 78, .external_lex_state = 2},
  [963] = {.lex_state = 78, .external_lex_state = 2},
  [964] = {.lex_state = 78, .external_lex_state = 2},
  [965] = {.lex_state = 78, .external_lex_state = 2},
  [966] = {.lex_state = 78, .external_lex_state = 2},
  [967] = {.lex_state = 78, .external_lex_state = 2},
  [968] = {.lex_state = 78, .external_lex_state = 2},
  [969] = {.lex_state = 78, .external_lex_state = 2},
  [970] = {.lex_state = 78, .external_lex_state = 2},
  [971] = {.lex_state = 78, .external_lex_state = 2},
  [972] = {.lex_state = 78, .external_lex_state = 2},
  [973] = {.lex_state = 78, .external_lex_state = 2},
  [974] = {.lex_state = 78, .external_lex_state = 2},
  [975] = {.lex_state = 78, .external_lex_state = 2},
  [976] = {.lex_state = 78, .external_lex_state = 2},
  [977] = {.lex_state = 78, .external_lex_state = 2},
  [978] = {.lex_state = 78, .external_lex_state = 2},
  [979] = {.lex_state = 78, .external_lex_state = 2},
  [980] = {.lex_state = 78, .external_lex_state = 2},
  [981] = {.lex_state = 67, .external_lex_state = 3},
  [982] = {.lex_state = 78, .external_lex_state = 2},
  [983] = {.lex_state = 78, .external_lex_state = 2},
  [984] = {.lex_state = 78, .external_lex_state = 2},
  [985] = {.lex_state = 78, .external_lex_state = 2},
  [986] = {.lex_state = 78, .external_lex_state = 2},
  [987] = {.lex_state = 78, .external_lex_state = 2},
  [988] = {.lex_state = 78, .external_lex_state = 2},
  [989] = {.lex_state = 78, .external_lex_state = 2},
  [990] = {.lex_state = 78, .external_lex_state = 2},
  [991] = {.lex_state = 78, .external_lex_state = 2},
  [992] = {.lex_state = 78, .external_lex_state = 2},
  [993] = {.lex_state = 78, .external_lex_state = 2},
  [994] = {.lex_state = 78, .external_lex_state = 2},
  [995] = {.lex_state = 78, .external_lex_state = 2},
  [996] = {.lex_state = 78, .external_lex_state = 2},
  [997] = {.lex_state = 78, .external_lex_state = 2},
  [998] = {.lex_state = 78, .external_lex_state = 2},
  [999] = {.lex_state = 78, .external_lex_state = 2},
  [1000] = {.lex_state = 78, .external_lex_state = 2},
  [1001] = {.lex_state = 78, .external_lex_state = 2},
  [1002] = {.lex_state = 78, .external_lex_state = 2},
  [1003] = {.lex_state = 78, .external_lex_state = 2},
  [1004] = {.lex_state = 78, .external_lex_state = 2},
  [1005] = {.lex_state = 78, .external_lex_state = 2},
  [1006] = {.lex_state = 78, .external_lex_state = 2},
  [1007] = {.lex_state = 78, .external_lex_state = 2},
  [1008] = {.lex_state = 78, .external_lex_state = 2},
  [1009] = {.lex_state = 78, .external_lex_state = 2},
  [1010] = {.lex_state = 78, .external_lex_state = 2},
  [1011] = {.lex_state = 78, .external_lex_state = 2},
  [1012] = {.lex_state = 78, .external_lex_state = 2},
  [1013] = {.lex_state = 78, .external_lex_state = 2},
  [1014] = {.lex_state = 78, .external_lex_state = 2},
  [1015] = {.lex_state = 78, .external_lex_state = 2},
  [1016] = {.lex_state = 78, .external_lex_state = 2},
  [1017] = {.lex_state = 78, .external_lex_state = 2},
  [1018] = {.lex_state = 78, .external_lex_state = 2},
  [1019] = {.lex_state = 78, .external_lex_state = 2},
  [1020] = {.lex_state = 78, .external_lex_state = 2},
  [1021] = {.lex_state = 78, .external_lex_state = 2},
  [1022] = {.lex_state = 78, .external_lex_state = 2},
  [1023] = {.lex_state = 78, .external_lex_state = 2},
  [1024] = {.lex_state = 78, .external_lex_state = 2},
  [1025] = {.lex_state = 78, .external_lex_state = 2},
  [1026] = {.lex_state = 78, .external_lex_state = 2},
  [1027] = {.lex_state = 78, .external_lex_state = 2},
  [1028] = {.lex_state = 78, .external_lex_state = 2},
  [1029] = {.lex_state = 78, .external_lex_state = 2},
  [1030] = {.lex_state = 78, .external_lex_state = 2},
  [1031] = {.lex_state = 78, .external_lex_state = 2},
  [1032] = {.lex_state = 78, .external_lex_state = 2},
  [1033] = {.lex_state = 78, .external_lex_state = 2},
  [1034] = {.lex_state = 78, .external_lex_state = 2},
  [1035] = {.lex_state = 78, .external_lex_state = 2},
  [1036] = {.lex_state = 78, .external_lex_state = 2},
  [1037] = {.lex_state = 78, .external_lex_state = 2},
  [1038] = {.lex_state = 78, .external_lex_state = 2},
  [1039] = {.lex_state = 78, .external_lex_state = 2},
  [1040] = {.lex_state = 78, .external_lex_state = 2},
  [1041] = {.lex_state = 78, .external_lex_state = 2},
  [1042] = {.lex_state = 78, .external_lex_state = 2},
  [1043] = {.lex_state = 78, .external_lex_state = 2},
  [1044] = {.lex_state = 78, .external_lex_state = 2},
  [1045] = {.lex_state = 78, .external_lex_state = 2},
  [1046] = {.lex_state = 78, .external_lex_state = 2},
  [1047] = {.lex_state = 78, .external_lex_state = 2},
  [1048] = {.lex_state = 78, .external_lex_state = 2},
  [1049] = {.lex_state = 78, .external_lex_state = 2},
  [1050] = {.lex_state = 78, .external_lex_state = 2},
  [1051] = {.lex_state = 78, .external_lex_state = 2},
  [1052] = {.lex_state = 78, .external_lex_state = 2},
  [1053] = {.lex_state = 78, .external_lex_state = 2},
  [1054] = {.lex_state = 78, .external_lex_state = 2},
  [1055] = {.lex_state = 78, .external_lex_state = 2},
  [1056] = {.lex_state = 78, .external_lex_state = 2},
  [1057] = {.lex_state = 78, .external_lex_state = 2},
  [1058] = {.lex_state = 78, .external_lex_state = 2},
  [1059] = {.lex_state = 78, .external_lex_state = 2},
  [1060] = {.lex_state = 78, .external_lex_state = 2},
  [1061] = {.lex_state = 78, .external_lex_state = 2},
  [1062] = {.lex_state = 78, .external_lex_state = 2},
  [1063] = {.lex_state = 78, .external_lex_state = 2},
  [1064] = {.lex_state = 78, .external_lex_state = 2},
  [1065] = {.lex_state = 78, .external_lex_state = 2},
  [1066] = {.lex_state = 78, .external_lex_state = 2},
  [1067] = {.lex_state = 78, .external_lex_state = 2},
  [1068] = {.lex_state = 78, .external_lex_state = 2},
  [1069] = {.lex_state = 78, .external_lex_state = 2},
  [1070] = {.lex_state = 78, .external_lex_state = 2},
  [1071] = {.lex_state = 78, .external_lex_state = 2},
  [1072] = {.lex_state = 78, .external_lex_state = 2},
  [1073] = {.lex_state = 78, .external_lex_state = 2},
  [1074] = {.lex_state = 78, .external_lex_state = 2},
  [1075] = {.lex_state = 78, .external_lex_state = 2},
  [1076] = {.lex_state = 78, .external_lex_state = 2},
  [1077] = {.lex_state = 78, .external_lex_state = 2},
  [1078] = {.lex_state = 78, .external_lex_state = 2},
  [1079] = {.lex_state = 78, .external_lex_state = 2},
  [1080] = {.lex_state = 78, .external_lex_state = 2},
  [1081] = {.lex_state = 78, .external_lex_state = 2},
  [1082] = {.lex_state = 78, .external_lex_state = 2},
  [1083] = {.lex_state = 78, .external_lex_state = 2},
  [1084] = {.lex_state = 78, .external_lex_state = 2},
  [1085] = {.lex_state = 78, .external_lex_state = 2},
  [1086] = {.lex_state = 78, .external_lex_state = 2},
  [1087] = {.lex_state = 78, .external_lex_state = 2},
  [1088] = {.lex_state = 78, .external_lex_state = 2},
  [1089] = {.lex_state = 78, .external_lex_state = 2},
  [1090] = {.lex_state = 78, .external_lex_state = 2},
  [1091] = {.lex_state = 78, .external_lex_state = 2},
  [1092] = {.lex_state = 78, .external_lex_state = 2},
  [1093] = {.lex_state = 78, .external_lex_state = 2},
  [1094] = {.lex_state = 78, .external_lex_state = 2},
  [1095] = {.lex_state = 78, .external_lex_state = 2},
  [1096] = {.lex_state = 78, .external_lex_state = 2},
  [1097] = {.lex_state = 78, .external_lex_state = 2},
  [1098] = {.lex_state = 78, .external_lex_state = 2},
  [1099] = {.lex_state = 78, .external_lex_state = 2},
  [1100] = {.lex_state = 78, .external_lex_state = 2},
  [1101] = {.lex_state = 78, .external_lex_state = 2},
  [1102] = {.lex_state = 78, .external_lex_state = 2},
  [1103] = {.lex_state = 78, .external_lex_state = 2},
  [1104] = {.lex_state = 78, .external_lex_state = 2},
  [1105] = {.lex_state = 78, .external_lex_state = 2},
  [1106] = {.lex_state = 78, .external_lex_state = 2},
  [1107] = {.lex_state = 78, .external_lex_state = 2},
  [1108] = {.lex_state = 78, .external_lex_state = 2},
  [1109] = {.lex_state = 78, .external_lex_state = 2},
  [1110] = {.lex_state = 78, .external_lex_state = 2},
  [1111] = {.lex_state = 78, .external_lex_state = 2},
  [1112] = {.lex_state = 78, .external_lex_state = 2},
  [1113] = {.lex_state = 78, .external_lex_state = 2},
  [1114] = {.lex_state = 78, .external_lex_state = 2},
  [1115] = {.lex_state = 78, .external_lex_state = 2},
  [1116] = {.lex_state = 78, .external_lex_state = 2},
  [1117] = {.lex_state = 78, .external_lex_state = 2},
  [1118] = {.lex_state = 78, .external_lex_state = 2},
  [1119] = {.lex_state = 78, .external_lex_state = 2},
  [1120] = {.lex_state = 78, .external_lex_state = 2},
  [1121] = {.lex_state = 78, .external_lex_state = 2},
  [1122] = {.lex_state = 78, .external_lex_state = 2},
  [1123] = {.lex_state = 78, .external_lex_state = 2},
  [1124] = {.lex_state = 78, .external_lex_state = 2},
  [1125] = {.lex_state = 78, .external_lex_state = 2},
  [1126] = {.lex_state = 78, .external_lex_state = 2},
  [1127] = {.lex_state = 78, .external_lex_state = 2},
  [1128] = {.lex_state = 78, .external_lex_state = 2},
  [1129] = {.lex_state = 78, .external_lex_state = 2},
  [1130] = {.lex_state = 78, .external_lex_state = 2},
  [1131] = {.lex_state = 78, .external_lex_state = 2},
  [1132] = {.lex_state = 78, .external_lex_state = 2},
  [1133] = {.lex_state = 78, .external_lex_state = 2},
  [1134] = {.lex_state = 78, .external_lex_state = 2},
  [1135] = {.lex_state = 78, .external_lex_state = 2},
  [1136] = {.lex_state = 78, .external_lex_state = 2},
  [1137] = {.lex_state = 78, .external_lex_state = 2},
  [1138] = {.lex_state = 78, .external_lex_state = 2},
  [1139] = {.lex_state = 78, .external_lex_state = 2},
  [1140] = {.lex_state = 78, .external_lex_state = 2},
  [1141] = {.lex_state = 78, .external_lex_state = 2},
  [1142] = {.lex_state = 78, .external_lex_state = 2},
  [1143] = {.lex_state = 78, .external_lex_state = 2},
  [1144] = {.lex_state = 78, .external_lex_state = 2},
  [1145] = {.lex_state = 78, .external_lex_state = 2},
  [1146] = {.lex_state = 78, .external_lex_state = 2},
  [1147] = {.lex_state = 78, .external_lex_state = 2},
  [1148] = {.lex_state = 78, .external_lex_state = 2},
  [1149] = {.lex_state = 78, .external_lex_state = 2},
  [1150] = {.lex_state = 78, .external_lex_state = 2},
  [1151] = {.lex_state = 78, .external_lex_state = 2},
  [1152] = {.lex_state = 78, .external_lex_state = 2},
  [1153] = {.lex_state = 78, .external_lex_state = 2},
  [1154] = {.lex_state = 78, .external_lex_state = 2},
  [1155] = {.lex_state = 78, .external_lex_state = 2},
  [1156] = {.lex_state = 78, .external_lex_state = 2},
  [1157] = {.lex_state = 78, .external_lex_state = 2},
  [1158] = {.lex_state = 78, .external_lex_state = 2},
  [1159] = {.lex_state = 78, .external_lex_state = 2},
  [1160] = {.lex_state = 78, .external_lex_state = 2},
  [1161] = {.lex_state = 78, .external_lex_state = 2},
  [1162] = {.lex_state = 78, .external_lex_state = 2},
  [1163] = {.lex_state = 78, .external_lex_state = 2},
  [1164] = {.lex_state = 78, .external_lex_state = 2},
  [1165] = {.lex_state = 78, .external_lex_state = 2},
  [1166] = {.lex_state = 78, .external_lex_state = 2},
  [1167] = {.lex_state = 78, .external_lex_state = 2},
  [1168] = {.lex_state = 78, .external_lex_state = 2},
  [1169] = {.lex_state = 78, .external_lex_state = 2},
  [1170] = {.lex_state = 78, .external_lex_state = 2},
  [1171] = {.lex_state = 78, .external_lex_state = 2},
  [1172] = {.lex_state = 78, .external_lex_state = 2},
  [1173] = {.lex_state = 78, .external_lex_state = 2},
  [1174] = {.lex_state = 78, .external_lex_state = 2},
  [1175] = {.lex_state = 78, .external_lex_state = 2},
  [1176] = {.lex_state = 78, .external_lex_state = 2},
  [1177] = {.lex_state = 78, .external_lex_state = 2},
  [1178] = {.lex_state = 78, .external_lex_state = 2},
  [1179] = {.lex_state = 78, .external_lex_state = 2},
  [1180] = {.lex_state = 78, .external_lex_state = 2},
  [1181] = {.lex_state = 78, .external_lex_state = 2},
  [1182] = {.lex_state = 78, .external_lex_state = 2},
  [1183] = {.lex_state = 78, .external_lex_state = 2},
  [1184] = {.lex_state = 78, .external_lex_state = 2},
  [1185] = {.lex_state = 78, .external_lex_state = 2},
  [1186] = {.lex_state = 78, .external_lex_state = 2},
  [1187] = {.lex_state = 78, .external_lex_state = 2},
  [1188] = {.lex_state = 78, .external_lex_state = 2},
  [1189] = {.lex_state = 78, .external_lex_state = 2},
  [1190] = {.lex_state = 78, .external_lex_state = 2},
  [1191] = {.lex_state = 78, .external_lex_state = 2},
  [1192] = {.lex_state = 78, .external_lex_state = 2},
  [1193] = {.lex_state = 78, .external_lex_state = 2},
  [1194] = {.lex_state = 78, .external_lex_state = 2},
  [1195] = {.lex_state = 78, .external_lex_state = 2},
  [1196] = {.lex_state = 78, .external_lex_state = 2},
  [1197] = {.lex_state = 78, .external_lex_state = 2},
  [1198] = {.lex_state = 78, .external_lex_state = 2},
  [1199] = {.lex_state = 78, .external_lex_state = 2},
  [1200] = {.lex_state = 78, .external_lex_state = 2},
  [1201] = {.lex_state = 78, .external_lex_state = 2},
  [1202] = {.lex_state = 78, .external_lex_state = 2},
  [1203] = {.lex_state = 78, .external_lex_state = 2},
  [1204] = {.lex_state = 78, .external_lex_state = 2},
  [1205] = {.lex_state = 78, .external_lex_state = 2},
  [1206] = {.lex_state = 78, .external_lex_state = 2},
  [1207] = {.lex_state = 78, .external_lex_state = 2},
  [1208] = {.lex_state = 78, .external_lex_state = 2},
  [1209] = {.lex_state = 78, .external_lex_state = 2},
  [1210] = {.lex_state = 78, .external_lex_state = 2},
  [1211] = {.lex_state = 78, .external_lex_state = 2},
  [1212] = {.lex_state = 78, .external_lex_state = 2},
  [1213] = {.lex_state = 78, .external_lex_state = 2},
  [1214] = {.lex_state = 78, .external_lex_state = 2},
  [1215] = {.lex_state = 78, .external_lex_state = 2},
  [1216] = {.lex_state = 78, .external_lex_state = 2},
  [1217] = {.lex_state = 78, .external_lex_state = 2},
  [1218] = {.lex_state = 78, .external_lex_state = 2},
  [1219] = {.lex_state = 78, .external_lex_state = 2},
  [1220] = {.lex_state = 78, .external_lex_state = 2},
  [1221] = {.lex_state = 78, .external_lex_state = 2},
  [1222] = {.lex_state = 78, .external_lex_state = 2},
  [1223] = {.lex_state = 78, .external_lex_state = 2},
  [1224] = {.lex_state = 78, .external_lex_state = 2},
  [1225] = {.lex_state = 78, .external_lex_state = 2},
  [1226] = {.lex_state = 78, .external_lex_state = 2},
  [1227] = {.lex_state = 78, .external_lex_state = 2},
  [1228] = {.lex_state = 78, .external_lex_state = 2},
  [1229] = {.lex_state = 78, .external_lex_state = 2},
  [1230] = {.lex_state = 78, .external_lex_state = 2},
  [1231] = {.lex_state = 78, .external_lex_state = 2},
  [1232] = {.lex_state = 78, .external_lex_state = 2},
  [1233] = {.lex_state = 78, .external_lex_state = 2},
  [1234] = {.lex_state = 78, .external_lex_state = 2},
  [1235] = {.lex_state = 78, .external_lex_state = 2},
  [1236] = {.lex_state = 78, .external_lex_state = 2},
  [1237] = {.lex_state = 78, .external_lex_state = 2},
  [1238] = {.lex_state = 78, .external_lex_state = 2},
  [1239] = {.lex_state = 78, .external_lex_state = 2},
  [1240] = {.lex_state = 78, .external_lex_state = 2},
  [1241] = {.lex_state = 78, .external_lex_state = 2},
  [1242] = {.lex_state = 78, .external_lex_state = 2},
  [1243] = {.lex_state = 78, .external_lex_state = 2},
  [1244] = {.lex_state = 78, .external_lex_state = 2},
  [1245] = {.lex_state = 78, .external_lex_state = 2},
  [1246] = {.lex_state = 78, .external_lex_state = 2},
  [1247] = {.lex_state = 78, .external_lex_state = 2},
  [1248] = {.lex_state = 78, .external_lex_state = 2},
  [1249] = {.lex_state = 78, .external_lex_state = 2},
  [1250] = {.lex_state = 78, .external_lex_state = 2},
  [1251] = {.lex_state = 78, .external_lex_state = 2},
  [1252] = {.lex_state = 78, .external_lex_state = 2},
  [1253] = {.lex_state = 78, .external_lex_state = 2},
  [1254] = {.lex_state = 78, .external_lex_state = 2},
  [1255] = {.lex_state = 78, .external_lex_state = 2},
  [1256] = {.lex_state = 78, .external_lex_state = 2},
  [1257] = {.lex_state = 78, .external_lex_state = 2},
  [1258] = {.lex_state = 78, .external_lex_state = 2},
  [1259] = {.lex_state = 78, .external_lex_state = 2},
  [1260] = {.lex_state = 78, .external_lex_state = 2},
  [1261] = {.lex_state = 78, .external_lex_state = 2},
  [1262] = {.lex_state = 78, .external_lex_state = 2},
  [1263] = {.lex_state = 78, .external_lex_state = 2},
  [1264] = {.lex_state = 78, .external_lex_state = 2},
  [1265] = {.lex_state = 78, .external_lex_state = 2},
  [1266] = {.lex_state = 78, .external_lex_state = 2},
  [1267] = {.lex_state = 78, .external_lex_state = 2},
  [1268] = {.lex_state = 78, .external_lex_state = 2},
  [1269] = {.lex_state = 78, .external_lex_state = 2},
  [1270] = {.lex_state = 78, .external_lex_state = 2},
  [1271] = {.lex_state = 78, .external_lex_state = 2},
  [1272] = {.lex_state = 78, .external_lex_state = 2},
  [1273] = {.lex_state = 78, .external_lex_state = 2},
  [1274] = {.lex_state = 78, .external_lex_state = 2},
  [1275] = {.lex_state = 78, .external_lex_state = 2},
  [1276] = {.lex_state = 78, .external_lex_state = 2},
  [1277] = {.lex_state = 78, .external_lex_state = 2},
  [1278] = {.lex_state = 78, .external_lex_state = 2},
  [1279] = {.lex_state = 78, .external_lex_state = 2},
  [1280] = {.lex_state = 78, .external_lex_state = 2},
  [1281] = {.lex_state = 78, .external_lex_state = 2},
  [1282] = {.lex_state = 78, .external_lex_state = 2},
  [1283] = {.lex_state = 78, .external_lex_state = 2},
  [1284] = {.lex_state = 78, .external_lex_state = 2},
  [1285] = {.lex_state = 78, .external_lex_state = 2},
  [1286] = {.lex_state = 78, .external_lex_state = 2},
  [1287] = {.lex_state = 78, .external_lex_state = 2},
  [1288] = {.lex_state = 78, .external_lex_state = 2},
  [1289] = {.lex_state = 78, .external_lex_state = 2},
  [1290] = {.lex_state = 78, .external_lex_state = 2},
  [1291] = {.lex_state = 78, .external_lex_state = 2},
  [1292] = {.lex_state = 78, .external_lex_state = 2},
  [1293] = {.lex_state = 78, .external_lex_state = 2},
  [1294] = {.lex_state = 78, .external_lex_state = 2},
  [1295] = {.lex_state = 78, .external_lex_state = 2},
  [1296] = {.lex_state = 78, .external_lex_state = 2},
  [1297] = {.lex_state = 78, .external_lex_state = 2},
  [1298] = {.lex_state = 78, .external_lex_state = 2},
  [1299] = {.lex_state = 78, .external_lex_state = 2},
  [1300] = {.lex_state = 78, .external_lex_state = 2},
  [1301] = {.lex_state = 78, .external_lex_state = 2},
  [1302] = {.lex_state = 78, .external_lex_state = 2},
  [1303] = {.lex_state = 78, .external_lex_state = 2},
  [1304] = {.lex_state = 78, .external_lex_state = 2},
  [1305] = {.lex_state = 78, .external_lex_state = 2},
  [1306] = {.lex_state = 78, .external_lex_state = 2},
  [1307] = {.lex_state = 78, .external_lex_state = 2},
  [1308] = {.lex_state = 78, .external_lex_state = 2},
  [1309] = {.lex_state = 78, .external_lex_state = 2},
  [1310] = {.lex_state = 78, .external_lex_state = 2},
  [1311] = {.lex_state = 78, .external_lex_state = 2},
  [1312] = {.lex_state = 78, .external_lex_state = 2},
  [1313] = {.lex_state = 78, .external_lex_state = 2},
  [1314] = {.lex_state = 78, .external_lex_state = 2},
  [1315] = {.lex_state = 78, .external_lex_state = 2},
  [1316] = {.lex_state = 78, .external_lex_state = 2},
  [1317] = {.lex_state = 78, .external_lex_state = 2},
  [1318] = {.lex_state = 78, .external_lex_state = 2},
  [1319] = {.lex_state = 78, .external_lex_state = 2},
  [1320] = {.lex_state = 78, .external_lex_state = 2},
  [1321] = {.lex_state = 78, .external_lex_state = 2},
  [1322] = {.lex_state = 78, .external_lex_state = 2},
  [1323] = {.lex_state = 78, .external_lex_state = 2},
  [1324] = {.lex_state = 78, .external_lex_state = 2},
  [1325] = {.lex_state = 78, .external_lex_state = 2},
  [1326] = {.lex_state = 78, .external_lex_state = 2},
  [1327] = {.lex_state = 78, .external_lex_state = 2},
  [1328] = {.lex_state = 78, .external_lex_state = 2},
  [1329] = {.lex_state = 78, .external_lex_state = 2},
  [1330] = {.lex_state = 78, .external_lex_state = 2},
  [1331] = {.lex_state = 78, .external_lex_state = 2},
  [1332] = {.lex_state = 78, .external_lex_state = 2},
  [1333] = {.lex_state = 78, .external_lex_state = 2},
  [1334] = {.lex_state = 78, .external_lex_state = 2},
  [1335] = {.lex_state = 78, .external_lex_state = 2},
  [1336] = {.lex_state = 78, .external_lex_state = 2},
  [1337] = {.lex_state = 78, .external_lex_state = 2},
  [1338] = {.lex_state = 78, .external_lex_state = 2},
  [1339] = {.lex_state = 78, .external_lex_state = 2},
  [1340] = {.lex_state = 78, .external_lex_state = 2},
  [1341] = {.lex_state = 78, .external_lex_state = 2},
  [1342] = {.lex_state = 78, .external_lex_state = 2},
  [1343] = {.lex_state = 78, .external_lex_state = 2},
  [1344] = {.lex_state = 78, .external_lex_state = 2},
  [1345] = {.lex_state = 78, .external_lex_state = 2},
  [1346] = {.lex_state = 78, .external_lex_state = 2},
  [1347] = {.lex_state = 78, .external_lex_state = 2},
  [1348] = {.lex_state = 78, .external_lex_state = 2},
  [1349] = {.lex_state = 78, .external_lex_state = 2},
  [1350] = {.lex_state = 78, .external_lex_state = 2},
  [1351] = {.lex_state = 78, .external_lex_state = 2},
  [1352] = {.lex_state = 78, .external_lex_state = 2},
  [1353] = {.lex_state = 78, .external_lex_state = 2},
  [1354] = {.lex_state = 78, .external_lex_state = 2},
  [1355] = {.lex_state = 78, .external_lex_state = 2},
  [1356] = {.lex_state = 78, .external_lex_state = 2},
  [1357] = {.lex_state = 78, .external_lex_state = 2},
  [1358] = {.lex_state = 78, .external_lex_state = 2},
  [1359] = {.lex_state = 78, .external_lex_state = 2},
  [1360] = {.lex_state = 78, .external_lex_state = 2},
  [1361] = {.lex_state = 78, .external_lex_state = 2},
  [1362] = {.lex_state = 78, .external_lex_state = 2},
  [1363] = {.lex_state = 78, .external_lex_state = 2},
  [1364] = {.lex_state = 78, .external_lex_state = 2},
  [1365] = {.lex_state = 78, .external_lex_state = 2},
  [1366] = {.lex_state = 78, .external_lex_state = 2},
  [1367] = {.lex_state = 78, .external_lex_state = 2},
  [1368] = {.lex_state = 78, .external_lex_state = 2},
  [1369] = {.lex_state = 78, .external_lex_state = 2},
  [1370] = {.lex_state = 78, .external_lex_state = 2},
  [1371] = {.lex_state = 78, .external_lex_state = 2},
  [1372] = {.lex_state = 78, .external_lex_state = 2},
  [1373] = {.lex_state = 78, .external_lex_state = 2},
  [1374] = {.lex_state = 78, .external_lex_state = 2},
  [1375] = {.lex_state = 78, .external_lex_state = 2},
  [1376] = {.lex_state = 78, .external_lex_state = 2},
  [1377] = {.lex_state = 78, .external_lex_state = 2},
  [1378] = {.lex_state = 78, .external_lex_state = 2},
  [1379] = {.lex_state = 78, .external_lex_state = 2},
  [1380] = {.lex_state = 78, .external_lex_state = 2},
  [1381] = {.lex_state = 78, .external_lex_state = 2},
  [1382] = {.lex_state = 78, .external_lex_state = 2},
  [1383] = {.lex_state = 78, .external_lex_state = 2},
  [1384] = {.lex_state = 78, .external_lex_state = 2},
  [1385] = {.lex_state = 78, .external_lex_state = 2},
  [1386] = {.lex_state = 78, .external_lex_state = 2},
  [1387] = {.lex_state = 78, .external_lex_state = 2},
  [1388] = {.lex_state = 78, .external_lex_state = 2},
  [1389] = {.lex_state = 78, .external_lex_state = 2},
  [1390] = {.lex_state = 78, .external_lex_state = 2},
  [1391] = {.lex_state = 78, .external_lex_state = 2},
  [1392] = {.lex_state = 78, .external_lex_state = 2},
  [1393] = {.lex_state = 78, .external_lex_state = 2},
  [1394] = {.lex_state = 78, .external_lex_state = 2},
  [1395] = {.lex_state = 78, .external_lex_state = 2},
  [1396] = {.lex_state = 78, .external_lex_state = 2},
  [1397] = {.lex_state = 78, .external_lex_state = 2},
  [1398] = {.lex_state = 78, .external_lex_state = 2},
  [1399] = {.lex_state = 78, .external_lex_state = 2},
  [1400] = {.lex_state = 78, .external_lex_state = 2},
  [1401] = {.lex_state = 78, .external_lex_state = 2},
  [1402] = {.lex_state = 78, .external_lex_state = 2},
  [1403] = {.lex_state = 78, .external_lex_state = 2},
  [1404] = {.lex_state = 78, .external_lex_state = 2},
  [1405] = {.lex_state = 78, .external_lex_state = 2},
  [1406] = {.lex_state = 78, .external_lex_state = 2},
  [1407] = {.lex_state = 78, .external_lex_state = 2},
  [1408] = {.lex_state = 78, .external_lex_state = 2},
  [1409] = {.lex_state = 78, .external_lex_state = 2},
  [1410] = {.lex_state = 78, .external_lex_state = 2},
  [1411] = {.lex_state = 78, .external_lex_state = 2},
  [1412] = {.lex_state = 78, .external_lex_state = 2},
  [1413] = {.lex_state = 78, .external_lex_state = 2},
  [1414] = {.lex_state = 78, .external_lex_state = 2},
  [1415] = {.lex_state = 78, .external_lex_state = 2},
  [1416] = {.lex_state = 78, .external_lex_state = 2},
  [1417] = {.lex_state = 78, .external_lex_state = 2},
  [1418] = {.lex_state = 78, .external_lex_state = 2},
  [1419] = {.lex_state = 78, .external_lex_state = 2},
  [1420] = {.lex_state = 78, .external_lex_state = 2},
  [1421] = {.lex_state = 78, .external_lex_state = 2},
  [1422] = {.lex_state = 78, .external_lex_state = 2},
  [1423] = {.lex_state = 78, .external_lex_state = 2},
  [1424] = {.lex_state = 78, .external_lex_state = 2},
  [1425] = {.lex_state = 78, .external_lex_state = 2},
  [1426] = {.lex_state = 78, .external_lex_state = 2},
  [1427] = {.lex_state = 78, .external_lex_state = 2},
  [1428] = {.lex_state = 78, .external_lex_state = 2},
  [1429] = {.lex_state = 78, .external_lex_state = 2},
  [1430] = {.lex_state = 78, .external_lex_state = 2},
  [1431] = {.lex_state = 78, .external_lex_state = 2},
  [1432] = {.lex_state = 78, .external_lex_state = 2},
  [1433] = {.lex_state = 78, .external_lex_state = 2},
  [1434] = {.lex_state = 78, .external_lex_state = 2},
  [1435] = {.lex_state = 78, .external_lex_state = 2},
  [1436] = {.lex_state = 78, .external_lex_state = 2},
  [1437] = {.lex_state = 78, .external_lex_state = 2},
  [1438] = {.lex_state = 78, .external_lex_state = 2},
  [1439] = {.lex_state = 78, .external_lex_state = 2},
  [1440] = {.lex_state = 78, .external_lex_state = 2},
  [1441] = {.lex_state = 78, .external_lex_state = 2},
  [1442] = {.lex_state = 78, .external_lex_state = 2},
  [1443] = {.lex_state = 78, .external_lex_state = 2},
  [1444] = {.lex_state = 78, .external_lex_state = 2},
  [1445] = {.lex_state = 78, .external_lex_state = 2},
  [1446] = {.lex_state = 78, .external_lex_state = 2},
  [1447] = {.lex_state = 78, .external_lex_state = 2},
  [1448] = {.lex_state = 78, .external_lex_state = 2},
  [1449] = {.lex_state = 78, .external_lex_state = 2},
  [1450] = {.lex_state = 78, .external_lex_state = 2},
  [1451] = {.lex_state = 78, .external_lex_state = 2},
  [1452] = {.lex_state = 78, .external_lex_state = 2},
  [1453] = {.lex_state = 78, .external_lex_state = 2},
  [1454] = {.lex_state = 78, .external_lex_state = 2},
  [1455] = {.lex_state = 78, .external_lex_state = 2},
  [1456] = {.lex_state = 78, .external_lex_state = 2},
  [1457] = {.lex_state = 78, .external_lex_state = 2},
  [1458] = {.lex_state = 78, .external_lex_state = 2},
  [1459] = {.lex_state = 78, .external_lex_state = 2},
  [1460] = {.lex_state = 78, .external_lex_state = 2},
  [1461] = {.lex_state = 78, .external_lex_state = 2},
  [1462] = {.lex_state = 78, .external_lex_state = 2},
  [1463] = {.lex_state = 78, .external_lex_state = 2},
  [1464] = {.lex_state = 78, .external_lex_state = 2},
  [1465] = {.lex_state = 78, .external_lex_state = 2},
  [1466] = {.lex_state = 78, .external_lex_state = 2},
  [1467] = {.lex_state = 78, .external_lex_state = 2},
  [1468] = {.lex_state = 78, .external_lex_state = 2},
  [1469] = {.lex_state = 78, .external_lex_state = 2},
  [1470] = {.lex_state = 78, .external_lex_state = 2},
  [1471] = {.lex_state = 78, .external_lex_state = 2},
  [1472] = {.lex_state = 78, .external_lex_state = 2},
  [1473] = {.lex_state = 78, .external_lex_state = 2},
  [1474] = {.lex_state = 78, .external_lex_state = 2},
  [1475] = {.lex_state = 78, .external_lex_state = 2},
  [1476] = {.lex_state = 78, .external_lex_state = 2},
  [1477] = {.lex_state = 78, .external_lex_state = 2},
  [1478] = {.lex_state = 78, .external_lex_state = 2},
  [1479] = {.lex_state = 78, .external_lex_state = 2},
  [1480] = {.lex_state = 78, .external_lex_state = 2},
  [1481] = {.lex_state = 78, .external_lex_state = 2},
  [1482] = {.lex_state = 78, .external_lex_state = 2},
  [1483] = {.lex_state = 78, .external_lex_state = 2},
  [1484] = {.lex_state = 78, .external_lex_state = 2},
  [1485] = {.lex_state = 78, .external_lex_state = 2},
  [1486] = {.lex_state = 78, .external_lex_state = 2},
  [1487] = {.lex_state = 78, .external_lex_state = 2},
  [1488] = {.lex_state = 78, .external_lex_state = 2},
  [1489] = {.lex_state = 78, .external_lex_state = 2},
  [1490] = {.lex_state = 78, .external_lex_state = 2},
  [1491] = {.lex_state = 78, .external_lex_state = 2},
  [1492] = {.lex_state = 78, .external_lex_state = 2},
  [1493] = {.lex_state = 78, .external_lex_state = 2},
  [1494] = {.lex_state = 78, .external_lex_state = 2},
  [1495] = {.lex_state = 78, .external_lex_state = 2},
  [1496] = {.lex_state = 78, .external_lex_state = 2},
  [1497] = {.lex_state = 78, .external_lex_state = 2},
  [1498] = {.lex_state = 78, .external_lex_state = 2},
  [1499] = {.lex_state = 78, .external_lex_state = 2},
  [1500] = {.lex_state = 78, .external_lex_state = 2},
  [1501] = {.lex_state = 78, .external_lex_state = 2},
  [1502] = {.lex_state = 78, .external_lex_state = 2},
  [1503] = {.lex_state = 78, .external_lex_state = 2},
  [1504] = {.lex_state = 78, .external_lex_state = 2},
  [1505] = {.lex_state = 78, .external_lex_state = 2},
  [1506] = {.lex_state = 78, .external_lex_state = 2},
  [1507] = {.lex_state = 78, .external_lex_state = 2},
  [1508] = {.lex_state = 78, .external_lex_state = 2},
  [1509] = {.lex_state = 78, .external_lex_state = 2},
  [1510] = {.lex_state = 78, .external_lex_state = 2},
  [1511] = {.lex_state = 78, .external_lex_state = 2},
  [1512] = {.lex_state = 78, .external_lex_state = 2},
  [1513] = {.lex_state = 78, .external_lex_state = 2},
  [1514] = {.lex_state = 78, .external_lex_state = 2},
  [1515] = {.lex_state = 78, .external_lex_state = 2},
  [1516] = {.lex_state = 78, .external_lex_state = 2},
  [1517] = {.lex_state = 78, .external_lex_state = 2},
  [1518] = {.lex_state = 78, .external_lex_state = 2},
  [1519] = {.lex_state = 78, .external_lex_state = 2},
  [1520] = {.lex_state = 78, .external_lex_state = 2},
  [1521] = {.lex_state = 78, .external_lex_state = 2},
  [1522] = {.lex_state = 78, .external_lex_state = 2},
  [1523] = {.lex_state = 78, .external_lex_state = 2},
  [1524] = {.lex_state = 78, .external_lex_state = 2},
  [1525] = {.lex_state = 78, .external_lex_state = 2},
  [1526] = {.lex_state = 78, .external_lex_state = 2},
  [1527] = {.lex_state = 78, .external_lex_state = 2},
  [1528] = {.lex_state = 78, .external_lex_state = 2},
  [1529] = {.lex_state = 78, .external_lex_state = 2},
  [1530] = {.lex_state = 78, .external_lex_state = 2},
  [1531] = {.lex_state = 78, .external_lex_state = 2},
  [1532] = {.lex_state = 78, .external_lex_state = 2},
  [1533] = {.lex_state = 78, .external_lex_state = 2},
  [1534] = {.lex_state = 78, .external_lex_state = 2},
  [1535] = {.lex_state = 78, .external_lex_state = 2},
  [1536] = {.lex_state = 78, .external_lex_state = 2},
  [1537] = {.lex_state = 78, .external_lex_state = 2},
  [1538] = {.lex_state = 78, .external_lex_state = 2},
  [1539] = {.lex_state = 78, .external_lex_state = 2},
  [1540] = {.lex_state = 78, .external_lex_state = 2},
  [1541] = {.lex_state = 78, .external_lex_state = 2},
  [1542] = {.lex_state = 78, .external_lex_state = 2},
  [1543] = {.lex_state = 78, .external_lex_state = 2},
  [1544] = {.lex_state = 78, .external_lex_state = 2},
  [1545] = {.lex_state = 78, .external_lex_state = 2},
  [1546] = {.lex_state = 78, .external_lex_state = 2},
  [1547] = {.lex_state = 78, .external_lex_state = 2},
  [1548] = {.lex_state = 78, .external_lex_state = 2},
  [1549] = {.lex_state = 78, .external_lex_state = 2},
  [1550] = {.lex_state = 78, .external_lex_state = 2},
  [1551] = {.lex_state = 78, .external_lex_state = 2},
  [1552] = {.lex_state = 78, .external_lex_state = 2},
  [1553] = {.lex_state = 78, .external_lex_state = 2},
  [1554] = {.lex_state = 78, .external_lex_state = 2},
  [1555] = {.lex_state = 78, .external_lex_state = 2},
  [1556] = {.lex_state = 78, .external_lex_state = 2},
  [1557] = {.lex_state = 78, .external_lex_state = 2},
  [1558] = {.lex_state = 78, .external_lex_state = 2},
  [1559] = {.lex_state = 78, .external_lex_state = 2},
  [1560] = {.lex_state = 78, .external_lex_state = 2},
  [1561] = {.lex_state = 78, .external_lex_state = 2},
  [1562] = {.lex_state = 78, .external_lex_state = 2},
  [1563] = {.lex_state = 78, .external_lex_state = 2},
  [1564] = {.lex_state = 78, .external_lex_state = 2},
  [1565] = {.lex_state = 78, .external_lex_state = 2},
  [1566] = {.lex_state = 78, .external_lex_state = 2},
  [1567] = {.lex_state = 78, .external_lex_state = 2},
  [1568] = {.lex_state = 78, .external_lex_state = 2},
  [1569] = {.lex_state = 78, .external_lex_state = 2},
  [1570] = {.lex_state = 78, .external_lex_state = 2},
  [1571] = {.lex_state = 78, .external_lex_state = 2},
  [1572] = {.lex_state = 78, .external_lex_state = 2},
  [1573] = {.lex_state = 78, .external_lex_state = 2},
  [1574] = {.lex_state = 78, .external_lex_state = 2},
  [1575] = {.lex_state = 78, .external_lex_state = 2},
  [1576] = {.lex_state = 78, .external_lex_state = 2},
  [1577] = {.lex_state = 78, .external_lex_state = 2},
  [1578] = {.lex_state = 78, .external_lex_state = 2},
  [1579] = {.lex_state = 78, .external_lex_state = 2},
  [1580] = {.lex_state = 78, .external_lex_state = 2},
  [1581] = {.lex_state = 78, .external_lex_state = 2},
  [1582] = {.lex_state = 78, .external_lex_state = 2},
  [1583] = {.lex_state = 78, .external_lex_state = 2},
  [1584] = {.lex_state = 78, .external_lex_state = 2},
  [1585] = {.lex_state = 78, .external_lex_state = 2},
  [1586] = {.lex_state = 78, .external_lex_state = 2},
  [1587] = {.lex_state = 78, .external_lex_state = 2},
  [1588] = {.lex_state = 78, .external_lex_state = 2},
  [1589] = {.lex_state = 78, .external_lex_state = 2},
  [1590] = {.lex_state = 78, .external_lex_state = 2},
  [1591] = {.lex_state = 78, .external_lex_state = 2},
  [1592] = {.lex_state = 78, .external_lex_state = 2},
  [1593] = {.lex_state = 78, .external_lex_state = 2},
  [1594] = {.lex_state = 78, .external_lex_state = 2},
  [1595] = {.lex_state = 78, .external_lex_state = 2},
  [1596] = {.lex_state = 78, .external_lex_state = 2},
  [1597] = {.lex_state = 78, .external_lex_state = 2},
  [1598] = {.lex_state = 78, .external_lex_state = 2},
  [1599] = {.lex_state = 78, .external_lex_state = 2},
  [1600] = {.lex_state = 78, .external_lex_state = 2},
  [1601] = {.lex_state = 78, .external_lex_state = 2},
  [1602] = {.lex_state = 78, .external_lex_state = 2},
  [1603] = {.lex_state = 78, .external_lex_state = 2},
  [1604] = {.lex_state = 78, .external_lex_state = 2},
  [1605] = {.lex_state = 78, .external_lex_state = 2},
  [1606] = {.lex_state = 78, .external_lex_state = 2},
  [1607] = {.lex_state = 78, .external_lex_state = 2},
  [1608] = {.lex_state = 78, .external_lex_state = 2},
  [1609] = {.lex_state = 78, .external_lex_state = 2},
  [1610] = {.lex_state = 78, .external_lex_state = 2},
  [1611] = {.lex_state = 78, .external_lex_state = 2},
  [1612] = {.lex_state = 78, .external_lex_state = 2},
  [1613] = {.lex_state = 78, .external_lex_state = 2},
  [1614] = {.lex_state = 78, .external_lex_state = 2},
  [1615] = {.lex_state = 78, .external_lex_state = 2},
  [1616] = {.lex_state = 78, .external_lex_state = 2},
  [1617] = {.lex_state = 78, .external_lex_state = 2},
  [1618] = {.lex_state = 78, .external_lex_state = 2},
  [1619] = {.lex_state = 78, .external_lex_state = 2},
  [1620] = {.lex_state = 78, .external_lex_state = 2},
  [1621] = {.lex_state = 78, .external_lex_state = 2},
  [1622] = {.lex_state = 78, .external_lex_state = 2},
  [1623] = {.lex_state = 78, .external_lex_state = 2},
  [1624] = {.lex_state = 78, .external_lex_state = 2},
  [1625] = {.lex_state = 78, .external_lex_state = 2},
  [1626] = {.lex_state = 78, .external_lex_state = 2},
  [1627] = {.lex_state = 78, .external_lex_state = 2},
  [1628] = {.lex_state = 78, .external_lex_state = 2},
  [1629] = {.lex_state = 78, .external_lex_state = 2},
  [1630] = {.lex_state = 78, .external_lex_state = 2},
  [1631] = {.lex_state = 78, .external_lex_state = 2},
  [1632] = {.lex_state = 78, .external_lex_state = 2},
  [1633] = {.lex_state = 78, .external_lex_state = 2},
  [1634] = {.lex_state = 78, .external_lex_state = 2},
  [1635] = {.lex_state = 78, .external_lex_state = 2},
  [1636] = {.lex_state = 78, .external_lex_state = 2},
  [1637] = {.lex_state = 78, .external_lex_state = 2},
  [1638] = {.lex_state = 78, .external_lex_state = 2},
  [1639] = {.lex_state = 78, .external_lex_state = 2},
  [1640] = {.lex_state = 78, .external_lex_state = 2},
  [1641] = {.lex_state = 78, .external_lex_state = 2},
  [1642] = {.lex_state = 78, .external_lex_state = 2},
  [1643] = {.lex_state = 78, .external_lex_state = 2},
  [1644] = {.lex_state = 78, .external_lex_state = 2},
  [1645] = {.lex_state = 78, .external_lex_state = 2},
  [1646] = {.lex_state = 78, .external_lex_state = 2},
  [1647] = {.lex_state = 78, .external_lex_state = 2},
  [1648] = {.lex_state = 78, .external_lex_state = 2},
  [1649] = {.lex_state = 78, .external_lex_state = 2},
  [1650] = {.lex_state = 78, .external_lex_state = 2},
  [1651] = {.lex_state = 78, .external_lex_state = 2},
  [1652] = {.lex_state = 78, .external_lex_state = 2},
  [1653] = {.lex_state = 78, .external_lex_state = 2},
  [1654] = {.lex_state = 78, .external_lex_state = 2},
  [1655] = {.lex_state = 78, .external_lex_state = 2},
  [1656] = {.lex_state = 78, .external_lex_state = 2},
  [1657] = {.lex_state = 78, .external_lex_state = 2},
  [1658] = {.lex_state = 78, .external_lex_state = 2},
  [1659] = {.lex_state = 78, .external_lex_state = 2},
  [1660] = {.lex_state = 78, .external_lex_state = 2},
  [1661] = {.lex_state = 78, .external_lex_state = 2},
  [1662] = {.lex_state = 78, .external_lex_state = 2},
  [1663] = {.lex_state = 78, .external_lex_state = 2},
  [1664] = {.lex_state = 78, .external_lex_state = 2},
  [1665] = {.lex_state = 78, .external_lex_state = 2},
  [1666] = {.lex_state = 78, .external_lex_state = 2},
  [1667] = {.lex_state = 78, .external_lex_state = 2},
  [1668] = {.lex_state = 78, .external_lex_state = 2},
  [1669] = {.lex_state = 78, .external_lex_state = 2},
  [1670] = {.lex_state = 78, .external_lex_state = 2},
  [1671] = {.lex_state = 78, .external_lex_state = 2},
  [1672] = {.lex_state = 78, .external_lex_state = 2},
  [1673] = {.lex_state = 78, .external_lex_state = 2},
  [1674] = {.lex_state = 78, .external_lex_state = 2},
  [1675] = {.lex_state = 78, .external_lex_state = 2},
  [1676] = {.lex_state = 78, .external_lex_state = 2},
  [1677] = {.lex_state = 78, .external_lex_state = 2},
  [1678] = {.lex_state = 78, .external_lex_state = 2},
  [1679] = {.lex_state = 78, .external_lex_state = 2},
  [1680] = {.lex_state = 78, .external_lex_state = 2},
  [1681] = {.lex_state = 78, .external_lex_state = 2},
  [1682] = {.lex_state = 78, .external_lex_state = 2},
  [1683] = {.lex_state = 78, .external_lex_state = 2},
  [1684] = {.lex_state = 78, .external_lex_state = 2},
  [1685] = {.lex_state = 78, .external_lex_state = 2},
  [1686] = {.lex_state = 78, .external_lex_state = 2},
  [1687] = {.lex_state = 78, .external_lex_state = 2},
  [1688] = {.lex_state = 78, .external_lex_state = 2},
  [1689] = {.lex_state = 78, .external_lex_state = 2},
  [1690] = {.lex_state = 78, .external_lex_state = 2},
  [1691] = {.lex_state = 78, .external_lex_state = 2},
  [1692] = {.lex_state = 78, .external_lex_state = 2},
  [1693] = {.lex_state = 78, .external_lex_state = 2},
  [1694] = {.lex_state = 78, .external_lex_state = 2},
  [1695] = {.lex_state = 78, .external_lex_state = 2},
  [1696] = {.lex_state = 78, .external_lex_state = 2},
  [1697] = {.lex_state = 78, .external_lex_state = 2},
  [1698] = {.lex_state = 78, .external_lex_state = 2},
  [1699] = {.lex_state = 78, .external_lex_state = 2},
  [1700] = {.lex_state = 78, .external_lex_state = 2},
  [1701] = {.lex_state = 78, .external_lex_state = 2},
  [1702] = {.lex_state = 78, .external_lex_state = 2},
  [1703] = {.lex_state = 78, .external_lex_state = 2},
  [1704] = {.lex_state = 67, .external_lex_state = 3},
  [1705] = {.lex_state = 78, .external_lex_state = 2},
  [1706] = {.lex_state = 78, .external_lex_state = 2},
  [1707] = {.lex_state = 78, .external_lex_state = 2},
  [1708] = {.lex_state = 78, .external_lex_state = 2},
  [1709] = {.lex_state = 78, .external_lex_state = 2},
  [1710] = {.lex_state = 78, .external_lex_state = 2},
  [1711] = {.lex_state = 78, .external_lex_state = 2},
  [1712] = {.lex_state = 78, .external_lex_state = 2},
  [1713] = {.lex_state = 78, .external_lex_state = 2},
  [1714] = {.lex_state = 78, .external_lex_state = 2},
  [1715] = {.lex_state = 78, .external_lex_state = 2},
  [1716] = {.lex_state = 78, .external_lex_state = 2},
  [1717] = {.lex_state = 78, .external_lex_state = 2},
  [1718] = {.lex_state = 78, .external_lex_state = 2},
  [1719] = {.lex_state = 78, .external_lex_state = 2},
  [1720] = {.lex_state = 78, .external_lex_state = 2},
  [1721] = {.lex_state = 78, .external_lex_state = 2},
  [1722] = {.lex_state = 78, .external_lex_state = 2},
  [1723] = {.lex_state = 78, .external_lex_state = 2},
  [1724] = {.lex_state = 78, .external_lex_state = 2},
  [1725] = {.lex_state = 78, .external_lex_state = 2},
  [1726] = {.lex_state = 78, .external_lex_state = 2},
  [1727] = {.lex_state = 78, .external_lex_state = 2},
  [1728] = {.lex_state = 78, .external_lex_state = 2},
  [1729] = {.lex_state = 78, .external_lex_state = 2},
  [1730] = {.lex_state = 78, .external_lex_state = 2},
  [1731] = {.lex_state = 78, .external_lex_state = 2},
  [1732] = {.lex_state = 78, .external_lex_state = 2},
  [1733] = {.lex_state = 78, .external_lex_state = 2},
  [1734] = {.lex_state = 78, .external_lex_state = 2},
  [1735] = {.lex_state = 78, .external_lex_state = 2},
  [1736] = {.lex_state = 78, .external_lex_state = 2},
  [1737] = {.lex_state = 78, .external_lex_state = 2},
  [1738] = {.lex_state = 78, .external_lex_state = 2},
  [1739] = {.lex_state = 78, .external_lex_state = 2},
  [1740] = {.lex_state = 78, .external_lex_state = 2},
  [1741] = {.lex_state = 78, .external_lex_state = 2},
  [1742] = {.lex_state = 78, .external_lex_state = 2},
  [1743] = {.lex_state = 78, .external_lex_state = 2},
  [1744] = {.lex_state = 78, .external_lex_state = 2},
  [1745] = {.lex_state = 78, .external_lex_state = 2},
  [1746] = {.lex_state = 78, .external_lex_state = 2},
  [1747] = {.lex_state = 78, .external_lex_state = 2},
  [1748] = {.lex_state = 78, .external_lex_state = 2},
  [1749] = {.lex_state = 78, .external_lex_state = 2},
  [1750] = {.lex_state = 78, .external_lex_state = 2},
  [1751] = {.lex_state = 78, .external_lex_state = 2},
  [1752] = {.lex_state = 78, .external_lex_state = 2},
  [1753] = {.lex_state = 78, .external_lex_state = 2},
  [1754] = {.lex_state = 78, .external_lex_state = 2},
  [1755] = {.lex_state = 78, .external_lex_state = 2},
  [1756] = {.lex_state = 78, .external_lex_state = 2},
  [1757] = {.lex_state = 78, .external_lex_state = 2},
  [1758] = {.lex_state = 78, .external_lex_state = 2},
  [1759] = {.lex_state = 78, .external_lex_state = 2},
  [1760] = {.lex_state = 78, .external_lex_state = 2},
  [1761] = {.lex_state = 78, .external_lex_state = 2},
  [1762] = {.lex_state = 78, .external_lex_state = 2},
  [1763] = {.lex_state = 78, .external_lex_state = 2},
  [1764] = {.lex_state = 78, .external_lex_state = 2},
  [1765] = {.lex_state = 78, .external_lex_state = 2},
  [1766] = {.lex_state = 78, .external_lex_state = 2},
  [1767] = {.lex_state = 78, .external_lex_state = 2},
  [1768] = {.lex_state = 78, .external_lex_state = 2},
  [1769] = {.lex_state = 78, .external_lex_state = 2},
  [1770] = {.lex_state = 78, .external_lex_state = 2},
  [1771] = {.lex_state = 78, .external_lex_state = 2},
  [1772] = {.lex_state = 78, .external_lex_state = 2},
  [1773] = {.lex_state = 78, .external_lex_state = 2},
  [1774] = {.lex_state = 78, .external_lex_state = 2},
  [1775] = {.lex_state = 78, .external_lex_state = 2},
  [1776] = {.lex_state = 78, .external_lex_state = 2},
  [1777] = {.lex_state = 78, .external_lex_state = 2},
  [1778] = {.lex_state = 78, .external_lex_state = 2},
  [1779] = {.lex_state = 78, .external_lex_state = 2},
  [1780] = {.lex_state = 78, .external_lex_state = 2},
  [1781] = {.lex_state = 78, .external_lex_state = 2},
  [1782] = {.lex_state = 78, .external_lex_state = 2},
  [1783] = {.lex_state = 78, .external_lex_state = 2},
  [1784] = {.lex_state = 78, .external_lex_state = 2},
  [1785] = {.lex_state = 78, .external_lex_state = 2},
  [1786] = {.lex_state = 78, .external_lex_state = 2},
  [1787] = {.lex_state = 78, .external_lex_state = 2},
  [1788] = {.lex_state = 78, .external_lex_state = 2},
  [1789] = {.lex_state = 78, .external_lex_state = 2},
  [1790] = {.lex_state = 78, .external_lex_state = 2},
  [1791] = {.lex_state = 78, .external_lex_state = 2},
  [1792] = {.lex_state = 78, .external_lex_state = 2},
  [1793] = {.lex_state = 78, .external_lex_state = 2},
  [1794] = {.lex_state = 78, .external_lex_state = 2},
  [1795] = {.lex_state = 78, .external_lex_state = 2},
  [1796] = {.lex_state = 78, .external_lex_state = 2},
  [1797] = {.lex_state = 78, .external_lex_state = 2},
  [1798] = {.lex_state = 78, .external_lex_state = 2},
  [1799] = {.lex_state = 78, .external_lex_state = 2},
  [1800] = {.lex_state = 78, .external_lex_state = 2},
  [1801] = {.lex_state = 78, .external_lex_state = 2},
  [1802] = {.lex_state = 78, .external_lex_state = 2},
  [1803] = {.lex_state = 78, .external_lex_state = 2},
  [1804] = {.lex_state = 78, .external_lex_state = 2},
  [1805] = {.lex_state = 78, .external_lex_state = 2},
  [1806] = {.lex_state = 78, .external_lex_state = 2},
  [1807] = {.lex_state = 78, .external_lex_state = 2},
  [1808] = {.lex_state = 78, .external_lex_state = 2},
  [1809] = {.lex_state = 78, .external_lex_state = 2},
  [1810] = {.lex_state = 78, .external_lex_state = 2},
  [1811] = {.lex_state = 78, .external_lex_state = 2},
  [1812] = {.lex_state = 78, .external_lex_state = 2},
  [1813] = {.lex_state = 78, .external_lex_state = 2},
  [1814] = {.lex_state = 78, .external_lex_state = 2},
  [1815] = {.lex_state = 78, .external_lex_state = 2},
  [1816] = {.lex_state = 78, .external_lex_state = 2},
  [1817] = {.lex_state = 78, .external_lex_state = 2},
  [1818] = {.lex_state = 78, .external_lex_state = 2},
  [1819] = {.lex_state = 78, .external_lex_state = 2},
  [1820] = {.lex_state = 78, .external_lex_state = 2},
  [1821] = {.lex_state = 78, .external_lex_state = 2},
  [1822] = {.lex_state = 78, .external_lex_state = 2},
  [1823] = {.lex_state = 78, .external_lex_state = 2},
  [1824] = {.lex_state = 78, .external_lex_state = 2},
  [1825] = {.lex_state = 78, .external_lex_state = 2},
  [1826] = {.lex_state = 78, .external_lex_state = 2},
  [1827] = {.lex_state = 78, .external_lex_state = 2},
  [1828] = {.lex_state = 78, .external_lex_state = 2},
  [1829] = {.lex_state = 78, .external_lex_state = 2},
  [1830] = {.lex_state = 78, .external_lex_state = 2},
  [1831] = {.lex_state = 78, .external_lex_state = 2},
  [1832] = {.lex_state = 78, .external_lex_state = 2},
  [1833] = {.lex_state = 78, .external_lex_state = 2},
  [1834] = {.lex_state = 78, .external_lex_state = 2},
  [1835] = {.lex_state = 78, .external_lex_state = 2},
  [1836] = {.lex_state = 78, .external_lex_state = 2},
  [1837] = {.lex_state = 78, .external_lex_state = 2},
  [1838] = {.lex_state = 78, .external_lex_state = 2},
  [1839] = {.lex_state = 78, .external_lex_state = 2},
  [1840] = {.lex_state = 78, .external_lex_state = 2},
  [1841] = {.lex_state = 78, .external_lex_state = 2},
  [1842] = {.lex_state = 78, .external_lex_state = 2},
  [1843] = {.lex_state = 78, .external_lex_state = 2},
  [1844] = {.lex_state = 78, .external_lex_state = 2},
  [1845] = {.lex_state = 78, .external_lex_state = 2},
  [1846] = {.lex_state = 78, .external_lex_state = 2},
  [1847] = {.lex_state = 78, .external_lex_state = 2},
  [1848] = {.lex_state = 78, .external_lex_state = 2},
  [1849] = {.lex_state = 78, .external_lex_state = 2},
  [1850] = {.lex_state = 78, .external_lex_state = 2},
  [1851] = {.lex_state = 78, .external_lex_state = 2},
  [1852] = {.lex_state = 78, .external_lex_state = 2},
  [1853] = {.lex_state = 78, .external_lex_state = 2},
  [1854] = {.lex_state = 78, .external_lex_state = 2},
  [1855] = {.lex_state = 78, .external_lex_state = 2},
  [1856] = {.lex_state = 78, .external_lex_state = 2},
  [1857] = {.lex_state = 78, .external_lex_state = 2},
  [1858] = {.lex_state = 78, .external_lex_state = 2},
  [1859] = {.lex_state = 78, .external_lex_state = 2},
  [1860] = {.lex_state = 78, .external_lex_state = 2},
  [1861] = {.lex_state = 78, .external_lex_state = 2},
  [1862] = {.lex_state = 78, .external_lex_state = 2},
  [1863] = {.lex_state = 78, .external_lex_state = 2},
  [1864] = {.lex_state = 78, .external_lex_state = 2},
  [1865] = {.lex_state = 78, .external_lex_state = 2},
  [1866] = {.lex_state = 78, .external_lex_state = 2},
  [1867] = {.lex_state = 78, .external_lex_state = 2},
  [1868] = {.lex_state = 78, .external_lex_state = 2},
  [1869] = {.lex_state = 78, .external_lex_state = 2},
  [1870] = {.lex_state = 78, .external_lex_state = 2},
  [1871] = {.lex_state = 78, .external_lex_state = 2},
  [1872] = {.lex_state = 78, .external_lex_state = 2},
  [1873] = {.lex_state = 78, .external_lex_state = 2},
  [1874] = {.lex_state = 78, .external_lex_state = 2},
  [1875] = {.lex_state = 78, .external_lex_state = 2},
  [1876] = {.lex_state = 78, .external_lex_state = 2},
  [1877] = {.lex_state = 78, .external_lex_state = 2},
  [1878] = {.lex_state = 78, .external_lex_state = 2},
  [1879] = {.lex_state = 67, .external_lex_state = 3},
  [1880] = {.lex_state = 67, .external_lex_state = 3},
  [1881] = {.lex_state = 67, .external_lex_state = 3},
  [1882] = {.lex_state = 67, .external_lex_state = 3},
  [1883] = {.lex_state = 67, .external_lex_state = 3},
  [1884] = {.lex_state = 67, .external_lex_state = 3},
  [1885] = {.lex_state = 67, .external_lex_state = 3},
  [1886] = {.lex_state = 67, .external_lex_state = 3},
  [1887] = {.lex_state = 67, .external_lex_state = 3},
  [1888] = {.lex_state = 67, .external_lex_state = 3},
  [1889] = {.lex_state = 102, .external_lex_state = 18},
  [1890] = {.lex_state = 208, .external_lex_state = 3},
  [1891] = {.lex_state = 208, .external_lex_state = 3},
  [1892] = {.lex_state = 208, .external_lex_state = 3},
  [1893] = {.lex_state = 208, .external_lex_state = 3},
  [1894] = {.lex_state = 208, .external_lex_state = 3},
  [1895] = {.lex_state = 208, .external_lex_state = 3},
  [1896] = {.lex_state = 208, .external_lex_state = 3},
  [1897] = {.lex_state = 208, .external_lex_state = 3},
  [1898] = {.lex_state = 208, .external_lex_state = 3},
  [1899] = {.lex_state = 208, .external_lex_state = 3},
  [1900] = {.lex_state = 208, .external_lex_state = 3},
  [1901] = {.lex_state = 208, .external_lex_state = 3},
  [1902] = {.lex_state = 66, .external_lex_state = 3},
  [1903] = {.lex_state = 67, .external_lex_state = 3},
  [1904] = {.lex_state = 67, .external_lex_state = 4},
  [1905] = {.lex_state = 67, .external_lex_state = 3},
  [1906] = {.lex_state = 67, .external_lex_state = 3},
  [1907] = {.lex_state = 223, .external_lex_state = 18},
  [1908] = {.lex_state = 67, .external_lex_state = 3},
  [1909] = {.lex_state = 67, .external_lex_state = 3},
  [1910] = {.lex_state = 67, .external_lex_state = 3},
  [1911] = {.lex_state = 67, .external_lex_state = 3},
  [1912] = {.lex_state = 67, .external_lex_state = 3},
  [1913] = {.lex_state = 67, .external_lex_state = 4},
  [1914] = {.lex_state = 67, .external_lex_state = 4},
  [1915] = {.lex_state = 67, .external_lex_state = 4},
  [1916] = {.lex_state = 67, .external_lex_state = 4},
  [1917] = {.lex_state = 66, .external_lex_state = 4},
  [1918] = {.lex_state = 67, .external_lex_state = 4},
  [1919] = {.lex_state = 67, .external_lex_state = 4},
  [1920] = {.lex_state = 67, .external_lex_state = 4},
  [1921] = {.lex_state = 67, .external_lex_state = 4},
  [1922] = {.lex_state = 67, .external_lex_state = 4},
  [1923] = {.lex_state = 67, .external_lex_state = 4},
  [1924] = {.lex_state = 67, .external_lex_state = 4},
  [1925] = {.lex_state = 67, .external_lex_state = 4},
  [1926] = {.lex_state = 67, .external_lex_state = 3},
  [1927] = {.lex_state = 67, .external_lex_state = 4},
  [1928] = {.lex_state = 67, .external_lex_state = 4},
  [1929] = {.lex_state = 67, .external_lex_state = 4},
  [1930] = {.lex_state = 102, .external_lex_state = 19},
  [1931] = {.lex_state = 67, .external_lex_state = 4},
  [1932] = {.lex_state = 102, .external_lex_state = 19},
  [1933] = {.lex_state = 102, .external_lex_state = 19},
  [1934] = {.lex_state = 70, .external_lex_state = 3},
  [1935] = {.lex_state = 70, .external_lex_state = 3},
  [1936] = {.lex_state = 70, .external_lex_state = 3},
  [1937] = {.lex_state = 70, .external_lex_state = 3},
  [1938] = {.lex_state = 78, .external_lex_state = 19},
  [1939] = {.lex_state = 78, .external_lex_state = 19},
  [1940] = {.lex_state = 70, .external_lex_state = 3},
  [1941] = {.lex_state = 70, .external_lex_state = 3},
  [1942] = {.lex_state = 78, .external_lex_state = 19},
  [1943] = {.lex_state = 102, .external_lex_state = 19},
  [1944] = {.lex_state = 70, .external_lex_state = 3},
  [1945] = {.lex_state = 70, .external_lex_state = 3},
  [1946] = {.lex_state = 78, .external_lex_state = 19},
  [1947] = {.lex_state = 78, .external_lex_state = 20},
  [1948] = {.lex_state = 78, .external_lex_state = 20},
  [1949] = {.lex_state = 78, .external_lex_state = 20},
  [1950] = {.lex_state = 210, .external_lex_state = 3},
  [1951] = {.lex_state = 210, .external_lex_state = 3},
  [1952] = {.lex_state = 78, .external_lex_state = 19},
  [1953] = {.lex_state = 210, .external_lex_state = 3},
  [1954] = {.lex_state = 78, .external_lex_state = 19},
  [1955] = {.lex_state = 210, .external_lex_state = 3},
  [1956] = {.lex_state = 78, .external_lex_state = 19},
  [1957] = {.lex_state = 78, .external_lex_state = 19},
  [1958] = {.lex_state = 210, .external_lex_state = 3},
  [1959] = {.lex_state = 210, .external_lex_state = 3},
  [1960] = {.lex_state = 210, .external_lex_state = 3},
  [1961] = {.lex_state = 210, .external_lex_state = 3},
  [1962] = {.lex_state = 70, .external_lex_state = 3},
  [1963] = {.lex_state = 70, .external_lex_state = 3},
  [1964] = {.lex_state = 70, .external_lex_state = 4},
  [1965] = {.lex_state = 70, .external_lex_state = 3},
  [1966] = {.lex_state = 70, .external_lex_state = 3},
  [1967] = {.lex_state = 70, .external_lex_state = 4},
  [1968] = {.lex_state = 70, .external_lex_state = 3},
  [1969] = {.lex_state = 70, .external_lex_state = 3},
  [1970] = {.lex_state = 70, .external_lex_state = 3},
  [1971] = {.lex_state = 70, .external_lex_state = 4},
  [1972] = {.lex_state = 70, .external_lex_state = 4},
  [1973] = {.lex_state = 70, .external_lex_state = 4},
  [1974] = {.lex_state = 70, .external_lex_state = 3},
  [1975] = {.lex_state = 70, .external_lex_state = 4},
  [1976] = {.lex_state = 70, .external_lex_state = 4},
  [1977] = {.lex_state = 70, .external_lex_state = 4},
  [1978] = {.lex_state = 70, .external_lex_state = 4},
  [1979] = {.lex_state = 70, .external_lex_state = 4},
  [1980] = {.lex_state = 70, .external_lex_state = 4},
  [1981] = {.lex_state = 70, .external_lex_state = 4},
  [1982] = {.lex_state = 70, .external_lex_state = 4},
  [1983] = {.lex_state = 70, .external_lex_state = 4},
  [1984] = {.lex_state = 101, .external_lex_state = 21},
  [1985] = {.lex_state = 101, .external_lex_state = 21},
  [1986] = {.lex_state = 101, .external_lex_state = 21},
  [1987] = {.lex_state = 115, .external_lex_state = 19},
  [1988] = {.lex_state = 115, .external_lex_state = 19},
  [1989] = {.lex_state = 115, .external_lex_state = 19},
  [1990] = {.lex_state = 115, .external_lex_state = 19},
  [1991] = {.lex_state = 115, .external_lex_state = 19},
  [1992] = {.lex_state = 115, .external_lex_state = 19},
  [1993] = {.lex_state = 115, .external_lex_state = 19},
  [1994] = {.lex_state = 231, .external_lex_state = 21},
  [1995] = {.lex_state = 115, .external_lex_state = 19},
  [1996] = {.lex_state = 115, .external_lex_state = 19},
  [1997] = {.lex_state = 115, .external_lex_state = 19},
  [1998] = {.lex_state = 115, .external_lex_state = 19},
  [1999] = {.lex_state = 115, .external_lex_state = 19},
  [2000] = {.lex_state = 115, .external_lex_state = 19},
  [2001] = {.lex_state = 115, .external_lex_state = 19},
  [2002] = {.lex_state = 115, .external_lex_state = 19},
  [2003] = {.lex_state = 78, .external_lex_state = 9},
  [2004] = {.lex_state = 78, .external_lex_state = 9},
  [2005] = {.lex_state = 231, .external_lex_state = 21},
  [2006] = {.lex_state = 78, .external_lex_state = 9},
  [2007] = {.lex_state = 78, .external_lex_state = 9},
  [2008] = {.lex_state = 231, .external_lex_state = 21},
  [2009] = {.lex_state = 78, .external_lex_state = 9},
  [2010] = {.lex_state = 78, .external_lex_state = 9},
  [2011] = {.lex_state = 101, .external_lex_state = 21},
  [2012] = {.lex_state = 75, .external_lex_state = 6},
  [2013] = {.lex_state = 216, .external_lex_state = 22},
  [2014] = {.lex_state = 101, .external_lex_state = 23},
  [2015] = {.lex_state = 79, .external_lex_state = 2},
  [2016] = {.lex_state = 216, .external_lex_state = 22},
  [2017] = {.lex_state = 216, .external_lex_state = 22},
  [2018] = {.lex_state = 216, .external_lex_state = 22},
  [2019] = {.lex_state = 101, .external_lex_state = 23},
  [2020] = {.lex_state = 101, .external_lex_state = 21},
  [2021] = {.lex_state = 101, .external_lex_state = 21},
  [2022] = {.lex_state = 216, .external_lex_state = 22},
  [2023] = {.lex_state = 77, .external_lex_state = 6},
  [2024] = {.lex_state = 215, .external_lex_state = 9},
  [2025] = {.lex_state = 215, .external_lex_state = 9},
  [2026] = {.lex_state = 215, .external_lex_state = 9},
  [2027] = {.lex_state = 79, .external_lex_state = 2},
  [2028] = {.lex_state = 79, .external_lex_state = 2},
  [2029] = {.lex_state = 79, .external_lex_state = 2},
  [2030] = {.lex_state = 215, .external_lex_state = 9},
  [2031] = {.lex_state = 215, .external_lex_state = 9},
  [2032] = {.lex_state = 215, .external_lex_state = 9},
  [2033] = {.lex_state = 101, .external_lex_state = 23},
  [2034] = {.lex_state = 216, .external_lex_state = 22},
  [2035] = {.lex_state = 101, .external_lex_state = 23},
  [2036] = {.lex_state = 216, .external_lex_state = 22},
  [2037] = {.lex_state = 216, .external_lex_state = 22},
  [2038] = {.lex_state = 82, .external_lex_state = 22},
  [2039] = {.lex_state = 216, .external_lex_state = 22},
  [2040] = {.lex_state = 216, .external_lex_state = 22},
  [2041] = {.lex_state = 216, .external_lex_state = 22},
  [2042] = {.lex_state = 216, .external_lex_state = 22},
  [2043] = {.lex_state = 216, .external_lex_state = 22},
  [2044] = {.lex_state = 216, .external_lex_state = 22},
  [2045] = {.lex_state = 101, .external_lex_state = 23},
  [2046] = {.lex_state = 216, .external_lex_state = 22},
  [2047] = {.lex_state = 216, .external_lex_state = 22},
  [2048] = {.lex_state = 101, .external_lex_state = 23},
  [2049] = {.lex_state = 216, .external_lex_state = 22},
  [2050] = {.lex_state = 101, .external_lex_state = 23},
  [2051] = {.lex_state = 101, .external_lex_state = 23},
  [2052] = {.lex_state = 216, .external_lex_state = 22},
  [2053] = {.lex_state = 216, .external_lex_state = 22},
  [2054] = {.lex_state = 216, .external_lex_state = 22},
  [2055] = {.lex_state = 216, .external_lex_state = 22},
  [2056] = {.lex_state = 216, .external_lex_state = 22},
  [2057] = {.lex_state = 80, .external_lex_state = 7},
  [2058] = {.lex_state = 78, .external_lex_state = 5},
  [2059] = {.lex_state = 80, .external_lex_state = 7},
  [2060] = {.lex_state = 83, .external_lex_state = 22},
  [2061] = {.lex_state = 78, .external_lex_state = 5},
  [2062] = {.lex_state = 78, .external_lex_state = 5},
  [2063] = {.lex_state = 80, .external_lex_state = 7},
  [2064] = {.lex_state = 78, .external_lex_state = 5},
  [2065] = {.lex_state = 78, .external_lex_state = 5},
  [2066] = {.lex_state = 78, .external_lex_state = 5},
  [2067] = {.lex_state = 82, .external_lex_state = 22},
  [2068] = {.lex_state = 79, .external_lex_state = 2},
  [2069] = {.lex_state = 79, .external_lex_state = 7},
  [2070] = {.lex_state = 79, .external_lex_state = 7},
  [2071] = {.lex_state = 79, .external_lex_state = 7},
  [2072] = {.lex_state = 79, .external_lex_state = 7},
  [2073] = {.lex_state = 82, .external_lex_state = 22},
  [2074] = {.lex_state = 79, .external_lex_state = 7},
  [2075] = {.lex_state = 79, .external_lex_state = 7},
  [2076] = {.lex_state = 79, .external_lex_state = 7},
  [2077] = {.lex_state = 79, .external_lex_state = 7},
  [2078] = {.lex_state = 79, .external_lex_state = 7},
  [2079] = {.lex_state = 79, .external_lex_state = 7},
  [2080] = {.lex_state = 79, .external_lex_state = 7},
  [2081] = {.lex_state = 79, .external_lex_state = 7},
  [2082] = {.lex_state = 82, .external_lex_state = 22},
  [2083] = {.lex_state = 101, .external_lex_state = 23},
  [2084] = {.lex_state = 214, .external_lex_state = 2},
  [2085] = {.lex_state = 82, .external_lex_state = 22},
  [2086] = {.lex_state = 82, .external_lex_state = 22},
  [2087] = {.lex_state = 214, .external_lex_state = 2},
  [2088] = {.lex_state = 214, .external_lex_state = 2},
  [2089] = {.lex_state = 101, .external_lex_state = 23},
  [2090] = {.lex_state = 101, .external_lex_state = 23},
  [2091] = {.lex_state = 214, .external_lex_state = 2},
  [2092] = {.lex_state = 101, .external_lex_state = 23},
  [2093] = {.lex_state = 82, .external_lex_state = 22},
  [2094] = {.lex_state = 101, .external_lex_state = 23},
  [2095] = {.lex_state = 82, .external_lex_state = 22},
  [2096] = {.lex_state = 82, .external_lex_state = 22},
  [2097] = {.lex_state = 82, .external_lex_state = 22},
  [2098] = {.lex_state = 82, .external_lex_state = 22},
  [2099] = {.lex_state = 216, .external_lex_state = 22},
  [2100] = {.lex_state = 101, .external_lex_state = 23},
  [2101] = {.lex_state = 101, .external_lex_state = 23},
  [2102] = {.lex_state = 79, .external_lex_state = 2},
  [2103] = {.lex_state = 101, .external_lex_state = 23},
  [2104] = {.lex_state = 79, .external_lex_state = 2},
  [2105] = {.lex_state = 79, .external_lex_state = 2},
  [2106] = {.lex_state = 79, .external_lex_state = 2},
  [2107] = {.lex_state = 79, .external_lex_state = 2},
  [2108] = {.lex_state = 79, .external_lex_state = 2},
  [2109] = {.lex_state = 101, .external_lex_state = 23},
  [2110] = {.lex_state = 101, .external_lex_state = 23},
  [2111] = {.lex_state = 79, .external_lex_state = 2},
  [2112] = {.lex_state = 101, .external_lex_state = 23},
  [2113] = {.lex_state = 79, .external_lex_state = 2},
  [2114] = {.lex_state = 79, .external_lex_state = 2},
  [2115] = {.lex_state = 79, .external_lex_state = 2},
  [2116] = {.lex_state = 101, .external_lex_state = 23},
  [2117] = {.lex_state = 79, .external_lex_state = 2},
  [2118] = {.lex_state = 79, .external_lex_state = 2},
  [2119] = {.lex_state = 217, .external_lex_state = 22},
  [2120] = {.lex_state = 82, .external_lex_state = 22},
  [2121] = {.lex_state = 216, .external_lex_state = 22},
  [2122] = {.lex_state = 216, .external_lex_state = 22},
  [2123] = {.lex_state = 216, .external_lex_state = 22},
  [2124] = {.lex_state = 101, .external_lex_state = 21},
  [2125] = {.lex_state = 84, .external_lex_state = 24},
  [2126] = {.lex_state = 84, .external_lex_state = 24},
  [2127] = {.lex_state = 216, .external_lex_state = 22},
  [2128] = {.lex_state = 83, .external_lex_state = 22},
  [2129] = {.lex_state = 216, .external_lex_state = 22},
  [2130] = {.lex_state = 216, .external_lex_state = 22},
  [2131] = {.lex_state = 216, .external_lex_state = 22},
  [2132] = {.lex_state = 82, .external_lex_state = 22},
  [2133] = {.lex_state = 216, .external_lex_state = 22},
  [2134] = {.lex_state = 82, .external_lex_state = 22},
  [2135] = {.lex_state = 216, .external_lex_state = 22},
  [2136] = {.lex_state = 216, .external_lex_state = 22},
  [2137] = {.lex_state = 101, .external_lex_state = 23},
  [2138] = {.lex_state = 101, .external_lex_state = 23},
  [2139] = {.lex_state = 82, .external_lex_state = 22},
  [2140] = {.lex_state = 82, .external_lex_state = 22},
  [2141] = {.lex_state = 220, .external_lex_state = 22},
  [2142] = {.lex_state = 220, .external_lex_state = 22},
  [2143] = {.lex_state = 101, .external_lex_state = 23},
  [2144] = {.lex_state = 101, .external_lex_state = 23},
  [2145] = {.lex_state = 82, .external_lex_state = 22},
  [2146] = {.lex_state = 101, .external_lex_state = 23},
  [2147] = {.lex_state = 220, .external_lex_state = 25},
  [2148] = {.lex_state = 84, .external_lex_state = 24},
  [2149] = {.lex_state = 84, .external_lex_state = 24},
  [2150] = {.lex_state = 84, .external_lex_state = 24},
  [2151] = {.lex_state = 84, .external_lex_state = 24},
  [2152] = {.lex_state = 84, .external_lex_state = 24},
  [2153] = {.lex_state = 84, .external_lex_state = 24},
  [2154] = {.lex_state = 220, .external_lex_state = 25},
  [2155] = {.lex_state = 84, .external_lex_state = 24},
  [2156] = {.lex_state = 84, .external_lex_state = 24},
  [2157] = {.lex_state = 84, .external_lex_state = 24},
  [2158] = {.lex_state = 82, .external_lex_state = 22},
  [2159] = {.lex_state = 220, .external_lex_state = 25},
  [2160] = {.lex_state = 82, .external_lex_state = 22},
  [2161] = {.lex_state = 220, .external_lex_state = 22},
  [2162] = {.lex_state = 82, .external_lex_state = 22},
  [2163] = {.lex_state = 220, .external_lex_state = 25},
  [2164] = {.lex_state = 82, .external_lex_state = 22},
  [2165] = {.lex_state = 82, .external_lex_state = 22},
  [2166] = {.lex_state = 82, .external_lex_state = 22},
  [2167] = {.lex_state = 82, .external_lex_state = 22},
  [2168] = {.lex_state = 82, .external_lex_state = 24},
  [2169] = {.lex_state = 82, .external_lex_state = 24},
  [2170] = {.lex_state = 82, .external_lex_state = 22},
  [2171] = {.lex_state = 220, .external_lex_state = 22},
  [2172] = {.lex_state = 220, .external_lex_state = 22},
  [2173] = {.lex_state = 220, .external_lex_state = 22},
  [2174] = {.lex_state = 220, .external_lex_state = 25},
  [2175] = {.lex_state = 82, .external_lex_state = 24},
  [2176] = {.lex_state = 220, .external_lex_state = 22},
  [2177] = {.lex_state = 84, .external_lex_state = 24},
  [2178] = {.lex_state = 220, .external_lex_state = 22},
  [2179] = {.lex_state = 220, .external_lex_state = 22},
  [2180] = {.lex_state = 220, .external_lex_state = 22},
  [2181] = {.lex_state = 220, .external_lex_state = 22},
  [2182] = {.lex_state = 220, .external_lex_state = 25},
  [2183] = {.lex_state = 220, .external_lex_state = 22},
  [2184] = {.lex_state = 220, .external_lex_state = 22},
  [2185] = {.lex_state = 84, .external_lex_state = 24},
  [2186] = {.lex_state = 220, .external_lex_state = 22},
  [2187] = {.lex_state = 84, .external_lex_state = 24},
  [2188] = {.lex_state = 220, .external_lex_state = 22},
  [2189] = {.lex_state = 82, .external_lex_state = 24},
  [2190] = {.lex_state = 84, .external_lex_state = 24},
  [2191] = {.lex_state = 82, .external_lex_state = 22},
  [2192] = {.lex_state = 220, .external_lex_state = 22},
  [2193] = {.lex_state = 84, .external_lex_state = 24},
  [2194] = {.lex_state = 220, .external_lex_state = 22},
  [2195] = {.lex_state = 82, .external_lex_state = 22},
  [2196] = {.lex_state = 220, .external_lex_state = 22},
  [2197] = {.lex_state = 88, .external_lex_state = 25},
  [2198] = {.lex_state = 82, .external_lex_state = 22},
  [2199] = {.lex_state = 231, .external_lex_state = 21},
  [2200] = {.lex_state = 82, .external_lex_state = 24},
  [2201] = {.lex_state = 220, .external_lex_state = 22},
  [2202] = {.lex_state = 88, .external_lex_state = 25},
  [2203] = {.lex_state = 220, .external_lex_state = 25},
  [2204] = {.lex_state = 220, .external_lex_state = 22},
  [2205] = {.lex_state = 220, .external_lex_state = 22},
  [2206] = {.lex_state = 220, .external_lex_state = 22},
  [2207] = {.lex_state = 220, .external_lex_state = 22},
  [2208] = {.lex_state = 220, .external_lex_state = 22},
  [2209] = {.lex_state = 220, .external_lex_state = 22},
  [2210] = {.lex_state = 220, .external_lex_state = 22},
  [2211] = {.lex_state = 220, .external_lex_state = 22},
  [2212] = {.lex_state = 220, .external_lex_state = 22},
  [2213] = {.lex_state = 220, .external_lex_state = 22},
  [2214] = {.lex_state = 220, .external_lex_state = 22},
  [2215] = {.lex_state = 220, .external_lex_state = 22},
  [2216] = {.lex_state = 220, .external_lex_state = 22},
  [2217] = {.lex_state = 220, .external_lex_state = 22},
  [2218] = {.lex_state = 220, .external_lex_state = 22},
  [2219] = {.lex_state = 220, .external_lex_state = 22},
  [2220] = {.lex_state = 220, .external_lex_state = 22},
  [2221] = {.lex_state = 220, .external_lex_state = 22},
  [2222] = {.lex_state = 220, .external_lex_state = 22},
  [2223] = {.lex_state = 220, .external_lex_state = 22},
  [2224] = {.lex_state = 220, .external_lex_state = 22},
  [2225] = {.lex_state = 220, .external_lex_state = 22},
  [2226] = {.lex_state = 220, .external_lex_state = 22},
  [2227] = {.lex_state = 220, .external_lex_state = 22},
  [2228] = {.lex_state = 220, .external_lex_state = 22},
  [2229] = {.lex_state = 220, .external_lex_state = 22},
  [2230] = {.lex_state = 220, .external_lex_state = 22},
  [2231] = {.lex_state = 83, .external_lex_state = 24},
  [2232] = {.lex_state = 220, .external_lex_state = 22},
  [2233] = {.lex_state = 220, .external_lex_state = 22},
  [2234] = {.lex_state = 220, .external_lex_state = 22},
  [2235] = {.lex_state = 82, .external_lex_state = 24},
  [2236] = {.lex_state = 220, .external_lex_state = 22},
  [2237] = {.lex_state = 220, .external_lex_state = 22},
  [2238] = {.lex_state = 220, .external_lex_state = 22},
  [2239] = {.lex_state = 220, .external_lex_state = 22},
  [2240] = {.lex_state = 82, .external_lex_state = 24},
  [2241] = {.lex_state = 220, .external_lex_state = 22},
  [2242] = {.lex_state = 220, .external_lex_state = 22},
  [2243] = {.lex_state = 220, .external_lex_state = 22},
  [2244] = {.lex_state = 220, .external_lex_state = 22},
  [2245] = {.lex_state = 220, .external_lex_state = 22},
  [2246] = {.lex_state = 220, .external_lex_state = 22},
  [2247] = {.lex_state = 220, .external_lex_state = 22},
  [2248] = {.lex_state = 220, .external_lex_state = 22},
  [2249] = {.lex_state = 220, .external_lex_state = 22},
  [2250] = {.lex_state = 220, .external_lex_state = 22},
  [2251] = {.lex_state = 220, .external_lex_state = 22},
  [2252] = {.lex_state = 220, .external_lex_state = 22},
  [2253] = {.lex_state = 82, .external_lex_state = 24},
  [2254] = {.lex_state = 220, .external_lex_state = 22},
  [2255] = {.lex_state = 220, .external_lex_state = 22},
  [2256] = {.lex_state = 220, .external_lex_state = 22},
  [2257] = {.lex_state = 82, .external_lex_state = 24},
  [2258] = {.lex_state = 82, .external_lex_state = 24},
  [2259] = {.lex_state = 220, .external_lex_state = 22},
  [2260] = {.lex_state = 220, .external_lex_state = 22},
  [2261] = {.lex_state = 220, .external_lex_state = 22},
  [2262] = {.lex_state = 220, .external_lex_state = 22},
  [2263] = {.lex_state = 82, .external_lex_state = 24},
  [2264] = {.lex_state = 220, .external_lex_state = 22},
  [2265] = {.lex_state = 220, .external_lex_state = 22},
  [2266] = {.lex_state = 82, .external_lex_state = 24},
  [2267] = {.lex_state = 220, .external_lex_state = 22},
  [2268] = {.lex_state = 220, .external_lex_state = 22},
  [2269] = {.lex_state = 220, .external_lex_state = 22},
  [2270] = {.lex_state = 220, .external_lex_state = 22},
  [2271] = {.lex_state = 220, .external_lex_state = 22},
  [2272] = {.lex_state = 82, .external_lex_state = 22},
  [2273] = {.lex_state = 82, .external_lex_state = 22},
  [2274] = {.lex_state = 220, .external_lex_state = 22},
  [2275] = {.lex_state = 220, .external_lex_state = 22},
  [2276] = {.lex_state = 220, .external_lex_state = 22},
  [2277] = {.lex_state = 220, .external_lex_state = 22},
  [2278] = {.lex_state = 220, .external_lex_state = 22},
  [2279] = {.lex_state = 220, .external_lex_state = 22},
  [2280] = {.lex_state = 220, .external_lex_state = 22},
  [2281] = {.lex_state = 220, .external_lex_state = 22},
  [2282] = {.lex_state = 220, .external_lex_state = 22},
  [2283] = {.lex_state = 220, .external_lex_state = 22},
  [2284] = {.lex_state = 220, .external_lex_state = 22},
  [2285] = {.lex_state = 220, .external_lex_state = 22},
  [2286] = {.lex_state = 220, .external_lex_state = 22},
  [2287] = {.lex_state = 220, .external_lex_state = 22},
  [2288] = {.lex_state = 220, .external_lex_state = 22},
  [2289] = {.lex_state = 220, .external_lex_state = 22},
  [2290] = {.lex_state = 220, .external_lex_state = 22},
  [2291] = {.lex_state = 220, .external_lex_state = 22},
  [2292] = {.lex_state = 220, .external_lex_state = 22},
  [2293] = {.lex_state = 220, .external_lex_state = 22},
  [2294] = {.lex_state = 220, .external_lex_state = 22},
  [2295] = {.lex_state = 220, .external_lex_state = 22},
  [2296] = {.lex_state = 220, .external_lex_state = 22},
  [2297] = {.lex_state = 220, .external_lex_state = 22},
  [2298] = {.lex_state = 220, .external_lex_state = 22},
  [2299] = {.lex_state = 220, .external_lex_state = 22},
  [2300] = {.lex_state = 220, .external_lex_state = 22},
  [2301] = {.lex_state = 220, .external_lex_state = 22},
  [2302] = {.lex_state = 220, .external_lex_state = 22},
  [2303] = {.lex_state = 220, .external_lex_state = 22},
  [2304] = {.lex_state = 220, .external_lex_state = 22},
  [2305] = {.lex_state = 220, .external_lex_state = 22},
  [2306] = {.lex_state = 220, .external_lex_state = 22},
  [2307] = {.lex_state = 220, .external_lex_state = 22},
  [2308] = {.lex_state = 220, .external_lex_state = 22},
  [2309] = {.lex_state = 220, .external_lex_state = 22},
  [2310] = {.lex_state = 220, .external_lex_state = 22},
  [2311] = {.lex_state = 220, .external_lex_state = 22},
  [2312] = {.lex_state = 220, .external_lex_state = 22},
  [2313] = {.lex_state = 220, .external_lex_state = 22},
  [2314] = {.lex_state = 220, .external_lex_state = 22},
  [2315] = {.lex_state = 220, .external_lex_state = 22},
  [2316] = {.lex_state = 220, .external_lex_state = 22},
  [2317] = {.lex_state = 220, .external_lex_state = 22},
  [2318] = {.lex_state = 220, .external_lex_state = 22},
  [2319] = {.lex_state = 220, .external_lex_state = 22},
  [2320] = {.lex_state = 220, .external_lex_state = 22},
  [2321] = {.lex_state = 220, .external_lex_state = 22},
  [2322] = {.lex_state = 220, .external_lex_state = 22},
  [2323] = {.lex_state = 220, .external_lex_state = 22},
  [2324] = {.lex_state = 220, .external_lex_state = 22},
  [2325] = {.lex_state = 220, .external_lex_state = 22},
  [2326] = {.lex_state = 220, .external_lex_state = 22},
  [2327] = {.lex_state = 220, .external_lex_state = 22},
  [2328] = {.lex_state = 220, .external_lex_state = 22},
  [2329] = {.lex_state = 220, .external_lex_state = 22},
  [2330] = {.lex_state = 220, .external_lex_state = 22},
  [2331] = {.lex_state = 220, .external_lex_state = 22},
  [2332] = {.lex_state = 220, .external_lex_state = 22},
  [2333] = {.lex_state = 220, .external_lex_state = 22},
  [2334] = {.lex_state = 220, .external_lex_state = 22},
  [2335] = {.lex_state = 220, .external_lex_state = 22},
  [2336] = {.lex_state = 220, .external_lex_state = 22},
  [2337] = {.lex_state = 220, .external_lex_state = 22},
  [2338] = {.lex_state = 220, .external_lex_state = 22},
  [2339] = {.lex_state = 220, .external_lex_state = 22},
  [2340] = {.lex_state = 220, .external_lex_state = 22},
  [2341] = {.lex_state = 220, .external_lex_state = 22},
  [2342] = {.lex_state = 220, .external_lex_state = 22},
  [2343] = {.lex_state = 220, .external_lex_state = 22},
  [2344] = {.lex_state = 220, .external_lex_state = 22},
  [2345] = {.lex_state = 220, .external_lex_state = 22},
  [2346] = {.lex_state = 220, .external_lex_state = 22},
  [2347] = {.lex_state = 82, .external_lex_state = 22},
  [2348] = {.lex_state = 220, .external_lex_state = 22},
  [2349] = {.lex_state = 220, .external_lex_state = 22},
  [2350] = {.lex_state = 220, .external_lex_state = 22},
  [2351] = {.lex_state = 220, .external_lex_state = 22},
  [2352] = {.lex_state = 83, .external_lex_state = 22},
  [2353] = {.lex_state = 220, .external_lex_state = 22},
  [2354] = {.lex_state = 220, .external_lex_state = 22},
  [2355] = {.lex_state = 220, .external_lex_state = 22},
  [2356] = {.lex_state = 220, .external_lex_state = 22},
  [2357] = {.lex_state = 220, .external_lex_state = 22},
  [2358] = {.lex_state = 220, .external_lex_state = 22},
  [2359] = {.lex_state = 220, .external_lex_state = 22},
  [2360] = {.lex_state = 220, .external_lex_state = 22},
  [2361] = {.lex_state = 220, .external_lex_state = 22},
  [2362] = {.lex_state = 220, .external_lex_state = 22},
  [2363] = {.lex_state = 220, .external_lex_state = 22},
  [2364] = {.lex_state = 220, .external_lex_state = 22},
  [2365] = {.lex_state = 220, .external_lex_state = 22},
  [2366] = {.lex_state = 220, .external_lex_state = 22},
  [2367] = {.lex_state = 220, .external_lex_state = 22},
  [2368] = {.lex_state = 220, .external_lex_state = 22},
  [2369] = {.lex_state = 82, .external_lex_state = 24},
  [2370] = {.lex_state = 88, .external_lex_state = 25},
  [2371] = {.lex_state = 82, .external_lex_state = 24},
  [2372] = {.lex_state = 82, .external_lex_state = 24},
  [2373] = {.lex_state = 82, .external_lex_state = 24},
  [2374] = {.lex_state = 82, .external_lex_state = 22},
  [2375] = {.lex_state = 82, .external_lex_state = 22},
  [2376] = {.lex_state = 83, .external_lex_state = 24},
  [2377] = {.lex_state = 82, .external_lex_state = 24},
  [2378] = {.lex_state = 82, .external_lex_state = 22},
  [2379] = {.lex_state = 82, .external_lex_state = 24},
  [2380] = {.lex_state = 82, .external_lex_state = 24},
  [2381] = {.lex_state = 93, .external_lex_state = 26},
  [2382] = {.lex_state = 93, .external_lex_state = 26},
  [2383] = {.lex_state = 93, .external_lex_state = 26},
  [2384] = {.lex_state = 82, .external_lex_state = 24},
  [2385] = {.lex_state = 93, .external_lex_state = 26},
  [2386] = {.lex_state = 82, .external_lex_state = 22},
  [2387] = {.lex_state = 88, .external_lex_state = 22},
  [2388] = {.lex_state = 93, .external_lex_state = 26},
  [2389] = {.lex_state = 88, .external_lex_state = 22},
  [2390] = {.lex_state = 82, .external_lex_state = 22},
  [2391] = {.lex_state = 88, .external_lex_state = 22},
  [2392] = {.lex_state = 82, .external_lex_state = 24},
  [2393] = {.lex_state = 82, .external_lex_state = 22},
  [2394] = {.lex_state = 93, .external_lex_state = 26},
  [2395] = {.lex_state = 220, .external_lex_state = 22},
  [2396] = {.lex_state = 88, .external_lex_state = 22},
  [2397] = {.lex_state = 82, .external_lex_state = 22},
  [2398] = {.lex_state = 88, .external_lex_state = 22},
  [2399] = {.lex_state = 93, .external_lex_state = 26},
  [2400] = {.lex_state = 93, .external_lex_state = 26},
  [2401] = {.lex_state = 93, .external_lex_state = 26},
  [2402] = {.lex_state = 93, .external_lex_state = 26},
  [2403] = {.lex_state = 93, .external_lex_state = 26},
  [2404] = {.lex_state = 93, .external_lex_state = 26},
  [2405] = {.lex_state = 93, .external_lex_state = 26},
  [2406] = {.lex_state = 93, .external_lex_state = 26},
  [2407] = {.lex_state = 93, .external_lex_state = 26},
  [2408] = {.lex_state = 93, .external_lex_state = 26},
  [2409] = {.lex_state = 93, .external_lex_state = 26},
  [2410] = {.lex_state = 82, .external_lex_state = 24},
  [2411] = {.lex_state = 93, .external_lex_state = 26},
  [2412] = {.lex_state = 93, .external_lex_state = 26},
  [2413] = {.lex_state = 82, .external_lex_state = 22},
  [2414] = {.lex_state = 93, .external_lex_state = 26},
  [2415] = {.lex_state = 93, .external_lex_state = 26},
  [2416] = {.lex_state = 93, .external_lex_state = 26},
  [2417] = {.lex_state = 93, .external_lex_state = 26},
  [2418] = {.lex_state = 93, .external_lex_state = 26},
  [2419] = {.lex_state = 82, .external_lex_state = 22},
  [2420] = {.lex_state = 88, .external_lex_state = 22},
  [2421] = {.lex_state = 88, .external_lex_state = 22},
  [2422] = {.lex_state = 88, .external_lex_state = 22},
  [2423] = {.lex_state = 88, .external_lex_state = 22},
  [2424] = {.lex_state = 88, .external_lex_state = 22},
  [2425] = {.lex_state = 88, .external_lex_state = 22},
  [2426] = {.lex_state = 82, .external_lex_state = 24},
  [2427] = {.lex_state = 88, .external_lex_state = 22},
  [2428] = {.lex_state = 88, .external_lex_state = 22},
  [2429] = {.lex_state = 88, .external_lex_state = 22},
  [2430] = {.lex_state = 88, .external_lex_state = 22},
  [2431] = {.lex_state = 88, .external_lex_state = 22},
  [2432] = {.lex_state = 83, .external_lex_state = 24},
  [2433] = {.lex_state = 88, .external_lex_state = 22},
  [2434] = {.lex_state = 88, .external_lex_state = 22},
  [2435] = {.lex_state = 88, .external_lex_state = 22},
  [2436] = {.lex_state = 82, .external_lex_state = 24},
  [2437] = {.lex_state = 83, .external_lex_state = 24},
  [2438] = {.lex_state = 88, .external_lex_state = 22},
  [2439] = {.lex_state = 88, .external_lex_state = 22},
  [2440] = {.lex_state = 88, .external_lex_state = 22},
  [2441] = {.lex_state = 88, .external_lex_state = 22},
  [2442] = {.lex_state = 88, .external_lex_state = 22},
  [2443] = {.lex_state = 82, .external_lex_state = 24},
  [2444] = {.lex_state = 88, .external_lex_state = 22},
  [2445] = {.lex_state = 88, .external_lex_state = 22},
  [2446] = {.lex_state = 82, .external_lex_state = 24},
  [2447] = {.lex_state = 88, .external_lex_state = 22},
  [2448] = {.lex_state = 88, .external_lex_state = 22},
  [2449] = {.lex_state = 82, .external_lex_state = 24},
  [2450] = {.lex_state = 88, .external_lex_state = 22},
  [2451] = {.lex_state = 88, .external_lex_state = 22},
  [2452] = {.lex_state = 82, .external_lex_state = 24},
  [2453] = {.lex_state = 88, .external_lex_state = 22},
  [2454] = {.lex_state = 88, .external_lex_state = 22},
  [2455] = {.lex_state = 88, .external_lex_state = 22},
  [2456] = {.lex_state = 82, .external_lex_state = 24},
  [2457] = {.lex_state = 88, .external_lex_state = 22},
  [2458] = {.lex_state = 82, .external_lex_state = 22},
  [2459] = {.lex_state = 82, .external_lex_state = 22},
  [2460] = {.lex_state = 88, .external_lex_state = 22},
  [2461] = {.lex_state = 101, .external_lex_state = 21},
  [2462] = {.lex_state = 88, .external_lex_state = 22},
  [2463] = {.lex_state = 220, .external_lex_state = 25},
  [2464] = {.lex_state = 222, .external_lex_state = 27},
  [2465] = {.lex_state = 222, .external_lex_state = 27},
  [2466] = {.lex_state = 82, .external_lex_state = 24},
  [2467] = {.lex_state = 82, .external_lex_state = 24},
  [2468] = {.lex_state = 222, .external_lex_state = 27},
  [2469] = {.lex_state = 88, .external_lex_state = 22},
  [2470] = {.lex_state = 88, .external_lex_state = 22},
  [2471] = {.lex_state = 82, .external_lex_state = 22},
  [2472] = {.lex_state = 222, .external_lex_state = 27},
  [2473] = {.lex_state = 222, .external_lex_state = 27},
  [2474] = {.lex_state = 222, .external_lex_state = 27},
  [2475] = {.lex_state = 82, .external_lex_state = 22},
  [2476] = {.lex_state = 222, .external_lex_state = 27},
  [2477] = {.lex_state = 88, .external_lex_state = 22},
  [2478] = {.lex_state = 82, .external_lex_state = 24},
  [2479] = {.lex_state = 88, .external_lex_state = 22},
  [2480] = {.lex_state = 88, .external_lex_state = 22},
  [2481] = {.lex_state = 88, .external_lex_state = 22},
  [2482] = {.lex_state = 84, .external_lex_state = 24},
  [2483] = {.lex_state = 88, .external_lex_state = 22},
  [2484] = {.lex_state = 88, .external_lex_state = 22},
  [2485] = {.lex_state = 88, .external_lex_state = 22},
  [2486] = {.lex_state = 88, .external_lex_state = 22},
  [2487] = {.lex_state = 88, .external_lex_state = 22},
  [2488] = {.lex_state = 84, .external_lex_state = 24},
  [2489] = {.lex_state = 88, .external_lex_state = 22},
  [2490] = {.lex_state = 88, .external_lex_state = 22},
  [2491] = {.lex_state = 88, .external_lex_state = 22},
  [2492] = {.lex_state = 88, .external_lex_state = 22},
  [2493] = {.lex_state = 88, .external_lex_state = 22},
  [2494] = {.lex_state = 84, .external_lex_state = 24},
  [2495] = {.lex_state = 88, .external_lex_state = 22},
  [2496] = {.lex_state = 88, .external_lex_state = 22},
  [2497] = {.lex_state = 88, .external_lex_state = 22},
  [2498] = {.lex_state = 88, .external_lex_state = 22},
  [2499] = {.lex_state = 84, .external_lex_state = 24},
  [2500] = {.lex_state = 88, .external_lex_state = 22},
  [2501] = {.lex_state = 88, .external_lex_state = 22},
  [2502] = {.lex_state = 88, .external_lex_state = 22},
  [2503] = {.lex_state = 220, .external_lex_state = 25},
  [2504] = {.lex_state = 88, .external_lex_state = 22},
  [2505] = {.lex_state = 88, .external_lex_state = 22},
  [2506] = {.lex_state = 88, .external_lex_state = 22},
  [2507] = {.lex_state = 88, .external_lex_state = 22},
  [2508] = {.lex_state = 88, .external_lex_state = 22},
  [2509] = {.lex_state = 93, .external_lex_state = 26},
  [2510] = {.lex_state = 93, .external_lex_state = 26},
  [2511] = {.lex_state = 93, .external_lex_state = 26},
  [2512] = {.lex_state = 93, .external_lex_state = 26},
  [2513] = {.lex_state = 88, .external_lex_state = 22},
  [2514] = {.lex_state = 93, .external_lex_state = 26},
  [2515] = {.lex_state = 93, .external_lex_state = 26},
  [2516] = {.lex_state = 93, .external_lex_state = 26},
  [2517] = {.lex_state = 84, .external_lex_state = 24},
  [2518] = {.lex_state = 88, .external_lex_state = 22},
  [2519] = {.lex_state = 88, .external_lex_state = 22},
  [2520] = {.lex_state = 88, .external_lex_state = 22},
  [2521] = {.lex_state = 88, .external_lex_state = 22},
  [2522] = {.lex_state = 88, .external_lex_state = 22},
  [2523] = {.lex_state = 88, .external_lex_state = 22},
  [2524] = {.lex_state = 88, .external_lex_state = 22},
  [2525] = {.lex_state = 88, .external_lex_state = 22},
  [2526] = {.lex_state = 88, .external_lex_state = 22},
  [2527] = {.lex_state = 88, .external_lex_state = 22},
  [2528] = {.lex_state = 88, .external_lex_state = 22},
  [2529] = {.lex_state = 88, .external_lex_state = 22},
  [2530] = {.lex_state = 92, .external_lex_state = 27},
  [2531] = {.lex_state = 88, .external_lex_state = 22},
  [2532] = {.lex_state = 92, .external_lex_state = 27},
  [2533] = {.lex_state = 93, .external_lex_state = 26},
  [2534] = {.lex_state = 93, .external_lex_state = 26},
  [2535] = {.lex_state = 93, .external_lex_state = 26},
  [2536] = {.lex_state = 88, .external_lex_state = 22},
  [2537] = {.lex_state = 93, .external_lex_state = 26},
  [2538] = {.lex_state = 88, .external_lex_state = 22},
  [2539] = {.lex_state = 88, .external_lex_state = 22},
  [2540] = {.lex_state = 88, .external_lex_state = 22},
  [2541] = {.lex_state = 93, .external_lex_state = 26},
  [2542] = {.lex_state = 93, .external_lex_state = 26},
  [2543] = {.lex_state = 88, .external_lex_state = 22},
  [2544] = {.lex_state = 93, .external_lex_state = 26},
  [2545] = {.lex_state = 93, .external_lex_state = 26},
  [2546] = {.lex_state = 93, .external_lex_state = 26},
  [2547] = {.lex_state = 93, .external_lex_state = 26},
  [2548] = {.lex_state = 93, .external_lex_state = 26},
  [2549] = {.lex_state = 93, .external_lex_state = 26},
  [2550] = {.lex_state = 93, .external_lex_state = 26},
  [2551] = {.lex_state = 101, .external_lex_state = 23},
  [2552] = {.lex_state = 93, .external_lex_state = 26},
  [2553] = {.lex_state = 93, .external_lex_state = 26},
  [2554] = {.lex_state = 93, .external_lex_state = 26},
  [2555] = {.lex_state = 93, .external_lex_state = 26},
  [2556] = {.lex_state = 93, .external_lex_state = 26},
  [2557] = {.lex_state = 93, .external_lex_state = 26},
  [2558] = {.lex_state = 93, .external_lex_state = 26},
  [2559] = {.lex_state = 84, .external_lex_state = 24},
  [2560] = {.lex_state = 84, .external_lex_state = 24},
  [2561] = {.lex_state = 88, .external_lex_state = 22},
  [2562] = {.lex_state = 93, .external_lex_state = 26},
  [2563] = {.lex_state = 93, .external_lex_state = 26},
  [2564] = {.lex_state = 88, .external_lex_state = 22},
  [2565] = {.lex_state = 84, .external_lex_state = 24},
  [2566] = {.lex_state = 88, .external_lex_state = 22},
  [2567] = {.lex_state = 93, .external_lex_state = 26},
  [2568] = {.lex_state = 93, .external_lex_state = 26},
  [2569] = {.lex_state = 93, .external_lex_state = 26},
  [2570] = {.lex_state = 93, .external_lex_state = 26},
  [2571] = {.lex_state = 93, .external_lex_state = 26},
  [2572] = {.lex_state = 92, .external_lex_state = 27},
  [2573] = {.lex_state = 93, .external_lex_state = 26},
  [2574] = {.lex_state = 101, .external_lex_state = 23},
  [2575] = {.lex_state = 93, .external_lex_state = 26},
  [2576] = {.lex_state = 93, .external_lex_state = 26},
  [2577] = {.lex_state = 93, .external_lex_state = 26},
  [2578] = {.lex_state = 92, .external_lex_state = 27},
  [2579] = {.lex_state = 93, .external_lex_state = 26},
  [2580] = {.lex_state = 92, .external_lex_state = 27},
  [2581] = {.lex_state = 93, .external_lex_state = 26},
  [2582] = {.lex_state = 93, .external_lex_state = 26},
  [2583] = {.lex_state = 93, .external_lex_state = 26},
  [2584] = {.lex_state = 93, .external_lex_state = 26},
  [2585] = {.lex_state = 88, .external_lex_state = 22},
  [2586] = {.lex_state = 93, .external_lex_state = 26},
  [2587] = {.lex_state = 93, .external_lex_state = 26},
  [2588] = {.lex_state = 220, .external_lex_state = 25},
  [2589] = {.lex_state = 93, .external_lex_state = 26},
  [2590] = {.lex_state = 93, .external_lex_state = 26},
  [2591] = {.lex_state = 93, .external_lex_state = 26},
  [2592] = {.lex_state = 92, .external_lex_state = 27},
  [2593] = {.lex_state = 220, .external_lex_state = 22},
  [2594] = {.lex_state = 92, .external_lex_state = 27},
  [2595] = {.lex_state = 220, .external_lex_state = 22},
  [2596] = {.lex_state = 93, .external_lex_state = 26},
  [2597] = {.lex_state = 92, .external_lex_state = 27},
  [2598] = {.lex_state = 92, .external_lex_state = 27},
  [2599] = {.lex_state = 92, .external_lex_state = 27},
  [2600] = {.lex_state = 92, .external_lex_state = 27},
  [2601] = {.lex_state = 92, .external_lex_state = 27},
  [2602] = {.lex_state = 220, .external_lex_state = 22},
  [2603] = {.lex_state = 220, .external_lex_state = 22},
  [2604] = {.lex_state = 93, .external_lex_state = 26},
  [2605] = {.lex_state = 93, .external_lex_state = 26},
  [2606] = {.lex_state = 92, .external_lex_state = 27},
  [2607] = {.lex_state = 92, .external_lex_state = 27},
  [2608] = {.lex_state = 92, .external_lex_state = 27},
  [2609] = {.lex_state = 92, .external_lex_state = 27},
  [2610] = {.lex_state = 92, .external_lex_state = 27},
  [2611] = {.lex_state = 93, .external_lex_state = 26},
  [2612] = {.lex_state = 92, .external_lex_state = 27},
  [2613] = {.lex_state = 92, .external_lex_state = 27},
  [2614] = {.lex_state = 93, .external_lex_state = 26},
  [2615] = {.lex_state = 93, .external_lex_state = 26},
  [2616] = {.lex_state = 93, .external_lex_state = 26},
  [2617] = {.lex_state = 93, .external_lex_state = 26},
  [2618] = {.lex_state = 92, .external_lex_state = 27},
  [2619] = {.lex_state = 92, .external_lex_state = 27},
  [2620] = {.lex_state = 92, .external_lex_state = 27},
  [2621] = {.lex_state = 92, .external_lex_state = 27},
  [2622] = {.lex_state = 92, .external_lex_state = 27},
  [2623] = {.lex_state = 92, .external_lex_state = 27},
  [2624] = {.lex_state = 92, .external_lex_state = 27},
  [2625] = {.lex_state = 92, .external_lex_state = 27},
  [2626] = {.lex_state = 92, .external_lex_state = 27},
  [2627] = {.lex_state = 92, .external_lex_state = 27},
  [2628] = {.lex_state = 92, .external_lex_state = 27},
  [2629] = {.lex_state = 92, .external_lex_state = 27},
  [2630] = {.lex_state = 92, .external_lex_state = 27},
  [2631] = {.lex_state = 92, .external_lex_state = 27},
  [2632] = {.lex_state = 92, .external_lex_state = 27},
  [2633] = {.lex_state = 220, .external_lex_state = 22},
  [2634] = {.lex_state = 92, .external_lex_state = 27},
  [2635] = {.lex_state = 220, .external_lex_state = 22},
  [2636] = {.lex_state = 220, .external_lex_state = 22},
  [2637] = {.lex_state = 92, .external_lex_state = 27},
  [2638] = {.lex_state = 220, .external_lex_state = 22},
  [2639] = {.lex_state = 220, .external_lex_state = 22},
  [2640] = {.lex_state = 220, .external_lex_state = 22},
  [2641] = {.lex_state = 220, .external_lex_state = 22},
  [2642] = {.lex_state = 220, .external_lex_state = 22},
  [2643] = {.lex_state = 220, .external_lex_state = 22},
  [2644] = {.lex_state = 220, .external_lex_state = 22},
  [2645] = {.lex_state = 220, .external_lex_state = 22},
  [2646] = {.lex_state = 220, .external_lex_state = 22},
  [2647] = {.lex_state = 220, .external_lex_state = 22},
  [2648] = {.lex_state = 220, .external_lex_state = 22},
  [2649] = {.lex_state = 220, .external_lex_state = 22},
  [2650] = {.lex_state = 220, .external_lex_state = 22},
  [2651] = {.lex_state = 220, .external_lex_state = 22},
  [2652] = {.lex_state = 220, .external_lex_state = 22},
  [2653] = {.lex_state = 220, .external_lex_state = 22},
  [2654] = {.lex_state = 92, .external_lex_state = 27},
  [2655] = {.lex_state = 220, .external_lex_state = 22},
  [2656] = {.lex_state = 92, .external_lex_state = 27},
  [2657] = {.lex_state = 220, .external_lex_state = 22},
  [2658] = {.lex_state = 92, .external_lex_state = 27},
  [2659] = {.lex_state = 220, .external_lex_state = 22},
  [2660] = {.lex_state = 220, .external_lex_state = 22},
  [2661] = {.lex_state = 220, .external_lex_state = 22},
  [2662] = {.lex_state = 220, .external_lex_state = 22},
  [2663] = {.lex_state = 92, .external_lex_state = 27},
  [2664] = {.lex_state = 92, .external_lex_state = 27},
  [2665] = {.lex_state = 92, .external_lex_state = 27},
  [2666] = {.lex_state = 92, .external_lex_state = 27},
  [2667] = {.lex_state = 89, .external_lex_state = 24},
  [2668] = {.lex_state = 92, .external_lex_state = 27},
  [2669] = {.lex_state = 92, .external_lex_state = 27},
  [2670] = {.lex_state = 92, .external_lex_state = 27},
  [2671] = {.lex_state = 88, .external_lex_state = 25},
  [2672] = {.lex_state = 92, .external_lex_state = 27},
  [2673] = {.lex_state = 220, .external_lex_state = 22},
  [2674] = {.lex_state = 220, .external_lex_state = 22},
  [2675] = {.lex_state = 220, .external_lex_state = 22},
  [2676] = {.lex_state = 92, .external_lex_state = 27},
  [2677] = {.lex_state = 92, .external_lex_state = 27},
  [2678] = {.lex_state = 92, .external_lex_state = 27},
  [2679] = {.lex_state = 92, .external_lex_state = 27},
  [2680] = {.lex_state = 92, .external_lex_state = 27},
  [2681] = {.lex_state = 92, .external_lex_state = 27},
  [2682] = {.lex_state = 92, .external_lex_state = 27},
  [2683] = {.lex_state = 92, .external_lex_state = 27},
  [2684] = {.lex_state = 220, .external_lex_state = 22},
  [2685] = {.lex_state = 220, .external_lex_state = 22},
  [2686] = {.lex_state = 92, .external_lex_state = 27},
  [2687] = {.lex_state = 220, .external_lex_state = 22},
  [2688] = {.lex_state = 92, .external_lex_state = 27},
  [2689] = {.lex_state = 92, .external_lex_state = 27},
  [2690] = {.lex_state = 92, .external_lex_state = 27},
  [2691] = {.lex_state = 88, .external_lex_state = 25},
  [2692] = {.lex_state = 92, .external_lex_state = 27},
  [2693] = {.lex_state = 92, .external_lex_state = 27},
  [2694] = {.lex_state = 92, .external_lex_state = 27},
  [2695] = {.lex_state = 220, .external_lex_state = 22},
  [2696] = {.lex_state = 92, .external_lex_state = 27},
  [2697] = {.lex_state = 92, .external_lex_state = 27},
  [2698] = {.lex_state = 92, .external_lex_state = 27},
  [2699] = {.lex_state = 92, .external_lex_state = 27},
  [2700] = {.lex_state = 92, .external_lex_state = 27},
  [2701] = {.lex_state = 92, .external_lex_state = 27},
  [2702] = {.lex_state = 92, .external_lex_state = 27},
  [2703] = {.lex_state = 92, .external_lex_state = 27},
  [2704] = {.lex_state = 92, .external_lex_state = 27},
  [2705] = {.lex_state = 92, .external_lex_state = 27},
  [2706] = {.lex_state = 220, .external_lex_state = 22},
  [2707] = {.lex_state = 92, .external_lex_state = 27},
  [2708] = {.lex_state = 220, .external_lex_state = 22},
  [2709] = {.lex_state = 88, .external_lex_state = 25},
  [2710] = {.lex_state = 92, .external_lex_state = 27},
  [2711] = {.lex_state = 92, .external_lex_state = 27},
  [2712] = {.lex_state = 89, .external_lex_state = 24},
  [2713] = {.lex_state = 88, .external_lex_state = 28},
  [2714] = {.lex_state = 220, .external_lex_state = 22},
  [2715] = {.lex_state = 220, .external_lex_state = 22},
  [2716] = {.lex_state = 92, .external_lex_state = 27},
  [2717] = {.lex_state = 92, .external_lex_state = 27},
  [2718] = {.lex_state = 89, .external_lex_state = 24},
  [2719] = {.lex_state = 220, .external_lex_state = 22},
  [2720] = {.lex_state = 220, .external_lex_state = 22},
  [2721] = {.lex_state = 220, .external_lex_state = 22},
  [2722] = {.lex_state = 220, .external_lex_state = 22},
  [2723] = {.lex_state = 220, .external_lex_state = 22},
  [2724] = {.lex_state = 92, .external_lex_state = 27},
  [2725] = {.lex_state = 220, .external_lex_state = 22},
  [2726] = {.lex_state = 220, .external_lex_state = 22},
  [2727] = {.lex_state = 89, .external_lex_state = 24},
  [2728] = {.lex_state = 92, .external_lex_state = 27},
  [2729] = {.lex_state = 220, .external_lex_state = 22},
  [2730] = {.lex_state = 220, .external_lex_state = 22},
  [2731] = {.lex_state = 92, .external_lex_state = 27},
  [2732] = {.lex_state = 92, .external_lex_state = 27},
  [2733] = {.lex_state = 220, .external_lex_state = 22},
  [2734] = {.lex_state = 92, .external_lex_state = 27},
  [2735] = {.lex_state = 88, .external_lex_state = 25},
  [2736] = {.lex_state = 89, .external_lex_state = 24},
  [2737] = {.lex_state = 88, .external_lex_state = 28},
  [2738] = {.lex_state = 92, .external_lex_state = 27},
  [2739] = {.lex_state = 92, .external_lex_state = 27},
  [2740] = {.lex_state = 92, .external_lex_state = 27},
  [2741] = {.lex_state = 92, .external_lex_state = 27},
  [2742] = {.lex_state = 92, .external_lex_state = 27},
  [2743] = {.lex_state = 92, .external_lex_state = 27},
  [2744] = {.lex_state = 92, .external_lex_state = 27},
  [2745] = {.lex_state = 92, .external_lex_state = 27},
  [2746] = {.lex_state = 92, .external_lex_state = 27},
  [2747] = {.lex_state = 89, .external_lex_state = 24},
  [2748] = {.lex_state = 89, .external_lex_state = 24},
  [2749] = {.lex_state = 92, .external_lex_state = 27},
  [2750] = {.lex_state = 220, .external_lex_state = 22},
  [2751] = {.lex_state = 92, .external_lex_state = 27},
  [2752] = {.lex_state = 92, .external_lex_state = 27},
  [2753] = {.lex_state = 92, .external_lex_state = 27},
  [2754] = {.lex_state = 92, .external_lex_state = 27},
  [2755] = {.lex_state = 88, .external_lex_state = 28},
  [2756] = {.lex_state = 220, .external_lex_state = 22},
  [2757] = {.lex_state = 88, .external_lex_state = 25},
  [2758] = {.lex_state = 89, .external_lex_state = 24},
  [2759] = {.lex_state = 220, .external_lex_state = 22},
  [2760] = {.lex_state = 92, .external_lex_state = 27},
  [2761] = {.lex_state = 220, .external_lex_state = 22},
  [2762] = {.lex_state = 220, .external_lex_state = 22},
  [2763] = {.lex_state = 89, .external_lex_state = 24},
  [2764] = {.lex_state = 92, .external_lex_state = 27},
  [2765] = {.lex_state = 92, .external_lex_state = 27},
  [2766] = {.lex_state = 92, .external_lex_state = 27},
  [2767] = {.lex_state = 220, .external_lex_state = 22},
  [2768] = {.lex_state = 89, .external_lex_state = 24},
  [2769] = {.lex_state = 92, .external_lex_state = 27},
  [2770] = {.lex_state = 220, .external_lex_state = 22},
  [2771] = {.lex_state = 92, .external_lex_state = 27},
  [2772] = {.lex_state = 89, .external_lex_state = 24},
  [2773] = {.lex_state = 220, .external_lex_state = 22},
  [2774] = {.lex_state = 220, .external_lex_state = 22},
  [2775] = {.lex_state = 89, .external_lex_state = 24},
  [2776] = {.lex_state = 220, .external_lex_state = 22},
  [2777] = {.lex_state = 92, .external_lex_state = 27},
  [2778] = {.lex_state = 92, .external_lex_state = 27},
  [2779] = {.lex_state = 220, .external_lex_state = 22},
  [2780] = {.lex_state = 220, .external_lex_state = 22},
  [2781] = {.lex_state = 92, .external_lex_state = 27},
  [2782] = {.lex_state = 220, .external_lex_state = 22},
  [2783] = {.lex_state = 220, .external_lex_state = 22},
  [2784] = {.lex_state = 88, .external_lex_state = 24},
  [2785] = {.lex_state = 222, .external_lex_state = 27},
  [2786] = {.lex_state = 220, .external_lex_state = 22},
  [2787] = {.lex_state = 220, .external_lex_state = 22},
  [2788] = {.lex_state = 88, .external_lex_state = 25},
  [2789] = {.lex_state = 220, .external_lex_state = 22},
  [2790] = {.lex_state = 220, .external_lex_state = 22},
  [2791] = {.lex_state = 89, .external_lex_state = 28},
  [2792] = {.lex_state = 220, .external_lex_state = 22},
  [2793] = {.lex_state = 88, .external_lex_state = 22},
  [2794] = {.lex_state = 222, .external_lex_state = 27},
  [2795] = {.lex_state = 220, .external_lex_state = 22},
  [2796] = {.lex_state = 222, .external_lex_state = 27},
  [2797] = {.lex_state = 88, .external_lex_state = 22},
  [2798] = {.lex_state = 89, .external_lex_state = 24},
  [2799] = {.lex_state = 88, .external_lex_state = 28},
  [2800] = {.lex_state = 220, .external_lex_state = 22},
  [2801] = {.lex_state = 220, .external_lex_state = 22},
  [2802] = {.lex_state = 220, .external_lex_state = 22},
  [2803] = {.lex_state = 220, .external_lex_state = 22},
  [2804] = {.lex_state = 88, .external_lex_state = 22},
  [2805] = {.lex_state = 220, .external_lex_state = 22},
  [2806] = {.lex_state = 220, .external_lex_state = 22},
  [2807] = {.lex_state = 88, .external_lex_state = 28},
  [2808] = {.lex_state = 88, .external_lex_state = 22},
  [2809] = {.lex_state = 88, .external_lex_state = 24},
  [2810] = {.lex_state = 220, .external_lex_state = 22},
  [2811] = {.lex_state = 88, .external_lex_state = 22},
  [2812] = {.lex_state = 220, .external_lex_state = 22},
  [2813] = {.lex_state = 220, .external_lex_state = 22},
  [2814] = {.lex_state = 220, .external_lex_state = 22},
  [2815] = {.lex_state = 222, .external_lex_state = 27},
  [2816] = {.lex_state = 88, .external_lex_state = 22},
  [2817] = {.lex_state = 220, .external_lex_state = 22},
  [2818] = {.lex_state = 220, .external_lex_state = 22},
  [2819] = {.lex_state = 220, .external_lex_state = 22},
  [2820] = {.lex_state = 88, .external_lex_state = 24},
  [2821] = {.lex_state = 88, .external_lex_state = 22},
  [2822] = {.lex_state = 222, .external_lex_state = 27},
  [2823] = {.lex_state = 88, .external_lex_state = 22},
  [2824] = {.lex_state = 88, .external_lex_state = 28},
  [2825] = {.lex_state = 92, .external_lex_state = 27},
  [2826] = {.lex_state = 220, .external_lex_state = 22},
  [2827] = {.lex_state = 89, .external_lex_state = 24},
  [2828] = {.lex_state = 220, .external_lex_state = 22},
  [2829] = {.lex_state = 220, .external_lex_state = 22},
  [2830] = {.lex_state = 220, .external_lex_state = 22},
  [2831] = {.lex_state = 89, .external_lex_state = 24},
  [2832] = {.lex_state = 89, .external_lex_state = 24},
  [2833] = {.lex_state = 89, .external_lex_state = 24},
  [2834] = {.lex_state = 89, .external_lex_state = 24},
  [2835] = {.lex_state = 88, .external_lex_state = 22},
  [2836] = {.lex_state = 88, .external_lex_state = 28},
  [2837] = {.lex_state = 89, .external_lex_state = 24},
  [2838] = {.lex_state = 89, .external_lex_state = 24},
  [2839] = {.lex_state = 89, .external_lex_state = 24},
  [2840] = {.lex_state = 89, .external_lex_state = 24},
  [2841] = {.lex_state = 89, .external_lex_state = 24},
  [2842] = {.lex_state = 89, .external_lex_state = 24},
  [2843] = {.lex_state = 89, .external_lex_state = 24},
  [2844] = {.lex_state = 89, .external_lex_state = 24},
  [2845] = {.lex_state = 89, .external_lex_state = 24},
  [2846] = {.lex_state = 89, .external_lex_state = 24},
  [2847] = {.lex_state = 89, .external_lex_state = 24},
  [2848] = {.lex_state = 89, .external_lex_state = 24},
  [2849] = {.lex_state = 222, .external_lex_state = 27},
  [2850] = {.lex_state = 222, .external_lex_state = 27},
  [2851] = {.lex_state = 88, .external_lex_state = 28},
  [2852] = {.lex_state = 222, .external_lex_state = 27},
  [2853] = {.lex_state = 88, .external_lex_state = 28},
  [2854] = {.lex_state = 89, .external_lex_state = 24},
  [2855] = {.lex_state = 89, .external_lex_state = 24},
  [2856] = {.lex_state = 222, .external_lex_state = 27},
  [2857] = {.lex_state = 89, .external_lex_state = 24},
  [2858] = {.lex_state = 222, .external_lex_state = 27},
  [2859] = {.lex_state = 222, .external_lex_state = 27},
  [2860] = {.lex_state = 89, .external_lex_state = 24},
  [2861] = {.lex_state = 222, .external_lex_state = 27},
  [2862] = {.lex_state = 89, .external_lex_state = 24},
  [2863] = {.lex_state = 222, .external_lex_state = 27},
  [2864] = {.lex_state = 89, .external_lex_state = 24},
  [2865] = {.lex_state = 89, .external_lex_state = 24},
  [2866] = {.lex_state = 89, .external_lex_state = 24},
  [2867] = {.lex_state = 89, .external_lex_state = 24},
  [2868] = {.lex_state = 222, .external_lex_state = 27},
  [2869] = {.lex_state = 89, .external_lex_state = 24},
  [2870] = {.lex_state = 89, .external_lex_state = 24},
  [2871] = {.lex_state = 89, .external_lex_state = 24},
  [2872] = {.lex_state = 89, .external_lex_state = 24},
  [2873] = {.lex_state = 89, .external_lex_state = 24},
  [2874] = {.lex_state = 89, .external_lex_state = 24},
  [2875] = {.lex_state = 89, .external_lex_state = 24},
  [2876] = {.lex_state = 89, .external_lex_state = 24},
  [2877] = {.lex_state = 89, .external_lex_state = 24},
  [2878] = {.lex_state = 89, .external_lex_state = 24},
  [2879] = {.lex_state = 89, .external_lex_state = 24},
  [2880] = {.lex_state = 89, .external_lex_state = 24},
  [2881] = {.lex_state = 89, .external_lex_state = 24},
  [2882] = {.lex_state = 89, .external_lex_state = 24},
  [2883] = {.lex_state = 89, .external_lex_state = 24},
  [2884] = {.lex_state = 89, .external_lex_state = 24},
  [2885] = {.lex_state = 89, .external_lex_state = 24},
  [2886] = {.lex_state = 89, .external_lex_state = 24},
  [2887] = {.lex_state = 89, .external_lex_state = 24},
  [2888] = {.lex_state = 89, .external_lex_state = 24},
  [2889] = {.lex_state = 89, .external_lex_state = 24},
  [2890] = {.lex_state = 89, .external_lex_state = 24},
  [2891] = {.lex_state = 222, .external_lex_state = 27},
  [2892] = {.lex_state = 222, .external_lex_state = 27},
  [2893] = {.lex_state = 89, .external_lex_state = 24},
  [2894] = {.lex_state = 89, .external_lex_state = 24},
  [2895] = {.lex_state = 89, .external_lex_state = 24},
  [2896] = {.lex_state = 89, .external_lex_state = 24},
  [2897] = {.lex_state = 222, .external_lex_state = 27},
  [2898] = {.lex_state = 222, .external_lex_state = 27},
  [2899] = {.lex_state = 89, .external_lex_state = 24},
  [2900] = {.lex_state = 89, .external_lex_state = 24},
  [2901] = {.lex_state = 89, .external_lex_state = 24},
  [2902] = {.lex_state = 89, .external_lex_state = 24},
  [2903] = {.lex_state = 89, .external_lex_state = 24},
  [2904] = {.lex_state = 89, .external_lex_state = 24},
  [2905] = {.lex_state = 89, .external_lex_state = 24},
  [2906] = {.lex_state = 89, .external_lex_state = 24},
  [2907] = {.lex_state = 89, .external_lex_state = 24},
  [2908] = {.lex_state = 89, .external_lex_state = 24},
  [2909] = {.lex_state = 89, .external_lex_state = 24},
  [2910] = {.lex_state = 89, .external_lex_state = 24},
  [2911] = {.lex_state = 88, .external_lex_state = 22},
  [2912] = {.lex_state = 88, .external_lex_state = 22},
  [2913] = {.lex_state = 88, .external_lex_state = 22},
  [2914] = {.lex_state = 88, .external_lex_state = 22},
  [2915] = {.lex_state = 88, .external_lex_state = 22},
  [2916] = {.lex_state = 89, .external_lex_state = 24},
  [2917] = {.lex_state = 88, .external_lex_state = 22},
  [2918] = {.lex_state = 88, .external_lex_state = 22},
  [2919] = {.lex_state = 88, .external_lex_state = 22},
  [2920] = {.lex_state = 88, .external_lex_state = 22},
  [2921] = {.lex_state = 89, .external_lex_state = 24},
  [2922] = {.lex_state = 89, .external_lex_state = 24},
  [2923] = {.lex_state = 89, .external_lex_state = 24},
  [2924] = {.lex_state = 89, .external_lex_state = 24},
  [2925] = {.lex_state = 89, .external_lex_state = 24},
  [2926] = {.lex_state = 89, .external_lex_state = 24},
  [2927] = {.lex_state = 89, .external_lex_state = 24},
  [2928] = {.lex_state = 88, .external_lex_state = 25},
  [2929] = {.lex_state = 89, .external_lex_state = 24},
  [2930] = {.lex_state = 88, .external_lex_state = 22},
  [2931] = {.lex_state = 89, .external_lex_state = 24},
  [2932] = {.lex_state = 89, .external_lex_state = 24},
  [2933] = {.lex_state = 89, .external_lex_state = 24},
  [2934] = {.lex_state = 222, .external_lex_state = 27},
  [2935] = {.lex_state = 89, .external_lex_state = 24},
  [2936] = {.lex_state = 222, .external_lex_state = 27},
  [2937] = {.lex_state = 89, .external_lex_state = 24},
  [2938] = {.lex_state = 89, .external_lex_state = 24},
  [2939] = {.lex_state = 89, .external_lex_state = 24},
  [2940] = {.lex_state = 89, .external_lex_state = 24},
  [2941] = {.lex_state = 89, .external_lex_state = 24},
  [2942] = {.lex_state = 222, .external_lex_state = 27},
  [2943] = {.lex_state = 89, .external_lex_state = 24},
  [2944] = {.lex_state = 89, .external_lex_state = 24},
  [2945] = {.lex_state = 222, .external_lex_state = 27},
  [2946] = {.lex_state = 89, .external_lex_state = 24},
  [2947] = {.lex_state = 89, .external_lex_state = 24},
  [2948] = {.lex_state = 89, .external_lex_state = 24},
  [2949] = {.lex_state = 89, .external_lex_state = 24},
  [2950] = {.lex_state = 89, .external_lex_state = 24},
  [2951] = {.lex_state = 89, .external_lex_state = 24},
  [2952] = {.lex_state = 89, .external_lex_state = 24},
  [2953] = {.lex_state = 89, .external_lex_state = 24},
  [2954] = {.lex_state = 89, .external_lex_state = 24},
  [2955] = {.lex_state = 89, .external_lex_state = 24},
  [2956] = {.lex_state = 89, .external_lex_state = 24},
  [2957] = {.lex_state = 89, .external_lex_state = 24},
  [2958] = {.lex_state = 89, .external_lex_state = 24},
  [2959] = {.lex_state = 89, .external_lex_state = 24},
  [2960] = {.lex_state = 89, .external_lex_state = 24},
  [2961] = {.lex_state = 89, .external_lex_state = 24},
  [2962] = {.lex_state = 89, .external_lex_state = 24},
  [2963] = {.lex_state = 89, .external_lex_state = 24},
  [2964] = {.lex_state = 222, .external_lex_state = 27},
  [2965] = {.lex_state = 89, .external_lex_state = 24},
  [2966] = {.lex_state = 222, .external_lex_state = 27},
  [2967] = {.lex_state = 89, .external_lex_state = 24},
  [2968] = {.lex_state = 89, .external_lex_state = 24},
  [2969] = {.lex_state = 89, .external_lex_state = 24},
  [2970] = {.lex_state = 88, .external_lex_state = 22},
  [2971] = {.lex_state = 89, .external_lex_state = 24},
  [2972] = {.lex_state = 89, .external_lex_state = 24},
  [2973] = {.lex_state = 89, .external_lex_state = 24},
  [2974] = {.lex_state = 89, .external_lex_state = 24},
  [2975] = {.lex_state = 89, .external_lex_state = 24},
  [2976] = {.lex_state = 89, .external_lex_state = 24},
  [2977] = {.lex_state = 89, .external_lex_state = 24},
  [2978] = {.lex_state = 88, .external_lex_state = 22},
  [2979] = {.lex_state = 88, .external_lex_state = 22},
  [2980] = {.lex_state = 88, .external_lex_state = 22},
  [2981] = {.lex_state = 88, .external_lex_state = 22},
  [2982] = {.lex_state = 88, .external_lex_state = 22},
  [2983] = {.lex_state = 88, .external_lex_state = 22},
  [2984] = {.lex_state = 88, .external_lex_state = 22},
  [2985] = {.lex_state = 88, .external_lex_state = 22},
  [2986] = {.lex_state = 88, .external_lex_state = 22},
  [2987] = {.lex_state = 88, .external_lex_state = 22},
  [2988] = {.lex_state = 88, .external_lex_state = 22},
  [2989] = {.lex_state = 88, .external_lex_state = 22},
  [2990] = {.lex_state = 88, .external_lex_state = 22},
  [2991] = {.lex_state = 222, .external_lex_state = 27},
  [2992] = {.lex_state = 89, .external_lex_state = 24},
  [2993] = {.lex_state = 89, .external_lex_state = 24},
  [2994] = {.lex_state = 89, .external_lex_state = 24},
  [2995] = {.lex_state = 88, .external_lex_state = 22},
  [2996] = {.lex_state = 89, .external_lex_state = 24},
  [2997] = {.lex_state = 88, .external_lex_state = 22},
  [2998] = {.lex_state = 88, .external_lex_state = 22},
  [2999] = {.lex_state = 89, .external_lex_state = 24},
  [3000] = {.lex_state = 89, .external_lex_state = 24},
  [3001] = {.lex_state = 89, .external_lex_state = 24},
  [3002] = {.lex_state = 89, .external_lex_state = 24},
  [3003] = {.lex_state = 89, .external_lex_state = 24},
  [3004] = {.lex_state = 89, .external_lex_state = 24},
  [3005] = {.lex_state = 89, .external_lex_state = 24},
  [3006] = {.lex_state = 89, .external_lex_state = 24},
  [3007] = {.lex_state = 89, .external_lex_state = 24},
  [3008] = {.lex_state = 89, .external_lex_state = 24},
  [3009] = {.lex_state = 89, .external_lex_state = 24},
  [3010] = {.lex_state = 89, .external_lex_state = 24},
  [3011] = {.lex_state = 89, .external_lex_state = 24},
  [3012] = {.lex_state = 89, .external_lex_state = 24},
  [3013] = {.lex_state = 222, .external_lex_state = 27},
  [3014] = {.lex_state = 89, .external_lex_state = 24},
  [3015] = {.lex_state = 89, .external_lex_state = 24},
  [3016] = {.lex_state = 89, .external_lex_state = 24},
  [3017] = {.lex_state = 222, .external_lex_state = 27},
  [3018] = {.lex_state = 222, .external_lex_state = 27},
  [3019] = {.lex_state = 89, .external_lex_state = 24},
  [3020] = {.lex_state = 222, .external_lex_state = 27},
  [3021] = {.lex_state = 222, .external_lex_state = 27},
  [3022] = {.lex_state = 89, .external_lex_state = 24},
  [3023] = {.lex_state = 89, .external_lex_state = 24},
  [3024] = {.lex_state = 222, .external_lex_state = 27},
  [3025] = {.lex_state = 89, .external_lex_state = 24},
  [3026] = {.lex_state = 89, .external_lex_state = 24},
  [3027] = {.lex_state = 89, .external_lex_state = 24},
  [3028] = {.lex_state = 222, .external_lex_state = 27},
  [3029] = {.lex_state = 89, .external_lex_state = 24},
  [3030] = {.lex_state = 89, .external_lex_state = 24},
  [3031] = {.lex_state = 89, .external_lex_state = 24},
  [3032] = {.lex_state = 89, .external_lex_state = 24},
  [3033] = {.lex_state = 222, .external_lex_state = 27},
  [3034] = {.lex_state = 222, .external_lex_state = 27},
  [3035] = {.lex_state = 89, .external_lex_state = 24},
  [3036] = {.lex_state = 89, .external_lex_state = 24},
  [3037] = {.lex_state = 222, .external_lex_state = 27},
  [3038] = {.lex_state = 88, .external_lex_state = 22},
  [3039] = {.lex_state = 88, .external_lex_state = 22},
  [3040] = {.lex_state = 88, .external_lex_state = 22},
  [3041] = {.lex_state = 88, .external_lex_state = 22},
  [3042] = {.lex_state = 88, .external_lex_state = 22},
  [3043] = {.lex_state = 88, .external_lex_state = 22},
  [3044] = {.lex_state = 88, .external_lex_state = 22},
  [3045] = {.lex_state = 88, .external_lex_state = 24},
  [3046] = {.lex_state = 88, .external_lex_state = 22},
  [3047] = {.lex_state = 88, .external_lex_state = 22},
  [3048] = {.lex_state = 88, .external_lex_state = 22},
  [3049] = {.lex_state = 88, .external_lex_state = 24},
  [3050] = {.lex_state = 88, .external_lex_state = 22},
  [3051] = {.lex_state = 88, .external_lex_state = 22},
  [3052] = {.lex_state = 88, .external_lex_state = 22},
  [3053] = {.lex_state = 88, .external_lex_state = 22},
  [3054] = {.lex_state = 88, .external_lex_state = 22},
  [3055] = {.lex_state = 88, .external_lex_state = 22},
  [3056] = {.lex_state = 88, .external_lex_state = 22},
  [3057] = {.lex_state = 88, .external_lex_state = 22},
  [3058] = {.lex_state = 88, .external_lex_state = 22},
  [3059] = {.lex_state = 222, .external_lex_state = 27},
  [3060] = {.lex_state = 88, .external_lex_state = 25},
  [3061] = {.lex_state = 222, .external_lex_state = 27},
  [3062] = {.lex_state = 88, .external_lex_state = 22},
  [3063] = {.lex_state = 88, .external_lex_state = 28},
  [3064] = {.lex_state = 222, .external_lex_state = 27},
  [3065] = {.lex_state = 88, .external_lex_state = 22},
  [3066] = {.lex_state = 88, .external_lex_state = 22},
  [3067] = {.lex_state = 222, .external_lex_state = 27},
  [3068] = {.lex_state = 88, .external_lex_state = 24},
  [3069] = {.lex_state = 88, .external_lex_state = 22},
  [3070] = {.lex_state = 88, .external_lex_state = 22},
  [3071] = {.lex_state = 88, .external_lex_state = 22},
  [3072] = {.lex_state = 88, .external_lex_state = 22},
  [3073] = {.lex_state = 222, .external_lex_state = 27},
  [3074] = {.lex_state = 88, .external_lex_state = 22},
  [3075] = {.lex_state = 88, .external_lex_state = 22},
  [3076] = {.lex_state = 222, .external_lex_state = 27},
  [3077] = {.lex_state = 88, .external_lex_state = 22},
  [3078] = {.lex_state = 88, .external_lex_state = 22},
  [3079] = {.lex_state = 88, .external_lex_state = 22},
  [3080] = {.lex_state = 222, .external_lex_state = 27},
  [3081] = {.lex_state = 88, .external_lex_state = 22},
  [3082] = {.lex_state = 88, .external_lex_state = 22},
  [3083] = {.lex_state = 88, .external_lex_state = 28},
  [3084] = {.lex_state = 222, .external_lex_state = 27},
  [3085] = {.lex_state = 97, .external_lex_state = 29},
  [3086] = {.lex_state = 222, .external_lex_state = 27},
  [3087] = {.lex_state = 88, .external_lex_state = 24},
  [3088] = {.lex_state = 222, .external_lex_state = 27},
  [3089] = {.lex_state = 222, .external_lex_state = 27},
  [3090] = {.lex_state = 97, .external_lex_state = 29},
  [3091] = {.lex_state = 97, .external_lex_state = 29},
  [3092] = {.lex_state = 222, .external_lex_state = 27},
  [3093] = {.lex_state = 97, .external_lex_state = 29},
  [3094] = {.lex_state = 97, .external_lex_state = 29},
  [3095] = {.lex_state = 88, .external_lex_state = 24},
  [3096] = {.lex_state = 88, .external_lex_state = 22},
  [3097] = {.lex_state = 222, .external_lex_state = 27},
  [3098] = {.lex_state = 97, .external_lex_state = 29},
  [3099] = {.lex_state = 88, .external_lex_state = 24},
  [3100] = {.lex_state = 222, .external_lex_state = 27},
  [3101] = {.lex_state = 88, .external_lex_state = 28},
  [3102] = {.lex_state = 97, .external_lex_state = 29},
  [3103] = {.lex_state = 88, .external_lex_state = 22},
  [3104] = {.lex_state = 222, .external_lex_state = 27},
  [3105] = {.lex_state = 222, .external_lex_state = 27},
  [3106] = {.lex_state = 222, .external_lex_state = 27},
  [3107] = {.lex_state = 88, .external_lex_state = 24},
  [3108] = {.lex_state = 222, .external_lex_state = 27},
  [3109] = {.lex_state = 97, .external_lex_state = 29},
  [3110] = {.lex_state = 222, .external_lex_state = 27},
  [3111] = {.lex_state = 222, .external_lex_state = 27},
  [3112] = {.lex_state = 97, .external_lex_state = 29},
  [3113] = {.lex_state = 222, .external_lex_state = 27},
  [3114] = {.lex_state = 222, .external_lex_state = 27},
  [3115] = {.lex_state = 97, .external_lex_state = 29},
  [3116] = {.lex_state = 222, .external_lex_state = 27},
  [3117] = {.lex_state = 222, .external_lex_state = 27},
  [3118] = {.lex_state = 222, .external_lex_state = 27},
  [3119] = {.lex_state = 88, .external_lex_state = 24},
  [3120] = {.lex_state = 97, .external_lex_state = 29},
  [3121] = {.lex_state = 97, .external_lex_state = 29},
  [3122] = {.lex_state = 97, .external_lex_state = 29},
  [3123] = {.lex_state = 88, .external_lex_state = 24},
  [3124] = {.lex_state = 97, .external_lex_state = 29},
  [3125] = {.lex_state = 222, .external_lex_state = 27},
  [3126] = {.lex_state = 97, .external_lex_state = 29},
  [3127] = {.lex_state = 97, .external_lex_state = 29},
  [3128] = {.lex_state = 88, .external_lex_state = 22},
  [3129] = {.lex_state = 97, .external_lex_state = 29},
  [3130] = {.lex_state = 97, .external_lex_state = 29},
  [3131] = {.lex_state = 89, .external_lex_state = 24},
  [3132] = {.lex_state = 222, .external_lex_state = 27},
  [3133] = {.lex_state = 222, .external_lex_state = 27},
  [3134] = {.lex_state = 97, .external_lex_state = 29},
  [3135] = {.lex_state = 97, .external_lex_state = 29},
  [3136] = {.lex_state = 222, .external_lex_state = 27},
  [3137] = {.lex_state = 88, .external_lex_state = 22},
  [3138] = {.lex_state = 95, .external_lex_state = 26},
  [3139] = {.lex_state = 222, .external_lex_state = 27},
  [3140] = {.lex_state = 97, .external_lex_state = 29},
  [3141] = {.lex_state = 88, .external_lex_state = 28},
  [3142] = {.lex_state = 97, .external_lex_state = 29},
  [3143] = {.lex_state = 97, .external_lex_state = 29},
  [3144] = {.lex_state = 222, .external_lex_state = 27},
  [3145] = {.lex_state = 88, .external_lex_state = 22},
  [3146] = {.lex_state = 222, .external_lex_state = 27},
  [3147] = {.lex_state = 222, .external_lex_state = 27},
  [3148] = {.lex_state = 222, .external_lex_state = 27},
  [3149] = {.lex_state = 97, .external_lex_state = 29},
  [3150] = {.lex_state = 97, .external_lex_state = 29},
  [3151] = {.lex_state = 88, .external_lex_state = 24},
  [3152] = {.lex_state = 88, .external_lex_state = 24},
  [3153] = {.lex_state = 222, .external_lex_state = 27},
  [3154] = {.lex_state = 222, .external_lex_state = 27},
  [3155] = {.lex_state = 88, .external_lex_state = 24},
  [3156] = {.lex_state = 222, .external_lex_state = 27},
  [3157] = {.lex_state = 222, .external_lex_state = 27},
  [3158] = {.lex_state = 97, .external_lex_state = 29},
  [3159] = {.lex_state = 88, .external_lex_state = 24},
  [3160] = {.lex_state = 97, .external_lex_state = 29},
  [3161] = {.lex_state = 97, .external_lex_state = 29},
  [3162] = {.lex_state = 222, .external_lex_state = 27},
  [3163] = {.lex_state = 88, .external_lex_state = 22},
  [3164] = {.lex_state = 97, .external_lex_state = 29},
  [3165] = {.lex_state = 222, .external_lex_state = 27},
  [3166] = {.lex_state = 88, .external_lex_state = 24},
  [3167] = {.lex_state = 222, .external_lex_state = 27},
  [3168] = {.lex_state = 222, .external_lex_state = 27},
  [3169] = {.lex_state = 88, .external_lex_state = 22},
  [3170] = {.lex_state = 88, .external_lex_state = 22},
  [3171] = {.lex_state = 222, .external_lex_state = 27},
  [3172] = {.lex_state = 88, .external_lex_state = 24},
  [3173] = {.lex_state = 92, .external_lex_state = 27},
  [3174] = {.lex_state = 88, .external_lex_state = 24},
  [3175] = {.lex_state = 88, .external_lex_state = 24},
  [3176] = {.lex_state = 88, .external_lex_state = 24},
  [3177] = {.lex_state = 88, .external_lex_state = 24},
  [3178] = {.lex_state = 88, .external_lex_state = 24},
  [3179] = {.lex_state = 88, .external_lex_state = 24},
  [3180] = {.lex_state = 88, .external_lex_state = 24},
  [3181] = {.lex_state = 88, .external_lex_state = 24},
  [3182] = {.lex_state = 222, .external_lex_state = 27},
  [3183] = {.lex_state = 222, .external_lex_state = 27},
  [3184] = {.lex_state = 222, .external_lex_state = 27},
  [3185] = {.lex_state = 222, .external_lex_state = 27},
  [3186] = {.lex_state = 222, .external_lex_state = 27},
  [3187] = {.lex_state = 222, .external_lex_state = 27},
  [3188] = {.lex_state = 222, .external_lex_state = 27},
  [3189] = {.lex_state = 222, .external_lex_state = 27},
  [3190] = {.lex_state = 222, .external_lex_state = 27},
  [3191] = {.lex_state = 222, .external_lex_state = 27},
  [3192] = {.lex_state = 222, .external_lex_state = 27},
  [3193] = {.lex_state = 222, .external_lex_state = 27},
  [3194] = {.lex_state = 88, .external_lex_state = 22},
  [3195] = {.lex_state = 88, .external_lex_state = 22},
  [3196] = {.lex_state = 88, .external_lex_state = 22},
  [3197] = {.lex_state = 88, .external_lex_state = 22},
  [3198] = {.lex_state = 88, .external_lex_state = 22},
  [3199] = {.lex_state = 88, .external_lex_state = 22},
  [3200] = {.lex_state = 93, .external_lex_state = 26},
  [3201] = {.lex_state = 88, .external_lex_state = 24},
  [3202] = {.lex_state = 93, .external_lex_state = 26},
  [3203] = {.lex_state = 88, .external_lex_state = 24},
  [3204] = {.lex_state = 222, .external_lex_state = 27},
  [3205] = {.lex_state = 222, .external_lex_state = 27},
  [3206] = {.lex_state = 93, .external_lex_state = 26},
  [3207] = {.lex_state = 93, .external_lex_state = 26},
  [3208] = {.lex_state = 222, .external_lex_state = 27},
  [3209] = {.lex_state = 88, .external_lex_state = 24},
  [3210] = {.lex_state = 88, .external_lex_state = 24},
  [3211] = {.lex_state = 88, .external_lex_state = 24},
  [3212] = {.lex_state = 222, .external_lex_state = 27},
  [3213] = {.lex_state = 88, .external_lex_state = 24},
  [3214] = {.lex_state = 93, .external_lex_state = 26},
  [3215] = {.lex_state = 93, .external_lex_state = 26},
  [3216] = {.lex_state = 93, .external_lex_state = 26},
  [3217] = {.lex_state = 88, .external_lex_state = 24},
  [3218] = {.lex_state = 88, .external_lex_state = 24},
  [3219] = {.lex_state = 222, .external_lex_state = 27},
  [3220] = {.lex_state = 88, .external_lex_state = 24},
  [3221] = {.lex_state = 88, .external_lex_state = 22},
  [3222] = {.lex_state = 88, .external_lex_state = 24},
  [3223] = {.lex_state = 88, .external_lex_state = 22},
  [3224] = {.lex_state = 88, .external_lex_state = 22},
  [3225] = {.lex_state = 88, .external_lex_state = 24},
  [3226] = {.lex_state = 222, .external_lex_state = 27},
  [3227] = {.lex_state = 222, .external_lex_state = 27},
  [3228] = {.lex_state = 88, .external_lex_state = 24},
  [3229] = {.lex_state = 88, .external_lex_state = 24},
  [3230] = {.lex_state = 92, .external_lex_state = 27},
  [3231] = {.lex_state = 88, .external_lex_state = 24},
  [3232] = {.lex_state = 88, .external_lex_state = 24},
  [3233] = {.lex_state = 88, .external_lex_state = 24},
  [3234] = {.lex_state = 88, .external_lex_state = 24},
  [3235] = {.lex_state = 88, .external_lex_state = 24},
  [3236] = {.lex_state = 92, .external_lex_state = 27},
  [3237] = {.lex_state = 88, .external_lex_state = 24},
  [3238] = {.lex_state = 88, .external_lex_state = 24},
  [3239] = {.lex_state = 88, .external_lex_state = 24},
  [3240] = {.lex_state = 88, .external_lex_state = 24},
  [3241] = {.lex_state = 88, .external_lex_state = 24},
  [3242] = {.lex_state = 88, .external_lex_state = 24},
  [3243] = {.lex_state = 88, .external_lex_state = 24},
  [3244] = {.lex_state = 88, .external_lex_state = 24},
  [3245] = {.lex_state = 88, .external_lex_state = 24},
  [3246] = {.lex_state = 88, .external_lex_state = 24},
  [3247] = {.lex_state = 88, .external_lex_state = 24},
  [3248] = {.lex_state = 88, .external_lex_state = 24},
  [3249] = {.lex_state = 88, .external_lex_state = 24},
  [3250] = {.lex_state = 222, .external_lex_state = 27},
  [3251] = {.lex_state = 88, .external_lex_state = 24},
  [3252] = {.lex_state = 88, .external_lex_state = 24},
  [3253] = {.lex_state = 88, .external_lex_state = 24},
  [3254] = {.lex_state = 88, .external_lex_state = 24},
  [3255] = {.lex_state = 88, .external_lex_state = 24},
  [3256] = {.lex_state = 92, .external_lex_state = 27},
  [3257] = {.lex_state = 92, .external_lex_state = 27},
  [3258] = {.lex_state = 88, .external_lex_state = 24},
  [3259] = {.lex_state = 88, .external_lex_state = 24},
  [3260] = {.lex_state = 88, .external_lex_state = 28},
  [3261] = {.lex_state = 88, .external_lex_state = 24},
  [3262] = {.lex_state = 88, .external_lex_state = 24},
  [3263] = {.lex_state = 88, .external_lex_state = 24},
  [3264] = {.lex_state = 88, .external_lex_state = 24},
  [3265] = {.lex_state = 88, .external_lex_state = 24},
  [3266] = {.lex_state = 88, .external_lex_state = 24},
  [3267] = {.lex_state = 88, .external_lex_state = 24},
  [3268] = {.lex_state = 88, .external_lex_state = 24},
  [3269] = {.lex_state = 88, .external_lex_state = 24},
  [3270] = {.lex_state = 88, .external_lex_state = 24},
  [3271] = {.lex_state = 88, .external_lex_state = 24},
  [3272] = {.lex_state = 88, .external_lex_state = 24},
  [3273] = {.lex_state = 88, .external_lex_state = 24},
  [3274] = {.lex_state = 88, .external_lex_state = 24},
  [3275] = {.lex_state = 88, .external_lex_state = 22},
  [3276] = {.lex_state = 88, .external_lex_state = 22},
  [3277] = {.lex_state = 88, .external_lex_state = 22},
  [3278] = {.lex_state = 88, .external_lex_state = 22},
  [3279] = {.lex_state = 88, .external_lex_state = 22},
  [3280] = {.lex_state = 88, .external_lex_state = 22},
  [3281] = {.lex_state = 88, .external_lex_state = 22},
  [3282] = {.lex_state = 88, .external_lex_state = 22},
  [3283] = {.lex_state = 88, .external_lex_state = 22},
  [3284] = {.lex_state = 88, .external_lex_state = 22},
  [3285] = {.lex_state = 88, .external_lex_state = 22},
  [3286] = {.lex_state = 88, .external_lex_state = 22},
  [3287] = {.lex_state = 88, .external_lex_state = 22},
  [3288] = {.lex_state = 88, .external_lex_state = 22},
  [3289] = {.lex_state = 93, .external_lex_state = 26},
  [3290] = {.lex_state = 93, .external_lex_state = 26},
  [3291] = {.lex_state = 93, .external_lex_state = 26},
  [3292] = {.lex_state = 222, .external_lex_state = 27},
  [3293] = {.lex_state = 88, .external_lex_state = 24},
  [3294] = {.lex_state = 88, .external_lex_state = 24},
  [3295] = {.lex_state = 88, .external_lex_state = 24},
  [3296] = {.lex_state = 88, .external_lex_state = 24},
  [3297] = {.lex_state = 88, .external_lex_state = 24},
  [3298] = {.lex_state = 88, .external_lex_state = 24},
  [3299] = {.lex_state = 88, .external_lex_state = 24},
  [3300] = {.lex_state = 88, .external_lex_state = 24},
  [3301] = {.lex_state = 92, .external_lex_state = 27},
  [3302] = {.lex_state = 92, .external_lex_state = 27},
  [3303] = {.lex_state = 88, .external_lex_state = 22},
  [3304] = {.lex_state = 88, .external_lex_state = 22},
  [3305] = {.lex_state = 92, .external_lex_state = 27},
  [3306] = {.lex_state = 222, .external_lex_state = 27},
  [3307] = {.lex_state = 92, .external_lex_state = 27},
  [3308] = {.lex_state = 88, .external_lex_state = 24},
  [3309] = {.lex_state = 88, .external_lex_state = 24},
  [3310] = {.lex_state = 88, .external_lex_state = 24},
  [3311] = {.lex_state = 101, .external_lex_state = 23},
  [3312] = {.lex_state = 101, .external_lex_state = 23},
  [3313] = {.lex_state = 88, .external_lex_state = 24},
  [3314] = {.lex_state = 88, .external_lex_state = 24},
  [3315] = {.lex_state = 88, .external_lex_state = 24},
  [3316] = {.lex_state = 88, .external_lex_state = 24},
  [3317] = {.lex_state = 101, .external_lex_state = 23},
  [3318] = {.lex_state = 88, .external_lex_state = 24},
  [3319] = {.lex_state = 93, .external_lex_state = 29},
  [3320] = {.lex_state = 92, .external_lex_state = 30},
  [3321] = {.lex_state = 88, .external_lex_state = 24},
  [3322] = {.lex_state = 88, .external_lex_state = 22},
  [3323] = {.lex_state = 101, .external_lex_state = 23},
  [3324] = {.lex_state = 88, .external_lex_state = 22},
  [3325] = {.lex_state = 92, .external_lex_state = 27},
  [3326] = {.lex_state = 88, .external_lex_state = 24},
  [3327] = {.lex_state = 88, .external_lex_state = 24},
  [3328] = {.lex_state = 222, .external_lex_state = 27},
  [3329] = {.lex_state = 88, .external_lex_state = 24},
  [3330] = {.lex_state = 88, .external_lex_state = 24},
  [3331] = {.lex_state = 88, .external_lex_state = 24},
  [3332] = {.lex_state = 88, .external_lex_state = 24},
  [3333] = {.lex_state = 88, .external_lex_state = 24},
  [3334] = {.lex_state = 88, .external_lex_state = 24},
  [3335] = {.lex_state = 88, .external_lex_state = 24},
  [3336] = {.lex_state = 88, .external_lex_state = 24},
  [3337] = {.lex_state = 88, .external_lex_state = 24},
  [3338] = {.lex_state = 88, .external_lex_state = 24},
  [3339] = {.lex_state = 88, .external_lex_state = 24},
  [3340] = {.lex_state = 88, .external_lex_state = 24},
  [3341] = {.lex_state = 88, .external_lex_state = 28},
  [3342] = {.lex_state = 92, .external_lex_state = 30},
  [3343] = {.lex_state = 92, .external_lex_state = 30},
  [3344] = {.lex_state = 88, .external_lex_state = 24},
  [3345] = {.lex_state = 88, .external_lex_state = 22},
  [3346] = {.lex_state = 88, .external_lex_state = 24},
  [3347] = {.lex_state = 92, .external_lex_state = 30},
  [3348] = {.lex_state = 101, .external_lex_state = 23},
  [3349] = {.lex_state = 222, .external_lex_state = 27},
  [3350] = {.lex_state = 222, .external_lex_state = 27},
  [3351] = {.lex_state = 92, .external_lex_state = 30},
  [3352] = {.lex_state = 92, .external_lex_state = 30},
  [3353] = {.lex_state = 92, .external_lex_state = 30},
  [3354] = {.lex_state = 222, .external_lex_state = 27},
  [3355] = {.lex_state = 88, .external_lex_state = 24},
  [3356] = {.lex_state = 88, .external_lex_state = 24},
  [3357] = {.lex_state = 88, .external_lex_state = 24},
  [3358] = {.lex_state = 88, .external_lex_state = 24},
  [3359] = {.lex_state = 88, .external_lex_state = 24},
  [3360] = {.lex_state = 88, .external_lex_state = 22},
  [3361] = {.lex_state = 88, .external_lex_state = 24},
  [3362] = {.lex_state = 222, .external_lex_state = 27},
  [3363] = {.lex_state = 88, .external_lex_state = 22},
  [3364] = {.lex_state = 92, .external_lex_state = 27},
  [3365] = {.lex_state = 92, .external_lex_state = 27},
  [3366] = {.lex_state = 92, .external_lex_state = 27},
  [3367] = {.lex_state = 92, .external_lex_state = 27},
  [3368] = {.lex_state = 92, .external_lex_state = 27},
  [3369] = {.lex_state = 88, .external_lex_state = 24},
  [3370] = {.lex_state = 92, .external_lex_state = 27},
  [3371] = {.lex_state = 92, .external_lex_state = 27},
  [3372] = {.lex_state = 92, .external_lex_state = 27},
  [3373] = {.lex_state = 88, .external_lex_state = 24},
  [3374] = {.lex_state = 88, .external_lex_state = 24},
  [3375] = {.lex_state = 92, .external_lex_state = 27},
  [3376] = {.lex_state = 88, .external_lex_state = 24},
  [3377] = {.lex_state = 88, .external_lex_state = 24},
  [3378] = {.lex_state = 88, .external_lex_state = 22},
  [3379] = {.lex_state = 92, .external_lex_state = 27},
  [3380] = {.lex_state = 92, .external_lex_state = 27},
  [3381] = {.lex_state = 92, .external_lex_state = 27},
  [3382] = {.lex_state = 92, .external_lex_state = 27},
  [3383] = {.lex_state = 92, .external_lex_state = 27},
  [3384] = {.lex_state = 92, .external_lex_state = 27},
  [3385] = {.lex_state = 92, .external_lex_state = 27},
  [3386] = {.lex_state = 92, .external_lex_state = 27},
  [3387] = {.lex_state = 92, .external_lex_state = 27},
  [3388] = {.lex_state = 92, .external_lex_state = 27},
  [3389] = {.lex_state = 92, .external_lex_state = 27},
  [3390] = {.lex_state = 88, .external_lex_state = 24},
  [3391] = {.lex_state = 88, .external_lex_state = 24},
  [3392] = {.lex_state = 88, .external_lex_state = 24},
  [3393] = {.lex_state = 88, .external_lex_state = 22},
  [3394] = {.lex_state = 88, .external_lex_state = 24},
  [3395] = {.lex_state = 88, .external_lex_state = 24},
  [3396] = {.lex_state = 88, .external_lex_state = 24},
  [3397] = {.lex_state = 88, .external_lex_state = 24},
  [3398] = {.lex_state = 88, .external_lex_state = 24},
  [3399] = {.lex_state = 88, .external_lex_state = 24},
  [3400] = {.lex_state = 92, .external_lex_state = 27},
  [3401] = {.lex_state = 88, .external_lex_state = 24},
  [3402] = {.lex_state = 88, .external_lex_state = 24},
  [3403] = {.lex_state = 88, .external_lex_state = 24},
  [3404] = {.lex_state = 88, .external_lex_state = 24},
  [3405] = {.lex_state = 92, .external_lex_state = 27},
  [3406] = {.lex_state = 92, .external_lex_state = 27},
  [3407] = {.lex_state = 92, .external_lex_state = 27},
  [3408] = {.lex_state = 92, .external_lex_state = 27},
  [3409] = {.lex_state = 93, .external_lex_state = 29},
  [3410] = {.lex_state = 93, .external_lex_state = 29},
  [3411] = {.lex_state = 92, .external_lex_state = 27},
  [3412] = {.lex_state = 88, .external_lex_state = 22},
  [3413] = {.lex_state = 88, .external_lex_state = 22},
  [3414] = {.lex_state = 89, .external_lex_state = 24},
  [3415] = {.lex_state = 88, .external_lex_state = 22},
  [3416] = {.lex_state = 89, .external_lex_state = 24},
  [3417] = {.lex_state = 88, .external_lex_state = 24},
  [3418] = {.lex_state = 88, .external_lex_state = 22},
  [3419] = {.lex_state = 88, .external_lex_state = 22},
  [3420] = {.lex_state = 88, .external_lex_state = 24},
  [3421] = {.lex_state = 88, .external_lex_state = 24},
  [3422] = {.lex_state = 89, .external_lex_state = 28},
  [3423] = {.lex_state = 92, .external_lex_state = 27},
  [3424] = {.lex_state = 89, .external_lex_state = 28},
  [3425] = {.lex_state = 89, .external_lex_state = 28},
  [3426] = {.lex_state = 88, .external_lex_state = 22},
  [3427] = {.lex_state = 88, .external_lex_state = 22},
  [3428] = {.lex_state = 92, .external_lex_state = 27},
  [3429] = {.lex_state = 92, .external_lex_state = 27},
  [3430] = {.lex_state = 92, .external_lex_state = 27},
  [3431] = {.lex_state = 92, .external_lex_state = 27},
  [3432] = {.lex_state = 92, .external_lex_state = 27},
  [3433] = {.lex_state = 92, .external_lex_state = 27},
  [3434] = {.lex_state = 92, .external_lex_state = 27},
  [3435] = {.lex_state = 92, .external_lex_state = 27},
  [3436] = {.lex_state = 92, .external_lex_state = 27},
  [3437] = {.lex_state = 92, .external_lex_state = 27},
  [3438] = {.lex_state = 92, .external_lex_state = 27},
  [3439] = {.lex_state = 92, .external_lex_state = 27},
  [3440] = {.lex_state = 92, .external_lex_state = 27},
  [3441] = {.lex_state = 88, .external_lex_state = 22},
  [3442] = {.lex_state = 88, .external_lex_state = 22},
  [3443] = {.lex_state = 88, .external_lex_state = 22},
  [3444] = {.lex_state = 88, .external_lex_state = 22},
  [3445] = {.lex_state = 88, .external_lex_state = 22},
  [3446] = {.lex_state = 88, .external_lex_state = 22},
  [3447] = {.lex_state = 222, .external_lex_state = 27},
  [3448] = {.lex_state = 92, .external_lex_state = 27},
  [3449] = {.lex_state = 88, .external_lex_state = 22},
  [3450] = {.lex_state = 88, .external_lex_state = 22},
  [3451] = {.lex_state = 88, .external_lex_state = 22},
  [3452] = {.lex_state = 88, .external_lex_state = 22},
  [3453] = {.lex_state = 88, .external_lex_state = 22},
  [3454] = {.lex_state = 92, .external_lex_state = 27},
  [3455] = {.lex_state = 92, .external_lex_state = 27},
  [3456] = {.lex_state = 88, .external_lex_state = 24},
  [3457] = {.lex_state = 88, .external_lex_state = 24},
  [3458] = {.lex_state = 92, .external_lex_state = 27},
  [3459] = {.lex_state = 92, .external_lex_state = 27},
  [3460] = {.lex_state = 92, .external_lex_state = 27},
  [3461] = {.lex_state = 92, .external_lex_state = 27},
  [3462] = {.lex_state = 92, .external_lex_state = 27},
  [3463] = {.lex_state = 92, .external_lex_state = 27},
  [3464] = {.lex_state = 92, .external_lex_state = 27},
  [3465] = {.lex_state = 88, .external_lex_state = 24},
  [3466] = {.lex_state = 88, .external_lex_state = 22},
  [3467] = {.lex_state = 88, .external_lex_state = 22},
  [3468] = {.lex_state = 88, .external_lex_state = 22},
  [3469] = {.lex_state = 88, .external_lex_state = 22},
  [3470] = {.lex_state = 88, .external_lex_state = 22},
  [3471] = {.lex_state = 88, .external_lex_state = 22},
  [3472] = {.lex_state = 88, .external_lex_state = 22},
  [3473] = {.lex_state = 92, .external_lex_state = 27},
  [3474] = {.lex_state = 88, .external_lex_state = 22},
  [3475] = {.lex_state = 92, .external_lex_state = 27},
  [3476] = {.lex_state = 92, .external_lex_state = 27},
  [3477] = {.lex_state = 92, .external_lex_state = 27},
  [3478] = {.lex_state = 88, .external_lex_state = 22},
  [3479] = {.lex_state = 92, .external_lex_state = 27},
  [3480] = {.lex_state = 92, .external_lex_state = 30},
  [3481] = {.lex_state = 88, .external_lex_state = 24},
  [3482] = {.lex_state = 88, .external_lex_state = 24},
  [3483] = {.lex_state = 88, .external_lex_state = 28},
  [3484] = {.lex_state = 92, .external_lex_state = 30},
  [3485] = {.lex_state = 92, .external_lex_state = 27},
  [3486] = {.lex_state = 88, .external_lex_state = 22},
  [3487] = {.lex_state = 88, .external_lex_state = 22},
  [3488] = {.lex_state = 88, .external_lex_state = 22},
  [3489] = {.lex_state = 88, .external_lex_state = 22},
  [3490] = {.lex_state = 88, .external_lex_state = 22},
  [3491] = {.lex_state = 88, .external_lex_state = 22},
  [3492] = {.lex_state = 88, .external_lex_state = 22},
  [3493] = {.lex_state = 88, .external_lex_state = 22},
  [3494] = {.lex_state = 88, .external_lex_state = 22},
  [3495] = {.lex_state = 88, .external_lex_state = 22},
  [3496] = {.lex_state = 88, .external_lex_state = 22},
  [3497] = {.lex_state = 88, .external_lex_state = 22},
  [3498] = {.lex_state = 92, .external_lex_state = 30},
  [3499] = {.lex_state = 92, .external_lex_state = 30},
  [3500] = {.lex_state = 88, .external_lex_state = 22},
  [3501] = {.lex_state = 88, .external_lex_state = 24},
  [3502] = {.lex_state = 92, .external_lex_state = 30},
  [3503] = {.lex_state = 88, .external_lex_state = 22},
  [3504] = {.lex_state = 88, .external_lex_state = 24},
  [3505] = {.lex_state = 92, .external_lex_state = 30},
  [3506] = {.lex_state = 92, .external_lex_state = 27},
  [3507] = {.lex_state = 92, .external_lex_state = 30},
  [3508] = {.lex_state = 92, .external_lex_state = 30},
  [3509] = {.lex_state = 92, .external_lex_state = 30},
  [3510] = {.lex_state = 88, .external_lex_state = 22},
  [3511] = {.lex_state = 88, .external_lex_state = 22},
  [3512] = {.lex_state = 88, .external_lex_state = 22},
  [3513] = {.lex_state = 88, .external_lex_state = 22},
  [3514] = {.lex_state = 88, .external_lex_state = 22},
  [3515] = {.lex_state = 88, .external_lex_state = 22},
  [3516] = {.lex_state = 92, .external_lex_state = 27},
  [3517] = {.lex_state = 92, .external_lex_state = 27},
  [3518] = {.lex_state = 92, .external_lex_state = 30},
  [3519] = {.lex_state = 92, .external_lex_state = 27},
  [3520] = {.lex_state = 92, .external_lex_state = 27},
  [3521] = {.lex_state = 92, .external_lex_state = 27},
  [3522] = {.lex_state = 92, .external_lex_state = 27},
  [3523] = {.lex_state = 88, .external_lex_state = 22},
  [3524] = {.lex_state = 88, .external_lex_state = 22},
  [3525] = {.lex_state = 88, .external_lex_state = 22},
  [3526] = {.lex_state = 92, .external_lex_state = 27},
  [3527] = {.lex_state = 88, .external_lex_state = 22},
  [3528] = {.lex_state = 88, .external_lex_state = 22},
  [3529] = {.lex_state = 92, .external_lex_state = 30},
  [3530] = {.lex_state = 88, .external_lex_state = 22},
  [3531] = {.lex_state = 88, .external_lex_state = 22},
  [3532] = {.lex_state = 92, .external_lex_state = 30},
  [3533] = {.lex_state = 88, .external_lex_state = 24},
  [3534] = {.lex_state = 88, .external_lex_state = 24},
  [3535] = {.lex_state = 92, .external_lex_state = 30},
  [3536] = {.lex_state = 92, .external_lex_state = 30},
  [3537] = {.lex_state = 92, .external_lex_state = 30},
  [3538] = {.lex_state = 115, .external_lex_state = 31},
  [3539] = {.lex_state = 92, .external_lex_state = 30},
  [3540] = {.lex_state = 88, .external_lex_state = 24},
  [3541] = {.lex_state = 92, .external_lex_state = 27},
  [3542] = {.lex_state = 92, .external_lex_state = 30},
  [3543] = {.lex_state = 92, .external_lex_state = 27},
  [3544] = {.lex_state = 92, .external_lex_state = 30},
  [3545] = {.lex_state = 92, .external_lex_state = 30},
  [3546] = {.lex_state = 88, .external_lex_state = 24},
  [3547] = {.lex_state = 92, .external_lex_state = 30},
  [3548] = {.lex_state = 88, .external_lex_state = 24},
  [3549] = {.lex_state = 88, .external_lex_state = 24},
  [3550] = {.lex_state = 92, .external_lex_state = 30},
  [3551] = {.lex_state = 92, .external_lex_state = 30},
  [3552] = {.lex_state = 92, .external_lex_state = 27},
  [3553] = {.lex_state = 92, .external_lex_state = 30},
  [3554] = {.lex_state = 92, .external_lex_state = 30},
  [3555] = {.lex_state = 92, .external_lex_state = 30},
  [3556] = {.lex_state = 92, .external_lex_state = 30},
  [3557] = {.lex_state = 88, .external_lex_state = 24},
  [3558] = {.lex_state = 92, .external_lex_state = 30},
  [3559] = {.lex_state = 92, .external_lex_state = 30},
  [3560] = {.lex_state = 92, .external_lex_state = 30},
  [3561] = {.lex_state = 89, .external_lex_state = 28},
  [3562] = {.lex_state = 88, .external_lex_state = 24},
  [3563] = {.lex_state = 89, .external_lex_state = 24},
  [3564] = {.lex_state = 88, .external_lex_state = 24},
  [3565] = {.lex_state = 92, .external_lex_state = 27},
  [3566] = {.lex_state = 92, .external_lex_state = 27},
  [3567] = {.lex_state = 92, .external_lex_state = 27},
  [3568] = {.lex_state = 88, .external_lex_state = 22},
  [3569] = {.lex_state = 88, .external_lex_state = 22},
  [3570] = {.lex_state = 88, .external_lex_state = 22},
  [3571] = {.lex_state = 92, .external_lex_state = 30},
  [3572] = {.lex_state = 89, .external_lex_state = 28},
  [3573] = {.lex_state = 92, .external_lex_state = 30},
  [3574] = {.lex_state = 92, .external_lex_state = 30},
  [3575] = {.lex_state = 92, .external_lex_state = 27},
  [3576] = {.lex_state = 92, .external_lex_state = 27},
  [3577] = {.lex_state = 92, .external_lex_state = 27},
  [3578] = {.lex_state = 92, .external_lex_state = 27},
  [3579] = {.lex_state = 92, .external_lex_state = 27},
  [3580] = {.lex_state = 92, .external_lex_state = 27},
  [3581] = {.lex_state = 92, .external_lex_state = 30},
  [3582] = {.lex_state = 92, .external_lex_state = 27},
  [3583] = {.lex_state = 92, .external_lex_state = 27},
  [3584] = {.lex_state = 92, .external_lex_state = 27},
  [3585] = {.lex_state = 92, .external_lex_state = 27},
  [3586] = {.lex_state = 92, .external_lex_state = 27},
  [3587] = {.lex_state = 92, .external_lex_state = 27},
  [3588] = {.lex_state = 92, .external_lex_state = 30},
  [3589] = {.lex_state = 92, .external_lex_state = 30},
  [3590] = {.lex_state = 92, .external_lex_state = 30},
  [3591] = {.lex_state = 92, .external_lex_state = 30},
  [3592] = {.lex_state = 92, .external_lex_state = 27},
  [3593] = {.lex_state = 92, .external_lex_state = 27},
  [3594] = {.lex_state = 92, .external_lex_state = 27},
  [3595] = {.lex_state = 92, .external_lex_state = 27},
  [3596] = {.lex_state = 92, .external_lex_state = 27},
  [3597] = {.lex_state = 88, .external_lex_state = 24},
  [3598] = {.lex_state = 92, .external_lex_state = 27},
  [3599] = {.lex_state = 92, .external_lex_state = 27},
  [3600] = {.lex_state = 88, .external_lex_state = 24},
  [3601] = {.lex_state = 92, .external_lex_state = 30},
  [3602] = {.lex_state = 92, .external_lex_state = 30},
  [3603] = {.lex_state = 92, .external_lex_state = 30},
  [3604] = {.lex_state = 92, .external_lex_state = 30},
  [3605] = {.lex_state = 92, .external_lex_state = 27},
  [3606] = {.lex_state = 92, .external_lex_state = 27},
  [3607] = {.lex_state = 92, .external_lex_state = 30},
  [3608] = {.lex_state = 92, .external_lex_state = 30},
  [3609] = {.lex_state = 92, .external_lex_state = 30},
  [3610] = {.lex_state = 92, .external_lex_state = 30},
  [3611] = {.lex_state = 88, .external_lex_state = 24},
  [3612] = {.lex_state = 88, .external_lex_state = 24},
  [3613] = {.lex_state = 88, .external_lex_state = 24},
  [3614] = {.lex_state = 92, .external_lex_state = 30},
  [3615] = {.lex_state = 92, .external_lex_state = 30},
  [3616] = {.lex_state = 89, .external_lex_state = 24},
  [3617] = {.lex_state = 88, .external_lex_state = 24},
  [3618] = {.lex_state = 92, .external_lex_state = 30},
  [3619] = {.lex_state = 88, .external_lex_state = 24},
  [3620] = {.lex_state = 88, .external_lex_state = 24},
  [3621] = {.lex_state = 88, .external_lex_state = 24},
  [3622] = {.lex_state = 92, .external_lex_state = 27},
  [3623] = {.lex_state = 92, .external_lex_state = 30},
  [3624] = {.lex_state = 92, .external_lex_state = 30},
  [3625] = {.lex_state = 88, .external_lex_state = 24},
  [3626] = {.lex_state = 88, .external_lex_state = 24},
  [3627] = {.lex_state = 88, .external_lex_state = 24},
  [3628] = {.lex_state = 88, .external_lex_state = 24},
  [3629] = {.lex_state = 92, .external_lex_state = 30},
  [3630] = {.lex_state = 92, .external_lex_state = 27},
  [3631] = {.lex_state = 92, .external_lex_state = 30},
  [3632] = {.lex_state = 92, .external_lex_state = 30},
  [3633] = {.lex_state = 88, .external_lex_state = 22},
  [3634] = {.lex_state = 88, .external_lex_state = 22},
  [3635] = {.lex_state = 88, .external_lex_state = 22},
  [3636] = {.lex_state = 88, .external_lex_state = 22},
  [3637] = {.lex_state = 88, .external_lex_state = 22},
  [3638] = {.lex_state = 88, .external_lex_state = 22},
  [3639] = {.lex_state = 88, .external_lex_state = 24},
  [3640] = {.lex_state = 88, .external_lex_state = 24},
  [3641] = {.lex_state = 89, .external_lex_state = 24},
  [3642] = {.lex_state = 92, .external_lex_state = 30},
  [3643] = {.lex_state = 92, .external_lex_state = 30},
  [3644] = {.lex_state = 92, .external_lex_state = 30},
  [3645] = {.lex_state = 92, .external_lex_state = 30},
  [3646] = {.lex_state = 92, .external_lex_state = 30},
  [3647] = {.lex_state = 88, .external_lex_state = 24},
  [3648] = {.lex_state = 88, .external_lex_state = 24},
  [3649] = {.lex_state = 92, .external_lex_state = 30},
  [3650] = {.lex_state = 88, .external_lex_state = 24},
  [3651] = {.lex_state = 88, .external_lex_state = 24},
  [3652] = {.lex_state = 92, .external_lex_state = 27},
  [3653] = {.lex_state = 92, .external_lex_state = 30},
  [3654] = {.lex_state = 92, .external_lex_state = 30},
  [3655] = {.lex_state = 92, .external_lex_state = 30},
  [3656] = {.lex_state = 92, .external_lex_state = 30},
  [3657] = {.lex_state = 88, .external_lex_state = 24},
  [3658] = {.lex_state = 92, .external_lex_state = 30},
  [3659] = {.lex_state = 88, .external_lex_state = 24},
  [3660] = {.lex_state = 88, .external_lex_state = 22},
  [3661] = {.lex_state = 92, .external_lex_state = 30},
  [3662] = {.lex_state = 92, .external_lex_state = 30},
  [3663] = {.lex_state = 89, .external_lex_state = 24},
  [3664] = {.lex_state = 92, .external_lex_state = 30},
  [3665] = {.lex_state = 89, .external_lex_state = 24},
  [3666] = {.lex_state = 92, .external_lex_state = 30},
  [3667] = {.lex_state = 92, .external_lex_state = 30},
  [3668] = {.lex_state = 88, .external_lex_state = 22},
  [3669] = {.lex_state = 89, .external_lex_state = 24},
  [3670] = {.lex_state = 89, .external_lex_state = 24},
  [3671] = {.lex_state = 89, .external_lex_state = 24},
  [3672] = {.lex_state = 92, .external_lex_state = 30},
  [3673] = {.lex_state = 92, .external_lex_state = 27},
  [3674] = {.lex_state = 115, .external_lex_state = 31},
  [3675] = {.lex_state = 88, .external_lex_state = 22},
  [3676] = {.lex_state = 88, .external_lex_state = 22},
  [3677] = {.lex_state = 88, .external_lex_state = 22},
  [3678] = {.lex_state = 88, .external_lex_state = 22},
  [3679] = {.lex_state = 88, .external_lex_state = 22},
  [3680] = {.lex_state = 88, .external_lex_state = 22},
  [3681] = {.lex_state = 88, .external_lex_state = 22},
  [3682] = {.lex_state = 88, .external_lex_state = 22},
  [3683] = {.lex_state = 88, .external_lex_state = 22},
  [3684] = {.lex_state = 88, .external_lex_state = 22},
  [3685] = {.lex_state = 88, .external_lex_state = 22},
  [3686] = {.lex_state = 88, .external_lex_state = 22},
  [3687] = {.lex_state = 88, .external_lex_state = 22},
  [3688] = {.lex_state = 88, .external_lex_state = 22},
  [3689] = {.lex_state = 92, .external_lex_state = 30},
  [3690] = {.lex_state = 92, .external_lex_state = 27},
  [3691] = {.lex_state = 92, .external_lex_state = 30},
  [3692] = {.lex_state = 92, .external_lex_state = 30},
  [3693] = {.lex_state = 89, .external_lex_state = 24},
  [3694] = {.lex_state = 89, .external_lex_state = 24},
  [3695] = {.lex_state = 92, .external_lex_state = 30},
  [3696] = {.lex_state = 92, .external_lex_state = 30},
  [3697] = {.lex_state = 92, .external_lex_state = 30},
  [3698] = {.lex_state = 92, .external_lex_state = 30},
  [3699] = {.lex_state = 92, .external_lex_state = 30},
  [3700] = {.lex_state = 89, .external_lex_state = 24},
  [3701] = {.lex_state = 89, .external_lex_state = 24},
  [3702] = {.lex_state = 89, .external_lex_state = 24},
  [3703] = {.lex_state = 89, .external_lex_state = 24},
  [3704] = {.lex_state = 89, .external_lex_state = 24},
  [3705] = {.lex_state = 89, .external_lex_state = 24},
  [3706] = {.lex_state = 89, .external_lex_state = 24},
  [3707] = {.lex_state = 89, .external_lex_state = 24},
  [3708] = {.lex_state = 89, .external_lex_state = 24},
  [3709] = {.lex_state = 88, .external_lex_state = 22},
  [3710] = {.lex_state = 88, .external_lex_state = 22},
  [3711] = {.lex_state = 88, .external_lex_state = 22},
  [3712] = {.lex_state = 88, .external_lex_state = 22},
  [3713] = {.lex_state = 88, .external_lex_state = 22},
  [3714] = {.lex_state = 88, .external_lex_state = 22},
  [3715] = {.lex_state = 88, .external_lex_state = 22},
  [3716] = {.lex_state = 88, .external_lex_state = 22},
  [3717] = {.lex_state = 88, .external_lex_state = 22},
  [3718] = {.lex_state = 88, .external_lex_state = 22},
  [3719] = {.lex_state = 88, .external_lex_state = 22},
  [3720] = {.lex_state = 88, .external_lex_state = 22},
  [3721] = {.lex_state = 88, .external_lex_state = 24},
  [3722] = {.lex_state = 88, .external_lex_state = 24},
  [3723] = {.lex_state = 92, .external_lex_state = 30},
  [3724] = {.lex_state = 89, .external_lex_state = 24},
  [3725] = {.lex_state = 89, .external_lex_state = 24},
  [3726] = {.lex_state = 88, .external_lex_state = 24},
  [3727] = {.lex_state = 88, .external_lex_state = 24},
  [3728] = {.lex_state = 89, .external_lex_state = 24},
  [3729] = {.lex_state = 88, .external_lex_state = 24},
  [3730] = {.lex_state = 92, .external_lex_state = 30},
  [3731] = {.lex_state = 88, .external_lex_state = 24},
  [3732] = {.lex_state = 92, .external_lex_state = 30},
  [3733] = {.lex_state = 89, .external_lex_state = 24},
  [3734] = {.lex_state = 92, .external_lex_state = 30},
  [3735] = {.lex_state = 92, .external_lex_state = 30},
  [3736] = {.lex_state = 92, .external_lex_state = 30},
  [3737] = {.lex_state = 92, .external_lex_state = 30},
  [3738] = {.lex_state = 92, .external_lex_state = 30},
  [3739] = {.lex_state = 88, .external_lex_state = 24},
  [3740] = {.lex_state = 92, .external_lex_state = 30},
  [3741] = {.lex_state = 89, .external_lex_state = 24},
  [3742] = {.lex_state = 88, .external_lex_state = 24},
  [3743] = {.lex_state = 92, .external_lex_state = 27},
  [3744] = {.lex_state = 92, .external_lex_state = 30},
  [3745] = {.lex_state = 92, .external_lex_state = 30},
  [3746] = {.lex_state = 88, .external_lex_state = 22},
  [3747] = {.lex_state = 88, .external_lex_state = 22},
  [3748] = {.lex_state = 92, .external_lex_state = 27},
  [3749] = {.lex_state = 92, .external_lex_state = 27},
  [3750] = {.lex_state = 88, .external_lex_state = 24},
  [3751] = {.lex_state = 88, .external_lex_state = 22},
  [3752] = {.lex_state = 88, .external_lex_state = 24},
  [3753] = {.lex_state = 92, .external_lex_state = 30},
  [3754] = {.lex_state = 88, .external_lex_state = 24},
  [3755] = {.lex_state = 88, .external_lex_state = 24},
  [3756] = {.lex_state = 92, .external_lex_state = 30},
  [3757] = {.lex_state = 89, .external_lex_state = 24},
  [3758] = {.lex_state = 88, .external_lex_state = 24},
  [3759] = {.lex_state = 88, .external_lex_state = 24},
  [3760] = {.lex_state = 88, .external_lex_state = 24},
  [3761] = {.lex_state = 88, .external_lex_state = 24},
  [3762] = {.lex_state = 88, .external_lex_state = 24},
  [3763] = {.lex_state = 92, .external_lex_state = 30},
  [3764] = {.lex_state = 89, .external_lex_state = 24},
  [3765] = {.lex_state = 88, .external_lex_state = 24},
  [3766] = {.lex_state = 92, .external_lex_state = 30},
  [3767] = {.lex_state = 88, .external_lex_state = 24},
  [3768] = {.lex_state = 89, .external_lex_state = 24},
  [3769] = {.lex_state = 89, .external_lex_state = 24},
  [3770] = {.lex_state = 92, .external_lex_state = 30},
  [3771] = {.lex_state = 92, .external_lex_state = 27},
  [3772] = {.lex_state = 88, .external_lex_state = 24},
  [3773] = {.lex_state = 92, .external_lex_state = 30},
  [3774] = {.lex_state = 88, .external_lex_state = 22},
  [3775] = {.lex_state = 92, .external_lex_state = 30},
  [3776] = {.lex_state = 92, .external_lex_state = 30},
  [3777] = {.lex_state = 89, .external_lex_state = 24},
  [3778] = {.lex_state = 89, .external_lex_state = 24},
  [3779] = {.lex_state = 89, .external_lex_state = 24},
  [3780] = {.lex_state = 89, .external_lex_state = 24},
  [3781] = {.lex_state = 89, .external_lex_state = 24},
  [3782] = {.lex_state = 89, .external_lex_state = 24},
  [3783] = {.lex_state = 89, .external_lex_state = 24},
  [3784] = {.lex_state = 92, .external_lex_state = 30},
  [3785] = {.lex_state = 92, .external_lex_state = 30},
  [3786] = {.lex_state = 92, .external_lex_state = 30},
  [3787] = {.lex_state = 88, .external_lex_state = 22},
  [3788] = {.lex_state = 92, .external_lex_state = 30},
  [3789] = {.lex_state = 92, .external_lex_state = 30},
  [3790] = {.lex_state = 89, .external_lex_state = 24},
  [3791] = {.lex_state = 92, .external_lex_state = 30},
  [3792] = {.lex_state = 92, .external_lex_state = 30},
  [3793] = {.lex_state = 92, .external_lex_state = 30},
  [3794] = {.lex_state = 89, .external_lex_state = 24},
  [3795] = {.lex_state = 89, .external_lex_state = 24},
  [3796] = {.lex_state = 92, .external_lex_state = 30},
  [3797] = {.lex_state = 92, .external_lex_state = 30},
  [3798] = {.lex_state = 92, .external_lex_state = 30},
  [3799] = {.lex_state = 92, .external_lex_state = 30},
  [3800] = {.lex_state = 92, .external_lex_state = 30},
  [3801] = {.lex_state = 92, .external_lex_state = 30},
  [3802] = {.lex_state = 92, .external_lex_state = 30},
  [3803] = {.lex_state = 92, .external_lex_state = 30},
  [3804] = {.lex_state = 92, .external_lex_state = 30},
  [3805] = {.lex_state = 88, .external_lex_state = 24},
  [3806] = {.lex_state = 88, .external_lex_state = 22},
  [3807] = {.lex_state = 88, .external_lex_state = 22},
  [3808] = {.lex_state = 92, .external_lex_state = 30},
  [3809] = {.lex_state = 92, .external_lex_state = 30},
  [3810] = {.lex_state = 92, .external_lex_state = 27},
  [3811] = {.lex_state = 92, .external_lex_state = 27},
  [3812] = {.lex_state = 89, .external_lex_state = 24},
  [3813] = {.lex_state = 92, .external_lex_state = 30},
  [3814] = {.lex_state = 92, .external_lex_state = 30},
  [3815] = {.lex_state = 92, .external_lex_state = 30},
  [3816] = {.lex_state = 92, .external_lex_state = 30},
  [3817] = {.lex_state = 92, .external_lex_state = 30},
  [3818] = {.lex_state = 88, .external_lex_state = 22},
  [3819] = {.lex_state = 88, .external_lex_state = 22},
  [3820] = {.lex_state = 92, .external_lex_state = 30},
  [3821] = {.lex_state = 92, .external_lex_state = 30},
  [3822] = {.lex_state = 89, .external_lex_state = 24},
  [3823] = {.lex_state = 89, .external_lex_state = 24},
  [3824] = {.lex_state = 92, .external_lex_state = 30},
  [3825] = {.lex_state = 92, .external_lex_state = 27},
  [3826] = {.lex_state = 92, .external_lex_state = 27},
  [3827] = {.lex_state = 92, .external_lex_state = 27},
  [3828] = {.lex_state = 92, .external_lex_state = 27},
  [3829] = {.lex_state = 89, .external_lex_state = 24},
  [3830] = {.lex_state = 92, .external_lex_state = 30},
  [3831] = {.lex_state = 92, .external_lex_state = 27},
  [3832] = {.lex_state = 92, .external_lex_state = 27},
  [3833] = {.lex_state = 92, .external_lex_state = 27},
  [3834] = {.lex_state = 92, .external_lex_state = 27},
  [3835] = {.lex_state = 92, .external_lex_state = 30},
  [3836] = {.lex_state = 92, .external_lex_state = 30},
  [3837] = {.lex_state = 92, .external_lex_state = 30},
  [3838] = {.lex_state = 89, .external_lex_state = 24},
  [3839] = {.lex_state = 92, .external_lex_state = 27},
  [3840] = {.lex_state = 89, .external_lex_state = 24},
  [3841] = {.lex_state = 89, .external_lex_state = 24},
  [3842] = {.lex_state = 92, .external_lex_state = 27},
  [3843] = {.lex_state = 92, .external_lex_state = 27},
  [3844] = {.lex_state = 92, .external_lex_state = 27},
  [3845] = {.lex_state = 89, .external_lex_state = 24},
  [3846] = {.lex_state = 92, .external_lex_state = 27},
  [3847] = {.lex_state = 92, .external_lex_state = 27},
  [3848] = {.lex_state = 92, .external_lex_state = 30},
  [3849] = {.lex_state = 92, .external_lex_state = 27},
  [3850] = {.lex_state = 92, .external_lex_state = 27},
  [3851] = {.lex_state = 89, .external_lex_state = 24},
  [3852] = {.lex_state = 92, .external_lex_state = 30},
  [3853] = {.lex_state = 89, .external_lex_state = 24},
  [3854] = {.lex_state = 89, .external_lex_state = 24},
  [3855] = {.lex_state = 89, .external_lex_state = 24},
  [3856] = {.lex_state = 92, .external_lex_state = 27},
  [3857] = {.lex_state = 89, .external_lex_state = 24},
  [3858] = {.lex_state = 92, .external_lex_state = 30},
  [3859] = {.lex_state = 89, .external_lex_state = 24},
  [3860] = {.lex_state = 89, .external_lex_state = 24},
  [3861] = {.lex_state = 89, .external_lex_state = 24},
  [3862] = {.lex_state = 89, .external_lex_state = 24},
  [3863] = {.lex_state = 89, .external_lex_state = 24},
  [3864] = {.lex_state = 92, .external_lex_state = 27},
  [3865] = {.lex_state = 92, .external_lex_state = 27},
  [3866] = {.lex_state = 89, .external_lex_state = 24},
  [3867] = {.lex_state = 92, .external_lex_state = 27},
  [3868] = {.lex_state = 92, .external_lex_state = 27},
  [3869] = {.lex_state = 92, .external_lex_state = 30},
  [3870] = {.lex_state = 92, .external_lex_state = 27},
  [3871] = {.lex_state = 92, .external_lex_state = 27},
  [3872] = {.lex_state = 89, .external_lex_state = 24},
  [3873] = {.lex_state = 92, .external_lex_state = 27},
  [3874] = {.lex_state = 92, .external_lex_state = 27},
  [3875] = {.lex_state = 89, .external_lex_state = 24},
  [3876] = {.lex_state = 89, .external_lex_state = 24},
  [3877] = {.lex_state = 92, .external_lex_state = 27},
  [3878] = {.lex_state = 89, .external_lex_state = 24},
  [3879] = {.lex_state = 89, .external_lex_state = 24},
  [3880] = {.lex_state = 89, .external_lex_state = 24},
  [3881] = {.lex_state = 89, .external_lex_state = 24},
  [3882] = {.lex_state = 92, .external_lex_state = 27},
  [3883] = {.lex_state = 89, .external_lex_state = 24},
  [3884] = {.lex_state = 89, .external_lex_state = 24},
  [3885] = {.lex_state = 89, .external_lex_state = 24},
  [3886] = {.lex_state = 89, .external_lex_state = 24},
  [3887] = {.lex_state = 89, .external_lex_state = 24},
  [3888] = {.lex_state = 89, .external_lex_state = 24},
  [3889] = {.lex_state = 89, .external_lex_state = 24},
  [3890] = {.lex_state = 89, .external_lex_state = 24},
  [3891] = {.lex_state = 92, .external_lex_state = 27},
  [3892] = {.lex_state = 89, .external_lex_state = 24},
  [3893] = {.lex_state = 89, .external_lex_state = 24},
  [3894] = {.lex_state = 89, .external_lex_state = 24},
  [3895] = {.lex_state = 89, .external_lex_state = 24},
  [3896] = {.lex_state = 92, .external_lex_state = 27},
  [3897] = {.lex_state = 92, .external_lex_state = 30},
  [3898] = {.lex_state = 92, .external_lex_state = 30},
  [3899] = {.lex_state = 92, .external_lex_state = 30},
  [3900] = {.lex_state = 92, .external_lex_state = 30},
  [3901] = {.lex_state = 92, .external_lex_state = 30},
  [3902] = {.lex_state = 89, .external_lex_state = 24},
  [3903] = {.lex_state = 89, .external_lex_state = 24},
  [3904] = {.lex_state = 89, .external_lex_state = 24},
  [3905] = {.lex_state = 89, .external_lex_state = 24},
  [3906] = {.lex_state = 89, .external_lex_state = 24},
  [3907] = {.lex_state = 89, .external_lex_state = 24},
  [3908] = {.lex_state = 89, .external_lex_state = 24},
  [3909] = {.lex_state = 89, .external_lex_state = 24},
  [3910] = {.lex_state = 92, .external_lex_state = 27},
  [3911] = {.lex_state = 89, .external_lex_state = 24},
  [3912] = {.lex_state = 92, .external_lex_state = 27},
  [3913] = {.lex_state = 92, .external_lex_state = 30},
  [3914] = {.lex_state = 89, .external_lex_state = 24},
  [3915] = {.lex_state = 92, .external_lex_state = 27},
  [3916] = {.lex_state = 92, .external_lex_state = 27},
  [3917] = {.lex_state = 92, .external_lex_state = 27},
  [3918] = {.lex_state = 92, .external_lex_state = 27},
  [3919] = {.lex_state = 92, .external_lex_state = 30},
  [3920] = {.lex_state = 92, .external_lex_state = 27},
  [3921] = {.lex_state = 89, .external_lex_state = 24},
  [3922] = {.lex_state = 92, .external_lex_state = 27},
  [3923] = {.lex_state = 88, .external_lex_state = 24},
  [3924] = {.lex_state = 92, .external_lex_state = 30},
  [3925] = {.lex_state = 89, .external_lex_state = 24},
  [3926] = {.lex_state = 89, .external_lex_state = 24},
  [3927] = {.lex_state = 89, .external_lex_state = 24},
  [3928] = {.lex_state = 89, .external_lex_state = 24},
  [3929] = {.lex_state = 92, .external_lex_state = 30},
  [3930] = {.lex_state = 92, .external_lex_state = 27},
  [3931] = {.lex_state = 92, .external_lex_state = 27},
  [3932] = {.lex_state = 92, .external_lex_state = 27},
  [3933] = {.lex_state = 92, .external_lex_state = 30},
  [3934] = {.lex_state = 92, .external_lex_state = 27},
  [3935] = {.lex_state = 92, .external_lex_state = 27},
  [3936] = {.lex_state = 92, .external_lex_state = 27},
  [3937] = {.lex_state = 92, .external_lex_state = 30},
  [3938] = {.lex_state = 92, .external_lex_state = 30},
  [3939] = {.lex_state = 92, .external_lex_state = 30},
  [3940] = {.lex_state = 92, .external_lex_state = 30},
  [3941] = {.lex_state = 92, .external_lex_state = 30},
  [3942] = {.lex_state = 92, .external_lex_state = 27},
  [3943] = {.lex_state = 92, .external_lex_state = 30},
  [3944] = {.lex_state = 92, .external_lex_state = 30},
  [3945] = {.lex_state = 92, .external_lex_state = 30},
  [3946] = {.lex_state = 92, .external_lex_state = 27},
  [3947] = {.lex_state = 92, .external_lex_state = 27},
  [3948] = {.lex_state = 89, .external_lex_state = 24},
  [3949] = {.lex_state = 89, .external_lex_state = 24},
  [3950] = {.lex_state = 89, .external_lex_state = 24},
  [3951] = {.lex_state = 89, .external_lex_state = 24},
  [3952] = {.lex_state = 89, .external_lex_state = 24},
  [3953] = {.lex_state = 89, .external_lex_state = 24},
  [3954] = {.lex_state = 89, .external_lex_state = 24},
  [3955] = {.lex_state = 89, .external_lex_state = 24},
  [3956] = {.lex_state = 89, .external_lex_state = 24},
  [3957] = {.lex_state = 89, .external_lex_state = 24},
  [3958] = {.lex_state = 89, .external_lex_state = 24},
  [3959] = {.lex_state = 89, .external_lex_state = 24},
  [3960] = {.lex_state = 89, .external_lex_state = 24},
  [3961] = {.lex_state = 92, .external_lex_state = 27},
  [3962] = {.lex_state = 92, .external_lex_state = 27},
  [3963] = {.lex_state = 92, .external_lex_state = 27},
  [3964] = {.lex_state = 92, .external_lex_state = 27},
  [3965] = {.lex_state = 89, .external_lex_state = 24},
  [3966] = {.lex_state = 92, .external_lex_state = 27},
  [3967] = {.lex_state = 89, .external_lex_state = 24},
  [3968] = {.lex_state = 89, .external_lex_state = 24},
  [3969] = {.lex_state = 92, .external_lex_state = 27},
  [3970] = {.lex_state = 92, .external_lex_state = 27},
  [3971] = {.lex_state = 92, .external_lex_state = 27},
  [3972] = {.lex_state = 92, .external_lex_state = 27},
  [3973] = {.lex_state = 92, .external_lex_state = 27},
  [3974] = {.lex_state = 92, .external_lex_state = 27},
  [3975] = {.lex_state = 92, .external_lex_state = 27},
  [3976] = {.lex_state = 92, .external_lex_state = 27},
  [3977] = {.lex_state = 92, .external_lex_state = 27},
  [3978] = {.lex_state = 92, .external_lex_state = 27},
  [3979] = {.lex_state = 92, .external_lex_state = 27},
  [3980] = {.lex_state = 92, .external_lex_state = 27},
  [3981] = {.lex_state = 92, .external_lex_state = 27},
  [3982] = {.lex_state = 92, .external_lex_state = 27},
  [3983] = {.lex_state = 92, .external_lex_state = 30},
  [3984] = {.lex_state = 92, .external_lex_state = 27},
  [3985] = {.lex_state = 89, .external_lex_state = 24},
  [3986] = {.lex_state = 92, .external_lex_state = 27},
  [3987] = {.lex_state = 92, .external_lex_state = 30},
  [3988] = {.lex_state = 92, .external_lex_state = 30},
  [3989] = {.lex_state = 92, .external_lex_state = 30},
  [3990] = {.lex_state = 92, .external_lex_state = 30},
  [3991] = {.lex_state = 92, .external_lex_state = 30},
  [3992] = {.lex_state = 92, .external_lex_state = 30},
  [3993] = {.lex_state = 92, .external_lex_state = 30},
  [3994] = {.lex_state = 88, .external_lex_state = 24},
  [3995] = {.lex_state = 92, .external_lex_state = 30},
  [3996] = {.lex_state = 92, .external_lex_state = 30},
  [3997] = {.lex_state = 92, .external_lex_state = 30},
  [3998] = {.lex_state = 92, .external_lex_state = 30},
  [3999] = {.lex_state = 92, .external_lex_state = 27},
  [4000] = {.lex_state = 92, .external_lex_state = 30},
  [4001] = {.lex_state = 92, .external_lex_state = 30},
  [4002] = {.lex_state = 92, .external_lex_state = 30},
  [4003] = {.lex_state = 92, .external_lex_state = 30},
  [4004] = {.lex_state = 92, .external_lex_state = 30},
  [4005] = {.lex_state = 92, .external_lex_state = 27},
  [4006] = {.lex_state = 92, .external_lex_state = 27},
  [4007] = {.lex_state = 92, .external_lex_state = 30},
  [4008] = {.lex_state = 92, .external_lex_state = 30},
  [4009] = {.lex_state = 92, .external_lex_state = 30},
  [4010] = {.lex_state = 92, .external_lex_state = 30},
  [4011] = {.lex_state = 92, .external_lex_state = 30},
  [4012] = {.lex_state = 92, .external_lex_state = 30},
  [4013] = {.lex_state = 92, .external_lex_state = 30},
  [4014] = {.lex_state = 92, .external_lex_state = 30},
  [4015] = {.lex_state = 92, .external_lex_state = 30},
  [4016] = {.lex_state = 92, .external_lex_state = 30},
  [4017] = {.lex_state = 92, .external_lex_state = 30},
  [4018] = {.lex_state = 92, .external_lex_state = 27},
  [4019] = {.lex_state = 92, .external_lex_state = 30},
  [4020] = {.lex_state = 92, .external_lex_state = 30},
  [4021] = {.lex_state = 92, .external_lex_state = 30},
  [4022] = {.lex_state = 92, .external_lex_state = 30},
  [4023] = {.lex_state = 92, .external_lex_state = 30},
  [4024] = {.lex_state = 92, .external_lex_state = 30},
  [4025] = {.lex_state = 92, .external_lex_state = 30},
  [4026] = {.lex_state = 92, .external_lex_state = 30},
  [4027] = {.lex_state = 92, .external_lex_state = 27},
  [4028] = {.lex_state = 92, .external_lex_state = 27},
  [4029] = {.lex_state = 92, .external_lex_state = 27},
  [4030] = {.lex_state = 92, .external_lex_state = 27},
  [4031] = {.lex_state = 92, .external_lex_state = 27},
  [4032] = {.lex_state = 92, .external_lex_state = 27},
  [4033] = {.lex_state = 92, .external_lex_state = 27},
  [4034] = {.lex_state = 92, .external_lex_state = 27},
  [4035] = {.lex_state = 92, .external_lex_state = 27},
  [4036] = {.lex_state = 92, .external_lex_state = 27},
  [4037] = {.lex_state = 92, .external_lex_state = 27},
  [4038] = {.lex_state = 92, .external_lex_state = 27},
  [4039] = {.lex_state = 92, .external_lex_state = 27},
  [4040] = {.lex_state = 92, .external_lex_state = 27},
  [4041] = {.lex_state = 92, .external_lex_state = 27},
  [4042] = {.lex_state = 92, .external_lex_state = 30},
  [4043] = {.lex_state = 107, .external_lex_state = 32},
  [4044] = {.lex_state = 92, .external_lex_state = 27},
  [4045] = {.lex_state = 92, .external_lex_state = 27},
  [4046] = {.lex_state = 92, .external_lex_state = 30},
  [4047] = {.lex_state = 92, .external_lex_state = 30},
  [4048] = {.lex_state = 92, .external_lex_state = 30},
  [4049] = {.lex_state = 92, .external_lex_state = 27},
  [4050] = {.lex_state = 92, .external_lex_state = 27},
  [4051] = {.lex_state = 92, .external_lex_state = 30},
  [4052] = {.lex_state = 92, .external_lex_state = 27},
  [4053] = {.lex_state = 92, .external_lex_state = 27},
  [4054] = {.lex_state = 92, .external_lex_state = 30},
  [4055] = {.lex_state = 92, .external_lex_state = 30},
  [4056] = {.lex_state = 92, .external_lex_state = 27},
  [4057] = {.lex_state = 92, .external_lex_state = 30},
  [4058] = {.lex_state = 92, .external_lex_state = 27},
  [4059] = {.lex_state = 92, .external_lex_state = 30},
  [4060] = {.lex_state = 92, .external_lex_state = 30},
  [4061] = {.lex_state = 92, .external_lex_state = 30},
  [4062] = {.lex_state = 92, .external_lex_state = 30},
  [4063] = {.lex_state = 92, .external_lex_state = 30},
  [4064] = {.lex_state = 92, .external_lex_state = 30},
  [4065] = {.lex_state = 92, .external_lex_state = 30},
  [4066] = {.lex_state = 92, .external_lex_state = 27},
  [4067] = {.lex_state = 92, .external_lex_state = 30},
  [4068] = {.lex_state = 92, .external_lex_state = 30},
  [4069] = {.lex_state = 92, .external_lex_state = 30},
  [4070] = {.lex_state = 92, .external_lex_state = 30},
  [4071] = {.lex_state = 92, .external_lex_state = 30},
  [4072] = {.lex_state = 92, .external_lex_state = 30},
  [4073] = {.lex_state = 92, .external_lex_state = 27},
  [4074] = {.lex_state = 92, .external_lex_state = 30},
  [4075] = {.lex_state = 92, .external_lex_state = 27},
  [4076] = {.lex_state = 92, .external_lex_state = 30},
  [4077] = {.lex_state = 92, .external_lex_state = 30},
  [4078] = {.lex_state = 92, .external_lex_state = 30},
  [4079] = {.lex_state = 92, .external_lex_state = 30},
  [4080] = {.lex_state = 104, .external_lex_state = 32},
  [4081] = {.lex_state = 92, .external_lex_state = 30},
  [4082] = {.lex_state = 92, .external_lex_state = 27},
  [4083] = {.lex_state = 92, .external_lex_state = 27},
  [4084] = {.lex_state = 92, .external_lex_state = 27},
  [4085] = {.lex_state = 92, .external_lex_state = 30},
  [4086] = {.lex_state = 92, .external_lex_state = 30},
  [4087] = {.lex_state = 92, .external_lex_state = 27},
  [4088] = {.lex_state = 92, .external_lex_state = 30},
  [4089] = {.lex_state = 92, .external_lex_state = 27},
  [4090] = {.lex_state = 92, .external_lex_state = 27},
  [4091] = {.lex_state = 92, .external_lex_state = 27},
  [4092] = {.lex_state = 92, .external_lex_state = 27},
  [4093] = {.lex_state = 92, .external_lex_state = 27},
  [4094] = {.lex_state = 92, .external_lex_state = 30},
  [4095] = {.lex_state = 92, .external_lex_state = 27},
  [4096] = {.lex_state = 92, .external_lex_state = 30},
  [4097] = {.lex_state = 92, .external_lex_state = 27},
  [4098] = {.lex_state = 92, .external_lex_state = 30},
  [4099] = {.lex_state = 92, .external_lex_state = 30},
  [4100] = {.lex_state = 92, .external_lex_state = 30},
  [4101] = {.lex_state = 92, .external_lex_state = 30},
  [4102] = {.lex_state = 92, .external_lex_state = 30},
  [4103] = {.lex_state = 92, .external_lex_state = 27},
  [4104] = {.lex_state = 92, .external_lex_state = 30},
  [4105] = {.lex_state = 92, .external_lex_state = 27},
  [4106] = {.lex_state = 92, .external_lex_state = 30},
  [4107] = {.lex_state = 92, .external_lex_state = 30},
  [4108] = {.lex_state = 92, .external_lex_state = 30},
  [4109] = {.lex_state = 92, .external_lex_state = 30},
  [4110] = {.lex_state = 104, .external_lex_state = 32},
  [4111] = {.lex_state = 92, .external_lex_state = 30},
  [4112] = {.lex_state = 92, .external_lex_state = 30},
  [4113] = {.lex_state = 92, .external_lex_state = 27},
  [4114] = {.lex_state = 92, .external_lex_state = 27},
  [4115] = {.lex_state = 92, .external_lex_state = 30},
  [4116] = {.lex_state = 92, .external_lex_state = 30},
  [4117] = {.lex_state = 92, .external_lex_state = 30},
  [4118] = {.lex_state = 92, .external_lex_state = 30},
  [4119] = {.lex_state = 92, .external_lex_state = 30},
  [4120] = {.lex_state = 92, .external_lex_state = 30},
  [4121] = {.lex_state = 92, .external_lex_state = 30},
  [4122] = {.lex_state = 92, .external_lex_state = 27},
  [4123] = {.lex_state = 92, .external_lex_state = 30},
  [4124] = {.lex_state = 92, .external_lex_state = 27},
  [4125] = {.lex_state = 92, .external_lex_state = 30},
  [4126] = {.lex_state = 92, .external_lex_state = 30},
  [4127] = {.lex_state = 92, .external_lex_state = 27},
  [4128] = {.lex_state = 92, .external_lex_state = 30},
  [4129] = {.lex_state = 92, .external_lex_state = 30},
  [4130] = {.lex_state = 92, .external_lex_state = 27},
  [4131] = {.lex_state = 92, .external_lex_state = 30},
  [4132] = {.lex_state = 92, .external_lex_state = 30},
  [4133] = {.lex_state = 92, .external_lex_state = 30},
  [4134] = {.lex_state = 92, .external_lex_state = 30},
  [4135] = {.lex_state = 92, .external_lex_state = 30},
  [4136] = {.lex_state = 92, .external_lex_state = 30},
  [4137] = {.lex_state = 92, .external_lex_state = 30},
  [4138] = {.lex_state = 92, .external_lex_state = 27},
  [4139] = {.lex_state = 231, .external_lex_state = 32},
  [4140] = {.lex_state = 92, .external_lex_state = 27},
  [4141] = {.lex_state = 92, .external_lex_state = 30},
  [4142] = {.lex_state = 92, .external_lex_state = 30},
  [4143] = {.lex_state = 92, .external_lex_state = 27},
  [4144] = {.lex_state = 92, .external_lex_state = 30},
  [4145] = {.lex_state = 92, .external_lex_state = 27},
  [4146] = {.lex_state = 92, .external_lex_state = 30},
  [4147] = {.lex_state = 92, .external_lex_state = 30},
  [4148] = {.lex_state = 92, .external_lex_state = 30},
  [4149] = {.lex_state = 92, .external_lex_state = 30},
  [4150] = {.lex_state = 92, .external_lex_state = 30},
  [4151] = {.lex_state = 92, .external_lex_state = 30},
  [4152] = {.lex_state = 92, .external_lex_state = 30},
  [4153] = {.lex_state = 92, .external_lex_state = 30},
  [4154] = {.lex_state = 92, .external_lex_state = 30},
  [4155] = {.lex_state = 92, .external_lex_state = 30},
  [4156] = {.lex_state = 92, .external_lex_state = 30},
  [4157] = {.lex_state = 92, .external_lex_state = 30},
  [4158] = {.lex_state = 92, .external_lex_state = 30},
  [4159] = {.lex_state = 92, .external_lex_state = 30},
  [4160] = {.lex_state = 92, .external_lex_state = 30},
  [4161] = {.lex_state = 92, .external_lex_state = 30},
  [4162] = {.lex_state = 92, .external_lex_state = 30},
  [4163] = {.lex_state = 92, .external_lex_state = 30},
  [4164] = {.lex_state = 92, .external_lex_state = 30},
  [4165] = {.lex_state = 92, .external_lex_state = 30},
  [4166] = {.lex_state = 92, .external_lex_state = 30},
  [4167] = {.lex_state = 92, .external_lex_state = 30},
  [4168] = {.lex_state = 92, .external_lex_state = 30},
  [4169] = {.lex_state = 92, .external_lex_state = 30},
  [4170] = {.lex_state = 92, .external_lex_state = 30},
  [4171] = {.lex_state = 92, .external_lex_state = 30},
  [4172] = {.lex_state = 92, .external_lex_state = 30},
  [4173] = {.lex_state = 224, .external_lex_state = 33},
  [4174] = {.lex_state = 92, .external_lex_state = 30},
  [4175] = {.lex_state = 92, .external_lex_state = 30},
  [4176] = {.lex_state = 92, .external_lex_state = 30},
  [4177] = {.lex_state = 92, .external_lex_state = 30},
  [4178] = {.lex_state = 92, .external_lex_state = 30},
  [4179] = {.lex_state = 92, .external_lex_state = 30},
  [4180] = {.lex_state = 225, .external_lex_state = 31},
  [4181] = {.lex_state = 92, .external_lex_state = 30},
  [4182] = {.lex_state = 92, .external_lex_state = 30},
  [4183] = {.lex_state = 92, .external_lex_state = 30},
  [4184] = {.lex_state = 92, .external_lex_state = 30},
  [4185] = {.lex_state = 92, .external_lex_state = 30},
  [4186] = {.lex_state = 92, .external_lex_state = 30},
  [4187] = {.lex_state = 92, .external_lex_state = 30},
  [4188] = {.lex_state = 92, .external_lex_state = 30},
  [4189] = {.lex_state = 92, .external_lex_state = 30},
  [4190] = {.lex_state = 92, .external_lex_state = 30},
  [4191] = {.lex_state = 225, .external_lex_state = 31},
  [4192] = {.lex_state = 92, .external_lex_state = 30},
  [4193] = {.lex_state = 92, .external_lex_state = 30},
  [4194] = {.lex_state = 92, .external_lex_state = 30},
  [4195] = {.lex_state = 92, .external_lex_state = 30},
  [4196] = {.lex_state = 92, .external_lex_state = 30},
  [4197] = {.lex_state = 226, .external_lex_state = 32},
  [4198] = {.lex_state = 92, .external_lex_state = 30},
  [4199] = {.lex_state = 92, .external_lex_state = 30},
  [4200] = {.lex_state = 92, .external_lex_state = 30},
  [4201] = {.lex_state = 92, .external_lex_state = 30},
  [4202] = {.lex_state = 92, .external_lex_state = 30},
  [4203] = {.lex_state = 92, .external_lex_state = 30},
  [4204] = {.lex_state = 92, .external_lex_state = 30},
  [4205] = {.lex_state = 92, .external_lex_state = 30},
  [4206] = {.lex_state = 92, .external_lex_state = 30},
  [4207] = {.lex_state = 92, .external_lex_state = 30},
  [4208] = {.lex_state = 92, .external_lex_state = 30},
  [4209] = {.lex_state = 92, .external_lex_state = 30},
  [4210] = {.lex_state = 92, .external_lex_state = 30},
  [4211] = {.lex_state = 92, .external_lex_state = 30},
  [4212] = {.lex_state = 92, .external_lex_state = 30},
  [4213] = {.lex_state = 92, .external_lex_state = 30},
  [4214] = {.lex_state = 92, .external_lex_state = 30},
  [4215] = {.lex_state = 92, .external_lex_state = 30},
  [4216] = {.lex_state = 92, .external_lex_state = 30},
  [4217] = {.lex_state = 92, .external_lex_state = 30},
  [4218] = {.lex_state = 92, .external_lex_state = 30},
  [4219] = {.lex_state = 92, .external_lex_state = 30},
  [4220] = {.lex_state = 92, .external_lex_state = 30},
  [4221] = {.lex_state = 92, .external_lex_state = 30},
  [4222] = {.lex_state = 92, .external_lex_state = 30},
  [4223] = {.lex_state = 92, .external_lex_state = 30},
  [4224] = {.lex_state = 92, .external_lex_state = 30},
  [4225] = {.lex_state = 92, .external_lex_state = 30},
  [4226] = {.lex_state = 92, .external_lex_state = 30},
  [4227] = {.lex_state = 92, .external_lex_state = 30},
  [4228] = {.lex_state = 92, .external_lex_state = 30},
  [4229] = {.lex_state = 230, .external_lex_state = 32},
  [4230] = {.lex_state = 230, .external_lex_state = 32},
  [4231] = {.lex_state = 92, .external_lex_state = 30},
  [4232] = {.lex_state = 92, .external_lex_state = 30},
  [4233] = {.lex_state = 232, .external_lex_state = 32},
  [4234] = {.lex_state = 226, .external_lex_state = 32},
  [4235] = {.lex_state = 226, .external_lex_state = 32},
  [4236] = {.lex_state = 226, .external_lex_state = 32},
  [4237] = {.lex_state = 226, .external_lex_state = 32},
  [4238] = {.lex_state = 92, .external_lex_state = 30},
  [4239] = {.lex_state = 226, .external_lex_state = 32},
  [4240] = {.lex_state = 92, .external_lex_state = 30},
  [4241] = {.lex_state = 92, .external_lex_state = 30},
  [4242] = {.lex_state = 92, .external_lex_state = 30},
  [4243] = {.lex_state = 92, .external_lex_state = 30},
  [4244] = {.lex_state = 92, .external_lex_state = 30},
  [4245] = {.lex_state = 92, .external_lex_state = 30},
  [4246] = {.lex_state = 230, .external_lex_state = 32},
  [4247] = {.lex_state = 92, .external_lex_state = 30},
  [4248] = {.lex_state = 92, .external_lex_state = 30},
  [4249] = {.lex_state = 226, .external_lex_state = 32},
  [4250] = {.lex_state = 226, .external_lex_state = 32},
  [4251] = {.lex_state = 92, .external_lex_state = 30},
  [4252] = {.lex_state = 92, .external_lex_state = 30},
  [4253] = {.lex_state = 92, .external_lex_state = 30},
  [4254] = {.lex_state = 230, .external_lex_state = 32},
  [4255] = {.lex_state = 226, .external_lex_state = 32},
  [4256] = {.lex_state = 92, .external_lex_state = 30},
  [4257] = {.lex_state = 92, .external_lex_state = 30},
  [4258] = {.lex_state = 92, .external_lex_state = 30},
  [4259] = {.lex_state = 92, .external_lex_state = 30},
  [4260] = {.lex_state = 92, .external_lex_state = 30},
  [4261] = {.lex_state = 92, .external_lex_state = 30},
  [4262] = {.lex_state = 92, .external_lex_state = 30},
  [4263] = {.lex_state = 92, .external_lex_state = 30},
  [4264] = {.lex_state = 226, .external_lex_state = 32},
  [4265] = {.lex_state = 92, .external_lex_state = 30},
  [4266] = {.lex_state = 92, .external_lex_state = 30},
  [4267] = {.lex_state = 226, .external_lex_state = 32},
  [4268] = {.lex_state = 92, .external_lex_state = 30},
  [4269] = {.lex_state = 92, .external_lex_state = 30},
  [4270] = {.lex_state = 226, .external_lex_state = 32},
  [4271] = {.lex_state = 92, .external_lex_state = 30},
  [4272] = {.lex_state = 92, .external_lex_state = 30},
  [4273] = {.lex_state = 226, .external_lex_state = 32},
  [4274] = {.lex_state = 92, .external_lex_state = 30},
  [4275] = {.lex_state = 92, .external_lex_state = 30},
  [4276] = {.lex_state = 92, .external_lex_state = 30},
  [4277] = {.lex_state = 92, .external_lex_state = 30},
  [4278] = {.lex_state = 226, .external_lex_state = 32},
  [4279] = {.lex_state = 232, .external_lex_state = 32},
  [4280] = {.lex_state = 226, .external_lex_state = 32},
  [4281] = {.lex_state = 92, .external_lex_state = 30},
  [4282] = {.lex_state = 92, .external_lex_state = 30},
  [4283] = {.lex_state = 92, .external_lex_state = 30},
  [4284] = {.lex_state = 92, .external_lex_state = 30},
  [4285] = {.lex_state = 92, .external_lex_state = 30},
  [4286] = {.lex_state = 230, .external_lex_state = 32},
  [4287] = {.lex_state = 92, .external_lex_state = 30},
  [4288] = {.lex_state = 92, .external_lex_state = 30},
  [4289] = {.lex_state = 92, .external_lex_state = 30},
  [4290] = {.lex_state = 92, .external_lex_state = 30},
  [4291] = {.lex_state = 92, .external_lex_state = 30},
  [4292] = {.lex_state = 92, .external_lex_state = 30},
  [4293] = {.lex_state = 92, .external_lex_state = 30},
  [4294] = {.lex_state = 92, .external_lex_state = 30},
  [4295] = {.lex_state = 92, .external_lex_state = 30},
  [4296] = {.lex_state = 92, .external_lex_state = 30},
  [4297] = {.lex_state = 92, .external_lex_state = 30},
  [4298] = {.lex_state = 92, .external_lex_state = 30},
  [4299] = {.lex_state = 92, .external_lex_state = 30},
  [4300] = {.lex_state = 92, .external_lex_state = 30},
  [4301] = {.lex_state = 92, .external_lex_state = 30},
  [4302] = {.lex_state = 92, .external_lex_state = 30},
  [4303] = {.lex_state = 92, .external_lex_state = 30},
  [4304] = {.lex_state = 92, .external_lex_state = 30},
  [4305] = {.lex_state = 92, .external_lex_state = 30},
  [4306] = {.lex_state = 226, .external_lex_state = 32},
  [4307] = {.lex_state = 92, .external_lex_state = 30},
  [4308] = {.lex_state = 92, .external_lex_state = 30},
  [4309] = {.lex_state = 92, .external_lex_state = 30},
  [4310] = {.lex_state = 92, .external_lex_state = 30},
  [4311] = {.lex_state = 231, .external_lex_state = 32},
  [4312] = {.lex_state = 231, .external_lex_state = 32},
  [4313] = {.lex_state = 231, .external_lex_state = 32},
  [4314] = {.lex_state = 231, .external_lex_state = 32},
  [4315] = {.lex_state = 231, .external_lex_state = 32},
  [4316] = {.lex_state = 231, .external_lex_state = 32},
  [4317] = {.lex_state = 231, .external_lex_state = 32},
  [4318] = {.lex_state = 231, .external_lex_state = 32},
  [4319] = {.lex_state = 231, .external_lex_state = 32},
  [4320] = {.lex_state = 231, .external_lex_state = 32},
  [4321] = {.lex_state = 231, .external_lex_state = 32},
  [4322] = {.lex_state = 231, .external_lex_state = 32},
  [4323] = {.lex_state = 231, .external_lex_state = 32},
  [4324] = {.lex_state = 231, .external_lex_state = 32},
  [4325] = {.lex_state = 231, .external_lex_state = 32},
  [4326] = {.lex_state = 231, .external_lex_state = 32},
  [4327] = {.lex_state = 231, .external_lex_state = 32},
  [4328] = {.lex_state = 231, .external_lex_state = 32},
  [4329] = {.lex_state = 231, .external_lex_state = 32},
  [4330] = {.lex_state = 231, .external_lex_state = 32},
  [4331] = {.lex_state = 231, .external_lex_state = 32},
  [4332] = {.lex_state = 231, .external_lex_state = 32},
  [4333] = {.lex_state = 231, .external_lex_state = 32},
  [4334] = {.lex_state = 231, .external_lex_state = 32},
  [4335] = {.lex_state = 231, .external_lex_state = 32},
  [4336] = {.lex_state = 231, .external_lex_state = 32},
  [4337] = {.lex_state = 231, .external_lex_state = 32},
  [4338] = {.lex_state = 231, .external_lex_state = 32},
  [4339] = {.lex_state = 231, .external_lex_state = 32},
  [4340] = {.lex_state = 231, .external_lex_state = 32},
  [4341] = {.lex_state = 231, .external_lex_state = 32},
  [4342] = {.lex_state = 231, .external_lex_state = 32},
  [4343] = {.lex_state = 231, .external_lex_state = 32},
  [4344] = {.lex_state = 231, .external_lex_state = 32},
  [4345] = {.lex_state = 231, .external_lex_state = 32},
  [4346] = {.lex_state = 231, .external_lex_state = 32},
  [4347] = {.lex_state = 231, .external_lex_state = 32},
  [4348] = {.lex_state = 231, .external_lex_state = 32},
  [4349] = {.lex_state = 231, .external_lex_state = 32},
  [4350] = {.lex_state = 231, .external_lex_state = 32},
  [4351] = {.lex_state = 231, .external_lex_state = 32},
  [4352] = {.lex_state = 231, .external_lex_state = 32},
  [4353] = {.lex_state = 231, .external_lex_state = 32},
  [4354] = {.lex_state = 231, .external_lex_state = 32},
  [4355] = {.lex_state = 231, .external_lex_state = 32},
  [4356] = {.lex_state = 231, .external_lex_state = 32},
  [4357] = {.lex_state = 231, .external_lex_state = 32},
  [4358] = {.lex_state = 231, .external_lex_state = 32},
  [4359] = {.lex_state = 231, .external_lex_state = 32},
  [4360] = {.lex_state = 231, .external_lex_state = 32},
  [4361] = {.lex_state = 231, .external_lex_state = 32},
  [4362] = {.lex_state = 231, .external_lex_state = 32},
  [4363] = {.lex_state = 114, .external_lex_state = 32},
  [4364] = {.lex_state = 226, .external_lex_state = 32},
  [4365] = {.lex_state = 226, .external_lex_state = 32},
  [4366] = {.lex_state = 226, .external_lex_state = 32},
  [4367] = {.lex_state = 226, .external_lex_state = 32},
  [4368] = {.lex_state = 231, .external_lex_state = 32},
  [4369] = {.lex_state = 231, .external_lex_state = 32},
  [4370] = {.lex_state = 231, .external_lex_state = 32},
  [4371] = {.lex_state = 231, .external_lex_state = 32},
  [4372] = {.lex_state = 231, .external_lex_state = 32},
  [4373] = {.lex_state = 231, .external_lex_state = 32},
  [4374] = {.lex_state = 231, .external_lex_state = 32},
  [4375] = {.lex_state = 231, .external_lex_state = 32},
  [4376] = {.lex_state = 231, .external_lex_state = 32},
  [4377] = {.lex_state = 231, .external_lex_state = 32},
  [4378] = {.lex_state = 231, .external_lex_state = 32},
  [4379] = {.lex_state = 231, .external_lex_state = 32},
  [4380] = {.lex_state = 231, .external_lex_state = 32},
  [4381] = {.lex_state = 231, .external_lex_state = 32},
  [4382] = {.lex_state = 231, .external_lex_state = 32},
  [4383] = {.lex_state = 231, .external_lex_state = 32},
  [4384] = {.lex_state = 231, .external_lex_state = 32},
  [4385] = {.lex_state = 103, .external_lex_state = 32},
  [4386] = {.lex_state = 231, .external_lex_state = 32},
  [4387] = {.lex_state = 231, .external_lex_state = 32},
  [4388] = {.lex_state = 231, .external_lex_state = 32},
  [4389] = {.lex_state = 231, .external_lex_state = 32},
  [4390] = {.lex_state = 231, .external_lex_state = 32},
  [4391] = {.lex_state = 107, .external_lex_state = 32},
  [4392] = {.lex_state = 231, .external_lex_state = 32},
  [4393] = {.lex_state = 231, .external_lex_state = 32},
  [4394] = {.lex_state = 107, .external_lex_state = 32},
  [4395] = {.lex_state = 107, .external_lex_state = 32},
  [4396] = {.lex_state = 107, .external_lex_state = 32},
  [4397] = {.lex_state = 107, .external_lex_state = 32},
  [4398] = {.lex_state = 107, .external_lex_state = 32},
  [4399] = {.lex_state = 115, .external_lex_state = 31},
  [4400] = {.lex_state = 115, .external_lex_state = 31},
  [4401] = {.lex_state = 107, .external_lex_state = 32},
  [4402] = {.lex_state = 101, .external_lex_state = 32},
  [4403] = {.lex_state = 231, .external_lex_state = 32},
  [4404] = {.lex_state = 231, .external_lex_state = 32},
  [4405] = {.lex_state = 231, .external_lex_state = 32},
  [4406] = {.lex_state = 231, .external_lex_state = 32},
  [4407] = {.lex_state = 231, .external_lex_state = 32},
  [4408] = {.lex_state = 231, .external_lex_state = 32},
  [4409] = {.lex_state = 231, .external_lex_state = 32},
  [4410] = {.lex_state = 231, .external_lex_state = 32},
  [4411] = {.lex_state = 231, .external_lex_state = 32},
  [4412] = {.lex_state = 101, .external_lex_state = 32},
  [4413] = {.lex_state = 231, .external_lex_state = 32},
  [4414] = {.lex_state = 231, .external_lex_state = 32},
  [4415] = {.lex_state = 231, .external_lex_state = 32},
  [4416] = {.lex_state = 231, .external_lex_state = 32},
  [4417] = {.lex_state = 103, .external_lex_state = 32},
  [4418] = {.lex_state = 231, .external_lex_state = 32},
  [4419] = {.lex_state = 231, .external_lex_state = 32},
  [4420] = {.lex_state = 231, .external_lex_state = 32},
  [4421] = {.lex_state = 231, .external_lex_state = 32},
  [4422] = {.lex_state = 101, .external_lex_state = 32},
  [4423] = {.lex_state = 231, .external_lex_state = 32},
  [4424] = {.lex_state = 231, .external_lex_state = 32},
  [4425] = {.lex_state = 231, .external_lex_state = 32},
  [4426] = {.lex_state = 231, .external_lex_state = 32},
  [4427] = {.lex_state = 231, .external_lex_state = 32},
  [4428] = {.lex_state = 231, .external_lex_state = 32},
  [4429] = {.lex_state = 110, .external_lex_state = 32},
  [4430] = {.lex_state = 231, .external_lex_state = 32},
  [4431] = {.lex_state = 231, .external_lex_state = 32},
  [4432] = {.lex_state = 231, .external_lex_state = 32},
  [4433] = {.lex_state = 231, .external_lex_state = 32},
  [4434] = {.lex_state = 231, .external_lex_state = 32},
  [4435] = {.lex_state = 231, .external_lex_state = 32},
  [4436] = {.lex_state = 231, .external_lex_state = 32},
  [4437] = {.lex_state = 231, .external_lex_state = 32},
  [4438] = {.lex_state = 231, .external_lex_state = 32},
  [4439] = {.lex_state = 231, .external_lex_state = 32},
  [4440] = {.lex_state = 231, .external_lex_state = 32},
  [4441] = {.lex_state = 231, .external_lex_state = 32},
  [4442] = {.lex_state = 231, .external_lex_state = 32},
  [4443] = {.lex_state = 231, .external_lex_state = 32},
  [4444] = {.lex_state = 231, .external_lex_state = 32},
  [4445] = {.lex_state = 101, .external_lex_state = 32},
  [4446] = {.lex_state = 115, .external_lex_state = 34},
  [4447] = {.lex_state = 115, .external_lex_state = 34},
  [4448] = {.lex_state = 115, .external_lex_state = 34},
  [4449] = {.lex_state = 115, .external_lex_state = 34},
  [4450] = {.lex_state = 101, .external_lex_state = 32},
  [4451] = {.lex_state = 101, .external_lex_state = 32},
  [4452] = {.lex_state = 101, .external_lex_state = 32},
  [4453] = {.lex_state = 101, .external_lex_state = 32},
  [4454] = {.lex_state = 101, .external_lex_state = 32},
  [4455] = {.lex_state = 101, .external_lex_state = 32},
  [4456] = {.lex_state = 101, .external_lex_state = 32},
  [4457] = {.lex_state = 101, .external_lex_state = 32},
  [4458] = {.lex_state = 101, .external_lex_state = 32},
  [4459] = {.lex_state = 101, .external_lex_state = 32},
  [4460] = {.lex_state = 101, .external_lex_state = 32},
  [4461] = {.lex_state = 101, .external_lex_state = 32},
  [4462] = {.lex_state = 101, .external_lex_state = 32},
  [4463] = {.lex_state = 101, .external_lex_state = 32},
  [4464] = {.lex_state = 101, .external_lex_state = 32},
  [4465] = {.lex_state = 107, .external_lex_state = 32},
  [4466] = {.lex_state = 107, .external_lex_state = 32},
  [4467] = {.lex_state = 107, .external_lex_state = 32},
  [4468] = {.lex_state = 101, .external_lex_state = 32},
  [4469] = {.lex_state = 101, .external_lex_state = 32},
  [4470] = {.lex_state = 107, .external_lex_state = 32},
  [4471] = {.lex_state = 107, .external_lex_state = 32},
  [4472] = {.lex_state = 107, .external_lex_state = 32},
  [4473] = {.lex_state = 107, .external_lex_state = 32},
  [4474] = {.lex_state = 107, .external_lex_state = 32},
  [4475] = {.lex_state = 107, .external_lex_state = 32},
  [4476] = {.lex_state = 107, .external_lex_state = 32},
  [4477] = {.lex_state = 107, .external_lex_state = 32},
  [4478] = {.lex_state = 231, .external_lex_state = 32},
  [4479] = {.lex_state = 107, .external_lex_state = 32},
  [4480] = {.lex_state = 107, .external_lex_state = 32},
  [4481] = {.lex_state = 107, .external_lex_state = 32},
  [4482] = {.lex_state = 107, .external_lex_state = 32},
  [4483] = {.lex_state = 107, .external_lex_state = 32},
  [4484] = {.lex_state = 107, .external_lex_state = 32},
  [4485] = {.lex_state = 107, .external_lex_state = 32},
  [4486] = {.lex_state = 107, .external_lex_state = 32},
  [4487] = {.lex_state = 107, .external_lex_state = 32},
  [4488] = {.lex_state = 107, .external_lex_state = 32},
  [4489] = {.lex_state = 107, .external_lex_state = 32},
  [4490] = {.lex_state = 107, .external_lex_state = 32},
  [4491] = {.lex_state = 230, .external_lex_state = 32},
  [4492] = {.lex_state = 107, .external_lex_state = 32},
  [4493] = {.lex_state = 103, .external_lex_state = 35},
  [4494] = {.lex_state = 231, .external_lex_state = 32},
  [4495] = {.lex_state = 103, .external_lex_state = 35},
  [4496] = {.lex_state = 103, .external_lex_state = 35},
  [4497] = {.lex_state = 103, .external_lex_state = 35},
  [4498] = {.lex_state = 231, .external_lex_state = 32},
  [4499] = {.lex_state = 231, .external_lex_state = 32},
  [4500] = {.lex_state = 103, .external_lex_state = 35},
  [4501] = {.lex_state = 232, .external_lex_state = 32},
  [4502] = {.lex_state = 231, .external_lex_state = 32},
  [4503] = {.lex_state = 103, .external_lex_state = 35},
  [4504] = {.lex_state = 101, .external_lex_state = 32},
  [4505] = {.lex_state = 231, .external_lex_state = 32},
  [4506] = {.lex_state = 101, .external_lex_state = 32},
  [4507] = {.lex_state = 101, .external_lex_state = 32},
  [4508] = {.lex_state = 103, .external_lex_state = 35},
  [4509] = {.lex_state = 231, .external_lex_state = 32},
  [4510] = {.lex_state = 231, .external_lex_state = 32},
  [4511] = {.lex_state = 101, .external_lex_state = 32},
  [4512] = {.lex_state = 101, .external_lex_state = 32},
  [4513] = {.lex_state = 101, .external_lex_state = 32},
  [4514] = {.lex_state = 118, .external_lex_state = 32},
  [4515] = {.lex_state = 101, .external_lex_state = 32},
  [4516] = {.lex_state = 231, .external_lex_state = 32},
  [4517] = {.lex_state = 101, .external_lex_state = 32},
  [4518] = {.lex_state = 103, .external_lex_state = 35},
  [4519] = {.lex_state = 231, .external_lex_state = 32},
  [4520] = {.lex_state = 103, .external_lex_state = 35},
  [4521] = {.lex_state = 101, .external_lex_state = 32},
  [4522] = {.lex_state = 101, .external_lex_state = 32},
  [4523] = {.lex_state = 103, .external_lex_state = 35},
  [4524] = {.lex_state = 101, .external_lex_state = 32},
  [4525] = {.lex_state = 103, .external_lex_state = 35},
  [4526] = {.lex_state = 103, .external_lex_state = 35},
  [4527] = {.lex_state = 101, .external_lex_state = 32},
  [4528] = {.lex_state = 232, .external_lex_state = 32},
  [4529] = {.lex_state = 226, .external_lex_state = 32},
  [4530] = {.lex_state = 101, .external_lex_state = 32},
  [4531] = {.lex_state = 231, .external_lex_state = 32},
  [4532] = {.lex_state = 231, .external_lex_state = 32},
  [4533] = {.lex_state = 231, .external_lex_state = 32},
  [4534] = {.lex_state = 101, .external_lex_state = 32},
  [4535] = {.lex_state = 103, .external_lex_state = 35},
  [4536] = {.lex_state = 101, .external_lex_state = 32},
  [4537] = {.lex_state = 101, .external_lex_state = 32},
  [4538] = {.lex_state = 115, .external_lex_state = 34},
  [4539] = {.lex_state = 103, .external_lex_state = 35},
  [4540] = {.lex_state = 231, .external_lex_state = 32},
  [4541] = {.lex_state = 101, .external_lex_state = 32},
  [4542] = {.lex_state = 231, .external_lex_state = 32},
  [4543] = {.lex_state = 101, .external_lex_state = 32},
  [4544] = {.lex_state = 101, .external_lex_state = 32},
  [4545] = {.lex_state = 103, .external_lex_state = 35},
  [4546] = {.lex_state = 115, .external_lex_state = 34},
  [4547] = {.lex_state = 101, .external_lex_state = 32},
  [4548] = {.lex_state = 101, .external_lex_state = 32},
  [4549] = {.lex_state = 101, .external_lex_state = 32},
  [4550] = {.lex_state = 103, .external_lex_state = 35},
  [4551] = {.lex_state = 101, .external_lex_state = 32},
  [4552] = {.lex_state = 103, .external_lex_state = 35},
  [4553] = {.lex_state = 231, .external_lex_state = 32},
  [4554] = {.lex_state = 231, .external_lex_state = 32},
  [4555] = {.lex_state = 231, .external_lex_state = 32},
  [4556] = {.lex_state = 103, .external_lex_state = 35},
  [4557] = {.lex_state = 231, .external_lex_state = 32},
  [4558] = {.lex_state = 231, .external_lex_state = 32},
  [4559] = {.lex_state = 101, .external_lex_state = 32},
  [4560] = {.lex_state = 231, .external_lex_state = 32},
  [4561] = {.lex_state = 231, .external_lex_state = 32},
  [4562] = {.lex_state = 114, .external_lex_state = 32},
  [4563] = {.lex_state = 103, .external_lex_state = 35},
  [4564] = {.lex_state = 231, .external_lex_state = 32},
  [4565] = {.lex_state = 231, .external_lex_state = 32},
  [4566] = {.lex_state = 231, .external_lex_state = 32},
  [4567] = {.lex_state = 231, .external_lex_state = 32},
  [4568] = {.lex_state = 231, .external_lex_state = 32},
  [4569] = {.lex_state = 231, .external_lex_state = 32},
  [4570] = {.lex_state = 103, .external_lex_state = 35},
  [4571] = {.lex_state = 231, .external_lex_state = 32},
  [4572] = {.lex_state = 101, .external_lex_state = 32},
  [4573] = {.lex_state = 103, .external_lex_state = 32},
  [4574] = {.lex_state = 231, .external_lex_state = 32},
  [4575] = {.lex_state = 101, .external_lex_state = 35},
  [4576] = {.lex_state = 231, .external_lex_state = 32},
  [4577] = {.lex_state = 101, .external_lex_state = 35},
  [4578] = {.lex_state = 110, .external_lex_state = 35},
  [4579] = {.lex_state = 111, .external_lex_state = 36},
  [4580] = {.lex_state = 114, .external_lex_state = 35},
  [4581] = {.lex_state = 103, .external_lex_state = 35},
  [4582] = {.lex_state = 110, .external_lex_state = 35},
  [4583] = {.lex_state = 103, .external_lex_state = 35},
  [4584] = {.lex_state = 114, .external_lex_state = 35},
  [4585] = {.lex_state = 110, .external_lex_state = 35},
  [4586] = {.lex_state = 111, .external_lex_state = 36},
  [4587] = {.lex_state = 114, .external_lex_state = 35},
  [4588] = {.lex_state = 114, .external_lex_state = 35},
  [4589] = {.lex_state = 110, .external_lex_state = 35},
  [4590] = {.lex_state = 114, .external_lex_state = 35},
  [4591] = {.lex_state = 110, .external_lex_state = 35},
  [4592] = {.lex_state = 110, .external_lex_state = 35},
  [4593] = {.lex_state = 110, .external_lex_state = 35},
  [4594] = {.lex_state = 110, .external_lex_state = 35},
  [4595] = {.lex_state = 110, .external_lex_state = 35},
  [4596] = {.lex_state = 110, .external_lex_state = 35},
  [4597] = {.lex_state = 111, .external_lex_state = 36},
  [4598] = {.lex_state = 110, .external_lex_state = 35},
  [4599] = {.lex_state = 231, .external_lex_state = 32},
  [4600] = {.lex_state = 110, .external_lex_state = 35},
  [4601] = {.lex_state = 114, .external_lex_state = 35},
  [4602] = {.lex_state = 110, .external_lex_state = 35},
  [4603] = {.lex_state = 110, .external_lex_state = 35},
  [4604] = {.lex_state = 231, .external_lex_state = 32},
  [4605] = {.lex_state = 231, .external_lex_state = 32},
  [4606] = {.lex_state = 101, .external_lex_state = 32},
  [4607] = {.lex_state = 110, .external_lex_state = 35},
  [4608] = {.lex_state = 110, .external_lex_state = 35},
  [4609] = {.lex_state = 101, .external_lex_state = 35},
  [4610] = {.lex_state = 101, .external_lex_state = 35},
  [4611] = {.lex_state = 101, .external_lex_state = 35},
  [4612] = {.lex_state = 101, .external_lex_state = 35},
  [4613] = {.lex_state = 101, .external_lex_state = 35},
  [4614] = {.lex_state = 101, .external_lex_state = 35},
  [4615] = {.lex_state = 101, .external_lex_state = 35},
  [4616] = {.lex_state = 101, .external_lex_state = 35},
  [4617] = {.lex_state = 101, .external_lex_state = 35},
  [4618] = {.lex_state = 101, .external_lex_state = 35},
  [4619] = {.lex_state = 101, .external_lex_state = 35},
  [4620] = {.lex_state = 101, .external_lex_state = 35},
  [4621] = {.lex_state = 101, .external_lex_state = 35},
  [4622] = {.lex_state = 101, .external_lex_state = 35},
  [4623] = {.lex_state = 101, .external_lex_state = 35},
  [4624] = {.lex_state = 103, .external_lex_state = 32},
  [4625] = {.lex_state = 101, .external_lex_state = 35},
  [4626] = {.lex_state = 101, .external_lex_state = 35},
  [4627] = {.lex_state = 101, .external_lex_state = 32},
  [4628] = {.lex_state = 101, .external_lex_state = 35},
  [4629] = {.lex_state = 101, .external_lex_state = 35},
  [4630] = {.lex_state = 101, .external_lex_state = 35},
  [4631] = {.lex_state = 101, .external_lex_state = 35},
  [4632] = {.lex_state = 101, .external_lex_state = 35},
  [4633] = {.lex_state = 101, .external_lex_state = 35},
  [4634] = {.lex_state = 101, .external_lex_state = 35},
  [4635] = {.lex_state = 101, .external_lex_state = 35},
  [4636] = {.lex_state = 101, .external_lex_state = 35},
  [4637] = {.lex_state = 101, .external_lex_state = 35},
  [4638] = {.lex_state = 101, .external_lex_state = 35},
  [4639] = {.lex_state = 101, .external_lex_state = 35},
  [4640] = {.lex_state = 101, .external_lex_state = 35},
  [4641] = {.lex_state = 101, .external_lex_state = 35},
  [4642] = {.lex_state = 101, .external_lex_state = 35},
  [4643] = {.lex_state = 101, .external_lex_state = 35},
  [4644] = {.lex_state = 103, .external_lex_state = 35},
  [4645] = {.lex_state = 101, .external_lex_state = 35},
  [4646] = {.lex_state = 101, .external_lex_state = 35},
  [4647] = {.lex_state = 101, .external_lex_state = 35},
  [4648] = {.lex_state = 101, .external_lex_state = 35},
  [4649] = {.lex_state = 101, .external_lex_state = 35},
  [4650] = {.lex_state = 101, .external_lex_state = 35},
  [4651] = {.lex_state = 101, .external_lex_state = 35},
  [4652] = {.lex_state = 101, .external_lex_state = 35},
  [4653] = {.lex_state = 110, .external_lex_state = 33},
  [4654] = {.lex_state = 101, .external_lex_state = 35},
  [4655] = {.lex_state = 110, .external_lex_state = 33},
  [4656] = {.lex_state = 101, .external_lex_state = 35},
  [4657] = {.lex_state = 101, .external_lex_state = 35},
  [4658] = {.lex_state = 101, .external_lex_state = 35},
  [4659] = {.lex_state = 101, .external_lex_state = 35},
  [4660] = {.lex_state = 101, .external_lex_state = 35},
  [4661] = {.lex_state = 101, .external_lex_state = 32},
  [4662] = {.lex_state = 101, .external_lex_state = 35},
  [4663] = {.lex_state = 231, .external_lex_state = 32},
  [4664] = {.lex_state = 231, .external_lex_state = 32},
  [4665] = {.lex_state = 101, .external_lex_state = 35},
  [4666] = {.lex_state = 101, .external_lex_state = 35},
  [4667] = {.lex_state = 114, .external_lex_state = 35},
  [4668] = {.lex_state = 101, .external_lex_state = 35},
  [4669] = {.lex_state = 101, .external_lex_state = 35},
  [4670] = {.lex_state = 101, .external_lex_state = 35},
  [4671] = {.lex_state = 101, .external_lex_state = 35},
  [4672] = {.lex_state = 101, .external_lex_state = 32},
  [4673] = {.lex_state = 101, .external_lex_state = 35},
  [4674] = {.lex_state = 101, .external_lex_state = 32},
  [4675] = {.lex_state = 231, .external_lex_state = 32},
  [4676] = {.lex_state = 231, .external_lex_state = 32},
  [4677] = {.lex_state = 101, .external_lex_state = 35},
  [4678] = {.lex_state = 231, .external_lex_state = 32},
  [4679] = {.lex_state = 231, .external_lex_state = 32},
  [4680] = {.lex_state = 231, .external_lex_state = 32},
  [4681] = {.lex_state = 231, .external_lex_state = 32},
  [4682] = {.lex_state = 231, .external_lex_state = 32},
  [4683] = {.lex_state = 231, .external_lex_state = 32},
  [4684] = {.lex_state = 231, .external_lex_state = 32},
  [4685] = {.lex_state = 231, .external_lex_state = 32},
  [4686] = {.lex_state = 109, .external_lex_state = 32},
  [4687] = {.lex_state = 101, .external_lex_state = 32},
  [4688] = {.lex_state = 101, .external_lex_state = 35},
  [4689] = {.lex_state = 101, .external_lex_state = 32},
  [4690] = {.lex_state = 103, .external_lex_state = 35},
  [4691] = {.lex_state = 231, .external_lex_state = 32},
  [4692] = {.lex_state = 236, .external_lex_state = 32},
  [4693] = {.lex_state = 111, .external_lex_state = 36},
  [4694] = {.lex_state = 101, .external_lex_state = 35},
  [4695] = {.lex_state = 110, .external_lex_state = 35},
  [4696] = {.lex_state = 101, .external_lex_state = 35},
  [4697] = {.lex_state = 101, .external_lex_state = 35},
  [4698] = {.lex_state = 103, .external_lex_state = 35},
  [4699] = {.lex_state = 107, .external_lex_state = 32},
  [4700] = {.lex_state = 101, .external_lex_state = 35},
  [4701] = {.lex_state = 101, .external_lex_state = 35},
  [4702] = {.lex_state = 111, .external_lex_state = 36},
  [4703] = {.lex_state = 111, .external_lex_state = 36},
  [4704] = {.lex_state = 101, .external_lex_state = 35},
  [4705] = {.lex_state = 111, .external_lex_state = 36},
  [4706] = {.lex_state = 101, .external_lex_state = 35},
  [4707] = {.lex_state = 101, .external_lex_state = 35},
  [4708] = {.lex_state = 101, .external_lex_state = 35},
  [4709] = {.lex_state = 115, .external_lex_state = 34},
  [4710] = {.lex_state = 101, .external_lex_state = 32},
  [4711] = {.lex_state = 101, .external_lex_state = 35},
  [4712] = {.lex_state = 101, .external_lex_state = 32},
  [4713] = {.lex_state = 231, .external_lex_state = 32},
  [4714] = {.lex_state = 101, .external_lex_state = 32},
  [4715] = {.lex_state = 231, .external_lex_state = 32},
  [4716] = {.lex_state = 115, .external_lex_state = 34},
  [4717] = {.lex_state = 231, .external_lex_state = 32},
  [4718] = {.lex_state = 101, .external_lex_state = 35},
  [4719] = {.lex_state = 101, .external_lex_state = 35},
  [4720] = {.lex_state = 101, .external_lex_state = 35},
  [4721] = {.lex_state = 231, .external_lex_state = 32},
  [4722] = {.lex_state = 101, .external_lex_state = 35},
  [4723] = {.lex_state = 101, .external_lex_state = 35},
  [4724] = {.lex_state = 101, .external_lex_state = 35},
  [4725] = {.lex_state = 101, .external_lex_state = 32},
  [4726] = {.lex_state = 101, .external_lex_state = 35},
  [4727] = {.lex_state = 101, .external_lex_state = 35},
  [4728] = {.lex_state = 101, .external_lex_state = 35},
  [4729] = {.lex_state = 111, .external_lex_state = 36},
  [4730] = {.lex_state = 115, .external_lex_state = 34},
  [4731] = {.lex_state = 115, .external_lex_state = 34},
  [4732] = {.lex_state = 231, .external_lex_state = 32},
  [4733] = {.lex_state = 115, .external_lex_state = 34},
  [4734] = {.lex_state = 110, .external_lex_state = 35},
  [4735] = {.lex_state = 101, .external_lex_state = 35},
  [4736] = {.lex_state = 101, .external_lex_state = 35},
  [4737] = {.lex_state = 101, .external_lex_state = 35},
  [4738] = {.lex_state = 110, .external_lex_state = 35},
  [4739] = {.lex_state = 101, .external_lex_state = 32},
  [4740] = {.lex_state = 101, .external_lex_state = 32},
  [4741] = {.lex_state = 101, .external_lex_state = 32},
  [4742] = {.lex_state = 101, .external_lex_state = 35},
  [4743] = {.lex_state = 101, .external_lex_state = 32},
  [4744] = {.lex_state = 101, .external_lex_state = 35},
  [4745] = {.lex_state = 101, .external_lex_state = 32},
  [4746] = {.lex_state = 231, .external_lex_state = 32},
  [4747] = {.lex_state = 101, .external_lex_state = 35},
  [4748] = {.lex_state = 101, .external_lex_state = 35},
  [4749] = {.lex_state = 111, .external_lex_state = 36},
  [4750] = {.lex_state = 110, .external_lex_state = 35},
  [4751] = {.lex_state = 101, .external_lex_state = 35},
  [4752] = {.lex_state = 231, .external_lex_state = 32},
  [4753] = {.lex_state = 111, .external_lex_state = 36},
  [4754] = {.lex_state = 231, .external_lex_state = 32},
  [4755] = {.lex_state = 101, .external_lex_state = 32},
  [4756] = {.lex_state = 101, .external_lex_state = 35},
  [4757] = {.lex_state = 111, .external_lex_state = 36},
  [4758] = {.lex_state = 231, .external_lex_state = 32},
  [4759] = {.lex_state = 101, .external_lex_state = 32},
  [4760] = {.lex_state = 110, .external_lex_state = 35},
  [4761] = {.lex_state = 101, .external_lex_state = 32},
  [4762] = {.lex_state = 111, .external_lex_state = 36},
  [4763] = {.lex_state = 101, .external_lex_state = 32},
  [4764] = {.lex_state = 101, .external_lex_state = 35},
  [4765] = {.lex_state = 101, .external_lex_state = 35},
  [4766] = {.lex_state = 110, .external_lex_state = 33},
  [4767] = {.lex_state = 101, .external_lex_state = 35},
  [4768] = {.lex_state = 101, .external_lex_state = 35},
  [4769] = {.lex_state = 101, .external_lex_state = 32},
  [4770] = {.lex_state = 110, .external_lex_state = 36},
  [4771] = {.lex_state = 101, .external_lex_state = 32},
  [4772] = {.lex_state = 101, .external_lex_state = 35},
  [4773] = {.lex_state = 101, .external_lex_state = 32},
  [4774] = {.lex_state = 101, .external_lex_state = 32},
  [4775] = {.lex_state = 109, .external_lex_state = 32},
  [4776] = {.lex_state = 101, .external_lex_state = 32},
  [4777] = {.lex_state = 101, .external_lex_state = 32},
  [4778] = {.lex_state = 101, .external_lex_state = 32},
  [4779] = {.lex_state = 101, .external_lex_state = 32},
  [4780] = {.lex_state = 101, .external_lex_state = 32},
  [4781] = {.lex_state = 110, .external_lex_state = 33},
  [4782] = {.lex_state = 101, .external_lex_state = 35},
  [4783] = {.lex_state = 101, .external_lex_state = 32},
  [4784] = {.lex_state = 103, .external_lex_state = 35},
  [4785] = {.lex_state = 110, .external_lex_state = 33},
  [4786] = {.lex_state = 110, .external_lex_state = 33},
  [4787] = {.lex_state = 101, .external_lex_state = 32},
  [4788] = {.lex_state = 101, .external_lex_state = 32},
  [4789] = {.lex_state = 101, .external_lex_state = 32},
  [4790] = {.lex_state = 101, .external_lex_state = 35},
  [4791] = {.lex_state = 101, .external_lex_state = 32},
  [4792] = {.lex_state = 101, .external_lex_state = 32},
  [4793] = {.lex_state = 101, .external_lex_state = 32},
  [4794] = {.lex_state = 110, .external_lex_state = 33},
  [4795] = {.lex_state = 110, .external_lex_state = 33},
  [4796] = {.lex_state = 101, .external_lex_state = 32},
  [4797] = {.lex_state = 110, .external_lex_state = 33},
  [4798] = {.lex_state = 110, .external_lex_state = 33},
  [4799] = {.lex_state = 101, .external_lex_state = 32},
  [4800] = {.lex_state = 101, .external_lex_state = 35},
  [4801] = {.lex_state = 101, .external_lex_state = 32},
  [4802] = {.lex_state = 101, .external_lex_state = 32},
  [4803] = {.lex_state = 101, .external_lex_state = 32},
  [4804] = {.lex_state = 101, .external_lex_state = 35},
  [4805] = {.lex_state = 101, .external_lex_state = 32},
  [4806] = {.lex_state = 101, .external_lex_state = 35},
  [4807] = {.lex_state = 110, .external_lex_state = 33},
  [4808] = {.lex_state = 101, .external_lex_state = 32},
  [4809] = {.lex_state = 101, .external_lex_state = 32},
  [4810] = {.lex_state = 101, .external_lex_state = 35},
  [4811] = {.lex_state = 99, .external_lex_state = 37},
  [4812] = {.lex_state = 101, .external_lex_state = 35},
  [4813] = {.lex_state = 99, .external_lex_state = 37},
  [4814] = {.lex_state = 99, .external_lex_state = 37},
  [4815] = {.lex_state = 101, .external_lex_state = 35},
  [4816] = {.lex_state = 99, .external_lex_state = 37},
  [4817] = {.lex_state = 101, .external_lex_state = 35},
  [4818] = {.lex_state = 101, .external_lex_state = 32},
  [4819] = {.lex_state = 101, .external_lex_state = 32},
  [4820] = {.lex_state = 99, .external_lex_state = 37},
  [4821] = {.lex_state = 101, .external_lex_state = 35},
  [4822] = {.lex_state = 101, .external_lex_state = 35},
  [4823] = {.lex_state = 101, .external_lex_state = 32},
  [4824] = {.lex_state = 101, .external_lex_state = 32},
  [4825] = {.lex_state = 101, .external_lex_state = 35},
  [4826] = {.lex_state = 99, .external_lex_state = 37},
  [4827] = {.lex_state = 101, .external_lex_state = 35},
  [4828] = {.lex_state = 101, .external_lex_state = 35},
  [4829] = {.lex_state = 101, .external_lex_state = 35},
  [4830] = {.lex_state = 101, .external_lex_state = 35},
  [4831] = {.lex_state = 99, .external_lex_state = 37},
  [4832] = {.lex_state = 101, .external_lex_state = 35},
  [4833] = {.lex_state = 99, .external_lex_state = 37},
  [4834] = {.lex_state = 99, .external_lex_state = 37},
  [4835] = {.lex_state = 101, .external_lex_state = 35},
  [4836] = {.lex_state = 101, .external_lex_state = 35},
  [4837] = {.lex_state = 101, .external_lex_state = 35},
  [4838] = {.lex_state = 101, .external_lex_state = 35},
  [4839] = {.lex_state = 99, .external_lex_state = 37},
  [4840] = {.lex_state = 101, .external_lex_state = 35},
  [4841] = {.lex_state = 101, .external_lex_state = 35},
  [4842] = {.lex_state = 101, .external_lex_state = 35},
  [4843] = {.lex_state = 101, .external_lex_state = 35},
  [4844] = {.lex_state = 101, .external_lex_state = 35},
  [4845] = {.lex_state = 101, .external_lex_state = 35},
  [4846] = {.lex_state = 101, .external_lex_state = 32},
  [4847] = {.lex_state = 101, .external_lex_state = 35},
  [4848] = {.lex_state = 101, .external_lex_state = 35},
  [4849] = {.lex_state = 101, .external_lex_state = 35},
  [4850] = {.lex_state = 101, .external_lex_state = 35},
  [4851] = {.lex_state = 99, .external_lex_state = 37},
  [4852] = {.lex_state = 99, .external_lex_state = 37},
  [4853] = {.lex_state = 101, .external_lex_state = 35},
  [4854] = {.lex_state = 101, .external_lex_state = 35},
  [4855] = {.lex_state = 99, .external_lex_state = 37},
  [4856] = {.lex_state = 99, .external_lex_state = 37},
  [4857] = {.lex_state = 99, .external_lex_state = 37},
  [4858] = {.lex_state = 99, .external_lex_state = 37},
  [4859] = {.lex_state = 99, .external_lex_state = 37},
  [4860] = {.lex_state = 101, .external_lex_state = 35},
  [4861] = {.lex_state = 99, .external_lex_state = 37},
  [4862] = {.lex_state = 99, .external_lex_state = 37},
  [4863] = {.lex_state = 101, .external_lex_state = 35},
  [4864] = {.lex_state = 99, .external_lex_state = 37},
  [4865] = {.lex_state = 99, .external_lex_state = 37},
  [4866] = {.lex_state = 99, .external_lex_state = 37},
  [4867] = {.lex_state = 101, .external_lex_state = 35},
  [4868] = {.lex_state = 99, .external_lex_state = 37},
  [4869] = {.lex_state = 99, .external_lex_state = 37},
  [4870] = {.lex_state = 110, .external_lex_state = 36},
  [4871] = {.lex_state = 101, .external_lex_state = 35},
  [4872] = {.lex_state = 101, .external_lex_state = 35},
  [4873] = {.lex_state = 101, .external_lex_state = 35},
  [4874] = {.lex_state = 101, .external_lex_state = 35},
  [4875] = {.lex_state = 101, .external_lex_state = 35},
  [4876] = {.lex_state = 101, .external_lex_state = 35},
  [4877] = {.lex_state = 101, .external_lex_state = 35},
  [4878] = {.lex_state = 101, .external_lex_state = 32},
  [4879] = {.lex_state = 101, .external_lex_state = 35},
  [4880] = {.lex_state = 101, .external_lex_state = 35},
  [4881] = {.lex_state = 101, .external_lex_state = 35},
  [4882] = {.lex_state = 101, .external_lex_state = 35},
  [4883] = {.lex_state = 101, .external_lex_state = 35},
  [4884] = {.lex_state = 101, .external_lex_state = 35},
  [4885] = {.lex_state = 110, .external_lex_state = 36},
  [4886] = {.lex_state = 111, .external_lex_state = 36},
  [4887] = {.lex_state = 111, .external_lex_state = 36},
  [4888] = {.lex_state = 101, .external_lex_state = 35},
  [4889] = {.lex_state = 101, .external_lex_state = 35},
  [4890] = {.lex_state = 99, .external_lex_state = 37},
  [4891] = {.lex_state = 111, .external_lex_state = 36},
  [4892] = {.lex_state = 101, .external_lex_state = 35},
  [4893] = {.lex_state = 101, .external_lex_state = 35},
  [4894] = {.lex_state = 101, .external_lex_state = 35},
  [4895] = {.lex_state = 111, .external_lex_state = 36},
  [4896] = {.lex_state = 101, .external_lex_state = 35},
  [4897] = {.lex_state = 101, .external_lex_state = 32},
  [4898] = {.lex_state = 99, .external_lex_state = 37},
  [4899] = {.lex_state = 101, .external_lex_state = 35},
  [4900] = {.lex_state = 101, .external_lex_state = 35},
  [4901] = {.lex_state = 99, .external_lex_state = 37},
  [4902] = {.lex_state = 99, .external_lex_state = 37},
  [4903] = {.lex_state = 99, .external_lex_state = 37},
  [4904] = {.lex_state = 101, .external_lex_state = 35},
  [4905] = {.lex_state = 101, .external_lex_state = 35},
  [4906] = {.lex_state = 99, .external_lex_state = 37},
  [4907] = {.lex_state = 111, .external_lex_state = 36},
  [4908] = {.lex_state = 101, .external_lex_state = 35},
  [4909] = {.lex_state = 99, .external_lex_state = 37},
  [4910] = {.lex_state = 101, .external_lex_state = 35},
  [4911] = {.lex_state = 101, .external_lex_state = 35},
  [4912] = {.lex_state = 99, .external_lex_state = 37},
  [4913] = {.lex_state = 101, .external_lex_state = 35},
  [4914] = {.lex_state = 110, .external_lex_state = 36},
  [4915] = {.lex_state = 110, .external_lex_state = 36},
  [4916] = {.lex_state = 101, .external_lex_state = 35},
  [4917] = {.lex_state = 101, .external_lex_state = 32},
  [4918] = {.lex_state = 99, .external_lex_state = 37},
  [4919] = {.lex_state = 101, .external_lex_state = 32},
  [4920] = {.lex_state = 101, .external_lex_state = 35},
  [4921] = {.lex_state = 99, .external_lex_state = 37},
  [4922] = {.lex_state = 101, .external_lex_state = 35},
  [4923] = {.lex_state = 99, .external_lex_state = 37},
  [4924] = {.lex_state = 99, .external_lex_state = 37},
  [4925] = {.lex_state = 101, .external_lex_state = 32},
  [4926] = {.lex_state = 111, .external_lex_state = 36},
  [4927] = {.lex_state = 110, .external_lex_state = 36},
  [4928] = {.lex_state = 99, .external_lex_state = 37},
  [4929] = {.lex_state = 101, .external_lex_state = 35},
  [4930] = {.lex_state = 99, .external_lex_state = 37},
  [4931] = {.lex_state = 101, .external_lex_state = 35},
  [4932] = {.lex_state = 101, .external_lex_state = 35},
  [4933] = {.lex_state = 101, .external_lex_state = 35},
  [4934] = {.lex_state = 110, .external_lex_state = 36},
  [4935] = {.lex_state = 99, .external_lex_state = 37},
  [4936] = {.lex_state = 99, .external_lex_state = 37},
  [4937] = {.lex_state = 101, .external_lex_state = 35},
  [4938] = {.lex_state = 99, .external_lex_state = 37},
  [4939] = {.lex_state = 99, .external_lex_state = 37},
  [4940] = {.lex_state = 101, .external_lex_state = 35},
  [4941] = {.lex_state = 101, .external_lex_state = 35},
  [4942] = {.lex_state = 101, .external_lex_state = 35},
  [4943] = {.lex_state = 101, .external_lex_state = 35},
  [4944] = {.lex_state = 101, .external_lex_state = 35},
  [4945] = {.lex_state = 101, .external_lex_state = 35},
  [4946] = {.lex_state = 111, .external_lex_state = 36},
  [4947] = {.lex_state = 99, .external_lex_state = 37},
  [4948] = {.lex_state = 100, .external_lex_state = 37},
  [4949] = {.lex_state = 110, .external_lex_state = 36},
  [4950] = {.lex_state = 101, .external_lex_state = 35},
  [4951] = {.lex_state = 101, .external_lex_state = 35},
  [4952] = {.lex_state = 100, .external_lex_state = 37},
  [4953] = {.lex_state = 101, .external_lex_state = 35},
  [4954] = {.lex_state = 214, .external_lex_state = 35},
  [4955] = {.lex_state = 100, .external_lex_state = 37},
  [4956] = {.lex_state = 100, .external_lex_state = 37},
  [4957] = {.lex_state = 100, .external_lex_state = 37},
  [4958] = {.lex_state = 100, .external_lex_state = 38},
  [4959] = {.lex_state = 100, .external_lex_state = 37},
  [4960] = {.lex_state = 100, .external_lex_state = 37},
  [4961] = {.lex_state = 225, .external_lex_state = 39},
  [4962] = {.lex_state = 214, .external_lex_state = 35},
  [4963] = {.lex_state = 101, .external_lex_state = 32},
  [4964] = {.lex_state = 100, .external_lex_state = 37},
  [4965] = {.lex_state = 110, .external_lex_state = 33},
  [4966] = {.lex_state = 214, .external_lex_state = 35},
  [4967] = {.lex_state = 100, .external_lex_state = 37},
  [4968] = {.lex_state = 101, .external_lex_state = 32},
  [4969] = {.lex_state = 101, .external_lex_state = 35},
  [4970] = {.lex_state = 100, .external_lex_state = 37},
  [4971] = {.lex_state = 100, .external_lex_state = 37},
  [4972] = {.lex_state = 100, .external_lex_state = 37},
  [4973] = {.lex_state = 100, .external_lex_state = 37},
  [4974] = {.lex_state = 100, .external_lex_state = 37},
  [4975] = {.lex_state = 100, .external_lex_state = 37},
  [4976] = {.lex_state = 214, .external_lex_state = 35},
  [4977] = {.lex_state = 101, .external_lex_state = 32},
  [4978] = {.lex_state = 100, .external_lex_state = 37},
  [4979] = {.lex_state = 100, .external_lex_state = 37},
  [4980] = {.lex_state = 214, .external_lex_state = 35},
  [4981] = {.lex_state = 214, .external_lex_state = 35},
  [4982] = {.lex_state = 100, .external_lex_state = 37},
  [4983] = {.lex_state = 100, .external_lex_state = 37},
  [4984] = {.lex_state = 100, .external_lex_state = 37},
  [4985] = {.lex_state = 100, .external_lex_state = 37},
  [4986] = {.lex_state = 100, .external_lex_state = 37},
  [4987] = {.lex_state = 100, .external_lex_state = 37},
  [4988] = {.lex_state = 100, .external_lex_state = 37},
  [4989] = {.lex_state = 100, .external_lex_state = 37},
  [4990] = {.lex_state = 214, .external_lex_state = 35},
  [4991] = {.lex_state = 110, .external_lex_state = 33},
  [4992] = {.lex_state = 100, .external_lex_state = 37},
  [4993] = {.lex_state = 100, .external_lex_state = 37},
  [4994] = {.lex_state = 214, .external_lex_state = 35},
  [4995] = {.lex_state = 214, .external_lex_state = 35},
  [4996] = {.lex_state = 214, .external_lex_state = 35},
  [4997] = {.lex_state = 101, .external_lex_state = 32},
  [4998] = {.lex_state = 110, .external_lex_state = 33},
  [4999] = {.lex_state = 100, .external_lex_state = 37},
  [5000] = {.lex_state = 214, .external_lex_state = 35},
  [5001] = {.lex_state = 100, .external_lex_state = 37},
  [5002] = {.lex_state = 100, .external_lex_state = 37},
  [5003] = {.lex_state = 100, .external_lex_state = 37},
  [5004] = {.lex_state = 110, .external_lex_state = 33},
  [5005] = {.lex_state = 100, .external_lex_state = 37},
  [5006] = {.lex_state = 214, .external_lex_state = 35},
  [5007] = {.lex_state = 101, .external_lex_state = 32},
  [5008] = {.lex_state = 110, .external_lex_state = 33},
  [5009] = {.lex_state = 101, .external_lex_state = 35},
  [5010] = {.lex_state = 100, .external_lex_state = 37},
  [5011] = {.lex_state = 100, .external_lex_state = 37},
  [5012] = {.lex_state = 100, .external_lex_state = 37},
  [5013] = {.lex_state = 100, .external_lex_state = 37},
  [5014] = {.lex_state = 100, .external_lex_state = 37},
  [5015] = {.lex_state = 214, .external_lex_state = 35},
  [5016] = {.lex_state = 101, .external_lex_state = 32},
  [5017] = {.lex_state = 100, .external_lex_state = 37},
  [5018] = {.lex_state = 100, .external_lex_state = 37},
  [5019] = {.lex_state = 225, .external_lex_state = 39},
  [5020] = {.lex_state = 214, .external_lex_state = 35},
  [5021] = {.lex_state = 100, .external_lex_state = 37},
  [5022] = {.lex_state = 100, .external_lex_state = 37},
  [5023] = {.lex_state = 214, .external_lex_state = 35},
  [5024] = {.lex_state = 214, .external_lex_state = 35},
  [5025] = {.lex_state = 100, .external_lex_state = 37},
  [5026] = {.lex_state = 101, .external_lex_state = 32},
  [5027] = {.lex_state = 100, .external_lex_state = 37},
  [5028] = {.lex_state = 214, .external_lex_state = 35},
  [5029] = {.lex_state = 100, .external_lex_state = 37},
  [5030] = {.lex_state = 100, .external_lex_state = 37},
  [5031] = {.lex_state = 100, .external_lex_state = 37},
  [5032] = {.lex_state = 214, .external_lex_state = 35},
  [5033] = {.lex_state = 100, .external_lex_state = 37},
  [5034] = {.lex_state = 100, .external_lex_state = 37},
  [5035] = {.lex_state = 100, .external_lex_state = 37},
  [5036] = {.lex_state = 100, .external_lex_state = 37},
  [5037] = {.lex_state = 100, .external_lex_state = 37},
  [5038] = {.lex_state = 214, .external_lex_state = 35},
  [5039] = {.lex_state = 100, .external_lex_state = 37},
  [5040] = {.lex_state = 100, .external_lex_state = 37},
  [5041] = {.lex_state = 214, .external_lex_state = 35},
  [5042] = {.lex_state = 214, .external_lex_state = 35},
  [5043] = {.lex_state = 214, .external_lex_state = 35},
  [5044] = {.lex_state = 101, .external_lex_state = 35},
  [5045] = {.lex_state = 100, .external_lex_state = 37},
  [5046] = {.lex_state = 100, .external_lex_state = 37},
  [5047] = {.lex_state = 100, .external_lex_state = 37},
  [5048] = {.lex_state = 100, .external_lex_state = 37},
  [5049] = {.lex_state = 214, .external_lex_state = 35},
  [5050] = {.lex_state = 100, .external_lex_state = 37},
  [5051] = {.lex_state = 214, .external_lex_state = 35},
  [5052] = {.lex_state = 214, .external_lex_state = 35},
  [5053] = {.lex_state = 100, .external_lex_state = 37},
  [5054] = {.lex_state = 100, .external_lex_state = 37},
  [5055] = {.lex_state = 214, .external_lex_state = 35},
  [5056] = {.lex_state = 100, .external_lex_state = 37},
  [5057] = {.lex_state = 100, .external_lex_state = 37},
  [5058] = {.lex_state = 214, .external_lex_state = 35},
  [5059] = {.lex_state = 214, .external_lex_state = 35},
  [5060] = {.lex_state = 225, .external_lex_state = 39},
  [5061] = {.lex_state = 100, .external_lex_state = 37},
  [5062] = {.lex_state = 100, .external_lex_state = 37},
  [5063] = {.lex_state = 214, .external_lex_state = 35},
  [5064] = {.lex_state = 214, .external_lex_state = 35},
  [5065] = {.lex_state = 100, .external_lex_state = 38},
  [5066] = {.lex_state = 100, .external_lex_state = 37},
  [5067] = {.lex_state = 100, .external_lex_state = 37},
  [5068] = {.lex_state = 100, .external_lex_state = 37},
  [5069] = {.lex_state = 100, .external_lex_state = 37},
  [5070] = {.lex_state = 214, .external_lex_state = 35},
  [5071] = {.lex_state = 100, .external_lex_state = 37},
  [5072] = {.lex_state = 100, .external_lex_state = 37},
  [5073] = {.lex_state = 100, .external_lex_state = 37},
  [5074] = {.lex_state = 100, .external_lex_state = 37},
  [5075] = {.lex_state = 100, .external_lex_state = 37},
  [5076] = {.lex_state = 214, .external_lex_state = 35},
  [5077] = {.lex_state = 100, .external_lex_state = 37},
  [5078] = {.lex_state = 110, .external_lex_state = 33},
  [5079] = {.lex_state = 100, .external_lex_state = 37},
  [5080] = {.lex_state = 214, .external_lex_state = 35},
  [5081] = {.lex_state = 214, .external_lex_state = 35},
  [5082] = {.lex_state = 214, .external_lex_state = 35},
  [5083] = {.lex_state = 100, .external_lex_state = 37},
  [5084] = {.lex_state = 100, .external_lex_state = 38},
  [5085] = {.lex_state = 214, .external_lex_state = 35},
  [5086] = {.lex_state = 214, .external_lex_state = 35},
  [5087] = {.lex_state = 214, .external_lex_state = 35},
  [5088] = {.lex_state = 214, .external_lex_state = 35},
  [5089] = {.lex_state = 214, .external_lex_state = 35},
  [5090] = {.lex_state = 214, .external_lex_state = 35},
  [5091] = {.lex_state = 214, .external_lex_state = 35},
  [5092] = {.lex_state = 214, .external_lex_state = 35},
  [5093] = {.lex_state = 100, .external_lex_state = 37},
  [5094] = {.lex_state = 100, .external_lex_state = 37},
  [5095] = {.lex_state = 214, .external_lex_state = 35},
  [5096] = {.lex_state = 214, .external_lex_state = 35},
  [5097] = {.lex_state = 100, .external_lex_state = 37},
  [5098] = {.lex_state = 214, .external_lex_state = 35},
  [5099] = {.lex_state = 214, .external_lex_state = 35},
  [5100] = {.lex_state = 100, .external_lex_state = 37},
  [5101] = {.lex_state = 100, .external_lex_state = 37},
  [5102] = {.lex_state = 100, .external_lex_state = 37},
  [5103] = {.lex_state = 100, .external_lex_state = 37},
  [5104] = {.lex_state = 100, .external_lex_state = 37},
  [5105] = {.lex_state = 100, .external_lex_state = 37},
  [5106] = {.lex_state = 100, .external_lex_state = 37},
  [5107] = {.lex_state = 100, .external_lex_state = 37},
  [5108] = {.lex_state = 101, .external_lex_state = 32},
  [5109] = {.lex_state = 101, .external_lex_state = 35},
  [5110] = {.lex_state = 101, .external_lex_state = 35},
  [5111] = {.lex_state = 100, .external_lex_state = 40},
  [5112] = {.lex_state = 101, .external_lex_state = 35},
  [5113] = {.lex_state = 100, .external_lex_state = 40},
  [5114] = {.lex_state = 101, .external_lex_state = 35},
  [5115] = {.lex_state = 101, .external_lex_state = 32},
  [5116] = {.lex_state = 101, .external_lex_state = 32},
  [5117] = {.lex_state = 101, .external_lex_state = 35},
  [5118] = {.lex_state = 214, .external_lex_state = 35},
  [5119] = {.lex_state = 101, .external_lex_state = 35},
  [5120] = {.lex_state = 101, .external_lex_state = 35},
  [5121] = {.lex_state = 101, .external_lex_state = 35},
  [5122] = {.lex_state = 101, .external_lex_state = 32},
  [5123] = {.lex_state = 101, .external_lex_state = 35},
  [5124] = {.lex_state = 101, .external_lex_state = 35},
  [5125] = {.lex_state = 101, .external_lex_state = 35},
  [5126] = {.lex_state = 101, .external_lex_state = 35},
  [5127] = {.lex_state = 101, .external_lex_state = 35},
  [5128] = {.lex_state = 101, .external_lex_state = 35},
  [5129] = {.lex_state = 101, .external_lex_state = 35},
  [5130] = {.lex_state = 101, .external_lex_state = 35},
  [5131] = {.lex_state = 101, .external_lex_state = 35},
  [5132] = {.lex_state = 101, .external_lex_state = 35},
  [5133] = {.lex_state = 99, .external_lex_state = 37},
  [5134] = {.lex_state = 101, .external_lex_state = 35},
  [5135] = {.lex_state = 101, .external_lex_state = 32},
  [5136] = {.lex_state = 101, .external_lex_state = 35},
  [5137] = {.lex_state = 101, .external_lex_state = 35},
  [5138] = {.lex_state = 101, .external_lex_state = 35},
  [5139] = {.lex_state = 101, .external_lex_state = 35},
  [5140] = {.lex_state = 101, .external_lex_state = 35},
  [5141] = {.lex_state = 101, .external_lex_state = 35},
  [5142] = {.lex_state = 101, .external_lex_state = 35},
  [5143] = {.lex_state = 99, .external_lex_state = 37},
  [5144] = {.lex_state = 225, .external_lex_state = 36},
  [5145] = {.lex_state = 214, .external_lex_state = 35},
  [5146] = {.lex_state = 225, .external_lex_state = 36},
  [5147] = {.lex_state = 225, .external_lex_state = 36},
  [5148] = {.lex_state = 214, .external_lex_state = 35},
  [5149] = {.lex_state = 110, .external_lex_state = 36},
  [5150] = {.lex_state = 214, .external_lex_state = 35},
  [5151] = {.lex_state = 101, .external_lex_state = 32},
  [5152] = {.lex_state = 225, .external_lex_state = 36},
  [5153] = {.lex_state = 101, .external_lex_state = 35},
  [5154] = {.lex_state = 101, .external_lex_state = 35},
  [5155] = {.lex_state = 225, .external_lex_state = 36},
  [5156] = {.lex_state = 101, .external_lex_state = 35},
  [5157] = {.lex_state = 101, .external_lex_state = 35},
  [5158] = {.lex_state = 99, .external_lex_state = 37},
  [5159] = {.lex_state = 101, .external_lex_state = 35},
  [5160] = {.lex_state = 99, .external_lex_state = 37},
  [5161] = {.lex_state = 225, .external_lex_state = 36},
  [5162] = {.lex_state = 101, .external_lex_state = 35},
  [5163] = {.lex_state = 101, .external_lex_state = 35},
  [5164] = {.lex_state = 101, .external_lex_state = 35},
  [5165] = {.lex_state = 101, .external_lex_state = 35},
  [5166] = {.lex_state = 101, .external_lex_state = 35},
  [5167] = {.lex_state = 101, .external_lex_state = 35},
  [5168] = {.lex_state = 101, .external_lex_state = 35},
  [5169] = {.lex_state = 110, .external_lex_state = 36},
  [5170] = {.lex_state = 101, .external_lex_state = 35},
  [5171] = {.lex_state = 214, .external_lex_state = 35},
  [5172] = {.lex_state = 101, .external_lex_state = 35},
  [5173] = {.lex_state = 101, .external_lex_state = 35},
  [5174] = {.lex_state = 101, .external_lex_state = 35},
  [5175] = {.lex_state = 101, .external_lex_state = 35},
  [5176] = {.lex_state = 101, .external_lex_state = 35},
  [5177] = {.lex_state = 101, .external_lex_state = 35},
  [5178] = {.lex_state = 101, .external_lex_state = 35},
  [5179] = {.lex_state = 101, .external_lex_state = 35},
  [5180] = {.lex_state = 101, .external_lex_state = 35},
  [5181] = {.lex_state = 101, .external_lex_state = 35},
  [5182] = {.lex_state = 101, .external_lex_state = 35},
  [5183] = {.lex_state = 101, .external_lex_state = 35},
  [5184] = {.lex_state = 101, .external_lex_state = 35},
  [5185] = {.lex_state = 100, .external_lex_state = 37},
  [5186] = {.lex_state = 107, .external_lex_state = 35},
  [5187] = {.lex_state = 101, .external_lex_state = 35},
  [5188] = {.lex_state = 104, .external_lex_state = 35},
  [5189] = {.lex_state = 101, .external_lex_state = 35},
  [5190] = {.lex_state = 225, .external_lex_state = 39},
  [5191] = {.lex_state = 104, .external_lex_state = 32},
  [5192] = {.lex_state = 101, .external_lex_state = 32},
  [5193] = {.lex_state = 100, .external_lex_state = 37},
  [5194] = {.lex_state = 100, .external_lex_state = 37},
  [5195] = {.lex_state = 101, .external_lex_state = 35},
  [5196] = {.lex_state = 101, .external_lex_state = 35},
  [5197] = {.lex_state = 101, .external_lex_state = 35},
  [5198] = {.lex_state = 101, .external_lex_state = 35},
  [5199] = {.lex_state = 101, .external_lex_state = 32},
  [5200] = {.lex_state = 225, .external_lex_state = 39},
  [5201] = {.lex_state = 100, .external_lex_state = 38},
  [5202] = {.lex_state = 101, .external_lex_state = 35},
  [5203] = {.lex_state = 101, .external_lex_state = 32},
  [5204] = {.lex_state = 100, .external_lex_state = 38},
  [5205] = {.lex_state = 101, .external_lex_state = 35},
  [5206] = {.lex_state = 101, .external_lex_state = 35},
  [5207] = {.lex_state = 101, .external_lex_state = 35},
  [5208] = {.lex_state = 100, .external_lex_state = 38},
  [5209] = {.lex_state = 107, .external_lex_state = 35},
  [5210] = {.lex_state = 101, .external_lex_state = 32},
  [5211] = {.lex_state = 225, .external_lex_state = 39},
  [5212] = {.lex_state = 101, .external_lex_state = 32},
  [5213] = {.lex_state = 100, .external_lex_state = 38},
  [5214] = {.lex_state = 101, .external_lex_state = 32},
  [5215] = {.lex_state = 101, .external_lex_state = 32},
  [5216] = {.lex_state = 100, .external_lex_state = 37},
  [5217] = {.lex_state = 107, .external_lex_state = 35},
  [5218] = {.lex_state = 104, .external_lex_state = 35},
  [5219] = {.lex_state = 101, .external_lex_state = 32},
  [5220] = {.lex_state = 101, .external_lex_state = 32},
  [5221] = {.lex_state = 101, .external_lex_state = 32},
  [5222] = {.lex_state = 225, .external_lex_state = 36},
  [5223] = {.lex_state = 225, .external_lex_state = 36},
  [5224] = {.lex_state = 225, .external_lex_state = 36},
  [5225] = {.lex_state = 214, .external_lex_state = 35},
  [5226] = {.lex_state = 225, .external_lex_state = 36},
  [5227] = {.lex_state = 225, .external_lex_state = 36},
  [5228] = {.lex_state = 225, .external_lex_state = 36},
  [5229] = {.lex_state = 225, .external_lex_state = 36},
  [5230] = {.lex_state = 225, .external_lex_state = 36},
  [5231] = {.lex_state = 225, .external_lex_state = 36},
  [5232] = {.lex_state = 225, .external_lex_state = 36},
  [5233] = {.lex_state = 225, .external_lex_state = 36},
  [5234] = {.lex_state = 225, .external_lex_state = 36},
  [5235] = {.lex_state = 225, .external_lex_state = 36},
  [5236] = {.lex_state = 225, .external_lex_state = 36},
  [5237] = {.lex_state = 225, .external_lex_state = 36},
  [5238] = {.lex_state = 225, .external_lex_state = 36},
  [5239] = {.lex_state = 225, .external_lex_state = 36},
  [5240] = {.lex_state = 225, .external_lex_state = 36},
  [5241] = {.lex_state = 101, .external_lex_state = 35},
  [5242] = {.lex_state = 101, .external_lex_state = 35},
  [5243] = {.lex_state = 225, .external_lex_state = 36},
  [5244] = {.lex_state = 225, .external_lex_state = 36},
  [5245] = {.lex_state = 225, .external_lex_state = 36},
  [5246] = {.lex_state = 225, .external_lex_state = 36},
  [5247] = {.lex_state = 225, .external_lex_state = 36},
  [5248] = {.lex_state = 225, .external_lex_state = 36},
  [5249] = {.lex_state = 225, .external_lex_state = 36},
  [5250] = {.lex_state = 225, .external_lex_state = 36},
  [5251] = {.lex_state = 225, .external_lex_state = 36},
  [5252] = {.lex_state = 225, .external_lex_state = 36},
  [5253] = {.lex_state = 101, .external_lex_state = 35},
  [5254] = {.lex_state = 225, .external_lex_state = 36},
  [5255] = {.lex_state = 101, .external_lex_state = 35},
  [5256] = {.lex_state = 225, .external_lex_state = 36},
  [5257] = {.lex_state = 225, .external_lex_state = 36},
  [5258] = {.lex_state = 225, .external_lex_state = 36},
  [5259] = {.lex_state = 225, .external_lex_state = 36},
  [5260] = {.lex_state = 225, .external_lex_state = 36},
  [5261] = {.lex_state = 225, .external_lex_state = 36},
  [5262] = {.lex_state = 225, .external_lex_state = 36},
  [5263] = {.lex_state = 225, .external_lex_state = 36},
  [5264] = {.lex_state = 214, .external_lex_state = 35},
  [5265] = {.lex_state = 101, .external_lex_state = 35},
  [5266] = {.lex_state = 225, .external_lex_state = 36},
  [5267] = {.lex_state = 101, .external_lex_state = 35},
  [5268] = {.lex_state = 101, .external_lex_state = 35},
  [5269] = {.lex_state = 214, .external_lex_state = 32},
  [5270] = {.lex_state = 214, .external_lex_state = 35},
  [5271] = {.lex_state = 225, .external_lex_state = 36},
  [5272] = {.lex_state = 225, .external_lex_state = 36},
  [5273] = {.lex_state = 101, .external_lex_state = 35},
  [5274] = {.lex_state = 225, .external_lex_state = 36},
  [5275] = {.lex_state = 214, .external_lex_state = 35},
  [5276] = {.lex_state = 225, .external_lex_state = 36},
  [5277] = {.lex_state = 225, .external_lex_state = 36},
  [5278] = {.lex_state = 101, .external_lex_state = 32},
  [5279] = {.lex_state = 225, .external_lex_state = 36},
  [5280] = {.lex_state = 101, .external_lex_state = 35},
  [5281] = {.lex_state = 101, .external_lex_state = 32},
  [5282] = {.lex_state = 225, .external_lex_state = 36},
  [5283] = {.lex_state = 214, .external_lex_state = 35},
  [5284] = {.lex_state = 225, .external_lex_state = 36},
  [5285] = {.lex_state = 225, .external_lex_state = 36},
  [5286] = {.lex_state = 225, .external_lex_state = 36},
  [5287] = {.lex_state = 225, .external_lex_state = 36},
  [5288] = {.lex_state = 225, .external_lex_state = 36},
  [5289] = {.lex_state = 225, .external_lex_state = 36},
  [5290] = {.lex_state = 225, .external_lex_state = 36},
  [5291] = {.lex_state = 225, .external_lex_state = 36},
  [5292] = {.lex_state = 101, .external_lex_state = 35},
  [5293] = {.lex_state = 225, .external_lex_state = 36},
  [5294] = {.lex_state = 225, .external_lex_state = 36},
  [5295] = {.lex_state = 225, .external_lex_state = 36},
  [5296] = {.lex_state = 225, .external_lex_state = 36},
  [5297] = {.lex_state = 225, .external_lex_state = 36},
  [5298] = {.lex_state = 225, .external_lex_state = 36},
  [5299] = {.lex_state = 225, .external_lex_state = 36},
  [5300] = {.lex_state = 225, .external_lex_state = 36},
  [5301] = {.lex_state = 225, .external_lex_state = 36},
  [5302] = {.lex_state = 214, .external_lex_state = 35},
  [5303] = {.lex_state = 225, .external_lex_state = 36},
  [5304] = {.lex_state = 225, .external_lex_state = 36},
  [5305] = {.lex_state = 225, .external_lex_state = 36},
  [5306] = {.lex_state = 225, .external_lex_state = 36},
  [5307] = {.lex_state = 225, .external_lex_state = 36},
  [5308] = {.lex_state = 225, .external_lex_state = 36},
  [5309] = {.lex_state = 225, .external_lex_state = 36},
  [5310] = {.lex_state = 225, .external_lex_state = 36},
  [5311] = {.lex_state = 225, .external_lex_state = 36},
  [5312] = {.lex_state = 101, .external_lex_state = 35},
  [5313] = {.lex_state = 225, .external_lex_state = 36},
  [5314] = {.lex_state = 225, .external_lex_state = 36},
  [5315] = {.lex_state = 101, .external_lex_state = 35},
  [5316] = {.lex_state = 104, .external_lex_state = 35},
  [5317] = {.lex_state = 214, .external_lex_state = 35},
  [5318] = {.lex_state = 225, .external_lex_state = 36},
  [5319] = {.lex_state = 214, .external_lex_state = 35},
  [5320] = {.lex_state = 225, .external_lex_state = 36},
  [5321] = {.lex_state = 225, .external_lex_state = 36},
  [5322] = {.lex_state = 225, .external_lex_state = 36},
  [5323] = {.lex_state = 101, .external_lex_state = 35},
  [5324] = {.lex_state = 107, .external_lex_state = 35},
  [5325] = {.lex_state = 225, .external_lex_state = 36},
  [5326] = {.lex_state = 225, .external_lex_state = 36},
  [5327] = {.lex_state = 225, .external_lex_state = 36},
  [5328] = {.lex_state = 225, .external_lex_state = 36},
  [5329] = {.lex_state = 225, .external_lex_state = 36},
  [5330] = {.lex_state = 225, .external_lex_state = 36},
  [5331] = {.lex_state = 101, .external_lex_state = 32},
  [5332] = {.lex_state = 225, .external_lex_state = 36},
  [5333] = {.lex_state = 225, .external_lex_state = 36},
  [5334] = {.lex_state = 225, .external_lex_state = 36},
  [5335] = {.lex_state = 225, .external_lex_state = 36},
  [5336] = {.lex_state = 225, .external_lex_state = 36},
  [5337] = {.lex_state = 225, .external_lex_state = 36},
  [5338] = {.lex_state = 225, .external_lex_state = 36},
  [5339] = {.lex_state = 225, .external_lex_state = 36},
  [5340] = {.lex_state = 225, .external_lex_state = 36},
  [5341] = {.lex_state = 225, .external_lex_state = 36},
  [5342] = {.lex_state = 214, .external_lex_state = 35},
  [5343] = {.lex_state = 214, .external_lex_state = 35},
  [5344] = {.lex_state = 225, .external_lex_state = 36},
  [5345] = {.lex_state = 225, .external_lex_state = 36},
  [5346] = {.lex_state = 225, .external_lex_state = 36},
  [5347] = {.lex_state = 225, .external_lex_state = 36},
  [5348] = {.lex_state = 225, .external_lex_state = 36},
  [5349] = {.lex_state = 225, .external_lex_state = 36},
  [5350] = {.lex_state = 225, .external_lex_state = 36},
  [5351] = {.lex_state = 101, .external_lex_state = 35},
  [5352] = {.lex_state = 101, .external_lex_state = 35},
  [5353] = {.lex_state = 225, .external_lex_state = 36},
  [5354] = {.lex_state = 225, .external_lex_state = 36},
  [5355] = {.lex_state = 225, .external_lex_state = 36},
  [5356] = {.lex_state = 225, .external_lex_state = 36},
  [5357] = {.lex_state = 101, .external_lex_state = 32},
  [5358] = {.lex_state = 101, .external_lex_state = 35},
  [5359] = {.lex_state = 101, .external_lex_state = 35},
  [5360] = {.lex_state = 101, .external_lex_state = 35},
  [5361] = {.lex_state = 101, .external_lex_state = 35},
  [5362] = {.lex_state = 214, .external_lex_state = 32},
  [5363] = {.lex_state = 225, .external_lex_state = 36},
  [5364] = {.lex_state = 214, .external_lex_state = 32},
  [5365] = {.lex_state = 225, .external_lex_state = 36},
  [5366] = {.lex_state = 101, .external_lex_state = 35},
  [5367] = {.lex_state = 225, .external_lex_state = 36},
  [5368] = {.lex_state = 225, .external_lex_state = 36},
  [5369] = {.lex_state = 101, .external_lex_state = 35},
  [5370] = {.lex_state = 101, .external_lex_state = 35},
  [5371] = {.lex_state = 225, .external_lex_state = 36},
  [5372] = {.lex_state = 225, .external_lex_state = 36},
  [5373] = {.lex_state = 225, .external_lex_state = 36},
  [5374] = {.lex_state = 225, .external_lex_state = 36},
  [5375] = {.lex_state = 225, .external_lex_state = 36},
  [5376] = {.lex_state = 225, .external_lex_state = 36},
  [5377] = {.lex_state = 214, .external_lex_state = 35},
  [5378] = {.lex_state = 225, .external_lex_state = 36},
  [5379] = {.lex_state = 225, .external_lex_state = 36},
  [5380] = {.lex_state = 225, .external_lex_state = 36},
  [5381] = {.lex_state = 225, .external_lex_state = 36},
  [5382] = {.lex_state = 225, .external_lex_state = 36},
  [5383] = {.lex_state = 225, .external_lex_state = 36},
  [5384] = {.lex_state = 101, .external_lex_state = 35},
  [5385] = {.lex_state = 225, .external_lex_state = 36},
  [5386] = {.lex_state = 225, .external_lex_state = 36},
  [5387] = {.lex_state = 225, .external_lex_state = 36},
  [5388] = {.lex_state = 225, .external_lex_state = 36},
  [5389] = {.lex_state = 225, .external_lex_state = 36},
  [5390] = {.lex_state = 225, .external_lex_state = 36},
  [5391] = {.lex_state = 225, .external_lex_state = 36},
  [5392] = {.lex_state = 225, .external_lex_state = 36},
  [5393] = {.lex_state = 225, .external_lex_state = 36},
  [5394] = {.lex_state = 225, .external_lex_state = 36},
  [5395] = {.lex_state = 225, .external_lex_state = 36},
  [5396] = {.lex_state = 214, .external_lex_state = 35},
  [5397] = {.lex_state = 107, .external_lex_state = 35},
  [5398] = {.lex_state = 225, .external_lex_state = 36},
  [5399] = {.lex_state = 225, .external_lex_state = 36},
  [5400] = {.lex_state = 225, .external_lex_state = 36},
  [5401] = {.lex_state = 225, .external_lex_state = 36},
  [5402] = {.lex_state = 225, .external_lex_state = 36},
  [5403] = {.lex_state = 225, .external_lex_state = 36},
  [5404] = {.lex_state = 225, .external_lex_state = 36},
  [5405] = {.lex_state = 225, .external_lex_state = 36},
  [5406] = {.lex_state = 214, .external_lex_state = 35},
  [5407] = {.lex_state = 214, .external_lex_state = 32},
  [5408] = {.lex_state = 214, .external_lex_state = 35},
  [5409] = {.lex_state = 214, .external_lex_state = 32},
  [5410] = {.lex_state = 214, .external_lex_state = 35},
  [5411] = {.lex_state = 214, .external_lex_state = 35},
  [5412] = {.lex_state = 119, .external_lex_state = 41},
  [5413] = {.lex_state = 119, .external_lex_state = 41},
  [5414] = {.lex_state = 119, .external_lex_state = 41},
  [5415] = {.lex_state = 101, .external_lex_state = 35},
  [5416] = {.lex_state = 119, .external_lex_state = 41},
  [5417] = {.lex_state = 214, .external_lex_state = 32},
  [5418] = {.lex_state = 214, .external_lex_state = 35},
  [5419] = {.lex_state = 101, .external_lex_state = 32},
  [5420] = {.lex_state = 119, .external_lex_state = 41},
  [5421] = {.lex_state = 214, .external_lex_state = 35},
  [5422] = {.lex_state = 214, .external_lex_state = 35},
  [5423] = {.lex_state = 101, .external_lex_state = 35},
  [5424] = {.lex_state = 119, .external_lex_state = 41},
  [5425] = {.lex_state = 214, .external_lex_state = 35},
  [5426] = {.lex_state = 101, .external_lex_state = 35},
  [5427] = {.lex_state = 214, .external_lex_state = 32},
  [5428] = {.lex_state = 119, .external_lex_state = 41},
  [5429] = {.lex_state = 214, .external_lex_state = 32},
  [5430] = {.lex_state = 214, .external_lex_state = 32},
  [5431] = {.lex_state = 214, .external_lex_state = 32},
  [5432] = {.lex_state = 214, .external_lex_state = 32},
  [5433] = {.lex_state = 214, .external_lex_state = 32},
  [5434] = {.lex_state = 101, .external_lex_state = 35},
  [5435] = {.lex_state = 119, .external_lex_state = 41},
  [5436] = {.lex_state = 119, .external_lex_state = 41},
  [5437] = {.lex_state = 101, .external_lex_state = 35},
  [5438] = {.lex_state = 214, .external_lex_state = 35},
  [5439] = {.lex_state = 119, .external_lex_state = 41},
  [5440] = {.lex_state = 214, .external_lex_state = 35},
  [5441] = {.lex_state = 214, .external_lex_state = 35},
  [5442] = {.lex_state = 214, .external_lex_state = 35},
  [5443] = {.lex_state = 214, .external_lex_state = 35},
  [5444] = {.lex_state = 214, .external_lex_state = 32},
  [5445] = {.lex_state = 101, .external_lex_state = 35},
  [5446] = {.lex_state = 119, .external_lex_state = 41},
  [5447] = {.lex_state = 214, .external_lex_state = 35},
  [5448] = {.lex_state = 119, .external_lex_state = 41},
  [5449] = {.lex_state = 101, .external_lex_state = 35},
  [5450] = {.lex_state = 214, .external_lex_state = 35},
  [5451] = {.lex_state = 214, .external_lex_state = 35},
  [5452] = {.lex_state = 214, .external_lex_state = 32},
  [5453] = {.lex_state = 101, .external_lex_state = 35},
  [5454] = {.lex_state = 214, .external_lex_state = 35},
  [5455] = {.lex_state = 214, .external_lex_state = 35},
  [5456] = {.lex_state = 119, .external_lex_state = 41},
  [5457] = {.lex_state = 101, .external_lex_state = 35},
  [5458] = {.lex_state = 214, .external_lex_state = 35},
  [5459] = {.lex_state = 119, .external_lex_state = 41},
  [5460] = {.lex_state = 214, .external_lex_state = 35},
  [5461] = {.lex_state = 119, .external_lex_state = 41},
  [5462] = {.lex_state = 214, .external_lex_state = 32},
  [5463] = {.lex_state = 214, .external_lex_state = 35},
  [5464] = {.lex_state = 214, .external_lex_state = 35},
  [5465] = {.lex_state = 214, .external_lex_state = 35},
  [5466] = {.lex_state = 214, .external_lex_state = 35},
  [5467] = {.lex_state = 119, .external_lex_state = 41},
  [5468] = {.lex_state = 214, .external_lex_state = 35},
  [5469] = {.lex_state = 119, .external_lex_state = 41},
  [5470] = {.lex_state = 101, .external_lex_state = 35},
  [5471] = {.lex_state = 214, .external_lex_state = 35},
  [5472] = {.lex_state = 101, .external_lex_state = 35},
  [5473] = {.lex_state = 214, .external_lex_state = 35},
  [5474] = {.lex_state = 214, .external_lex_state = 32},
  [5475] = {.lex_state = 214, .external_lex_state = 35},
  [5476] = {.lex_state = 214, .external_lex_state = 35},
  [5477] = {.lex_state = 119, .external_lex_state = 41},
  [5478] = {.lex_state = 119, .external_lex_state = 41},
  [5479] = {.lex_state = 101, .external_lex_state = 35},
  [5480] = {.lex_state = 101, .external_lex_state = 35},
  [5481] = {.lex_state = 214, .external_lex_state = 32},
  [5482] = {.lex_state = 214, .external_lex_state = 35},
  [5483] = {.lex_state = 214, .external_lex_state = 35},
  [5484] = {.lex_state = 214, .external_lex_state = 35},
  [5485] = {.lex_state = 119, .external_lex_state = 41},
  [5486] = {.lex_state = 119, .external_lex_state = 41},
  [5487] = {.lex_state = 119, .external_lex_state = 41},
  [5488] = {.lex_state = 214, .external_lex_state = 32},
  [5489] = {.lex_state = 230, .external_lex_state = 35},
  [5490] = {.lex_state = 214, .external_lex_state = 35},
  [5491] = {.lex_state = 230, .external_lex_state = 35},
  [5492] = {.lex_state = 230, .external_lex_state = 35},
  [5493] = {.lex_state = 230, .external_lex_state = 35},
  [5494] = {.lex_state = 101, .external_lex_state = 35},
  [5495] = {.lex_state = 214, .external_lex_state = 35},
  [5496] = {.lex_state = 230, .external_lex_state = 35},
  [5497] = {.lex_state = 230, .external_lex_state = 35},
  [5498] = {.lex_state = 230, .external_lex_state = 35},
  [5499] = {.lex_state = 214, .external_lex_state = 35},
  [5500] = {.lex_state = 230, .external_lex_state = 35},
  [5501] = {.lex_state = 230, .external_lex_state = 35},
  [5502] = {.lex_state = 230, .external_lex_state = 35},
  [5503] = {.lex_state = 230, .external_lex_state = 35},
  [5504] = {.lex_state = 230, .external_lex_state = 35},
  [5505] = {.lex_state = 230, .external_lex_state = 35},
  [5506] = {.lex_state = 230, .external_lex_state = 35},
  [5507] = {.lex_state = 101, .external_lex_state = 35},
  [5508] = {.lex_state = 107, .external_lex_state = 35},
  [5509] = {.lex_state = 214, .external_lex_state = 35},
  [5510] = {.lex_state = 230, .external_lex_state = 35},
  [5511] = {.lex_state = 80, .external_lex_state = 35},
  [5512] = {.lex_state = 230, .external_lex_state = 35},
  [5513] = {.lex_state = 230, .external_lex_state = 35},
  [5514] = {.lex_state = 214, .external_lex_state = 35},
  [5515] = {.lex_state = 230, .external_lex_state = 35},
  [5516] = {.lex_state = 230, .external_lex_state = 35},
  [5517] = {.lex_state = 214, .external_lex_state = 35},
  [5518] = {.lex_state = 230, .external_lex_state = 35},
  [5519] = {.lex_state = 230, .external_lex_state = 35},
  [5520] = {.lex_state = 214, .external_lex_state = 35},
  [5521] = {.lex_state = 230, .external_lex_state = 35},
  [5522] = {.lex_state = 230, .external_lex_state = 35},
  [5523] = {.lex_state = 230, .external_lex_state = 35},
  [5524] = {.lex_state = 230, .external_lex_state = 35},
  [5525] = {.lex_state = 230, .external_lex_state = 35},
  [5526] = {.lex_state = 214, .external_lex_state = 35},
  [5527] = {.lex_state = 230, .external_lex_state = 35},
  [5528] = {.lex_state = 230, .external_lex_state = 35},
  [5529] = {.lex_state = 230, .external_lex_state = 35},
  [5530] = {.lex_state = 230, .external_lex_state = 35},
  [5531] = {.lex_state = 230, .external_lex_state = 35},
  [5532] = {.lex_state = 230, .external_lex_state = 35},
  [5533] = {.lex_state = 230, .external_lex_state = 35},
  [5534] = {.lex_state = 230, .external_lex_state = 35},
  [5535] = {.lex_state = 230, .external_lex_state = 35},
  [5536] = {.lex_state = 230, .external_lex_state = 35},
  [5537] = {.lex_state = 230, .external_lex_state = 35},
  [5538] = {.lex_state = 230, .external_lex_state = 35},
  [5539] = {.lex_state = 230, .external_lex_state = 35},
  [5540] = {.lex_state = 230, .external_lex_state = 35},
  [5541] = {.lex_state = 230, .external_lex_state = 35},
  [5542] = {.lex_state = 230, .external_lex_state = 35},
  [5543] = {.lex_state = 230, .external_lex_state = 35},
  [5544] = {.lex_state = 230, .external_lex_state = 35},
  [5545] = {.lex_state = 230, .external_lex_state = 35},
  [5546] = {.lex_state = 230, .external_lex_state = 35},
  [5547] = {.lex_state = 230, .external_lex_state = 35},
  [5548] = {.lex_state = 230, .external_lex_state = 35},
  [5549] = {.lex_state = 230, .external_lex_state = 35},
  [5550] = {.lex_state = 101, .external_lex_state = 35},
  [5551] = {.lex_state = 101, .external_lex_state = 35},
  [5552] = {.lex_state = 101, .external_lex_state = 35},
  [5553] = {.lex_state = 80, .external_lex_state = 35},
  [5554] = {.lex_state = 93, .external_lex_state = 35},
  [5555] = {.lex_state = 101, .external_lex_state = 35},
  [5556] = {.lex_state = 93, .external_lex_state = 35},
  [5557] = {.lex_state = 101, .external_lex_state = 35},
  [5558] = {.lex_state = 101, .external_lex_state = 35},
  [5559] = {.lex_state = 93, .external_lex_state = 35},
  [5560] = {.lex_state = 101, .external_lex_state = 35},
  [5561] = {.lex_state = 80, .external_lex_state = 35},
  [5562] = {.lex_state = 80, .external_lex_state = 35},
  [5563] = {.lex_state = 80, .external_lex_state = 35},
  [5564] = {.lex_state = 101, .external_lex_state = 35},
  [5565] = {.lex_state = 214, .external_lex_state = 35},
  [5566] = {.lex_state = 101, .external_lex_state = 35},
  [5567] = {.lex_state = 214, .external_lex_state = 35},
  [5568] = {.lex_state = 93, .external_lex_state = 35},
  [5569] = {.lex_state = 101, .external_lex_state = 35},
  [5570] = {.lex_state = 214, .external_lex_state = 35},
  [5571] = {.lex_state = 80, .external_lex_state = 35},
  [5572] = {.lex_state = 214, .external_lex_state = 35},
  [5573] = {.lex_state = 214, .external_lex_state = 35},
  [5574] = {.lex_state = 80, .external_lex_state = 35},
  [5575] = {.lex_state = 80, .external_lex_state = 35},
  [5576] = {.lex_state = 80, .external_lex_state = 35},
  [5577] = {.lex_state = 101, .external_lex_state = 35},
  [5578] = {.lex_state = 214, .external_lex_state = 41},
  [5579] = {.lex_state = 101, .external_lex_state = 35},
  [5580] = {.lex_state = 101, .external_lex_state = 35},
  [5581] = {.lex_state = 93, .external_lex_state = 35},
  [5582] = {.lex_state = 101, .external_lex_state = 35},
  [5583] = {.lex_state = 101, .external_lex_state = 35},
  [5584] = {.lex_state = 101, .external_lex_state = 35},
  [5585] = {.lex_state = 101, .external_lex_state = 35},
  [5586] = {.lex_state = 80, .external_lex_state = 35},
  [5587] = {.lex_state = 80, .external_lex_state = 35},
  [5588] = {.lex_state = 101, .external_lex_state = 35},
  [5589] = {.lex_state = 80, .external_lex_state = 35},
  [5590] = {.lex_state = 101, .external_lex_state = 35},
  [5591] = {.lex_state = 93, .external_lex_state = 35},
  [5592] = {.lex_state = 101, .external_lex_state = 35},
  [5593] = {.lex_state = 80, .external_lex_state = 35},
  [5594] = {.lex_state = 214, .external_lex_state = 35},
  [5595] = {.lex_state = 93, .external_lex_state = 35},
  [5596] = {.lex_state = 80, .external_lex_state = 35},
  [5597] = {.lex_state = 93, .external_lex_state = 35},
  [5598] = {.lex_state = 101, .external_lex_state = 35},
  [5599] = {.lex_state = 101, .external_lex_state = 35},
  [5600] = {.lex_state = 101, .external_lex_state = 35},
  [5601] = {.lex_state = 101, .external_lex_state = 35},
  [5602] = {.lex_state = 80, .external_lex_state = 35},
  [5603] = {.lex_state = 80, .external_lex_state = 35},
  [5604] = {.lex_state = 101, .external_lex_state = 35},
  [5605] = {.lex_state = 101, .external_lex_state = 35},
  [5606] = {.lex_state = 101, .external_lex_state = 35},
  [5607] = {.lex_state = 101, .external_lex_state = 35},
  [5608] = {.lex_state = 80, .external_lex_state = 35},
  [5609] = {.lex_state = 80, .external_lex_state = 35},
  [5610] = {.lex_state = 214, .external_lex_state = 35},
  [5611] = {.lex_state = 93, .external_lex_state = 35},
  [5612] = {.lex_state = 101, .external_lex_state = 35},
  [5613] = {.lex_state = 101, .external_lex_state = 35},
  [5614] = {.lex_state = 214, .external_lex_state = 41},
  [5615] = {.lex_state = 80, .external_lex_state = 35},
  [5616] = {.lex_state = 214, .external_lex_state = 35},
  [5617] = {.lex_state = 101, .external_lex_state = 35},
  [5618] = {.lex_state = 214, .external_lex_state = 35},
  [5619] = {.lex_state = 214, .external_lex_state = 35},
  [5620] = {.lex_state = 101, .external_lex_state = 35},
  [5621] = {.lex_state = 101, .external_lex_state = 35},
  [5622] = {.lex_state = 80, .external_lex_state = 35},
  [5623] = {.lex_state = 101, .external_lex_state = 35},
  [5624] = {.lex_state = 101, .external_lex_state = 35},
  [5625] = {.lex_state = 214, .external_lex_state = 35},
  [5626] = {.lex_state = 214, .external_lex_state = 35},
  [5627] = {.lex_state = 101, .external_lex_state = 35},
  [5628] = {.lex_state = 214, .external_lex_state = 35},
  [5629] = {.lex_state = 214, .external_lex_state = 35},
  [5630] = {.lex_state = 80, .external_lex_state = 35},
  [5631] = {.lex_state = 101, .external_lex_state = 35},
  [5632] = {.lex_state = 101, .external_lex_state = 35},
  [5633] = {.lex_state = 101, .external_lex_state = 35},
  [5634] = {.lex_state = 101, .external_lex_state = 35},
  [5635] = {.lex_state = 214, .external_lex_state = 35},
  [5636] = {.lex_state = 80, .external_lex_state = 35},
  [5637] = {.lex_state = 214, .external_lex_state = 35},
  [5638] = {.lex_state = 101, .external_lex_state = 35},
  [5639] = {.lex_state = 214, .external_lex_state = 35},
  [5640] = {.lex_state = 101, .external_lex_state = 35},
  [5641] = {.lex_state = 101, .external_lex_state = 35},
  [5642] = {.lex_state = 101, .external_lex_state = 35},
  [5643] = {.lex_state = 80, .external_lex_state = 35},
  [5644] = {.lex_state = 101, .external_lex_state = 35},
  [5645] = {.lex_state = 214, .external_lex_state = 35},
  [5646] = {.lex_state = 80, .external_lex_state = 35},
  [5647] = {.lex_state = 214, .external_lex_state = 35},
  [5648] = {.lex_state = 101, .external_lex_state = 35},
  [5649] = {.lex_state = 93, .external_lex_state = 35},
  [5650] = {.lex_state = 101, .external_lex_state = 35},
  [5651] = {.lex_state = 101, .external_lex_state = 35},
  [5652] = {.lex_state = 214, .external_lex_state = 35},
  [5653] = {.lex_state = 101, .external_lex_state = 35},
  [5654] = {.lex_state = 101, .external_lex_state = 35},
  [5655] = {.lex_state = 101, .external_lex_state = 35},
  [5656] = {.lex_state = 101, .external_lex_state = 35},
  [5657] = {.lex_state = 101, .external_lex_state = 35},
  [5658] = {.lex_state = 101, .external_lex_state = 35},
  [5659] = {.lex_state = 101, .external_lex_state = 35},
  [5660] = {.lex_state = 101, .external_lex_state = 35},
  [5661] = {.lex_state = 101, .external_lex_state = 35},
  [5662] = {.lex_state = 101, .external_lex_state = 35},
  [5663] = {.lex_state = 101, .external_lex_state = 35},
  [5664] = {.lex_state = 80, .external_lex_state = 35},
  [5665] = {.lex_state = 214, .external_lex_state = 35},
  [5666] = {.lex_state = 101, .external_lex_state = 35},
  [5667] = {.lex_state = 101, .external_lex_state = 35},
  [5668] = {.lex_state = 101, .external_lex_state = 35},
  [5669] = {.lex_state = 101, .external_lex_state = 35},
  [5670] = {.lex_state = 80, .external_lex_state = 35},
  [5671] = {.lex_state = 214, .external_lex_state = 35},
  [5672] = {.lex_state = 101, .external_lex_state = 35},
  [5673] = {.lex_state = 80, .external_lex_state = 35},
  [5674] = {.lex_state = 214, .external_lex_state = 35},
  [5675] = {.lex_state = 214, .external_lex_state = 35},
  [5676] = {.lex_state = 80, .external_lex_state = 35},
  [5677] = {.lex_state = 101, .external_lex_state = 35},
  [5678] = {.lex_state = 101, .external_lex_state = 35},
  [5679] = {.lex_state = 80, .external_lex_state = 35},
  [5680] = {.lex_state = 93, .external_lex_state = 35},
  [5681] = {.lex_state = 101, .external_lex_state = 35},
  [5682] = {.lex_state = 101, .external_lex_state = 35},
  [5683] = {.lex_state = 101, .external_lex_state = 35},
  [5684] = {.lex_state = 214, .external_lex_state = 35},
  [5685] = {.lex_state = 80, .external_lex_state = 35},
  [5686] = {.lex_state = 246, .external_lex_state = 35},
  [5687] = {.lex_state = 101, .external_lex_state = 35},
  [5688] = {.lex_state = 101, .external_lex_state = 35},
  [5689] = {.lex_state = 93, .external_lex_state = 35},
  [5690] = {.lex_state = 241, .external_lex_state = 35},
  [5691] = {.lex_state = 101, .external_lex_state = 35},
  [5692] = {.lex_state = 214, .external_lex_state = 35},
  [5693] = {.lex_state = 101, .external_lex_state = 35},
  [5694] = {.lex_state = 101, .external_lex_state = 35},
  [5695] = {.lex_state = 80, .external_lex_state = 35},
  [5696] = {.lex_state = 101, .external_lex_state = 35},
  [5697] = {.lex_state = 80, .external_lex_state = 35},
  [5698] = {.lex_state = 93, .external_lex_state = 35},
  [5699] = {.lex_state = 101, .external_lex_state = 35},
  [5700] = {.lex_state = 101, .external_lex_state = 35},
  [5701] = {.lex_state = 214, .external_lex_state = 35},
  [5702] = {.lex_state = 93, .external_lex_state = 35},
  [5703] = {.lex_state = 214, .external_lex_state = 35},
  [5704] = {.lex_state = 101, .external_lex_state = 35},
  [5705] = {.lex_state = 101, .external_lex_state = 35},
  [5706] = {.lex_state = 101, .external_lex_state = 35},
  [5707] = {.lex_state = 101, .external_lex_state = 35},
  [5708] = {.lex_state = 80, .external_lex_state = 35},
  [5709] = {.lex_state = 101, .external_lex_state = 35},
  [5710] = {.lex_state = 101, .external_lex_state = 35},
  [5711] = {.lex_state = 214, .external_lex_state = 35},
  [5712] = {.lex_state = 101, .external_lex_state = 35},
  [5713] = {.lex_state = 101, .external_lex_state = 35},
  [5714] = {.lex_state = 101, .external_lex_state = 35},
  [5715] = {.lex_state = 214, .external_lex_state = 35},
  [5716] = {.lex_state = 101, .external_lex_state = 35},
  [5717] = {.lex_state = 80, .external_lex_state = 35},
  [5718] = {.lex_state = 80, .external_lex_state = 35},
  [5719] = {.lex_state = 101, .external_lex_state = 35},
  [5720] = {.lex_state = 80, .external_lex_state = 35},
  [5721] = {.lex_state = 93, .external_lex_state = 35},
  [5722] = {.lex_state = 93, .external_lex_state = 35},
  [5723] = {.lex_state = 101, .external_lex_state = 35},
  [5724] = {.lex_state = 214, .external_lex_state = 35},
  [5725] = {.lex_state = 214, .external_lex_state = 35},
  [5726] = {.lex_state = 80, .external_lex_state = 35},
  [5727] = {.lex_state = 80, .external_lex_state = 35},
  [5728] = {.lex_state = 101, .external_lex_state = 35},
  [5729] = {.lex_state = 241, .external_lex_state = 35},
  [5730] = {.lex_state = 214, .external_lex_state = 35},
  [5731] = {.lex_state = 80, .external_lex_state = 35},
  [5732] = {.lex_state = 80, .external_lex_state = 35},
  [5733] = {.lex_state = 101, .external_lex_state = 35},
  [5734] = {.lex_state = 101, .external_lex_state = 35},
  [5735] = {.lex_state = 246, .external_lex_state = 35},
  [5736] = {.lex_state = 101, .external_lex_state = 35},
  [5737] = {.lex_state = 101, .external_lex_state = 35},
  [5738] = {.lex_state = 80, .external_lex_state = 35},
  [5739] = {.lex_state = 80, .external_lex_state = 35},
  [5740] = {.lex_state = 80, .external_lex_state = 35},
  [5741] = {.lex_state = 80, .external_lex_state = 35},
  [5742] = {.lex_state = 214, .external_lex_state = 35},
  [5743] = {.lex_state = 80, .external_lex_state = 35},
  [5744] = {.lex_state = 80, .external_lex_state = 35},
  [5745] = {.lex_state = 214, .external_lex_state = 41},
  [5746] = {.lex_state = 214, .external_lex_state = 35},
  [5747] = {.lex_state = 80, .external_lex_state = 35},
  [5748] = {.lex_state = 80, .external_lex_state = 35},
  [5749] = {.lex_state = 214, .external_lex_state = 41},
  [5750] = {.lex_state = 80, .external_lex_state = 35},
  [5751] = {.lex_state = 80, .external_lex_state = 35},
  [5752] = {.lex_state = 101, .external_lex_state = 35},
  [5753] = {.lex_state = 101, .external_lex_state = 35},
  [5754] = {.lex_state = 80, .external_lex_state = 35},
  [5755] = {.lex_state = 101, .external_lex_state = 35},
  [5756] = {.lex_state = 80, .external_lex_state = 35},
  [5757] = {.lex_state = 214, .external_lex_state = 35},
  [5758] = {.lex_state = 101, .external_lex_state = 35},
  [5759] = {.lex_state = 80, .external_lex_state = 35},
  [5760] = {.lex_state = 214, .external_lex_state = 35},
  [5761] = {.lex_state = 101, .external_lex_state = 35},
  [5762] = {.lex_state = 80, .external_lex_state = 35},
  [5763] = {.lex_state = 214, .external_lex_state = 35},
  [5764] = {.lex_state = 214, .external_lex_state = 35},
  [5765] = {.lex_state = 214, .external_lex_state = 41},
  [5766] = {.lex_state = 80, .external_lex_state = 35},
  [5767] = {.lex_state = 101, .external_lex_state = 35},
  [5768] = {.lex_state = 80, .external_lex_state = 35},
  [5769] = {.lex_state = 101, .external_lex_state = 35},
  [5770] = {.lex_state = 93, .external_lex_state = 35},
  [5771] = {.lex_state = 80, .external_lex_state = 35},
  [5772] = {.lex_state = 101, .external_lex_state = 35},
  [5773] = {.lex_state = 101, .external_lex_state = 35},
  [5774] = {.lex_state = 80, .external_lex_state = 35},
  [5775] = {.lex_state = 101, .external_lex_state = 35},
  [5776] = {.lex_state = 214, .external_lex_state = 41},
  [5777] = {.lex_state = 80, .external_lex_state = 35},
  [5778] = {.lex_state = 101, .external_lex_state = 35},
  [5779] = {.lex_state = 101, .external_lex_state = 35},
  [5780] = {.lex_state = 80, .external_lex_state = 35},
  [5781] = {.lex_state = 214, .external_lex_state = 41},
  [5782] = {.lex_state = 101, .external_lex_state = 35},
  [5783] = {.lex_state = 101, .external_lex_state = 35},
  [5784] = {.lex_state = 214, .external_lex_state = 35},
  [5785] = {.lex_state = 214, .external_lex_state = 35},
  [5786] = {.lex_state = 80, .external_lex_state = 35},
  [5787] = {.lex_state = 101, .external_lex_state = 35},
  [5788] = {.lex_state = 101, .external_lex_state = 35},
  [5789] = {.lex_state = 101, .external_lex_state = 35},
  [5790] = {.lex_state = 214, .external_lex_state = 35},
  [5791] = {.lex_state = 101, .external_lex_state = 35},
  [5792] = {.lex_state = 101, .external_lex_state = 35},
  [5793] = {.lex_state = 101, .external_lex_state = 35},
  [5794] = {.lex_state = 101, .external_lex_state = 35},
  [5795] = {.lex_state = 214, .external_lex_state = 35},
  [5796] = {.lex_state = 101, .external_lex_state = 35},
  [5797] = {.lex_state = 214, .external_lex_state = 35},
  [5798] = {.lex_state = 214, .external_lex_state = 35},
  [5799] = {.lex_state = 101, .external_lex_state = 35},
  [5800] = {.lex_state = 214, .external_lex_state = 35},
  [5801] = {.lex_state = 101, .external_lex_state = 35},
  [5802] = {.lex_state = 214, .external_lex_state = 35},
  [5803] = {.lex_state = 101, .external_lex_state = 35},
  [5804] = {.lex_state = 80, .external_lex_state = 35},
  [5805] = {.lex_state = 101, .external_lex_state = 35},
  [5806] = {.lex_state = 101, .external_lex_state = 35},
  [5807] = {.lex_state = 101, .external_lex_state = 35},
  [5808] = {.lex_state = 80, .external_lex_state = 35},
  [5809] = {.lex_state = 101, .external_lex_state = 35},
  [5810] = {.lex_state = 101, .external_lex_state = 35},
  [5811] = {.lex_state = 80, .external_lex_state = 35},
  [5812] = {.lex_state = 101, .external_lex_state = 35},
  [5813] = {.lex_state = 101, .external_lex_state = 35},
  [5814] = {.lex_state = 93, .external_lex_state = 35},
  [5815] = {.lex_state = 101, .external_lex_state = 35},
  [5816] = {.lex_state = 101, .external_lex_state = 35},
  [5817] = {.lex_state = 101, .external_lex_state = 35},
  [5818] = {.lex_state = 93, .external_lex_state = 35},
  [5819] = {.lex_state = 101, .external_lex_state = 35},
  [5820] = {.lex_state = 101, .external_lex_state = 35},
  [5821] = {.lex_state = 214, .external_lex_state = 35},
  [5822] = {.lex_state = 101, .external_lex_state = 35},
  [5823] = {.lex_state = 101, .external_lex_state = 35},
  [5824] = {.lex_state = 93, .external_lex_state = 35},
  [5825] = {.lex_state = 80, .external_lex_state = 35},
  [5826] = {.lex_state = 214, .external_lex_state = 35},
  [5827] = {.lex_state = 93, .external_lex_state = 35},
  [5828] = {.lex_state = 101, .external_lex_state = 35},
  [5829] = {.lex_state = 80, .external_lex_state = 35},
  [5830] = {.lex_state = 101, .external_lex_state = 35},
  [5831] = {.lex_state = 101, .external_lex_state = 35},
  [5832] = {.lex_state = 101, .external_lex_state = 35},
  [5833] = {.lex_state = 101, .external_lex_state = 35},
  [5834] = {.lex_state = 101, .external_lex_state = 35},
  [5835] = {.lex_state = 101, .external_lex_state = 35},
  [5836] = {.lex_state = 101, .external_lex_state = 35},
  [5837] = {.lex_state = 214, .external_lex_state = 35},
  [5838] = {.lex_state = 80, .external_lex_state = 35},
  [5839] = {.lex_state = 101, .external_lex_state = 35},
  [5840] = {.lex_state = 101, .external_lex_state = 35},
  [5841] = {.lex_state = 80, .external_lex_state = 35},
  [5842] = {.lex_state = 101, .external_lex_state = 35},
  [5843] = {.lex_state = 93, .external_lex_state = 35},
  [5844] = {.lex_state = 214, .external_lex_state = 35},
  [5845] = {.lex_state = 101, .external_lex_state = 35},
  [5846] = {.lex_state = 93, .external_lex_state = 35},
  [5847] = {.lex_state = 214, .external_lex_state = 35},
  [5848] = {.lex_state = 214, .external_lex_state = 41},
  [5849] = {.lex_state = 80, .external_lex_state = 35},
  [5850] = {.lex_state = 214, .external_lex_state = 35},
  [5851] = {.lex_state = 80, .external_lex_state = 35},
  [5852] = {.lex_state = 93, .external_lex_state = 35},
  [5853] = {.lex_state = 101, .external_lex_state = 35},
  [5854] = {.lex_state = 101, .external_lex_state = 35},
  [5855] = {.lex_state = 101, .external_lex_state = 35},
  [5856] = {.lex_state = 80, .external_lex_state = 35},
  [5857] = {.lex_state = 101, .external_lex_state = 35},
  [5858] = {.lex_state = 101, .external_lex_state = 35},
  [5859] = {.lex_state = 101, .external_lex_state = 35},
  [5860] = {.lex_state = 214, .external_lex_state = 35},
  [5861] = {.lex_state = 101, .external_lex_state = 35},
  [5862] = {.lex_state = 214, .external_lex_state = 41},
  [5863] = {.lex_state = 101, .external_lex_state = 35},
  [5864] = {.lex_state = 101, .external_lex_state = 35},
  [5865] = {.lex_state = 80, .external_lex_state = 35},
  [5866] = {.lex_state = 214, .external_lex_state = 41},
  [5867] = {.lex_state = 101, .external_lex_state = 35},
  [5868] = {.lex_state = 101, .external_lex_state = 35},
  [5869] = {.lex_state = 101, .external_lex_state = 35},
  [5870] = {.lex_state = 214, .external_lex_state = 35},
  [5871] = {.lex_state = 101, .external_lex_state = 35},
  [5872] = {.lex_state = 214, .external_lex_state = 35},
  [5873] = {(TSStateId)(-1)},
  [5874] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_body] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_program_token1] = ACTIONS(1),
    [anon_sym___END__] = ACTIONS(1),
    [anon_sym_BEGIN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_rescue] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_next] = ACTIONS(1),
    [anon_sym_redo] = ACTIONS(1),
    [anon_sym_retry] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_unless] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [sym_line] = ACTIONS(1),
    [sym_file] = ACTIONS(1),
    [sym_encoding] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_elsif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_ensure] = ACTIONS(1),
    [anon_sym_COLON_COLON2] = ACTIONS(1),
    [anon_sym_AMP_DOT] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON2] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_defined_QMARK] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS_AT] = ACTIONS(1),
    [anon_sym_DASH_AT] = ACTIONS(1),
    [anon_sym_TILDE_AT] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_EQ2] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_i] = ACTIONS(1),
    [anon_sym_ri] = ACTIONS(1),
    [anon_sym_r] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_constant] = ACTIONS(1),
    [aux_sym_constant_suffix_token1] = ACTIONS(1),
    [sym_instance_variable] = ACTIONS(1),
    [sym_class_variable] = ACTIONS(1),
    [sym_global_variable] = ACTIONS(1),
    [sym_character] = ACTIONS(1),
    [anon_sym_POUND_LBRACE] = ACTIONS(1),
    [sym__line_break] = ACTIONS(1),
    [sym__no_line_break] = ACTIONS(1),
    [sym_simple_symbol] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__symbol_start] = ACTIONS(1),
    [sym__subshell_start] = ACTIONS(1),
    [sym__regex_start] = ACTIONS(1),
    [sym__string_array_start] = ACTIONS(1),
    [sym__symbol_array_start] = ACTIONS(1),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_string_content] = ACTIONS(1),
    [sym_heredoc_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [sym_heredoc_beginning] = ACTIONS(1),
    [sym__block_ampersand] = ACTIONS(1),
    [sym__splat_star] = ACTIONS(1),
    [sym__unary_minus] = ACTIONS(1),
    [sym__unary_minus_num] = ACTIONS(1),
    [sym__binary_minus] = ACTIONS(1),
    [sym__binary_star] = ACTIONS(1),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1),
    [sym_hash_key_symbol] = ACTIONS(1),
    [sym__identifier_suffix] = ACTIONS(1),
    [sym__constant_suffix] = ACTIONS(1),
    [sym__hash_splat_star_star] = ACTIONS(1),
    [sym__binary_star_star] = ACTIONS(1),
    [sym__element_reference_bracket] = ACTIONS(1),
    [sym__short_interpolation] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(5610),
    [sym__statements] = STATE(5464),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4713),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4683),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3219),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2087),
    [aux_sym__statements_repeat1] = STATE(305),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [aux_sym_program_token1] = ACTIONS(11),
    [anon_sym___END__] = ACTIONS(13),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_undef] = ACTIONS(77),
    [anon_sym_alias] = ACTIONS(79),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [2] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(2),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(129),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(129),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(129),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [3] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4371),
    [sym_argument_list] = STATE(2188),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(3),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(179),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_elsif] = ACTIONS(179),
    [anon_sym_else] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(179),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [4] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4371),
    [sym_argument_list] = STATE(2188),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(4),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(179),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_elsif] = ACTIONS(179),
    [anon_sym_else] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(179),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [5] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4387),
    [sym_argument_list] = STATE(2178),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(5),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(179),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(179),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_elsif] = ACTIONS(179),
    [anon_sym_else] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(179),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [6] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(6),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(129),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(129),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(129),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [7] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(7),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(129),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(129),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(129),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [8] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(8),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(123),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [9] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4371),
    [sym_argument_list] = STATE(2188),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(9),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(177),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(177),
    [anon_sym___END__] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [10] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4387),
    [sym_argument_list] = STATE(2178),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(10),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(177),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(177),
    [anon_sym___END__] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [11] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(11),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(123),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [12] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4371),
    [sym_argument_list] = STATE(2188),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(12),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(177),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(177),
    [anon_sym___END__] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [13] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(13),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(123),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [14] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4371),
    [sym_argument_list] = STATE(2188),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(14),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [15] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(15),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [16] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4387),
    [sym_argument_list] = STATE(2178),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(16),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [17] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(17),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [18] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4371),
    [sym_argument_list] = STATE(2188),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(18),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [19] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(19),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [20] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4764),
    [sym_argument_list] = STATE(2758),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2944),
    [sym_block] = STATE(2961),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(20),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(237),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [21] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4387),
    [sym_argument_list] = STATE(2178),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(21),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(335),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [22] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4371),
    [sym_argument_list] = STATE(2188),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(22),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [23] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(23),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [24] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(24),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [25] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4767),
    [sym_argument_list] = STATE(2775),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(25),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(237),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [26] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4387),
    [sym_argument_list] = STATE(2178),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(26),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [27] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(27),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [28] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4804),
    [sym_argument_list] = STATE(3045),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2944),
    [sym_block] = STATE(2961),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(28),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [29] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4765),
    [sym_argument_list] = STATE(3068),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(29),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [30] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(30),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(335),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_unless] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_until] = ACTIONS(129),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [31] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4371),
    [sym_argument_list] = STATE(2188),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(31),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_then] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [32] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(32),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_then] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(123),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [33] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4387),
    [sym_argument_list] = STATE(2178),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(33),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(179),
    [anon_sym_unless] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(179),
    [anon_sym_until] = ACTIONS(179),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(177),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [34] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4765),
    [sym_argument_list] = STATE(3068),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(34),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [35] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4764),
    [sym_argument_list] = STATE(2758),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2944),
    [sym_block] = STATE(2961),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(35),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(237),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [36] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4767),
    [sym_argument_list] = STATE(2775),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(36),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(237),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [37] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4804),
    [sym_argument_list] = STATE(3045),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2944),
    [sym_block] = STATE(2961),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(37),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [38] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4764),
    [sym_argument_list] = STATE(2758),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2944),
    [sym_block] = STATE(2961),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(38),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(179),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [39] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4767),
    [sym_argument_list] = STATE(2775),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(39),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [40] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4767),
    [sym_argument_list] = STATE(2775),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(40),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_and] = ACTIONS(129),
    [anon_sym_or] = ACTIONS(129),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [41] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4764),
    [sym_argument_list] = STATE(2758),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2944),
    [sym_block] = STATE(2961),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(41),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [anon_sym_and] = ACTIONS(179),
    [anon_sym_or] = ACTIONS(179),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [42] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(42),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(413),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_elsif] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(413),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [43] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(43),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(413),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_elsif] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(413),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [44] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(44),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(413),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_elsif] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(413),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [45] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4421),
    [sym_argument_list] = STATE(2327),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(45),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [46] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4408),
    [sym_argument_list] = STATE(2313),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(46),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [47] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4435),
    [sym_argument_list] = STATE(2333),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(47),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [48] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4443),
    [sym_argument_list] = STATE(2250),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(48),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(429),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(429),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_elsif] = ACTIONS(429),
    [anon_sym_else] = ACTIONS(429),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(429),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [49] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4408),
    [sym_argument_list] = STATE(2313),
    [sym__argument] = STATE(4507),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(49),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [50] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4421),
    [sym_argument_list] = STATE(2327),
    [sym__argument] = STATE(4507),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(50),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [51] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4435),
    [sym_argument_list] = STATE(2333),
    [sym__argument] = STATE(4507),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(51),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [52] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4443),
    [sym_argument_list] = STATE(2250),
    [sym__argument] = STATE(4507),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(52),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(429),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(429),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_elsif] = ACTIONS(429),
    [anon_sym_else] = ACTIONS(429),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(429),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [53] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(53),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(411),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(411),
    [anon_sym___END__] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [54] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(54),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(411),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(411),
    [anon_sym___END__] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [55] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(55),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(411),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(411),
    [anon_sym___END__] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [56] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4408),
    [sym_argument_list] = STATE(2313),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(56),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(419),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [57] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4421),
    [sym_argument_list] = STATE(2327),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(57),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(415),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [58] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4435),
    [sym_argument_list] = STATE(2333),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(58),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(423),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [59] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(59),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [60] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4443),
    [sym_argument_list] = STATE(2250),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(60),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(427),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(427),
    [anon_sym___END__] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [61] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(61),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [62] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3132),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4435),
    [sym_argument_list] = STATE(2333),
    [sym__argument] = STATE(4599),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1951),
    [sym_identifier_suffix] = STATE(1953),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2588),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(62),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(423),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [63] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(63),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [64] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4765),
    [sym_argument_list] = STATE(3068),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(64),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [65] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(65),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [66] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3132),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4443),
    [sym_argument_list] = STATE(2250),
    [sym__argument] = STATE(4599),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1951),
    [sym_identifier_suffix] = STATE(1953),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2588),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(66),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(427),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(427),
    [anon_sym___END__] = ACTIONS(429),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [67] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3132),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4421),
    [sym_argument_list] = STATE(2327),
    [sym__argument] = STATE(4599),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1951),
    [sym_identifier_suffix] = STATE(1953),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2588),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(67),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(415),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [68] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(68),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [69] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(69),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [70] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3132),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4408),
    [sym_argument_list] = STATE(2313),
    [sym__argument] = STATE(4599),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1951),
    [sym_identifier_suffix] = STATE(1953),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2588),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(70),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(419),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [71] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4767),
    [sym_argument_list] = STATE(2775),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(71),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(237),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [72] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4389),
    [sym_argument_list] = STATE(2180),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(72),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(335),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_unless] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_until] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [73] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4443),
    [sym_argument_list] = STATE(2250),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(73),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [74] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4421),
    [sym_argument_list] = STATE(2327),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(74),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [75] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4435),
    [sym_argument_list] = STATE(2333),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(75),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [76] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4408),
    [sym_argument_list] = STATE(2313),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(76),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(229),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [77] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4767),
    [sym_argument_list] = STATE(2775),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(77),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(237),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [78] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4386),
    [sym_argument_list] = STATE(2179),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(78),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(121),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_then] = ACTIONS(413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(411),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [79] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4765),
    [sym_argument_list] = STATE(3068),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(79),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [80] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4943),
    [sym_argument_list] = STATE(2890),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(80),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [81] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4443),
    [sym_argument_list] = STATE(2250),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(81),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [82] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4435),
    [sym_argument_list] = STATE(2333),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(82),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [83] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4408),
    [sym_argument_list] = STATE(2313),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(83),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [84] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3405),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4408),
    [sym_argument_list] = STATE(2313),
    [sym__argument] = STATE(4687),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1965),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2671),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(84),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [85] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3405),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4421),
    [sym_argument_list] = STATE(2327),
    [sym__argument] = STATE(4687),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1965),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2671),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(85),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [86] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3405),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4443),
    [sym_argument_list] = STATE(2250),
    [sym__argument] = STATE(4687),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1965),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2671),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(86),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_unless] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_until] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [87] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4421),
    [sym_argument_list] = STATE(2327),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(87),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(353),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [88] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4937),
    [sym_argument_list] = STATE(2884),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(88),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [89] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3405),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4435),
    [sym_argument_list] = STATE(2333),
    [sym__argument] = STATE(4687),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1965),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2671),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(89),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [90] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4408),
    [sym_argument_list] = STATE(2313),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(90),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [91] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4421),
    [sym_argument_list] = STATE(2327),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(91),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [92] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4942),
    [sym_argument_list] = STATE(2887),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(92),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [93] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4867),
    [sym_argument_list] = STATE(2925),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(93),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [94] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4435),
    [sym_argument_list] = STATE(2333),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(94),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [95] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4767),
    [sym_argument_list] = STATE(2775),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(95),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(413),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [96] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4443),
    [sym_argument_list] = STATE(2250),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(96),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [97] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3856),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4408),
    [sym_argument_list] = STATE(2313),
    [sym__argument] = STATE(5007),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5608),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2393),
    [sym__variable] = STATE(32),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1974),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(3060),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(97),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(419),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [98] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3835),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4867),
    [sym_argument_list] = STATE(2925),
    [sym__argument] = STATE(4969),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3063),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(98),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [99] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3835),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4937),
    [sym_argument_list] = STATE(2884),
    [sym__argument] = STATE(4969),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3063),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(99),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [100] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3835),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4942),
    [sym_argument_list] = STATE(2887),
    [sym__argument] = STATE(4969),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3063),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(100),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [101] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3835),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4943),
    [sym_argument_list] = STATE(2890),
    [sym__argument] = STATE(4969),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3063),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(101),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(601),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [102] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4937),
    [sym_argument_list] = STATE(2884),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(102),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [103] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4942),
    [sym_argument_list] = STATE(2887),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(103),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [104] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4943),
    [sym_argument_list] = STATE(2890),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(104),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [105] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4867),
    [sym_argument_list] = STATE(2925),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(105),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [106] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4767),
    [sym_argument_list] = STATE(2775),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_do_block] = STATE(2976),
    [sym_block] = STATE(2977),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(106),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(413),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_PIPE] = ACTIONS(413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(273),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(411),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(413),
    [anon_sym_CARET] = ACTIONS(411),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(411),
    [anon_sym_AMP_DOT] = ACTIONS(411),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_LT_LT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(413),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(411),
    [anon_sym_EQ_EQ] = ACTIONS(413),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(411),
    [anon_sym_LT_EQ_GT] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_BANG_TILDE] = ACTIONS(411),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(411),
    [sym__binary_star] = ACTIONS(411),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
    [sym__binary_star_star] = ACTIONS(411),
    [sym__element_reference_bracket] = ACTIONS(411),
  },
  [107] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3856),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4421),
    [sym_argument_list] = STATE(2327),
    [sym__argument] = STATE(5007),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5608),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2393),
    [sym__variable] = STATE(32),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1974),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(3060),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(107),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(415),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [108] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3856),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4435),
    [sym_argument_list] = STATE(2333),
    [sym__argument] = STATE(5007),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5608),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2393),
    [sym__variable] = STATE(32),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1974),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(3060),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(108),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(423),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [109] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3856),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4443),
    [sym_argument_list] = STATE(2250),
    [sym__argument] = STATE(5007),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5608),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2393),
    [sym__variable] = STATE(32),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1974),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(3060),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(109),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_then] = ACTIONS(429),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(427),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [110] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3933),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4867),
    [sym_argument_list] = STATE(2925),
    [sym__argument] = STATE(5156),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1976),
    [sym_identifier_suffix] = STATE(1977),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3101),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(110),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(427),
    [anon_sym_DOT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(427),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(427),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(427),
    [anon_sym_AMP_DOT] = ACTIONS(427),
    [anon_sym_QMARK] = ACTIONS(429),
    [anon_sym_and] = ACTIONS(429),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(427),
    [anon_sym_GT_GT] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_SLASH] = ACTIONS(427),
    [anon_sym_PERCENT] = ACTIONS(427),
    [anon_sym_EQ_EQ] = ACTIONS(429),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ_GT] = ACTIONS(427),
    [anon_sym_EQ_TILDE] = ACTIONS(427),
    [anon_sym_BANG_TILDE] = ACTIONS(427),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(427),
    [sym__binary_star] = ACTIONS(427),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(427),
    [sym__element_reference_bracket] = ACTIONS(427),
  },
  [111] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3933),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4943),
    [sym_argument_list] = STATE(2890),
    [sym__argument] = STATE(5156),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1976),
    [sym_identifier_suffix] = STATE(1977),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3101),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(111),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(423),
    [sym__element_reference_bracket] = ACTIONS(423),
  },
  [112] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3933),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4937),
    [sym_argument_list] = STATE(2884),
    [sym__argument] = STATE(5156),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1976),
    [sym_identifier_suffix] = STATE(1977),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3101),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(112),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(419),
    [sym__element_reference_bracket] = ACTIONS(419),
  },
  [113] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3933),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4942),
    [sym_argument_list] = STATE(2887),
    [sym__argument] = STATE(5156),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1976),
    [sym_identifier_suffix] = STATE(1977),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3101),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(113),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(279),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(633),
    [sym__binary_star_star] = ACTIONS(415),
    [sym__element_reference_bracket] = ACTIONS(415),
  },
  [114] = {
    [sym__statements] = STATE(5572),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_expr] = STATE(5517),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(3052),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5511),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2191),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(3052),
    [sym_string_array] = STATE(3052),
    [sym_symbol_array] = STATE(3052),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(3052),
    [sym_heredoc_body] = STATE(114),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(3056),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [115] = {
    [sym__statements] = STATE(5675),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_expr] = STATE(5514),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(3052),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5511),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2191),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(3052),
    [sym_string_array] = STATE(3052),
    [sym_symbol_array] = STATE(3052),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(3052),
    [sym_heredoc_body] = STATE(115),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(3056),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [116] = {
    [sym__statements] = STATE(5572),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_expr] = STATE(5514),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(3052),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5511),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2191),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(3052),
    [sym_string_array] = STATE(3052),
    [sym_symbol_array] = STATE(3052),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(3052),
    [sym_heredoc_body] = STATE(116),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(3056),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [117] = {
    [sym__statements] = STATE(5675),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_expr] = STATE(5517),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(3052),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5511),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2191),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(3052),
    [sym_string_array] = STATE(3052),
    [sym_symbol_array] = STATE(3052),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(3052),
    [sym_heredoc_body] = STATE(117),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(3056),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_COLON_COLON] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(649),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(671),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(675),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [118] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_splat_parameter] = STATE(4875),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__array_pattern_n] = STATE(5490),
    [sym__pattern_expr] = STATE(5270),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym__array_pattern_body] = STATE(5763),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(5764),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5619),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3540),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2478),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(3540),
    [sym_string_array] = STATE(3540),
    [sym_symbol_array] = STATE(3540),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3540),
    [sym_heredoc_body] = STATE(118),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(3546),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(701),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [119] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_splat_parameter] = STATE(4875),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__array_pattern_n] = STATE(5490),
    [sym__pattern_expr] = STATE(5270),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym__array_pattern_body] = STATE(5724),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(5725),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5619),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3540),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2478),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(3540),
    [sym_string_array] = STATE(3540),
    [sym_symbol_array] = STATE(3540),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3540),
    [sym_heredoc_body] = STATE(119),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(3546),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [120] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_splat_parameter] = STATE(4875),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__array_pattern_n] = STATE(5490),
    [sym__pattern_expr] = STATE(5270),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym__array_pattern_body] = STATE(5763),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(5764),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5715),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3540),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2478),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(3540),
    [sym_string_array] = STATE(3540),
    [sym_symbol_array] = STATE(3540),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3540),
    [sym_heredoc_body] = STATE(120),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(3546),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(727),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [121] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_splat_parameter] = STATE(4875),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__array_pattern_n] = STATE(5490),
    [sym__pattern_expr] = STATE(5270),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym__array_pattern_body] = STATE(5724),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(5725),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5715),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3540),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2478),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(3540),
    [sym_string_array] = STATE(3540),
    [sym_symbol_array] = STATE(3540),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3540),
    [sym_heredoc_body] = STATE(121),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(3546),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(729),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [122] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_splat_parameter] = STATE(4875),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__array_pattern_n] = STATE(5490),
    [sym__pattern_expr] = STATE(5270),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym__array_pattern_body] = STATE(5724),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(5725),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5619),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3540),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2478),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(3540),
    [sym_string_array] = STATE(3540),
    [sym_symbol_array] = STATE(3540),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3540),
    [sym_heredoc_body] = STATE(122),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(3546),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(693),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(699),
    [anon_sym_RBRACK] = ACTIONS(731),
    [anon_sym_DOT_DOT] = ACTIONS(703),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(707),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(711),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [123] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_superclass] = STATE(5407),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5651),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(123),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(218),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(735),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [124] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_superclass] = STATE(5452),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5859),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(124),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(203),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(755),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [125] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_superclass] = STATE(5432),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5823),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(125),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(225),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [126] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5592),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(126),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(208),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(759),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [127] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5769),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(127),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(196),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(761),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [128] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_superclass] = STATE(5432),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5823),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(128),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(225),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(757),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [129] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5868),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(129),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(209),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(763),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [130] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_superclass] = STATE(5407),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5651),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(130),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(218),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(735),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [131] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_superclass] = STATE(5452),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5859),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(131),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(203),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(755),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [132] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5592),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(132),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(208),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(759),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [133] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5769),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(133),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(196),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(761),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [134] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5868),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(134),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(209),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(763),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [135] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(135),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [136] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(136),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [137] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(137),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [138] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(181),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5753),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(138),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(182),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(773),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [139] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(139),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [140] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(5335),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5627),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(140),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(211),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(779),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [141] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(186),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5688),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(141),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(166),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(783),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [142] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(142),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(785),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [143] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(3012),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5599),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(143),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(787),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [144] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(177),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5792),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(144),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(178),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(791),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [145] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(145),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(793),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [146] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(3012),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5599),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(146),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(787),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(795),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [147] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(173),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5840),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(147),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(171),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(797),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [148] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(148),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(799),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [149] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(3012),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5599),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(149),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(787),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [150] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(168),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5704),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(150),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(169),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(803),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [151] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(151),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(805),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [152] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(3012),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5599),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(152),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(787),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [153] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(174),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5810),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(153),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(175),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(809),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [154] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(154),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [155] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(3012),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5599),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(155),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(787),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [156] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(156),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [157] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(3012),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5599),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(157),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(787),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [158] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(3012),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5599),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(158),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(787),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(819),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [159] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(3012),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5599),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(159),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(787),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [160] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(160),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(823),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [161] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(3012),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5599),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(161),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(787),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [162] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(162),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(827),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [163] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(2248),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5678),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(163),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(193),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(765),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [164] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym__body_expr] = STATE(3012),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5599),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(164),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(220),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(787),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(831),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [165] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(183),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5655),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(165),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(184),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(833),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [166] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(167),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5663),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(166),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(835),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [167] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5605),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(167),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(219),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(837),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [168] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5799),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(168),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(204),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(839),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [169] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(170),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5820),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(169),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [170] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5557),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(170),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(192),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(843),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [171] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(180),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5817),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(171),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(845),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [172] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5672),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(172),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(847),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [173] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5755),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(173),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(198),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(849),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [174] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5853),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(174),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(212),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(851),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [175] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(176),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5796),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(175),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(853),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [176] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5583),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(176),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(214),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(855),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [177] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5687),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(177),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(207),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(857),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [178] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(179),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5714),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(178),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(859),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [179] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5787),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(179),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(200),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(861),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [180] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5836),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(180),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(216),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(863),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [181] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5683),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(181),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(206),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(865),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [182] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(172),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5699),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(182),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(867),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [183] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5579),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(183),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(197),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(869),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [184] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(185),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5590),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(184),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(871),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [185] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5661),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(185),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(199),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(873),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [186] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5585),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(186),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(217),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(875),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [187] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym__body_statement] = STATE(5624),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(187),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(230),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(877),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [188] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2430),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(188),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(883),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(883),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_elsif] = ACTIONS(883),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(883),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [189] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2450),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(189),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_elsif] = ACTIONS(921),
    [anon_sym_else] = ACTIONS(921),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(921),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [190] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym__body_statement] = STATE(5822),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(190),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(226),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [191] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym__body_statement] = STATE(5588),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(191),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(229),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(925),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [192] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5560),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(192),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(927),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [193] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5842),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(193),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(929),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [194] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5654),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(194),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(931),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [195] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5669),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(195),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(933),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [196] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5813),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(196),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [197] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5660),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(197),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(937),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [198] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5834),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(198),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [199] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5681),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(199),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(941),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [200] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5803),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(200),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(943),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [201] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2498),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(201),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(883),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(883),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_elsif] = ACTIONS(883),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(883),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(955),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [202] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5604),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(202),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(963),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [203] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5620),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(203),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(965),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [204] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5555),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(204),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(967),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [205] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5658),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(205),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(969),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [206] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5819),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(206),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(971),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [207] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5783),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(207),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(973),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [208] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5713),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(208),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(975),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [209] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5621),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(209),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(977),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [210] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5682),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(210),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(979),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [211] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5828),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(211),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(981),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [212] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5582),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(212),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(983),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [213] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5830),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(213),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(985),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [214] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5600),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(214),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(987),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [215] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5831),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(215),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(989),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [216] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5705),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(216),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(991),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [217] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5558),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(217),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [218] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5789),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(218),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(995),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [219] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5736),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(219),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [220] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5854),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(220),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(999),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [221] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2506),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(221),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_elsif] = ACTIONS(921),
    [anon_sym_else] = ACTIONS(921),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(921),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(955),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [222] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5775),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(222),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1001),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [223] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5855),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(223),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1003),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [224] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5857),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(224),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1005),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [225] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym_body_statement] = STATE(5696),
    [sym__body_statement] = STATE(5659),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(225),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1007),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [226] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym__body_statement] = STATE(5631),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(226),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1009),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [227] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2539),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(227),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_end] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_elsif] = ACTIONS(921),
    [anon_sym_else] = ACTIONS(921),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(921),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1021),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [228] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4428),
    [sym__argument] = STATE(4461),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(228),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1031),
    [anon_sym_rescue] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1033),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_unless] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_until] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1031),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_elsif] = ACTIONS(1031),
    [anon_sym_else] = ACTIONS(1031),
    [anon_sym_then] = ACTIONS(1031),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1031),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1029),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
  },
  [229] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym__body_statement] = STATE(5767),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(229),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1041),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [230] = {
    [sym__statements] = STATE(4900),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5280),
    [sym_begin] = STATE(2259),
    [sym_ensure] = STATE(5280),
    [sym_rescue] = STATE(5280),
    [sym__body_statement] = STATE(5691),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(230),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [aux_sym__body_statement_repeat1] = STATE(4910),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1043),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [231] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4428),
    [sym__argument] = STATE(4507),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(231),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1031),
    [anon_sym_rescue] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_unless] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_until] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1031),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_elsif] = ACTIONS(1031),
    [anon_sym_else] = ACTIONS(1031),
    [anon_sym_then] = ACTIONS(1031),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1031),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1029),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [232] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4559),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(232),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(241),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1055),
    [anon_sym_rescue] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1055),
    [anon_sym_else] = ACTIONS(1055),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [233] = {
    [sym_block_body] = STATE(5844),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(300),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3476),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_hash_splat_argument] = STATE(5425),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1963),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2691),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(233),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(5425),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1057),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [234] = {
    [sym_block_body] = STATE(5844),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(300),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3476),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_hash_splat_argument] = STATE(5425),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1963),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2691),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(234),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(5425),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1057),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [235] = {
    [sym_block_body] = STATE(5844),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(300),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3476),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_hash_splat_argument] = STATE(5425),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1963),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2691),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(235),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(5425),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1057),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [236] = {
    [sym_block_body] = STATE(5711),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(294),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3476),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_hash_splat_argument] = STATE(5458),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1963),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2691),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(236),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(5458),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1057),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [237] = {
    [sym_block_body] = STATE(5711),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(294),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3476),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_hash_splat_argument] = STATE(5458),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1963),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2691),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(237),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(5458),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1057),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [238] = {
    [sym_block_body] = STATE(5844),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(300),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3476),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_hash_splat_argument] = STATE(5425),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1963),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2691),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(238),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(5425),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1057),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [239] = {
    [sym_block_body] = STATE(5844),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(300),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3476),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_hash_splat_argument] = STATE(5425),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1963),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2691),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(239),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(5425),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1057),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [240] = {
    [sym_block_body] = STATE(5711),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(294),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3476),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_hash_splat_argument] = STATE(5458),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1963),
    [sym_identifier_suffix] = STATE(1962),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2691),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(240),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(5458),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1075),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(1057),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [241] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4925),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(241),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(241),
    [sym_identifier] = ACTIONS(1077),
    [anon_sym_BEGIN] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1083),
    [anon_sym_RBRACE] = ACTIONS(1086),
    [anon_sym_END] = ACTIONS(1088),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1094),
    [anon_sym_RPAREN] = ACTIONS(1086),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_end] = ACTIONS(1100),
    [anon_sym_rescue] = ACTIONS(1100),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1108),
    [anon_sym_nil] = ACTIONS(1111),
    [anon_sym_class] = ACTIONS(1114),
    [anon_sym_module] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1120),
    [anon_sym_yield] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1126),
    [anon_sym_next] = ACTIONS(1129),
    [anon_sym_redo] = ACTIONS(1132),
    [anon_sym_retry] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1138),
    [anon_sym_unless] = ACTIONS(1141),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_until] = ACTIONS(1147),
    [anon_sym_for] = ACTIONS(1150),
    [anon_sym_in] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1153),
    [anon_sym_when] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1156),
    [anon_sym_DOT_DOT] = ACTIONS(1159),
    [anon_sym_elsif] = ACTIONS(1100),
    [anon_sym_else] = ACTIONS(1100),
    [anon_sym_begin] = ACTIONS(1162),
    [anon_sym_ensure] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_defined_QMARK] = ACTIONS(1168),
    [anon_sym_not] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1174),
    [anon_sym_TILDE] = ACTIONS(1174),
    [anon_sym_undef] = ACTIONS(1177),
    [anon_sym_alias] = ACTIONS(1180),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1183),
    [sym_float] = ACTIONS(1183),
    [sym_super] = ACTIONS(1077),
    [sym_self] = ACTIONS(1077),
    [sym_true] = ACTIONS(1186),
    [sym_false] = ACTIONS(1186),
    [sym_constant] = ACTIONS(1077),
    [aux_sym_constant_suffix_token1] = ACTIONS(1189),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1192),
    [sym_instance_variable] = ACTIONS(1195),
    [sym_class_variable] = ACTIONS(1195),
    [sym_global_variable] = ACTIONS(1195),
    [sym_character] = ACTIONS(1198),
    [anon_sym_DASH_GT] = ACTIONS(1201),
    [sym_simple_symbol] = ACTIONS(1204),
    [sym__string_start] = ACTIONS(1207),
    [sym__symbol_start] = ACTIONS(1210),
    [sym__subshell_start] = ACTIONS(1213),
    [sym__regex_start] = ACTIONS(1216),
    [sym__string_array_start] = ACTIONS(1219),
    [sym__symbol_array_start] = ACTIONS(1222),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1198),
    [sym__unary_minus] = ACTIONS(1225),
    [sym__unary_minus_num] = ACTIONS(1228),
    [sym__binary_minus] = ACTIONS(1231),
    [sym__identifier_suffix] = ACTIONS(1234),
    [sym__constant_suffix] = ACTIONS(1189),
  },
  [242] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2625),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(242),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_elsif] = ACTIONS(921),
    [anon_sym_else] = ACTIONS(921),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(921),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1245),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [243] = {
    [sym__statements] = STATE(4950),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(243),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1249),
    [anon_sym_rescue] = ACTIONS(1249),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1249),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1249),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [244] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(244),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1251),
    [anon_sym_rescue] = ACTIONS(1251),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1251),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1251),
    [anon_sym_else] = ACTIONS(1251),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1251),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [245] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2613),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(245),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(883),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(883),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_elsif] = ACTIONS(883),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1245),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [246] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_elsif] = STATE(5566),
    [sym_else] = STATE(5566),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(246),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [247] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_elsif] = STATE(5807),
    [sym_else] = STATE(5807),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(247),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1259),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [248] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2690),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(248),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_elsif] = ACTIONS(921),
    [anon_sym_else] = ACTIONS(921),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(921),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [249] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_elsif] = STATE(5839),
    [sym_else] = STATE(5839),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(249),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [250] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_elsif] = STATE(5641),
    [sym_else] = STATE(5641),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(250),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [251] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2659),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(251),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(919),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(919),
    [anon_sym___END__] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [252] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2633),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(252),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(881),
    [anon_sym___END__] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [253] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_elsif] = STATE(5552),
    [sym_else] = STATE(5552),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(253),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1295),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [254] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_elsif] = STATE(5644),
    [sym_else] = STATE(5644),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(254),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1297),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [255] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_elsif] = STATE(5752),
    [sym_else] = STATE(5752),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(255),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1299),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_elsif] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [256] = {
    [sym__statements] = STATE(5358),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(256),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [sym__terminator] = STATE(273),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1301),
    [anon_sym_rescue] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [257] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2702),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(257),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(883),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(883),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_elsif] = ACTIONS(883),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(883),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [258] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(258),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1303),
    [anon_sym_rescue] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1303),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [259] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2769),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(259),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(921),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(921),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_elsif] = ACTIONS(921),
    [anon_sym_else] = ACTIONS(921),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(921),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [260] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(260),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1315),
    [anon_sym_rescue] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1315),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1315),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [261] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2750),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(261),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(919),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(919),
    [anon_sym___END__] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [262] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2770),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(262),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(881),
    [anon_sym___END__] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [263] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4544),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_when] = STATE(5434),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5761),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(263),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym__terminator] = STATE(5117),
    [aux_sym_case_repeat1] = STATE(5131),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1341),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [264] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(264),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1343),
    [anon_sym_rescue] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1343),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [265] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(265),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1345),
    [anon_sym_rescue] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [266] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4551),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_when] = STATE(5434),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5815),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(266),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym__terminator] = STATE(5176),
    [aux_sym_case_repeat1] = STATE(5177),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1349),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [267] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4547),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_when] = STATE(5434),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_else] = STATE(5607),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(267),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym__terminator] = STATE(5128),
    [aux_sym_case_repeat1] = STATE(5129),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1353),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [268] = {
    [sym_block_body] = STATE(5639),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(293),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(268),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1355),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [269] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(269),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1357),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1357),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1357),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [270] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3217),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(270),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [271] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(271),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1397),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1397),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [272] = {
    [sym_block_body] = STATE(5711),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(294),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(272),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1399),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [273] = {
    [sym__statements] = STATE(5267),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(273),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1401),
    [anon_sym_rescue] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1401),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1401),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [274] = {
    [sym_block_body] = STATE(5637),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(302),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(274),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1403),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [275] = {
    [sym_block_body] = STATE(5826),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(295),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(275),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [276] = {
    [sym_block_body] = STATE(5746),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(298),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(276),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1407),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [277] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(277),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [278] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3295),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(278),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [279] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2806),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(279),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(919),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(919),
    [anon_sym___END__] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [280] = {
    [sym_block_body] = STATE(5844),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(300),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(280),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1429),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [281] = {
    [sym__statements] = STATE(4953),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(281),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1431),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(1431),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1431),
    [anon_sym_then] = ACTIONS(1257),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [282] = {
    [sym_block_body] = STATE(5785),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_block_parameters] = STATE(309),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(282),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [283] = {
    [sym__statements] = STATE(5370),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(283),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1435),
    [anon_sym_rescue] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(1435),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [284] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3196),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(284),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [285] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4428),
    [sym__argument] = STATE(4554),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(285),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(185),
    [aux_sym_program_token1] = ACTIONS(1029),
    [anon_sym___END__] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1455),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_unless] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_until] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1029),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
  },
  [286] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3346),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(286),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1473),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [287] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3397),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(287),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1473),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [288] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3177),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(288),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [289] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2998),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(289),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [290] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3252),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(290),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [291] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3304),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(291),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [292] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2913),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(292),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [293] = {
    [sym_block_body] = STATE(5703),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(293),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1517),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [294] = {
    [sym_block_body] = STATE(5674),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(294),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1519),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [295] = {
    [sym_block_body] = STATE(5798),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(295),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [296] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3419),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(296),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [297] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2991),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(297),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(881),
    [anon_sym___END__] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [298] = {
    [sym_block_body] = STATE(5847),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(298),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1553),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [299] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3047),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(299),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [300] = {
    [sym_block_body] = STATE(5742),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(300),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1575),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [301] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3469),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(301),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [302] = {
    [sym_block_body] = STATE(5573),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(302),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [303] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3132),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4428),
    [sym__argument] = STATE(4599),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1951),
    [sym_identifier_suffix] = STATE(1953),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2588),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(303),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(463),
    [aux_sym_program_token1] = ACTIONS(1029),
    [anon_sym___END__] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_unless] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_until] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1029),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
  },
  [304] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3403),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(304),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [305] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4732),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4683),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3219),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(305),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2087),
    [aux_sym__statements_repeat1] = STATE(308),
    [ts_builtin_sym_end] = ACTIONS(1053),
    [sym_identifier] = ACTIONS(9),
    [aux_sym_program_token1] = ACTIONS(1053),
    [anon_sym___END__] = ACTIONS(1055),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [anon_sym_undef] = ACTIONS(77),
    [anon_sym_alias] = ACTIONS(79),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [306] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2891),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(306),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(919),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(919),
    [anon_sym___END__] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [307] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3309),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(307),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [308] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4897),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(308),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2087),
    [aux_sym__statements_repeat1] = STATE(308),
    [ts_builtin_sym_end] = ACTIONS(1086),
    [sym_identifier] = ACTIONS(1077),
    [aux_sym_program_token1] = ACTIONS(1086),
    [anon_sym___END__] = ACTIONS(1100),
    [anon_sym_BEGIN] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1083),
    [anon_sym_END] = ACTIONS(1088),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1094),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1108),
    [anon_sym_nil] = ACTIONS(1111),
    [anon_sym_class] = ACTIONS(1114),
    [anon_sym_module] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1120),
    [anon_sym_yield] = ACTIONS(1123),
    [anon_sym_break] = ACTIONS(1126),
    [anon_sym_next] = ACTIONS(1129),
    [anon_sym_redo] = ACTIONS(1132),
    [anon_sym_retry] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1138),
    [anon_sym_unless] = ACTIONS(1141),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_until] = ACTIONS(1147),
    [anon_sym_for] = ACTIONS(1150),
    [anon_sym_case] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1156),
    [anon_sym_DOT_DOT] = ACTIONS(1159),
    [anon_sym_begin] = ACTIONS(1162),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_defined_QMARK] = ACTIONS(1168),
    [anon_sym_not] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1174),
    [anon_sym_TILDE] = ACTIONS(1174),
    [anon_sym_undef] = ACTIONS(1177),
    [anon_sym_alias] = ACTIONS(1180),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1183),
    [sym_float] = ACTIONS(1183),
    [sym_super] = ACTIONS(1077),
    [sym_self] = ACTIONS(1077),
    [sym_true] = ACTIONS(1186),
    [sym_false] = ACTIONS(1186),
    [sym_constant] = ACTIONS(1077),
    [aux_sym_constant_suffix_token1] = ACTIONS(1189),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1192),
    [sym_instance_variable] = ACTIONS(1195),
    [sym_class_variable] = ACTIONS(1195),
    [sym_global_variable] = ACTIONS(1195),
    [sym_character] = ACTIONS(1198),
    [anon_sym_DASH_GT] = ACTIONS(1201),
    [sym_simple_symbol] = ACTIONS(1204),
    [sym__string_start] = ACTIONS(1207),
    [sym__symbol_start] = ACTIONS(1210),
    [sym__subshell_start] = ACTIONS(1213),
    [sym__regex_start] = ACTIONS(1216),
    [sym__string_array_start] = ACTIONS(1219),
    [sym__symbol_array_start] = ACTIONS(1222),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1198),
    [sym__unary_minus] = ACTIONS(1225),
    [sym__unary_minus_num] = ACTIONS(1228),
    [sym__binary_minus] = ACTIONS(1231),
    [sym__identifier_suffix] = ACTIONS(1234),
    [sym__constant_suffix] = ACTIONS(1189),
  },
  [309] = {
    [sym_block_body] = STATE(5684),
    [sym__statements] = STATE(5757),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(309),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1608),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [310] = {
    [sym__statements] = STATE(5782),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(310),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1610),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [311] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3111),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(311),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(919),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(919),
    [anon_sym___END__] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1620),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [312] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_splat_parameter] = STATE(4875),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_top_expr_body] = STATE(4888),
    [sym__array_pattern_n] = STATE(4880),
    [sym__pattern_expr] = STATE(4881),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(4882),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(4883),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4088),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3222),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2373),
    [sym_constant_suffix] = STATE(3355),
    [sym_identifier_suffix] = STATE(3356),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3083),
    [sym_subshell] = STATE(3222),
    [sym_string_array] = STATE(3222),
    [sym_symbol_array] = STATE(3222),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3222),
    [sym_heredoc_body] = STATE(312),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3225),
    [sym_identifier] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1626),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1630),
    [anon_sym_STAR] = ACTIONS(1632),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(1636),
    [anon_sym_DOT_DOT] = ACTIONS(1638),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_constant] = ACTIONS(1652),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1654),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [313] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_splat_parameter] = STATE(4875),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_top_expr_body] = STATE(4888),
    [sym__array_pattern_n] = STATE(4880),
    [sym__pattern_expr] = STATE(4881),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(4882),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(4883),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3940),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3222),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2373),
    [sym_constant_suffix] = STATE(3355),
    [sym_identifier_suffix] = STATE(3356),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3083),
    [sym_subshell] = STATE(3222),
    [sym_string_array] = STATE(3222),
    [sym_symbol_array] = STATE(3222),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3222),
    [sym_heredoc_body] = STATE(313),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3225),
    [sym_identifier] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1626),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1656),
    [anon_sym_STAR] = ACTIONS(1632),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(1636),
    [anon_sym_DOT_DOT] = ACTIONS(1658),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_constant] = ACTIONS(1652),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1654),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [314] = {
    [sym__statements] = STATE(5760),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(314),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1670),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [315] = {
    [sym__statements] = STATE(5572),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5511),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(315),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [316] = {
    [sym__statements] = STATE(5790),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(316),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1672),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [317] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_splat_parameter] = STATE(4460),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_top_expr_body] = STATE(4416),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4456),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4457),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4445),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4402),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2724),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2391),
    [sym_identifier_suffix] = STATE(2389),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(317),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1676),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1682),
    [anon_sym_STAR] = ACTIONS(1684),
    [anon_sym_STAR_STAR] = ACTIONS(1686),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1688),
    [anon_sym_DOT_DOT] = ACTIONS(1690),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(1700),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [318] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_splat_parameter] = STATE(4739),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_top_expr_body] = STATE(4416),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4761),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4712),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4661),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4606),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3833),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(3169),
    [sym_identifier_suffix] = STATE(3170),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2928),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(318),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_LBRACE] = ACTIONS(1676),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1706),
    [anon_sym_STAR] = ACTIONS(1684),
    [anon_sym_STAR_STAR] = ACTIONS(1686),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1688),
    [anon_sym_DOT_DOT] = ACTIONS(1708),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(1718),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [319] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3531),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(319),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1734),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [320] = {
    [sym__statements] = STATE(5594),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(320),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [321] = {
    [sym__statements] = STATE(5784),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(321),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [322] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_splat_parameter] = STATE(4564),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_top_expr_body] = STATE(4416),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4567),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4566),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4532),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4510),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3349),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2640),
    [sym_identifier_suffix] = STATE(2675),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2503),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(322),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(1746),
    [anon_sym_LBRACE] = ACTIONS(1676),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1748),
    [anon_sym_STAR] = ACTIONS(1750),
    [anon_sym_STAR_STAR] = ACTIONS(1752),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1688),
    [anon_sym_DOT_DOT] = ACTIONS(1754),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1756),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(1758),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [323] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_splat_parameter] = STATE(4830),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_top_expr_body] = STATE(4888),
    [sym__array_pattern_n] = STATE(4880),
    [sym__pattern_expr] = STATE(4832),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(4882),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(4883),
    [sym_keyword_pattern] = STATE(4863),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4700),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4688),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3900),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3222),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2373),
    [sym_constant_suffix] = STATE(3232),
    [sym_identifier_suffix] = STATE(3233),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2851),
    [sym_subshell] = STATE(3222),
    [sym_string_array] = STATE(3222),
    [sym_symbol_array] = STATE(3222),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3222),
    [sym_heredoc_body] = STATE(323),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3225),
    [sym_identifier] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1626),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1762),
    [anon_sym_STAR] = ACTIONS(1632),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(1636),
    [anon_sym_DOT_DOT] = ACTIONS(1764),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_constant] = ACTIONS(1774),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1654),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [324] = {
    [sym__statements] = STATE(5613),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(324),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1778),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [325] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3157),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(325),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(881),
    [anon_sym___END__] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1620),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [326] = {
    [sym__statements] = STATE(5675),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5511),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(326),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(685),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [327] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_splat_parameter] = STATE(4460),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_top_expr_body] = STATE(4416),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4456),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4457),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4445),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4402),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4000),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(3074),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2195),
    [sym_constant_suffix] = STATE(3456),
    [sym_identifier_suffix] = STATE(3457),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2709),
    [sym_subshell] = STATE(3074),
    [sym_string_array] = STATE(3074),
    [sym_symbol_array] = STATE(3074),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(3074),
    [sym_heredoc_body] = STATE(327),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3070),
    [sym_identifier] = ACTIONS(1780),
    [anon_sym_LBRACE] = ACTIONS(1782),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1784),
    [anon_sym_COLON_COLON] = ACTIONS(1786),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(1684),
    [anon_sym_STAR_STAR] = ACTIONS(1686),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_DOT_DOT] = ACTIONS(1792),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1796),
    [sym_true] = ACTIONS(1798),
    [sym_false] = ACTIONS(1798),
    [sym_constant] = ACTIONS(1800),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1802),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(1804),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [328] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_splat_parameter] = STATE(4564),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_top_expr_body] = STATE(4416),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4567),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4566),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4532),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4510),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3118),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2640),
    [sym_identifier_suffix] = STATE(2675),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2503),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(328),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(1746),
    [anon_sym_LBRACE] = ACTIONS(1676),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1806),
    [anon_sym_STAR] = ACTIONS(1750),
    [anon_sym_STAR_STAR] = ACTIONS(1752),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1688),
    [anon_sym_DOT_DOT] = ACTIONS(1808),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1756),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(1758),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [329] = {
    [sym__statements] = STATE(5671),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(329),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1810),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [330] = {
    [sym__statements] = STATE(5784),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5511),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(330),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [331] = {
    [sym__statements] = STATE(5648),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(331),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(1812),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [332] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_splat_parameter] = STATE(4875),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_top_expr_body] = STATE(4888),
    [sym__array_pattern_n] = STATE(4880),
    [sym__pattern_expr] = STATE(4881),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(4882),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(4883),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4000),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3222),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2373),
    [sym_constant_suffix] = STATE(3355),
    [sym_identifier_suffix] = STATE(3356),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3083),
    [sym_subshell] = STATE(3222),
    [sym_string_array] = STATE(3222),
    [sym_symbol_array] = STATE(3222),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3222),
    [sym_heredoc_body] = STATE(332),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3225),
    [sym_identifier] = ACTIONS(1624),
    [anon_sym_LBRACE] = ACTIONS(1626),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1630),
    [anon_sym_STAR] = ACTIONS(1632),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(1636),
    [anon_sym_DOT_DOT] = ACTIONS(1638),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_constant] = ACTIONS(1652),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1654),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [333] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_splat_parameter] = STATE(4830),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_top_expr_body] = STATE(4888),
    [sym__array_pattern_n] = STATE(4880),
    [sym__pattern_expr] = STATE(4832),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(4882),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(4883),
    [sym_keyword_pattern] = STATE(4863),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4700),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4688),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3992),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3222),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2373),
    [sym_constant_suffix] = STATE(3232),
    [sym_identifier_suffix] = STATE(3233),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2851),
    [sym_subshell] = STATE(3222),
    [sym_string_array] = STATE(3222),
    [sym_symbol_array] = STATE(3222),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3222),
    [sym_heredoc_body] = STATE(333),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3225),
    [sym_identifier] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1626),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1814),
    [anon_sym_STAR] = ACTIONS(1632),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(1636),
    [anon_sym_DOT_DOT] = ACTIONS(1816),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_constant] = ACTIONS(1774),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1654),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [334] = {
    [sym__statements] = STATE(5860),
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4572),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(334),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_empty_statement] = STATE(2027),
    [aux_sym__statements_repeat1] = STATE(232),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(1828),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [335] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4428),
    [sym__argument] = STATE(4803),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(335),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1033),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_then] = ACTIONS(1031),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1029),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
  },
  [336] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_splat_parameter] = STATE(4460),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_top_expr_body] = STATE(4416),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4456),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4457),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4445),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4402),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2668),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2391),
    [sym_identifier_suffix] = STATE(2389),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(336),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1676),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1832),
    [anon_sym_STAR] = ACTIONS(1684),
    [anon_sym_STAR_STAR] = ACTIONS(1686),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1688),
    [anon_sym_DOT_DOT] = ACTIONS(1834),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(1700),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [337] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_splat_parameter] = STATE(4460),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_top_expr_body] = STATE(4416),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4456),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4457),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4445),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4402),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3519),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2391),
    [sym_identifier_suffix] = STATE(2389),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2202),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(337),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(1674),
    [anon_sym_LBRACE] = ACTIONS(1676),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1836),
    [anon_sym_STAR] = ACTIONS(1684),
    [anon_sym_STAR_STAR] = ACTIONS(1686),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1688),
    [anon_sym_DOT_DOT] = ACTIONS(1838),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(1700),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [338] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_splat_parameter] = STATE(4739),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_top_expr_body] = STATE(4416),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4761),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4712),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4661),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4606),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4053),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(3169),
    [sym_identifier_suffix] = STATE(3170),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2928),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(338),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(1704),
    [anon_sym_LBRACE] = ACTIONS(1676),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(1678),
    [anon_sym_COLON_COLON] = ACTIONS(1680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(1684),
    [anon_sym_STAR_STAR] = ACTIONS(1686),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1688),
    [anon_sym_DOT_DOT] = ACTIONS(1852),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(1718),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [339] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3570),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(339),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1876),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [340] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4905),
    [sym__argument] = STATE(4849),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(340),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(1029),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
  },
  [341] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4428),
    [sym__argument] = STATE(4824),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(341),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1892),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_then] = ACTIONS(1031),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1896),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1029),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
  },
  [342] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3649),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(342),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1902),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [343] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3650),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(343),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1916),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [344] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3186),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(344),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(919),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(919),
    [anon_sym___END__] = ACTIONS(921),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1930),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [345] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3590),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(345),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1902),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [346] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3405),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4428),
    [sym__argument] = STATE(4687),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1965),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2671),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(346),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1934),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_unless] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_until] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1029),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
  },
  [347] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3635),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(347),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1876),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [348] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4428),
    [sym__argument] = STATE(4878),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(348),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_then] = ACTIONS(1031),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1029),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [349] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3779),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(349),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_COLON2] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1954),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [350] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3364),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(350),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1972),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [351] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3808),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(351),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1978),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [352] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3799),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(352),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1978),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [353] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3643),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(353),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [354] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3400),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(354),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1972),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [355] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3856),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_command_argument_list] = STATE(4428),
    [sym__argument] = STATE(5007),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5608),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2393),
    [sym__variable] = STATE(32),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1974),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(3060),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(355),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_then] = ACTIONS(1031),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(1029),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
  },
  [356] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4905),
    [sym__argument] = STATE(4884),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(356),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(1029),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
  },
  [357] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3555),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(357),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [358] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3747),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(358),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2008),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [359] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3835),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4905),
    [sym__argument] = STATE(4969),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3063),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(359),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(1029),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(601),
  },
  [360] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3594),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(360),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [361] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3760),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(361),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2036),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [362] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3725),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(362),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_COLON2] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1954),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [363] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4543),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(363),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [364] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4548),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(364),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [365] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4549),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(365),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [366] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3552),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(366),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [367] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3867),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(367),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [368] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3883),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(368),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_COLON2] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [369] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3460),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(369),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2080),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [370] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3817),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(370),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(919),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(2090),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [371] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3820),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(371),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(2090),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [372] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3827),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(372),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(2048),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [373] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3933),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_command_argument_list] = STATE(4905),
    [sym__argument] = STATE(5156),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1976),
    [sym_identifier_suffix] = STATE(1977),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3101),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(373),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(1029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(1029),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(1031),
    [anon_sym_or] = ACTIONS(1031),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(633),
  },
  [374] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3829),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(374),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_DOT] = ACTIONS(883),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(881),
    [anon_sym_AMP_DOT] = ACTIONS(881),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_COLON2] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(881),
    [sym__element_reference_bracket] = ACTIONS(881),
  },
  [375] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3866),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(375),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_COLON2] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [376] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3934),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(376),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_then] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [377] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3926),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(377),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_DOT] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(243),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_COLON_COLON2] = ACTIONS(919),
    [anon_sym_AMP_DOT] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_COLON2] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(919),
    [sym__element_reference_bracket] = ACTIONS(919),
  },
  [378] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4793),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4809),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(378),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [379] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4052),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(379),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [380] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4788),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4809),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(380),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [381] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4787),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4809),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(381),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [382] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4022),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(382),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [383] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4774),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(383),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [384] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4796),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4809),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(384),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [385] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4780),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(385),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [386] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4791),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(386),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [387] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4792),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4809),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(387),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [388] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4773),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(388),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [389] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4778),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(389),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [390] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4805),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4809),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(390),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [391] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4777),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(391),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [392] = {
    [sym_begin_block] = STATE(4509),
    [sym_end_block] = STATE(4509),
    [sym__statement] = STATE(4801),
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_if_modifier] = STATE(4509),
    [sym_unless_modifier] = STATE(4509),
    [sym_while_modifier] = STATE(4509),
    [sym_until_modifier] = STATE(4509),
    [sym_rescue_modifier] = STATE(4509),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4530),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym_undef] = STATE(4509),
    [sym_alias] = STATE(4509),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(392),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_BEGIN] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_END] = ACTIONS(19),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_undef] = ACTIONS(667),
    [anon_sym_alias] = ACTIONS(669),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [393] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4038),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(393),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [394] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4121),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(394),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_COLON2] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [395] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4135),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(395),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_in] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [396] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4134),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(396),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_COLON2] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [397] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4140),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(397),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(921),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(919),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [398] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5626),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(398),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [399] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5715),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(399),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2256),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [400] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5625),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(400),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [401] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5821),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(401),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2260),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [402] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4157),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(402),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(921),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_COLON2] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [403] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5665),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(403),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2280),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [404] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5628),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(404),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2282),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [405] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4152),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(405),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(919),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_COLON2] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [406] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4178),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(406),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_CARET] = ACTIONS(881),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(883),
    [anon_sym_COLON2] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_LT_LT] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(881),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(881),
    [anon_sym_LT_EQ_GT] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_BANG_TILDE] = ACTIONS(881),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__binary_star] = ACTIONS(881),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(881),
  },
  [407] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5692),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(407),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2302),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [408] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument] = STATE(4904),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(408),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2304),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [409] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5730),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(409),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [410] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_expr] = STATE(4800),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4001),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3222),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2373),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2836),
    [sym_subshell] = STATE(3222),
    [sym_string_array] = STATE(3222),
    [sym_symbol_array] = STATE(3222),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3222),
    [sym_heredoc_body] = STATE(410),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3225),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(1626),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1630),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(1636),
    [anon_sym_DOT_DOT] = ACTIONS(1638),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_constant] = ACTIONS(2312),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym__no_line_break] = ACTIONS(2314),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1654),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [411] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument] = STATE(4904),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(411),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2316),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2316),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [412] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5619),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(412),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2318),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [413] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument_list_with_trailing_comma] = STATE(5570),
    [sym__argument] = STATE(5264),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(413),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2320),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [414] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_expr] = STATE(4782),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4000),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3222),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2373),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2836),
    [sym_subshell] = STATE(3222),
    [sym_string_array] = STATE(3222),
    [sym_symbol_array] = STATE(3222),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3222),
    [sym_heredoc_body] = STATE(414),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3225),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(1626),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(691),
    [anon_sym_COLON_COLON] = ACTIONS(1628),
    [anon_sym_COMMA] = ACTIONS(2322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1630),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(1636),
    [anon_sym_DOT_DOT] = ACTIONS(1638),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_constant] = ACTIONS(2312),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1654),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [415] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4240),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(415),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_PIPE] = ACTIONS(921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_AMP] = ACTIONS(921),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_LT] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_CARET] = ACTIONS(919),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_COLON2] = ACTIONS(921),
    [anon_sym_and] = ACTIONS(921),
    [anon_sym_or] = ACTIONS(921),
    [anon_sym_PIPE_PIPE] = ACTIONS(919),
    [anon_sym_AMP_AMP] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(921),
    [anon_sym_GT] = ACTIONS(921),
    [anon_sym_GT_EQ] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_SLASH] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(921),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ_GT] = ACTIONS(919),
    [anon_sym_EQ_TILDE] = ACTIONS(919),
    [anon_sym_BANG_TILDE] = ACTIONS(919),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2334),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__binary_star] = ACTIONS(919),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
    [sym__binary_star_star] = ACTIONS(919),
  },
  [416] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym__argument] = STATE(4420),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(416),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1033),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
  },
  [417] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym__argument] = STATE(4420),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(417),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [418] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5189),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3943),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument] = STATE(4904),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1979),
    [sym_identifier_suffix] = STATE(1983),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(418),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2252),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(715),
    [sym__splat_star] = ACTIONS(717),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [419] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3132),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym__argument] = STATE(4420),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1951),
    [sym_identifier_suffix] = STATE(1953),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2588),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(419),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(463),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(475),
    [sym__splat_star] = ACTIONS(477),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym_hash_key_symbol] = ACTIONS(483),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(485),
  },
  [420] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym__argument] = STATE(4420),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1969),
    [sym_identifier_suffix] = STATE(1970),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2788),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(420),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1892),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1896),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(337),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(359),
    [sym__splat_star] = ACTIONS(361),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym_hash_key_symbol] = ACTIONS(367),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(369),
  },
  [421] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2694),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym__argument] = STATE(4420),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1941),
    [sym_identifier_suffix] = STATE(1935),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2370),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(421),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(431),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(451),
    [sym__splat_star] = ACTIONS(453),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym_hash_key_symbol] = ACTIONS(459),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(461),
  },
  [422] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3835),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym__argument] = STATE(4904),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1971),
    [sym_identifier_suffix] = STATE(1972),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3063),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(422),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(569),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(593),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym_hash_key_symbol] = ACTIONS(599),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(601),
  },
  [423] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3644),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym__argument] = STATE(4904),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1967),
    [sym_identifier_suffix] = STATE(1973),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2807),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(423),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(235),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(321),
    [sym__splat_star] = ACTIONS(323),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym_hash_key_symbol] = ACTIONS(329),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(333),
  },
  [424] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3933),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym__argument] = STATE(4904),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1976),
    [sym_identifier_suffix] = STATE(1977),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3101),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(424),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(603),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(623),
    [sym__splat_star] = ACTIONS(625),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym_hash_key_symbol] = ACTIONS(631),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(633),
  },
  [425] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2936),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym__argument] = STATE(4420),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1955),
    [sym_identifier_suffix] = STATE(1959),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2463),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(425),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(185),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1455),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(185),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(205),
    [sym__splat_star] = ACTIONS(207),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym_hash_key_symbol] = ACTIONS(213),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
    [sym__hash_splat_star_star] = ACTIONS(215),
  },
  [426] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4908),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3786),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym__argument] = STATE(4904),
    [sym_forward_argument] = STATE(4940),
    [sym_splat_argument] = STATE(4940),
    [sym_hash_splat_argument] = STATE(4940),
    [sym_block_argument] = STATE(4940),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1982),
    [sym_identifier_suffix] = STATE(1978),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2853),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(426),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(4940),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1990),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(375),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__block_ampersand] = ACTIONS(397),
    [sym__splat_star] = ACTIONS(399),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym_hash_key_symbol] = ACTIONS(405),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
    [sym__hash_splat_star_star] = ACTIONS(407),
  },
  [427] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3405),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym__argument] = STATE(4420),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1965),
    [sym_identifier_suffix] = STATE(1966),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2671),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(427),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1934),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(487),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(507),
    [sym__splat_star] = ACTIONS(509),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym_hash_key_symbol] = ACTIONS(515),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(517),
  },
  [428] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3856),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym__argument] = STATE(4420),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5608),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2393),
    [sym__variable] = STATE(32),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1968),
    [sym_identifier_suffix] = STATE(1974),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(3060),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(428),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(537),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(557),
    [sym__splat_star] = ACTIONS(559),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym_hash_key_symbol] = ACTIONS(565),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(567),
  },
  [429] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4407),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2597),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym__argument] = STATE(4420),
    [sym_forward_argument] = STATE(4414),
    [sym_splat_argument] = STATE(4414),
    [sym_hash_splat_argument] = STATE(4414),
    [sym_block_argument] = STATE(4414),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1937),
    [sym_identifier_suffix] = STATE(1936),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2197),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(429),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_pair] = STATE(4414),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1033),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(119),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__block_ampersand] = ACTIONS(163),
    [sym__splat_star] = ACTIONS(165),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym_hash_key_symbol] = ACTIONS(171),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
    [sym__hash_splat_star_star] = ACTIONS(175),
  },
  [430] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4574),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2785),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2796),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(430),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2342),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [431] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2672),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2634),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(431),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2344),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [432] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4818),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3440),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3479),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(432),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2346),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [433] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4537),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2672),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2634),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5780),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2375),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(433),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_defined_QMARK] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2344),
    [sym__unary_minus] = ACTIONS(2356),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [434] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4663),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3067),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3064),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(434),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2358),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [435] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4537),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2666),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2656),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5562),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2097),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(435),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_defined_QMARK] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2344),
    [sym__unary_minus] = ACTIONS(2368),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [436] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4468),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2530),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2578),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(436),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2370),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [437] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_rescue_modifier_expression] = STATE(4894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5253),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3852),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3924),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5575),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(437),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_defined_QMARK] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2380),
    [sym__unary_minus] = ACTIONS(2382),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [438] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4537),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2666),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2656),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5780),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2375),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(438),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_defined_QMARK] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2344),
    [sym__unary_minus] = ACTIONS(2356),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [439] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4799),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3230),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3256),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5593),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2165),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(439),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_defined_QMARK] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2392),
    [sym__unary_minus] = ACTIONS(2394),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [440] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(5108),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3690),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3743),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(440),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2396),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [441] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_rescue_modifier_expression] = STATE(4894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5242),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3770),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3499),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5575),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(441),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_defined_QMARK] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2398),
    [sym__unary_minus] = ACTIONS(2382),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [442] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4468),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2530),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2578),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(442),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2370),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [443] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_rescue_modifier_expression] = STATE(4894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5242),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3821),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3848),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5575),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(443),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_defined_QMARK] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2398),
    [sym__unary_minus] = ACTIONS(2382),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [444] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(5115),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3630),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3810),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5780),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2375),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(444),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_defined_QMARK] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2396),
    [sym__unary_minus] = ACTIONS(2356),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [445] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_rescue_modifier_expression] = STATE(4894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4944),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3498),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3547),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(445),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2400),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [446] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4675),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3067),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3064),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5747),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(446),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_defined_QMARK] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2358),
    [sym__unary_minus] = ACTIONS(2410),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [447] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_rescue_modifier_expression] = STATE(4894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5120),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3809),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3614),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(447),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2380),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [448] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4675),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3073),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3076),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5747),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(448),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_defined_QMARK] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2358),
    [sym__unary_minus] = ACTIONS(2410),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [449] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4512),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2672),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2634),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(449),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2344),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [450] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4740),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3301),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3305),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(450),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2392),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [451] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4537),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2672),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2634),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5562),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2097),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(451),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_defined_QMARK] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2344),
    [sym__unary_minus] = ACTIONS(2368),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [452] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_rescue_modifier_expression] = STATE(4894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5142),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3770),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3499),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(452),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2398),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [453] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_rescue_modifier_expression] = STATE(4433),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4799),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3301),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3305),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5593),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2165),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(453),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_defined_QMARK] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2392),
    [sym__unary_minus] = ACTIONS(2394),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [454] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_rescue_modifier_expression] = STATE(4894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4920),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3507),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3480),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(454),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [455] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2669),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(455),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2414),
    [anon_sym_rescue] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_elsif] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_then] = ACTIONS(2414),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2414),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2310),
    [sym__no_line_break] = ACTIONS(2416),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [456] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2668),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(456),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2418),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2420),
    [anon_sym_rescue] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2420),
    [anon_sym_do] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_elsif] = ACTIONS(2420),
    [anon_sym_else] = ACTIONS(2420),
    [anon_sym_then] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2420),
    [anon_sym_and] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2418),
    [sym__no_line_break] = ACTIONS(2422),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [457] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4576),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2897),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(457),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [458] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4664),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3117),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(458),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [459] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2663),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(459),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2426),
    [anon_sym_rescue] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2426),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_elsif] = ACTIONS(2426),
    [anon_sym_else] = ACTIONS(2426),
    [anon_sym_then] = ACTIONS(2426),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2426),
    [anon_sym_and] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2424),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [460] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2665),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(460),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2430),
    [anon_sym_rescue] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2430),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_elsif] = ACTIONS(2430),
    [anon_sym_else] = ACTIONS(2430),
    [anon_sym_then] = ACTIONS(2430),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2430),
    [anon_sym_and] = ACTIONS(2430),
    [anon_sym_or] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2428),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [461] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2613),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(461),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(883),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(883),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_elsif] = ACTIONS(883),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [462] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2598),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(462),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2434),
    [anon_sym_rescue] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2434),
    [anon_sym_do] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_elsif] = ACTIONS(2434),
    [anon_sym_else] = ACTIONS(2434),
    [anon_sym_then] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2434),
    [anon_sym_and] = ACTIONS(2434),
    [anon_sym_or] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2432),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [463] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2764),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(463),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2414),
    [anon_sym_rescue] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_elsif] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_then] = ACTIONS(2414),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2414),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2310),
    [sym__no_line_break] = ACTIONS(2416),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [464] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4524),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2754),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5829),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(464),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_defined_QMARK] = ACTIONS(2438),
    [anon_sym_not] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_TILDE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2444),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [465] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4469),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2601),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(465),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [466] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4524),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2754),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(466),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [467] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4684),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3117),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5747),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(467),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_defined_QMARK] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2410),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [468] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(5116),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3917),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5829),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(468),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_defined_QMARK] = ACTIONS(2438),
    [anon_sym_not] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_TILDE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2444),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [469] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_rescue_modifier_expression] = STATE(4896),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4922),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3624),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(469),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [470] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_rescue_modifier_expression] = STATE(4896),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4945),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3691),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(470),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [471] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_rescue_modifier_expression] = STATE(4896),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5268),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4046),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5586),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(95),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(471),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [472] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2724),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(472),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2418),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2420),
    [anon_sym_rescue] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_elsif] = ACTIONS(2420),
    [anon_sym_else] = ACTIONS(2420),
    [anon_sym_then] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2420),
    [anon_sym_and] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2418),
    [sym__no_line_break] = ACTIONS(2422),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [473] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4524),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2692),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5780),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2375),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(473),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_defined_QMARK] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2356),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [474] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_rescue_modifier_expression] = STATE(4896),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5268),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3869),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5575),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(474),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_defined_QMARK] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2382),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [475] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4515),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2692),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(475),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [476] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_rescue_modifier_expression] = STATE(4896),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5255),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4002),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5586),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(95),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(476),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [477] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4469),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2601),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(477),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [478] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4524),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2692),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5562),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2097),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(478),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_defined_QMARK] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2368),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [479] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4684),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3204),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(479),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [480] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4819),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3506),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(480),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [481] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4776),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3406),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5593),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2165),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(481),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_defined_QMARK] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2394),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [482] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_rescue_modifier_expression] = STATE(4896),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5159),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3869),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(482),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [483] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_rescue_modifier_expression] = STATE(4896),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5112),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3858),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(483),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [484] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(5026),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3748),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(484),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [485] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4515),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2692),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(485),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [486] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4741),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3406),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(486),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [487] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_rescue_modifier_expression] = STATE(4419),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4776),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3423),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(487),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [488] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2751),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(488),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2426),
    [anon_sym_rescue] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_elsif] = ACTIONS(2426),
    [anon_sym_else] = ACTIONS(2426),
    [anon_sym_then] = ACTIONS(2426),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2426),
    [anon_sym_and] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2424),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [489] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2678),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(489),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2434),
    [anon_sym_rescue] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_elsif] = ACTIONS(2434),
    [anon_sym_else] = ACTIONS(2434),
    [anon_sym_then] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2434),
    [anon_sym_and] = ACTIONS(2434),
    [anon_sym_or] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2432),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [490] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2766),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(490),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(2430),
    [anon_sym_rescue] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_elsif] = ACTIONS(2430),
    [anon_sym_else] = ACTIONS(2430),
    [anon_sym_then] = ACTIONS(2430),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(2430),
    [anon_sym_and] = ACTIONS(2430),
    [anon_sym_or] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2428),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [491] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2702),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(491),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_end] = ACTIONS(883),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_when] = ACTIONS(883),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_elsif] = ACTIONS(883),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_ensure] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [492] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4521),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(492),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [493] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2752),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5829),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(493),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_defined_QMARK] = ACTIONS(2438),
    [anon_sym_not] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_TILDE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2444),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [494] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2753),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5829),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(494),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_defined_QMARK] = ACTIONS(2438),
    [anon_sym_not] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_TILDE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2444),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [495] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5829),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(495),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_defined_QMARK] = ACTIONS(2438),
    [anon_sym_not] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_TILDE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2444),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [496] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(5203),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3947),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5673),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2397),
    [sym__variable] = STATE(23),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(496),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [497] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(5219),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3947),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5673),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2397),
    [sym__variable] = STATE(23),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(497),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [498] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2934),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(498),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [499] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3108),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(499),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [500] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3773),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(500),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [501] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4872),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3802),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(501),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [502] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4873),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3735),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(502),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [503] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4874),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3732),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(503),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [504] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3773),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(37),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(356),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5865),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(79),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2377),
    [sym__variable] = STATE(34),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(504),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_next] = ACTIONS(385),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_defined_QMARK] = ACTIONS(387),
    [anon_sym_not] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(401),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [505] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4679),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3219),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(505),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [506] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3454),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(506),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [507] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3477),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(507),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [508] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3448),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(508),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [509] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(509),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [510] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3929),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(510),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [511] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3930),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5673),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2397),
    [sym__variable] = STATE(23),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(511),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [512] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3962),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5673),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2397),
    [sym__variable] = STATE(23),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(512),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [513] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3963),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5673),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2397),
    [sym__variable] = STATE(23),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(513),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [514] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3575),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5673),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2397),
    [sym__variable] = STATE(23),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(514),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [515] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4423),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3219),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(515),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [516] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2743),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(516),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [517] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2752),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(517),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [518] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4423),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3947),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5673),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2397),
    [sym__variable] = STATE(23),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(518),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [519] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2753),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(519),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [520] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3824),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(520),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [521] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2707),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(521),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [522] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(522),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [523] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2680),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(523),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [524] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(524),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [525] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3167),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(525),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [526] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(526),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [527] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4802),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(527),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [528] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4763),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(528),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [529] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4808),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(529),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [530] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4783),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(530),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [531] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(5331),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3947),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5673),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2397),
    [sym__variable] = STATE(23),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(531),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [532] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4771),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(532),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [533] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4423),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3473),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(533),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [534] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4685),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3219),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(534),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [535] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3824),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(535),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [536] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3454),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(21),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5727),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(72),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2160),
    [sym__variable] = STATE(30),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(536),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_defined_QMARK] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2160),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [537] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4872),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3836),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(537),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [538] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4873),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3837),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(538),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [539] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4874),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3537),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5685),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2410),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(539),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2018),
    [anon_sym_defined_QMARK] = ACTIONS(583),
    [anon_sym_not] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(595),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [540] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3615),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(540),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [541] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3407),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(541),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [542] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3371),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(542),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [543] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3372),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(543),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [544] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(544),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [545] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(545),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [546] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4534),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(546),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [547] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4536),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(547),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [548] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2599),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(548),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [549] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4061),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5717),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(106),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2467),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(549),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_defined_QMARK] = ACTIONS(2468),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2474),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [550] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4872),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4076),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5717),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(106),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2467),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(550),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_defined_QMARK] = ACTIONS(2468),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2474),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [551] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3541),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(551),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1896),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [552] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3566),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(552),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1896),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [553] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2964),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(553),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [554] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3567),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(554),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1896),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [555] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3575),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(555),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1896),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [556] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4522),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(556),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [557] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4527),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(557),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [558] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3250),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(558),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [559] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4423),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2744),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(559),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [560] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4873),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4077),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5717),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(106),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2467),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(560),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_defined_QMARK] = ACTIONS(2468),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2474),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [561] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4874),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3732),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5717),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(106),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2467),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(561),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_defined_QMARK] = ACTIONS(2468),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2474),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [562] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4061),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5717),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(106),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2467),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(562),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_defined_QMARK] = ACTIONS(2468),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2474),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [563] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4871),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4144),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5717),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(106),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2467),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(563),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_defined_QMARK] = ACTIONS(2468),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2474),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [564] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4691),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3219),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(564),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [565] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2707),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5571),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2098),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(565),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_defined_QMARK] = ACTIONS(443),
    [anon_sym_not] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(455),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [566] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3615),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(566),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [567] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4872),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3653),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(567),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [568] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4873),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3666),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(568),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [569] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4874),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3537),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3258),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(28),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(340),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5849),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(64),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2257),
    [sym__variable] = STATE(29),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(569),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1890),
    [anon_sym_defined_QMARK] = ACTIONS(283),
    [anon_sym_not] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(325),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [570] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2964),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(570),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [571] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2858),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(571),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [572] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4055),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5586),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(95),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(572),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [573] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2859),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(573),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [574] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(574),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [575] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2934),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2638),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(10),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(285),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5676),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(54),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2123),
    [sym__variable] = STATE(11),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(575),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(191),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_next] = ACTIONS(195),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(197),
    [anon_sym_not] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(209),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [576] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2707),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5780),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2375),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(576),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_defined_QMARK] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2356),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [577] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5780),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2375),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(577),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_defined_QMARK] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2356),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [578] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2680),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5780),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2375),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(578),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_defined_QMARK] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2356),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [579] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5780),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2375),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(579),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_defined_QMARK] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2356),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [580] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2600),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(580),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [581] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3407),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5708),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2158),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(581),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_defined_QMARK] = ACTIONS(499),
    [anon_sym_not] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(505),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(511),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [582] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3930),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(22),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5673),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(78),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2397),
    [sym__variable] = STATE(23),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(582),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_defined_QMARK] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2464),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [583] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3912),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5608),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2393),
    [sym__variable] = STATE(32),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(583),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [584] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3541),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(26),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(341),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5744),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(65),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2347),
    [sym__variable] = STATE(27),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(584),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(343),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_next] = ACTIONS(347),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1896),
    [anon_sym_defined_QMARK] = ACTIONS(349),
    [anon_sym_not] = ACTIONS(351),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(355),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(363),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [585] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2707),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5780),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2375),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(585),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_defined_QMARK] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2356),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [586] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2743),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5829),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(586),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_defined_QMARK] = ACTIONS(2438),
    [anon_sym_not] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_TILDE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2444),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [587] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(587),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [588] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2451),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(5),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(228),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5808),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(43),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2082),
    [sym__variable] = STATE(7),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(588),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(137),
    [anon_sym_break] = ACTIONS(139),
    [anon_sym_next] = ACTIONS(141),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_defined_QMARK] = ACTIONS(147),
    [anon_sym_not] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(153),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(167),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [589] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3929),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(589),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [590] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2606),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(590),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [591] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4682),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3219),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(591),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [592] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2599),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(592),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [593] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2600),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(593),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [594] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5437),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4144),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5717),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(106),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2467),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(594),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_defined_QMARK] = ACTIONS(2468),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2474),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [595] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3145),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(16),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(335),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5561),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(61),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2198),
    [sym__variable] = STATE(17),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(595),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(219),
    [anon_sym_break] = ACTIONS(221),
    [anon_sym_next] = ACTIONS(223),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1830),
    [anon_sym_defined_QMARK] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_TILDE] = ACTIONS(231),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(233),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [596] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4872),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3944),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(596),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [597] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4873),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3945),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(597),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [598] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4874),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3732),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(598),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [599] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3250),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(599),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [600] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3824),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5575),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(600),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_defined_QMARK] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2382),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [601] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4872),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3836),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5575),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(601),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_defined_QMARK] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2382),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [602] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4873),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3837),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5575),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(602),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_defined_QMARK] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2382),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [603] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4874),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3537),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5575),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(603),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_defined_QMARK] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2382),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [604] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4680),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3219),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(604),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [605] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3171),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(9),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5664),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(55),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2131),
    [sym__variable] = STATE(8),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(605),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(69),
    [anon_sym_defined_QMARK] = ACTIONS(71),
    [anon_sym_not] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [anon_sym_TILDE] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(111),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [606] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3824),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(20),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5575),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(71),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2449),
    [sym__variable] = STATE(25),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(606),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_defined_QMARK] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2382),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [607] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3912),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5608),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2393),
    [sym__variable] = STATE(32),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(607),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [608] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3871),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5608),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2393),
    [sym__variable] = STATE(32),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(608),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [609] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3874),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5608),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2393),
    [sym__variable] = STATE(32),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(609),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [610] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3575),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(31),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(355),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5608),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(68),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2393),
    [sym__variable] = STATE(32),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(610),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(545),
    [anon_sym_next] = ACTIONS(547),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_defined_QMARK] = ACTIONS(549),
    [anon_sym_not] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(555),
    [anon_sym_TILDE] = ACTIONS(555),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(561),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [611] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2743),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(3),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5851),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(44),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2093),
    [sym__variable] = STATE(2),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(611),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_defined_QMARK] = ACTIONS(661),
    [anon_sym_not] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(679),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [612] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(5415),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4144),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(41),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5717),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(106),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2467),
    [sym__variable] = STATE(40),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(612),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_defined_QMARK] = ACTIONS(2468),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2474),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [613] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3108),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5747),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(613),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_defined_QMARK] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2410),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [614] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3116),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5747),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(614),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_defined_QMARK] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2410),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [615] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3136),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5747),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(615),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_defined_QMARK] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2410),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [616] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2934),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5747),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(616),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_defined_QMARK] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2410),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [617] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4871),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3983),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(35),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(373),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5603),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(77),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2426),
    [sym__variable] = STATE(36),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(617),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(609),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_next] = ACTIONS(613),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_defined_QMARK] = ACTIONS(615),
    [anon_sym_not] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(627),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [618] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3108),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5747),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2130),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(618),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_defined_QMARK] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2410),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [619] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4911),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4055),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5586),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(95),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(619),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [620] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4872),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4057),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5586),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(95),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(620),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [621] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4873),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(4025),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5586),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(95),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(621),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [622] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return_command] = STATE(4889),
    [sym_yield_command] = STATE(4889),
    [sym_break_command] = STATE(4889),
    [sym_next_command] = STATE(4889),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__expression] = STATE(4874),
    [sym_match_pattern] = STATE(4889),
    [sym_test_pattern] = STATE(4889),
    [sym__arg] = STATE(3537),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3421),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(38),
    [sym_command_call] = STATE(4893),
    [sym_command_call_with_block] = STATE(4734),
    [sym__chained_command_call] = STATE(359),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_command_assignment] = STATE(4889),
    [sym_operator_assignment] = STATE(3342),
    [sym_command_operator_assignment] = STATE(4889),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_command_binary] = STATE(4889),
    [sym_unary] = STATE(3342),
    [sym_command_unary] = STATE(4889),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5586),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(95),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2446),
    [sym__variable] = STATE(39),
    [sym__nonlocal_variable] = STATE(1928),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(1981),
    [sym_identifier_suffix] = STATE(1980),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(622),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(577),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_next] = ACTIONS(581),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_defined_QMARK] = ACTIONS(2448),
    [anon_sym_not] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(293),
    [sym_self] = ACTIONS(293),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(293),
    [aux_sym_constant_suffix_token1] = ACTIONS(297),
    [aux_sym_identifier_suffix_token1] = ACTIONS(299),
    [sym_instance_variable] = ACTIONS(301),
    [sym_class_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2454),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(331),
    [sym__constant_suffix] = ACTIONS(297),
  },
  [623] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3108),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(623),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [624] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3116),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(624),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [625] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3136),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(625),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [626] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2707),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(626),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [627] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3407),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5593),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2165),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(627),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_defined_QMARK] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2394),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [628] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2743),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(18),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5829),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(69),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(19),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(628),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_defined_QMARK] = ACTIONS(2438),
    [anon_sym_not] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_TILDE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2444),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [629] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2707),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(629),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [630] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(630),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [631] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2680),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(631),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [632] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(3360),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(14),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(348),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5643),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(59),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2374),
    [sym__variable] = STATE(15),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(632),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(523),
    [anon_sym_next] = ACTIONS(525),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1940),
    [anon_sym_defined_QMARK] = ACTIONS(527),
    [anon_sym_not] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(535),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [633] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2707),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5562),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2097),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(633),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_defined_QMARK] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2368),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [634] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2679),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5562),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2097),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(634),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_defined_QMARK] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2368),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [635] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2680),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5562),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2097),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(635),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_defined_QMARK] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2368),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [636] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5562),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2097),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(636),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_defined_QMARK] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2368),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [637] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3407),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5593),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2165),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(637),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_defined_QMARK] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2394),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [638] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4418),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3371),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5593),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2165),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(638),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_defined_QMARK] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2394),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [639] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4444),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(3372),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5593),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2165),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(639),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_defined_QMARK] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2394),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [640] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2608),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2930),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(33),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(346),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5593),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(63),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2165),
    [sym__variable] = STATE(24),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(640),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_next] = ACTIONS(497),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_defined_QMARK] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2394),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [641] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4424),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2707),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2501),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(4),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4429),
    [sym__chained_command_call] = STATE(231),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5562),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(42),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2097),
    [sym__variable] = STATE(6),
    [sym__nonlocal_variable] = STATE(1879),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1945),
    [sym_identifier_suffix] = STATE(1944),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(641),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_next] = ACTIONS(441),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_defined_QMARK] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(155),
    [sym_self] = ACTIONS(155),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(155),
    [aux_sym_constant_suffix_token1] = ACTIONS(157),
    [aux_sym_identifier_suffix_token1] = ACTIONS(159),
    [sym_instance_variable] = ACTIONS(161),
    [sym_class_variable] = ACTIONS(161),
    [sym_global_variable] = ACTIONS(161),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2368),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(173),
    [sym__constant_suffix] = ACTIONS(157),
  },
  [642] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return_command] = STATE(4438),
    [sym_yield_command] = STATE(4438),
    [sym_break_command] = STATE(4438),
    [sym_next_command] = STATE(4438),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__expression] = STATE(4440),
    [sym_match_pattern] = STATE(4438),
    [sym_test_pattern] = STATE(4438),
    [sym__arg] = STATE(2934),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2780),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(12),
    [sym_command_call] = STATE(4425),
    [sym_command_call_with_block] = STATE(4529),
    [sym__chained_command_call] = STATE(303),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_command_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(2473),
    [sym_command_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_command_binary] = STATE(4438),
    [sym_unary] = STATE(2473),
    [sym_command_unary] = STATE(4438),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5630),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(53),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2133),
    [sym__variable] = STATE(13),
    [sym__nonlocal_variable] = STATE(1895),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(1960),
    [sym_identifier_suffix] = STATE(1961),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(642),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_next] = ACTIONS(45),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1583),
    [anon_sym_defined_QMARK] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(469),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(9),
    [sym_self] = ACTIONS(9),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(9),
    [aux_sym_constant_suffix_token1] = ACTIONS(87),
    [aux_sym_identifier_suffix_token1] = ACTIONS(89),
    [sym_instance_variable] = ACTIONS(91),
    [sym_class_variable] = ACTIONS(91),
    [sym_global_variable] = ACTIONS(91),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(479),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(117),
    [sym__constant_suffix] = ACTIONS(87),
  },
  [643] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__hash_pattern_body] = STATE(5850),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5458),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3481),
    [sym_identifier_suffix] = STATE(3482),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3483),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(643),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5458),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2476),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [644] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__hash_pattern_body] = STATE(5701),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5458),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3481),
    [sym_identifier_suffix] = STATE(3482),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3483),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(644),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5458),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2476),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [645] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__hash_pattern_body] = STATE(5850),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5425),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3481),
    [sym_identifier_suffix] = STATE(3482),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3483),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(645),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5425),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2476),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [646] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__hash_pattern_body] = STATE(5701),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5425),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3481),
    [sym_identifier_suffix] = STATE(3482),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3483),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(646),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5425),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2476),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [647] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__hash_pattern_body] = STATE(5701),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5458),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3481),
    [sym_identifier_suffix] = STATE(3482),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3483),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(647),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5458),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2476),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [648] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3114),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(648),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(2310),
    [anon_sym___END__] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2310),
    [sym__no_line_break] = ACTIONS(2416),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [649] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3118),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(649),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(2418),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(2418),
    [anon_sym___END__] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2418),
    [sym__no_line_break] = ACTIONS(2422),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [650] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3349),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(650),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(2418),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(2418),
    [anon_sym___END__] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2418),
    [sym__no_line_break] = ACTIONS(2422),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [651] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3350),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(651),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(2310),
    [anon_sym___END__] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2310),
    [sym__no_line_break] = ACTIONS(2416),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [652] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3154),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(652),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(2424),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(2424),
    [anon_sym___END__] = ACTIONS(2426),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2424),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [653] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_then] = STATE(5360),
    [sym_begin] = STATE(2259),
    [sym_exceptions] = STATE(4968),
    [sym_exception_variable] = STATE(5192),
    [sym__arg] = STATE(3910),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(5151),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(653),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym__terminator] = STATE(260),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_then] = ACTIONS(2490),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(753),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2492),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [654] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2856),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(654),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(2432),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(2432),
    [anon_sym___END__] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2434),
    [anon_sym_or] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2432),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [655] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3104),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(655),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(2428),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(2428),
    [anon_sym___END__] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2430),
    [anon_sym_or] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2428),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [656] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2991),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(656),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(881),
    [anon_sym___END__] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [657] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3106),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(657),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(2432),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(2432),
    [anon_sym___END__] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2434),
    [anon_sym_or] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2432),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [658] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_primitive] = STATE(4742),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3791),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3540),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2478),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3341),
    [sym_subshell] = STATE(3540),
    [sym_string_array] = STATE(3540),
    [sym_symbol_array] = STATE(3540),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3540),
    [sym_heredoc_body] = STATE(658),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3546),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(2494),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [659] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3362),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(659),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(2428),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(2428),
    [anon_sym___END__] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2430),
    [anon_sym_or] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2428),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [660] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3354),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(660),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(2424),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(2424),
    [anon_sym___END__] = ACTIONS(2426),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2424),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [661] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3157),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(661),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym_identifier] = ACTIONS(879),
    [aux_sym_program_token1] = ACTIONS(881),
    [anon_sym___END__] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [662] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3833),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(662),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_then] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2418),
    [sym__no_line_break] = ACTIONS(2422),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [663] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3834),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(663),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_then] = ACTIONS(2414),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2310),
    [sym__no_line_break] = ACTIONS(2416),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [664] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3901),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(664),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2310),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym__no_line_break] = ACTIONS(2314),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [665] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3520),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(665),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2310),
    [sym__no_line_break] = ACTIONS(2416),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [666] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3519),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(666),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2418),
    [sym__no_line_break] = ACTIONS(2422),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [667] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3900),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(667),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2418),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym__no_line_break] = ACTIONS(2496),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [668] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3992),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(668),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2418),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym__no_line_break] = ACTIONS(2496),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [669] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_primitive] = STATE(4382),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3106),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2159),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(669),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [670] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_primitive] = STATE(4382),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3870),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2159),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(670),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [671] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3899),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(671),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2430),
    [anon_sym_or] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [672] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3560),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(672),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2434),
    [anon_sym_or] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [673] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_primitive] = STATE(4742),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3573),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3222),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2373),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2836),
    [sym_subshell] = STATE(3222),
    [sym_string_array] = STATE(3222),
    [sym_symbol_array] = STATE(3222),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3222),
    [sym_heredoc_body] = STATE(673),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3225),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1654),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [674] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3993),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(674),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2310),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym__no_line_break] = ACTIONS(2314),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [675] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3916),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(675),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_then] = ACTIONS(2426),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2424),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [676] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3920),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(676),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_then] = ACTIONS(2430),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2430),
    [anon_sym_or] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2428),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [677] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_primitive] = STATE(4382),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2598),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2159),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(677),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [678] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_primitive] = STATE(4382),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3622),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2159),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(678),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [679] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3622),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(679),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_then] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2434),
    [anon_sym_or] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2432),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [680] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4053),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(680),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_then] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2418),
    [sym__no_line_break] = ACTIONS(2422),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [681] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_primitive] = STATE(4742),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(3052),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2191),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2735),
    [sym_subshell] = STATE(3052),
    [sym_string_array] = STATE(3052),
    [sym_symbol_array] = STATE(3052),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(3052),
    [sym_heredoc_body] = STATE(681),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(3056),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(2498),
    [sym_true] = ACTIONS(673),
    [sym_false] = ACTIONS(673),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(677),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [682] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_primitive] = STATE(4382),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3791),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(3074),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2195),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2757),
    [sym_subshell] = STATE(3074),
    [sym_string_array] = STATE(3074),
    [sym_symbol_array] = STATE(3074),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(3074),
    [sym_heredoc_body] = STATE(682),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3070),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1794),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1796),
    [sym_true] = ACTIONS(1798),
    [sym_false] = ACTIONS(1798),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1802),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(1804),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [683] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3516),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(683),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2424),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [684] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3517),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(684),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2430),
    [anon_sym_or] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2428),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [685] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3400),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(685),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [686] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3370),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(686),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_rescue] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2434),
    [anon_sym_or] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2432),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [687] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3552),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(687),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [688] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_primitive] = STATE(4742),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3560),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3222),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2373),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2836),
    [sym_subshell] = STATE(3222),
    [sym_string_array] = STATE(3222),
    [sym_symbol_array] = STATE(3222),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3222),
    [sym_heredoc_body] = STATE(688),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3225),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1654),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [689] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_primitive] = STATE(4382),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3370),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2159),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(689),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [690] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3643),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(690),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [691] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3940),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(691),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2418),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym__no_line_break] = ACTIONS(2496),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [692] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3941),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(692),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2310),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym__no_line_break] = ACTIONS(2314),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [693] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_primitive] = STATE(4742),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3785),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3222),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2373),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2836),
    [sym_subshell] = STATE(3222),
    [sym_string_array] = STATE(3222),
    [sym_symbol_array] = STATE(3222),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3222),
    [sym_heredoc_body] = STATE(693),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3225),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1654),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [694] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_primitive] = STATE(4742),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3791),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3222),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2373),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2836),
    [sym_subshell] = STATE(3222),
    [sym_string_array] = STATE(3222),
    [sym_symbol_array] = STATE(3222),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3222),
    [sym_heredoc_body] = STATE(694),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3225),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1648),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1654),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [695] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_primitive] = STATE(4382),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2678),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2159),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(695),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [696] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3898),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(696),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [697] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4056),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(697),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_then] = ACTIONS(2414),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2310),
    [sym__no_line_break] = ACTIONS(2416),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [698] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym__pattern_primitive] = STATE(4382),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2856),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2220),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2054),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2159),
    [sym_subshell] = STATE(2220),
    [sym_string_array] = STATE(2220),
    [sym_symbol_array] = STATE(2220),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2220),
    [sym_heredoc_body] = STATE(698),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2241),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(1696),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1702),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [699] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym__pattern_primitive] = STATE(4742),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3791),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(3540),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2478),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3341),
    [sym_subshell] = STATE(3540),
    [sym_string_array] = STATE(3540),
    [sym_symbol_array] = STATE(3540),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(3540),
    [sym_heredoc_body] = STATE(699),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(3546),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(2494),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(713),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [700] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3785),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(700),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2434),
    [anon_sym_or] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [701] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3990),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(701),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2430),
    [anon_sym_or] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [702] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3573),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(702),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2434),
    [anon_sym_or] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [703] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4088),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(703),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2418),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym__no_line_break] = ACTIONS(2496),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [704] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3870),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(704),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_then] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2434),
    [anon_sym_or] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2432),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [705] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3989),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(705),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [706] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3938),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(706),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [707] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3827),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(707),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [708] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3820),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(708),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [709] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4005),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(709),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_then] = ACTIONS(2426),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2424),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [710] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4094),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(710),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2310),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2414),
    [anon_sym_or] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym__no_line_break] = ACTIONS(2314),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [711] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3649),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(711),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_rescue] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [712] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3939),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(712),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2430),
    [anon_sym_or] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [713] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4006),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(713),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_then] = ACTIONS(2430),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_and] = ACTIONS(2430),
    [anon_sym_or] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2428),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [714] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5499),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3501),
    [sym_identifier_suffix] = STATE(3504),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(714),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5499),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2500),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [715] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5425),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3501),
    [sym_identifier_suffix] = STATE(3504),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(715),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5425),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2504),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2500),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [716] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5438),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3501),
    [sym_identifier_suffix] = STATE(3504),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(716),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5438),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2500),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [717] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3808),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(717),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [718] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4001),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(718),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2310),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym__no_line_break] = ACTIONS(2314),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [719] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5499),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3501),
    [sym_identifier_suffix] = STATE(3504),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(719),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5499),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2500),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [720] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5499),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3501),
    [sym_identifier_suffix] = STATE(3504),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(720),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5499),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2510),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2500),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [721] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4125),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(721),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2426),
    [anon_sym_or] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [722] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3791),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(722),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2434),
    [anon_sym_or] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [723] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5499),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3501),
    [sym_identifier_suffix] = STATE(3504),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(723),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5499),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2500),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [724] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4000),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(724),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2418),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2418),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym__no_line_break] = ACTIONS(2496),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [725] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5458),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3501),
    [sym_identifier_suffix] = STATE(3504),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(725),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5458),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2514),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2500),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [726] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5499),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3501),
    [sym_identifier_suffix] = STATE(3504),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(726),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5499),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2500),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [727] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4096),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(727),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_and] = ACTIONS(2430),
    [anon_sym_or] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [728] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3932),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(728),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_then] = ACTIONS(883),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(881),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [729] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5499),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3501),
    [sym_identifier_suffix] = STATE(3504),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(729),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5499),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2518),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2500),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [730] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3080),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3076),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(730),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2358),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [731] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2816),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2821),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(731),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2520),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [732] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4003),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(4099),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(732),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2522),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [733] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2595),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2593),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(733),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2524),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [734] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2893),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3420),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3533),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(2893),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(734),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2526),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [735] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2455),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2460),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(735),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2528),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [736] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2893),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3159),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3298),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(2893),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(736),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2526),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [737] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2387),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2396),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(737),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2530),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [738] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2893),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3119),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3255),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(2893),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(738),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2532),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [739] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3439),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3479),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(739),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2346),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [740] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2893),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3669),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3733),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(2893),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(740),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2534),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [741] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3223),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3324),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(741),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2536),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [742] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2893),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3670),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3665),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(2893),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(742),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2538),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [743] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3224),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3378),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(743),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2536),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [744] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2893),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3671),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3704),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(2893),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(744),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2534),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [745] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3453),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3528),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(745),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2540),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [746] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3066),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3163),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(746),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2542),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [747] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2670),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2634),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(747),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2344),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [748] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3987),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3995),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(748),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2544),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [749] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3913),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3848),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(749),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2398),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [750] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3236),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3256),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(750),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2392),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [751] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2893),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3155),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3151),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(2893),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(751),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2546),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [752] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3037),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3064),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(752),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2358),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [753] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3997),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(753),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [754] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3830),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3924),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(754),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2380),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [755] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3508),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3547),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(755),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2400),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [756] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3518),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3614),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(756),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2380),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [757] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4004),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3998),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(757),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2544),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [758] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3896),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3946),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(758),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2548),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [759] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3598),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3810),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(759),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2396),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [760] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2794),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2796),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(760),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2342),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [761] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3509),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3480),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(761),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [762] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3652),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3743),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(762),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2396),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [763] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4282),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_hash_splat_argument] = STATE(5499),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(3501),
    [sym_identifier_suffix] = STATE(3504),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3141),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(763),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_pair] = STATE(5499),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(2500),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym_hash_key_symbol] = ACTIONS(721),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
    [sym__hash_splat_star_star] = ACTIONS(723),
  },
  [764] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2664),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2656),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(764),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2344),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [765] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2469),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2457),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(765),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2528),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [766] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2893),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3107),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3095),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(2893),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(766),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2550),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [767] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3532),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3499),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(767),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2398),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [768] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3343),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3996),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(4100),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(3343),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(768),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2522),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [769] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2695),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2687),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(769),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2552),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [770] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2893),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3417),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3465),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(2893),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(770),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2546),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [771] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3302),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3305),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(771),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2392),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [772] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2793),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2808),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(772),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2520),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [773] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3882),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3984),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(773),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2548),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [774] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3472),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(3524),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(774),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2540),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [775] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2893),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3663),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3616),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_right_assignment_list] = STATE(2893),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(775),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2538),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [776] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2286),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2684),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2706),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2286),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(776),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2552),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [777] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2472),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2532),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2578),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_right_assignment_list] = STATE(2472),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(777),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2370),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [778] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4108),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(778),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [779] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4130),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(779),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym__line_break] = ACTIONS(2554),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [780] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_pattern] = STATE(4997),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3999),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(5357),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(780),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2492),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [781] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4106),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(781),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [782] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_pattern] = STATE(5281),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3999),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(5357),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(782),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2492),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [783] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4195),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(783),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2554),
    [anon_sym_PIPE] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [784] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4142),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(784),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [785] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3088),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2474),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(785),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2358),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [786] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3325),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2474),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(786),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2392),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [787] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3964),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(5221),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(787),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2492),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [788] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3213),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(2975),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(788),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2546),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [789] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2484),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2303),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(789),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2528),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [790] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3740),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3352),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(790),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2400),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [791] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4168),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(791),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_COMMA] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [792] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3769),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(2975),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(792),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2538),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [793] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3418),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2303),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(793),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2536),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [794] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2774),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2303),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(794),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2552),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [795] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3839),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2474),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(795),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2396),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [796] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3344),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(2975),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(796),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2526),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [797] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3569),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2303),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(797),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2540),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [798] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3673),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2474),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(798),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2346),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [799] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2618),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2474),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(799),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2370),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [800] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4174),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3352),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(800),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2522),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [801] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3823),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(2975),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(801),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2534),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [802] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2852),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2474),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(802),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2342),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [803] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3303),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2303),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(803),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2542),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [804] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2429),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2303),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(804),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2530),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [805] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2997),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2303),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(805),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2520),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [806] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4060),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3352),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(806),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2544),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [807] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3402),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(2975),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(807),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2532),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [808] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2686),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2474),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(808),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2344),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [809] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3251),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(2975),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(809),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2550),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [810] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3631),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3352),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(810),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2412),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [811] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3642),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3352),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(811),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2398),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [812] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4050),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2474),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(812),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2548),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [813] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2673),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_splat_argument] = STATE(2303),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(813),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__splat_star] = ACTIONS(2524),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [814] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3692),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_splat_argument] = STATE(3352),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(814),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__splat_star] = ACTIONS(2380),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [815] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3877),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(815),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [816] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4019),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(816),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [817] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3466),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(817),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [818] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3010),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3562),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(818),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [819] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3299),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(819),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [820] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2441),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(820),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [821] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2493),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(821),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [822] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3148),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(822),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [823] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2485),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(823),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [824] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2693),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(824),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [825] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3010),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3659),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(825),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [826] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2779),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(826),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [827] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3180),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(827),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [828] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(5330),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3923),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(828),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [829] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4126),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(829),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [830] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4045),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(830),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [831] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2898),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(831),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [832] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3322),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(832),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [833] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2433),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(833),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [834] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3544),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(834),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [835] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4081),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(835),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [836] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3128),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(836),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [837] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3859),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(837),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [838] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3273),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(838),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [839] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3485),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(839),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [840] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2674),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(840),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [841] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4179),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(841),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [842] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3812),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(842),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [843] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2627),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(843),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [844] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3558),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(844),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [845] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3010),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3909),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(845),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [846] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3010),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3259),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(846),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [847] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3534),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(847),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [848] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3413),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(848),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [849] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2518),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(849),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [850] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3781),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(850),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [851] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3081),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(851),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [852] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3248),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(852),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [853] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2636),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(853),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [854] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3539),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(854),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [855] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2917),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(855),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [856] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3010),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3203),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(856),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [857] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3640),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(857),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [858] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3510),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(858),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [859] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4176),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(859),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [860] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3393),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(860),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [861] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3366),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(861),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [862] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3010),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3172),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(862),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [863] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(2894),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3841),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(863),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [864] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2920),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(864),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [865] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2813),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(865),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [866] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3969),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(866),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [867] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3668),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(867),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [868] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3525),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(868),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [869] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3010),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3783),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(869),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [870] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3010),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3911),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(870),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [871] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2564),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(871),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [872] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3010),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3231),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(872),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [873] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3581),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(873),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [874] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3568),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(874),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [875] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2233),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2802),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(875),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [876] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3208),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(876),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [877] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3749),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(877),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [878] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2716),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(878),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [879] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3050),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(879),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [880] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3137),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(880),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [881] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3347),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3988),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(881),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [882] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2287),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2762),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(882),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [883] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_rescue_modifier_arg] = STATE(2468),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3462),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(883),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [884] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_rescue_modifier_arg] = STATE(3010),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3694),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(884),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [885] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3024),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(885),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [886] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4263),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(886),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [887] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4062),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(887),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [888] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4063),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(888),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [889] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4064),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(889),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [890] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4065),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(890),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [891] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4067),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(891),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [892] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4068),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(892),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [893] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4069),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(893),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [894] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4070),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(894),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [895] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4071),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(895),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [896] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4072),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(896),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [897] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4074),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(897),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [898] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4128),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(898),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [899] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4104),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(899),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [900] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3776),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(900),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [901] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4205),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(901),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [902] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4075),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(902),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [903] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3292),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(903),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [904] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3447),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(904),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [905] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3306),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(905),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [906] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3113),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(906),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [907] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3106),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(907),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [908] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3113),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(908),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [909] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2738),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(909),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [910] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2740),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(910),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [911] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(911),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [912] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2728),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(912),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [913] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2732),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(913),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [914] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2771),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(914),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [915] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2731),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(915),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [916] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2734),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(916),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [917] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2741),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(917),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [918] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2760),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(918),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [919] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2765),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(919),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [920] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2777),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(920),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [921] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2717),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(921),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [922] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2742),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(922),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [923] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4088),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(923),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [924] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4170),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(924),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [925] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2781),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(925),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [926] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2825),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(926),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [927] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2828),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(927),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [928] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4107),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(928),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [929] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3776),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(929),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [930] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3791),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(930),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [931] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4120),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(931),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [932] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3776),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(932),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [933] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3788),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(933),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [934] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3789),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(934),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [935] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3353),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(935),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [936] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3168),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(936),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [937] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3792),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(937),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [938] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3796),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(938),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [939] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3797),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(939),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [940] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3798),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(940),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [941] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3800),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(941),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [942] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3801),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(942),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [943] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3803),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(943),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [944] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3804),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(944),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [945] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3695),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(945),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [946] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3697),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(946),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [947] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3698),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(947),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [948] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3723),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(948),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [949] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3118),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(949),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [950] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3736),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(950),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [951] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3937),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(951),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [952] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3737),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(952),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [953] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3915),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(953),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [954] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3864),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(954),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [955] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3865),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(955),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [956] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(956),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [957] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4107),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(957),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [958] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4078),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(958),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [959] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4079),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(959),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [960] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3918),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(960),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [961] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3873),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(961),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [962] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3825),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(962),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [963] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3826),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(963),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [964] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3353),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(964),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [965] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3828),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(965),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [966] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3831),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(966),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [967] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3868),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(967),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [968] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3842),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(968),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [969] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3843),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(969),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [970] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3846),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(970),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [971] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3847),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(971),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [972] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3849),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(972),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [973] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3833),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(973),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [974] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3891),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(974),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [975] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4018),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(975),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [976] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3844),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(976),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [977] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4042),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(977),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [978] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4020),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(978),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [979] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4021),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(979),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [980] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3353),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(980),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [981] = {
    [sym_heredoc_body] = STATE(981),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2558),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [982] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4007),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(982),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [983] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4008),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(983),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [984] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4009),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(984),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [985] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4010),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(985),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [986] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4011),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(986),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [987] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4012),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(987),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [988] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4013),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(988),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [989] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4014),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(989),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [990] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4015),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(990),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [991] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4016),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(991),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [992] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4017),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(992),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [993] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3182),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(993),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [994] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3183),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(994),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [995] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3184),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(995),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [996] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4024),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(996),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [997] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3897),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(997),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [998] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4048),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(998),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [999] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4175),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(999),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1000] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4155),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1000),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1001] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4156),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1001),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1002] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3353),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1002),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1003] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4185),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1003),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1004] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4186),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1004),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1005] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4187),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1005),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1006] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4188),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1006),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1007] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4189),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1007),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1008] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4190),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1008),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1009] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4193),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1009),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1010] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4171),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1010),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1011] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4148),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1011),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1012] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4149),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1012),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1013] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4151),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1013),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1014] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4161),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1014),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1015] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4147),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1015),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1016] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3185),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1016),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1017] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3187),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1017),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1018] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3188),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1018),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1019] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4131),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1019),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1020] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4132),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1020),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1021] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4133),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1021),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1022] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4059),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1022),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1023] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4226),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1023),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1024] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4136),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1024),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1025] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4137),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1025),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1026] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4109),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1026),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1027] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4111),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1027),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1028] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4129),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1028),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1029] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4116),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1029),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1030] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4117),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1030),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1031] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3190),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1031),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1032] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3191),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1032),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1033] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3455),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1033),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1034] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3192),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1034),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1035] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3475),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1035),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1036] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3455),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1036),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1037] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3146),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1037),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1038] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3147),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1038),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1039] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1039),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1040] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4085),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1040),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1041] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3193),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1041),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1042] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3349),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1042),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1043] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3086),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1043),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1044] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3089),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1044),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1045] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3092),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1045),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1046] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3105),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1046),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1047] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3084),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1047),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1048] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3110),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1048),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1049] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3133),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1049),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1050] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3139),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1050),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1051] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3144),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1051),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1052] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3153),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1052),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1053] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3156),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1053),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1054] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3940),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1054),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1055] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4194),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1055),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1056] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4127),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1056),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1057] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3212),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1057),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1058] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3097),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1058),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1059] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3328),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1059),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1060] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2739),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1060),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1061] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3784),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1061),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1062] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3785),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1062),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1063] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4244),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1063),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1064] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4274),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1064),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1065] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4275),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1065),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1066] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3353),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1066),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1067] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3793),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1067),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1068] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3813),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1068),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1069] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3814),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1069),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1070] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3815),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1070),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1071] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3753),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1071),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1072] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3756),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1072),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1073] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3766),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1073),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1074] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3775),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1074),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1075] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3816),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1075),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1076] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3763),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1076),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1077] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3730),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1077),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1078] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3734),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1078),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1079] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2724),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1079),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1080] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3696),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1080),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1081] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4308),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1081),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1082] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3731),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1082),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1083] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4066),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1083),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1084] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4122),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1084),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1085] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4124),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1085),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1086] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1086),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1087] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4082),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1087),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1088] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4083),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1088),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1089] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4084),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1089),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1090] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4087),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1090),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1091] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4089),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1091),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1092] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4090),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1092),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1093] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4143),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1093),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1094] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4091),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1094),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1095] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4092),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1095),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1096] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4093),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1096),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1097] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4095),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1097),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1098] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4114),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1098),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1099] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4138),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1099),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1100] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3832),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1100),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1101] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3512),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1101),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1102] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3597),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1102),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1103] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3647),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1103),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1104] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3648),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1104),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1105] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(2888),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1105),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1106] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3611),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1106),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1107] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3612),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1107),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1108] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3613),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1108),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1109] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3617),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1109),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1110] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3619),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1110),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1111] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3620),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1111),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1112] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3651),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1112),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1113] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3625),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1113),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1114] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3626),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1114),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1115] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3627),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1115),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1116] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3628),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1116),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1117] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3639),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1117),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1118] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3657),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1118),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1119] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4164),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1119),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1120] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3564),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1120),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1121] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3855),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1121),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1122] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3905),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1122),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1123] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3845),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1123),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1124] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(2888),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1124),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1125] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3861),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1125),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1126] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3862),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1126),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1127] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3863),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1127),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1128] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3872),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1128),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1129] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3879),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1129),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1130] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3886),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1130),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1131] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3887),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1131),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1132] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3888),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1132),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1133] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3890),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1133),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1134] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3893),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1134),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1135] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3914),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1135),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1136] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3876),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1136),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1137] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3851),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1137),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1138] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2966),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1138),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1139] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2856),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1139),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1140] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2966),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1140),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1141] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3458),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1141),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1142] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3459),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1142),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1143] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1143),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1144] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3428),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1144),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1145] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3429),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1145),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1146] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3430),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1146),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1147] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3431),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1147),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1148] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3432),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1148),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1149] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3433),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1149),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1150] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3434),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1150),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1151] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3435),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1151),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1152] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3436),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1152),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1153] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3437),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1153),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1154] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3438),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1154),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1155] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3992),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1155),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1156] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3463),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1156),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1157] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3543),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1157),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1158] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3162),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5609),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2129),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1158),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1614),
    [anon_sym_defined_QMARK] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1622),
    [anon_sym_TILDE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1585),
    [sym__unary_minus_num] = ACTIONS(481),
    [sym__binary_minus] = ACTIONS(1585),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1159] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4102),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1159),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1160] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4244),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1160),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1161] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4245),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1161),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1162] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4086),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1162),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1163] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4115),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1163),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1164] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3784),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1164),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1165] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3744),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1165),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1166] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3745),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1166),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1167] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3353),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1167),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1168] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4227),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1168),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1169] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4232),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1169),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1170] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4222),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1170),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1171] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4231),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1171),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1172] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4241),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1172),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1173] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4243),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1173),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1174] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4248),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1174),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1175] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4310),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1175),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1176] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4217),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1176),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1177] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4220),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1177),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1178] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4221),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1178),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1179] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4223),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1179),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1180] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2668),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1180),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1181] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4253),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1181),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1182] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3994),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1182),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1183] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3605),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1183),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1184] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3592),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1184),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1185] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3593),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1185),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1186] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1186),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1187] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3576),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1187),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1188] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3577),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1188),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1189] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3578),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1189),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1190] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3579),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1190),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1191] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3580),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1191),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1192] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3582),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1192),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1193] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3583),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1193),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1194] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3584),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1194),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1195] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3585),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1195),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1196] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3586),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1196),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1197] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3587),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1197),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1198] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3596),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1198),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1199] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4073),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1199),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1200] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3234),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1200),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1201] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3293),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1201),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1202] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3294),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1202),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1203] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(2888),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1203),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1204] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3237),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1204),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1205] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3238),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1205),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1206] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3239),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1206),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1207] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3240),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1207),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1208] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3241),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1208),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1209] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3242),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1209),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1210] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3243),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1210),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1211] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3244),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1211),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1212] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3245),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1212),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1213] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3246),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1213),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1214] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3247),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1214),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1215] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3297),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1215),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1216] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3300),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1216),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1217] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3768),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1217),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1218] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3777),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1218),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1219] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3778),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1219),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1220] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(2888),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1220),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1221] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3764),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1221),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1222] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3693),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1222),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1223] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3700),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1223),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1224] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3701),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1224),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1225] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3702),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1225),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1226] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3703),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1226),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1227] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3705),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1227),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1228] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3707),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1228),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1229] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3708),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1229),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1230] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3724),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1230),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1231] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3728),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1231),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1232] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3782),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1232),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1233] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3790),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1233),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1234] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3931),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1234),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1235] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2678),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1235),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1236] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2787),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1236),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1237] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2861),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1237),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1238] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2863),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1238),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1239] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1239),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1240] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3017),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1240),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1241] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3018),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1241),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1242] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3020),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1242),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1243] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3021),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1243),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1244] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3028),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1244),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1245] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3033),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1245),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1246] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3034),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1246),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1247] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3013),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1247),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1248] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2850),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1248),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1249] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2868),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1249),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1250] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3900),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1250),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1251] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2942),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1251),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1252] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3125),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1252),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1253] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5811),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2164),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1253),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2070),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2074),
    [anon_sym_defined_QMARK] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2084),
    [sym__unary_minus_num] = ACTIONS(2086),
    [sym__binary_minus] = ACTIONS(2084),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1254] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3571),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1254),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1255] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3573),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1255),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1256] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4169),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1256),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1257] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4162),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1257),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1258] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4163),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1258),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1259] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3353),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1259),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1260] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4182),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1260),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1261] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4184),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1261),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1262] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4192),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1262),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1263] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4150),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1263),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1264] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4153),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1264),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1265] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4154),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1265),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1266] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4160),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1266),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1267] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4165),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1267),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1268] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4166),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1268),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1269] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4167),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1269),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1270] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4196),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1270),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1271] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4181),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1271),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1272] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3329),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1272),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1273] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3490),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1273),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1274] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3523),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1274),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1275] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3527),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1275),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1276] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1276),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1277] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3513),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1277),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1278] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3514),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1278),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1279] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3515),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1279),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1280] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3488),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1280),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1281] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3489),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1281),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1282] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3492),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1282),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1283] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3494),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1283),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1284] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3496),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1284),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1285] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3497),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1285),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1286] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3500),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1286),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1287] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3511),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1287),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1288] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3487),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1288),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1289] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3441),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1289),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1290] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3559),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1290),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1291] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3551),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1291),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1292] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3553),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1292),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1293] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3353),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1293),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1294] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3601),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1294),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1295] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3602),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1295),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1296] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3603),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1296),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1297] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3604),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1297),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1298] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3608),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1298),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1299] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3609),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1299),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1300] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3610),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1300),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1301] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3623),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1301),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1302] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3629),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1302),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1303] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3645),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1303),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1304] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3646),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1304),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1305] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3550),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1305),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1306] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3667),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1306),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1307] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3915),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1307),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1308] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2598),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1308),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1309] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2818),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1309),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1310] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2819),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1310),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1311] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1311),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1312] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2676),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1312),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1313] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2677),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1313),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1314] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2681),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1314),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1315] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2697),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1315),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1316] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2698),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1316),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1317] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2700),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1317),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1318] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2699),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1318),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1319] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2688),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1319),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1320] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2689),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1320),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1321] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2701),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1321),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1322] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2704),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1322),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1323] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2703),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1323),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1324] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2749),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1324),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1325] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2945),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5589),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2122),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1325),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1461),
    [sym__unary_minus_num] = ACTIONS(211),
    [sym__binary_minus] = ACTIONS(1461),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1326] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4042),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1326),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1327] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4047),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5596),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2443),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1327),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2182),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_defined_QMARK] = ACTIONS(2186),
    [anon_sym_not] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2192),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2194),
    [sym__unary_minus_num] = ACTIONS(2196),
    [sym__binary_minus] = ACTIONS(2194),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1328] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3742),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1328),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1329] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3758),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1329),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1330] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3759),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1330),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1331] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(2888),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1331),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1332] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3805),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1332),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1333] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3727),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1333),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1334] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3729),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1334),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1335] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3752),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1335),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1336] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3754),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1336),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1337] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3755),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1337),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1338] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3762),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1338),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1339] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3767),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1339),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1340] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3721),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1340),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1341] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3722),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1341),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1342] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3726),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1342),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1343] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3750),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1343),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1344] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3772),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1344),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1345] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3699),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1345),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1346] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3426),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1346),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1347] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3467),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1347),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1348] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3468),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1348),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1349] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1349),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1350] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3442),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1350),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1351] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3443),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1351),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1352] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3444),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1352),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1353] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3445),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1353),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1354] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3446),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1354),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1355] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3412),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1355),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1356] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3478),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1356),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1357] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3449),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1357),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1358] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3450),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1358),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1359] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3451),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1359),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1360] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3452),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1360),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1361] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3471),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1361),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1362] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3599),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1362),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1363] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3261),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1363),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1364] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3175),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1364),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1365] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3176),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1365),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1366] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(2888),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1366),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1367] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3263),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1367),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1368] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3264),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1368),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1369] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3265),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1369),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1370] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3266),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1370),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1371] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3267),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1371),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1372] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3268),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1372),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1373] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3269),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1373),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1374] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3270),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1374),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1375] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3271),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1375),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1376] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3272),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1376),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1377] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3166),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1377),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1378] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3179),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1378),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1379] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3181),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1379),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1380] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2787),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1380),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1381] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3961),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1381),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1382] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2607),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1382),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1383] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2705),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1383),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1384] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2696),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1384),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1385] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1385),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1386] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2612),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1386),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1387] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2592),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1387),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1388] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2610),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1388),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1389] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2594),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1389),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1390] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2630),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1390),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1391] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2609),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1391),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1392] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2632),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1392),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1393] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2619),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1393),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1394] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2620),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1394),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1395] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2621),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1395),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1396] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2622),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1396),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1397] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2628),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1397),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1398] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2637),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1398),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1399] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2585),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1399),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1400] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3931),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1400),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1401] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3597),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1401),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1402] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3600),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5741),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2436),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1402),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1906),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1908),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1910),
    [anon_sym_defined_QMARK] = ACTIONS(1912),
    [anon_sym_not] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1920),
    [sym__unary_minus_num] = ACTIONS(1922),
    [sym__binary_minus] = ACTIONS(1920),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1403] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3326),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1403),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1404] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3395),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1404),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1405] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3396),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1405),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1406] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(2888),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1406),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1407] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3357),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1407),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1408] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3361),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1408),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1409] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3369),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1409),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1410] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3373),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1410),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1411] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3374),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1411),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1412] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3376),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1412),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1413] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3377),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1413),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1414] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3390),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1414),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1415] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3391),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1415),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1416] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3392),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1416),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1417] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3394),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1417),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1418] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3980),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1418),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1419] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3981),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1419),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1420] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1420),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1421] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3399),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1421),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1422] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4271),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1422),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1423] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3806),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1423),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1424] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3818),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1424),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1425] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3819),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1425),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1426] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1426),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1427] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3710),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1427),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1428] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3711),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1428),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1429] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3712),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1429),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1430] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3713),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1430),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1431] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3714),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1431),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1432] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3715),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1432),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1433] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3716),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1433),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1434] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3717),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1434),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1435] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3718),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1435),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1436] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3719),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1436),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1437] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3720),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1437),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1438] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3751),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1438),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1439] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3709),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1439),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1440] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4066),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1440),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1441] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3870),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1441),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1442] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2730),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1442),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1443] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2623),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1443),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1444] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2624),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1444),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1445] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1445),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1446] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2786),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1446),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1447] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2795),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1447),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1448] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2800),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1448),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1449] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2801),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1449),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1450] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2830),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1450),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1451] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2805),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1451),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1452] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2826),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1452),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1453] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2829),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1453),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1454] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2803),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1454),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1455] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2789),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1455),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1456] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2812),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1456),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1457] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2790),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1457),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1458] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2710),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1458),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1459] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3234),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1459),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1460] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3235),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5615),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2258),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1460),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1363),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_defined_QMARK] = ACTIONS(1377),
    [anon_sym_not] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1391),
    [sym__unary_minus_num] = ACTIONS(1393),
    [sym__binary_minus] = ACTIONS(1391),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1461] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3315),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1461),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1462] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3401),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1462),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1463] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3308),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1463),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1464] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(2888),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1464),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1465] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3330),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1465),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1466] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3331),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1466),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1467] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3332),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1467),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1468] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3333),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1468),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1469] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3334),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1469),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1470] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3335),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1470),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1471] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3336),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1471),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1472] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3337),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1472),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1473] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3338),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1473),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1474] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3339),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1474),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1475] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3340),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1475),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1476] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3205),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1476),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1477] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3970),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1477),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1478] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3922),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1478),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1479] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3321),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1479),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1480] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3318),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1480),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1481] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3275),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1481),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1482] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3194),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1482),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1483] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3195),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1483),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1484] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1484),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1485] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3278),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1485),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1486] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3279),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1486),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1487] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3280),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1487),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1488] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3281),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1488),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1489] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3282),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1489),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1490] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3283),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1490),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1491] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3284),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1491),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1492] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3285),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1492),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1493] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3286),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1493),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1494] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3287),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1494),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1495] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3288),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1495),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1496] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3198),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1496),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1497] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3277),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1497),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1498] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3971),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1498),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1499] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2519),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1499),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1500] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2817),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5636),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2127),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1500),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1417),
    [anon_sym_not] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1425),
    [sym__unary_minus_num] = ACTIONS(1427),
    [sym__binary_minus] = ACTIONS(1425),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1501] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3065),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1501),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1502] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2536),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1502),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1503] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2538),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1503),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1504] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1504),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1505] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2520),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1505),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1506] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2521),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1506),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1507] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2522),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1507),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1508] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2523),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1508),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1509] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2524),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1509),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1510] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2525),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1510),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1511] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2526),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1511),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1512] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2527),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1512),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1513] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2528),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1513),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1514] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2529),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1514),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1515] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2531),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1515),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1516] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3972),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1516),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1517] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2543),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1517),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1518] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2631),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1518),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1519] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3559),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1519),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1520] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3560),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5622),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2263),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1520),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1888),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1766),
    [anon_sym_defined_QMARK] = ACTIONS(1768),
    [anon_sym_not] = ACTIONS(1770),
    [anon_sym_BANG] = ACTIONS(1772),
    [anon_sym_TILDE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1776),
    [sym__unary_minus_num] = ACTIONS(327),
    [sym__binary_minus] = ACTIONS(1776),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1521] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3949),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1521),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1522] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3925),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1522),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1523] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3985),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1523),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1524] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(2888),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1524),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1525] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3950),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1525),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1526] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3951),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1526),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1527] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3952),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1527),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1528] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3953),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1528),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1529] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3954),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1529),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1530] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3955),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1530),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1531] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3956),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1531),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1532] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3957),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1532),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1533] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3958),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1533),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1534] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3959),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1534),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1535] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3960),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1535),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1536] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3973),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1536),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1537] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3974),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1537),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1538] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3935),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1538),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1539] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3975),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1539),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1540] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3928),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1540),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1541] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3968),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1541),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1542] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3976),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1542),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1543] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3605),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1543),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1544] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4103),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1544),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1545] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2641),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1545),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1546] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2756),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1546),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1547] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2776),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1547),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1548] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1548),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1549] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2767),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1549),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1550] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2782),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1550),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1551] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2714),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1551),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1552] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2715),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1552),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1553] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2720),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1553),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1554] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2721),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1554),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1555] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2722),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1555),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1556] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2723),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1556),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1557] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2725),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1557),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1558] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2726),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1558),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1559] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2729),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1559),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1560] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3978),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1560),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1561] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3979),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1561),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1562] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2761),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1562),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1563] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2759),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1563),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1564] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4098),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1564),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1565] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4146),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1565),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1566] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3854),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1566),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1567] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3878),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1567),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1568] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3881),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1568),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1569] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(2888),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1569),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1570] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3880),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1570),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1571] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3889),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1571),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1572] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3892),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1572),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1573] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3894),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1573),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1574] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3895),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1574),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1575] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3902),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1575),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1576] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3903),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1576),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1577] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3904),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1577),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1578] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3906),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1578),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1579] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3907),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1579),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1580] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3908),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1580),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1581] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3982),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1581),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1582] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3885),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1582),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1583] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4183),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1583),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1584] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2730),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1584),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1585] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2566),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1585),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1586] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3043),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1586),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1587] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3044),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1587),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1588] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1588),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1589] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3072),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1589),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1590] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3075),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1590),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1591] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3078),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1591),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1592] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3079),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1592),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1593] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3082),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1593),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1594] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3057),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1594),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1595] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3038),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1595),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1596] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3039),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1596),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1597] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3040),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1597),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1598] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3041),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1598),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1599] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3042),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1599),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1600] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3051),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1600),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1601] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3062),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1601),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1602] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4175),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1602),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1603] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4177),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5726),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2488),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1603),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2264),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_defined_QMARK] = ACTIONS(2268),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2276),
    [sym__unary_minus_num] = ACTIONS(2278),
    [sym__binary_minus] = ACTIONS(2276),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1604] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3822),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1604),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1605] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4053),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5777),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2390),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1605),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2046),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1986),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1854),
    [anon_sym_defined_QMARK] = ACTIONS(1856),
    [anon_sym_not] = ACTIONS(1858),
    [anon_sym_BANG] = ACTIONS(1860),
    [anon_sym_TILDE] = ACTIONS(1860),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1862),
    [sym__unary_minus_num] = ACTIONS(563),
    [sym__binary_minus] = ACTIONS(1862),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1606] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3065),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1606),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1607] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3622),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5759),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2272),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1607),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1894),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_defined_QMARK] = ACTIONS(1712),
    [anon_sym_not] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1716),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1720),
    [sym__unary_minus_num] = ACTIONS(365),
    [sym__binary_minus] = ACTIONS(1720),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1608] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2655),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1608),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1609] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2657),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1609),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1610] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1610),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1611] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2642),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1611),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1612] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2643),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1612),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1613] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2644),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1613),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1614] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2645),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1614),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1615] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2646),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1615),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1616] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2647),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1616),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1617] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2648),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1617),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1618] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2649),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1618),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1619] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2650),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1619),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1620] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2651),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1620),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1621] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2652),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1621),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1622] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2661),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1622),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1623] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2635),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1623),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1624] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3261),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1624),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1625] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3262),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5750),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2266),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1625),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_defined_QMARK] = ACTIONS(1487),
    [anon_sym_not] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_TILDE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1495),
    [sym__unary_minus_num] = ACTIONS(1497),
    [sym__binary_minus] = ACTIONS(1495),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1626] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4000),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5768),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2372),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1626),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1974),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1976),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_defined_QMARK] = ACTIONS(1642),
    [anon_sym_not] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(719),
    [sym__unary_minus_num] = ACTIONS(629),
    [sym__binary_minus] = ACTIONS(719),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1627] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2641),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1627),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1628] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2733),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5743),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2135),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1628),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1319),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_defined_QMARK] = ACTIONS(1323),
    [anon_sym_not] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1329),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1331),
    [sym__unary_minus_num] = ACTIONS(1333),
    [sym__binary_minus] = ACTIONS(1331),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1629] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2504),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1629),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1630] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2505),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1630),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1631] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1631),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1632] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2479),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1632),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1633] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2477),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1633),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1634] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2490),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1634),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1635] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2497),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1635),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1636] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2486),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1636),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1637] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2496),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1637),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1638] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2500),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1638),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1639] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2481),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1639),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1640] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2487),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1640),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1641] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2489),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1641),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1642] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2495),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1642),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1643] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2508),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1643),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1644] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2483),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1644),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1645] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3855),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1645),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1646] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3857),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5856),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2482),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1646),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2100),
    [anon_sym_defined_QMARK] = ACTIONS(2102),
    [anon_sym_not] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2108),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2110),
    [sym__unary_minus_num] = ACTIONS(2112),
    [sym__binary_minus] = ACTIONS(2110),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1647] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2491),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1647),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1648] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3077),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5748),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2162),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1648),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1555),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1559),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_defined_QMARK] = ACTIONS(1563),
    [anon_sym_not] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1569),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1571),
    [sym__unary_minus_num] = ACTIONS(1573),
    [sym__binary_minus] = ACTIONS(1571),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1649] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2422),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1649),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1650] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2448),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1650),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1651] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1651),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1652] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2421),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1652),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1653] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2427),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1653),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1654] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2431),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1654),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1655] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2434),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1655),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1656] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2435),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1656),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1657] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2454),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1657),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1658] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2438),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1658),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1659] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2439),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1659),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1660] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2440),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1660),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1661] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2444),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1661),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1662] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2445),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1662),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1663] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2428),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1663),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1664] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2447),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1664),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1665] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4169),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1665),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1666] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4172),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5720),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2560),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1666),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_defined_QMARK] = ACTIONS(2290),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2296),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2298),
    [sym__unary_minus_num] = ACTIONS(2300),
    [sym__binary_minus] = ACTIONS(2298),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1667] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2425),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1667),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1668] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2653),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5751),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2121),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1668),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1279),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_defined_QMARK] = ACTIONS(1283),
    [anon_sym_not] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1289),
    [anon_sym_TILDE] = ACTIONS(1289),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1291),
    [sym__unary_minus_num] = ACTIONS(1293),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1669] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3742),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1669),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1670] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3761),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5786),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2466),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1670),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2028),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2030),
    [anon_sym_defined_QMARK] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2040),
    [sym__unary_minus_num] = ACTIONS(2042),
    [sym__binary_minus] = ACTIONS(2040),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1671] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3490),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1671),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1672] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2492),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1672),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1673] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3326),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1673),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1674] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3327),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5838),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2379),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1674),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1465),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1467),
    [anon_sym_defined_QMARK] = ACTIONS(1469),
    [anon_sym_not] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1477),
    [sym__unary_minus_num] = ACTIONS(1479),
    [sym__binary_minus] = ACTIONS(1477),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1675] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3426),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1675),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1676] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2423),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1676),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1677] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3315),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1677),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1678] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3316),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5563),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2369),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1678),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1587),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(1593),
    [anon_sym_not] = ACTIONS(1595),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1601),
    [sym__unary_minus_num] = ACTIONS(1603),
    [sym__binary_minus] = ACTIONS(1601),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1679] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3806),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1679),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1680] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3491),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5762),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2413),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1680),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1726),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_defined_QMARK] = ACTIONS(1730),
    [anon_sym_not] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1738),
    [sym__unary_minus_num] = ACTIONS(1740),
    [sym__binary_minus] = ACTIONS(1738),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1681] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3949),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1681),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1682] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3967),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5576),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2559),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1682),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2138),
    [anon_sym_defined_QMARK] = ACTIONS(2140),
    [anon_sym_not] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_TILDE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2148),
    [sym__unary_minus_num] = ACTIONS(2150),
    [sym__binary_minus] = ACTIONS(2148),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1683] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3275),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1683),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1684] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3427),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5766),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2419),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1684),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_defined_QMARK] = ACTIONS(1529),
    [anon_sym_not] = ACTIONS(1531),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1537),
    [sym__unary_minus_num] = ACTIONS(1539),
    [sym__binary_minus] = ACTIONS(1537),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1685] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3977),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1685),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1686] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4113),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1686),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1687] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3768),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1687),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1688] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3706),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5587),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2499),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1688),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1946),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1948),
    [anon_sym_defined_QMARK] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1964),
    [sym__unary_minus_num] = ACTIONS(1966),
    [sym__binary_minus] = ACTIONS(1964),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1689] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3966),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1689),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1690] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3807),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5771),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2471),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1690),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2000),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2002),
    [anon_sym_defined_QMARK] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2012),
    [sym__unary_minus_num] = ACTIONS(2014),
    [sym__binary_minus] = ACTIONS(2012),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1691] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3854),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1691),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1692] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3838),
    [sym__unary_minus_pow] = STATE(2972),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(2837),
    [sym_operator_assignment] = STATE(2837),
    [sym_conditional] = STATE(2837),
    [sym_range] = STATE(2837),
    [sym_binary] = STATE(2837),
    [sym_unary] = STATE(2837),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5602),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2565),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1692),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2054),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_defined_QMARK] = ACTIONS(2058),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_TILDE] = ACTIONS(2064),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2066),
    [sym__unary_minus_num] = ACTIONS(2068),
    [sym__binary_minus] = ACTIONS(2066),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1693] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3276),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5774),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2273),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1693),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_defined_QMARK] = ACTIONS(1443),
    [anon_sym_not] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1449),
    [anon_sym_TILDE] = ACTIONS(1449),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1451),
    [sym__unary_minus_num] = ACTIONS(1453),
    [sym__binary_minus] = ACTIONS(1451),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1694] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2745),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1694),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1695] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2746),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1695),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1696] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2745),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5646),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2086),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1696),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(747),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_defined_QMARK] = ACTIONS(1307),
    [anon_sym_not] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1313),
    [anon_sym_TILDE] = ACTIONS(1313),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(683),
    [sym__unary_minus_num] = ACTIONS(681),
    [sym__binary_minus] = ACTIONS(683),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1697] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4284),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1697),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1698] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3571),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1698),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1699] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3588),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1699),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1700] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3589),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1700),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1701] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3353),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1701),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1702] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3168),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1702),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1703] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2683),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1703),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1704] = {
    [sym_heredoc_body] = STATE(1704),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1705] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2607),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5697),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2067),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1705),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1035),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_defined_QMARK] = ACTIONS(1241),
    [anon_sym_not] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1039),
    [sym__unary_minus_num] = ACTIONS(169),
    [sym__binary_minus] = ACTIONS(1039),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1706] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2519),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5731),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2096),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1706),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1013),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_defined_QMARK] = ACTIONS(1017),
    [anon_sym_not] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1025),
    [sym__unary_minus_num] = ACTIONS(1027),
    [sym__binary_minus] = ACTIONS(1025),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1707] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2491),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5754),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2085),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1707),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(945),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_defined_QMARK] = ACTIONS(951),
    [anon_sym_not] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_TILDE] = ACTIONS(957),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(959),
    [sym__unary_minus_num] = ACTIONS(961),
    [sym__binary_minus] = ACTIONS(959),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1708] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2425),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2268),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5756),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2073),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1708),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(885),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_defined_QMARK] = ACTIONS(899),
    [anon_sym_not] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(905),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(913),
    [sym__unary_minus_num] = ACTIONS(915),
    [sym__binary_minus] = ACTIONS(913),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1709] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3226),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1709),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1710] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3227),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1710),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1711] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5574),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2136),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1711),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(29),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(65),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_defined_QMARK] = ACTIONS(1926),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1932),
    [anon_sym_TILDE] = ACTIONS(1932),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(115),
    [sym__unary_minus_num] = ACTIONS(113),
    [sym__binary_minus] = ACTIONS(115),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1712] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4225),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1712),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1713] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3654),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1713),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1714] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3655),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1714),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1715] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3658),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1715),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1716] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3661),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1716),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1717] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3662),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1717),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1718] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4256),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1718),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1719] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4260),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1719),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1720] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4276),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1720),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1721] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4262),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1721),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1722] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4224),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1722),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1723] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4268),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1723),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1724] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4228),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1724),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1725] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4238),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1725),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1726] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4247),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1726),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1727] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4251),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1727),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1728] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4258),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1728),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1729] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4261),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1729),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1730] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4266),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1730),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1731] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4277),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1731),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1732] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4198),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1732),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1733] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4199),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1733),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1734] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4201),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1734),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1735] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4207),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1735),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1736] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4208),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1736),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1737] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4210),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1737),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1738] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4211),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1738),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1739] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4212),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1739),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1740] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4213),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1740),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1741] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4214),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1741),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1742] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4215),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1742),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1743] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4216),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1743),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1744] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3689),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1744),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1745] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3545),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1745),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1746] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4145),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1746),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1747] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4218),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1747),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1748] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3554),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1748),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1749] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3536),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1749),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1750] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3664),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1750),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1751] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3656),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1751),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1752] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4105),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5718),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2475),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1752),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2236),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_defined_QMARK] = ACTIONS(2240),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2248),
    [sym__unary_minus_num] = ACTIONS(2250),
    [sym__binary_minus] = ACTIONS(2248),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1753] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3519),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1753),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1754] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4044),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1754),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1755] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4036),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1755),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1756] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4037),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1756),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1757] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1757),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1758] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3986),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1758),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1759] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4058),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1759),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1760] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4027),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1760),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1761] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4028),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1761),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1762] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3607),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1762),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1763] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4029),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1763),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1764] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4030),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1764),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1765] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4031),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1765),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1766] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4032),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1766),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1767] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4033),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1767),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1768] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4034),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1768),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1769] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4035),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1769),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1770] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4040),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1770),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1771] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4026),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1771),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1772] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3632),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5841),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2235),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1772),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1898),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1900),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_defined_QMARK] = ACTIONS(1820),
    [anon_sym_not] = ACTIONS(1822),
    [anon_sym_BANG] = ACTIONS(1824),
    [anon_sym_TILDE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1826),
    [sym__unary_minus_num] = ACTIONS(597),
    [sym__binary_minus] = ACTIONS(1826),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1773] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3370),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1773),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1774] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4041),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1774),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1775] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3408),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1775),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1776] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3379),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1776),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1777] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3380),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1777),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1778] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3381),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1778),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1779] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3382),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1779),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1780] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3383),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1780),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1781] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3384),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1781),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1782] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3385),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1782),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1783] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3386),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1783),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1784] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3387),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1784),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1785] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3388),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1785),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1786] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3389),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1786),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1787] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3367),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1787),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1788] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3526),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1788),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1789] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3307),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1789),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1790] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3411),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1790),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1791] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2464),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1791),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1792] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3675),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1792),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1793] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3633),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1793),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1794] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3634),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1794),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1795] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1795),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1796] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3678),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1796),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1797] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3679),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1797),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1798] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3680),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1798),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1799] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3681),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1799),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1800] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3682),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1800),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1801] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3683),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1801),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1802] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3684),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1802),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1803] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3685),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1803),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1804] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3686),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1804),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1805] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3687),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1805),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1806] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3688),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1806),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1807] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3637),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1807),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1808] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3677),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1808),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1809] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3368),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1809),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1810] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4044),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1810),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1811] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4049),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5739),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2458),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1811),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2164),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_defined_QMARK] = ACTIONS(2168),
    [anon_sym_not] = ACTIONS(2170),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2176),
    [sym__unary_minus_num] = ACTIONS(2178),
    [sym__binary_minus] = ACTIONS(2176),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1812] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2911),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1812),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1813] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2912),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2265),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1813),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1814] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2341),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1814),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1815] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2980),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1815),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1816] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2981),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1816),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1817] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2982),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1817),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1818] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2983),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1818),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1819] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2984),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1819),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1820] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2985),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1820),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1821] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2986),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1821),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1822] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2987),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1822),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1823] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2988),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1823),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1824] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2989),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1824),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1825] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2990),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1825),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1826] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2915),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1826),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1827] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2919),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1827),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1828] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2979),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1828),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1829] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2918),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1829),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1830] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3675),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1830),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1831] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3676),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5740),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2459),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1831),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1864),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1866),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1868),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1870),
    [anon_sym_defined_QMARK] = ACTIONS(1872),
    [anon_sym_not] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1878),
    [anon_sym_TILDE] = ACTIONS(1878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1880),
    [sym__unary_minus_num] = ACTIONS(1882),
    [sym__binary_minus] = ACTIONS(1880),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1832] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(3408),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5732),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2166),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1832),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1936),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_defined_QMARK] = ACTIONS(1842),
    [anon_sym_not] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1846),
    [anon_sym_TILDE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1848),
    [sym__unary_minus_num] = ACTIONS(513),
    [sym__binary_minus] = ACTIONS(1848),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1833] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2979),
    [sym__unary_minus_pow] = STATE(2349),
    [sym__primary] = STATE(2835),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2018),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2364),
    [sym_operator_assignment] = STATE(2364),
    [sym_conditional] = STATE(2364),
    [sym_range] = STATE(2364),
    [sym_binary] = STATE(2364),
    [sym_unary] = STATE(2364),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5738),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2141),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2167),
    [sym__variable] = STATE(2017),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1833),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1513),
    [sym__unary_minus_num] = ACTIONS(1515),
    [sym__binary_minus] = ACTIONS(1513),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1834] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4257),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1834),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1835] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4265),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1835),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1836] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(4097),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2289),
    [sym_left_assignment_list] = STATE(5804),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2386),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1836),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(1722),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2114),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(2118),
    [anon_sym_defined_QMARK] = ACTIONS(2120),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(2128),
    [sym__unary_minus_num] = ACTIONS(2130),
    [sym__binary_minus] = ACTIONS(2128),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1837] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4269),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1837),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1838] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4242),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1838),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1839] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4259),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1839),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1840] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4272),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1840),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1841] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4291),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1841),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1842] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4281),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1842),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1843] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4252),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1843),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1844] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4200),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1844),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1845] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4202),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1845),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1846] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4203),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1846),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1847] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4204),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1847),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1848] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4206),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1848),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1849] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4209),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1849),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1850] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4283),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5679),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2517),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1850),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2326),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_defined_QMARK] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2338),
    [sym__unary_minus_num] = ACTIONS(2340),
    [sym__binary_minus] = ACTIONS(2338),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1851] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4219),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1851),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1852] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4141),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3274),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2168),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5825),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2820),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2371),
    [sym__variable] = STATE(2169),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1852),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(1992),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(1660),
    [anon_sym_defined_QMARK] = ACTIONS(1662),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(1668),
    [sym__unary_minus_num] = ACTIONS(403),
    [sym__binary_minus] = ACTIONS(1668),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1853] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4098),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(2938),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1853),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1854] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4118),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1854),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1855] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4119),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2974),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1855),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1856] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(3353),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5695),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2494),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(3425),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1856),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(1942),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2198),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2200),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2202),
    [anon_sym_defined_QMARK] = ACTIONS(2204),
    [anon_sym_not] = ACTIONS(2206),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(291),
    [sym_float] = ACTIONS(291),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1958),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1960),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(1962),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2212),
    [sym__unary_minus_num] = ACTIONS(2214),
    [sym__binary_minus] = ACTIONS(2212),
    [sym__identifier_suffix] = ACTIONS(1968),
    [sym__constant_suffix] = ACTIONS(1958),
  },
  [1857] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4285),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1857),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1858] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4287),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1858),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1859] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4288),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1859),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1860] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4289),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1860),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1861] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4290),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1861),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1862] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4292),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1862),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1863] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4293),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1863),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1864] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4294),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1864),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1865] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4295),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1865),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1866] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4296),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1866),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1867] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4297),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1867),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1868] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4298),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1868),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1869] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4299),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1869),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1870] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4300),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1870),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1871] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4301),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1871),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1872] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4302),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1872),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1873] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4303),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1873),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1874] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4304),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1874),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1875] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4305),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1875),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1876] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4307),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1876),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1877] = {
    [sym_method] = STATE(2845),
    [sym_singleton_method] = STATE(2845),
    [sym_class] = STATE(2845),
    [sym_singleton_class] = STATE(2845),
    [sym_module] = STATE(2845),
    [sym_return] = STATE(2845),
    [sym_yield] = STATE(2845),
    [sym_break] = STATE(2845),
    [sym_next] = STATE(2845),
    [sym_redo] = STATE(2845),
    [sym_retry] = STATE(2845),
    [sym_while] = STATE(2845),
    [sym_until] = STATE(2845),
    [sym_for] = STATE(2845),
    [sym_case] = STATE(2845),
    [sym_case_match] = STATE(2845),
    [sym_if] = STATE(2845),
    [sym_unless] = STATE(2845),
    [sym_begin] = STATE(2845),
    [sym__arg] = STATE(4309),
    [sym__unary_minus_pow] = STATE(3320),
    [sym__primary] = STATE(3131),
    [sym_parenthesized_statements] = STATE(2845),
    [sym_element_reference] = STATE(2193),
    [sym_scope_resolution] = STATE(2193),
    [sym__call] = STATE(2126),
    [sym_call] = STATE(2845),
    [sym_assignment] = STATE(3342),
    [sym_operator_assignment] = STATE(3342),
    [sym_conditional] = STATE(3342),
    [sym_range] = STATE(3342),
    [sym_binary] = STATE(3342),
    [sym_unary] = STATE(3342),
    [sym_parenthesized_unary] = STATE(2845),
    [sym_unary_literal] = STATE(3019),
    [sym__literal] = STATE(2845),
    [sym__numeric] = STATE(2844),
    [sym__simple_numeric] = STATE(3019),
    [sym_left_assignment_list] = STATE(5553),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2667),
    [sym__function_identifier_call] = STATE(3000),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2125),
    [sym__nonlocal_variable] = STATE(2149),
    [sym__int_or_float] = STATE(5453),
    [sym_complex] = STATE(2862),
    [sym_rational] = STATE(2862),
    [sym_nil] = STATE(2193),
    [sym_constant_suffix] = STATE(2827),
    [sym_identifier_suffix] = STATE(2798),
    [sym_chained_string] = STATE(2845),
    [sym_string] = STATE(2713),
    [sym_subshell] = STATE(2845),
    [sym_string_array] = STATE(2845),
    [sym_symbol_array] = STATE(2845),
    [sym_delimited_symbol] = STATE(2844),
    [sym_regex] = STATE(2845),
    [sym_heredoc_body] = STATE(1877),
    [sym_array] = STATE(2845),
    [sym_hash] = STATE(2845),
    [sym_lambda] = STATE(2845),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(571),
    [anon_sym_def] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(245),
    [anon_sym_class] = ACTIONS(247),
    [anon_sym_module] = ACTIONS(249),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_next] = ACTIONS(1371),
    [anon_sym_redo] = ACTIONS(259),
    [anon_sym_retry] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_unless] = ACTIONS(265),
    [anon_sym_while] = ACTIONS(267),
    [anon_sym_until] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(277),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym_begin] = ACTIONS(281),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_defined_QMARK] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(395),
    [sym_float] = ACTIONS(395),
    [sym_super] = ACTIONS(1359),
    [sym_self] = ACTIONS(1359),
    [sym_true] = ACTIONS(295),
    [sym_false] = ACTIONS(295),
    [sym_constant] = ACTIONS(1359),
    [aux_sym_constant_suffix_token1] = ACTIONS(1385),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1387),
    [sym_instance_variable] = ACTIONS(1389),
    [sym_class_variable] = ACTIONS(1389),
    [sym_global_variable] = ACTIONS(1389),
    [sym_character] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(305),
    [sym_simple_symbol] = ACTIONS(307),
    [sym__string_start] = ACTIONS(309),
    [sym__symbol_start] = ACTIONS(311),
    [sym__subshell_start] = ACTIONS(313),
    [sym__regex_start] = ACTIONS(315),
    [sym__string_array_start] = ACTIONS(317),
    [sym__symbol_array_start] = ACTIONS(319),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(303),
    [sym__unary_minus] = ACTIONS(2230),
    [sym__unary_minus_num] = ACTIONS(2232),
    [sym__binary_minus] = ACTIONS(2230),
    [sym__identifier_suffix] = ACTIONS(1395),
    [sym__constant_suffix] = ACTIONS(1385),
  },
  [1878] = {
    [sym_method] = STATE(2259),
    [sym_singleton_method] = STATE(2259),
    [sym_class] = STATE(2259),
    [sym_singleton_class] = STATE(2259),
    [sym_module] = STATE(2259),
    [sym_return] = STATE(2259),
    [sym_yield] = STATE(2259),
    [sym_break] = STATE(2259),
    [sym_next] = STATE(2259),
    [sym_redo] = STATE(2259),
    [sym_retry] = STATE(2259),
    [sym_while] = STATE(2259),
    [sym_until] = STATE(2259),
    [sym_for] = STATE(2259),
    [sym_case] = STATE(2259),
    [sym_case_match] = STATE(2259),
    [sym_if] = STATE(2259),
    [sym_unless] = STATE(2259),
    [sym_begin] = STATE(2259),
    [sym__arg] = STATE(2683),
    [sym__unary_minus_pow] = STATE(2476),
    [sym__primary] = STATE(2395),
    [sym_parenthesized_statements] = STATE(2259),
    [sym_element_reference] = STATE(2055),
    [sym_scope_resolution] = STATE(2055),
    [sym__call] = STATE(2013),
    [sym_call] = STATE(2259),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_parenthesized_unary] = STATE(2259),
    [sym_unary_literal] = STATE(2289),
    [sym__literal] = STATE(2259),
    [sym__numeric] = STATE(2291),
    [sym__simple_numeric] = STATE(2264),
    [sym_left_assignment_list] = STATE(5670),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(2142),
    [sym__function_identifier_call] = STATE(2209),
    [sym__lhs] = STATE(2095),
    [sym__variable] = STATE(2016),
    [sym__nonlocal_variable] = STATE(2044),
    [sym__int_or_float] = STATE(5472),
    [sym_complex] = STATE(2228),
    [sym_rational] = STATE(2228),
    [sym_nil] = STATE(2055),
    [sym_constant_suffix] = STATE(2201),
    [sym_identifier_suffix] = STATE(2196),
    [sym_chained_string] = STATE(2259),
    [sym_string] = STATE(2163),
    [sym_subshell] = STATE(2259),
    [sym_string_array] = STATE(2259),
    [sym_symbol_array] = STATE(2259),
    [sym_delimited_symbol] = STATE(2291),
    [sym_regex] = STATE(2259),
    [sym_heredoc_body] = STATE(1878),
    [sym_array] = STATE(2259),
    [sym_hash] = STATE(2259),
    [sym_lambda] = STATE(2259),
    [sym_identifier] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_def] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_COLON_COLON] = ACTIONS(25),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(33),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_module] = ACTIONS(37),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_next] = ACTIONS(893),
    [anon_sym_redo] = ACTIONS(47),
    [anon_sym_retry] = ACTIONS(49),
    [anon_sym_if] = ACTIONS(51),
    [anon_sym_unless] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_until] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_defined_QMARK] = ACTIONS(1265),
    [anon_sym_not] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(83),
    [sym_float] = ACTIONS(83),
    [sym_super] = ACTIONS(879),
    [sym_self] = ACTIONS(879),
    [sym_true] = ACTIONS(85),
    [sym_false] = ACTIONS(85),
    [sym_constant] = ACTIONS(879),
    [aux_sym_constant_suffix_token1] = ACTIONS(907),
    [aux_sym_identifier_suffix_token1] = ACTIONS(909),
    [sym_instance_variable] = ACTIONS(911),
    [sym_class_variable] = ACTIONS(911),
    [sym_global_variable] = ACTIONS(911),
    [sym_character] = ACTIONS(93),
    [anon_sym_DASH_GT] = ACTIONS(95),
    [sym_simple_symbol] = ACTIONS(97),
    [sym__string_start] = ACTIONS(99),
    [sym__symbol_start] = ACTIONS(101),
    [sym__subshell_start] = ACTIONS(103),
    [sym__regex_start] = ACTIONS(105),
    [sym__string_array_start] = ACTIONS(107),
    [sym__symbol_array_start] = ACTIONS(109),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(93),
    [sym__unary_minus] = ACTIONS(1051),
    [sym__unary_minus_num] = ACTIONS(457),
    [sym__binary_minus] = ACTIONS(1051),
    [sym__identifier_suffix] = ACTIONS(917),
    [sym__constant_suffix] = ACTIONS(907),
  },
  [1879] = {
    [sym_heredoc_body] = STATE(1879),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1880] = {
    [sym_heredoc_body] = STATE(1880),
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_def] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_end] = ACTIONS(2562),
    [anon_sym_rescue] = ACTIONS(2562),
    [anon_sym_EQ] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2564),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_nil] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
    [anon_sym_class] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_yield] = ACTIONS(2562),
    [anon_sym_break] = ACTIONS(2562),
    [anon_sym_next] = ACTIONS(2562),
    [anon_sym_redo] = ACTIONS(2562),
    [anon_sym_retry] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_unless] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [anon_sym_until] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_case] = ACTIONS(2562),
    [anon_sym_when] = ACTIONS(2562),
    [anon_sym_EQ_GT] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_LPAREN2] = ACTIONS(2564),
    [anon_sym_DOT_DOT] = ACTIONS(2562),
    [anon_sym_CARET] = ACTIONS(2562),
    [anon_sym_elsif] = ACTIONS(2562),
    [anon_sym_else] = ACTIONS(2562),
    [anon_sym_then] = ACTIONS(2562),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_ensure] = ACTIONS(2562),
    [anon_sym_COLON_COLON2] = ACTIONS(2564),
    [anon_sym_AMP_DOT] = ACTIONS(2564),
    [anon_sym_PLUS_EQ] = ACTIONS(2564),
    [anon_sym_DASH_EQ] = ACTIONS(2564),
    [anon_sym_STAR_EQ] = ACTIONS(2564),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2564),
    [anon_sym_SLASH_EQ] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2564),
    [anon_sym_PIPE_EQ] = ACTIONS(2564),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2564),
    [anon_sym_AMP_EQ] = ACTIONS(2564),
    [anon_sym_PERCENT_EQ] = ACTIONS(2564),
    [anon_sym_GT_GT_EQ] = ACTIONS(2564),
    [anon_sym_LT_LT_EQ] = ACTIONS(2564),
    [anon_sym_CARET_EQ] = ACTIONS(2564),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_and] = ACTIONS(2562),
    [anon_sym_or] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_EQ] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_GT_EQ] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_SLASH] = ACTIONS(2562),
    [anon_sym_PERCENT] = ACTIONS(2562),
    [anon_sym_EQ_EQ] = ACTIONS(2562),
    [anon_sym_BANG_EQ] = ACTIONS(2564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2564),
    [anon_sym_LT_EQ_GT] = ACTIONS(2564),
    [anon_sym_EQ_TILDE] = ACTIONS(2564),
    [anon_sym_BANG_TILDE] = ACTIONS(2564),
    [anon_sym_defined_QMARK] = ACTIONS(2564),
    [anon_sym_not] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2562),
    [sym_float] = ACTIONS(2562),
    [sym_super] = ACTIONS(2562),
    [sym_self] = ACTIONS(2562),
    [sym_true] = ACTIONS(2562),
    [sym_false] = ACTIONS(2562),
    [sym_constant] = ACTIONS(2562),
    [aux_sym_constant_suffix_token1] = ACTIONS(2564),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2562),
    [sym_instance_variable] = ACTIONS(2564),
    [sym_class_variable] = ACTIONS(2564),
    [sym_global_variable] = ACTIONS(2564),
    [sym_character] = ACTIONS(2564),
    [anon_sym_DASH_GT] = ACTIONS(2564),
    [sym__line_break] = ACTIONS(2564),
    [sym_simple_symbol] = ACTIONS(2564),
    [sym__string_start] = ACTIONS(2564),
    [sym__symbol_start] = ACTIONS(2564),
    [sym__subshell_start] = ACTIONS(2564),
    [sym__regex_start] = ACTIONS(2564),
    [sym__string_array_start] = ACTIONS(2564),
    [sym__symbol_array_start] = ACTIONS(2564),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2564),
    [sym__block_ampersand] = ACTIONS(2564),
    [sym__splat_star] = ACTIONS(2564),
    [sym__unary_minus] = ACTIONS(2564),
    [sym__unary_minus_num] = ACTIONS(2564),
    [sym__binary_minus] = ACTIONS(2564),
    [sym__binary_star] = ACTIONS(2564),
    [sym_hash_key_symbol] = ACTIONS(2564),
    [sym__identifier_suffix] = ACTIONS(2564),
    [sym__constant_suffix] = ACTIONS(2564),
    [sym__hash_splat_star_star] = ACTIONS(2564),
    [sym__binary_star_star] = ACTIONS(2564),
    [sym__element_reference_bracket] = ACTIONS(2564),
  },
  [1881] = {
    [sym_heredoc_body] = STATE(1881),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_RPAREN] = ACTIONS(2568),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_end] = ACTIONS(2570),
    [anon_sym_rescue] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_unless] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [anon_sym_until] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2570),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_when] = ACTIONS(2570),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_CARET] = ACTIONS(2570),
    [anon_sym_elsif] = ACTIONS(2570),
    [anon_sym_else] = ACTIONS(2570),
    [anon_sym_then] = ACTIONS(2570),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_ensure] = ACTIONS(2570),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS_EQ] = ACTIONS(2568),
    [anon_sym_DASH_EQ] = ACTIONS(2568),
    [anon_sym_STAR_EQ] = ACTIONS(2568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2568),
    [anon_sym_SLASH_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2568),
    [anon_sym_AMP_EQ] = ACTIONS(2568),
    [anon_sym_PERCENT_EQ] = ACTIONS(2568),
    [anon_sym_GT_GT_EQ] = ACTIONS(2568),
    [anon_sym_LT_LT_EQ] = ACTIONS(2568),
    [anon_sym_CARET_EQ] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_EQ] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_EQ] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_EQ_EQ] = ACTIONS(2570),
    [anon_sym_BANG_EQ] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_LT_EQ_GT] = ACTIONS(2568),
    [anon_sym_EQ_TILDE] = ACTIONS(2568),
    [anon_sym_BANG_TILDE] = ACTIONS(2568),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym__line_break] = ACTIONS(2568),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__binary_star] = ACTIONS(2568),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [1882] = {
    [sym_heredoc_body] = STATE(1882),
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_LBRACE] = ACTIONS(2576),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_def] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_RPAREN] = ACTIONS(2576),
    [anon_sym_DOT] = ACTIONS(2574),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_end] = ACTIONS(2574),
    [anon_sym_rescue] = ACTIONS(2574),
    [anon_sym_EQ] = ACTIONS(2574),
    [anon_sym_COMMA] = ACTIONS(2576),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_SEMI] = ACTIONS(2576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_nil] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2574),
    [anon_sym_class] = ACTIONS(2574),
    [anon_sym_LT] = ACTIONS(2574),
    [anon_sym_module] = ACTIONS(2574),
    [anon_sym_return] = ACTIONS(2574),
    [anon_sym_yield] = ACTIONS(2574),
    [anon_sym_break] = ACTIONS(2574),
    [anon_sym_next] = ACTIONS(2574),
    [anon_sym_redo] = ACTIONS(2574),
    [anon_sym_retry] = ACTIONS(2574),
    [anon_sym_if] = ACTIONS(2574),
    [anon_sym_unless] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [anon_sym_until] = ACTIONS(2574),
    [anon_sym_for] = ACTIONS(2574),
    [anon_sym_in] = ACTIONS(2574),
    [anon_sym_do] = ACTIONS(2574),
    [anon_sym_case] = ACTIONS(2574),
    [anon_sym_when] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(2576),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_LPAREN2] = ACTIONS(2576),
    [anon_sym_DOT_DOT] = ACTIONS(2574),
    [anon_sym_CARET] = ACTIONS(2574),
    [anon_sym_elsif] = ACTIONS(2574),
    [anon_sym_else] = ACTIONS(2574),
    [anon_sym_then] = ACTIONS(2574),
    [anon_sym_begin] = ACTIONS(2574),
    [anon_sym_ensure] = ACTIONS(2574),
    [anon_sym_COLON_COLON2] = ACTIONS(2576),
    [anon_sym_AMP_DOT] = ACTIONS(2576),
    [anon_sym_PLUS_EQ] = ACTIONS(2576),
    [anon_sym_DASH_EQ] = ACTIONS(2576),
    [anon_sym_STAR_EQ] = ACTIONS(2576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2576),
    [anon_sym_SLASH_EQ] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2576),
    [anon_sym_PIPE_EQ] = ACTIONS(2576),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2576),
    [anon_sym_AMP_EQ] = ACTIONS(2576),
    [anon_sym_PERCENT_EQ] = ACTIONS(2576),
    [anon_sym_GT_GT_EQ] = ACTIONS(2576),
    [anon_sym_LT_LT_EQ] = ACTIONS(2576),
    [anon_sym_CARET_EQ] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(2574),
    [anon_sym_and] = ACTIONS(2574),
    [anon_sym_or] = ACTIONS(2574),
    [anon_sym_PIPE_PIPE] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_LT_LT] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2574),
    [anon_sym_LT_EQ] = ACTIONS(2574),
    [anon_sym_GT] = ACTIONS(2574),
    [anon_sym_GT_EQ] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2574),
    [anon_sym_EQ_EQ] = ACTIONS(2574),
    [anon_sym_BANG_EQ] = ACTIONS(2576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2576),
    [anon_sym_LT_EQ_GT] = ACTIONS(2576),
    [anon_sym_EQ_TILDE] = ACTIONS(2576),
    [anon_sym_BANG_TILDE] = ACTIONS(2576),
    [anon_sym_defined_QMARK] = ACTIONS(2576),
    [anon_sym_not] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2574),
    [sym_float] = ACTIONS(2574),
    [sym_super] = ACTIONS(2574),
    [sym_self] = ACTIONS(2574),
    [sym_true] = ACTIONS(2574),
    [sym_false] = ACTIONS(2574),
    [sym_constant] = ACTIONS(2574),
    [aux_sym_constant_suffix_token1] = ACTIONS(2576),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2574),
    [sym_instance_variable] = ACTIONS(2576),
    [sym_class_variable] = ACTIONS(2576),
    [sym_global_variable] = ACTIONS(2576),
    [sym_character] = ACTIONS(2576),
    [anon_sym_DASH_GT] = ACTIONS(2576),
    [sym__line_break] = ACTIONS(2576),
    [sym_simple_symbol] = ACTIONS(2576),
    [sym__string_start] = ACTIONS(2576),
    [sym__symbol_start] = ACTIONS(2576),
    [sym__subshell_start] = ACTIONS(2576),
    [sym__regex_start] = ACTIONS(2576),
    [sym__string_array_start] = ACTIONS(2576),
    [sym__symbol_array_start] = ACTIONS(2576),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2576),
    [sym__block_ampersand] = ACTIONS(2576),
    [sym__splat_star] = ACTIONS(2576),
    [sym__unary_minus] = ACTIONS(2576),
    [sym__unary_minus_num] = ACTIONS(2576),
    [sym__binary_minus] = ACTIONS(2576),
    [sym__binary_star] = ACTIONS(2576),
    [sym_hash_key_symbol] = ACTIONS(2576),
    [sym__identifier_suffix] = ACTIONS(2576),
    [sym__constant_suffix] = ACTIONS(2576),
    [sym__hash_splat_star_star] = ACTIONS(2576),
    [sym__binary_star_star] = ACTIONS(2576),
    [sym__element_reference_bracket] = ACTIONS(2576),
  },
  [1883] = {
    [sym_heredoc_body] = STATE(1883),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_end] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_when] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2578),
    [anon_sym_elsif] = ACTIONS(2578),
    [anon_sym_else] = ACTIONS(2578),
    [anon_sym_then] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_ensure] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_PLUS_EQ] = ACTIONS(2580),
    [anon_sym_DASH_EQ] = ACTIONS(2580),
    [anon_sym_STAR_EQ] = ACTIONS(2580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2580),
    [anon_sym_SLASH_EQ] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2580),
    [anon_sym_PIPE_EQ] = ACTIONS(2580),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2580),
    [anon_sym_AMP_EQ] = ACTIONS(2580),
    [anon_sym_PERCENT_EQ] = ACTIONS(2580),
    [anon_sym_GT_GT_EQ] = ACTIONS(2580),
    [anon_sym_LT_LT_EQ] = ACTIONS(2580),
    [anon_sym_CARET_EQ] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2578),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_SLASH] = ACTIONS(2578),
    [anon_sym_PERCENT] = ACTIONS(2578),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1884] = {
    [sym_heredoc_body] = STATE(1884),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_end] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_EQ] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_when] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2582),
    [anon_sym_elsif] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_then] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_ensure] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_PLUS_EQ] = ACTIONS(2584),
    [anon_sym_DASH_EQ] = ACTIONS(2584),
    [anon_sym_STAR_EQ] = ACTIONS(2584),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2584),
    [anon_sym_SLASH_EQ] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2584),
    [anon_sym_PIPE_EQ] = ACTIONS(2584),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2584),
    [anon_sym_AMP_EQ] = ACTIONS(2584),
    [anon_sym_PERCENT_EQ] = ACTIONS(2584),
    [anon_sym_GT_GT_EQ] = ACTIONS(2584),
    [anon_sym_LT_LT_EQ] = ACTIONS(2584),
    [anon_sym_CARET_EQ] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_PERCENT] = ACTIONS(2582),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1885] = {
    [sym_heredoc_body] = STATE(1885),
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_def] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_end] = ACTIONS(2586),
    [anon_sym_rescue] = ACTIONS(2586),
    [anon_sym_EQ] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2586),
    [anon_sym_nil] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_next] = ACTIONS(2586),
    [anon_sym_redo] = ACTIONS(2586),
    [anon_sym_retry] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_unless] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_until] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_when] = ACTIONS(2586),
    [anon_sym_EQ_GT] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2588),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_CARET] = ACTIONS(2586),
    [anon_sym_elsif] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2586),
    [anon_sym_then] = ACTIONS(2586),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_ensure] = ACTIONS(2586),
    [anon_sym_COLON_COLON2] = ACTIONS(2588),
    [anon_sym_AMP_DOT] = ACTIONS(2588),
    [anon_sym_PLUS_EQ] = ACTIONS(2588),
    [anon_sym_DASH_EQ] = ACTIONS(2588),
    [anon_sym_STAR_EQ] = ACTIONS(2588),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2588),
    [anon_sym_SLASH_EQ] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2588),
    [anon_sym_PIPE_EQ] = ACTIONS(2588),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2588),
    [anon_sym_AMP_EQ] = ACTIONS(2588),
    [anon_sym_PERCENT_EQ] = ACTIONS(2588),
    [anon_sym_GT_GT_EQ] = ACTIONS(2588),
    [anon_sym_LT_LT_EQ] = ACTIONS(2588),
    [anon_sym_CARET_EQ] = ACTIONS(2588),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_and] = ACTIONS(2586),
    [anon_sym_or] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_EQ] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_SLASH] = ACTIONS(2586),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_EQ_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT_EQ_GT] = ACTIONS(2588),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_BANG_TILDE] = ACTIONS(2588),
    [anon_sym_defined_QMARK] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2586),
    [sym_float] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_self] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_constant] = ACTIONS(2586),
    [aux_sym_constant_suffix_token1] = ACTIONS(2588),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2586),
    [sym_instance_variable] = ACTIONS(2588),
    [sym_class_variable] = ACTIONS(2588),
    [sym_global_variable] = ACTIONS(2588),
    [sym_character] = ACTIONS(2588),
    [anon_sym_DASH_GT] = ACTIONS(2588),
    [sym__line_break] = ACTIONS(2588),
    [sym_simple_symbol] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__symbol_start] = ACTIONS(2588),
    [sym__subshell_start] = ACTIONS(2588),
    [sym__regex_start] = ACTIONS(2588),
    [sym__string_array_start] = ACTIONS(2588),
    [sym__symbol_array_start] = ACTIONS(2588),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2588),
    [sym__block_ampersand] = ACTIONS(2588),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(2588),
    [sym__unary_minus_num] = ACTIONS(2588),
    [sym__binary_minus] = ACTIONS(2588),
    [sym__binary_star] = ACTIONS(2588),
    [sym_hash_key_symbol] = ACTIONS(2588),
    [sym__identifier_suffix] = ACTIONS(2588),
    [sym__constant_suffix] = ACTIONS(2588),
    [sym__hash_splat_star_star] = ACTIONS(2588),
    [sym__binary_star_star] = ACTIONS(2588),
    [sym__element_reference_bracket] = ACTIONS(2588),
  },
  [1886] = {
    [sym_heredoc_body] = STATE(1886),
    [sym_identifier] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_RBRACE] = ACTIONS(2592),
    [anon_sym_def] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_end] = ACTIONS(2590),
    [anon_sym_rescue] = ACTIONS(2590),
    [anon_sym_EQ] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_nil] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_yield] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_next] = ACTIONS(2590),
    [anon_sym_redo] = ACTIONS(2590),
    [anon_sym_retry] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_unless] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_until] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_when] = ACTIONS(2590),
    [anon_sym_EQ_GT] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_elsif] = ACTIONS(2590),
    [anon_sym_else] = ACTIONS(2590),
    [anon_sym_then] = ACTIONS(2590),
    [anon_sym_begin] = ACTIONS(2590),
    [anon_sym_ensure] = ACTIONS(2590),
    [anon_sym_COLON_COLON2] = ACTIONS(2592),
    [anon_sym_AMP_DOT] = ACTIONS(2592),
    [anon_sym_PLUS_EQ] = ACTIONS(2592),
    [anon_sym_DASH_EQ] = ACTIONS(2592),
    [anon_sym_STAR_EQ] = ACTIONS(2592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2592),
    [anon_sym_SLASH_EQ] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2592),
    [anon_sym_PIPE_EQ] = ACTIONS(2592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2592),
    [anon_sym_AMP_EQ] = ACTIONS(2592),
    [anon_sym_PERCENT_EQ] = ACTIONS(2592),
    [anon_sym_GT_GT_EQ] = ACTIONS(2592),
    [anon_sym_LT_LT_EQ] = ACTIONS(2592),
    [anon_sym_CARET_EQ] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_and] = ACTIONS(2590),
    [anon_sym_or] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2590),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2592),
    [anon_sym_LT_EQ_GT] = ACTIONS(2592),
    [anon_sym_EQ_TILDE] = ACTIONS(2592),
    [anon_sym_BANG_TILDE] = ACTIONS(2592),
    [anon_sym_defined_QMARK] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2590),
    [sym_float] = ACTIONS(2590),
    [sym_super] = ACTIONS(2590),
    [sym_self] = ACTIONS(2590),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_constant] = ACTIONS(2590),
    [aux_sym_constant_suffix_token1] = ACTIONS(2592),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2590),
    [sym_instance_variable] = ACTIONS(2592),
    [sym_class_variable] = ACTIONS(2592),
    [sym_global_variable] = ACTIONS(2592),
    [sym_character] = ACTIONS(2592),
    [anon_sym_DASH_GT] = ACTIONS(2592),
    [sym__line_break] = ACTIONS(2592),
    [sym_simple_symbol] = ACTIONS(2592),
    [sym__string_start] = ACTIONS(2592),
    [sym__symbol_start] = ACTIONS(2592),
    [sym__subshell_start] = ACTIONS(2592),
    [sym__regex_start] = ACTIONS(2592),
    [sym__string_array_start] = ACTIONS(2592),
    [sym__symbol_array_start] = ACTIONS(2592),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2592),
    [sym__block_ampersand] = ACTIONS(2592),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(2592),
    [sym__unary_minus_num] = ACTIONS(2592),
    [sym__binary_minus] = ACTIONS(2592),
    [sym__binary_star] = ACTIONS(2592),
    [sym_hash_key_symbol] = ACTIONS(2592),
    [sym__identifier_suffix] = ACTIONS(2592),
    [sym__constant_suffix] = ACTIONS(2592),
    [sym__hash_splat_star_star] = ACTIONS(2592),
    [sym__binary_star_star] = ACTIONS(2592),
    [sym__element_reference_bracket] = ACTIONS(2592),
  },
  [1887] = {
    [sym_heredoc_body] = STATE(1887),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_RPAREN] = ACTIONS(2572),
    [anon_sym_DOT] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_end] = ACTIONS(2566),
    [anon_sym_rescue] = ACTIONS(2566),
    [anon_sym_EQ] = ACTIONS(2566),
    [anon_sym_COMMA] = ACTIONS(2572),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(2572),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_unless] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_until] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_when] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2566),
    [anon_sym_CARET] = ACTIONS(2566),
    [anon_sym_elsif] = ACTIONS(2566),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_then] = ACTIONS(2566),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_ensure] = ACTIONS(2566),
    [anon_sym_COLON_COLON2] = ACTIONS(2572),
    [anon_sym_AMP_DOT] = ACTIONS(2572),
    [anon_sym_PLUS_EQ] = ACTIONS(2572),
    [anon_sym_DASH_EQ] = ACTIONS(2572),
    [anon_sym_STAR_EQ] = ACTIONS(2572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2572),
    [anon_sym_SLASH_EQ] = ACTIONS(2572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2572),
    [anon_sym_PIPE_EQ] = ACTIONS(2572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2572),
    [anon_sym_AMP_EQ] = ACTIONS(2572),
    [anon_sym_PERCENT_EQ] = ACTIONS(2572),
    [anon_sym_GT_GT_EQ] = ACTIONS(2572),
    [anon_sym_LT_LT_EQ] = ACTIONS(2572),
    [anon_sym_CARET_EQ] = ACTIONS(2572),
    [anon_sym_QMARK] = ACTIONS(2566),
    [anon_sym_and] = ACTIONS(2566),
    [anon_sym_or] = ACTIONS(2566),
    [anon_sym_PIPE_PIPE] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2566),
    [anon_sym_LT_EQ] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_EQ] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_SLASH] = ACTIONS(2566),
    [anon_sym_PERCENT] = ACTIONS(2566),
    [anon_sym_EQ_EQ] = ACTIONS(2566),
    [anon_sym_BANG_EQ] = ACTIONS(2572),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2572),
    [anon_sym_LT_EQ_GT] = ACTIONS(2572),
    [anon_sym_EQ_TILDE] = ACTIONS(2572),
    [anon_sym_BANG_TILDE] = ACTIONS(2572),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym__line_break] = ACTIONS(2572),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2572),
    [sym__binary_star] = ACTIONS(2572),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2572),
    [sym__element_reference_bracket] = ACTIONS(2572),
  },
  [1888] = {
    [sym_heredoc_body] = STATE(1888),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_RPAREN] = ACTIONS(2568),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_end] = ACTIONS(2570),
    [anon_sym_rescue] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_unless] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [anon_sym_until] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_when] = ACTIONS(2570),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_CARET] = ACTIONS(2570),
    [anon_sym_elsif] = ACTIONS(2570),
    [anon_sym_else] = ACTIONS(2570),
    [anon_sym_then] = ACTIONS(2570),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_ensure] = ACTIONS(2570),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS_EQ] = ACTIONS(2568),
    [anon_sym_DASH_EQ] = ACTIONS(2568),
    [anon_sym_STAR_EQ] = ACTIONS(2568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2568),
    [anon_sym_SLASH_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2568),
    [anon_sym_AMP_EQ] = ACTIONS(2568),
    [anon_sym_PERCENT_EQ] = ACTIONS(2568),
    [anon_sym_GT_GT_EQ] = ACTIONS(2568),
    [anon_sym_LT_LT_EQ] = ACTIONS(2568),
    [anon_sym_CARET_EQ] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_EQ] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_EQ] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_EQ_EQ] = ACTIONS(2570),
    [anon_sym_BANG_EQ] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_LT_EQ_GT] = ACTIONS(2568),
    [anon_sym_EQ_TILDE] = ACTIONS(2568),
    [anon_sym_BANG_TILDE] = ACTIONS(2568),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym__line_break] = ACTIONS(2568),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__binary_star] = ACTIONS(2568),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [1889] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5376),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(4891),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(4946),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1889),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2594),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2598),
    [anon_sym_COLON_COLON] = ACTIONS(2604),
    [anon_sym_end] = ACTIONS(2606),
    [anon_sym_rescue] = ACTIONS(2606),
    [anon_sym_EQ] = ACTIONS(2608),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2606),
    [anon_sym_do] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_when] = ACTIONS(2606),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_elsif] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2606),
    [anon_sym_then] = ACTIONS(2606),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_ensure] = ACTIONS(2606),
    [anon_sym_and] = ACTIONS(2606),
    [anon_sym_or] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2652),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym__line_break] = ACTIONS(2598),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1890] = {
    [sym_heredoc_body] = STATE(1890),
    [ts_builtin_sym_end] = ACTIONS(745),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2682),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1891] = {
    [sym_heredoc_body] = STATE(1891),
    [ts_builtin_sym_end] = ACTIONS(745),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1892] = {
    [sym_heredoc_body] = STATE(1892),
    [ts_builtin_sym_end] = ACTIONS(2592),
    [sym_identifier] = ACTIONS(2590),
    [aux_sym_program_token1] = ACTIONS(2592),
    [anon_sym___END__] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_def] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_rescue] = ACTIONS(2590),
    [anon_sym_EQ] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_nil] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_yield] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_next] = ACTIONS(2590),
    [anon_sym_redo] = ACTIONS(2590),
    [anon_sym_retry] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_unless] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_until] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_EQ_GT] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_begin] = ACTIONS(2590),
    [anon_sym_COLON_COLON2] = ACTIONS(2592),
    [anon_sym_AMP_DOT] = ACTIONS(2592),
    [anon_sym_PLUS_EQ] = ACTIONS(2592),
    [anon_sym_DASH_EQ] = ACTIONS(2592),
    [anon_sym_STAR_EQ] = ACTIONS(2592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2592),
    [anon_sym_SLASH_EQ] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2592),
    [anon_sym_PIPE_EQ] = ACTIONS(2592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2592),
    [anon_sym_AMP_EQ] = ACTIONS(2592),
    [anon_sym_PERCENT_EQ] = ACTIONS(2592),
    [anon_sym_GT_GT_EQ] = ACTIONS(2592),
    [anon_sym_LT_LT_EQ] = ACTIONS(2592),
    [anon_sym_CARET_EQ] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_and] = ACTIONS(2590),
    [anon_sym_or] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2590),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2592),
    [anon_sym_LT_EQ_GT] = ACTIONS(2592),
    [anon_sym_EQ_TILDE] = ACTIONS(2592),
    [anon_sym_BANG_TILDE] = ACTIONS(2592),
    [anon_sym_defined_QMARK] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2590),
    [sym_float] = ACTIONS(2590),
    [sym_super] = ACTIONS(2590),
    [sym_self] = ACTIONS(2590),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_constant] = ACTIONS(2590),
    [aux_sym_constant_suffix_token1] = ACTIONS(2592),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2590),
    [sym_instance_variable] = ACTIONS(2592),
    [sym_class_variable] = ACTIONS(2592),
    [sym_global_variable] = ACTIONS(2592),
    [sym_character] = ACTIONS(2592),
    [anon_sym_DASH_GT] = ACTIONS(2592),
    [sym__line_break] = ACTIONS(2592),
    [sym_simple_symbol] = ACTIONS(2592),
    [sym__string_start] = ACTIONS(2592),
    [sym__symbol_start] = ACTIONS(2592),
    [sym__subshell_start] = ACTIONS(2592),
    [sym__regex_start] = ACTIONS(2592),
    [sym__string_array_start] = ACTIONS(2592),
    [sym__symbol_array_start] = ACTIONS(2592),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2592),
    [sym__block_ampersand] = ACTIONS(2592),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(2592),
    [sym__unary_minus_num] = ACTIONS(2592),
    [sym__binary_minus] = ACTIONS(2592),
    [sym__binary_star] = ACTIONS(2592),
    [sym_hash_key_symbol] = ACTIONS(2592),
    [sym__identifier_suffix] = ACTIONS(2592),
    [sym__constant_suffix] = ACTIONS(2592),
    [sym__hash_splat_star_star] = ACTIONS(2592),
    [sym__binary_star_star] = ACTIONS(2592),
    [sym__element_reference_bracket] = ACTIONS(2592),
  },
  [1893] = {
    [sym_heredoc_body] = STATE(1893),
    [ts_builtin_sym_end] = ACTIONS(2568),
    [sym_identifier] = ACTIONS(2566),
    [aux_sym_program_token1] = ACTIONS(2568),
    [anon_sym___END__] = ACTIONS(2570),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_rescue] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_unless] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [anon_sym_until] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_CARET] = ACTIONS(2570),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS_EQ] = ACTIONS(2568),
    [anon_sym_DASH_EQ] = ACTIONS(2568),
    [anon_sym_STAR_EQ] = ACTIONS(2568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2568),
    [anon_sym_SLASH_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2568),
    [anon_sym_AMP_EQ] = ACTIONS(2568),
    [anon_sym_PERCENT_EQ] = ACTIONS(2568),
    [anon_sym_GT_GT_EQ] = ACTIONS(2568),
    [anon_sym_LT_LT_EQ] = ACTIONS(2568),
    [anon_sym_CARET_EQ] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_EQ] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_EQ] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_EQ_EQ] = ACTIONS(2570),
    [anon_sym_BANG_EQ] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_LT_EQ_GT] = ACTIONS(2568),
    [anon_sym_EQ_TILDE] = ACTIONS(2568),
    [anon_sym_BANG_TILDE] = ACTIONS(2568),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym__line_break] = ACTIONS(2568),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__binary_star] = ACTIONS(2568),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [1894] = {
    [sym_heredoc_body] = STATE(1894),
    [ts_builtin_sym_end] = ACTIONS(2588),
    [sym_identifier] = ACTIONS(2586),
    [aux_sym_program_token1] = ACTIONS(2588),
    [anon_sym___END__] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_def] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_rescue] = ACTIONS(2586),
    [anon_sym_EQ] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2586),
    [anon_sym_nil] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_next] = ACTIONS(2586),
    [anon_sym_redo] = ACTIONS(2586),
    [anon_sym_retry] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_unless] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_until] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_EQ_GT] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2588),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_CARET] = ACTIONS(2586),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_COLON_COLON2] = ACTIONS(2588),
    [anon_sym_AMP_DOT] = ACTIONS(2588),
    [anon_sym_PLUS_EQ] = ACTIONS(2588),
    [anon_sym_DASH_EQ] = ACTIONS(2588),
    [anon_sym_STAR_EQ] = ACTIONS(2588),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2588),
    [anon_sym_SLASH_EQ] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2588),
    [anon_sym_PIPE_EQ] = ACTIONS(2588),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2588),
    [anon_sym_AMP_EQ] = ACTIONS(2588),
    [anon_sym_PERCENT_EQ] = ACTIONS(2588),
    [anon_sym_GT_GT_EQ] = ACTIONS(2588),
    [anon_sym_LT_LT_EQ] = ACTIONS(2588),
    [anon_sym_CARET_EQ] = ACTIONS(2588),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_and] = ACTIONS(2586),
    [anon_sym_or] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_EQ] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_SLASH] = ACTIONS(2586),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_EQ_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT_EQ_GT] = ACTIONS(2588),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_BANG_TILDE] = ACTIONS(2588),
    [anon_sym_defined_QMARK] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2586),
    [sym_float] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_self] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_constant] = ACTIONS(2586),
    [aux_sym_constant_suffix_token1] = ACTIONS(2588),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2586),
    [sym_instance_variable] = ACTIONS(2588),
    [sym_class_variable] = ACTIONS(2588),
    [sym_global_variable] = ACTIONS(2588),
    [sym_character] = ACTIONS(2588),
    [anon_sym_DASH_GT] = ACTIONS(2588),
    [sym__line_break] = ACTIONS(2588),
    [sym_simple_symbol] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__symbol_start] = ACTIONS(2588),
    [sym__subshell_start] = ACTIONS(2588),
    [sym__regex_start] = ACTIONS(2588),
    [sym__string_array_start] = ACTIONS(2588),
    [sym__symbol_array_start] = ACTIONS(2588),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2588),
    [sym__block_ampersand] = ACTIONS(2588),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(2588),
    [sym__unary_minus_num] = ACTIONS(2588),
    [sym__binary_minus] = ACTIONS(2588),
    [sym__binary_star] = ACTIONS(2588),
    [sym_hash_key_symbol] = ACTIONS(2588),
    [sym__identifier_suffix] = ACTIONS(2588),
    [sym__constant_suffix] = ACTIONS(2588),
    [sym__hash_splat_star_star] = ACTIONS(2588),
    [sym__binary_star_star] = ACTIONS(2588),
    [sym__element_reference_bracket] = ACTIONS(2588),
  },
  [1895] = {
    [sym_heredoc_body] = STATE(1895),
    [ts_builtin_sym_end] = ACTIONS(745),
    [sym_identifier] = ACTIONS(733),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1896] = {
    [sym_heredoc_body] = STATE(1896),
    [ts_builtin_sym_end] = ACTIONS(2564),
    [sym_identifier] = ACTIONS(2562),
    [aux_sym_program_token1] = ACTIONS(2564),
    [anon_sym___END__] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2564),
    [anon_sym_def] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_rescue] = ACTIONS(2562),
    [anon_sym_EQ] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2564),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_nil] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
    [anon_sym_class] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_yield] = ACTIONS(2562),
    [anon_sym_break] = ACTIONS(2562),
    [anon_sym_next] = ACTIONS(2562),
    [anon_sym_redo] = ACTIONS(2562),
    [anon_sym_retry] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_unless] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [anon_sym_until] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_case] = ACTIONS(2562),
    [anon_sym_EQ_GT] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_LPAREN2] = ACTIONS(2564),
    [anon_sym_DOT_DOT] = ACTIONS(2562),
    [anon_sym_CARET] = ACTIONS(2562),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_COLON_COLON2] = ACTIONS(2564),
    [anon_sym_AMP_DOT] = ACTIONS(2564),
    [anon_sym_PLUS_EQ] = ACTIONS(2564),
    [anon_sym_DASH_EQ] = ACTIONS(2564),
    [anon_sym_STAR_EQ] = ACTIONS(2564),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2564),
    [anon_sym_SLASH_EQ] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2564),
    [anon_sym_PIPE_EQ] = ACTIONS(2564),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2564),
    [anon_sym_AMP_EQ] = ACTIONS(2564),
    [anon_sym_PERCENT_EQ] = ACTIONS(2564),
    [anon_sym_GT_GT_EQ] = ACTIONS(2564),
    [anon_sym_LT_LT_EQ] = ACTIONS(2564),
    [anon_sym_CARET_EQ] = ACTIONS(2564),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_and] = ACTIONS(2562),
    [anon_sym_or] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_EQ] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_GT_EQ] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_SLASH] = ACTIONS(2562),
    [anon_sym_PERCENT] = ACTIONS(2562),
    [anon_sym_EQ_EQ] = ACTIONS(2562),
    [anon_sym_BANG_EQ] = ACTIONS(2564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2564),
    [anon_sym_LT_EQ_GT] = ACTIONS(2564),
    [anon_sym_EQ_TILDE] = ACTIONS(2564),
    [anon_sym_BANG_TILDE] = ACTIONS(2564),
    [anon_sym_defined_QMARK] = ACTIONS(2564),
    [anon_sym_not] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2562),
    [sym_float] = ACTIONS(2562),
    [sym_super] = ACTIONS(2562),
    [sym_self] = ACTIONS(2562),
    [sym_true] = ACTIONS(2562),
    [sym_false] = ACTIONS(2562),
    [sym_constant] = ACTIONS(2562),
    [aux_sym_constant_suffix_token1] = ACTIONS(2564),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2562),
    [sym_instance_variable] = ACTIONS(2564),
    [sym_class_variable] = ACTIONS(2564),
    [sym_global_variable] = ACTIONS(2564),
    [sym_character] = ACTIONS(2564),
    [anon_sym_DASH_GT] = ACTIONS(2564),
    [sym__line_break] = ACTIONS(2564),
    [sym_simple_symbol] = ACTIONS(2564),
    [sym__string_start] = ACTIONS(2564),
    [sym__symbol_start] = ACTIONS(2564),
    [sym__subshell_start] = ACTIONS(2564),
    [sym__regex_start] = ACTIONS(2564),
    [sym__string_array_start] = ACTIONS(2564),
    [sym__symbol_array_start] = ACTIONS(2564),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2564),
    [sym__block_ampersand] = ACTIONS(2564),
    [sym__splat_star] = ACTIONS(2564),
    [sym__unary_minus] = ACTIONS(2564),
    [sym__unary_minus_num] = ACTIONS(2564),
    [sym__binary_minus] = ACTIONS(2564),
    [sym__binary_star] = ACTIONS(2564),
    [sym_hash_key_symbol] = ACTIONS(2564),
    [sym__identifier_suffix] = ACTIONS(2564),
    [sym__constant_suffix] = ACTIONS(2564),
    [sym__hash_splat_star_star] = ACTIONS(2564),
    [sym__binary_star_star] = ACTIONS(2564),
    [sym__element_reference_bracket] = ACTIONS(2564),
  },
  [1897] = {
    [sym_heredoc_body] = STATE(1897),
    [ts_builtin_sym_end] = ACTIONS(2568),
    [sym_identifier] = ACTIONS(2566),
    [aux_sym_program_token1] = ACTIONS(2568),
    [anon_sym___END__] = ACTIONS(2570),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_rescue] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_unless] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [anon_sym_until] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2570),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_CARET] = ACTIONS(2570),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS_EQ] = ACTIONS(2568),
    [anon_sym_DASH_EQ] = ACTIONS(2568),
    [anon_sym_STAR_EQ] = ACTIONS(2568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2568),
    [anon_sym_SLASH_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2568),
    [anon_sym_AMP_EQ] = ACTIONS(2568),
    [anon_sym_PERCENT_EQ] = ACTIONS(2568),
    [anon_sym_GT_GT_EQ] = ACTIONS(2568),
    [anon_sym_LT_LT_EQ] = ACTIONS(2568),
    [anon_sym_CARET_EQ] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_EQ] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_EQ] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_EQ_EQ] = ACTIONS(2570),
    [anon_sym_BANG_EQ] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_LT_EQ_GT] = ACTIONS(2568),
    [anon_sym_EQ_TILDE] = ACTIONS(2568),
    [anon_sym_BANG_TILDE] = ACTIONS(2568),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym__line_break] = ACTIONS(2568),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__binary_star] = ACTIONS(2568),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [1898] = {
    [sym_heredoc_body] = STATE(1898),
    [ts_builtin_sym_end] = ACTIONS(2580),
    [sym_identifier] = ACTIONS(2578),
    [aux_sym_program_token1] = ACTIONS(2580),
    [anon_sym___END__] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_PLUS_EQ] = ACTIONS(2580),
    [anon_sym_DASH_EQ] = ACTIONS(2580),
    [anon_sym_STAR_EQ] = ACTIONS(2580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2580),
    [anon_sym_SLASH_EQ] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2580),
    [anon_sym_PIPE_EQ] = ACTIONS(2580),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2580),
    [anon_sym_AMP_EQ] = ACTIONS(2580),
    [anon_sym_PERCENT_EQ] = ACTIONS(2580),
    [anon_sym_GT_GT_EQ] = ACTIONS(2580),
    [anon_sym_LT_LT_EQ] = ACTIONS(2580),
    [anon_sym_CARET_EQ] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2578),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_SLASH] = ACTIONS(2578),
    [anon_sym_PERCENT] = ACTIONS(2578),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1899] = {
    [sym_heredoc_body] = STATE(1899),
    [ts_builtin_sym_end] = ACTIONS(2584),
    [sym_identifier] = ACTIONS(2582),
    [aux_sym_program_token1] = ACTIONS(2584),
    [anon_sym___END__] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_EQ] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_PLUS_EQ] = ACTIONS(2584),
    [anon_sym_DASH_EQ] = ACTIONS(2584),
    [anon_sym_STAR_EQ] = ACTIONS(2584),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2584),
    [anon_sym_SLASH_EQ] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2584),
    [anon_sym_PIPE_EQ] = ACTIONS(2584),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2584),
    [anon_sym_AMP_EQ] = ACTIONS(2584),
    [anon_sym_PERCENT_EQ] = ACTIONS(2584),
    [anon_sym_GT_GT_EQ] = ACTIONS(2584),
    [anon_sym_LT_LT_EQ] = ACTIONS(2584),
    [anon_sym_CARET_EQ] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_PERCENT] = ACTIONS(2582),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1900] = {
    [sym_heredoc_body] = STATE(1900),
    [ts_builtin_sym_end] = ACTIONS(2576),
    [sym_identifier] = ACTIONS(2574),
    [aux_sym_program_token1] = ACTIONS(2576),
    [anon_sym___END__] = ACTIONS(2574),
    [anon_sym_LBRACE] = ACTIONS(2576),
    [anon_sym_def] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_DOT] = ACTIONS(2574),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_rescue] = ACTIONS(2574),
    [anon_sym_EQ] = ACTIONS(2574),
    [anon_sym_COMMA] = ACTIONS(2576),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_SEMI] = ACTIONS(2576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_nil] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2574),
    [anon_sym_class] = ACTIONS(2574),
    [anon_sym_LT] = ACTIONS(2574),
    [anon_sym_module] = ACTIONS(2574),
    [anon_sym_return] = ACTIONS(2574),
    [anon_sym_yield] = ACTIONS(2574),
    [anon_sym_break] = ACTIONS(2574),
    [anon_sym_next] = ACTIONS(2574),
    [anon_sym_redo] = ACTIONS(2574),
    [anon_sym_retry] = ACTIONS(2574),
    [anon_sym_if] = ACTIONS(2574),
    [anon_sym_unless] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [anon_sym_until] = ACTIONS(2574),
    [anon_sym_for] = ACTIONS(2574),
    [anon_sym_in] = ACTIONS(2574),
    [anon_sym_do] = ACTIONS(2574),
    [anon_sym_case] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(2576),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_LPAREN2] = ACTIONS(2576),
    [anon_sym_DOT_DOT] = ACTIONS(2574),
    [anon_sym_CARET] = ACTIONS(2574),
    [anon_sym_begin] = ACTIONS(2574),
    [anon_sym_COLON_COLON2] = ACTIONS(2576),
    [anon_sym_AMP_DOT] = ACTIONS(2576),
    [anon_sym_PLUS_EQ] = ACTIONS(2576),
    [anon_sym_DASH_EQ] = ACTIONS(2576),
    [anon_sym_STAR_EQ] = ACTIONS(2576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2576),
    [anon_sym_SLASH_EQ] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2576),
    [anon_sym_PIPE_EQ] = ACTIONS(2576),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2576),
    [anon_sym_AMP_EQ] = ACTIONS(2576),
    [anon_sym_PERCENT_EQ] = ACTIONS(2576),
    [anon_sym_GT_GT_EQ] = ACTIONS(2576),
    [anon_sym_LT_LT_EQ] = ACTIONS(2576),
    [anon_sym_CARET_EQ] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(2574),
    [anon_sym_and] = ACTIONS(2574),
    [anon_sym_or] = ACTIONS(2574),
    [anon_sym_PIPE_PIPE] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_LT_LT] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2574),
    [anon_sym_LT_EQ] = ACTIONS(2574),
    [anon_sym_GT] = ACTIONS(2574),
    [anon_sym_GT_EQ] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2574),
    [anon_sym_EQ_EQ] = ACTIONS(2574),
    [anon_sym_BANG_EQ] = ACTIONS(2576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2576),
    [anon_sym_LT_EQ_GT] = ACTIONS(2576),
    [anon_sym_EQ_TILDE] = ACTIONS(2576),
    [anon_sym_BANG_TILDE] = ACTIONS(2576),
    [anon_sym_defined_QMARK] = ACTIONS(2576),
    [anon_sym_not] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2574),
    [sym_float] = ACTIONS(2574),
    [sym_super] = ACTIONS(2574),
    [sym_self] = ACTIONS(2574),
    [sym_true] = ACTIONS(2574),
    [sym_false] = ACTIONS(2574),
    [sym_constant] = ACTIONS(2574),
    [aux_sym_constant_suffix_token1] = ACTIONS(2576),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2574),
    [sym_instance_variable] = ACTIONS(2576),
    [sym_class_variable] = ACTIONS(2576),
    [sym_global_variable] = ACTIONS(2576),
    [sym_character] = ACTIONS(2576),
    [anon_sym_DASH_GT] = ACTIONS(2576),
    [sym__line_break] = ACTIONS(2576),
    [sym_simple_symbol] = ACTIONS(2576),
    [sym__string_start] = ACTIONS(2576),
    [sym__symbol_start] = ACTIONS(2576),
    [sym__subshell_start] = ACTIONS(2576),
    [sym__regex_start] = ACTIONS(2576),
    [sym__string_array_start] = ACTIONS(2576),
    [sym__symbol_array_start] = ACTIONS(2576),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2576),
    [sym__block_ampersand] = ACTIONS(2576),
    [sym__splat_star] = ACTIONS(2576),
    [sym__unary_minus] = ACTIONS(2576),
    [sym__unary_minus_num] = ACTIONS(2576),
    [sym__binary_minus] = ACTIONS(2576),
    [sym__binary_star] = ACTIONS(2576),
    [sym_hash_key_symbol] = ACTIONS(2576),
    [sym__identifier_suffix] = ACTIONS(2576),
    [sym__constant_suffix] = ACTIONS(2576),
    [sym__hash_splat_star_star] = ACTIONS(2576),
    [sym__binary_star_star] = ACTIONS(2576),
    [sym__element_reference_bracket] = ACTIONS(2576),
  },
  [1901] = {
    [sym_heredoc_body] = STATE(1901),
    [ts_builtin_sym_end] = ACTIONS(2572),
    [sym_identifier] = ACTIONS(2566),
    [aux_sym_program_token1] = ACTIONS(2572),
    [anon_sym___END__] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_DOT] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_rescue] = ACTIONS(2566),
    [anon_sym_EQ] = ACTIONS(2566),
    [anon_sym_COMMA] = ACTIONS(2572),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(2572),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_unless] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_until] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2566),
    [anon_sym_CARET] = ACTIONS(2566),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_COLON_COLON2] = ACTIONS(2572),
    [anon_sym_AMP_DOT] = ACTIONS(2572),
    [anon_sym_PLUS_EQ] = ACTIONS(2572),
    [anon_sym_DASH_EQ] = ACTIONS(2572),
    [anon_sym_STAR_EQ] = ACTIONS(2572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2572),
    [anon_sym_SLASH_EQ] = ACTIONS(2572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2572),
    [anon_sym_PIPE_EQ] = ACTIONS(2572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2572),
    [anon_sym_AMP_EQ] = ACTIONS(2572),
    [anon_sym_PERCENT_EQ] = ACTIONS(2572),
    [anon_sym_GT_GT_EQ] = ACTIONS(2572),
    [anon_sym_LT_LT_EQ] = ACTIONS(2572),
    [anon_sym_CARET_EQ] = ACTIONS(2572),
    [anon_sym_QMARK] = ACTIONS(2566),
    [anon_sym_and] = ACTIONS(2566),
    [anon_sym_or] = ACTIONS(2566),
    [anon_sym_PIPE_PIPE] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2566),
    [anon_sym_LT_EQ] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_EQ] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_SLASH] = ACTIONS(2566),
    [anon_sym_PERCENT] = ACTIONS(2566),
    [anon_sym_EQ_EQ] = ACTIONS(2566),
    [anon_sym_BANG_EQ] = ACTIONS(2572),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2572),
    [anon_sym_LT_EQ_GT] = ACTIONS(2572),
    [anon_sym_EQ_TILDE] = ACTIONS(2572),
    [anon_sym_BANG_TILDE] = ACTIONS(2572),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym__line_break] = ACTIONS(2572),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2572),
    [sym__binary_star] = ACTIONS(2572),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2572),
    [sym__element_reference_bracket] = ACTIONS(2572),
  },
  [1902] = {
    [sym_heredoc_body] = STATE(1902),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LBRACK2] = ACTIONS(2686),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1903] = {
    [sym_heredoc_body] = STATE(1903),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1904] = {
    [sym_heredoc_body] = STATE(1904),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2690),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1905] = {
    [sym_heredoc_body] = STATE(1905),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1906] = {
    [sym_heredoc_body] = STATE(1906),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1907] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5376),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(4891),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(4946),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1907),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [ts_builtin_sym_end] = ACTIONS(2598),
    [sym_identifier] = ACTIONS(2594),
    [aux_sym_program_token1] = ACTIONS(2598),
    [anon_sym___END__] = ACTIONS(2606),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2604),
    [anon_sym_rescue] = ACTIONS(2606),
    [anon_sym_EQ] = ACTIONS(2608),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(2606),
    [anon_sym_or] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2652),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym__line_break] = ACTIONS(2598),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1908] = {
    [sym_heredoc_body] = STATE(1908),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1909] = {
    [sym_heredoc_body] = STATE(1909),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2694),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1910] = {
    [sym_heredoc_body] = STATE(1910),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_rescue] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_unless] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_until] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_CARET] = ACTIONS(2570),
    [anon_sym_then] = ACTIONS(2570),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS_EQ] = ACTIONS(2568),
    [anon_sym_DASH_EQ] = ACTIONS(2568),
    [anon_sym_STAR_EQ] = ACTIONS(2568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2568),
    [anon_sym_SLASH_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2568),
    [anon_sym_AMP_EQ] = ACTIONS(2568),
    [anon_sym_PERCENT_EQ] = ACTIONS(2568),
    [anon_sym_GT_GT_EQ] = ACTIONS(2568),
    [anon_sym_LT_LT_EQ] = ACTIONS(2568),
    [anon_sym_CARET_EQ] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_EQ] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_EQ] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_EQ_EQ] = ACTIONS(2570),
    [anon_sym_BANG_EQ] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_LT_EQ_GT] = ACTIONS(2568),
    [anon_sym_EQ_TILDE] = ACTIONS(2568),
    [anon_sym_BANG_TILDE] = ACTIONS(2568),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym__line_break] = ACTIONS(2568),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__binary_star] = ACTIONS(2568),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [1911] = {
    [sym_heredoc_body] = STATE(1911),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2696),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym__line_break] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1912] = {
    [sym_heredoc_body] = STATE(1912),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_rescue] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_unless] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_until] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2570),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_CARET] = ACTIONS(2570),
    [anon_sym_then] = ACTIONS(2570),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS_EQ] = ACTIONS(2568),
    [anon_sym_DASH_EQ] = ACTIONS(2568),
    [anon_sym_STAR_EQ] = ACTIONS(2568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2568),
    [anon_sym_SLASH_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2568),
    [anon_sym_AMP_EQ] = ACTIONS(2568),
    [anon_sym_PERCENT_EQ] = ACTIONS(2568),
    [anon_sym_GT_GT_EQ] = ACTIONS(2568),
    [anon_sym_LT_LT_EQ] = ACTIONS(2568),
    [anon_sym_CARET_EQ] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_EQ] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_EQ] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_EQ_EQ] = ACTIONS(2570),
    [anon_sym_BANG_EQ] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_LT_EQ_GT] = ACTIONS(2568),
    [anon_sym_EQ_TILDE] = ACTIONS(2568),
    [anon_sym_BANG_TILDE] = ACTIONS(2568),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym__line_break] = ACTIONS(2568),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__binary_star] = ACTIONS(2568),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [1913] = {
    [sym_heredoc_body] = STATE(1913),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1914] = {
    [sym_heredoc_body] = STATE(1914),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2700),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1915] = {
    [sym_heredoc_body] = STATE(1915),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_PLUS_EQ] = ACTIONS(2580),
    [anon_sym_DASH_EQ] = ACTIONS(2580),
    [anon_sym_STAR_EQ] = ACTIONS(2580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2580),
    [anon_sym_SLASH_EQ] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2580),
    [anon_sym_PIPE_EQ] = ACTIONS(2580),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2580),
    [anon_sym_AMP_EQ] = ACTIONS(2580),
    [anon_sym_PERCENT_EQ] = ACTIONS(2580),
    [anon_sym_GT_GT_EQ] = ACTIONS(2580),
    [anon_sym_LT_LT_EQ] = ACTIONS(2580),
    [anon_sym_CARET_EQ] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2578),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_SLASH] = ACTIONS(2578),
    [anon_sym_PERCENT] = ACTIONS(2578),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1916] = {
    [sym_heredoc_body] = STATE(1916),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1917] = {
    [sym_heredoc_body] = STATE(1917),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LBRACK2] = ACTIONS(2686),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1918] = {
    [sym_heredoc_body] = STATE(1918),
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_def] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_rescue] = ACTIONS(2586),
    [anon_sym_EQ] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2586),
    [anon_sym_nil] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_next] = ACTIONS(2586),
    [anon_sym_redo] = ACTIONS(2586),
    [anon_sym_retry] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_unless] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_until] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_EQ_GT] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_RBRACK] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2588),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_CARET] = ACTIONS(2586),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_COLON_COLON2] = ACTIONS(2588),
    [anon_sym_AMP_DOT] = ACTIONS(2588),
    [anon_sym_PLUS_EQ] = ACTIONS(2588),
    [anon_sym_DASH_EQ] = ACTIONS(2588),
    [anon_sym_STAR_EQ] = ACTIONS(2588),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2588),
    [anon_sym_SLASH_EQ] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2588),
    [anon_sym_PIPE_EQ] = ACTIONS(2588),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2588),
    [anon_sym_AMP_EQ] = ACTIONS(2588),
    [anon_sym_PERCENT_EQ] = ACTIONS(2588),
    [anon_sym_GT_GT_EQ] = ACTIONS(2588),
    [anon_sym_LT_LT_EQ] = ACTIONS(2588),
    [anon_sym_CARET_EQ] = ACTIONS(2588),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_and] = ACTIONS(2586),
    [anon_sym_or] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_EQ] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_SLASH] = ACTIONS(2586),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_EQ_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT_EQ_GT] = ACTIONS(2588),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_BANG_TILDE] = ACTIONS(2588),
    [anon_sym_defined_QMARK] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2586),
    [sym_float] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_self] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_constant] = ACTIONS(2586),
    [aux_sym_constant_suffix_token1] = ACTIONS(2588),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2586),
    [sym_instance_variable] = ACTIONS(2588),
    [sym_class_variable] = ACTIONS(2588),
    [sym_global_variable] = ACTIONS(2588),
    [sym_character] = ACTIONS(2588),
    [anon_sym_DASH_GT] = ACTIONS(2588),
    [sym_simple_symbol] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__symbol_start] = ACTIONS(2588),
    [sym__subshell_start] = ACTIONS(2588),
    [sym__regex_start] = ACTIONS(2588),
    [sym__string_array_start] = ACTIONS(2588),
    [sym__symbol_array_start] = ACTIONS(2588),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2588),
    [sym__block_ampersand] = ACTIONS(2588),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(2588),
    [sym__unary_minus_num] = ACTIONS(2588),
    [sym__binary_minus] = ACTIONS(2588),
    [sym__binary_star] = ACTIONS(2588),
    [sym_hash_key_symbol] = ACTIONS(2588),
    [sym__identifier_suffix] = ACTIONS(2588),
    [sym__constant_suffix] = ACTIONS(2588),
    [sym__hash_splat_star_star] = ACTIONS(2588),
    [sym__binary_star_star] = ACTIONS(2588),
    [sym__element_reference_bracket] = ACTIONS(2588),
  },
  [1919] = {
    [sym_heredoc_body] = STATE(1919),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_EQ] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_PLUS_EQ] = ACTIONS(2584),
    [anon_sym_DASH_EQ] = ACTIONS(2584),
    [anon_sym_STAR_EQ] = ACTIONS(2584),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2584),
    [anon_sym_SLASH_EQ] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2584),
    [anon_sym_PIPE_EQ] = ACTIONS(2584),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2584),
    [anon_sym_AMP_EQ] = ACTIONS(2584),
    [anon_sym_PERCENT_EQ] = ACTIONS(2584),
    [anon_sym_GT_GT_EQ] = ACTIONS(2584),
    [anon_sym_LT_LT_EQ] = ACTIONS(2584),
    [anon_sym_CARET_EQ] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_PERCENT] = ACTIONS(2582),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1920] = {
    [sym_heredoc_body] = STATE(1920),
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_LBRACE] = ACTIONS(2576),
    [anon_sym_def] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_RPAREN] = ACTIONS(2576),
    [anon_sym_DOT] = ACTIONS(2574),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_rescue] = ACTIONS(2574),
    [anon_sym_EQ] = ACTIONS(2574),
    [anon_sym_COMMA] = ACTIONS(2576),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_nil] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2574),
    [anon_sym_class] = ACTIONS(2574),
    [anon_sym_LT] = ACTIONS(2574),
    [anon_sym_module] = ACTIONS(2574),
    [anon_sym_return] = ACTIONS(2574),
    [anon_sym_yield] = ACTIONS(2574),
    [anon_sym_break] = ACTIONS(2574),
    [anon_sym_next] = ACTIONS(2574),
    [anon_sym_redo] = ACTIONS(2574),
    [anon_sym_retry] = ACTIONS(2574),
    [anon_sym_if] = ACTIONS(2574),
    [anon_sym_unless] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [anon_sym_until] = ACTIONS(2574),
    [anon_sym_for] = ACTIONS(2574),
    [anon_sym_in] = ACTIONS(2574),
    [anon_sym_do] = ACTIONS(2574),
    [anon_sym_case] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(2576),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_RBRACK] = ACTIONS(2576),
    [anon_sym_LPAREN2] = ACTIONS(2576),
    [anon_sym_DOT_DOT] = ACTIONS(2574),
    [anon_sym_CARET] = ACTIONS(2574),
    [anon_sym_begin] = ACTIONS(2574),
    [anon_sym_COLON_COLON2] = ACTIONS(2576),
    [anon_sym_AMP_DOT] = ACTIONS(2576),
    [anon_sym_PLUS_EQ] = ACTIONS(2576),
    [anon_sym_DASH_EQ] = ACTIONS(2576),
    [anon_sym_STAR_EQ] = ACTIONS(2576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2576),
    [anon_sym_SLASH_EQ] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2576),
    [anon_sym_PIPE_EQ] = ACTIONS(2576),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2576),
    [anon_sym_AMP_EQ] = ACTIONS(2576),
    [anon_sym_PERCENT_EQ] = ACTIONS(2576),
    [anon_sym_GT_GT_EQ] = ACTIONS(2576),
    [anon_sym_LT_LT_EQ] = ACTIONS(2576),
    [anon_sym_CARET_EQ] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(2574),
    [anon_sym_and] = ACTIONS(2574),
    [anon_sym_or] = ACTIONS(2574),
    [anon_sym_PIPE_PIPE] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_LT_LT] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2574),
    [anon_sym_LT_EQ] = ACTIONS(2574),
    [anon_sym_GT] = ACTIONS(2574),
    [anon_sym_GT_EQ] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2574),
    [anon_sym_EQ_EQ] = ACTIONS(2574),
    [anon_sym_BANG_EQ] = ACTIONS(2576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2576),
    [anon_sym_LT_EQ_GT] = ACTIONS(2576),
    [anon_sym_EQ_TILDE] = ACTIONS(2576),
    [anon_sym_BANG_TILDE] = ACTIONS(2576),
    [anon_sym_defined_QMARK] = ACTIONS(2576),
    [anon_sym_not] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2574),
    [sym_float] = ACTIONS(2574),
    [sym_super] = ACTIONS(2574),
    [sym_self] = ACTIONS(2574),
    [sym_true] = ACTIONS(2574),
    [sym_false] = ACTIONS(2574),
    [sym_constant] = ACTIONS(2574),
    [aux_sym_constant_suffix_token1] = ACTIONS(2576),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2574),
    [sym_instance_variable] = ACTIONS(2576),
    [sym_class_variable] = ACTIONS(2576),
    [sym_global_variable] = ACTIONS(2576),
    [sym_character] = ACTIONS(2576),
    [anon_sym_DASH_GT] = ACTIONS(2576),
    [sym_simple_symbol] = ACTIONS(2576),
    [sym__string_start] = ACTIONS(2576),
    [sym__symbol_start] = ACTIONS(2576),
    [sym__subshell_start] = ACTIONS(2576),
    [sym__regex_start] = ACTIONS(2576),
    [sym__string_array_start] = ACTIONS(2576),
    [sym__symbol_array_start] = ACTIONS(2576),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2576),
    [sym__block_ampersand] = ACTIONS(2576),
    [sym__splat_star] = ACTIONS(2576),
    [sym__unary_minus] = ACTIONS(2576),
    [sym__unary_minus_num] = ACTIONS(2576),
    [sym__binary_minus] = ACTIONS(2576),
    [sym__binary_star] = ACTIONS(2576),
    [sym_hash_key_symbol] = ACTIONS(2576),
    [sym__identifier_suffix] = ACTIONS(2576),
    [sym__constant_suffix] = ACTIONS(2576),
    [sym__hash_splat_star_star] = ACTIONS(2576),
    [sym__binary_star_star] = ACTIONS(2576),
    [sym__element_reference_bracket] = ACTIONS(2576),
  },
  [1921] = {
    [sym_heredoc_body] = STATE(1921),
    [sym_identifier] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_def] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_rescue] = ACTIONS(2590),
    [anon_sym_EQ] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_nil] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_yield] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_next] = ACTIONS(2590),
    [anon_sym_redo] = ACTIONS(2590),
    [anon_sym_retry] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_unless] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_until] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_EQ_GT] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_RBRACK] = ACTIONS(2592),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_begin] = ACTIONS(2590),
    [anon_sym_COLON_COLON2] = ACTIONS(2592),
    [anon_sym_AMP_DOT] = ACTIONS(2592),
    [anon_sym_PLUS_EQ] = ACTIONS(2592),
    [anon_sym_DASH_EQ] = ACTIONS(2592),
    [anon_sym_STAR_EQ] = ACTIONS(2592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2592),
    [anon_sym_SLASH_EQ] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2592),
    [anon_sym_PIPE_EQ] = ACTIONS(2592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2592),
    [anon_sym_AMP_EQ] = ACTIONS(2592),
    [anon_sym_PERCENT_EQ] = ACTIONS(2592),
    [anon_sym_GT_GT_EQ] = ACTIONS(2592),
    [anon_sym_LT_LT_EQ] = ACTIONS(2592),
    [anon_sym_CARET_EQ] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_and] = ACTIONS(2590),
    [anon_sym_or] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2590),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2592),
    [anon_sym_LT_EQ_GT] = ACTIONS(2592),
    [anon_sym_EQ_TILDE] = ACTIONS(2592),
    [anon_sym_BANG_TILDE] = ACTIONS(2592),
    [anon_sym_defined_QMARK] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2590),
    [sym_float] = ACTIONS(2590),
    [sym_super] = ACTIONS(2590),
    [sym_self] = ACTIONS(2590),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_constant] = ACTIONS(2590),
    [aux_sym_constant_suffix_token1] = ACTIONS(2592),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2590),
    [sym_instance_variable] = ACTIONS(2592),
    [sym_class_variable] = ACTIONS(2592),
    [sym_global_variable] = ACTIONS(2592),
    [sym_character] = ACTIONS(2592),
    [anon_sym_DASH_GT] = ACTIONS(2592),
    [sym_simple_symbol] = ACTIONS(2592),
    [sym__string_start] = ACTIONS(2592),
    [sym__symbol_start] = ACTIONS(2592),
    [sym__subshell_start] = ACTIONS(2592),
    [sym__regex_start] = ACTIONS(2592),
    [sym__string_array_start] = ACTIONS(2592),
    [sym__symbol_array_start] = ACTIONS(2592),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2592),
    [sym__block_ampersand] = ACTIONS(2592),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(2592),
    [sym__unary_minus_num] = ACTIONS(2592),
    [sym__binary_minus] = ACTIONS(2592),
    [sym__binary_star] = ACTIONS(2592),
    [sym_hash_key_symbol] = ACTIONS(2592),
    [sym__identifier_suffix] = ACTIONS(2592),
    [sym__constant_suffix] = ACTIONS(2592),
    [sym__hash_splat_star_star] = ACTIONS(2592),
    [sym__binary_star_star] = ACTIONS(2592),
    [sym__element_reference_bracket] = ACTIONS(2592),
  },
  [1922] = {
    [sym_heredoc_body] = STATE(1922),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_RPAREN] = ACTIONS(2568),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_rescue] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_unless] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_until] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2570),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_RBRACK] = ACTIONS(2568),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_CARET] = ACTIONS(2570),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS_EQ] = ACTIONS(2568),
    [anon_sym_DASH_EQ] = ACTIONS(2568),
    [anon_sym_STAR_EQ] = ACTIONS(2568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2568),
    [anon_sym_SLASH_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2568),
    [anon_sym_AMP_EQ] = ACTIONS(2568),
    [anon_sym_PERCENT_EQ] = ACTIONS(2568),
    [anon_sym_GT_GT_EQ] = ACTIONS(2568),
    [anon_sym_LT_LT_EQ] = ACTIONS(2568),
    [anon_sym_CARET_EQ] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_EQ] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_EQ] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_EQ_EQ] = ACTIONS(2570),
    [anon_sym_BANG_EQ] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_LT_EQ_GT] = ACTIONS(2568),
    [anon_sym_EQ_TILDE] = ACTIONS(2568),
    [anon_sym_BANG_TILDE] = ACTIONS(2568),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__binary_star] = ACTIONS(2568),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [1923] = {
    [sym_heredoc_body] = STATE(1923),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_RPAREN] = ACTIONS(2568),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_rescue] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_unless] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_until] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_RBRACK] = ACTIONS(2568),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_CARET] = ACTIONS(2570),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS_EQ] = ACTIONS(2568),
    [anon_sym_DASH_EQ] = ACTIONS(2568),
    [anon_sym_STAR_EQ] = ACTIONS(2568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2568),
    [anon_sym_SLASH_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2568),
    [anon_sym_AMP_EQ] = ACTIONS(2568),
    [anon_sym_PERCENT_EQ] = ACTIONS(2568),
    [anon_sym_GT_GT_EQ] = ACTIONS(2568),
    [anon_sym_LT_LT_EQ] = ACTIONS(2568),
    [anon_sym_CARET_EQ] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_EQ] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_EQ] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_EQ_EQ] = ACTIONS(2570),
    [anon_sym_BANG_EQ] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_LT_EQ_GT] = ACTIONS(2568),
    [anon_sym_EQ_TILDE] = ACTIONS(2568),
    [anon_sym_BANG_TILDE] = ACTIONS(2568),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__binary_star] = ACTIONS(2568),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [1924] = {
    [sym_heredoc_body] = STATE(1924),
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2564),
    [anon_sym_def] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_rescue] = ACTIONS(2562),
    [anon_sym_EQ] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2564),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_nil] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2562),
    [anon_sym_class] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_yield] = ACTIONS(2562),
    [anon_sym_break] = ACTIONS(2562),
    [anon_sym_next] = ACTIONS(2562),
    [anon_sym_redo] = ACTIONS(2562),
    [anon_sym_retry] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_unless] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [anon_sym_until] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_case] = ACTIONS(2562),
    [anon_sym_EQ_GT] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_RBRACK] = ACTIONS(2564),
    [anon_sym_LPAREN2] = ACTIONS(2564),
    [anon_sym_DOT_DOT] = ACTIONS(2562),
    [anon_sym_CARET] = ACTIONS(2562),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_COLON_COLON2] = ACTIONS(2564),
    [anon_sym_AMP_DOT] = ACTIONS(2564),
    [anon_sym_PLUS_EQ] = ACTIONS(2564),
    [anon_sym_DASH_EQ] = ACTIONS(2564),
    [anon_sym_STAR_EQ] = ACTIONS(2564),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2564),
    [anon_sym_SLASH_EQ] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2564),
    [anon_sym_PIPE_EQ] = ACTIONS(2564),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2564),
    [anon_sym_AMP_EQ] = ACTIONS(2564),
    [anon_sym_PERCENT_EQ] = ACTIONS(2564),
    [anon_sym_GT_GT_EQ] = ACTIONS(2564),
    [anon_sym_LT_LT_EQ] = ACTIONS(2564),
    [anon_sym_CARET_EQ] = ACTIONS(2564),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_and] = ACTIONS(2562),
    [anon_sym_or] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_EQ] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_GT_EQ] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_SLASH] = ACTIONS(2562),
    [anon_sym_PERCENT] = ACTIONS(2562),
    [anon_sym_EQ_EQ] = ACTIONS(2562),
    [anon_sym_BANG_EQ] = ACTIONS(2564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2564),
    [anon_sym_LT_EQ_GT] = ACTIONS(2564),
    [anon_sym_EQ_TILDE] = ACTIONS(2564),
    [anon_sym_BANG_TILDE] = ACTIONS(2564),
    [anon_sym_defined_QMARK] = ACTIONS(2564),
    [anon_sym_not] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2562),
    [sym_float] = ACTIONS(2562),
    [sym_super] = ACTIONS(2562),
    [sym_self] = ACTIONS(2562),
    [sym_true] = ACTIONS(2562),
    [sym_false] = ACTIONS(2562),
    [sym_constant] = ACTIONS(2562),
    [aux_sym_constant_suffix_token1] = ACTIONS(2564),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2562),
    [sym_instance_variable] = ACTIONS(2564),
    [sym_class_variable] = ACTIONS(2564),
    [sym_global_variable] = ACTIONS(2564),
    [sym_character] = ACTIONS(2564),
    [anon_sym_DASH_GT] = ACTIONS(2564),
    [sym_simple_symbol] = ACTIONS(2564),
    [sym__string_start] = ACTIONS(2564),
    [sym__symbol_start] = ACTIONS(2564),
    [sym__subshell_start] = ACTIONS(2564),
    [sym__regex_start] = ACTIONS(2564),
    [sym__string_array_start] = ACTIONS(2564),
    [sym__symbol_array_start] = ACTIONS(2564),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2564),
    [sym__block_ampersand] = ACTIONS(2564),
    [sym__splat_star] = ACTIONS(2564),
    [sym__unary_minus] = ACTIONS(2564),
    [sym__unary_minus_num] = ACTIONS(2564),
    [sym__binary_minus] = ACTIONS(2564),
    [sym__binary_star] = ACTIONS(2564),
    [sym_hash_key_symbol] = ACTIONS(2564),
    [sym__identifier_suffix] = ACTIONS(2564),
    [sym__constant_suffix] = ACTIONS(2564),
    [sym__hash_splat_star_star] = ACTIONS(2564),
    [sym__binary_star_star] = ACTIONS(2564),
    [sym__element_reference_bracket] = ACTIONS(2564),
  },
  [1925] = {
    [sym_heredoc_body] = STATE(1925),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2702),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1926] = {
    [sym_heredoc_body] = STATE(1926),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_rescue] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_unless] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [anon_sym_until] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2570),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_CARET] = ACTIONS(2570),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS_EQ] = ACTIONS(2568),
    [anon_sym_DASH_EQ] = ACTIONS(2568),
    [anon_sym_STAR_EQ] = ACTIONS(2568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2568),
    [anon_sym_SLASH_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2568),
    [anon_sym_AMP_EQ] = ACTIONS(2568),
    [anon_sym_PERCENT_EQ] = ACTIONS(2568),
    [anon_sym_GT_GT_EQ] = ACTIONS(2568),
    [anon_sym_LT_LT_EQ] = ACTIONS(2568),
    [anon_sym_CARET_EQ] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_EQ] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_EQ] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_EQ_EQ] = ACTIONS(2570),
    [anon_sym_BANG_EQ] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_LT_EQ_GT] = ACTIONS(2568),
    [anon_sym_EQ_TILDE] = ACTIONS(2568),
    [anon_sym_BANG_TILDE] = ACTIONS(2568),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym__line_break] = ACTIONS(2568),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__binary_star] = ACTIONS(2568),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [1927] = {
    [sym_heredoc_body] = STATE(1927),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_def] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_RPAREN] = ACTIONS(2572),
    [anon_sym_DOT] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_rescue] = ACTIONS(2566),
    [anon_sym_EQ] = ACTIONS(2566),
    [anon_sym_COMMA] = ACTIONS(2572),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_nil] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_next] = ACTIONS(2566),
    [anon_sym_redo] = ACTIONS(2566),
    [anon_sym_retry] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_unless] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_until] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_RBRACK] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2566),
    [anon_sym_CARET] = ACTIONS(2566),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_COLON_COLON2] = ACTIONS(2572),
    [anon_sym_AMP_DOT] = ACTIONS(2572),
    [anon_sym_PLUS_EQ] = ACTIONS(2572),
    [anon_sym_DASH_EQ] = ACTIONS(2572),
    [anon_sym_STAR_EQ] = ACTIONS(2572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2572),
    [anon_sym_SLASH_EQ] = ACTIONS(2572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2572),
    [anon_sym_PIPE_EQ] = ACTIONS(2572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2572),
    [anon_sym_AMP_EQ] = ACTIONS(2572),
    [anon_sym_PERCENT_EQ] = ACTIONS(2572),
    [anon_sym_GT_GT_EQ] = ACTIONS(2572),
    [anon_sym_LT_LT_EQ] = ACTIONS(2572),
    [anon_sym_CARET_EQ] = ACTIONS(2572),
    [anon_sym_QMARK] = ACTIONS(2566),
    [anon_sym_and] = ACTIONS(2566),
    [anon_sym_or] = ACTIONS(2566),
    [anon_sym_PIPE_PIPE] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2566),
    [anon_sym_LT_EQ] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_EQ] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_SLASH] = ACTIONS(2566),
    [anon_sym_PERCENT] = ACTIONS(2566),
    [anon_sym_EQ_EQ] = ACTIONS(2566),
    [anon_sym_BANG_EQ] = ACTIONS(2572),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2572),
    [anon_sym_LT_EQ_GT] = ACTIONS(2572),
    [anon_sym_EQ_TILDE] = ACTIONS(2572),
    [anon_sym_BANG_TILDE] = ACTIONS(2572),
    [anon_sym_defined_QMARK] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2566),
    [sym_float] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_self] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_constant] = ACTIONS(2566),
    [aux_sym_constant_suffix_token1] = ACTIONS(2572),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2566),
    [sym_instance_variable] = ACTIONS(2572),
    [sym_class_variable] = ACTIONS(2572),
    [sym_global_variable] = ACTIONS(2572),
    [sym_character] = ACTIONS(2572),
    [anon_sym_DASH_GT] = ACTIONS(2572),
    [sym_simple_symbol] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__symbol_start] = ACTIONS(2572),
    [sym__subshell_start] = ACTIONS(2572),
    [sym__regex_start] = ACTIONS(2572),
    [sym__string_array_start] = ACTIONS(2572),
    [sym__symbol_array_start] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2572),
    [sym__block_ampersand] = ACTIONS(2572),
    [sym__splat_star] = ACTIONS(2572),
    [sym__unary_minus] = ACTIONS(2572),
    [sym__unary_minus_num] = ACTIONS(2572),
    [sym__binary_minus] = ACTIONS(2572),
    [sym__binary_star] = ACTIONS(2572),
    [sym_hash_key_symbol] = ACTIONS(2572),
    [sym__identifier_suffix] = ACTIONS(2572),
    [sym__constant_suffix] = ACTIONS(2572),
    [sym__hash_splat_star_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2572),
    [sym__element_reference_bracket] = ACTIONS(2572),
  },
  [1928] = {
    [sym_heredoc_body] = STATE(1928),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1929] = {
    [sym_heredoc_body] = STATE(1929),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1930] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5376),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(4891),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(4946),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1930),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2704),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2598),
    [anon_sym_COLON_COLON] = ACTIONS(2604),
    [anon_sym_rescue] = ACTIONS(2606),
    [anon_sym_EQ] = ACTIONS(2608),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_RBRACK] = ACTIONS(2598),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_and] = ACTIONS(2606),
    [anon_sym_or] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2652),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1931] = {
    [sym_heredoc_body] = STATE(1931),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(733),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(733),
    [anon_sym_nil] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_next] = ACTIONS(733),
    [anon_sym_redo] = ACTIONS(733),
    [anon_sym_retry] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_begin] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_defined_QMARK] = ACTIONS(745),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(733),
    [sym_float] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_self] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_constant] = ACTIONS(733),
    [aux_sym_constant_suffix_token1] = ACTIONS(745),
    [aux_sym_identifier_suffix_token1] = ACTIONS(733),
    [sym_instance_variable] = ACTIONS(745),
    [sym_class_variable] = ACTIONS(745),
    [sym_global_variable] = ACTIONS(745),
    [sym_character] = ACTIONS(745),
    [anon_sym_DASH_GT] = ACTIONS(745),
    [sym_simple_symbol] = ACTIONS(745),
    [sym__string_start] = ACTIONS(745),
    [sym__symbol_start] = ACTIONS(745),
    [sym__subshell_start] = ACTIONS(745),
    [sym__regex_start] = ACTIONS(745),
    [sym__string_array_start] = ACTIONS(745),
    [sym__symbol_array_start] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(745),
    [sym__block_ampersand] = ACTIONS(745),
    [sym__splat_star] = ACTIONS(745),
    [sym__unary_minus] = ACTIONS(745),
    [sym__unary_minus_num] = ACTIONS(745),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym_hash_key_symbol] = ACTIONS(745),
    [sym__identifier_suffix] = ACTIONS(745),
    [sym__constant_suffix] = ACTIONS(745),
    [sym__hash_splat_star_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [1932] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5376),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(4891),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym_destructured_left_assignment] = STATE(5397),
    [sym_rest_assignment] = STATE(5397),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(4887),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1932),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_RPAREN] = ACTIONS(2708),
    [anon_sym_COLON_COLON] = ACTIONS(2604),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2710),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2652),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1933] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5376),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(4891),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym_destructured_left_assignment] = STATE(5397),
    [sym_rest_assignment] = STATE(5397),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(4887),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1933),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_RPAREN] = ACTIONS(2712),
    [anon_sym_COLON_COLON] = ACTIONS(2604),
    [anon_sym_EQ] = ACTIONS(2712),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2714),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2652),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1934] = {
    [sym_heredoc_body] = STATE(1934),
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_def] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_end] = ACTIONS(2586),
    [anon_sym_rescue] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_nil] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_COLON] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_next] = ACTIONS(2586),
    [anon_sym_redo] = ACTIONS(2586),
    [anon_sym_retry] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_unless] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_until] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_when] = ACTIONS(2586),
    [anon_sym_EQ_GT] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2588),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_CARET] = ACTIONS(2588),
    [anon_sym_elsif] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2586),
    [anon_sym_then] = ACTIONS(2586),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_ensure] = ACTIONS(2586),
    [anon_sym_COLON_COLON2] = ACTIONS(2588),
    [anon_sym_AMP_DOT] = ACTIONS(2588),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_and] = ACTIONS(2586),
    [anon_sym_or] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_EQ] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT_EQ_GT] = ACTIONS(2588),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_BANG_TILDE] = ACTIONS(2588),
    [anon_sym_defined_QMARK] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2586),
    [sym_float] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_self] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_constant] = ACTIONS(2586),
    [aux_sym_constant_suffix_token1] = ACTIONS(2588),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2586),
    [sym_instance_variable] = ACTIONS(2588),
    [sym_class_variable] = ACTIONS(2588),
    [sym_global_variable] = ACTIONS(2588),
    [sym_character] = ACTIONS(2588),
    [anon_sym_DASH_GT] = ACTIONS(2588),
    [sym__line_break] = ACTIONS(2588),
    [sym_simple_symbol] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__symbol_start] = ACTIONS(2588),
    [sym__subshell_start] = ACTIONS(2588),
    [sym__regex_start] = ACTIONS(2588),
    [sym__string_array_start] = ACTIONS(2588),
    [sym__symbol_array_start] = ACTIONS(2588),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2588),
    [sym__block_ampersand] = ACTIONS(2588),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(2588),
    [sym__unary_minus_num] = ACTIONS(2588),
    [sym__binary_minus] = ACTIONS(2588),
    [sym__binary_star] = ACTIONS(2588),
    [sym_hash_key_symbol] = ACTIONS(2588),
    [sym__identifier_suffix] = ACTIONS(2588),
    [sym__constant_suffix] = ACTIONS(2588),
    [sym__hash_splat_star_star] = ACTIONS(2588),
    [sym__binary_star_star] = ACTIONS(2588),
    [sym__element_reference_bracket] = ACTIONS(2588),
  },
  [1935] = {
    [sym_heredoc_body] = STATE(1935),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_end] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_when] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_elsif] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_then] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_ensure] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1936] = {
    [sym_heredoc_body] = STATE(1936),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_end] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2558),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_when] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_elsif] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_then] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_ensure] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1937] = {
    [sym_heredoc_body] = STATE(1937),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_end] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2558),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_when] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_elsif] = ACTIONS(2578),
    [anon_sym_else] = ACTIONS(2578),
    [anon_sym_then] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_ensure] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1938] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5376),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(4891),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym_left_assignment_list] = STATE(5507),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(4934),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1938),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_COLON_COLON] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2652),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1939] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5376),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(4891),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym_left_assignment_list] = STATE(5550),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(4870),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1939),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_COLON_COLON] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2652),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1940] = {
    [sym_heredoc_body] = STATE(1940),
    [sym_identifier] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_RBRACE] = ACTIONS(2592),
    [anon_sym_def] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_end] = ACTIONS(2590),
    [anon_sym_rescue] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_nil] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_yield] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_next] = ACTIONS(2590),
    [anon_sym_redo] = ACTIONS(2590),
    [anon_sym_retry] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_unless] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_until] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_when] = ACTIONS(2590),
    [anon_sym_EQ_GT] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_CARET] = ACTIONS(2592),
    [anon_sym_elsif] = ACTIONS(2590),
    [anon_sym_else] = ACTIONS(2590),
    [anon_sym_then] = ACTIONS(2590),
    [anon_sym_begin] = ACTIONS(2590),
    [anon_sym_ensure] = ACTIONS(2590),
    [anon_sym_COLON_COLON2] = ACTIONS(2592),
    [anon_sym_AMP_DOT] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_and] = ACTIONS(2590),
    [anon_sym_or] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_LT_LT] = ACTIONS(2592),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2592),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2592),
    [anon_sym_LT_EQ_GT] = ACTIONS(2592),
    [anon_sym_EQ_TILDE] = ACTIONS(2592),
    [anon_sym_BANG_TILDE] = ACTIONS(2592),
    [anon_sym_defined_QMARK] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2590),
    [sym_float] = ACTIONS(2590),
    [sym_super] = ACTIONS(2590),
    [sym_self] = ACTIONS(2590),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_constant] = ACTIONS(2590),
    [aux_sym_constant_suffix_token1] = ACTIONS(2592),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2590),
    [sym_instance_variable] = ACTIONS(2592),
    [sym_class_variable] = ACTIONS(2592),
    [sym_global_variable] = ACTIONS(2592),
    [sym_character] = ACTIONS(2592),
    [anon_sym_DASH_GT] = ACTIONS(2592),
    [sym__line_break] = ACTIONS(2592),
    [sym_simple_symbol] = ACTIONS(2592),
    [sym__string_start] = ACTIONS(2592),
    [sym__symbol_start] = ACTIONS(2592),
    [sym__subshell_start] = ACTIONS(2592),
    [sym__regex_start] = ACTIONS(2592),
    [sym__string_array_start] = ACTIONS(2592),
    [sym__symbol_array_start] = ACTIONS(2592),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2592),
    [sym__block_ampersand] = ACTIONS(2592),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(2592),
    [sym__unary_minus_num] = ACTIONS(2592),
    [sym__binary_minus] = ACTIONS(2592),
    [sym__binary_star] = ACTIONS(2592),
    [sym_hash_key_symbol] = ACTIONS(2592),
    [sym__identifier_suffix] = ACTIONS(2592),
    [sym__constant_suffix] = ACTIONS(2592),
    [sym__hash_splat_star_star] = ACTIONS(2592),
    [sym__binary_star_star] = ACTIONS(2592),
    [sym__element_reference_bracket] = ACTIONS(2592),
  },
  [1941] = {
    [sym_heredoc_body] = STATE(1941),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_end] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2560),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_when] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_elsif] = ACTIONS(2578),
    [anon_sym_else] = ACTIONS(2578),
    [anon_sym_then] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_ensure] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1942] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5376),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(4891),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym_left_assignment_list] = STATE(5494),
    [sym__mlhs] = STATE(5508),
    [sym_destructured_left_assignment] = STATE(5186),
    [sym_rest_assignment] = STATE(5186),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(4885),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1942),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_COLON_COLON] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2652),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1943] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5376),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(4891),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(4946),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1943),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2608),
    [anon_sym_COLON_COLON] = ACTIONS(2604),
    [anon_sym_EQ] = ACTIONS(2608),
    [anon_sym_COMMA] = ACTIONS(2608),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2716),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2652),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1944] = {
    [sym_heredoc_body] = STATE(1944),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_end] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_when] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_elsif] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_then] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_ensure] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1945] = {
    [sym_heredoc_body] = STATE(1945),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_end] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_when] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_elsif] = ACTIONS(2578),
    [anon_sym_else] = ACTIONS(2578),
    [anon_sym_then] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_ensure] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1946] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5376),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(4891),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym_destructured_left_assignment] = STATE(5397),
    [sym_rest_assignment] = STATE(5397),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(4887),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1946),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_COLON_COLON] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(31),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2652),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1947] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5311),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(128),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(5325),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1947),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2718),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2720),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2722),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1948] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5311),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(131),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(5325),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1948),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2718),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2724),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2726),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1949] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5311),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(130),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(5325),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1949),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2718),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2728),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2730),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1950] = {
    [sym_heredoc_body] = STATE(1950),
    [ts_builtin_sym_end] = ACTIONS(2588),
    [sym_identifier] = ACTIONS(2586),
    [aux_sym_program_token1] = ACTIONS(2588),
    [anon_sym___END__] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_def] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_rescue] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_nil] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_COLON] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_next] = ACTIONS(2586),
    [anon_sym_redo] = ACTIONS(2586),
    [anon_sym_retry] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_unless] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_until] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_EQ_GT] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2588),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_CARET] = ACTIONS(2588),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_COLON_COLON2] = ACTIONS(2588),
    [anon_sym_AMP_DOT] = ACTIONS(2588),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_and] = ACTIONS(2586),
    [anon_sym_or] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_EQ] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT_EQ_GT] = ACTIONS(2588),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_BANG_TILDE] = ACTIONS(2588),
    [anon_sym_defined_QMARK] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2586),
    [sym_float] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_self] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_constant] = ACTIONS(2586),
    [aux_sym_constant_suffix_token1] = ACTIONS(2588),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2586),
    [sym_instance_variable] = ACTIONS(2588),
    [sym_class_variable] = ACTIONS(2588),
    [sym_global_variable] = ACTIONS(2588),
    [sym_character] = ACTIONS(2588),
    [anon_sym_DASH_GT] = ACTIONS(2588),
    [sym__line_break] = ACTIONS(2588),
    [sym_simple_symbol] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__symbol_start] = ACTIONS(2588),
    [sym__subshell_start] = ACTIONS(2588),
    [sym__regex_start] = ACTIONS(2588),
    [sym__string_array_start] = ACTIONS(2588),
    [sym__symbol_array_start] = ACTIONS(2588),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2588),
    [sym__block_ampersand] = ACTIONS(2588),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(2588),
    [sym__unary_minus_num] = ACTIONS(2588),
    [sym__binary_minus] = ACTIONS(2588),
    [sym__binary_star] = ACTIONS(2588),
    [sym_hash_key_symbol] = ACTIONS(2588),
    [sym__identifier_suffix] = ACTIONS(2588),
    [sym__constant_suffix] = ACTIONS(2588),
    [sym__hash_splat_star_star] = ACTIONS(2588),
    [sym__binary_star_star] = ACTIONS(2588),
    [sym__element_reference_bracket] = ACTIONS(2588),
  },
  [1951] = {
    [sym_heredoc_body] = STATE(1951),
    [ts_builtin_sym_end] = ACTIONS(2580),
    [sym_identifier] = ACTIONS(2578),
    [aux_sym_program_token1] = ACTIONS(2580),
    [anon_sym___END__] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2682),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1952] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5311),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(132),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(5325),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1952),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2718),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2732),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1953] = {
    [sym_heredoc_body] = STATE(1953),
    [ts_builtin_sym_end] = ACTIONS(2584),
    [sym_identifier] = ACTIONS(2582),
    [aux_sym_program_token1] = ACTIONS(2584),
    [anon_sym___END__] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2682),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1954] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5311),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(133),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(5325),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1954),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2718),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2734),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1955] = {
    [sym_heredoc_body] = STATE(1955),
    [ts_builtin_sym_end] = ACTIONS(2580),
    [sym_identifier] = ACTIONS(2578),
    [aux_sym_program_token1] = ACTIONS(2580),
    [anon_sym___END__] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1956] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5311),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(4891),
    [sym_scope_resolution] = STATE(134),
    [sym__call] = STATE(4597),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(5325),
    [sym__variable] = STATE(4586),
    [sym__nonlocal_variable] = STATE(4693),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(4891),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1956),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2718),
    [anon_sym_nil] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2652),
    [sym_self] = ACTIONS(2652),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_constant] = ACTIONS(2736),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2660),
    [sym_class_variable] = ACTIONS(2660),
    [sym_global_variable] = ACTIONS(2660),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1957] = {
    [sym_method] = STATE(5325),
    [sym_singleton_method] = STATE(5325),
    [sym_class] = STATE(5325),
    [sym_singleton_class] = STATE(5325),
    [sym_module] = STATE(5325),
    [sym_return] = STATE(5325),
    [sym_yield] = STATE(5325),
    [sym_break] = STATE(5325),
    [sym_next] = STATE(5325),
    [sym_redo] = STATE(5325),
    [sym_retry] = STATE(5325),
    [sym_while] = STATE(5325),
    [sym_until] = STATE(5325),
    [sym_for] = STATE(5325),
    [sym_case] = STATE(5325),
    [sym_case_match] = STATE(5325),
    [sym_if] = STATE(5325),
    [sym_unless] = STATE(5325),
    [sym_begin] = STATE(5325),
    [sym__primary] = STATE(5326),
    [sym_parenthesized_statements] = STATE(5325),
    [sym_element_reference] = STATE(5008),
    [sym_scope_resolution] = STATE(5008),
    [sym__call] = STATE(4653),
    [sym_call] = STATE(5325),
    [sym_parenthesized_unary] = STATE(5325),
    [sym_unary_literal] = STATE(5367),
    [sym__literal] = STATE(5325),
    [sym__numeric] = STATE(5314),
    [sym__simple_numeric] = STATE(5367),
    [sym__function_identifier] = STATE(4770),
    [sym__function_identifier_call] = STATE(5404),
    [sym__lhs] = STATE(4998),
    [sym__variable] = STATE(4655),
    [sym__nonlocal_variable] = STATE(4786),
    [sym__int_or_float] = STATE(5449),
    [sym_complex] = STATE(5223),
    [sym_rational] = STATE(5223),
    [sym_nil] = STATE(5008),
    [sym_constant_suffix] = STATE(4749),
    [sym_identifier_suffix] = STATE(4757),
    [sym_chained_string] = STATE(5325),
    [sym_string] = STATE(4961),
    [sym_subshell] = STATE(5325),
    [sym_string_array] = STATE(5325),
    [sym_symbol_array] = STATE(5325),
    [sym_delimited_symbol] = STATE(5314),
    [sym_regex] = STATE(5325),
    [sym_heredoc_body] = STATE(1957),
    [sym_array] = STATE(5325),
    [sym_hash] = STATE(5325),
    [sym_lambda] = STATE(5325),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_def] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_nil] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_next] = ACTIONS(2622),
    [anon_sym_redo] = ACTIONS(2624),
    [anon_sym_retry] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_unless] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_until] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_begin] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_defined_QMARK] = ACTIONS(2646),
    [anon_sym_not] = ACTIONS(2648),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2650),
    [sym_float] = ACTIONS(2650),
    [sym_super] = ACTIONS(2738),
    [sym_self] = ACTIONS(2738),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_constant] = ACTIONS(2738),
    [aux_sym_constant_suffix_token1] = ACTIONS(2656),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2658),
    [sym_instance_variable] = ACTIONS(2746),
    [sym_class_variable] = ACTIONS(2746),
    [sym_global_variable] = ACTIONS(2746),
    [sym_character] = ACTIONS(2662),
    [anon_sym_DASH_GT] = ACTIONS(2664),
    [sym_simple_symbol] = ACTIONS(2666),
    [sym__string_start] = ACTIONS(2668),
    [sym__symbol_start] = ACTIONS(2670),
    [sym__subshell_start] = ACTIONS(2672),
    [sym__regex_start] = ACTIONS(2674),
    [sym__string_array_start] = ACTIONS(2676),
    [sym__symbol_array_start] = ACTIONS(2678),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2662),
    [sym__unary_minus_num] = ACTIONS(2644),
    [sym__identifier_suffix] = ACTIONS(2680),
    [sym__constant_suffix] = ACTIONS(2656),
  },
  [1958] = {
    [sym_heredoc_body] = STATE(1958),
    [ts_builtin_sym_end] = ACTIONS(2592),
    [sym_identifier] = ACTIONS(2590),
    [aux_sym_program_token1] = ACTIONS(2592),
    [anon_sym___END__] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_def] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_rescue] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_nil] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_yield] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_next] = ACTIONS(2590),
    [anon_sym_redo] = ACTIONS(2590),
    [anon_sym_retry] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_unless] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_until] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_EQ_GT] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_CARET] = ACTIONS(2592),
    [anon_sym_begin] = ACTIONS(2590),
    [anon_sym_COLON_COLON2] = ACTIONS(2592),
    [anon_sym_AMP_DOT] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_and] = ACTIONS(2590),
    [anon_sym_or] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_LT_LT] = ACTIONS(2592),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2592),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2592),
    [anon_sym_LT_EQ_GT] = ACTIONS(2592),
    [anon_sym_EQ_TILDE] = ACTIONS(2592),
    [anon_sym_BANG_TILDE] = ACTIONS(2592),
    [anon_sym_defined_QMARK] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2590),
    [sym_float] = ACTIONS(2590),
    [sym_super] = ACTIONS(2590),
    [sym_self] = ACTIONS(2590),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_constant] = ACTIONS(2590),
    [aux_sym_constant_suffix_token1] = ACTIONS(2592),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2590),
    [sym_instance_variable] = ACTIONS(2592),
    [sym_class_variable] = ACTIONS(2592),
    [sym_global_variable] = ACTIONS(2592),
    [sym_character] = ACTIONS(2592),
    [anon_sym_DASH_GT] = ACTIONS(2592),
    [sym__line_break] = ACTIONS(2592),
    [sym_simple_symbol] = ACTIONS(2592),
    [sym__string_start] = ACTIONS(2592),
    [sym__symbol_start] = ACTIONS(2592),
    [sym__subshell_start] = ACTIONS(2592),
    [sym__regex_start] = ACTIONS(2592),
    [sym__string_array_start] = ACTIONS(2592),
    [sym__symbol_array_start] = ACTIONS(2592),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2592),
    [sym__block_ampersand] = ACTIONS(2592),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(2592),
    [sym__unary_minus_num] = ACTIONS(2592),
    [sym__binary_minus] = ACTIONS(2592),
    [sym__binary_star] = ACTIONS(2592),
    [sym_hash_key_symbol] = ACTIONS(2592),
    [sym__identifier_suffix] = ACTIONS(2592),
    [sym__constant_suffix] = ACTIONS(2592),
    [sym__hash_splat_star_star] = ACTIONS(2592),
    [sym__binary_star_star] = ACTIONS(2592),
    [sym__element_reference_bracket] = ACTIONS(2592),
  },
  [1959] = {
    [sym_heredoc_body] = STATE(1959),
    [ts_builtin_sym_end] = ACTIONS(2584),
    [sym_identifier] = ACTIONS(2582),
    [aux_sym_program_token1] = ACTIONS(2584),
    [anon_sym___END__] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1960] = {
    [sym_heredoc_body] = STATE(1960),
    [ts_builtin_sym_end] = ACTIONS(2580),
    [sym_identifier] = ACTIONS(2578),
    [aux_sym_program_token1] = ACTIONS(2580),
    [anon_sym___END__] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1961] = {
    [sym_heredoc_body] = STATE(1961),
    [ts_builtin_sym_end] = ACTIONS(2584),
    [sym_identifier] = ACTIONS(2582),
    [aux_sym_program_token1] = ACTIONS(2584),
    [anon_sym___END__] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1962] = {
    [sym_heredoc_body] = STATE(1962),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1963] = {
    [sym_heredoc_body] = STATE(1963),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1964] = {
    [sym_heredoc_body] = STATE(1964),
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_def] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_rescue] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_nil] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_COLON] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_next] = ACTIONS(2586),
    [anon_sym_redo] = ACTIONS(2586),
    [anon_sym_retry] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_unless] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_until] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_EQ_GT] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_RBRACK] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2588),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_CARET] = ACTIONS(2588),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_COLON_COLON2] = ACTIONS(2588),
    [anon_sym_AMP_DOT] = ACTIONS(2588),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_and] = ACTIONS(2586),
    [anon_sym_or] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_LT_EQ] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT_EQ_GT] = ACTIONS(2588),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_BANG_TILDE] = ACTIONS(2588),
    [anon_sym_defined_QMARK] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2586),
    [sym_float] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_self] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_constant] = ACTIONS(2586),
    [aux_sym_constant_suffix_token1] = ACTIONS(2588),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2586),
    [sym_instance_variable] = ACTIONS(2588),
    [sym_class_variable] = ACTIONS(2588),
    [sym_global_variable] = ACTIONS(2588),
    [sym_character] = ACTIONS(2588),
    [anon_sym_DASH_GT] = ACTIONS(2588),
    [sym_simple_symbol] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__symbol_start] = ACTIONS(2588),
    [sym__subshell_start] = ACTIONS(2588),
    [sym__regex_start] = ACTIONS(2588),
    [sym__string_array_start] = ACTIONS(2588),
    [sym__symbol_array_start] = ACTIONS(2588),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2588),
    [sym__block_ampersand] = ACTIONS(2588),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(2588),
    [sym__unary_minus_num] = ACTIONS(2588),
    [sym__binary_minus] = ACTIONS(2588),
    [sym__binary_star] = ACTIONS(2588),
    [sym_hash_key_symbol] = ACTIONS(2588),
    [sym__identifier_suffix] = ACTIONS(2588),
    [sym__constant_suffix] = ACTIONS(2588),
    [sym__hash_splat_star_star] = ACTIONS(2588),
    [sym__binary_star_star] = ACTIONS(2588),
    [sym__element_reference_bracket] = ACTIONS(2588),
  },
  [1965] = {
    [sym_heredoc_body] = STATE(1965),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2696),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1966] = {
    [sym_heredoc_body] = STATE(1966),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2696),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1967] = {
    [sym_heredoc_body] = STATE(1967),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2690),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1968] = {
    [sym_heredoc_body] = STATE(1968),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_then] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1969] = {
    [sym_heredoc_body] = STATE(1969),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2694),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_then] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1970] = {
    [sym_heredoc_body] = STATE(1970),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2694),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_then] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1971] = {
    [sym_heredoc_body] = STATE(1971),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1972] = {
    [sym_heredoc_body] = STATE(1972),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1973] = {
    [sym_heredoc_body] = STATE(1973),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2690),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1974] = {
    [sym_heredoc_body] = STATE(1974),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_then] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1975] = {
    [sym_heredoc_body] = STATE(1975),
    [sym_identifier] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_def] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_rescue] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_nil] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_yield] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_next] = ACTIONS(2590),
    [anon_sym_redo] = ACTIONS(2590),
    [anon_sym_retry] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_unless] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_until] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_EQ_GT] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_RBRACK] = ACTIONS(2592),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_CARET] = ACTIONS(2592),
    [anon_sym_begin] = ACTIONS(2590),
    [anon_sym_COLON_COLON2] = ACTIONS(2592),
    [anon_sym_AMP_DOT] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_and] = ACTIONS(2590),
    [anon_sym_or] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_LT_LT] = ACTIONS(2592),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2592),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2592),
    [anon_sym_LT_EQ_GT] = ACTIONS(2592),
    [anon_sym_EQ_TILDE] = ACTIONS(2592),
    [anon_sym_BANG_TILDE] = ACTIONS(2592),
    [anon_sym_defined_QMARK] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2590),
    [sym_float] = ACTIONS(2590),
    [sym_super] = ACTIONS(2590),
    [sym_self] = ACTIONS(2590),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_constant] = ACTIONS(2590),
    [aux_sym_constant_suffix_token1] = ACTIONS(2592),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2590),
    [sym_instance_variable] = ACTIONS(2592),
    [sym_class_variable] = ACTIONS(2592),
    [sym_global_variable] = ACTIONS(2592),
    [sym_character] = ACTIONS(2592),
    [anon_sym_DASH_GT] = ACTIONS(2592),
    [sym_simple_symbol] = ACTIONS(2592),
    [sym__string_start] = ACTIONS(2592),
    [sym__symbol_start] = ACTIONS(2592),
    [sym__subshell_start] = ACTIONS(2592),
    [sym__regex_start] = ACTIONS(2592),
    [sym__string_array_start] = ACTIONS(2592),
    [sym__symbol_array_start] = ACTIONS(2592),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2592),
    [sym__block_ampersand] = ACTIONS(2592),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(2592),
    [sym__unary_minus_num] = ACTIONS(2592),
    [sym__binary_minus] = ACTIONS(2592),
    [sym__binary_star] = ACTIONS(2592),
    [sym_hash_key_symbol] = ACTIONS(2592),
    [sym__identifier_suffix] = ACTIONS(2592),
    [sym__constant_suffix] = ACTIONS(2592),
    [sym__hash_splat_star_star] = ACTIONS(2592),
    [sym__binary_star_star] = ACTIONS(2592),
    [sym__element_reference_bracket] = ACTIONS(2592),
  },
  [1976] = {
    [sym_heredoc_body] = STATE(1976),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2702),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1977] = {
    [sym_heredoc_body] = STATE(1977),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2702),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1978] = {
    [sym_heredoc_body] = STATE(1978),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2700),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1979] = {
    [sym_heredoc_body] = STATE(1979),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1980] = {
    [sym_heredoc_body] = STATE(1980),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1981] = {
    [sym_heredoc_body] = STATE(1981),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1982] = {
    [sym_heredoc_body] = STATE(1982),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_COLON] = ACTIONS(2700),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [1983] = {
    [sym_heredoc_body] = STATE(1983),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [1984] = {
    [sym_splat_parameter] = STATE(4463),
    [sym__array_pattern_n] = STATE(4430),
    [sym__pattern_expr] = STATE(4451),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4445),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4402),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(1984),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2752),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_end] = ACTIONS(2758),
    [anon_sym_rescue] = ACTIONS(2758),
    [anon_sym_COMMA] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2760),
    [anon_sym_STAR] = ACTIONS(2762),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2758),
    [anon_sym_unless] = ACTIONS(2758),
    [anon_sym_while] = ACTIONS(2758),
    [anon_sym_until] = ACTIONS(2758),
    [anon_sym_in] = ACTIONS(2758),
    [anon_sym_do] = ACTIONS(2758),
    [anon_sym_when] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2768),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_elsif] = ACTIONS(2758),
    [anon_sym_else] = ACTIONS(2758),
    [anon_sym_then] = ACTIONS(2758),
    [anon_sym_ensure] = ACTIONS(2758),
    [anon_sym_and] = ACTIONS(2758),
    [anon_sym_or] = ACTIONS(2758),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym__line_break] = ACTIONS(2752),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
  },
  [1985] = {
    [sym__pattern_expr] = STATE(4406),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4445),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4402),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(1985),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2322),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_end] = ACTIONS(2794),
    [anon_sym_rescue] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2760),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_unless] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_until] = ACTIONS(2794),
    [anon_sym_in] = ACTIONS(2794),
    [anon_sym_do] = ACTIONS(2794),
    [anon_sym_when] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2768),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_elsif] = ACTIONS(2794),
    [anon_sym_else] = ACTIONS(2794),
    [anon_sym_then] = ACTIONS(2794),
    [anon_sym_ensure] = ACTIONS(2794),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym__line_break] = ACTIONS(2322),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
  },
  [1986] = {
    [sym__pattern_expr] = STATE(4403),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4445),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4402),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(1986),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_RPAREN] = ACTIONS(2796),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_end] = ACTIONS(2798),
    [anon_sym_rescue] = ACTIONS(2798),
    [anon_sym_COMMA] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2760),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2798),
    [anon_sym_unless] = ACTIONS(2798),
    [anon_sym_while] = ACTIONS(2798),
    [anon_sym_until] = ACTIONS(2798),
    [anon_sym_in] = ACTIONS(2798),
    [anon_sym_do] = ACTIONS(2798),
    [anon_sym_when] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2768),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_elsif] = ACTIONS(2798),
    [anon_sym_else] = ACTIONS(2798),
    [anon_sym_then] = ACTIONS(2798),
    [anon_sym_ensure] = ACTIONS(2798),
    [anon_sym_and] = ACTIONS(2798),
    [anon_sym_or] = ACTIONS(2798),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym__line_break] = ACTIONS(2796),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
  },
  [1987] = {
    [sym_splat_parameter] = STATE(4875),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym__array_pattern_n] = STATE(5490),
    [sym__pattern_expr] = STATE(5270),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym__array_pattern_body] = STATE(5795),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(5797),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(5800),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_constant_suffix] = STATE(5568),
    [sym_identifier_suffix] = STATE(5568),
    [sym_string] = STATE(4690),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(1987),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(2810),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2816),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2824),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [1988] = {
    [sym_splat_parameter] = STATE(4875),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym__array_pattern_n] = STATE(5490),
    [sym__pattern_expr] = STATE(5270),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym__array_pattern_body] = STATE(5802),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(5837),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(5870),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_constant_suffix] = STATE(5568),
    [sym_identifier_suffix] = STATE(5568),
    [sym_string] = STATE(4690),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(1988),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_RPAREN] = ACTIONS(2816),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(2810),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2824),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [1989] = {
    [sym_splat_parameter] = STATE(4875),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym__array_pattern_n] = STATE(5490),
    [sym__pattern_expr] = STATE(5270),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym__array_pattern_body] = STATE(5565),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(5567),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(5616),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_constant_suffix] = STATE(5568),
    [sym_identifier_suffix] = STATE(5568),
    [sym_string] = STATE(4690),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(1989),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(2810),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2848),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2824),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [1990] = {
    [sym_splat_parameter] = STATE(4875),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym__array_pattern_n] = STATE(5490),
    [sym__pattern_expr] = STATE(5270),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym__array_pattern_body] = STATE(5645),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(5647),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(5652),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_constant_suffix] = STATE(5568),
    [sym_identifier_suffix] = STATE(5568),
    [sym_string] = STATE(4690),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(1990),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_RPAREN] = ACTIONS(2848),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(2810),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2824),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [1991] = {
    [sym_splat_parameter] = STATE(4875),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym__pattern_top_expr_body] = STATE(4879),
    [sym__array_pattern_n] = STATE(4880),
    [sym__pattern_expr] = STATE(4881),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(4882),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(4883),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_constant_suffix] = STATE(5568),
    [sym_identifier_suffix] = STATE(5568),
    [sym_string] = STATE(4690),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(1991),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(2810),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2824),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [1992] = {
    [sym_splat_parameter] = STATE(4875),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym__pattern_top_expr_body] = STATE(4888),
    [sym__array_pattern_n] = STATE(4880),
    [sym__pattern_expr] = STATE(4881),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(4882),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(4883),
    [sym_keyword_pattern] = STATE(4836),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_constant_suffix] = STATE(5568),
    [sym_identifier_suffix] = STATE(5568),
    [sym_string] = STATE(4690),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(1992),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(2810),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2824),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [1993] = {
    [sym_splat_parameter] = STATE(4739),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym__pattern_top_expr_body] = STATE(4769),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4761),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4712),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4661),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4606),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_constant_suffix] = STATE(5814),
    [sym_identifier_suffix] = STATE(5814),
    [sym_string] = STATE(4573),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(1993),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_STAR_STAR] = ACTIONS(1686),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2856),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(2858),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2860),
    [sym_float] = ACTIONS(2860),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2862),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2858),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [1994] = {
    [sym_splat_parameter] = STATE(4571),
    [sym__array_pattern_n] = STATE(4430),
    [sym__pattern_expr] = STATE(4557),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4532),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4510),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(1994),
    [sym_lambda] = STATE(4345),
    [ts_builtin_sym_end] = ACTIONS(2752),
    [sym_identifier] = ACTIONS(2748),
    [aux_sym_program_token1] = ACTIONS(2752),
    [anon_sym___END__] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_rescue] = ACTIONS(2758),
    [anon_sym_COMMA] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2758),
    [anon_sym_unless] = ACTIONS(2758),
    [anon_sym_while] = ACTIONS(2758),
    [anon_sym_until] = ACTIONS(2758),
    [anon_sym_do] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2868),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1756),
    [anon_sym_and] = ACTIONS(2758),
    [anon_sym_or] = ACTIONS(2758),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym__line_break] = ACTIONS(2752),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2870),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
  },
  [1995] = {
    [sym_splat_parameter] = STATE(4830),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym__pattern_top_expr_body] = STATE(4888),
    [sym__array_pattern_n] = STATE(4880),
    [sym__pattern_expr] = STATE(4832),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(4882),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(4883),
    [sym_keyword_pattern] = STATE(4863),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4700),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4688),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_constant_suffix] = STATE(5722),
    [sym_identifier_suffix] = STATE(5722),
    [sym_string] = STATE(4644),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(1995),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2872),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2810),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2876),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2880),
    [sym_float] = ACTIONS(2880),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2882),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2878),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [1996] = {
    [sym_splat_parameter] = STATE(4739),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym__pattern_top_expr_body] = STATE(4441),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4761),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4712),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4661),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4606),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_constant_suffix] = STATE(5814),
    [sym_identifier_suffix] = STATE(5814),
    [sym_string] = STATE(4573),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(1996),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_STAR_STAR] = ACTIONS(1686),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2856),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(2858),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2860),
    [sym_float] = ACTIONS(2860),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2862),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2858),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [1997] = {
    [sym_splat_parameter] = STATE(4460),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym__pattern_top_expr_body] = STATE(4441),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4456),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4457),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4445),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4402),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_constant_suffix] = STATE(5556),
    [sym_identifier_suffix] = STATE(5556),
    [sym_string] = STATE(4385),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(1997),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2884),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2760),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_STAR_STAR] = ACTIONS(1686),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2768),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2886),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [1998] = {
    [sym_splat_parameter] = STATE(4564),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym__pattern_top_expr_body] = STATE(4416),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4567),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4566),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4532),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4510),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_constant_suffix] = STATE(5559),
    [sym_identifier_suffix] = STATE(5559),
    [sym_string] = STATE(4501),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(1998),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2888),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2890),
    [anon_sym_STAR_STAR] = ACTIONS(1752),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2868),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2892),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2870),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [1999] = {
    [sym_splat_parameter] = STATE(4564),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym__pattern_top_expr_body] = STATE(4441),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4567),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4566),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4532),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4510),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_constant_suffix] = STATE(5559),
    [sym_identifier_suffix] = STATE(5559),
    [sym_string] = STATE(4501),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(1999),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2888),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2890),
    [anon_sym_STAR_STAR] = ACTIONS(1752),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2868),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2892),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2870),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [2000] = {
    [sym_splat_parameter] = STATE(4830),
    [sym_hash_splat_parameter] = STATE(4828),
    [sym_hash_splat_nil] = STATE(4828),
    [sym__pattern_top_expr_body] = STATE(4879),
    [sym__array_pattern_n] = STATE(4880),
    [sym__pattern_expr] = STATE(4832),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(4882),
    [sym_find_pattern] = STATE(4756),
    [sym__hash_pattern_body] = STATE(4883),
    [sym_keyword_pattern] = STATE(4863),
    [sym__hash_pattern_any_rest] = STATE(4841),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4700),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4688),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_constant_suffix] = STATE(5722),
    [sym_identifier_suffix] = STATE(5722),
    [sym_string] = STATE(4644),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2000),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2872),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2810),
    [anon_sym_STAR_STAR] = ACTIONS(1634),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2876),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2880),
    [sym_float] = ACTIONS(2880),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2882),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2878),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [2001] = {
    [sym_splat_parameter] = STATE(4460),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym__pattern_top_expr_body] = STATE(4416),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4456),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4457),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4445),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4402),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_constant_suffix] = STATE(5556),
    [sym_identifier_suffix] = STATE(5556),
    [sym_string] = STATE(4385),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2001),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2884),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2760),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_STAR_STAR] = ACTIONS(1686),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2768),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2886),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [2002] = {
    [sym_splat_parameter] = STATE(4739),
    [sym_hash_splat_parameter] = STATE(4436),
    [sym_hash_splat_nil] = STATE(4436),
    [sym__pattern_top_expr_body] = STATE(4416),
    [sym__array_pattern_n] = STATE(4442),
    [sym__pattern_expr] = STATE(4761),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym__find_pattern_body] = STATE(4409),
    [sym_find_pattern] = STATE(4379),
    [sym__hash_pattern_body] = STATE(4410),
    [sym_keyword_pattern] = STATE(4712),
    [sym__hash_pattern_any_rest] = STATE(4413),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4661),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4606),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_constant_suffix] = STATE(5814),
    [sym_identifier_suffix] = STATE(5814),
    [sym_string] = STATE(4573),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2002),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2854),
    [anon_sym_STAR_STAR] = ACTIONS(1686),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2856),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(2858),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2860),
    [sym_float] = ACTIONS(2860),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2862),
    [aux_sym_constant_suffix_token1] = ACTIONS(2826),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2828),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2858),
    [sym__identifier_suffix] = ACTIONS(2828),
    [sym__constant_suffix] = ACTIONS(2826),
  },
  [2003] = {
    [sym_heredoc_body] = STATE(2003),
    [sym_identifier] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_RBRACE] = ACTIONS(2592),
    [anon_sym_def] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2592),
    [anon_sym_RPAREN] = ACTIONS(2592),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_end] = ACTIONS(2590),
    [anon_sym_rescue] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_nil] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_yield] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_next] = ACTIONS(2590),
    [anon_sym_redo] = ACTIONS(2590),
    [anon_sym_retry] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_unless] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_until] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_when] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_elsif] = ACTIONS(2590),
    [anon_sym_else] = ACTIONS(2590),
    [anon_sym_then] = ACTIONS(2590),
    [anon_sym_begin] = ACTIONS(2590),
    [anon_sym_ensure] = ACTIONS(2590),
    [anon_sym_and] = ACTIONS(2590),
    [anon_sym_or] = ACTIONS(2590),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_defined_QMARK] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_TILDE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2590),
    [sym_float] = ACTIONS(2590),
    [sym_super] = ACTIONS(2590),
    [sym_self] = ACTIONS(2590),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_constant] = ACTIONS(2590),
    [aux_sym_constant_suffix_token1] = ACTIONS(2592),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2590),
    [sym_instance_variable] = ACTIONS(2592),
    [sym_class_variable] = ACTIONS(2592),
    [sym_global_variable] = ACTIONS(2592),
    [sym_character] = ACTIONS(2592),
    [anon_sym_DASH_GT] = ACTIONS(2592),
    [sym__line_break] = ACTIONS(2592),
    [sym_simple_symbol] = ACTIONS(2592),
    [sym__string_start] = ACTIONS(2592),
    [sym__symbol_start] = ACTIONS(2592),
    [sym__subshell_start] = ACTIONS(2592),
    [sym__regex_start] = ACTIONS(2592),
    [sym__string_array_start] = ACTIONS(2592),
    [sym__symbol_array_start] = ACTIONS(2592),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2592),
    [sym__block_ampersand] = ACTIONS(2592),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(2592),
    [sym__unary_minus_num] = ACTIONS(2592),
    [sym__binary_minus] = ACTIONS(2592),
    [sym_hash_key_symbol] = ACTIONS(2592),
    [sym__identifier_suffix] = ACTIONS(2592),
    [sym__constant_suffix] = ACTIONS(2592),
    [sym__hash_splat_star_star] = ACTIONS(2592),
  },
  [2004] = {
    [sym_heredoc_body] = STATE(2004),
    [sym_identifier] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2896),
    [anon_sym_RBRACE] = ACTIONS(2896),
    [anon_sym_def] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2896),
    [anon_sym_RPAREN] = ACTIONS(2896),
    [anon_sym_COLON_COLON] = ACTIONS(2896),
    [anon_sym_end] = ACTIONS(2894),
    [anon_sym_rescue] = ACTIONS(2894),
    [anon_sym_COMMA] = ACTIONS(2896),
    [anon_sym_SEMI] = ACTIONS(2896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2896),
    [anon_sym_STAR] = ACTIONS(2896),
    [anon_sym_nil] = ACTIONS(2894),
    [anon_sym_class] = ACTIONS(2894),
    [anon_sym_module] = ACTIONS(2894),
    [anon_sym_return] = ACTIONS(2894),
    [anon_sym_yield] = ACTIONS(2894),
    [anon_sym_break] = ACTIONS(2894),
    [anon_sym_next] = ACTIONS(2894),
    [anon_sym_redo] = ACTIONS(2894),
    [anon_sym_retry] = ACTIONS(2894),
    [anon_sym_if] = ACTIONS(2894),
    [anon_sym_unless] = ACTIONS(2894),
    [anon_sym_while] = ACTIONS(2894),
    [anon_sym_until] = ACTIONS(2894),
    [anon_sym_for] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2894),
    [anon_sym_do] = ACTIONS(2894),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_when] = ACTIONS(2894),
    [anon_sym_LBRACK] = ACTIONS(2896),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_elsif] = ACTIONS(2894),
    [anon_sym_else] = ACTIONS(2894),
    [anon_sym_then] = ACTIONS(2894),
    [anon_sym_begin] = ACTIONS(2894),
    [anon_sym_ensure] = ACTIONS(2894),
    [anon_sym_and] = ACTIONS(2894),
    [anon_sym_or] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_defined_QMARK] = ACTIONS(2896),
    [anon_sym_not] = ACTIONS(2894),
    [anon_sym_BANG] = ACTIONS(2896),
    [anon_sym_TILDE] = ACTIONS(2896),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2894),
    [sym_float] = ACTIONS(2894),
    [sym_super] = ACTIONS(2894),
    [sym_self] = ACTIONS(2894),
    [sym_true] = ACTIONS(2894),
    [sym_false] = ACTIONS(2894),
    [sym_constant] = ACTIONS(2894),
    [aux_sym_constant_suffix_token1] = ACTIONS(2896),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2894),
    [sym_instance_variable] = ACTIONS(2896),
    [sym_class_variable] = ACTIONS(2896),
    [sym_global_variable] = ACTIONS(2896),
    [sym_character] = ACTIONS(2896),
    [anon_sym_DASH_GT] = ACTIONS(2896),
    [sym__line_break] = ACTIONS(2896),
    [sym_simple_symbol] = ACTIONS(2896),
    [sym__string_start] = ACTIONS(2896),
    [sym__symbol_start] = ACTIONS(2896),
    [sym__subshell_start] = ACTIONS(2896),
    [sym__regex_start] = ACTIONS(2896),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2896),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2896),
    [sym__block_ampersand] = ACTIONS(2896),
    [sym__splat_star] = ACTIONS(2896),
    [sym__unary_minus] = ACTIONS(2896),
    [sym__unary_minus_num] = ACTIONS(2896),
    [sym__binary_minus] = ACTIONS(2896),
    [sym_hash_key_symbol] = ACTIONS(2896),
    [sym__identifier_suffix] = ACTIONS(2896),
    [sym__constant_suffix] = ACTIONS(2896),
    [sym__hash_splat_star_star] = ACTIONS(2896),
  },
  [2005] = {
    [sym__pattern_expr] = STATE(4406),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4532),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4510),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2005),
    [sym_lambda] = STATE(4345),
    [ts_builtin_sym_end] = ACTIONS(2322),
    [sym_identifier] = ACTIONS(2748),
    [aux_sym_program_token1] = ACTIONS(2322),
    [anon_sym___END__] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_rescue] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_unless] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_until] = ACTIONS(2794),
    [anon_sym_do] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2868),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1756),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym__line_break] = ACTIONS(2322),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2870),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
  },
  [2006] = {
    [sym_heredoc_body] = STATE(2006),
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_def] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_end] = ACTIONS(2562),
    [anon_sym_rescue] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2564),
    [anon_sym_STAR] = ACTIONS(2564),
    [anon_sym_nil] = ACTIONS(2562),
    [anon_sym_class] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_yield] = ACTIONS(2562),
    [anon_sym_break] = ACTIONS(2562),
    [anon_sym_next] = ACTIONS(2562),
    [anon_sym_redo] = ACTIONS(2562),
    [anon_sym_retry] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_unless] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [anon_sym_until] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_case] = ACTIONS(2562),
    [anon_sym_when] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_DOT_DOT] = ACTIONS(2562),
    [anon_sym_elsif] = ACTIONS(2562),
    [anon_sym_else] = ACTIONS(2562),
    [anon_sym_then] = ACTIONS(2562),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_ensure] = ACTIONS(2562),
    [anon_sym_and] = ACTIONS(2562),
    [anon_sym_or] = ACTIONS(2562),
    [anon_sym_PLUS] = ACTIONS(2564),
    [anon_sym_defined_QMARK] = ACTIONS(2564),
    [anon_sym_not] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2564),
    [anon_sym_TILDE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2562),
    [sym_float] = ACTIONS(2562),
    [sym_super] = ACTIONS(2562),
    [sym_self] = ACTIONS(2562),
    [sym_true] = ACTIONS(2562),
    [sym_false] = ACTIONS(2562),
    [sym_constant] = ACTIONS(2562),
    [aux_sym_constant_suffix_token1] = ACTIONS(2564),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2562),
    [sym_instance_variable] = ACTIONS(2564),
    [sym_class_variable] = ACTIONS(2564),
    [sym_global_variable] = ACTIONS(2564),
    [sym_character] = ACTIONS(2564),
    [anon_sym_DASH_GT] = ACTIONS(2564),
    [sym__line_break] = ACTIONS(2564),
    [sym_simple_symbol] = ACTIONS(2564),
    [sym__string_start] = ACTIONS(2564),
    [sym__symbol_start] = ACTIONS(2564),
    [sym__subshell_start] = ACTIONS(2564),
    [sym__regex_start] = ACTIONS(2564),
    [sym__string_array_start] = ACTIONS(2564),
    [sym__symbol_array_start] = ACTIONS(2564),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2564),
    [sym__block_ampersand] = ACTIONS(2564),
    [sym__splat_star] = ACTIONS(2564),
    [sym__unary_minus] = ACTIONS(2564),
    [sym__unary_minus_num] = ACTIONS(2564),
    [sym__binary_minus] = ACTIONS(2564),
    [sym_hash_key_symbol] = ACTIONS(2564),
    [sym__identifier_suffix] = ACTIONS(2564),
    [sym__constant_suffix] = ACTIONS(2564),
    [sym__hash_splat_star_star] = ACTIONS(2564),
  },
  [2007] = {
    [sym_heredoc_body] = STATE(2007),
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_def] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_COLON_COLON] = ACTIONS(2588),
    [anon_sym_end] = ACTIONS(2586),
    [anon_sym_rescue] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_nil] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_next] = ACTIONS(2586),
    [anon_sym_redo] = ACTIONS(2586),
    [anon_sym_retry] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_unless] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_until] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_when] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_elsif] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2586),
    [anon_sym_then] = ACTIONS(2586),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_ensure] = ACTIONS(2586),
    [anon_sym_and] = ACTIONS(2586),
    [anon_sym_or] = ACTIONS(2586),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_defined_QMARK] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_TILDE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2586),
    [sym_float] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_self] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_constant] = ACTIONS(2586),
    [aux_sym_constant_suffix_token1] = ACTIONS(2588),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2586),
    [sym_instance_variable] = ACTIONS(2588),
    [sym_class_variable] = ACTIONS(2588),
    [sym_global_variable] = ACTIONS(2588),
    [sym_character] = ACTIONS(2588),
    [anon_sym_DASH_GT] = ACTIONS(2588),
    [sym__line_break] = ACTIONS(2588),
    [sym_simple_symbol] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__symbol_start] = ACTIONS(2588),
    [sym__subshell_start] = ACTIONS(2588),
    [sym__regex_start] = ACTIONS(2588),
    [sym__string_array_start] = ACTIONS(2588),
    [sym__symbol_array_start] = ACTIONS(2588),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2588),
    [sym__block_ampersand] = ACTIONS(2588),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(2588),
    [sym__unary_minus_num] = ACTIONS(2588),
    [sym__binary_minus] = ACTIONS(2588),
    [sym_hash_key_symbol] = ACTIONS(2588),
    [sym__identifier_suffix] = ACTIONS(2588),
    [sym__constant_suffix] = ACTIONS(2588),
    [sym__hash_splat_star_star] = ACTIONS(2588),
  },
  [2008] = {
    [sym__pattern_expr] = STATE(4403),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4532),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4510),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2008),
    [sym_lambda] = STATE(4345),
    [ts_builtin_sym_end] = ACTIONS(2796),
    [sym_identifier] = ACTIONS(2748),
    [aux_sym_program_token1] = ACTIONS(2796),
    [anon_sym___END__] = ACTIONS(2798),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_rescue] = ACTIONS(2798),
    [anon_sym_COMMA] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2798),
    [anon_sym_unless] = ACTIONS(2798),
    [anon_sym_while] = ACTIONS(2798),
    [anon_sym_until] = ACTIONS(2798),
    [anon_sym_do] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2868),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1756),
    [anon_sym_and] = ACTIONS(2798),
    [anon_sym_or] = ACTIONS(2798),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym__line_break] = ACTIONS(2796),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2870),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
  },
  [2009] = {
    [sym_heredoc_body] = STATE(2009),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_COLON_COLON] = ACTIONS(2580),
    [anon_sym_end] = ACTIONS(2578),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_when] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_elsif] = ACTIONS(2578),
    [anon_sym_else] = ACTIONS(2578),
    [anon_sym_then] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_ensure] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2580),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
  },
  [2010] = {
    [sym_heredoc_body] = STATE(2010),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2584),
    [anon_sym_end] = ACTIONS(2582),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_when] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_elsif] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_then] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_ensure] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2584),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
  },
  [2011] = {
    [sym_splat_parameter] = STATE(4755),
    [sym__array_pattern_n] = STATE(4430),
    [sym__pattern_expr] = STATE(4725),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4661),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4606),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2011),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2762),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2758),
    [anon_sym_unless] = ACTIONS(2758),
    [anon_sym_do] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2856),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_then] = ACTIONS(2758),
    [anon_sym_and] = ACTIONS(2758),
    [anon_sym_or] = ACTIONS(2758),
    [anon_sym_PLUS] = ACTIONS(2858),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2860),
    [sym_float] = ACTIONS(2860),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym__line_break] = ACTIONS(2752),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2858),
  },
  [2012] = {
    [sym_heredoc_body] = STATE(2012),
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_BEGIN] = ACTIONS(2570),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_END] = ACTIONS(2570),
    [anon_sym_def] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2570),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2570),
    [anon_sym_end] = ACTIONS(2570),
    [anon_sym_rescue] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2568),
    [anon_sym_nil] = ACTIONS(2570),
    [anon_sym_class] = ACTIONS(2570),
    [anon_sym_LT] = ACTIONS(2568),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_return] = ACTIONS(2570),
    [anon_sym_yield] = ACTIONS(2570),
    [anon_sym_break] = ACTIONS(2570),
    [anon_sym_next] = ACTIONS(2570),
    [anon_sym_redo] = ACTIONS(2570),
    [anon_sym_retry] = ACTIONS(2570),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_unless] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [anon_sym_until] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_case] = ACTIONS(2570),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_else] = ACTIONS(2570),
    [anon_sym_begin] = ACTIONS(2570),
    [anon_sym_ensure] = ACTIONS(2570),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2568),
    [anon_sym_defined_QMARK] = ACTIONS(2568),
    [anon_sym_not] = ACTIONS(2570),
    [anon_sym_BANG] = ACTIONS(2568),
    [anon_sym_TILDE] = ACTIONS(2568),
    [anon_sym_undef] = ACTIONS(2570),
    [anon_sym_alias] = ACTIONS(2570),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2570),
    [sym_float] = ACTIONS(2570),
    [sym_super] = ACTIONS(2570),
    [sym_self] = ACTIONS(2570),
    [sym_true] = ACTIONS(2570),
    [sym_false] = ACTIONS(2570),
    [sym_constant] = ACTIONS(2570),
    [aux_sym_constant_suffix_token1] = ACTIONS(2568),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2570),
    [sym_instance_variable] = ACTIONS(2568),
    [sym_class_variable] = ACTIONS(2568),
    [sym_global_variable] = ACTIONS(2568),
    [sym_character] = ACTIONS(2568),
    [anon_sym_DASH_GT] = ACTIONS(2568),
    [sym__line_break] = ACTIONS(2568),
    [sym_simple_symbol] = ACTIONS(2568),
    [sym__string_start] = ACTIONS(2568),
    [sym__symbol_start] = ACTIONS(2568),
    [sym__subshell_start] = ACTIONS(2568),
    [sym__regex_start] = ACTIONS(2568),
    [sym__string_array_start] = ACTIONS(2568),
    [sym__symbol_array_start] = ACTIONS(2568),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2568),
    [sym__unary_minus] = ACTIONS(2568),
    [sym__unary_minus_num] = ACTIONS(2568),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__identifier_suffix] = ACTIONS(2568),
    [sym__constant_suffix] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [2013] = {
    [sym_argument_list] = STATE(2188),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_heredoc_body] = STATE(2013),
    [ts_builtin_sym_end] = ACTIONS(177),
    [aux_sym_program_token1] = ACTIONS(177),
    [anon_sym___END__] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(177),
    [anon_sym_rescue] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_if] = ACTIONS(177),
    [anon_sym_unless] = ACTIONS(177),
    [anon_sym_while] = ACTIONS(177),
    [anon_sym_until] = ACTIONS(177),
    [anon_sym_in] = ACTIONS(177),
    [anon_sym_do] = ACTIONS(2900),
    [anon_sym_when] = ACTIONS(177),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_elsif] = ACTIONS(177),
    [anon_sym_else] = ACTIONS(177),
    [anon_sym_then] = ACTIONS(177),
    [anon_sym_ensure] = ACTIONS(177),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_and] = ACTIONS(177),
    [anon_sym_or] = ACTIONS(177),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(177),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [2014] = {
    [sym_splat_parameter] = STATE(4845),
    [sym__array_pattern_n] = STATE(4933),
    [sym__pattern_expr] = STATE(4842),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4700),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4688),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2014),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_rescue] = ACTIONS(2758),
    [anon_sym_COMMA] = ACTIONS(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2752),
    [anon_sym_DOT_DOT] = ACTIONS(2876),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2758),
    [anon_sym_or] = ACTIONS(2758),
    [anon_sym_PLUS] = ACTIONS(2878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2880),
    [sym_float] = ACTIONS(2880),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2878),
  },
  [2015] = {
    [sym_heredoc_body] = STATE(2015),
    [sym_identifier] = ACTIONS(2044),
    [anon_sym_BEGIN] = ACTIONS(2044),
    [anon_sym_LBRACE] = ACTIONS(2908),
    [anon_sym_RBRACE] = ACTIONS(2908),
    [anon_sym_END] = ACTIONS(2044),
    [anon_sym_def] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_RPAREN] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_end] = ACTIONS(2044),
    [anon_sym_rescue] = ACTIONS(2044),
    [anon_sym_PIPE] = ACTIONS(2908),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2908),
    [anon_sym_STAR] = ACTIONS(2908),
    [anon_sym_nil] = ACTIONS(2044),
    [anon_sym_class] = ACTIONS(2044),
    [anon_sym_module] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_yield] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_next] = ACTIONS(2044),
    [anon_sym_redo] = ACTIONS(2044),
    [anon_sym_retry] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_unless] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_until] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_in] = ACTIONS(2044),
    [anon_sym_case] = ACTIONS(2044),
    [anon_sym_when] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2908),
    [anon_sym_DOT_DOT] = ACTIONS(2044),
    [anon_sym_elsif] = ACTIONS(2044),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_then] = ACTIONS(2044),
    [anon_sym_begin] = ACTIONS(2044),
    [anon_sym_ensure] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_defined_QMARK] = ACTIONS(2908),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2908),
    [anon_sym_TILDE] = ACTIONS(2908),
    [anon_sym_undef] = ACTIONS(2044),
    [anon_sym_alias] = ACTIONS(2044),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2044),
    [sym_float] = ACTIONS(2044),
    [sym_super] = ACTIONS(2044),
    [sym_self] = ACTIONS(2044),
    [sym_true] = ACTIONS(2044),
    [sym_false] = ACTIONS(2044),
    [sym_constant] = ACTIONS(2044),
    [aux_sym_constant_suffix_token1] = ACTIONS(2908),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2044),
    [sym_instance_variable] = ACTIONS(2908),
    [sym_class_variable] = ACTIONS(2908),
    [sym_global_variable] = ACTIONS(2908),
    [sym_character] = ACTIONS(2908),
    [anon_sym_DASH_GT] = ACTIONS(2908),
    [sym_simple_symbol] = ACTIONS(2908),
    [sym__string_start] = ACTIONS(2908),
    [sym__symbol_start] = ACTIONS(2908),
    [sym__subshell_start] = ACTIONS(2908),
    [sym__regex_start] = ACTIONS(2908),
    [sym__string_array_start] = ACTIONS(2908),
    [sym__symbol_array_start] = ACTIONS(2908),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2908),
    [sym__unary_minus] = ACTIONS(2908),
    [sym__unary_minus_num] = ACTIONS(2908),
    [sym__binary_minus] = ACTIONS(2908),
    [sym__identifier_suffix] = ACTIONS(2908),
    [sym__constant_suffix] = ACTIONS(2908),
  },
  [2016] = {
    [sym_argument_list] = STATE(2179),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_heredoc_body] = STATE(2016),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(2900),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2017] = {
    [sym_argument_list] = STATE(2180),
    [sym_do_block] = STATE(2300),
    [sym_block] = STATE(2267),
    [sym_heredoc_body] = STATE(2017),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2018] = {
    [sym_argument_list] = STATE(2178),
    [sym_do_block] = STATE(2329),
    [sym_block] = STATE(2330),
    [sym_heredoc_body] = STATE(2018),
    [ts_builtin_sym_end] = ACTIONS(177),
    [aux_sym_program_token1] = ACTIONS(177),
    [anon_sym___END__] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_DOT] = ACTIONS(179),
    [anon_sym_end] = ACTIONS(177),
    [anon_sym_rescue] = ACTIONS(177),
    [anon_sym_EQ] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(179),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(177),
    [anon_sym_AMP] = ACTIONS(179),
    [anon_sym_LT] = ACTIONS(179),
    [anon_sym_if] = ACTIONS(177),
    [anon_sym_unless] = ACTIONS(177),
    [anon_sym_while] = ACTIONS(177),
    [anon_sym_until] = ACTIONS(177),
    [anon_sym_in] = ACTIONS(177),
    [anon_sym_do] = ACTIONS(177),
    [anon_sym_when] = ACTIONS(177),
    [anon_sym_EQ_GT] = ACTIONS(177),
    [anon_sym_LPAREN2] = ACTIONS(145),
    [anon_sym_DOT_DOT] = ACTIONS(179),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_elsif] = ACTIONS(177),
    [anon_sym_else] = ACTIONS(177),
    [anon_sym_then] = ACTIONS(177),
    [anon_sym_ensure] = ACTIONS(177),
    [anon_sym_COLON_COLON2] = ACTIONS(177),
    [anon_sym_AMP_DOT] = ACTIONS(177),
    [anon_sym_PLUS_EQ] = ACTIONS(177),
    [anon_sym_DASH_EQ] = ACTIONS(177),
    [anon_sym_STAR_EQ] = ACTIONS(177),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(177),
    [anon_sym_SLASH_EQ] = ACTIONS(177),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(177),
    [anon_sym_PIPE_EQ] = ACTIONS(177),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(177),
    [anon_sym_AMP_EQ] = ACTIONS(177),
    [anon_sym_PERCENT_EQ] = ACTIONS(177),
    [anon_sym_GT_GT_EQ] = ACTIONS(177),
    [anon_sym_LT_LT_EQ] = ACTIONS(177),
    [anon_sym_CARET_EQ] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_and] = ACTIONS(177),
    [anon_sym_or] = ACTIONS(177),
    [anon_sym_PIPE_PIPE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(179),
    [anon_sym_LT_LT] = ACTIONS(179),
    [anon_sym_GT_GT] = ACTIONS(179),
    [anon_sym_LT_EQ] = ACTIONS(179),
    [anon_sym_GT] = ACTIONS(179),
    [anon_sym_GT_EQ] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(179),
    [anon_sym_SLASH] = ACTIONS(179),
    [anon_sym_PERCENT] = ACTIONS(179),
    [anon_sym_EQ_EQ] = ACTIONS(179),
    [anon_sym_BANG_EQ] = ACTIONS(177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(177),
    [anon_sym_LT_EQ_GT] = ACTIONS(177),
    [anon_sym_EQ_TILDE] = ACTIONS(177),
    [anon_sym_BANG_TILDE] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(177),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(177),
    [sym__binary_star] = ACTIONS(177),
    [sym__binary_star_star] = ACTIONS(177),
    [sym__element_reference_bracket] = ACTIONS(177),
  },
  [2019] = {
    [sym_splat_parameter] = STATE(4932),
    [sym__array_pattern_n] = STATE(4933),
    [sym__pattern_expr] = STATE(4941),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2019),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_COMMA] = ACTIONS(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2752),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2758),
    [anon_sym_or] = ACTIONS(2758),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
  },
  [2020] = {
    [sym__pattern_expr] = STATE(4403),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4661),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4606),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2020),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2852),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2798),
    [anon_sym_unless] = ACTIONS(2798),
    [anon_sym_do] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2856),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_then] = ACTIONS(2798),
    [anon_sym_and] = ACTIONS(2798),
    [anon_sym_or] = ACTIONS(2798),
    [anon_sym_PLUS] = ACTIONS(2858),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2860),
    [sym_float] = ACTIONS(2860),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym__line_break] = ACTIONS(2796),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2858),
  },
  [2021] = {
    [sym__pattern_expr] = STATE(4406),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4661),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4606),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2021),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2852),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_unless] = ACTIONS(2794),
    [anon_sym_do] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2856),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_then] = ACTIONS(2794),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2858),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2860),
    [sym_float] = ACTIONS(2860),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym__line_break] = ACTIONS(2322),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2858),
  },
  [2022] = {
    [sym_heredoc_body] = STATE(2022),
    [ts_builtin_sym_end] = ACTIONS(2910),
    [aux_sym_program_token1] = ACTIONS(2910),
    [anon_sym___END__] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_RBRACE] = ACTIONS(2910),
    [anon_sym_RPAREN] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2912),
    [anon_sym_COLON_COLON] = ACTIONS(2914),
    [anon_sym_end] = ACTIONS(2910),
    [anon_sym_rescue] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COMMA] = ACTIONS(2910),
    [anon_sym_PIPE] = ACTIONS(2912),
    [anon_sym_SEMI] = ACTIONS(2910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2910),
    [anon_sym_AMP] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_unless] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_until] = ACTIONS(2910),
    [anon_sym_in] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_when] = ACTIONS(2910),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_LBRACK2] = ACTIONS(2916),
    [anon_sym_LPAREN2] = ACTIONS(2916),
    [anon_sym_DOT_DOT] = ACTIONS(2912),
    [anon_sym_CARET] = ACTIONS(2912),
    [anon_sym_elsif] = ACTIONS(2910),
    [anon_sym_else] = ACTIONS(2910),
    [anon_sym_then] = ACTIONS(2910),
    [anon_sym_ensure] = ACTIONS(2910),
    [anon_sym_COLON_COLON2] = ACTIONS(2910),
    [anon_sym_AMP_DOT] = ACTIONS(2910),
    [anon_sym_PLUS_EQ] = ACTIONS(2910),
    [anon_sym_DASH_EQ] = ACTIONS(2910),
    [anon_sym_STAR_EQ] = ACTIONS(2910),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2910),
    [anon_sym_SLASH_EQ] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2910),
    [anon_sym_PIPE_EQ] = ACTIONS(2910),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2910),
    [anon_sym_AMP_EQ] = ACTIONS(2910),
    [anon_sym_PERCENT_EQ] = ACTIONS(2910),
    [anon_sym_GT_GT_EQ] = ACTIONS(2910),
    [anon_sym_LT_LT_EQ] = ACTIONS(2910),
    [anon_sym_CARET_EQ] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_and] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2912),
    [anon_sym_AMP_AMP] = ACTIONS(2912),
    [anon_sym_LT_LT] = ACTIONS(2912),
    [anon_sym_GT_GT] = ACTIONS(2912),
    [anon_sym_LT_EQ] = ACTIONS(2912),
    [anon_sym_GT] = ACTIONS(2912),
    [anon_sym_GT_EQ] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_SLASH] = ACTIONS(2912),
    [anon_sym_PERCENT] = ACTIONS(2912),
    [anon_sym_EQ_EQ] = ACTIONS(2912),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2910),
    [anon_sym_LT_EQ_GT] = ACTIONS(2910),
    [anon_sym_EQ_TILDE] = ACTIONS(2910),
    [anon_sym_BANG_TILDE] = ACTIONS(2910),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2910),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2910),
    [sym__binary_star] = ACTIONS(2910),
    [sym__binary_star_star] = ACTIONS(2910),
    [sym__element_reference_bracket] = ACTIONS(2910),
  },
  [2023] = {
    [sym_heredoc_body] = STATE(2023),
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_BEGIN] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_END] = ACTIONS(2912),
    [anon_sym_def] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2912),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_end] = ACTIONS(2912),
    [anon_sym_rescue] = ACTIONS(2912),
    [anon_sym_SEMI] = ACTIONS(2910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2910),
    [anon_sym_STAR] = ACTIONS(2910),
    [anon_sym_nil] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2910),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2912),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_next] = ACTIONS(2912),
    [anon_sym_redo] = ACTIONS(2912),
    [anon_sym_retry] = ACTIONS(2912),
    [anon_sym_if] = ACTIONS(2912),
    [anon_sym_unless] = ACTIONS(2912),
    [anon_sym_while] = ACTIONS(2912),
    [anon_sym_until] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_case] = ACTIONS(2912),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_DOT_DOT] = ACTIONS(2912),
    [anon_sym_else] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2912),
    [anon_sym_ensure] = ACTIONS(2912),
    [anon_sym_COLON_COLON2] = ACTIONS(2910),
    [anon_sym_AMP_DOT] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_defined_QMARK] = ACTIONS(2910),
    [anon_sym_not] = ACTIONS(2912),
    [anon_sym_BANG] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2910),
    [anon_sym_undef] = ACTIONS(2912),
    [anon_sym_alias] = ACTIONS(2912),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2912),
    [sym_float] = ACTIONS(2912),
    [sym_super] = ACTIONS(2912),
    [sym_self] = ACTIONS(2912),
    [sym_true] = ACTIONS(2912),
    [sym_false] = ACTIONS(2912),
    [sym_constant] = ACTIONS(2912),
    [aux_sym_constant_suffix_token1] = ACTIONS(2910),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2912),
    [sym_instance_variable] = ACTIONS(2910),
    [sym_class_variable] = ACTIONS(2910),
    [sym_global_variable] = ACTIONS(2910),
    [sym_character] = ACTIONS(2910),
    [anon_sym_DASH_GT] = ACTIONS(2910),
    [sym__line_break] = ACTIONS(2910),
    [sym_simple_symbol] = ACTIONS(2910),
    [sym__string_start] = ACTIONS(2910),
    [sym__symbol_start] = ACTIONS(2910),
    [sym__subshell_start] = ACTIONS(2910),
    [sym__regex_start] = ACTIONS(2910),
    [sym__string_array_start] = ACTIONS(2910),
    [sym__symbol_array_start] = ACTIONS(2910),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2910),
    [sym__unary_minus] = ACTIONS(2910),
    [sym__unary_minus_num] = ACTIONS(2910),
    [sym__binary_minus] = ACTIONS(2910),
    [sym__identifier_suffix] = ACTIONS(2910),
    [sym__constant_suffix] = ACTIONS(2910),
    [sym__element_reference_bracket] = ACTIONS(2910),
  },
  [2024] = {
    [sym_heredoc_body] = STATE(2024),
    [ts_builtin_sym_end] = ACTIONS(2592),
    [sym_identifier] = ACTIONS(2590),
    [aux_sym_program_token1] = ACTIONS(2592),
    [anon_sym___END__] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_def] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2592),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_rescue] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_nil] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_yield] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_next] = ACTIONS(2590),
    [anon_sym_redo] = ACTIONS(2590),
    [anon_sym_retry] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_unless] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_until] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_begin] = ACTIONS(2590),
    [anon_sym_and] = ACTIONS(2590),
    [anon_sym_or] = ACTIONS(2590),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_defined_QMARK] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_TILDE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2590),
    [sym_float] = ACTIONS(2590),
    [sym_super] = ACTIONS(2590),
    [sym_self] = ACTIONS(2590),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_constant] = ACTIONS(2590),
    [aux_sym_constant_suffix_token1] = ACTIONS(2592),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2590),
    [sym_instance_variable] = ACTIONS(2592),
    [sym_class_variable] = ACTIONS(2592),
    [sym_global_variable] = ACTIONS(2592),
    [sym_character] = ACTIONS(2592),
    [anon_sym_DASH_GT] = ACTIONS(2592),
    [sym__line_break] = ACTIONS(2592),
    [sym_simple_symbol] = ACTIONS(2592),
    [sym__string_start] = ACTIONS(2592),
    [sym__symbol_start] = ACTIONS(2592),
    [sym__subshell_start] = ACTIONS(2592),
    [sym__regex_start] = ACTIONS(2592),
    [sym__string_array_start] = ACTIONS(2592),
    [sym__symbol_array_start] = ACTIONS(2592),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2592),
    [sym__block_ampersand] = ACTIONS(2592),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(2592),
    [sym__unary_minus_num] = ACTIONS(2592),
    [sym__binary_minus] = ACTIONS(2592),
    [sym_hash_key_symbol] = ACTIONS(2592),
    [sym__identifier_suffix] = ACTIONS(2592),
    [sym__constant_suffix] = ACTIONS(2592),
    [sym__hash_splat_star_star] = ACTIONS(2592),
  },
  [2025] = {
    [sym_heredoc_body] = STATE(2025),
    [ts_builtin_sym_end] = ACTIONS(2564),
    [sym_identifier] = ACTIONS(2562),
    [aux_sym_program_token1] = ACTIONS(2564),
    [anon_sym___END__] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2564),
    [anon_sym_def] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_rescue] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2564),
    [anon_sym_STAR] = ACTIONS(2564),
    [anon_sym_nil] = ACTIONS(2562),
    [anon_sym_class] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_yield] = ACTIONS(2562),
    [anon_sym_break] = ACTIONS(2562),
    [anon_sym_next] = ACTIONS(2562),
    [anon_sym_redo] = ACTIONS(2562),
    [anon_sym_retry] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_unless] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [anon_sym_until] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_case] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_DOT_DOT] = ACTIONS(2562),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_and] = ACTIONS(2562),
    [anon_sym_or] = ACTIONS(2562),
    [anon_sym_PLUS] = ACTIONS(2564),
    [anon_sym_defined_QMARK] = ACTIONS(2564),
    [anon_sym_not] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2564),
    [anon_sym_TILDE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2562),
    [sym_float] = ACTIONS(2562),
    [sym_super] = ACTIONS(2562),
    [sym_self] = ACTIONS(2562),
    [sym_true] = ACTIONS(2562),
    [sym_false] = ACTIONS(2562),
    [sym_constant] = ACTIONS(2562),
    [aux_sym_constant_suffix_token1] = ACTIONS(2564),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2562),
    [sym_instance_variable] = ACTIONS(2564),
    [sym_class_variable] = ACTIONS(2564),
    [sym_global_variable] = ACTIONS(2564),
    [sym_character] = ACTIONS(2564),
    [anon_sym_DASH_GT] = ACTIONS(2564),
    [sym__line_break] = ACTIONS(2564),
    [sym_simple_symbol] = ACTIONS(2564),
    [sym__string_start] = ACTIONS(2564),
    [sym__symbol_start] = ACTIONS(2564),
    [sym__subshell_start] = ACTIONS(2564),
    [sym__regex_start] = ACTIONS(2564),
    [sym__string_array_start] = ACTIONS(2564),
    [sym__symbol_array_start] = ACTIONS(2564),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2564),
    [sym__block_ampersand] = ACTIONS(2564),
    [sym__splat_star] = ACTIONS(2564),
    [sym__unary_minus] = ACTIONS(2564),
    [sym__unary_minus_num] = ACTIONS(2564),
    [sym__binary_minus] = ACTIONS(2564),
    [sym_hash_key_symbol] = ACTIONS(2564),
    [sym__identifier_suffix] = ACTIONS(2564),
    [sym__constant_suffix] = ACTIONS(2564),
    [sym__hash_splat_star_star] = ACTIONS(2564),
  },
  [2026] = {
    [sym_heredoc_body] = STATE(2026),
    [ts_builtin_sym_end] = ACTIONS(2588),
    [sym_identifier] = ACTIONS(2586),
    [aux_sym_program_token1] = ACTIONS(2588),
    [anon_sym___END__] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_def] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_COLON_COLON] = ACTIONS(2588),
    [anon_sym_rescue] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_nil] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_next] = ACTIONS(2586),
    [anon_sym_redo] = ACTIONS(2586),
    [anon_sym_retry] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_unless] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_until] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_and] = ACTIONS(2586),
    [anon_sym_or] = ACTIONS(2586),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_defined_QMARK] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_TILDE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2586),
    [sym_float] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_self] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_constant] = ACTIONS(2586),
    [aux_sym_constant_suffix_token1] = ACTIONS(2588),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2586),
    [sym_instance_variable] = ACTIONS(2588),
    [sym_class_variable] = ACTIONS(2588),
    [sym_global_variable] = ACTIONS(2588),
    [sym_character] = ACTIONS(2588),
    [anon_sym_DASH_GT] = ACTIONS(2588),
    [sym__line_break] = ACTIONS(2588),
    [sym_simple_symbol] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__symbol_start] = ACTIONS(2588),
    [sym__subshell_start] = ACTIONS(2588),
    [sym__regex_start] = ACTIONS(2588),
    [sym__string_array_start] = ACTIONS(2588),
    [sym__symbol_array_start] = ACTIONS(2588),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2588),
    [sym__block_ampersand] = ACTIONS(2588),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(2588),
    [sym__unary_minus_num] = ACTIONS(2588),
    [sym__binary_minus] = ACTIONS(2588),
    [sym_hash_key_symbol] = ACTIONS(2588),
    [sym__identifier_suffix] = ACTIONS(2588),
    [sym__constant_suffix] = ACTIONS(2588),
    [sym__hash_splat_star_star] = ACTIONS(2588),
  },
  [2027] = {
    [sym_heredoc_body] = STATE(2027),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_BEGIN] = ACTIONS(2918),
    [anon_sym_LBRACE] = ACTIONS(2920),
    [anon_sym_RBRACE] = ACTIONS(2920),
    [anon_sym_END] = ACTIONS(2918),
    [anon_sym_def] = ACTIONS(2918),
    [anon_sym_LPAREN] = ACTIONS(2920),
    [anon_sym_RPAREN] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_end] = ACTIONS(2918),
    [anon_sym_rescue] = ACTIONS(2918),
    [anon_sym_SEMI] = ACTIONS(2920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2920),
    [anon_sym_STAR] = ACTIONS(2920),
    [anon_sym_nil] = ACTIONS(2918),
    [anon_sym_class] = ACTIONS(2918),
    [anon_sym_module] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_break] = ACTIONS(2918),
    [anon_sym_next] = ACTIONS(2918),
    [anon_sym_redo] = ACTIONS(2918),
    [anon_sym_retry] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_unless] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_until] = ACTIONS(2918),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_in] = ACTIONS(2918),
    [anon_sym_case] = ACTIONS(2918),
    [anon_sym_when] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_DOT_DOT] = ACTIONS(2918),
    [anon_sym_elsif] = ACTIONS(2918),
    [anon_sym_else] = ACTIONS(2918),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_ensure] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_defined_QMARK] = ACTIONS(2920),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2920),
    [anon_sym_undef] = ACTIONS(2918),
    [anon_sym_alias] = ACTIONS(2918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2918),
    [sym_float] = ACTIONS(2918),
    [sym_super] = ACTIONS(2918),
    [sym_self] = ACTIONS(2918),
    [sym_true] = ACTIONS(2918),
    [sym_false] = ACTIONS(2918),
    [sym_constant] = ACTIONS(2918),
    [aux_sym_constant_suffix_token1] = ACTIONS(2920),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2918),
    [sym_instance_variable] = ACTIONS(2920),
    [sym_class_variable] = ACTIONS(2920),
    [sym_global_variable] = ACTIONS(2920),
    [sym_character] = ACTIONS(2920),
    [anon_sym_DASH_GT] = ACTIONS(2920),
    [sym_simple_symbol] = ACTIONS(2920),
    [sym__string_start] = ACTIONS(2920),
    [sym__symbol_start] = ACTIONS(2920),
    [sym__subshell_start] = ACTIONS(2920),
    [sym__regex_start] = ACTIONS(2920),
    [sym__string_array_start] = ACTIONS(2920),
    [sym__symbol_array_start] = ACTIONS(2920),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2920),
    [sym__unary_minus] = ACTIONS(2920),
    [sym__unary_minus_num] = ACTIONS(2920),
    [sym__binary_minus] = ACTIONS(2920),
    [sym__identifier_suffix] = ACTIONS(2920),
    [sym__constant_suffix] = ACTIONS(2920),
  },
  [2028] = {
    [sym_heredoc_body] = STATE(2028),
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_BEGIN] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_RBRACE] = ACTIONS(1086),
    [anon_sym_END] = ACTIONS(1100),
    [anon_sym_def] = ACTIONS(1100),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_RPAREN] = ACTIONS(1086),
    [anon_sym_COLON_COLON] = ACTIONS(1086),
    [anon_sym_end] = ACTIONS(1100),
    [anon_sym_rescue] = ACTIONS(1100),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_nil] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1100),
    [anon_sym_module] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_yield] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_next] = ACTIONS(1100),
    [anon_sym_redo] = ACTIONS(1100),
    [anon_sym_retry] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_unless] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_until] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_in] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_when] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_DOT_DOT] = ACTIONS(1100),
    [anon_sym_elsif] = ACTIONS(1100),
    [anon_sym_else] = ACTIONS(1100),
    [anon_sym_begin] = ACTIONS(1100),
    [anon_sym_ensure] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1086),
    [anon_sym_defined_QMARK] = ACTIONS(1086),
    [anon_sym_not] = ACTIONS(1100),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_undef] = ACTIONS(1100),
    [anon_sym_alias] = ACTIONS(1100),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1100),
    [sym_float] = ACTIONS(1100),
    [sym_super] = ACTIONS(1100),
    [sym_self] = ACTIONS(1100),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_constant] = ACTIONS(1100),
    [aux_sym_constant_suffix_token1] = ACTIONS(1086),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1100),
    [sym_instance_variable] = ACTIONS(1086),
    [sym_class_variable] = ACTIONS(1086),
    [sym_global_variable] = ACTIONS(1086),
    [sym_character] = ACTIONS(1086),
    [anon_sym_DASH_GT] = ACTIONS(1086),
    [sym_simple_symbol] = ACTIONS(1086),
    [sym__string_start] = ACTIONS(1086),
    [sym__symbol_start] = ACTIONS(1086),
    [sym__subshell_start] = ACTIONS(1086),
    [sym__regex_start] = ACTIONS(1086),
    [sym__string_array_start] = ACTIONS(1086),
    [sym__symbol_array_start] = ACTIONS(1086),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1086),
    [sym__unary_minus] = ACTIONS(1086),
    [sym__unary_minus_num] = ACTIONS(1086),
    [sym__binary_minus] = ACTIONS(1086),
    [sym__identifier_suffix] = ACTIONS(1086),
    [sym__constant_suffix] = ACTIONS(1086),
  },
  [2029] = {
    [sym_heredoc_body] = STATE(2029),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_BEGIN] = ACTIONS(2922),
    [anon_sym_LBRACE] = ACTIONS(2924),
    [anon_sym_RBRACE] = ACTIONS(2924),
    [anon_sym_END] = ACTIONS(2922),
    [anon_sym_def] = ACTIONS(2922),
    [anon_sym_LPAREN] = ACTIONS(2924),
    [anon_sym_RPAREN] = ACTIONS(2924),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_end] = ACTIONS(2922),
    [anon_sym_rescue] = ACTIONS(2922),
    [anon_sym_SEMI] = ACTIONS(2924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2924),
    [anon_sym_nil] = ACTIONS(2922),
    [anon_sym_class] = ACTIONS(2922),
    [anon_sym_module] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_break] = ACTIONS(2922),
    [anon_sym_next] = ACTIONS(2922),
    [anon_sym_redo] = ACTIONS(2922),
    [anon_sym_retry] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_unless] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_until] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_in] = ACTIONS(2922),
    [anon_sym_case] = ACTIONS(2922),
    [anon_sym_when] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_DOT_DOT] = ACTIONS(2922),
    [anon_sym_elsif] = ACTIONS(2922),
    [anon_sym_else] = ACTIONS(2922),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_ensure] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2924),
    [anon_sym_defined_QMARK] = ACTIONS(2924),
    [anon_sym_not] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2924),
    [anon_sym_TILDE] = ACTIONS(2924),
    [anon_sym_undef] = ACTIONS(2922),
    [anon_sym_alias] = ACTIONS(2922),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2922),
    [sym_float] = ACTIONS(2922),
    [sym_super] = ACTIONS(2922),
    [sym_self] = ACTIONS(2922),
    [sym_true] = ACTIONS(2922),
    [sym_false] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2922),
    [aux_sym_constant_suffix_token1] = ACTIONS(2924),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2922),
    [sym_instance_variable] = ACTIONS(2924),
    [sym_class_variable] = ACTIONS(2924),
    [sym_global_variable] = ACTIONS(2924),
    [sym_character] = ACTIONS(2924),
    [anon_sym_DASH_GT] = ACTIONS(2924),
    [sym_simple_symbol] = ACTIONS(2924),
    [sym__string_start] = ACTIONS(2924),
    [sym__symbol_start] = ACTIONS(2924),
    [sym__subshell_start] = ACTIONS(2924),
    [sym__regex_start] = ACTIONS(2924),
    [sym__string_array_start] = ACTIONS(2924),
    [sym__symbol_array_start] = ACTIONS(2924),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2924),
    [sym__unary_minus] = ACTIONS(2924),
    [sym__unary_minus_num] = ACTIONS(2924),
    [sym__binary_minus] = ACTIONS(2924),
    [sym__identifier_suffix] = ACTIONS(2924),
    [sym__constant_suffix] = ACTIONS(2924),
  },
  [2030] = {
    [sym_heredoc_body] = STATE(2030),
    [ts_builtin_sym_end] = ACTIONS(2580),
    [sym_identifier] = ACTIONS(2578),
    [aux_sym_program_token1] = ACTIONS(2580),
    [anon_sym___END__] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_COLON_COLON] = ACTIONS(2580),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2580),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym__line_break] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
  },
  [2031] = {
    [sym_heredoc_body] = STATE(2031),
    [ts_builtin_sym_end] = ACTIONS(2584),
    [sym_identifier] = ACTIONS(2582),
    [aux_sym_program_token1] = ACTIONS(2584),
    [anon_sym___END__] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2584),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2584),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym__line_break] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
  },
  [2032] = {
    [sym_heredoc_body] = STATE(2032),
    [ts_builtin_sym_end] = ACTIONS(2896),
    [sym_identifier] = ACTIONS(2894),
    [aux_sym_program_token1] = ACTIONS(2896),
    [anon_sym___END__] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2896),
    [anon_sym_def] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2896),
    [anon_sym_COLON_COLON] = ACTIONS(2896),
    [anon_sym_rescue] = ACTIONS(2894),
    [anon_sym_COMMA] = ACTIONS(2896),
    [anon_sym_SEMI] = ACTIONS(2896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2896),
    [anon_sym_STAR] = ACTIONS(2896),
    [anon_sym_nil] = ACTIONS(2894),
    [anon_sym_class] = ACTIONS(2894),
    [anon_sym_module] = ACTIONS(2894),
    [anon_sym_return] = ACTIONS(2894),
    [anon_sym_yield] = ACTIONS(2894),
    [anon_sym_break] = ACTIONS(2894),
    [anon_sym_next] = ACTIONS(2894),
    [anon_sym_redo] = ACTIONS(2894),
    [anon_sym_retry] = ACTIONS(2894),
    [anon_sym_if] = ACTIONS(2894),
    [anon_sym_unless] = ACTIONS(2894),
    [anon_sym_while] = ACTIONS(2894),
    [anon_sym_until] = ACTIONS(2894),
    [anon_sym_for] = ACTIONS(2894),
    [anon_sym_do] = ACTIONS(2894),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_LBRACK] = ACTIONS(2896),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_begin] = ACTIONS(2894),
    [anon_sym_and] = ACTIONS(2894),
    [anon_sym_or] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_defined_QMARK] = ACTIONS(2896),
    [anon_sym_not] = ACTIONS(2894),
    [anon_sym_BANG] = ACTIONS(2896),
    [anon_sym_TILDE] = ACTIONS(2896),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2894),
    [sym_float] = ACTIONS(2894),
    [sym_super] = ACTIONS(2894),
    [sym_self] = ACTIONS(2894),
    [sym_true] = ACTIONS(2894),
    [sym_false] = ACTIONS(2894),
    [sym_constant] = ACTIONS(2894),
    [aux_sym_constant_suffix_token1] = ACTIONS(2896),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2894),
    [sym_instance_variable] = ACTIONS(2896),
    [sym_class_variable] = ACTIONS(2896),
    [sym_global_variable] = ACTIONS(2896),
    [sym_character] = ACTIONS(2896),
    [anon_sym_DASH_GT] = ACTIONS(2896),
    [sym__line_break] = ACTIONS(2896),
    [sym_simple_symbol] = ACTIONS(2896),
    [sym__string_start] = ACTIONS(2896),
    [sym__symbol_start] = ACTIONS(2896),
    [sym__subshell_start] = ACTIONS(2896),
    [sym__regex_start] = ACTIONS(2896),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2896),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2896),
    [sym__block_ampersand] = ACTIONS(2896),
    [sym__splat_star] = ACTIONS(2896),
    [sym__unary_minus] = ACTIONS(2896),
    [sym__unary_minus_num] = ACTIONS(2896),
    [sym__binary_minus] = ACTIONS(2896),
    [sym_hash_key_symbol] = ACTIONS(2896),
    [sym__identifier_suffix] = ACTIONS(2896),
    [sym__constant_suffix] = ACTIONS(2896),
    [sym__hash_splat_star_star] = ACTIONS(2896),
  },
  [2033] = {
    [sym__pattern_expr] = STATE(4800),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4700),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4688),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2033),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_RPAREN] = ACTIONS(2796),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_rescue] = ACTIONS(2798),
    [anon_sym_COMMA] = ACTIONS(2796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2796),
    [anon_sym_DOT_DOT] = ACTIONS(2876),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2798),
    [anon_sym_or] = ACTIONS(2798),
    [anon_sym_PLUS] = ACTIONS(2878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2880),
    [sym_float] = ACTIONS(2880),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2878),
  },
  [2034] = {
    [sym_heredoc_body] = STATE(2034),
    [ts_builtin_sym_end] = ACTIONS(2584),
    [aux_sym_program_token1] = ACTIONS(2584),
    [anon_sym___END__] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_end] = ACTIONS(2584),
    [anon_sym_rescue] = ACTIONS(2584),
    [anon_sym_EQ] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2584),
    [anon_sym_unless] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2584),
    [anon_sym_until] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(2584),
    [anon_sym_do] = ACTIONS(2584),
    [anon_sym_when] = ACTIONS(2584),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_CARET] = ACTIONS(2582),
    [anon_sym_elsif] = ACTIONS(2584),
    [anon_sym_else] = ACTIONS(2584),
    [anon_sym_then] = ACTIONS(2584),
    [anon_sym_ensure] = ACTIONS(2584),
    [anon_sym_COLON_COLON2] = ACTIONS(2584),
    [anon_sym_AMP_DOT] = ACTIONS(2584),
    [anon_sym_PLUS_EQ] = ACTIONS(2584),
    [anon_sym_DASH_EQ] = ACTIONS(2584),
    [anon_sym_STAR_EQ] = ACTIONS(2584),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2584),
    [anon_sym_SLASH_EQ] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2584),
    [anon_sym_PIPE_EQ] = ACTIONS(2584),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2584),
    [anon_sym_AMP_EQ] = ACTIONS(2584),
    [anon_sym_PERCENT_EQ] = ACTIONS(2584),
    [anon_sym_GT_GT_EQ] = ACTIONS(2584),
    [anon_sym_LT_LT_EQ] = ACTIONS(2584),
    [anon_sym_CARET_EQ] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2584),
    [anon_sym_and] = ACTIONS(2584),
    [anon_sym_or] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_LT_EQ] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_PERCENT] = ACTIONS(2582),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ] = ACTIONS(2584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_LT_EQ_GT] = ACTIONS(2584),
    [anon_sym_EQ_TILDE] = ACTIONS(2584),
    [anon_sym_BANG_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2584),
    [sym__binary_star] = ACTIONS(2584),
    [sym__binary_star_star] = ACTIONS(2584),
    [sym__element_reference_bracket] = ACTIONS(2584),
  },
  [2035] = {
    [sym__pattern_expr] = STATE(4800),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2035),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_RPAREN] = ACTIONS(2796),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_COMMA] = ACTIONS(2796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2796),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2798),
    [anon_sym_or] = ACTIONS(2798),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
  },
  [2036] = {
    [sym_heredoc_body] = STATE(2036),
    [ts_builtin_sym_end] = ACTIONS(2568),
    [aux_sym_program_token1] = ACTIONS(2568),
    [anon_sym___END__] = ACTIONS(2570),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_RPAREN] = ACTIONS(2568),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_end] = ACTIONS(2568),
    [anon_sym_rescue] = ACTIONS(2568),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_unless] = ACTIONS(2568),
    [anon_sym_while] = ACTIONS(2568),
    [anon_sym_until] = ACTIONS(2568),
    [anon_sym_in] = ACTIONS(2568),
    [anon_sym_do] = ACTIONS(2568),
    [anon_sym_when] = ACTIONS(2568),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_CARET] = ACTIONS(2570),
    [anon_sym_elsif] = ACTIONS(2568),
    [anon_sym_else] = ACTIONS(2568),
    [anon_sym_then] = ACTIONS(2568),
    [anon_sym_ensure] = ACTIONS(2568),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS_EQ] = ACTIONS(2568),
    [anon_sym_DASH_EQ] = ACTIONS(2568),
    [anon_sym_STAR_EQ] = ACTIONS(2568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2568),
    [anon_sym_SLASH_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2568),
    [anon_sym_AMP_EQ] = ACTIONS(2568),
    [anon_sym_PERCENT_EQ] = ACTIONS(2568),
    [anon_sym_GT_GT_EQ] = ACTIONS(2568),
    [anon_sym_LT_LT_EQ] = ACTIONS(2568),
    [anon_sym_CARET_EQ] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2568),
    [anon_sym_and] = ACTIONS(2568),
    [anon_sym_or] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_EQ] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_EQ] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_EQ_EQ] = ACTIONS(2570),
    [anon_sym_BANG_EQ] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_LT_EQ_GT] = ACTIONS(2568),
    [anon_sym_EQ_TILDE] = ACTIONS(2568),
    [anon_sym_BANG_TILDE] = ACTIONS(2568),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2568),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__binary_star] = ACTIONS(2568),
    [sym__binary_star_star] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [2037] = {
    [sym_heredoc_body] = STATE(2037),
    [ts_builtin_sym_end] = ACTIONS(2588),
    [aux_sym_program_token1] = ACTIONS(2588),
    [anon_sym___END__] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_end] = ACTIONS(2588),
    [anon_sym_rescue] = ACTIONS(2588),
    [anon_sym_EQ] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_unless] = ACTIONS(2588),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_until] = ACTIONS(2588),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_do] = ACTIONS(2588),
    [anon_sym_when] = ACTIONS(2588),
    [anon_sym_EQ_GT] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2588),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_CARET] = ACTIONS(2586),
    [anon_sym_elsif] = ACTIONS(2588),
    [anon_sym_else] = ACTIONS(2588),
    [anon_sym_then] = ACTIONS(2588),
    [anon_sym_ensure] = ACTIONS(2588),
    [anon_sym_COLON_COLON2] = ACTIONS(2588),
    [anon_sym_AMP_DOT] = ACTIONS(2588),
    [anon_sym_PLUS_EQ] = ACTIONS(2588),
    [anon_sym_DASH_EQ] = ACTIONS(2588),
    [anon_sym_STAR_EQ] = ACTIONS(2588),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2588),
    [anon_sym_SLASH_EQ] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2588),
    [anon_sym_PIPE_EQ] = ACTIONS(2588),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2588),
    [anon_sym_AMP_EQ] = ACTIONS(2588),
    [anon_sym_PERCENT_EQ] = ACTIONS(2588),
    [anon_sym_GT_GT_EQ] = ACTIONS(2588),
    [anon_sym_LT_LT_EQ] = ACTIONS(2588),
    [anon_sym_CARET_EQ] = ACTIONS(2588),
    [anon_sym_QMARK] = ACTIONS(2588),
    [anon_sym_and] = ACTIONS(2588),
    [anon_sym_or] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_LT_EQ] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_SLASH] = ACTIONS(2586),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_EQ_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2588),
    [anon_sym_LT_EQ_GT] = ACTIONS(2588),
    [anon_sym_EQ_TILDE] = ACTIONS(2588),
    [anon_sym_BANG_TILDE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2588),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2588),
    [sym__binary_star] = ACTIONS(2588),
    [sym__binary_star_star] = ACTIONS(2588),
    [sym__element_reference_bracket] = ACTIONS(2588),
  },
  [2038] = {
    [sym_heredoc_body] = STATE(2038),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(2926),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2686),
    [anon_sym_LBRACK2] = ACTIONS(2686),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2039] = {
    [sym_heredoc_body] = STATE(2039),
    [ts_builtin_sym_end] = ACTIONS(2564),
    [aux_sym_program_token1] = ACTIONS(2564),
    [anon_sym___END__] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_end] = ACTIONS(2564),
    [anon_sym_rescue] = ACTIONS(2564),
    [anon_sym_EQ] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2564),
    [anon_sym_unless] = ACTIONS(2564),
    [anon_sym_while] = ACTIONS(2564),
    [anon_sym_until] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_do] = ACTIONS(2564),
    [anon_sym_when] = ACTIONS(2564),
    [anon_sym_EQ_GT] = ACTIONS(2564),
    [anon_sym_LPAREN2] = ACTIONS(2564),
    [anon_sym_DOT_DOT] = ACTIONS(2562),
    [anon_sym_CARET] = ACTIONS(2562),
    [anon_sym_elsif] = ACTIONS(2564),
    [anon_sym_else] = ACTIONS(2564),
    [anon_sym_then] = ACTIONS(2564),
    [anon_sym_ensure] = ACTIONS(2564),
    [anon_sym_COLON_COLON2] = ACTIONS(2564),
    [anon_sym_AMP_DOT] = ACTIONS(2564),
    [anon_sym_PLUS_EQ] = ACTIONS(2564),
    [anon_sym_DASH_EQ] = ACTIONS(2564),
    [anon_sym_STAR_EQ] = ACTIONS(2564),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2564),
    [anon_sym_SLASH_EQ] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2564),
    [anon_sym_PIPE_EQ] = ACTIONS(2564),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2564),
    [anon_sym_AMP_EQ] = ACTIONS(2564),
    [anon_sym_PERCENT_EQ] = ACTIONS(2564),
    [anon_sym_GT_GT_EQ] = ACTIONS(2564),
    [anon_sym_LT_LT_EQ] = ACTIONS(2564),
    [anon_sym_CARET_EQ] = ACTIONS(2564),
    [anon_sym_QMARK] = ACTIONS(2564),
    [anon_sym_and] = ACTIONS(2564),
    [anon_sym_or] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_EQ] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_GT_EQ] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_SLASH] = ACTIONS(2562),
    [anon_sym_PERCENT] = ACTIONS(2562),
    [anon_sym_EQ_EQ] = ACTIONS(2562),
    [anon_sym_BANG_EQ] = ACTIONS(2564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2564),
    [anon_sym_LT_EQ_GT] = ACTIONS(2564),
    [anon_sym_EQ_TILDE] = ACTIONS(2564),
    [anon_sym_BANG_TILDE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2564),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2564),
    [sym__binary_star] = ACTIONS(2564),
    [sym__binary_star_star] = ACTIONS(2564),
    [sym__element_reference_bracket] = ACTIONS(2564),
  },
  [2040] = {
    [sym_heredoc_body] = STATE(2040),
    [ts_builtin_sym_end] = ACTIONS(2572),
    [aux_sym_program_token1] = ACTIONS(2572),
    [anon_sym___END__] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_RPAREN] = ACTIONS(2572),
    [anon_sym_DOT] = ACTIONS(2566),
    [anon_sym_end] = ACTIONS(2572),
    [anon_sym_rescue] = ACTIONS(2572),
    [anon_sym_EQ] = ACTIONS(2566),
    [anon_sym_COMMA] = ACTIONS(2572),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(2572),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2572),
    [anon_sym_unless] = ACTIONS(2572),
    [anon_sym_while] = ACTIONS(2572),
    [anon_sym_until] = ACTIONS(2572),
    [anon_sym_in] = ACTIONS(2572),
    [anon_sym_do] = ACTIONS(2572),
    [anon_sym_when] = ACTIONS(2572),
    [anon_sym_EQ_GT] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2566),
    [anon_sym_CARET] = ACTIONS(2566),
    [anon_sym_elsif] = ACTIONS(2572),
    [anon_sym_else] = ACTIONS(2572),
    [anon_sym_then] = ACTIONS(2572),
    [anon_sym_ensure] = ACTIONS(2572),
    [anon_sym_COLON_COLON2] = ACTIONS(2572),
    [anon_sym_AMP_DOT] = ACTIONS(2572),
    [anon_sym_PLUS_EQ] = ACTIONS(2572),
    [anon_sym_DASH_EQ] = ACTIONS(2572),
    [anon_sym_STAR_EQ] = ACTIONS(2572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2572),
    [anon_sym_SLASH_EQ] = ACTIONS(2572),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2572),
    [anon_sym_PIPE_EQ] = ACTIONS(2572),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2572),
    [anon_sym_AMP_EQ] = ACTIONS(2572),
    [anon_sym_PERCENT_EQ] = ACTIONS(2572),
    [anon_sym_GT_GT_EQ] = ACTIONS(2572),
    [anon_sym_LT_LT_EQ] = ACTIONS(2572),
    [anon_sym_CARET_EQ] = ACTIONS(2572),
    [anon_sym_QMARK] = ACTIONS(2572),
    [anon_sym_and] = ACTIONS(2572),
    [anon_sym_or] = ACTIONS(2572),
    [anon_sym_PIPE_PIPE] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2566),
    [anon_sym_LT_EQ] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_EQ] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_SLASH] = ACTIONS(2566),
    [anon_sym_PERCENT] = ACTIONS(2566),
    [anon_sym_EQ_EQ] = ACTIONS(2566),
    [anon_sym_BANG_EQ] = ACTIONS(2572),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2572),
    [anon_sym_LT_EQ_GT] = ACTIONS(2572),
    [anon_sym_EQ_TILDE] = ACTIONS(2572),
    [anon_sym_BANG_TILDE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2572),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2572),
    [sym__binary_star] = ACTIONS(2572),
    [sym__binary_star_star] = ACTIONS(2572),
    [sym__element_reference_bracket] = ACTIONS(2572),
  },
  [2041] = {
    [sym_heredoc_body] = STATE(2041),
    [ts_builtin_sym_end] = ACTIONS(2568),
    [aux_sym_program_token1] = ACTIONS(2568),
    [anon_sym___END__] = ACTIONS(2570),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_RPAREN] = ACTIONS(2568),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_end] = ACTIONS(2568),
    [anon_sym_rescue] = ACTIONS(2568),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_unless] = ACTIONS(2568),
    [anon_sym_while] = ACTIONS(2568),
    [anon_sym_until] = ACTIONS(2568),
    [anon_sym_in] = ACTIONS(2568),
    [anon_sym_do] = ACTIONS(2572),
    [anon_sym_when] = ACTIONS(2568),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LPAREN2] = ACTIONS(2572),
    [anon_sym_DOT_DOT] = ACTIONS(2570),
    [anon_sym_CARET] = ACTIONS(2570),
    [anon_sym_elsif] = ACTIONS(2568),
    [anon_sym_else] = ACTIONS(2568),
    [anon_sym_then] = ACTIONS(2568),
    [anon_sym_ensure] = ACTIONS(2568),
    [anon_sym_COLON_COLON2] = ACTIONS(2568),
    [anon_sym_AMP_DOT] = ACTIONS(2568),
    [anon_sym_PLUS_EQ] = ACTIONS(2568),
    [anon_sym_DASH_EQ] = ACTIONS(2568),
    [anon_sym_STAR_EQ] = ACTIONS(2568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2568),
    [anon_sym_SLASH_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_PIPE_EQ] = ACTIONS(2568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2568),
    [anon_sym_AMP_EQ] = ACTIONS(2568),
    [anon_sym_PERCENT_EQ] = ACTIONS(2568),
    [anon_sym_GT_GT_EQ] = ACTIONS(2568),
    [anon_sym_LT_LT_EQ] = ACTIONS(2568),
    [anon_sym_CARET_EQ] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2568),
    [anon_sym_and] = ACTIONS(2568),
    [anon_sym_or] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2570),
    [anon_sym_LT_EQ] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_EQ] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_PERCENT] = ACTIONS(2570),
    [anon_sym_EQ_EQ] = ACTIONS(2570),
    [anon_sym_BANG_EQ] = ACTIONS(2568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2568),
    [anon_sym_LT_EQ_GT] = ACTIONS(2568),
    [anon_sym_EQ_TILDE] = ACTIONS(2568),
    [anon_sym_BANG_TILDE] = ACTIONS(2568),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2568),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2568),
    [sym__binary_star] = ACTIONS(2568),
    [sym__binary_star_star] = ACTIONS(2568),
    [sym__element_reference_bracket] = ACTIONS(2568),
  },
  [2042] = {
    [sym_heredoc_body] = STATE(2042),
    [ts_builtin_sym_end] = ACTIONS(2580),
    [aux_sym_program_token1] = ACTIONS(2580),
    [anon_sym___END__] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_end] = ACTIONS(2580),
    [anon_sym_rescue] = ACTIONS(2580),
    [anon_sym_EQ] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2580),
    [anon_sym_unless] = ACTIONS(2580),
    [anon_sym_while] = ACTIONS(2580),
    [anon_sym_until] = ACTIONS(2580),
    [anon_sym_in] = ACTIONS(2580),
    [anon_sym_do] = ACTIONS(2580),
    [anon_sym_when] = ACTIONS(2580),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_CARET] = ACTIONS(2578),
    [anon_sym_elsif] = ACTIONS(2580),
    [anon_sym_else] = ACTIONS(2580),
    [anon_sym_then] = ACTIONS(2580),
    [anon_sym_ensure] = ACTIONS(2580),
    [anon_sym_COLON_COLON2] = ACTIONS(2580),
    [anon_sym_AMP_DOT] = ACTIONS(2580),
    [anon_sym_PLUS_EQ] = ACTIONS(2580),
    [anon_sym_DASH_EQ] = ACTIONS(2580),
    [anon_sym_STAR_EQ] = ACTIONS(2580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2580),
    [anon_sym_SLASH_EQ] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2580),
    [anon_sym_PIPE_EQ] = ACTIONS(2580),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2580),
    [anon_sym_AMP_EQ] = ACTIONS(2580),
    [anon_sym_PERCENT_EQ] = ACTIONS(2580),
    [anon_sym_GT_GT_EQ] = ACTIONS(2580),
    [anon_sym_LT_LT_EQ] = ACTIONS(2580),
    [anon_sym_CARET_EQ] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2580),
    [anon_sym_and] = ACTIONS(2580),
    [anon_sym_or] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2578),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_SLASH] = ACTIONS(2578),
    [anon_sym_PERCENT] = ACTIONS(2578),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2580),
    [anon_sym_EQ_TILDE] = ACTIONS(2580),
    [anon_sym_BANG_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2580),
    [sym__binary_star] = ACTIONS(2580),
    [sym__binary_star_star] = ACTIONS(2580),
    [sym__element_reference_bracket] = ACTIONS(2580),
  },
  [2043] = {
    [sym_heredoc_body] = STATE(2043),
    [ts_builtin_sym_end] = ACTIONS(2592),
    [aux_sym_program_token1] = ACTIONS(2592),
    [anon_sym___END__] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_RBRACE] = ACTIONS(2592),
    [anon_sym_RPAREN] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_end] = ACTIONS(2592),
    [anon_sym_rescue] = ACTIONS(2592),
    [anon_sym_EQ] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_unless] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [anon_sym_until] = ACTIONS(2592),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_do] = ACTIONS(2592),
    [anon_sym_when] = ACTIONS(2592),
    [anon_sym_EQ_GT] = ACTIONS(2592),
    [anon_sym_LPAREN2] = ACTIONS(2592),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_elsif] = ACTIONS(2592),
    [anon_sym_else] = ACTIONS(2592),
    [anon_sym_then] = ACTIONS(2592),
    [anon_sym_ensure] = ACTIONS(2592),
    [anon_sym_COLON_COLON2] = ACTIONS(2592),
    [anon_sym_AMP_DOT] = ACTIONS(2592),
    [anon_sym_PLUS_EQ] = ACTIONS(2592),
    [anon_sym_DASH_EQ] = ACTIONS(2592),
    [anon_sym_STAR_EQ] = ACTIONS(2592),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2592),
    [anon_sym_SLASH_EQ] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2592),
    [anon_sym_PIPE_EQ] = ACTIONS(2592),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2592),
    [anon_sym_AMP_EQ] = ACTIONS(2592),
    [anon_sym_PERCENT_EQ] = ACTIONS(2592),
    [anon_sym_GT_GT_EQ] = ACTIONS(2592),
    [anon_sym_LT_LT_EQ] = ACTIONS(2592),
    [anon_sym_CARET_EQ] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2592),
    [anon_sym_and] = ACTIONS(2592),
    [anon_sym_or] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2590),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2592),
    [anon_sym_LT_EQ_GT] = ACTIONS(2592),
    [anon_sym_EQ_TILDE] = ACTIONS(2592),
    [anon_sym_BANG_TILDE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2592),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2592),
    [sym__binary_star] = ACTIONS(2592),
    [sym__binary_star_star] = ACTIONS(2592),
    [sym__element_reference_bracket] = ACTIONS(2592),
  },
  [2044] = {
    [sym_heredoc_body] = STATE(2044),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2045] = {
    [sym__pattern_expr] = STATE(4782),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4700),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4688),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2045),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_RPAREN] = ACTIONS(2322),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_rescue] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(2322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2322),
    [anon_sym_DOT_DOT] = ACTIONS(2876),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2880),
    [sym_float] = ACTIONS(2880),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2878),
  },
  [2046] = {
    [sym_heredoc_body] = STATE(2046),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2047] = {
    [sym_heredoc_body] = STATE(2047),
    [ts_builtin_sym_end] = ACTIONS(2576),
    [aux_sym_program_token1] = ACTIONS(2576),
    [anon_sym___END__] = ACTIONS(2574),
    [anon_sym_LBRACE] = ACTIONS(2576),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_RPAREN] = ACTIONS(2576),
    [anon_sym_DOT] = ACTIONS(2574),
    [anon_sym_end] = ACTIONS(2576),
    [anon_sym_rescue] = ACTIONS(2576),
    [anon_sym_EQ] = ACTIONS(2574),
    [anon_sym_COMMA] = ACTIONS(2576),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_SEMI] = ACTIONS(2576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2574),
    [anon_sym_LT] = ACTIONS(2574),
    [anon_sym_if] = ACTIONS(2576),
    [anon_sym_unless] = ACTIONS(2576),
    [anon_sym_while] = ACTIONS(2576),
    [anon_sym_until] = ACTIONS(2576),
    [anon_sym_in] = ACTIONS(2576),
    [anon_sym_do] = ACTIONS(2576),
    [anon_sym_when] = ACTIONS(2576),
    [anon_sym_EQ_GT] = ACTIONS(2576),
    [anon_sym_LPAREN2] = ACTIONS(2576),
    [anon_sym_DOT_DOT] = ACTIONS(2574),
    [anon_sym_CARET] = ACTIONS(2574),
    [anon_sym_elsif] = ACTIONS(2576),
    [anon_sym_else] = ACTIONS(2576),
    [anon_sym_then] = ACTIONS(2576),
    [anon_sym_ensure] = ACTIONS(2576),
    [anon_sym_COLON_COLON2] = ACTIONS(2576),
    [anon_sym_AMP_DOT] = ACTIONS(2576),
    [anon_sym_PLUS_EQ] = ACTIONS(2576),
    [anon_sym_DASH_EQ] = ACTIONS(2576),
    [anon_sym_STAR_EQ] = ACTIONS(2576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2576),
    [anon_sym_SLASH_EQ] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2576),
    [anon_sym_PIPE_EQ] = ACTIONS(2576),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2576),
    [anon_sym_AMP_EQ] = ACTIONS(2576),
    [anon_sym_PERCENT_EQ] = ACTIONS(2576),
    [anon_sym_GT_GT_EQ] = ACTIONS(2576),
    [anon_sym_LT_LT_EQ] = ACTIONS(2576),
    [anon_sym_CARET_EQ] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(2576),
    [anon_sym_and] = ACTIONS(2576),
    [anon_sym_or] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_LT_LT] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2574),
    [anon_sym_LT_EQ] = ACTIONS(2574),
    [anon_sym_GT] = ACTIONS(2574),
    [anon_sym_GT_EQ] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2574),
    [anon_sym_EQ_EQ] = ACTIONS(2574),
    [anon_sym_BANG_EQ] = ACTIONS(2576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2576),
    [anon_sym_LT_EQ_GT] = ACTIONS(2576),
    [anon_sym_EQ_TILDE] = ACTIONS(2576),
    [anon_sym_BANG_TILDE] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2576),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2576),
    [sym__binary_star] = ACTIONS(2576),
    [sym__binary_star_star] = ACTIONS(2576),
    [sym__element_reference_bracket] = ACTIONS(2576),
  },
  [2048] = {
    [sym__pattern_expr] = STATE(4782),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2048),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_RPAREN] = ACTIONS(2322),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_COMMA] = ACTIONS(2322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2322),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
  },
  [2049] = {
    [sym_heredoc_body] = STATE(2049),
    [ts_builtin_sym_end] = ACTIONS(2932),
    [aux_sym_program_token1] = ACTIONS(2932),
    [anon_sym___END__] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_end] = ACTIONS(2932),
    [anon_sym_rescue] = ACTIONS(2932),
    [anon_sym_EQ] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_PIPE] = ACTIONS(2934),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LT] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2932),
    [anon_sym_unless] = ACTIONS(2932),
    [anon_sym_while] = ACTIONS(2932),
    [anon_sym_until] = ACTIONS(2932),
    [anon_sym_in] = ACTIONS(2932),
    [anon_sym_do] = ACTIONS(2932),
    [anon_sym_when] = ACTIONS(2932),
    [anon_sym_EQ_GT] = ACTIONS(2932),
    [anon_sym_DOT_DOT] = ACTIONS(2934),
    [anon_sym_CARET] = ACTIONS(2934),
    [anon_sym_elsif] = ACTIONS(2932),
    [anon_sym_else] = ACTIONS(2932),
    [anon_sym_then] = ACTIONS(2932),
    [anon_sym_ensure] = ACTIONS(2932),
    [anon_sym_COLON_COLON2] = ACTIONS(2932),
    [anon_sym_AMP_DOT] = ACTIONS(2932),
    [anon_sym_PLUS_EQ] = ACTIONS(2932),
    [anon_sym_DASH_EQ] = ACTIONS(2932),
    [anon_sym_STAR_EQ] = ACTIONS(2932),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2932),
    [anon_sym_SLASH_EQ] = ACTIONS(2932),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2932),
    [anon_sym_PIPE_EQ] = ACTIONS(2932),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2932),
    [anon_sym_AMP_EQ] = ACTIONS(2932),
    [anon_sym_PERCENT_EQ] = ACTIONS(2932),
    [anon_sym_GT_GT_EQ] = ACTIONS(2932),
    [anon_sym_LT_LT_EQ] = ACTIONS(2932),
    [anon_sym_CARET_EQ] = ACTIONS(2932),
    [anon_sym_QMARK] = ACTIONS(2932),
    [anon_sym_and] = ACTIONS(2932),
    [anon_sym_or] = ACTIONS(2932),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(2934),
    [anon_sym_GT_GT] = ACTIONS(2934),
    [anon_sym_LT_EQ] = ACTIONS(2934),
    [anon_sym_GT] = ACTIONS(2934),
    [anon_sym_GT_EQ] = ACTIONS(2932),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_SLASH] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_EQ_EQ] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2932),
    [anon_sym_LT_EQ_GT] = ACTIONS(2932),
    [anon_sym_EQ_TILDE] = ACTIONS(2932),
    [anon_sym_BANG_TILDE] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2932),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2932),
    [sym__binary_star] = ACTIONS(2932),
    [sym__binary_star_star] = ACTIONS(2932),
    [sym__element_reference_bracket] = ACTIONS(2932),
  },
  [2050] = {
    [sym_splat_parameter] = STATE(4875),
    [sym__array_pattern_n] = STATE(5490),
    [sym__pattern_expr] = STATE(5270),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym__array_pattern_body] = STATE(5724),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(5725),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2050),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
  },
  [2051] = {
    [sym_splat_parameter] = STATE(4875),
    [sym__array_pattern_n] = STATE(5490),
    [sym__pattern_expr] = STATE(5270),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym__array_pattern_body] = STATE(5763),
    [sym_array_pattern] = STATE(4756),
    [sym__find_pattern_body] = STATE(5764),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2051),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2938),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
  },
  [2052] = {
    [sym_heredoc_body] = STATE(2052),
    [ts_builtin_sym_end] = ACTIONS(2940),
    [aux_sym_program_token1] = ACTIONS(2940),
    [anon_sym___END__] = ACTIONS(2942),
    [anon_sym_LBRACE] = ACTIONS(2940),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_end] = ACTIONS(2940),
    [anon_sym_rescue] = ACTIONS(2940),
    [anon_sym_EQ] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_PIPE] = ACTIONS(2942),
    [anon_sym_SEMI] = ACTIONS(2940),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LT] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2940),
    [anon_sym_unless] = ACTIONS(2940),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_until] = ACTIONS(2940),
    [anon_sym_in] = ACTIONS(2940),
    [anon_sym_do] = ACTIONS(2940),
    [anon_sym_when] = ACTIONS(2940),
    [anon_sym_EQ_GT] = ACTIONS(2940),
    [anon_sym_DOT_DOT] = ACTIONS(2942),
    [anon_sym_CARET] = ACTIONS(2942),
    [anon_sym_elsif] = ACTIONS(2940),
    [anon_sym_else] = ACTIONS(2940),
    [anon_sym_then] = ACTIONS(2940),
    [anon_sym_ensure] = ACTIONS(2940),
    [anon_sym_COLON_COLON2] = ACTIONS(2940),
    [anon_sym_AMP_DOT] = ACTIONS(2940),
    [anon_sym_PLUS_EQ] = ACTIONS(2940),
    [anon_sym_DASH_EQ] = ACTIONS(2940),
    [anon_sym_STAR_EQ] = ACTIONS(2940),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2940),
    [anon_sym_SLASH_EQ] = ACTIONS(2940),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2940),
    [anon_sym_PIPE_EQ] = ACTIONS(2940),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2940),
    [anon_sym_AMP_EQ] = ACTIONS(2940),
    [anon_sym_PERCENT_EQ] = ACTIONS(2940),
    [anon_sym_GT_GT_EQ] = ACTIONS(2940),
    [anon_sym_LT_LT_EQ] = ACTIONS(2940),
    [anon_sym_CARET_EQ] = ACTIONS(2940),
    [anon_sym_QMARK] = ACTIONS(2940),
    [anon_sym_and] = ACTIONS(2940),
    [anon_sym_or] = ACTIONS(2940),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_LT_LT] = ACTIONS(2942),
    [anon_sym_GT_GT] = ACTIONS(2942),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2940),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_SLASH] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2940),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2940),
    [anon_sym_LT_EQ_GT] = ACTIONS(2940),
    [anon_sym_EQ_TILDE] = ACTIONS(2940),
    [anon_sym_BANG_TILDE] = ACTIONS(2940),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2940),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2940),
    [sym__binary_star] = ACTIONS(2940),
    [sym__binary_star_star] = ACTIONS(2940),
    [sym__element_reference_bracket] = ACTIONS(2940),
  },
  [2053] = {
    [sym_heredoc_body] = STATE(2053),
    [ts_builtin_sym_end] = ACTIONS(2944),
    [aux_sym_program_token1] = ACTIONS(2944),
    [anon_sym___END__] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2944),
    [anon_sym_RBRACE] = ACTIONS(2944),
    [anon_sym_RPAREN] = ACTIONS(2944),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_end] = ACTIONS(2944),
    [anon_sym_rescue] = ACTIONS(2944),
    [anon_sym_EQ] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2944),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2944),
    [anon_sym_unless] = ACTIONS(2944),
    [anon_sym_while] = ACTIONS(2944),
    [anon_sym_until] = ACTIONS(2944),
    [anon_sym_in] = ACTIONS(2944),
    [anon_sym_do] = ACTIONS(2944),
    [anon_sym_when] = ACTIONS(2944),
    [anon_sym_EQ_GT] = ACTIONS(2944),
    [anon_sym_DOT_DOT] = ACTIONS(2946),
    [anon_sym_CARET] = ACTIONS(2946),
    [anon_sym_elsif] = ACTIONS(2944),
    [anon_sym_else] = ACTIONS(2944),
    [anon_sym_then] = ACTIONS(2944),
    [anon_sym_ensure] = ACTIONS(2944),
    [anon_sym_COLON_COLON2] = ACTIONS(2944),
    [anon_sym_AMP_DOT] = ACTIONS(2944),
    [anon_sym_PLUS_EQ] = ACTIONS(2944),
    [anon_sym_DASH_EQ] = ACTIONS(2944),
    [anon_sym_STAR_EQ] = ACTIONS(2944),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2944),
    [anon_sym_SLASH_EQ] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2944),
    [anon_sym_PIPE_EQ] = ACTIONS(2944),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2944),
    [anon_sym_AMP_EQ] = ACTIONS(2944),
    [anon_sym_PERCENT_EQ] = ACTIONS(2944),
    [anon_sym_GT_GT_EQ] = ACTIONS(2944),
    [anon_sym_LT_LT_EQ] = ACTIONS(2944),
    [anon_sym_CARET_EQ] = ACTIONS(2944),
    [anon_sym_QMARK] = ACTIONS(2944),
    [anon_sym_and] = ACTIONS(2944),
    [anon_sym_or] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2946),
    [anon_sym_LT_EQ] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_GT_EQ] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_SLASH] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_EQ_EQ] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2944),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2944),
    [anon_sym_LT_EQ_GT] = ACTIONS(2944),
    [anon_sym_EQ_TILDE] = ACTIONS(2944),
    [anon_sym_BANG_TILDE] = ACTIONS(2944),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2944),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2944),
    [sym__binary_star] = ACTIONS(2944),
    [sym__binary_star_star] = ACTIONS(2944),
    [sym__element_reference_bracket] = ACTIONS(2944),
  },
  [2054] = {
    [sym_heredoc_body] = STATE(2054),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(2930),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2055] = {
    [sym_heredoc_body] = STATE(2055),
    [ts_builtin_sym_end] = ACTIONS(123),
    [aux_sym_program_token1] = ACTIONS(123),
    [anon_sym___END__] = ACTIONS(129),
    [anon_sym_LBRACE] = ACTIONS(123),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_DOT] = ACTIONS(129),
    [anon_sym_end] = ACTIONS(123),
    [anon_sym_rescue] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_unless] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_until] = ACTIONS(123),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_when] = ACTIONS(123),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_DOT_DOT] = ACTIONS(129),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_elsif] = ACTIONS(123),
    [anon_sym_else] = ACTIONS(123),
    [anon_sym_then] = ACTIONS(123),
    [anon_sym_ensure] = ACTIONS(123),
    [anon_sym_COLON_COLON2] = ACTIONS(123),
    [anon_sym_AMP_DOT] = ACTIONS(123),
    [anon_sym_PLUS_EQ] = ACTIONS(123),
    [anon_sym_DASH_EQ] = ACTIONS(123),
    [anon_sym_STAR_EQ] = ACTIONS(123),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(123),
    [anon_sym_SLASH_EQ] = ACTIONS(123),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(123),
    [anon_sym_PIPE_EQ] = ACTIONS(123),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(123),
    [anon_sym_AMP_EQ] = ACTIONS(123),
    [anon_sym_PERCENT_EQ] = ACTIONS(123),
    [anon_sym_GT_GT_EQ] = ACTIONS(123),
    [anon_sym_LT_LT_EQ] = ACTIONS(123),
    [anon_sym_CARET_EQ] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_EQ] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(129),
    [anon_sym_PERCENT] = ACTIONS(129),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(123),
    [anon_sym_LT_EQ_GT] = ACTIONS(123),
    [anon_sym_EQ_TILDE] = ACTIONS(123),
    [anon_sym_BANG_TILDE] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(123),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(123),
    [sym__binary_star] = ACTIONS(123),
    [sym__binary_star_star] = ACTIONS(123),
    [sym__element_reference_bracket] = ACTIONS(123),
  },
  [2056] = {
    [sym_heredoc_body] = STATE(2056),
    [ts_builtin_sym_end] = ACTIONS(2910),
    [aux_sym_program_token1] = ACTIONS(2910),
    [anon_sym___END__] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_RBRACE] = ACTIONS(2910),
    [anon_sym_RPAREN] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2912),
    [anon_sym_end] = ACTIONS(2910),
    [anon_sym_rescue] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COMMA] = ACTIONS(2910),
    [anon_sym_PIPE] = ACTIONS(2912),
    [anon_sym_SEMI] = ACTIONS(2910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2910),
    [anon_sym_AMP] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_unless] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_until] = ACTIONS(2910),
    [anon_sym_in] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_when] = ACTIONS(2910),
    [anon_sym_EQ_GT] = ACTIONS(2910),
    [anon_sym_DOT_DOT] = ACTIONS(2912),
    [anon_sym_CARET] = ACTIONS(2912),
    [anon_sym_elsif] = ACTIONS(2910),
    [anon_sym_else] = ACTIONS(2910),
    [anon_sym_then] = ACTIONS(2910),
    [anon_sym_ensure] = ACTIONS(2910),
    [anon_sym_COLON_COLON2] = ACTIONS(2910),
    [anon_sym_AMP_DOT] = ACTIONS(2910),
    [anon_sym_PLUS_EQ] = ACTIONS(2910),
    [anon_sym_DASH_EQ] = ACTIONS(2910),
    [anon_sym_STAR_EQ] = ACTIONS(2910),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2910),
    [anon_sym_SLASH_EQ] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2910),
    [anon_sym_PIPE_EQ] = ACTIONS(2910),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2910),
    [anon_sym_AMP_EQ] = ACTIONS(2910),
    [anon_sym_PERCENT_EQ] = ACTIONS(2910),
    [anon_sym_GT_GT_EQ] = ACTIONS(2910),
    [anon_sym_LT_LT_EQ] = ACTIONS(2910),
    [anon_sym_CARET_EQ] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_and] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2912),
    [anon_sym_AMP_AMP] = ACTIONS(2912),
    [anon_sym_LT_LT] = ACTIONS(2912),
    [anon_sym_GT_GT] = ACTIONS(2912),
    [anon_sym_LT_EQ] = ACTIONS(2912),
    [anon_sym_GT] = ACTIONS(2912),
    [anon_sym_GT_EQ] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_SLASH] = ACTIONS(2912),
    [anon_sym_PERCENT] = ACTIONS(2912),
    [anon_sym_EQ_EQ] = ACTIONS(2912),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2910),
    [anon_sym_LT_EQ_GT] = ACTIONS(2910),
    [anon_sym_EQ_TILDE] = ACTIONS(2910),
    [anon_sym_BANG_TILDE] = ACTIONS(2910),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2910),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2910),
    [sym__binary_star] = ACTIONS(2910),
    [sym__binary_star_star] = ACTIONS(2910),
    [sym__element_reference_bracket] = ACTIONS(2910),
  },
  [2057] = {
    [sym_heredoc_body] = STATE(2057),
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_BEGIN] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_END] = ACTIONS(2948),
    [anon_sym_def] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2950),
    [anon_sym_end] = ACTIONS(2948),
    [anon_sym_rescue] = ACTIONS(2948),
    [anon_sym_EQ] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_STAR] = ACTIONS(2950),
    [anon_sym_nil] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_module] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_next] = ACTIONS(2948),
    [anon_sym_redo] = ACTIONS(2948),
    [anon_sym_retry] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_unless] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_until] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2948),
    [anon_sym_else] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2948),
    [anon_sym_ensure] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_defined_QMARK] = ACTIONS(2950),
    [anon_sym_not] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2950),
    [anon_sym_undef] = ACTIONS(2948),
    [anon_sym_alias] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2948),
    [sym_float] = ACTIONS(2948),
    [sym_super] = ACTIONS(2948),
    [sym_self] = ACTIONS(2948),
    [sym_true] = ACTIONS(2948),
    [sym_false] = ACTIONS(2948),
    [sym_constant] = ACTIONS(2948),
    [aux_sym_constant_suffix_token1] = ACTIONS(2950),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2948),
    [sym_instance_variable] = ACTIONS(2950),
    [sym_class_variable] = ACTIONS(2950),
    [sym_global_variable] = ACTIONS(2950),
    [sym_character] = ACTIONS(2950),
    [anon_sym_DASH_GT] = ACTIONS(2950),
    [sym__line_break] = ACTIONS(2950),
    [sym_simple_symbol] = ACTIONS(2950),
    [sym__string_start] = ACTIONS(2950),
    [sym__symbol_start] = ACTIONS(2950),
    [sym__subshell_start] = ACTIONS(2950),
    [sym__regex_start] = ACTIONS(2950),
    [sym__string_array_start] = ACTIONS(2950),
    [sym__symbol_array_start] = ACTIONS(2950),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2950),
    [sym__unary_minus] = ACTIONS(2950),
    [sym__unary_minus_num] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym__identifier_suffix] = ACTIONS(2950),
    [sym__constant_suffix] = ACTIONS(2950),
  },
  [2058] = {
    [sym_heredoc_body] = STATE(2058),
    [sym_identifier] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_def] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2592),
    [anon_sym_RPAREN] = ACTIONS(2592),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_rescue] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_nil] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_yield] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_next] = ACTIONS(2590),
    [anon_sym_redo] = ACTIONS(2590),
    [anon_sym_retry] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_unless] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_until] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_RBRACK] = ACTIONS(2592),
    [anon_sym_DOT_DOT] = ACTIONS(2590),
    [anon_sym_begin] = ACTIONS(2590),
    [anon_sym_and] = ACTIONS(2590),
    [anon_sym_or] = ACTIONS(2590),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_defined_QMARK] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_TILDE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2590),
    [sym_float] = ACTIONS(2590),
    [sym_super] = ACTIONS(2590),
    [sym_self] = ACTIONS(2590),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_constant] = ACTIONS(2590),
    [aux_sym_constant_suffix_token1] = ACTIONS(2592),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2590),
    [sym_instance_variable] = ACTIONS(2592),
    [sym_class_variable] = ACTIONS(2592),
    [sym_global_variable] = ACTIONS(2592),
    [sym_character] = ACTIONS(2592),
    [anon_sym_DASH_GT] = ACTIONS(2592),
    [sym_simple_symbol] = ACTIONS(2592),
    [sym__string_start] = ACTIONS(2592),
    [sym__symbol_start] = ACTIONS(2592),
    [sym__subshell_start] = ACTIONS(2592),
    [sym__regex_start] = ACTIONS(2592),
    [sym__string_array_start] = ACTIONS(2592),
    [sym__symbol_array_start] = ACTIONS(2592),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2592),
    [sym__block_ampersand] = ACTIONS(2592),
    [sym__splat_star] = ACTIONS(2592),
    [sym__unary_minus] = ACTIONS(2592),
    [sym__unary_minus_num] = ACTIONS(2592),
    [sym__binary_minus] = ACTIONS(2592),
    [sym_hash_key_symbol] = ACTIONS(2592),
    [sym__identifier_suffix] = ACTIONS(2592),
    [sym__constant_suffix] = ACTIONS(2592),
    [sym__hash_splat_star_star] = ACTIONS(2592),
  },
  [2059] = {
    [sym_heredoc_body] = STATE(2059),
    [sym_identifier] = ACTIONS(2952),
    [anon_sym_BEGIN] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_END] = ACTIONS(2952),
    [anon_sym_def] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2954),
    [anon_sym_end] = ACTIONS(2952),
    [anon_sym_rescue] = ACTIONS(2952),
    [anon_sym_EQ] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2954),
    [anon_sym_nil] = ACTIONS(2952),
    [anon_sym_class] = ACTIONS(2952),
    [anon_sym_module] = ACTIONS(2952),
    [anon_sym_return] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2952),
    [anon_sym_break] = ACTIONS(2952),
    [anon_sym_next] = ACTIONS(2952),
    [anon_sym_redo] = ACTIONS(2952),
    [anon_sym_retry] = ACTIONS(2952),
    [anon_sym_if] = ACTIONS(2952),
    [anon_sym_unless] = ACTIONS(2952),
    [anon_sym_while] = ACTIONS(2952),
    [anon_sym_until] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2952),
    [anon_sym_case] = ACTIONS(2952),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_else] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2952),
    [anon_sym_ensure] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_defined_QMARK] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2952),
    [anon_sym_BANG] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2954),
    [anon_sym_undef] = ACTIONS(2952),
    [anon_sym_alias] = ACTIONS(2952),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2952),
    [sym_float] = ACTIONS(2952),
    [sym_super] = ACTIONS(2952),
    [sym_self] = ACTIONS(2952),
    [sym_true] = ACTIONS(2952),
    [sym_false] = ACTIONS(2952),
    [sym_constant] = ACTIONS(2952),
    [aux_sym_constant_suffix_token1] = ACTIONS(2954),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2952),
    [sym_instance_variable] = ACTIONS(2954),
    [sym_class_variable] = ACTIONS(2954),
    [sym_global_variable] = ACTIONS(2954),
    [sym_character] = ACTIONS(2954),
    [anon_sym_DASH_GT] = ACTIONS(2954),
    [sym__line_break] = ACTIONS(2954),
    [sym_simple_symbol] = ACTIONS(2954),
    [sym__string_start] = ACTIONS(2954),
    [sym__symbol_start] = ACTIONS(2954),
    [sym__subshell_start] = ACTIONS(2954),
    [sym__regex_start] = ACTIONS(2954),
    [sym__string_array_start] = ACTIONS(2954),
    [sym__symbol_array_start] = ACTIONS(2954),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2954),
    [sym__unary_minus] = ACTIONS(2954),
    [sym__unary_minus_num] = ACTIONS(2954),
    [sym__binary_minus] = ACTIONS(2954),
    [sym__identifier_suffix] = ACTIONS(2954),
    [sym__constant_suffix] = ACTIONS(2954),
  },
  [2060] = {
    [sym_heredoc_body] = STATE(2060),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_end] = ACTIONS(745),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_in] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_when] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2956),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_then] = ACTIONS(745),
    [anon_sym_ensure] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2061] = {
    [sym_heredoc_body] = STATE(2061),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_def] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_COLON_COLON] = ACTIONS(2580),
    [anon_sym_rescue] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2580),
    [anon_sym_nil] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_next] = ACTIONS(2578),
    [anon_sym_redo] = ACTIONS(2578),
    [anon_sym_retry] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_unless] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_until] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_DOT_DOT] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_and] = ACTIONS(2578),
    [anon_sym_or] = ACTIONS(2578),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_defined_QMARK] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2580),
    [anon_sym_TILDE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2578),
    [sym_float] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_self] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_constant] = ACTIONS(2578),
    [aux_sym_constant_suffix_token1] = ACTIONS(2580),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2578),
    [sym_instance_variable] = ACTIONS(2580),
    [sym_class_variable] = ACTIONS(2580),
    [sym_global_variable] = ACTIONS(2580),
    [sym_character] = ACTIONS(2580),
    [anon_sym_DASH_GT] = ACTIONS(2580),
    [sym_simple_symbol] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__symbol_start] = ACTIONS(2580),
    [sym__subshell_start] = ACTIONS(2580),
    [sym__regex_start] = ACTIONS(2580),
    [sym__string_array_start] = ACTIONS(2580),
    [sym__symbol_array_start] = ACTIONS(2580),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2580),
    [sym__block_ampersand] = ACTIONS(2580),
    [sym__splat_star] = ACTIONS(2580),
    [sym__unary_minus] = ACTIONS(2580),
    [sym__unary_minus_num] = ACTIONS(2580),
    [sym__binary_minus] = ACTIONS(2580),
    [sym_hash_key_symbol] = ACTIONS(2580),
    [sym__identifier_suffix] = ACTIONS(2580),
    [sym__constant_suffix] = ACTIONS(2580),
    [sym__hash_splat_star_star] = ACTIONS(2580),
  },
  [2062] = {
    [sym_heredoc_body] = STATE(2062),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_def] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2584),
    [anon_sym_rescue] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2584),
    [anon_sym_nil] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_next] = ACTIONS(2582),
    [anon_sym_redo] = ACTIONS(2582),
    [anon_sym_retry] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_unless] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_until] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_DOT_DOT] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(2582),
    [anon_sym_or] = ACTIONS(2582),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_defined_QMARK] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2584),
    [anon_sym_TILDE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2582),
    [sym_float] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_self] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_constant] = ACTIONS(2582),
    [aux_sym_constant_suffix_token1] = ACTIONS(2584),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2582),
    [sym_instance_variable] = ACTIONS(2584),
    [sym_class_variable] = ACTIONS(2584),
    [sym_global_variable] = ACTIONS(2584),
    [sym_character] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(2584),
    [sym_simple_symbol] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__symbol_start] = ACTIONS(2584),
    [sym__subshell_start] = ACTIONS(2584),
    [sym__regex_start] = ACTIONS(2584),
    [sym__string_array_start] = ACTIONS(2584),
    [sym__symbol_array_start] = ACTIONS(2584),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2584),
    [sym__block_ampersand] = ACTIONS(2584),
    [sym__splat_star] = ACTIONS(2584),
    [sym__unary_minus] = ACTIONS(2584),
    [sym__unary_minus_num] = ACTIONS(2584),
    [sym__binary_minus] = ACTIONS(2584),
    [sym_hash_key_symbol] = ACTIONS(2584),
    [sym__identifier_suffix] = ACTIONS(2584),
    [sym__constant_suffix] = ACTIONS(2584),
    [sym__hash_splat_star_star] = ACTIONS(2584),
  },
  [2063] = {
    [sym_heredoc_body] = STATE(2063),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_BEGIN] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_END] = ACTIONS(2958),
    [anon_sym_def] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_end] = ACTIONS(2958),
    [anon_sym_rescue] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2960),
    [anon_sym_nil] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(2958),
    [anon_sym_module] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_break] = ACTIONS(2958),
    [anon_sym_next] = ACTIONS(2958),
    [anon_sym_redo] = ACTIONS(2958),
    [anon_sym_retry] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_unless] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_until] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_case] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_DOT_DOT] = ACTIONS(2958),
    [anon_sym_else] = ACTIONS(2958),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_ensure] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_defined_QMARK] = ACTIONS(2960),
    [anon_sym_not] = ACTIONS(2958),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_undef] = ACTIONS(2958),
    [anon_sym_alias] = ACTIONS(2958),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(2958),
    [sym_float] = ACTIONS(2958),
    [sym_super] = ACTIONS(2958),
    [sym_self] = ACTIONS(2958),
    [sym_true] = ACTIONS(2958),
    [sym_false] = ACTIONS(2958),
    [sym_constant] = ACTIONS(2958),
    [aux_sym_constant_suffix_token1] = ACTIONS(2960),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2958),
    [sym_instance_variable] = ACTIONS(2960),
    [sym_class_variable] = ACTIONS(2960),
    [sym_global_variable] = ACTIONS(2960),
    [sym_character] = ACTIONS(2960),
    [anon_sym_DASH_GT] = ACTIONS(2960),
    [sym__line_break] = ACTIONS(2960),
    [sym_simple_symbol] = ACTIONS(2960),
    [sym__string_start] = ACTIONS(2960),
    [sym__symbol_start] = ACTIONS(2960),
    [sym__subshell_start] = ACTIONS(2960),
    [sym__regex_start] = ACTIONS(2960),
    [sym__string_array_start] = ACTIONS(2960),
    [sym__symbol_array_start] = ACTIONS(2960),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2960),
    [sym__unary_minus] = ACTIONS(2960),
    [sym__unary_minus_num] = ACTIONS(2960),
    [sym__binary_minus] = ACTIONS(2960),
    [sym__identifier_suffix] = ACTIONS(2960),
    [sym__constant_suffix] = ACTIONS(2960),
  },
  [2064] = {
    [sym_heredoc_body] = STATE(2064),
    [sym_identifier] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2896),
    [anon_sym_def] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2896),
    [anon_sym_RPAREN] = ACTIONS(2896),
    [anon_sym_COLON_COLON] = ACTIONS(2896),
    [anon_sym_rescue] = ACTIONS(2894),
    [anon_sym_COMMA] = ACTIONS(2896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2896),
    [anon_sym_STAR] = ACTIONS(2896),
    [anon_sym_nil] = ACTIONS(2894),
    [anon_sym_class] = ACTIONS(2894),
    [anon_sym_module] = ACTIONS(2894),
    [anon_sym_return] = ACTIONS(2894),
    [anon_sym_yield] = ACTIONS(2894),
    [anon_sym_break] = ACTIONS(2894),
    [anon_sym_next] = ACTIONS(2894),
    [anon_sym_redo] = ACTIONS(2894),
    [anon_sym_retry] = ACTIONS(2894),
    [anon_sym_if] = ACTIONS(2894),
    [anon_sym_unless] = ACTIONS(2894),
    [anon_sym_while] = ACTIONS(2894),
    [anon_sym_until] = ACTIONS(2894),
    [anon_sym_for] = ACTIONS(2894),
    [anon_sym_do] = ACTIONS(2894),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_LBRACK] = ACTIONS(2896),
    [anon_sym_RBRACK] = ACTIONS(2896),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_begin] = ACTIONS(2894),
    [anon_sym_and] = ACTIONS(2894),
    [anon_sym_or] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_defined_QMARK] = ACTIONS(2896),
    [anon_sym_not] = ACTIONS(2894),
    [anon_sym_BANG] = ACTIONS(2896),
    [anon_sym_TILDE] = ACTIONS(2896),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2894),
    [sym_float] = ACTIONS(2894),
    [sym_super] = ACTIONS(2894),
    [sym_self] = ACTIONS(2894),
    [sym_true] = ACTIONS(2894),
    [sym_false] = ACTIONS(2894),
    [sym_constant] = ACTIONS(2894),
    [aux_sym_constant_suffix_token1] = ACTIONS(2896),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2894),
    [sym_instance_variable] = ACTIONS(2896),
    [sym_class_variable] = ACTIONS(2896),
    [sym_global_variable] = ACTIONS(2896),
    [sym_character] = ACTIONS(2896),
    [anon_sym_DASH_GT] = ACTIONS(2896),
    [sym_simple_symbol] = ACTIONS(2896),
    [sym__string_start] = ACTIONS(2896),
    [sym__symbol_start] = ACTIONS(2896),
    [sym__subshell_start] = ACTIONS(2896),
    [sym__regex_start] = ACTIONS(2896),
    [sym__string_array_start] = ACTIONS(2896),
    [sym__symbol_array_start] = ACTIONS(2896),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2896),
    [sym__block_ampersand] = ACTIONS(2896),
    [sym__splat_star] = ACTIONS(2896),
    [sym__unary_minus] = ACTIONS(2896),
    [sym__unary_minus_num] = ACTIONS(2896),
    [sym__binary_minus] = ACTIONS(2896),
    [sym_hash_key_symbol] = ACTIONS(2896),
    [sym__identifier_suffix] = ACTIONS(2896),
    [sym__constant_suffix] = ACTIONS(2896),
    [sym__hash_splat_star_star] = ACTIONS(2896),
  },
  [2065] = {
    [sym_heredoc_body] = STATE(2065),
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2564),
    [anon_sym_def] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_rescue] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2564),
    [anon_sym_STAR] = ACTIONS(2564),
    [anon_sym_nil] = ACTIONS(2562),
    [anon_sym_class] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_yield] = ACTIONS(2562),
    [anon_sym_break] = ACTIONS(2562),
    [anon_sym_next] = ACTIONS(2562),
    [anon_sym_redo] = ACTIONS(2562),
    [anon_sym_retry] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_unless] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [anon_sym_until] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_case] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_RBRACK] = ACTIONS(2564),
    [anon_sym_DOT_DOT] = ACTIONS(2562),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_and] = ACTIONS(2562),
    [anon_sym_or] = ACTIONS(2562),
    [anon_sym_PLUS] = ACTIONS(2564),
    [anon_sym_defined_QMARK] = ACTIONS(2564),
    [anon_sym_not] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2564),
    [anon_sym_TILDE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2562),
    [sym_float] = ACTIONS(2562),
    [sym_super] = ACTIONS(2562),
    [sym_self] = ACTIONS(2562),
    [sym_true] = ACTIONS(2562),
    [sym_false] = ACTIONS(2562),
    [sym_constant] = ACTIONS(2562),
    [aux_sym_constant_suffix_token1] = ACTIONS(2564),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2562),
    [sym_instance_variable] = ACTIONS(2564),
    [sym_class_variable] = ACTIONS(2564),
    [sym_global_variable] = ACTIONS(2564),
    [sym_character] = ACTIONS(2564),
    [anon_sym_DASH_GT] = ACTIONS(2564),
    [sym_simple_symbol] = ACTIONS(2564),
    [sym__string_start] = ACTIONS(2564),
    [sym__symbol_start] = ACTIONS(2564),
    [sym__subshell_start] = ACTIONS(2564),
    [sym__regex_start] = ACTIONS(2564),
    [sym__string_array_start] = ACTIONS(2564),
    [sym__symbol_array_start] = ACTIONS(2564),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2564),
    [sym__block_ampersand] = ACTIONS(2564),
    [sym__splat_star] = ACTIONS(2564),
    [sym__unary_minus] = ACTIONS(2564),
    [sym__unary_minus_num] = ACTIONS(2564),
    [sym__binary_minus] = ACTIONS(2564),
    [sym_hash_key_symbol] = ACTIONS(2564),
    [sym__identifier_suffix] = ACTIONS(2564),
    [sym__constant_suffix] = ACTIONS(2564),
    [sym__hash_splat_star_star] = ACTIONS(2564),
  },
  [2066] = {
    [sym_heredoc_body] = STATE(2066),
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_def] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_COLON_COLON] = ACTIONS(2588),
    [anon_sym_rescue] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_nil] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_next] = ACTIONS(2586),
    [anon_sym_redo] = ACTIONS(2586),
    [anon_sym_retry] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_unless] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_until] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_RBRACK] = ACTIONS(2588),
    [anon_sym_DOT_DOT] = ACTIONS(2586),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_and] = ACTIONS(2586),
    [anon_sym_or] = ACTIONS(2586),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_defined_QMARK] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_TILDE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2586),
    [sym_float] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_self] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_constant] = ACTIONS(2586),
    [aux_sym_constant_suffix_token1] = ACTIONS(2588),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2586),
    [sym_instance_variable] = ACTIONS(2588),
    [sym_class_variable] = ACTIONS(2588),
    [sym_global_variable] = ACTIONS(2588),
    [sym_character] = ACTIONS(2588),
    [anon_sym_DASH_GT] = ACTIONS(2588),
    [sym_simple_symbol] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__symbol_start] = ACTIONS(2588),
    [sym__subshell_start] = ACTIONS(2588),
    [sym__regex_start] = ACTIONS(2588),
    [sym__string_array_start] = ACTIONS(2588),
    [sym__symbol_array_start] = ACTIONS(2588),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2588),
    [sym__block_ampersand] = ACTIONS(2588),
    [sym__splat_star] = ACTIONS(2588),
    [sym__unary_minus] = ACTIONS(2588),
    [sym__unary_minus_num] = ACTIONS(2588),
    [sym__binary_minus] = ACTIONS(2588),
    [sym_hash_key_symbol] = ACTIONS(2588),
    [sym__identifier_suffix] = ACTIONS(2588),
    [sym__constant_suffix] = ACTIONS(2588),
    [sym__hash_splat_star_star] = ACTIONS(2588),
  },
  [2067] = {
    [sym_heredoc_body] = STATE(2067),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2962),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_when] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_then] = ACTIONS(2962),
    [anon_sym_ensure] = ACTIONS(2962),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(2968),
    [anon_sym_DASH_EQ] = ACTIONS(2968),
    [anon_sym_STAR_EQ] = ACTIONS(2968),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2968),
    [anon_sym_SLASH_EQ] = ACTIONS(2968),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2968),
    [anon_sym_PIPE_EQ] = ACTIONS(2968),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2968),
    [anon_sym_AMP_EQ] = ACTIONS(2968),
    [anon_sym_PERCENT_EQ] = ACTIONS(2968),
    [anon_sym_GT_GT_EQ] = ACTIONS(2968),
    [anon_sym_LT_LT_EQ] = ACTIONS(2968),
    [anon_sym_CARET_EQ] = ACTIONS(2968),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2068] = {
    [sym_heredoc_body] = STATE(2068),
    [sym_identifier] = ACTIONS(2044),
    [anon_sym_BEGIN] = ACTIONS(2044),
    [anon_sym_LBRACE] = ACTIONS(2908),
    [anon_sym_END] = ACTIONS(2044),
    [anon_sym_def] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_end] = ACTIONS(2044),
    [anon_sym_rescue] = ACTIONS(2044),
    [anon_sym_PIPE] = ACTIONS(2908),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2908),
    [anon_sym_STAR] = ACTIONS(2908),
    [anon_sym_nil] = ACTIONS(2044),
    [anon_sym_class] = ACTIONS(2044),
    [anon_sym_module] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_yield] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_next] = ACTIONS(2044),
    [anon_sym_redo] = ACTIONS(2044),
    [anon_sym_retry] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_unless] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_until] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_case] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2908),
    [anon_sym_DOT_DOT] = ACTIONS(2044),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_begin] = ACTIONS(2044),
    [anon_sym_ensure] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_defined_QMARK] = ACTIONS(2908),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2908),
    [anon_sym_TILDE] = ACTIONS(2908),
    [anon_sym_undef] = ACTIONS(2044),
    [anon_sym_alias] = ACTIONS(2044),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2044),
    [sym_float] = ACTIONS(2044),
    [sym_super] = ACTIONS(2044),
    [sym_self] = ACTIONS(2044),
    [sym_true] = ACTIONS(2044),
    [sym_false] = ACTIONS(2044),
    [sym_constant] = ACTIONS(2044),
    [aux_sym_constant_suffix_token1] = ACTIONS(2908),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2044),
    [sym_instance_variable] = ACTIONS(2908),
    [sym_class_variable] = ACTIONS(2908),
    [sym_global_variable] = ACTIONS(2908),
    [sym_character] = ACTIONS(2908),
    [anon_sym_DASH_GT] = ACTIONS(2908),
    [sym_simple_symbol] = ACTIONS(2908),
    [sym__string_start] = ACTIONS(2908),
    [sym__symbol_start] = ACTIONS(2908),
    [sym__subshell_start] = ACTIONS(2908),
    [sym__regex_start] = ACTIONS(2908),
    [sym__string_array_start] = ACTIONS(2908),
    [sym__symbol_array_start] = ACTIONS(2908),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2908),
    [sym__unary_minus] = ACTIONS(2908),
    [sym__unary_minus_num] = ACTIONS(2908),
    [sym__binary_minus] = ACTIONS(2908),
    [sym__identifier_suffix] = ACTIONS(2908),
    [sym__constant_suffix] = ACTIONS(2908),
  },
  [2069] = {
    [sym_heredoc_body] = STATE(2069),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_BEGIN] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_END] = ACTIONS(2970),
    [anon_sym_def] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2972),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_end] = ACTIONS(2970),
    [anon_sym_rescue] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_nil] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_module] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_next] = ACTIONS(2970),
    [anon_sym_redo] = ACTIONS(2970),
    [anon_sym_retry] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_unless] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_until] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_DOT_DOT] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_ensure] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_defined_QMARK] = ACTIONS(2972),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_undef] = ACTIONS(2970),
    [anon_sym_alias] = ACTIONS(2970),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2970),
    [sym_float] = ACTIONS(2970),
    [sym_super] = ACTIONS(2970),
    [sym_self] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [sym_constant] = ACTIONS(2970),
    [aux_sym_constant_suffix_token1] = ACTIONS(2972),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2970),
    [sym_instance_variable] = ACTIONS(2972),
    [sym_class_variable] = ACTIONS(2972),
    [sym_global_variable] = ACTIONS(2972),
    [sym_character] = ACTIONS(2972),
    [anon_sym_DASH_GT] = ACTIONS(2972),
    [sym__line_break] = ACTIONS(2972),
    [sym_simple_symbol] = ACTIONS(2972),
    [sym__string_start] = ACTIONS(2972),
    [sym__symbol_start] = ACTIONS(2972),
    [sym__subshell_start] = ACTIONS(2972),
    [sym__regex_start] = ACTIONS(2972),
    [sym__string_array_start] = ACTIONS(2972),
    [sym__symbol_array_start] = ACTIONS(2972),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2972),
    [sym__unary_minus] = ACTIONS(2972),
    [sym__unary_minus_num] = ACTIONS(2972),
    [sym__binary_minus] = ACTIONS(2972),
    [sym__identifier_suffix] = ACTIONS(2972),
    [sym__constant_suffix] = ACTIONS(2972),
  },
  [2070] = {
    [sym_heredoc_body] = STATE(2070),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_BEGIN] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_END] = ACTIONS(2974),
    [anon_sym_def] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(2976),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_end] = ACTIONS(2974),
    [anon_sym_rescue] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2976),
    [anon_sym_nil] = ACTIONS(2974),
    [anon_sym_class] = ACTIONS(2974),
    [anon_sym_module] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_break] = ACTIONS(2974),
    [anon_sym_next] = ACTIONS(2974),
    [anon_sym_redo] = ACTIONS(2974),
    [anon_sym_retry] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_unless] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_until] = ACTIONS(2974),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_case] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_DOT_DOT] = ACTIONS(2974),
    [anon_sym_else] = ACTIONS(2974),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_ensure] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2976),
    [anon_sym_defined_QMARK] = ACTIONS(2976),
    [anon_sym_not] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2976),
    [anon_sym_TILDE] = ACTIONS(2976),
    [anon_sym_undef] = ACTIONS(2974),
    [anon_sym_alias] = ACTIONS(2974),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2974),
    [sym_float] = ACTIONS(2974),
    [sym_super] = ACTIONS(2974),
    [sym_self] = ACTIONS(2974),
    [sym_true] = ACTIONS(2974),
    [sym_false] = ACTIONS(2974),
    [sym_constant] = ACTIONS(2974),
    [aux_sym_constant_suffix_token1] = ACTIONS(2976),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2974),
    [sym_instance_variable] = ACTIONS(2976),
    [sym_class_variable] = ACTIONS(2976),
    [sym_global_variable] = ACTIONS(2976),
    [sym_character] = ACTIONS(2976),
    [anon_sym_DASH_GT] = ACTIONS(2976),
    [sym__line_break] = ACTIONS(2976),
    [sym_simple_symbol] = ACTIONS(2976),
    [sym__string_start] = ACTIONS(2976),
    [sym__symbol_start] = ACTIONS(2976),
    [sym__subshell_start] = ACTIONS(2976),
    [sym__regex_start] = ACTIONS(2976),
    [sym__string_array_start] = ACTIONS(2976),
    [sym__symbol_array_start] = ACTIONS(2976),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2976),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__unary_minus_num] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(2976),
    [sym__identifier_suffix] = ACTIONS(2976),
    [sym__constant_suffix] = ACTIONS(2976),
  },
  [2071] = {
    [sym_heredoc_body] = STATE(2071),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_BEGIN] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_END] = ACTIONS(2978),
    [anon_sym_def] = ACTIONS(2978),
    [anon_sym_LPAREN] = ACTIONS(2980),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_end] = ACTIONS(2978),
    [anon_sym_rescue] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_nil] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_module] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_next] = ACTIONS(2978),
    [anon_sym_redo] = ACTIONS(2978),
    [anon_sym_retry] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_unless] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_until] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_case] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_DOT_DOT] = ACTIONS(2978),
    [anon_sym_else] = ACTIONS(2978),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_ensure] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_defined_QMARK] = ACTIONS(2980),
    [anon_sym_not] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_undef] = ACTIONS(2978),
    [anon_sym_alias] = ACTIONS(2978),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2978),
    [sym_float] = ACTIONS(2978),
    [sym_super] = ACTIONS(2978),
    [sym_self] = ACTIONS(2978),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [sym_constant] = ACTIONS(2978),
    [aux_sym_constant_suffix_token1] = ACTIONS(2980),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2978),
    [sym_instance_variable] = ACTIONS(2980),
    [sym_class_variable] = ACTIONS(2980),
    [sym_global_variable] = ACTIONS(2980),
    [sym_character] = ACTIONS(2980),
    [anon_sym_DASH_GT] = ACTIONS(2980),
    [sym__line_break] = ACTIONS(2980),
    [sym_simple_symbol] = ACTIONS(2980),
    [sym__string_start] = ACTIONS(2980),
    [sym__symbol_start] = ACTIONS(2980),
    [sym__subshell_start] = ACTIONS(2980),
    [sym__regex_start] = ACTIONS(2980),
    [sym__string_array_start] = ACTIONS(2980),
    [sym__symbol_array_start] = ACTIONS(2980),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2980),
    [sym__unary_minus] = ACTIONS(2980),
    [sym__unary_minus_num] = ACTIONS(2980),
    [sym__binary_minus] = ACTIONS(2980),
    [sym__identifier_suffix] = ACTIONS(2980),
    [sym__constant_suffix] = ACTIONS(2980),
  },
  [2072] = {
    [sym_heredoc_body] = STATE(2072),
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_BEGIN] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_END] = ACTIONS(2982),
    [anon_sym_def] = ACTIONS(2982),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_end] = ACTIONS(2982),
    [anon_sym_rescue] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_nil] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_module] = ACTIONS(2982),
    [anon_sym_return] = ACTIONS(2982),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2982),
    [anon_sym_next] = ACTIONS(2982),
    [anon_sym_redo] = ACTIONS(2982),
    [anon_sym_retry] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2982),
    [anon_sym_unless] = ACTIONS(2982),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_until] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2982),
    [anon_sym_case] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_DOT_DOT] = ACTIONS(2982),
    [anon_sym_else] = ACTIONS(2982),
    [anon_sym_begin] = ACTIONS(2982),
    [anon_sym_ensure] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_defined_QMARK] = ACTIONS(2984),
    [anon_sym_not] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_undef] = ACTIONS(2982),
    [anon_sym_alias] = ACTIONS(2982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2982),
    [sym_float] = ACTIONS(2982),
    [sym_super] = ACTIONS(2982),
    [sym_self] = ACTIONS(2982),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [sym_constant] = ACTIONS(2982),
    [aux_sym_constant_suffix_token1] = ACTIONS(2984),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2982),
    [sym_instance_variable] = ACTIONS(2984),
    [sym_class_variable] = ACTIONS(2984),
    [sym_global_variable] = ACTIONS(2984),
    [sym_character] = ACTIONS(2984),
    [anon_sym_DASH_GT] = ACTIONS(2984),
    [sym__line_break] = ACTIONS(2984),
    [sym_simple_symbol] = ACTIONS(2984),
    [sym__string_start] = ACTIONS(2984),
    [sym__symbol_start] = ACTIONS(2984),
    [sym__subshell_start] = ACTIONS(2984),
    [sym__regex_start] = ACTIONS(2984),
    [sym__string_array_start] = ACTIONS(2984),
    [sym__symbol_array_start] = ACTIONS(2984),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2984),
    [sym__unary_minus] = ACTIONS(2984),
    [sym__unary_minus_num] = ACTIONS(2984),
    [sym__binary_minus] = ACTIONS(2984),
    [sym__identifier_suffix] = ACTIONS(2984),
    [sym__constant_suffix] = ACTIONS(2984),
  },
  [2073] = {
    [sym_heredoc_body] = STATE(2073),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2962),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_when] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_then] = ACTIONS(2962),
    [anon_sym_ensure] = ACTIONS(2962),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [anon_sym_DASH_EQ] = ACTIONS(2988),
    [anon_sym_STAR_EQ] = ACTIONS(2988),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2988),
    [anon_sym_SLASH_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_PIPE_EQ] = ACTIONS(2988),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2988),
    [anon_sym_AMP_EQ] = ACTIONS(2988),
    [anon_sym_PERCENT_EQ] = ACTIONS(2988),
    [anon_sym_GT_GT_EQ] = ACTIONS(2988),
    [anon_sym_LT_LT_EQ] = ACTIONS(2988),
    [anon_sym_CARET_EQ] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2074] = {
    [sym_heredoc_body] = STATE(2074),
    [sym_identifier] = ACTIONS(2990),
    [anon_sym_BEGIN] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_END] = ACTIONS(2990),
    [anon_sym_def] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2992),
    [anon_sym_end] = ACTIONS(2990),
    [anon_sym_rescue] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_STAR] = ACTIONS(2992),
    [anon_sym_nil] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2990),
    [anon_sym_module] = ACTIONS(2990),
    [anon_sym_return] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2990),
    [anon_sym_break] = ACTIONS(2990),
    [anon_sym_next] = ACTIONS(2990),
    [anon_sym_redo] = ACTIONS(2990),
    [anon_sym_retry] = ACTIONS(2990),
    [anon_sym_if] = ACTIONS(2990),
    [anon_sym_unless] = ACTIONS(2990),
    [anon_sym_while] = ACTIONS(2990),
    [anon_sym_until] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2990),
    [anon_sym_case] = ACTIONS(2990),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(2990),
    [anon_sym_else] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2990),
    [anon_sym_ensure] = ACTIONS(2990),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_defined_QMARK] = ACTIONS(2992),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2992),
    [anon_sym_undef] = ACTIONS(2990),
    [anon_sym_alias] = ACTIONS(2990),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2990),
    [sym_float] = ACTIONS(2990),
    [sym_super] = ACTIONS(2990),
    [sym_self] = ACTIONS(2990),
    [sym_true] = ACTIONS(2990),
    [sym_false] = ACTIONS(2990),
    [sym_constant] = ACTIONS(2990),
    [aux_sym_constant_suffix_token1] = ACTIONS(2992),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2990),
    [sym_instance_variable] = ACTIONS(2992),
    [sym_class_variable] = ACTIONS(2992),
    [sym_global_variable] = ACTIONS(2992),
    [sym_character] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(2992),
    [sym__line_break] = ACTIONS(2992),
    [sym_simple_symbol] = ACTIONS(2992),
    [sym__string_start] = ACTIONS(2992),
    [sym__symbol_start] = ACTIONS(2992),
    [sym__subshell_start] = ACTIONS(2992),
    [sym__regex_start] = ACTIONS(2992),
    [sym__string_array_start] = ACTIONS(2992),
    [sym__symbol_array_start] = ACTIONS(2992),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2992),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__unary_minus_num] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(2992),
    [sym__identifier_suffix] = ACTIONS(2992),
    [sym__constant_suffix] = ACTIONS(2992),
  },
  [2075] = {
    [sym_heredoc_body] = STATE(2075),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_BEGIN] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_END] = ACTIONS(2994),
    [anon_sym_def] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2996),
    [anon_sym_end] = ACTIONS(2994),
    [anon_sym_rescue] = ACTIONS(2994),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2996),
    [anon_sym_STAR] = ACTIONS(2996),
    [anon_sym_nil] = ACTIONS(2994),
    [anon_sym_class] = ACTIONS(2994),
    [anon_sym_module] = ACTIONS(2994),
    [anon_sym_return] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2994),
    [anon_sym_break] = ACTIONS(2994),
    [anon_sym_next] = ACTIONS(2994),
    [anon_sym_redo] = ACTIONS(2994),
    [anon_sym_retry] = ACTIONS(2994),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_unless] = ACTIONS(2994),
    [anon_sym_while] = ACTIONS(2994),
    [anon_sym_until] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2994),
    [anon_sym_case] = ACTIONS(2994),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_DOT_DOT] = ACTIONS(2994),
    [anon_sym_else] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2994),
    [anon_sym_ensure] = ACTIONS(2994),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_defined_QMARK] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2994),
    [anon_sym_BANG] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2996),
    [anon_sym_undef] = ACTIONS(2994),
    [anon_sym_alias] = ACTIONS(2994),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2994),
    [sym_float] = ACTIONS(2994),
    [sym_super] = ACTIONS(2994),
    [sym_self] = ACTIONS(2994),
    [sym_true] = ACTIONS(2994),
    [sym_false] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2994),
    [aux_sym_constant_suffix_token1] = ACTIONS(2996),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2994),
    [sym_instance_variable] = ACTIONS(2996),
    [sym_class_variable] = ACTIONS(2996),
    [sym_global_variable] = ACTIONS(2996),
    [sym_character] = ACTIONS(2996),
    [anon_sym_DASH_GT] = ACTIONS(2996),
    [sym__line_break] = ACTIONS(2996),
    [sym_simple_symbol] = ACTIONS(2996),
    [sym__string_start] = ACTIONS(2996),
    [sym__symbol_start] = ACTIONS(2996),
    [sym__subshell_start] = ACTIONS(2996),
    [sym__regex_start] = ACTIONS(2996),
    [sym__string_array_start] = ACTIONS(2996),
    [sym__symbol_array_start] = ACTIONS(2996),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2996),
    [sym__unary_minus] = ACTIONS(2996),
    [sym__unary_minus_num] = ACTIONS(2996),
    [sym__binary_minus] = ACTIONS(2996),
    [sym__identifier_suffix] = ACTIONS(2996),
    [sym__constant_suffix] = ACTIONS(2996),
  },
  [2076] = {
    [sym_heredoc_body] = STATE(2076),
    [sym_identifier] = ACTIONS(2998),
    [anon_sym_BEGIN] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(3000),
    [anon_sym_END] = ACTIONS(2998),
    [anon_sym_def] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(3000),
    [anon_sym_COLON_COLON] = ACTIONS(3000),
    [anon_sym_end] = ACTIONS(2998),
    [anon_sym_rescue] = ACTIONS(2998),
    [anon_sym_SEMI] = ACTIONS(3000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3000),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_nil] = ACTIONS(2998),
    [anon_sym_class] = ACTIONS(2998),
    [anon_sym_module] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2998),
    [anon_sym_break] = ACTIONS(2998),
    [anon_sym_next] = ACTIONS(2998),
    [anon_sym_redo] = ACTIONS(2998),
    [anon_sym_retry] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_case] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(3000),
    [anon_sym_DOT_DOT] = ACTIONS(2998),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2998),
    [anon_sym_ensure] = ACTIONS(2998),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_defined_QMARK] = ACTIONS(3000),
    [anon_sym_not] = ACTIONS(2998),
    [anon_sym_BANG] = ACTIONS(3000),
    [anon_sym_TILDE] = ACTIONS(3000),
    [anon_sym_undef] = ACTIONS(2998),
    [anon_sym_alias] = ACTIONS(2998),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2998),
    [sym_float] = ACTIONS(2998),
    [sym_super] = ACTIONS(2998),
    [sym_self] = ACTIONS(2998),
    [sym_true] = ACTIONS(2998),
    [sym_false] = ACTIONS(2998),
    [sym_constant] = ACTIONS(2998),
    [aux_sym_constant_suffix_token1] = ACTIONS(3000),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2998),
    [sym_instance_variable] = ACTIONS(3000),
    [sym_class_variable] = ACTIONS(3000),
    [sym_global_variable] = ACTIONS(3000),
    [sym_character] = ACTIONS(3000),
    [anon_sym_DASH_GT] = ACTIONS(3000),
    [sym__line_break] = ACTIONS(3000),
    [sym_simple_symbol] = ACTIONS(3000),
    [sym__string_start] = ACTIONS(3000),
    [sym__symbol_start] = ACTIONS(3000),
    [sym__subshell_start] = ACTIONS(3000),
    [sym__regex_start] = ACTIONS(3000),
    [sym__string_array_start] = ACTIONS(3000),
    [sym__symbol_array_start] = ACTIONS(3000),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3000),
    [sym__unary_minus] = ACTIONS(3000),
    [sym__unary_minus_num] = ACTIONS(3000),
    [sym__binary_minus] = ACTIONS(3000),
    [sym__identifier_suffix] = ACTIONS(3000),
    [sym__constant_suffix] = ACTIONS(3000),
  },
  [2077] = {
    [sym_heredoc_body] = STATE(2077),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_BEGIN] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_END] = ACTIONS(3002),
    [anon_sym_def] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_end] = ACTIONS(3002),
    [anon_sym_rescue] = ACTIONS(3002),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3004),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_nil] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_module] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_yield] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3002),
    [anon_sym_redo] = ACTIONS(3002),
    [anon_sym_retry] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3004),
    [anon_sym_DOT_DOT] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_begin] = ACTIONS(3002),
    [anon_sym_ensure] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3004),
    [anon_sym_defined_QMARK] = ACTIONS(3004),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_undef] = ACTIONS(3002),
    [anon_sym_alias] = ACTIONS(3002),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3002),
    [sym_float] = ACTIONS(3002),
    [sym_super] = ACTIONS(3002),
    [sym_self] = ACTIONS(3002),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [sym_constant] = ACTIONS(3002),
    [aux_sym_constant_suffix_token1] = ACTIONS(3004),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3002),
    [sym_instance_variable] = ACTIONS(3004),
    [sym_class_variable] = ACTIONS(3004),
    [sym_global_variable] = ACTIONS(3004),
    [sym_character] = ACTIONS(3004),
    [anon_sym_DASH_GT] = ACTIONS(3004),
    [sym__line_break] = ACTIONS(3004),
    [sym_simple_symbol] = ACTIONS(3004),
    [sym__string_start] = ACTIONS(3004),
    [sym__symbol_start] = ACTIONS(3004),
    [sym__subshell_start] = ACTIONS(3004),
    [sym__regex_start] = ACTIONS(3004),
    [sym__string_array_start] = ACTIONS(3004),
    [sym__symbol_array_start] = ACTIONS(3004),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3004),
    [sym__unary_minus] = ACTIONS(3004),
    [sym__unary_minus_num] = ACTIONS(3004),
    [sym__binary_minus] = ACTIONS(3004),
    [sym__identifier_suffix] = ACTIONS(3004),
    [sym__constant_suffix] = ACTIONS(3004),
  },
  [2078] = {
    [sym_heredoc_body] = STATE(2078),
    [sym_identifier] = ACTIONS(3006),
    [anon_sym_BEGIN] = ACTIONS(3006),
    [anon_sym_LBRACE] = ACTIONS(3008),
    [anon_sym_END] = ACTIONS(3006),
    [anon_sym_def] = ACTIONS(3006),
    [anon_sym_LPAREN] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3008),
    [anon_sym_end] = ACTIONS(3006),
    [anon_sym_rescue] = ACTIONS(3006),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3008),
    [anon_sym_nil] = ACTIONS(3006),
    [anon_sym_class] = ACTIONS(3006),
    [anon_sym_module] = ACTIONS(3006),
    [anon_sym_return] = ACTIONS(3006),
    [anon_sym_yield] = ACTIONS(3006),
    [anon_sym_break] = ACTIONS(3006),
    [anon_sym_next] = ACTIONS(3006),
    [anon_sym_redo] = ACTIONS(3006),
    [anon_sym_retry] = ACTIONS(3006),
    [anon_sym_if] = ACTIONS(3006),
    [anon_sym_unless] = ACTIONS(3006),
    [anon_sym_while] = ACTIONS(3006),
    [anon_sym_until] = ACTIONS(3006),
    [anon_sym_for] = ACTIONS(3006),
    [anon_sym_case] = ACTIONS(3006),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_DOT_DOT] = ACTIONS(3006),
    [anon_sym_else] = ACTIONS(3006),
    [anon_sym_begin] = ACTIONS(3006),
    [anon_sym_ensure] = ACTIONS(3006),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_defined_QMARK] = ACTIONS(3008),
    [anon_sym_not] = ACTIONS(3006),
    [anon_sym_BANG] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3008),
    [anon_sym_undef] = ACTIONS(3006),
    [anon_sym_alias] = ACTIONS(3006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3006),
    [sym_float] = ACTIONS(3006),
    [sym_super] = ACTIONS(3006),
    [sym_self] = ACTIONS(3006),
    [sym_true] = ACTIONS(3006),
    [sym_false] = ACTIONS(3006),
    [sym_constant] = ACTIONS(3006),
    [aux_sym_constant_suffix_token1] = ACTIONS(3008),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3006),
    [sym_instance_variable] = ACTIONS(3008),
    [sym_class_variable] = ACTIONS(3008),
    [sym_global_variable] = ACTIONS(3008),
    [sym_character] = ACTIONS(3008),
    [anon_sym_DASH_GT] = ACTIONS(3008),
    [sym__line_break] = ACTIONS(3008),
    [sym_simple_symbol] = ACTIONS(3008),
    [sym__string_start] = ACTIONS(3008),
    [sym__symbol_start] = ACTIONS(3008),
    [sym__subshell_start] = ACTIONS(3008),
    [sym__regex_start] = ACTIONS(3008),
    [sym__string_array_start] = ACTIONS(3008),
    [sym__symbol_array_start] = ACTIONS(3008),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3008),
    [sym__unary_minus] = ACTIONS(3008),
    [sym__unary_minus_num] = ACTIONS(3008),
    [sym__binary_minus] = ACTIONS(3008),
    [sym__identifier_suffix] = ACTIONS(3008),
    [sym__constant_suffix] = ACTIONS(3008),
  },
  [2079] = {
    [sym_heredoc_body] = STATE(2079),
    [sym_identifier] = ACTIONS(3010),
    [anon_sym_BEGIN] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_END] = ACTIONS(3010),
    [anon_sym_def] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3012),
    [anon_sym_end] = ACTIONS(3010),
    [anon_sym_rescue] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(3012),
    [anon_sym_nil] = ACTIONS(3010),
    [anon_sym_class] = ACTIONS(3010),
    [anon_sym_module] = ACTIONS(3010),
    [anon_sym_return] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3010),
    [anon_sym_break] = ACTIONS(3010),
    [anon_sym_next] = ACTIONS(3010),
    [anon_sym_redo] = ACTIONS(3010),
    [anon_sym_retry] = ACTIONS(3010),
    [anon_sym_if] = ACTIONS(3010),
    [anon_sym_unless] = ACTIONS(3010),
    [anon_sym_while] = ACTIONS(3010),
    [anon_sym_until] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3010),
    [anon_sym_case] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_DOT_DOT] = ACTIONS(3010),
    [anon_sym_else] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3010),
    [anon_sym_ensure] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_defined_QMARK] = ACTIONS(3012),
    [anon_sym_not] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3012),
    [anon_sym_undef] = ACTIONS(3010),
    [anon_sym_alias] = ACTIONS(3010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3010),
    [sym_float] = ACTIONS(3010),
    [sym_super] = ACTIONS(3010),
    [sym_self] = ACTIONS(3010),
    [sym_true] = ACTIONS(3010),
    [sym_false] = ACTIONS(3010),
    [sym_constant] = ACTIONS(3010),
    [aux_sym_constant_suffix_token1] = ACTIONS(3012),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3010),
    [sym_instance_variable] = ACTIONS(3012),
    [sym_class_variable] = ACTIONS(3012),
    [sym_global_variable] = ACTIONS(3012),
    [sym_character] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3012),
    [sym__line_break] = ACTIONS(3012),
    [sym_simple_symbol] = ACTIONS(3012),
    [sym__string_start] = ACTIONS(3012),
    [sym__symbol_start] = ACTIONS(3012),
    [sym__subshell_start] = ACTIONS(3012),
    [sym__regex_start] = ACTIONS(3012),
    [sym__string_array_start] = ACTIONS(3012),
    [sym__symbol_array_start] = ACTIONS(3012),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3012),
    [sym__unary_minus] = ACTIONS(3012),
    [sym__unary_minus_num] = ACTIONS(3012),
    [sym__binary_minus] = ACTIONS(3012),
    [sym__identifier_suffix] = ACTIONS(3012),
    [sym__constant_suffix] = ACTIONS(3012),
  },
  [2080] = {
    [sym_heredoc_body] = STATE(2080),
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_BEGIN] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_END] = ACTIONS(3014),
    [anon_sym_def] = ACTIONS(3014),
    [anon_sym_LPAREN] = ACTIONS(3016),
    [anon_sym_COLON_COLON] = ACTIONS(3016),
    [anon_sym_end] = ACTIONS(3014),
    [anon_sym_rescue] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_nil] = ACTIONS(3014),
    [anon_sym_class] = ACTIONS(3014),
    [anon_sym_module] = ACTIONS(3014),
    [anon_sym_return] = ACTIONS(3014),
    [anon_sym_yield] = ACTIONS(3014),
    [anon_sym_break] = ACTIONS(3014),
    [anon_sym_next] = ACTIONS(3014),
    [anon_sym_redo] = ACTIONS(3014),
    [anon_sym_retry] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_unless] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_until] = ACTIONS(3014),
    [anon_sym_for] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_else] = ACTIONS(3014),
    [anon_sym_begin] = ACTIONS(3014),
    [anon_sym_ensure] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_defined_QMARK] = ACTIONS(3016),
    [anon_sym_not] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [anon_sym_undef] = ACTIONS(3014),
    [anon_sym_alias] = ACTIONS(3014),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3014),
    [sym_float] = ACTIONS(3014),
    [sym_super] = ACTIONS(3014),
    [sym_self] = ACTIONS(3014),
    [sym_true] = ACTIONS(3014),
    [sym_false] = ACTIONS(3014),
    [sym_constant] = ACTIONS(3014),
    [aux_sym_constant_suffix_token1] = ACTIONS(3016),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3014),
    [sym_instance_variable] = ACTIONS(3016),
    [sym_class_variable] = ACTIONS(3016),
    [sym_global_variable] = ACTIONS(3016),
    [sym_character] = ACTIONS(3016),
    [anon_sym_DASH_GT] = ACTIONS(3016),
    [sym__line_break] = ACTIONS(3016),
    [sym_simple_symbol] = ACTIONS(3016),
    [sym__string_start] = ACTIONS(3016),
    [sym__symbol_start] = ACTIONS(3016),
    [sym__subshell_start] = ACTIONS(3016),
    [sym__regex_start] = ACTIONS(3016),
    [sym__string_array_start] = ACTIONS(3016),
    [sym__symbol_array_start] = ACTIONS(3016),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3016),
    [sym__unary_minus] = ACTIONS(3016),
    [sym__unary_minus_num] = ACTIONS(3016),
    [sym__binary_minus] = ACTIONS(3016),
    [sym__identifier_suffix] = ACTIONS(3016),
    [sym__constant_suffix] = ACTIONS(3016),
  },
  [2081] = {
    [sym_heredoc_body] = STATE(2081),
    [sym_identifier] = ACTIONS(3018),
    [anon_sym_BEGIN] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_END] = ACTIONS(3018),
    [anon_sym_def] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3020),
    [anon_sym_end] = ACTIONS(3018),
    [anon_sym_rescue] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_nil] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(3018),
    [anon_sym_module] = ACTIONS(3018),
    [anon_sym_return] = ACTIONS(3018),
    [anon_sym_yield] = ACTIONS(3018),
    [anon_sym_break] = ACTIONS(3018),
    [anon_sym_next] = ACTIONS(3018),
    [anon_sym_redo] = ACTIONS(3018),
    [anon_sym_retry] = ACTIONS(3018),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_unless] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_until] = ACTIONS(3018),
    [anon_sym_for] = ACTIONS(3018),
    [anon_sym_case] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_DOT_DOT] = ACTIONS(3018),
    [anon_sym_else] = ACTIONS(3018),
    [anon_sym_begin] = ACTIONS(3018),
    [anon_sym_ensure] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_defined_QMARK] = ACTIONS(3020),
    [anon_sym_not] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3020),
    [anon_sym_undef] = ACTIONS(3018),
    [anon_sym_alias] = ACTIONS(3018),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3018),
    [sym_float] = ACTIONS(3018),
    [sym_super] = ACTIONS(3018),
    [sym_self] = ACTIONS(3018),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [sym_constant] = ACTIONS(3018),
    [aux_sym_constant_suffix_token1] = ACTIONS(3020),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3018),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_character] = ACTIONS(3020),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [sym__line_break] = ACTIONS(3020),
    [sym_simple_symbol] = ACTIONS(3020),
    [sym__string_start] = ACTIONS(3020),
    [sym__symbol_start] = ACTIONS(3020),
    [sym__subshell_start] = ACTIONS(3020),
    [sym__regex_start] = ACTIONS(3020),
    [sym__string_array_start] = ACTIONS(3020),
    [sym__symbol_array_start] = ACTIONS(3020),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3020),
    [sym__unary_minus] = ACTIONS(3020),
    [sym__unary_minus_num] = ACTIONS(3020),
    [sym__binary_minus] = ACTIONS(3020),
    [sym__identifier_suffix] = ACTIONS(3020),
    [sym__constant_suffix] = ACTIONS(3020),
  },
  [2082] = {
    [sym_heredoc_body] = STATE(2082),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2962),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(3022),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_when] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_then] = ACTIONS(2962),
    [anon_sym_ensure] = ACTIONS(2962),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(3024),
    [anon_sym_DASH_EQ] = ACTIONS(3024),
    [anon_sym_STAR_EQ] = ACTIONS(3024),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3024),
    [anon_sym_SLASH_EQ] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3024),
    [anon_sym_PIPE_EQ] = ACTIONS(3024),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3024),
    [anon_sym_AMP_EQ] = ACTIONS(3024),
    [anon_sym_PERCENT_EQ] = ACTIONS(3024),
    [anon_sym_GT_GT_EQ] = ACTIONS(3024),
    [anon_sym_LT_LT_EQ] = ACTIONS(3024),
    [anon_sym_CARET_EQ] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2083] = {
    [sym_splat_parameter] = STATE(4876),
    [sym__pattern_expr] = STATE(4853),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4700),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4688),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2083),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2876),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2880),
    [sym_float] = ACTIONS(2880),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2878),
  },
  [2084] = {
    [sym_heredoc_body] = STATE(2084),
    [ts_builtin_sym_end] = ACTIONS(2924),
    [sym_identifier] = ACTIONS(2922),
    [aux_sym_program_token1] = ACTIONS(2924),
    [anon_sym___END__] = ACTIONS(2922),
    [anon_sym_BEGIN] = ACTIONS(2922),
    [anon_sym_LBRACE] = ACTIONS(2924),
    [anon_sym_END] = ACTIONS(2922),
    [anon_sym_def] = ACTIONS(2922),
    [anon_sym_LPAREN] = ACTIONS(2924),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2924),
    [anon_sym_nil] = ACTIONS(2922),
    [anon_sym_class] = ACTIONS(2922),
    [anon_sym_module] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_break] = ACTIONS(2922),
    [anon_sym_next] = ACTIONS(2922),
    [anon_sym_redo] = ACTIONS(2922),
    [anon_sym_retry] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_unless] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_until] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_case] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_DOT_DOT] = ACTIONS(2922),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2924),
    [anon_sym_defined_QMARK] = ACTIONS(2924),
    [anon_sym_not] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2924),
    [anon_sym_TILDE] = ACTIONS(2924),
    [anon_sym_undef] = ACTIONS(2922),
    [anon_sym_alias] = ACTIONS(2922),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2922),
    [sym_float] = ACTIONS(2922),
    [sym_super] = ACTIONS(2922),
    [sym_self] = ACTIONS(2922),
    [sym_true] = ACTIONS(2922),
    [sym_false] = ACTIONS(2922),
    [sym_constant] = ACTIONS(2922),
    [aux_sym_constant_suffix_token1] = ACTIONS(2924),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2922),
    [sym_instance_variable] = ACTIONS(2924),
    [sym_class_variable] = ACTIONS(2924),
    [sym_global_variable] = ACTIONS(2924),
    [sym_character] = ACTIONS(2924),
    [anon_sym_DASH_GT] = ACTIONS(2924),
    [sym_simple_symbol] = ACTIONS(2924),
    [sym__string_start] = ACTIONS(2924),
    [sym__symbol_start] = ACTIONS(2924),
    [sym__subshell_start] = ACTIONS(2924),
    [sym__regex_start] = ACTIONS(2924),
    [sym__string_array_start] = ACTIONS(2924),
    [sym__symbol_array_start] = ACTIONS(2924),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2924),
    [sym__unary_minus] = ACTIONS(2924),
    [sym__unary_minus_num] = ACTIONS(2924),
    [sym__binary_minus] = ACTIONS(2924),
    [sym__identifier_suffix] = ACTIONS(2924),
    [sym__constant_suffix] = ACTIONS(2924),
  },
  [2085] = {
    [sym_heredoc_body] = STATE(2085),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2962),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(3026),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_when] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_then] = ACTIONS(2962),
    [anon_sym_ensure] = ACTIONS(2962),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(3028),
    [anon_sym_DASH_EQ] = ACTIONS(3028),
    [anon_sym_STAR_EQ] = ACTIONS(3028),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3028),
    [anon_sym_SLASH_EQ] = ACTIONS(3028),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3028),
    [anon_sym_PIPE_EQ] = ACTIONS(3028),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3028),
    [anon_sym_AMP_EQ] = ACTIONS(3028),
    [anon_sym_PERCENT_EQ] = ACTIONS(3028),
    [anon_sym_GT_GT_EQ] = ACTIONS(3028),
    [anon_sym_LT_LT_EQ] = ACTIONS(3028),
    [anon_sym_CARET_EQ] = ACTIONS(3028),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2086] = {
    [sym_heredoc_body] = STATE(2086),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2962),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(3030),
    [anon_sym_COMMA] = ACTIONS(3032),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_when] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_then] = ACTIONS(2962),
    [anon_sym_ensure] = ACTIONS(2962),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(3034),
    [anon_sym_DASH_EQ] = ACTIONS(3034),
    [anon_sym_STAR_EQ] = ACTIONS(3034),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3034),
    [anon_sym_SLASH_EQ] = ACTIONS(3034),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3034),
    [anon_sym_PIPE_EQ] = ACTIONS(3034),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3034),
    [anon_sym_AMP_EQ] = ACTIONS(3034),
    [anon_sym_PERCENT_EQ] = ACTIONS(3034),
    [anon_sym_GT_GT_EQ] = ACTIONS(3034),
    [anon_sym_LT_LT_EQ] = ACTIONS(3034),
    [anon_sym_CARET_EQ] = ACTIONS(3034),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2087] = {
    [sym_heredoc_body] = STATE(2087),
    [ts_builtin_sym_end] = ACTIONS(2920),
    [sym_identifier] = ACTIONS(2918),
    [aux_sym_program_token1] = ACTIONS(2920),
    [anon_sym___END__] = ACTIONS(2918),
    [anon_sym_BEGIN] = ACTIONS(2918),
    [anon_sym_LBRACE] = ACTIONS(2920),
    [anon_sym_END] = ACTIONS(2918),
    [anon_sym_def] = ACTIONS(2918),
    [anon_sym_LPAREN] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2920),
    [anon_sym_STAR] = ACTIONS(2920),
    [anon_sym_nil] = ACTIONS(2918),
    [anon_sym_class] = ACTIONS(2918),
    [anon_sym_module] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_break] = ACTIONS(2918),
    [anon_sym_next] = ACTIONS(2918),
    [anon_sym_redo] = ACTIONS(2918),
    [anon_sym_retry] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_unless] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_until] = ACTIONS(2918),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_case] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_DOT_DOT] = ACTIONS(2918),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_defined_QMARK] = ACTIONS(2920),
    [anon_sym_not] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2920),
    [anon_sym_undef] = ACTIONS(2918),
    [anon_sym_alias] = ACTIONS(2918),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2918),
    [sym_float] = ACTIONS(2918),
    [sym_super] = ACTIONS(2918),
    [sym_self] = ACTIONS(2918),
    [sym_true] = ACTIONS(2918),
    [sym_false] = ACTIONS(2918),
    [sym_constant] = ACTIONS(2918),
    [aux_sym_constant_suffix_token1] = ACTIONS(2920),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2918),
    [sym_instance_variable] = ACTIONS(2920),
    [sym_class_variable] = ACTIONS(2920),
    [sym_global_variable] = ACTIONS(2920),
    [sym_character] = ACTIONS(2920),
    [anon_sym_DASH_GT] = ACTIONS(2920),
    [sym_simple_symbol] = ACTIONS(2920),
    [sym__string_start] = ACTIONS(2920),
    [sym__symbol_start] = ACTIONS(2920),
    [sym__subshell_start] = ACTIONS(2920),
    [sym__regex_start] = ACTIONS(2920),
    [sym__string_array_start] = ACTIONS(2920),
    [sym__symbol_array_start] = ACTIONS(2920),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2920),
    [sym__unary_minus] = ACTIONS(2920),
    [sym__unary_minus_num] = ACTIONS(2920),
    [sym__binary_minus] = ACTIONS(2920),
    [sym__identifier_suffix] = ACTIONS(2920),
    [sym__constant_suffix] = ACTIONS(2920),
  },
  [2088] = {
    [sym_heredoc_body] = STATE(2088),
    [ts_builtin_sym_end] = ACTIONS(1086),
    [sym_identifier] = ACTIONS(1100),
    [aux_sym_program_token1] = ACTIONS(1086),
    [anon_sym___END__] = ACTIONS(1100),
    [anon_sym_BEGIN] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_END] = ACTIONS(1100),
    [anon_sym_def] = ACTIONS(1100),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_COLON_COLON] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_nil] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1100),
    [anon_sym_module] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_yield] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_next] = ACTIONS(1100),
    [anon_sym_redo] = ACTIONS(1100),
    [anon_sym_retry] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_unless] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_until] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_DOT_DOT] = ACTIONS(1100),
    [anon_sym_begin] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1086),
    [anon_sym_defined_QMARK] = ACTIONS(1086),
    [anon_sym_not] = ACTIONS(1100),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_undef] = ACTIONS(1100),
    [anon_sym_alias] = ACTIONS(1100),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(1100),
    [sym_float] = ACTIONS(1100),
    [sym_super] = ACTIONS(1100),
    [sym_self] = ACTIONS(1100),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_constant] = ACTIONS(1100),
    [aux_sym_constant_suffix_token1] = ACTIONS(1086),
    [aux_sym_identifier_suffix_token1] = ACTIONS(1100),
    [sym_instance_variable] = ACTIONS(1086),
    [sym_class_variable] = ACTIONS(1086),
    [sym_global_variable] = ACTIONS(1086),
    [sym_character] = ACTIONS(1086),
    [anon_sym_DASH_GT] = ACTIONS(1086),
    [sym_simple_symbol] = ACTIONS(1086),
    [sym__string_start] = ACTIONS(1086),
    [sym__symbol_start] = ACTIONS(1086),
    [sym__subshell_start] = ACTIONS(1086),
    [sym__regex_start] = ACTIONS(1086),
    [sym__string_array_start] = ACTIONS(1086),
    [sym__symbol_array_start] = ACTIONS(1086),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(1086),
    [sym__unary_minus] = ACTIONS(1086),
    [sym__unary_minus_num] = ACTIONS(1086),
    [sym__binary_minus] = ACTIONS(1086),
    [sym__identifier_suffix] = ACTIONS(1086),
    [sym__constant_suffix] = ACTIONS(1086),
  },
  [2089] = {
    [sym_splat_parameter] = STATE(4876),
    [sym__pattern_expr] = STATE(4853),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2089),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
  },
  [2090] = {
    [sym_splat_parameter] = STATE(4426),
    [sym__pattern_expr] = STATE(4404),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4445),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4402),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2090),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2760),
    [anon_sym_STAR] = ACTIONS(2762),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2768),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
  },
  [2091] = {
    [sym_heredoc_body] = STATE(2091),
    [ts_builtin_sym_end] = ACTIONS(2908),
    [sym_identifier] = ACTIONS(2044),
    [aux_sym_program_token1] = ACTIONS(2908),
    [anon_sym___END__] = ACTIONS(2044),
    [anon_sym_BEGIN] = ACTIONS(2044),
    [anon_sym_LBRACE] = ACTIONS(2908),
    [anon_sym_END] = ACTIONS(2044),
    [anon_sym_def] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2908),
    [anon_sym_STAR] = ACTIONS(2908),
    [anon_sym_nil] = ACTIONS(2044),
    [anon_sym_class] = ACTIONS(2044),
    [anon_sym_module] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_yield] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_next] = ACTIONS(2044),
    [anon_sym_redo] = ACTIONS(2044),
    [anon_sym_retry] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_unless] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_until] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_case] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2908),
    [anon_sym_DOT_DOT] = ACTIONS(2044),
    [anon_sym_begin] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_defined_QMARK] = ACTIONS(2908),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2908),
    [anon_sym_TILDE] = ACTIONS(2908),
    [anon_sym_undef] = ACTIONS(2044),
    [anon_sym_alias] = ACTIONS(2044),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2044),
    [sym_float] = ACTIONS(2044),
    [sym_super] = ACTIONS(2044),
    [sym_self] = ACTIONS(2044),
    [sym_true] = ACTIONS(2044),
    [sym_false] = ACTIONS(2044),
    [sym_constant] = ACTIONS(2044),
    [aux_sym_constant_suffix_token1] = ACTIONS(2908),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2044),
    [sym_instance_variable] = ACTIONS(2908),
    [sym_class_variable] = ACTIONS(2908),
    [sym_global_variable] = ACTIONS(2908),
    [sym_character] = ACTIONS(2908),
    [anon_sym_DASH_GT] = ACTIONS(2908),
    [sym_simple_symbol] = ACTIONS(2908),
    [sym__string_start] = ACTIONS(2908),
    [sym__symbol_start] = ACTIONS(2908),
    [sym__subshell_start] = ACTIONS(2908),
    [sym__regex_start] = ACTIONS(2908),
    [sym__string_array_start] = ACTIONS(2908),
    [sym__symbol_array_start] = ACTIONS(2908),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2908),
    [sym__unary_minus] = ACTIONS(2908),
    [sym__unary_minus_num] = ACTIONS(2908),
    [sym__binary_minus] = ACTIONS(2908),
    [sym__identifier_suffix] = ACTIONS(2908),
    [sym__constant_suffix] = ACTIONS(2908),
  },
  [2092] = {
    [sym_splat_parameter] = STATE(4426),
    [sym__pattern_expr] = STATE(4404),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4661),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4606),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2092),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2762),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2856),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(2858),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2860),
    [sym_float] = ACTIONS(2860),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2858),
  },
  [2093] = {
    [sym_heredoc_body] = STATE(2093),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2962),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(3036),
    [anon_sym_COMMA] = ACTIONS(3032),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_when] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_then] = ACTIONS(2962),
    [anon_sym_ensure] = ACTIONS(2962),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(3038),
    [anon_sym_DASH_EQ] = ACTIONS(3038),
    [anon_sym_STAR_EQ] = ACTIONS(3038),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3038),
    [anon_sym_SLASH_EQ] = ACTIONS(3038),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3038),
    [anon_sym_PIPE_EQ] = ACTIONS(3038),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3038),
    [anon_sym_AMP_EQ] = ACTIONS(3038),
    [anon_sym_PERCENT_EQ] = ACTIONS(3038),
    [anon_sym_GT_GT_EQ] = ACTIONS(3038),
    [anon_sym_LT_LT_EQ] = ACTIONS(3038),
    [anon_sym_CARET_EQ] = ACTIONS(3038),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2094] = {
    [sym_splat_parameter] = STATE(4426),
    [sym__pattern_expr] = STATE(4404),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4532),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4510),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2094),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2868),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2870),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
  },
  [2095] = {
    [sym_heredoc_body] = STATE(2095),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2962),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(3040),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_when] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_then] = ACTIONS(2962),
    [anon_sym_ensure] = ACTIONS(2962),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(3042),
    [anon_sym_DASH_EQ] = ACTIONS(3042),
    [anon_sym_STAR_EQ] = ACTIONS(3042),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3042),
    [anon_sym_SLASH_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_PIPE_EQ] = ACTIONS(3042),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3042),
    [anon_sym_AMP_EQ] = ACTIONS(3042),
    [anon_sym_PERCENT_EQ] = ACTIONS(3042),
    [anon_sym_GT_GT_EQ] = ACTIONS(3042),
    [anon_sym_LT_LT_EQ] = ACTIONS(3042),
    [anon_sym_CARET_EQ] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2096] = {
    [sym_heredoc_body] = STATE(2096),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2962),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(3044),
    [anon_sym_COMMA] = ACTIONS(3032),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_when] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_then] = ACTIONS(2962),
    [anon_sym_ensure] = ACTIONS(2962),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(3046),
    [anon_sym_DASH_EQ] = ACTIONS(3046),
    [anon_sym_STAR_EQ] = ACTIONS(3046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3046),
    [anon_sym_SLASH_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_PIPE_EQ] = ACTIONS(3046),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3046),
    [anon_sym_AMP_EQ] = ACTIONS(3046),
    [anon_sym_PERCENT_EQ] = ACTIONS(3046),
    [anon_sym_GT_GT_EQ] = ACTIONS(3046),
    [anon_sym_LT_LT_EQ] = ACTIONS(3046),
    [anon_sym_CARET_EQ] = ACTIONS(3046),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2097] = {
    [sym_heredoc_body] = STATE(2097),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2962),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(3048),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_when] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_then] = ACTIONS(2962),
    [anon_sym_ensure] = ACTIONS(2962),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(3050),
    [anon_sym_DASH_EQ] = ACTIONS(3050),
    [anon_sym_STAR_EQ] = ACTIONS(3050),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3050),
    [anon_sym_SLASH_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_PIPE_EQ] = ACTIONS(3050),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3050),
    [anon_sym_AMP_EQ] = ACTIONS(3050),
    [anon_sym_PERCENT_EQ] = ACTIONS(3050),
    [anon_sym_GT_GT_EQ] = ACTIONS(3050),
    [anon_sym_LT_LT_EQ] = ACTIONS(3050),
    [anon_sym_CARET_EQ] = ACTIONS(3050),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2098] = {
    [sym_heredoc_body] = STATE(2098),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_RPAREN] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_end] = ACTIONS(2962),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(3052),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_when] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_elsif] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_then] = ACTIONS(2962),
    [anon_sym_ensure] = ACTIONS(2962),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(3054),
    [anon_sym_DASH_EQ] = ACTIONS(3054),
    [anon_sym_STAR_EQ] = ACTIONS(3054),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3054),
    [anon_sym_SLASH_EQ] = ACTIONS(3054),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3054),
    [anon_sym_PIPE_EQ] = ACTIONS(3054),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3054),
    [anon_sym_AMP_EQ] = ACTIONS(3054),
    [anon_sym_PERCENT_EQ] = ACTIONS(3054),
    [anon_sym_GT_GT_EQ] = ACTIONS(3054),
    [anon_sym_LT_LT_EQ] = ACTIONS(3054),
    [anon_sym_CARET_EQ] = ACTIONS(3054),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2099] = {
    [sym_heredoc_body] = STATE(2099),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(2926),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2686),
    [anon_sym_LBRACK2] = ACTIONS(2686),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2100] = {
    [sym__pattern_expr] = STATE(4853),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4700),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4688),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2100),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2874),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2876),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2878),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2880),
    [sym_float] = ACTIONS(2880),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2878),
  },
  [2101] = {
    [sym__pattern_expr] = STATE(5517),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2101),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
  },
  [2102] = {
    [sym_heredoc_body] = STATE(2102),
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_BEGIN] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(3016),
    [anon_sym_END] = ACTIONS(3014),
    [anon_sym_def] = ACTIONS(3014),
    [anon_sym_LPAREN] = ACTIONS(3016),
    [anon_sym_COLON_COLON] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_nil] = ACTIONS(3014),
    [anon_sym_class] = ACTIONS(3014),
    [anon_sym_module] = ACTIONS(3014),
    [anon_sym_return] = ACTIONS(3014),
    [anon_sym_yield] = ACTIONS(3014),
    [anon_sym_break] = ACTIONS(3014),
    [anon_sym_next] = ACTIONS(3014),
    [anon_sym_redo] = ACTIONS(3014),
    [anon_sym_retry] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_unless] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_until] = ACTIONS(3014),
    [anon_sym_for] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_begin] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_defined_QMARK] = ACTIONS(3016),
    [anon_sym_not] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3016),
    [anon_sym_undef] = ACTIONS(3014),
    [anon_sym_alias] = ACTIONS(3014),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3014),
    [sym_float] = ACTIONS(3014),
    [sym_super] = ACTIONS(3014),
    [sym_self] = ACTIONS(3014),
    [sym_true] = ACTIONS(3014),
    [sym_false] = ACTIONS(3014),
    [sym_constant] = ACTIONS(3014),
    [aux_sym_constant_suffix_token1] = ACTIONS(3016),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3014),
    [sym_instance_variable] = ACTIONS(3016),
    [sym_class_variable] = ACTIONS(3016),
    [sym_global_variable] = ACTIONS(3016),
    [sym_character] = ACTIONS(3016),
    [anon_sym_DASH_GT] = ACTIONS(3016),
    [sym_simple_symbol] = ACTIONS(3016),
    [sym__string_start] = ACTIONS(3016),
    [sym__symbol_start] = ACTIONS(3016),
    [sym__subshell_start] = ACTIONS(3016),
    [sym__regex_start] = ACTIONS(3016),
    [sym__string_array_start] = ACTIONS(3016),
    [sym__symbol_array_start] = ACTIONS(3016),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3016),
    [sym__unary_minus] = ACTIONS(3016),
    [sym__unary_minus_num] = ACTIONS(3016),
    [sym__binary_minus] = ACTIONS(3016),
    [sym__identifier_suffix] = ACTIONS(3016),
    [sym__constant_suffix] = ACTIONS(3016),
  },
  [2103] = {
    [sym__pattern_expr] = STATE(4853),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2103),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
  },
  [2104] = {
    [sym_heredoc_body] = STATE(2104),
    [sym_identifier] = ACTIONS(2990),
    [anon_sym_BEGIN] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_END] = ACTIONS(2990),
    [anon_sym_def] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2992),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2992),
    [anon_sym_STAR] = ACTIONS(2992),
    [anon_sym_nil] = ACTIONS(2990),
    [anon_sym_class] = ACTIONS(2990),
    [anon_sym_module] = ACTIONS(2990),
    [anon_sym_return] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2990),
    [anon_sym_break] = ACTIONS(2990),
    [anon_sym_next] = ACTIONS(2990),
    [anon_sym_redo] = ACTIONS(2990),
    [anon_sym_retry] = ACTIONS(2990),
    [anon_sym_if] = ACTIONS(2990),
    [anon_sym_unless] = ACTIONS(2990),
    [anon_sym_while] = ACTIONS(2990),
    [anon_sym_until] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2990),
    [anon_sym_case] = ACTIONS(2990),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_DOT_DOT] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2990),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_defined_QMARK] = ACTIONS(2992),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2992),
    [anon_sym_undef] = ACTIONS(2990),
    [anon_sym_alias] = ACTIONS(2990),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2990),
    [sym_float] = ACTIONS(2990),
    [sym_super] = ACTIONS(2990),
    [sym_self] = ACTIONS(2990),
    [sym_true] = ACTIONS(2990),
    [sym_false] = ACTIONS(2990),
    [sym_constant] = ACTIONS(2990),
    [aux_sym_constant_suffix_token1] = ACTIONS(2992),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2990),
    [sym_instance_variable] = ACTIONS(2992),
    [sym_class_variable] = ACTIONS(2992),
    [sym_global_variable] = ACTIONS(2992),
    [sym_character] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(2992),
    [sym_simple_symbol] = ACTIONS(2992),
    [sym__string_start] = ACTIONS(2992),
    [sym__symbol_start] = ACTIONS(2992),
    [sym__subshell_start] = ACTIONS(2992),
    [sym__regex_start] = ACTIONS(2992),
    [sym__string_array_start] = ACTIONS(2992),
    [sym__symbol_array_start] = ACTIONS(2992),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2992),
    [sym__unary_minus] = ACTIONS(2992),
    [sym__unary_minus_num] = ACTIONS(2992),
    [sym__binary_minus] = ACTIONS(2992),
    [sym__identifier_suffix] = ACTIONS(2992),
    [sym__constant_suffix] = ACTIONS(2992),
  },
  [2105] = {
    [sym_heredoc_body] = STATE(2105),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_BEGIN] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_RBRACE] = ACTIONS(3004),
    [anon_sym_END] = ACTIONS(3002),
    [anon_sym_def] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(3004),
    [anon_sym_COLON_COLON] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3004),
    [anon_sym_STAR] = ACTIONS(3004),
    [anon_sym_nil] = ACTIONS(3002),
    [anon_sym_class] = ACTIONS(3002),
    [anon_sym_module] = ACTIONS(3002),
    [anon_sym_return] = ACTIONS(3002),
    [anon_sym_yield] = ACTIONS(3002),
    [anon_sym_break] = ACTIONS(3002),
    [anon_sym_next] = ACTIONS(3002),
    [anon_sym_redo] = ACTIONS(3002),
    [anon_sym_retry] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [anon_sym_for] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3004),
    [anon_sym_DOT_DOT] = ACTIONS(3002),
    [anon_sym_begin] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3004),
    [anon_sym_defined_QMARK] = ACTIONS(3004),
    [anon_sym_not] = ACTIONS(3002),
    [anon_sym_BANG] = ACTIONS(3004),
    [anon_sym_TILDE] = ACTIONS(3004),
    [anon_sym_undef] = ACTIONS(3002),
    [anon_sym_alias] = ACTIONS(3002),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3002),
    [sym_float] = ACTIONS(3002),
    [sym_super] = ACTIONS(3002),
    [sym_self] = ACTIONS(3002),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [sym_constant] = ACTIONS(3002),
    [aux_sym_constant_suffix_token1] = ACTIONS(3004),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3002),
    [sym_instance_variable] = ACTIONS(3004),
    [sym_class_variable] = ACTIONS(3004),
    [sym_global_variable] = ACTIONS(3004),
    [sym_character] = ACTIONS(3004),
    [anon_sym_DASH_GT] = ACTIONS(3004),
    [sym_simple_symbol] = ACTIONS(3004),
    [sym__string_start] = ACTIONS(3004),
    [sym__symbol_start] = ACTIONS(3004),
    [sym__subshell_start] = ACTIONS(3004),
    [sym__regex_start] = ACTIONS(3004),
    [sym__string_array_start] = ACTIONS(3004),
    [sym__symbol_array_start] = ACTIONS(3004),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3004),
    [sym__unary_minus] = ACTIONS(3004),
    [sym__unary_minus_num] = ACTIONS(3004),
    [sym__binary_minus] = ACTIONS(3004),
    [sym__identifier_suffix] = ACTIONS(3004),
    [sym__constant_suffix] = ACTIONS(3004),
  },
  [2106] = {
    [sym_heredoc_body] = STATE(2106),
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_BEGIN] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_END] = ACTIONS(2994),
    [anon_sym_def] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2996),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2996),
    [anon_sym_STAR] = ACTIONS(2996),
    [anon_sym_nil] = ACTIONS(2994),
    [anon_sym_class] = ACTIONS(2994),
    [anon_sym_module] = ACTIONS(2994),
    [anon_sym_return] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2994),
    [anon_sym_break] = ACTIONS(2994),
    [anon_sym_next] = ACTIONS(2994),
    [anon_sym_redo] = ACTIONS(2994),
    [anon_sym_retry] = ACTIONS(2994),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_unless] = ACTIONS(2994),
    [anon_sym_while] = ACTIONS(2994),
    [anon_sym_until] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2994),
    [anon_sym_case] = ACTIONS(2994),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_DOT_DOT] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2994),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_defined_QMARK] = ACTIONS(2996),
    [anon_sym_not] = ACTIONS(2994),
    [anon_sym_BANG] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2996),
    [anon_sym_undef] = ACTIONS(2994),
    [anon_sym_alias] = ACTIONS(2994),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2994),
    [sym_float] = ACTIONS(2994),
    [sym_super] = ACTIONS(2994),
    [sym_self] = ACTIONS(2994),
    [sym_true] = ACTIONS(2994),
    [sym_false] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2994),
    [aux_sym_constant_suffix_token1] = ACTIONS(2996),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2994),
    [sym_instance_variable] = ACTIONS(2996),
    [sym_class_variable] = ACTIONS(2996),
    [sym_global_variable] = ACTIONS(2996),
    [sym_character] = ACTIONS(2996),
    [anon_sym_DASH_GT] = ACTIONS(2996),
    [sym_simple_symbol] = ACTIONS(2996),
    [sym__string_start] = ACTIONS(2996),
    [sym__symbol_start] = ACTIONS(2996),
    [sym__subshell_start] = ACTIONS(2996),
    [sym__regex_start] = ACTIONS(2996),
    [sym__string_array_start] = ACTIONS(2996),
    [sym__symbol_array_start] = ACTIONS(2996),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2996),
    [sym__unary_minus] = ACTIONS(2996),
    [sym__unary_minus_num] = ACTIONS(2996),
    [sym__binary_minus] = ACTIONS(2996),
    [sym__identifier_suffix] = ACTIONS(2996),
    [sym__constant_suffix] = ACTIONS(2996),
  },
  [2107] = {
    [sym_heredoc_body] = STATE(2107),
    [sym_identifier] = ACTIONS(3018),
    [anon_sym_BEGIN] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_RBRACE] = ACTIONS(3020),
    [anon_sym_END] = ACTIONS(3018),
    [anon_sym_def] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_nil] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(3018),
    [anon_sym_module] = ACTIONS(3018),
    [anon_sym_return] = ACTIONS(3018),
    [anon_sym_yield] = ACTIONS(3018),
    [anon_sym_break] = ACTIONS(3018),
    [anon_sym_next] = ACTIONS(3018),
    [anon_sym_redo] = ACTIONS(3018),
    [anon_sym_retry] = ACTIONS(3018),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_unless] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_until] = ACTIONS(3018),
    [anon_sym_for] = ACTIONS(3018),
    [anon_sym_case] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_DOT_DOT] = ACTIONS(3018),
    [anon_sym_begin] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_defined_QMARK] = ACTIONS(3020),
    [anon_sym_not] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3020),
    [anon_sym_undef] = ACTIONS(3018),
    [anon_sym_alias] = ACTIONS(3018),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3018),
    [sym_float] = ACTIONS(3018),
    [sym_super] = ACTIONS(3018),
    [sym_self] = ACTIONS(3018),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [sym_constant] = ACTIONS(3018),
    [aux_sym_constant_suffix_token1] = ACTIONS(3020),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3018),
    [sym_instance_variable] = ACTIONS(3020),
    [sym_class_variable] = ACTIONS(3020),
    [sym_global_variable] = ACTIONS(3020),
    [sym_character] = ACTIONS(3020),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [sym_simple_symbol] = ACTIONS(3020),
    [sym__string_start] = ACTIONS(3020),
    [sym__symbol_start] = ACTIONS(3020),
    [sym__subshell_start] = ACTIONS(3020),
    [sym__regex_start] = ACTIONS(3020),
    [sym__string_array_start] = ACTIONS(3020),
    [sym__symbol_array_start] = ACTIONS(3020),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3020),
    [sym__unary_minus] = ACTIONS(3020),
    [sym__unary_minus_num] = ACTIONS(3020),
    [sym__binary_minus] = ACTIONS(3020),
    [sym__identifier_suffix] = ACTIONS(3020),
    [sym__constant_suffix] = ACTIONS(3020),
  },
  [2108] = {
    [sym_heredoc_body] = STATE(2108),
    [sym_identifier] = ACTIONS(2998),
    [anon_sym_BEGIN] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(3000),
    [anon_sym_RBRACE] = ACTIONS(3000),
    [anon_sym_END] = ACTIONS(2998),
    [anon_sym_def] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(3000),
    [anon_sym_COLON_COLON] = ACTIONS(3000),
    [anon_sym_SEMI] = ACTIONS(3000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3000),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_nil] = ACTIONS(2998),
    [anon_sym_class] = ACTIONS(2998),
    [anon_sym_module] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2998),
    [anon_sym_break] = ACTIONS(2998),
    [anon_sym_next] = ACTIONS(2998),
    [anon_sym_redo] = ACTIONS(2998),
    [anon_sym_retry] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_unless] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_until] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_case] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(3000),
    [anon_sym_DOT_DOT] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2998),
    [anon_sym_PLUS] = ACTIONS(3000),
    [anon_sym_defined_QMARK] = ACTIONS(3000),
    [anon_sym_not] = ACTIONS(2998),
    [anon_sym_BANG] = ACTIONS(3000),
    [anon_sym_TILDE] = ACTIONS(3000),
    [anon_sym_undef] = ACTIONS(2998),
    [anon_sym_alias] = ACTIONS(2998),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2998),
    [sym_float] = ACTIONS(2998),
    [sym_super] = ACTIONS(2998),
    [sym_self] = ACTIONS(2998),
    [sym_true] = ACTIONS(2998),
    [sym_false] = ACTIONS(2998),
    [sym_constant] = ACTIONS(2998),
    [aux_sym_constant_suffix_token1] = ACTIONS(3000),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2998),
    [sym_instance_variable] = ACTIONS(3000),
    [sym_class_variable] = ACTIONS(3000),
    [sym_global_variable] = ACTIONS(3000),
    [sym_character] = ACTIONS(3000),
    [anon_sym_DASH_GT] = ACTIONS(3000),
    [sym_simple_symbol] = ACTIONS(3000),
    [sym__string_start] = ACTIONS(3000),
    [sym__symbol_start] = ACTIONS(3000),
    [sym__subshell_start] = ACTIONS(3000),
    [sym__regex_start] = ACTIONS(3000),
    [sym__string_array_start] = ACTIONS(3000),
    [sym__symbol_array_start] = ACTIONS(3000),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3000),
    [sym__unary_minus] = ACTIONS(3000),
    [sym__unary_minus_num] = ACTIONS(3000),
    [sym__binary_minus] = ACTIONS(3000),
    [sym__identifier_suffix] = ACTIONS(3000),
    [sym__constant_suffix] = ACTIONS(3000),
  },
  [2109] = {
    [sym__pattern_expr] = STATE(4404),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4532),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4510),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2109),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2864),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2868),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1756),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2870),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
  },
  [2110] = {
    [sym__pattern_expr] = STATE(5514),
    [sym_as_pattern] = STATE(4790),
    [sym__pattern_expr_alt] = STATE(4790),
    [sym_alternative_pattern] = STATE(4768),
    [sym_array_pattern] = STATE(4756),
    [sym_find_pattern] = STATE(4756),
    [sym_hash_pattern] = STATE(4756),
    [sym__pattern_expr_basic] = STATE(4748),
    [sym_parenthesized_pattern] = STATE(4756),
    [sym__pattern_value] = STATE(4756),
    [sym__pattern_range] = STATE(4704),
    [sym__pattern_primitive] = STATE(4677),
    [sym__pattern_lambda] = STATE(4668),
    [sym__pattern_literal] = STATE(4668),
    [sym__keyword_variable] = STATE(4658),
    [sym_variable_reference_pattern] = STATE(4728),
    [sym_expression_reference_pattern] = STATE(4728),
    [sym__pattern_constant] = STATE(4588),
    [sym__pattern_constant_resolution] = STATE(4590),
    [sym_unary_literal] = STATE(4659),
    [sym__literal] = STATE(4658),
    [sym__numeric] = STATE(4651),
    [sym__simple_numeric] = STATE(4659),
    [sym__int_or_float] = STATE(5423),
    [sym_complex] = STATE(4666),
    [sym_rational] = STATE(4666),
    [sym_nil] = STATE(4662),
    [sym_string] = STATE(4658),
    [sym_subshell] = STATE(4658),
    [sym_string_array] = STATE(4658),
    [sym_symbol_array] = STATE(4658),
    [sym_delimited_symbol] = STATE(4651),
    [sym_regex] = STATE(4658),
    [sym_heredoc_body] = STATE(2110),
    [sym_lambda] = STATE(4648),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2808),
    [anon_sym_nil] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2818),
    [sym_line] = ACTIONS(655),
    [sym_file] = ACTIONS(655),
    [sym_encoding] = ACTIONS(655),
    [anon_sym_CARET] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2820),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2822),
    [sym_float] = ACTIONS(2822),
    [sym_self] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_constant] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2830),
    [sym_simple_symbol] = ACTIONS(2832),
    [sym__string_start] = ACTIONS(2834),
    [sym__symbol_start] = ACTIONS(2836),
    [sym__subshell_start] = ACTIONS(2838),
    [sym__regex_start] = ACTIONS(2840),
    [sym__string_array_start] = ACTIONS(2842),
    [sym__symbol_array_start] = ACTIONS(2844),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2846),
    [sym__unary_minus_num] = ACTIONS(2820),
  },
  [2111] = {
    [sym_heredoc_body] = STATE(2111),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_BEGIN] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2972),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_END] = ACTIONS(2970),
    [anon_sym_def] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2972),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2972),
    [anon_sym_nil] = ACTIONS(2970),
    [anon_sym_class] = ACTIONS(2970),
    [anon_sym_module] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_break] = ACTIONS(2970),
    [anon_sym_next] = ACTIONS(2970),
    [anon_sym_redo] = ACTIONS(2970),
    [anon_sym_retry] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_unless] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_until] = ACTIONS(2970),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_case] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_DOT_DOT] = ACTIONS(2970),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_defined_QMARK] = ACTIONS(2972),
    [anon_sym_not] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2972),
    [anon_sym_TILDE] = ACTIONS(2972),
    [anon_sym_undef] = ACTIONS(2970),
    [anon_sym_alias] = ACTIONS(2970),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2970),
    [sym_float] = ACTIONS(2970),
    [sym_super] = ACTIONS(2970),
    [sym_self] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [sym_constant] = ACTIONS(2970),
    [aux_sym_constant_suffix_token1] = ACTIONS(2972),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2970),
    [sym_instance_variable] = ACTIONS(2972),
    [sym_class_variable] = ACTIONS(2972),
    [sym_global_variable] = ACTIONS(2972),
    [sym_character] = ACTIONS(2972),
    [anon_sym_DASH_GT] = ACTIONS(2972),
    [sym_simple_symbol] = ACTIONS(2972),
    [sym__string_start] = ACTIONS(2972),
    [sym__symbol_start] = ACTIONS(2972),
    [sym__subshell_start] = ACTIONS(2972),
    [sym__regex_start] = ACTIONS(2972),
    [sym__string_array_start] = ACTIONS(2972),
    [sym__symbol_array_start] = ACTIONS(2972),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2972),
    [sym__unary_minus] = ACTIONS(2972),
    [sym__unary_minus_num] = ACTIONS(2972),
    [sym__binary_minus] = ACTIONS(2972),
    [sym__identifier_suffix] = ACTIONS(2972),
    [sym__constant_suffix] = ACTIONS(2972),
  },
  [2112] = {
    [sym__pattern_expr] = STATE(4404),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4445),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4402),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2112),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2760),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2768),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
  },
  [2113] = {
    [sym_heredoc_body] = STATE(2113),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_BEGIN] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_END] = ACTIONS(2974),
    [anon_sym_def] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(2976),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2976),
    [anon_sym_nil] = ACTIONS(2974),
    [anon_sym_class] = ACTIONS(2974),
    [anon_sym_module] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_break] = ACTIONS(2974),
    [anon_sym_next] = ACTIONS(2974),
    [anon_sym_redo] = ACTIONS(2974),
    [anon_sym_retry] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_unless] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_until] = ACTIONS(2974),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_case] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_DOT_DOT] = ACTIONS(2974),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2976),
    [anon_sym_defined_QMARK] = ACTIONS(2976),
    [anon_sym_not] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2976),
    [anon_sym_TILDE] = ACTIONS(2976),
    [anon_sym_undef] = ACTIONS(2974),
    [anon_sym_alias] = ACTIONS(2974),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2974),
    [sym_float] = ACTIONS(2974),
    [sym_super] = ACTIONS(2974),
    [sym_self] = ACTIONS(2974),
    [sym_true] = ACTIONS(2974),
    [sym_false] = ACTIONS(2974),
    [sym_constant] = ACTIONS(2974),
    [aux_sym_constant_suffix_token1] = ACTIONS(2976),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2974),
    [sym_instance_variable] = ACTIONS(2976),
    [sym_class_variable] = ACTIONS(2976),
    [sym_global_variable] = ACTIONS(2976),
    [sym_character] = ACTIONS(2976),
    [anon_sym_DASH_GT] = ACTIONS(2976),
    [sym_simple_symbol] = ACTIONS(2976),
    [sym__string_start] = ACTIONS(2976),
    [sym__symbol_start] = ACTIONS(2976),
    [sym__subshell_start] = ACTIONS(2976),
    [sym__regex_start] = ACTIONS(2976),
    [sym__string_array_start] = ACTIONS(2976),
    [sym__symbol_array_start] = ACTIONS(2976),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2976),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__unary_minus_num] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(2976),
    [sym__identifier_suffix] = ACTIONS(2976),
    [sym__constant_suffix] = ACTIONS(2976),
  },
  [2114] = {
    [sym_heredoc_body] = STATE(2114),
    [sym_identifier] = ACTIONS(3006),
    [anon_sym_BEGIN] = ACTIONS(3006),
    [anon_sym_LBRACE] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3008),
    [anon_sym_END] = ACTIONS(3006),
    [anon_sym_def] = ACTIONS(3006),
    [anon_sym_LPAREN] = ACTIONS(3008),
    [anon_sym_COLON_COLON] = ACTIONS(3008),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3008),
    [anon_sym_STAR] = ACTIONS(3008),
    [anon_sym_nil] = ACTIONS(3006),
    [anon_sym_class] = ACTIONS(3006),
    [anon_sym_module] = ACTIONS(3006),
    [anon_sym_return] = ACTIONS(3006),
    [anon_sym_yield] = ACTIONS(3006),
    [anon_sym_break] = ACTIONS(3006),
    [anon_sym_next] = ACTIONS(3006),
    [anon_sym_redo] = ACTIONS(3006),
    [anon_sym_retry] = ACTIONS(3006),
    [anon_sym_if] = ACTIONS(3006),
    [anon_sym_unless] = ACTIONS(3006),
    [anon_sym_while] = ACTIONS(3006),
    [anon_sym_until] = ACTIONS(3006),
    [anon_sym_for] = ACTIONS(3006),
    [anon_sym_case] = ACTIONS(3006),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_DOT_DOT] = ACTIONS(3006),
    [anon_sym_begin] = ACTIONS(3006),
    [anon_sym_PLUS] = ACTIONS(3008),
    [anon_sym_defined_QMARK] = ACTIONS(3008),
    [anon_sym_not] = ACTIONS(3006),
    [anon_sym_BANG] = ACTIONS(3008),
    [anon_sym_TILDE] = ACTIONS(3008),
    [anon_sym_undef] = ACTIONS(3006),
    [anon_sym_alias] = ACTIONS(3006),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3006),
    [sym_float] = ACTIONS(3006),
    [sym_super] = ACTIONS(3006),
    [sym_self] = ACTIONS(3006),
    [sym_true] = ACTIONS(3006),
    [sym_false] = ACTIONS(3006),
    [sym_constant] = ACTIONS(3006),
    [aux_sym_constant_suffix_token1] = ACTIONS(3008),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3006),
    [sym_instance_variable] = ACTIONS(3008),
    [sym_class_variable] = ACTIONS(3008),
    [sym_global_variable] = ACTIONS(3008),
    [sym_character] = ACTIONS(3008),
    [anon_sym_DASH_GT] = ACTIONS(3008),
    [sym_simple_symbol] = ACTIONS(3008),
    [sym__string_start] = ACTIONS(3008),
    [sym__symbol_start] = ACTIONS(3008),
    [sym__subshell_start] = ACTIONS(3008),
    [sym__regex_start] = ACTIONS(3008),
    [sym__string_array_start] = ACTIONS(3008),
    [sym__symbol_array_start] = ACTIONS(3008),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3008),
    [sym__unary_minus] = ACTIONS(3008),
    [sym__unary_minus_num] = ACTIONS(3008),
    [sym__binary_minus] = ACTIONS(3008),
    [sym__identifier_suffix] = ACTIONS(3008),
    [sym__constant_suffix] = ACTIONS(3008),
  },
  [2115] = {
    [sym_heredoc_body] = STATE(2115),
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_BEGIN] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_RBRACE] = ACTIONS(2984),
    [anon_sym_END] = ACTIONS(2982),
    [anon_sym_def] = ACTIONS(2982),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2984),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_nil] = ACTIONS(2982),
    [anon_sym_class] = ACTIONS(2982),
    [anon_sym_module] = ACTIONS(2982),
    [anon_sym_return] = ACTIONS(2982),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2982),
    [anon_sym_next] = ACTIONS(2982),
    [anon_sym_redo] = ACTIONS(2982),
    [anon_sym_retry] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2982),
    [anon_sym_unless] = ACTIONS(2982),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_until] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2982),
    [anon_sym_case] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_DOT_DOT] = ACTIONS(2982),
    [anon_sym_begin] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_defined_QMARK] = ACTIONS(2984),
    [anon_sym_not] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2984),
    [anon_sym_undef] = ACTIONS(2982),
    [anon_sym_alias] = ACTIONS(2982),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2982),
    [sym_float] = ACTIONS(2982),
    [sym_super] = ACTIONS(2982),
    [sym_self] = ACTIONS(2982),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [sym_constant] = ACTIONS(2982),
    [aux_sym_constant_suffix_token1] = ACTIONS(2984),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2982),
    [sym_instance_variable] = ACTIONS(2984),
    [sym_class_variable] = ACTIONS(2984),
    [sym_global_variable] = ACTIONS(2984),
    [sym_character] = ACTIONS(2984),
    [anon_sym_DASH_GT] = ACTIONS(2984),
    [sym_simple_symbol] = ACTIONS(2984),
    [sym__string_start] = ACTIONS(2984),
    [sym__symbol_start] = ACTIONS(2984),
    [sym__subshell_start] = ACTIONS(2984),
    [sym__regex_start] = ACTIONS(2984),
    [sym__string_array_start] = ACTIONS(2984),
    [sym__symbol_array_start] = ACTIONS(2984),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2984),
    [sym__unary_minus] = ACTIONS(2984),
    [sym__unary_minus_num] = ACTIONS(2984),
    [sym__binary_minus] = ACTIONS(2984),
    [sym__identifier_suffix] = ACTIONS(2984),
    [sym__constant_suffix] = ACTIONS(2984),
  },
  [2116] = {
    [sym__pattern_expr] = STATE(4404),
    [sym_as_pattern] = STATE(4392),
    [sym__pattern_expr_alt] = STATE(4392),
    [sym_alternative_pattern] = STATE(4393),
    [sym_array_pattern] = STATE(4379),
    [sym_find_pattern] = STATE(4379),
    [sym_hash_pattern] = STATE(4379),
    [sym__pattern_expr_basic] = STATE(4661),
    [sym_parenthesized_pattern] = STATE(4379),
    [sym__pattern_value] = STATE(4379),
    [sym__pattern_range] = STATE(4370),
    [sym__pattern_primitive] = STATE(4606),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_variable_reference_pattern] = STATE(4376),
    [sym_expression_reference_pattern] = STATE(4376),
    [sym__pattern_constant] = STATE(4229),
    [sym__pattern_constant_resolution] = STATE(4230),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2116),
    [sym_lambda] = STATE(4345),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2852),
    [anon_sym_nil] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_DOT_DOT] = ACTIONS(2856),
    [sym_line] = ACTIONS(1692),
    [sym_file] = ACTIONS(1692),
    [sym_encoding] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(2858),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2860),
    [sym_float] = ACTIONS(2860),
    [sym_self] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_constant] = ACTIONS(2774),
    [anon_sym_DASH_GT] = ACTIONS(2776),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2858),
  },
  [2117] = {
    [sym_heredoc_body] = STATE(2117),
    [sym_identifier] = ACTIONS(3010),
    [anon_sym_BEGIN] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_END] = ACTIONS(3010),
    [anon_sym_def] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_COLON_COLON] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(3012),
    [anon_sym_nil] = ACTIONS(3010),
    [anon_sym_class] = ACTIONS(3010),
    [anon_sym_module] = ACTIONS(3010),
    [anon_sym_return] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3010),
    [anon_sym_break] = ACTIONS(3010),
    [anon_sym_next] = ACTIONS(3010),
    [anon_sym_redo] = ACTIONS(3010),
    [anon_sym_retry] = ACTIONS(3010),
    [anon_sym_if] = ACTIONS(3010),
    [anon_sym_unless] = ACTIONS(3010),
    [anon_sym_while] = ACTIONS(3010),
    [anon_sym_until] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3010),
    [anon_sym_case] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_DOT_DOT] = ACTIONS(3010),
    [anon_sym_begin] = ACTIONS(3010),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_defined_QMARK] = ACTIONS(3012),
    [anon_sym_not] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3012),
    [anon_sym_undef] = ACTIONS(3010),
    [anon_sym_alias] = ACTIONS(3010),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(3010),
    [sym_float] = ACTIONS(3010),
    [sym_super] = ACTIONS(3010),
    [sym_self] = ACTIONS(3010),
    [sym_true] = ACTIONS(3010),
    [sym_false] = ACTIONS(3010),
    [sym_constant] = ACTIONS(3010),
    [aux_sym_constant_suffix_token1] = ACTIONS(3012),
    [aux_sym_identifier_suffix_token1] = ACTIONS(3010),
    [sym_instance_variable] = ACTIONS(3012),
    [sym_class_variable] = ACTIONS(3012),
    [sym_global_variable] = ACTIONS(3012),
    [sym_character] = ACTIONS(3012),
    [anon_sym_DASH_GT] = ACTIONS(3012),
    [sym_simple_symbol] = ACTIONS(3012),
    [sym__string_start] = ACTIONS(3012),
    [sym__symbol_start] = ACTIONS(3012),
    [sym__subshell_start] = ACTIONS(3012),
    [sym__regex_start] = ACTIONS(3012),
    [sym__string_array_start] = ACTIONS(3012),
    [sym__symbol_array_start] = ACTIONS(3012),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(3012),
    [sym__unary_minus] = ACTIONS(3012),
    [sym__unary_minus_num] = ACTIONS(3012),
    [sym__binary_minus] = ACTIONS(3012),
    [sym__identifier_suffix] = ACTIONS(3012),
    [sym__constant_suffix] = ACTIONS(3012),
  },
  [2118] = {
    [sym_heredoc_body] = STATE(2118),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_BEGIN] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2980),
    [anon_sym_END] = ACTIONS(2978),
    [anon_sym_def] = ACTIONS(2978),
    [anon_sym_LPAREN] = ACTIONS(2980),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_nil] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_module] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_next] = ACTIONS(2978),
    [anon_sym_redo] = ACTIONS(2978),
    [anon_sym_retry] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_unless] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_until] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_case] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_DOT_DOT] = ACTIONS(2978),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_defined_QMARK] = ACTIONS(2980),
    [anon_sym_not] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_undef] = ACTIONS(2978),
    [anon_sym_alias] = ACTIONS(2978),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2978),
    [sym_float] = ACTIONS(2978),
    [sym_super] = ACTIONS(2978),
    [sym_self] = ACTIONS(2978),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [sym_constant] = ACTIONS(2978),
    [aux_sym_constant_suffix_token1] = ACTIONS(2980),
    [aux_sym_identifier_suffix_token1] = ACTIONS(2978),
    [sym_instance_variable] = ACTIONS(2980),
    [sym_class_variable] = ACTIONS(2980),
    [sym_global_variable] = ACTIONS(2980),
    [sym_character] = ACTIONS(2980),
    [anon_sym_DASH_GT] = ACTIONS(2980),
    [sym_simple_symbol] = ACTIONS(2980),
    [sym__string_start] = ACTIONS(2980),
    [sym__symbol_start] = ACTIONS(2980),
    [sym__subshell_start] = ACTIONS(2980),
    [sym__regex_start] = ACTIONS(2980),
    [sym__string_array_start] = ACTIONS(2980),
    [sym__symbol_array_start] = ACTIONS(2980),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2980),
    [sym__unary_minus] = ACTIONS(2980),
    [sym__unary_minus_num] = ACTIONS(2980),
    [sym__binary_minus] = ACTIONS(2980),
    [sym__identifier_suffix] = ACTIONS(2980),
    [sym__constant_suffix] = ACTIONS(2980),
  },
  [2119] = {
    [sym_heredoc_body] = STATE(2119),
    [ts_builtin_sym_end] = ACTIONS(745),
    [aux_sym_program_token1] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(745),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_unless] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_until] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2956),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(745),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2120] = {
    [sym_heredoc_body] = STATE(2120),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_COLON_COLON] = ACTIONS(2926),
    [anon_sym_rescue] = ACTIONS(2686),
    [anon_sym_EQ] = ACTIONS(733),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(2686),
    [anon_sym_unless] = ACTIONS(2686),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_until] = ACTIONS(2686),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_EQ_GT] = ACTIONS(2686),
    [anon_sym_LBRACK2] = ACTIONS(2686),
    [anon_sym_LPAREN2] = ACTIONS(745),
    [anon_sym_DOT_DOT] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(745),
    [anon_sym_or] = ACTIONS(745),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(733),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(733),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2686),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__binary_star_star] = ACTIONS(745),
    [sym__element_reference_bracket] = ACTIONS(745),
  },
  [2121] = {
    [sym_heredoc_body] = STATE(2121),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [ts_builtin_sym_end] = ACTIONS(2962),
    [aux_sym_program_token1] = ACTIONS(2962),
    [anon_sym___END__] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(3058),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(3060),
    [anon_sym_DASH_EQ] = ACTIONS(3060),
    [anon_sym_STAR_EQ] = ACTIONS(3060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3060),
    [anon_sym_SLASH_EQ] = ACTIONS(3060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3060),
    [anon_sym_PIPE_EQ] = ACTIONS(3060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3060),
    [anon_sym_AMP_EQ] = ACTIONS(3060),
    [anon_sym_PERCENT_EQ] = ACTIONS(3060),
    [anon_sym_GT_GT_EQ] = ACTIONS(3060),
    [anon_sym_LT_LT_EQ] = ACTIONS(3060),
    [anon_sym_CARET_EQ] = ACTIONS(3060),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2122] = {
    [sym_heredoc_body] = STATE(2122),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [ts_builtin_sym_end] = ACTIONS(2962),
    [aux_sym_program_token1] = ACTIONS(2962),
    [anon_sym___END__] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(3062),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(3064),
    [anon_sym_DASH_EQ] = ACTIONS(3064),
    [anon_sym_STAR_EQ] = ACTIONS(3064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3064),
    [anon_sym_SLASH_EQ] = ACTIONS(3064),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3064),
    [anon_sym_PIPE_EQ] = ACTIONS(3064),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3064),
    [anon_sym_AMP_EQ] = ACTIONS(3064),
    [anon_sym_PERCENT_EQ] = ACTIONS(3064),
    [anon_sym_GT_GT_EQ] = ACTIONS(3064),
    [anon_sym_LT_LT_EQ] = ACTIONS(3064),
    [anon_sym_CARET_EQ] = ACTIONS(3064),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2123] = {
    [sym_heredoc_body] = STATE(2123),
    [aux_sym__mlhs_repeat1] = STATE(5217),
    [ts_builtin_sym_end] = ACTIONS(2962),
    [aux_sym_program_token1] = ACTIONS(2962),
    [anon_sym___END__] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2964),
    [anon_sym_rescue] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(3066),
    [anon_sym_COMMA] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_unless] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_until] = ACTIONS(2962),
    [anon_sym_in] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_EQ_GT] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_CARET] = ACTIONS(2964),
    [anon_sym_COLON_COLON2] = ACTIONS(2962),
    [anon_sym_AMP_DOT] = ACTIONS(2962),
    [anon_sym_PLUS_EQ] = ACTIONS(3068),
    [anon_sym_DASH_EQ] = ACTIONS(3068),
    [anon_sym_STAR_EQ] = ACTIONS(3068),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3068),
    [anon_sym_SLASH_EQ] = ACTIONS(3068),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3068),
    [anon_sym_PIPE_EQ] = ACTIONS(3068),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3068),
    [anon_sym_AMP_EQ] = ACTIONS(3068),
    [anon_sym_PERCENT_EQ] = ACTIONS(3068),
    [anon_sym_GT_GT_EQ] = ACTIONS(3068),
    [anon_sym_LT_LT_EQ] = ACTIONS(3068),
    [anon_sym_CARET_EQ] = ACTIONS(3068),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_LT_LT] = ACTIONS(2964),
    [anon_sym_GT_GT] = ACTIONS(2964),
    [anon_sym_LT_EQ] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_GT_EQ] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_SLASH] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_EQ_EQ] = ACTIONS(2964),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2962),
    [anon_sym_LT_EQ_GT] = ACTIONS(2962),
    [anon_sym_EQ_TILDE] = ACTIONS(2962),
    [anon_sym_BANG_TILDE] = ACTIONS(2962),
    [sym_comment] = ACTIONS(3),
    [sym__line_break] = ACTIONS(2962),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym__binary_minus] = ACTIONS(2962),
    [sym__binary_star] = ACTIONS(2962),
    [sym__binary_star_star] = ACTIONS(2962),
    [sym__element_reference_bracket] = ACTIONS(2962),
  },
  [2124] = {
    [sym__pattern_primitive] = STATE(4369),
    [sym__pattern_lambda] = STATE(4348),
    [sym__pattern_literal] = STATE(4348),
    [sym__keyword_variable] = STATE(4338),
    [sym_unary_literal] = STATE(4327),
    [sym__literal] = STATE(4338),
    [sym__numeric] = STATE(4352),
    [sym__simple_numeric] = STATE(4327),
    [sym__int_or_float] = STATE(5480),
    [sym_complex] = STATE(4340),
    [sym_rational] = STATE(4340),
    [sym_nil] = STATE(4311),
    [sym_string] = STATE(4338),
    [sym_subshell] = STATE(4338),
    [sym_string_array] = STATE(4338),
    [sym_symbol_array] = STATE(4338),
    [sym_delimited_symbol] = STATE(4352),
    [sym_regex] = STATE(4338),
    [sym_heredoc_body] = STATE(2124),
    [sym_lambda] = STATE(4345),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_RPAREN] = ACTIONS(3070),
    [anon_sym_end] = ACTIONS(3070),
    [anon_sym_rescue] = ACTIONS(3070),
    [anon_sym_COMMA] = ACTIONS(3070),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3070),
    [anon_sym_unless] = ACTIONS(3070),
    [anon_sym_while] = ACTIONS(3070),
    [anon_sym_until] = ACTIONS(3070),
    [anon_sym_in] = ACTIONS(3070),
    [anon_sym_do] = ACTIONS(3070),
    [anon_sym_when] = ACTIONS(3070),
    [anon_sym_EQ_GT] = ACTIONS(3070),
    [sym_line] = ACTIONS(3074),
    [sym_file] = ACTIONS(3074),
    [sym_encoding] = ACTIONS(3074),
    [anon_sym_elsif] = ACTIONS(3070),
    [anon_sym_else] = ACTIONS(3070),
    [anon_sym_then] = ACTIONS(3070),
    [anon_sym_ensure] = ACTIONS(3070),
    [anon_sym_and] = ACTIONS(3070),
    [anon_sym_or] = ACTIONS(3070),
    [anon_sym_PLUS] = ACTIONS(2770),
    [sym_comment] = ACTIONS(81),
    [sym_integer] = ACTIONS(2772),
    [sym_float] = ACTIONS(2772),
    [sym_self] = ACTIONS(3074),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [anon_sym_DASH_GT] = ACTIONS(3076),
    [sym__line_break] = ACTIONS(3070),
    [sym_simple_symbol] = ACTIONS(2778),
    [sym__string_start] = ACTIONS(2780),
    [sym__symbol_start] = ACTIONS(2782),
    [sym__subshell_start] = ACTIONS(2784),
    [sym__regex_start] = ACTIONS(2786),
    [sym__string_array_start] = ACTIONS(2788),
    [sym__symbol_array_start] = ACTIONS(2790),
    [sym__heredoc_body_start] = ACTIONS(5),
    [sym_heredoc_beginning] = ACTIONS(2792),
    [sym__unary_minus_num] = ACTIONS(2770),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    ACTIONS(3080), 1,
      anon_sym_do,
    STATE(2125), 1,
      sym_heredoc_body,
    STATE(2775), 1,
      sym_argument_list,
    STATE(2976), 1,
      sym_do_block,
    STATE(2977), 1,
      sym_block,
    ACTIONS(129), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    ACTIONS(3080), 1,
      anon_sym_do,
    STATE(2126), 1,
      sym_heredoc_body,
    STATE(2758), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_do_block,
    STATE(2961), 1,
      sym_block,
    ACTIONS(179), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(177), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [174] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(3082), 1,
      anon_sym_EQ,
    STATE(2127), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3084), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [256] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2928), 1,
      anon_sym_COLON,
    STATE(2128), 1,
      sym_heredoc_body,
    ACTIONS(2956), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [334] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3086), 1,
      anon_sym_EQ,
    STATE(2129), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3088), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [414] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3090), 1,
      anon_sym_EQ,
    STATE(2130), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3092), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [494] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(3094), 1,
      anon_sym_EQ,
    STATE(2131), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3096), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2132), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [650] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3098), 1,
      anon_sym_EQ,
    STATE(2133), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3100), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [730] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2914), 1,
      anon_sym_COLON_COLON,
    STATE(2134), 1,
      sym_heredoc_body,
    ACTIONS(2916), 2,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2912), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2910), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [808] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3102), 1,
      anon_sym_EQ,
    STATE(2135), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3104), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [888] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(3106), 1,
      anon_sym_EQ,
    STATE(2136), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3108), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 17,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [970] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1694), 1,
      anon_sym_CARET,
    ACTIONS(2748), 1,
      sym_identifier,
    ACTIONS(2750), 1,
      anon_sym_LBRACE,
    ACTIONS(2754), 1,
      anon_sym_LPAREN,
    ACTIONS(2756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2760), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2764), 1,
      anon_sym_nil,
    ACTIONS(2766), 1,
      anon_sym_LBRACK,
    ACTIONS(2768), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2774), 1,
      sym_constant,
    ACTIONS(2776), 1,
      anon_sym_DASH_GT,
    ACTIONS(2778), 1,
      sym_simple_symbol,
    ACTIONS(2780), 1,
      sym__string_start,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(2784), 1,
      sym__subshell_start,
    ACTIONS(2786), 1,
      sym__regex_start,
    ACTIONS(2788), 1,
      sym__string_array_start,
    ACTIONS(2790), 1,
      sym__symbol_array_start,
    ACTIONS(2792), 1,
      sym_heredoc_beginning,
    STATE(2137), 1,
      sym_heredoc_body,
    STATE(4229), 1,
      sym__pattern_constant,
    STATE(4230), 1,
      sym__pattern_constant_resolution,
    STATE(4311), 1,
      sym_nil,
    STATE(4345), 1,
      sym_lambda,
    STATE(4370), 1,
      sym__pattern_range,
    STATE(4372), 1,
      sym__pattern_expr_basic,
    STATE(4402), 1,
      sym__pattern_primitive,
    STATE(5480), 1,
      sym__int_or_float,
    ACTIONS(2770), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2772), 2,
      sym_integer,
      sym_float,
    STATE(4327), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4340), 2,
      sym_complex,
      sym_rational,
    STATE(4348), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4352), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4376), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4379), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(1692), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4338), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [1113] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1756), 1,
      anon_sym_CARET,
    ACTIONS(2748), 1,
      sym_identifier,
    ACTIONS(2750), 1,
      anon_sym_LBRACE,
    ACTIONS(2754), 1,
      anon_sym_LPAREN,
    ACTIONS(2756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2764), 1,
      anon_sym_nil,
    ACTIONS(2766), 1,
      anon_sym_LBRACK,
    ACTIONS(2774), 1,
      sym_constant,
    ACTIONS(2776), 1,
      anon_sym_DASH_GT,
    ACTIONS(2778), 1,
      sym_simple_symbol,
    ACTIONS(2780), 1,
      sym__string_start,
    ACTIONS(2784), 1,
      sym__subshell_start,
    ACTIONS(2786), 1,
      sym__regex_start,
    ACTIONS(2788), 1,
      sym__string_array_start,
    ACTIONS(2790), 1,
      sym__symbol_array_start,
    ACTIONS(2792), 1,
      sym_heredoc_beginning,
    ACTIONS(2864), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2870), 1,
      sym__symbol_start,
    STATE(2138), 1,
      sym_heredoc_body,
    STATE(4229), 1,
      sym__pattern_constant,
    STATE(4230), 1,
      sym__pattern_constant_resolution,
    STATE(4311), 1,
      sym_nil,
    STATE(4345), 1,
      sym_lambda,
    STATE(4370), 1,
      sym__pattern_range,
    STATE(4372), 1,
      sym__pattern_expr_basic,
    STATE(4510), 1,
      sym__pattern_primitive,
    STATE(5480), 1,
      sym__int_or_float,
    ACTIONS(2770), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2772), 2,
      sym_integer,
      sym_float,
    STATE(4327), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4340), 2,
      sym_complex,
      sym_rational,
    STATE(4348), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4352), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4376), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4379), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(1692), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4338), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [1256] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2139), 1,
      sym_heredoc_body,
    ACTIONS(2930), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2140), 1,
      sym_heredoc_body,
    ACTIONS(2572), 2,
      anon_sym_LBRACE,
      anon_sym_LPAREN2,
    ACTIONS(2570), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2568), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1406] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(2898), 1,
      anon_sym_LBRACE,
    STATE(2141), 1,
      sym_heredoc_body,
    STATE(2180), 1,
      sym_argument_list,
    STATE(2267), 1,
      sym_block,
    STATE(2300), 1,
      sym_do_block,
    ACTIONS(413), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1489] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(2898), 1,
      anon_sym_LBRACE,
    ACTIONS(2900), 1,
      anon_sym_do,
    STATE(2142), 1,
      sym_heredoc_body,
    STATE(2179), 1,
      sym_argument_list,
    STATE(2267), 1,
      sym_block,
    STATE(2300), 1,
      sym_do_block,
    ACTIONS(413), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1574] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_CARET,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2812), 1,
      anon_sym_nil,
    ACTIONS(2814), 1,
      anon_sym_LBRACK,
    ACTIONS(2830), 1,
      anon_sym_DASH_GT,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(2874), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2906), 1,
      sym_constant,
    STATE(2143), 1,
      sym_heredoc_body,
    STATE(4588), 1,
      sym__pattern_constant,
    STATE(4590), 1,
      sym__pattern_constant_resolution,
    STATE(4648), 1,
      sym_lambda,
    STATE(4662), 1,
      sym_nil,
    STATE(4688), 1,
      sym__pattern_primitive,
    STATE(4704), 1,
      sym__pattern_range,
    STATE(4722), 1,
      sym__pattern_expr_basic,
    STATE(5423), 1,
      sym__int_or_float,
    ACTIONS(2878), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2880), 2,
      sym_integer,
      sym_float,
    STATE(4651), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4659), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4666), 2,
      sym_complex,
      sym_rational,
    STATE(4668), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4728), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4756), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(655), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4658), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [1717] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_CARET,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_LPAREN,
    ACTIONS(2806), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2808), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2812), 1,
      anon_sym_nil,
    ACTIONS(2814), 1,
      anon_sym_LBRACK,
    ACTIONS(2818), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2830), 1,
      anon_sym_DASH_GT,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2906), 1,
      sym_constant,
    STATE(2144), 1,
      sym_heredoc_body,
    STATE(4588), 1,
      sym__pattern_constant,
    STATE(4590), 1,
      sym__pattern_constant_resolution,
    STATE(4648), 1,
      sym_lambda,
    STATE(4662), 1,
      sym_nil,
    STATE(4677), 1,
      sym__pattern_primitive,
    STATE(4704), 1,
      sym__pattern_range,
    STATE(4722), 1,
      sym__pattern_expr_basic,
    STATE(5423), 1,
      sym__int_or_float,
    ACTIONS(2820), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2822), 2,
      sym_integer,
      sym_float,
    STATE(4651), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4659), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4666), 2,
      sym_complex,
      sym_rational,
    STATE(4668), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4728), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4756), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(655), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4658), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [1860] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2914), 1,
      anon_sym_COLON_COLON,
    STATE(2145), 1,
      sym_heredoc_body,
    ACTIONS(2916), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2912), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2910), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [1937] = 40,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1694), 1,
      anon_sym_CARET,
    ACTIONS(2748), 1,
      sym_identifier,
    ACTIONS(2750), 1,
      anon_sym_LBRACE,
    ACTIONS(2754), 1,
      anon_sym_LPAREN,
    ACTIONS(2756), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2764), 1,
      anon_sym_nil,
    ACTIONS(2766), 1,
      anon_sym_LBRACK,
    ACTIONS(2774), 1,
      sym_constant,
    ACTIONS(2776), 1,
      anon_sym_DASH_GT,
    ACTIONS(2778), 1,
      sym_simple_symbol,
    ACTIONS(2780), 1,
      sym__string_start,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(2784), 1,
      sym__subshell_start,
    ACTIONS(2786), 1,
      sym__regex_start,
    ACTIONS(2788), 1,
      sym__string_array_start,
    ACTIONS(2790), 1,
      sym__symbol_array_start,
    ACTIONS(2792), 1,
      sym_heredoc_beginning,
    ACTIONS(2852), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2856), 1,
      anon_sym_DOT_DOT,
    STATE(2146), 1,
      sym_heredoc_body,
    STATE(4229), 1,
      sym__pattern_constant,
    STATE(4230), 1,
      sym__pattern_constant_resolution,
    STATE(4311), 1,
      sym_nil,
    STATE(4345), 1,
      sym_lambda,
    STATE(4370), 1,
      sym__pattern_range,
    STATE(4372), 1,
      sym__pattern_expr_basic,
    STATE(4606), 1,
      sym__pattern_primitive,
    STATE(5480), 1,
      sym__int_or_float,
    ACTIONS(2858), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2860), 2,
      sym_integer,
      sym_float,
    STATE(4327), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4340), 2,
      sym_complex,
      sym_rational,
    STATE(4348), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4352), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4376), 2,
      sym_variable_reference_pattern,
      sym_expression_reference_pattern,
    STATE(4379), 5,
      sym_array_pattern,
      sym_find_pattern,
      sym_hash_pattern,
      sym_parenthesized_pattern,
      sym__pattern_value,
    ACTIONS(1692), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4338), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [2080] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    STATE(2147), 1,
      sym_heredoc_body,
    STATE(2154), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_string,
    ACTIONS(3112), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3110), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2148), 1,
      sym_heredoc_body,
    ACTIONS(2566), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2572), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2230] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2149), 1,
      sym_heredoc_body,
    ACTIONS(733), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2302] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2150), 1,
      sym_heredoc_body,
    ACTIONS(2572), 3,
      anon_sym_LBRACE,
      anon_sym_do,
      anon_sym_LPAREN2,
    ACTIONS(2570), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2568), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2151), 1,
      sym_heredoc_body,
    ACTIONS(2574), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2576), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2448] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2152), 1,
      sym_heredoc_body,
    ACTIONS(2578), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2580), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2153), 1,
      sym_heredoc_body,
    ACTIONS(2582), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2584), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2592] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3118), 1,
      sym__string_start,
    STATE(2203), 1,
      sym_string,
    STATE(2154), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3116), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3114), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2155), 1,
      sym_heredoc_body,
    ACTIONS(2562), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2564), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2156), 1,
      sym_heredoc_body,
    ACTIONS(2586), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2588), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2812] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2157), 1,
      sym_heredoc_body,
    ACTIONS(2590), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2592), 40,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3121), 1,
      anon_sym_EQ,
    STATE(2158), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3123), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [2962] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3125), 1,
      anon_sym_EQ_GT,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2159), 1,
      sym_heredoc_body,
    STATE(2203), 1,
      sym_string,
    ACTIONS(2964), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3042] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(3127), 1,
      anon_sym_EQ,
    STATE(2160), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3129), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3122] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3137), 1,
      anon_sym_ri,
    STATE(2161), 1,
      sym_heredoc_body,
    ACTIONS(3135), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3133), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3131), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3198] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_EQ,
    STATE(2162), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3141), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3278] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2163), 1,
      sym_heredoc_body,
    STATE(2203), 1,
      sym_string,
    ACTIONS(2964), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3356] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(3143), 1,
      anon_sym_EQ,
    STATE(2164), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3145), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3436] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3147), 1,
      anon_sym_EQ,
    STATE(2165), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3149), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3514] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3151), 1,
      anon_sym_EQ,
    STATE(2166), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3153), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3592] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3155), 1,
      anon_sym_EQ,
    STATE(2167), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3157), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3670] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    STATE(2168), 1,
      sym_heredoc_body,
    STATE(2944), 1,
      sym_do_block,
    STATE(2961), 1,
      sym_block,
    STATE(3045), 1,
      sym_argument_list,
    ACTIONS(179), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(177), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3752] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    STATE(2169), 1,
      sym_heredoc_body,
    STATE(2976), 1,
      sym_do_block,
    STATE(2977), 1,
      sym_block,
    STATE(3068), 1,
      sym_argument_list,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3834] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2926), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3159), 1,
      anon_sym_COLON,
    STATE(2170), 1,
      sym_heredoc_body,
    ACTIONS(2686), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3911] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2171), 1,
      sym_heredoc_body,
    STATE(2217), 1,
      sym_argument_list,
    ACTIONS(3163), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3161), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [3986] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2172), 1,
      sym_heredoc_body,
    ACTIONS(2586), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2588), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4057] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2173), 1,
      sym_heredoc_body,
    ACTIONS(2590), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2592), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4128] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2174), 1,
      sym_heredoc_body,
    ACTIONS(3167), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3165), 47,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4199] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2914), 1,
      anon_sym_COLON_COLON,
    STATE(2175), 1,
      sym_heredoc_body,
    ACTIONS(2916), 3,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2912), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2910), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4274] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2898), 1,
      anon_sym_LBRACE,
    ACTIONS(2900), 1,
      anon_sym_do,
    STATE(2176), 1,
      sym_heredoc_body,
    STATE(2346), 1,
      sym_do_block,
    STATE(2350), 1,
      sym_block,
    ACTIONS(3171), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3169), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2177), 1,
      sym_heredoc_body,
    ACTIONS(2946), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2944), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4424] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2898), 1,
      anon_sym_LBRACE,
    STATE(2178), 1,
      sym_heredoc_body,
    STATE(2246), 1,
      sym_do_block,
    STATE(2342), 1,
      sym_block,
    ACTIONS(3175), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3173), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4501] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2898), 1,
      anon_sym_LBRACE,
    ACTIONS(2900), 1,
      anon_sym_do,
    STATE(2179), 1,
      sym_heredoc_body,
    STATE(2236), 1,
      sym_do_block,
    STATE(2338), 1,
      sym_block,
    ACTIONS(3179), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3177), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4580] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2898), 1,
      anon_sym_LBRACE,
    STATE(2180), 1,
      sym_heredoc_body,
    STATE(2236), 1,
      sym_do_block,
    STATE(2338), 1,
      sym_block,
    ACTIONS(3179), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3177), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4657] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2181), 1,
      sym_heredoc_body,
    STATE(2313), 1,
      sym_argument_list,
    ACTIONS(421), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(419), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4732] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2182), 1,
      sym_heredoc_body,
    ACTIONS(3183), 10,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3181), 47,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4803] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2898), 1,
      anon_sym_LBRACE,
    STATE(2183), 1,
      sym_heredoc_body,
    STATE(2346), 1,
      sym_do_block,
    STATE(2350), 1,
      sym_block,
    ACTIONS(3171), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3169), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4880] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2184), 1,
      sym_heredoc_body,
    STATE(2333), 1,
      sym_argument_list,
    ACTIONS(425), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(423), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [4955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2185), 1,
      sym_heredoc_body,
    ACTIONS(2912), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2910), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5026] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2186), 1,
      sym_heredoc_body,
    STATE(2250), 1,
      sym_argument_list,
    ACTIONS(429), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(427), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5101] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2187), 1,
      sym_heredoc_body,
    ACTIONS(2942), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2940), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5172] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2898), 1,
      anon_sym_LBRACE,
    ACTIONS(2900), 1,
      anon_sym_do,
    STATE(2188), 1,
      sym_heredoc_body,
    STATE(2246), 1,
      sym_do_block,
    STATE(2342), 1,
      sym_block,
    ACTIONS(3175), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3173), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5251] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2926), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3185), 1,
      anon_sym_COLON,
    STATE(2189), 1,
      sym_heredoc_body,
    ACTIONS(2686), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2190), 1,
      sym_heredoc_body,
    ACTIONS(2934), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2932), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2191), 1,
      sym_heredoc_body,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5470] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2192), 1,
      sym_heredoc_body,
    STATE(2299), 1,
      sym_argument_list,
    ACTIONS(3189), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3187), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2193), 1,
      sym_heredoc_body,
    ACTIONS(129), 18,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 39,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5616] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2194), 1,
      sym_heredoc_body,
    STATE(2327), 1,
      sym_argument_list,
    ACTIONS(417), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(415), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2195), 1,
      sym_heredoc_body,
    ACTIONS(2930), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5763] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2196), 1,
      sym_heredoc_body,
    ACTIONS(2582), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2584), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5833] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3191), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2197), 1,
      sym_heredoc_body,
    STATE(2203), 1,
      sym_string,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5911] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3193), 1,
      anon_sym_EQ,
    STATE(2198), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3195), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [5987] = 27,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2778), 1,
      sym_simple_symbol,
    ACTIONS(2780), 1,
      sym__string_start,
    ACTIONS(2784), 1,
      sym__subshell_start,
    ACTIONS(2786), 1,
      sym__regex_start,
    ACTIONS(2788), 1,
      sym__string_array_start,
    ACTIONS(2790), 1,
      sym__symbol_array_start,
    ACTIONS(2792), 1,
      sym_heredoc_beginning,
    ACTIONS(2870), 1,
      sym__symbol_start,
    ACTIONS(3072), 1,
      anon_sym_nil,
    ACTIONS(3076), 1,
      anon_sym_DASH_GT,
    ACTIONS(3197), 1,
      anon_sym___END__,
    STATE(2199), 1,
      sym_heredoc_body,
    STATE(4311), 1,
      sym_nil,
    STATE(4345), 1,
      sym_lambda,
    STATE(4369), 1,
      sym__pattern_primitive,
    STATE(5480), 1,
      sym__int_or_float,
    ACTIONS(2770), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2772), 2,
      sym_integer,
      sym_float,
    STATE(4327), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4340), 2,
      sym_complex,
      sym_rational,
    STATE(4348), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4352), 2,
      sym__numeric,
      sym_delimited_symbol,
    ACTIONS(3074), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4338), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3070), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [6101] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2926), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3199), 1,
      anon_sym_COLON,
    STATE(2200), 1,
      sym_heredoc_body,
    ACTIONS(2686), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6177] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2201), 1,
      sym_heredoc_body,
    ACTIONS(2578), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2580), 47,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6247] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3125), 1,
      anon_sym_EQ_GT,
    ACTIONS(3201), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2202), 1,
      sym_heredoc_body,
    STATE(2203), 1,
      sym_string,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6327] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2203), 1,
      sym_heredoc_body,
    ACTIONS(3205), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3203), 47,
      sym__line_break,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6397] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2204), 1,
      sym_heredoc_body,
    ACTIONS(3209), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3207), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6466] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2205), 1,
      sym_heredoc_body,
    ACTIONS(3213), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3211), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6535] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2206), 1,
      sym_heredoc_body,
    ACTIONS(3217), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3215), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6604] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2207), 1,
      sym_heredoc_body,
    ACTIONS(3221), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3219), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6673] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym_heredoc_body,
    ACTIONS(3225), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3223), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6742] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2209), 1,
      sym_heredoc_body,
    ACTIONS(3229), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3227), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6811] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2210), 1,
      sym_heredoc_body,
    ACTIONS(3233), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3231), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6880] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2211), 1,
      sym_heredoc_body,
    ACTIONS(3237), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3235), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [6949] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2212), 1,
      sym_heredoc_body,
    ACTIONS(3241), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3239), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7018] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2213), 1,
      sym_heredoc_body,
    ACTIONS(3245), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3243), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7087] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2214), 1,
      sym_heredoc_body,
    ACTIONS(3249), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3247), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7156] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2215), 1,
      sym_heredoc_body,
    ACTIONS(3253), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3251), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7225] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2216), 1,
      sym_heredoc_body,
    ACTIONS(3257), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3255), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7294] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2217), 1,
      sym_heredoc_body,
    ACTIONS(3261), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3259), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7363] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2218), 1,
      sym_heredoc_body,
    ACTIONS(3265), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3263), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7432] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2219), 1,
      sym_heredoc_body,
    ACTIONS(3269), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3267), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7501] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3125), 1,
      anon_sym_EQ_GT,
    STATE(2220), 1,
      sym_heredoc_body,
    ACTIONS(2964), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7572] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2221), 1,
      sym_heredoc_body,
    ACTIONS(3273), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3271), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7641] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2222), 1,
      sym_heredoc_body,
    ACTIONS(3277), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3275), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7710] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2223), 1,
      sym_heredoc_body,
    ACTIONS(3281), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3279), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7779] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2224), 1,
      sym_heredoc_body,
    ACTIONS(3285), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3283), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7848] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2225), 1,
      sym_heredoc_body,
    ACTIONS(3289), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3287), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7917] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2226), 1,
      sym_heredoc_body,
    ACTIONS(3293), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3291), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [7986] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2227), 1,
      sym_heredoc_body,
    ACTIONS(3297), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3295), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8055] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2228), 1,
      sym_heredoc_body,
    ACTIONS(3133), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3131), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8124] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2229), 1,
      sym_heredoc_body,
    ACTIONS(3301), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3299), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8193] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2230), 1,
      sym_heredoc_body,
    ACTIONS(3305), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3303), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8262] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2956), 1,
      anon_sym_EQ_GT,
    ACTIONS(3185), 1,
      anon_sym_COLON,
    STATE(2231), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8335] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2232), 1,
      sym_heredoc_body,
    ACTIONS(3309), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3307), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8404] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2233), 1,
      sym_heredoc_body,
    ACTIONS(3313), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3311), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8473] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2234), 1,
      sym_heredoc_body,
    ACTIONS(3317), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3315), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8542] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3319), 1,
      anon_sym_EQ,
    STATE(2235), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3321), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8617] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2236), 1,
      sym_heredoc_body,
    ACTIONS(3325), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3323), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8686] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2237), 1,
      sym_heredoc_body,
    ACTIONS(3329), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3327), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8755] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2238), 1,
      sym_heredoc_body,
    ACTIONS(3333), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3331), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8824] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3339), 1,
      anon_sym_EQ_GT,
    STATE(2239), 1,
      sym_heredoc_body,
    ACTIONS(3337), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3335), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8895] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2572), 1,
      anon_sym_LPAREN2,
    STATE(2240), 1,
      sym_heredoc_body,
    ACTIONS(2570), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2568), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [8966] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3341), 1,
      anon_sym_EQ_GT,
    STATE(2241), 1,
      sym_heredoc_body,
    ACTIONS(2964), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9037] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2242), 1,
      sym_heredoc_body,
    ACTIONS(3345), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3343), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9106] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2243), 1,
      sym_heredoc_body,
    ACTIONS(3349), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3347), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9175] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2244), 1,
      sym_heredoc_body,
    ACTIONS(3353), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3351), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9244] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2245), 1,
      sym_heredoc_body,
    ACTIONS(3357), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3355), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9313] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2246), 1,
      sym_heredoc_body,
    ACTIONS(3361), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3359), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9382] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2247), 1,
      sym_heredoc_body,
    ACTIONS(3365), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3363), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9451] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2248), 1,
      sym_heredoc_body,
    ACTIONS(3369), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3367), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9520] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2249), 1,
      sym_heredoc_body,
    ACTIONS(3373), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3371), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9589] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2250), 1,
      sym_heredoc_body,
    ACTIONS(3377), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3375), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9658] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2251), 1,
      sym_heredoc_body,
    ACTIONS(3381), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3379), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9727] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2252), 1,
      sym_heredoc_body,
    ACTIONS(3385), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3383), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9796] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2930), 1,
      anon_sym_EQ_GT,
    STATE(2253), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 37,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9867] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2254), 1,
      sym_heredoc_body,
    ACTIONS(3389), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3387), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [9936] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2255), 1,
      sym_heredoc_body,
    ACTIONS(3393), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3391), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10005] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2256), 1,
      sym_heredoc_body,
    ACTIONS(3397), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3395), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10074] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3399), 1,
      anon_sym_EQ,
    STATE(2257), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3401), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10149] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3403), 1,
      anon_sym_EQ,
    STATE(2258), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3405), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10224] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2259), 1,
      sym_heredoc_body,
    ACTIONS(2964), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10293] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2260), 1,
      sym_heredoc_body,
    ACTIONS(3409), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3407), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10362] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2261), 1,
      sym_heredoc_body,
    ACTIONS(3413), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3411), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10431] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2262), 1,
      sym_heredoc_body,
    ACTIONS(3417), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3415), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10500] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3419), 1,
      anon_sym_EQ,
    STATE(2263), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3421), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10575] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2264), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10644] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2265), 1,
      sym_heredoc_body,
    ACTIONS(3429), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3427), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10713] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3431), 1,
      anon_sym_EQ,
    STATE(2266), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3433), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10788] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2267), 1,
      sym_heredoc_body,
    ACTIONS(3437), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3435), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10857] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3443), 1,
      anon_sym_DOT,
    ACTIONS(3445), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(3447), 1,
      anon_sym_AMP_DOT,
    ACTIONS(3449), 1,
      sym__element_reference_bracket,
    STATE(2268), 1,
      sym_heredoc_body,
    ACTIONS(3441), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [10934] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2269), 1,
      sym_heredoc_body,
    ACTIONS(3453), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3451), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11003] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2270), 1,
      sym_heredoc_body,
    ACTIONS(3457), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3455), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11072] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2271), 1,
      sym_heredoc_body,
    ACTIONS(3461), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3459), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11141] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3463), 1,
      anon_sym_EQ,
    STATE(2272), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3465), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11216] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3467), 1,
      anon_sym_EQ,
    STATE(2273), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3469), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11291] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2274), 1,
      sym_heredoc_body,
    ACTIONS(3473), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3471), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11360] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2275), 1,
      sym_heredoc_body,
    ACTIONS(3477), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3475), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11429] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2276), 1,
      sym_heredoc_body,
    ACTIONS(3481), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3479), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11498] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2277), 1,
      sym_heredoc_body,
    ACTIONS(3485), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3483), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11567] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2278), 1,
      sym_heredoc_body,
    ACTIONS(3489), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3487), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11636] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2279), 1,
      sym_heredoc_body,
    ACTIONS(3493), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3491), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11705] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2280), 1,
      sym_heredoc_body,
    ACTIONS(3497), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3495), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11774] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_EQ_GT,
    STATE(2281), 1,
      sym_heredoc_body,
    ACTIONS(3501), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3499), 45,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11845] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2282), 1,
      sym_heredoc_body,
    ACTIONS(3507), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3505), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11914] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2283), 1,
      sym_heredoc_body,
    ACTIONS(3511), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3509), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [11983] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2284), 1,
      sym_heredoc_body,
    ACTIONS(3515), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3513), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12052] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2285), 1,
      sym_heredoc_body,
    ACTIONS(3519), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3517), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12121] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2286), 1,
      sym_heredoc_body,
    ACTIONS(3523), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12190] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2287), 1,
      sym_heredoc_body,
    ACTIONS(3527), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3525), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12259] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2288), 1,
      sym_heredoc_body,
    ACTIONS(3531), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3529), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12328] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2289), 1,
      sym_heredoc_body,
    ACTIONS(3535), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3533), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12397] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2290), 1,
      sym_heredoc_body,
    ACTIONS(3539), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3537), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12466] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2291), 1,
      sym_heredoc_body,
    ACTIONS(3543), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12535] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2292), 1,
      sym_heredoc_body,
    ACTIONS(3547), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3545), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12604] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2293), 1,
      sym_heredoc_body,
    ACTIONS(3551), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3549), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12673] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2294), 1,
      sym_heredoc_body,
    ACTIONS(3555), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3553), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12742] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2295), 1,
      sym_heredoc_body,
    ACTIONS(3559), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12811] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2296), 1,
      sym_heredoc_body,
    ACTIONS(3563), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3561), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12880] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2297), 1,
      sym_heredoc_body,
    ACTIONS(3567), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3565), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [12949] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2298), 1,
      sym_heredoc_body,
    ACTIONS(3571), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3569), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13018] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2299), 1,
      sym_heredoc_body,
    ACTIONS(3575), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3573), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13087] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2300), 1,
      sym_heredoc_body,
    ACTIONS(3437), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3435), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13156] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2301), 1,
      sym_heredoc_body,
    ACTIONS(3579), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3577), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13225] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2302), 1,
      sym_heredoc_body,
    ACTIONS(3583), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3581), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13294] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2303), 1,
      sym_heredoc_body,
    ACTIONS(3587), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13363] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2304), 1,
      sym_heredoc_body,
    ACTIONS(3591), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3589), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13432] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2305), 1,
      sym_heredoc_body,
    ACTIONS(3595), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3593), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13501] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2306), 1,
      sym_heredoc_body,
    ACTIONS(3599), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3597), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13570] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2307), 1,
      sym_heredoc_body,
    ACTIONS(3603), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3601), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13639] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2308), 1,
      sym_heredoc_body,
    ACTIONS(3607), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3605), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13708] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2309), 1,
      sym_heredoc_body,
    ACTIONS(3611), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3609), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13777] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2310), 1,
      sym_heredoc_body,
    ACTIONS(3615), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3613), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13846] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2311), 1,
      sym_heredoc_body,
    ACTIONS(3619), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3617), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13915] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2312), 1,
      sym_heredoc_body,
    ACTIONS(3623), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3621), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [13984] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2313), 1,
      sym_heredoc_body,
    ACTIONS(3627), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3625), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14053] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2314), 1,
      sym_heredoc_body,
    ACTIONS(3631), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3629), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14122] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2315), 1,
      sym_heredoc_body,
    ACTIONS(3635), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3633), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14191] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2316), 1,
      sym_heredoc_body,
    ACTIONS(3639), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3637), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14260] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2317), 1,
      sym_heredoc_body,
    ACTIONS(3643), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3641), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14329] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2318), 1,
      sym_heredoc_body,
    ACTIONS(3647), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3645), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14398] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2319), 1,
      sym_heredoc_body,
    ACTIONS(3651), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3649), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14467] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2320), 1,
      sym_heredoc_body,
    ACTIONS(3655), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3653), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14536] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2321), 1,
      sym_heredoc_body,
    ACTIONS(3659), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3657), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14605] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2322), 1,
      sym_heredoc_body,
    ACTIONS(3663), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14674] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2323), 1,
      sym_heredoc_body,
    ACTIONS(3337), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3335), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14743] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2324), 1,
      sym_heredoc_body,
    ACTIONS(3667), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3665), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14812] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2325), 1,
      sym_heredoc_body,
    ACTIONS(3671), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3669), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14881] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2326), 1,
      sym_heredoc_body,
    ACTIONS(3675), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3673), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [14950] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2327), 1,
      sym_heredoc_body,
    ACTIONS(3679), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3677), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15019] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2328), 1,
      sym_heredoc_body,
    ACTIONS(3683), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3681), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15088] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2329), 1,
      sym_heredoc_body,
    ACTIONS(3687), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3685), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15157] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2330), 1,
      sym_heredoc_body,
    ACTIONS(3687), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3685), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15226] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2331), 1,
      sym_heredoc_body,
    ACTIONS(3691), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3689), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15295] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2332), 1,
      sym_heredoc_body,
    ACTIONS(3695), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15364] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2333), 1,
      sym_heredoc_body,
    ACTIONS(3699), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3697), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15433] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2334), 1,
      sym_heredoc_body,
    ACTIONS(3703), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3701), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15502] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2335), 1,
      sym_heredoc_body,
    ACTIONS(3707), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3705), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15571] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2336), 1,
      sym_heredoc_body,
    ACTIONS(3711), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3709), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15640] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2337), 1,
      sym_heredoc_body,
    ACTIONS(3715), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3713), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15709] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2338), 1,
      sym_heredoc_body,
    ACTIONS(3325), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3323), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15778] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2339), 1,
      sym_heredoc_body,
    ACTIONS(3695), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15847] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2340), 1,
      sym_heredoc_body,
    ACTIONS(3501), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3499), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15916] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2341), 1,
      sym_heredoc_body,
    ACTIONS(3719), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [15985] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2342), 1,
      sym_heredoc_body,
    ACTIONS(3361), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3359), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16054] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2343), 1,
      sym_heredoc_body,
    ACTIONS(3723), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3721), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16123] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2344), 1,
      sym_heredoc_body,
    ACTIONS(3727), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3725), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16192] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2345), 1,
      sym_heredoc_body,
    ACTIONS(3731), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3729), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16261] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2346), 1,
      sym_heredoc_body,
    ACTIONS(3735), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3733), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16330] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3737), 1,
      anon_sym_EQ,
    STATE(2347), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3739), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16405] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2348), 1,
      sym_heredoc_body,
    ACTIONS(3743), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3741), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16474] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2349), 1,
      sym_heredoc_body,
    ACTIONS(3747), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3745), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16543] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2350), 1,
      sym_heredoc_body,
    ACTIONS(3735), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3733), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16612] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2351), 1,
      sym_heredoc_body,
    ACTIONS(3499), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3695), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16683] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2956), 1,
      anon_sym_EQ_GT,
    ACTIONS(3159), 1,
      anon_sym_COLON,
    STATE(2352), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16756] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2353), 1,
      sym_heredoc_body,
    ACTIONS(3751), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3749), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16825] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2354), 1,
      sym_heredoc_body,
    ACTIONS(3755), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3753), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16894] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2355), 1,
      sym_heredoc_body,
    ACTIONS(3759), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3757), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [16963] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2356), 1,
      sym_heredoc_body,
    ACTIONS(3763), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3761), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17032] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2357), 1,
      sym_heredoc_body,
    ACTIONS(3767), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3765), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17101] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2358), 1,
      sym_heredoc_body,
    ACTIONS(3499), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(3695), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17172] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2359), 1,
      sym_heredoc_body,
    ACTIONS(3771), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3769), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17241] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2360), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17310] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2361), 1,
      sym_heredoc_body,
    ACTIONS(3779), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3777), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17379] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2362), 1,
      sym_heredoc_body,
    ACTIONS(3783), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3781), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17448] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2363), 1,
      sym_heredoc_body,
    ACTIONS(3787), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3785), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17517] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2364), 1,
      sym_heredoc_body,
    ACTIONS(3441), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17586] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2365), 1,
      sym_heredoc_body,
    ACTIONS(3791), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3789), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17655] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2366), 1,
      sym_heredoc_body,
    ACTIONS(3795), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3793), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17724] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2367), 1,
      sym_heredoc_body,
    ACTIONS(3799), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3797), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17793] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2368), 1,
      sym_heredoc_body,
    ACTIONS(3803), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3801), 46,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17862] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3805), 1,
      anon_sym_EQ,
    STATE(2369), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3807), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [17936] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3809), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_string,
    STATE(2370), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18012] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3811), 1,
      anon_sym_EQ,
    STATE(2371), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3813), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18086] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3815), 1,
      anon_sym_EQ,
    STATE(2372), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3817), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18160] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2930), 1,
      anon_sym_EQ_GT,
    STATE(2373), 1,
      sym_heredoc_body,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18230] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3819), 1,
      anon_sym_EQ,
    STATE(2374), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3821), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18304] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3823), 1,
      anon_sym_EQ,
    STATE(2375), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3825), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18378] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2956), 1,
      anon_sym_EQ_GT,
    ACTIONS(3199), 1,
      anon_sym_COLON,
    STATE(2376), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18450] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3827), 1,
      anon_sym_EQ,
    STATE(2377), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3829), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18524] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(3831), 1,
      anon_sym_EQ,
    STATE(2378), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3833), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18600] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3835), 1,
      anon_sym_EQ,
    STATE(2379), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3837), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18674] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2926), 1,
      anon_sym_COLON_COLON,
    STATE(2380), 1,
      sym_heredoc_body,
    ACTIONS(2686), 2,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [18746] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3841), 1,
      anon_sym_LPAREN,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    STATE(2381), 1,
      sym_heredoc_body,
    STATE(2870), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4484), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5500), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [18845] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3859), 1,
      anon_sym_LPAREN,
    STATE(2382), 1,
      sym_heredoc_body,
    STATE(2870), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5504), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [18944] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3861), 1,
      anon_sym_LPAREN,
    STATE(2383), 1,
      sym_heredoc_body,
    STATE(2870), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4481), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5491), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [19043] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2914), 1,
      anon_sym_COLON_COLON,
    STATE(2384), 1,
      sym_heredoc_body,
    ACTIONS(2916), 2,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
    ACTIONS(2912), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2910), 33,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19114] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3863), 1,
      anon_sym_LPAREN,
    STATE(2385), 1,
      sym_heredoc_body,
    STATE(2870), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4482), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5503), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [19213] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(3865), 1,
      anon_sym_EQ,
    STATE(2386), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3867), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 21,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19288] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(3869), 1,
      anon_sym_rescue,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2387), 1,
      sym_heredoc_body,
    STATE(2420), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [19391] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3903), 1,
      anon_sym_LPAREN,
    STATE(2388), 1,
      sym_heredoc_body,
    STATE(2870), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4475), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5496), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [19490] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2928), 1,
      anon_sym_COLON,
    STATE(2389), 1,
      sym_heredoc_body,
    ACTIONS(2582), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2584), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19559] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3905), 1,
      anon_sym_EQ,
    STATE(2390), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3907), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19632] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2928), 1,
      anon_sym_COLON,
    STATE(2391), 1,
      sym_heredoc_body,
    ACTIONS(2578), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2580), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2392), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 36,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19768] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3909), 1,
      anon_sym_EQ,
    STATE(2393), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3911), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [19841] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3913), 1,
      anon_sym_LPAREN,
    STATE(2394), 1,
      sym_heredoc_body,
    STATE(2870), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4465), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5489), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [19940] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3449), 1,
      sym__element_reference_bracket,
    ACTIONS(3915), 1,
      anon_sym_DOT,
    ACTIONS(3917), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(3919), 1,
      anon_sym_AMP_DOT,
    STATE(2395), 1,
      sym_heredoc_body,
    ACTIONS(3441), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20015] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2396), 1,
      sym_heredoc_body,
    STATE(2420), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 44,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20084] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(3921), 1,
      anon_sym_EQ,
    STATE(2397), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3923), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 21,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20159] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3925), 1,
      anon_sym_COMMA,
    STATE(2398), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [20228] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3928), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2399), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4485), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5523), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20327] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3930), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2400), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4483), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5525), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20426] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3932), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2401), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4476), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5528), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20525] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3934), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2402), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4486), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5530), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20624] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3936), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2403), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4487), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5532), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20723] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3938), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2404), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4467), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5534), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20822] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3940), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2405), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4471), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5536), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [20921] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3942), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2406), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4474), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5539), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21020] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3944), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2407), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4488), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5541), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21119] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3946), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2408), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4479), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5543), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21218] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3948), 1,
      anon_sym_LPAREN,
    STATE(2409), 1,
      sym_heredoc_body,
    STATE(2870), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4477), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5515), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21317] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3950), 1,
      anon_sym_EQ,
    STATE(2410), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3952), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21390] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3954), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2411), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4466), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5506), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21489] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3956), 1,
      anon_sym_LPAREN,
    STATE(2412), 1,
      sym_heredoc_body,
    STATE(2870), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4492), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5518), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21588] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(3958), 1,
      anon_sym_EQ,
    STATE(2413), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3960), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 21,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [21663] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3962), 1,
      anon_sym_LPAREN,
    STATE(2414), 1,
      sym_heredoc_body,
    STATE(2870), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4472), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5546), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21762] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3964), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2415), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4489), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5547), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21861] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3966), 1,
      anon_sym_LPAREN,
    STATE(2416), 1,
      sym_heredoc_body,
    STATE(2870), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4470), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5521), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [21960] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3968), 1,
      anon_sym_LPAREN,
    STATE(2293), 1,
      sym__method_rest,
    STATE(2417), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4480), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5537), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22059] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3839), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      sym_constant,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(3970), 1,
      anon_sym_LPAREN,
    STATE(2418), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4490), 1,
      sym__method_name,
    STATE(4699), 1,
      sym__nonlocal_variable,
    STATE(5299), 1,
      sym__method_rest,
    STATE(5493), 1,
      sym__variable,
    ACTIONS(3847), 2,
      sym_super,
      sym_self,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 4,
      sym__function_identifier,
      sym_operator,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [22158] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3972), 1,
      anon_sym_EQ,
    STATE(2419), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3974), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 22,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22231] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3980), 1,
      anon_sym_COMMA,
    STATE(2398), 1,
      aux_sym_exceptions_repeat1,
    STATE(2420), 1,
      sym_heredoc_body,
    ACTIONS(3978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22302] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2421), 1,
      sym_heredoc_body,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 40,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22372] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2422), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [22470] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    STATE(2423), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [22566] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3990), 1,
      sym__binary_star_star,
    STATE(2424), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22634] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2425), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22702] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3992), 1,
      anon_sym_EQ,
    STATE(2426), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(3994), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 21,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22774] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2427), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [22842] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    STATE(2428), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [22940] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_DOT,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2429), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [23038] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    STATE(2430), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [23136] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2431), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23204] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4004), 1,
      anon_sym_COLON,
    STATE(2432), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23272] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(3869), 1,
      anon_sym_rescue,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2433), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [23372] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2434), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 36,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23448] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2435), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 36,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23522] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4006), 1,
      anon_sym_EQ,
    STATE(2436), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4008), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 20,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23596] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2688), 1,
      anon_sym_COLON,
    STATE(2437), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23664] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2438), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 28,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [23754] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2439), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 29,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [23842] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2440), 1,
      sym_heredoc_body,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 38,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [23914] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(3869), 1,
      anon_sym_rescue,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2441), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [24014] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    STATE(2442), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [24112] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4010), 1,
      anon_sym_EQ,
    STATE(2443), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4012), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 20,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24186] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2444), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 29,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [24274] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2445), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24342] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4018), 1,
      anon_sym_EQ,
    STATE(2446), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4020), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 20,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24416] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    STATE(2447), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [24514] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2448), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [24612] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4026), 1,
      anon_sym_EQ,
    STATE(2449), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4028), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 21,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24684] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    STATE(2450), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [24780] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3449), 1,
      sym__element_reference_bracket,
    ACTIONS(4034), 1,
      anon_sym_DOT,
    ACTIONS(4036), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4038), 1,
      anon_sym_AMP_DOT,
    STATE(2451), 1,
      sym_heredoc_body,
    ACTIONS(3441), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2956), 1,
      anon_sym_EQ_GT,
    STATE(2452), 1,
      sym_heredoc_body,
    ACTIONS(733), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24922] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4040), 1,
      sym__binary_star_star,
    STATE(2453), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [24990] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    STATE(2454), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 35,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25070] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4042), 1,
      anon_sym_rescue,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2455), 1,
      sym_heredoc_body,
    STATE(2462), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [25171] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4076), 1,
      anon_sym_EQ,
    STATE(2456), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4078), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 19,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25244] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4080), 1,
      anon_sym_COMMA,
    STATE(2457), 1,
      sym_heredoc_body,
    STATE(2462), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25313] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4082), 1,
      anon_sym_EQ,
    STATE(2458), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4084), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 20,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25384] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4086), 1,
      anon_sym_EQ,
    STATE(2459), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4088), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 20,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25455] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2460), 1,
      sym_heredoc_body,
    STATE(2462), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 42,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25522] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2778), 1,
      sym_simple_symbol,
    ACTIONS(2780), 1,
      sym__string_start,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(2784), 1,
      sym__subshell_start,
    ACTIONS(2786), 1,
      sym__regex_start,
    ACTIONS(2788), 1,
      sym__string_array_start,
    ACTIONS(2790), 1,
      sym__symbol_array_start,
    ACTIONS(2792), 1,
      sym_heredoc_beginning,
    ACTIONS(3072), 1,
      anon_sym_nil,
    ACTIONS(3076), 1,
      anon_sym_DASH_GT,
    STATE(2461), 1,
      sym_heredoc_body,
    STATE(4311), 1,
      sym_nil,
    STATE(4345), 1,
      sym_lambda,
    STATE(4369), 1,
      sym__pattern_primitive,
    STATE(5480), 1,
      sym__int_or_float,
    ACTIONS(2858), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2860), 2,
      sym_integer,
      sym_float,
    STATE(4327), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4340), 2,
      sym_complex,
      sym_rational,
    STATE(4348), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4352), 2,
      sym__numeric,
      sym_delimited_symbol,
    ACTIONS(3074), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4338), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3070), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [25629] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4080), 1,
      anon_sym_COMMA,
    STATE(2462), 1,
      sym_heredoc_body,
    STATE(2470), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25698] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4090), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_string,
    STATE(2463), 1,
      sym_heredoc_body,
    ACTIONS(2964), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25771] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2464), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25836] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym_heredoc_body,
    ACTIONS(3225), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3223), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25901] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4092), 1,
      anon_sym_EQ,
    STATE(2466), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4094), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 19,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [25974] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4096), 1,
      anon_sym_EQ,
    STATE(2467), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4098), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 19,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26047] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2468), 1,
      sym_heredoc_body,
    ACTIONS(3527), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3525), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26112] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    ACTIONS(4080), 1,
      anon_sym_COMMA,
    ACTIONS(4100), 1,
      anon_sym_rescue,
    STATE(2462), 1,
      aux_sym_exceptions_repeat1,
    STATE(2469), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [26215] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4102), 1,
      anon_sym_COMMA,
    STATE(2470), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26282] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4105), 1,
      anon_sym_EQ,
    STATE(2471), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4107), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 19,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26355] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2472), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26420] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2473), 1,
      sym_heredoc_body,
    ACTIONS(3441), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26485] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2474), 1,
      sym_heredoc_body,
    ACTIONS(3587), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26550] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4109), 1,
      anon_sym_EQ,
    STATE(2475), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4111), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 16,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 19,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26623] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2476), 1,
      sym_heredoc_body,
    ACTIONS(3747), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3745), 43,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26688] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2477), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26754] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(2478), 1,
      sym_heredoc_body,
    ACTIONS(129), 17,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(123), 33,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26818] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2479), 1,
      sym_heredoc_body,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 38,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26886] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4113), 1,
      sym__binary_star_star,
    STATE(2480), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [26952] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2481), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [27038] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4115), 1,
      anon_sym_EQ,
    STATE(2482), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4117), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2962), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [27110] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2483), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [27206] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2484), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [27302] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4042), 1,
      anon_sym_rescue,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2485), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [27400] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2486), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 34,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27472] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2487), 1,
      sym_heredoc_body,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 36,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27542] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4119), 1,
      anon_sym_EQ,
    STATE(2488), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4121), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2962), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [27614] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2489), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [27700] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2490), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27766] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2491), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [27832] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2492), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [27926] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4042), 1,
      anon_sym_rescue,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2493), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [28024] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4123), 1,
      anon_sym_EQ,
    STATE(2494), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4125), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 18,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28094] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2495), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28160] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2496), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 33,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28238] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2497), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 34,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28312] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2498), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [28408] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4127), 1,
      anon_sym_EQ,
    STATE(2499), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4129), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 18,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28478] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2500), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [28566] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3449), 1,
      sym__element_reference_bracket,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4133), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4135), 1,
      anon_sym_AMP_DOT,
    STATE(2501), 1,
      sym_heredoc_body,
    ACTIONS(3441), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28638] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4137), 1,
      sym__binary_star_star,
    STATE(2502), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28704] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3125), 1,
      anon_sym_EQ_GT,
    ACTIONS(4139), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_string,
    STATE(2503), 1,
      sym_heredoc_body,
    ACTIONS(2964), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [28778] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2504), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [28874] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2505), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [28970] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2506), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [29064] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2507), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29160] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    STATE(2508), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [29256] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2509), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4484), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29343] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2510), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4475), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29430] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2511), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4466), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29517] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2512), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4472), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29604] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4145), 1,
      sym__binary_star_star,
    STATE(2513), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [29669] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2514), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4480), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29756] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2515), 1,
      sym_heredoc_body,
    STATE(3006), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4481), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29843] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2516), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4480), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [29930] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4147), 1,
      anon_sym_EQ,
    STATE(2517), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4149), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2962), 16,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [30001] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4100), 1,
      anon_sym_rescue,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4163), 1,
      anon_sym_QMARK,
    ACTIONS(4165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2518), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [30098] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2519), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30163] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2520), 1,
      sym_heredoc_body,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 37,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30230] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2521), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30295] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2522), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30360] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2523), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 33,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30433] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2524), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 33,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30504] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2525), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 32,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30581] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2526), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [30668] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2527), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [30753] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2528), 1,
      sym_heredoc_body,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 35,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [30822] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2529), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [30907] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4183), 1,
      anon_sym_rescue,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2530), 1,
      sym_heredoc_body,
    STATE(2580), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 19,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [31008] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2531), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [31073] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4183), 1,
      anon_sym_rescue,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2532), 1,
      sym_heredoc_body,
    STATE(2580), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [31170] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2533), 1,
      sym_heredoc_body,
    STATE(3006), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4465), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31257] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2534), 1,
      sym_heredoc_body,
    STATE(3006), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4482), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31344] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2535), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4482), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31431] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4163), 1,
      anon_sym_QMARK,
    ACTIONS(4165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2536), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [31526] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2537), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4465), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31613] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4163), 1,
      anon_sym_QMARK,
    ACTIONS(4165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2538), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [31708] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2539), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [31801] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4163), 1,
      anon_sym_QMARK,
    ACTIONS(4165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2540), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [31896] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2541), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4485), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [31983] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2542), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4485), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32070] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4163), 1,
      anon_sym_QMARK,
    ACTIONS(4165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2543), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [32165] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2544), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4481), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32252] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2545), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4483), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32339] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2546), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4483), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32426] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2547), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4476), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32513] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2548), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4476), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32600] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2549), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4486), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32687] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2550), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4486), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32774] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(4221), 1,
      anon_sym_nil,
    ACTIONS(4225), 1,
      anon_sym_DASH_GT,
    STATE(2551), 1,
      sym_heredoc_body,
    STATE(4648), 1,
      sym_lambda,
    STATE(4662), 1,
      sym_nil,
    STATE(4726), 1,
      sym__pattern_primitive,
    STATE(5423), 1,
      sym__int_or_float,
    ACTIONS(2878), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2880), 2,
      sym_integer,
      sym_float,
    STATE(4651), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4659), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4666), 2,
      sym_complex,
      sym_rational,
    STATE(4668), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(4223), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4658), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3070), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [32879] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2552), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [32966] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2553), 1,
      sym_heredoc_body,
    STATE(3006), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4473), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33053] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2554), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4467), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33140] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2555), 1,
      sym_heredoc_body,
    STATE(3006), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4477), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33227] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2556), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4477), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33314] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2557), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4471), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33401] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2558), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4471), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33488] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(4227), 1,
      anon_sym_EQ,
    STATE(2559), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4229), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2962), 16,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [33559] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4231), 1,
      anon_sym_EQ,
    STATE(2560), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4233), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2962), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [33628] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4235), 1,
      sym__binary_star_star,
    STATE(2561), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [33693] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2562), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4474), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33780] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2563), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4474), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [33867] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4100), 1,
      anon_sym_rescue,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4163), 1,
      anon_sym_QMARK,
    ACTIONS(4165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2564), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [33964] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4237), 1,
      anon_sym_EQ,
    STATE(2565), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(4239), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_CARET_EQ,
    ACTIONS(2962), 17,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(2964), 17,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
  [34033] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2566), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [34126] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2567), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4490), 1,
      sym__method_name,
    STATE(5329), 1,
      sym__method_rest,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34213] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2568), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4479), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34300] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2569), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4479), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34387] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2570), 1,
      sym_heredoc_body,
    STATE(3006), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4492), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34474] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2571), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4492), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34561] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4241), 1,
      anon_sym_COMMA,
    STATE(2572), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [34626] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2573), 1,
      sym_heredoc_body,
    STATE(3006), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4484), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34713] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(4221), 1,
      anon_sym_nil,
    ACTIONS(4225), 1,
      anon_sym_DASH_GT,
    STATE(2574), 1,
      sym_heredoc_body,
    STATE(4648), 1,
      sym_lambda,
    STATE(4662), 1,
      sym_nil,
    STATE(4726), 1,
      sym__pattern_primitive,
    STATE(5423), 1,
      sym__int_or_float,
    ACTIONS(2820), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2822), 2,
      sym_integer,
      sym_float,
    STATE(4651), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4659), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4666), 2,
      sym_complex,
      sym_rational,
    STATE(4668), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(4223), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4658), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
    ACTIONS(3070), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [34818] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2575), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4490), 1,
      sym__method_name,
    STATE(5344), 1,
      sym__method_rest,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34905] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2576), 1,
      sym_heredoc_body,
    STATE(3006), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4470), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [34992] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2577), 1,
      sym_heredoc_body,
    STATE(2842), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4470), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35079] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2578), 1,
      sym_heredoc_body,
    STATE(2580), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 41,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35144] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2579), 1,
      sym_heredoc_body,
    STATE(3006), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4472), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35231] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4244), 1,
      anon_sym_COMMA,
    STATE(2572), 1,
      aux_sym_exceptions_repeat1,
    STATE(2580), 1,
      sym_heredoc_body,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35298] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2581), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4487), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35385] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2582), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4487), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35472] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2583), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4488), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35559] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2584), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4488), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35646] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4163), 1,
      anon_sym_QMARK,
    ACTIONS(4165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    STATE(2585), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [35741] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2586), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4489), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35828] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2587), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4489), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [35915] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4246), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_string,
    STATE(2588), 1,
      sym_heredoc_body,
    ACTIONS(2964), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [35986] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2589), 1,
      sym_heredoc_body,
    STATE(3006), 1,
      sym__method_rest,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4475), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [36073] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2344), 1,
      sym__method_rest,
    STATE(2590), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4466), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [36160] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 1,
      sym_constant,
    STATE(2225), 1,
      sym__method_rest,
    STATE(2591), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4467), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [36247] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2592), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36311] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2593), 1,
      sym_heredoc_body,
    STATE(2602), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36375] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2594), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 33,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [36447] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4248), 1,
      anon_sym_rescue,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4262), 1,
      anon_sym_QMARK,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2595), 1,
      sym_heredoc_body,
    STATE(2602), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [36545] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4143), 1,
      sym_constant,
    ACTIONS(4282), 1,
      sym_identifier,
    STATE(2596), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4498), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [36629] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(4286), 1,
      anon_sym_EQ_GT,
    STATE(2597), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [36725] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2598), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [36815] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2599), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [36911] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2600), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [37007] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4183), 1,
      anon_sym_rescue,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2601), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 19,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [37105] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4288), 1,
      anon_sym_COMMA,
    STATE(2602), 1,
      sym_heredoc_body,
    STATE(2603), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37171] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4290), 1,
      anon_sym_COMMA,
    STATE(2603), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37235] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2870), 1,
      sym__symbol_start,
    ACTIONS(4293), 1,
      sym_identifier,
    ACTIONS(4299), 1,
      sym_constant,
    ACTIONS(4307), 1,
      sym_simple_symbol,
    STATE(2604), 1,
      sym_heredoc_body,
    STATE(4681), 1,
      sym__method_name,
    STATE(4715), 1,
      sym_constant_suffix,
    STATE(4717), 1,
      sym_identifier_suffix,
    ACTIONS(4301), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4303), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4305), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4746), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4297), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4295), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [37319] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4309), 1,
      sym_identifier,
    ACTIONS(4315), 1,
      sym_constant,
    ACTIONS(4323), 1,
      sym_simple_symbol,
    ACTIONS(4325), 1,
      sym__symbol_start,
    STATE(2605), 1,
      sym_heredoc_body,
    STATE(2615), 1,
      sym__method_name,
    STATE(3206), 1,
      sym_constant_suffix,
    STATE(3207), 1,
      sym_identifier_suffix,
    ACTIONS(4317), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4319), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4321), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(3289), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4313), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4311), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [37403] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2606), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37471] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2607), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37535] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    STATE(2608), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37601] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2609), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 32,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37677] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2610), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37741] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4143), 1,
      sym_constant,
    ACTIONS(4282), 1,
      sym_identifier,
    STATE(2611), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4478), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [37825] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2612), 1,
      sym_heredoc_body,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 37,
      sym__line_break,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [37891] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2613), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [37983] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(3857), 1,
      sym_simple_symbol,
    ACTIONS(4143), 1,
      sym_constant,
    ACTIONS(4282), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_heredoc_body,
    STATE(4396), 1,
      sym_constant_suffix,
    STATE(4397), 1,
      sym_identifier_suffix,
    STATE(4513), 1,
      sym__method_name,
    ACTIONS(3851), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(3853), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4391), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(3845), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(3843), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [38067] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2870), 1,
      sym__symbol_start,
    ACTIONS(4293), 1,
      sym_identifier,
    ACTIONS(4299), 1,
      sym_constant,
    ACTIONS(4307), 1,
      sym_simple_symbol,
    STATE(2615), 1,
      sym_heredoc_body,
    STATE(4498), 1,
      sym__method_name,
    STATE(4715), 1,
      sym_constant_suffix,
    STATE(4717), 1,
      sym_identifier_suffix,
    ACTIONS(4301), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4303), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4305), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4746), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4297), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4295), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [38151] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4309), 1,
      sym_identifier,
    ACTIONS(4315), 1,
      sym_constant,
    ACTIONS(4323), 1,
      sym_simple_symbol,
    ACTIONS(4325), 1,
      sym__symbol_start,
    STATE(2596), 1,
      sym__method_name,
    STATE(2616), 1,
      sym_heredoc_body,
    STATE(3206), 1,
      sym_constant_suffix,
    STATE(3207), 1,
      sym_identifier_suffix,
    ACTIONS(4317), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4319), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4321), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(3289), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4313), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4311), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [38235] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2870), 1,
      sym__symbol_start,
    ACTIONS(4293), 1,
      sym_identifier,
    ACTIONS(4299), 1,
      sym_constant,
    ACTIONS(4307), 1,
      sym_simple_symbol,
    STATE(2617), 1,
      sym_heredoc_body,
    STATE(4478), 1,
      sym__method_name,
    STATE(4715), 1,
      sym_constant_suffix,
    STATE(4717), 1,
      sym_identifier_suffix,
    ACTIONS(4301), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4303), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4305), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
    STATE(4746), 5,
      sym__function_identifier,
      sym_operator,
      sym__nonlocal_variable,
      sym_setter,
      sym_delimited_symbol,
    ACTIONS(4297), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4295), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [38319] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2618), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [38411] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2619), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 26,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [38495] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2620), 1,
      sym_heredoc_body,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 35,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38563] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2621), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 26,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [38647] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2622), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 40,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [38711] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2623), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [38803] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2624), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [38895] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2625), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [38985] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2626), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39077] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4183), 1,
      anon_sym_rescue,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2627), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39171] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2628), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39263] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2629), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39359] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2630), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 33,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39429] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2631), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [39521] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2632), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 25,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [39607] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4262), 1,
      anon_sym_QMARK,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2633), 1,
      sym_heredoc_body,
    ACTIONS(4002), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [39700] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2634), 1,
      sym_heredoc_body,
    STATE(2658), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 39,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [39763] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4262), 1,
      anon_sym_QMARK,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2635), 1,
      sym_heredoc_body,
    ACTIONS(4024), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [39856] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4248), 1,
      anon_sym_rescue,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4262), 1,
      anon_sym_QMARK,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2636), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [39951] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2637), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [40042] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3449), 1,
      sym__element_reference_bracket,
    ACTIONS(4329), 1,
      anon_sym_DOT,
    ACTIONS(4331), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4333), 1,
      anon_sym_AMP_DOT,
    STATE(2638), 1,
      sym_heredoc_body,
    ACTIONS(3441), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40111] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__binary_star_star,
    STATE(2639), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40174] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COLON,
    STATE(2640), 1,
      sym_heredoc_body,
    ACTIONS(2578), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2580), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40237] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2641), 1,
      sym_heredoc_body,
    ACTIONS(3719), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40300] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2642), 1,
      sym_heredoc_body,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 34,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40365] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2643), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40428] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2644), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40491] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2645), 1,
      sym_heredoc_body,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40562] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2646), 1,
      sym_heredoc_body,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40631] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2647), 1,
      sym_heredoc_body,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 29,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40706] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2648), 1,
      sym_heredoc_body,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 22,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [40791] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2649), 1,
      sym_heredoc_body,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 23,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [40874] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2650), 1,
      sym_heredoc_body,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 32,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [40941] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2651), 1,
      sym_heredoc_body,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 23,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [41024] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2652), 1,
      sym_heredoc_body,
    ACTIONS(4016), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41087] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2653), 1,
      sym_heredoc_body,
    ACTIONS(3988), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [41178] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4337), 1,
      anon_sym_COMMA,
    STATE(2654), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41241] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4262), 1,
      anon_sym_QMARK,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2655), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [41334] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4340), 1,
      anon_sym_COMMA,
    STATE(2656), 1,
      sym_heredoc_body,
    STATE(2658), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41399] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4262), 1,
      anon_sym_QMARK,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2657), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [41492] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4340), 1,
      anon_sym_COMMA,
    STATE(2654), 1,
      aux_sym_exceptions_repeat1,
    STATE(2658), 1,
      sym_heredoc_body,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41557] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2659), 1,
      sym_heredoc_body,
    ACTIONS(4032), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [41648] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4262), 1,
      anon_sym_QMARK,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2660), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [41741] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4262), 1,
      anon_sym_QMARK,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2661), 1,
      sym_heredoc_body,
    ACTIONS(3998), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [41834] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4342), 1,
      sym__binary_star_star,
    STATE(2662), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [41897] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2663), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4344), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [41988] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4340), 1,
      anon_sym_COMMA,
    ACTIONS(4346), 1,
      anon_sym_rescue,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2658), 1,
      aux_sym_exceptions_repeat1,
    STATE(2664), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42085] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2665), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4380), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42176] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4340), 1,
      anon_sym_COMMA,
    ACTIONS(4346), 1,
      anon_sym_rescue,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2658), 1,
      aux_sym_exceptions_repeat1,
    STATE(2666), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42277] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    ACTIONS(3080), 1,
      anon_sym_do,
    STATE(2667), 1,
      sym_heredoc_body,
    STATE(2775), 1,
      sym_argument_list,
    STATE(2976), 1,
      sym_do_block,
    STATE(2977), 1,
      sym_block,
    ACTIONS(413), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42350] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2668), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4382), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42441] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    STATE(2669), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4384), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42532] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    ACTIONS(4386), 1,
      anon_sym_rescue,
    STATE(2658), 1,
      aux_sym_exceptions_repeat1,
    STATE(2670), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42627] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4388), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_string,
    STATE(2671), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [42696] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    ACTIONS(4386), 1,
      anon_sym_rescue,
    STATE(2658), 1,
      aux_sym_exceptions_repeat1,
    STATE(2672), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [42795] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4262), 1,
      anon_sym_QMARK,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2673), 1,
      sym_heredoc_body,
    ACTIONS(3587), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [42888] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4248), 1,
      anon_sym_rescue,
    ACTIONS(4250), 1,
      anon_sym_PIPE,
    ACTIONS(4252), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4254), 1,
      anon_sym_AMP,
    ACTIONS(4258), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4260), 1,
      anon_sym_CARET,
    ACTIONS(4262), 1,
      anon_sym_QMARK,
    ACTIONS(4264), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4266), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4270), 1,
      anon_sym_GT_EQ,
    ACTIONS(4276), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4280), 1,
      sym__binary_star_star,
    STATE(2674), 1,
      sym_heredoc_body,
    ACTIONS(3313), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4272), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4256), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4274), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4278), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [42983] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_COLON,
    STATE(2675), 1,
      sym_heredoc_body,
    ACTIONS(2582), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2584), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43046] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2676), 1,
      sym_heredoc_body,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 35,
      sym__line_break,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43110] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2677), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43172] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2678), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 21,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [43260] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2679), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43354] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2680), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43448] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2681), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43510] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2682), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43600] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2683), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43662] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4390), 1,
      anon_sym_rescue,
    ACTIONS(4392), 1,
      anon_sym_COMMA,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4406), 1,
      anon_sym_QMARK,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2684), 1,
      sym_heredoc_body,
    STATE(2685), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 15,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [43760] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_COMMA,
    STATE(2685), 1,
      sym_heredoc_body,
    STATE(2708), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43824] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2686), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [43914] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2685), 1,
      aux_sym_exceptions_repeat1,
    STATE(2687), 1,
      sym_heredoc_body,
    ACTIONS(3523), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [43976] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2688), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 24,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [44058] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2689), 1,
      sym_heredoc_body,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 33,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44124] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2690), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 21,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [44212] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4426), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_string,
    STATE(2691), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44280] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    ACTIONS(4386), 1,
      anon_sym_rescue,
    STATE(2692), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [44376] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    ACTIONS(4386), 1,
      anon_sym_rescue,
    STATE(2693), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [44468] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    ACTIONS(4428), 1,
      anon_sym_EQ_GT,
    STATE(2694), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [44562] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4406), 1,
      anon_sym_QMARK,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    ACTIONS(4430), 1,
      anon_sym_rescue,
    STATE(2685), 1,
      aux_sym_exceptions_repeat1,
    STATE(2695), 1,
      sym_heredoc_body,
    ACTIONS(3523), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [44658] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2696), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [44748] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2697), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44818] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2698), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [44886] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2699), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 23,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [44970] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2700), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45044] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2701), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 24,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [45126] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2702), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [45216] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2703), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [45306] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2704), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 38,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45368] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2705), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [45458] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_COMMA,
    STATE(2685), 1,
      aux_sym_exceptions_repeat1,
    STATE(2706), 1,
      sym_heredoc_body,
    ACTIONS(3523), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45522] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2707), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 36,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45588] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4432), 1,
      anon_sym_COMMA,
    STATE(2708), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45650] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    ACTIONS(3201), 1,
      anon_sym_COLON,
    STATE(2709), 1,
      sym_heredoc_body,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3125), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(2962), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45720] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2710), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [45810] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2711), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [45904] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3137), 1,
      anon_sym_ri,
    STATE(2712), 1,
      sym_heredoc_body,
    ACTIONS(3135), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3133), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3131), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [45968] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    STATE(2713), 1,
      sym_heredoc_body,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46033] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2714), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46094] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2715), 1,
      sym_heredoc_body,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46163] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4346), 1,
      anon_sym_rescue,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2716), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46254] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2717), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 23,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [46335] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    STATE(2718), 1,
      sym_heredoc_body,
    STATE(2890), 1,
      sym_argument_list,
    ACTIONS(425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(423), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46398] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4467), 1,
      sym__binary_star_star,
    STATE(2719), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46459] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2720), 1,
      sym_heredoc_body,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46526] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2721), 1,
      sym_heredoc_body,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46599] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2722), 1,
      sym_heredoc_body,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [46682] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2723), 1,
      sym_heredoc_body,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 21,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [46763] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2724), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4382), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [46852] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2725), 1,
      sym_heredoc_body,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [46917] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2726), 1,
      sym_heredoc_body,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 21,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [46998] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    STATE(2727), 1,
      sym_heredoc_body,
    STATE(2925), 1,
      sym_argument_list,
    ACTIONS(429), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(427), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47061] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2728), 1,
      sym_heredoc_body,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 34,
      sym__line_break,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47124] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2729), 1,
      sym_heredoc_body,
    ACTIONS(4016), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47185] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2730), 1,
      sym_heredoc_body,
    ACTIONS(3719), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47246] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2731), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47315] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2732), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47376] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2733), 1,
      sym_heredoc_body,
    ACTIONS(3988), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [47465] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2734), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47532] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_string,
    STATE(2735), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47597] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    ACTIONS(3080), 1,
      anon_sym_do,
    STATE(2736), 1,
      sym_heredoc_body,
    STATE(2937), 1,
      sym_do_block,
    STATE(2940), 1,
      sym_block,
    ACTIONS(3171), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3169), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47664] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    STATE(2737), 1,
      sym_heredoc_body,
    STATE(2755), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    ACTIONS(3112), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3110), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [47729] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2738), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47818] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2739), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47907] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2740), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [47996] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2741), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 29,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48069] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2742), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48130] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2743), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48195] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2744), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [48288] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2745), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48349] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2746), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [48436] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    STATE(2747), 1,
      sym_heredoc_body,
    STATE(3027), 1,
      sym_argument_list,
    ACTIONS(3163), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3161), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48499] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    STATE(2748), 1,
      sym_heredoc_body,
    STATE(2843), 1,
      sym_argument_list,
    ACTIONS(3189), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3187), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [48562] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2749), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [48651] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2750), 1,
      sym_heredoc_body,
    ACTIONS(4032), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 18,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [48740] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2751), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4344), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [48829] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2752), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [48922] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2753), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [49015] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4346), 1,
      anon_sym_rescue,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2754), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [49110] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4469), 1,
      sym__string_start,
    STATE(2791), 1,
      sym_string,
    STATE(2755), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3116), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3114), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49173] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4406), 1,
      anon_sym_QMARK,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2756), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [49264] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2757), 1,
      sym_heredoc_body,
    STATE(2791), 1,
      sym_string,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3125), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(2962), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49331] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    ACTIONS(3080), 1,
      anon_sym_do,
    STATE(2758), 1,
      sym_heredoc_body,
    STATE(2929), 1,
      sym_do_block,
    STATE(2931), 1,
      sym_block,
    ACTIONS(3175), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3173), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49398] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4406), 1,
      anon_sym_QMARK,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2759), 1,
      sym_heredoc_body,
    ACTIONS(4024), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [49489] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2760), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 22,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [49572] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4406), 1,
      anon_sym_QMARK,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2761), 1,
      sym_heredoc_body,
    ACTIONS(3998), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [49663] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4406), 1,
      anon_sym_QMARK,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    ACTIONS(4430), 1,
      anon_sym_rescue,
    STATE(2762), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [49756] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    STATE(2763), 1,
      sym_heredoc_body,
    STATE(2884), 1,
      sym_argument_list,
    ACTIONS(421), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(419), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [49819] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2764), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4384), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [49908] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2765), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 23,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [49989] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    STATE(2766), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4380), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [50078] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2767), 1,
      sym_heredoc_body,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 32,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50141] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3137), 1,
      anon_sym_ri,
    STATE(2768), 1,
      sym_heredoc_body,
    ACTIONS(3135), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3133), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3131), 33,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50204] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2769), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 20,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [50291] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4406), 1,
      anon_sym_QMARK,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2770), 1,
      sym_heredoc_body,
    ACTIONS(4002), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [50382] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2771), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 37,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50443] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    STATE(2772), 1,
      sym_heredoc_body,
    STATE(2887), 1,
      sym_argument_list,
    ACTIONS(417), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(415), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50506] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4472), 1,
      sym__binary_star_star,
    STATE(2773), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50567] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4406), 1,
      anon_sym_QMARK,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2774), 1,
      sym_heredoc_body,
    ACTIONS(3587), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [50658] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    ACTIONS(3080), 1,
      anon_sym_do,
    STATE(2775), 1,
      sym_heredoc_body,
    STATE(2946), 1,
      sym_do_block,
    STATE(2957), 1,
      sym_block,
    ACTIONS(3179), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3177), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50725] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4406), 1,
      anon_sym_QMARK,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2776), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [50816] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2777), 1,
      sym_heredoc_body,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 32,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [50881] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2778), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [50970] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4406), 1,
      anon_sym_QMARK,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    ACTIONS(4430), 1,
      anon_sym_rescue,
    STATE(2779), 1,
      sym_heredoc_body,
    ACTIONS(3313), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [51063] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3449), 1,
      sym__element_reference_bracket,
    ACTIONS(4474), 1,
      anon_sym_DOT,
    ACTIONS(4476), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4478), 1,
      anon_sym_AMP_DOT,
    STATE(2780), 1,
      sym_heredoc_body,
    ACTIONS(3441), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51130] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2781), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 19,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [51219] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2782), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51280] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_PIPE,
    ACTIONS(4396), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4398), 1,
      anon_sym_AMP,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4404), 1,
      anon_sym_CARET,
    ACTIONS(4406), 1,
      anon_sym_QMARK,
    ACTIONS(4408), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4410), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4414), 1,
      anon_sym_GT_EQ,
    ACTIONS(4420), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4424), 1,
      sym__binary_star_star,
    STATE(2783), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4412), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4416), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4400), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4418), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4422), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [51371] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2784), 1,
      sym_heredoc_body,
    ACTIONS(2586), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2588), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51429] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym___END__,
    ACTIONS(4480), 1,
      anon_sym_rescue,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2785), 1,
      sym_heredoc_body,
    STATE(2815), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [51527] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    STATE(2786), 1,
      sym_heredoc_body,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51589] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    STATE(2787), 1,
      sym_heredoc_body,
    ACTIONS(3719), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51649] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4522), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_string,
    STATE(2788), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51715] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    STATE(2789), 1,
      sym_heredoc_body,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [51795] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4542), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4546), 1,
      anon_sym_QMARK,
    ACTIONS(4548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4550), 1,
      anon_sym_AMP_AMP,
    STATE(2790), 1,
      sym_heredoc_body,
    ACTIONS(3998), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [51885] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2791), 1,
      sym_heredoc_body,
    ACTIONS(3205), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3203), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [51943] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4552), 1,
      sym__binary_star_star,
    STATE(2792), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52003] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4554), 1,
      anon_sym_rescue,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2793), 1,
      sym_heredoc_body,
    STATE(2797), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [52097] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym___END__,
    ACTIONS(4480), 1,
      anon_sym_rescue,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2794), 1,
      sym_heredoc_body,
    STATE(2815), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [52191] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    STATE(2795), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52251] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2796), 1,
      sym_heredoc_body,
    STATE(2815), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52311] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_COMMA,
    STATE(2797), 1,
      sym_heredoc_body,
    STATE(2811), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52373] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2798), 1,
      sym_heredoc_body,
    ACTIONS(2582), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2584), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52431] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2799), 1,
      sym_heredoc_body,
    ACTIONS(3183), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3181), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52489] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    STATE(2800), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52549] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    STATE(2801), 1,
      sym_heredoc_body,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52617] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4390), 1,
      anon_sym_rescue,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4542), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4546), 1,
      anon_sym_QMARK,
    ACTIONS(4548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4550), 1,
      anon_sym_AMP_AMP,
    STATE(2802), 1,
      sym_heredoc_body,
    ACTIONS(3313), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 15,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [52709] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    STATE(2803), 1,
      sym_heredoc_body,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 29,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52773] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3499), 1,
      anon_sym_LBRACE,
    STATE(2804), 1,
      sym_heredoc_body,
    ACTIONS(3695), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52833] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    STATE(2805), 1,
      sym_heredoc_body,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [52905] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4542), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4550), 1,
      anon_sym_AMP_AMP,
    STATE(2806), 1,
      sym_heredoc_body,
    ACTIONS(4032), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [52993] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    ACTIONS(4590), 1,
      anon_sym_COLON,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    STATE(2807), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53059] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2797), 1,
      aux_sym_exceptions_repeat1,
    STATE(2808), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 35,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53119] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2809), 1,
      sym_heredoc_body,
    ACTIONS(2590), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2592), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53177] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4592), 1,
      sym__binary_star_star,
    STATE(2810), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53237] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4594), 1,
      anon_sym_COMMA,
    STATE(2811), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53297] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    STATE(2812), 1,
      sym_heredoc_body,
    ACTIONS(4016), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53357] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4390), 1,
      anon_sym_rescue,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4542), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4546), 1,
      anon_sym_QMARK,
    ACTIONS(4548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4550), 1,
      anon_sym_AMP_AMP,
    STATE(2813), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 15,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [53449] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4542), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4546), 1,
      anon_sym_QMARK,
    ACTIONS(4548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4550), 1,
      anon_sym_AMP_AMP,
    STATE(2814), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [53539] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4597), 1,
      anon_sym_COMMA,
    STATE(2815), 1,
      sym_heredoc_body,
    STATE(2822), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [53601] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(4588), 1,
      anon_sym_COMMA,
    ACTIONS(4599), 1,
      anon_sym_rescue,
    STATE(2797), 1,
      aux_sym_exceptions_repeat1,
    STATE(2816), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [53697] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4542), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4550), 1,
      anon_sym_AMP_AMP,
    STATE(2817), 1,
      sym_heredoc_body,
    ACTIONS(3988), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 17,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [53785] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4542), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4546), 1,
      anon_sym_QMARK,
    ACTIONS(4548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4550), 1,
      anon_sym_AMP_AMP,
    STATE(2818), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [53875] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4542), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4546), 1,
      anon_sym_QMARK,
    ACTIONS(4548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4550), 1,
      anon_sym_AMP_AMP,
    STATE(2819), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [53965] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    STATE(2820), 1,
      sym_heredoc_body,
    STATE(2976), 1,
      sym_do_block,
    STATE(2977), 1,
      sym_block,
    STATE(3068), 1,
      sym_argument_list,
    ACTIONS(413), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(411), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54033] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4588), 1,
      anon_sym_COMMA,
    STATE(2797), 1,
      aux_sym_exceptions_repeat1,
    STATE(2821), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54095] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_COMMA,
    STATE(2822), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54155] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2823), 1,
      sym_heredoc_body,
    ACTIONS(3499), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    ACTIONS(3695), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54215] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2824), 1,
      sym_heredoc_body,
    ACTIONS(3167), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3165), 35,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54273] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    STATE(2825), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [54361] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4550), 1,
      anon_sym_AMP_AMP,
    STATE(2826), 1,
      sym_heredoc_body,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 19,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [54443] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2827), 1,
      sym_heredoc_body,
    ACTIONS(2578), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2580), 35,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54501] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4542), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4544), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4546), 1,
      anon_sym_QMARK,
    ACTIONS(4548), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4550), 1,
      anon_sym_AMP_AMP,
    STATE(2828), 1,
      sym_heredoc_body,
    ACTIONS(4024), 2,
      anon_sym___END__,
      anon_sym_DOT,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 16,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [54591] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    ACTIONS(4524), 1,
      anon_sym_PIPE,
    ACTIONS(4526), 1,
      anon_sym_AMP,
    ACTIONS(4530), 1,
      anon_sym_CARET,
    ACTIONS(4534), 1,
      anon_sym_GT_EQ,
    ACTIONS(4538), 1,
      anon_sym_EQ_EQ,
    STATE(2829), 1,
      sym_heredoc_body,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4528), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4540), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 20,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [54671] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__binary_star_star,
    STATE(2830), 1,
      sym_heredoc_body,
    ACTIONS(4532), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4536), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4518), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym___END__,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__line_break,
      sym__element_reference_bracket,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54737] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2831), 1,
      sym_heredoc_body,
    ACTIONS(3257), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3255), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54794] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2832), 1,
      sym_heredoc_body,
    ACTIONS(3381), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3379), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54851] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2833), 1,
      sym_heredoc_body,
    ACTIONS(3385), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3383), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54908] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2834), 1,
      sym_heredoc_body,
    ACTIONS(3417), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3415), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [54965] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3443), 1,
      anon_sym_DOT,
    ACTIONS(3447), 1,
      anon_sym_AMP_DOT,
    ACTIONS(3449), 1,
      sym__element_reference_bracket,
    ACTIONS(4604), 1,
      anon_sym_COLON_COLON2,
    STATE(2835), 1,
      sym_heredoc_body,
    ACTIONS(3441), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55030] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    ACTIONS(3125), 1,
      anon_sym_EQ_GT,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    STATE(2836), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55095] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2837), 1,
      sym_heredoc_body,
    ACTIONS(3441), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55152] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2838), 1,
      sym_heredoc_body,
    ACTIONS(3599), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3597), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55209] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2839), 1,
      sym_heredoc_body,
    ACTIONS(3305), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3303), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55266] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2840), 1,
      sym_heredoc_body,
    ACTIONS(3595), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3593), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55323] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2841), 1,
      sym_heredoc_body,
    ACTIONS(3559), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3557), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55380] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2842), 1,
      sym_heredoc_body,
    ACTIONS(3727), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3725), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55437] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2843), 1,
      sym_heredoc_body,
    ACTIONS(3575), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3573), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55494] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2844), 1,
      sym_heredoc_body,
    ACTIONS(3543), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3541), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55551] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2845), 1,
      sym_heredoc_body,
    ACTIONS(2964), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55608] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2846), 1,
      sym_heredoc_body,
    ACTIONS(3253), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3251), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55665] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2847), 1,
      sym_heredoc_body,
    ACTIONS(3743), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3741), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55722] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2848), 1,
      sym_heredoc_body,
    ACTIONS(3751), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3749), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [55779] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    ACTIONS(4606), 1,
      anon_sym___END__,
    STATE(2849), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [55872] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2850), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [55951] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    ACTIONS(3125), 1,
      anon_sym_EQ_GT,
    ACTIONS(4608), 1,
      anon_sym_COLON,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    STATE(2851), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56018] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym___END__,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2852), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [56107] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    ACTIONS(4610), 1,
      anon_sym_COLON,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    STATE(2853), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56172] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2854), 1,
      sym_heredoc_body,
    ACTIONS(3755), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3753), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56229] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2855), 1,
      sym_heredoc_body,
    ACTIONS(3767), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3765), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56286] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym___END__,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2856), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [56373] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2857), 1,
      sym_heredoc_body,
    ACTIONS(3603), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3601), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56430] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2858), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [56523] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2859), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [56616] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2860), 1,
      sym_heredoc_body,
    ACTIONS(3333), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3331), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56673] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2861), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [56762] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2862), 1,
      sym_heredoc_body,
    ACTIONS(3133), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3131), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56819] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2863), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [56908] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2864), 1,
      sym_heredoc_body,
    ACTIONS(3345), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3343), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [56965] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2865), 1,
      sym_heredoc_body,
    ACTIONS(3277), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3275), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57022] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2866), 1,
      sym_heredoc_body,
    ACTIONS(3281), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3279), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57079] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2867), 1,
      sym_heredoc_body,
    ACTIONS(3293), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3291), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57136] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2868), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57195] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2869), 1,
      sym_heredoc_body,
    ACTIONS(3309), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3307), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57252] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2870), 1,
      sym_heredoc_body,
    ACTIONS(3551), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3549), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57309] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2871), 1,
      sym_heredoc_body,
    ACTIONS(3365), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3363), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57366] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2872), 1,
      sym_heredoc_body,
    ACTIONS(3457), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3455), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57423] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2873), 1,
      sym_heredoc_body,
    ACTIONS(3461), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3459), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57480] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2874), 1,
      sym_heredoc_body,
    ACTIONS(3507), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3505), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57537] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2875), 1,
      sym_heredoc_body,
    ACTIONS(3515), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3513), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57594] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2876), 1,
      sym_heredoc_body,
    ACTIONS(3531), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3529), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57651] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2877), 1,
      sym_heredoc_body,
    ACTIONS(3555), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3553), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57708] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2878), 1,
      sym_heredoc_body,
    ACTIONS(3623), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3621), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57765] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2879), 1,
      sym_heredoc_body,
    ACTIONS(3473), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3471), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57822] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2880), 1,
      sym_heredoc_body,
    ACTIONS(3671), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3669), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57879] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2881), 1,
      sym_heredoc_body,
    ACTIONS(3477), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3475), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57936] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2882), 1,
      sym_heredoc_body,
    ACTIONS(3245), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3243), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [57993] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2883), 1,
      sym_heredoc_body,
    ACTIONS(3695), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58050] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2884), 1,
      sym_heredoc_body,
    ACTIONS(3627), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3625), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58107] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2885), 1,
      sym_heredoc_body,
    ACTIONS(3481), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3479), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58164] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2886), 1,
      sym_heredoc_body,
    ACTIONS(3711), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3709), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58221] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2887), 1,
      sym_heredoc_body,
    ACTIONS(3679), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3677), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58278] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2888), 1,
      sym_heredoc_body,
    ACTIONS(3719), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58335] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2889), 1,
      sym_heredoc_body,
    ACTIONS(3225), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3223), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58392] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2890), 1,
      sym_heredoc_body,
    ACTIONS(3699), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3697), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58449] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym___END__,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2891), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [58536] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym___END__,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2892), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [58625] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2893), 1,
      sym_heredoc_body,
    ACTIONS(3523), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58682] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2894), 1,
      sym_heredoc_body,
    ACTIONS(3527), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3525), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58739] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2895), 1,
      sym_heredoc_body,
    ACTIONS(3799), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3797), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58796] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2896), 1,
      sym_heredoc_body,
    ACTIONS(3337), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3335), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [58853] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4480), 1,
      anon_sym_rescue,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2897), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [58948] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4480), 1,
      anon_sym_rescue,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2898), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [59039] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2899), 1,
      sym_heredoc_body,
    ACTIONS(3759), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3757), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59096] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2900), 1,
      sym_heredoc_body,
    ACTIONS(3485), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3483), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59153] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2901), 1,
      sym_heredoc_body,
    ACTIONS(3489), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3487), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59210] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2902), 1,
      sym_heredoc_body,
    ACTIONS(3615), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3613), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59267] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2903), 1,
      sym_heredoc_body,
    ACTIONS(3519), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3517), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59324] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2904), 1,
      sym_heredoc_body,
    ACTIONS(3269), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3267), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59381] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2905), 1,
      sym_heredoc_body,
    ACTIONS(3579), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3577), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59438] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2906), 1,
      sym_heredoc_body,
    ACTIONS(3317), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3315), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59495] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2907), 1,
      sym_heredoc_body,
    ACTIONS(3655), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3653), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59552] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2908), 1,
      sym_heredoc_body,
    ACTIONS(3591), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3589), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59609] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2909), 1,
      sym_heredoc_body,
    ACTIONS(3607), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3605), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59666] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2910), 1,
      sym_heredoc_body,
    ACTIONS(3659), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3657), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [59723] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2911), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [59812] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2912), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [59901] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2913), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [59988] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2914), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [60077] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2915), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [60166] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2916), 1,
      sym_heredoc_body,
    ACTIONS(3795), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3793), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60223] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4554), 1,
      anon_sym_rescue,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2917), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [60314] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2918), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [60401] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2919), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [60490] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4554), 1,
      anon_sym_rescue,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2920), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [60581] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2921), 1,
      sym_heredoc_body,
    ACTIONS(3619), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3617), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60638] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2922), 1,
      sym_heredoc_body,
    ACTIONS(3563), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3561), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60695] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2923), 1,
      sym_heredoc_body,
    ACTIONS(3631), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3629), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60752] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2924), 1,
      sym_heredoc_body,
    ACTIONS(3667), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3665), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60809] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2925), 1,
      sym_heredoc_body,
    ACTIONS(3377), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3375), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60866] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2926), 1,
      sym_heredoc_body,
    ACTIONS(3611), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3609), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60923] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2927), 1,
      sym_heredoc_body,
    ACTIONS(3567), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3565), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [60980] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(3125), 1,
      anon_sym_EQ_GT,
    ACTIONS(4612), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_string,
    STATE(2928), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61047] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2929), 1,
      sym_heredoc_body,
    ACTIONS(3361), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3359), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61104] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3449), 1,
      sym__element_reference_bracket,
    ACTIONS(4034), 1,
      anon_sym_DOT,
    ACTIONS(4038), 1,
      anon_sym_AMP_DOT,
    ACTIONS(4614), 1,
      anon_sym_COLON_COLON2,
    STATE(2930), 1,
      sym_heredoc_body,
    ACTIONS(3441), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61169] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2931), 1,
      sym_heredoc_body,
    ACTIONS(3361), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3359), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61226] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2932), 1,
      sym_heredoc_body,
    ACTIONS(3241), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3239), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61283] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2933), 1,
      sym_heredoc_body,
    ACTIONS(3635), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3633), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61340] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    STATE(2934), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61401] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2935), 1,
      sym_heredoc_body,
    ACTIONS(3723), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3721), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61458] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    ACTIONS(4606), 1,
      anon_sym___END__,
    ACTIONS(4616), 1,
      anon_sym_EQ_GT,
    STATE(2936), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [61551] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2937), 1,
      sym_heredoc_body,
    ACTIONS(3735), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3733), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61608] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2938), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61665] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2939), 1,
      sym_heredoc_body,
    ACTIONS(3731), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3729), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61722] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2940), 1,
      sym_heredoc_body,
    ACTIONS(3735), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3733), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61779] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2941), 1,
      sym_heredoc_body,
    ACTIONS(3213), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3211), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61836] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym___END__,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2942), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [61925] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2943), 1,
      sym_heredoc_body,
    ACTIONS(3571), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3569), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [61982] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2944), 1,
      sym_heredoc_body,
    ACTIONS(3687), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3685), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62039] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym___END__,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2945), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [62128] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2946), 1,
      sym_heredoc_body,
    ACTIONS(3325), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3323), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62185] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2947), 1,
      sym_heredoc_body,
    ACTIONS(3639), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3637), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62242] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2948), 1,
      sym_heredoc_body,
    ACTIONS(3643), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3641), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62299] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2949), 1,
      sym_heredoc_body,
    ACTIONS(3273), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3271), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62356] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2950), 1,
      sym_heredoc_body,
    ACTIONS(3297), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3295), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62413] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2951), 1,
      sym_heredoc_body,
    ACTIONS(3771), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3769), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62470] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2952), 1,
      sym_heredoc_body,
    ACTIONS(3301), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3299), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62527] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2953), 1,
      sym_heredoc_body,
    ACTIONS(3373), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3371), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62584] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2954), 1,
      sym_heredoc_body,
    ACTIONS(3389), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3387), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62641] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2955), 1,
      sym_heredoc_body,
    ACTIONS(3393), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3391), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62698] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2956), 1,
      sym_heredoc_body,
    ACTIONS(3397), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3395), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62755] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2957), 1,
      sym_heredoc_body,
    ACTIONS(3325), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3323), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62812] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2958), 1,
      sym_heredoc_body,
    ACTIONS(3663), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3661), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62869] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2959), 1,
      sym_heredoc_body,
    ACTIONS(3285), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3283), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62926] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2960), 1,
      sym_heredoc_body,
    ACTIONS(3501), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3499), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [62983] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2961), 1,
      sym_heredoc_body,
    ACTIONS(3687), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3685), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63040] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2962), 1,
      sym_heredoc_body,
    ACTIONS(3775), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3773), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63097] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2963), 1,
      sym_heredoc_body,
    ACTIONS(3675), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3673), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63154] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2964), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63217] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2965), 1,
      sym_heredoc_body,
    ACTIONS(3233), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3231), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63274] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2966), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63333] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2967), 1,
      sym_heredoc_body,
    ACTIONS(3357), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3355), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63390] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2968), 1,
      sym_heredoc_body,
    ACTIONS(3547), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3545), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63447] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2969), 1,
      sym_heredoc_body,
    ACTIONS(3715), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3713), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63504] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3137), 1,
      anon_sym_ri,
    STATE(2970), 1,
      sym_heredoc_body,
    ACTIONS(3135), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3133), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3131), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63565] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2971), 1,
      sym_heredoc_body,
    ACTIONS(3493), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3491), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63622] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2972), 1,
      sym_heredoc_body,
    ACTIONS(3747), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3745), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63679] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2973), 1,
      sym_heredoc_body,
    ACTIONS(3583), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3581), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63736] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2974), 1,
      sym_heredoc_body,
    ACTIONS(3429), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3427), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63793] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2975), 1,
      sym_heredoc_body,
    ACTIONS(3587), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63850] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2976), 1,
      sym_heredoc_body,
    ACTIONS(3437), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3435), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63907] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2977), 1,
      sym_heredoc_body,
    ACTIONS(3437), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3435), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [63964] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4618), 1,
      sym__binary_star_star,
    STATE(2978), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64023] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2979), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64082] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2980), 1,
      sym_heredoc_body,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64143] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2981), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64202] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2982), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64261] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2983), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64328] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2984), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64393] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2985), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64464] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2986), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [64545] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2987), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [64624] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2988), 1,
      sym_heredoc_body,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 29,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64687] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2989), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [64766] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2990), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64825] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym___END__,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(2991), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [64914] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2992), 1,
      sym_heredoc_body,
    ACTIONS(3703), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3701), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [64971] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2993), 1,
      sym_heredoc_body,
    ACTIONS(3511), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3509), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65028] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2994), 1,
      sym_heredoc_body,
    ACTIONS(3349), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3347), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65085] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4620), 1,
      sym__binary_star_star,
    STATE(2995), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65144] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2996), 1,
      sym_heredoc_body,
    ACTIONS(3409), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3407), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65201] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2997), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [65290] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    STATE(2998), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [65379] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2999), 1,
      sym_heredoc_body,
    ACTIONS(3647), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3645), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65436] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3000), 1,
      sym_heredoc_body,
    ACTIONS(3229), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3227), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65493] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3001), 1,
      sym_heredoc_body,
    ACTIONS(3691), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3689), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65550] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3002), 1,
      sym_heredoc_body,
    ACTIONS(3707), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3705), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65607] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3003), 1,
      sym_heredoc_body,
    ACTIONS(3221), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3219), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65664] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3004), 1,
      sym_heredoc_body,
    ACTIONS(3763), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3761), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65721] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3005), 1,
      sym_heredoc_body,
    ACTIONS(3329), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3327), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65778] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3006), 1,
      sym_heredoc_body,
    ACTIONS(3289), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3287), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65835] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3007), 1,
      sym_heredoc_body,
    ACTIONS(3413), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3411), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65892] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3008), 1,
      sym_heredoc_body,
    ACTIONS(3651), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3649), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [65949] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3009), 1,
      sym_heredoc_body,
    ACTIONS(3453), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3451), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66006] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3010), 1,
      sym_heredoc_body,
    ACTIONS(3313), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3311), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66063] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3011), 1,
      sym_heredoc_body,
    ACTIONS(3209), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3207), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66120] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3012), 1,
      sym_heredoc_body,
    ACTIONS(3369), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3367), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66177] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(3013), 1,
      sym_heredoc_body,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 29,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66240] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3014), 1,
      sym_heredoc_body,
    ACTIONS(3265), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3263), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66297] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3015), 1,
      sym_heredoc_body,
    ACTIONS(3497), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3495), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66354] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3016), 1,
      sym_heredoc_body,
    ACTIONS(3539), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3537), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66411] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(3017), 1,
      sym_heredoc_body,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66472] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(3018), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66531] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3019), 1,
      sym_heredoc_body,
    ACTIONS(3535), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3533), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66588] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(3020), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66647] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(3021), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66714] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3022), 1,
      sym_heredoc_body,
    ACTIONS(3683), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3681), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66771] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3023), 1,
      sym_heredoc_body,
    ACTIONS(3779), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3777), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66828] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(3024), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66893] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3025), 1,
      sym_heredoc_body,
    ACTIONS(3791), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3789), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [66950] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3026), 1,
      sym_heredoc_body,
    ACTIONS(3217), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3215), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67007] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3027), 1,
      sym_heredoc_body,
    ACTIONS(3261), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3259), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67064] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(3028), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym___END__,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67135] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3029), 1,
      sym_heredoc_body,
    ACTIONS(3237), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3235), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67192] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3030), 1,
      sym_heredoc_body,
    ACTIONS(3783), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3781), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67249] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3031), 1,
      sym_heredoc_body,
    ACTIONS(3787), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3785), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67306] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3032), 1,
      sym_heredoc_body,
    ACTIONS(3353), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3351), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67363] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(3033), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [67444] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    STATE(3034), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [67523] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3035), 1,
      sym_heredoc_body,
    ACTIONS(3803), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3801), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67580] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3036), 1,
      sym_heredoc_body,
    ACTIONS(3249), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3247), 34,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67637] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym___END__,
    ACTIONS(4622), 1,
      anon_sym_rescue,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3037), 1,
      sym_heredoc_body,
    STATE(3059), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [67729] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3038), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 18,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [67809] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3039), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [67887] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3040), 1,
      sym_heredoc_body,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [67949] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3041), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [68027] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3042), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68085] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4684), 1,
      anon_sym_QMARK,
    ACTIONS(4686), 1,
      anon_sym_PIPE_PIPE,
    STATE(3043), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [68173] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4684), 1,
      anon_sym_QMARK,
    ACTIONS(4686), 1,
      anon_sym_PIPE_PIPE,
    STATE(3044), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [68261] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    STATE(2929), 1,
      sym_do_block,
    STATE(2931), 1,
      sym_block,
    STATE(3045), 1,
      sym_heredoc_body,
    ACTIONS(3175), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3173), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68323] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3046), 1,
      sym_heredoc_body,
    ACTIONS(3337), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3339), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3335), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68381] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4686), 1,
      anon_sym_PIPE_PIPE,
    STATE(3047), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [68467] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4684), 1,
      anon_sym_QMARK,
    ACTIONS(4686), 1,
      anon_sym_PIPE_PIPE,
    STATE(3048), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [68555] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    STATE(2937), 1,
      sym_do_block,
    STATE(2940), 1,
      sym_block,
    STATE(3049), 1,
      sym_heredoc_body,
    ACTIONS(3171), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3169), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68617] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4599), 1,
      anon_sym_rescue,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4684), 1,
      anon_sym_QMARK,
    ACTIONS(4686), 1,
      anon_sym_PIPE_PIPE,
    STATE(3050), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [68707] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4684), 1,
      anon_sym_QMARK,
    ACTIONS(4686), 1,
      anon_sym_PIPE_PIPE,
    STATE(3051), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [68795] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3052), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68851] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4688), 1,
      sym__binary_star_star,
    STATE(3053), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68909] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3054), 1,
      sym_heredoc_body,
    ACTIONS(3337), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3335), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [68965] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3055), 1,
      sym_heredoc_body,
    ACTIONS(3501), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3503), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(3499), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69023] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3056), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69079] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3057), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69149] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4690), 1,
      sym__binary_star_star,
    STATE(3058), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69207] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COMMA,
    STATE(3059), 1,
      sym_heredoc_body,
    STATE(3061), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69267] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(99), 1,
      sym__string_start,
    ACTIONS(4694), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      aux_sym_chained_string_repeat1,
    STATE(2203), 1,
      sym_string,
    STATE(3060), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69331] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    STATE(3061), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69389] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4684), 1,
      anon_sym_QMARK,
    ACTIONS(4686), 1,
      anon_sym_PIPE_PIPE,
    STATE(3062), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [69477] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    ACTIONS(4699), 1,
      anon_sym_COLON,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    STATE(3063), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69541] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3059), 1,
      aux_sym_exceptions_repeat1,
    STATE(3064), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69599] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3065), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69657] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    ACTIONS(4701), 1,
      anon_sym_rescue,
    STATE(3066), 1,
      sym_heredoc_body,
    STATE(3096), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [69749] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym___END__,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4622), 1,
      anon_sym_rescue,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3059), 1,
      aux_sym_exceptions_repeat1,
    STATE(3067), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [69845] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    STATE(2946), 1,
      sym_do_block,
    STATE(2957), 1,
      sym_block,
    STATE(3068), 1,
      sym_heredoc_body,
    ACTIONS(3179), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3177), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69907] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3069), 1,
      sym_heredoc_body,
    ACTIONS(3501), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3499), 34,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [69963] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3070), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3341), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(2962), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70021] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4703), 1,
      sym__binary_star_star,
    STATE(3071), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70079] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3072), 1,
      sym_heredoc_body,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70139] = 26,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym___END__,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    ACTIONS(4692), 1,
      anon_sym_COMMA,
    ACTIONS(4705), 1,
      anon_sym_rescue,
    STATE(3059), 1,
      aux_sym_exceptions_repeat1,
    STATE(3073), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [70237] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3074), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3125), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_EQ_GT,
    ACTIONS(2962), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70295] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3075), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70353] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4692), 1,
      anon_sym_COMMA,
    STATE(3059), 1,
      aux_sym_exceptions_repeat1,
    STATE(3076), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70413] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4686), 1,
      anon_sym_PIPE_PIPE,
    STATE(3077), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [70499] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3078), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 33,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70557] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3079), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70623] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    ACTIONS(4692), 1,
      anon_sym_COMMA,
    ACTIONS(4705), 1,
      anon_sym_rescue,
    STATE(3059), 1,
      aux_sym_exceptions_repeat1,
    STATE(3080), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [70717] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4599), 1,
      anon_sym_rescue,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4684), 1,
      anon_sym_QMARK,
    ACTIONS(4686), 1,
      anon_sym_PIPE_PIPE,
    STATE(3081), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [70807] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    STATE(3082), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70871] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    ACTIONS(3125), 1,
      anon_sym_EQ_GT,
    ACTIONS(4707), 1,
      anon_sym_COLON,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    STATE(3083), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [70937] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3084), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71000] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    STATE(2152), 1,
      sym_constant_suffix,
    STATE(2153), 1,
      sym_identifier_suffix,
    STATE(2736), 1,
      sym_argument_list,
    STATE(3085), 1,
      sym_heredoc_body,
    ACTIONS(4709), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4715), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4717), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2148), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4713), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4711), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [71071] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3086), 1,
      sym_heredoc_body,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 29,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71130] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4719), 1,
      anon_sym_COMMA,
    STATE(3087), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71187] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3088), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [71274] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3089), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71331] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(1898), 1,
      sym_constant_suffix,
    STATE(1899), 1,
      sym_identifier_suffix,
    STATE(2183), 1,
      sym_argument_list,
    STATE(3090), 1,
      sym_heredoc_body,
    ACTIONS(4722), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4728), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4730), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1901), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4726), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4724), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [71402] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    ACTIONS(4732), 1,
      sym_identifier,
    ACTIONS(4738), 1,
      sym_constant,
    STATE(1915), 1,
      sym_constant_suffix,
    STATE(1919), 1,
      sym_identifier_suffix,
    STATE(2736), 1,
      sym_argument_list,
    STATE(3091), 1,
      sym_heredoc_body,
    ACTIONS(4740), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4742), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1927), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4736), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4734), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [71475] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3092), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71532] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2034), 1,
      sym_identifier_suffix,
    STATE(2042), 1,
      sym_constant_suffix,
    STATE(2183), 1,
      sym_argument_list,
    STATE(3093), 1,
      sym_heredoc_body,
    ACTIONS(4744), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4750), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4752), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2040), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4748), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4746), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [71603] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(1898), 1,
      sym_constant_suffix,
    STATE(1899), 1,
      sym_identifier_suffix,
    STATE(2176), 1,
      sym_argument_list,
    STATE(3094), 1,
      sym_heredoc_body,
    ACTIONS(4722), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4728), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4730), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1901), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4726), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4724), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [71674] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3095), 1,
      sym_heredoc_body,
    STATE(3123), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71731] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4754), 1,
      anon_sym_COMMA,
    STATE(3096), 1,
      sym_heredoc_body,
    STATE(3103), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [71790] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3097), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [71877] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    STATE(3098), 1,
      sym_heredoc_body,
    STATE(4749), 1,
      sym_constant_suffix,
    STATE(4757), 1,
      sym_identifier_suffix,
    STATE(4927), 1,
      sym_argument_list,
    ACTIONS(2656), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2680), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(4756), 2,
      sym_constant,
      sym_identifier,
    STATE(4753), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4760), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4758), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [71948] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4764), 1,
      anon_sym_COMMA,
    STATE(3099), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72005] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4606), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3100), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [72096] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    ACTIONS(4767), 1,
      anon_sym_COLON,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    STATE(3101), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72159] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4769), 1,
      sym_identifier,
    ACTIONS(4775), 1,
      sym_constant,
    STATE(1883), 1,
      sym_constant_suffix,
    STATE(1884), 1,
      sym_identifier_suffix,
    STATE(2176), 1,
      sym_argument_list,
    STATE(3102), 1,
      sym_heredoc_body,
    ACTIONS(4777), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4779), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1887), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4773), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4771), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72232] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4781), 1,
      anon_sym_COMMA,
    STATE(3103), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72289] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    ACTIONS(4784), 1,
      anon_sym___END__,
    STATE(3104), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4380), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [72376] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3105), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72441] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3106), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [72526] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4786), 1,
      anon_sym_rescue,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3107), 1,
      sym_heredoc_body,
    STATE(3123), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [72617] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3108), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72678] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4769), 1,
      sym_identifier,
    ACTIONS(4820), 1,
      sym_constant,
    STATE(1883), 1,
      sym_constant_suffix,
    STATE(1884), 1,
      sym_identifier_suffix,
    STATE(2176), 1,
      sym_argument_list,
    STATE(3109), 1,
      sym_heredoc_body,
    ACTIONS(4777), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4779), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1887), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4773), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4771), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72751] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3110), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym___END__,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [72820] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3111), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [72905] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4722), 1,
      sym_identifier,
    ACTIONS(4822), 1,
      sym_constant,
    STATE(1898), 1,
      sym_constant_suffix,
    STATE(1899), 1,
      sym_identifier_suffix,
    STATE(2176), 1,
      sym_argument_list,
    STATE(3112), 1,
      sym_heredoc_body,
    ACTIONS(4728), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4730), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1901), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4726), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4724), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [72978] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3113), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73035] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    ACTIONS(4824), 1,
      anon_sym___END__,
    STATE(3114), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4384), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [73122] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    ACTIONS(4709), 1,
      sym_identifier,
    ACTIONS(4826), 1,
      sym_constant,
    STATE(2152), 1,
      sym_constant_suffix,
    STATE(2153), 1,
      sym_identifier_suffix,
    STATE(3049), 1,
      sym_argument_list,
    STATE(3115), 1,
      sym_heredoc_body,
    ACTIONS(4715), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4717), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2148), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4713), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4711), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73195] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3116), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [73286] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4622), 1,
      anon_sym_rescue,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3117), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [73379] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    ACTIONS(4828), 1,
      anon_sym___END__,
    STATE(3118), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4382), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [73466] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    ACTIONS(4830), 1,
      anon_sym_rescue,
    STATE(3119), 1,
      sym_heredoc_body,
    STATE(3249), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [73557] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(1883), 1,
      sym_constant_suffix,
    STATE(1884), 1,
      sym_identifier_suffix,
    STATE(2183), 1,
      sym_argument_list,
    STATE(3120), 1,
      sym_heredoc_body,
    ACTIONS(4769), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4777), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4779), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1887), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4773), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4771), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73628] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4769), 1,
      sym_identifier,
    ACTIONS(4832), 1,
      sym_constant,
    STATE(1883), 1,
      sym_constant_suffix,
    STATE(1884), 1,
      sym_identifier_suffix,
    STATE(2183), 1,
      sym_argument_list,
    STATE(3121), 1,
      sym_heredoc_body,
    ACTIONS(4777), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4779), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1887), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4773), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4771), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73701] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    STATE(2152), 1,
      sym_constant_suffix,
    STATE(2153), 1,
      sym_identifier_suffix,
    STATE(3049), 1,
      sym_argument_list,
    STATE(3122), 1,
      sym_heredoc_body,
    ACTIONS(4709), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4715), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4717), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2148), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4713), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4711), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73772] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4834), 1,
      anon_sym_COMMA,
    STATE(3099), 1,
      aux_sym_exceptions_repeat1,
    STATE(3123), 1,
      sym_heredoc_body,
    ACTIONS(3978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [73831] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4744), 1,
      sym_identifier,
    ACTIONS(4836), 1,
      sym_constant,
    STATE(2034), 1,
      sym_identifier_suffix,
    STATE(2042), 1,
      sym_constant_suffix,
    STATE(2183), 1,
      sym_argument_list,
    STATE(3124), 1,
      sym_heredoc_body,
    ACTIONS(4750), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4752), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2040), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4748), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4746), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [73904] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    ACTIONS(4838), 1,
      anon_sym___END__,
    STATE(3125), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [73991] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(2034), 1,
      sym_identifier_suffix,
    STATE(2042), 1,
      sym_constant_suffix,
    STATE(2176), 1,
      sym_argument_list,
    STATE(3126), 1,
      sym_heredoc_body,
    ACTIONS(4744), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4750), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4752), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2040), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4748), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4746), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74062] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    STATE(3127), 1,
      sym_heredoc_body,
    STATE(4766), 1,
      sym_identifier_suffix,
    STATE(4807), 1,
      sym_constant_suffix,
    STATE(4927), 1,
      sym_argument_list,
    ACTIONS(4840), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4846), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4848), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4794), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4844), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4842), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74133] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    ACTIONS(4701), 1,
      anon_sym_rescue,
    STATE(3128), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [74222] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4744), 1,
      sym_identifier,
    ACTIONS(4850), 1,
      sym_constant,
    STATE(2034), 1,
      sym_identifier_suffix,
    STATE(2042), 1,
      sym_constant_suffix,
    STATE(2176), 1,
      sym_argument_list,
    STATE(3129), 1,
      sym_heredoc_body,
    ACTIONS(4750), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4752), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2040), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4748), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4746), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74295] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    ACTIONS(4709), 1,
      sym_identifier,
    ACTIONS(4852), 1,
      sym_constant,
    STATE(2152), 1,
      sym_constant_suffix,
    STATE(2153), 1,
      sym_identifier_suffix,
    STATE(2736), 1,
      sym_argument_list,
    STATE(3130), 1,
      sym_heredoc_body,
    ACTIONS(4715), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4717), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2148), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4713), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4711), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74368] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4854), 1,
      anon_sym_DOT,
    ACTIONS(4856), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(4858), 1,
      anon_sym_AMP_DOT,
    ACTIONS(4860), 1,
      sym__element_reference_bracket,
    STATE(3131), 1,
      sym_heredoc_body,
    ACTIONS(3441), 8,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [74431] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4606), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    ACTIONS(4862), 1,
      anon_sym_EQ_GT,
    STATE(3132), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [74522] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3133), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [74601] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4744), 1,
      sym_identifier,
    ACTIONS(4864), 1,
      sym_constant,
    STATE(2034), 1,
      sym_identifier_suffix,
    STATE(2042), 1,
      sym_constant_suffix,
    STATE(2183), 1,
      sym_argument_list,
    STATE(3134), 1,
      sym_heredoc_body,
    ACTIONS(4750), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4752), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2040), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4748), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4746), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74674] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    ACTIONS(4732), 1,
      sym_identifier,
    ACTIONS(4866), 1,
      sym_constant,
    STATE(1915), 1,
      sym_constant_suffix,
    STATE(1919), 1,
      sym_identifier_suffix,
    STATE(3049), 1,
      sym_argument_list,
    STATE(3135), 1,
      sym_heredoc_body,
    ACTIONS(4740), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4742), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1927), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4736), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4734), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [74747] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3136), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [74838] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(3871), 1,
      anon_sym_PIPE,
    ACTIONS(3873), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_AMP,
    ACTIONS(3879), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3881), 1,
      anon_sym_CARET,
    ACTIONS(3883), 1,
      anon_sym_QMARK,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3891), 1,
      anon_sym_GT_EQ,
    ACTIONS(3897), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3901), 1,
      sym__binary_star_star,
    ACTIONS(4701), 1,
      anon_sym_rescue,
    STATE(3137), 1,
      sym_heredoc_body,
    ACTIONS(3889), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3893), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3877), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3895), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3899), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [74927] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4872), 1,
      anon_sym_EQ2,
    STATE(3138), 1,
      sym_heredoc_body,
    ACTIONS(4868), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(4870), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [74984] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3139), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 18,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [75061] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    STATE(1915), 1,
      sym_constant_suffix,
    STATE(1919), 1,
      sym_identifier_suffix,
    STATE(2736), 1,
      sym_argument_list,
    STATE(3140), 1,
      sym_heredoc_body,
    ACTIONS(4732), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4740), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4742), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1927), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4736), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4734), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75132] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    ACTIONS(4426), 1,
      anon_sym_COLON,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    STATE(3141), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [75195] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4769), 1,
      sym_identifier,
    ACTIONS(4874), 1,
      sym_constant,
    STATE(1883), 1,
      sym_constant_suffix,
    STATE(1884), 1,
      sym_identifier_suffix,
    STATE(2183), 1,
      sym_argument_list,
    STATE(3142), 1,
      sym_heredoc_body,
    ACTIONS(4777), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4779), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1887), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4773), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4771), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75268] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4756), 1,
      sym_identifier,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    ACTIONS(4876), 1,
      sym_constant,
    STATE(3143), 1,
      sym_heredoc_body,
    STATE(4749), 1,
      sym_constant_suffix,
    STATE(4757), 1,
      sym_identifier_suffix,
    STATE(4927), 1,
      sym_argument_list,
    ACTIONS(2656), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2680), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4753), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4760), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4758), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75341] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3144), 1,
      sym_heredoc_body,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [75402] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3449), 1,
      sym__element_reference_bracket,
    ACTIONS(4034), 1,
      anon_sym_DOT,
    ACTIONS(4038), 1,
      anon_sym_AMP_DOT,
    ACTIONS(4878), 1,
      anon_sym_COLON_COLON2,
    STATE(3145), 1,
      sym_heredoc_body,
    ACTIONS(3441), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [75465] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3146), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [75552] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3147), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [75639] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4622), 1,
      anon_sym_rescue,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3148), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [75728] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4756), 1,
      sym_identifier,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    ACTIONS(4880), 1,
      sym_constant,
    STATE(3149), 1,
      sym_heredoc_body,
    STATE(4749), 1,
      sym_constant_suffix,
    STATE(4757), 1,
      sym_identifier_suffix,
    STATE(4927), 1,
      sym_argument_list,
    ACTIONS(2656), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2680), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4753), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4760), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4758), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75801] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    ACTIONS(4840), 1,
      sym_identifier,
    ACTIONS(4882), 1,
      sym_constant,
    STATE(3150), 1,
      sym_heredoc_body,
    STATE(4766), 1,
      sym_identifier_suffix,
    STATE(4807), 1,
      sym_constant_suffix,
    STATE(4927), 1,
      sym_argument_list,
    ACTIONS(4846), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4848), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(4794), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4844), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4842), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [75874] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3151), 1,
      sym_heredoc_body,
    STATE(3152), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [75931] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4884), 1,
      anon_sym_COMMA,
    STATE(3087), 1,
      aux_sym_exceptions_repeat1,
    STATE(3152), 1,
      sym_heredoc_body,
    ACTIONS(3978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [75990] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3153), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 18,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [76067] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_PIPE,
    ACTIONS(4484), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4486), 1,
      anon_sym_AMP,
    ACTIONS(4494), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4496), 1,
      anon_sym_CARET,
    ACTIONS(4498), 1,
      anon_sym_QMARK,
    ACTIONS(4500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4502), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4506), 1,
      anon_sym_GT_EQ,
    ACTIONS(4512), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4516), 1,
      sym__binary_star_star,
    ACTIONS(4886), 1,
      anon_sym___END__,
    STATE(3154), 1,
      sym_heredoc_body,
    ACTIONS(4504), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4508), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4488), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4510), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4514), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4344), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [76154] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4888), 1,
      anon_sym_rescue,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3152), 1,
      aux_sym_exceptions_repeat1,
    STATE(3155), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [76245] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3156), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76302] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3157), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [76389] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4722), 1,
      sym_identifier,
    ACTIONS(4922), 1,
      sym_constant,
    STATE(1898), 1,
      sym_constant_suffix,
    STATE(1899), 1,
      sym_identifier_suffix,
    STATE(2183), 1,
      sym_argument_list,
    STATE(3158), 1,
      sym_heredoc_body,
    ACTIONS(4728), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4730), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1901), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4726), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4724), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [76462] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    ACTIONS(4924), 1,
      anon_sym_rescue,
    STATE(3159), 1,
      sym_heredoc_body,
    STATE(3210), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [76553] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(279), 1,
      anon_sym_LPAREN2,
    STATE(1915), 1,
      sym_constant_suffix,
    STATE(1919), 1,
      sym_identifier_suffix,
    STATE(3049), 1,
      sym_argument_list,
    STATE(3160), 1,
      sym_heredoc_body,
    ACTIONS(4732), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4740), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4742), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1927), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4736), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4734), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [76624] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    ACTIONS(4769), 1,
      sym_identifier,
    ACTIONS(4926), 1,
      sym_constant,
    STATE(1883), 1,
      sym_constant_suffix,
    STATE(1884), 1,
      sym_identifier_suffix,
    STATE(2183), 1,
      sym_argument_list,
    STATE(3161), 1,
      sym_heredoc_body,
    ACTIONS(4777), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4779), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1887), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4773), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4771), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [76697] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3162), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [76784] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3096), 1,
      aux_sym_exceptions_repeat1,
    STATE(3163), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [76841] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_LPAREN2,
    STATE(1883), 1,
      sym_constant_suffix,
    STATE(1884), 1,
      sym_identifier_suffix,
    STATE(2176), 1,
      sym_argument_list,
    STATE(3164), 1,
      sym_heredoc_body,
    ACTIONS(4769), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(4777), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(4779), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(1887), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(4773), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4771), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [76912] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym___END__,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    STATE(3165), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [76999] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3166), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77055] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4940), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3167), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [77145] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3168), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77201] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3159), 1,
      anon_sym_COLON,
    STATE(3169), 1,
      sym_heredoc_body,
    ACTIONS(2578), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2580), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77257] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3159), 1,
      anon_sym_COLON,
    STATE(3170), 1,
      sym_heredoc_body,
    ACTIONS(2582), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2584), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77313] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4940), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3171), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [77403] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4888), 1,
      anon_sym_rescue,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3172), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [77491] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4960), 1,
      anon_sym_COMMA,
    STATE(3173), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77547] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3174), 1,
      sym_heredoc_body,
    ACTIONS(3499), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3695), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [77603] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3175), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [77689] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3176), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [77775] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3177), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 14,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [77859] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3178), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [77945] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3179), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [78031] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    ACTIONS(4830), 1,
      anon_sym_rescue,
    STATE(3180), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [78119] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3181), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [78205] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3182), 1,
      sym_heredoc_body,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__line_break,
      sym__binary_minus,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78263] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3183), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78319] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3184), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78375] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3185), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78439] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym___END__,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3186), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [78523] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3187), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78585] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3188), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym___END__,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78653] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym___END__,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4940), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3189), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [78739] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3190), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [78817] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3191), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [78893] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3192), 1,
      sym_heredoc_body,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [78953] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3193), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [79029] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4965), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4975), 1,
      anon_sym_QMARK,
    ACTIONS(4977), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4979), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3194), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [79115] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4965), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4975), 1,
      anon_sym_QMARK,
    ACTIONS(4977), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4979), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3195), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [79201] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4965), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4977), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4979), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3196), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [79285] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4965), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4975), 1,
      anon_sym_QMARK,
    ACTIONS(4977), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4979), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3197), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [79371] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4965), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4975), 1,
      anon_sym_QMARK,
    ACTIONS(4977), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4979), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3198), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [79457] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4995), 1,
      sym__binary_star_star,
    STATE(3199), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79513] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3200), 1,
      sym_heredoc_body,
    ACTIONS(3723), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(3721), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [79567] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4997), 1,
      sym__binary_star_star,
    STATE(3201), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79623] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3202), 1,
      sym_heredoc_body,
    ACTIONS(3779), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(3777), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [79677] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4786), 1,
      anon_sym_rescue,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3203), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [79765] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4705), 1,
      anon_sym_rescue,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4940), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3204), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [79857] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3205), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [79913] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3206), 1,
      sym_heredoc_body,
    ACTIONS(2578), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2580), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [79967] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3207), 1,
      sym_heredoc_body,
    ACTIONS(2582), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2584), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [80021] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym___END__,
    ACTIONS(4705), 1,
      anon_sym_rescue,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4940), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3208), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [80109] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3209), 1,
      sym_heredoc_body,
    ACTIONS(3695), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80163] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4999), 1,
      anon_sym_COMMA,
    STATE(3210), 1,
      sym_heredoc_body,
    STATE(3218), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80221] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5001), 1,
      sym__binary_star_star,
    STATE(3211), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80277] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym___END__,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3212), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [80361] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3213), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [80447] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3214), 1,
      sym_heredoc_body,
    ACTIONS(2586), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2588), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [80501] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3215), 1,
      sym_heredoc_body,
    ACTIONS(2590), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2592), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [80555] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3216), 1,
      sym_heredoc_body,
    ACTIONS(2574), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2576), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [80609] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3217), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [80695] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5003), 1,
      anon_sym_COMMA,
    STATE(3218), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80751] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4606), 1,
      anon_sym___END__,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4940), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3219), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [80841] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5006), 1,
      sym__binary_star_star,
    STATE(3220), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80897] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5008), 1,
      sym__binary_star_star,
    STATE(3221), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [80953] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3125), 1,
      anon_sym_EQ_GT,
    STATE(3222), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81009] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    ACTIONS(5010), 1,
      anon_sym_rescue,
    ACTIONS(5012), 1,
      anon_sym_COMMA,
    STATE(3223), 1,
      sym_heredoc_body,
    STATE(3363), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [81101] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    ACTIONS(5014), 1,
      anon_sym_rescue,
    STATE(3224), 1,
      sym_heredoc_body,
    STATE(3363), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [81191] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3341), 1,
      anon_sym_EQ_GT,
    STATE(3225), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81247] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4940), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3226), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [81333] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym___END__,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4940), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3227), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [81419] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_EQ_GT,
    STATE(3228), 1,
      sym_heredoc_body,
    ACTIONS(3501), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3499), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81475] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3339), 1,
      anon_sym_EQ_GT,
    STATE(3229), 1,
      sym_heredoc_body,
    ACTIONS(3337), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3335), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81531] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5016), 1,
      anon_sym_rescue,
    ACTIONS(5018), 1,
      anon_sym_COMMA,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3230), 1,
      sym_heredoc_body,
    STATE(3257), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [81625] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    ACTIONS(4924), 1,
      anon_sym_rescue,
    STATE(3231), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [81713] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_COLON,
    STATE(3232), 1,
      sym_heredoc_body,
    ACTIONS(2578), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2580), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81769] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_COLON,
    STATE(3233), 1,
      sym_heredoc_body,
    ACTIONS(2582), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2584), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81825] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3234), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [81881] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3235), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 14,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [81965] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_rescue,
    ACTIONS(5018), 1,
      anon_sym_COMMA,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3236), 1,
      sym_heredoc_body,
    STATE(3257), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [82055] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3237), 1,
      sym_heredoc_body,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82113] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3238), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82169] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3239), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82225] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3240), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82289] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3241), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82351] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3242), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82419] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3243), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [82497] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3244), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [82573] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3245), 1,
      sym_heredoc_body,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82633] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3246), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [82709] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3247), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82765] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4888), 1,
      anon_sym_rescue,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3248), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [82853] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5052), 1,
      anon_sym_COMMA,
    STATE(3249), 1,
      sym_heredoc_body,
    STATE(3253), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82911] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4490), 1,
      anon_sym_in,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3250), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym___END__,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [82971] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3251), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83057] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3252), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83143] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5054), 1,
      anon_sym_COMMA,
    STATE(3253), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83199] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5057), 1,
      sym__binary_star_star,
    STATE(3254), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83255] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3249), 1,
      aux_sym_exceptions_repeat1,
    STATE(3255), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83311] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_COMMA,
    STATE(3256), 1,
      sym_heredoc_body,
    STATE(3257), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83369] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5018), 1,
      anon_sym_COMMA,
    STATE(3173), 1,
      aux_sym_exceptions_repeat1,
    STATE(3257), 1,
      sym_heredoc_body,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83427] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4860), 1,
      sym__element_reference_bracket,
    ACTIONS(5059), 1,
      anon_sym_DOT,
    ACTIONS(5061), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(5063), 1,
      anon_sym_AMP_DOT,
    STATE(3258), 1,
      sym_heredoc_body,
    ACTIONS(3441), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83489] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    ACTIONS(4830), 1,
      anon_sym_rescue,
    STATE(3259), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [83577] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    ACTIONS(4426), 1,
      anon_sym_COLON,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    STATE(3260), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83639] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3261), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83695] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3262), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 14,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [83779] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3263), 1,
      sym_heredoc_body,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83837] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3264), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83893] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3265), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [83949] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3266), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84013] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3267), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84075] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3268), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84143] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3269), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [84221] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3270), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [84297] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3271), 1,
      sym_heredoc_body,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84357] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3272), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [84433] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4786), 1,
      anon_sym_rescue,
    ACTIONS(4788), 1,
      anon_sym_PIPE,
    ACTIONS(4790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4792), 1,
      anon_sym_AMP,
    ACTIONS(4796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4798), 1,
      anon_sym_CARET,
    ACTIONS(4800), 1,
      anon_sym_QMARK,
    ACTIONS(4802), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4808), 1,
      anon_sym_GT_EQ,
    ACTIONS(4814), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4818), 1,
      sym__binary_star_star,
    STATE(3273), 1,
      sym_heredoc_body,
    ACTIONS(4806), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4810), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4794), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4812), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4816), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [84521] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4860), 1,
      sym__element_reference_bracket,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5067), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(5069), 1,
      anon_sym_AMP_DOT,
    STATE(3274), 1,
      sym_heredoc_body,
    ACTIONS(3441), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84583] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3275), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84639] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4965), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4977), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4979), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3276), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [84723] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4965), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4975), 1,
      anon_sym_QMARK,
    ACTIONS(4977), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4979), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3277), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [84809] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3278), 1,
      sym_heredoc_body,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84867] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3279), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84923] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3280), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [84979] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3281), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85043] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3282), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85105] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3283), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85173] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4979), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3284), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [85251] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3285), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [85327] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3286), 1,
      sym_heredoc_body,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85387] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3287), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [85463] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3288), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [85519] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3289), 1,
      sym_heredoc_body,
    ACTIONS(4868), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(4870), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [85573] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3290), 1,
      sym_heredoc_body,
    ACTIONS(2562), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(2564), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [85627] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3291), 1,
      sym_heredoc_body,
    ACTIONS(5071), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
      sym_constant,
      sym_identifier,
    ACTIONS(5073), 28,
      sym_simple_symbol,
      sym__symbol_start,
      sym__identifier_suffix,
      sym__constant_suffix,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
      aux_sym_constant_suffix_token1,
      aux_sym_identifier_suffix_token1,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [85681] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym___END__,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4940), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3292), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [85767] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3293), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [85853] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3294), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [85939] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3295), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 14,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [86023] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3296), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86109] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3297), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86195] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3210), 1,
      aux_sym_exceptions_repeat1,
    STATE(3298), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 31,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86251] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    ACTIONS(4924), 1,
      anon_sym_rescue,
    STATE(3299), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86339] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    STATE(3300), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86425] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    ACTIONS(5075), 1,
      anon_sym_rescue,
    STATE(3257), 1,
      aux_sym_exceptions_repeat1,
    STATE(3301), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [86517] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    ACTIONS(5075), 1,
      anon_sym_rescue,
    STATE(3257), 1,
      aux_sym_exceptions_repeat1,
    STATE(3302), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [86605] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_DOT,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4965), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4975), 1,
      anon_sym_QMARK,
    ACTIONS(4977), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4979), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3303), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86691] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(4965), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4967), 1,
      anon_sym_AMP,
    ACTIONS(4971), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4973), 1,
      anon_sym_CARET,
    ACTIONS(4975), 1,
      anon_sym_QMARK,
    ACTIONS(4977), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4979), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4983), 1,
      anon_sym_GT_EQ,
    ACTIONS(4989), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4993), 1,
      sym__binary_star_star,
    STATE(3304), 1,
      sym_heredoc_body,
    ACTIONS(4981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4985), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4969), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4987), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4991), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [86777] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3257), 1,
      aux_sym_exceptions_repeat1,
    STATE(3305), 1,
      sym_heredoc_body,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 32,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [86833] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym___END__,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4940), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3306), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [86919] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3307), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [87002] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5089), 1,
      anon_sym_QMARK,
    ACTIONS(5091), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3308), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [87087] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5091), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3309), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [87170] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5109), 1,
      sym__binary_star_star,
    STATE(3310), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87225] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2778), 1,
      sym_simple_symbol,
    ACTIONS(2780), 1,
      sym__string_start,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(2784), 1,
      sym__subshell_start,
    ACTIONS(2786), 1,
      sym__regex_start,
    ACTIONS(2788), 1,
      sym__string_array_start,
    ACTIONS(2790), 1,
      sym__symbol_array_start,
    ACTIONS(2792), 1,
      sym_heredoc_beginning,
    ACTIONS(3072), 1,
      anon_sym_nil,
    ACTIONS(3076), 1,
      anon_sym_DASH_GT,
    STATE(3311), 1,
      sym_heredoc_body,
    STATE(4311), 1,
      sym_nil,
    STATE(4345), 1,
      sym_lambda,
    STATE(4382), 1,
      sym__pattern_primitive,
    STATE(5480), 1,
      sym__int_or_float,
    ACTIONS(2858), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2860), 2,
      sym_integer,
      sym_float,
    STATE(4327), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4340), 2,
      sym_complex,
      sym_rational,
    STATE(4348), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4352), 2,
      sym__numeric,
      sym_delimited_symbol,
    ACTIONS(3074), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4338), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [87318] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2778), 1,
      sym_simple_symbol,
    ACTIONS(2780), 1,
      sym__string_start,
    ACTIONS(2782), 1,
      sym__symbol_start,
    ACTIONS(2784), 1,
      sym__subshell_start,
    ACTIONS(2786), 1,
      sym__regex_start,
    ACTIONS(2788), 1,
      sym__string_array_start,
    ACTIONS(2790), 1,
      sym__symbol_array_start,
    ACTIONS(2792), 1,
      sym_heredoc_beginning,
    ACTIONS(3072), 1,
      anon_sym_nil,
    ACTIONS(3076), 1,
      anon_sym_DASH_GT,
    STATE(3312), 1,
      sym_heredoc_body,
    STATE(4311), 1,
      sym_nil,
    STATE(4345), 1,
      sym_lambda,
    STATE(4382), 1,
      sym__pattern_primitive,
    STATE(5480), 1,
      sym__int_or_float,
    ACTIONS(2770), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2772), 2,
      sym_integer,
      sym_float,
    STATE(4327), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4340), 2,
      sym_complex,
      sym_rational,
    STATE(4348), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4352), 2,
      sym__numeric,
      sym_delimited_symbol,
    ACTIONS(3074), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4338), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [87411] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4703), 1,
      sym__binary_star_star,
    STATE(3313), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87466] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5089), 1,
      anon_sym_QMARK,
    ACTIONS(5091), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3314), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [87551] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3315), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87606] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5091), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3316), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 13,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [87689] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(4221), 1,
      anon_sym_nil,
    ACTIONS(4225), 1,
      anon_sym_DASH_GT,
    STATE(3317), 1,
      sym_heredoc_body,
    STATE(4648), 1,
      sym_lambda,
    STATE(4662), 1,
      sym_nil,
    STATE(4742), 1,
      sym__pattern_primitive,
    STATE(5423), 1,
      sym__int_or_float,
    ACTIONS(2878), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2880), 2,
      sym_integer,
      sym_float,
    STATE(4651), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4659), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4666), 2,
      sym_complex,
      sym_rational,
    STATE(4668), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(4223), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4658), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [87782] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5089), 1,
      anon_sym_QMARK,
    ACTIONS(5091), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3318), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [87867] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2030), 1,
      sym_constant_suffix,
    STATE(2031), 1,
      sym_identifier_suffix,
    STATE(3319), 1,
      sym_heredoc_body,
    ACTIONS(5111), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(5117), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(5119), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2032), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(5115), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5113), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [87932] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3320), 1,
      sym_heredoc_body,
    ACTIONS(3747), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3745), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [87985] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5089), 1,
      anon_sym_QMARK,
    ACTIONS(5091), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3321), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [88070] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    ACTIONS(5014), 1,
      anon_sym_rescue,
    STATE(3322), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [88157] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2832), 1,
      sym_simple_symbol,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(2836), 1,
      sym__symbol_start,
    ACTIONS(2838), 1,
      sym__subshell_start,
    ACTIONS(2840), 1,
      sym__regex_start,
    ACTIONS(2842), 1,
      sym__string_array_start,
    ACTIONS(2844), 1,
      sym__symbol_array_start,
    ACTIONS(2846), 1,
      sym_heredoc_beginning,
    ACTIONS(4221), 1,
      anon_sym_nil,
    ACTIONS(4225), 1,
      anon_sym_DASH_GT,
    STATE(3323), 1,
      sym_heredoc_body,
    STATE(4648), 1,
      sym_lambda,
    STATE(4662), 1,
      sym_nil,
    STATE(4742), 1,
      sym__pattern_primitive,
    STATE(5423), 1,
      sym__int_or_float,
    ACTIONS(2820), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2822), 2,
      sym_integer,
      sym_float,
    STATE(4651), 2,
      sym__numeric,
      sym_delimited_symbol,
    STATE(4659), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4666), 2,
      sym_complex,
      sym_rational,
    STATE(4668), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    ACTIONS(4223), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4658), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [88250] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_COMMA,
    STATE(3324), 1,
      sym_heredoc_body,
    STATE(3363), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88307] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3325), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [88390] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    STATE(3326), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88445] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5131), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5135), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    STATE(3327), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [88528] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    ACTIONS(4838), 1,
      anon_sym___END__,
    STATE(3328), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [88613] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5131), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5135), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5151), 1,
      anon_sym_QMARK,
    STATE(3329), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [88698] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3330), 1,
      sym_heredoc_body,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88755] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3331), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88810] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3332), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88865] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3333), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88928] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3334), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [88989] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3335), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89056] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3336), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 15,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [89133] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3337), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [89208] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3338), 1,
      sym_heredoc_body,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89267] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3339), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [89342] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3340), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89397] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    STATE(3341), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89456] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3342), 1,
      sym_heredoc_body,
    ACTIONS(3441), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89509] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3343), 1,
      sym_heredoc_body,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89562] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_DOT,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5131), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5135), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5151), 1,
      anon_sym_QMARK,
    STATE(3344), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [89647] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5153), 1,
      anon_sym_COMMA,
    STATE(3345), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89702] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5131), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5135), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5151), 1,
      anon_sym_QMARK,
    STATE(3346), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [89787] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3347), 1,
      sym_heredoc_body,
    ACTIONS(3527), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3525), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [89840] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2778), 1,
      sym_simple_symbol,
    ACTIONS(2780), 1,
      sym__string_start,
    ACTIONS(2784), 1,
      sym__subshell_start,
    ACTIONS(2786), 1,
      sym__regex_start,
    ACTIONS(2788), 1,
      sym__string_array_start,
    ACTIONS(2790), 1,
      sym__symbol_array_start,
    ACTIONS(2792), 1,
      sym_heredoc_beginning,
    ACTIONS(2870), 1,
      sym__symbol_start,
    ACTIONS(3072), 1,
      anon_sym_nil,
    ACTIONS(3076), 1,
      anon_sym_DASH_GT,
    STATE(3348), 1,
      sym_heredoc_body,
    STATE(4311), 1,
      sym_nil,
    STATE(4345), 1,
      sym_lambda,
    STATE(4382), 1,
      sym__pattern_primitive,
    STATE(5480), 1,
      sym__int_or_float,
    ACTIONS(2770), 2,
      sym__unary_minus_num,
      anon_sym_PLUS,
    ACTIONS(2772), 2,
      sym_integer,
      sym_float,
    STATE(4327), 2,
      sym_unary_literal,
      sym__simple_numeric,
    STATE(4340), 2,
      sym_complex,
      sym_rational,
    STATE(4348), 2,
      sym__pattern_lambda,
      sym__pattern_literal,
    STATE(4352), 2,
      sym__numeric,
      sym_delimited_symbol,
    ACTIONS(3074), 6,
      sym_line,
      sym_file,
      sym_encoding,
      sym_self,
      sym_true,
      sym_false,
    STATE(4338), 7,
      sym__keyword_variable,
      sym__literal,
      sym_string,
      sym_subshell,
      sym_string_array,
      sym_symbol_array,
      sym_regex,
  [89933] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    ACTIONS(4828), 1,
      anon_sym___END__,
    STATE(3349), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4382), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [90018] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    ACTIONS(4824), 1,
      anon_sym___END__,
    STATE(3350), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4384), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [90103] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3351), 1,
      sym_heredoc_body,
    ACTIONS(3225), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3223), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90156] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3352), 1,
      sym_heredoc_body,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90209] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3353), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 32,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90262] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    ACTIONS(4886), 1,
      anon_sym___END__,
    STATE(3354), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4344), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [90347] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3199), 1,
      anon_sym_COLON,
    STATE(3355), 1,
      sym_heredoc_body,
    ACTIONS(2578), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2580), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90402] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3199), 1,
      anon_sym_COLON,
    STATE(3356), 1,
      sym_heredoc_body,
    ACTIONS(2582), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2584), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90457] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    STATE(3357), 1,
      sym_heredoc_body,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90514] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5156), 1,
      sym__binary_star_star,
    STATE(3358), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90569] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5158), 1,
      sym__binary_star_star,
    STATE(3359), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90624] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3449), 1,
      sym__element_reference_bracket,
    ACTIONS(4131), 1,
      anon_sym_DOT,
    ACTIONS(4135), 1,
      anon_sym_AMP_DOT,
    ACTIONS(5160), 1,
      anon_sym_COLON_COLON2,
    STATE(3360), 1,
      sym_heredoc_body,
    ACTIONS(3441), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90685] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    STATE(3361), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90740] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4624), 1,
      anon_sym_PIPE,
    ACTIONS(4626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4628), 1,
      anon_sym_AMP,
    ACTIONS(4632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4634), 1,
      anon_sym_CARET,
    ACTIONS(4636), 1,
      anon_sym_QMARK,
    ACTIONS(4638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4644), 1,
      anon_sym_GT_EQ,
    ACTIONS(4650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4654), 1,
      sym__binary_star_star,
    ACTIONS(4784), 1,
      anon_sym___END__,
    STATE(3362), 1,
      sym_heredoc_body,
    ACTIONS(4642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4380), 12,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [90825] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5012), 1,
      anon_sym_COMMA,
    STATE(3345), 1,
      aux_sym_exceptions_repeat1,
    STATE(3363), 1,
      sym_heredoc_body,
    ACTIONS(3978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [90882] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3364), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 14,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [90963] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3365), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [91046] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    ACTIONS(5075), 1,
      anon_sym_rescue,
    STATE(3366), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [91131] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3367), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [91214] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3368), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [91297] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    STATE(3369), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [91352] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3370), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 14,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [91433] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3371), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [91520] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3372), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [91607] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    STATE(3373), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [91670] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    STATE(3374), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [91731] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3375), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [91818] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    STATE(3376), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [91885] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    STATE(3377), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 15,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [91962] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3363), 1,
      aux_sym_exceptions_repeat1,
    STATE(3378), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92017] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3379), 1,
      sym_heredoc_body,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__line_break,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92074] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3380), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92129] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3381), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92184] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3382), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92247] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3383), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92308] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3384), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92375] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3385), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [92452] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3386), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [92527] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3387), 1,
      sym_heredoc_body,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92586] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3388), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 17,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [92661] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3389), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92716] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    STATE(3390), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [92791] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    STATE(3391), 1,
      sym_heredoc_body,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [92850] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    STATE(3392), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [92925] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4044), 1,
      anon_sym_PIPE,
    ACTIONS(4046), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4048), 1,
      anon_sym_AMP,
    ACTIONS(4052), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4054), 1,
      anon_sym_CARET,
    ACTIONS(4056), 1,
      anon_sym_QMARK,
    ACTIONS(4058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4064), 1,
      anon_sym_GT_EQ,
    ACTIONS(4070), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4074), 1,
      sym__binary_star_star,
    ACTIONS(5014), 1,
      anon_sym_rescue,
    STATE(3393), 1,
      sym_heredoc_body,
    ACTIONS(4062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4066), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4050), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4068), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4072), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [93012] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    STATE(3394), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 30,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93067] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5131), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5135), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5151), 1,
      anon_sym_QMARK,
    STATE(3395), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [93152] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5131), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5135), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5151), 1,
      anon_sym_QMARK,
    STATE(3396), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [93237] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5131), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5135), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    STATE(3397), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 13,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [93320] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5131), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5135), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5151), 1,
      anon_sym_QMARK,
    STATE(3398), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [93405] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(5121), 1,
      sym__binary_star_star,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(5125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5127), 1,
      anon_sym_AMP,
    ACTIONS(5131), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5133), 1,
      anon_sym_CARET,
    ACTIONS(5135), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5141), 1,
      anon_sym_GT_EQ,
    ACTIONS(5147), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5151), 1,
      anon_sym_QMARK,
    STATE(3399), 1,
      sym_heredoc_body,
    ACTIONS(5139), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5143), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5129), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5145), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5149), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 12,
      sym__element_reference_bracket,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [93490] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3400), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [93573] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5089), 1,
      anon_sym_QMARK,
    ACTIONS(5091), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3401), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [93658] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_DOT,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5089), 1,
      anon_sym_QMARK,
    ACTIONS(5091), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3402), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [93743] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(5077), 1,
      anon_sym_PIPE,
    ACTIONS(5079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5081), 1,
      anon_sym_AMP,
    ACTIONS(5085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5087), 1,
      anon_sym_CARET,
    ACTIONS(5089), 1,
      anon_sym_QMARK,
    ACTIONS(5091), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5097), 1,
      anon_sym_GT_EQ,
    ACTIONS(5103), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5107), 1,
      sym__binary_star_star,
    STATE(3403), 1,
      sym_heredoc_body,
    ACTIONS(5095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5099), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5083), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5101), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5105), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 12,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [93828] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3404), 1,
      sym_heredoc_body,
    ACTIONS(3499), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(3695), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3693), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [93883] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    ACTIONS(5162), 1,
      anon_sym_EQ_GT,
    STATE(3405), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [93970] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    ACTIONS(5075), 1,
      anon_sym_rescue,
    STATE(3406), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [94059] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3407), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94118] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3408), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 31,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94173] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2009), 1,
      sym_constant_suffix,
    STATE(2010), 1,
      sym_identifier_suffix,
    STATE(3409), 1,
      sym_heredoc_body,
    ACTIONS(5164), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(5170), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(5172), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2004), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(5168), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5166), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [94238] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2061), 1,
      sym_constant_suffix,
    STATE(2062), 1,
      sym_identifier_suffix,
    STATE(3410), 1,
      sym_heredoc_body,
    ACTIONS(5174), 2,
      sym_constant,
      sym_identifier,
    ACTIONS(5180), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(5182), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    STATE(2064), 2,
      sym__function_identifier,
      sym_operator,
    ACTIONS(5178), 10,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5176), 19,
      anon_sym_PIPE,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
      anon_sym_PLUS_AT,
      anon_sym_DASH_AT,
      anon_sym_TILDE_AT,
      anon_sym_LBRACK_RBRACK_EQ,
      anon_sym_BQUOTE,
  [94303] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3411), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [94386] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    STATE(3412), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94452] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4163), 1,
      anon_sym_QMARK,
    ACTIONS(4165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    ACTIONS(5010), 1,
      anon_sym_rescue,
    STATE(3413), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [94538] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3414), 1,
      sym_heredoc_body,
    ACTIONS(2586), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2588), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94590] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5198), 1,
      sym__binary_star_star,
    STATE(3415), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94644] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3416), 1,
      sym_heredoc_body,
    ACTIONS(2590), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2592), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [94696] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4884), 1,
      anon_sym_COMMA,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    ACTIONS(5200), 1,
      anon_sym_rescue,
    STATE(3152), 1,
      aux_sym_exceptions_repeat1,
    STATE(3417), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [94786] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5208), 1,
      anon_sym_QMARK,
    ACTIONS(5210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5212), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3418), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [94870] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5208), 1,
      anon_sym_QMARK,
    ACTIONS(5210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5212), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3419), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [94954] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4890), 1,
      anon_sym_PIPE,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4894), 1,
      anon_sym_AMP,
    ACTIONS(4898), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_CARET,
    ACTIONS(4902), 1,
      anon_sym_QMARK,
    ACTIONS(4904), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4906), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4910), 1,
      anon_sym_GT_EQ,
    ACTIONS(4916), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4920), 1,
      sym__binary_star_star,
    ACTIONS(4999), 1,
      anon_sym_COMMA,
    ACTIONS(5220), 1,
      anon_sym_rescue,
    STATE(3210), 1,
      aux_sym_exceptions_repeat1,
    STATE(3420), 1,
      sym_heredoc_body,
    ACTIONS(4908), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4912), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4896), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4914), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4918), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [95044] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4860), 1,
      sym__element_reference_bracket,
    ACTIONS(5222), 1,
      anon_sym_DOT,
    ACTIONS(5224), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(5226), 1,
      anon_sym_AMP_DOT,
    STATE(3421), 1,
      sym_heredoc_body,
    ACTIONS(3441), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3439), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95104] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1962), 1,
      sym__string_start,
    STATE(2791), 1,
      sym_string,
    STATE(3422), 1,
      sym_heredoc_body,
    STATE(3424), 1,
      aux_sym_chained_string_repeat1,
    ACTIONS(3112), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3110), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95162] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5016), 1,
      anon_sym_rescue,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3423), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [95250] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5260), 1,
      sym__string_start,
    STATE(2791), 1,
      sym_string,
    STATE(3424), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3116), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3114), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95306] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1962), 1,
      sym__string_start,
    STATE(2791), 1,
      sym_string,
    STATE(3422), 1,
      aux_sym_chained_string_repeat1,
    STATE(3425), 1,
      sym_heredoc_body,
    ACTIONS(2964), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95364] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    STATE(3426), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95418] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5212), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3427), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [95500] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3428), 1,
      sym_heredoc_body,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__line_break,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95556] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3429), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95610] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3430), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95664] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3431), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95726] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3432), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95786] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3433), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [95852] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3434), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 15,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [95928] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3435), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [96002] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3436), 1,
      sym_heredoc_body,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96060] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3437), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 16,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [96134] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3438), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96188] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(5263), 1,
      anon_sym_rescue,
    STATE(3439), 1,
      sym_heredoc_body,
    STATE(3521), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [96274] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(5263), 1,
      anon_sym_rescue,
    STATE(3440), 1,
      sym_heredoc_body,
    STATE(3521), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [96364] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5208), 1,
      anon_sym_QMARK,
    ACTIONS(5210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5212), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3441), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [96448] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    STATE(3442), 1,
      sym_heredoc_body,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96504] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    STATE(3443), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96558] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    STATE(3444), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96612] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    STATE(3445), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96674] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    STATE(3446), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [96734] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4838), 1,
      anon_sym___END__,
    ACTIONS(4928), 1,
      anon_sym_PIPE,
    ACTIONS(4930), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4932), 1,
      anon_sym_AMP,
    ACTIONS(4936), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4938), 1,
      anon_sym_CARET,
    ACTIONS(4940), 1,
      anon_sym_QMARK,
    ACTIONS(4942), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4944), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4948), 1,
      anon_sym_GT_EQ,
    ACTIONS(4954), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4958), 1,
      sym__binary_star_star,
    STATE(3447), 1,
      sym_heredoc_body,
    ACTIONS(4946), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4950), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4934), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4952), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4956), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [96818] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3448), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [96904] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3449), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [96978] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    STATE(3450), 1,
      sym_heredoc_body,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97036] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3451), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 15,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [97110] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    STATE(3452), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97164] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(5265), 1,
      anon_sym_rescue,
    ACTIONS(5267), 1,
      anon_sym_COMMA,
    STATE(3453), 1,
      sym_heredoc_body,
    STATE(3495), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [97254] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3454), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97312] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3455), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 30,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97366] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2928), 1,
      anon_sym_COLON,
    STATE(3456), 1,
      sym_heredoc_body,
    ACTIONS(2578), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2580), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97420] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2928), 1,
      anon_sym_COLON,
    STATE(3457), 1,
      sym_heredoc_body,
    ACTIONS(2582), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2584), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [97474] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3458), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [97556] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3459), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [97638] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3460), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [97718] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3461), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [97800] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5016), 1,
      anon_sym_rescue,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3462), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [97884] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3463), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [97966] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3464), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 12,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [98048] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4884), 1,
      anon_sym_COMMA,
    STATE(3152), 1,
      aux_sym_exceptions_repeat1,
    STATE(3465), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98104] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4151), 1,
      anon_sym_PIPE,
    ACTIONS(4153), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4155), 1,
      anon_sym_AMP,
    ACTIONS(4159), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4161), 1,
      anon_sym_CARET,
    ACTIONS(4163), 1,
      anon_sym_QMARK,
    ACTIONS(4165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4167), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4171), 1,
      anon_sym_GT_EQ,
    ACTIONS(4177), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4181), 1,
      sym__binary_star_star,
    ACTIONS(5010), 1,
      anon_sym_rescue,
    STATE(3466), 1,
      sym_heredoc_body,
    ACTIONS(4169), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4173), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4157), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4175), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4179), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [98190] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5208), 1,
      anon_sym_QMARK,
    ACTIONS(5210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5212), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3467), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [98274] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5208), 1,
      anon_sym_QMARK,
    ACTIONS(5210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5212), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3468), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [98358] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5212), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3469), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [98440] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5208), 1,
      anon_sym_QMARK,
    ACTIONS(5210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5212), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3470), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [98524] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5208), 1,
      anon_sym_QMARK,
    ACTIONS(5210), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5212), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3471), 1,
      sym_heredoc_body,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [98608] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(5269), 1,
      anon_sym_rescue,
    STATE(3472), 1,
      sym_heredoc_body,
    STATE(3495), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [98696] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3473), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [98782] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5271), 1,
      sym__binary_star_star,
    STATE(3474), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [98836] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3475), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 13,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [98916] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    ACTIONS(5273), 1,
      anon_sym_EQ_GT,
    STATE(3476), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [99002] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3477), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [99088] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5184), 1,
      anon_sym_PIPE,
    ACTIONS(5186), 1,
      anon_sym_AMP,
    ACTIONS(5188), 1,
      anon_sym_CARET,
    ACTIONS(5196), 1,
      sym__binary_star_star,
    ACTIONS(5212), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5214), 1,
      anon_sym_GT_EQ,
    ACTIONS(5216), 1,
      anon_sym_EQ_EQ,
    STATE(3478), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5190), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5192), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5194), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5204), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5218), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [99164] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3479), 1,
      sym_heredoc_body,
    STATE(3521), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 29,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99217] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3480), 1,
      sym_heredoc_body,
    STATE(3529), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99270] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4004), 1,
      anon_sym_COLON,
    STATE(3481), 1,
      sym_heredoc_body,
    ACTIONS(2578), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2580), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99323] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4004), 1,
      anon_sym_COLON,
    STATE(3482), 1,
      sym_heredoc_body,
    ACTIONS(2582), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2584), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99376] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(309), 1,
      sym__string_start,
    ACTIONS(5275), 1,
      anon_sym_COLON,
    STATE(2737), 1,
      aux_sym_chained_string_repeat1,
    STATE(2791), 1,
      sym_string,
    STATE(3483), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99435] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5277), 1,
      anon_sym_COMMA,
    STATE(3484), 1,
      sym_heredoc_body,
    STATE(3505), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99490] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(5263), 1,
      anon_sym_rescue,
    STATE(3485), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [99573] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(5279), 1,
      anon_sym_PIPE,
    ACTIONS(5281), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5289), 1,
      anon_sym_CARET,
    ACTIONS(5291), 1,
      anon_sym_QMARK,
    ACTIONS(5293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_GT_EQ,
    ACTIONS(5305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3486), 1,
      sym_heredoc_body,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5285), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [99656] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(5279), 1,
      anon_sym_PIPE,
    ACTIONS(5281), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5289), 1,
      anon_sym_CARET,
    ACTIONS(5291), 1,
      anon_sym_QMARK,
    ACTIONS(5293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_GT_EQ,
    ACTIONS(5305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3487), 1,
      sym_heredoc_body,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5285), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [99739] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3488), 1,
      sym_heredoc_body,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99800] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3489), 1,
      sym_heredoc_body,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99859] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3490), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [99912] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(5279), 1,
      anon_sym_PIPE,
    ACTIONS(5281), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5289), 1,
      anon_sym_CARET,
    ACTIONS(5293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_GT_EQ,
    ACTIONS(5305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3491), 1,
      sym_heredoc_body,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5285), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [99993] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5279), 1,
      anon_sym_PIPE,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5289), 1,
      anon_sym_CARET,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3492), 1,
      sym_heredoc_body,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100058] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5311), 1,
      sym__binary_star_star,
    STATE(3493), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100111] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5279), 1,
      anon_sym_PIPE,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5289), 1,
      anon_sym_CARET,
    ACTIONS(5295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_GT_EQ,
    ACTIONS(5305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3494), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5285), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [100186] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5267), 1,
      anon_sym_COMMA,
    STATE(3495), 1,
      sym_heredoc_body,
    STATE(3530), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100241] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5279), 1,
      anon_sym_PIPE,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5289), 1,
      anon_sym_CARET,
    ACTIONS(5299), 1,
      anon_sym_GT_EQ,
    ACTIONS(5305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3496), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5285), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [100314] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3497), 1,
      sym_heredoc_body,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100371] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5313), 1,
      anon_sym_rescue,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3498), 1,
      sym_heredoc_body,
    STATE(3542), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [100460] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3484), 1,
      aux_sym_exceptions_repeat1,
    STATE(3499), 1,
      sym_heredoc_body,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 29,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100513] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5279), 1,
      anon_sym_PIPE,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5289), 1,
      anon_sym_CARET,
    ACTIONS(5299), 1,
      anon_sym_GT_EQ,
    ACTIONS(5305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3500), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5285), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 14,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [100586] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2688), 1,
      anon_sym_COLON,
    STATE(3501), 1,
      sym_heredoc_body,
    ACTIONS(2578), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2580), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100639] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5351), 1,
      anon_sym_COMMA,
    STATE(3502), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100692] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5354), 1,
      sym__binary_star_star,
    STATE(3503), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100745] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2688), 1,
      anon_sym_COLON,
    STATE(3504), 1,
      sym_heredoc_body,
    ACTIONS(2582), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2584), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LPAREN2,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100798] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_COMMA,
    STATE(3505), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [100851] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_PIPE,
    ACTIONS(4187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4189), 1,
      anon_sym_AMP,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4197), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4199), 1,
      anon_sym_CARET,
    ACTIONS(4201), 1,
      anon_sym_QMARK,
    ACTIONS(4203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4205), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4209), 1,
      anon_sym_GT_EQ,
    ACTIONS(4215), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4219), 1,
      sym__binary_star_star,
    ACTIONS(5263), 1,
      anon_sym_rescue,
    STATE(3506), 1,
      sym_heredoc_body,
    ACTIONS(4207), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4211), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4191), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4213), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4217), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [100938] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    ACTIONS(5359), 1,
      anon_sym_rescue,
    STATE(3507), 1,
      sym_heredoc_body,
    STATE(3529), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [101027] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5313), 1,
      anon_sym_rescue,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3508), 1,
      sym_heredoc_body,
    STATE(3542), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [101112] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    ACTIONS(5359), 1,
      anon_sym_rescue,
    STATE(3509), 1,
      sym_heredoc_body,
    STATE(3529), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [101197] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(5269), 1,
      anon_sym_rescue,
    STATE(3510), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [101282] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3511), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101335] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(5279), 1,
      anon_sym_PIPE,
    ACTIONS(5281), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5289), 1,
      anon_sym_CARET,
    ACTIONS(5291), 1,
      anon_sym_QMARK,
    ACTIONS(5293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_GT_EQ,
    ACTIONS(5305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3512), 1,
      sym_heredoc_body,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5285), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [101418] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3513), 1,
      sym_heredoc_body,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101473] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3514), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101526] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3515), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [101579] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3516), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4344), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [101660] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3517), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4380), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [101741] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_rescue,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3518), 1,
      sym_heredoc_body,
    STATE(3535), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [101826] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3519), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4382), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [101907] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3520), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4384), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [101988] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_COMMA,
    STATE(3521), 1,
      sym_heredoc_body,
    STATE(3522), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102043] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5397), 1,
      anon_sym_COMMA,
    STATE(3522), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102096] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5279), 1,
      anon_sym_PIPE,
    ACTIONS(5281), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5289), 1,
      anon_sym_CARET,
    ACTIONS(5291), 1,
      anon_sym_QMARK,
    ACTIONS(5293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_GT_EQ,
    ACTIONS(5305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3523), 1,
      sym_heredoc_body,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5285), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [102179] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3495), 1,
      aux_sym_exceptions_repeat1,
    STATE(3524), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102232] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4556), 1,
      anon_sym_PIPE,
    ACTIONS(4558), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4560), 1,
      anon_sym_AMP,
    ACTIONS(4564), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4566), 1,
      anon_sym_CARET,
    ACTIONS(4568), 1,
      anon_sym_QMARK,
    ACTIONS(4570), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4572), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4576), 1,
      anon_sym_GT_EQ,
    ACTIONS(4582), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4586), 1,
      sym__binary_star_star,
    ACTIONS(5269), 1,
      anon_sym_rescue,
    STATE(3525), 1,
      sym_heredoc_body,
    ACTIONS(4574), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4578), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4562), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4580), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4584), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [102317] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    STATE(3526), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 11,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [102398] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5279), 1,
      anon_sym_PIPE,
    ACTIONS(5281), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5289), 1,
      anon_sym_CARET,
    ACTIONS(5291), 1,
      anon_sym_QMARK,
    ACTIONS(5293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_GT_EQ,
    ACTIONS(5305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3527), 1,
      sym_heredoc_body,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5285), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [102481] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5267), 1,
      anon_sym_COMMA,
    STATE(3495), 1,
      aux_sym_exceptions_repeat1,
    STATE(3528), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102536] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5400), 1,
      anon_sym_COMMA,
    STATE(3502), 1,
      aux_sym_exceptions_repeat1,
    STATE(3529), 1,
      sym_heredoc_body,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102591] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_COMMA,
    STATE(3530), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102644] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(5279), 1,
      anon_sym_PIPE,
    ACTIONS(5281), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5283), 1,
      anon_sym_AMP,
    ACTIONS(5287), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5289), 1,
      anon_sym_CARET,
    ACTIONS(5293), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5299), 1,
      anon_sym_GT_EQ,
    ACTIONS(5305), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5309), 1,
      sym__binary_star_star,
    STATE(3531), 1,
      sym_heredoc_body,
    ACTIONS(5297), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5301), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5285), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5303), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [102725] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    ACTIONS(5405), 1,
      anon_sym_rescue,
    STATE(3484), 1,
      aux_sym_exceptions_repeat1,
    STATE(3532), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [102810] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4999), 1,
      anon_sym_COMMA,
    STATE(3210), 1,
      aux_sym_exceptions_repeat1,
    STATE(3533), 1,
      sym_heredoc_body,
    ACTIONS(3523), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [102865] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(5220), 1,
      anon_sym_rescue,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3534), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [102949] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5439), 1,
      anon_sym_COMMA,
    STATE(3535), 1,
      sym_heredoc_body,
    STATE(3672), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103003] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3536), 1,
      sym_heredoc_body,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103059] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    STATE(3537), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103113] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(3538), 1,
      sym_heredoc_body,
    STATE(4427), 1,
      sym__hash_pattern_any_rest,
    STATE(4437), 1,
      sym_keyword_pattern,
    STATE(5591), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(5441), 2,
      sym_constant,
      sym_identifier,
    STATE(4436), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5556), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5443), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5445), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [103183] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5361), 1,
      anon_sym_rescue,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3539), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [103265] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3540), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103315] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3541), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103371] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5453), 1,
      anon_sym_COMMA,
    STATE(3542), 1,
      sym_heredoc_body,
    STATE(3618), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103425] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    STATE(3543), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [103505] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    ACTIONS(5359), 1,
      anon_sym_rescue,
    STATE(3544), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [103587] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3545), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [103661] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3546), 1,
      sym_heredoc_body,
    ACTIONS(2964), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(2962), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103711] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3542), 1,
      aux_sym_exceptions_repeat1,
    STATE(3547), 1,
      sym_heredoc_body,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103763] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3548), 1,
      sym_heredoc_body,
    ACTIONS(3501), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3499), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103813] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3549), 1,
      sym_heredoc_body,
    ACTIONS(3337), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3335), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [103863] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3550), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [103943] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3551), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [104023] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3552), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [104103] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3553), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [104183] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3554), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 14,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [104255] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3555), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [104333] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3556), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [104413] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5485), 1,
      sym__binary_star_star,
    STATE(3557), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104465] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    ACTIONS(5405), 1,
      anon_sym_rescue,
    STATE(3558), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [104547] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3559), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104599] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3560), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [104677] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3561), 1,
      sym_heredoc_body,
    ACTIONS(3167), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3165), 27,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104727] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(5200), 1,
      anon_sym_rescue,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3562), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [104811] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5487), 1,
      anon_sym_COMMA,
    STATE(3563), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [104863] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3564), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [104945] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3565), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [105029] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3566), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [105113] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3567), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [105197] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4684), 1,
      anon_sym_QMARK,
    ACTIONS(4686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5265), 1,
      anon_sym_rescue,
    STATE(3568), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [105281] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3587), 1,
      anon_sym_DOT,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3569), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [105363] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3570), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [105445] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3571), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105497] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3572), 1,
      sym_heredoc_body,
    ACTIONS(3183), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3181), 27,
      sym__string_start,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105547] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3573), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 11,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [105625] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3574), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [105709] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    STATE(3575), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105763] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3576), 1,
      sym_heredoc_body,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__line_break,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105817] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3577), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105869] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3578), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105921] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    STATE(3579), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [105981] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3580), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106039] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5313), 1,
      anon_sym_rescue,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3581), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106121] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    STATE(3582), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106185] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3583), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [106259] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3584), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 14,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [106331] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3585), 1,
      sym_heredoc_body,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106387] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3586), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 14,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [106459] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3587), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [106511] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3588), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106591] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3589), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106671] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3590), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 11,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [106749] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3591), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [106829] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3592), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [106909] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3593), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [106989] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3594), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [107067] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3595), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107147] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3596), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107227] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3597), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107279] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    ACTIONS(5522), 1,
      anon_sym_rescue,
    ACTIONS(5524), 1,
      anon_sym_COMMA,
    STATE(3598), 1,
      sym_heredoc_body,
    STATE(3811), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107365] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3599), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107445] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3600), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 10,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [107525] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3601), 1,
      sym_heredoc_body,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107579] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3602), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107631] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3603), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107683] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3604), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107743] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    STATE(3605), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 28,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [107795] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5526), 1,
      anon_sym_EQ_GT,
    STATE(3606), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [107879] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3607), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [107959] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3608), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108017] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3609), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108081] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3610), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [108155] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3611), 1,
      sym_heredoc_body,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108209] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3612), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108261] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3613), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108313] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3535), 1,
      aux_sym_exceptions_repeat1,
    STATE(3614), 1,
      sym_heredoc_body,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 28,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108365] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3615), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 26,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108421] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_COMMA,
    STATE(3616), 1,
      sym_heredoc_body,
    STATE(3641), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108475] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3617), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108535] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5530), 1,
      anon_sym_COMMA,
    STATE(3618), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108587] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3619), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108645] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3620), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108709] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5533), 1,
      sym__binary_star_star,
    STATE(3621), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [108761] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3622), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [108839] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3623), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 14,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [108911] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    ACTIONS(5359), 1,
      anon_sym_rescue,
    STATE(3624), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [108997] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3625), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [109071] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3626), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [109143] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3627), 1,
      sym_heredoc_body,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109199] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3628), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [109271] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3629), 1,
      sym_heredoc_body,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109327] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    ACTIONS(5522), 1,
      anon_sym_rescue,
    ACTIONS(5524), 1,
      anon_sym_COMMA,
    STATE(3630), 1,
      sym_heredoc_body,
    STATE(3811), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3521), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [109417] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3631), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [109497] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3632), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [109577] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3633), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [109659] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3634), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [109741] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3635), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [109821] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3636), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [109903] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3637), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [109985] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5535), 1,
      sym__binary_star_star,
    STATE(3638), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110037] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3639), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110089] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(5200), 1,
      anon_sym_rescue,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3640), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [110173] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_COMMA,
    STATE(3563), 1,
      aux_sym_exceptions_repeat1,
    STATE(3641), 1,
      sym_heredoc_body,
    ACTIONS(3978), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110227] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3642), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [110307] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3643), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [110387] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    ACTIONS(5537), 1,
      anon_sym_EQ_GT,
    STATE(3644), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [110471] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3645), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 14,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [110543] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3646), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [110595] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3647), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [110677] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3648), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [110759] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3649), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [110839] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3650), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 10,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [110919] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3651), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [111001] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    ACTIONS(5539), 1,
      anon_sym_rescue,
    STATE(3652), 1,
      sym_heredoc_body,
    STATE(3811), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [111085] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3653), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [111169] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3654), 1,
      sym_heredoc_body,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111223] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3655), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111275] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3656), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111327] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3657), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [111409] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3658), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 28,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111461] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(5220), 1,
      anon_sym_rescue,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    STATE(3659), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [111545] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5541), 1,
      sym__binary_star_star,
    STATE(3660), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111597] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3661), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111657] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3662), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111715] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5528), 1,
      anon_sym_COMMA,
    ACTIONS(5543), 1,
      anon_sym_rescue,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3641), 1,
      aux_sym_exceptions_repeat1,
    STATE(3663), 1,
      sym_heredoc_body,
    ACTIONS(3523), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3521), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111803] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3664), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 14,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [111875] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3641), 1,
      aux_sym_exceptions_repeat1,
    STATE(3665), 1,
      sym_heredoc_body,
    ACTIONS(3523), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [111927] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3666), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [112011] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3667), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [112091] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_DOT,
    ACTIONS(4656), 1,
      anon_sym_PIPE,
    ACTIONS(4658), 1,
      anon_sym_AMP,
    ACTIONS(4662), 1,
      anon_sym_CARET,
    ACTIONS(4664), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4668), 1,
      anon_sym_GT_EQ,
    ACTIONS(4674), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4678), 1,
      sym__binary_star_star,
    ACTIONS(4680), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4682), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4684), 1,
      anon_sym_QMARK,
    ACTIONS(4686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5265), 1,
      anon_sym_rescue,
    STATE(3668), 1,
      sym_heredoc_body,
    ACTIONS(4666), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4670), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4660), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4672), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4676), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [112175] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    ACTIONS(5577), 1,
      anon_sym_rescue,
    ACTIONS(5579), 1,
      anon_sym_COMMA,
    STATE(3669), 1,
      sym_heredoc_body,
    STATE(3794), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3521), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112263] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    ACTIONS(5581), 1,
      anon_sym_rescue,
    STATE(3641), 1,
      aux_sym_exceptions_repeat1,
    STATE(3670), 1,
      sym_heredoc_body,
    ACTIONS(3523), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [112349] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    ACTIONS(5583), 1,
      anon_sym_rescue,
    STATE(3671), 1,
      sym_heredoc_body,
    STATE(3794), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [112435] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5585), 1,
      anon_sym_COMMA,
    STATE(3672), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 27,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112487] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3673), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 10,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [112567] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(3674), 1,
      sym_heredoc_body,
    STATE(4437), 1,
      sym_keyword_pattern,
    STATE(4439), 1,
      sym__hash_pattern_any_rest,
    STATE(5591), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(5441), 2,
      sym_constant,
      sym_identifier,
    STATE(4436), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5556), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5588), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5590), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [112637] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3675), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112689] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3676), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [112769] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5492), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5498), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5502), 1,
      anon_sym_QMARK,
    ACTIONS(5504), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3677), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [112851] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3678), 1,
      sym_heredoc_body,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112905] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3679), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [112957] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3680), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113009] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3681), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113069] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3682), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113127] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3683), 1,
      sym_heredoc_body,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113191] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5506), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3684), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [113265] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3685), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [113337] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3686), 1,
      sym_heredoc_body,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113393] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5490), 1,
      anon_sym_PIPE,
    ACTIONS(5494), 1,
      anon_sym_AMP,
    ACTIONS(5500), 1,
      anon_sym_CARET,
    ACTIONS(5510), 1,
      anon_sym_GT_EQ,
    ACTIONS(5516), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3687), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5508), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5512), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5496), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5514), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5518), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [113465] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5520), 1,
      sym__binary_star_star,
    STATE(3688), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113517] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3689), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113581] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    ACTIONS(5539), 1,
      anon_sym_rescue,
    STATE(3690), 1,
      sym_heredoc_body,
    STATE(3811), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [113669] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5313), 1,
      anon_sym_rescue,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3691), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [113755] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3692), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [113834] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3693), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [113885] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    ACTIONS(5583), 1,
      anon_sym_rescue,
    STATE(3694), 1,
      sym_heredoc_body,
    ACTIONS(3313), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [113968] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3695), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [114039] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3696), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [114118] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3697), 1,
      sym_heredoc_body,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114173] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3698), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [114244] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3699), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [114323] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3700), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114374] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3701), 1,
      sym_heredoc_body,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114433] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3702), 1,
      sym_heredoc_body,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114490] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3703), 1,
      sym_heredoc_body,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114553] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3704), 1,
      sym_heredoc_body,
    STATE(3794), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114604] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3705), 1,
      sym_heredoc_body,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [114677] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3706), 1,
      sym_heredoc_body,
    ACTIONS(3988), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 8,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [114756] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3707), 1,
      sym_heredoc_body,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 11,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [114827] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3708), 1,
      sym_heredoc_body,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [114882] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(5656), 1,
      anon_sym_PIPE,
    ACTIONS(5658), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5666), 1,
      anon_sym_CARET,
    ACTIONS(5668), 1,
      anon_sym_QMARK,
    ACTIONS(5670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5676), 1,
      anon_sym_GT_EQ,
    ACTIONS(5682), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3709), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5662), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5684), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [114963] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3710), 1,
      sym_heredoc_body,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__line_break,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115016] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3711), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115067] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3712), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115118] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3713), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115177] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3714), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115234] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5656), 1,
      anon_sym_PIPE,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5666), 1,
      anon_sym_CARET,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3715), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115297] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5656), 1,
      anon_sym_PIPE,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5666), 1,
      anon_sym_CARET,
    ACTIONS(5672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5676), 1,
      anon_sym_GT_EQ,
    ACTIONS(5682), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3716), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5662), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5684), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 11,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [115370] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5656), 1,
      anon_sym_PIPE,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5666), 1,
      anon_sym_CARET,
    ACTIONS(5676), 1,
      anon_sym_GT_EQ,
    ACTIONS(5682), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3717), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5662), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5684), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [115441] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3718), 1,
      sym_heredoc_body,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115496] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5656), 1,
      anon_sym_PIPE,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5666), 1,
      anon_sym_CARET,
    ACTIONS(5676), 1,
      anon_sym_GT_EQ,
    ACTIONS(5682), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3719), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5662), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5684), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [115567] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3720), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115618] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_GT_EQ,
    ACTIONS(5704), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3721), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5692), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5706), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [115689] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3722), 1,
      sym_heredoc_body,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115744] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3723), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [115795] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3724), 1,
      sym_heredoc_body,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 11,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [115866] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3725), 1,
      sym_heredoc_body,
    ACTIONS(4002), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [115947] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_GT_EQ,
    ACTIONS(5704), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3726), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5692), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5706), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [116018] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3727), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116069] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3728), 1,
      sym_heredoc_body,
    ACTIONS(4016), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116120] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3729), 1,
      sym_heredoc_body,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116171] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3730), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [116242] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_GT_EQ,
    ACTIONS(5704), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_QMARK,
    ACTIONS(5716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5718), 1,
      anon_sym_AMP_AMP,
    STATE(3731), 1,
      sym_heredoc_body,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5692), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5706), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [116323] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    STATE(3732), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116376] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5579), 1,
      anon_sym_COMMA,
    STATE(3733), 1,
      sym_heredoc_body,
    STATE(3794), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116429] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3734), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116480] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    STATE(3735), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [116563] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3736), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [116642] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3737), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [116721] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    STATE(3738), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [116804] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5724), 1,
      sym__binary_star_star,
    STATE(3739), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116855] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3740), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [116934] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5726), 1,
      sym__binary_star_star,
    STATE(3741), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [116985] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3742), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117036] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3743), 1,
      sym_heredoc_body,
    STATE(3811), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 27,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117087] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3744), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [117166] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3745), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [117245] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5728), 1,
      sym__binary_star_star,
    STATE(3746), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117296] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(5656), 1,
      anon_sym_PIPE,
    ACTIONS(5658), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5666), 1,
      anon_sym_CARET,
    ACTIONS(5670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5676), 1,
      anon_sym_GT_EQ,
    ACTIONS(5682), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3747), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5662), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5684), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [117375] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    ACTIONS(5539), 1,
      anon_sym_rescue,
    STATE(3748), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [117460] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_PIPE,
    ACTIONS(4350), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4352), 1,
      anon_sym_AMP,
    ACTIONS(4356), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4358), 1,
      anon_sym_CARET,
    ACTIONS(4360), 1,
      anon_sym_QMARK,
    ACTIONS(4362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4364), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4368), 1,
      anon_sym_GT_EQ,
    ACTIONS(4374), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4378), 1,
      sym__binary_star_star,
    ACTIONS(5539), 1,
      anon_sym_rescue,
    STATE(3749), 1,
      sym_heredoc_body,
    ACTIONS(4366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4370), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4354), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4372), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4376), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [117541] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3750), 1,
      sym_heredoc_body,
    ACTIONS(4016), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117592] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(5656), 1,
      anon_sym_PIPE,
    ACTIONS(5658), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5666), 1,
      anon_sym_CARET,
    ACTIONS(5668), 1,
      anon_sym_QMARK,
    ACTIONS(5670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5676), 1,
      anon_sym_GT_EQ,
    ACTIONS(5682), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3751), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5662), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5684), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [117673] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3752), 1,
      sym_heredoc_body,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117732] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3753), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117789] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3754), 1,
      sym_heredoc_body,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117846] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3755), 1,
      sym_heredoc_body,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117909] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3756), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [117972] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5730), 1,
      anon_sym_COMMA,
    STATE(3757), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118023] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_GT_EQ,
    ACTIONS(5704), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_QMARK,
    ACTIONS(5716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5718), 1,
      anon_sym_AMP_AMP,
    STATE(3758), 1,
      sym_heredoc_body,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5692), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5706), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [118104] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_GT_EQ,
    ACTIONS(5704), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_QMARK,
    ACTIONS(5716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5718), 1,
      anon_sym_AMP_AMP,
    STATE(3759), 1,
      sym_heredoc_body,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5692), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5706), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [118185] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_DOT,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_GT_EQ,
    ACTIONS(5704), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5718), 1,
      anon_sym_AMP_AMP,
    STATE(3760), 1,
      sym_heredoc_body,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5692), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5706), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [118264] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_GT_EQ,
    ACTIONS(5704), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5718), 1,
      anon_sym_AMP_AMP,
    STATE(3761), 1,
      sym_heredoc_body,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5692), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5706), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 9,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [118343] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_GT_EQ,
    ACTIONS(5704), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_QMARK,
    ACTIONS(5716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5718), 1,
      anon_sym_AMP_AMP,
    STATE(3762), 1,
      sym_heredoc_body,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5692), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5706), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [118424] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3763), 1,
      sym_heredoc_body,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118479] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3764), 1,
      sym_heredoc_body,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118532] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5733), 1,
      sym__binary_star_star,
    STATE(3765), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 26,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118583] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3766), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [118662] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_GT_EQ,
    ACTIONS(5704), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    ACTIONS(5718), 1,
      anon_sym_AMP_AMP,
    STATE(3767), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5692), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5706), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 11,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [118735] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3768), 1,
      sym_heredoc_body,
    ACTIONS(3719), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118786] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3769), 1,
      sym_heredoc_body,
    ACTIONS(3587), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [118867] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    ACTIONS(5405), 1,
      anon_sym_rescue,
    STATE(3484), 1,
      aux_sym_exceptions_repeat1,
    STATE(3770), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3521), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [118954] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5735), 1,
      anon_sym_COMMA,
    STATE(3771), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119005] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_DOT,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_GT_EQ,
    ACTIONS(5704), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_QMARK,
    ACTIONS(5716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5718), 1,
      anon_sym_AMP_AMP,
    STATE(3772), 1,
      sym_heredoc_body,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5692), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5706), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [119086] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    STATE(3773), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 25,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119141] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT,
    ACTIONS(5656), 1,
      anon_sym_PIPE,
    ACTIONS(5658), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5666), 1,
      anon_sym_CARET,
    ACTIONS(5668), 1,
      anon_sym_QMARK,
    ACTIONS(5670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5676), 1,
      anon_sym_GT_EQ,
    ACTIONS(5682), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3774), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5662), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5684), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [119222] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3775), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [119295] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3776), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119346] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3777), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [119427] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3778), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [119508] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3779), 1,
      sym_heredoc_body,
    ACTIONS(4032), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 8,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [119587] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3780), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [119668] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    ACTIONS(5583), 1,
      anon_sym_rescue,
    STATE(3781), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [119751] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3782), 1,
      sym_heredoc_body,
    ACTIONS(3998), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [119832] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    ACTIONS(5581), 1,
      anon_sym_rescue,
    STATE(3783), 1,
      sym_heredoc_body,
    ACTIONS(3313), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3311), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [119915] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3784), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [119966] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3785), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [120043] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5738), 1,
      anon_sym_EQ_GT,
    STATE(3786), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [120126] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5740), 1,
      sym__binary_star_star,
    STATE(3787), 1,
      sym_heredoc_body,
    ACTIONS(3425), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120177] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3788), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [120256] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3789), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [120335] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    STATE(3790), 1,
      sym_heredoc_body,
    ACTIONS(4024), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [120416] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3791), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [120493] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3792), 1,
      sym_heredoc_body,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__binary_minus,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120546] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3793), 1,
      sym_heredoc_body,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__binary_minus,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120599] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5579), 1,
      anon_sym_COMMA,
    STATE(3757), 1,
      aux_sym_exceptions_repeat1,
    STATE(3794), 1,
      sym_heredoc_body,
    ACTIONS(3978), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120652] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5742), 1,
      sym__binary_star_star,
    STATE(3795), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120703] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3796), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120754] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3797), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120805] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3798), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120864] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3799), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 10,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [120941] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3800), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [120998] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3801), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121061] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    STATE(3802), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [121144] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3803), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [121223] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3804), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [121296] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    STATE(3805), 1,
      sym_heredoc_body,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121349] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3806), 1,
      sym_heredoc_body,
    ACTIONS(3719), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121400] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_DOT,
    ACTIONS(5656), 1,
      anon_sym_PIPE,
    ACTIONS(5658), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5666), 1,
      anon_sym_CARET,
    ACTIONS(5670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5676), 1,
      anon_sym_GT_EQ,
    ACTIONS(5682), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3807), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5662), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5684), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 9,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [121479] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3808), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 9,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [121558] = 24,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5361), 1,
      anon_sym_rescue,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3535), 1,
      aux_sym_exceptions_repeat1,
    STATE(3809), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3521), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121645] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_COMMA,
    STATE(3810), 1,
      sym_heredoc_body,
    STATE(3811), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121698] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5524), 1,
      anon_sym_COMMA,
    STATE(3771), 1,
      aux_sym_exceptions_repeat1,
    STATE(3811), 1,
      sym_heredoc_body,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121751] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5545), 1,
      anon_sym_PIPE,
    ACTIONS(5547), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5549), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5555), 1,
      anon_sym_CARET,
    ACTIONS(5557), 1,
      anon_sym_QMARK,
    ACTIONS(5559), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5561), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5565), 1,
      anon_sym_GT_EQ,
    ACTIONS(5571), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5575), 1,
      sym__binary_star_star,
    ACTIONS(5581), 1,
      anon_sym_rescue,
    STATE(3812), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5563), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5567), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5551), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5569), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5573), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [121834] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3813), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121885] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3814), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 27,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121936] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3815), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [121995] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3816), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [122066] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3817), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [122143] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5656), 1,
      anon_sym_PIPE,
    ACTIONS(5658), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5666), 1,
      anon_sym_CARET,
    ACTIONS(5668), 1,
      anon_sym_QMARK,
    ACTIONS(5670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5676), 1,
      anon_sym_GT_EQ,
    ACTIONS(5682), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3818), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5662), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5684), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [122224] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_DOT,
    ACTIONS(5656), 1,
      anon_sym_PIPE,
    ACTIONS(5658), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5660), 1,
      anon_sym_AMP,
    ACTIONS(5664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5666), 1,
      anon_sym_CARET,
    ACTIONS(5668), 1,
      anon_sym_QMARK,
    ACTIONS(5670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5676), 1,
      anon_sym_GT_EQ,
    ACTIONS(5682), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5686), 1,
      sym__binary_star_star,
    STATE(3819), 1,
      sym_heredoc_body,
    ACTIONS(5674), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5678), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5662), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5680), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5684), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 8,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [122305] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3820), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [122384] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5277), 1,
      anon_sym_COMMA,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    ACTIONS(5744), 1,
      anon_sym_rescue,
    STATE(3484), 1,
      aux_sym_exceptions_repeat1,
    STATE(3821), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3521), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122472] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5758), 1,
      anon_sym_QMARK,
    ACTIONS(5760), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3822), 1,
      sym_heredoc_body,
    ACTIONS(4024), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [122552] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5758), 1,
      anon_sym_QMARK,
    ACTIONS(5760), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3823), 1,
      sym_heredoc_body,
    ACTIONS(3587), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [122632] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3824), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122686] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    STATE(3825), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122736] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    STATE(3826), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122794] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3827), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [122872] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    STATE(3828), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [122928] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5758), 1,
      anon_sym_QMARK,
    ACTIONS(5760), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3829), 1,
      sym_heredoc_body,
    ACTIONS(4002), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [123008] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    ACTIONS(5439), 1,
      anon_sym_COMMA,
    ACTIONS(5810), 1,
      anon_sym_rescue,
    STATE(3535), 1,
      aux_sym_exceptions_repeat1,
    STATE(3830), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3521), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123092] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    STATE(3831), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123154] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3832), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [123232] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3833), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4382), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [123310] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3834), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4384), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [123388] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    ACTIONS(5812), 1,
      anon_sym_EQ_GT,
    STATE(3835), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [123470] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3836), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [123552] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3837), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [123634] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5760), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3838), 1,
      sym_heredoc_body,
    ACTIONS(3988), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 7,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [123712] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3839), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [123790] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5814), 1,
      sym__binary_star_star,
    STATE(3840), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123840] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5543), 1,
      anon_sym_rescue,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5818), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5828), 1,
      anon_sym_QMARK,
    ACTIONS(5830), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3841), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [123922] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3842), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 11,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [123994] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3843), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [124064] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3844), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [124142] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5818), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5828), 1,
      anon_sym_QMARK,
    ACTIONS(5830), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3845), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [124222] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    STATE(3846), 1,
      sym_heredoc_body,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124276] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3847), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 12,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [124346] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5277), 1,
      anon_sym_COMMA,
    STATE(3484), 1,
      aux_sym_exceptions_repeat1,
    STATE(3848), 1,
      sym_heredoc_body,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 25,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124398] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    STATE(3849), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124448] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3850), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [124530] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5818), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5828), 1,
      anon_sym_QMARK,
    ACTIONS(5830), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3851), 1,
      sym_heredoc_body,
    ACTIONS(4024), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [124610] = 25,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    ACTIONS(5439), 1,
      anon_sym_COMMA,
    ACTIONS(5810), 1,
      anon_sym_rescue,
    STATE(3535), 1,
      aux_sym_exceptions_repeat1,
    STATE(3852), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3521), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124698] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5848), 1,
      sym__binary_star_star,
    STATE(3853), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124748] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3854), 1,
      sym_heredoc_body,
    ACTIONS(3719), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124798] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3855), 1,
      sym_heredoc_body,
    ACTIONS(3719), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [124848] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5850), 1,
      anon_sym_EQ_GT,
    STATE(3856), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [124930] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5818), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5830), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3857), 1,
      sym_heredoc_body,
    ACTIONS(3988), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [125008] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5361), 1,
      anon_sym_rescue,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3858), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125092] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5577), 1,
      anon_sym_rescue,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5818), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5828), 1,
      anon_sym_QMARK,
    ACTIONS(5830), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3859), 1,
      sym_heredoc_body,
    ACTIONS(3527), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125174] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5852), 1,
      sym__binary_star_star,
    STATE(3860), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125224] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3861), 1,
      sym_heredoc_body,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125276] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3862), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125326] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3863), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125376] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3864), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [125454] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3865), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [125532] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5818), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5830), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3866), 1,
      sym_heredoc_body,
    ACTIONS(4032), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 7,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [125610] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3867), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 9,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [125686] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3868), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [125764] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    ACTIONS(5405), 1,
      anon_sym_rescue,
    STATE(3869), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [125848] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3870), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 9,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [125924] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3871), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [126006] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3872), 1,
      sym_heredoc_body,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126064] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    STATE(3873), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126114] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3874), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [126196] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5854), 1,
      sym__binary_star_star,
    STATE(3875), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126246] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5818), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5828), 1,
      anon_sym_QMARK,
    ACTIONS(5830), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3876), 1,
      sym_heredoc_body,
    ACTIONS(3998), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [126326] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    ACTIONS(5522), 1,
      anon_sym_rescue,
    STATE(3877), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [126406] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5758), 1,
      anon_sym_QMARK,
    ACTIONS(5760), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3878), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [126486] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3879), 1,
      sym_heredoc_body,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126542] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3880), 1,
      sym_heredoc_body,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [126594] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5758), 1,
      anon_sym_QMARK,
    ACTIONS(5760), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3881), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [126674] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    ACTIONS(5856), 1,
      anon_sym_rescue,
    STATE(3882), 1,
      sym_heredoc_body,
    STATE(3936), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3521), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [126756] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5760), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3883), 1,
      sym_heredoc_body,
    ACTIONS(4032), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 7,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [126834] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5758), 1,
      anon_sym_QMARK,
    ACTIONS(5760), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3884), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [126914] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5748), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5754), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5758), 1,
      anon_sym_QMARK,
    ACTIONS(5760), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3885), 1,
      sym_heredoc_body,
    ACTIONS(3998), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 6,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [126994] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3886), 1,
      sym_heredoc_body,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127056] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3887), 1,
      sym_heredoc_body,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [127128] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3888), 1,
      sym_heredoc_body,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [127198] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3889), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127248] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3890), 1,
      sym_heredoc_body,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127302] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3891), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 8,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [127380] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3892), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127430] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3893), 1,
      sym_heredoc_body,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [127500] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3894), 1,
      sym_heredoc_body,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127558] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3895), 1,
      sym_heredoc_body,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127614] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    ACTIONS(5858), 1,
      anon_sym_rescue,
    ACTIONS(5860), 1,
      anon_sym_COMMA,
    STATE(3896), 1,
      sym_heredoc_body,
    STATE(3936), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3521), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [127698] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3897), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [127776] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3898), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4344), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [127854] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3899), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4380), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [127932] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3900), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4382), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [128010] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_PIPE,
    ACTIONS(5317), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5319), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5329), 1,
      anon_sym_CARET,
    ACTIONS(5331), 1,
      anon_sym_QMARK,
    ACTIONS(5333), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5335), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5339), 1,
      anon_sym_GT_EQ,
    ACTIONS(5345), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5349), 1,
      sym__binary_star_star,
    STATE(3901), 1,
      sym_heredoc_body,
    ACTIONS(5337), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5341), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5321), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5343), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5347), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4384), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [128088] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3902), 1,
      sym_heredoc_body,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128150] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3903), 1,
      sym_heredoc_body,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [128222] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3904), 1,
      sym_heredoc_body,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [128292] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5818), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5828), 1,
      anon_sym_QMARK,
    ACTIONS(5830), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3905), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [128372] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3906), 1,
      sym_heredoc_body,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128426] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_PIPE,
    ACTIONS(5750), 1,
      anon_sym_AMP,
    ACTIONS(5756), 1,
      anon_sym_CARET,
    ACTIONS(5766), 1,
      anon_sym_GT_EQ,
    ACTIONS(5772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3907), 1,
      sym_heredoc_body,
    ACTIONS(5764), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5768), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5752), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5770), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5774), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [128496] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5776), 1,
      sym__binary_star_star,
    STATE(3908), 1,
      sym_heredoc_body,
    ACTIONS(4016), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128546] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5543), 1,
      anon_sym_rescue,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5818), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5828), 1,
      anon_sym_QMARK,
    ACTIONS(5830), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3909), 1,
      sym_heredoc_body,
    ACTIONS(3313), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3311), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128628] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5862), 1,
      anon_sym_COMMA,
    STATE(3910), 1,
      sym_heredoc_body,
    STATE(5122), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5866), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5864), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128712] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5577), 1,
      anon_sym_rescue,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5818), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5828), 1,
      anon_sym_QMARK,
    ACTIONS(5830), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3911), 1,
      sym_heredoc_body,
    ACTIONS(3313), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3311), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128794] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    STATE(3912), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128848] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5277), 1,
      anon_sym_COMMA,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    ACTIONS(5744), 1,
      anon_sym_rescue,
    STATE(3484), 1,
      aux_sym_exceptions_repeat1,
    STATE(3913), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3521), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128932] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3914), 1,
      sym_heredoc_body,
    ACTIONS(4016), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [128982] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    STATE(3915), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 26,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129032] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3916), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4344), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [129110] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4193), 1,
      anon_sym_in,
    ACTIONS(4195), 1,
      anon_sym_EQ_GT,
    ACTIONS(4435), 1,
      anon_sym_PIPE,
    ACTIONS(4437), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4439), 1,
      anon_sym_AMP,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(4445), 1,
      anon_sym_CARET,
    ACTIONS(4447), 1,
      anon_sym_QMARK,
    ACTIONS(4449), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4451), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4455), 1,
      anon_sym_GT_EQ,
    ACTIONS(4461), 1,
      anon_sym_EQ_EQ,
    ACTIONS(4465), 1,
      sym__binary_star_star,
    ACTIONS(5522), 1,
      anon_sym_rescue,
    STATE(3917), 1,
      sym_heredoc_body,
    ACTIONS(4453), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(4457), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4441), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4459), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4463), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129194] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    STATE(3918), 1,
      sym_heredoc_body,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129246] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3919), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4284), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [129328] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5451), 1,
      sym__binary_star_star,
    ACTIONS(5455), 1,
      anon_sym_PIPE,
    ACTIONS(5457), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5459), 1,
      anon_sym_AMP,
    ACTIONS(5463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5465), 1,
      anon_sym_CARET,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    ACTIONS(5469), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5471), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5475), 1,
      anon_sym_GT_EQ,
    ACTIONS(5481), 1,
      anon_sym_EQ_EQ,
    STATE(3920), 1,
      sym_heredoc_body,
    ACTIONS(5473), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5477), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5461), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5479), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5483), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4380), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [129406] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5816), 1,
      anon_sym_PIPE,
    ACTIONS(5818), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5820), 1,
      anon_sym_AMP,
    ACTIONS(5824), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5826), 1,
      anon_sym_CARET,
    ACTIONS(5828), 1,
      anon_sym_QMARK,
    ACTIONS(5830), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5832), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5836), 1,
      anon_sym_GT_EQ,
    ACTIONS(5842), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5846), 1,
      sym__binary_star_star,
    STATE(3921), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5838), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5822), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5840), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5844), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 6,
      sym__element_reference_bracket,
      anon_sym_rescue,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [129486] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    STATE(3922), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129535] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_DOT,
    ACTIONS(5407), 1,
      anon_sym_PIPE,
    ACTIONS(5409), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5411), 1,
      anon_sym_AMP,
    ACTIONS(5415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5417), 1,
      anon_sym_CARET,
    ACTIONS(5419), 1,
      anon_sym_QMARK,
    ACTIONS(5421), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5427), 1,
      anon_sym_GT_EQ,
    ACTIONS(5433), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5437), 1,
      sym__binary_star_star,
    ACTIONS(5870), 1,
      anon_sym_rescue,
    STATE(3923), 1,
      sym_heredoc_body,
    ACTIONS(5425), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5429), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5872), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3311), 3,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(5413), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5431), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5435), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129618] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5439), 1,
      anon_sym_COMMA,
    STATE(3535), 1,
      aux_sym_exceptions_repeat1,
    STATE(3924), 1,
      sym_heredoc_body,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129669] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym_PIPE,
    ACTIONS(5876), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5884), 1,
      anon_sym_CARET,
    ACTIONS(5886), 1,
      anon_sym_QMARK,
    ACTIONS(5888), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5894), 1,
      anon_sym_GT_EQ,
    ACTIONS(5900), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3925), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5880), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5902), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129748] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym_PIPE,
    ACTIONS(5876), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5884), 1,
      anon_sym_CARET,
    ACTIONS(5888), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5894), 1,
      anon_sym_GT_EQ,
    ACTIONS(5900), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3926), 1,
      sym_heredoc_body,
    ACTIONS(4032), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5880), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5902), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 6,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [129825] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym_PIPE,
    ACTIONS(5876), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5884), 1,
      anon_sym_CARET,
    ACTIONS(5886), 1,
      anon_sym_QMARK,
    ACTIONS(5888), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5894), 1,
      anon_sym_GT_EQ,
    ACTIONS(5900), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3927), 1,
      sym_heredoc_body,
    ACTIONS(3984), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5880), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3982), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5902), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129904] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym_PIPE,
    ACTIONS(5876), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5884), 1,
      anon_sym_CARET,
    ACTIONS(5886), 1,
      anon_sym_QMARK,
    ACTIONS(5888), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5894), 1,
      anon_sym_GT_EQ,
    ACTIONS(5900), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3928), 1,
      sym_heredoc_body,
    ACTIONS(3998), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5880), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3996), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5902), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [129983] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    STATE(3929), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130036] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    STATE(3930), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130089] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    STATE(3931), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130138] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3932), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5866), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4000), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130217] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5906), 1,
      anon_sym_EQ_GT,
    STATE(3933), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4284), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130298] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    STATE(3934), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [130373] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(3935), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [130450] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5860), 1,
      anon_sym_COMMA,
    STATE(3936), 1,
      sym_heredoc_body,
    STATE(3942), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130501] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3937), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [130578] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3938), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4344), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [130655] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3939), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4380), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [130732] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3940), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4382), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [130809] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(3941), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4384), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [130886] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5938), 1,
      anon_sym_COMMA,
    STATE(3942), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [130935] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5941), 1,
      anon_sym_EQ_GT,
    STATE(3943), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4284), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131016] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    STATE(3944), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131097] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    STATE(3945), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131178] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5860), 1,
      anon_sym_COMMA,
    STATE(3936), 1,
      aux_sym_exceptions_repeat1,
    STATE(3946), 1,
      sym_heredoc_body,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131229] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(3947), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4284), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131310] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5943), 1,
      sym__binary_star_star,
    STATE(3948), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131359] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3949), 1,
      sym_heredoc_body,
    ACTIONS(3719), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131408] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3950), 1,
      sym_heredoc_body,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__binary_minus,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131459] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3951), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131508] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3952), 1,
      sym_heredoc_body,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131557] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3953), 1,
      sym_heredoc_body,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 8,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131614] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3954), 1,
      sym_heredoc_body,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131669] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym_PIPE,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5884), 1,
      anon_sym_CARET,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3955), 1,
      sym_heredoc_body,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 15,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131730] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym_PIPE,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5884), 1,
      anon_sym_CARET,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5894), 1,
      anon_sym_GT_EQ,
    ACTIONS(5900), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3956), 1,
      sym_heredoc_body,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5880), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5902), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 8,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [131801] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym_PIPE,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5884), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      anon_sym_GT_EQ,
    ACTIONS(5900), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3957), 1,
      sym_heredoc_body,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5880), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5902), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [131870] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3958), 1,
      sym_heredoc_body,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [131923] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym_PIPE,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5884), 1,
      anon_sym_CARET,
    ACTIONS(5894), 1,
      anon_sym_GT_EQ,
    ACTIONS(5900), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3959), 1,
      sym_heredoc_body,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3984), 3,
      anon_sym_DOT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
    ACTIONS(5880), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5902), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [131992] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3960), 1,
      sym_heredoc_body,
    ACTIONS(4016), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132041] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    STATE(3961), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [132116] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(3962), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132197] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(5449), 1,
      anon_sym_EQ_GT,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(3963), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132278] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3964), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5866), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3585), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132357] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5945), 1,
      sym__binary_star_star,
    STATE(3965), 1,
      sym_heredoc_body,
    ACTIONS(3425), 9,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_COLON2,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3423), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__element_reference_bracket,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132406] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(3966), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [132483] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym_PIPE,
    ACTIONS(5876), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5884), 1,
      anon_sym_CARET,
    ACTIONS(5888), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5894), 1,
      anon_sym_GT_EQ,
    ACTIONS(5900), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3967), 1,
      sym_heredoc_body,
    ACTIONS(3988), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5880), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5902), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 6,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [132560] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym_PIPE,
    ACTIONS(5876), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5884), 1,
      anon_sym_CARET,
    ACTIONS(5886), 1,
      anon_sym_QMARK,
    ACTIONS(5888), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5894), 1,
      anon_sym_GT_EQ,
    ACTIONS(5900), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3968), 1,
      sym_heredoc_body,
    ACTIONS(4024), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5880), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4022), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5902), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132639] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5020), 1,
      anon_sym_PIPE,
    ACTIONS(5022), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5024), 1,
      anon_sym_AMP,
    ACTIONS(5028), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5030), 1,
      anon_sym_CARET,
    ACTIONS(5032), 1,
      anon_sym_QMARK,
    ACTIONS(5034), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5036), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5040), 1,
      anon_sym_GT_EQ,
    ACTIONS(5046), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5050), 1,
      sym__binary_star_star,
    ACTIONS(5856), 1,
      anon_sym_rescue,
    STATE(3969), 1,
      sym_heredoc_body,
    ACTIONS(5038), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5042), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5026), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5044), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5048), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3525), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [132718] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    STATE(3970), 1,
      sym_heredoc_body,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__line_break,
      sym__binary_minus,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132769] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    STATE(3971), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132818] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    STATE(3972), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132875] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    STATE(3973), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132930] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    STATE(3974), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [132991] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    STATE(3975), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [133062] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    STATE(3976), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [133131] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(3977), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [133208] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    STATE(3978), 1,
      sym_heredoc_body,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133261] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    STATE(3979), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 11,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [133330] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(3980), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [133407] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(3981), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 7,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [133484] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    STATE(3982), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_then,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133533] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    STATE(3983), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4284), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133614] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3936), 1,
      aux_sym_exceptions_repeat1,
    STATE(3984), 1,
      sym_heredoc_body,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 25,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133663] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym_PIPE,
    ACTIONS(5876), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5878), 1,
      anon_sym_AMP,
    ACTIONS(5882), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5884), 1,
      anon_sym_CARET,
    ACTIONS(5886), 1,
      anon_sym_QMARK,
    ACTIONS(5888), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5894), 1,
      anon_sym_GT_EQ,
    ACTIONS(5900), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5904), 1,
      sym__binary_star_star,
    STATE(3985), 1,
      sym_heredoc_body,
    ACTIONS(3719), 2,
      anon_sym_DOT,
      anon_sym_COLON2,
    ACTIONS(5892), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5896), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5880), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5898), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 5,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5902), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133742] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    STATE(3986), 1,
      sym_heredoc_body,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__line_break,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133792] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5951), 1,
      anon_sym_rescue,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(3987), 1,
      sym_heredoc_body,
    STATE(3991), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3521), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133872] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5810), 1,
      anon_sym_rescue,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(3988), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [133950] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3989), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4344), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [134026] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3990), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4380), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [134102] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_COMMA,
    STATE(3991), 1,
      sym_heredoc_body,
    STATE(4051), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134152] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3992), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4382), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [134228] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(3993), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4384), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [134304] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_DOT,
    ACTIONS(5688), 1,
      anon_sym_PIPE,
    ACTIONS(5690), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_CARET,
    ACTIONS(5698), 1,
      anon_sym_GT_EQ,
    ACTIONS(5704), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5708), 1,
      sym__binary_star_star,
    ACTIONS(5710), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5712), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5714), 1,
      anon_sym_QMARK,
    ACTIONS(5716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5718), 1,
      anon_sym_AMP_AMP,
    STATE(3994), 1,
      sym_heredoc_body,
    ACTIONS(5696), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5700), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6019), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4022), 3,
      sym__element_reference_bracket,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(5692), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5702), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5706), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134384] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3991), 1,
      aux_sym_exceptions_repeat1,
    STATE(3995), 1,
      sym_heredoc_body,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 24,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134432] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    ACTIONS(6021), 1,
      anon_sym_rescue,
    ACTIONS(6023), 1,
      anon_sym_COMMA,
    STATE(3996), 1,
      sym_heredoc_body,
    STATE(4112), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3521), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134514] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(3997), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6025), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4344), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134592] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_COMMA,
    STATE(3991), 1,
      aux_sym_exceptions_repeat1,
    STATE(3998), 1,
      sym_heredoc_body,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134642] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(3999), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5866), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6027), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134720] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(4000), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6025), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4382), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134798] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(4001), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6025), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4384), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134876] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5810), 1,
      anon_sym_rescue,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4002), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3525), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [134958] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    ACTIONS(6029), 1,
      anon_sym_rescue,
    STATE(4003), 1,
      sym_heredoc_body,
    STATE(4112), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3521), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135038] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    ACTIONS(6017), 1,
      anon_sym_COMMA,
    ACTIONS(6031), 1,
      anon_sym_rescue,
    STATE(3991), 1,
      aux_sym_exceptions_repeat1,
    STATE(4004), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3521), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135120] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(4005), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4344), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [135196] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(4006), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4380), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [135272] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4007), 1,
      sym_heredoc_body,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__binary_minus,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135322] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4008), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135370] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4009), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135418] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4010), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135474] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4011), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135528] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4012), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135588] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4013), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [135658] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4014), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [135726] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4015), 1,
      sym_heredoc_body,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135778] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4016), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [135846] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4017), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [135894] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(4018), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [135970] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5744), 1,
      anon_sym_rescue,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4019), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136048] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4020), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [136124] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4021), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [136200] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4022), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [136274] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4023), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [136350] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4024), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [136426] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4025), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136506] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5363), 1,
      anon_sym_PIPE,
    ACTIONS(5365), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5367), 1,
      anon_sym_AMP,
    ACTIONS(5371), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5373), 1,
      anon_sym_CARET,
    ACTIONS(5375), 1,
      anon_sym_QMARK,
    ACTIONS(5377), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5379), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5383), 1,
      anon_sym_GT_EQ,
    ACTIONS(5389), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5393), 1,
      sym__binary_star_star,
    STATE(4026), 1,
      sym_heredoc_body,
    ACTIONS(5381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5385), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5369), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5387), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5391), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4327), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [136582] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    STATE(4027), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136630] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    STATE(4028), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136686] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    STATE(4029), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136740] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    STATE(4030), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136800] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    STATE(4031), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [136870] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    STATE(4032), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [136938] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    STATE(4033), 1,
      sym_heredoc_body,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [136990] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    STATE(4034), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [137058] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    STATE(4035), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137106] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6057), 1,
      anon_sym_QMARK,
    ACTIONS(6059), 1,
      anon_sym_PIPE_PIPE,
    STATE(4036), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [137182] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6057), 1,
      anon_sym_QMARK,
    ACTIONS(6059), 1,
      anon_sym_PIPE_PIPE,
    STATE(4037), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3717), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [137258] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_PIPE_PIPE,
    STATE(4038), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [137332] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6057), 1,
      anon_sym_QMARK,
    ACTIONS(6059), 1,
      anon_sym_PIPE_PIPE,
    STATE(4039), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [137408] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6057), 1,
      anon_sym_QMARK,
    ACTIONS(6059), 1,
      anon_sym_PIPE_PIPE,
    STATE(4040), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3996), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [137484] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6057), 1,
      anon_sym_QMARK,
    ACTIONS(6059), 1,
      anon_sym_PIPE_PIPE,
    STATE(4041), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [137560] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4042), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 24,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137608] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4043), 1,
      sym_heredoc_body,
    ACTIONS(2576), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ_GT,
    ACTIONS(2574), 19,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
  [137654] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    STATE(4044), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137702] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5228), 1,
      anon_sym_PIPE,
    ACTIONS(5230), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5232), 1,
      anon_sym_AMP,
    ACTIONS(5236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5238), 1,
      anon_sym_CARET,
    ACTIONS(5240), 1,
      anon_sym_QMARK,
    ACTIONS(5242), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5244), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5248), 1,
      anon_sym_GT_EQ,
    ACTIONS(5254), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5258), 1,
      sym__binary_star_star,
    ACTIONS(5858), 1,
      anon_sym_rescue,
    STATE(4045), 1,
      sym_heredoc_body,
    ACTIONS(5246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5250), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5234), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5252), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5256), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137780] = 23,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5744), 1,
      anon_sym_rescue,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4046), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3525), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [137862] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4047), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [137936] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4048), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4022), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [138012] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6059), 1,
      anon_sym_PIPE_PIPE,
    STATE(4049), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 7,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [138086] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6057), 1,
      anon_sym_QMARK,
    ACTIONS(6059), 1,
      anon_sym_PIPE_PIPE,
    STATE(4050), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3585), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [138162] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6061), 1,
      anon_sym_COMMA,
    STATE(4051), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138210] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    ACTIONS(6033), 1,
      anon_sym_AMP,
    ACTIONS(6039), 1,
      anon_sym_PIPE,
    ACTIONS(6041), 1,
      anon_sym_CARET,
    ACTIONS(6045), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6047), 1,
      anon_sym_GT_EQ,
    ACTIONS(6049), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6053), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6055), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6057), 1,
      anon_sym_QMARK,
    ACTIONS(6059), 1,
      anon_sym_PIPE_PIPE,
    STATE(4052), 1,
      sym_heredoc_body,
    ACTIONS(6035), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6037), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5947), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6043), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6051), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4000), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [138286] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(4053), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4382), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [138362] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4054), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4284), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138442] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4055), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138494] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(4056), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4384), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [138570] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5323), 1,
      anon_sym_in,
    ACTIONS(5325), 1,
      anon_sym_EQ_GT,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4057), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138650] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__binary_star_star,
    STATE(4058), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 24,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138698] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    STATE(4059), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138753] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4060), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3585), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138828] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    STATE(4061), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138879] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4062), 1,
      sym_heredoc_body,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138928] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4063), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [138975] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4064), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139022] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4065), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139077] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    STATE(4066), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139124] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4067), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139177] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4068), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 15,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139236] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4069), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 8,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [139305] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4070), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [139372] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4071), 1,
      sym_heredoc_body,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139423] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4072), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [139490] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6096), 1,
      anon_sym_GT_EQ,
    ACTIONS(6102), 1,
      anon_sym_EQ_EQ,
    STATE(4073), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6082), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4022), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6104), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139565] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4074), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139612] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(194), 1,
      sym__terminator,
    STATE(4075), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6106), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139691] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4076), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3717), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139770] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4077), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3717), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139849] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4078), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3717), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139924] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4079), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3717), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [139999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4080), 1,
      sym_heredoc_body,
    ACTIONS(3777), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ_GT,
    ACTIONS(3779), 19,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
  [140044] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5951), 1,
      anon_sym_rescue,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4081), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140121] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    STATE(4082), 1,
      sym_heredoc_body,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__line_break,
      sym__binary_minus,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140170] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    STATE(4083), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140217] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    STATE(4084), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140264] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    STATE(4085), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140311] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(4086), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4327), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140386] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    STATE(4087), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140441] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(4088), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4382), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140516] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    STATE(4089), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140569] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    STATE(4090), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 15,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140628] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    ACTIONS(6092), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6096), 1,
      anon_sym_GT_EQ,
    ACTIONS(6102), 1,
      anon_sym_EQ_EQ,
    STATE(4091), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6082), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6104), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 8,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [140697] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    ACTIONS(6096), 1,
      anon_sym_GT_EQ,
    ACTIONS(6102), 1,
      anon_sym_EQ_EQ,
    STATE(4092), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6082), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6104), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [140764] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    STATE(4093), 1,
      sym_heredoc_body,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140815] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(4094), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4384), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [140890] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    ACTIONS(6096), 1,
      anon_sym_GT_EQ,
    ACTIONS(6102), 1,
      anon_sym_EQ_EQ,
    STATE(4095), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6082), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6104), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [140957] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(4096), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4380), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141032] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(213), 1,
      sym__terminator,
    STATE(4097), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6106), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141111] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4098), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141158] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4099), 1,
      sym_heredoc_body,
    STATE(4112), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 23,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141205] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6023), 1,
      anon_sym_COMMA,
    STATE(4100), 1,
      sym_heredoc_body,
    STATE(4112), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(3523), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3521), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141254] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_COMMA,
    STATE(4101), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3587), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3585), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141301] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4102), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3996), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141376] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6096), 1,
      anon_sym_GT_EQ,
    ACTIONS(6102), 1,
      anon_sym_EQ_EQ,
    STATE(4103), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6082), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6104), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 6,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [141449] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4104), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4022), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141524] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6096), 1,
      anon_sym_GT_EQ,
    ACTIONS(6102), 1,
      anon_sym_EQ_EQ,
    STATE(4105), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6135), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6082), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6133), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
    ACTIONS(6104), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141601] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(4106), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6025), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4380), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141678] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    STATE(4107), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141725] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(4108), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6025), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4000), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141802] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4109), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3982), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [141877] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4110), 1,
      sym_heredoc_body,
    ACTIONS(3721), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      anon_sym_EQ_GT,
    ACTIONS(3723), 19,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
  [141922] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4111), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 8,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [141991] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6023), 1,
      anon_sym_COMMA,
    STATE(4101), 1,
      aux_sym_exceptions_repeat1,
    STATE(4112), 1,
      sym_heredoc_body,
    ACTIONS(3978), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3976), 22,
      sym__binary_minus,
      sym__binary_star,
      sym__binary_star_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142040] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(4113), 1,
      sym_heredoc_body,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4327), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142115] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    STATE(4114), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 23,
      sym__line_break,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142162] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4115), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4022), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142237] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    STATE(4116), 1,
      sym_heredoc_body,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142288] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4117), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [142355] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4118), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142430] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4119), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142505] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4120), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 6,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [142578] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4121), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 6,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
  [142651] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6096), 1,
      anon_sym_GT_EQ,
    ACTIONS(6102), 1,
      anon_sym_EQ_EQ,
    STATE(4122), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6082), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6104), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142726] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4123), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3982), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142801] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6096), 1,
      anon_sym_GT_EQ,
    ACTIONS(6102), 1,
      anon_sym_EQ_EQ,
    STATE(4124), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6082), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6104), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142876] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(4125), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4344), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [142951] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    ACTIONS(6029), 1,
      anon_sym_rescue,
    STATE(4126), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3525), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143028] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(4127), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5866), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6137), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143105] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4128), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3996), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143180] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4129), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 9,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [143247] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__binary_star_star,
    ACTIONS(5780), 1,
      anon_sym_AMP,
    ACTIONS(5788), 1,
      anon_sym_PIPE,
    ACTIONS(5790), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5794), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5796), 1,
      anon_sym_CARET,
    ACTIONS(5798), 1,
      anon_sym_QMARK,
    ACTIONS(5800), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5802), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5804), 1,
      anon_sym_GT_EQ,
    ACTIONS(5806), 1,
      anon_sym_EQ_EQ,
    STATE(4130), 1,
      sym_heredoc_body,
    ACTIONS(5782), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5784), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5866), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5786), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5792), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6139), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5808), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143324] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    STATE(4131), 1,
      sym_heredoc_body,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 20,
      sym__binary_minus,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143373] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    STATE(4132), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143420] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    STATE(4133), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 23,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143467] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5965), 1,
      anon_sym_QMARK,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4134), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4000), 5,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143542] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4135), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 6,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [143615] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    STATE(4136), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143668] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    STATE(4137), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 15,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143727] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6096), 1,
      anon_sym_GT_EQ,
    ACTIONS(6102), 1,
      anon_sym_EQ_EQ,
    STATE(4138), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6082), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3996), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6104), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [143802] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3137), 1,
      anon_sym_ri,
    STATE(4139), 1,
      sym_heredoc_body,
    ACTIONS(3133), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3135), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3131), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [143851] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6096), 1,
      anon_sym_GT_EQ,
    ACTIONS(6102), 1,
      anon_sym_EQ_EQ,
    STATE(4140), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6082), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6104), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(4030), 6,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_QMARK,
      anon_sym_and,
      anon_sym_or,
  [143924] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(4141), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6141), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6137), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144001] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5624), 1,
      anon_sym_PIPE,
    ACTIONS(5626), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5628), 1,
      anon_sym_AMP,
    ACTIONS(5632), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5634), 1,
      anon_sym_CARET,
    ACTIONS(5636), 1,
      anon_sym_QMARK,
    ACTIONS(5638), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5640), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5644), 1,
      anon_sym_GT_EQ,
    ACTIONS(5650), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5654), 1,
      sym__binary_star_star,
    STATE(4142), 1,
      sym_heredoc_body,
    ACTIONS(5642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5646), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6141), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5630), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5648), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6139), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(5652), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144078] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6074), 1,
      sym__binary_star_star,
    ACTIONS(6076), 1,
      anon_sym_PIPE,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6080), 1,
      anon_sym_AMP,
    ACTIONS(6084), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6086), 1,
      anon_sym_CARET,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6096), 1,
      anon_sym_GT_EQ,
    ACTIONS(6102), 1,
      anon_sym_EQ_EQ,
    STATE(4143), 1,
      sym_heredoc_body,
    ACTIONS(6094), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6082), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6100), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3982), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6104), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144153] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5720), 1,
      anon_sym_in,
    ACTIONS(5722), 1,
      anon_sym_EQ_GT,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4144), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4284), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144232] = 22,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5868), 1,
      sym__binary_star_star,
    ACTIONS(5908), 1,
      anon_sym_PIPE,
    ACTIONS(5910), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5912), 1,
      anon_sym_AMP,
    ACTIONS(5916), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5918), 1,
      anon_sym_CARET,
    ACTIONS(5920), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5926), 1,
      anon_sym_GT_EQ,
    ACTIONS(5932), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5936), 1,
      anon_sym_QMARK,
    STATE(223), 1,
      sym__terminator,
    STATE(4145), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(5924), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5928), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6106), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5914), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5930), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5934), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144311] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_PIPE,
    ACTIONS(5955), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5957), 1,
      anon_sym_AMP,
    ACTIONS(5961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5963), 1,
      anon_sym_CARET,
    ACTIONS(5967), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5969), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5973), 1,
      anon_sym_GT_EQ,
    ACTIONS(5979), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5983), 1,
      sym__binary_star_star,
    STATE(4146), 1,
      sym_heredoc_body,
    ACTIONS(5971), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5975), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5959), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5977), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5981), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3986), 6,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
  [144384] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6151), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6155), 1,
      anon_sym_QMARK,
    ACTIONS(6157), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4147), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4022), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144458] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4148), 1,
      sym_heredoc_body,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144508] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4149), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 8,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [144574] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    STATE(4150), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 15,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144628] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4151), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144674] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6195), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    STATE(4152), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4030), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144746] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    STATE(4153), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 15,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144798] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    STATE(4154), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 14,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144856] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6151), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6155), 1,
      anon_sym_QMARK,
    ACTIONS(6157), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4155), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [144930] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6151), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6155), 1,
      anon_sym_QMARK,
    ACTIONS(6157), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4156), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3717), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145004] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6151), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6157), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4157), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4030), 5,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145076] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6151), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6155), 1,
      anon_sym_QMARK,
    ACTIONS(6157), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4158), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3982), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145150] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6195), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6205), 1,
      anon_sym_QMARK,
    STATE(4159), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3982), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145224] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    STATE(4160), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 7,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [145292] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6151), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6155), 1,
      anon_sym_QMARK,
    ACTIONS(6157), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4161), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3996), 4,
      anon_sym_rescue,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145366] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6195), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6205), 1,
      anon_sym_QMARK,
    STATE(4162), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3717), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145440] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6195), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6205), 1,
      anon_sym_QMARK,
    STATE(4163), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3717), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145514] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5985), 1,
      anon_sym_PIPE,
    ACTIONS(5987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5989), 1,
      anon_sym_AMP,
    ACTIONS(5993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5995), 1,
      anon_sym_CARET,
    ACTIONS(5997), 1,
      anon_sym_QMARK,
    ACTIONS(5999), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6005), 1,
      anon_sym_GT_EQ,
    ACTIONS(6011), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6015), 1,
      sym__binary_star_star,
    STATE(4164), 1,
      sym_heredoc_body,
    ACTIONS(6003), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6007), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(5991), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6009), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4327), 4,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6013), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145588] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    STATE(4165), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 8,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [145654] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    STATE(4166), 1,
      sym_heredoc_body,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 17,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145704] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    STATE(4167), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 8,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [145770] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(4168), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6025), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6139), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145846] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    STATE(4169), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145892] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5592), 1,
      anon_sym_PIPE,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    STATE(4170), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6025), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6137), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [145968] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4171), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 8,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [146034] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6195), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    STATE(4172), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3986), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146106] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6209), 1,
      anon_sym___END__,
    STATE(4173), 1,
      sym_heredoc_body,
    ACTIONS(745), 9,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6207), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [146152] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6195), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6205), 1,
      anon_sym_QMARK,
    STATE(4174), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3585), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146226] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4175), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146272] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6021), 1,
      anon_sym_rescue,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6151), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6155), 1,
      anon_sym_QMARK,
    ACTIONS(6157), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4176), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3525), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146348] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6151), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6157), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4177), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3986), 5,
      anon_sym_rescue,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146420] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6195), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6205), 1,
      anon_sym_QMARK,
    STATE(4178), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4000), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146494] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6031), 1,
      anon_sym_rescue,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6145), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6151), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6155), 1,
      anon_sym_QMARK,
    ACTIONS(6157), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4179), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3525), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146570] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1752), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4180), 1,
      sym_heredoc_body,
    STATE(4427), 1,
      sym__hash_pattern_any_rest,
    STATE(4437), 1,
      sym_keyword_pattern,
    STATE(5702), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6211), 2,
      sym_constant,
      sym_identifier,
    STATE(4436), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5559), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5443), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5445), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [146634] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6195), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6205), 1,
      anon_sym_QMARK,
    STATE(4181), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(3996), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146708] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    STATE(4182), 1,
      sym_heredoc_body,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__binary_minus,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146756] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_AMP,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    ACTIONS(6185), 1,
      anon_sym_PIPE,
    ACTIONS(6187), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6191), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6193), 1,
      anon_sym_CARET,
    ACTIONS(6195), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6197), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6199), 1,
      anon_sym_GT_EQ,
    ACTIONS(6201), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6205), 1,
      anon_sym_QMARK,
    STATE(4183), 1,
      sym_heredoc_body,
    ACTIONS(6177), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6179), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6181), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6189), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(4022), 4,
      anon_sym_COMMA,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6203), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146830] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    STATE(4184), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146876] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4185), 1,
      sym_heredoc_body,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 19,
      sym__binary_minus,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146924] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4186), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [146970] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4187), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147016] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4188), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 15,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147070] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4189), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 15,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147122] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4190), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 14,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147180] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1752), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4191), 1,
      sym_heredoc_body,
    STATE(4437), 1,
      sym_keyword_pattern,
    STATE(4439), 1,
      sym__hash_pattern_any_rest,
    STATE(5702), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6211), 2,
      sym_constant,
      sym_identifier,
    STATE(4436), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5559), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5588), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5590), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [147244] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    STATE(4192), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147290] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6143), 1,
      anon_sym_PIPE,
    ACTIONS(6147), 1,
      anon_sym_AMP,
    ACTIONS(6153), 1,
      anon_sym_CARET,
    ACTIONS(6159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6163), 1,
      anon_sym_GT_EQ,
    ACTIONS(6169), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6173), 1,
      sym__binary_star_star,
    STATE(4193), 1,
      sym_heredoc_body,
    ACTIONS(6161), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6165), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6149), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6167), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6171), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 7,
      anon_sym_rescue,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [147358] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    ACTIONS(6213), 1,
      anon_sym_PIPE,
    STATE(4194), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6025), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6137), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147434] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5594), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5596), 1,
      anon_sym_AMP,
    ACTIONS(5600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5602), 1,
      anon_sym_CARET,
    ACTIONS(5604), 1,
      anon_sym_QMARK,
    ACTIONS(5606), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 1,
      anon_sym_GT_EQ,
    ACTIONS(5618), 1,
      anon_sym_EQ_EQ,
    ACTIONS(5622), 1,
      sym__binary_star_star,
    ACTIONS(6215), 1,
      anon_sym_PIPE,
    STATE(4195), 1,
      sym_heredoc_body,
    ACTIONS(5610), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5614), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6025), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6139), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5598), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(5616), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5620), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147510] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6183), 1,
      sym__binary_star_star,
    STATE(4196), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 22,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147556] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym___END__,
    STATE(4197), 1,
      sym_heredoc_body,
    ACTIONS(3315), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [147599] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6231), 1,
      anon_sym_COLON2,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4198), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147674] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6253), 1,
      anon_sym_COLON2,
    STATE(4199), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147749] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6255), 1,
      anon_sym_COLON2,
    STATE(4200), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147824] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6257), 1,
      anon_sym_COLON2,
    STATE(4201), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147899] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6259), 1,
      anon_sym_COLON2,
    STATE(4202), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [147974] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6261), 1,
      anon_sym_COLON2,
    STATE(4203), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148049] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6263), 1,
      anon_sym_COLON2,
    STATE(4204), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148124] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6265), 1,
      anon_sym_RPAREN,
    STATE(4205), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148199] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6269), 1,
      anon_sym_COLON2,
    STATE(4206), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148274] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6271), 1,
      anon_sym_COLON2,
    STATE(4207), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148349] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6273), 1,
      anon_sym_COLON2,
    STATE(4208), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148424] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6275), 1,
      anon_sym_COLON2,
    STATE(4209), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148499] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6277), 1,
      anon_sym_COLON2,
    STATE(4210), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148574] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6279), 1,
      anon_sym_COLON2,
    STATE(4211), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148649] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6281), 1,
      anon_sym_COLON2,
    STATE(4212), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148724] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6283), 1,
      anon_sym_COLON2,
    STATE(4213), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148799] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6285), 1,
      anon_sym_COLON2,
    STATE(4214), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148874] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6287), 1,
      anon_sym_COLON2,
    STATE(4215), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [148949] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6289), 1,
      anon_sym_COLON2,
    STATE(4216), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149024] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4217), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [149089] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6291), 1,
      anon_sym_COLON2,
    STATE(4218), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149164] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6293), 1,
      anon_sym_RPAREN,
    STATE(4219), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149239] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4220), 1,
      sym_heredoc_body,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149288] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4221), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [149353] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4222), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149398] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4223), 1,
      sym_heredoc_body,
    ACTIONS(4016), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(4014), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149443] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6295), 1,
      anon_sym_COLON2,
    STATE(4224), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149518] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6297), 1,
      anon_sym_COLON2,
    STATE(4225), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149593] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6299), 1,
      anon_sym_COLON2,
    STATE(4226), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149668] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4227), 1,
      sym_heredoc_body,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 18,
      sym__binary_minus,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149715] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6301), 1,
      anon_sym_COLON2,
    STATE(4228), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149790] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym___END__,
    ACTIONS(6307), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6309), 1,
      anon_sym_LBRACK2,
    ACTIONS(6311), 1,
      anon_sym_LPAREN2,
    STATE(4229), 1,
      sym_heredoc_body,
    ACTIONS(6303), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [149839] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6315), 1,
      anon_sym___END__,
    STATE(4230), 1,
      sym_heredoc_body,
    ACTIONS(6313), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [149882] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4231), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 6,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149935] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4232), 1,
      sym_heredoc_body,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [149980] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4233), 1,
      sym_heredoc_body,
    ACTIONS(3183), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3181), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [150023] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3651), 1,
      anon_sym___END__,
    STATE(4234), 1,
      sym_heredoc_body,
    ACTIONS(3649), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [150066] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3655), 1,
      anon_sym___END__,
    STATE(4235), 1,
      sym_heredoc_body,
    ACTIONS(3653), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [150109] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3659), 1,
      anon_sym___END__,
    STATE(4236), 1,
      sym_heredoc_body,
    ACTIONS(3657), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [150152] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym___END__,
    STATE(4237), 1,
      sym_heredoc_body,
    ACTIONS(3661), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [150195] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6317), 1,
      anon_sym_COLON2,
    STATE(4238), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150270] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3675), 1,
      anon_sym___END__,
    STATE(4239), 1,
      sym_heredoc_body,
    ACTIONS(3673), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [150313] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4240), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4030), 4,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150384] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4241), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150435] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6319), 1,
      anon_sym_COLON2,
    STATE(4242), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150510] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4243), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3984), 5,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3982), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150567] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4244), 1,
      sym_heredoc_body,
    ACTIONS(3719), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_DOT_DOT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_EQ_EQ,
    ACTIONS(3717), 21,
      sym__binary_minus,
      sym__binary_star,
      anon_sym_DOT_DOT_DOT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150612] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4245), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3986), 4,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150683] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2926), 1,
      anon_sym___END__,
    STATE(4246), 1,
      sym_heredoc_body,
    ACTIONS(2686), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [150726] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6321), 1,
      anon_sym_COLON2,
    STATE(4247), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150801] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4248), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3982), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [150874] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3795), 1,
      anon_sym___END__,
    STATE(4249), 1,
      sym_heredoc_body,
    ACTIONS(3793), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [150917] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3799), 1,
      anon_sym___END__,
    STATE(4250), 1,
      sym_heredoc_body,
    ACTIONS(3797), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [150960] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6323), 1,
      anon_sym_COLON2,
    STATE(4251), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151035] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6325), 1,
      anon_sym_COLON2,
    STATE(4252), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151110] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4253), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3996), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151183] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2914), 1,
      anon_sym___END__,
    STATE(4254), 1,
      sym_heredoc_body,
    ACTIONS(2916), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [151226] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3695), 1,
      anon_sym___END__,
    STATE(4255), 1,
      sym_heredoc_body,
    ACTIONS(3693), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [151269] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6327), 1,
      anon_sym_COLON2,
    STATE(4256), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151344] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6329), 1,
      anon_sym_COLON2,
    STATE(4257), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151419] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6331), 1,
      anon_sym_COLON2,
    STATE(4258), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151494] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6333), 1,
      anon_sym_COLON2,
    STATE(4259), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151569] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6335), 1,
      anon_sym_COLON2,
    STATE(4260), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151644] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6337), 1,
      anon_sym_COLON2,
    STATE(4261), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151719] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6339), 1,
      anon_sym_COLON2,
    STATE(4262), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151794] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6341), 1,
      anon_sym_RPAREN,
    STATE(4263), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151869] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3333), 1,
      anon_sym___END__,
    STATE(4264), 1,
      sym_heredoc_body,
    ACTIONS(3331), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [151912] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6343), 1,
      anon_sym_COLON2,
    STATE(4265), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [151987] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6345), 1,
      anon_sym_COLON2,
    STATE(4266), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152062] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3591), 1,
      anon_sym___END__,
    STATE(4267), 1,
      sym_heredoc_body,
    ACTIONS(3589), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [152105] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6347), 1,
      anon_sym_COLON2,
    STATE(4268), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152180] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6349), 1,
      anon_sym_COLON2,
    STATE(4269), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152255] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym___END__,
    STATE(4270), 1,
      sym_heredoc_body,
    ACTIONS(3709), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [152298] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4271), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4022), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152371] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6351), 1,
      anon_sym_COLON2,
    STATE(4272), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152446] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym___END__,
    STATE(4273), 1,
      sym_heredoc_body,
    ACTIONS(3605), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [152489] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4274), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3717), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152562] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4275), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(3717), 3,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152635] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6353), 1,
      anon_sym_COLON2,
    STATE(4276), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152710] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6355), 1,
      anon_sym_COLON2,
    STATE(4277), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152785] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym___END__,
    STATE(4278), 1,
      sym_heredoc_body,
    ACTIONS(3617), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [152828] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4279), 1,
      sym_heredoc_body,
    ACTIONS(3167), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3165), 27,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [152871] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3631), 1,
      anon_sym___END__,
    STATE(4280), 1,
      sym_heredoc_body,
    ACTIONS(3629), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [152914] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6357), 1,
      anon_sym_COLON2,
    STATE(4281), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [152989] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6359), 1,
      anon_sym_EQ_GT,
    STATE(4282), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153064] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6361), 1,
      anon_sym_COLON2,
    STATE(4283), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153139] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6363), 1,
      anon_sym_COLON2,
    STATE(4284), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153214] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6365), 1,
      anon_sym_RPAREN,
    STATE(4285), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153289] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6369), 1,
      anon_sym___END__,
    STATE(4286), 1,
      sym_heredoc_body,
    ACTIONS(6367), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [153332] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6371), 1,
      anon_sym_RPAREN,
    STATE(4287), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153407] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6373), 1,
      anon_sym_RPAREN,
    STATE(4288), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153482] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6375), 1,
      anon_sym_RPAREN,
    STATE(4289), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153557] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6377), 1,
      anon_sym_RPAREN,
    STATE(4290), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153632] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6219), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6225), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6229), 1,
      anon_sym_QMARK,
    ACTIONS(6235), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    ACTIONS(6379), 1,
      anon_sym_COLON2,
    STATE(4291), 1,
      sym_heredoc_body,
    ACTIONS(6233), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153707] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6381), 1,
      anon_sym_RPAREN,
    STATE(4292), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153782] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6383), 1,
      anon_sym_RPAREN,
    STATE(4293), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153857] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6385), 1,
      anon_sym_RPAREN,
    STATE(4294), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [153932] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6387), 1,
      anon_sym_RPAREN,
    STATE(4295), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154007] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6389), 1,
      anon_sym_RPAREN,
    STATE(4296), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154082] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6391), 1,
      anon_sym_RPAREN,
    STATE(4297), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154157] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6393), 1,
      anon_sym_RPAREN,
    STATE(4298), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154232] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6395), 1,
      anon_sym_RPAREN,
    STATE(4299), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154307] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6397), 1,
      anon_sym_RPAREN,
    STATE(4300), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154382] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6399), 1,
      anon_sym_RPAREN,
    STATE(4301), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154457] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6401), 1,
      anon_sym_RPAREN,
    STATE(4302), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154532] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6403), 1,
      anon_sym_RPAREN,
    STATE(4303), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154607] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6405), 1,
      anon_sym_RPAREN,
    STATE(4304), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154682] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6407), 1,
      anon_sym_RPAREN,
    STATE(4305), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154757] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym___END__,
    STATE(4306), 1,
      sym_heredoc_body,
    ACTIONS(3665), 28,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [154800] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6409), 1,
      anon_sym_RPAREN,
    STATE(4307), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154875] = 20,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    STATE(4308), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(4327), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [154948] = 21,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_AMP,
    ACTIONS(6072), 1,
      sym__binary_star_star,
    ACTIONS(6108), 1,
      anon_sym_PIPE,
    ACTIONS(6110), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6116), 1,
      anon_sym_CARET,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    ACTIONS(6120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6124), 1,
      anon_sym_GT_EQ,
    ACTIONS(6126), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6411), 1,
      anon_sym_RPAREN,
    STATE(4309), 1,
      sym_heredoc_body,
    ACTIONS(6066), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6068), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6267), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6070), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6112), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6128), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
  [155023] = 17,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6217), 1,
      anon_sym_PIPE,
    ACTIONS(6221), 1,
      anon_sym_AMP,
    ACTIONS(6227), 1,
      anon_sym_CARET,
    ACTIONS(6237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6241), 1,
      anon_sym_GT_EQ,
    ACTIONS(6247), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6251), 1,
      sym__binary_star_star,
    STATE(4310), 1,
      sym_heredoc_body,
    ACTIONS(6239), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6243), 2,
      sym__binary_minus,
      anon_sym_PLUS,
    ACTIONS(6223), 3,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
    ACTIONS(6245), 3,
      sym__binary_star,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6249), 5,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_EQ_TILDE,
      anon_sym_BANG_TILDE,
    ACTIONS(3982), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_COLON2,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
  [155090] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4311), 1,
      sym_heredoc_body,
    ACTIONS(6413), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(2930), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155132] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4312), 1,
      sym_heredoc_body,
    ACTIONS(3357), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3355), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155174] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4313), 1,
      sym_heredoc_body,
    ACTIONS(3591), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3589), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155216] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4314), 1,
      sym_heredoc_body,
    ACTIONS(3607), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3605), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155258] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4315), 1,
      sym_heredoc_body,
    ACTIONS(3619), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3617), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155300] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4316), 1,
      sym_heredoc_body,
    ACTIONS(3631), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3629), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155342] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4317), 1,
      sym_heredoc_body,
    ACTIONS(3547), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3545), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155384] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4318), 1,
      sym_heredoc_body,
    ACTIONS(3297), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3295), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155426] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4319), 1,
      sym_heredoc_body,
    ACTIONS(3301), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3299), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155468] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4320), 1,
      sym_heredoc_body,
    ACTIONS(3667), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3665), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155510] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4321), 1,
      sym_heredoc_body,
    ACTIONS(3703), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3701), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155552] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4322), 1,
      sym_heredoc_body,
    ACTIONS(3583), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3581), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155594] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4323), 1,
      sym_heredoc_body,
    ACTIONS(3647), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3645), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155636] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4324), 1,
      sym_heredoc_body,
    ACTIONS(3707), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3705), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155678] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4325), 1,
      sym_heredoc_body,
    ACTIONS(3651), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3649), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155720] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4326), 1,
      sym_heredoc_body,
    ACTIONS(3655), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3653), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155762] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4327), 1,
      sym_heredoc_body,
    ACTIONS(3535), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3533), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155804] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4328), 1,
      sym_heredoc_body,
    ACTIONS(3659), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3657), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155846] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4329), 1,
      sym_heredoc_body,
    ACTIONS(3691), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3689), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155888] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4330), 1,
      sym_heredoc_body,
    ACTIONS(3663), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3661), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155930] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4331), 1,
      sym_heredoc_body,
    ACTIONS(3221), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3219), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [155972] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4332), 1,
      sym_heredoc_body,
    ACTIONS(3675), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3673), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156014] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4333), 1,
      sym_heredoc_body,
    ACTIONS(3305), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3303), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156056] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4334), 1,
      sym_heredoc_body,
    ACTIONS(3791), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3789), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156098] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4335), 1,
      sym_heredoc_body,
    ACTIONS(3795), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3793), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156140] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4336), 1,
      sym_heredoc_body,
    ACTIONS(3799), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3797), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156182] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4337), 1,
      sym_heredoc_body,
    ACTIONS(3317), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3315), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156224] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4338), 1,
      sym_heredoc_body,
    ACTIONS(6415), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3125), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156266] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4339), 1,
      sym_heredoc_body,
    ACTIONS(3333), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3331), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156308] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4340), 1,
      sym_heredoc_body,
    ACTIONS(3133), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3131), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156350] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4341), 1,
      sym_heredoc_body,
    ACTIONS(3249), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3247), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156392] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4342), 1,
      sym_heredoc_body,
    ACTIONS(3731), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3729), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156434] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4343), 1,
      sym_heredoc_body,
    ACTIONS(3599), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3597), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156476] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4344), 1,
      sym_heredoc_body,
    ACTIONS(3595), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3593), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156518] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4345), 1,
      sym_heredoc_body,
    ACTIONS(6417), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3341), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156560] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4346), 1,
      sym_heredoc_body,
    ACTIONS(3711), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3709), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156602] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4347), 1,
      sym_heredoc_body,
    ACTIONS(3615), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3613), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156644] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4348), 1,
      sym_heredoc_body,
    ACTIONS(6421), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(6419), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156686] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4349), 1,
      sym_heredoc_body,
    ACTIONS(3425), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3423), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156728] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4350), 1,
      sym_heredoc_body,
    ACTIONS(2946), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(2944), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156770] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4351), 1,
      sym_heredoc_body,
    ACTIONS(3217), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3215), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156812] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4352), 1,
      sym_heredoc_body,
    ACTIONS(3543), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3541), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156854] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4353), 1,
      sym_heredoc_body,
    ACTIONS(3683), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3681), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156896] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4354), 1,
      sym_heredoc_body,
    ACTIONS(3715), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3713), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156938] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4355), 1,
      sym_heredoc_body,
    ACTIONS(3695), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3693), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [156980] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4356), 1,
      sym_heredoc_body,
    ACTIONS(3353), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3351), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157022] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4357), 1,
      sym_heredoc_body,
    ACTIONS(3381), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3379), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157064] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4358), 1,
      sym_heredoc_body,
    ACTIONS(3273), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3271), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157106] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4359), 1,
      sym_heredoc_body,
    ACTIONS(3385), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3383), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157148] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4360), 1,
      sym_heredoc_body,
    ACTIONS(3213), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3211), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157190] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4361), 1,
      sym_heredoc_body,
    ACTIONS(3285), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3283), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157232] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4362), 1,
      sym_heredoc_body,
    ACTIONS(3417), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3415), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157274] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2928), 1,
      anon_sym_COLON,
    STATE(4363), 1,
      sym_heredoc_body,
    ACTIONS(2686), 26,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157315] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6425), 1,
      anon_sym___END__,
    STATE(4364), 1,
      sym_heredoc_body,
    ACTIONS(6423), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [157356] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6429), 1,
      anon_sym___END__,
    STATE(4365), 1,
      sym_heredoc_body,
    ACTIONS(6427), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [157397] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6429), 1,
      anon_sym___END__,
    STATE(4366), 1,
      sym_heredoc_body,
    ACTIONS(6427), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [157438] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6425), 1,
      anon_sym___END__,
    STATE(4367), 1,
      sym_heredoc_body,
    ACTIONS(6423), 26,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [157479] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6431), 1,
      anon_sym___END__,
    STATE(4368), 1,
      sym_heredoc_body,
    ACTIONS(3503), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157519] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6435), 1,
      anon_sym___END__,
    STATE(4369), 1,
      sym_heredoc_body,
    ACTIONS(6433), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157559] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6439), 1,
      anon_sym___END__,
    STATE(4370), 1,
      sym_heredoc_body,
    ACTIONS(6437), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157599] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6443), 1,
      anon_sym___END__,
    ACTIONS(6445), 1,
      anon_sym_LBRACE,
    ACTIONS(6447), 1,
      anon_sym_do,
    STATE(4364), 1,
      sym_block,
    STATE(4367), 1,
      sym_do_block,
    STATE(4371), 1,
      sym_heredoc_body,
    ACTIONS(6441), 21,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157647] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6451), 1,
      anon_sym___END__,
    STATE(4372), 1,
      sym_heredoc_body,
    ACTIONS(6449), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157687] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6455), 1,
      anon_sym___END__,
    STATE(4373), 1,
      sym_heredoc_body,
    ACTIONS(6453), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157727] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6459), 1,
      anon_sym___END__,
    STATE(4374), 1,
      sym_heredoc_body,
    ACTIONS(6457), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157767] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym___END__,
    STATE(4375), 1,
      sym_heredoc_body,
    ACTIONS(6461), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157807] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym___END__,
    STATE(4376), 1,
      sym_heredoc_body,
    ACTIONS(6303), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157847] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6467), 1,
      anon_sym___END__,
    STATE(4377), 1,
      sym_heredoc_body,
    ACTIONS(6465), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157887] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6471), 1,
      anon_sym___END__,
    STATE(4378), 1,
      sym_heredoc_body,
    ACTIONS(6469), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157927] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6473), 1,
      anon_sym___END__,
    STATE(4379), 1,
      sym_heredoc_body,
    ACTIONS(2956), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [157967] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym___END__,
    STATE(4380), 1,
      sym_heredoc_body,
    ACTIONS(6475), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158007] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6481), 1,
      anon_sym___END__,
    STATE(4381), 1,
      sym_heredoc_body,
    ACTIONS(6479), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158047] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6485), 1,
      anon_sym___END__,
    STATE(4382), 1,
      sym_heredoc_body,
    ACTIONS(6483), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158087] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6487), 1,
      anon_sym___END__,
    STATE(4383), 1,
      sym_heredoc_body,
    ACTIONS(3339), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158127] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6491), 1,
      anon_sym___END__,
    STATE(4384), 1,
      sym_heredoc_body,
    ACTIONS(6489), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158167] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6493), 1,
      anon_sym_COLON,
    STATE(4385), 1,
      sym_heredoc_body,
    ACTIONS(3125), 24,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158209] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6445), 1,
      anon_sym_LBRACE,
    ACTIONS(6447), 1,
      anon_sym_do,
    ACTIONS(6497), 1,
      anon_sym___END__,
    STATE(4365), 1,
      sym_block,
    STATE(4366), 1,
      sym_do_block,
    STATE(4386), 1,
      sym_heredoc_body,
    ACTIONS(6495), 21,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158257] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6443), 1,
      anon_sym___END__,
    ACTIONS(6445), 1,
      anon_sym_LBRACE,
    STATE(4364), 1,
      sym_block,
    STATE(4367), 1,
      sym_do_block,
    STATE(4387), 1,
      sym_heredoc_body,
    ACTIONS(6441), 22,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158303] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6501), 1,
      anon_sym___END__,
    STATE(4388), 1,
      sym_heredoc_body,
    ACTIONS(6499), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158343] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6445), 1,
      anon_sym_LBRACE,
    ACTIONS(6497), 1,
      anon_sym___END__,
    STATE(4365), 1,
      sym_block,
    STATE(4366), 1,
      sym_do_block,
    STATE(4389), 1,
      sym_heredoc_body,
    ACTIONS(6495), 22,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158389] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym___END__,
    STATE(4390), 1,
      sym_heredoc_body,
    ACTIONS(6503), 25,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158429] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4391), 1,
      sym_heredoc_body,
    ACTIONS(4870), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(4868), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [158468] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6509), 1,
      anon_sym___END__,
    STATE(4392), 1,
      sym_heredoc_body,
    ACTIONS(6507), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158507] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym___END__,
    STATE(4393), 1,
      sym_heredoc_body,
    ACTIONS(6511), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158546] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4394), 1,
      sym_heredoc_body,
    ACTIONS(2564), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2562), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [158585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4395), 1,
      sym_heredoc_body,
    ACTIONS(5073), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(5071), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [158624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4396), 1,
      sym_heredoc_body,
    ACTIONS(2580), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2578), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [158663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4397), 1,
      sym_heredoc_body,
    ACTIONS(2584), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2582), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [158702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4398), 1,
      sym_heredoc_body,
    ACTIONS(2588), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2586), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [158741] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4399), 1,
      sym_heredoc_body,
    STATE(4437), 1,
      sym_keyword_pattern,
    STATE(4439), 1,
      sym__hash_pattern_any_rest,
    STATE(5721), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6515), 2,
      sym_constant,
      sym_identifier,
    STATE(4436), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5814), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5588), 4,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5590), 6,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [158800] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4400), 1,
      sym_heredoc_body,
    STATE(4427), 1,
      sym__hash_pattern_any_rest,
    STATE(4437), 1,
      sym_keyword_pattern,
    STATE(5721), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6515), 2,
      sym_constant,
      sym_identifier,
    STATE(4436), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5814), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5443), 4,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(5445), 6,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [158859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4401), 1,
      sym_heredoc_body,
    ACTIONS(2592), 10,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
    ACTIONS(2590), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_STAR,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      sym_identifier,
  [158898] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6517), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6519), 1,
      anon_sym_DOT_DOT,
    STATE(4402), 1,
      sym_heredoc_body,
    ACTIONS(6303), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158939] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6523), 1,
      anon_sym___END__,
    ACTIONS(6525), 1,
      anon_sym_EQ_GT,
    STATE(4403), 1,
      sym_heredoc_body,
    ACTIONS(6521), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [158980] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6525), 1,
      anon_sym_EQ_GT,
    ACTIONS(6529), 1,
      anon_sym___END__,
    STATE(4404), 1,
      sym_heredoc_body,
    ACTIONS(6527), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159021] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6533), 1,
      anon_sym___END__,
    STATE(4405), 1,
      sym_heredoc_body,
    ACTIONS(6531), 24,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159060] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6525), 1,
      anon_sym_EQ_GT,
    ACTIONS(6537), 1,
      anon_sym___END__,
    STATE(4406), 1,
      sym_heredoc_body,
    ACTIONS(6535), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159101] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6541), 1,
      anon_sym___END__,
    STATE(4407), 1,
      sym_heredoc_body,
    ACTIONS(6539), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159139] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6545), 1,
      anon_sym___END__,
    STATE(4408), 1,
      sym_heredoc_body,
    ACTIONS(6543), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159177] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym___END__,
    STATE(4409), 1,
      sym_heredoc_body,
    ACTIONS(6547), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159215] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6553), 1,
      anon_sym___END__,
    STATE(4410), 1,
      sym_heredoc_body,
    ACTIONS(6551), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159253] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6557), 1,
      anon_sym___END__,
    STATE(4411), 1,
      sym_heredoc_body,
    ACTIONS(6555), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159291] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6561), 1,
      anon_sym_PIPE,
    STATE(4412), 1,
      sym_heredoc_body,
    STATE(4422), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6559), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159331] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6565), 1,
      anon_sym___END__,
    STATE(4413), 1,
      sym_heredoc_body,
    ACTIONS(6563), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159369] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6541), 1,
      anon_sym___END__,
    STATE(4414), 1,
      sym_heredoc_body,
    ACTIONS(6539), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159407] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6569), 1,
      anon_sym___END__,
    STATE(4415), 1,
      sym_heredoc_body,
    ACTIONS(6567), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159445] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6573), 1,
      anon_sym___END__,
    STATE(4416), 1,
      sym_heredoc_body,
    ACTIONS(6571), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159483] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6575), 1,
      anon_sym_COLON,
    STATE(4417), 1,
      sym_heredoc_body,
    ACTIONS(2956), 23,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159521] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6579), 1,
      anon_sym___END__,
    STATE(4418), 1,
      sym_heredoc_body,
    ACTIONS(6577), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159559] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym___END__,
    STATE(4419), 1,
      sym_heredoc_body,
    ACTIONS(6581), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159597] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6587), 1,
      anon_sym___END__,
    STATE(4420), 1,
      sym_heredoc_body,
    ACTIONS(6585), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159635] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6591), 1,
      anon_sym___END__,
    STATE(4421), 1,
      sym_heredoc_body,
    ACTIONS(6589), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159673] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6595), 1,
      anon_sym_PIPE,
    STATE(4422), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6593), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159711] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6600), 1,
      anon_sym___END__,
    STATE(4423), 1,
      sym_heredoc_body,
    ACTIONS(6598), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159749] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6579), 1,
      anon_sym___END__,
    STATE(4424), 1,
      sym_heredoc_body,
    ACTIONS(6577), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159787] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6604), 1,
      anon_sym___END__,
    STATE(4425), 1,
      sym_heredoc_body,
    ACTIONS(6602), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159825] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6608), 1,
      anon_sym___END__,
    STATE(4426), 1,
      sym_heredoc_body,
    ACTIONS(6606), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159863] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym___END__,
    STATE(4427), 1,
      sym_heredoc_body,
    ACTIONS(6610), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159901] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6443), 1,
      anon_sym___END__,
    STATE(4428), 1,
      sym_heredoc_body,
    ACTIONS(6441), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159939] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4429), 1,
      sym_heredoc_body,
    ACTIONS(6614), 3,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6602), 21,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [159977] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6618), 1,
      anon_sym___END__,
    STATE(4430), 1,
      sym_heredoc_body,
    ACTIONS(6616), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160015] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6209), 1,
      anon_sym___END__,
    STATE(4431), 1,
      sym_heredoc_body,
    ACTIONS(6207), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160053] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6622), 1,
      anon_sym___END__,
    STATE(4432), 1,
      sym_heredoc_body,
    ACTIONS(6620), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160091] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6626), 1,
      anon_sym___END__,
    STATE(4433), 1,
      sym_heredoc_body,
    ACTIONS(6624), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160129] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6630), 1,
      anon_sym___END__,
    STATE(4434), 1,
      sym_heredoc_body,
    ACTIONS(6628), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160167] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6634), 1,
      anon_sym___END__,
    STATE(4435), 1,
      sym_heredoc_body,
    ACTIONS(6632), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160205] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym___END__,
    STATE(4436), 1,
      sym_heredoc_body,
    ACTIONS(6636), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160243] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6642), 1,
      anon_sym___END__,
    STATE(4437), 1,
      sym_heredoc_body,
    ACTIONS(6640), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160281] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4606), 1,
      anon_sym___END__,
    STATE(4438), 1,
      sym_heredoc_body,
    ACTIONS(4284), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160319] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5445), 1,
      anon_sym___END__,
    STATE(4439), 1,
      sym_heredoc_body,
    ACTIONS(5443), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160357] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6579), 1,
      anon_sym___END__,
    STATE(4440), 1,
      sym_heredoc_body,
    ACTIONS(6577), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160395] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6646), 1,
      anon_sym___END__,
    STATE(4441), 1,
      sym_heredoc_body,
    ACTIONS(6644), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160433] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6650), 1,
      anon_sym___END__,
    STATE(4442), 1,
      sym_heredoc_body,
    ACTIONS(6648), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160471] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6654), 1,
      anon_sym___END__,
    STATE(4443), 1,
      sym_heredoc_body,
    ACTIONS(6652), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160509] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6579), 1,
      anon_sym___END__,
    STATE(4444), 1,
      sym_heredoc_body,
    ACTIONS(6577), 23,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160547] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6561), 1,
      anon_sym_PIPE,
    STATE(4412), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4445), 1,
      sym_heredoc_body,
    ACTIONS(6511), 22,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_EQ_GT,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160587] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4446), 1,
      sym_heredoc_body,
    STATE(4838), 1,
      sym_keyword_pattern,
    STATE(4860), 1,
      sym__hash_pattern_any_rest,
    STATE(5852), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6656), 2,
      sym_constant,
      sym_identifier,
    STATE(4828), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5568), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5590), 3,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5588), 5,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [160644] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4447), 1,
      sym_heredoc_body,
    STATE(4838), 1,
      sym_keyword_pattern,
    STATE(4860), 1,
      sym__hash_pattern_any_rest,
    STATE(5698), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6658), 2,
      sym_constant,
      sym_identifier,
    STATE(4828), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5722), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5588), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5590), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [160701] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4448), 1,
      sym_heredoc_body,
    STATE(4822), 1,
      sym__hash_pattern_any_rest,
    STATE(4838), 1,
      sym_keyword_pattern,
    STATE(5852), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6656), 2,
      sym_constant,
      sym_identifier,
    STATE(4828), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5568), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5445), 3,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5443), 5,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [160758] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4449), 1,
      sym_heredoc_body,
    STATE(4822), 1,
      sym__hash_pattern_any_rest,
    STATE(4838), 1,
      sym_keyword_pattern,
    STATE(5698), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6658), 2,
      sym_constant,
      sym_identifier,
    STATE(4828), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5722), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
    ACTIONS(5443), 4,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5445), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [160815] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6660), 1,
      sym_identifier,
    ACTIONS(6666), 1,
      anon_sym_nil,
    STATE(4450), 1,
      sym_heredoc_body,
    ACTIONS(6662), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(6664), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160856] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6525), 1,
      anon_sym_EQ_GT,
    ACTIONS(6668), 1,
      anon_sym_COMMA,
    STATE(4451), 1,
      sym_heredoc_body,
    ACTIONS(6616), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160894] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6670), 1,
      anon_sym_COMMA,
    STATE(4452), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6640), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160930] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6675), 1,
      anon_sym_COMMA,
    STATE(4453), 1,
      sym_heredoc_body,
    STATE(4462), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6673), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [160968] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6677), 1,
      anon_sym_COMMA,
    STATE(4454), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161004] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6680), 1,
      sym_identifier,
    STATE(4455), 1,
      sym_heredoc_body,
    ACTIONS(2598), 6,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2606), 15,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161042] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6525), 1,
      anon_sym_EQ_GT,
    ACTIONS(6668), 1,
      anon_sym_COMMA,
    STATE(4456), 1,
      sym_heredoc_body,
    ACTIONS(6682), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161080] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6684), 1,
      anon_sym_COMMA,
    STATE(4457), 1,
      sym_heredoc_body,
    STATE(4458), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6563), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161118] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6686), 1,
      anon_sym_COMMA,
    STATE(4452), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4458), 1,
      sym_heredoc_body,
    ACTIONS(5588), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161156] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6688), 1,
      anon_sym_COMMA,
    STATE(4459), 1,
      sym_heredoc_body,
    STATE(4462), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6673), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161194] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6675), 1,
      anon_sym_COMMA,
    STATE(4459), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4460), 1,
      sym_heredoc_body,
    ACTIONS(6690), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161232] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_COMMA,
    STATE(4461), 1,
      sym_heredoc_body,
    STATE(4464), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6692), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161270] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6696), 1,
      anon_sym_COMMA,
    STATE(4462), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6527), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161306] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6675), 1,
      anon_sym_COMMA,
    STATE(4453), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4463), 1,
      sym_heredoc_body,
    ACTIONS(6690), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161344] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_COMMA,
    STATE(4454), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4464), 1,
      sym_heredoc_body,
    ACTIONS(6699), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161382] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(813), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(155), 1,
      sym_parameters,
    STATE(202), 1,
      sym__terminator,
    STATE(2831), 1,
      sym__body_expr,
    STATE(4465), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5488), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [161441] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(769), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(136), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4466), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [161500] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(811), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(154), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4467), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [161559] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6709), 1,
      anon_sym_rescue,
    STATE(4468), 1,
      sym_heredoc_body,
    ACTIONS(6624), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161594] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6709), 1,
      anon_sym_rescue,
    STATE(4469), 1,
      sym_heredoc_body,
    ACTIONS(6581), 20,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [161629] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(821), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(159), 1,
      sym_parameters,
    STATE(202), 1,
      sym__terminator,
    STATE(2831), 1,
      sym__body_expr,
    STATE(4470), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5488), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [161688] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(767), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(135), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4471), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [161747] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(795), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(146), 1,
      sym_parameters,
    STATE(202), 1,
      sym__terminator,
    STATE(2831), 1,
      sym__body_expr,
    STATE(4472), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5488), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [161806] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(831), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(164), 1,
      sym_parameters,
    STATE(202), 1,
      sym__terminator,
    STATE(2831), 1,
      sym__body_expr,
    STATE(4473), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5488), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [161865] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(815), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(156), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4474), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [161924] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(807), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(152), 1,
      sym_parameters,
    STATE(202), 1,
      sym__terminator,
    STATE(2831), 1,
      sym__body_expr,
    STATE(4475), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5488), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [161983] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(799), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(148), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4476), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162042] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(817), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(157), 1,
      sym_parameters,
    STATE(202), 1,
      sym__terminator,
    STATE(2831), 1,
      sym__body_expr,
    STATE(4477), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5488), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162101] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6713), 1,
      anon_sym___END__,
    STATE(4478), 1,
      sym_heredoc_body,
    ACTIONS(6711), 20,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [162136] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(823), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(160), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4479), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162195] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(777), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(139), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4480), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162254] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(801), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(149), 1,
      sym_parameters,
    STATE(202), 1,
      sym__terminator,
    STATE(2831), 1,
      sym__body_expr,
    STATE(4481), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5488), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162313] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(825), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(161), 1,
      sym_parameters,
    STATE(202), 1,
      sym__terminator,
    STATE(2831), 1,
      sym__body_expr,
    STATE(4482), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5488), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162372] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(793), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(145), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4483), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162431] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(789), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(143), 1,
      sym_parameters,
    STATE(202), 1,
      sym__terminator,
    STATE(2831), 1,
      sym__body_expr,
    STATE(4484), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5488), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162490] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(785), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(142), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4485), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162549] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(805), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(151), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4486), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162608] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(771), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(137), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4487), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162667] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(827), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(162), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4488), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162726] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(829), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(163), 1,
      sym_parameters,
    STATE(210), 1,
      sym__terminator,
    STATE(2216), 1,
      sym__body_expr,
    STATE(4489), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5417), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162785] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(781), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(140), 1,
      sym_parameters,
    STATE(205), 1,
      sym__terminator,
    STATE(4490), 1,
      sym_heredoc_body,
    STATE(5245), 1,
      sym__body_expr,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5429), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162844] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2926), 1,
      anon_sym___END__,
    ACTIONS(3056), 1,
      anon_sym_COLON,
    STATE(4491), 1,
      sym_heredoc_body,
    ACTIONS(2686), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [162881] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(819), 1,
      anon_sym_EQ,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6703), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    STATE(158), 1,
      sym_parameters,
    STATE(202), 1,
      sym__terminator,
    STATE(2831), 1,
      sym__body_expr,
    STATE(4492), 1,
      sym_heredoc_body,
    STATE(5362), 1,
      sym__simple_formal_parameter,
    STATE(5488), 1,
      sym_bare_parameters,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162940] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(273), 1,
      anon_sym_do,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      sym_identifier,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    STATE(4493), 1,
      sym_heredoc_body,
    STATE(5359), 1,
      sym__simple_formal_parameter,
    STATE(2838), 2,
      sym_do_block,
      sym_block,
    STATE(5369), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [162994] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6725), 1,
      anon_sym___END__,
    STATE(4494), 1,
      sym_heredoc_body,
    ACTIONS(6723), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [163028] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6445), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      sym_identifier,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6727), 1,
      anon_sym_do,
    STATE(4495), 1,
      sym_heredoc_body,
    STATE(5359), 1,
      sym__simple_formal_parameter,
    STATE(4343), 2,
      sym_do_block,
      sym_block,
    STATE(5366), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163082] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6715), 1,
      sym_identifier,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(6731), 1,
      anon_sym_do,
    STATE(4496), 1,
      sym_heredoc_body,
    STATE(5359), 1,
      sym__simple_formal_parameter,
    STATE(4616), 2,
      sym_do_block,
      sym_block,
    STATE(5315), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163136] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6715), 1,
      sym_identifier,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6733), 1,
      anon_sym_LBRACE,
    ACTIONS(6735), 1,
      anon_sym_do,
    STATE(4497), 1,
      sym_heredoc_body,
    STATE(5359), 1,
      sym__simple_formal_parameter,
    STATE(4343), 2,
      sym_do_block,
      sym_block,
    STATE(5352), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163190] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6739), 1,
      anon_sym___END__,
    STATE(4498), 1,
      sym_heredoc_body,
    ACTIONS(6737), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [163224] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6743), 1,
      anon_sym___END__,
    STATE(4499), 1,
      sym_heredoc_body,
    ACTIONS(6741), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [163258] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6715), 1,
      sym_identifier,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6745), 1,
      anon_sym_LBRACE,
    ACTIONS(6747), 1,
      anon_sym_do,
    STATE(4500), 1,
      sym_heredoc_body,
    STATE(5359), 1,
      sym__simple_formal_parameter,
    STATE(5356), 2,
      sym_do_block,
      sym_block,
    STATE(5384), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163312] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_COLON,
    STATE(4501), 1,
      sym_heredoc_body,
    ACTIONS(6415), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3125), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [163348] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6753), 1,
      anon_sym___END__,
    STATE(4502), 1,
      sym_heredoc_body,
    ACTIONS(6751), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [163382] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_do,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(2898), 1,
      anon_sym_LBRACE,
    ACTIONS(6715), 1,
      sym_identifier,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    STATE(4503), 1,
      sym_heredoc_body,
    STATE(5359), 1,
      sym__simple_formal_parameter,
    STATE(2306), 2,
      sym_do_block,
      sym_block,
    STATE(5351), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163436] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_COMMA,
    STATE(4504), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [163470] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6760), 1,
      anon_sym___END__,
    STATE(4505), 1,
      sym_heredoc_body,
    ACTIONS(6758), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [163504] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6762), 1,
      anon_sym_COMMA,
    STATE(4504), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4506), 1,
      sym_heredoc_body,
    ACTIONS(6699), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [163540] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6762), 1,
      anon_sym_COMMA,
    STATE(4506), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4507), 1,
      sym_heredoc_body,
    ACTIONS(6692), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [163576] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6715), 1,
      sym_identifier,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6764), 1,
      anon_sym_LBRACE,
    ACTIONS(6766), 1,
      anon_sym_do,
    STATE(4508), 1,
      sym_heredoc_body,
    STATE(5359), 1,
      sym__simple_formal_parameter,
    STATE(4616), 2,
      sym_do_block,
      sym_block,
    STATE(5273), 2,
      sym_parameters,
      sym_bare_parameters,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163630] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6770), 1,
      anon_sym___END__,
    STATE(4509), 1,
      sym_heredoc_body,
    ACTIONS(6768), 19,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [163664] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym___END__,
    ACTIONS(6772), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6774), 1,
      anon_sym_DOT_DOT,
    STATE(4510), 1,
      sym_heredoc_body,
    ACTIONS(6303), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [163701] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6776), 1,
      anon_sym_COMMA,
    STATE(4511), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(6711), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [163734] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6779), 1,
      anon_sym_rescue,
    STATE(4512), 1,
      sym_heredoc_body,
    ACTIONS(6624), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [163767] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6783), 1,
      anon_sym_COMMA,
    STATE(4513), 1,
      sym_heredoc_body,
    STATE(4517), 1,
      aux_sym_undef_repeat1,
    ACTIONS(6781), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [163802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6785), 1,
      anon_sym_EQ2,
    STATE(4514), 1,
      sym_heredoc_body,
    ACTIONS(4870), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [163835] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6779), 1,
      anon_sym_rescue,
    STATE(4515), 1,
      sym_heredoc_body,
    ACTIONS(6581), 18,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [163868] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4516), 1,
      sym_heredoc_body,
    ACTIONS(3723), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3721), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [163901] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6783), 1,
      anon_sym_COMMA,
    STATE(4511), 1,
      aux_sym_undef_repeat1,
    STATE(4517), 1,
      sym_heredoc_body,
    ACTIONS(6787), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_do,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [163936] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6789), 1,
      sym_identifier,
    ACTIONS(6791), 1,
      anon_sym_COMMA,
    ACTIONS(6793), 1,
      anon_sym_PIPE,
    ACTIONS(6795), 1,
      anon_sym_SEMI,
    STATE(4518), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5319), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [163991] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4519), 1,
      sym_heredoc_body,
    ACTIONS(3779), 2,
      anon_sym___END__,
      anon_sym_DOT_DOT,
    ACTIONS(3777), 17,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [164024] = 16,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6789), 1,
      sym_identifier,
    ACTIONS(6797), 1,
      anon_sym_COMMA,
    ACTIONS(6799), 1,
      anon_sym_PIPE,
    ACTIONS(6801), 1,
      anon_sym_SEMI,
    STATE(4520), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5396), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164079] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4521), 1,
      sym_heredoc_body,
    ACTIONS(6805), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6803), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164111] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4522), 1,
      sym_heredoc_body,
    ACTIONS(6805), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6807), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164143] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6789), 1,
      sym_identifier,
    ACTIONS(6809), 1,
      anon_sym_PIPE,
    ACTIONS(6811), 1,
      anon_sym_SEMI,
    STATE(4523), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5163), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164195] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_rescue,
    STATE(4524), 1,
      sym_heredoc_body,
    ACTIONS(6581), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [164227] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6789), 1,
      sym_identifier,
    ACTIONS(6815), 1,
      anon_sym_PIPE,
    ACTIONS(6817), 1,
      anon_sym_SEMI,
    STATE(4525), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5163), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164279] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6789), 1,
      sym_identifier,
    ACTIONS(6819), 1,
      anon_sym_PIPE,
    ACTIONS(6821), 1,
      anon_sym_SEMI,
    STATE(4526), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5163), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164331] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4527), 1,
      sym_heredoc_body,
    ACTIONS(6805), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6823), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164363] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6473), 1,
      anon_sym___END__,
    ACTIONS(6825), 1,
      anon_sym_COLON,
    STATE(4528), 1,
      sym_heredoc_body,
    ACTIONS(2956), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [164397] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6604), 1,
      anon_sym___END__,
    STATE(4529), 1,
      sym_heredoc_body,
    ACTIONS(6827), 3,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6602), 14,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [164431] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4530), 1,
      sym_heredoc_body,
    ACTIONS(6805), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6768), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164463] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6829), 1,
      anon_sym___END__,
    ACTIONS(6831), 1,
      anon_sym_PIPE,
    STATE(4531), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6593), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [164497] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym___END__,
    ACTIONS(6834), 1,
      anon_sym_PIPE,
    STATE(4532), 1,
      sym_heredoc_body,
    STATE(4533), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6511), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [164533] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6834), 1,
      anon_sym_PIPE,
    ACTIONS(6836), 1,
      anon_sym___END__,
    STATE(4531), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4533), 1,
      sym_heredoc_body,
    ACTIONS(6559), 15,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [164569] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4534), 1,
      sym_heredoc_body,
    ACTIONS(6805), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6838), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164601] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6789), 1,
      sym_identifier,
    ACTIONS(6840), 1,
      anon_sym_PIPE,
    ACTIONS(6842), 1,
      anon_sym_SEMI,
    STATE(4535), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5163), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164653] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4536), 1,
      sym_heredoc_body,
    ACTIONS(6805), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6844), 16,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
  [164685] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_rescue,
    STATE(4537), 1,
      sym_heredoc_body,
    ACTIONS(6624), 17,
      sym__line_break,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_then,
      anon_sym_ensure,
      anon_sym_and,
      anon_sym_or,
  [164717] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(6846), 1,
      anon_sym_RBRACE,
    STATE(4538), 1,
      sym_heredoc_body,
    STATE(4836), 1,
      sym_keyword_pattern,
    STATE(4841), 1,
      sym__hash_pattern_any_rest,
    STATE(5850), 1,
      sym__hash_pattern_body,
    STATE(5852), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6656), 2,
      sym_constant,
      sym_identifier,
    STATE(4828), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5568), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [164768] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6848), 1,
      sym_identifier,
    ACTIONS(6850), 1,
      anon_sym_RPAREN,
    STATE(4539), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5440), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [164817] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6660), 1,
      sym_identifier,
    ACTIONS(6666), 1,
      anon_sym_nil,
    STATE(4540), 1,
      sym_heredoc_body,
    ACTIONS(6662), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(6664), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [164852] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3137), 1,
      anon_sym_ri,
    STATE(4541), 1,
      sym_heredoc_body,
    ACTIONS(3135), 2,
      anon_sym_i,
      anon_sym_r,
    ACTIONS(3131), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [164887] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2574), 1,
      anon_sym___END__,
    STATE(4542), 1,
      sym_heredoc_body,
    ACTIONS(2576), 16,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
  [164918] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6852), 1,
      anon_sym_end,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    STATE(4543), 1,
      sym_heredoc_body,
    STATE(4847), 1,
      sym__terminator,
    STATE(5109), 1,
      aux_sym_case_match_repeat1,
    STATE(5183), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5632), 1,
      sym_else,
    ACTIONS(1337), 2,
      sym__line_break,
      anon_sym_SEMI,
  [164977] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(6870), 1,
      anon_sym_end,
    STATE(4544), 1,
      sym_heredoc_body,
    STATE(4843), 1,
      sym__terminator,
    STATE(5165), 1,
      aux_sym_case_repeat1,
    STATE(5166), 1,
      aux_sym_case_match_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5832), 1,
      sym_else,
    ACTIONS(1337), 2,
      sym__line_break,
      anon_sym_SEMI,
  [165036] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6848), 1,
      sym_identifier,
    ACTIONS(6872), 1,
      anon_sym_RPAREN,
    STATE(4545), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5460), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165085] = 15,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2834), 1,
      sym__string_start,
    ACTIONS(6874), 1,
      anon_sym_RBRACE,
    STATE(4546), 1,
      sym_heredoc_body,
    STATE(4836), 1,
      sym_keyword_pattern,
    STATE(4841), 1,
      sym__hash_pattern_any_rest,
    STATE(5701), 1,
      sym__hash_pattern_body,
    STATE(5852), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6656), 2,
      sym_constant,
      sym_identifier,
    STATE(4828), 2,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
    STATE(5568), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [165136] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(6876), 1,
      anon_sym_end,
    STATE(4547), 1,
      sym_heredoc_body,
    STATE(4817), 1,
      sym__terminator,
    STATE(5170), 1,
      aux_sym_case_repeat1,
    STATE(5172), 1,
      aux_sym_case_match_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5657), 1,
      sym_else,
    ACTIONS(1337), 2,
      sym__line_break,
      anon_sym_SEMI,
  [165195] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(6878), 1,
      anon_sym_end,
    STATE(4548), 1,
      sym_heredoc_body,
    STATE(4821), 1,
      sym__terminator,
    STATE(5125), 1,
      aux_sym_case_match_repeat1,
    STATE(5179), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5869), 1,
      sym_else,
    ACTIONS(1337), 2,
      sym__line_break,
      anon_sym_SEMI,
  [165254] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(6880), 1,
      anon_sym_end,
    STATE(4549), 1,
      sym_heredoc_body,
    STATE(4835), 1,
      sym__terminator,
    STATE(5136), 1,
      aux_sym_case_repeat1,
    STATE(5137), 1,
      aux_sym_case_match_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5650), 1,
      sym_else,
    ACTIONS(1337), 2,
      sym__line_break,
      anon_sym_SEMI,
  [165313] = 14,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6848), 1,
      sym_identifier,
    ACTIONS(6882), 1,
      anon_sym_RPAREN,
    STATE(4550), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5471), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165362] = 19,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(6884), 1,
      anon_sym_end,
    STATE(4551), 1,
      sym_heredoc_body,
    STATE(4812), 1,
      sym__terminator,
    STATE(5114), 1,
      aux_sym_case_match_repeat1,
    STATE(5184), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5638), 1,
      sym_else,
    ACTIONS(1337), 2,
      sym__line_break,
      anon_sym_SEMI,
  [165421] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2854), 1,
      anon_sym_STAR,
    ACTIONS(6701), 1,
      sym_identifier,
    ACTIONS(6705), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6707), 1,
      anon_sym_AMP,
    ACTIONS(6886), 1,
      anon_sym_LPAREN,
    STATE(4552), 1,
      sym_heredoc_body,
    STATE(5427), 1,
      sym__formal_parameter,
    STATE(5431), 1,
      sym__simple_formal_parameter,
    STATE(5433), 1,
      sym_parameters,
    STATE(5444), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165467] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___END__,
    ACTIONS(6888), 1,
      anon_sym_COMMA,
    STATE(4553), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6527), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165499] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym___END__,
    ACTIONS(6893), 1,
      anon_sym_COMMA,
    STATE(4554), 1,
      sym_heredoc_body,
    STATE(4568), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6692), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165533] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6680), 1,
      sym_identifier,
    STATE(4555), 1,
      sym_heredoc_body,
    ACTIONS(2598), 6,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2606), 9,
      anon_sym___END__,
      anon_sym_rescue,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165565] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6895), 1,
      sym_identifier,
    STATE(4556), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5163), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165611] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6525), 1,
      anon_sym_EQ_GT,
    ACTIONS(6618), 1,
      anon_sym___END__,
    ACTIONS(6897), 1,
      anon_sym_COMMA,
    STATE(4557), 1,
      sym_heredoc_body,
    ACTIONS(6616), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165645] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5590), 1,
      anon_sym___END__,
    ACTIONS(6899), 1,
      anon_sym_COMMA,
    STATE(4558), 1,
      sym_heredoc_body,
    STATE(4560), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(5588), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165679] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    STATE(2028), 1,
      sym__terminator,
    STATE(4559), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(6901), 8,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [165721] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6642), 1,
      anon_sym___END__,
    ACTIONS(6903), 1,
      anon_sym_COMMA,
    STATE(4560), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6640), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165753] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6906), 1,
      anon_sym___END__,
    ACTIONS(6908), 1,
      anon_sym_COMMA,
    STATE(4553), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4561), 1,
      sym_heredoc_body,
    ACTIONS(6673), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165787] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3159), 1,
      anon_sym_COLON,
    STATE(4562), 1,
      sym_heredoc_body,
    ACTIONS(2686), 15,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [165817] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6789), 1,
      sym_identifier,
    STATE(4563), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5163), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [165863] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym___END__,
    ACTIONS(6912), 1,
      anon_sym_COMMA,
    STATE(4561), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4564), 1,
      sym_heredoc_body,
    ACTIONS(6690), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165897] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6906), 1,
      anon_sym___END__,
    ACTIONS(6912), 1,
      anon_sym_COMMA,
    STATE(4553), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4565), 1,
      sym_heredoc_body,
    ACTIONS(6673), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165931] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6565), 1,
      anon_sym___END__,
    ACTIONS(6914), 1,
      anon_sym_COMMA,
    STATE(4558), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4566), 1,
      sym_heredoc_body,
    ACTIONS(6563), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165965] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6525), 1,
      anon_sym_EQ_GT,
    ACTIONS(6897), 1,
      anon_sym_COMMA,
    ACTIONS(6916), 1,
      anon_sym___END__,
    STATE(4567), 1,
      sym_heredoc_body,
    ACTIONS(6682), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [165999] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_COMMA,
    ACTIONS(6918), 1,
      anon_sym___END__,
    STATE(4568), 1,
      sym_heredoc_body,
    STATE(4569), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6699), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [166033] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6587), 1,
      anon_sym___END__,
    ACTIONS(6920), 1,
      anon_sym_COMMA,
    STATE(4569), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [166065] = 13,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2810), 1,
      anon_sym_STAR,
    ACTIONS(6717), 1,
      anon_sym_LPAREN,
    ACTIONS(6719), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6721), 1,
      anon_sym_AMP,
    ACTIONS(6848), 1,
      sym_identifier,
    STATE(4570), 1,
      sym_heredoc_body,
    STATE(5127), 1,
      sym__simple_formal_parameter,
    STATE(5162), 1,
      sym_parameters,
    STATE(5163), 1,
      sym__formal_parameter,
    STATE(5168), 7,
      sym_forward_parameter,
      sym_splat_parameter,
      sym_hash_splat_parameter,
      sym_hash_splat_nil,
      sym_block_parameter,
      sym_keyword_parameter,
      sym_optional_parameter,
  [166111] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym___END__,
    ACTIONS(6912), 1,
      anon_sym_COMMA,
    STATE(4565), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4571), 1,
      sym_heredoc_body,
    ACTIONS(6690), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [166145] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    STATE(2028), 1,
      sym__terminator,
    STATE(4572), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    ACTIONS(1053), 8,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [166187] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6923), 1,
      anon_sym_COLON,
    STATE(4573), 1,
      sym_heredoc_body,
    ACTIONS(3125), 13,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [166218] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6626), 1,
      anon_sym___END__,
    ACTIONS(6925), 1,
      anon_sym_rescue,
    STATE(4574), 1,
      sym_heredoc_body,
    ACTIONS(6624), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [166249] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3135), 1,
      anon_sym_r,
    STATE(4575), 1,
      sym_heredoc_body,
    ACTIONS(3137), 2,
      anon_sym_i,
      anon_sym_ri,
    ACTIONS(3131), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [166282] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym___END__,
    ACTIONS(6925), 1,
      anon_sym_rescue,
    STATE(4576), 1,
      sym_heredoc_body,
    ACTIONS(6581), 13,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [166313] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3135), 1,
      anon_sym_r,
    STATE(4577), 1,
      sym_heredoc_body,
    ACTIONS(3137), 2,
      anon_sym_i,
      anon_sym_ri,
    ACTIONS(3131), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [166346] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4578), 1,
      sym_heredoc_body,
    ACTIONS(3629), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4579), 1,
      sym_heredoc_body,
    ACTIONS(6207), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(745), 9,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [166400] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_COLON,
    STATE(4580), 1,
      sym_heredoc_body,
    ACTIONS(2686), 13,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [166428] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3167), 1,
      anon_sym_DOT_DOT,
    STATE(4581), 1,
      sym_heredoc_body,
    ACTIONS(3165), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [166456] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4582), 1,
      sym_heredoc_body,
    ACTIONS(3315), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166482] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3183), 1,
      anon_sym_DOT_DOT,
    STATE(4583), 1,
      sym_heredoc_body,
    ACTIONS(3181), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [166510] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4584), 1,
      sym_heredoc_body,
    ACTIONS(6367), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [166536] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4585), 1,
      sym_heredoc_body,
    ACTIONS(3709), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166562] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    ACTIONS(6745), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      anon_sym_do,
    STATE(4586), 1,
      sym_heredoc_body,
    STATE(4915), 1,
      sym_argument_list,
    STATE(5381), 1,
      sym_do_block,
    STATE(5393), 1,
      sym_block,
    ACTIONS(123), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [166600] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4587), 1,
      sym_heredoc_body,
    ACTIONS(2916), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [166626] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6929), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6931), 1,
      anon_sym_LBRACK2,
    ACTIONS(6933), 1,
      anon_sym_LPAREN2,
    STATE(4588), 1,
      sym_heredoc_body,
    ACTIONS(6303), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [166658] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4589), 1,
      sym_heredoc_body,
    ACTIONS(3331), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166684] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4590), 1,
      sym_heredoc_body,
    ACTIONS(6313), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [166710] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4591), 1,
      sym_heredoc_body,
    ACTIONS(3649), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166736] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4592), 1,
      sym_heredoc_body,
    ACTIONS(3653), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166762] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4593), 1,
      sym_heredoc_body,
    ACTIONS(3589), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166788] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4594), 1,
      sym_heredoc_body,
    ACTIONS(3657), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166814] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4595), 1,
      sym_heredoc_body,
    ACTIONS(3661), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166840] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4596), 1,
      sym_heredoc_body,
    ACTIONS(3605), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166866] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    ACTIONS(6745), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      anon_sym_do,
    STATE(4597), 1,
      sym_heredoc_body,
    STATE(4914), 1,
      sym_argument_list,
    STATE(5374), 1,
      sym_do_block,
    STATE(5375), 1,
      sym_block,
    ACTIONS(177), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [166904] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4598), 1,
      sym_heredoc_body,
    ACTIONS(3673), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166930] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym___END__,
    ACTIONS(6935), 1,
      anon_sym_COMMA,
    STATE(4599), 1,
      sym_heredoc_body,
    STATE(4604), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6692), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [166962] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4600), 1,
      sym_heredoc_body,
    ACTIONS(3617), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [166988] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4601), 1,
      sym_heredoc_body,
    ACTIONS(2686), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [167014] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4602), 1,
      sym_heredoc_body,
    ACTIONS(3665), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [167040] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4603), 1,
      sym_heredoc_body,
    ACTIONS(3693), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [167066] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6918), 1,
      anon_sym___END__,
    ACTIONS(6935), 1,
      anon_sym_COMMA,
    STATE(4604), 1,
      sym_heredoc_body,
    STATE(4605), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6699), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [167098] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6587), 1,
      anon_sym___END__,
    ACTIONS(6937), 1,
      anon_sym_COMMA,
    STATE(4605), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [167128] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6940), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6942), 1,
      anon_sym_DOT_DOT,
    STATE(4606), 1,
      sym_heredoc_body,
    ACTIONS(6303), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [167158] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4607), 1,
      sym_heredoc_body,
    ACTIONS(3793), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [167184] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4608), 1,
      sym_heredoc_body,
    ACTIONS(3797), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [167210] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_DOT_DOT,
    STATE(4609), 1,
      sym_heredoc_body,
    ACTIONS(3689), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167237] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3723), 1,
      anon_sym_DOT_DOT,
    STATE(4610), 1,
      sym_heredoc_body,
    ACTIONS(3721), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167264] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_DOT_DOT,
    STATE(4611), 1,
      sym_heredoc_body,
    ACTIONS(3423), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167291] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_DOT_DOT,
    STATE(4612), 1,
      sym_heredoc_body,
    ACTIONS(3777), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167318] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3703), 1,
      anon_sym_DOT_DOT,
    STATE(4613), 1,
      sym_heredoc_body,
    ACTIONS(3701), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167345] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3707), 1,
      anon_sym_DOT_DOT,
    STATE(4614), 1,
      sym_heredoc_body,
    ACTIONS(3705), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167372] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3695), 1,
      anon_sym_DOT_DOT,
    STATE(4615), 1,
      sym_heredoc_body,
    ACTIONS(3693), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167399] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_DOT_DOT,
    STATE(4616), 1,
      sym_heredoc_body,
    ACTIONS(3597), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167426] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_DOT_DOT,
    STATE(4617), 1,
      sym_heredoc_body,
    ACTIONS(3709), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167453] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3285), 1,
      anon_sym_DOT_DOT,
    STATE(4618), 1,
      sym_heredoc_body,
    ACTIONS(3283), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167480] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_DOT_DOT,
    STATE(4619), 1,
      sym_heredoc_body,
    ACTIONS(3355), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167507] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_DOT_DOT,
    STATE(4620), 1,
      sym_heredoc_body,
    ACTIONS(3545), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167534] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3583), 1,
      anon_sym_DOT_DOT,
    STATE(4621), 1,
      sym_heredoc_body,
    ACTIONS(3581), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167561] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3647), 1,
      anon_sym_DOT_DOT,
    STATE(4622), 1,
      sym_heredoc_body,
    ACTIONS(3645), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167588] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3305), 1,
      anon_sym_DOT_DOT,
    STATE(4623), 1,
      sym_heredoc_body,
    ACTIONS(3303), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167615] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_COLON,
    STATE(4624), 1,
      sym_heredoc_body,
    ACTIONS(2956), 12,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [167642] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3221), 1,
      anon_sym_DOT_DOT,
    STATE(4625), 1,
      sym_heredoc_body,
    ACTIONS(3219), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167669] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3213), 1,
      anon_sym_DOT_DOT,
    STATE(4626), 1,
      sym_heredoc_body,
    ACTIONS(3211), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167696] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    STATE(4627), 1,
      sym_heredoc_body,
    STATE(4672), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6559), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [167725] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_DOT_DOT,
    STATE(4628), 1,
      sym_heredoc_body,
    ACTIONS(3379), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167752] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_DOT_DOT,
    STATE(4629), 1,
      sym_heredoc_body,
    ACTIONS(3383), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167779] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3595), 1,
      anon_sym_DOT_DOT,
    STATE(4630), 1,
      sym_heredoc_body,
    ACTIONS(3593), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167806] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_DOT_DOT,
    STATE(4631), 1,
      sym_heredoc_body,
    ACTIONS(3247), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167833] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3273), 1,
      anon_sym_DOT_DOT,
    STATE(4632), 1,
      sym_heredoc_body,
    ACTIONS(3271), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167860] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3297), 1,
      anon_sym_DOT_DOT,
    STATE(4633), 1,
      sym_heredoc_body,
    ACTIONS(3295), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167887] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3417), 1,
      anon_sym_DOT_DOT,
    STATE(4634), 1,
      sym_heredoc_body,
    ACTIONS(3415), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167914] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3301), 1,
      anon_sym_DOT_DOT,
    STATE(4635), 1,
      sym_heredoc_body,
    ACTIONS(3299), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167941] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3683), 1,
      anon_sym_DOT_DOT,
    STATE(4636), 1,
      sym_heredoc_body,
    ACTIONS(3681), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167968] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3715), 1,
      anon_sym_DOT_DOT,
    STATE(4637), 1,
      sym_heredoc_body,
    ACTIONS(3713), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [167995] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3591), 1,
      anon_sym_DOT_DOT,
    STATE(4638), 1,
      sym_heredoc_body,
    ACTIONS(3589), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168022] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3731), 1,
      anon_sym_DOT_DOT,
    STATE(4639), 1,
      sym_heredoc_body,
    ACTIONS(3729), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168049] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_DOT_DOT,
    STATE(4640), 1,
      sym_heredoc_body,
    ACTIONS(3617), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168076] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3631), 1,
      anon_sym_DOT_DOT,
    STATE(4641), 1,
      sym_heredoc_body,
    ACTIONS(3629), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168103] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_DOT_DOT,
    STATE(4642), 1,
      sym_heredoc_body,
    ACTIONS(3665), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168130] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3651), 1,
      anon_sym_DOT_DOT,
    STATE(4643), 1,
      sym_heredoc_body,
    ACTIONS(3649), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168157] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6948), 1,
      anon_sym_COLON,
    STATE(4644), 1,
      sym_heredoc_body,
    ACTIONS(3125), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168186] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3655), 1,
      anon_sym_DOT_DOT,
    STATE(4645), 1,
      sym_heredoc_body,
    ACTIONS(3653), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168213] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3659), 1,
      anon_sym_DOT_DOT,
    STATE(4646), 1,
      sym_heredoc_body,
    ACTIONS(3657), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168240] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_DOT_DOT,
    STATE(4647), 1,
      sym_heredoc_body,
    ACTIONS(3661), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168267] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6417), 1,
      anon_sym_DOT_DOT,
    STATE(4648), 1,
      sym_heredoc_body,
    ACTIONS(3341), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168294] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3217), 1,
      anon_sym_DOT_DOT,
    STATE(4649), 1,
      sym_heredoc_body,
    ACTIONS(3215), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168321] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3675), 1,
      anon_sym_DOT_DOT,
    STATE(4650), 1,
      sym_heredoc_body,
    ACTIONS(3673), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168348] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3543), 1,
      anon_sym_DOT_DOT,
    STATE(4651), 1,
      sym_heredoc_body,
    ACTIONS(3541), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168375] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2946), 1,
      anon_sym_DOT_DOT,
    STATE(4652), 1,
      sym_heredoc_body,
    ACTIONS(2944), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168402] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    ACTIONS(6745), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      anon_sym_do,
    STATE(4653), 1,
      sym_heredoc_body,
    STATE(4914), 1,
      sym_argument_list,
    STATE(5374), 1,
      sym_do_block,
    STATE(5375), 1,
      sym_block,
    ACTIONS(177), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [168439] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3795), 1,
      anon_sym_DOT_DOT,
    STATE(4654), 1,
      sym_heredoc_body,
    ACTIONS(3793), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168466] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    ACTIONS(6745), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      anon_sym_do,
    STATE(4655), 1,
      sym_heredoc_body,
    STATE(4915), 1,
      sym_argument_list,
    STATE(5381), 1,
      sym_do_block,
    STATE(5393), 1,
      sym_block,
    ACTIONS(123), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [168503] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3799), 1,
      anon_sym_DOT_DOT,
    STATE(4656), 1,
      sym_heredoc_body,
    ACTIONS(3797), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168530] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_DOT_DOT,
    STATE(4657), 1,
      sym_heredoc_body,
    ACTIONS(3613), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168557] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6415), 1,
      anon_sym_DOT_DOT,
    STATE(4658), 1,
      sym_heredoc_body,
    ACTIONS(3125), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168584] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3535), 1,
      anon_sym_DOT_DOT,
    STATE(4659), 1,
      sym_heredoc_body,
    ACTIONS(3533), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168611] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_DOT_DOT,
    STATE(4660), 1,
      sym_heredoc_body,
    ACTIONS(3315), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168638] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    STATE(4627), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4661), 1,
      sym_heredoc_body,
    ACTIONS(6511), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [168667] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6413), 1,
      anon_sym_DOT_DOT,
    STATE(4662), 1,
      sym_heredoc_body,
    ACTIONS(2930), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168694] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6626), 1,
      anon_sym___END__,
    ACTIONS(6950), 1,
      anon_sym_rescue,
    STATE(4663), 1,
      sym_heredoc_body,
    ACTIONS(6624), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [168723] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym___END__,
    ACTIONS(6950), 1,
      anon_sym_rescue,
    STATE(4664), 1,
      sym_heredoc_body,
    ACTIONS(6581), 11,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [168752] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3333), 1,
      anon_sym_DOT_DOT,
    STATE(4665), 1,
      sym_heredoc_body,
    ACTIONS(3331), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168779] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_DOT_DOT,
    STATE(4666), 1,
      sym_heredoc_body,
    ACTIONS(3131), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168806] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3199), 1,
      anon_sym_COLON,
    STATE(4667), 1,
      sym_heredoc_body,
    ACTIONS(2686), 12,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_LPAREN2,
      anon_sym_and,
      anon_sym_or,
  [168833] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6421), 1,
      anon_sym_DOT_DOT,
    STATE(4668), 1,
      sym_heredoc_body,
    ACTIONS(6419), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168860] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3353), 1,
      anon_sym_DOT_DOT,
    STATE(4669), 1,
      sym_heredoc_body,
    ACTIONS(3351), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168887] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3791), 1,
      anon_sym_DOT_DOT,
    STATE(4670), 1,
      sym_heredoc_body,
    ACTIONS(3789), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168914] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6952), 1,
      sym_identifier,
    ACTIONS(6954), 1,
      anon_sym_nil,
    STATE(4671), 1,
      sym_heredoc_body,
    ACTIONS(6664), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6662), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [168945] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6956), 1,
      anon_sym_PIPE,
    STATE(4672), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6593), 11,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [168972] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_DOT_DOT,
    STATE(4673), 1,
      sym_heredoc_body,
    ACTIONS(3605), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [168999] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym_COMMA,
    STATE(4674), 1,
      sym_heredoc_body,
    STATE(4689), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6699), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [169027] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6626), 1,
      anon_sym___END__,
    ACTIONS(6961), 1,
      anon_sym_rescue,
    STATE(4675), 1,
      sym_heredoc_body,
    ACTIONS(6624), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [169055] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6713), 1,
      anon_sym___END__,
    ACTIONS(6963), 1,
      anon_sym_COMMA,
    STATE(4676), 2,
      sym_heredoc_body,
      aux_sym_undef_repeat1,
    ACTIONS(6711), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [169083] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6966), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6968), 1,
      anon_sym_DOT_DOT,
    STATE(4677), 1,
      sym_heredoc_body,
    ACTIONS(6303), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169111] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6970), 1,
      anon_sym___END__,
    ACTIONS(6972), 1,
      anon_sym_COMMA,
    STATE(4676), 1,
      aux_sym_undef_repeat1,
    STATE(4678), 1,
      sym_heredoc_body,
    ACTIONS(6787), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [169141] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6974), 1,
      anon_sym___END__,
    STATE(4679), 1,
      sym_heredoc_body,
    ACTIONS(6976), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6838), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [169169] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6978), 1,
      anon_sym___END__,
    STATE(4680), 1,
      sym_heredoc_body,
    ACTIONS(6976), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6803), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [169197] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6972), 1,
      anon_sym_COMMA,
    ACTIONS(6980), 1,
      anon_sym___END__,
    STATE(4678), 1,
      aux_sym_undef_repeat1,
    STATE(4681), 1,
      sym_heredoc_body,
    ACTIONS(6781), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [169227] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6982), 1,
      anon_sym___END__,
    STATE(4682), 1,
      sym_heredoc_body,
    ACTIONS(6976), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6823), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [169255] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6770), 1,
      anon_sym___END__,
    STATE(4683), 1,
      sym_heredoc_body,
    ACTIONS(6976), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6768), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [169283] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym___END__,
    ACTIONS(6961), 1,
      anon_sym_rescue,
    STATE(4684), 1,
      sym_heredoc_body,
    ACTIONS(6581), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_and,
      anon_sym_or,
  [169311] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6984), 1,
      anon_sym___END__,
    STATE(4685), 1,
      sym_heredoc_body,
    ACTIONS(6976), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6844), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [169339] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(733), 1,
      anon_sym_DOT,
    ACTIONS(745), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6785), 1,
      anon_sym_EQ2,
    STATE(4686), 1,
      sym_heredoc_body,
    ACTIONS(4868), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(4870), 7,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [169371] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6959), 1,
      anon_sym_COMMA,
    STATE(4674), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4687), 1,
      sym_heredoc_body,
    ACTIONS(6692), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [169399] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6986), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6988), 1,
      anon_sym_DOT_DOT,
    STATE(4688), 1,
      sym_heredoc_body,
    ACTIONS(6303), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169427] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6990), 1,
      anon_sym_COMMA,
    STATE(4689), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 10,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [169453] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6415), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6993), 1,
      anon_sym_COLON,
    STATE(4690), 1,
      sym_heredoc_body,
    ACTIONS(3125), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169481] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6995), 1,
      anon_sym___END__,
    STATE(4691), 1,
      sym_heredoc_body,
    ACTIONS(6976), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6807), 9,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [169509] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(4868), 1,
      anon_sym___END__,
    ACTIONS(6997), 1,
      anon_sym_EQ2,
    STATE(4692), 1,
      sym_heredoc_body,
    ACTIONS(4870), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [169537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4693), 1,
      sym_heredoc_body,
    ACTIONS(745), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [169560] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4694), 1,
      sym_heredoc_body,
    ACTIONS(6469), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169583] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4695), 1,
      sym_heredoc_body,
    ACTIONS(6427), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [169606] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4696), 1,
      sym_heredoc_body,
    ACTIONS(6503), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169629] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4697), 1,
      sym_heredoc_body,
    ACTIONS(6499), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169652] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6999), 1,
      anon_sym_COLON,
    STATE(4698), 1,
      sym_heredoc_body,
    ACTIONS(2956), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169677] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(733), 1,
      anon_sym_DOT,
    ACTIONS(745), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4868), 1,
      anon_sym_STAR,
    STATE(4699), 1,
      sym_heredoc_body,
    ACTIONS(4870), 8,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [169706] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7001), 1,
      anon_sym_PIPE,
    STATE(4700), 1,
      sym_heredoc_body,
    STATE(4708), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6511), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169733] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4701), 1,
      sym_heredoc_body,
    ACTIONS(6461), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4702), 1,
      sym_heredoc_body,
    ACTIONS(2588), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [169779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4703), 1,
      sym_heredoc_body,
    ACTIONS(2592), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [169802] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4704), 1,
      sym_heredoc_body,
    ACTIONS(6437), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4705), 1,
      sym_heredoc_body,
    ACTIONS(2576), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [169848] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4706), 1,
      sym_heredoc_body,
    ACTIONS(6628), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169871] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4707), 1,
      sym_heredoc_body,
    ACTIONS(6620), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169894] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7001), 1,
      anon_sym_PIPE,
    STATE(4708), 1,
      sym_heredoc_body,
    STATE(4736), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6559), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [169921] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4437), 1,
      sym_keyword_pattern,
    STATE(4709), 1,
      sym_heredoc_body,
    STATE(5591), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(5441), 2,
      sym_constant,
      sym_identifier,
    STATE(5556), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [169956] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7003), 1,
      anon_sym_COMMA,
    STATE(4710), 1,
      sym_heredoc_body,
    STATE(4759), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6673), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [169983] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4711), 1,
      sym_heredoc_body,
    ACTIONS(6489), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170006] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7005), 1,
      anon_sym_COMMA,
    STATE(4712), 1,
      sym_heredoc_body,
    STATE(4714), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6563), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [170033] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(1055), 1,
      anon_sym___END__,
    ACTIONS(7007), 1,
      anon_sym_rescue,
    ACTIONS(7011), 1,
      anon_sym_if,
    ACTIONS(7013), 1,
      anon_sym_unless,
    ACTIONS(7015), 1,
      anon_sym_while,
    ACTIONS(7017), 1,
      anon_sym_until,
    STATE(2088), 1,
      sym__terminator,
    STATE(4713), 1,
      sym_heredoc_body,
    ACTIONS(1053), 2,
      ts_builtin_sym_end,
      aux_sym_program_token1,
    ACTIONS(7009), 2,
      sym__line_break,
      anon_sym_SEMI,
  [170072] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7019), 1,
      anon_sym_COMMA,
    STATE(4714), 1,
      sym_heredoc_body,
    STATE(4745), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(5588), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [170099] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2578), 1,
      anon_sym___END__,
    STATE(4715), 1,
      sym_heredoc_body,
    ACTIONS(2580), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170124] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4437), 1,
      sym_keyword_pattern,
    STATE(4716), 1,
      sym_heredoc_body,
    STATE(5721), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6515), 2,
      sym_constant,
      sym_identifier,
    STATE(5814), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [170159] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2582), 1,
      anon_sym___END__,
    STATE(4717), 1,
      sym_heredoc_body,
    ACTIONS(2584), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170184] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7021), 1,
      sym_identifier,
    STATE(4718), 1,
      sym_heredoc_body,
    ACTIONS(2606), 4,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2598), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [170211] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4719), 1,
      sym_heredoc_body,
    ACTIONS(6453), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170234] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4720), 1,
      sym_heredoc_body,
    ACTIONS(2576), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170257] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5071), 1,
      anon_sym___END__,
    STATE(4721), 1,
      sym_heredoc_body,
    ACTIONS(5073), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170282] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4722), 1,
      sym_heredoc_body,
    ACTIONS(6449), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170305] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7023), 1,
      anon_sym_PIPE,
    STATE(4723), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6593), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170330] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4724), 1,
      sym_heredoc_body,
    ACTIONS(6465), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170353] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6525), 1,
      anon_sym_EQ_GT,
    ACTIONS(7026), 1,
      anon_sym_COMMA,
    STATE(4725), 1,
      sym_heredoc_body,
    ACTIONS(6616), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [170380] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4726), 1,
      sym_heredoc_body,
    ACTIONS(6433), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170403] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4727), 1,
      sym_heredoc_body,
    ACTIONS(6479), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170426] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4728), 1,
      sym_heredoc_body,
    ACTIONS(6303), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4729), 1,
      sym_heredoc_body,
    ACTIONS(2572), 3,
      anon_sym_LBRACE,
      anon_sym_do,
      anon_sym_LPAREN2,
    ACTIONS(2568), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [170474] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4730), 1,
      sym_heredoc_body,
    STATE(4838), 1,
      sym_keyword_pattern,
    STATE(5698), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6658), 2,
      sym_constant,
      sym_identifier,
    STATE(5722), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [170509] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4437), 1,
      sym_keyword_pattern,
    STATE(4731), 1,
      sym_heredoc_body,
    STATE(5702), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6211), 2,
      sym_constant,
      sym_identifier,
    STATE(5559), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [170544] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7007), 1,
      anon_sym_rescue,
    ACTIONS(7011), 1,
      anon_sym_if,
    ACTIONS(7013), 1,
      anon_sym_unless,
    ACTIONS(7015), 1,
      anon_sym_while,
    ACTIONS(7017), 1,
      anon_sym_until,
    ACTIONS(7028), 1,
      anon_sym___END__,
    STATE(2088), 1,
      sym__terminator,
    STATE(4732), 1,
      sym_heredoc_body,
    ACTIONS(6901), 2,
      ts_builtin_sym_end,
      aux_sym_program_token1,
    ACTIONS(7009), 2,
      sym__line_break,
      anon_sym_SEMI,
  [170583] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2834), 1,
      sym__string_start,
    STATE(4733), 1,
      sym_heredoc_body,
    STATE(4838), 1,
      sym_keyword_pattern,
    STATE(5852), 1,
      sym_string,
    ACTIONS(2826), 2,
      sym__constant_suffix,
      aux_sym_constant_suffix_token1,
    ACTIONS(2828), 2,
      sym__identifier_suffix,
      aux_sym_identifier_suffix_token1,
    ACTIONS(6656), 2,
      sym_constant,
      sym_identifier,
    STATE(5568), 2,
      sym_constant_suffix,
      sym_identifier_suffix,
  [170618] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4734), 1,
      sym_heredoc_body,
    ACTIONS(7030), 3,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(6602), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170643] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4735), 1,
      sym_heredoc_body,
    ACTIONS(6457), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170666] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7032), 1,
      anon_sym_PIPE,
    STATE(4736), 2,
      sym_heredoc_body,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6593), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170691] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4737), 1,
      sym_heredoc_body,
    ACTIONS(3503), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170714] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4738), 1,
      sym_heredoc_body,
    ACTIONS(6423), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [170737] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7003), 1,
      anon_sym_COMMA,
    STATE(4739), 1,
      sym_heredoc_body,
    STATE(4743), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6690), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [170764] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7035), 1,
      anon_sym_rescue,
    STATE(4740), 1,
      sym_heredoc_body,
    ACTIONS(6624), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [170789] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7035), 1,
      anon_sym_rescue,
    STATE(4741), 1,
      sym_heredoc_body,
    ACTIONS(6581), 10,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [170814] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4742), 1,
      sym_heredoc_body,
    ACTIONS(6483), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170837] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7037), 1,
      anon_sym_COMMA,
    STATE(4743), 1,
      sym_heredoc_body,
    STATE(4759), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6673), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [170864] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4744), 1,
      sym_heredoc_body,
    ACTIONS(3339), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170887] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7039), 1,
      anon_sym_COMMA,
    STATE(4745), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6640), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [170912] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4868), 1,
      anon_sym___END__,
    STATE(4746), 1,
      sym_heredoc_body,
    ACTIONS(4870), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [170937] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4747), 1,
      sym_heredoc_body,
    ACTIONS(6475), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170960] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_PIPE,
    STATE(4748), 1,
      sym_heredoc_body,
    STATE(4751), 1,
      aux_sym_alternative_pattern_repeat1,
    ACTIONS(6511), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [170987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4749), 1,
      sym_heredoc_body,
    ACTIONS(2580), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171010] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4750), 1,
      sym_heredoc_body,
    ACTIONS(6427), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [171033] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7042), 1,
      anon_sym_PIPE,
    STATE(4723), 1,
      aux_sym_alternative_pattern_repeat1,
    STATE(4751), 1,
      sym_heredoc_body,
    ACTIONS(6559), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171060] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym___END__,
    STATE(4752), 1,
      sym_heredoc_body,
    ACTIONS(2588), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4753), 1,
      sym_heredoc_body,
    ACTIONS(2572), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171108] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym___END__,
    STATE(4754), 1,
      sym_heredoc_body,
    ACTIONS(2592), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171133] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7003), 1,
      anon_sym_COMMA,
    STATE(4710), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4755), 1,
      sym_heredoc_body,
    ACTIONS(6690), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171160] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4756), 1,
      sym_heredoc_body,
    ACTIONS(2956), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4757), 1,
      sym_heredoc_body,
    ACTIONS(2584), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171206] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym___END__,
    STATE(4758), 1,
      sym_heredoc_body,
    ACTIONS(2564), 10,
      sym__line_break,
      ts_builtin_sym_end,
      aux_sym_program_token1,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
  [171231] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7044), 1,
      anon_sym_COMMA,
    STATE(4759), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6527), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171256] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4760), 1,
      sym_heredoc_body,
    ACTIONS(6423), 11,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
      anon_sym_and,
      anon_sym_or,
  [171279] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6525), 1,
      anon_sym_EQ_GT,
    ACTIONS(7026), 1,
      anon_sym_COMMA,
    STATE(4761), 1,
      sym_heredoc_body,
    ACTIONS(6682), 9,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4762), 1,
      sym_heredoc_body,
    ACTIONS(2564), 11,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171329] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4763), 1,
      sym_heredoc_body,
    ACTIONS(7047), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6844), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [171353] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(7049), 1,
      anon_sym_do,
    STATE(4738), 1,
      sym_block,
    STATE(4760), 1,
      sym_do_block,
    STATE(4764), 1,
      sym_heredoc_body,
    ACTIONS(6441), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171383] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    STATE(4695), 1,
      sym_block,
    STATE(4750), 1,
      sym_do_block,
    STATE(4765), 1,
      sym_heredoc_body,
    ACTIONS(6495), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171411] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4766), 1,
      sym_heredoc_body,
    ACTIONS(2584), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171433] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(7049), 1,
      anon_sym_do,
    STATE(4695), 1,
      sym_block,
    STATE(4750), 1,
      sym_do_block,
    STATE(4767), 1,
      sym_heredoc_body,
    ACTIONS(6495), 6,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171463] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4768), 1,
      sym_heredoc_body,
    ACTIONS(6511), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171485] = 11,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7051), 1,
      anon_sym_if,
    ACTIONS(7053), 1,
      anon_sym_unless,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(271), 1,
      sym__terminator,
    STATE(4769), 1,
      sym_heredoc_body,
    STATE(5214), 1,
      sym__guard,
    STATE(5426), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5419), 2,
      sym_if_guard,
      sym_unless_guard,
  [171521] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    ACTIONS(6745), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      anon_sym_do,
    STATE(4770), 1,
      sym_heredoc_body,
    STATE(4915), 1,
      sym_argument_list,
    STATE(5381), 1,
      sym_do_block,
    STATE(5393), 1,
      sym_block,
    ACTIONS(411), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171555] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4771), 1,
      sym_heredoc_body,
    ACTIONS(7047), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6803), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [171579] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4772), 1,
      sym_heredoc_body,
    ACTIONS(6207), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171601] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(249), 1,
      sym__terminator,
    STATE(4773), 1,
      sym_heredoc_body,
    STATE(5195), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [171639] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(255), 1,
      sym__terminator,
    STATE(4774), 1,
      sym_heredoc_body,
    STATE(5207), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [171677] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(6785), 1,
      anon_sym_EQ2,
    STATE(4775), 1,
      sym_heredoc_body,
    ACTIONS(4868), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(4870), 7,
      sym__line_break,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR_STAR,
      anon_sym_AMP,
      sym_identifier,
  [171703] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7057), 1,
      anon_sym_rescue,
    STATE(4776), 1,
      sym_heredoc_body,
    ACTIONS(6581), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [171727] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(250), 1,
      sym__terminator,
    STATE(4777), 1,
      sym_heredoc_body,
    STATE(5197), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [171765] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(254), 1,
      sym__terminator,
    STATE(4778), 1,
      sym_heredoc_body,
    STATE(5198), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [171803] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_COMMA,
    STATE(4779), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [171827] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(253), 1,
      sym__terminator,
    STATE(4780), 1,
      sym_heredoc_body,
    STATE(5196), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [171865] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4781), 1,
      sym_heredoc_body,
    ACTIONS(2564), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171887] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_EQ_GT,
    STATE(4782), 1,
      sym_heredoc_body,
    ACTIONS(6535), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171911] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4783), 1,
      sym_heredoc_body,
    ACTIONS(7047), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6823), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [171935] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7064), 1,
      anon_sym_COLON,
    STATE(4784), 1,
      sym_heredoc_body,
    ACTIONS(2956), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [171959] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4785), 1,
      sym_heredoc_body,
    ACTIONS(2588), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [171981] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4786), 1,
      sym_heredoc_body,
    ACTIONS(745), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172003] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7066), 1,
      anon_sym_rescue,
    ACTIONS(7068), 1,
      anon_sym_if,
    ACTIONS(7070), 1,
      anon_sym_unless,
    ACTIONS(7072), 1,
      anon_sym_while,
    ACTIONS(7074), 1,
      anon_sym_until,
    ACTIONS(7076), 1,
      anon_sym_do,
    STATE(331), 1,
      sym__terminator,
    STATE(2874), 1,
      sym_do,
    STATE(4787), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [172041] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7066), 1,
      anon_sym_rescue,
    ACTIONS(7068), 1,
      anon_sym_if,
    ACTIONS(7070), 1,
      anon_sym_unless,
    ACTIONS(7072), 1,
      anon_sym_while,
    ACTIONS(7074), 1,
      anon_sym_until,
    ACTIONS(7078), 1,
      anon_sym_do,
    STATE(324), 1,
      sym__terminator,
    STATE(2284), 1,
      sym_do,
    STATE(4788), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [172079] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7080), 1,
      anon_sym_COMMA,
    STATE(4779), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4789), 1,
      sym_heredoc_body,
    ACTIONS(6699), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172105] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4790), 1,
      sym_heredoc_body,
    ACTIONS(6507), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172127] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(246), 1,
      sym__terminator,
    STATE(4791), 1,
      sym_heredoc_body,
    STATE(5206), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [172165] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7066), 1,
      anon_sym_rescue,
    ACTIONS(7068), 1,
      anon_sym_if,
    ACTIONS(7070), 1,
      anon_sym_unless,
    ACTIONS(7072), 1,
      anon_sym_while,
    ACTIONS(7074), 1,
      anon_sym_until,
    ACTIONS(7082), 1,
      anon_sym_do,
    STATE(310), 1,
      sym__terminator,
    STATE(4792), 1,
      sym_heredoc_body,
    STATE(5256), 1,
      sym_do,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [172203] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7066), 1,
      anon_sym_rescue,
    ACTIONS(7068), 1,
      anon_sym_if,
    ACTIONS(7070), 1,
      anon_sym_unless,
    ACTIONS(7072), 1,
      anon_sym_while,
    ACTIONS(7074), 1,
      anon_sym_until,
    ACTIONS(7082), 1,
      anon_sym_do,
    STATE(310), 1,
      sym__terminator,
    STATE(4793), 1,
      sym_heredoc_body,
    STATE(5257), 1,
      sym_do,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [172241] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4794), 1,
      sym_heredoc_body,
    ACTIONS(2572), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172263] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4795), 1,
      sym_heredoc_body,
    ACTIONS(2576), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172285] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7066), 1,
      anon_sym_rescue,
    ACTIONS(7068), 1,
      anon_sym_if,
    ACTIONS(7070), 1,
      anon_sym_unless,
    ACTIONS(7072), 1,
      anon_sym_while,
    ACTIONS(7074), 1,
      anon_sym_until,
    ACTIONS(7076), 1,
      anon_sym_do,
    STATE(331), 1,
      sym__terminator,
    STATE(2875), 1,
      sym_do,
    STATE(4796), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [172323] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4797), 1,
      sym_heredoc_body,
    ACTIONS(2592), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172345] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4798), 1,
      sym_heredoc_body,
    ACTIONS(2572), 3,
      anon_sym_LBRACE,
      anon_sym_do,
      anon_sym_LPAREN2,
    ACTIONS(2568), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172369] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7057), 1,
      anon_sym_rescue,
    STATE(4799), 1,
      sym_heredoc_body,
    ACTIONS(6624), 9,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
      anon_sym_and,
      anon_sym_or,
  [172393] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_EQ_GT,
    STATE(4800), 1,
      sym_heredoc_body,
    ACTIONS(6521), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172417] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(247), 1,
      sym__terminator,
    STATE(4801), 1,
      sym_heredoc_body,
    STATE(5205), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [172455] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4802), 1,
      sym_heredoc_body,
    ACTIONS(7047), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6838), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [172479] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7080), 1,
      anon_sym_COMMA,
    STATE(4789), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4803), 1,
      sym_heredoc_body,
    ACTIONS(6692), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172505] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    STATE(4738), 1,
      sym_block,
    STATE(4760), 1,
      sym_do_block,
    STATE(4804), 1,
      sym_heredoc_body,
    ACTIONS(6441), 7,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172533] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7066), 1,
      anon_sym_rescue,
    ACTIONS(7068), 1,
      anon_sym_if,
    ACTIONS(7070), 1,
      anon_sym_unless,
    ACTIONS(7072), 1,
      anon_sym_while,
    ACTIONS(7074), 1,
      anon_sym_until,
    ACTIONS(7078), 1,
      anon_sym_do,
    STATE(324), 1,
      sym__terminator,
    STATE(2282), 1,
      sym_do,
    STATE(4805), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [172571] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4806), 1,
      sym_heredoc_body,
    ACTIONS(6531), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172593] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4807), 1,
      sym_heredoc_body,
    ACTIONS(2580), 10,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_LPAREN2,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [172615] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4808), 1,
      sym_heredoc_body,
    ACTIONS(7047), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6807), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [172639] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4809), 1,
      sym_heredoc_body,
    ACTIONS(7047), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6768), 8,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_unless,
      anon_sym_while,
      anon_sym_until,
      anon_sym_do,
  [172663] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7084), 1,
      anon_sym_COMMA,
    STATE(4810), 1,
      sym_heredoc_body,
    STATE(4848), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(5588), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172688] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7088), 1,
      aux_sym_string_array_token1,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7094), 1,
      sym__string_end,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    STATE(4811), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5435), 1,
      aux_sym_symbol_array_repeat1,
  [172725] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7098), 1,
      anon_sym_end,
    STATE(4812), 1,
      sym_heredoc_body,
    STATE(5126), 1,
      aux_sym_case_match_repeat1,
    STATE(5157), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5773), 1,
      sym_else,
  [172762] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7100), 1,
      aux_sym_string_array_token1,
    ACTIONS(7102), 1,
      sym__string_end,
    STATE(4813), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5485), 1,
      aux_sym_string_array_repeat1,
  [172799] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7104), 1,
      aux_sym_string_array_token1,
    ACTIONS(7106), 1,
      sym__string_end,
    STATE(4814), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5487), 1,
      aux_sym_symbol_array_repeat1,
  [172836] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7108), 1,
      anon_sym_COMMA,
    STATE(4815), 1,
      sym_heredoc_body,
    STATE(4840), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6673), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [172861] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7110), 1,
      aux_sym_string_array_token1,
    ACTIONS(7112), 1,
      sym__string_end,
    STATE(4816), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5446), 1,
      aux_sym_string_array_repeat1,
  [172898] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7114), 1,
      anon_sym_end,
    STATE(4817), 1,
      sym_heredoc_body,
    STATE(5138), 1,
      aux_sym_case_repeat1,
    STATE(5139), 1,
      aux_sym_case_match_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5662), 1,
      sym_else,
  [172935] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_rescue,
    STATE(4818), 1,
      sym_heredoc_body,
    ACTIONS(6624), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172958] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_rescue,
    STATE(4819), 1,
      sym_heredoc_body,
    ACTIONS(6581), 8,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [172981] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7118), 1,
      aux_sym_string_array_token1,
    ACTIONS(7120), 1,
      sym__string_end,
    STATE(4820), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5486), 1,
      aux_sym_symbol_array_repeat1,
  [173018] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7122), 1,
      anon_sym_end,
    STATE(4821), 1,
      sym_heredoc_body,
    STATE(5121), 1,
      aux_sym_case_match_repeat1,
    STATE(5175), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5833), 1,
      sym_else,
  [173055] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4822), 1,
      sym_heredoc_body,
    ACTIONS(6610), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173076] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7124), 1,
      anon_sym_COMMA,
    STATE(4823), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 7,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [173099] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7127), 1,
      anon_sym_COMMA,
    STATE(4824), 1,
      sym_heredoc_body,
    STATE(4846), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6692), 7,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [173124] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4825), 1,
      sym_heredoc_body,
    ACTIONS(6567), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173145] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7129), 1,
      aux_sym_string_array_token1,
    ACTIONS(7131), 1,
      sym__string_end,
    STATE(4826), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5428), 1,
      aux_sym_string_array_repeat1,
  [173182] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7133), 1,
      anon_sym_COMMA,
    STATE(4827), 1,
      sym_heredoc_body,
    STATE(4854), 1,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(5588), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173207] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4828), 1,
      sym_heredoc_body,
    ACTIONS(6636), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173228] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7135), 1,
      anon_sym_COMMA,
    STATE(4829), 1,
      sym_heredoc_body,
    STATE(4850), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6699), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173253] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7108), 1,
      anon_sym_COMMA,
    STATE(4830), 1,
      sym_heredoc_body,
    STATE(4837), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6690), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173278] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7137), 1,
      aux_sym_string_array_token1,
    ACTIONS(7139), 1,
      sym__string_end,
    STATE(4831), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5420), 1,
      aux_sym_symbol_array_repeat1,
  [173315] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_EQ_GT,
    ACTIONS(7141), 1,
      anon_sym_COMMA,
    STATE(4832), 1,
      sym_heredoc_body,
    ACTIONS(6682), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173340] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7143), 1,
      aux_sym_string_array_token1,
    ACTIONS(7145), 1,
      sym__string_end,
    STATE(4833), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5456), 1,
      aux_sym_string_array_repeat1,
  [173377] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7147), 1,
      aux_sym_string_array_token1,
    ACTIONS(7149), 1,
      sym__string_end,
    STATE(4834), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5414), 1,
      aux_sym_symbol_array_repeat1,
  [173414] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7151), 1,
      anon_sym_end,
    STATE(4835), 1,
      sym_heredoc_body,
    STATE(5181), 1,
      aux_sym_case_repeat1,
    STATE(5182), 1,
      aux_sym_case_match_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5858), 1,
      sym_else,
  [173451] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7153), 1,
      anon_sym_COMMA,
    STATE(4827), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4836), 1,
      sym_heredoc_body,
    ACTIONS(6563), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173476] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7155), 1,
      anon_sym_COMMA,
    STATE(4837), 1,
      sym_heredoc_body,
    STATE(4840), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6673), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173501] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4838), 1,
      sym_heredoc_body,
    ACTIONS(6640), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173522] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7157), 1,
      aux_sym_string_array_token1,
    ACTIONS(7159), 1,
      sym__string_end,
    STATE(4839), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5467), 1,
      aux_sym_string_array_repeat1,
  [173559] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7161), 1,
      anon_sym_COMMA,
    STATE(4840), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6527), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173582] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4841), 1,
      sym_heredoc_body,
    ACTIONS(6563), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173603] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_EQ_GT,
    ACTIONS(7141), 1,
      anon_sym_COMMA,
    STATE(4842), 1,
      sym_heredoc_body,
    ACTIONS(6616), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173628] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7164), 1,
      anon_sym_end,
    STATE(4843), 1,
      sym_heredoc_body,
    STATE(5130), 1,
      aux_sym_case_repeat1,
    STATE(5141), 1,
      aux_sym_case_match_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5779), 1,
      sym_else,
  [173665] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4844), 1,
      sym_heredoc_body,
    ACTIONS(6555), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173686] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7108), 1,
      anon_sym_COMMA,
    STATE(4815), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4845), 1,
      sym_heredoc_body,
    ACTIONS(6690), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173711] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7127), 1,
      anon_sym_COMMA,
    STATE(4823), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4846), 1,
      sym_heredoc_body,
    ACTIONS(6699), 7,
      sym__line_break,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [173736] = 12,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7166), 1,
      anon_sym_end,
    STATE(4847), 1,
      sym_heredoc_body,
    STATE(5167), 1,
      aux_sym_case_repeat1,
    STATE(5174), 1,
      aux_sym_case_match_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5816), 1,
      sym_else,
  [173773] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7168), 1,
      anon_sym_COMMA,
    STATE(4848), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6640), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173796] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7135), 1,
      anon_sym_COMMA,
    STATE(4829), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(4849), 1,
      sym_heredoc_body,
    ACTIONS(6692), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173821] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7171), 1,
      anon_sym_COMMA,
    STATE(4850), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173844] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7174), 1,
      aux_sym_string_array_token1,
    ACTIONS(7176), 1,
      sym__string_end,
    STATE(4851), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5448), 1,
      aux_sym_string_array_repeat1,
  [173881] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7178), 1,
      aux_sym_string_array_token1,
    ACTIONS(7180), 1,
      sym__string_end,
    STATE(4852), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5478), 1,
      aux_sym_string_array_repeat1,
  [173918] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_EQ_GT,
    STATE(4853), 1,
      sym_heredoc_body,
    ACTIONS(6527), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173941] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7182), 1,
      anon_sym_COMMA,
    STATE(4854), 2,
      sym_heredoc_body,
      aux_sym__hash_pattern_body_repeat1,
    ACTIONS(6640), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [173964] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7185), 1,
      aux_sym_string_array_token1,
    ACTIONS(7187), 1,
      sym__string_end,
    STATE(4855), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5477), 1,
      aux_sym_symbol_array_repeat1,
  [174001] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7189), 1,
      aux_sym_string_array_token1,
    ACTIONS(7191), 1,
      sym__string_end,
    STATE(4856), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5416), 1,
      aux_sym_symbol_array_repeat1,
  [174038] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7193), 1,
      aux_sym_string_array_token1,
    ACTIONS(7195), 1,
      sym__string_end,
    STATE(4857), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5439), 1,
      aux_sym_symbol_array_repeat1,
  [174075] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7197), 1,
      aux_sym_string_array_token1,
    ACTIONS(7199), 1,
      sym__string_end,
    STATE(4858), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5424), 1,
      aux_sym_string_array_repeat1,
  [174112] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7201), 1,
      aux_sym_string_array_token1,
    ACTIONS(7203), 1,
      sym__string_end,
    STATE(4859), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5459), 1,
      aux_sym_string_array_repeat1,
  [174149] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4860), 1,
      sym_heredoc_body,
    ACTIONS(5443), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174170] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7205), 1,
      aux_sym_string_array_token1,
    ACTIONS(7207), 1,
      sym__string_end,
    STATE(4861), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5413), 1,
      aux_sym_string_array_repeat1,
  [174207] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7209), 1,
      aux_sym_string_array_token1,
    ACTIONS(7211), 1,
      sym__string_end,
    STATE(4862), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5436), 1,
      aux_sym_symbol_array_repeat1,
  [174244] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7213), 1,
      anon_sym_COMMA,
    STATE(4810), 1,
      aux_sym__hash_pattern_body_repeat1,
    STATE(4863), 1,
      sym_heredoc_body,
    ACTIONS(6563), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174269] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7215), 1,
      aux_sym_string_array_token1,
    ACTIONS(7217), 1,
      sym__string_end,
    STATE(4864), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
    STATE(5461), 1,
      aux_sym_symbol_array_repeat1,
  [174306] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7219), 1,
      aux_sym_string_array_token1,
    ACTIONS(7221), 1,
      sym__string_end,
    STATE(4864), 1,
      aux_sym__literal_contents,
    STATE(4865), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [174340] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7223), 1,
      aux_sym_string_array_token1,
    ACTIONS(7225), 1,
      sym__string_end,
    STATE(4857), 1,
      aux_sym__literal_contents,
    STATE(4866), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [174374] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4867), 1,
      sym_heredoc_body,
    ACTIONS(6652), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174394] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7227), 1,
      aux_sym_string_array_token1,
    ACTIONS(7229), 1,
      sym__string_end,
    STATE(4816), 1,
      aux_sym__literal_contents,
    STATE(4868), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [174428] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7231), 1,
      aux_sym_string_array_token1,
    ACTIONS(7233), 1,
      sym__string_end,
    STATE(4820), 1,
      aux_sym__literal_contents,
    STATE(4869), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [174462] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(7235), 1,
      anon_sym_in,
    STATE(4870), 1,
      sym_heredoc_body,
    STATE(5212), 1,
      sym_in,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2962), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174490] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4871), 1,
      sym_heredoc_body,
    ACTIONS(6598), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174510] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4872), 1,
      sym_heredoc_body,
    ACTIONS(6577), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174530] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4873), 1,
      sym_heredoc_body,
    ACTIONS(6577), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174550] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4874), 1,
      sym_heredoc_body,
    ACTIONS(6577), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174570] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7237), 1,
      anon_sym_COMMA,
    STATE(4875), 1,
      sym_heredoc_body,
    STATE(4916), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6690), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174594] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4876), 1,
      sym_heredoc_body,
    ACTIONS(6606), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174614] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7237), 1,
      anon_sym_COMMA,
    STATE(4877), 1,
      sym_heredoc_body,
    STATE(4931), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6673), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174638] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_COMMA,
    STATE(4878), 1,
      sym_heredoc_body,
    STATE(4917), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6692), 6,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [174662] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4879), 1,
      sym_heredoc_body,
    ACTIONS(6644), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174682] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4880), 1,
      sym_heredoc_body,
    ACTIONS(6648), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174702] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_EQ_GT,
    ACTIONS(7241), 1,
      anon_sym_COMMA,
    STATE(4881), 1,
      sym_heredoc_body,
    ACTIONS(6682), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174726] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4882), 1,
      sym_heredoc_body,
    ACTIONS(6547), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174746] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4883), 1,
      sym_heredoc_body,
    ACTIONS(6551), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174766] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7243), 1,
      anon_sym_COMMA,
    STATE(4884), 1,
      sym_heredoc_body,
    STATE(4892), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6692), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174790] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(7235), 1,
      anon_sym_in,
    STATE(4885), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    STATE(5220), 1,
      sym_in,
    ACTIONS(2962), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4886), 1,
      sym_heredoc_body,
    ACTIONS(2944), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174838] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4887), 1,
      sym_heredoc_body,
    ACTIONS(2962), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(7245), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [174860] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4888), 1,
      sym_heredoc_body,
    ACTIONS(6571), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174880] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4889), 1,
      sym_heredoc_body,
    ACTIONS(4284), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174900] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7247), 1,
      aux_sym_string_array_token1,
    ACTIONS(7249), 1,
      sym__string_end,
    STATE(4826), 1,
      aux_sym__literal_contents,
    STATE(4890), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [174934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4891), 1,
      sym_heredoc_body,
    ACTIONS(123), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [174954] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7243), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      sym_heredoc_body,
    STATE(4899), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6699), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174978] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4893), 1,
      sym_heredoc_body,
    ACTIONS(6602), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [174998] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4894), 1,
      sym_heredoc_body,
    ACTIONS(6624), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4895), 1,
      sym_heredoc_body,
    ACTIONS(2940), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [175038] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4896), 1,
      sym_heredoc_body,
    ACTIONS(6581), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175058] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    STATE(2088), 1,
      sym__terminator,
    STATE(4897), 1,
      sym_heredoc_body,
    ACTIONS(7009), 2,
      sym__line_break,
      anon_sym_SEMI,
  [175090] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7251), 1,
      aux_sym_string_array_token1,
    ACTIONS(7253), 1,
      sym__string_end,
    STATE(4839), 1,
      aux_sym__literal_contents,
    STATE(4898), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [175124] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_COMMA,
    STATE(4899), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175146] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7258), 1,
      anon_sym_end,
    ACTIONS(7260), 1,
      anon_sym_rescue,
    ACTIONS(7262), 1,
      anon_sym_ensure,
    STATE(4900), 1,
      sym_heredoc_body,
    STATE(4913), 1,
      aux_sym__body_statement_repeat1,
    STATE(5280), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [175176] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7264), 1,
      aux_sym_string_array_token1,
    ACTIONS(7266), 1,
      sym__string_end,
    STATE(4851), 1,
      aux_sym__literal_contents,
    STATE(4901), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [175210] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7268), 1,
      aux_sym_string_array_token1,
    ACTIONS(7270), 1,
      sym__string_end,
    STATE(4831), 1,
      aux_sym__literal_contents,
    STATE(4902), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [175244] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7272), 1,
      aux_sym_string_array_token1,
    ACTIONS(7274), 1,
      sym__string_end,
    STATE(4903), 1,
      sym_heredoc_body,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(5143), 1,
      sym_interpolation,
  [175278] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4904), 1,
      sym_heredoc_body,
    ACTIONS(6585), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175298] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4905), 1,
      sym_heredoc_body,
    ACTIONS(6441), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175318] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7276), 1,
      aux_sym_string_array_token1,
    ACTIONS(7278), 1,
      sym__string_end,
    STATE(4833), 1,
      aux_sym__literal_contents,
    STATE(4906), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [175352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4907), 1,
      sym_heredoc_body,
    ACTIONS(2910), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [175372] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4908), 1,
      sym_heredoc_body,
    ACTIONS(6539), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175392] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7280), 1,
      aux_sym_string_array_token1,
    ACTIONS(7282), 1,
      sym__string_end,
    STATE(4852), 1,
      aux_sym__literal_contents,
    STATE(4909), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [175426] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7258), 1,
      anon_sym_end,
    ACTIONS(7260), 1,
      anon_sym_rescue,
    ACTIONS(7262), 1,
      anon_sym_ensure,
    STATE(4910), 1,
      sym_heredoc_body,
    STATE(4929), 1,
      aux_sym__body_statement_repeat1,
    STATE(5280), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [175456] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4911), 1,
      sym_heredoc_body,
    ACTIONS(6577), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175476] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7284), 1,
      aux_sym_string_array_token1,
    ACTIONS(7286), 1,
      sym__string_end,
    STATE(4855), 1,
      aux_sym__literal_contents,
    STATE(4912), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [175510] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7260), 1,
      anon_sym_rescue,
    ACTIONS(7262), 1,
      anon_sym_ensure,
    ACTIONS(7288), 1,
      anon_sym_end,
    STATE(4913), 1,
      sym_heredoc_body,
    STATE(4929), 1,
      aux_sym__body_statement_repeat1,
    STATE(5280), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [175540] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6745), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      anon_sym_do,
    STATE(4914), 1,
      sym_heredoc_body,
    STATE(5290), 1,
      sym_do_block,
    STATE(5291), 1,
      sym_block,
    ACTIONS(3173), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [175568] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6745), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      anon_sym_do,
    STATE(4915), 1,
      sym_heredoc_body,
    STATE(5295), 1,
      sym_do_block,
    STATE(5298), 1,
      sym_block,
    ACTIONS(3177), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [175596] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7290), 1,
      anon_sym_COMMA,
    STATE(4916), 1,
      sym_heredoc_body,
    STATE(4931), 1,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6673), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175620] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7239), 1,
      anon_sym_COMMA,
    STATE(4917), 1,
      sym_heredoc_body,
    STATE(4919), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6699), 6,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [175644] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7292), 1,
      aux_sym_string_array_token1,
    ACTIONS(7294), 1,
      sym__string_end,
    STATE(4834), 1,
      aux_sym__literal_contents,
    STATE(4918), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [175678] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7296), 1,
      anon_sym_COMMA,
    STATE(4919), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 6,
      sym__line_break,
      anon_sym_rescue,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [175700] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7299), 1,
      anon_sym_rescue,
    STATE(4920), 1,
      sym_heredoc_body,
    ACTIONS(6624), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175722] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7301), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7304), 1,
      aux_sym_string_array_token1,
    ACTIONS(7306), 1,
      sym_escape_sequence,
    ACTIONS(7309), 1,
      sym_string_content,
    ACTIONS(7312), 1,
      sym__string_end,
    ACTIONS(7314), 1,
      sym__short_interpolation,
    STATE(5143), 1,
      sym_interpolation,
    STATE(4921), 2,
      sym_heredoc_body,
      aux_sym__literal_contents,
  [175754] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7299), 1,
      anon_sym_rescue,
    STATE(4922), 1,
      sym_heredoc_body,
    ACTIONS(6581), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [175776] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7317), 1,
      aux_sym_string_array_token1,
    ACTIONS(7319), 1,
      sym__string_end,
    STATE(4858), 1,
      aux_sym__literal_contents,
    STATE(4923), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [175810] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7321), 1,
      aux_sym_string_array_token1,
    ACTIONS(7323), 1,
      sym__string_end,
    STATE(4811), 1,
      aux_sym__literal_contents,
    STATE(4924), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [175844] = 10,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_rescue,
    ACTIONS(6856), 1,
      anon_sym_if,
    ACTIONS(6858), 1,
      anon_sym_unless,
    ACTIONS(6860), 1,
      anon_sym_while,
    ACTIONS(6862), 1,
      anon_sym_until,
    STATE(2028), 1,
      sym__terminator,
    STATE(4925), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [175876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4926), 1,
      sym_heredoc_body,
    ACTIONS(2932), 8,
      sym__element_reference_bracket,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [175896] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6745), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      anon_sym_do,
    STATE(4927), 1,
      sym_heredoc_body,
    STATE(5226), 1,
      sym_do_block,
    STATE(5289), 1,
      sym_block,
    ACTIONS(3169), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [175924] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7325), 1,
      aux_sym_string_array_token1,
    ACTIONS(7327), 1,
      sym__string_end,
    STATE(4859), 1,
      aux_sym__literal_contents,
    STATE(4928), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [175958] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7329), 1,
      anon_sym_end,
    ACTIONS(7331), 1,
      anon_sym_rescue,
    ACTIONS(7334), 1,
      anon_sym_else,
    ACTIONS(7337), 1,
      anon_sym_ensure,
    STATE(4929), 2,
      sym_heredoc_body,
      aux_sym__body_statement_repeat1,
    STATE(5280), 3,
      sym_else,
      sym_ensure,
      sym_rescue,
  [175986] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7340), 1,
      aux_sym_string_array_token1,
    ACTIONS(7342), 1,
      sym__string_end,
    STATE(4856), 1,
      aux_sym__literal_contents,
    STATE(4930), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [176020] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7344), 1,
      anon_sym_COMMA,
    STATE(4931), 2,
      sym_heredoc_body,
      aux_sym__array_pattern_n_repeat1,
    ACTIONS(6527), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176042] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7237), 1,
      anon_sym_COMMA,
    STATE(4877), 1,
      aux_sym__array_pattern_n_repeat1,
    STATE(4932), 1,
      sym_heredoc_body,
    ACTIONS(6690), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176066] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4933), 1,
      sym_heredoc_body,
    ACTIONS(6616), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176086] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    ACTIONS(7235), 1,
      anon_sym_in,
    STATE(4934), 1,
      sym_heredoc_body,
    STATE(5199), 1,
      sym_in,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(2962), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176114] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7347), 1,
      aux_sym_string_array_token1,
    ACTIONS(7349), 1,
      sym__string_end,
    STATE(4813), 1,
      aux_sym__literal_contents,
    STATE(4935), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [176148] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7351), 1,
      aux_sym_string_array_token1,
    ACTIONS(7353), 1,
      sym__string_end,
    STATE(4814), 1,
      aux_sym__literal_contents,
    STATE(4936), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [176182] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4937), 1,
      sym_heredoc_body,
    ACTIONS(6543), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176202] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7355), 1,
      aux_sym_string_array_token1,
    ACTIONS(7357), 1,
      sym__string_end,
    STATE(4861), 1,
      aux_sym__literal_contents,
    STATE(4938), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [176236] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7359), 1,
      aux_sym_string_array_token1,
    ACTIONS(7361), 1,
      sym__string_end,
    STATE(4862), 1,
      aux_sym__literal_contents,
    STATE(4939), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [176270] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4940), 1,
      sym_heredoc_body,
    ACTIONS(6539), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176290] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_EQ_GT,
    ACTIONS(7241), 1,
      anon_sym_COMMA,
    STATE(4941), 1,
      sym_heredoc_body,
    ACTIONS(6616), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176314] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4942), 1,
      sym_heredoc_body,
    ACTIONS(6589), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176334] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4943), 1,
      sym_heredoc_body,
    ACTIONS(6632), 8,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176354] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7363), 1,
      anon_sym_rescue,
    STATE(4944), 1,
      sym_heredoc_body,
    ACTIONS(6624), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176376] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7363), 1,
      anon_sym_rescue,
    STATE(4945), 1,
      sym_heredoc_body,
    ACTIONS(6581), 7,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [176398] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(4946), 1,
      sym_heredoc_body,
    ACTIONS(2962), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
    ACTIONS(7365), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [176420] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7090), 1,
      sym_escape_sequence,
    ACTIONS(7092), 1,
      sym_string_content,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7367), 1,
      aux_sym_string_array_token1,
    ACTIONS(7369), 1,
      sym__string_end,
    STATE(4921), 1,
      aux_sym__literal_contents,
    STATE(4947), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
  [176454] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7371), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(4948), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [176483] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3135), 1,
      anon_sym_r,
    STATE(4949), 1,
      sym_heredoc_body,
    ACTIONS(3137), 2,
      anon_sym_i,
      anon_sym_ri,
    ACTIONS(3131), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176506] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4950), 1,
      sym_heredoc_body,
    ACTIONS(7373), 7,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [176525] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7375), 1,
      sym_identifier,
    ACTIONS(7379), 1,
      anon_sym_do,
    STATE(4951), 1,
      sym_heredoc_body,
    ACTIONS(7377), 5,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [176548] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7381), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(4952), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [176577] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4953), 1,
      sym_heredoc_body,
    ACTIONS(7383), 7,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_in,
      anon_sym_when,
      anon_sym_elsif,
      anon_sym_else,
      anon_sym_ensure,
  [176596] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2889), 1,
      sym__pow,
    STATE(3557), 1,
      sym__simple_numeric,
    STATE(4954), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(291), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [176623] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7389), 1,
      sym__string_end,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    STATE(4955), 1,
      sym_heredoc_body,
    STATE(5014), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [176652] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7393), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(4956), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [176681] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7395), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(4957), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [176710] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7397), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7403), 1,
      sym_heredoc_end,
    ACTIONS(7405), 1,
      sym__short_interpolation,
    STATE(5208), 1,
      sym_interpolation,
    ACTIONS(7400), 2,
      sym_heredoc_content,
      sym_escape_sequence,
    STATE(4958), 2,
      sym_heredoc_body,
      aux_sym_heredoc_body_repeat1,
  [176737] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7408), 1,
      sym__string_end,
    STATE(4959), 1,
      sym_heredoc_body,
    STATE(5083), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [176766] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7312), 1,
      sym__string_end,
    ACTIONS(7410), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7416), 1,
      sym__short_interpolation,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7413), 2,
      sym_string_content,
      sym_escape_sequence,
    STATE(4960), 2,
      sym_heredoc_body,
      aux_sym__literal_contents,
  [176793] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2668), 1,
      sym__string_start,
    STATE(4961), 1,
      sym_heredoc_body,
    STATE(5019), 1,
      aux_sym_chained_string_repeat1,
    STATE(5211), 1,
      sym_string,
    ACTIONS(2962), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176818] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3310), 1,
      sym__simple_numeric,
    STATE(3351), 1,
      sym__pow,
    STATE(4962), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [176845] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7419), 1,
      anon_sym_COMMA,
    STATE(4963), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [176866] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7422), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(4964), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [176895] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4965), 1,
      sym_heredoc_body,
    ACTIONS(2944), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [176914] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(3199), 1,
      sym__simple_numeric,
    STATE(4966), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(357), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [176941] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7424), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(4967), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [176970] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_EQ_GT,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(264), 1,
      sym__terminator,
    STATE(4968), 1,
      sym_heredoc_body,
    STATE(5215), 1,
      sym_exception_variable,
    STATE(5312), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [176999] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7426), 1,
      anon_sym_COMMA,
    STATE(4969), 1,
      sym_heredoc_body,
    STATE(5009), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6692), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [177022] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7428), 1,
      sym__string_end,
    STATE(4970), 1,
      sym_heredoc_body,
    STATE(4985), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177051] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7430), 1,
      sym__string_end,
    STATE(4971), 1,
      sym_heredoc_body,
    STATE(4986), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177080] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7432), 1,
      sym__string_end,
    STATE(4972), 1,
      sym_heredoc_body,
    STATE(4987), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177109] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7434), 1,
      sym__string_end,
    STATE(4973), 1,
      sym_heredoc_body,
    STATE(4988), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177138] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7436), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(4974), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177167] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7438), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(4975), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177196] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3351), 1,
      sym__pow,
    STATE(3765), 1,
      sym__simple_numeric,
    STATE(4976), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [177223] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7055), 1,
      anon_sym_then,
    ACTIONS(7440), 1,
      anon_sym_COMMA,
    STATE(269), 1,
      sym__terminator,
    STATE(4977), 1,
      sym_heredoc_body,
    STATE(5210), 1,
      aux_sym_when_repeat1,
    STATE(5457), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [177252] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7442), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(4978), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [177281] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7444), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(4979), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [177310] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3351), 1,
      sym__pow,
    STATE(3948), 1,
      sym__simple_numeric,
    STATE(4980), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [177337] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(3787), 1,
      sym__simple_numeric,
    STATE(4981), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(357), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [177364] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7446), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(4982), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [177393] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7448), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(4983), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [177422] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7450), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(4984), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [177451] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7452), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(4985), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177480] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7454), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(4986), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177509] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7456), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(4987), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177538] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7458), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(4988), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177567] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7460), 1,
      sym__string_end,
    STATE(4989), 1,
      sym_heredoc_body,
    STATE(5030), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177596] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2889), 1,
      sym__pow,
    STATE(3201), 1,
      sym__simple_numeric,
    STATE(4990), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(291), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [177623] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4991), 1,
      sym_heredoc_body,
    ACTIONS(2932), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177642] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7462), 1,
      sym__string_end,
    STATE(4992), 1,
      sym_heredoc_body,
    STATE(5001), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177671] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7464), 1,
      sym__string_end,
    STATE(4993), 1,
      sym_heredoc_body,
    STATE(5002), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177700] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3351), 1,
      sym__pow,
    STATE(3621), 1,
      sym__simple_numeric,
    STATE(4994), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(291), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [177727] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3351), 1,
      sym__pow,
    STATE(3853), 1,
      sym__simple_numeric,
    STATE(4995), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [177754] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3313), 1,
      sym__simple_numeric,
    STATE(3351), 1,
      sym__pow,
    STATE(4996), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [177781] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7055), 1,
      anon_sym_then,
    ACTIONS(7440), 1,
      anon_sym_COMMA,
    STATE(277), 1,
      sym__terminator,
    STATE(4977), 1,
      aux_sym_when_repeat1,
    STATE(4997), 1,
      sym_heredoc_body,
    STATE(5470), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [177810] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4998), 1,
      sym_heredoc_body,
    ACTIONS(7466), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
    ACTIONS(2962), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177831] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7468), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(4999), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [177860] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3254), 1,
      sym__simple_numeric,
    STATE(3351), 1,
      sym__pow,
    STATE(5000), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(291), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [177887] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7470), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5001), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177916] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7472), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5002), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [177945] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7474), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5003), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [177974] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5004), 1,
      sym_heredoc_body,
    ACTIONS(2910), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [177993] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7476), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5005), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178022] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3211), 1,
      sym__simple_numeric,
    STATE(3351), 1,
      sym__pow,
    STATE(5006), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(291), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [178049] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7478), 1,
      anon_sym_COMMA,
    STATE(5007), 1,
      sym_heredoc_body,
    STATE(5016), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6692), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [178072] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5008), 1,
      sym_heredoc_body,
    ACTIONS(123), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178091] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7426), 1,
      anon_sym_COMMA,
    STATE(5009), 1,
      sym_heredoc_body,
    STATE(5044), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6699), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [178114] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7480), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5010), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178143] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7482), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5011), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178172] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7484), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5012), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178201] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7486), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5013), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178230] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7488), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5014), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [178259] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3351), 1,
      sym__pow,
    STATE(3741), 1,
      sym__simple_numeric,
    STATE(5015), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(291), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [178286] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7478), 1,
      anon_sym_COMMA,
    STATE(4963), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5016), 1,
      sym_heredoc_body,
    ACTIONS(6699), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [178309] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7490), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5017), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178338] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7492), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5018), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178367] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2668), 1,
      sym__string_start,
    STATE(5019), 1,
      sym_heredoc_body,
    STATE(5060), 1,
      aux_sym_chained_string_repeat1,
    STATE(5211), 1,
      sym_string,
    ACTIONS(3110), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [178392] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(2513), 1,
      sym__simple_numeric,
    STATE(5020), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [178419] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7494), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5021), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178448] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7496), 1,
      sym__string_end,
    STATE(4975), 1,
      aux_sym__literal_contents,
    STATE(5022), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [178477] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3351), 1,
      sym__pow,
    STATE(3840), 1,
      sym__simple_numeric,
    STATE(5023), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(291), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [178504] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(3071), 1,
      sym__simple_numeric,
    STATE(3351), 1,
      sym__pow,
    STATE(5024), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [178531] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7498), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5025), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178560] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7500), 1,
      anon_sym_rescue,
    STATE(5026), 1,
      sym_heredoc_body,
    ACTIONS(6581), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [178581] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7502), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5027), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178610] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2889), 1,
      sym__pow,
    STATE(3220), 1,
      sym__simple_numeric,
    STATE(5028), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(291), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [178637] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7504), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5029), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178666] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7506), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5030), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [178695] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7508), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5031), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178724] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2889), 1,
      sym__pow,
    STATE(3875), 1,
      sym__simple_numeric,
    STATE(5032), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(291), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [178751] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7510), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5033), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178780] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7512), 1,
      sym__string_end,
    STATE(5034), 1,
      sym_heredoc_body,
    STATE(5053), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [178809] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7514), 1,
      sym__string_end,
    STATE(5035), 1,
      sym_heredoc_body,
    STATE(5054), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [178838] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7516), 1,
      sym__string_end,
    STATE(5036), 1,
      sym_heredoc_body,
    STATE(5056), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [178867] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7518), 1,
      sym__string_end,
    STATE(5037), 1,
      sym_heredoc_body,
    STATE(5057), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [178896] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2889), 1,
      sym__pow,
    STATE(3739), 1,
      sym__simple_numeric,
    STATE(5038), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [178923] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7520), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5039), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178952] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7522), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5040), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [178981] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(2561), 1,
      sym__simple_numeric,
    STATE(5041), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [179008] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(3474), 1,
      sym__simple_numeric,
    STATE(5042), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(357), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [179035] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(3503), 1,
      sym__simple_numeric,
    STATE(5043), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(357), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [179062] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7524), 1,
      anon_sym_COMMA,
    STATE(5044), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 5,
      anon_sym_RPAREN,
      anon_sym_rescue,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [179083] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7527), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5045), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [179112] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7529), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5046), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [179141] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7531), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5047), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [179170] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7533), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5048), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [179199] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(3415), 1,
      sym__simple_numeric,
    STATE(5049), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(357), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [179226] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7535), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5050), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [179255] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2889), 1,
      sym__pow,
    STATE(3795), 1,
      sym__simple_numeric,
    STATE(5051), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(291), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [179282] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(3746), 1,
      sym__simple_numeric,
    STATE(5052), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(357), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [179309] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7537), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5053), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179338] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7539), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5054), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179367] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(3221), 1,
      sym__simple_numeric,
    STATE(5055), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(357), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [179394] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7541), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5056), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179423] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7543), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5057), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179452] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(3638), 1,
      sym__simple_numeric,
    STATE(5058), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(357), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [179479] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(2792), 1,
      sym__simple_numeric,
    STATE(5059), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [179506] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7545), 1,
      sym__string_start,
    STATE(5211), 1,
      sym_string,
    STATE(5060), 2,
      sym_heredoc_body,
      aux_sym_chained_string_repeat1,
    ACTIONS(3114), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [179529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7548), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5061), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [179558] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7550), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5062), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [179587] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2889), 1,
      sym__pow,
    STATE(3358), 1,
      sym__simple_numeric,
    STATE(5063), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [179614] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(3660), 1,
      sym__simple_numeric,
    STATE(5064), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(357), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [179641] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7552), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7556), 1,
      sym_heredoc_end,
    ACTIONS(7558), 1,
      sym__short_interpolation,
    STATE(5065), 1,
      sym_heredoc_body,
    STATE(5084), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(5208), 1,
      sym_interpolation,
    ACTIONS(7554), 2,
      sym_heredoc_content,
      sym_escape_sequence,
  [179670] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7560), 1,
      sym__string_end,
    STATE(5066), 1,
      sym_heredoc_body,
    STATE(5071), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179699] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7562), 1,
      sym__string_end,
    STATE(5067), 1,
      sym_heredoc_body,
    STATE(5072), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179728] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7564), 1,
      sym__string_end,
    STATE(5068), 1,
      sym_heredoc_body,
    STATE(5073), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179757] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7566), 1,
      sym__string_end,
    STATE(5069), 1,
      sym_heredoc_body,
    STATE(5075), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179786] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(3493), 1,
      sym__simple_numeric,
    STATE(5070), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(357), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [179813] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7568), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5071), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179842] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7570), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5072), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179871] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7572), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5073), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179900] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7574), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5074), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179929] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7576), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5075), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [179958] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(2773), 1,
      sym__simple_numeric,
    STATE(5076), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [179985] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7578), 1,
      sym__string_end,
    STATE(5077), 1,
      sym_heredoc_body,
    STATE(5079), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [180014] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5078), 1,
      sym_heredoc_body,
    ACTIONS(2940), 7,
      sym__line_break,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [180033] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7580), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5079), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [180062] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(2719), 1,
      sym__simple_numeric,
    STATE(5080), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180089] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2889), 1,
      sym__pow,
    STATE(3359), 1,
      sym__simple_numeric,
    STATE(5081), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [180116] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(3058), 1,
      sym__simple_numeric,
    STATE(5082), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180143] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7582), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5083), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [180172] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7552), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7558), 1,
      sym__short_interpolation,
    ACTIONS(7584), 1,
      sym_heredoc_end,
    STATE(4958), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(5084), 1,
      sym_heredoc_body,
    STATE(5208), 1,
      sym_interpolation,
    ACTIONS(7554), 2,
      sym_heredoc_content,
      sym_escape_sequence,
  [180201] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(3053), 1,
      sym__simple_numeric,
    STATE(5085), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180228] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2889), 1,
      sym__pow,
    STATE(3965), 1,
      sym__simple_numeric,
    STATE(5086), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [180255] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(2639), 1,
      sym__simple_numeric,
    STATE(5087), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180282] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(2662), 1,
      sym__simple_numeric,
    STATE(5088), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180309] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2889), 1,
      sym__pow,
    STATE(3860), 1,
      sym__simple_numeric,
    STATE(5089), 1,
      sym_heredoc_body,
    STATE(5453), 1,
      sym__int_or_float,
    ACTIONS(395), 2,
      sym_integer,
      sym_float,
    STATE(2862), 2,
      sym_complex,
      sym_rational,
  [180336] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(2480), 1,
      sym__simple_numeric,
    STATE(5090), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180363] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(2502), 1,
      sym__simple_numeric,
    STATE(5091), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180390] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2424), 1,
      sym__simple_numeric,
    STATE(2465), 1,
      sym__pow,
    STATE(5092), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180417] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7586), 1,
      sym__string_end,
    STATE(5093), 1,
      sym_heredoc_body,
    STATE(5100), 1,
      aux_sym__literal_contents,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [180446] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7588), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5094), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [180475] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(2453), 1,
      sym__simple_numeric,
    STATE(5095), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180502] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2465), 1,
      sym__pow,
    STATE(2978), 1,
      sym__simple_numeric,
    STATE(5096), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7590), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5097), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [180558] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(2995), 1,
      sym__simple_numeric,
    STATE(5098), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180585] = 8,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(2208), 1,
      sym__pow,
    STATE(2810), 1,
      sym__simple_numeric,
    STATE(5099), 1,
      sym_heredoc_body,
    STATE(5472), 1,
      sym__int_or_float,
    ACTIONS(83), 2,
      sym_integer,
      sym_float,
    STATE(2228), 2,
      sym_complex,
      sym_rational,
  [180612] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7592), 1,
      sym__string_end,
    STATE(4960), 1,
      aux_sym__literal_contents,
    STATE(5100), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [180641] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7594), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5101), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [180670] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7596), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5102), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [180699] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7598), 1,
      sym__string_end,
    STATE(5074), 1,
      aux_sym__literal_contents,
    STATE(5103), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [180728] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7600), 1,
      sym__string_end,
    STATE(4967), 1,
      aux_sym__literal_contents,
    STATE(5104), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [180757] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7602), 1,
      sym__string_end,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5105), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [180786] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7385), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7391), 1,
      sym__short_interpolation,
    ACTIONS(7604), 1,
      sym__string_end,
    STATE(4974), 1,
      aux_sym__literal_contents,
    STATE(5106), 1,
      sym_heredoc_body,
    STATE(5194), 1,
      sym_interpolation,
    ACTIONS(7387), 2,
      sym_string_content,
      sym_escape_sequence,
  [180815] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    ACTIONS(7606), 1,
      sym__string_end,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5107), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [180844] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7500), 1,
      anon_sym_rescue,
    STATE(5108), 1,
      sym_heredoc_body,
    ACTIONS(6624), 6,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [180865] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7608), 1,
      anon_sym_end,
    STATE(5109), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5864), 1,
      sym_else,
  [180893] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7610), 1,
      sym_identifier,
    ACTIONS(7612), 1,
      anon_sym_LPAREN,
    STATE(4380), 1,
      sym__nonlocal_variable,
    STATE(5110), 1,
      sym_heredoc_body,
    ACTIONS(3855), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [180917] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    STATE(4903), 1,
      aux_sym__literal_contents,
    STATE(5111), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [180943] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7614), 1,
      anon_sym_rescue,
    STATE(5112), 1,
      sym_heredoc_body,
    ACTIONS(6581), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [180963] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7086), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(7096), 1,
      sym__short_interpolation,
    STATE(4947), 1,
      aux_sym__literal_contents,
    STATE(5113), 1,
      sym_heredoc_body,
    STATE(5143), 1,
      sym_interpolation,
    ACTIONS(7092), 2,
      sym_string_content,
      sym_escape_sequence,
  [180989] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7616), 1,
      anon_sym_end,
    STATE(5114), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5788), 1,
      sym_else,
  [181017] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_rescue,
    STATE(5115), 1,
      sym_heredoc_body,
    ACTIONS(6624), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [181037] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_rescue,
    STATE(5116), 1,
      sym_heredoc_body,
    ACTIONS(6581), 5,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
      anon_sym_and,
      anon_sym_or,
  [181057] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7620), 1,
      anon_sym_end,
    STATE(5117), 1,
      sym_heredoc_body,
    STATE(5140), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5598), 1,
      sym_else,
  [181085] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4349), 1,
      sym__simple_numeric,
    STATE(5118), 1,
      sym_heredoc_body,
    STATE(5480), 1,
      sym__int_or_float,
    ACTIONS(2772), 2,
      sym_integer,
      sym_float,
    STATE(4340), 2,
      sym_complex,
      sym_rational,
  [181109] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7610), 1,
      sym_identifier,
    ACTIONS(7612), 1,
      anon_sym_LPAREN,
    STATE(4380), 1,
      sym__nonlocal_variable,
    STATE(5119), 1,
      sym_heredoc_body,
    ACTIONS(4305), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [181133] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7614), 1,
      anon_sym_rescue,
    STATE(5120), 1,
      sym_heredoc_body,
    ACTIONS(6624), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [181153] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7622), 1,
      anon_sym_end,
    STATE(5121), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5733), 1,
      sym_else,
  [181181] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5862), 1,
      anon_sym_COMMA,
    STATE(5122), 1,
      sym_heredoc_body,
    STATE(5135), 1,
      aux_sym_exceptions_repeat1,
    ACTIONS(7624), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [181203] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7626), 1,
      anon_sym_COMMA,
    STATE(5123), 1,
      sym_heredoc_body,
    STATE(5178), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6699), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [181225] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5124), 1,
      sym_heredoc_body,
    ACTIONS(7628), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [181243] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7630), 1,
      anon_sym_end,
    STATE(5125), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5861), 1,
      sym_else,
  [181271] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7632), 1,
      anon_sym_end,
    STATE(5126), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5793), 1,
      sym_else,
  [181299] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5127), 1,
      sym_heredoc_body,
    ACTIONS(7634), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [181317] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7636), 1,
      anon_sym_end,
    STATE(5128), 1,
      sym_heredoc_body,
    STATE(5173), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5677), 1,
      sym_else,
  [181345] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7636), 1,
      anon_sym_end,
    STATE(5129), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5677), 1,
      sym_else,
  [181373] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7638), 1,
      anon_sym_end,
    STATE(5130), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5612), 1,
      sym_else,
  [181401] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7620), 1,
      anon_sym_end,
    STATE(5131), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5598), 1,
      sym_else,
  [181429] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5132), 1,
      sym_heredoc_body,
    ACTIONS(7640), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [181447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5133), 1,
      sym_heredoc_body,
    ACTIONS(7642), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(7644), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [181467] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5134), 1,
      sym_heredoc_body,
    ACTIONS(2954), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [181485] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7646), 1,
      anon_sym_COMMA,
    STATE(5135), 2,
      sym_heredoc_body,
      aux_sym_exceptions_repeat1,
    ACTIONS(3585), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [181505] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7151), 1,
      anon_sym_end,
    STATE(5136), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5858), 1,
      sym_else,
  [181533] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7649), 1,
      anon_sym_end,
    STATE(5137), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5863), 1,
      sym_else,
  [181561] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7651), 1,
      anon_sym_end,
    STATE(5138), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5867), 1,
      sym_else,
  [181589] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7653), 1,
      anon_sym_end,
    STATE(5139), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5871), 1,
      sym_else,
  [181617] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7655), 1,
      anon_sym_end,
    STATE(5140), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5580), 1,
      sym_else,
  [181645] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7657), 1,
      anon_sym_end,
    STATE(5141), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5633), 1,
      sym_else,
  [181673] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7659), 1,
      anon_sym_rescue,
    STATE(5142), 1,
      sym_heredoc_body,
    ACTIONS(6624), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [181693] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5143), 1,
      sym_heredoc_body,
    ACTIONS(7661), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(7663), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [181713] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    STATE(5144), 1,
      sym_heredoc_body,
    STATE(5345), 1,
      sym_argument_list,
    ACTIONS(3161), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181735] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4611), 1,
      sym__simple_numeric,
    STATE(5145), 1,
      sym_heredoc_body,
    STATE(5423), 1,
      sym__int_or_float,
    ACTIONS(2822), 2,
      sym_integer,
      sym_float,
    STATE(4666), 2,
      sym_complex,
      sym_rational,
  [181759] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    STATE(5146), 1,
      sym_heredoc_body,
    STATE(5346), 1,
      sym_argument_list,
    ACTIONS(3187), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181781] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    STATE(5147), 1,
      sym_heredoc_body,
    STATE(5405), 1,
      sym_argument_list,
    ACTIONS(419), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181803] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5148), 1,
      sym_heredoc_body,
    STATE(5227), 1,
      sym__simple_numeric,
    STATE(5449), 1,
      sym__int_or_float,
    ACTIONS(2650), 2,
      sym_integer,
      sym_float,
    STATE(5223), 2,
      sym_complex,
      sym_rational,
  [181827] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5149), 1,
      sym_heredoc_body,
    ACTIONS(3267), 6,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181845] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4611), 1,
      sym__simple_numeric,
    STATE(5150), 1,
      sym_heredoc_body,
    STATE(5423), 1,
      sym__int_or_float,
    ACTIONS(2880), 2,
      sym_integer,
      sym_float,
    STATE(4666), 2,
      sym_complex,
      sym_rational,
  [181869] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(5862), 1,
      anon_sym_COMMA,
    STATE(5122), 1,
      aux_sym_exceptions_repeat1,
    STATE(5151), 1,
      sym_heredoc_body,
    ACTIONS(5864), 4,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [181891] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    STATE(5152), 1,
      sym_heredoc_body,
    STATE(5318), 1,
      sym_argument_list,
    ACTIONS(415), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181913] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5153), 1,
      sym_heredoc_body,
    ACTIONS(2950), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [181931] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7665), 1,
      sym_identifier,
    ACTIONS(7667), 1,
      anon_sym_LPAREN,
    STATE(4747), 1,
      sym__nonlocal_variable,
    STATE(5154), 1,
      sym_heredoc_body,
    ACTIONS(7669), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [181955] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    STATE(5155), 1,
      sym_heredoc_body,
    STATE(5320), 1,
      sym_argument_list,
    ACTIONS(423), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [181977] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7626), 1,
      anon_sym_COMMA,
    STATE(5123), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5156), 1,
      sym_heredoc_body,
    ACTIONS(6692), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [181999] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7671), 1,
      anon_sym_end,
    STATE(5157), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5617), 1,
      sym_else,
  [182027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5158), 1,
      sym_heredoc_body,
    ACTIONS(2574), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(2576), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [182047] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7659), 1,
      anon_sym_rescue,
    STATE(5159), 1,
      sym_heredoc_body,
    ACTIONS(6581), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [182067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5160), 1,
      sym_heredoc_body,
    ACTIONS(7673), 3,
      anon_sym_POUND_LBRACE,
      aux_sym_string_array_token1,
      sym_escape_sequence,
    ACTIONS(7675), 3,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
  [182087] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(4762), 1,
      anon_sym_LPAREN2,
    STATE(5161), 1,
      sym_heredoc_body,
    STATE(5322), 1,
      sym_argument_list,
    ACTIONS(427), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [182109] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5162), 1,
      sym_heredoc_body,
    ACTIONS(7677), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [182127] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5163), 1,
      sym_heredoc_body,
    ACTIONS(7679), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [182145] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5164), 1,
      sym_heredoc_body,
    ACTIONS(2960), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [182163] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7164), 1,
      anon_sym_end,
    STATE(5165), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5779), 1,
      sym_else,
  [182191] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7681), 1,
      anon_sym_end,
    STATE(5166), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5835), 1,
      sym_else,
  [182219] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7683), 1,
      anon_sym_end,
    STATE(5167), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5712), 1,
      sym_else,
  [182247] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5168), 1,
      sym_heredoc_body,
    ACTIONS(7685), 6,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
      anon_sym_do,
  [182265] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5169), 1,
      sym_heredoc_body,
    ACTIONS(3307), 6,
      sym__element_reference_bracket,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [182283] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7114), 1,
      anon_sym_end,
    STATE(5170), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5662), 1,
      sym_else,
  [182311] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(4349), 1,
      sym__simple_numeric,
    STATE(5171), 1,
      sym_heredoc_body,
    STATE(5480), 1,
      sym__int_or_float,
    ACTIONS(2860), 2,
      sym_integer,
      sym_float,
    STATE(4340), 2,
      sym_complex,
      sym_rational,
  [182335] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7687), 1,
      anon_sym_end,
    STATE(5172), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5666), 1,
      sym_else,
  [182363] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7689), 1,
      anon_sym_end,
    STATE(5173), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5667), 1,
      sym_else,
  [182391] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7691), 1,
      anon_sym_end,
    STATE(5174), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5584), 1,
      sym_else,
  [182419] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7693), 1,
      anon_sym_end,
    STATE(5175), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5723), 1,
      sym_else,
  [182447] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7695), 1,
      anon_sym_end,
    STATE(5176), 1,
      sym_heredoc_body,
    STATE(5180), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5601), 1,
      sym_else,
  [182475] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7695), 1,
      anon_sym_end,
    STATE(5177), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5601), 1,
      sym_else,
  [182503] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_COMMA,
    STATE(5178), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(6585), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [182523] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7122), 1,
      anon_sym_end,
    STATE(5179), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5833), 1,
      sym_else,
  [182551] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7700), 1,
      anon_sym_end,
    STATE(5180), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5791), 1,
      sym_else,
  [182579] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7702), 1,
      anon_sym_end,
    STATE(5181), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5693), 1,
      sym_else,
  [182607] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_in,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7704), 1,
      anon_sym_end,
    STATE(5182), 1,
      sym_heredoc_body,
    STATE(5187), 1,
      aux_sym_case_match_repeat1,
    STATE(5479), 1,
      sym_in_clause,
    STATE(5700), 1,
      sym_else,
  [182635] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7166), 1,
      anon_sym_end,
    STATE(5183), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5816), 1,
      sym_else,
  [182663] = 9,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6866), 1,
      anon_sym_when,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7098), 1,
      anon_sym_end,
    STATE(5184), 1,
      sym_heredoc_body,
    STATE(5202), 1,
      aux_sym_case_repeat1,
    STATE(5434), 1,
      sym_when,
    STATE(5773), 1,
      sym_else,
  [182691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7673), 1,
      anon_sym_POUND_LBRACE,
    STATE(5185), 1,
      sym_heredoc_body,
    ACTIONS(7675), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [182710] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(3032), 1,
      anon_sym_COMMA,
    STATE(5186), 1,
      sym_heredoc_body,
    STATE(5217), 1,
      aux_sym__mlhs_repeat1,
    ACTIONS(7706), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [182731] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7710), 1,
      anon_sym_in,
    STATE(5479), 1,
      sym_in_clause,
    ACTIONS(7708), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(5187), 2,
      sym_heredoc_body,
      aux_sym_case_match_repeat1,
  [182752] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7713), 1,
      anon_sym_EQ,
    ACTIONS(7715), 1,
      anon_sym_COLON,
    STATE(5188), 1,
      sym_heredoc_body,
    ACTIONS(7685), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_SEMI,
  [182773] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5189), 1,
      sym_heredoc_body,
    ACTIONS(7717), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6539), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [182792] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5190), 1,
      sym_heredoc_body,
    ACTIONS(3165), 5,
      sym__string_start,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [182809] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7719), 1,
      anon_sym_EQ,
    ACTIONS(7721), 1,
      anon_sym_COLON,
    STATE(5191), 1,
      sym_heredoc_body,
    ACTIONS(7685), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182830] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(265), 1,
      sym__terminator,
    STATE(5192), 1,
      sym_heredoc_body,
    STATE(5323), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [182853] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2574), 1,
      anon_sym_POUND_LBRACE,
    STATE(5193), 1,
      sym_heredoc_body,
    ACTIONS(2576), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [182872] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7661), 1,
      anon_sym_POUND_LBRACE,
    STATE(5194), 1,
      sym_heredoc_body,
    ACTIONS(7663), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [182891] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7723), 1,
      anon_sym_end,
    ACTIONS(7725), 1,
      anon_sym_elsif,
    STATE(5195), 1,
      sym_heredoc_body,
    STATE(5812), 2,
      sym_elsif,
      sym_else,
  [182914] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7725), 1,
      anon_sym_elsif,
    ACTIONS(7727), 1,
      anon_sym_end,
    STATE(5196), 1,
      sym_heredoc_body,
    STATE(5772), 2,
      sym_elsif,
      sym_else,
  [182937] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7725), 1,
      anon_sym_elsif,
    ACTIONS(7729), 1,
      anon_sym_end,
    STATE(5197), 1,
      sym_heredoc_body,
    STATE(5640), 2,
      sym_elsif,
      sym_else,
  [182960] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7725), 1,
      anon_sym_elsif,
    ACTIONS(7731), 1,
      anon_sym_end,
    STATE(5198), 1,
      sym_heredoc_body,
    STATE(5642), 2,
      sym_elsif,
      sym_else,
  [182983] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7076), 1,
      anon_sym_do,
    STATE(331), 1,
      sym__terminator,
    STATE(2881), 1,
      sym_do,
    STATE(5199), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [183006] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5200), 1,
      sym_heredoc_body,
    ACTIONS(3181), 5,
      sym__string_start,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183023] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7642), 1,
      anon_sym_POUND_LBRACE,
    STATE(5201), 1,
      sym_heredoc_body,
    ACTIONS(7644), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [183042] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7735), 1,
      anon_sym_when,
    STATE(5434), 1,
      sym_when,
    ACTIONS(7733), 2,
      anon_sym_end,
      anon_sym_else,
    STATE(5202), 2,
      sym_heredoc_body,
      aux_sym_case_repeat1,
  [183063] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5203), 1,
      sym_heredoc_body,
    ACTIONS(7740), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(7738), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [183082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(2574), 1,
      anon_sym_POUND_LBRACE,
    STATE(5204), 1,
      sym_heredoc_body,
    ACTIONS(2576), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [183101] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7725), 1,
      anon_sym_elsif,
    ACTIONS(7742), 1,
      anon_sym_end,
    STATE(5205), 1,
      sym_heredoc_body,
    STATE(5805), 2,
      sym_elsif,
      sym_else,
  [183124] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7725), 1,
      anon_sym_elsif,
    ACTIONS(7744), 1,
      anon_sym_end,
    STATE(5206), 1,
      sym_heredoc_body,
    STATE(5564), 2,
      sym_elsif,
      sym_else,
  [183147] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_else,
    ACTIONS(7725), 1,
      anon_sym_elsif,
    ACTIONS(7746), 1,
      anon_sym_end,
    STATE(5207), 1,
      sym_heredoc_body,
    STATE(5656), 2,
      sym_elsif,
      sym_else,
  [183170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7748), 1,
      anon_sym_POUND_LBRACE,
    STATE(5208), 1,
      sym_heredoc_body,
    ACTIONS(7750), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [183189] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7752), 1,
      anon_sym_COMMA,
    STATE(5209), 2,
      sym_heredoc_body,
      aux_sym__mlhs_repeat1,
    ACTIONS(7245), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [183208] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7755), 1,
      anon_sym_COMMA,
    STATE(5210), 2,
      sym_heredoc_body,
      aux_sym_when_repeat1,
    ACTIONS(7758), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [183227] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5211), 1,
      sym_heredoc_body,
    ACTIONS(3203), 5,
      sym__string_start,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183244] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7078), 1,
      anon_sym_do,
    STATE(324), 1,
      sym__terminator,
    STATE(2275), 1,
      sym_do,
    STATE(5212), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [183267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7673), 1,
      anon_sym_POUND_LBRACE,
    STATE(5213), 1,
      sym_heredoc_body,
    ACTIONS(7675), 4,
      sym_heredoc_content,
      sym_heredoc_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [183286] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(281), 1,
      sym__terminator,
    STATE(5214), 1,
      sym_heredoc_body,
    STATE(5445), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [183309] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7055), 1,
      anon_sym_then,
    STATE(258), 1,
      sym__terminator,
    STATE(5215), 1,
      sym_heredoc_body,
    STATE(5361), 1,
      sym_then,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [183332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7642), 1,
      anon_sym_POUND_LBRACE,
    STATE(5216), 1,
      sym_heredoc_body,
    ACTIONS(7644), 4,
      sym_string_content,
      sym__string_end,
      sym__short_interpolation,
      sym_escape_sequence,
  [183351] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7760), 1,
      anon_sym_COMMA,
    STATE(5209), 1,
      aux_sym__mlhs_repeat1,
    STATE(5217), 1,
      sym_heredoc_body,
    ACTIONS(2712), 3,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_in,
  [183372] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7762), 1,
      anon_sym_EQ,
    ACTIONS(7764), 1,
      anon_sym_COLON,
    STATE(5218), 1,
      sym_heredoc_body,
    ACTIONS(7685), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
  [183393] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5219), 1,
      sym_heredoc_body,
    ACTIONS(7740), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(7766), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [183412] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7082), 1,
      anon_sym_do,
    STATE(310), 1,
      sym__terminator,
    STATE(5220), 1,
      sym_heredoc_body,
    STATE(5387), 1,
      sym_do,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [183435] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5221), 1,
      sym_heredoc_body,
    ACTIONS(3585), 5,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_then,
  [183452] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5222), 1,
      sym_heredoc_body,
    ACTIONS(3271), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183468] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5223), 1,
      sym_heredoc_body,
    ACTIONS(3131), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183484] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5224), 1,
      sym_heredoc_body,
    ACTIONS(3557), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183500] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7768), 1,
      anon_sym_COMMA,
    ACTIONS(7679), 2,
      anon_sym_PIPE,
      anon_sym_SEMI,
    STATE(5225), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [183518] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5226), 1,
      sym_heredoc_body,
    ACTIONS(3733), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183534] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5227), 1,
      sym_heredoc_body,
    ACTIONS(3423), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183550] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5228), 1,
      sym_heredoc_body,
    ACTIONS(3729), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183566] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5229), 1,
      sym_heredoc_body,
    ACTIONS(3211), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183582] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5230), 1,
      sym_heredoc_body,
    ACTIONS(3451), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183598] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5231), 1,
      sym_heredoc_body,
    ACTIONS(3247), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183614] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5232), 1,
      sym_heredoc_body,
    ACTIONS(3495), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183630] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5233), 1,
      sym_heredoc_body,
    ACTIONS(3721), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183646] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5234), 1,
      sym_heredoc_body,
    ACTIONS(3789), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183662] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5235), 1,
      sym_heredoc_body,
    ACTIONS(3215), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183678] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5236), 1,
      sym_heredoc_body,
    ACTIONS(3351), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183694] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5237), 1,
      sym_heredoc_body,
    ACTIONS(3379), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183710] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5238), 1,
      sym_heredoc_body,
    ACTIONS(3383), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183726] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5239), 1,
      sym_heredoc_body,
    ACTIONS(3415), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183742] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5240), 1,
      sym_heredoc_body,
    ACTIONS(3749), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183758] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7771), 1,
      anon_sym_COMMA,
    ACTIONS(7679), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    STATE(5241), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [183776] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7774), 1,
      anon_sym_rescue,
    STATE(5242), 1,
      sym_heredoc_body,
    ACTIONS(6624), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [183794] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5243), 1,
      sym_heredoc_body,
    ACTIONS(3427), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183810] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5244), 1,
      sym_heredoc_body,
    ACTIONS(3251), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183826] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5245), 1,
      sym_heredoc_body,
    ACTIONS(3255), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183842] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5246), 1,
      sym_heredoc_body,
    ACTIONS(3275), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183858] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5247), 1,
      sym_heredoc_body,
    ACTIONS(3295), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183874] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5248), 1,
      sym_heredoc_body,
    ACTIONS(3279), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183890] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5249), 1,
      sym_heredoc_body,
    ACTIONS(3561), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183906] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5250), 1,
      sym_heredoc_body,
    ACTIONS(3291), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183922] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5251), 1,
      sym_heredoc_body,
    ACTIONS(3753), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183938] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5252), 1,
      sym_heredoc_body,
    ACTIONS(3565), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183954] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7776), 1,
      anon_sym_rescue,
    STATE(5253), 1,
      sym_heredoc_body,
    ACTIONS(6624), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [183972] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5254), 1,
      sym_heredoc_body,
    ACTIONS(3569), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [183988] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7776), 1,
      anon_sym_rescue,
    STATE(5255), 1,
      sym_heredoc_body,
    ACTIONS(6581), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [184006] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5256), 1,
      sym_heredoc_body,
    ACTIONS(3505), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184022] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5257), 1,
      sym_heredoc_body,
    ACTIONS(3513), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184038] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5258), 1,
      sym_heredoc_body,
    ACTIONS(3529), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184054] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5259), 1,
      sym_heredoc_body,
    ACTIONS(3553), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184070] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5260), 1,
      sym_heredoc_body,
    ACTIONS(3621), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184086] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5261), 1,
      sym_heredoc_body,
    ACTIONS(3669), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184102] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5262), 1,
      sym_heredoc_body,
    ACTIONS(3609), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184118] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5263), 1,
      sym_heredoc_body,
    ACTIONS(3693), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184134] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7780), 1,
      anon_sym_COMMA,
    STATE(5264), 1,
      sym_heredoc_body,
    STATE(5343), 1,
      aux_sym_command_argument_list_repeat1,
    ACTIONS(7778), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [184154] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5265), 1,
      sym_heredoc_body,
    ACTIONS(2908), 4,
      anon_sym_end,
      anon_sym_in,
      anon_sym_when,
      anon_sym_else,
  [184170] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5266), 1,
      sym_heredoc_body,
    ACTIONS(3633), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184186] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5267), 1,
      sym_heredoc_body,
    ACTIONS(7782), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [184202] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7774), 1,
      anon_sym_rescue,
    STATE(5268), 1,
      sym_heredoc_body,
    ACTIONS(6581), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [184220] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7784), 1,
      anon_sym_COMMA,
    STATE(5269), 1,
      sym_heredoc_body,
    STATE(5364), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(7786), 2,
      sym__line_break,
      anon_sym_SEMI,
  [184240] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_EQ_GT,
    ACTIONS(7241), 1,
      anon_sym_COMMA,
    STATE(5270), 1,
      sym_heredoc_body,
    ACTIONS(7788), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [184260] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5271), 1,
      sym_heredoc_body,
    ACTIONS(3709), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184276] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5272), 1,
      sym_heredoc_body,
    ACTIONS(3637), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184292] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6764), 1,
      anon_sym_LBRACE,
    ACTIONS(7790), 1,
      anon_sym_do,
    STATE(5273), 1,
      sym_heredoc_body,
    STATE(4657), 2,
      sym_do_block,
      sym_block,
  [184312] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5274), 1,
      sym_heredoc_body,
    ACTIONS(3613), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184328] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7792), 1,
      anon_sym_COMMA,
    ACTIONS(6585), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(5275), 2,
      sym_heredoc_body,
      aux_sym_command_argument_list_repeat1,
  [184346] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5276), 1,
      sym_heredoc_body,
    ACTIONS(3303), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184362] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5277), 1,
      sym_heredoc_body,
    ACTIONS(3593), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184378] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7795), 1,
      sym_identifier,
    STATE(5278), 1,
      sym_heredoc_body,
    ACTIONS(7377), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [184396] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5279), 1,
      sym_heredoc_body,
    ACTIONS(3765), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184412] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5280), 1,
      sym_heredoc_body,
    ACTIONS(7797), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [184428] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5281), 1,
      sym_heredoc_body,
    ACTIONS(7799), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
  [184444] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5282), 1,
      sym_heredoc_body,
    ACTIONS(3395), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184460] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5185), 1,
      sym__nonlocal_variable,
    STATE(5283), 1,
      sym_heredoc_body,
    ACTIONS(7801), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [184478] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5284), 1,
      sym_heredoc_body,
    ACTIONS(3499), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184494] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5285), 1,
      sym_heredoc_body,
    ACTIONS(3391), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184510] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5286), 1,
      sym_heredoc_body,
    ACTIONS(3641), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184526] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5287), 1,
      sym_heredoc_body,
    ACTIONS(3769), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184542] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5288), 1,
      sym_heredoc_body,
    ACTIONS(3773), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184558] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5289), 1,
      sym_heredoc_body,
    ACTIONS(3733), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184574] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5290), 1,
      sym_heredoc_body,
    ACTIONS(3359), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184590] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5291), 1,
      sym_heredoc_body,
    ACTIONS(3359), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184606] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7803), 1,
      anon_sym_COMMA,
    STATE(5241), 1,
      aux_sym_parameters_repeat1,
    STATE(5292), 1,
      sym_heredoc_body,
    ACTIONS(7786), 2,
      anon_sym_LBRACE,
      anon_sym_do,
  [184626] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5293), 1,
      sym_heredoc_body,
    ACTIONS(3781), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184642] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5294), 1,
      sym_heredoc_body,
    ACTIONS(3785), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184658] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5295), 1,
      sym_heredoc_body,
    ACTIONS(3323), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184674] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5296), 1,
      sym_heredoc_body,
    ACTIONS(3793), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184690] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5297), 1,
      sym_heredoc_body,
    ACTIONS(3777), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184706] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5298), 1,
      sym_heredoc_body,
    ACTIONS(3323), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184722] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5299), 1,
      sym_heredoc_body,
    ACTIONS(3549), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184738] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5300), 1,
      sym_heredoc_body,
    ACTIONS(3299), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184754] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5301), 1,
      sym_heredoc_body,
    ACTIONS(3231), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184770] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_PIPE,
    ACTIONS(6811), 1,
      anon_sym_SEMI,
    ACTIONS(7805), 1,
      anon_sym_COMMA,
    STATE(5225), 1,
      aux_sym_parameters_repeat1,
    STATE(5302), 1,
      sym_heredoc_body,
  [184792] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5303), 1,
      sym_heredoc_body,
    ACTIONS(3283), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184808] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5304), 1,
      sym_heredoc_body,
    ACTIONS(3355), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184824] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5305), 1,
      sym_heredoc_body,
    ACTIONS(3545), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184840] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5306), 1,
      sym_heredoc_body,
    ACTIONS(3581), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184856] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5307), 1,
      sym_heredoc_body,
    ACTIONS(3645), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184872] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5308), 1,
      sym_heredoc_body,
    ACTIONS(3689), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184888] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5309), 1,
      sym_heredoc_body,
    ACTIONS(3713), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184904] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5310), 1,
      sym_heredoc_body,
    ACTIONS(3649), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184920] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7809), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(7811), 1,
      sym__element_reference_bracket,
    STATE(5311), 1,
      sym_heredoc_body,
    ACTIONS(7807), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [184940] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5312), 1,
      sym_heredoc_body,
    ACTIONS(7813), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [184956] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5313), 1,
      sym_heredoc_body,
    ACTIONS(3797), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184972] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5314), 1,
      sym_heredoc_body,
    ACTIONS(3541), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [184988] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6729), 1,
      anon_sym_LBRACE,
    ACTIONS(7049), 1,
      anon_sym_do,
    STATE(5315), 1,
      sym_heredoc_body,
    STATE(4657), 2,
      sym_do_block,
      sym_block,
  [185008] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7815), 1,
      anon_sym_EQ,
    ACTIONS(7817), 1,
      anon_sym_COLON,
    STATE(5316), 1,
      sym_heredoc_body,
    ACTIONS(7685), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [185028] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5213), 1,
      sym__nonlocal_variable,
    STATE(5317), 1,
      sym_heredoc_body,
    ACTIONS(7819), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [185046] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5318), 1,
      sym_heredoc_body,
    ACTIONS(3677), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185062] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7821), 1,
      anon_sym_COMMA,
    ACTIONS(7823), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_SEMI,
    STATE(5302), 1,
      aux_sym_parameters_repeat1,
    STATE(5319), 1,
      sym_heredoc_body,
  [185084] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5320), 1,
      sym_heredoc_body,
    ACTIONS(3697), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185100] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5321), 1,
      sym_heredoc_body,
    ACTIONS(3761), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185116] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5322), 1,
      sym_heredoc_body,
    ACTIONS(3375), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185132] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5323), 1,
      sym_heredoc_body,
    ACTIONS(7827), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [185148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5324), 1,
      sym_heredoc_body,
    ACTIONS(7829), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [185164] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5325), 1,
      sym_heredoc_body,
    ACTIONS(2962), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185180] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON2,
    ACTIONS(7835), 1,
      sym__element_reference_bracket,
    STATE(5326), 1,
      sym_heredoc_body,
    ACTIONS(7831), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [185200] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5327), 1,
      sym_heredoc_body,
    ACTIONS(3653), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185216] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5328), 1,
      sym_heredoc_body,
    ACTIONS(3315), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185232] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5329), 1,
      sym_heredoc_body,
    ACTIONS(3287), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185248] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5330), 1,
      sym_heredoc_body,
    ACTIONS(3311), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185264] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5331), 1,
      sym_heredoc_body,
    ACTIONS(7740), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(7837), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185282] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5332), 1,
      sym_heredoc_body,
    ACTIONS(3657), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185298] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5333), 1,
      sym_heredoc_body,
    ACTIONS(3347), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185314] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5334), 1,
      sym_heredoc_body,
    ACTIONS(3207), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185330] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5335), 1,
      sym_heredoc_body,
    ACTIONS(3367), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185346] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5336), 1,
      sym_heredoc_body,
    ACTIONS(3537), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185362] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5337), 1,
      sym_heredoc_body,
    ACTIONS(3235), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185378] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5338), 1,
      sym_heredoc_body,
    ACTIONS(3239), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185394] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5339), 1,
      sym_heredoc_body,
    ACTIONS(3243), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185410] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5340), 1,
      sym_heredoc_body,
    ACTIONS(3661), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185426] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5341), 1,
      sym_heredoc_body,
    ACTIONS(3263), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185442] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5160), 1,
      sym__nonlocal_variable,
    STATE(5342), 1,
      sym_heredoc_body,
    ACTIONS(7839), 3,
      sym_instance_variable,
      sym_class_variable,
      sym_global_variable,
  [185460] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7841), 1,
      anon_sym_COMMA,
    STATE(5275), 1,
      aux_sym_command_argument_list_repeat1,
    STATE(5343), 1,
      sym_heredoc_body,
    ACTIONS(2316), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [185480] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5344), 1,
      sym_heredoc_body,
    ACTIONS(3725), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185496] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5345), 1,
      sym_heredoc_body,
    ACTIONS(3259), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185512] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5346), 1,
      sym_heredoc_body,
    ACTIONS(3573), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185528] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5347), 1,
      sym_heredoc_body,
    ACTIONS(3601), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185544] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5348), 1,
      sym_heredoc_body,
    ACTIONS(3335), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185560] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5349), 1,
      sym_heredoc_body,
    ACTIONS(3673), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185576] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5350), 1,
      sym_heredoc_body,
    ACTIONS(3757), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185592] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2898), 1,
      anon_sym_LBRACE,
    ACTIONS(2900), 1,
      anon_sym_do,
    STATE(5351), 1,
      sym_heredoc_body,
    STATE(2310), 2,
      sym_do_block,
      sym_block,
  [185612] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6733), 1,
      anon_sym_LBRACE,
    ACTIONS(7843), 1,
      anon_sym_do,
    STATE(5352), 1,
      sym_heredoc_body,
    STATE(4347), 2,
      sym_do_block,
      sym_block,
  [185632] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5353), 1,
      sym_heredoc_body,
    ACTIONS(3327), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185648] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5354), 1,
      sym_heredoc_body,
    ACTIONS(3331), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185664] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5355), 1,
      sym_heredoc_body,
    ACTIONS(3741), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185680] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5356), 1,
      sym_heredoc_body,
    ACTIONS(3597), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185696] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5357), 1,
      sym_heredoc_body,
    ACTIONS(6027), 4,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_then,
  [185712] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5358), 1,
      sym_heredoc_body,
    ACTIONS(7845), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [185728] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7803), 1,
      anon_sym_COMMA,
    STATE(5292), 1,
      aux_sym_parameters_repeat1,
    STATE(5359), 1,
      sym_heredoc_body,
    ACTIONS(7847), 2,
      anon_sym_LBRACE,
      anon_sym_do,
  [185748] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5360), 1,
      sym_heredoc_body,
    ACTIONS(7849), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [185764] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5361), 1,
      sym_heredoc_body,
    ACTIONS(7851), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [185780] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7784), 1,
      anon_sym_COMMA,
    STATE(5269), 1,
      aux_sym_parameters_repeat1,
    STATE(5362), 1,
      sym_heredoc_body,
    ACTIONS(7847), 2,
      sym__line_break,
      anon_sym_SEMI,
  [185800] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5363), 1,
      sym_heredoc_body,
    ACTIONS(3371), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185816] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7853), 1,
      anon_sym_COMMA,
    ACTIONS(7679), 2,
      sym__line_break,
      anon_sym_SEMI,
    STATE(5364), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [185834] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5365), 1,
      sym_heredoc_body,
    ACTIONS(3801), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185850] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6445), 1,
      anon_sym_LBRACE,
    ACTIONS(6447), 1,
      anon_sym_do,
    STATE(5366), 1,
      sym_heredoc_body,
    STATE(4347), 2,
      sym_do_block,
      sym_block,
  [185870] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5367), 1,
      sym_heredoc_body,
    ACTIONS(3533), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185886] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5368), 1,
      sym_heredoc_body,
    ACTIONS(3407), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185902] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LBRACE,
    ACTIONS(3080), 1,
      anon_sym_do,
    STATE(5369), 1,
      sym_heredoc_body,
    STATE(2902), 2,
      sym_do_block,
      sym_block,
  [185922] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5370), 1,
      sym_heredoc_body,
    ACTIONS(7856), 4,
      anon_sym_end,
      anon_sym_rescue,
      anon_sym_else,
      anon_sym_ensure,
  [185938] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5371), 1,
      sym_heredoc_body,
    ACTIONS(3411), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185954] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5372), 1,
      sym_heredoc_body,
    ACTIONS(3491), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185970] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5373), 1,
      sym_heredoc_body,
    ACTIONS(3387), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [185986] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5374), 1,
      sym_heredoc_body,
    ACTIONS(3685), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186002] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5375), 1,
      sym_heredoc_body,
    ACTIONS(3685), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186018] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7811), 1,
      sym__element_reference_bracket,
    ACTIONS(7858), 1,
      anon_sym_COLON_COLON2,
    STATE(5376), 1,
      sym_heredoc_body,
    ACTIONS(7807), 2,
      anon_sym_DOT,
      anon_sym_AMP_DOT,
  [186038] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6819), 1,
      anon_sym_PIPE,
    ACTIONS(6821), 1,
      anon_sym_SEMI,
    ACTIONS(7860), 1,
      anon_sym_COMMA,
    STATE(5225), 1,
      aux_sym_parameters_repeat1,
    STATE(5377), 1,
      sym_heredoc_body,
  [186060] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5378), 1,
      sym_heredoc_body,
    ACTIONS(3509), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186076] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5379), 1,
      sym_heredoc_body,
    ACTIONS(3681), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186092] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5380), 1,
      sym_heredoc_body,
    ACTIONS(3343), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186108] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5381), 1,
      sym_heredoc_body,
    ACTIONS(3435), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186124] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5382), 1,
      sym_heredoc_body,
    ACTIONS(3363), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186140] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5383), 1,
      sym_heredoc_body,
    ACTIONS(3455), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186156] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6745), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      anon_sym_do,
    STATE(5384), 1,
      sym_heredoc_body,
    STATE(5274), 2,
      sym_do_block,
      sym_block,
  [186176] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5385), 1,
      sym_heredoc_body,
    ACTIONS(3459), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186192] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5386), 1,
      sym_heredoc_body,
    ACTIONS(3471), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186208] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5387), 1,
      sym_heredoc_body,
    ACTIONS(3475), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186224] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5388), 1,
      sym_heredoc_body,
    ACTIONS(3479), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186240] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5389), 1,
      sym_heredoc_body,
    ACTIONS(3483), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186256] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5390), 1,
      sym_heredoc_body,
    ACTIONS(3487), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186272] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5391), 1,
      sym_heredoc_body,
    ACTIONS(3517), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186288] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5392), 1,
      sym_heredoc_body,
    ACTIONS(3577), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186304] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5393), 1,
      sym_heredoc_body,
    ACTIONS(3435), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186320] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5394), 1,
      sym_heredoc_body,
    ACTIONS(3589), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186336] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5395), 1,
      sym_heredoc_body,
    ACTIONS(3605), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186352] = 7,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7862), 1,
      anon_sym_COMMA,
    ACTIONS(7864), 1,
      anon_sym_PIPE,
    ACTIONS(7866), 1,
      anon_sym_SEMI,
    STATE(5377), 1,
      aux_sym_parameters_repeat1,
    STATE(5396), 1,
      sym_heredoc_body,
  [186374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5397), 1,
      sym_heredoc_body,
    ACTIONS(7245), 4,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
  [186390] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5398), 1,
      sym_heredoc_body,
    ACTIONS(3617), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186406] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5399), 1,
      sym_heredoc_body,
    ACTIONS(3629), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186422] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5400), 1,
      sym_heredoc_body,
    ACTIONS(3665), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186438] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5401), 1,
      sym_heredoc_body,
    ACTIONS(3701), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186454] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5402), 1,
      sym_heredoc_body,
    ACTIONS(3705), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186470] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5403), 1,
      sym_heredoc_body,
    ACTIONS(3219), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186486] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5404), 1,
      sym_heredoc_body,
    ACTIONS(3227), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186502] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5405), 1,
      sym_heredoc_body,
    ACTIONS(3625), 4,
      sym__element_reference_bracket,
      anon_sym_DOT,
      anon_sym_COLON_COLON2,
      anon_sym_AMP_DOT,
  [186518] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(7870), 1,
      anon_sym_PIPE,
    STATE(5406), 1,
      sym_heredoc_body,
    STATE(5441), 1,
      aux_sym_block_parameters_repeat1,
  [186537] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(195), 1,
      sym__terminator,
    STATE(5407), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [186554] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7872), 1,
      anon_sym_RBRACE,
    ACTIONS(7874), 1,
      anon_sym_COMMA,
    STATE(5408), 2,
      sym_heredoc_body,
      aux_sym_hash_repeat1,
  [186571] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5409), 1,
      sym_heredoc_body,
    ACTIONS(7628), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186586] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7877), 1,
      anon_sym_RPAREN,
    ACTIONS(7879), 1,
      anon_sym_COMMA,
    STATE(5410), 1,
      sym_heredoc_body,
    STATE(5465), 1,
      aux_sym_parameters_repeat1,
  [186605] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(7881), 1,
      anon_sym_PIPE,
    STATE(5411), 1,
      sym_heredoc_body,
    STATE(5441), 1,
      aux_sym_block_parameters_repeat1,
  [186624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7883), 1,
      aux_sym_string_array_token1,
    ACTIONS(7886), 1,
      sym__string_end,
    STATE(5412), 2,
      sym_heredoc_body,
      aux_sym_string_array_repeat1,
  [186641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7504), 1,
      sym__string_end,
    ACTIONS(7888), 1,
      aux_sym_string_array_token1,
    STATE(5412), 1,
      aux_sym_string_array_repeat1,
    STATE(5413), 1,
      sym_heredoc_body,
  [186660] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7448), 1,
      sym__string_end,
    ACTIONS(7890), 1,
      aux_sym_string_array_token1,
    STATE(5414), 1,
      sym_heredoc_body,
    STATE(5469), 1,
      aux_sym_symbol_array_repeat1,
  [186679] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7892), 1,
      anon_sym_RPAREN,
    STATE(5415), 1,
      sym_heredoc_body,
    ACTIONS(7894), 2,
      anon_sym_and,
      anon_sym_or,
  [186696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7468), 1,
      sym__string_end,
    ACTIONS(7896), 1,
      aux_sym_string_array_token1,
    STATE(5416), 1,
      sym_heredoc_body,
    STATE(5469), 1,
      aux_sym_symbol_array_repeat1,
  [186715] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(193), 1,
      sym__terminator,
    STATE(5417), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [186732] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(7898), 1,
      anon_sym_PIPE,
    STATE(5418), 1,
      sym_heredoc_body,
    STATE(5475), 1,
      aux_sym_block_parameters_repeat1,
  [186751] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5419), 1,
      sym_heredoc_body,
    ACTIONS(7900), 3,
      sym__line_break,
      anon_sym_SEMI,
      anon_sym_then,
  [186766] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7492), 1,
      sym__string_end,
    ACTIONS(7902), 1,
      aux_sym_string_array_token1,
    STATE(5420), 1,
      sym_heredoc_body,
    STATE(5469), 1,
      aux_sym_symbol_array_repeat1,
  [186785] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(7904), 1,
      anon_sym_PIPE,
    STATE(5421), 1,
      sym_heredoc_body,
    STATE(5463), 1,
      aux_sym_block_parameters_repeat1,
  [186804] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(7906), 1,
      anon_sym_PIPE,
    STATE(5422), 1,
      sym_heredoc_body,
    STATE(5441), 1,
      aux_sym_block_parameters_repeat1,
  [186823] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7908), 1,
      anon_sym_i,
    ACTIONS(7910), 1,
      anon_sym_ri,
    ACTIONS(7912), 1,
      anon_sym_r,
    STATE(5423), 1,
      sym_heredoc_body,
  [186842] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7482), 1,
      sym__string_end,
    ACTIONS(7914), 1,
      aux_sym_string_array_token1,
    STATE(5412), 1,
      aux_sym_string_array_repeat1,
    STATE(5424), 1,
      sym_heredoc_body,
  [186861] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7916), 1,
      anon_sym_RBRACE,
    ACTIONS(7918), 1,
      anon_sym_COMMA,
    STATE(5425), 1,
      sym_heredoc_body,
    STATE(5468), 1,
      aux_sym_hash_repeat1,
  [186880] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5426), 1,
      sym_heredoc_body,
    ACTIONS(7920), 3,
      anon_sym_end,
      anon_sym_in,
      anon_sym_else,
  [186895] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5427), 1,
      sym_heredoc_body,
    ACTIONS(7679), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186910] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7450), 1,
      sym__string_end,
    ACTIONS(7922), 1,
      aux_sym_string_array_token1,
    STATE(5412), 1,
      aux_sym_string_array_repeat1,
    STATE(5428), 1,
      sym_heredoc_body,
  [186929] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(211), 1,
      sym__terminator,
    STATE(5429), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [186946] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5430), 1,
      sym_heredoc_body,
    ACTIONS(2954), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186961] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5431), 1,
      sym_heredoc_body,
    ACTIONS(7634), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186976] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(215), 1,
      sym__terminator,
    STATE(5432), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [186993] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5433), 1,
      sym_heredoc_body,
    ACTIONS(7677), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187008] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5434), 1,
      sym_heredoc_body,
    ACTIONS(7924), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [187023] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7486), 1,
      sym__string_end,
    ACTIONS(7926), 1,
      aux_sym_string_array_token1,
    STATE(5435), 1,
      sym_heredoc_body,
    STATE(5469), 1,
      aux_sym_symbol_array_repeat1,
  [187042] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7510), 1,
      sym__string_end,
    ACTIONS(7928), 1,
      aux_sym_string_array_token1,
    STATE(5436), 1,
      sym_heredoc_body,
    STATE(5469), 1,
      aux_sym_symbol_array_repeat1,
  [187061] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7930), 1,
      anon_sym_RPAREN,
    STATE(5437), 1,
      sym_heredoc_body,
    ACTIONS(7894), 2,
      anon_sym_and,
      anon_sym_or,
  [187078] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7932), 1,
      anon_sym_RBRACE,
    ACTIONS(7934), 1,
      anon_sym_COMMA,
    STATE(5438), 1,
      sym_heredoc_body,
    STATE(5455), 1,
      aux_sym_hash_repeat1,
  [187097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7393), 1,
      sym__string_end,
    ACTIONS(7936), 1,
      aux_sym_string_array_token1,
    STATE(5439), 1,
      sym_heredoc_body,
    STATE(5469), 1,
      aux_sym_symbol_array_repeat1,
  [187116] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7879), 1,
      anon_sym_COMMA,
    ACTIONS(7938), 1,
      anon_sym_RPAREN,
    STATE(5410), 1,
      aux_sym_parameters_repeat1,
    STATE(5440), 1,
      sym_heredoc_body,
  [187135] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7940), 1,
      anon_sym_COMMA,
    ACTIONS(7943), 1,
      anon_sym_PIPE,
    STATE(5441), 2,
      sym_heredoc_body,
      aux_sym_block_parameters_repeat1,
  [187152] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(7945), 1,
      anon_sym_PIPE,
    STATE(5406), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5442), 1,
      sym_heredoc_body,
  [187171] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(7947), 1,
      anon_sym_PIPE,
    STATE(5443), 1,
      sym_heredoc_body,
    STATE(5484), 1,
      aux_sym_block_parameters_repeat1,
  [187190] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5444), 1,
      sym_heredoc_body,
    ACTIONS(7685), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187205] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5445), 1,
      sym_heredoc_body,
    ACTIONS(7949), 3,
      anon_sym_end,
      anon_sym_in,
      anon_sym_else,
  [187220] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7484), 1,
      sym__string_end,
    ACTIONS(7951), 1,
      aux_sym_string_array_token1,
    STATE(5412), 1,
      aux_sym_string_array_repeat1,
    STATE(5446), 1,
      sym_heredoc_body,
  [187239] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(7953), 1,
      anon_sym_PIPE,
    STATE(5441), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5447), 1,
      sym_heredoc_body,
  [187258] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7371), 1,
      sym__string_end,
    ACTIONS(7955), 1,
      aux_sym_string_array_token1,
    STATE(5412), 1,
      aux_sym_string_array_repeat1,
    STATE(5448), 1,
      sym_heredoc_body,
  [187277] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7957), 1,
      anon_sym_i,
    ACTIONS(7959), 1,
      anon_sym_ri,
    ACTIONS(7961), 1,
      anon_sym_r,
    STATE(5449), 1,
      sym_heredoc_body,
  [187296] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(7963), 1,
      anon_sym_PIPE,
    STATE(5441), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5450), 1,
      sym_heredoc_body,
  [187315] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(7965), 1,
      anon_sym_PIPE,
    STATE(5450), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5451), 1,
      sym_heredoc_body,
  [187334] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(224), 1,
      sym__terminator,
    STATE(5452), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [187351] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7967), 1,
      anon_sym_i,
    ACTIONS(7969), 1,
      anon_sym_ri,
    ACTIONS(7971), 1,
      anon_sym_r,
    STATE(5453), 1,
      sym_heredoc_body,
  [187370] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7879), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_RPAREN,
    STATE(5454), 1,
      sym_heredoc_body,
    STATE(5465), 1,
      aux_sym_parameters_repeat1,
  [187389] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2518), 1,
      anon_sym_RBRACE,
    ACTIONS(7975), 1,
      anon_sym_COMMA,
    STATE(5408), 1,
      aux_sym_hash_repeat1,
    STATE(5455), 1,
      sym_heredoc_body,
  [187408] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7529), 1,
      sym__string_end,
    ACTIONS(7977), 1,
      aux_sym_string_array_token1,
    STATE(5412), 1,
      aux_sym_string_array_repeat1,
    STATE(5456), 1,
      sym_heredoc_body,
  [187427] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5457), 1,
      sym_heredoc_body,
    ACTIONS(7979), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [187442] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7981), 1,
      anon_sym_RBRACE,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    STATE(5458), 1,
      sym_heredoc_body,
    STATE(5473), 1,
      aux_sym_hash_repeat1,
  [187461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7442), 1,
      sym__string_end,
    ACTIONS(7985), 1,
      aux_sym_string_array_token1,
    STATE(5412), 1,
      aux_sym_string_array_repeat1,
    STATE(5459), 1,
      sym_heredoc_body,
  [187480] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7879), 1,
      anon_sym_COMMA,
    ACTIONS(7987), 1,
      anon_sym_RPAREN,
    STATE(5460), 1,
      sym_heredoc_body,
    STATE(5476), 1,
      aux_sym_parameters_repeat1,
  [187499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7533), 1,
      sym__string_end,
    ACTIONS(7989), 1,
      aux_sym_string_array_token1,
    STATE(5461), 1,
      sym_heredoc_body,
    STATE(5469), 1,
      aux_sym_symbol_array_repeat1,
  [187518] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5462), 1,
      sym_heredoc_body,
    ACTIONS(2960), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187533] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(7991), 1,
      anon_sym_PIPE,
    STATE(5441), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5463), 1,
      sym_heredoc_body,
  [187552] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7993), 1,
      ts_builtin_sym_end,
    ACTIONS(7995), 1,
      aux_sym_program_token1,
    ACTIONS(7997), 1,
      anon_sym___END__,
    STATE(5464), 1,
      sym_heredoc_body,
  [187571] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7679), 1,
      anon_sym_RPAREN,
    ACTIONS(7999), 1,
      anon_sym_COMMA,
    STATE(5465), 2,
      sym_heredoc_body,
      aux_sym_parameters_repeat1,
  [187588] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    STATE(5422), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5466), 1,
      sym_heredoc_body,
  [187607] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7422), 1,
      sym__string_end,
    ACTIONS(8004), 1,
      aux_sym_string_array_token1,
    STATE(5412), 1,
      aux_sym_string_array_repeat1,
    STATE(5467), 1,
      sym_heredoc_body,
  [187626] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2510), 1,
      anon_sym_RBRACE,
    ACTIONS(8006), 1,
      anon_sym_COMMA,
    STATE(5408), 1,
      aux_sym_hash_repeat1,
    STATE(5468), 1,
      sym_heredoc_body,
  [187645] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8008), 1,
      aux_sym_string_array_token1,
    ACTIONS(8011), 1,
      sym__string_end,
    STATE(5469), 2,
      sym_heredoc_body,
      aux_sym_symbol_array_repeat1,
  [187662] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5470), 1,
      sym_heredoc_body,
    ACTIONS(8013), 3,
      anon_sym_end,
      anon_sym_when,
      anon_sym_else,
  [187677] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7879), 1,
      anon_sym_COMMA,
    ACTIONS(8015), 1,
      anon_sym_RPAREN,
    STATE(5454), 1,
      aux_sym_parameters_repeat1,
    STATE(5471), 1,
      sym_heredoc_body,
  [187696] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8017), 1,
      anon_sym_i,
    ACTIONS(8019), 1,
      anon_sym_ri,
    ACTIONS(8021), 1,
      anon_sym_r,
    STATE(5472), 1,
      sym_heredoc_body,
  [187715] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2508), 1,
      anon_sym_RBRACE,
    ACTIONS(8023), 1,
      anon_sym_COMMA,
    STATE(5408), 1,
      aux_sym_hash_repeat1,
    STATE(5473), 1,
      sym_heredoc_body,
  [187734] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5474), 1,
      sym_heredoc_body,
    ACTIONS(2950), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187749] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(8025), 1,
      anon_sym_PIPE,
    STATE(5441), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5475), 1,
      sym_heredoc_body,
  [187768] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7879), 1,
      anon_sym_COMMA,
    ACTIONS(8027), 1,
      anon_sym_RPAREN,
    STATE(5465), 1,
      aux_sym_parameters_repeat1,
    STATE(5476), 1,
      sym_heredoc_body,
  [187787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7476), 1,
      sym__string_end,
    ACTIONS(8029), 1,
      aux_sym_string_array_token1,
    STATE(5469), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5477), 1,
      sym_heredoc_body,
  [187806] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7381), 1,
      sym__string_end,
    ACTIONS(8031), 1,
      aux_sym_string_array_token1,
    STATE(5412), 1,
      aux_sym_string_array_repeat1,
    STATE(5478), 1,
      sym_heredoc_body,
  [187825] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5479), 1,
      sym_heredoc_body,
    ACTIONS(8033), 3,
      anon_sym_end,
      anon_sym_in,
      anon_sym_else,
  [187840] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8035), 1,
      anon_sym_i,
    ACTIONS(8037), 1,
      anon_sym_ri,
    ACTIONS(8039), 1,
      anon_sym_r,
    STATE(5480), 1,
      sym_heredoc_body,
  [187859] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5481), 1,
      sym_heredoc_body,
    ACTIONS(7640), 3,
      sym__line_break,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [187874] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(8041), 1,
      anon_sym_PIPE,
    STATE(5411), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5482), 1,
      sym_heredoc_body,
  [187893] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(8043), 1,
      anon_sym_PIPE,
    STATE(5447), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5483), 1,
      sym_heredoc_body,
  [187912] = 6,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7868), 1,
      anon_sym_COMMA,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    STATE(5441), 1,
      aux_sym_block_parameters_repeat1,
    STATE(5484), 1,
      sym_heredoc_body,
  [187931] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7606), 1,
      sym__string_end,
    ACTIONS(8047), 1,
      aux_sym_string_array_token1,
    STATE(5412), 1,
      aux_sym_string_array_repeat1,
    STATE(5485), 1,
      sym_heredoc_body,
  [187950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7502), 1,
      sym__string_end,
    ACTIONS(8049), 1,
      aux_sym_string_array_token1,
    STATE(5469), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5486), 1,
      sym_heredoc_body,
  [187969] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(7490), 1,
      sym__string_end,
    ACTIONS(8051), 1,
      aux_sym_string_array_token1,
    STATE(5469), 1,
      aux_sym_symbol_array_repeat1,
    STATE(5487), 1,
      sym_heredoc_body,
  [187988] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(220), 1,
      sym__terminator,
    STATE(5488), 1,
      sym_heredoc_body,
    ACTIONS(753), 2,
      sym__line_break,
      anon_sym_SEMI,
  [188005] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5489), 1,
      sym_heredoc_body,
    ACTIONS(8053), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188019] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5490), 1,
      sym_heredoc_body,
    ACTIONS(7788), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [188033] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5491), 1,
      sym_heredoc_body,
    ACTIONS(8055), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188047] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5492), 1,
      sym_heredoc_body,
    ACTIONS(8057), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188061] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5493), 1,
      sym_heredoc_body,
    ACTIONS(8059), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188075] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7235), 1,
      anon_sym_in,
    STATE(5220), 1,
      sym_in,
    STATE(5494), 1,
      sym_heredoc_body,
  [188091] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7864), 1,
      anon_sym_PIPE,
    ACTIONS(7866), 1,
      anon_sym_SEMI,
    STATE(5495), 1,
      sym_heredoc_body,
  [188107] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5496), 1,
      sym_heredoc_body,
    ACTIONS(8061), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188121] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5497), 1,
      sym_heredoc_body,
    ACTIONS(745), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188135] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5498), 1,
      sym_heredoc_body,
    ACTIONS(8063), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188149] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5499), 1,
      sym_heredoc_body,
    ACTIONS(7872), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [188163] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5500), 1,
      sym_heredoc_body,
    ACTIONS(8065), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188177] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5501), 1,
      sym_heredoc_body,
    ACTIONS(8067), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188191] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5502), 1,
      sym_heredoc_body,
    ACTIONS(8069), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188205] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5503), 1,
      sym_heredoc_body,
    ACTIONS(8071), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188219] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5504), 1,
      sym_heredoc_body,
    ACTIONS(8073), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188233] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5505), 1,
      sym_heredoc_body,
    ACTIONS(8075), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188247] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5506), 1,
      sym_heredoc_body,
    ACTIONS(8077), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188261] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7235), 1,
      anon_sym_in,
    STATE(5199), 1,
      sym_in,
    STATE(5507), 1,
      sym_heredoc_body,
  [188277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    STATE(5508), 1,
      sym_heredoc_body,
    ACTIONS(8079), 2,
      anon_sym_EQ,
      anon_sym_in,
  [188291] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7823), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_SEMI,
    STATE(5509), 1,
      sym_heredoc_body,
  [188307] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5510), 1,
      sym_heredoc_body,
    ACTIONS(8081), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8079), 1,
      anon_sym_EQ,
    ACTIONS(8083), 1,
      anon_sym_RPAREN,
    STATE(5511), 1,
      sym_heredoc_body,
  [188337] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5512), 1,
      sym_heredoc_body,
    ACTIONS(8085), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188351] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5513), 1,
      sym_heredoc_body,
    ACTIONS(8087), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188365] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_EQ_GT,
    ACTIONS(8089), 1,
      anon_sym_RPAREN,
    STATE(5514), 1,
      sym_heredoc_body,
  [188381] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5515), 1,
      sym_heredoc_body,
    ACTIONS(8091), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188395] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5516), 1,
      sym_heredoc_body,
    ACTIONS(8093), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188409] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7062), 1,
      anon_sym_EQ_GT,
    ACTIONS(8095), 1,
      anon_sym_RPAREN,
    STATE(5517), 1,
      sym_heredoc_body,
  [188425] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5518), 1,
      sym_heredoc_body,
    ACTIONS(8097), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188439] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5519), 1,
      sym_heredoc_body,
    ACTIONS(8099), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188453] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5520), 1,
      sym_heredoc_body,
    ACTIONS(8101), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [188467] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5521), 1,
      sym_heredoc_body,
    ACTIONS(8103), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188481] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5522), 1,
      sym_heredoc_body,
    ACTIONS(8105), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188495] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5523), 1,
      sym_heredoc_body,
    ACTIONS(8107), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188509] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5524), 1,
      sym_heredoc_body,
    ACTIONS(8109), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188523] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5525), 1,
      sym_heredoc_body,
    ACTIONS(8111), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188537] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
    STATE(5243), 1,
      sym_parenthesized_statements,
    STATE(5526), 1,
      sym_heredoc_body,
  [188553] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5527), 1,
      sym_heredoc_body,
    ACTIONS(8113), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188567] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5528), 1,
      sym_heredoc_body,
    ACTIONS(8115), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188581] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5529), 1,
      sym_heredoc_body,
    ACTIONS(8117), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188595] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5530), 1,
      sym_heredoc_body,
    ACTIONS(8119), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188609] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5531), 1,
      sym_heredoc_body,
    ACTIONS(8121), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188623] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5532), 1,
      sym_heredoc_body,
    ACTIONS(8123), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188637] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5533), 1,
      sym_heredoc_body,
    ACTIONS(8125), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188651] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5534), 1,
      sym_heredoc_body,
    ACTIONS(8127), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188665] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5535), 1,
      sym_heredoc_body,
    ACTIONS(8129), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188679] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5536), 1,
      sym_heredoc_body,
    ACTIONS(8131), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188693] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5537), 1,
      sym_heredoc_body,
    ACTIONS(8133), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188707] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5538), 1,
      sym_heredoc_body,
    ACTIONS(8135), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188721] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5539), 1,
      sym_heredoc_body,
    ACTIONS(8137), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188735] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5540), 1,
      sym_heredoc_body,
    ACTIONS(8139), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188749] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5541), 1,
      sym_heredoc_body,
    ACTIONS(8141), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188763] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5542), 1,
      sym_heredoc_body,
    ACTIONS(8143), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188777] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5543), 1,
      sym_heredoc_body,
    ACTIONS(8145), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188791] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5544), 1,
      sym_heredoc_body,
    ACTIONS(8147), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188805] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5545), 1,
      sym_heredoc_body,
    ACTIONS(8149), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188819] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5546), 1,
      sym_heredoc_body,
    ACTIONS(8151), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188833] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5547), 1,
      sym_heredoc_body,
    ACTIONS(8153), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188847] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5548), 1,
      sym_heredoc_body,
    ACTIONS(8155), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188861] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    STATE(5549), 1,
      sym_heredoc_body,
    ACTIONS(8157), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [188875] = 5,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7235), 1,
      anon_sym_in,
    STATE(5212), 1,
      sym_in,
    STATE(5550), 1,
      sym_heredoc_body,
  [188891] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8159), 1,
      sym_identifier,
    STATE(5551), 1,
      sym_heredoc_body,
  [188904] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8161), 1,
      anon_sym_end,
    STATE(5552), 1,
      sym_heredoc_body,
  [188917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8163), 1,
      anon_sym_EQ,
    STATE(5553), 1,
      sym_heredoc_body,
  [188930] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8165), 1,
      anon_sym_COLON,
    STATE(5554), 1,
      sym_heredoc_body,
  [188943] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8167), 1,
      anon_sym_end,
    STATE(5555), 1,
      sym_heredoc_body,
  [188956] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6575), 1,
      anon_sym_COLON,
    STATE(5556), 1,
      sym_heredoc_body,
  [188969] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8169), 1,
      anon_sym_end,
    STATE(5557), 1,
      sym_heredoc_body,
  [188982] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8171), 1,
      anon_sym_end,
    STATE(5558), 1,
      sym_heredoc_body,
  [188995] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6825), 1,
      anon_sym_COLON,
    STATE(5559), 1,
      sym_heredoc_body,
  [189008] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8173), 1,
      anon_sym_end,
    STATE(5560), 1,
      sym_heredoc_body,
  [189021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8175), 1,
      anon_sym_EQ,
    STATE(5561), 1,
      sym_heredoc_body,
  [189034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8177), 1,
      anon_sym_EQ,
    STATE(5562), 1,
      sym_heredoc_body,
  [189047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8179), 1,
      anon_sym_EQ,
    STATE(5563), 1,
      sym_heredoc_body,
  [189060] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8181), 1,
      anon_sym_end,
    STATE(5564), 1,
      sym_heredoc_body,
  [189073] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_RBRACK,
    STATE(5565), 1,
      sym_heredoc_body,
  [189086] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8185), 1,
      anon_sym_end,
    STATE(5566), 1,
      sym_heredoc_body,
  [189099] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8187), 1,
      anon_sym_RBRACK,
    STATE(5567), 1,
      sym_heredoc_body,
  [189112] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7064), 1,
      anon_sym_COLON,
    STATE(5568), 1,
      sym_heredoc_body,
  [189125] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8189), 1,
      sym_constant,
    STATE(5569), 1,
      sym_heredoc_body,
  [189138] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8191), 1,
      anon_sym_RBRACK,
    STATE(5570), 1,
      sym_heredoc_body,
  [189151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8193), 1,
      anon_sym_EQ,
    STATE(5571), 1,
      sym_heredoc_body,
  [189164] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8195), 1,
      anon_sym_RPAREN,
    STATE(5572), 1,
      sym_heredoc_body,
  [189177] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8197), 1,
      anon_sym_RBRACE,
    STATE(5573), 1,
      sym_heredoc_body,
  [189190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8199), 1,
      anon_sym_EQ,
    STATE(5574), 1,
      sym_heredoc_body,
  [189203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8201), 1,
      anon_sym_EQ,
    STATE(5575), 1,
      sym_heredoc_body,
  [189216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8203), 1,
      anon_sym_EQ,
    STATE(5576), 1,
      sym_heredoc_body,
  [189229] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8205), 1,
      sym_constant,
    STATE(5577), 1,
      sym_heredoc_body,
  [189242] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8207), 1,
      sym__string_end,
    STATE(5578), 1,
      sym_heredoc_body,
  [189255] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8209), 1,
      anon_sym_end,
    STATE(5579), 1,
      sym_heredoc_body,
  [189268] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8211), 1,
      anon_sym_end,
    STATE(5580), 1,
      sym_heredoc_body,
  [189281] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_COLON,
    STATE(5581), 1,
      sym_heredoc_body,
  [189294] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_end,
    STATE(5582), 1,
      sym_heredoc_body,
  [189307] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8215), 1,
      anon_sym_end,
    STATE(5583), 1,
      sym_heredoc_body,
  [189320] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8217), 1,
      anon_sym_end,
    STATE(5584), 1,
      sym_heredoc_body,
  [189333] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8219), 1,
      anon_sym_end,
    STATE(5585), 1,
      sym_heredoc_body,
  [189346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8221), 1,
      anon_sym_EQ,
    STATE(5586), 1,
      sym_heredoc_body,
  [189359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8223), 1,
      anon_sym_EQ,
    STATE(5587), 1,
      sym_heredoc_body,
  [189372] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8225), 1,
      anon_sym_end,
    STATE(5588), 1,
      sym_heredoc_body,
  [189385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8227), 1,
      anon_sym_EQ,
    STATE(5589), 1,
      sym_heredoc_body,
  [189398] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8229), 1,
      anon_sym_end,
    STATE(5590), 1,
      sym_heredoc_body,
  [189411] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6493), 1,
      anon_sym_COLON,
    STATE(5591), 1,
      sym_heredoc_body,
  [189424] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8231), 1,
      anon_sym_end,
    STATE(5592), 1,
      sym_heredoc_body,
  [189437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8233), 1,
      anon_sym_EQ,
    STATE(5593), 1,
      sym_heredoc_body,
  [189450] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8235), 1,
      anon_sym_RBRACE,
    STATE(5594), 1,
      sym_heredoc_body,
  [189463] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_COLON,
    STATE(5595), 1,
      sym_heredoc_body,
  [189476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8237), 1,
      anon_sym_EQ,
    STATE(5596), 1,
      sym_heredoc_body,
  [189489] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8239), 1,
      anon_sym_COLON,
    STATE(5597), 1,
      sym_heredoc_body,
  [189502] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7655), 1,
      anon_sym_end,
    STATE(5598), 1,
      sym_heredoc_body,
  [189515] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8241), 1,
      anon_sym_end,
    STATE(5599), 1,
      sym_heredoc_body,
  [189528] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8243), 1,
      anon_sym_end,
    STATE(5600), 1,
      sym_heredoc_body,
  [189541] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7700), 1,
      anon_sym_end,
    STATE(5601), 1,
      sym_heredoc_body,
  [189554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8245), 1,
      anon_sym_EQ,
    STATE(5602), 1,
      sym_heredoc_body,
  [189567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8247), 1,
      anon_sym_EQ,
    STATE(5603), 1,
      sym_heredoc_body,
  [189580] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8249), 1,
      anon_sym_end,
    STATE(5604), 1,
      sym_heredoc_body,
  [189593] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_end,
    STATE(5605), 1,
      sym_heredoc_body,
  [189606] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8253), 1,
      sym_constant,
    STATE(5606), 1,
      sym_heredoc_body,
  [189619] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7636), 1,
      anon_sym_end,
    STATE(5607), 1,
      sym_heredoc_body,
  [189632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8255), 1,
      anon_sym_EQ,
    STATE(5608), 1,
      sym_heredoc_body,
  [189645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8257), 1,
      anon_sym_EQ,
    STATE(5609), 1,
      sym_heredoc_body,
  [189658] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8259), 1,
      ts_builtin_sym_end,
    STATE(5610), 1,
      sym_heredoc_body,
  [189671] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8261), 1,
      anon_sym_COLON,
    STATE(5611), 1,
      sym_heredoc_body,
  [189684] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8263), 1,
      anon_sym_end,
    STATE(5612), 1,
      sym_heredoc_body,
  [189697] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8265), 1,
      anon_sym_end,
    STATE(5613), 1,
      sym_heredoc_body,
  [189710] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8267), 1,
      sym__string_end,
    STATE(5614), 1,
      sym_heredoc_body,
  [189723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8269), 1,
      anon_sym_EQ,
    STATE(5615), 1,
      sym_heredoc_body,
  [189736] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8271), 1,
      anon_sym_RBRACK,
    STATE(5616), 1,
      sym_heredoc_body,
  [189749] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8273), 1,
      anon_sym_end,
    STATE(5617), 1,
      sym_heredoc_body,
  [189762] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8275), 1,
      anon_sym_LBRACE,
    STATE(5618), 1,
      sym_heredoc_body,
  [189775] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8277), 1,
      anon_sym_RBRACK,
    STATE(5619), 1,
      sym_heredoc_body,
  [189788] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8279), 1,
      anon_sym_end,
    STATE(5620), 1,
      sym_heredoc_body,
  [189801] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8281), 1,
      anon_sym_end,
    STATE(5621), 1,
      sym_heredoc_body,
  [189814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8283), 1,
      anon_sym_EQ,
    STATE(5622), 1,
      sym_heredoc_body,
  [189827] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8285), 1,
      sym_constant,
    STATE(5623), 1,
      sym_heredoc_body,
  [189840] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8287), 1,
      anon_sym_end,
    STATE(5624), 1,
      sym_heredoc_body,
  [189853] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8289), 1,
      anon_sym_RPAREN,
    STATE(5625), 1,
      sym_heredoc_body,
  [189866] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8291), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      sym_heredoc_body,
  [189879] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8293), 1,
      anon_sym_end,
    STATE(5627), 1,
      sym_heredoc_body,
  [189892] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8295), 1,
      anon_sym_RBRACK,
    STATE(5628), 1,
      sym_heredoc_body,
  [189905] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8297), 1,
      ts_builtin_sym_end,
    STATE(5629), 1,
      sym_heredoc_body,
  [189918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8299), 1,
      anon_sym_EQ,
    STATE(5630), 1,
      sym_heredoc_body,
  [189931] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8301), 1,
      anon_sym_end,
    STATE(5631), 1,
      sym_heredoc_body,
  [189944] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7166), 1,
      anon_sym_end,
    STATE(5632), 1,
      sym_heredoc_body,
  [189957] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8303), 1,
      anon_sym_end,
    STATE(5633), 1,
      sym_heredoc_body,
  [189970] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8305), 1,
      sym_constant,
    STATE(5634), 1,
      sym_heredoc_body,
  [189983] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8307), 1,
      anon_sym_LBRACE,
    STATE(5635), 1,
      sym_heredoc_body,
  [189996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8309), 1,
      anon_sym_EQ,
    STATE(5636), 1,
      sym_heredoc_body,
  [190009] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8311), 1,
      anon_sym_RBRACE,
    STATE(5637), 1,
      sym_heredoc_body,
  [190022] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7098), 1,
      anon_sym_end,
    STATE(5638), 1,
      sym_heredoc_body,
  [190035] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8313), 1,
      anon_sym_RBRACE,
    STATE(5639), 1,
      sym_heredoc_body,
  [190048] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8315), 1,
      anon_sym_end,
    STATE(5640), 1,
      sym_heredoc_body,
  [190061] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8317), 1,
      anon_sym_end,
    STATE(5641), 1,
      sym_heredoc_body,
  [190074] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8319), 1,
      anon_sym_end,
    STATE(5642), 1,
      sym_heredoc_body,
  [190087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8321), 1,
      anon_sym_EQ,
    STATE(5643), 1,
      sym_heredoc_body,
  [190100] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8323), 1,
      anon_sym_end,
    STATE(5644), 1,
      sym_heredoc_body,
  [190113] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8183), 1,
      anon_sym_RPAREN,
    STATE(5645), 1,
      sym_heredoc_body,
  [190126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8325), 1,
      anon_sym_EQ,
    STATE(5646), 1,
      sym_heredoc_body,
  [190139] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8187), 1,
      anon_sym_RPAREN,
    STATE(5647), 1,
      sym_heredoc_body,
  [190152] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8327), 1,
      anon_sym_end,
    STATE(5648), 1,
      sym_heredoc_body,
  [190165] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8329), 1,
      anon_sym_COLON,
    STATE(5649), 1,
      sym_heredoc_body,
  [190178] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7151), 1,
      anon_sym_end,
    STATE(5650), 1,
      sym_heredoc_body,
  [190191] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8331), 1,
      anon_sym_end,
    STATE(5651), 1,
      sym_heredoc_body,
  [190204] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8271), 1,
      anon_sym_RPAREN,
    STATE(5652), 1,
      sym_heredoc_body,
  [190217] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8333), 1,
      sym_identifier,
    STATE(5653), 1,
      sym_heredoc_body,
  [190230] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8335), 1,
      anon_sym_end,
    STATE(5654), 1,
      sym_heredoc_body,
  [190243] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8337), 1,
      anon_sym_end,
    STATE(5655), 1,
      sym_heredoc_body,
  [190256] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8339), 1,
      anon_sym_end,
    STATE(5656), 1,
      sym_heredoc_body,
  [190269] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7114), 1,
      anon_sym_end,
    STATE(5657), 1,
      sym_heredoc_body,
  [190282] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8341), 1,
      anon_sym_end,
    STATE(5658), 1,
      sym_heredoc_body,
  [190295] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8343), 1,
      anon_sym_end,
    STATE(5659), 1,
      sym_heredoc_body,
  [190308] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8345), 1,
      anon_sym_end,
    STATE(5660), 1,
      sym_heredoc_body,
  [190321] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8347), 1,
      anon_sym_end,
    STATE(5661), 1,
      sym_heredoc_body,
  [190334] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7651), 1,
      anon_sym_end,
    STATE(5662), 1,
      sym_heredoc_body,
  [190347] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8349), 1,
      anon_sym_end,
    STATE(5663), 1,
      sym_heredoc_body,
  [190360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8351), 1,
      anon_sym_EQ,
    STATE(5664), 1,
      sym_heredoc_body,
  [190373] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8353), 1,
      anon_sym_RBRACK,
    STATE(5665), 1,
      sym_heredoc_body,
  [190386] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8355), 1,
      anon_sym_end,
    STATE(5666), 1,
      sym_heredoc_body,
  [190399] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8357), 1,
      anon_sym_end,
    STATE(5667), 1,
      sym_heredoc_body,
  [190412] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8359), 1,
      sym_identifier,
    STATE(5668), 1,
      sym_heredoc_body,
  [190425] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8361), 1,
      anon_sym_end,
    STATE(5669), 1,
      sym_heredoc_body,
  [190438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8363), 1,
      anon_sym_EQ,
    STATE(5670), 1,
      sym_heredoc_body,
  [190451] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8365), 1,
      anon_sym_RBRACE,
    STATE(5671), 1,
      sym_heredoc_body,
  [190464] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8367), 1,
      anon_sym_end,
    STATE(5672), 1,
      sym_heredoc_body,
  [190477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8369), 1,
      anon_sym_EQ,
    STATE(5673), 1,
      sym_heredoc_body,
  [190490] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8371), 1,
      anon_sym_RBRACE,
    STATE(5674), 1,
      sym_heredoc_body,
  [190503] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8373), 1,
      anon_sym_RPAREN,
    STATE(5675), 1,
      sym_heredoc_body,
  [190516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8375), 1,
      anon_sym_EQ,
    STATE(5676), 1,
      sym_heredoc_body,
  [190529] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7689), 1,
      anon_sym_end,
    STATE(5677), 1,
      sym_heredoc_body,
  [190542] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8377), 1,
      anon_sym_end,
    STATE(5678), 1,
      sym_heredoc_body,
  [190555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8379), 1,
      anon_sym_EQ,
    STATE(5679), 1,
      sym_heredoc_body,
  [190568] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8381), 1,
      anon_sym_COLON,
    STATE(5680), 1,
      sym_heredoc_body,
  [190581] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_end,
    STATE(5681), 1,
      sym_heredoc_body,
  [190594] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8385), 1,
      anon_sym_end,
    STATE(5682), 1,
      sym_heredoc_body,
  [190607] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8387), 1,
      anon_sym_end,
    STATE(5683), 1,
      sym_heredoc_body,
  [190620] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8389), 1,
      anon_sym_RBRACE,
    STATE(5684), 1,
      sym_heredoc_body,
  [190633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8391), 1,
      anon_sym_EQ,
    STATE(5685), 1,
      sym_heredoc_body,
  [190646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8393), 1,
      sym_uninterpreted,
    STATE(5686), 1,
      sym_heredoc_body,
  [190659] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8395), 1,
      anon_sym_end,
    STATE(5687), 1,
      sym_heredoc_body,
  [190672] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8397), 1,
      anon_sym_end,
    STATE(5688), 1,
      sym_heredoc_body,
  [190685] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8399), 1,
      anon_sym_COLON,
    STATE(5689), 1,
      sym_heredoc_body,
  [190698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8401), 1,
      anon_sym_,
    STATE(5690), 1,
      sym_heredoc_body,
  [190711] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8403), 1,
      anon_sym_end,
    STATE(5691), 1,
      sym_heredoc_body,
  [190724] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8405), 1,
      anon_sym_RBRACK,
    STATE(5692), 1,
      sym_heredoc_body,
  [190737] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8407), 1,
      anon_sym_end,
    STATE(5693), 1,
      sym_heredoc_body,
  [190750] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8409), 1,
      sym_identifier,
    STATE(5694), 1,
      sym_heredoc_body,
  [190763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8411), 1,
      anon_sym_EQ,
    STATE(5695), 1,
      sym_heredoc_body,
  [190776] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8413), 1,
      anon_sym_end,
    STATE(5696), 1,
      sym_heredoc_body,
  [190789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8415), 1,
      anon_sym_EQ,
    STATE(5697), 1,
      sym_heredoc_body,
  [190802] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6948), 1,
      anon_sym_COLON,
    STATE(5698), 1,
      sym_heredoc_body,
  [190815] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8417), 1,
      anon_sym_end,
    STATE(5699), 1,
      sym_heredoc_body,
  [190828] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8419), 1,
      anon_sym_end,
    STATE(5700), 1,
      sym_heredoc_body,
  [190841] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8421), 1,
      anon_sym_RBRACE,
    STATE(5701), 1,
      sym_heredoc_body,
  [190854] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_COLON,
    STATE(5702), 1,
      sym_heredoc_body,
  [190867] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8423), 1,
      anon_sym_RBRACE,
    STATE(5703), 1,
      sym_heredoc_body,
  [190880] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_end,
    STATE(5704), 1,
      sym_heredoc_body,
  [190893] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8427), 1,
      anon_sym_end,
    STATE(5705), 1,
      sym_heredoc_body,
  [190906] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8429), 1,
      sym_constant,
    STATE(5706), 1,
      sym_heredoc_body,
  [190919] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8431), 1,
      sym_identifier,
    STATE(5707), 1,
      sym_heredoc_body,
  [190932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8433), 1,
      anon_sym_EQ,
    STATE(5708), 1,
      sym_heredoc_body,
  [190945] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8435), 1,
      sym_identifier,
    STATE(5709), 1,
      sym_heredoc_body,
  [190958] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8437), 1,
      sym_identifier,
    STATE(5710), 1,
      sym_heredoc_body,
  [190971] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8439), 1,
      anon_sym_RBRACE,
    STATE(5711), 1,
      sym_heredoc_body,
  [190984] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8441), 1,
      anon_sym_end,
    STATE(5712), 1,
      sym_heredoc_body,
  [190997] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8443), 1,
      anon_sym_end,
    STATE(5713), 1,
      sym_heredoc_body,
  [191010] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8445), 1,
      anon_sym_end,
    STATE(5714), 1,
      sym_heredoc_body,
  [191023] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8447), 1,
      anon_sym_RBRACK,
    STATE(5715), 1,
      sym_heredoc_body,
  [191036] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8449), 1,
      sym_constant,
    STATE(5716), 1,
      sym_heredoc_body,
  [191049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8451), 1,
      anon_sym_EQ,
    STATE(5717), 1,
      sym_heredoc_body,
  [191062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8453), 1,
      anon_sym_EQ,
    STATE(5718), 1,
      sym_heredoc_body,
  [191075] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8455), 1,
      sym_constant,
    STATE(5719), 1,
      sym_heredoc_body,
  [191088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8457), 1,
      anon_sym_EQ,
    STATE(5720), 1,
      sym_heredoc_body,
  [191101] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6923), 1,
      anon_sym_COLON,
    STATE(5721), 1,
      sym_heredoc_body,
  [191114] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6999), 1,
      anon_sym_COLON,
    STATE(5722), 1,
      sym_heredoc_body,
  [191127] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8459), 1,
      anon_sym_end,
    STATE(5723), 1,
      sym_heredoc_body,
  [191140] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8461), 1,
      anon_sym_RBRACK,
    STATE(5724), 1,
      sym_heredoc_body,
  [191153] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8463), 1,
      anon_sym_RBRACK,
    STATE(5725), 1,
      sym_heredoc_body,
  [191166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8465), 1,
      anon_sym_EQ,
    STATE(5726), 1,
      sym_heredoc_body,
  [191179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8467), 1,
      anon_sym_EQ,
    STATE(5727), 1,
      sym_heredoc_body,
  [191192] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8469), 1,
      sym_identifier,
    STATE(5728), 1,
      sym_heredoc_body,
  [191205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8393), 1,
      anon_sym_,
    STATE(5729), 1,
      sym_heredoc_body,
  [191218] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8471), 1,
      anon_sym_RPAREN,
    STATE(5730), 1,
      sym_heredoc_body,
  [191231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8473), 1,
      anon_sym_EQ,
    STATE(5731), 1,
      sym_heredoc_body,
  [191244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8475), 1,
      anon_sym_EQ,
    STATE(5732), 1,
      sym_heredoc_body,
  [191257] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8477), 1,
      anon_sym_end,
    STATE(5733), 1,
      sym_heredoc_body,
  [191270] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8479), 1,
      sym_identifier,
    STATE(5734), 1,
      sym_heredoc_body,
  [191283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8401), 1,
      sym_uninterpreted,
    STATE(5735), 1,
      sym_heredoc_body,
  [191296] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8481), 1,
      anon_sym_end,
    STATE(5736), 1,
      sym_heredoc_body,
  [191309] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8483), 1,
      sym_constant,
    STATE(5737), 1,
      sym_heredoc_body,
  [191322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8485), 1,
      anon_sym_EQ,
    STATE(5738), 1,
      sym_heredoc_body,
  [191335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8487), 1,
      anon_sym_EQ,
    STATE(5739), 1,
      sym_heredoc_body,
  [191348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8489), 1,
      anon_sym_EQ,
    STATE(5740), 1,
      sym_heredoc_body,
  [191361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8491), 1,
      anon_sym_EQ,
    STATE(5741), 1,
      sym_heredoc_body,
  [191374] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8493), 1,
      anon_sym_RBRACE,
    STATE(5742), 1,
      sym_heredoc_body,
  [191387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8495), 1,
      anon_sym_EQ,
    STATE(5743), 1,
      sym_heredoc_body,
  [191400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8497), 1,
      anon_sym_EQ,
    STATE(5744), 1,
      sym_heredoc_body,
  [191413] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8499), 1,
      sym__string_end,
    STATE(5745), 1,
      sym_heredoc_body,
  [191426] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8501), 1,
      anon_sym_RBRACE,
    STATE(5746), 1,
      sym_heredoc_body,
  [191439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8503), 1,
      anon_sym_EQ,
    STATE(5747), 1,
      sym_heredoc_body,
  [191452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8505), 1,
      anon_sym_EQ,
    STATE(5748), 1,
      sym_heredoc_body,
  [191465] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8507), 1,
      sym__string_end,
    STATE(5749), 1,
      sym_heredoc_body,
  [191478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8509), 1,
      anon_sym_EQ,
    STATE(5750), 1,
      sym_heredoc_body,
  [191491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8511), 1,
      anon_sym_EQ,
    STATE(5751), 1,
      sym_heredoc_body,
  [191504] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8513), 1,
      anon_sym_end,
    STATE(5752), 1,
      sym_heredoc_body,
  [191517] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8515), 1,
      anon_sym_end,
    STATE(5753), 1,
      sym_heredoc_body,
  [191530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8517), 1,
      anon_sym_EQ,
    STATE(5754), 1,
      sym_heredoc_body,
  [191543] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8519), 1,
      anon_sym_end,
    STATE(5755), 1,
      sym_heredoc_body,
  [191556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8521), 1,
      anon_sym_EQ,
    STATE(5756), 1,
      sym_heredoc_body,
  [191569] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8523), 1,
      anon_sym_RBRACE,
    STATE(5757), 1,
      sym_heredoc_body,
  [191582] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8525), 1,
      sym_constant,
    STATE(5758), 1,
      sym_heredoc_body,
  [191595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8527), 1,
      anon_sym_EQ,
    STATE(5759), 1,
      sym_heredoc_body,
  [191608] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8529), 1,
      anon_sym_RBRACE,
    STATE(5760), 1,
      sym_heredoc_body,
  [191621] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7620), 1,
      anon_sym_end,
    STATE(5761), 1,
      sym_heredoc_body,
  [191634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8531), 1,
      anon_sym_EQ,
    STATE(5762), 1,
      sym_heredoc_body,
  [191647] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8533), 1,
      anon_sym_RBRACK,
    STATE(5763), 1,
      sym_heredoc_body,
  [191660] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8535), 1,
      anon_sym_RBRACK,
    STATE(5764), 1,
      sym_heredoc_body,
  [191673] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8537), 1,
      sym__string_end,
    STATE(5765), 1,
      sym_heredoc_body,
  [191686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8539), 1,
      anon_sym_EQ,
    STATE(5766), 1,
      sym_heredoc_body,
  [191699] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8541), 1,
      anon_sym_end,
    STATE(5767), 1,
      sym_heredoc_body,
  [191712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8543), 1,
      anon_sym_EQ,
    STATE(5768), 1,
      sym_heredoc_body,
  [191725] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8545), 1,
      anon_sym_end,
    STATE(5769), 1,
      sym_heredoc_body,
  [191738] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8547), 1,
      anon_sym_COLON,
    STATE(5770), 1,
      sym_heredoc_body,
  [191751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8549), 1,
      anon_sym_EQ,
    STATE(5771), 1,
      sym_heredoc_body,
  [191764] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8551), 1,
      anon_sym_end,
    STATE(5772), 1,
      sym_heredoc_body,
  [191777] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7671), 1,
      anon_sym_end,
    STATE(5773), 1,
      sym_heredoc_body,
  [191790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8553), 1,
      anon_sym_EQ,
    STATE(5774), 1,
      sym_heredoc_body,
  [191803] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8555), 1,
      anon_sym_end,
    STATE(5775), 1,
      sym_heredoc_body,
  [191816] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8557), 1,
      sym__string_end,
    STATE(5776), 1,
      sym_heredoc_body,
  [191829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8559), 1,
      anon_sym_EQ,
    STATE(5777), 1,
      sym_heredoc_body,
  [191842] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8561), 1,
      sym_constant,
    STATE(5778), 1,
      sym_heredoc_body,
  [191855] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7638), 1,
      anon_sym_end,
    STATE(5779), 1,
      sym_heredoc_body,
  [191868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8563), 1,
      anon_sym_EQ,
    STATE(5780), 1,
      sym_heredoc_body,
  [191881] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8565), 1,
      sym__string_end,
    STATE(5781), 1,
      sym_heredoc_body,
  [191894] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8567), 1,
      anon_sym_end,
    STATE(5782), 1,
      sym_heredoc_body,
  [191907] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8569), 1,
      anon_sym_end,
    STATE(5783), 1,
      sym_heredoc_body,
  [191920] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8571), 1,
      anon_sym_RPAREN,
    STATE(5784), 1,
      sym_heredoc_body,
  [191933] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8573), 1,
      anon_sym_RBRACE,
    STATE(5785), 1,
      sym_heredoc_body,
  [191946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8575), 1,
      anon_sym_EQ,
    STATE(5786), 1,
      sym_heredoc_body,
  [191959] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8577), 1,
      anon_sym_end,
    STATE(5787), 1,
      sym_heredoc_body,
  [191972] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8579), 1,
      anon_sym_end,
    STATE(5788), 1,
      sym_heredoc_body,
  [191985] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8581), 1,
      anon_sym_end,
    STATE(5789), 1,
      sym_heredoc_body,
  [191998] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8583), 1,
      anon_sym_RBRACE,
    STATE(5790), 1,
      sym_heredoc_body,
  [192011] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8585), 1,
      anon_sym_end,
    STATE(5791), 1,
      sym_heredoc_body,
  [192024] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8587), 1,
      anon_sym_end,
    STATE(5792), 1,
      sym_heredoc_body,
  [192037] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8589), 1,
      anon_sym_end,
    STATE(5793), 1,
      sym_heredoc_body,
  [192050] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8591), 1,
      sym_identifier,
    STATE(5794), 1,
      sym_heredoc_body,
  [192063] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8593), 1,
      anon_sym_RBRACK,
    STATE(5795), 1,
      sym_heredoc_body,
  [192076] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8595), 1,
      anon_sym_end,
    STATE(5796), 1,
      sym_heredoc_body,
  [192089] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8597), 1,
      anon_sym_RBRACK,
    STATE(5797), 1,
      sym_heredoc_body,
  [192102] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8599), 1,
      anon_sym_RBRACE,
    STATE(5798), 1,
      sym_heredoc_body,
  [192115] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8601), 1,
      anon_sym_end,
    STATE(5799), 1,
      sym_heredoc_body,
  [192128] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8603), 1,
      anon_sym_RBRACK,
    STATE(5800), 1,
      sym_heredoc_body,
  [192141] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8605), 1,
      sym_identifier,
    STATE(5801), 1,
      sym_heredoc_body,
  [192154] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8593), 1,
      anon_sym_RPAREN,
    STATE(5802), 1,
      sym_heredoc_body,
  [192167] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8607), 1,
      anon_sym_end,
    STATE(5803), 1,
      sym_heredoc_body,
  [192180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8609), 1,
      anon_sym_EQ,
    STATE(5804), 1,
      sym_heredoc_body,
  [192193] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8611), 1,
      anon_sym_end,
    STATE(5805), 1,
      sym_heredoc_body,
  [192206] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8613), 1,
      sym_constant,
    STATE(5806), 1,
      sym_heredoc_body,
  [192219] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8615), 1,
      anon_sym_end,
    STATE(5807), 1,
      sym_heredoc_body,
  [192232] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8617), 1,
      anon_sym_EQ,
    STATE(5808), 1,
      sym_heredoc_body,
  [192245] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8619), 1,
      sym_constant,
    STATE(5809), 1,
      sym_heredoc_body,
  [192258] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8621), 1,
      anon_sym_end,
    STATE(5810), 1,
      sym_heredoc_body,
  [192271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8623), 1,
      anon_sym_EQ,
    STATE(5811), 1,
      sym_heredoc_body,
  [192284] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8625), 1,
      anon_sym_end,
    STATE(5812), 1,
      sym_heredoc_body,
  [192297] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8627), 1,
      anon_sym_end,
    STATE(5813), 1,
      sym_heredoc_body,
  [192310] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_COLON,
    STATE(5814), 1,
      sym_heredoc_body,
  [192323] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7695), 1,
      anon_sym_end,
    STATE(5815), 1,
      sym_heredoc_body,
  [192336] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7683), 1,
      anon_sym_end,
    STATE(5816), 1,
      sym_heredoc_body,
  [192349] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8629), 1,
      anon_sym_end,
    STATE(5817), 1,
      sym_heredoc_body,
  [192362] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8631), 1,
      anon_sym_COLON,
    STATE(5818), 1,
      sym_heredoc_body,
  [192375] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8633), 1,
      anon_sym_end,
    STATE(5819), 1,
      sym_heredoc_body,
  [192388] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8635), 1,
      anon_sym_end,
    STATE(5820), 1,
      sym_heredoc_body,
  [192401] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8637), 1,
      anon_sym_RBRACK,
    STATE(5821), 1,
      sym_heredoc_body,
  [192414] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8639), 1,
      anon_sym_end,
    STATE(5822), 1,
      sym_heredoc_body,
  [192427] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8641), 1,
      anon_sym_end,
    STATE(5823), 1,
      sym_heredoc_body,
  [192440] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8643), 1,
      anon_sym_COLON,
    STATE(5824), 1,
      sym_heredoc_body,
  [192453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8645), 1,
      anon_sym_EQ,
    STATE(5825), 1,
      sym_heredoc_body,
  [192466] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8647), 1,
      anon_sym_RBRACE,
    STATE(5826), 1,
      sym_heredoc_body,
  [192479] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8649), 1,
      anon_sym_COLON,
    STATE(5827), 1,
      sym_heredoc_body,
  [192492] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8651), 1,
      anon_sym_end,
    STATE(5828), 1,
      sym_heredoc_body,
  [192505] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8653), 1,
      anon_sym_EQ,
    STATE(5829), 1,
      sym_heredoc_body,
  [192518] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8655), 1,
      anon_sym_end,
    STATE(5830), 1,
      sym_heredoc_body,
  [192531] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8657), 1,
      anon_sym_end,
    STATE(5831), 1,
      sym_heredoc_body,
  [192544] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7164), 1,
      anon_sym_end,
    STATE(5832), 1,
      sym_heredoc_body,
  [192557] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7693), 1,
      anon_sym_end,
    STATE(5833), 1,
      sym_heredoc_body,
  [192570] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8659), 1,
      anon_sym_end,
    STATE(5834), 1,
      sym_heredoc_body,
  [192583] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8661), 1,
      anon_sym_end,
    STATE(5835), 1,
      sym_heredoc_body,
  [192596] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8663), 1,
      anon_sym_end,
    STATE(5836), 1,
      sym_heredoc_body,
  [192609] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8597), 1,
      anon_sym_RPAREN,
    STATE(5837), 1,
      sym_heredoc_body,
  [192622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8665), 1,
      anon_sym_EQ,
    STATE(5838), 1,
      sym_heredoc_body,
  [192635] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8667), 1,
      anon_sym_end,
    STATE(5839), 1,
      sym_heredoc_body,
  [192648] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8669), 1,
      anon_sym_end,
    STATE(5840), 1,
      sym_heredoc_body,
  [192661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8671), 1,
      anon_sym_EQ,
    STATE(5841), 1,
      sym_heredoc_body,
  [192674] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8673), 1,
      anon_sym_end,
    STATE(5842), 1,
      sym_heredoc_body,
  [192687] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8675), 1,
      anon_sym_COLON,
    STATE(5843), 1,
      sym_heredoc_body,
  [192700] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8677), 1,
      anon_sym_RBRACE,
    STATE(5844), 1,
      sym_heredoc_body,
  [192713] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8679), 1,
      sym_constant,
    STATE(5845), 1,
      sym_heredoc_body,
  [192726] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_COLON,
    STATE(5846), 1,
      sym_heredoc_body,
  [192739] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8683), 1,
      anon_sym_RBRACE,
    STATE(5847), 1,
      sym_heredoc_body,
  [192752] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8685), 1,
      sym__string_end,
    STATE(5848), 1,
      sym_heredoc_body,
  [192765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8687), 1,
      anon_sym_EQ,
    STATE(5849), 1,
      sym_heredoc_body,
  [192778] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8689), 1,
      anon_sym_RBRACE,
    STATE(5850), 1,
      sym_heredoc_body,
  [192791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8691), 1,
      anon_sym_EQ,
    STATE(5851), 1,
      sym_heredoc_body,
  [192804] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(6993), 1,
      anon_sym_COLON,
    STATE(5852), 1,
      sym_heredoc_body,
  [192817] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8693), 1,
      anon_sym_end,
    STATE(5853), 1,
      sym_heredoc_body,
  [192830] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8695), 1,
      anon_sym_end,
    STATE(5854), 1,
      sym_heredoc_body,
  [192843] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8697), 1,
      anon_sym_end,
    STATE(5855), 1,
      sym_heredoc_body,
  [192856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8699), 1,
      anon_sym_EQ,
    STATE(5856), 1,
      sym_heredoc_body,
  [192869] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8701), 1,
      anon_sym_end,
    STATE(5857), 1,
      sym_heredoc_body,
  [192882] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_end,
    STATE(5858), 1,
      sym_heredoc_body,
  [192895] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8703), 1,
      anon_sym_end,
    STATE(5859), 1,
      sym_heredoc_body,
  [192908] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8705), 1,
      anon_sym_RBRACE,
    STATE(5860), 1,
      sym_heredoc_body,
  [192921] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_end,
    STATE(5861), 1,
      sym_heredoc_body,
  [192934] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8709), 1,
      sym__string_end,
    STATE(5862), 1,
      sym_heredoc_body,
  [192947] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8711), 1,
      anon_sym_end,
    STATE(5863), 1,
      sym_heredoc_body,
  [192960] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8713), 1,
      anon_sym_end,
    STATE(5864), 1,
      sym_heredoc_body,
  [192973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(8715), 1,
      anon_sym_EQ,
    STATE(5865), 1,
      sym_heredoc_body,
  [192986] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8717), 1,
      sym__string_end,
    STATE(5866), 1,
      sym_heredoc_body,
  [192999] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8719), 1,
      anon_sym_end,
    STATE(5867), 1,
      sym_heredoc_body,
  [193012] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8721), 1,
      anon_sym_end,
    STATE(5868), 1,
      sym_heredoc_body,
  [193025] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym_end,
    STATE(5869), 1,
      sym_heredoc_body,
  [193038] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8603), 1,
      anon_sym_RPAREN,
    STATE(5870), 1,
      sym_heredoc_body,
  [193051] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8723), 1,
      anon_sym_end,
    STATE(5871), 1,
      sym_heredoc_body,
  [193064] = 4,
    ACTIONS(5), 1,
      sym__heredoc_body_start,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(8725), 1,
      ts_builtin_sym_end,
    STATE(5872), 1,
      sym_heredoc_body,
  [193077] = 1,
    ACTIONS(8727), 1,
      ts_builtin_sym_end,
  [193081] = 1,
    ACTIONS(8729), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2125)] = 0,
  [SMALL_STATE(2126)] = 87,
  [SMALL_STATE(2127)] = 174,
  [SMALL_STATE(2128)] = 256,
  [SMALL_STATE(2129)] = 334,
  [SMALL_STATE(2130)] = 414,
  [SMALL_STATE(2131)] = 494,
  [SMALL_STATE(2132)] = 576,
  [SMALL_STATE(2133)] = 650,
  [SMALL_STATE(2134)] = 730,
  [SMALL_STATE(2135)] = 808,
  [SMALL_STATE(2136)] = 888,
  [SMALL_STATE(2137)] = 970,
  [SMALL_STATE(2138)] = 1113,
  [SMALL_STATE(2139)] = 1256,
  [SMALL_STATE(2140)] = 1331,
  [SMALL_STATE(2141)] = 1406,
  [SMALL_STATE(2142)] = 1489,
  [SMALL_STATE(2143)] = 1574,
  [SMALL_STATE(2144)] = 1717,
  [SMALL_STATE(2145)] = 1860,
  [SMALL_STATE(2146)] = 1937,
  [SMALL_STATE(2147)] = 2080,
  [SMALL_STATE(2148)] = 2158,
  [SMALL_STATE(2149)] = 2230,
  [SMALL_STATE(2150)] = 2302,
  [SMALL_STATE(2151)] = 2376,
  [SMALL_STATE(2152)] = 2448,
  [SMALL_STATE(2153)] = 2520,
  [SMALL_STATE(2154)] = 2592,
  [SMALL_STATE(2155)] = 2668,
  [SMALL_STATE(2156)] = 2740,
  [SMALL_STATE(2157)] = 2812,
  [SMALL_STATE(2158)] = 2884,
  [SMALL_STATE(2159)] = 2962,
  [SMALL_STATE(2160)] = 3042,
  [SMALL_STATE(2161)] = 3122,
  [SMALL_STATE(2162)] = 3198,
  [SMALL_STATE(2163)] = 3278,
  [SMALL_STATE(2164)] = 3356,
  [SMALL_STATE(2165)] = 3436,
  [SMALL_STATE(2166)] = 3514,
  [SMALL_STATE(2167)] = 3592,
  [SMALL_STATE(2168)] = 3670,
  [SMALL_STATE(2169)] = 3752,
  [SMALL_STATE(2170)] = 3834,
  [SMALL_STATE(2171)] = 3911,
  [SMALL_STATE(2172)] = 3986,
  [SMALL_STATE(2173)] = 4057,
  [SMALL_STATE(2174)] = 4128,
  [SMALL_STATE(2175)] = 4199,
  [SMALL_STATE(2176)] = 4274,
  [SMALL_STATE(2177)] = 4353,
  [SMALL_STATE(2178)] = 4424,
  [SMALL_STATE(2179)] = 4501,
  [SMALL_STATE(2180)] = 4580,
  [SMALL_STATE(2181)] = 4657,
  [SMALL_STATE(2182)] = 4732,
  [SMALL_STATE(2183)] = 4803,
  [SMALL_STATE(2184)] = 4880,
  [SMALL_STATE(2185)] = 4955,
  [SMALL_STATE(2186)] = 5026,
  [SMALL_STATE(2187)] = 5101,
  [SMALL_STATE(2188)] = 5172,
  [SMALL_STATE(2189)] = 5251,
  [SMALL_STATE(2190)] = 5328,
  [SMALL_STATE(2191)] = 5399,
  [SMALL_STATE(2192)] = 5470,
  [SMALL_STATE(2193)] = 5545,
  [SMALL_STATE(2194)] = 5616,
  [SMALL_STATE(2195)] = 5691,
  [SMALL_STATE(2196)] = 5763,
  [SMALL_STATE(2197)] = 5833,
  [SMALL_STATE(2198)] = 5911,
  [SMALL_STATE(2199)] = 5987,
  [SMALL_STATE(2200)] = 6101,
  [SMALL_STATE(2201)] = 6177,
  [SMALL_STATE(2202)] = 6247,
  [SMALL_STATE(2203)] = 6327,
  [SMALL_STATE(2204)] = 6397,
  [SMALL_STATE(2205)] = 6466,
  [SMALL_STATE(2206)] = 6535,
  [SMALL_STATE(2207)] = 6604,
  [SMALL_STATE(2208)] = 6673,
  [SMALL_STATE(2209)] = 6742,
  [SMALL_STATE(2210)] = 6811,
  [SMALL_STATE(2211)] = 6880,
  [SMALL_STATE(2212)] = 6949,
  [SMALL_STATE(2213)] = 7018,
  [SMALL_STATE(2214)] = 7087,
  [SMALL_STATE(2215)] = 7156,
  [SMALL_STATE(2216)] = 7225,
  [SMALL_STATE(2217)] = 7294,
  [SMALL_STATE(2218)] = 7363,
  [SMALL_STATE(2219)] = 7432,
  [SMALL_STATE(2220)] = 7501,
  [SMALL_STATE(2221)] = 7572,
  [SMALL_STATE(2222)] = 7641,
  [SMALL_STATE(2223)] = 7710,
  [SMALL_STATE(2224)] = 7779,
  [SMALL_STATE(2225)] = 7848,
  [SMALL_STATE(2226)] = 7917,
  [SMALL_STATE(2227)] = 7986,
  [SMALL_STATE(2228)] = 8055,
  [SMALL_STATE(2229)] = 8124,
  [SMALL_STATE(2230)] = 8193,
  [SMALL_STATE(2231)] = 8262,
  [SMALL_STATE(2232)] = 8335,
  [SMALL_STATE(2233)] = 8404,
  [SMALL_STATE(2234)] = 8473,
  [SMALL_STATE(2235)] = 8542,
  [SMALL_STATE(2236)] = 8617,
  [SMALL_STATE(2237)] = 8686,
  [SMALL_STATE(2238)] = 8755,
  [SMALL_STATE(2239)] = 8824,
  [SMALL_STATE(2240)] = 8895,
  [SMALL_STATE(2241)] = 8966,
  [SMALL_STATE(2242)] = 9037,
  [SMALL_STATE(2243)] = 9106,
  [SMALL_STATE(2244)] = 9175,
  [SMALL_STATE(2245)] = 9244,
  [SMALL_STATE(2246)] = 9313,
  [SMALL_STATE(2247)] = 9382,
  [SMALL_STATE(2248)] = 9451,
  [SMALL_STATE(2249)] = 9520,
  [SMALL_STATE(2250)] = 9589,
  [SMALL_STATE(2251)] = 9658,
  [SMALL_STATE(2252)] = 9727,
  [SMALL_STATE(2253)] = 9796,
  [SMALL_STATE(2254)] = 9867,
  [SMALL_STATE(2255)] = 9936,
  [SMALL_STATE(2256)] = 10005,
  [SMALL_STATE(2257)] = 10074,
  [SMALL_STATE(2258)] = 10149,
  [SMALL_STATE(2259)] = 10224,
  [SMALL_STATE(2260)] = 10293,
  [SMALL_STATE(2261)] = 10362,
  [SMALL_STATE(2262)] = 10431,
  [SMALL_STATE(2263)] = 10500,
  [SMALL_STATE(2264)] = 10575,
  [SMALL_STATE(2265)] = 10644,
  [SMALL_STATE(2266)] = 10713,
  [SMALL_STATE(2267)] = 10788,
  [SMALL_STATE(2268)] = 10857,
  [SMALL_STATE(2269)] = 10934,
  [SMALL_STATE(2270)] = 11003,
  [SMALL_STATE(2271)] = 11072,
  [SMALL_STATE(2272)] = 11141,
  [SMALL_STATE(2273)] = 11216,
  [SMALL_STATE(2274)] = 11291,
  [SMALL_STATE(2275)] = 11360,
  [SMALL_STATE(2276)] = 11429,
  [SMALL_STATE(2277)] = 11498,
  [SMALL_STATE(2278)] = 11567,
  [SMALL_STATE(2279)] = 11636,
  [SMALL_STATE(2280)] = 11705,
  [SMALL_STATE(2281)] = 11774,
  [SMALL_STATE(2282)] = 11845,
  [SMALL_STATE(2283)] = 11914,
  [SMALL_STATE(2284)] = 11983,
  [SMALL_STATE(2285)] = 12052,
  [SMALL_STATE(2286)] = 12121,
  [SMALL_STATE(2287)] = 12190,
  [SMALL_STATE(2288)] = 12259,
  [SMALL_STATE(2289)] = 12328,
  [SMALL_STATE(2290)] = 12397,
  [SMALL_STATE(2291)] = 12466,
  [SMALL_STATE(2292)] = 12535,
  [SMALL_STATE(2293)] = 12604,
  [SMALL_STATE(2294)] = 12673,
  [SMALL_STATE(2295)] = 12742,
  [SMALL_STATE(2296)] = 12811,
  [SMALL_STATE(2297)] = 12880,
  [SMALL_STATE(2298)] = 12949,
  [SMALL_STATE(2299)] = 13018,
  [SMALL_STATE(2300)] = 13087,
  [SMALL_STATE(2301)] = 13156,
  [SMALL_STATE(2302)] = 13225,
  [SMALL_STATE(2303)] = 13294,
  [SMALL_STATE(2304)] = 13363,
  [SMALL_STATE(2305)] = 13432,
  [SMALL_STATE(2306)] = 13501,
  [SMALL_STATE(2307)] = 13570,
  [SMALL_STATE(2308)] = 13639,
  [SMALL_STATE(2309)] = 13708,
  [SMALL_STATE(2310)] = 13777,
  [SMALL_STATE(2311)] = 13846,
  [SMALL_STATE(2312)] = 13915,
  [SMALL_STATE(2313)] = 13984,
  [SMALL_STATE(2314)] = 14053,
  [SMALL_STATE(2315)] = 14122,
  [SMALL_STATE(2316)] = 14191,
  [SMALL_STATE(2317)] = 14260,
  [SMALL_STATE(2318)] = 14329,
  [SMALL_STATE(2319)] = 14398,
  [SMALL_STATE(2320)] = 14467,
  [SMALL_STATE(2321)] = 14536,
  [SMALL_STATE(2322)] = 14605,
  [SMALL_STATE(2323)] = 14674,
  [SMALL_STATE(2324)] = 14743,
  [SMALL_STATE(2325)] = 14812,
  [SMALL_STATE(2326)] = 14881,
  [SMALL_STATE(2327)] = 14950,
  [SMALL_STATE(2328)] = 15019,
  [SMALL_STATE(2329)] = 15088,
  [SMALL_STATE(2330)] = 15157,
  [SMALL_STATE(2331)] = 15226,
  [SMALL_STATE(2332)] = 15295,
  [SMALL_STATE(2333)] = 15364,
  [SMALL_STATE(2334)] = 15433,
  [SMALL_STATE(2335)] = 15502,
  [SMALL_STATE(2336)] = 15571,
  [SMALL_STATE(2337)] = 15640,
  [SMALL_STATE(2338)] = 15709,
  [SMALL_STATE(2339)] = 15778,
  [SMALL_STATE(2340)] = 15847,
  [SMALL_STATE(2341)] = 15916,
  [SMALL_STATE(2342)] = 15985,
  [SMALL_STATE(2343)] = 16054,
  [SMALL_STATE(2344)] = 16123,
  [SMALL_STATE(2345)] = 16192,
  [SMALL_STATE(2346)] = 16261,
  [SMALL_STATE(2347)] = 16330,
  [SMALL_STATE(2348)] = 16405,
  [SMALL_STATE(2349)] = 16474,
  [SMALL_STATE(2350)] = 16543,
  [SMALL_STATE(2351)] = 16612,
  [SMALL_STATE(2352)] = 16683,
  [SMALL_STATE(2353)] = 16756,
  [SMALL_STATE(2354)] = 16825,
  [SMALL_STATE(2355)] = 16894,
  [SMALL_STATE(2356)] = 16963,
  [SMALL_STATE(2357)] = 17032,
  [SMALL_STATE(2358)] = 17101,
  [SMALL_STATE(2359)] = 17172,
  [SMALL_STATE(2360)] = 17241,
  [SMALL_STATE(2361)] = 17310,
  [SMALL_STATE(2362)] = 17379,
  [SMALL_STATE(2363)] = 17448,
  [SMALL_STATE(2364)] = 17517,
  [SMALL_STATE(2365)] = 17586,
  [SMALL_STATE(2366)] = 17655,
  [SMALL_STATE(2367)] = 17724,
  [SMALL_STATE(2368)] = 17793,
  [SMALL_STATE(2369)] = 17862,
  [SMALL_STATE(2370)] = 17936,
  [SMALL_STATE(2371)] = 18012,
  [SMALL_STATE(2372)] = 18086,
  [SMALL_STATE(2373)] = 18160,
  [SMALL_STATE(2374)] = 18230,
  [SMALL_STATE(2375)] = 18304,
  [SMALL_STATE(2376)] = 18378,
  [SMALL_STATE(2377)] = 18450,
  [SMALL_STATE(2378)] = 18524,
  [SMALL_STATE(2379)] = 18600,
  [SMALL_STATE(2380)] = 18674,
  [SMALL_STATE(2381)] = 18746,
  [SMALL_STATE(2382)] = 18845,
  [SMALL_STATE(2383)] = 18944,
  [SMALL_STATE(2384)] = 19043,
  [SMALL_STATE(2385)] = 19114,
  [SMALL_STATE(2386)] = 19213,
  [SMALL_STATE(2387)] = 19288,
  [SMALL_STATE(2388)] = 19391,
  [SMALL_STATE(2389)] = 19490,
  [SMALL_STATE(2390)] = 19559,
  [SMALL_STATE(2391)] = 19632,
  [SMALL_STATE(2392)] = 19701,
  [SMALL_STATE(2393)] = 19768,
  [SMALL_STATE(2394)] = 19841,
  [SMALL_STATE(2395)] = 19940,
  [SMALL_STATE(2396)] = 20015,
  [SMALL_STATE(2397)] = 20084,
  [SMALL_STATE(2398)] = 20159,
  [SMALL_STATE(2399)] = 20228,
  [SMALL_STATE(2400)] = 20327,
  [SMALL_STATE(2401)] = 20426,
  [SMALL_STATE(2402)] = 20525,
  [SMALL_STATE(2403)] = 20624,
  [SMALL_STATE(2404)] = 20723,
  [SMALL_STATE(2405)] = 20822,
  [SMALL_STATE(2406)] = 20921,
  [SMALL_STATE(2407)] = 21020,
  [SMALL_STATE(2408)] = 21119,
  [SMALL_STATE(2409)] = 21218,
  [SMALL_STATE(2410)] = 21317,
  [SMALL_STATE(2411)] = 21390,
  [SMALL_STATE(2412)] = 21489,
  [SMALL_STATE(2413)] = 21588,
  [SMALL_STATE(2414)] = 21663,
  [SMALL_STATE(2415)] = 21762,
  [SMALL_STATE(2416)] = 21861,
  [SMALL_STATE(2417)] = 21960,
  [SMALL_STATE(2418)] = 22059,
  [SMALL_STATE(2419)] = 22158,
  [SMALL_STATE(2420)] = 22231,
  [SMALL_STATE(2421)] = 22302,
  [SMALL_STATE(2422)] = 22372,
  [SMALL_STATE(2423)] = 22470,
  [SMALL_STATE(2424)] = 22566,
  [SMALL_STATE(2425)] = 22634,
  [SMALL_STATE(2426)] = 22702,
  [SMALL_STATE(2427)] = 22774,
  [SMALL_STATE(2428)] = 22842,
  [SMALL_STATE(2429)] = 22940,
  [SMALL_STATE(2430)] = 23038,
  [SMALL_STATE(2431)] = 23136,
  [SMALL_STATE(2432)] = 23204,
  [SMALL_STATE(2433)] = 23272,
  [SMALL_STATE(2434)] = 23372,
  [SMALL_STATE(2435)] = 23448,
  [SMALL_STATE(2436)] = 23522,
  [SMALL_STATE(2437)] = 23596,
  [SMALL_STATE(2438)] = 23664,
  [SMALL_STATE(2439)] = 23754,
  [SMALL_STATE(2440)] = 23842,
  [SMALL_STATE(2441)] = 23914,
  [SMALL_STATE(2442)] = 24014,
  [SMALL_STATE(2443)] = 24112,
  [SMALL_STATE(2444)] = 24186,
  [SMALL_STATE(2445)] = 24274,
  [SMALL_STATE(2446)] = 24342,
  [SMALL_STATE(2447)] = 24416,
  [SMALL_STATE(2448)] = 24514,
  [SMALL_STATE(2449)] = 24612,
  [SMALL_STATE(2450)] = 24684,
  [SMALL_STATE(2451)] = 24780,
  [SMALL_STATE(2452)] = 24854,
  [SMALL_STATE(2453)] = 24922,
  [SMALL_STATE(2454)] = 24990,
  [SMALL_STATE(2455)] = 25070,
  [SMALL_STATE(2456)] = 25171,
  [SMALL_STATE(2457)] = 25244,
  [SMALL_STATE(2458)] = 25313,
  [SMALL_STATE(2459)] = 25384,
  [SMALL_STATE(2460)] = 25455,
  [SMALL_STATE(2461)] = 25522,
  [SMALL_STATE(2462)] = 25629,
  [SMALL_STATE(2463)] = 25698,
  [SMALL_STATE(2464)] = 25771,
  [SMALL_STATE(2465)] = 25836,
  [SMALL_STATE(2466)] = 25901,
  [SMALL_STATE(2467)] = 25974,
  [SMALL_STATE(2468)] = 26047,
  [SMALL_STATE(2469)] = 26112,
  [SMALL_STATE(2470)] = 26215,
  [SMALL_STATE(2471)] = 26282,
  [SMALL_STATE(2472)] = 26355,
  [SMALL_STATE(2473)] = 26420,
  [SMALL_STATE(2474)] = 26485,
  [SMALL_STATE(2475)] = 26550,
  [SMALL_STATE(2476)] = 26623,
  [SMALL_STATE(2477)] = 26688,
  [SMALL_STATE(2478)] = 26754,
  [SMALL_STATE(2479)] = 26818,
  [SMALL_STATE(2480)] = 26886,
  [SMALL_STATE(2481)] = 26952,
  [SMALL_STATE(2482)] = 27038,
  [SMALL_STATE(2483)] = 27110,
  [SMALL_STATE(2484)] = 27206,
  [SMALL_STATE(2485)] = 27302,
  [SMALL_STATE(2486)] = 27400,
  [SMALL_STATE(2487)] = 27472,
  [SMALL_STATE(2488)] = 27542,
  [SMALL_STATE(2489)] = 27614,
  [SMALL_STATE(2490)] = 27700,
  [SMALL_STATE(2491)] = 27766,
  [SMALL_STATE(2492)] = 27832,
  [SMALL_STATE(2493)] = 27926,
  [SMALL_STATE(2494)] = 28024,
  [SMALL_STATE(2495)] = 28094,
  [SMALL_STATE(2496)] = 28160,
  [SMALL_STATE(2497)] = 28238,
  [SMALL_STATE(2498)] = 28312,
  [SMALL_STATE(2499)] = 28408,
  [SMALL_STATE(2500)] = 28478,
  [SMALL_STATE(2501)] = 28566,
  [SMALL_STATE(2502)] = 28638,
  [SMALL_STATE(2503)] = 28704,
  [SMALL_STATE(2504)] = 28778,
  [SMALL_STATE(2505)] = 28874,
  [SMALL_STATE(2506)] = 28970,
  [SMALL_STATE(2507)] = 29064,
  [SMALL_STATE(2508)] = 29160,
  [SMALL_STATE(2509)] = 29256,
  [SMALL_STATE(2510)] = 29343,
  [SMALL_STATE(2511)] = 29430,
  [SMALL_STATE(2512)] = 29517,
  [SMALL_STATE(2513)] = 29604,
  [SMALL_STATE(2514)] = 29669,
  [SMALL_STATE(2515)] = 29756,
  [SMALL_STATE(2516)] = 29843,
  [SMALL_STATE(2517)] = 29930,
  [SMALL_STATE(2518)] = 30001,
  [SMALL_STATE(2519)] = 30098,
  [SMALL_STATE(2520)] = 30163,
  [SMALL_STATE(2521)] = 30230,
  [SMALL_STATE(2522)] = 30295,
  [SMALL_STATE(2523)] = 30360,
  [SMALL_STATE(2524)] = 30433,
  [SMALL_STATE(2525)] = 30504,
  [SMALL_STATE(2526)] = 30581,
  [SMALL_STATE(2527)] = 30668,
  [SMALL_STATE(2528)] = 30753,
  [SMALL_STATE(2529)] = 30822,
  [SMALL_STATE(2530)] = 30907,
  [SMALL_STATE(2531)] = 31008,
  [SMALL_STATE(2532)] = 31073,
  [SMALL_STATE(2533)] = 31170,
  [SMALL_STATE(2534)] = 31257,
  [SMALL_STATE(2535)] = 31344,
  [SMALL_STATE(2536)] = 31431,
  [SMALL_STATE(2537)] = 31526,
  [SMALL_STATE(2538)] = 31613,
  [SMALL_STATE(2539)] = 31708,
  [SMALL_STATE(2540)] = 31801,
  [SMALL_STATE(2541)] = 31896,
  [SMALL_STATE(2542)] = 31983,
  [SMALL_STATE(2543)] = 32070,
  [SMALL_STATE(2544)] = 32165,
  [SMALL_STATE(2545)] = 32252,
  [SMALL_STATE(2546)] = 32339,
  [SMALL_STATE(2547)] = 32426,
  [SMALL_STATE(2548)] = 32513,
  [SMALL_STATE(2549)] = 32600,
  [SMALL_STATE(2550)] = 32687,
  [SMALL_STATE(2551)] = 32774,
  [SMALL_STATE(2552)] = 32879,
  [SMALL_STATE(2553)] = 32966,
  [SMALL_STATE(2554)] = 33053,
  [SMALL_STATE(2555)] = 33140,
  [SMALL_STATE(2556)] = 33227,
  [SMALL_STATE(2557)] = 33314,
  [SMALL_STATE(2558)] = 33401,
  [SMALL_STATE(2559)] = 33488,
  [SMALL_STATE(2560)] = 33559,
  [SMALL_STATE(2561)] = 33628,
  [SMALL_STATE(2562)] = 33693,
  [SMALL_STATE(2563)] = 33780,
  [SMALL_STATE(2564)] = 33867,
  [SMALL_STATE(2565)] = 33964,
  [SMALL_STATE(2566)] = 34033,
  [SMALL_STATE(2567)] = 34126,
  [SMALL_STATE(2568)] = 34213,
  [SMALL_STATE(2569)] = 34300,
  [SMALL_STATE(2570)] = 34387,
  [SMALL_STATE(2571)] = 34474,
  [SMALL_STATE(2572)] = 34561,
  [SMALL_STATE(2573)] = 34626,
  [SMALL_STATE(2574)] = 34713,
  [SMALL_STATE(2575)] = 34818,
  [SMALL_STATE(2576)] = 34905,
  [SMALL_STATE(2577)] = 34992,
  [SMALL_STATE(2578)] = 35079,
  [SMALL_STATE(2579)] = 35144,
  [SMALL_STATE(2580)] = 35231,
  [SMALL_STATE(2581)] = 35298,
  [SMALL_STATE(2582)] = 35385,
  [SMALL_STATE(2583)] = 35472,
  [SMALL_STATE(2584)] = 35559,
  [SMALL_STATE(2585)] = 35646,
  [SMALL_STATE(2586)] = 35741,
  [SMALL_STATE(2587)] = 35828,
  [SMALL_STATE(2588)] = 35915,
  [SMALL_STATE(2589)] = 35986,
  [SMALL_STATE(2590)] = 36073,
  [SMALL_STATE(2591)] = 36160,
  [SMALL_STATE(2592)] = 36247,
  [SMALL_STATE(2593)] = 36311,
  [SMALL_STATE(2594)] = 36375,
  [SMALL_STATE(2595)] = 36447,
  [SMALL_STATE(2596)] = 36545,
  [SMALL_STATE(2597)] = 36629,
  [SMALL_STATE(2598)] = 36725,
  [SMALL_STATE(2599)] = 36815,
  [SMALL_STATE(2600)] = 36911,
  [SMALL_STATE(2601)] = 37007,
  [SMALL_STATE(2602)] = 37105,
  [SMALL_STATE(2603)] = 37171,
  [SMALL_STATE(2604)] = 37235,
  [SMALL_STATE(2605)] = 37319,
  [SMALL_STATE(2606)] = 37403,
  [SMALL_STATE(2607)] = 37471,
  [SMALL_STATE(2608)] = 37535,
  [SMALL_STATE(2609)] = 37601,
  [SMALL_STATE(2610)] = 37677,
  [SMALL_STATE(2611)] = 37741,
  [SMALL_STATE(2612)] = 37825,
  [SMALL_STATE(2613)] = 37891,
  [SMALL_STATE(2614)] = 37983,
  [SMALL_STATE(2615)] = 38067,
  [SMALL_STATE(2616)] = 38151,
  [SMALL_STATE(2617)] = 38235,
  [SMALL_STATE(2618)] = 38319,
  [SMALL_STATE(2619)] = 38411,
  [SMALL_STATE(2620)] = 38495,
  [SMALL_STATE(2621)] = 38563,
  [SMALL_STATE(2622)] = 38647,
  [SMALL_STATE(2623)] = 38711,
  [SMALL_STATE(2624)] = 38803,
  [SMALL_STATE(2625)] = 38895,
  [SMALL_STATE(2626)] = 38985,
  [SMALL_STATE(2627)] = 39077,
  [SMALL_STATE(2628)] = 39171,
  [SMALL_STATE(2629)] = 39263,
  [SMALL_STATE(2630)] = 39359,
  [SMALL_STATE(2631)] = 39429,
  [SMALL_STATE(2632)] = 39521,
  [SMALL_STATE(2633)] = 39607,
  [SMALL_STATE(2634)] = 39700,
  [SMALL_STATE(2635)] = 39763,
  [SMALL_STATE(2636)] = 39856,
  [SMALL_STATE(2637)] = 39951,
  [SMALL_STATE(2638)] = 40042,
  [SMALL_STATE(2639)] = 40111,
  [SMALL_STATE(2640)] = 40174,
  [SMALL_STATE(2641)] = 40237,
  [SMALL_STATE(2642)] = 40300,
  [SMALL_STATE(2643)] = 40365,
  [SMALL_STATE(2644)] = 40428,
  [SMALL_STATE(2645)] = 40491,
  [SMALL_STATE(2646)] = 40562,
  [SMALL_STATE(2647)] = 40631,
  [SMALL_STATE(2648)] = 40706,
  [SMALL_STATE(2649)] = 40791,
  [SMALL_STATE(2650)] = 40874,
  [SMALL_STATE(2651)] = 40941,
  [SMALL_STATE(2652)] = 41024,
  [SMALL_STATE(2653)] = 41087,
  [SMALL_STATE(2654)] = 41178,
  [SMALL_STATE(2655)] = 41241,
  [SMALL_STATE(2656)] = 41334,
  [SMALL_STATE(2657)] = 41399,
  [SMALL_STATE(2658)] = 41492,
  [SMALL_STATE(2659)] = 41557,
  [SMALL_STATE(2660)] = 41648,
  [SMALL_STATE(2661)] = 41741,
  [SMALL_STATE(2662)] = 41834,
  [SMALL_STATE(2663)] = 41897,
  [SMALL_STATE(2664)] = 41988,
  [SMALL_STATE(2665)] = 42085,
  [SMALL_STATE(2666)] = 42176,
  [SMALL_STATE(2667)] = 42277,
  [SMALL_STATE(2668)] = 42350,
  [SMALL_STATE(2669)] = 42441,
  [SMALL_STATE(2670)] = 42532,
  [SMALL_STATE(2671)] = 42627,
  [SMALL_STATE(2672)] = 42696,
  [SMALL_STATE(2673)] = 42795,
  [SMALL_STATE(2674)] = 42888,
  [SMALL_STATE(2675)] = 42983,
  [SMALL_STATE(2676)] = 43046,
  [SMALL_STATE(2677)] = 43110,
  [SMALL_STATE(2678)] = 43172,
  [SMALL_STATE(2679)] = 43260,
  [SMALL_STATE(2680)] = 43354,
  [SMALL_STATE(2681)] = 43448,
  [SMALL_STATE(2682)] = 43510,
  [SMALL_STATE(2683)] = 43600,
  [SMALL_STATE(2684)] = 43662,
  [SMALL_STATE(2685)] = 43760,
  [SMALL_STATE(2686)] = 43824,
  [SMALL_STATE(2687)] = 43914,
  [SMALL_STATE(2688)] = 43976,
  [SMALL_STATE(2689)] = 44058,
  [SMALL_STATE(2690)] = 44124,
  [SMALL_STATE(2691)] = 44212,
  [SMALL_STATE(2692)] = 44280,
  [SMALL_STATE(2693)] = 44376,
  [SMALL_STATE(2694)] = 44468,
  [SMALL_STATE(2695)] = 44562,
  [SMALL_STATE(2696)] = 44658,
  [SMALL_STATE(2697)] = 44748,
  [SMALL_STATE(2698)] = 44818,
  [SMALL_STATE(2699)] = 44886,
  [SMALL_STATE(2700)] = 44970,
  [SMALL_STATE(2701)] = 45044,
  [SMALL_STATE(2702)] = 45126,
  [SMALL_STATE(2703)] = 45216,
  [SMALL_STATE(2704)] = 45306,
  [SMALL_STATE(2705)] = 45368,
  [SMALL_STATE(2706)] = 45458,
  [SMALL_STATE(2707)] = 45522,
  [SMALL_STATE(2708)] = 45588,
  [SMALL_STATE(2709)] = 45650,
  [SMALL_STATE(2710)] = 45720,
  [SMALL_STATE(2711)] = 45810,
  [SMALL_STATE(2712)] = 45904,
  [SMALL_STATE(2713)] = 45968,
  [SMALL_STATE(2714)] = 46033,
  [SMALL_STATE(2715)] = 46094,
  [SMALL_STATE(2716)] = 46163,
  [SMALL_STATE(2717)] = 46254,
  [SMALL_STATE(2718)] = 46335,
  [SMALL_STATE(2719)] = 46398,
  [SMALL_STATE(2720)] = 46459,
  [SMALL_STATE(2721)] = 46526,
  [SMALL_STATE(2722)] = 46599,
  [SMALL_STATE(2723)] = 46682,
  [SMALL_STATE(2724)] = 46763,
  [SMALL_STATE(2725)] = 46852,
  [SMALL_STATE(2726)] = 46917,
  [SMALL_STATE(2727)] = 46998,
  [SMALL_STATE(2728)] = 47061,
  [SMALL_STATE(2729)] = 47124,
  [SMALL_STATE(2730)] = 47185,
  [SMALL_STATE(2731)] = 47246,
  [SMALL_STATE(2732)] = 47315,
  [SMALL_STATE(2733)] = 47376,
  [SMALL_STATE(2734)] = 47465,
  [SMALL_STATE(2735)] = 47532,
  [SMALL_STATE(2736)] = 47597,
  [SMALL_STATE(2737)] = 47664,
  [SMALL_STATE(2738)] = 47729,
  [SMALL_STATE(2739)] = 47818,
  [SMALL_STATE(2740)] = 47907,
  [SMALL_STATE(2741)] = 47996,
  [SMALL_STATE(2742)] = 48069,
  [SMALL_STATE(2743)] = 48130,
  [SMALL_STATE(2744)] = 48195,
  [SMALL_STATE(2745)] = 48288,
  [SMALL_STATE(2746)] = 48349,
  [SMALL_STATE(2747)] = 48436,
  [SMALL_STATE(2748)] = 48499,
  [SMALL_STATE(2749)] = 48562,
  [SMALL_STATE(2750)] = 48651,
  [SMALL_STATE(2751)] = 48740,
  [SMALL_STATE(2752)] = 48829,
  [SMALL_STATE(2753)] = 48922,
  [SMALL_STATE(2754)] = 49015,
  [SMALL_STATE(2755)] = 49110,
  [SMALL_STATE(2756)] = 49173,
  [SMALL_STATE(2757)] = 49264,
  [SMALL_STATE(2758)] = 49331,
  [SMALL_STATE(2759)] = 49398,
  [SMALL_STATE(2760)] = 49489,
  [SMALL_STATE(2761)] = 49572,
  [SMALL_STATE(2762)] = 49663,
  [SMALL_STATE(2763)] = 49756,
  [SMALL_STATE(2764)] = 49819,
  [SMALL_STATE(2765)] = 49908,
  [SMALL_STATE(2766)] = 49989,
  [SMALL_STATE(2767)] = 50078,
  [SMALL_STATE(2768)] = 50141,
  [SMALL_STATE(2769)] = 50204,
  [SMALL_STATE(2770)] = 50291,
  [SMALL_STATE(2771)] = 50382,
  [SMALL_STATE(2772)] = 50443,
  [SMALL_STATE(2773)] = 50506,
  [SMALL_STATE(2774)] = 50567,
  [SMALL_STATE(2775)] = 50658,
  [SMALL_STATE(2776)] = 50725,
  [SMALL_STATE(2777)] = 50816,
  [SMALL_STATE(2778)] = 50881,
  [SMALL_STATE(2779)] = 50970,
  [SMALL_STATE(2780)] = 51063,
  [SMALL_STATE(2781)] = 51130,
  [SMALL_STATE(2782)] = 51219,
  [SMALL_STATE(2783)] = 51280,
  [SMALL_STATE(2784)] = 51371,
  [SMALL_STATE(2785)] = 51429,
  [SMALL_STATE(2786)] = 51527,
  [SMALL_STATE(2787)] = 51589,
  [SMALL_STATE(2788)] = 51649,
  [SMALL_STATE(2789)] = 51715,
  [SMALL_STATE(2790)] = 51795,
  [SMALL_STATE(2791)] = 51885,
  [SMALL_STATE(2792)] = 51943,
  [SMALL_STATE(2793)] = 52003,
  [SMALL_STATE(2794)] = 52097,
  [SMALL_STATE(2795)] = 52191,
  [SMALL_STATE(2796)] = 52251,
  [SMALL_STATE(2797)] = 52311,
  [SMALL_STATE(2798)] = 52373,
  [SMALL_STATE(2799)] = 52431,
  [SMALL_STATE(2800)] = 52489,
  [SMALL_STATE(2801)] = 52549,
  [SMALL_STATE(2802)] = 52617,
  [SMALL_STATE(2803)] = 52709,
  [SMALL_STATE(2804)] = 52773,
  [SMALL_STATE(2805)] = 52833,
  [SMALL_STATE(2806)] = 52905,
  [SMALL_STATE(2807)] = 52993,
  [SMALL_STATE(2808)] = 53059,
  [SMALL_STATE(2809)] = 53119,
  [SMALL_STATE(2810)] = 53177,
  [SMALL_STATE(2811)] = 53237,
  [SMALL_STATE(2812)] = 53297,
  [SMALL_STATE(2813)] = 53357,
  [SMALL_STATE(2814)] = 53449,
  [SMALL_STATE(2815)] = 53539,
  [SMALL_STATE(2816)] = 53601,
  [SMALL_STATE(2817)] = 53697,
  [SMALL_STATE(2818)] = 53785,
  [SMALL_STATE(2819)] = 53875,
  [SMALL_STATE(2820)] = 53965,
  [SMALL_STATE(2821)] = 54033,
  [SMALL_STATE(2822)] = 54095,
  [SMALL_STATE(2823)] = 54155,
  [SMALL_STATE(2824)] = 54215,
  [SMALL_STATE(2825)] = 54273,
  [SMALL_STATE(2826)] = 54361,
  [SMALL_STATE(2827)] = 54443,
  [SMALL_STATE(2828)] = 54501,
  [SMALL_STATE(2829)] = 54591,
  [SMALL_STATE(2830)] = 54671,
  [SMALL_STATE(2831)] = 54737,
  [SMALL_STATE(2832)] = 54794,
  [SMALL_STATE(2833)] = 54851,
  [SMALL_STATE(2834)] = 54908,
  [SMALL_STATE(2835)] = 54965,
  [SMALL_STATE(2836)] = 55030,
  [SMALL_STATE(2837)] = 55095,
  [SMALL_STATE(2838)] = 55152,
  [SMALL_STATE(2839)] = 55209,
  [SMALL_STATE(2840)] = 55266,
  [SMALL_STATE(2841)] = 55323,
  [SMALL_STATE(2842)] = 55380,
  [SMALL_STATE(2843)] = 55437,
  [SMALL_STATE(2844)] = 55494,
  [SMALL_STATE(2845)] = 55551,
  [SMALL_STATE(2846)] = 55608,
  [SMALL_STATE(2847)] = 55665,
  [SMALL_STATE(2848)] = 55722,
  [SMALL_STATE(2849)] = 55779,
  [SMALL_STATE(2850)] = 55872,
  [SMALL_STATE(2851)] = 55951,
  [SMALL_STATE(2852)] = 56018,
  [SMALL_STATE(2853)] = 56107,
  [SMALL_STATE(2854)] = 56172,
  [SMALL_STATE(2855)] = 56229,
  [SMALL_STATE(2856)] = 56286,
  [SMALL_STATE(2857)] = 56373,
  [SMALL_STATE(2858)] = 56430,
  [SMALL_STATE(2859)] = 56523,
  [SMALL_STATE(2860)] = 56616,
  [SMALL_STATE(2861)] = 56673,
  [SMALL_STATE(2862)] = 56762,
  [SMALL_STATE(2863)] = 56819,
  [SMALL_STATE(2864)] = 56908,
  [SMALL_STATE(2865)] = 56965,
  [SMALL_STATE(2866)] = 57022,
  [SMALL_STATE(2867)] = 57079,
  [SMALL_STATE(2868)] = 57136,
  [SMALL_STATE(2869)] = 57195,
  [SMALL_STATE(2870)] = 57252,
  [SMALL_STATE(2871)] = 57309,
  [SMALL_STATE(2872)] = 57366,
  [SMALL_STATE(2873)] = 57423,
  [SMALL_STATE(2874)] = 57480,
  [SMALL_STATE(2875)] = 57537,
  [SMALL_STATE(2876)] = 57594,
  [SMALL_STATE(2877)] = 57651,
  [SMALL_STATE(2878)] = 57708,
  [SMALL_STATE(2879)] = 57765,
  [SMALL_STATE(2880)] = 57822,
  [SMALL_STATE(2881)] = 57879,
  [SMALL_STATE(2882)] = 57936,
  [SMALL_STATE(2883)] = 57993,
  [SMALL_STATE(2884)] = 58050,
  [SMALL_STATE(2885)] = 58107,
  [SMALL_STATE(2886)] = 58164,
  [SMALL_STATE(2887)] = 58221,
  [SMALL_STATE(2888)] = 58278,
  [SMALL_STATE(2889)] = 58335,
  [SMALL_STATE(2890)] = 58392,
  [SMALL_STATE(2891)] = 58449,
  [SMALL_STATE(2892)] = 58536,
  [SMALL_STATE(2893)] = 58625,
  [SMALL_STATE(2894)] = 58682,
  [SMALL_STATE(2895)] = 58739,
  [SMALL_STATE(2896)] = 58796,
  [SMALL_STATE(2897)] = 58853,
  [SMALL_STATE(2898)] = 58948,
  [SMALL_STATE(2899)] = 59039,
  [SMALL_STATE(2900)] = 59096,
  [SMALL_STATE(2901)] = 59153,
  [SMALL_STATE(2902)] = 59210,
  [SMALL_STATE(2903)] = 59267,
  [SMALL_STATE(2904)] = 59324,
  [SMALL_STATE(2905)] = 59381,
  [SMALL_STATE(2906)] = 59438,
  [SMALL_STATE(2907)] = 59495,
  [SMALL_STATE(2908)] = 59552,
  [SMALL_STATE(2909)] = 59609,
  [SMALL_STATE(2910)] = 59666,
  [SMALL_STATE(2911)] = 59723,
  [SMALL_STATE(2912)] = 59812,
  [SMALL_STATE(2913)] = 59901,
  [SMALL_STATE(2914)] = 59988,
  [SMALL_STATE(2915)] = 60077,
  [SMALL_STATE(2916)] = 60166,
  [SMALL_STATE(2917)] = 60223,
  [SMALL_STATE(2918)] = 60314,
  [SMALL_STATE(2919)] = 60401,
  [SMALL_STATE(2920)] = 60490,
  [SMALL_STATE(2921)] = 60581,
  [SMALL_STATE(2922)] = 60638,
  [SMALL_STATE(2923)] = 60695,
  [SMALL_STATE(2924)] = 60752,
  [SMALL_STATE(2925)] = 60809,
  [SMALL_STATE(2926)] = 60866,
  [SMALL_STATE(2927)] = 60923,
  [SMALL_STATE(2928)] = 60980,
  [SMALL_STATE(2929)] = 61047,
  [SMALL_STATE(2930)] = 61104,
  [SMALL_STATE(2931)] = 61169,
  [SMALL_STATE(2932)] = 61226,
  [SMALL_STATE(2933)] = 61283,
  [SMALL_STATE(2934)] = 61340,
  [SMALL_STATE(2935)] = 61401,
  [SMALL_STATE(2936)] = 61458,
  [SMALL_STATE(2937)] = 61551,
  [SMALL_STATE(2938)] = 61608,
  [SMALL_STATE(2939)] = 61665,
  [SMALL_STATE(2940)] = 61722,
  [SMALL_STATE(2941)] = 61779,
  [SMALL_STATE(2942)] = 61836,
  [SMALL_STATE(2943)] = 61925,
  [SMALL_STATE(2944)] = 61982,
  [SMALL_STATE(2945)] = 62039,
  [SMALL_STATE(2946)] = 62128,
  [SMALL_STATE(2947)] = 62185,
  [SMALL_STATE(2948)] = 62242,
  [SMALL_STATE(2949)] = 62299,
  [SMALL_STATE(2950)] = 62356,
  [SMALL_STATE(2951)] = 62413,
  [SMALL_STATE(2952)] = 62470,
  [SMALL_STATE(2953)] = 62527,
  [SMALL_STATE(2954)] = 62584,
  [SMALL_STATE(2955)] = 62641,
  [SMALL_STATE(2956)] = 62698,
  [SMALL_STATE(2957)] = 62755,
  [SMALL_STATE(2958)] = 62812,
  [SMALL_STATE(2959)] = 62869,
  [SMALL_STATE(2960)] = 62926,
  [SMALL_STATE(2961)] = 62983,
  [SMALL_STATE(2962)] = 63040,
  [SMALL_STATE(2963)] = 63097,
  [SMALL_STATE(2964)] = 63154,
  [SMALL_STATE(2965)] = 63217,
  [SMALL_STATE(2966)] = 63274,
  [SMALL_STATE(2967)] = 63333,
  [SMALL_STATE(2968)] = 63390,
  [SMALL_STATE(2969)] = 63447,
  [SMALL_STATE(2970)] = 63504,
  [SMALL_STATE(2971)] = 63565,
  [SMALL_STATE(2972)] = 63622,
  [SMALL_STATE(2973)] = 63679,
  [SMALL_STATE(2974)] = 63736,
  [SMALL_STATE(2975)] = 63793,
  [SMALL_STATE(2976)] = 63850,
  [SMALL_STATE(2977)] = 63907,
  [SMALL_STATE(2978)] = 63964,
  [SMALL_STATE(2979)] = 64023,
  [SMALL_STATE(2980)] = 64082,
  [SMALL_STATE(2981)] = 64143,
  [SMALL_STATE(2982)] = 64202,
  [SMALL_STATE(2983)] = 64261,
  [SMALL_STATE(2984)] = 64328,
  [SMALL_STATE(2985)] = 64393,
  [SMALL_STATE(2986)] = 64464,
  [SMALL_STATE(2987)] = 64545,
  [SMALL_STATE(2988)] = 64624,
  [SMALL_STATE(2989)] = 64687,
  [SMALL_STATE(2990)] = 64766,
  [SMALL_STATE(2991)] = 64825,
  [SMALL_STATE(2992)] = 64914,
  [SMALL_STATE(2993)] = 64971,
  [SMALL_STATE(2994)] = 65028,
  [SMALL_STATE(2995)] = 65085,
  [SMALL_STATE(2996)] = 65144,
  [SMALL_STATE(2997)] = 65201,
  [SMALL_STATE(2998)] = 65290,
  [SMALL_STATE(2999)] = 65379,
  [SMALL_STATE(3000)] = 65436,
  [SMALL_STATE(3001)] = 65493,
  [SMALL_STATE(3002)] = 65550,
  [SMALL_STATE(3003)] = 65607,
  [SMALL_STATE(3004)] = 65664,
  [SMALL_STATE(3005)] = 65721,
  [SMALL_STATE(3006)] = 65778,
  [SMALL_STATE(3007)] = 65835,
  [SMALL_STATE(3008)] = 65892,
  [SMALL_STATE(3009)] = 65949,
  [SMALL_STATE(3010)] = 66006,
  [SMALL_STATE(3011)] = 66063,
  [SMALL_STATE(3012)] = 66120,
  [SMALL_STATE(3013)] = 66177,
  [SMALL_STATE(3014)] = 66240,
  [SMALL_STATE(3015)] = 66297,
  [SMALL_STATE(3016)] = 66354,
  [SMALL_STATE(3017)] = 66411,
  [SMALL_STATE(3018)] = 66472,
  [SMALL_STATE(3019)] = 66531,
  [SMALL_STATE(3020)] = 66588,
  [SMALL_STATE(3021)] = 66647,
  [SMALL_STATE(3022)] = 66714,
  [SMALL_STATE(3023)] = 66771,
  [SMALL_STATE(3024)] = 66828,
  [SMALL_STATE(3025)] = 66893,
  [SMALL_STATE(3026)] = 66950,
  [SMALL_STATE(3027)] = 67007,
  [SMALL_STATE(3028)] = 67064,
  [SMALL_STATE(3029)] = 67135,
  [SMALL_STATE(3030)] = 67192,
  [SMALL_STATE(3031)] = 67249,
  [SMALL_STATE(3032)] = 67306,
  [SMALL_STATE(3033)] = 67363,
  [SMALL_STATE(3034)] = 67444,
  [SMALL_STATE(3035)] = 67523,
  [SMALL_STATE(3036)] = 67580,
  [SMALL_STATE(3037)] = 67637,
  [SMALL_STATE(3038)] = 67729,
  [SMALL_STATE(3039)] = 67809,
  [SMALL_STATE(3040)] = 67887,
  [SMALL_STATE(3041)] = 67949,
  [SMALL_STATE(3042)] = 68027,
  [SMALL_STATE(3043)] = 68085,
  [SMALL_STATE(3044)] = 68173,
  [SMALL_STATE(3045)] = 68261,
  [SMALL_STATE(3046)] = 68323,
  [SMALL_STATE(3047)] = 68381,
  [SMALL_STATE(3048)] = 68467,
  [SMALL_STATE(3049)] = 68555,
  [SMALL_STATE(3050)] = 68617,
  [SMALL_STATE(3051)] = 68707,
  [SMALL_STATE(3052)] = 68795,
  [SMALL_STATE(3053)] = 68851,
  [SMALL_STATE(3054)] = 68909,
  [SMALL_STATE(3055)] = 68965,
  [SMALL_STATE(3056)] = 69023,
  [SMALL_STATE(3057)] = 69079,
  [SMALL_STATE(3058)] = 69149,
  [SMALL_STATE(3059)] = 69207,
  [SMALL_STATE(3060)] = 69267,
  [SMALL_STATE(3061)] = 69331,
  [SMALL_STATE(3062)] = 69389,
  [SMALL_STATE(3063)] = 69477,
  [SMALL_STATE(3064)] = 69541,
  [SMALL_STATE(3065)] = 69599,
  [SMALL_STATE(3066)] = 69657,
  [SMALL_STATE(3067)] = 69749,
  [SMALL_STATE(3068)] = 69845,
  [SMALL_STATE(3069)] = 69907,
  [SMALL_STATE(3070)] = 69963,
  [SMALL_STATE(3071)] = 70021,
  [SMALL_STATE(3072)] = 70079,
  [SMALL_STATE(3073)] = 70139,
  [SMALL_STATE(3074)] = 70237,
  [SMALL_STATE(3075)] = 70295,
  [SMALL_STATE(3076)] = 70353,
  [SMALL_STATE(3077)] = 70413,
  [SMALL_STATE(3078)] = 70499,
  [SMALL_STATE(3079)] = 70557,
  [SMALL_STATE(3080)] = 70623,
  [SMALL_STATE(3081)] = 70717,
  [SMALL_STATE(3082)] = 70807,
  [SMALL_STATE(3083)] = 70871,
  [SMALL_STATE(3084)] = 70937,
  [SMALL_STATE(3085)] = 71000,
  [SMALL_STATE(3086)] = 71071,
  [SMALL_STATE(3087)] = 71130,
  [SMALL_STATE(3088)] = 71187,
  [SMALL_STATE(3089)] = 71274,
  [SMALL_STATE(3090)] = 71331,
  [SMALL_STATE(3091)] = 71402,
  [SMALL_STATE(3092)] = 71475,
  [SMALL_STATE(3093)] = 71532,
  [SMALL_STATE(3094)] = 71603,
  [SMALL_STATE(3095)] = 71674,
  [SMALL_STATE(3096)] = 71731,
  [SMALL_STATE(3097)] = 71790,
  [SMALL_STATE(3098)] = 71877,
  [SMALL_STATE(3099)] = 71948,
  [SMALL_STATE(3100)] = 72005,
  [SMALL_STATE(3101)] = 72096,
  [SMALL_STATE(3102)] = 72159,
  [SMALL_STATE(3103)] = 72232,
  [SMALL_STATE(3104)] = 72289,
  [SMALL_STATE(3105)] = 72376,
  [SMALL_STATE(3106)] = 72441,
  [SMALL_STATE(3107)] = 72526,
  [SMALL_STATE(3108)] = 72617,
  [SMALL_STATE(3109)] = 72678,
  [SMALL_STATE(3110)] = 72751,
  [SMALL_STATE(3111)] = 72820,
  [SMALL_STATE(3112)] = 72905,
  [SMALL_STATE(3113)] = 72978,
  [SMALL_STATE(3114)] = 73035,
  [SMALL_STATE(3115)] = 73122,
  [SMALL_STATE(3116)] = 73195,
  [SMALL_STATE(3117)] = 73286,
  [SMALL_STATE(3118)] = 73379,
  [SMALL_STATE(3119)] = 73466,
  [SMALL_STATE(3120)] = 73557,
  [SMALL_STATE(3121)] = 73628,
  [SMALL_STATE(3122)] = 73701,
  [SMALL_STATE(3123)] = 73772,
  [SMALL_STATE(3124)] = 73831,
  [SMALL_STATE(3125)] = 73904,
  [SMALL_STATE(3126)] = 73991,
  [SMALL_STATE(3127)] = 74062,
  [SMALL_STATE(3128)] = 74133,
  [SMALL_STATE(3129)] = 74222,
  [SMALL_STATE(3130)] = 74295,
  [SMALL_STATE(3131)] = 74368,
  [SMALL_STATE(3132)] = 74431,
  [SMALL_STATE(3133)] = 74522,
  [SMALL_STATE(3134)] = 74601,
  [SMALL_STATE(3135)] = 74674,
  [SMALL_STATE(3136)] = 74747,
  [SMALL_STATE(3137)] = 74838,
  [SMALL_STATE(3138)] = 74927,
  [SMALL_STATE(3139)] = 74984,
  [SMALL_STATE(3140)] = 75061,
  [SMALL_STATE(3141)] = 75132,
  [SMALL_STATE(3142)] = 75195,
  [SMALL_STATE(3143)] = 75268,
  [SMALL_STATE(3144)] = 75341,
  [SMALL_STATE(3145)] = 75402,
  [SMALL_STATE(3146)] = 75465,
  [SMALL_STATE(3147)] = 75552,
  [SMALL_STATE(3148)] = 75639,
  [SMALL_STATE(3149)] = 75728,
  [SMALL_STATE(3150)] = 75801,
  [SMALL_STATE(3151)] = 75874,
  [SMALL_STATE(3152)] = 75931,
  [SMALL_STATE(3153)] = 75990,
  [SMALL_STATE(3154)] = 76067,
  [SMALL_STATE(3155)] = 76154,
  [SMALL_STATE(3156)] = 76245,
  [SMALL_STATE(3157)] = 76302,
  [SMALL_STATE(3158)] = 76389,
  [SMALL_STATE(3159)] = 76462,
  [SMALL_STATE(3160)] = 76553,
  [SMALL_STATE(3161)] = 76624,
  [SMALL_STATE(3162)] = 76697,
  [SMALL_STATE(3163)] = 76784,
  [SMALL_STATE(3164)] = 76841,
  [SMALL_STATE(3165)] = 76912,
  [SMALL_STATE(3166)] = 76999,
  [SMALL_STATE(3167)] = 77055,
  [SMALL_STATE(3168)] = 77145,
  [SMALL_STATE(3169)] = 77201,
  [SMALL_STATE(3170)] = 77257,
  [SMALL_STATE(3171)] = 77313,
  [SMALL_STATE(3172)] = 77403,
  [SMALL_STATE(3173)] = 77491,
  [SMALL_STATE(3174)] = 77547,
  [SMALL_STATE(3175)] = 77603,
  [SMALL_STATE(3176)] = 77689,
  [SMALL_STATE(3177)] = 77775,
  [SMALL_STATE(3178)] = 77859,
  [SMALL_STATE(3179)] = 77945,
  [SMALL_STATE(3180)] = 78031,
  [SMALL_STATE(3181)] = 78119,
  [SMALL_STATE(3182)] = 78205,
  [SMALL_STATE(3183)] = 78263,
  [SMALL_STATE(3184)] = 78319,
  [SMALL_STATE(3185)] = 78375,
  [SMALL_STATE(3186)] = 78439,
  [SMALL_STATE(3187)] = 78523,
  [SMALL_STATE(3188)] = 78585,
  [SMALL_STATE(3189)] = 78653,
  [SMALL_STATE(3190)] = 78739,
  [SMALL_STATE(3191)] = 78817,
  [SMALL_STATE(3192)] = 78893,
  [SMALL_STATE(3193)] = 78953,
  [SMALL_STATE(3194)] = 79029,
  [SMALL_STATE(3195)] = 79115,
  [SMALL_STATE(3196)] = 79201,
  [SMALL_STATE(3197)] = 79285,
  [SMALL_STATE(3198)] = 79371,
  [SMALL_STATE(3199)] = 79457,
  [SMALL_STATE(3200)] = 79513,
  [SMALL_STATE(3201)] = 79567,
  [SMALL_STATE(3202)] = 79623,
  [SMALL_STATE(3203)] = 79677,
  [SMALL_STATE(3204)] = 79765,
  [SMALL_STATE(3205)] = 79857,
  [SMALL_STATE(3206)] = 79913,
  [SMALL_STATE(3207)] = 79967,
  [SMALL_STATE(3208)] = 80021,
  [SMALL_STATE(3209)] = 80109,
  [SMALL_STATE(3210)] = 80163,
  [SMALL_STATE(3211)] = 80221,
  [SMALL_STATE(3212)] = 80277,
  [SMALL_STATE(3213)] = 80361,
  [SMALL_STATE(3214)] = 80447,
  [SMALL_STATE(3215)] = 80501,
  [SMALL_STATE(3216)] = 80555,
  [SMALL_STATE(3217)] = 80609,
  [SMALL_STATE(3218)] = 80695,
  [SMALL_STATE(3219)] = 80751,
  [SMALL_STATE(3220)] = 80841,
  [SMALL_STATE(3221)] = 80897,
  [SMALL_STATE(3222)] = 80953,
  [SMALL_STATE(3223)] = 81009,
  [SMALL_STATE(3224)] = 81101,
  [SMALL_STATE(3225)] = 81191,
  [SMALL_STATE(3226)] = 81247,
  [SMALL_STATE(3227)] = 81333,
  [SMALL_STATE(3228)] = 81419,
  [SMALL_STATE(3229)] = 81475,
  [SMALL_STATE(3230)] = 81531,
  [SMALL_STATE(3231)] = 81625,
  [SMALL_STATE(3232)] = 81713,
  [SMALL_STATE(3233)] = 81769,
  [SMALL_STATE(3234)] = 81825,
  [SMALL_STATE(3235)] = 81881,
  [SMALL_STATE(3236)] = 81965,
  [SMALL_STATE(3237)] = 82055,
  [SMALL_STATE(3238)] = 82113,
  [SMALL_STATE(3239)] = 82169,
  [SMALL_STATE(3240)] = 82225,
  [SMALL_STATE(3241)] = 82289,
  [SMALL_STATE(3242)] = 82351,
  [SMALL_STATE(3243)] = 82419,
  [SMALL_STATE(3244)] = 82497,
  [SMALL_STATE(3245)] = 82573,
  [SMALL_STATE(3246)] = 82633,
  [SMALL_STATE(3247)] = 82709,
  [SMALL_STATE(3248)] = 82765,
  [SMALL_STATE(3249)] = 82853,
  [SMALL_STATE(3250)] = 82911,
  [SMALL_STATE(3251)] = 82971,
  [SMALL_STATE(3252)] = 83057,
  [SMALL_STATE(3253)] = 83143,
  [SMALL_STATE(3254)] = 83199,
  [SMALL_STATE(3255)] = 83255,
  [SMALL_STATE(3256)] = 83311,
  [SMALL_STATE(3257)] = 83369,
  [SMALL_STATE(3258)] = 83427,
  [SMALL_STATE(3259)] = 83489,
  [SMALL_STATE(3260)] = 83577,
  [SMALL_STATE(3261)] = 83639,
  [SMALL_STATE(3262)] = 83695,
  [SMALL_STATE(3263)] = 83779,
  [SMALL_STATE(3264)] = 83837,
  [SMALL_STATE(3265)] = 83893,
  [SMALL_STATE(3266)] = 83949,
  [SMALL_STATE(3267)] = 84013,
  [SMALL_STATE(3268)] = 84075,
  [SMALL_STATE(3269)] = 84143,
  [SMALL_STATE(3270)] = 84221,
  [SMALL_STATE(3271)] = 84297,
  [SMALL_STATE(3272)] = 84357,
  [SMALL_STATE(3273)] = 84433,
  [SMALL_STATE(3274)] = 84521,
  [SMALL_STATE(3275)] = 84583,
  [SMALL_STATE(3276)] = 84639,
  [SMALL_STATE(3277)] = 84723,
  [SMALL_STATE(3278)] = 84809,
  [SMALL_STATE(3279)] = 84867,
  [SMALL_STATE(3280)] = 84923,
  [SMALL_STATE(3281)] = 84979,
  [SMALL_STATE(3282)] = 85043,
  [SMALL_STATE(3283)] = 85105,
  [SMALL_STATE(3284)] = 85173,
  [SMALL_STATE(3285)] = 85251,
  [SMALL_STATE(3286)] = 85327,
  [SMALL_STATE(3287)] = 85387,
  [SMALL_STATE(3288)] = 85463,
  [SMALL_STATE(3289)] = 85519,
  [SMALL_STATE(3290)] = 85573,
  [SMALL_STATE(3291)] = 85627,
  [SMALL_STATE(3292)] = 85681,
  [SMALL_STATE(3293)] = 85767,
  [SMALL_STATE(3294)] = 85853,
  [SMALL_STATE(3295)] = 85939,
  [SMALL_STATE(3296)] = 86023,
  [SMALL_STATE(3297)] = 86109,
  [SMALL_STATE(3298)] = 86195,
  [SMALL_STATE(3299)] = 86251,
  [SMALL_STATE(3300)] = 86339,
  [SMALL_STATE(3301)] = 86425,
  [SMALL_STATE(3302)] = 86517,
  [SMALL_STATE(3303)] = 86605,
  [SMALL_STATE(3304)] = 86691,
  [SMALL_STATE(3305)] = 86777,
  [SMALL_STATE(3306)] = 86833,
  [SMALL_STATE(3307)] = 86919,
  [SMALL_STATE(3308)] = 87002,
  [SMALL_STATE(3309)] = 87087,
  [SMALL_STATE(3310)] = 87170,
  [SMALL_STATE(3311)] = 87225,
  [SMALL_STATE(3312)] = 87318,
  [SMALL_STATE(3313)] = 87411,
  [SMALL_STATE(3314)] = 87466,
  [SMALL_STATE(3315)] = 87551,
  [SMALL_STATE(3316)] = 87606,
  [SMALL_STATE(3317)] = 87689,
  [SMALL_STATE(3318)] = 87782,
  [SMALL_STATE(3319)] = 87867,
  [SMALL_STATE(3320)] = 87932,
  [SMALL_STATE(3321)] = 87985,
  [SMALL_STATE(3322)] = 88070,
  [SMALL_STATE(3323)] = 88157,
  [SMALL_STATE(3324)] = 88250,
  [SMALL_STATE(3325)] = 88307,
  [SMALL_STATE(3326)] = 88390,
  [SMALL_STATE(3327)] = 88445,
  [SMALL_STATE(3328)] = 88528,
  [SMALL_STATE(3329)] = 88613,
  [SMALL_STATE(3330)] = 88698,
  [SMALL_STATE(3331)] = 88755,
  [SMALL_STATE(3332)] = 88810,
  [SMALL_STATE(3333)] = 88865,
  [SMALL_STATE(3334)] = 88928,
  [SMALL_STATE(3335)] = 88989,
  [SMALL_STATE(3336)] = 89056,
  [SMALL_STATE(3337)] = 89133,
  [SMALL_STATE(3338)] = 89208,
  [SMALL_STATE(3339)] = 89267,
  [SMALL_STATE(3340)] = 89342,
  [SMALL_STATE(3341)] = 89397,
  [SMALL_STATE(3342)] = 89456,
  [SMALL_STATE(3343)] = 89509,
  [SMALL_STATE(3344)] = 89562,
  [SMALL_STATE(3345)] = 89647,
  [SMALL_STATE(3346)] = 89702,
  [SMALL_STATE(3347)] = 89787,
  [SMALL_STATE(3348)] = 89840,
  [SMALL_STATE(3349)] = 89933,
  [SMALL_STATE(3350)] = 90018,
  [SMALL_STATE(3351)] = 90103,
  [SMALL_STATE(3352)] = 90156,
  [SMALL_STATE(3353)] = 90209,
  [SMALL_STATE(3354)] = 90262,
  [SMALL_STATE(3355)] = 90347,
  [SMALL_STATE(3356)] = 90402,
  [SMALL_STATE(3357)] = 90457,
  [SMALL_STATE(3358)] = 90514,
  [SMALL_STATE(3359)] = 90569,
  [SMALL_STATE(3360)] = 90624,
  [SMALL_STATE(3361)] = 90685,
  [SMALL_STATE(3362)] = 90740,
  [SMALL_STATE(3363)] = 90825,
  [SMALL_STATE(3364)] = 90882,
  [SMALL_STATE(3365)] = 90963,
  [SMALL_STATE(3366)] = 91046,
  [SMALL_STATE(3367)] = 91131,
  [SMALL_STATE(3368)] = 91214,
  [SMALL_STATE(3369)] = 91297,
  [SMALL_STATE(3370)] = 91352,
  [SMALL_STATE(3371)] = 91433,
  [SMALL_STATE(3372)] = 91520,
  [SMALL_STATE(3373)] = 91607,
  [SMALL_STATE(3374)] = 91670,
  [SMALL_STATE(3375)] = 91731,
  [SMALL_STATE(3376)] = 91818,
  [SMALL_STATE(3377)] = 91885,
  [SMALL_STATE(3378)] = 91962,
  [SMALL_STATE(3379)] = 92017,
  [SMALL_STATE(3380)] = 92074,
  [SMALL_STATE(3381)] = 92129,
  [SMALL_STATE(3382)] = 92184,
  [SMALL_STATE(3383)] = 92247,
  [SMALL_STATE(3384)] = 92308,
  [SMALL_STATE(3385)] = 92375,
  [SMALL_STATE(3386)] = 92452,
  [SMALL_STATE(3387)] = 92527,
  [SMALL_STATE(3388)] = 92586,
  [SMALL_STATE(3389)] = 92661,
  [SMALL_STATE(3390)] = 92716,
  [SMALL_STATE(3391)] = 92791,
  [SMALL_STATE(3392)] = 92850,
  [SMALL_STATE(3393)] = 92925,
  [SMALL_STATE(3394)] = 93012,
  [SMALL_STATE(3395)] = 93067,
  [SMALL_STATE(3396)] = 93152,
  [SMALL_STATE(3397)] = 93237,
  [SMALL_STATE(3398)] = 93320,
  [SMALL_STATE(3399)] = 93405,
  [SMALL_STATE(3400)] = 93490,
  [SMALL_STATE(3401)] = 93573,
  [SMALL_STATE(3402)] = 93658,
  [SMALL_STATE(3403)] = 93743,
  [SMALL_STATE(3404)] = 93828,
  [SMALL_STATE(3405)] = 93883,
  [SMALL_STATE(3406)] = 93970,
  [SMALL_STATE(3407)] = 94059,
  [SMALL_STATE(3408)] = 94118,
  [SMALL_STATE(3409)] = 94173,
  [SMALL_STATE(3410)] = 94238,
  [SMALL_STATE(3411)] = 94303,
  [SMALL_STATE(3412)] = 94386,
  [SMALL_STATE(3413)] = 94452,
  [SMALL_STATE(3414)] = 94538,
  [SMALL_STATE(3415)] = 94590,
  [SMALL_STATE(3416)] = 94644,
  [SMALL_STATE(3417)] = 94696,
  [SMALL_STATE(3418)] = 94786,
  [SMALL_STATE(3419)] = 94870,
  [SMALL_STATE(3420)] = 94954,
  [SMALL_STATE(3421)] = 95044,
  [SMALL_STATE(3422)] = 95104,
  [SMALL_STATE(3423)] = 95162,
  [SMALL_STATE(3424)] = 95250,
  [SMALL_STATE(3425)] = 95306,
  [SMALL_STATE(3426)] = 95364,
  [SMALL_STATE(3427)] = 95418,
  [SMALL_STATE(3428)] = 95500,
  [SMALL_STATE(3429)] = 95556,
  [SMALL_STATE(3430)] = 95610,
  [SMALL_STATE(3431)] = 95664,
  [SMALL_STATE(3432)] = 95726,
  [SMALL_STATE(3433)] = 95786,
  [SMALL_STATE(3434)] = 95852,
  [SMALL_STATE(3435)] = 95928,
  [SMALL_STATE(3436)] = 96002,
  [SMALL_STATE(3437)] = 96060,
  [SMALL_STATE(3438)] = 96134,
  [SMALL_STATE(3439)] = 96188,
  [SMALL_STATE(3440)] = 96274,
  [SMALL_STATE(3441)] = 96364,
  [SMALL_STATE(3442)] = 96448,
  [SMALL_STATE(3443)] = 96504,
  [SMALL_STATE(3444)] = 96558,
  [SMALL_STATE(3445)] = 96612,
  [SMALL_STATE(3446)] = 96674,
  [SMALL_STATE(3447)] = 96734,
  [SMALL_STATE(3448)] = 96818,
  [SMALL_STATE(3449)] = 96904,
  [SMALL_STATE(3450)] = 96978,
  [SMALL_STATE(3451)] = 97036,
  [SMALL_STATE(3452)] = 97110,
  [SMALL_STATE(3453)] = 97164,
  [SMALL_STATE(3454)] = 97254,
  [SMALL_STATE(3455)] = 97312,
  [SMALL_STATE(3456)] = 97366,
  [SMALL_STATE(3457)] = 97420,
  [SMALL_STATE(3458)] = 97474,
  [SMALL_STATE(3459)] = 97556,
  [SMALL_STATE(3460)] = 97638,
  [SMALL_STATE(3461)] = 97718,
  [SMALL_STATE(3462)] = 97800,
  [SMALL_STATE(3463)] = 97884,
  [SMALL_STATE(3464)] = 97966,
  [SMALL_STATE(3465)] = 98048,
  [SMALL_STATE(3466)] = 98104,
  [SMALL_STATE(3467)] = 98190,
  [SMALL_STATE(3468)] = 98274,
  [SMALL_STATE(3469)] = 98358,
  [SMALL_STATE(3470)] = 98440,
  [SMALL_STATE(3471)] = 98524,
  [SMALL_STATE(3472)] = 98608,
  [SMALL_STATE(3473)] = 98696,
  [SMALL_STATE(3474)] = 98782,
  [SMALL_STATE(3475)] = 98836,
  [SMALL_STATE(3476)] = 98916,
  [SMALL_STATE(3477)] = 99002,
  [SMALL_STATE(3478)] = 99088,
  [SMALL_STATE(3479)] = 99164,
  [SMALL_STATE(3480)] = 99217,
  [SMALL_STATE(3481)] = 99270,
  [SMALL_STATE(3482)] = 99323,
  [SMALL_STATE(3483)] = 99376,
  [SMALL_STATE(3484)] = 99435,
  [SMALL_STATE(3485)] = 99490,
  [SMALL_STATE(3486)] = 99573,
  [SMALL_STATE(3487)] = 99656,
  [SMALL_STATE(3488)] = 99739,
  [SMALL_STATE(3489)] = 99800,
  [SMALL_STATE(3490)] = 99859,
  [SMALL_STATE(3491)] = 99912,
  [SMALL_STATE(3492)] = 99993,
  [SMALL_STATE(3493)] = 100058,
  [SMALL_STATE(3494)] = 100111,
  [SMALL_STATE(3495)] = 100186,
  [SMALL_STATE(3496)] = 100241,
  [SMALL_STATE(3497)] = 100314,
  [SMALL_STATE(3498)] = 100371,
  [SMALL_STATE(3499)] = 100460,
  [SMALL_STATE(3500)] = 100513,
  [SMALL_STATE(3501)] = 100586,
  [SMALL_STATE(3502)] = 100639,
  [SMALL_STATE(3503)] = 100692,
  [SMALL_STATE(3504)] = 100745,
  [SMALL_STATE(3505)] = 100798,
  [SMALL_STATE(3506)] = 100851,
  [SMALL_STATE(3507)] = 100938,
  [SMALL_STATE(3508)] = 101027,
  [SMALL_STATE(3509)] = 101112,
  [SMALL_STATE(3510)] = 101197,
  [SMALL_STATE(3511)] = 101282,
  [SMALL_STATE(3512)] = 101335,
  [SMALL_STATE(3513)] = 101418,
  [SMALL_STATE(3514)] = 101473,
  [SMALL_STATE(3515)] = 101526,
  [SMALL_STATE(3516)] = 101579,
  [SMALL_STATE(3517)] = 101660,
  [SMALL_STATE(3518)] = 101741,
  [SMALL_STATE(3519)] = 101826,
  [SMALL_STATE(3520)] = 101907,
  [SMALL_STATE(3521)] = 101988,
  [SMALL_STATE(3522)] = 102043,
  [SMALL_STATE(3523)] = 102096,
  [SMALL_STATE(3524)] = 102179,
  [SMALL_STATE(3525)] = 102232,
  [SMALL_STATE(3526)] = 102317,
  [SMALL_STATE(3527)] = 102398,
  [SMALL_STATE(3528)] = 102481,
  [SMALL_STATE(3529)] = 102536,
  [SMALL_STATE(3530)] = 102591,
  [SMALL_STATE(3531)] = 102644,
  [SMALL_STATE(3532)] = 102725,
  [SMALL_STATE(3533)] = 102810,
  [SMALL_STATE(3534)] = 102865,
  [SMALL_STATE(3535)] = 102949,
  [SMALL_STATE(3536)] = 103003,
  [SMALL_STATE(3537)] = 103059,
  [SMALL_STATE(3538)] = 103113,
  [SMALL_STATE(3539)] = 103183,
  [SMALL_STATE(3540)] = 103265,
  [SMALL_STATE(3541)] = 103315,
  [SMALL_STATE(3542)] = 103371,
  [SMALL_STATE(3543)] = 103425,
  [SMALL_STATE(3544)] = 103505,
  [SMALL_STATE(3545)] = 103587,
  [SMALL_STATE(3546)] = 103661,
  [SMALL_STATE(3547)] = 103711,
  [SMALL_STATE(3548)] = 103763,
  [SMALL_STATE(3549)] = 103813,
  [SMALL_STATE(3550)] = 103863,
  [SMALL_STATE(3551)] = 103943,
  [SMALL_STATE(3552)] = 104023,
  [SMALL_STATE(3553)] = 104103,
  [SMALL_STATE(3554)] = 104183,
  [SMALL_STATE(3555)] = 104255,
  [SMALL_STATE(3556)] = 104333,
  [SMALL_STATE(3557)] = 104413,
  [SMALL_STATE(3558)] = 104465,
  [SMALL_STATE(3559)] = 104547,
  [SMALL_STATE(3560)] = 104599,
  [SMALL_STATE(3561)] = 104677,
  [SMALL_STATE(3562)] = 104727,
  [SMALL_STATE(3563)] = 104811,
  [SMALL_STATE(3564)] = 104863,
  [SMALL_STATE(3565)] = 104945,
  [SMALL_STATE(3566)] = 105029,
  [SMALL_STATE(3567)] = 105113,
  [SMALL_STATE(3568)] = 105197,
  [SMALL_STATE(3569)] = 105281,
  [SMALL_STATE(3570)] = 105363,
  [SMALL_STATE(3571)] = 105445,
  [SMALL_STATE(3572)] = 105497,
  [SMALL_STATE(3573)] = 105547,
  [SMALL_STATE(3574)] = 105625,
  [SMALL_STATE(3575)] = 105709,
  [SMALL_STATE(3576)] = 105763,
  [SMALL_STATE(3577)] = 105817,
  [SMALL_STATE(3578)] = 105869,
  [SMALL_STATE(3579)] = 105921,
  [SMALL_STATE(3580)] = 105981,
  [SMALL_STATE(3581)] = 106039,
  [SMALL_STATE(3582)] = 106121,
  [SMALL_STATE(3583)] = 106185,
  [SMALL_STATE(3584)] = 106259,
  [SMALL_STATE(3585)] = 106331,
  [SMALL_STATE(3586)] = 106387,
  [SMALL_STATE(3587)] = 106459,
  [SMALL_STATE(3588)] = 106511,
  [SMALL_STATE(3589)] = 106591,
  [SMALL_STATE(3590)] = 106671,
  [SMALL_STATE(3591)] = 106749,
  [SMALL_STATE(3592)] = 106829,
  [SMALL_STATE(3593)] = 106909,
  [SMALL_STATE(3594)] = 106989,
  [SMALL_STATE(3595)] = 107067,
  [SMALL_STATE(3596)] = 107147,
  [SMALL_STATE(3597)] = 107227,
  [SMALL_STATE(3598)] = 107279,
  [SMALL_STATE(3599)] = 107365,
  [SMALL_STATE(3600)] = 107445,
  [SMALL_STATE(3601)] = 107525,
  [SMALL_STATE(3602)] = 107579,
  [SMALL_STATE(3603)] = 107631,
  [SMALL_STATE(3604)] = 107683,
  [SMALL_STATE(3605)] = 107743,
  [SMALL_STATE(3606)] = 107795,
  [SMALL_STATE(3607)] = 107879,
  [SMALL_STATE(3608)] = 107959,
  [SMALL_STATE(3609)] = 108017,
  [SMALL_STATE(3610)] = 108081,
  [SMALL_STATE(3611)] = 108155,
  [SMALL_STATE(3612)] = 108209,
  [SMALL_STATE(3613)] = 108261,
  [SMALL_STATE(3614)] = 108313,
  [SMALL_STATE(3615)] = 108365,
  [SMALL_STATE(3616)] = 108421,
  [SMALL_STATE(3617)] = 108475,
  [SMALL_STATE(3618)] = 108535,
  [SMALL_STATE(3619)] = 108587,
  [SMALL_STATE(3620)] = 108645,
  [SMALL_STATE(3621)] = 108709,
  [SMALL_STATE(3622)] = 108761,
  [SMALL_STATE(3623)] = 108839,
  [SMALL_STATE(3624)] = 108911,
  [SMALL_STATE(3625)] = 108997,
  [SMALL_STATE(3626)] = 109071,
  [SMALL_STATE(3627)] = 109143,
  [SMALL_STATE(3628)] = 109199,
  [SMALL_STATE(3629)] = 109271,
  [SMALL_STATE(3630)] = 109327,
  [SMALL_STATE(3631)] = 109417,
  [SMALL_STATE(3632)] = 109497,
  [SMALL_STATE(3633)] = 109577,
  [SMALL_STATE(3634)] = 109659,
  [SMALL_STATE(3635)] = 109741,
  [SMALL_STATE(3636)] = 109821,
  [SMALL_STATE(3637)] = 109903,
  [SMALL_STATE(3638)] = 109985,
  [SMALL_STATE(3639)] = 110037,
  [SMALL_STATE(3640)] = 110089,
  [SMALL_STATE(3641)] = 110173,
  [SMALL_STATE(3642)] = 110227,
  [SMALL_STATE(3643)] = 110307,
  [SMALL_STATE(3644)] = 110387,
  [SMALL_STATE(3645)] = 110471,
  [SMALL_STATE(3646)] = 110543,
  [SMALL_STATE(3647)] = 110595,
  [SMALL_STATE(3648)] = 110677,
  [SMALL_STATE(3649)] = 110759,
  [SMALL_STATE(3650)] = 110839,
  [SMALL_STATE(3651)] = 110919,
  [SMALL_STATE(3652)] = 111001,
  [SMALL_STATE(3653)] = 111085,
  [SMALL_STATE(3654)] = 111169,
  [SMALL_STATE(3655)] = 111223,
  [SMALL_STATE(3656)] = 111275,
  [SMALL_STATE(3657)] = 111327,
  [SMALL_STATE(3658)] = 111409,
  [SMALL_STATE(3659)] = 111461,
  [SMALL_STATE(3660)] = 111545,
  [SMALL_STATE(3661)] = 111597,
  [SMALL_STATE(3662)] = 111657,
  [SMALL_STATE(3663)] = 111715,
  [SMALL_STATE(3664)] = 111803,
  [SMALL_STATE(3665)] = 111875,
  [SMALL_STATE(3666)] = 111927,
  [SMALL_STATE(3667)] = 112011,
  [SMALL_STATE(3668)] = 112091,
  [SMALL_STATE(3669)] = 112175,
  [SMALL_STATE(3670)] = 112263,
  [SMALL_STATE(3671)] = 112349,
  [SMALL_STATE(3672)] = 112435,
  [SMALL_STATE(3673)] = 112487,
  [SMALL_STATE(3674)] = 112567,
  [SMALL_STATE(3675)] = 112637,
  [SMALL_STATE(3676)] = 112689,
  [SMALL_STATE(3677)] = 112769,
  [SMALL_STATE(3678)] = 112851,
  [SMALL_STATE(3679)] = 112905,
  [SMALL_STATE(3680)] = 112957,
  [SMALL_STATE(3681)] = 113009,
  [SMALL_STATE(3682)] = 113069,
  [SMALL_STATE(3683)] = 113127,
  [SMALL_STATE(3684)] = 113191,
  [SMALL_STATE(3685)] = 113265,
  [SMALL_STATE(3686)] = 113337,
  [SMALL_STATE(3687)] = 113393,
  [SMALL_STATE(3688)] = 113465,
  [SMALL_STATE(3689)] = 113517,
  [SMALL_STATE(3690)] = 113581,
  [SMALL_STATE(3691)] = 113669,
  [SMALL_STATE(3692)] = 113755,
  [SMALL_STATE(3693)] = 113834,
  [SMALL_STATE(3694)] = 113885,
  [SMALL_STATE(3695)] = 113968,
  [SMALL_STATE(3696)] = 114039,
  [SMALL_STATE(3697)] = 114118,
  [SMALL_STATE(3698)] = 114173,
  [SMALL_STATE(3699)] = 114244,
  [SMALL_STATE(3700)] = 114323,
  [SMALL_STATE(3701)] = 114374,
  [SMALL_STATE(3702)] = 114433,
  [SMALL_STATE(3703)] = 114490,
  [SMALL_STATE(3704)] = 114553,
  [SMALL_STATE(3705)] = 114604,
  [SMALL_STATE(3706)] = 114677,
  [SMALL_STATE(3707)] = 114756,
  [SMALL_STATE(3708)] = 114827,
  [SMALL_STATE(3709)] = 114882,
  [SMALL_STATE(3710)] = 114963,
  [SMALL_STATE(3711)] = 115016,
  [SMALL_STATE(3712)] = 115067,
  [SMALL_STATE(3713)] = 115118,
  [SMALL_STATE(3714)] = 115177,
  [SMALL_STATE(3715)] = 115234,
  [SMALL_STATE(3716)] = 115297,
  [SMALL_STATE(3717)] = 115370,
  [SMALL_STATE(3718)] = 115441,
  [SMALL_STATE(3719)] = 115496,
  [SMALL_STATE(3720)] = 115567,
  [SMALL_STATE(3721)] = 115618,
  [SMALL_STATE(3722)] = 115689,
  [SMALL_STATE(3723)] = 115744,
  [SMALL_STATE(3724)] = 115795,
  [SMALL_STATE(3725)] = 115866,
  [SMALL_STATE(3726)] = 115947,
  [SMALL_STATE(3727)] = 116018,
  [SMALL_STATE(3728)] = 116069,
  [SMALL_STATE(3729)] = 116120,
  [SMALL_STATE(3730)] = 116171,
  [SMALL_STATE(3731)] = 116242,
  [SMALL_STATE(3732)] = 116323,
  [SMALL_STATE(3733)] = 116376,
  [SMALL_STATE(3734)] = 116429,
  [SMALL_STATE(3735)] = 116480,
  [SMALL_STATE(3736)] = 116563,
  [SMALL_STATE(3737)] = 116642,
  [SMALL_STATE(3738)] = 116721,
  [SMALL_STATE(3739)] = 116804,
  [SMALL_STATE(3740)] = 116855,
  [SMALL_STATE(3741)] = 116934,
  [SMALL_STATE(3742)] = 116985,
  [SMALL_STATE(3743)] = 117036,
  [SMALL_STATE(3744)] = 117087,
  [SMALL_STATE(3745)] = 117166,
  [SMALL_STATE(3746)] = 117245,
  [SMALL_STATE(3747)] = 117296,
  [SMALL_STATE(3748)] = 117375,
  [SMALL_STATE(3749)] = 117460,
  [SMALL_STATE(3750)] = 117541,
  [SMALL_STATE(3751)] = 117592,
  [SMALL_STATE(3752)] = 117673,
  [SMALL_STATE(3753)] = 117732,
  [SMALL_STATE(3754)] = 117789,
  [SMALL_STATE(3755)] = 117846,
  [SMALL_STATE(3756)] = 117909,
  [SMALL_STATE(3757)] = 117972,
  [SMALL_STATE(3758)] = 118023,
  [SMALL_STATE(3759)] = 118104,
  [SMALL_STATE(3760)] = 118185,
  [SMALL_STATE(3761)] = 118264,
  [SMALL_STATE(3762)] = 118343,
  [SMALL_STATE(3763)] = 118424,
  [SMALL_STATE(3764)] = 118479,
  [SMALL_STATE(3765)] = 118532,
  [SMALL_STATE(3766)] = 118583,
  [SMALL_STATE(3767)] = 118662,
  [SMALL_STATE(3768)] = 118735,
  [SMALL_STATE(3769)] = 118786,
  [SMALL_STATE(3770)] = 118867,
  [SMALL_STATE(3771)] = 118954,
  [SMALL_STATE(3772)] = 119005,
  [SMALL_STATE(3773)] = 119086,
  [SMALL_STATE(3774)] = 119141,
  [SMALL_STATE(3775)] = 119222,
  [SMALL_STATE(3776)] = 119295,
  [SMALL_STATE(3777)] = 119346,
  [SMALL_STATE(3778)] = 119427,
  [SMALL_STATE(3779)] = 119508,
  [SMALL_STATE(3780)] = 119587,
  [SMALL_STATE(3781)] = 119668,
  [SMALL_STATE(3782)] = 119751,
  [SMALL_STATE(3783)] = 119832,
  [SMALL_STATE(3784)] = 119915,
  [SMALL_STATE(3785)] = 119966,
  [SMALL_STATE(3786)] = 120043,
  [SMALL_STATE(3787)] = 120126,
  [SMALL_STATE(3788)] = 120177,
  [SMALL_STATE(3789)] = 120256,
  [SMALL_STATE(3790)] = 120335,
  [SMALL_STATE(3791)] = 120416,
  [SMALL_STATE(3792)] = 120493,
  [SMALL_STATE(3793)] = 120546,
  [SMALL_STATE(3794)] = 120599,
  [SMALL_STATE(3795)] = 120652,
  [SMALL_STATE(3796)] = 120703,
  [SMALL_STATE(3797)] = 120754,
  [SMALL_STATE(3798)] = 120805,
  [SMALL_STATE(3799)] = 120864,
  [SMALL_STATE(3800)] = 120941,
  [SMALL_STATE(3801)] = 120998,
  [SMALL_STATE(3802)] = 121061,
  [SMALL_STATE(3803)] = 121144,
  [SMALL_STATE(3804)] = 121223,
  [SMALL_STATE(3805)] = 121296,
  [SMALL_STATE(3806)] = 121349,
  [SMALL_STATE(3807)] = 121400,
  [SMALL_STATE(3808)] = 121479,
  [SMALL_STATE(3809)] = 121558,
  [SMALL_STATE(3810)] = 121645,
  [SMALL_STATE(3811)] = 121698,
  [SMALL_STATE(3812)] = 121751,
  [SMALL_STATE(3813)] = 121834,
  [SMALL_STATE(3814)] = 121885,
  [SMALL_STATE(3815)] = 121936,
  [SMALL_STATE(3816)] = 121995,
  [SMALL_STATE(3817)] = 122066,
  [SMALL_STATE(3818)] = 122143,
  [SMALL_STATE(3819)] = 122224,
  [SMALL_STATE(3820)] = 122305,
  [SMALL_STATE(3821)] = 122384,
  [SMALL_STATE(3822)] = 122472,
  [SMALL_STATE(3823)] = 122552,
  [SMALL_STATE(3824)] = 122632,
  [SMALL_STATE(3825)] = 122686,
  [SMALL_STATE(3826)] = 122736,
  [SMALL_STATE(3827)] = 122794,
  [SMALL_STATE(3828)] = 122872,
  [SMALL_STATE(3829)] = 122928,
  [SMALL_STATE(3830)] = 123008,
  [SMALL_STATE(3831)] = 123092,
  [SMALL_STATE(3832)] = 123154,
  [SMALL_STATE(3833)] = 123232,
  [SMALL_STATE(3834)] = 123310,
  [SMALL_STATE(3835)] = 123388,
  [SMALL_STATE(3836)] = 123470,
  [SMALL_STATE(3837)] = 123552,
  [SMALL_STATE(3838)] = 123634,
  [SMALL_STATE(3839)] = 123712,
  [SMALL_STATE(3840)] = 123790,
  [SMALL_STATE(3841)] = 123840,
  [SMALL_STATE(3842)] = 123922,
  [SMALL_STATE(3843)] = 123994,
  [SMALL_STATE(3844)] = 124064,
  [SMALL_STATE(3845)] = 124142,
  [SMALL_STATE(3846)] = 124222,
  [SMALL_STATE(3847)] = 124276,
  [SMALL_STATE(3848)] = 124346,
  [SMALL_STATE(3849)] = 124398,
  [SMALL_STATE(3850)] = 124448,
  [SMALL_STATE(3851)] = 124530,
  [SMALL_STATE(3852)] = 124610,
  [SMALL_STATE(3853)] = 124698,
  [SMALL_STATE(3854)] = 124748,
  [SMALL_STATE(3855)] = 124798,
  [SMALL_STATE(3856)] = 124848,
  [SMALL_STATE(3857)] = 124930,
  [SMALL_STATE(3858)] = 125008,
  [SMALL_STATE(3859)] = 125092,
  [SMALL_STATE(3860)] = 125174,
  [SMALL_STATE(3861)] = 125224,
  [SMALL_STATE(3862)] = 125276,
  [SMALL_STATE(3863)] = 125326,
  [SMALL_STATE(3864)] = 125376,
  [SMALL_STATE(3865)] = 125454,
  [SMALL_STATE(3866)] = 125532,
  [SMALL_STATE(3867)] = 125610,
  [SMALL_STATE(3868)] = 125686,
  [SMALL_STATE(3869)] = 125764,
  [SMALL_STATE(3870)] = 125848,
  [SMALL_STATE(3871)] = 125924,
  [SMALL_STATE(3872)] = 126006,
  [SMALL_STATE(3873)] = 126064,
  [SMALL_STATE(3874)] = 126114,
  [SMALL_STATE(3875)] = 126196,
  [SMALL_STATE(3876)] = 126246,
  [SMALL_STATE(3877)] = 126326,
  [SMALL_STATE(3878)] = 126406,
  [SMALL_STATE(3879)] = 126486,
  [SMALL_STATE(3880)] = 126542,
  [SMALL_STATE(3881)] = 126594,
  [SMALL_STATE(3882)] = 126674,
  [SMALL_STATE(3883)] = 126756,
  [SMALL_STATE(3884)] = 126834,
  [SMALL_STATE(3885)] = 126914,
  [SMALL_STATE(3886)] = 126994,
  [SMALL_STATE(3887)] = 127056,
  [SMALL_STATE(3888)] = 127128,
  [SMALL_STATE(3889)] = 127198,
  [SMALL_STATE(3890)] = 127248,
  [SMALL_STATE(3891)] = 127302,
  [SMALL_STATE(3892)] = 127380,
  [SMALL_STATE(3893)] = 127430,
  [SMALL_STATE(3894)] = 127500,
  [SMALL_STATE(3895)] = 127558,
  [SMALL_STATE(3896)] = 127614,
  [SMALL_STATE(3897)] = 127698,
  [SMALL_STATE(3898)] = 127776,
  [SMALL_STATE(3899)] = 127854,
  [SMALL_STATE(3900)] = 127932,
  [SMALL_STATE(3901)] = 128010,
  [SMALL_STATE(3902)] = 128088,
  [SMALL_STATE(3903)] = 128150,
  [SMALL_STATE(3904)] = 128222,
  [SMALL_STATE(3905)] = 128292,
  [SMALL_STATE(3906)] = 128372,
  [SMALL_STATE(3907)] = 128426,
  [SMALL_STATE(3908)] = 128496,
  [SMALL_STATE(3909)] = 128546,
  [SMALL_STATE(3910)] = 128628,
  [SMALL_STATE(3911)] = 128712,
  [SMALL_STATE(3912)] = 128794,
  [SMALL_STATE(3913)] = 128848,
  [SMALL_STATE(3914)] = 128932,
  [SMALL_STATE(3915)] = 128982,
  [SMALL_STATE(3916)] = 129032,
  [SMALL_STATE(3917)] = 129110,
  [SMALL_STATE(3918)] = 129194,
  [SMALL_STATE(3919)] = 129246,
  [SMALL_STATE(3920)] = 129328,
  [SMALL_STATE(3921)] = 129406,
  [SMALL_STATE(3922)] = 129486,
  [SMALL_STATE(3923)] = 129535,
  [SMALL_STATE(3924)] = 129618,
  [SMALL_STATE(3925)] = 129669,
  [SMALL_STATE(3926)] = 129748,
  [SMALL_STATE(3927)] = 129825,
  [SMALL_STATE(3928)] = 129904,
  [SMALL_STATE(3929)] = 129983,
  [SMALL_STATE(3930)] = 130036,
  [SMALL_STATE(3931)] = 130089,
  [SMALL_STATE(3932)] = 130138,
  [SMALL_STATE(3933)] = 130217,
  [SMALL_STATE(3934)] = 130298,
  [SMALL_STATE(3935)] = 130373,
  [SMALL_STATE(3936)] = 130450,
  [SMALL_STATE(3937)] = 130501,
  [SMALL_STATE(3938)] = 130578,
  [SMALL_STATE(3939)] = 130655,
  [SMALL_STATE(3940)] = 130732,
  [SMALL_STATE(3941)] = 130809,
  [SMALL_STATE(3942)] = 130886,
  [SMALL_STATE(3943)] = 130935,
  [SMALL_STATE(3944)] = 131016,
  [SMALL_STATE(3945)] = 131097,
  [SMALL_STATE(3946)] = 131178,
  [SMALL_STATE(3947)] = 131229,
  [SMALL_STATE(3948)] = 131310,
  [SMALL_STATE(3949)] = 131359,
  [SMALL_STATE(3950)] = 131408,
  [SMALL_STATE(3951)] = 131459,
  [SMALL_STATE(3952)] = 131508,
  [SMALL_STATE(3953)] = 131557,
  [SMALL_STATE(3954)] = 131614,
  [SMALL_STATE(3955)] = 131669,
  [SMALL_STATE(3956)] = 131730,
  [SMALL_STATE(3957)] = 131801,
  [SMALL_STATE(3958)] = 131870,
  [SMALL_STATE(3959)] = 131923,
  [SMALL_STATE(3960)] = 131992,
  [SMALL_STATE(3961)] = 132041,
  [SMALL_STATE(3962)] = 132116,
  [SMALL_STATE(3963)] = 132197,
  [SMALL_STATE(3964)] = 132278,
  [SMALL_STATE(3965)] = 132357,
  [SMALL_STATE(3966)] = 132406,
  [SMALL_STATE(3967)] = 132483,
  [SMALL_STATE(3968)] = 132560,
  [SMALL_STATE(3969)] = 132639,
  [SMALL_STATE(3970)] = 132718,
  [SMALL_STATE(3971)] = 132769,
  [SMALL_STATE(3972)] = 132818,
  [SMALL_STATE(3973)] = 132875,
  [SMALL_STATE(3974)] = 132930,
  [SMALL_STATE(3975)] = 132991,
  [SMALL_STATE(3976)] = 133062,
  [SMALL_STATE(3977)] = 133131,
  [SMALL_STATE(3978)] = 133208,
  [SMALL_STATE(3979)] = 133261,
  [SMALL_STATE(3980)] = 133330,
  [SMALL_STATE(3981)] = 133407,
  [SMALL_STATE(3982)] = 133484,
  [SMALL_STATE(3983)] = 133533,
  [SMALL_STATE(3984)] = 133614,
  [SMALL_STATE(3985)] = 133663,
  [SMALL_STATE(3986)] = 133742,
  [SMALL_STATE(3987)] = 133792,
  [SMALL_STATE(3988)] = 133872,
  [SMALL_STATE(3989)] = 133950,
  [SMALL_STATE(3990)] = 134026,
  [SMALL_STATE(3991)] = 134102,
  [SMALL_STATE(3992)] = 134152,
  [SMALL_STATE(3993)] = 134228,
  [SMALL_STATE(3994)] = 134304,
  [SMALL_STATE(3995)] = 134384,
  [SMALL_STATE(3996)] = 134432,
  [SMALL_STATE(3997)] = 134514,
  [SMALL_STATE(3998)] = 134592,
  [SMALL_STATE(3999)] = 134642,
  [SMALL_STATE(4000)] = 134720,
  [SMALL_STATE(4001)] = 134798,
  [SMALL_STATE(4002)] = 134876,
  [SMALL_STATE(4003)] = 134958,
  [SMALL_STATE(4004)] = 135038,
  [SMALL_STATE(4005)] = 135120,
  [SMALL_STATE(4006)] = 135196,
  [SMALL_STATE(4007)] = 135272,
  [SMALL_STATE(4008)] = 135322,
  [SMALL_STATE(4009)] = 135370,
  [SMALL_STATE(4010)] = 135418,
  [SMALL_STATE(4011)] = 135474,
  [SMALL_STATE(4012)] = 135528,
  [SMALL_STATE(4013)] = 135588,
  [SMALL_STATE(4014)] = 135658,
  [SMALL_STATE(4015)] = 135726,
  [SMALL_STATE(4016)] = 135778,
  [SMALL_STATE(4017)] = 135846,
  [SMALL_STATE(4018)] = 135894,
  [SMALL_STATE(4019)] = 135970,
  [SMALL_STATE(4020)] = 136048,
  [SMALL_STATE(4021)] = 136124,
  [SMALL_STATE(4022)] = 136200,
  [SMALL_STATE(4023)] = 136274,
  [SMALL_STATE(4024)] = 136350,
  [SMALL_STATE(4025)] = 136426,
  [SMALL_STATE(4026)] = 136506,
  [SMALL_STATE(4027)] = 136582,
  [SMALL_STATE(4028)] = 136630,
  [SMALL_STATE(4029)] = 136686,
  [SMALL_STATE(4030)] = 136740,
  [SMALL_STATE(4031)] = 136800,
  [SMALL_STATE(4032)] = 136870,
  [SMALL_STATE(4033)] = 136938,
  [SMALL_STATE(4034)] = 136990,
  [SMALL_STATE(4035)] = 137058,
  [SMALL_STATE(4036)] = 137106,
  [SMALL_STATE(4037)] = 137182,
  [SMALL_STATE(4038)] = 137258,
  [SMALL_STATE(4039)] = 137332,
  [SMALL_STATE(4040)] = 137408,
  [SMALL_STATE(4041)] = 137484,
  [SMALL_STATE(4042)] = 137560,
  [SMALL_STATE(4043)] = 137608,
  [SMALL_STATE(4044)] = 137654,
  [SMALL_STATE(4045)] = 137702,
  [SMALL_STATE(4046)] = 137780,
  [SMALL_STATE(4047)] = 137862,
  [SMALL_STATE(4048)] = 137936,
  [SMALL_STATE(4049)] = 138012,
  [SMALL_STATE(4050)] = 138086,
  [SMALL_STATE(4051)] = 138162,
  [SMALL_STATE(4052)] = 138210,
  [SMALL_STATE(4053)] = 138286,
  [SMALL_STATE(4054)] = 138362,
  [SMALL_STATE(4055)] = 138442,
  [SMALL_STATE(4056)] = 138494,
  [SMALL_STATE(4057)] = 138570,
  [SMALL_STATE(4058)] = 138650,
  [SMALL_STATE(4059)] = 138698,
  [SMALL_STATE(4060)] = 138753,
  [SMALL_STATE(4061)] = 138828,
  [SMALL_STATE(4062)] = 138879,
  [SMALL_STATE(4063)] = 138928,
  [SMALL_STATE(4064)] = 138975,
  [SMALL_STATE(4065)] = 139022,
  [SMALL_STATE(4066)] = 139077,
  [SMALL_STATE(4067)] = 139124,
  [SMALL_STATE(4068)] = 139177,
  [SMALL_STATE(4069)] = 139236,
  [SMALL_STATE(4070)] = 139305,
  [SMALL_STATE(4071)] = 139372,
  [SMALL_STATE(4072)] = 139423,
  [SMALL_STATE(4073)] = 139490,
  [SMALL_STATE(4074)] = 139565,
  [SMALL_STATE(4075)] = 139612,
  [SMALL_STATE(4076)] = 139691,
  [SMALL_STATE(4077)] = 139770,
  [SMALL_STATE(4078)] = 139849,
  [SMALL_STATE(4079)] = 139924,
  [SMALL_STATE(4080)] = 139999,
  [SMALL_STATE(4081)] = 140044,
  [SMALL_STATE(4082)] = 140121,
  [SMALL_STATE(4083)] = 140170,
  [SMALL_STATE(4084)] = 140217,
  [SMALL_STATE(4085)] = 140264,
  [SMALL_STATE(4086)] = 140311,
  [SMALL_STATE(4087)] = 140386,
  [SMALL_STATE(4088)] = 140441,
  [SMALL_STATE(4089)] = 140516,
  [SMALL_STATE(4090)] = 140569,
  [SMALL_STATE(4091)] = 140628,
  [SMALL_STATE(4092)] = 140697,
  [SMALL_STATE(4093)] = 140764,
  [SMALL_STATE(4094)] = 140815,
  [SMALL_STATE(4095)] = 140890,
  [SMALL_STATE(4096)] = 140957,
  [SMALL_STATE(4097)] = 141032,
  [SMALL_STATE(4098)] = 141111,
  [SMALL_STATE(4099)] = 141158,
  [SMALL_STATE(4100)] = 141205,
  [SMALL_STATE(4101)] = 141254,
  [SMALL_STATE(4102)] = 141301,
  [SMALL_STATE(4103)] = 141376,
  [SMALL_STATE(4104)] = 141449,
  [SMALL_STATE(4105)] = 141524,
  [SMALL_STATE(4106)] = 141601,
  [SMALL_STATE(4107)] = 141678,
  [SMALL_STATE(4108)] = 141725,
  [SMALL_STATE(4109)] = 141802,
  [SMALL_STATE(4110)] = 141877,
  [SMALL_STATE(4111)] = 141922,
  [SMALL_STATE(4112)] = 141991,
  [SMALL_STATE(4113)] = 142040,
  [SMALL_STATE(4114)] = 142115,
  [SMALL_STATE(4115)] = 142162,
  [SMALL_STATE(4116)] = 142237,
  [SMALL_STATE(4117)] = 142288,
  [SMALL_STATE(4118)] = 142355,
  [SMALL_STATE(4119)] = 142430,
  [SMALL_STATE(4120)] = 142505,
  [SMALL_STATE(4121)] = 142578,
  [SMALL_STATE(4122)] = 142651,
  [SMALL_STATE(4123)] = 142726,
  [SMALL_STATE(4124)] = 142801,
  [SMALL_STATE(4125)] = 142876,
  [SMALL_STATE(4126)] = 142951,
  [SMALL_STATE(4127)] = 143028,
  [SMALL_STATE(4128)] = 143105,
  [SMALL_STATE(4129)] = 143180,
  [SMALL_STATE(4130)] = 143247,
  [SMALL_STATE(4131)] = 143324,
  [SMALL_STATE(4132)] = 143373,
  [SMALL_STATE(4133)] = 143420,
  [SMALL_STATE(4134)] = 143467,
  [SMALL_STATE(4135)] = 143542,
  [SMALL_STATE(4136)] = 143615,
  [SMALL_STATE(4137)] = 143668,
  [SMALL_STATE(4138)] = 143727,
  [SMALL_STATE(4139)] = 143802,
  [SMALL_STATE(4140)] = 143851,
  [SMALL_STATE(4141)] = 143924,
  [SMALL_STATE(4142)] = 144001,
  [SMALL_STATE(4143)] = 144078,
  [SMALL_STATE(4144)] = 144153,
  [SMALL_STATE(4145)] = 144232,
  [SMALL_STATE(4146)] = 144311,
  [SMALL_STATE(4147)] = 144384,
  [SMALL_STATE(4148)] = 144458,
  [SMALL_STATE(4149)] = 144508,
  [SMALL_STATE(4150)] = 144574,
  [SMALL_STATE(4151)] = 144628,
  [SMALL_STATE(4152)] = 144674,
  [SMALL_STATE(4153)] = 144746,
  [SMALL_STATE(4154)] = 144798,
  [SMALL_STATE(4155)] = 144856,
  [SMALL_STATE(4156)] = 144930,
  [SMALL_STATE(4157)] = 145004,
  [SMALL_STATE(4158)] = 145076,
  [SMALL_STATE(4159)] = 145150,
  [SMALL_STATE(4160)] = 145224,
  [SMALL_STATE(4161)] = 145292,
  [SMALL_STATE(4162)] = 145366,
  [SMALL_STATE(4163)] = 145440,
  [SMALL_STATE(4164)] = 145514,
  [SMALL_STATE(4165)] = 145588,
  [SMALL_STATE(4166)] = 145654,
  [SMALL_STATE(4167)] = 145704,
  [SMALL_STATE(4168)] = 145770,
  [SMALL_STATE(4169)] = 145846,
  [SMALL_STATE(4170)] = 145892,
  [SMALL_STATE(4171)] = 145968,
  [SMALL_STATE(4172)] = 146034,
  [SMALL_STATE(4173)] = 146106,
  [SMALL_STATE(4174)] = 146152,
  [SMALL_STATE(4175)] = 146226,
  [SMALL_STATE(4176)] = 146272,
  [SMALL_STATE(4177)] = 146348,
  [SMALL_STATE(4178)] = 146420,
  [SMALL_STATE(4179)] = 146494,
  [SMALL_STATE(4180)] = 146570,
  [SMALL_STATE(4181)] = 146634,
  [SMALL_STATE(4182)] = 146708,
  [SMALL_STATE(4183)] = 146756,
  [SMALL_STATE(4184)] = 146830,
  [SMALL_STATE(4185)] = 146876,
  [SMALL_STATE(4186)] = 146924,
  [SMALL_STATE(4187)] = 146970,
  [SMALL_STATE(4188)] = 147016,
  [SMALL_STATE(4189)] = 147070,
  [SMALL_STATE(4190)] = 147122,
  [SMALL_STATE(4191)] = 147180,
  [SMALL_STATE(4192)] = 147244,
  [SMALL_STATE(4193)] = 147290,
  [SMALL_STATE(4194)] = 147358,
  [SMALL_STATE(4195)] = 147434,
  [SMALL_STATE(4196)] = 147510,
  [SMALL_STATE(4197)] = 147556,
  [SMALL_STATE(4198)] = 147599,
  [SMALL_STATE(4199)] = 147674,
  [SMALL_STATE(4200)] = 147749,
  [SMALL_STATE(4201)] = 147824,
  [SMALL_STATE(4202)] = 147899,
  [SMALL_STATE(4203)] = 147974,
  [SMALL_STATE(4204)] = 148049,
  [SMALL_STATE(4205)] = 148124,
  [SMALL_STATE(4206)] = 148199,
  [SMALL_STATE(4207)] = 148274,
  [SMALL_STATE(4208)] = 148349,
  [SMALL_STATE(4209)] = 148424,
  [SMALL_STATE(4210)] = 148499,
  [SMALL_STATE(4211)] = 148574,
  [SMALL_STATE(4212)] = 148649,
  [SMALL_STATE(4213)] = 148724,
  [SMALL_STATE(4214)] = 148799,
  [SMALL_STATE(4215)] = 148874,
  [SMALL_STATE(4216)] = 148949,
  [SMALL_STATE(4217)] = 149024,
  [SMALL_STATE(4218)] = 149089,
  [SMALL_STATE(4219)] = 149164,
  [SMALL_STATE(4220)] = 149239,
  [SMALL_STATE(4221)] = 149288,
  [SMALL_STATE(4222)] = 149353,
  [SMALL_STATE(4223)] = 149398,
  [SMALL_STATE(4224)] = 149443,
  [SMALL_STATE(4225)] = 149518,
  [SMALL_STATE(4226)] = 149593,
  [SMALL_STATE(4227)] = 149668,
  [SMALL_STATE(4228)] = 149715,
  [SMALL_STATE(4229)] = 149790,
  [SMALL_STATE(4230)] = 149839,
  [SMALL_STATE(4231)] = 149882,
  [SMALL_STATE(4232)] = 149935,
  [SMALL_STATE(4233)] = 149980,
  [SMALL_STATE(4234)] = 150023,
  [SMALL_STATE(4235)] = 150066,
  [SMALL_STATE(4236)] = 150109,
  [SMALL_STATE(4237)] = 150152,
  [SMALL_STATE(4238)] = 150195,
  [SMALL_STATE(4239)] = 150270,
  [SMALL_STATE(4240)] = 150313,
  [SMALL_STATE(4241)] = 150384,
  [SMALL_STATE(4242)] = 150435,
  [SMALL_STATE(4243)] = 150510,
  [SMALL_STATE(4244)] = 150567,
  [SMALL_STATE(4245)] = 150612,
  [SMALL_STATE(4246)] = 150683,
  [SMALL_STATE(4247)] = 150726,
  [SMALL_STATE(4248)] = 150801,
  [SMALL_STATE(4249)] = 150874,
  [SMALL_STATE(4250)] = 150917,
  [SMALL_STATE(4251)] = 150960,
  [SMALL_STATE(4252)] = 151035,
  [SMALL_STATE(4253)] = 151110,
  [SMALL_STATE(4254)] = 151183,
  [SMALL_STATE(4255)] = 151226,
  [SMALL_STATE(4256)] = 151269,
  [SMALL_STATE(4257)] = 151344,
  [SMALL_STATE(4258)] = 151419,
  [SMALL_STATE(4259)] = 151494,
  [SMALL_STATE(4260)] = 151569,
  [SMALL_STATE(4261)] = 151644,
  [SMALL_STATE(4262)] = 151719,
  [SMALL_STATE(4263)] = 151794,
  [SMALL_STATE(4264)] = 151869,
  [SMALL_STATE(4265)] = 151912,
  [SMALL_STATE(4266)] = 151987,
  [SMALL_STATE(4267)] = 152062,
  [SMALL_STATE(4268)] = 152105,
  [SMALL_STATE(4269)] = 152180,
  [SMALL_STATE(4270)] = 152255,
  [SMALL_STATE(4271)] = 152298,
  [SMALL_STATE(4272)] = 152371,
  [SMALL_STATE(4273)] = 152446,
  [SMALL_STATE(4274)] = 152489,
  [SMALL_STATE(4275)] = 152562,
  [SMALL_STATE(4276)] = 152635,
  [SMALL_STATE(4277)] = 152710,
  [SMALL_STATE(4278)] = 152785,
  [SMALL_STATE(4279)] = 152828,
  [SMALL_STATE(4280)] = 152871,
  [SMALL_STATE(4281)] = 152914,
  [SMALL_STATE(4282)] = 152989,
  [SMALL_STATE(4283)] = 153064,
  [SMALL_STATE(4284)] = 153139,
  [SMALL_STATE(4285)] = 153214,
  [SMALL_STATE(4286)] = 153289,
  [SMALL_STATE(4287)] = 153332,
  [SMALL_STATE(4288)] = 153407,
  [SMALL_STATE(4289)] = 153482,
  [SMALL_STATE(4290)] = 153557,
  [SMALL_STATE(4291)] = 153632,
  [SMALL_STATE(4292)] = 153707,
  [SMALL_STATE(4293)] = 153782,
  [SMALL_STATE(4294)] = 153857,
  [SMALL_STATE(4295)] = 153932,
  [SMALL_STATE(4296)] = 154007,
  [SMALL_STATE(4297)] = 154082,
  [SMALL_STATE(4298)] = 154157,
  [SMALL_STATE(4299)] = 154232,
  [SMALL_STATE(4300)] = 154307,
  [SMALL_STATE(4301)] = 154382,
  [SMALL_STATE(4302)] = 154457,
  [SMALL_STATE(4303)] = 154532,
  [SMALL_STATE(4304)] = 154607,
  [SMALL_STATE(4305)] = 154682,
  [SMALL_STATE(4306)] = 154757,
  [SMALL_STATE(4307)] = 154800,
  [SMALL_STATE(4308)] = 154875,
  [SMALL_STATE(4309)] = 154948,
  [SMALL_STATE(4310)] = 155023,
  [SMALL_STATE(4311)] = 155090,
  [SMALL_STATE(4312)] = 155132,
  [SMALL_STATE(4313)] = 155174,
  [SMALL_STATE(4314)] = 155216,
  [SMALL_STATE(4315)] = 155258,
  [SMALL_STATE(4316)] = 155300,
  [SMALL_STATE(4317)] = 155342,
  [SMALL_STATE(4318)] = 155384,
  [SMALL_STATE(4319)] = 155426,
  [SMALL_STATE(4320)] = 155468,
  [SMALL_STATE(4321)] = 155510,
  [SMALL_STATE(4322)] = 155552,
  [SMALL_STATE(4323)] = 155594,
  [SMALL_STATE(4324)] = 155636,
  [SMALL_STATE(4325)] = 155678,
  [SMALL_STATE(4326)] = 155720,
  [SMALL_STATE(4327)] = 155762,
  [SMALL_STATE(4328)] = 155804,
  [SMALL_STATE(4329)] = 155846,
  [SMALL_STATE(4330)] = 155888,
  [SMALL_STATE(4331)] = 155930,
  [SMALL_STATE(4332)] = 155972,
  [SMALL_STATE(4333)] = 156014,
  [SMALL_STATE(4334)] = 156056,
  [SMALL_STATE(4335)] = 156098,
  [SMALL_STATE(4336)] = 156140,
  [SMALL_STATE(4337)] = 156182,
  [SMALL_STATE(4338)] = 156224,
  [SMALL_STATE(4339)] = 156266,
  [SMALL_STATE(4340)] = 156308,
  [SMALL_STATE(4341)] = 156350,
  [SMALL_STATE(4342)] = 156392,
  [SMALL_STATE(4343)] = 156434,
  [SMALL_STATE(4344)] = 156476,
  [SMALL_STATE(4345)] = 156518,
  [SMALL_STATE(4346)] = 156560,
  [SMALL_STATE(4347)] = 156602,
  [SMALL_STATE(4348)] = 156644,
  [SMALL_STATE(4349)] = 156686,
  [SMALL_STATE(4350)] = 156728,
  [SMALL_STATE(4351)] = 156770,
  [SMALL_STATE(4352)] = 156812,
  [SMALL_STATE(4353)] = 156854,
  [SMALL_STATE(4354)] = 156896,
  [SMALL_STATE(4355)] = 156938,
  [SMALL_STATE(4356)] = 156980,
  [SMALL_STATE(4357)] = 157022,
  [SMALL_STATE(4358)] = 157064,
  [SMALL_STATE(4359)] = 157106,
  [SMALL_STATE(4360)] = 157148,
  [SMALL_STATE(4361)] = 157190,
  [SMALL_STATE(4362)] = 157232,
  [SMALL_STATE(4363)] = 157274,
  [SMALL_STATE(4364)] = 157315,
  [SMALL_STATE(4365)] = 157356,
  [SMALL_STATE(4366)] = 157397,
  [SMALL_STATE(4367)] = 157438,
  [SMALL_STATE(4368)] = 157479,
  [SMALL_STATE(4369)] = 157519,
  [SMALL_STATE(4370)] = 157559,
  [SMALL_STATE(4371)] = 157599,
  [SMALL_STATE(4372)] = 157647,
  [SMALL_STATE(4373)] = 157687,
  [SMALL_STATE(4374)] = 157727,
  [SMALL_STATE(4375)] = 157767,
  [SMALL_STATE(4376)] = 157807,
  [SMALL_STATE(4377)] = 157847,
  [SMALL_STATE(4378)] = 157887,
  [SMALL_STATE(4379)] = 157927,
  [SMALL_STATE(4380)] = 157967,
  [SMALL_STATE(4381)] = 158007,
  [SMALL_STATE(4382)] = 158047,
  [SMALL_STATE(4383)] = 158087,
  [SMALL_STATE(4384)] = 158127,
  [SMALL_STATE(4385)] = 158167,
  [SMALL_STATE(4386)] = 158209,
  [SMALL_STATE(4387)] = 158257,
  [SMALL_STATE(4388)] = 158303,
  [SMALL_STATE(4389)] = 158343,
  [SMALL_STATE(4390)] = 158389,
  [SMALL_STATE(4391)] = 158429,
  [SMALL_STATE(4392)] = 158468,
  [SMALL_STATE(4393)] = 158507,
  [SMALL_STATE(4394)] = 158546,
  [SMALL_STATE(4395)] = 158585,
  [SMALL_STATE(4396)] = 158624,
  [SMALL_STATE(4397)] = 158663,
  [SMALL_STATE(4398)] = 158702,
  [SMALL_STATE(4399)] = 158741,
  [SMALL_STATE(4400)] = 158800,
  [SMALL_STATE(4401)] = 158859,
  [SMALL_STATE(4402)] = 158898,
  [SMALL_STATE(4403)] = 158939,
  [SMALL_STATE(4404)] = 158980,
  [SMALL_STATE(4405)] = 159021,
  [SMALL_STATE(4406)] = 159060,
  [SMALL_STATE(4407)] = 159101,
  [SMALL_STATE(4408)] = 159139,
  [SMALL_STATE(4409)] = 159177,
  [SMALL_STATE(4410)] = 159215,
  [SMALL_STATE(4411)] = 159253,
  [SMALL_STATE(4412)] = 159291,
  [SMALL_STATE(4413)] = 159331,
  [SMALL_STATE(4414)] = 159369,
  [SMALL_STATE(4415)] = 159407,
  [SMALL_STATE(4416)] = 159445,
  [SMALL_STATE(4417)] = 159483,
  [SMALL_STATE(4418)] = 159521,
  [SMALL_STATE(4419)] = 159559,
  [SMALL_STATE(4420)] = 159597,
  [SMALL_STATE(4421)] = 159635,
  [SMALL_STATE(4422)] = 159673,
  [SMALL_STATE(4423)] = 159711,
  [SMALL_STATE(4424)] = 159749,
  [SMALL_STATE(4425)] = 159787,
  [SMALL_STATE(4426)] = 159825,
  [SMALL_STATE(4427)] = 159863,
  [SMALL_STATE(4428)] = 159901,
  [SMALL_STATE(4429)] = 159939,
  [SMALL_STATE(4430)] = 159977,
  [SMALL_STATE(4431)] = 160015,
  [SMALL_STATE(4432)] = 160053,
  [SMALL_STATE(4433)] = 160091,
  [SMALL_STATE(4434)] = 160129,
  [SMALL_STATE(4435)] = 160167,
  [SMALL_STATE(4436)] = 160205,
  [SMALL_STATE(4437)] = 160243,
  [SMALL_STATE(4438)] = 160281,
  [SMALL_STATE(4439)] = 160319,
  [SMALL_STATE(4440)] = 160357,
  [SMALL_STATE(4441)] = 160395,
  [SMALL_STATE(4442)] = 160433,
  [SMALL_STATE(4443)] = 160471,
  [SMALL_STATE(4444)] = 160509,
  [SMALL_STATE(4445)] = 160547,
  [SMALL_STATE(4446)] = 160587,
  [SMALL_STATE(4447)] = 160644,
  [SMALL_STATE(4448)] = 160701,
  [SMALL_STATE(4449)] = 160758,
  [SMALL_STATE(4450)] = 160815,
  [SMALL_STATE(4451)] = 160856,
  [SMALL_STATE(4452)] = 160894,
  [SMALL_STATE(4453)] = 160930,
  [SMALL_STATE(4454)] = 160968,
  [SMALL_STATE(4455)] = 161004,
  [SMALL_STATE(4456)] = 161042,
  [SMALL_STATE(4457)] = 161080,
  [SMALL_STATE(4458)] = 161118,
  [SMALL_STATE(4459)] = 161156,
  [SMALL_STATE(4460)] = 161194,
  [SMALL_STATE(4461)] = 161232,
  [SMALL_STATE(4462)] = 161270,
  [SMALL_STATE(4463)] = 161306,
  [SMALL_STATE(4464)] = 161344,
  [SMALL_STATE(4465)] = 161382,
  [SMALL_STATE(4466)] = 161441,
  [SMALL_STATE(4467)] = 161500,
  [SMALL_STATE(4468)] = 161559,
  [SMALL_STATE(4469)] = 161594,
  [SMALL_STATE(4470)] = 161629,
  [SMALL_STATE(4471)] = 161688,
  [SMALL_STATE(4472)] = 161747,
  [SMALL_STATE(4473)] = 161806,
  [SMALL_STATE(4474)] = 161865,
  [SMALL_STATE(4475)] = 161924,
  [SMALL_STATE(4476)] = 161983,
  [SMALL_STATE(4477)] = 162042,
  [SMALL_STATE(4478)] = 162101,
  [SMALL_STATE(4479)] = 162136,
  [SMALL_STATE(4480)] = 162195,
  [SMALL_STATE(4481)] = 162254,
  [SMALL_STATE(4482)] = 162313,
  [SMALL_STATE(4483)] = 162372,
  [SMALL_STATE(4484)] = 162431,
  [SMALL_STATE(4485)] = 162490,
  [SMALL_STATE(4486)] = 162549,
  [SMALL_STATE(4487)] = 162608,
  [SMALL_STATE(4488)] = 162667,
  [SMALL_STATE(4489)] = 162726,
  [SMALL_STATE(4490)] = 162785,
  [SMALL_STATE(4491)] = 162844,
  [SMALL_STATE(4492)] = 162881,
  [SMALL_STATE(4493)] = 162940,
  [SMALL_STATE(4494)] = 162994,
  [SMALL_STATE(4495)] = 163028,
  [SMALL_STATE(4496)] = 163082,
  [SMALL_STATE(4497)] = 163136,
  [SMALL_STATE(4498)] = 163190,
  [SMALL_STATE(4499)] = 163224,
  [SMALL_STATE(4500)] = 163258,
  [SMALL_STATE(4501)] = 163312,
  [SMALL_STATE(4502)] = 163348,
  [SMALL_STATE(4503)] = 163382,
  [SMALL_STATE(4504)] = 163436,
  [SMALL_STATE(4505)] = 163470,
  [SMALL_STATE(4506)] = 163504,
  [SMALL_STATE(4507)] = 163540,
  [SMALL_STATE(4508)] = 163576,
  [SMALL_STATE(4509)] = 163630,
  [SMALL_STATE(4510)] = 163664,
  [SMALL_STATE(4511)] = 163701,
  [SMALL_STATE(4512)] = 163734,
  [SMALL_STATE(4513)] = 163767,
  [SMALL_STATE(4514)] = 163802,
  [SMALL_STATE(4515)] = 163835,
  [SMALL_STATE(4516)] = 163868,
  [SMALL_STATE(4517)] = 163901,
  [SMALL_STATE(4518)] = 163936,
  [SMALL_STATE(4519)] = 163991,
  [SMALL_STATE(4520)] = 164024,
  [SMALL_STATE(4521)] = 164079,
  [SMALL_STATE(4522)] = 164111,
  [SMALL_STATE(4523)] = 164143,
  [SMALL_STATE(4524)] = 164195,
  [SMALL_STATE(4525)] = 164227,
  [SMALL_STATE(4526)] = 164279,
  [SMALL_STATE(4527)] = 164331,
  [SMALL_STATE(4528)] = 164363,
  [SMALL_STATE(4529)] = 164397,
  [SMALL_STATE(4530)] = 164431,
  [SMALL_STATE(4531)] = 164463,
  [SMALL_STATE(4532)] = 164497,
  [SMALL_STATE(4533)] = 164533,
  [SMALL_STATE(4534)] = 164569,
  [SMALL_STATE(4535)] = 164601,
  [SMALL_STATE(4536)] = 164653,
  [SMALL_STATE(4537)] = 164685,
  [SMALL_STATE(4538)] = 164717,
  [SMALL_STATE(4539)] = 164768,
  [SMALL_STATE(4540)] = 164817,
  [SMALL_STATE(4541)] = 164852,
  [SMALL_STATE(4542)] = 164887,
  [SMALL_STATE(4543)] = 164918,
  [SMALL_STATE(4544)] = 164977,
  [SMALL_STATE(4545)] = 165036,
  [SMALL_STATE(4546)] = 165085,
  [SMALL_STATE(4547)] = 165136,
  [SMALL_STATE(4548)] = 165195,
  [SMALL_STATE(4549)] = 165254,
  [SMALL_STATE(4550)] = 165313,
  [SMALL_STATE(4551)] = 165362,
  [SMALL_STATE(4552)] = 165421,
  [SMALL_STATE(4553)] = 165467,
  [SMALL_STATE(4554)] = 165499,
  [SMALL_STATE(4555)] = 165533,
  [SMALL_STATE(4556)] = 165565,
  [SMALL_STATE(4557)] = 165611,
  [SMALL_STATE(4558)] = 165645,
  [SMALL_STATE(4559)] = 165679,
  [SMALL_STATE(4560)] = 165721,
  [SMALL_STATE(4561)] = 165753,
  [SMALL_STATE(4562)] = 165787,
  [SMALL_STATE(4563)] = 165817,
  [SMALL_STATE(4564)] = 165863,
  [SMALL_STATE(4565)] = 165897,
  [SMALL_STATE(4566)] = 165931,
  [SMALL_STATE(4567)] = 165965,
  [SMALL_STATE(4568)] = 165999,
  [SMALL_STATE(4569)] = 166033,
  [SMALL_STATE(4570)] = 166065,
  [SMALL_STATE(4571)] = 166111,
  [SMALL_STATE(4572)] = 166145,
  [SMALL_STATE(4573)] = 166187,
  [SMALL_STATE(4574)] = 166218,
  [SMALL_STATE(4575)] = 166249,
  [SMALL_STATE(4576)] = 166282,
  [SMALL_STATE(4577)] = 166313,
  [SMALL_STATE(4578)] = 166346,
  [SMALL_STATE(4579)] = 166372,
  [SMALL_STATE(4580)] = 166400,
  [SMALL_STATE(4581)] = 166428,
  [SMALL_STATE(4582)] = 166456,
  [SMALL_STATE(4583)] = 166482,
  [SMALL_STATE(4584)] = 166510,
  [SMALL_STATE(4585)] = 166536,
  [SMALL_STATE(4586)] = 166562,
  [SMALL_STATE(4587)] = 166600,
  [SMALL_STATE(4588)] = 166626,
  [SMALL_STATE(4589)] = 166658,
  [SMALL_STATE(4590)] = 166684,
  [SMALL_STATE(4591)] = 166710,
  [SMALL_STATE(4592)] = 166736,
  [SMALL_STATE(4593)] = 166762,
  [SMALL_STATE(4594)] = 166788,
  [SMALL_STATE(4595)] = 166814,
  [SMALL_STATE(4596)] = 166840,
  [SMALL_STATE(4597)] = 166866,
  [SMALL_STATE(4598)] = 166904,
  [SMALL_STATE(4599)] = 166930,
  [SMALL_STATE(4600)] = 166962,
  [SMALL_STATE(4601)] = 166988,
  [SMALL_STATE(4602)] = 167014,
  [SMALL_STATE(4603)] = 167040,
  [SMALL_STATE(4604)] = 167066,
  [SMALL_STATE(4605)] = 167098,
  [SMALL_STATE(4606)] = 167128,
  [SMALL_STATE(4607)] = 167158,
  [SMALL_STATE(4608)] = 167184,
  [SMALL_STATE(4609)] = 167210,
  [SMALL_STATE(4610)] = 167237,
  [SMALL_STATE(4611)] = 167264,
  [SMALL_STATE(4612)] = 167291,
  [SMALL_STATE(4613)] = 167318,
  [SMALL_STATE(4614)] = 167345,
  [SMALL_STATE(4615)] = 167372,
  [SMALL_STATE(4616)] = 167399,
  [SMALL_STATE(4617)] = 167426,
  [SMALL_STATE(4618)] = 167453,
  [SMALL_STATE(4619)] = 167480,
  [SMALL_STATE(4620)] = 167507,
  [SMALL_STATE(4621)] = 167534,
  [SMALL_STATE(4622)] = 167561,
  [SMALL_STATE(4623)] = 167588,
  [SMALL_STATE(4624)] = 167615,
  [SMALL_STATE(4625)] = 167642,
  [SMALL_STATE(4626)] = 167669,
  [SMALL_STATE(4627)] = 167696,
  [SMALL_STATE(4628)] = 167725,
  [SMALL_STATE(4629)] = 167752,
  [SMALL_STATE(4630)] = 167779,
  [SMALL_STATE(4631)] = 167806,
  [SMALL_STATE(4632)] = 167833,
  [SMALL_STATE(4633)] = 167860,
  [SMALL_STATE(4634)] = 167887,
  [SMALL_STATE(4635)] = 167914,
  [SMALL_STATE(4636)] = 167941,
  [SMALL_STATE(4637)] = 167968,
  [SMALL_STATE(4638)] = 167995,
  [SMALL_STATE(4639)] = 168022,
  [SMALL_STATE(4640)] = 168049,
  [SMALL_STATE(4641)] = 168076,
  [SMALL_STATE(4642)] = 168103,
  [SMALL_STATE(4643)] = 168130,
  [SMALL_STATE(4644)] = 168157,
  [SMALL_STATE(4645)] = 168186,
  [SMALL_STATE(4646)] = 168213,
  [SMALL_STATE(4647)] = 168240,
  [SMALL_STATE(4648)] = 168267,
  [SMALL_STATE(4649)] = 168294,
  [SMALL_STATE(4650)] = 168321,
  [SMALL_STATE(4651)] = 168348,
  [SMALL_STATE(4652)] = 168375,
  [SMALL_STATE(4653)] = 168402,
  [SMALL_STATE(4654)] = 168439,
  [SMALL_STATE(4655)] = 168466,
  [SMALL_STATE(4656)] = 168503,
  [SMALL_STATE(4657)] = 168530,
  [SMALL_STATE(4658)] = 168557,
  [SMALL_STATE(4659)] = 168584,
  [SMALL_STATE(4660)] = 168611,
  [SMALL_STATE(4661)] = 168638,
  [SMALL_STATE(4662)] = 168667,
  [SMALL_STATE(4663)] = 168694,
  [SMALL_STATE(4664)] = 168723,
  [SMALL_STATE(4665)] = 168752,
  [SMALL_STATE(4666)] = 168779,
  [SMALL_STATE(4667)] = 168806,
  [SMALL_STATE(4668)] = 168833,
  [SMALL_STATE(4669)] = 168860,
  [SMALL_STATE(4670)] = 168887,
  [SMALL_STATE(4671)] = 168914,
  [SMALL_STATE(4672)] = 168945,
  [SMALL_STATE(4673)] = 168972,
  [SMALL_STATE(4674)] = 168999,
  [SMALL_STATE(4675)] = 169027,
  [SMALL_STATE(4676)] = 169055,
  [SMALL_STATE(4677)] = 169083,
  [SMALL_STATE(4678)] = 169111,
  [SMALL_STATE(4679)] = 169141,
  [SMALL_STATE(4680)] = 169169,
  [SMALL_STATE(4681)] = 169197,
  [SMALL_STATE(4682)] = 169227,
  [SMALL_STATE(4683)] = 169255,
  [SMALL_STATE(4684)] = 169283,
  [SMALL_STATE(4685)] = 169311,
  [SMALL_STATE(4686)] = 169339,
  [SMALL_STATE(4687)] = 169371,
  [SMALL_STATE(4688)] = 169399,
  [SMALL_STATE(4689)] = 169427,
  [SMALL_STATE(4690)] = 169453,
  [SMALL_STATE(4691)] = 169481,
  [SMALL_STATE(4692)] = 169509,
  [SMALL_STATE(4693)] = 169537,
  [SMALL_STATE(4694)] = 169560,
  [SMALL_STATE(4695)] = 169583,
  [SMALL_STATE(4696)] = 169606,
  [SMALL_STATE(4697)] = 169629,
  [SMALL_STATE(4698)] = 169652,
  [SMALL_STATE(4699)] = 169677,
  [SMALL_STATE(4700)] = 169706,
  [SMALL_STATE(4701)] = 169733,
  [SMALL_STATE(4702)] = 169756,
  [SMALL_STATE(4703)] = 169779,
  [SMALL_STATE(4704)] = 169802,
  [SMALL_STATE(4705)] = 169825,
  [SMALL_STATE(4706)] = 169848,
  [SMALL_STATE(4707)] = 169871,
  [SMALL_STATE(4708)] = 169894,
  [SMALL_STATE(4709)] = 169921,
  [SMALL_STATE(4710)] = 169956,
  [SMALL_STATE(4711)] = 169983,
  [SMALL_STATE(4712)] = 170006,
  [SMALL_STATE(4713)] = 170033,
  [SMALL_STATE(4714)] = 170072,
  [SMALL_STATE(4715)] = 170099,
  [SMALL_STATE(4716)] = 170124,
  [SMALL_STATE(4717)] = 170159,
  [SMALL_STATE(4718)] = 170184,
  [SMALL_STATE(4719)] = 170211,
  [SMALL_STATE(4720)] = 170234,
  [SMALL_STATE(4721)] = 170257,
  [SMALL_STATE(4722)] = 170282,
  [SMALL_STATE(4723)] = 170305,
  [SMALL_STATE(4724)] = 170330,
  [SMALL_STATE(4725)] = 170353,
  [SMALL_STATE(4726)] = 170380,
  [SMALL_STATE(4727)] = 170403,
  [SMALL_STATE(4728)] = 170426,
  [SMALL_STATE(4729)] = 170449,
  [SMALL_STATE(4730)] = 170474,
  [SMALL_STATE(4731)] = 170509,
  [SMALL_STATE(4732)] = 170544,
  [SMALL_STATE(4733)] = 170583,
  [SMALL_STATE(4734)] = 170618,
  [SMALL_STATE(4735)] = 170643,
  [SMALL_STATE(4736)] = 170666,
  [SMALL_STATE(4737)] = 170691,
  [SMALL_STATE(4738)] = 170714,
  [SMALL_STATE(4739)] = 170737,
  [SMALL_STATE(4740)] = 170764,
  [SMALL_STATE(4741)] = 170789,
  [SMALL_STATE(4742)] = 170814,
  [SMALL_STATE(4743)] = 170837,
  [SMALL_STATE(4744)] = 170864,
  [SMALL_STATE(4745)] = 170887,
  [SMALL_STATE(4746)] = 170912,
  [SMALL_STATE(4747)] = 170937,
  [SMALL_STATE(4748)] = 170960,
  [SMALL_STATE(4749)] = 170987,
  [SMALL_STATE(4750)] = 171010,
  [SMALL_STATE(4751)] = 171033,
  [SMALL_STATE(4752)] = 171060,
  [SMALL_STATE(4753)] = 171085,
  [SMALL_STATE(4754)] = 171108,
  [SMALL_STATE(4755)] = 171133,
  [SMALL_STATE(4756)] = 171160,
  [SMALL_STATE(4757)] = 171183,
  [SMALL_STATE(4758)] = 171206,
  [SMALL_STATE(4759)] = 171231,
  [SMALL_STATE(4760)] = 171256,
  [SMALL_STATE(4761)] = 171279,
  [SMALL_STATE(4762)] = 171306,
  [SMALL_STATE(4763)] = 171329,
  [SMALL_STATE(4764)] = 171353,
  [SMALL_STATE(4765)] = 171383,
  [SMALL_STATE(4766)] = 171411,
  [SMALL_STATE(4767)] = 171433,
  [SMALL_STATE(4768)] = 171463,
  [SMALL_STATE(4769)] = 171485,
  [SMALL_STATE(4770)] = 171521,
  [SMALL_STATE(4771)] = 171555,
  [SMALL_STATE(4772)] = 171579,
  [SMALL_STATE(4773)] = 171601,
  [SMALL_STATE(4774)] = 171639,
  [SMALL_STATE(4775)] = 171677,
  [SMALL_STATE(4776)] = 171703,
  [SMALL_STATE(4777)] = 171727,
  [SMALL_STATE(4778)] = 171765,
  [SMALL_STATE(4779)] = 171803,
  [SMALL_STATE(4780)] = 171827,
  [SMALL_STATE(4781)] = 171865,
  [SMALL_STATE(4782)] = 171887,
  [SMALL_STATE(4783)] = 171911,
  [SMALL_STATE(4784)] = 171935,
  [SMALL_STATE(4785)] = 171959,
  [SMALL_STATE(4786)] = 171981,
  [SMALL_STATE(4787)] = 172003,
  [SMALL_STATE(4788)] = 172041,
  [SMALL_STATE(4789)] = 172079,
  [SMALL_STATE(4790)] = 172105,
  [SMALL_STATE(4791)] = 172127,
  [SMALL_STATE(4792)] = 172165,
  [SMALL_STATE(4793)] = 172203,
  [SMALL_STATE(4794)] = 172241,
  [SMALL_STATE(4795)] = 172263,
  [SMALL_STATE(4796)] = 172285,
  [SMALL_STATE(4797)] = 172323,
  [SMALL_STATE(4798)] = 172345,
  [SMALL_STATE(4799)] = 172369,
  [SMALL_STATE(4800)] = 172393,
  [SMALL_STATE(4801)] = 172417,
  [SMALL_STATE(4802)] = 172455,
  [SMALL_STATE(4803)] = 172479,
  [SMALL_STATE(4804)] = 172505,
  [SMALL_STATE(4805)] = 172533,
  [SMALL_STATE(4806)] = 172571,
  [SMALL_STATE(4807)] = 172593,
  [SMALL_STATE(4808)] = 172615,
  [SMALL_STATE(4809)] = 172639,
  [SMALL_STATE(4810)] = 172663,
  [SMALL_STATE(4811)] = 172688,
  [SMALL_STATE(4812)] = 172725,
  [SMALL_STATE(4813)] = 172762,
  [SMALL_STATE(4814)] = 172799,
  [SMALL_STATE(4815)] = 172836,
  [SMALL_STATE(4816)] = 172861,
  [SMALL_STATE(4817)] = 172898,
  [SMALL_STATE(4818)] = 172935,
  [SMALL_STATE(4819)] = 172958,
  [SMALL_STATE(4820)] = 172981,
  [SMALL_STATE(4821)] = 173018,
  [SMALL_STATE(4822)] = 173055,
  [SMALL_STATE(4823)] = 173076,
  [SMALL_STATE(4824)] = 173099,
  [SMALL_STATE(4825)] = 173124,
  [SMALL_STATE(4826)] = 173145,
  [SMALL_STATE(4827)] = 173182,
  [SMALL_STATE(4828)] = 173207,
  [SMALL_STATE(4829)] = 173228,
  [SMALL_STATE(4830)] = 173253,
  [SMALL_STATE(4831)] = 173278,
  [SMALL_STATE(4832)] = 173315,
  [SMALL_STATE(4833)] = 173340,
  [SMALL_STATE(4834)] = 173377,
  [SMALL_STATE(4835)] = 173414,
  [SMALL_STATE(4836)] = 173451,
  [SMALL_STATE(4837)] = 173476,
  [SMALL_STATE(4838)] = 173501,
  [SMALL_STATE(4839)] = 173522,
  [SMALL_STATE(4840)] = 173559,
  [SMALL_STATE(4841)] = 173582,
  [SMALL_STATE(4842)] = 173603,
  [SMALL_STATE(4843)] = 173628,
  [SMALL_STATE(4844)] = 173665,
  [SMALL_STATE(4845)] = 173686,
  [SMALL_STATE(4846)] = 173711,
  [SMALL_STATE(4847)] = 173736,
  [SMALL_STATE(4848)] = 173773,
  [SMALL_STATE(4849)] = 173796,
  [SMALL_STATE(4850)] = 173821,
  [SMALL_STATE(4851)] = 173844,
  [SMALL_STATE(4852)] = 173881,
  [SMALL_STATE(4853)] = 173918,
  [SMALL_STATE(4854)] = 173941,
  [SMALL_STATE(4855)] = 173964,
  [SMALL_STATE(4856)] = 174001,
  [SMALL_STATE(4857)] = 174038,
  [SMALL_STATE(4858)] = 174075,
  [SMALL_STATE(4859)] = 174112,
  [SMALL_STATE(4860)] = 174149,
  [SMALL_STATE(4861)] = 174170,
  [SMALL_STATE(4862)] = 174207,
  [SMALL_STATE(4863)] = 174244,
  [SMALL_STATE(4864)] = 174269,
  [SMALL_STATE(4865)] = 174306,
  [SMALL_STATE(4866)] = 174340,
  [SMALL_STATE(4867)] = 174374,
  [SMALL_STATE(4868)] = 174394,
  [SMALL_STATE(4869)] = 174428,
  [SMALL_STATE(4870)] = 174462,
  [SMALL_STATE(4871)] = 174490,
  [SMALL_STATE(4872)] = 174510,
  [SMALL_STATE(4873)] = 174530,
  [SMALL_STATE(4874)] = 174550,
  [SMALL_STATE(4875)] = 174570,
  [SMALL_STATE(4876)] = 174594,
  [SMALL_STATE(4877)] = 174614,
  [SMALL_STATE(4878)] = 174638,
  [SMALL_STATE(4879)] = 174662,
  [SMALL_STATE(4880)] = 174682,
  [SMALL_STATE(4881)] = 174702,
  [SMALL_STATE(4882)] = 174726,
  [SMALL_STATE(4883)] = 174746,
  [SMALL_STATE(4884)] = 174766,
  [SMALL_STATE(4885)] = 174790,
  [SMALL_STATE(4886)] = 174818,
  [SMALL_STATE(4887)] = 174838,
  [SMALL_STATE(4888)] = 174860,
  [SMALL_STATE(4889)] = 174880,
  [SMALL_STATE(4890)] = 174900,
  [SMALL_STATE(4891)] = 174934,
  [SMALL_STATE(4892)] = 174954,
  [SMALL_STATE(4893)] = 174978,
  [SMALL_STATE(4894)] = 174998,
  [SMALL_STATE(4895)] = 175018,
  [SMALL_STATE(4896)] = 175038,
  [SMALL_STATE(4897)] = 175058,
  [SMALL_STATE(4898)] = 175090,
  [SMALL_STATE(4899)] = 175124,
  [SMALL_STATE(4900)] = 175146,
  [SMALL_STATE(4901)] = 175176,
  [SMALL_STATE(4902)] = 175210,
  [SMALL_STATE(4903)] = 175244,
  [SMALL_STATE(4904)] = 175278,
  [SMALL_STATE(4905)] = 175298,
  [SMALL_STATE(4906)] = 175318,
  [SMALL_STATE(4907)] = 175352,
  [SMALL_STATE(4908)] = 175372,
  [SMALL_STATE(4909)] = 175392,
  [SMALL_STATE(4910)] = 175426,
  [SMALL_STATE(4911)] = 175456,
  [SMALL_STATE(4912)] = 175476,
  [SMALL_STATE(4913)] = 175510,
  [SMALL_STATE(4914)] = 175540,
  [SMALL_STATE(4915)] = 175568,
  [SMALL_STATE(4916)] = 175596,
  [SMALL_STATE(4917)] = 175620,
  [SMALL_STATE(4918)] = 175644,
  [SMALL_STATE(4919)] = 175678,
  [SMALL_STATE(4920)] = 175700,
  [SMALL_STATE(4921)] = 175722,
  [SMALL_STATE(4922)] = 175754,
  [SMALL_STATE(4923)] = 175776,
  [SMALL_STATE(4924)] = 175810,
  [SMALL_STATE(4925)] = 175844,
  [SMALL_STATE(4926)] = 175876,
  [SMALL_STATE(4927)] = 175896,
  [SMALL_STATE(4928)] = 175924,
  [SMALL_STATE(4929)] = 175958,
  [SMALL_STATE(4930)] = 175986,
  [SMALL_STATE(4931)] = 176020,
  [SMALL_STATE(4932)] = 176042,
  [SMALL_STATE(4933)] = 176066,
  [SMALL_STATE(4934)] = 176086,
  [SMALL_STATE(4935)] = 176114,
  [SMALL_STATE(4936)] = 176148,
  [SMALL_STATE(4937)] = 176182,
  [SMALL_STATE(4938)] = 176202,
  [SMALL_STATE(4939)] = 176236,
  [SMALL_STATE(4940)] = 176270,
  [SMALL_STATE(4941)] = 176290,
  [SMALL_STATE(4942)] = 176314,
  [SMALL_STATE(4943)] = 176334,
  [SMALL_STATE(4944)] = 176354,
  [SMALL_STATE(4945)] = 176376,
  [SMALL_STATE(4946)] = 176398,
  [SMALL_STATE(4947)] = 176420,
  [SMALL_STATE(4948)] = 176454,
  [SMALL_STATE(4949)] = 176483,
  [SMALL_STATE(4950)] = 176506,
  [SMALL_STATE(4951)] = 176525,
  [SMALL_STATE(4952)] = 176548,
  [SMALL_STATE(4953)] = 176577,
  [SMALL_STATE(4954)] = 176596,
  [SMALL_STATE(4955)] = 176623,
  [SMALL_STATE(4956)] = 176652,
  [SMALL_STATE(4957)] = 176681,
  [SMALL_STATE(4958)] = 176710,
  [SMALL_STATE(4959)] = 176737,
  [SMALL_STATE(4960)] = 176766,
  [SMALL_STATE(4961)] = 176793,
  [SMALL_STATE(4962)] = 176818,
  [SMALL_STATE(4963)] = 176845,
  [SMALL_STATE(4964)] = 176866,
  [SMALL_STATE(4965)] = 176895,
  [SMALL_STATE(4966)] = 176914,
  [SMALL_STATE(4967)] = 176941,
  [SMALL_STATE(4968)] = 176970,
  [SMALL_STATE(4969)] = 176999,
  [SMALL_STATE(4970)] = 177022,
  [SMALL_STATE(4971)] = 177051,
  [SMALL_STATE(4972)] = 177080,
  [SMALL_STATE(4973)] = 177109,
  [SMALL_STATE(4974)] = 177138,
  [SMALL_STATE(4975)] = 177167,
  [SMALL_STATE(4976)] = 177196,
  [SMALL_STATE(4977)] = 177223,
  [SMALL_STATE(4978)] = 177252,
  [SMALL_STATE(4979)] = 177281,
  [SMALL_STATE(4980)] = 177310,
  [SMALL_STATE(4981)] = 177337,
  [SMALL_STATE(4982)] = 177364,
  [SMALL_STATE(4983)] = 177393,
  [SMALL_STATE(4984)] = 177422,
  [SMALL_STATE(4985)] = 177451,
  [SMALL_STATE(4986)] = 177480,
  [SMALL_STATE(4987)] = 177509,
  [SMALL_STATE(4988)] = 177538,
  [SMALL_STATE(4989)] = 177567,
  [SMALL_STATE(4990)] = 177596,
  [SMALL_STATE(4991)] = 177623,
  [SMALL_STATE(4992)] = 177642,
  [SMALL_STATE(4993)] = 177671,
  [SMALL_STATE(4994)] = 177700,
  [SMALL_STATE(4995)] = 177727,
  [SMALL_STATE(4996)] = 177754,
  [SMALL_STATE(4997)] = 177781,
  [SMALL_STATE(4998)] = 177810,
  [SMALL_STATE(4999)] = 177831,
  [SMALL_STATE(5000)] = 177860,
  [SMALL_STATE(5001)] = 177887,
  [SMALL_STATE(5002)] = 177916,
  [SMALL_STATE(5003)] = 177945,
  [SMALL_STATE(5004)] = 177974,
  [SMALL_STATE(5005)] = 177993,
  [SMALL_STATE(5006)] = 178022,
  [SMALL_STATE(5007)] = 178049,
  [SMALL_STATE(5008)] = 178072,
  [SMALL_STATE(5009)] = 178091,
  [SMALL_STATE(5010)] = 178114,
  [SMALL_STATE(5011)] = 178143,
  [SMALL_STATE(5012)] = 178172,
  [SMALL_STATE(5013)] = 178201,
  [SMALL_STATE(5014)] = 178230,
  [SMALL_STATE(5015)] = 178259,
  [SMALL_STATE(5016)] = 178286,
  [SMALL_STATE(5017)] = 178309,
  [SMALL_STATE(5018)] = 178338,
  [SMALL_STATE(5019)] = 178367,
  [SMALL_STATE(5020)] = 178392,
  [SMALL_STATE(5021)] = 178419,
  [SMALL_STATE(5022)] = 178448,
  [SMALL_STATE(5023)] = 178477,
  [SMALL_STATE(5024)] = 178504,
  [SMALL_STATE(5025)] = 178531,
  [SMALL_STATE(5026)] = 178560,
  [SMALL_STATE(5027)] = 178581,
  [SMALL_STATE(5028)] = 178610,
  [SMALL_STATE(5029)] = 178637,
  [SMALL_STATE(5030)] = 178666,
  [SMALL_STATE(5031)] = 178695,
  [SMALL_STATE(5032)] = 178724,
  [SMALL_STATE(5033)] = 178751,
  [SMALL_STATE(5034)] = 178780,
  [SMALL_STATE(5035)] = 178809,
  [SMALL_STATE(5036)] = 178838,
  [SMALL_STATE(5037)] = 178867,
  [SMALL_STATE(5038)] = 178896,
  [SMALL_STATE(5039)] = 178923,
  [SMALL_STATE(5040)] = 178952,
  [SMALL_STATE(5041)] = 178981,
  [SMALL_STATE(5042)] = 179008,
  [SMALL_STATE(5043)] = 179035,
  [SMALL_STATE(5044)] = 179062,
  [SMALL_STATE(5045)] = 179083,
  [SMALL_STATE(5046)] = 179112,
  [SMALL_STATE(5047)] = 179141,
  [SMALL_STATE(5048)] = 179170,
  [SMALL_STATE(5049)] = 179199,
  [SMALL_STATE(5050)] = 179226,
  [SMALL_STATE(5051)] = 179255,
  [SMALL_STATE(5052)] = 179282,
  [SMALL_STATE(5053)] = 179309,
  [SMALL_STATE(5054)] = 179338,
  [SMALL_STATE(5055)] = 179367,
  [SMALL_STATE(5056)] = 179394,
  [SMALL_STATE(5057)] = 179423,
  [SMALL_STATE(5058)] = 179452,
  [SMALL_STATE(5059)] = 179479,
  [SMALL_STATE(5060)] = 179506,
  [SMALL_STATE(5061)] = 179529,
  [SMALL_STATE(5062)] = 179558,
  [SMALL_STATE(5063)] = 179587,
  [SMALL_STATE(5064)] = 179614,
  [SMALL_STATE(5065)] = 179641,
  [SMALL_STATE(5066)] = 179670,
  [SMALL_STATE(5067)] = 179699,
  [SMALL_STATE(5068)] = 179728,
  [SMALL_STATE(5069)] = 179757,
  [SMALL_STATE(5070)] = 179786,
  [SMALL_STATE(5071)] = 179813,
  [SMALL_STATE(5072)] = 179842,
  [SMALL_STATE(5073)] = 179871,
  [SMALL_STATE(5074)] = 179900,
  [SMALL_STATE(5075)] = 179929,
  [SMALL_STATE(5076)] = 179958,
  [SMALL_STATE(5077)] = 179985,
  [SMALL_STATE(5078)] = 180014,
  [SMALL_STATE(5079)] = 180033,
  [SMALL_STATE(5080)] = 180062,
  [SMALL_STATE(5081)] = 180089,
  [SMALL_STATE(5082)] = 180116,
  [SMALL_STATE(5083)] = 180143,
  [SMALL_STATE(5084)] = 180172,
  [SMALL_STATE(5085)] = 180201,
  [SMALL_STATE(5086)] = 180228,
  [SMALL_STATE(5087)] = 180255,
  [SMALL_STATE(5088)] = 180282,
  [SMALL_STATE(5089)] = 180309,
  [SMALL_STATE(5090)] = 180336,
  [SMALL_STATE(5091)] = 180363,
  [SMALL_STATE(5092)] = 180390,
  [SMALL_STATE(5093)] = 180417,
  [SMALL_STATE(5094)] = 180446,
  [SMALL_STATE(5095)] = 180475,
  [SMALL_STATE(5096)] = 180502,
  [SMALL_STATE(5097)] = 180529,
  [SMALL_STATE(5098)] = 180558,
  [SMALL_STATE(5099)] = 180585,
  [SMALL_STATE(5100)] = 180612,
  [SMALL_STATE(5101)] = 180641,
  [SMALL_STATE(5102)] = 180670,
  [SMALL_STATE(5103)] = 180699,
  [SMALL_STATE(5104)] = 180728,
  [SMALL_STATE(5105)] = 180757,
  [SMALL_STATE(5106)] = 180786,
  [SMALL_STATE(5107)] = 180815,
  [SMALL_STATE(5108)] = 180844,
  [SMALL_STATE(5109)] = 180865,
  [SMALL_STATE(5110)] = 180893,
  [SMALL_STATE(5111)] = 180917,
  [SMALL_STATE(5112)] = 180943,
  [SMALL_STATE(5113)] = 180963,
  [SMALL_STATE(5114)] = 180989,
  [SMALL_STATE(5115)] = 181017,
  [SMALL_STATE(5116)] = 181037,
  [SMALL_STATE(5117)] = 181057,
  [SMALL_STATE(5118)] = 181085,
  [SMALL_STATE(5119)] = 181109,
  [SMALL_STATE(5120)] = 181133,
  [SMALL_STATE(5121)] = 181153,
  [SMALL_STATE(5122)] = 181181,
  [SMALL_STATE(5123)] = 181203,
  [SMALL_STATE(5124)] = 181225,
  [SMALL_STATE(5125)] = 181243,
  [SMALL_STATE(5126)] = 181271,
  [SMALL_STATE(5127)] = 181299,
  [SMALL_STATE(5128)] = 181317,
  [SMALL_STATE(5129)] = 181345,
  [SMALL_STATE(5130)] = 181373,
  [SMALL_STATE(5131)] = 181401,
  [SMALL_STATE(5132)] = 181429,
  [SMALL_STATE(5133)] = 181447,
  [SMALL_STATE(5134)] = 181467,
  [SMALL_STATE(5135)] = 181485,
  [SMALL_STATE(5136)] = 181505,
  [SMALL_STATE(5137)] = 181533,
  [SMALL_STATE(5138)] = 181561,
  [SMALL_STATE(5139)] = 181589,
  [SMALL_STATE(5140)] = 181617,
  [SMALL_STATE(5141)] = 181645,
  [SMALL_STATE(5142)] = 181673,
  [SMALL_STATE(5143)] = 181693,
  [SMALL_STATE(5144)] = 181713,
  [SMALL_STATE(5145)] = 181735,
  [SMALL_STATE(5146)] = 181759,
  [SMALL_STATE(5147)] = 181781,
  [SMALL_STATE(5148)] = 181803,
  [SMALL_STATE(5149)] = 181827,
  [SMALL_STATE(5150)] = 181845,
  [SMALL_STATE(5151)] = 181869,
  [SMALL_STATE(5152)] = 181891,
  [SMALL_STATE(5153)] = 181913,
  [SMALL_STATE(5154)] = 181931,
  [SMALL_STATE(5155)] = 181955,
  [SMALL_STATE(5156)] = 181977,
  [SMALL_STATE(5157)] = 181999,
  [SMALL_STATE(5158)] = 182027,
  [SMALL_STATE(5159)] = 182047,
  [SMALL_STATE(5160)] = 182067,
  [SMALL_STATE(5161)] = 182087,
  [SMALL_STATE(5162)] = 182109,
  [SMALL_STATE(5163)] = 182127,
  [SMALL_STATE(5164)] = 182145,
  [SMALL_STATE(5165)] = 182163,
  [SMALL_STATE(5166)] = 182191,
  [SMALL_STATE(5167)] = 182219,
  [SMALL_STATE(5168)] = 182247,
  [SMALL_STATE(5169)] = 182265,
  [SMALL_STATE(5170)] = 182283,
  [SMALL_STATE(5171)] = 182311,
  [SMALL_STATE(5172)] = 182335,
  [SMALL_STATE(5173)] = 182363,
  [SMALL_STATE(5174)] = 182391,
  [SMALL_STATE(5175)] = 182419,
  [SMALL_STATE(5176)] = 182447,
  [SMALL_STATE(5177)] = 182475,
  [SMALL_STATE(5178)] = 182503,
  [SMALL_STATE(5179)] = 182523,
  [SMALL_STATE(5180)] = 182551,
  [SMALL_STATE(5181)] = 182579,
  [SMALL_STATE(5182)] = 182607,
  [SMALL_STATE(5183)] = 182635,
  [SMALL_STATE(5184)] = 182663,
  [SMALL_STATE(5185)] = 182691,
  [SMALL_STATE(5186)] = 182710,
  [SMALL_STATE(5187)] = 182731,
  [SMALL_STATE(5188)] = 182752,
  [SMALL_STATE(5189)] = 182773,
  [SMALL_STATE(5190)] = 182792,
  [SMALL_STATE(5191)] = 182809,
  [SMALL_STATE(5192)] = 182830,
  [SMALL_STATE(5193)] = 182853,
  [SMALL_STATE(5194)] = 182872,
  [SMALL_STATE(5195)] = 182891,
  [SMALL_STATE(5196)] = 182914,
  [SMALL_STATE(5197)] = 182937,
  [SMALL_STATE(5198)] = 182960,
  [SMALL_STATE(5199)] = 182983,
  [SMALL_STATE(5200)] = 183006,
  [SMALL_STATE(5201)] = 183023,
  [SMALL_STATE(5202)] = 183042,
  [SMALL_STATE(5203)] = 183063,
  [SMALL_STATE(5204)] = 183082,
  [SMALL_STATE(5205)] = 183101,
  [SMALL_STATE(5206)] = 183124,
  [SMALL_STATE(5207)] = 183147,
  [SMALL_STATE(5208)] = 183170,
  [SMALL_STATE(5209)] = 183189,
  [SMALL_STATE(5210)] = 183208,
  [SMALL_STATE(5211)] = 183227,
  [SMALL_STATE(5212)] = 183244,
  [SMALL_STATE(5213)] = 183267,
  [SMALL_STATE(5214)] = 183286,
  [SMALL_STATE(5215)] = 183309,
  [SMALL_STATE(5216)] = 183332,
  [SMALL_STATE(5217)] = 183351,
  [SMALL_STATE(5218)] = 183372,
  [SMALL_STATE(5219)] = 183393,
  [SMALL_STATE(5220)] = 183412,
  [SMALL_STATE(5221)] = 183435,
  [SMALL_STATE(5222)] = 183452,
  [SMALL_STATE(5223)] = 183468,
  [SMALL_STATE(5224)] = 183484,
  [SMALL_STATE(5225)] = 183500,
  [SMALL_STATE(5226)] = 183518,
  [SMALL_STATE(5227)] = 183534,
  [SMALL_STATE(5228)] = 183550,
  [SMALL_STATE(5229)] = 183566,
  [SMALL_STATE(5230)] = 183582,
  [SMALL_STATE(5231)] = 183598,
  [SMALL_STATE(5232)] = 183614,
  [SMALL_STATE(5233)] = 183630,
  [SMALL_STATE(5234)] = 183646,
  [SMALL_STATE(5235)] = 183662,
  [SMALL_STATE(5236)] = 183678,
  [SMALL_STATE(5237)] = 183694,
  [SMALL_STATE(5238)] = 183710,
  [SMALL_STATE(5239)] = 183726,
  [SMALL_STATE(5240)] = 183742,
  [SMALL_STATE(5241)] = 183758,
  [SMALL_STATE(5242)] = 183776,
  [SMALL_STATE(5243)] = 183794,
  [SMALL_STATE(5244)] = 183810,
  [SMALL_STATE(5245)] = 183826,
  [SMALL_STATE(5246)] = 183842,
  [SMALL_STATE(5247)] = 183858,
  [SMALL_STATE(5248)] = 183874,
  [SMALL_STATE(5249)] = 183890,
  [SMALL_STATE(5250)] = 183906,
  [SMALL_STATE(5251)] = 183922,
  [SMALL_STATE(5252)] = 183938,
  [SMALL_STATE(5253)] = 183954,
  [SMALL_STATE(5254)] = 183972,
  [SMALL_STATE(5255)] = 183988,
  [SMALL_STATE(5256)] = 184006,
  [SMALL_STATE(5257)] = 184022,
  [SMALL_STATE(5258)] = 184038,
  [SMALL_STATE(5259)] = 184054,
  [SMALL_STATE(5260)] = 184070,
  [SMALL_STATE(5261)] = 184086,
  [SMALL_STATE(5262)] = 184102,
  [SMALL_STATE(5263)] = 184118,
  [SMALL_STATE(5264)] = 184134,
  [SMALL_STATE(5265)] = 184154,
  [SMALL_STATE(5266)] = 184170,
  [SMALL_STATE(5267)] = 184186,
  [SMALL_STATE(5268)] = 184202,
  [SMALL_STATE(5269)] = 184220,
  [SMALL_STATE(5270)] = 184240,
  [SMALL_STATE(5271)] = 184260,
  [SMALL_STATE(5272)] = 184276,
  [SMALL_STATE(5273)] = 184292,
  [SMALL_STATE(5274)] = 184312,
  [SMALL_STATE(5275)] = 184328,
  [SMALL_STATE(5276)] = 184346,
  [SMALL_STATE(5277)] = 184362,
  [SMALL_STATE(5278)] = 184378,
  [SMALL_STATE(5279)] = 184396,
  [SMALL_STATE(5280)] = 184412,
  [SMALL_STATE(5281)] = 184428,
  [SMALL_STATE(5282)] = 184444,
  [SMALL_STATE(5283)] = 184460,
  [SMALL_STATE(5284)] = 184478,
  [SMALL_STATE(5285)] = 184494,
  [SMALL_STATE(5286)] = 184510,
  [SMALL_STATE(5287)] = 184526,
  [SMALL_STATE(5288)] = 184542,
  [SMALL_STATE(5289)] = 184558,
  [SMALL_STATE(5290)] = 184574,
  [SMALL_STATE(5291)] = 184590,
  [SMALL_STATE(5292)] = 184606,
  [SMALL_STATE(5293)] = 184626,
  [SMALL_STATE(5294)] = 184642,
  [SMALL_STATE(5295)] = 184658,
  [SMALL_STATE(5296)] = 184674,
  [SMALL_STATE(5297)] = 184690,
  [SMALL_STATE(5298)] = 184706,
  [SMALL_STATE(5299)] = 184722,
  [SMALL_STATE(5300)] = 184738,
  [SMALL_STATE(5301)] = 184754,
  [SMALL_STATE(5302)] = 184770,
  [SMALL_STATE(5303)] = 184792,
  [SMALL_STATE(5304)] = 184808,
  [SMALL_STATE(5305)] = 184824,
  [SMALL_STATE(5306)] = 184840,
  [SMALL_STATE(5307)] = 184856,
  [SMALL_STATE(5308)] = 184872,
  [SMALL_STATE(5309)] = 184888,
  [SMALL_STATE(5310)] = 184904,
  [SMALL_STATE(5311)] = 184920,
  [SMALL_STATE(5312)] = 184940,
  [SMALL_STATE(5313)] = 184956,
  [SMALL_STATE(5314)] = 184972,
  [SMALL_STATE(5315)] = 184988,
  [SMALL_STATE(5316)] = 185008,
  [SMALL_STATE(5317)] = 185028,
  [SMALL_STATE(5318)] = 185046,
  [SMALL_STATE(5319)] = 185062,
  [SMALL_STATE(5320)] = 185084,
  [SMALL_STATE(5321)] = 185100,
  [SMALL_STATE(5322)] = 185116,
  [SMALL_STATE(5323)] = 185132,
  [SMALL_STATE(5324)] = 185148,
  [SMALL_STATE(5325)] = 185164,
  [SMALL_STATE(5326)] = 185180,
  [SMALL_STATE(5327)] = 185200,
  [SMALL_STATE(5328)] = 185216,
  [SMALL_STATE(5329)] = 185232,
  [SMALL_STATE(5330)] = 185248,
  [SMALL_STATE(5331)] = 185264,
  [SMALL_STATE(5332)] = 185282,
  [SMALL_STATE(5333)] = 185298,
  [SMALL_STATE(5334)] = 185314,
  [SMALL_STATE(5335)] = 185330,
  [SMALL_STATE(5336)] = 185346,
  [SMALL_STATE(5337)] = 185362,
  [SMALL_STATE(5338)] = 185378,
  [SMALL_STATE(5339)] = 185394,
  [SMALL_STATE(5340)] = 185410,
  [SMALL_STATE(5341)] = 185426,
  [SMALL_STATE(5342)] = 185442,
  [SMALL_STATE(5343)] = 185460,
  [SMALL_STATE(5344)] = 185480,
  [SMALL_STATE(5345)] = 185496,
  [SMALL_STATE(5346)] = 185512,
  [SMALL_STATE(5347)] = 185528,
  [SMALL_STATE(5348)] = 185544,
  [SMALL_STATE(5349)] = 185560,
  [SMALL_STATE(5350)] = 185576,
  [SMALL_STATE(5351)] = 185592,
  [SMALL_STATE(5352)] = 185612,
  [SMALL_STATE(5353)] = 185632,
  [SMALL_STATE(5354)] = 185648,
  [SMALL_STATE(5355)] = 185664,
  [SMALL_STATE(5356)] = 185680,
  [SMALL_STATE(5357)] = 185696,
  [SMALL_STATE(5358)] = 185712,
  [SMALL_STATE(5359)] = 185728,
  [SMALL_STATE(5360)] = 185748,
  [SMALL_STATE(5361)] = 185764,
  [SMALL_STATE(5362)] = 185780,
  [SMALL_STATE(5363)] = 185800,
  [SMALL_STATE(5364)] = 185816,
  [SMALL_STATE(5365)] = 185834,
  [SMALL_STATE(5366)] = 185850,
  [SMALL_STATE(5367)] = 185870,
  [SMALL_STATE(5368)] = 185886,
  [SMALL_STATE(5369)] = 185902,
  [SMALL_STATE(5370)] = 185922,
  [SMALL_STATE(5371)] = 185938,
  [SMALL_STATE(5372)] = 185954,
  [SMALL_STATE(5373)] = 185970,
  [SMALL_STATE(5374)] = 185986,
  [SMALL_STATE(5375)] = 186002,
  [SMALL_STATE(5376)] = 186018,
  [SMALL_STATE(5377)] = 186038,
  [SMALL_STATE(5378)] = 186060,
  [SMALL_STATE(5379)] = 186076,
  [SMALL_STATE(5380)] = 186092,
  [SMALL_STATE(5381)] = 186108,
  [SMALL_STATE(5382)] = 186124,
  [SMALL_STATE(5383)] = 186140,
  [SMALL_STATE(5384)] = 186156,
  [SMALL_STATE(5385)] = 186176,
  [SMALL_STATE(5386)] = 186192,
  [SMALL_STATE(5387)] = 186208,
  [SMALL_STATE(5388)] = 186224,
  [SMALL_STATE(5389)] = 186240,
  [SMALL_STATE(5390)] = 186256,
  [SMALL_STATE(5391)] = 186272,
  [SMALL_STATE(5392)] = 186288,
  [SMALL_STATE(5393)] = 186304,
  [SMALL_STATE(5394)] = 186320,
  [SMALL_STATE(5395)] = 186336,
  [SMALL_STATE(5396)] = 186352,
  [SMALL_STATE(5397)] = 186374,
  [SMALL_STATE(5398)] = 186390,
  [SMALL_STATE(5399)] = 186406,
  [SMALL_STATE(5400)] = 186422,
  [SMALL_STATE(5401)] = 186438,
  [SMALL_STATE(5402)] = 186454,
  [SMALL_STATE(5403)] = 186470,
  [SMALL_STATE(5404)] = 186486,
  [SMALL_STATE(5405)] = 186502,
  [SMALL_STATE(5406)] = 186518,
  [SMALL_STATE(5407)] = 186537,
  [SMALL_STATE(5408)] = 186554,
  [SMALL_STATE(5409)] = 186571,
  [SMALL_STATE(5410)] = 186586,
  [SMALL_STATE(5411)] = 186605,
  [SMALL_STATE(5412)] = 186624,
  [SMALL_STATE(5413)] = 186641,
  [SMALL_STATE(5414)] = 186660,
  [SMALL_STATE(5415)] = 186679,
  [SMALL_STATE(5416)] = 186696,
  [SMALL_STATE(5417)] = 186715,
  [SMALL_STATE(5418)] = 186732,
  [SMALL_STATE(5419)] = 186751,
  [SMALL_STATE(5420)] = 186766,
  [SMALL_STATE(5421)] = 186785,
  [SMALL_STATE(5422)] = 186804,
  [SMALL_STATE(5423)] = 186823,
  [SMALL_STATE(5424)] = 186842,
  [SMALL_STATE(5425)] = 186861,
  [SMALL_STATE(5426)] = 186880,
  [SMALL_STATE(5427)] = 186895,
  [SMALL_STATE(5428)] = 186910,
  [SMALL_STATE(5429)] = 186929,
  [SMALL_STATE(5430)] = 186946,
  [SMALL_STATE(5431)] = 186961,
  [SMALL_STATE(5432)] = 186976,
  [SMALL_STATE(5433)] = 186993,
  [SMALL_STATE(5434)] = 187008,
  [SMALL_STATE(5435)] = 187023,
  [SMALL_STATE(5436)] = 187042,
  [SMALL_STATE(5437)] = 187061,
  [SMALL_STATE(5438)] = 187078,
  [SMALL_STATE(5439)] = 187097,
  [SMALL_STATE(5440)] = 187116,
  [SMALL_STATE(5441)] = 187135,
  [SMALL_STATE(5442)] = 187152,
  [SMALL_STATE(5443)] = 187171,
  [SMALL_STATE(5444)] = 187190,
  [SMALL_STATE(5445)] = 187205,
  [SMALL_STATE(5446)] = 187220,
  [SMALL_STATE(5447)] = 187239,
  [SMALL_STATE(5448)] = 187258,
  [SMALL_STATE(5449)] = 187277,
  [SMALL_STATE(5450)] = 187296,
  [SMALL_STATE(5451)] = 187315,
  [SMALL_STATE(5452)] = 187334,
  [SMALL_STATE(5453)] = 187351,
  [SMALL_STATE(5454)] = 187370,
  [SMALL_STATE(5455)] = 187389,
  [SMALL_STATE(5456)] = 187408,
  [SMALL_STATE(5457)] = 187427,
  [SMALL_STATE(5458)] = 187442,
  [SMALL_STATE(5459)] = 187461,
  [SMALL_STATE(5460)] = 187480,
  [SMALL_STATE(5461)] = 187499,
  [SMALL_STATE(5462)] = 187518,
  [SMALL_STATE(5463)] = 187533,
  [SMALL_STATE(5464)] = 187552,
  [SMALL_STATE(5465)] = 187571,
  [SMALL_STATE(5466)] = 187588,
  [SMALL_STATE(5467)] = 187607,
  [SMALL_STATE(5468)] = 187626,
  [SMALL_STATE(5469)] = 187645,
  [SMALL_STATE(5470)] = 187662,
  [SMALL_STATE(5471)] = 187677,
  [SMALL_STATE(5472)] = 187696,
  [SMALL_STATE(5473)] = 187715,
  [SMALL_STATE(5474)] = 187734,
  [SMALL_STATE(5475)] = 187749,
  [SMALL_STATE(5476)] = 187768,
  [SMALL_STATE(5477)] = 187787,
  [SMALL_STATE(5478)] = 187806,
  [SMALL_STATE(5479)] = 187825,
  [SMALL_STATE(5480)] = 187840,
  [SMALL_STATE(5481)] = 187859,
  [SMALL_STATE(5482)] = 187874,
  [SMALL_STATE(5483)] = 187893,
  [SMALL_STATE(5484)] = 187912,
  [SMALL_STATE(5485)] = 187931,
  [SMALL_STATE(5486)] = 187950,
  [SMALL_STATE(5487)] = 187969,
  [SMALL_STATE(5488)] = 187988,
  [SMALL_STATE(5489)] = 188005,
  [SMALL_STATE(5490)] = 188019,
  [SMALL_STATE(5491)] = 188033,
  [SMALL_STATE(5492)] = 188047,
  [SMALL_STATE(5493)] = 188061,
  [SMALL_STATE(5494)] = 188075,
  [SMALL_STATE(5495)] = 188091,
  [SMALL_STATE(5496)] = 188107,
  [SMALL_STATE(5497)] = 188121,
  [SMALL_STATE(5498)] = 188135,
  [SMALL_STATE(5499)] = 188149,
  [SMALL_STATE(5500)] = 188163,
  [SMALL_STATE(5501)] = 188177,
  [SMALL_STATE(5502)] = 188191,
  [SMALL_STATE(5503)] = 188205,
  [SMALL_STATE(5504)] = 188219,
  [SMALL_STATE(5505)] = 188233,
  [SMALL_STATE(5506)] = 188247,
  [SMALL_STATE(5507)] = 188261,
  [SMALL_STATE(5508)] = 188277,
  [SMALL_STATE(5509)] = 188291,
  [SMALL_STATE(5510)] = 188307,
  [SMALL_STATE(5511)] = 188321,
  [SMALL_STATE(5512)] = 188337,
  [SMALL_STATE(5513)] = 188351,
  [SMALL_STATE(5514)] = 188365,
  [SMALL_STATE(5515)] = 188381,
  [SMALL_STATE(5516)] = 188395,
  [SMALL_STATE(5517)] = 188409,
  [SMALL_STATE(5518)] = 188425,
  [SMALL_STATE(5519)] = 188439,
  [SMALL_STATE(5520)] = 188453,
  [SMALL_STATE(5521)] = 188467,
  [SMALL_STATE(5522)] = 188481,
  [SMALL_STATE(5523)] = 188495,
  [SMALL_STATE(5524)] = 188509,
  [SMALL_STATE(5525)] = 188523,
  [SMALL_STATE(5526)] = 188537,
  [SMALL_STATE(5527)] = 188553,
  [SMALL_STATE(5528)] = 188567,
  [SMALL_STATE(5529)] = 188581,
  [SMALL_STATE(5530)] = 188595,
  [SMALL_STATE(5531)] = 188609,
  [SMALL_STATE(5532)] = 188623,
  [SMALL_STATE(5533)] = 188637,
  [SMALL_STATE(5534)] = 188651,
  [SMALL_STATE(5535)] = 188665,
  [SMALL_STATE(5536)] = 188679,
  [SMALL_STATE(5537)] = 188693,
  [SMALL_STATE(5538)] = 188707,
  [SMALL_STATE(5539)] = 188721,
  [SMALL_STATE(5540)] = 188735,
  [SMALL_STATE(5541)] = 188749,
  [SMALL_STATE(5542)] = 188763,
  [SMALL_STATE(5543)] = 188777,
  [SMALL_STATE(5544)] = 188791,
  [SMALL_STATE(5545)] = 188805,
  [SMALL_STATE(5546)] = 188819,
  [SMALL_STATE(5547)] = 188833,
  [SMALL_STATE(5548)] = 188847,
  [SMALL_STATE(5549)] = 188861,
  [SMALL_STATE(5550)] = 188875,
  [SMALL_STATE(5551)] = 188891,
  [SMALL_STATE(5552)] = 188904,
  [SMALL_STATE(5553)] = 188917,
  [SMALL_STATE(5554)] = 188930,
  [SMALL_STATE(5555)] = 188943,
  [SMALL_STATE(5556)] = 188956,
  [SMALL_STATE(5557)] = 188969,
  [SMALL_STATE(5558)] = 188982,
  [SMALL_STATE(5559)] = 188995,
  [SMALL_STATE(5560)] = 189008,
  [SMALL_STATE(5561)] = 189021,
  [SMALL_STATE(5562)] = 189034,
  [SMALL_STATE(5563)] = 189047,
  [SMALL_STATE(5564)] = 189060,
  [SMALL_STATE(5565)] = 189073,
  [SMALL_STATE(5566)] = 189086,
  [SMALL_STATE(5567)] = 189099,
  [SMALL_STATE(5568)] = 189112,
  [SMALL_STATE(5569)] = 189125,
  [SMALL_STATE(5570)] = 189138,
  [SMALL_STATE(5571)] = 189151,
  [SMALL_STATE(5572)] = 189164,
  [SMALL_STATE(5573)] = 189177,
  [SMALL_STATE(5574)] = 189190,
  [SMALL_STATE(5575)] = 189203,
  [SMALL_STATE(5576)] = 189216,
  [SMALL_STATE(5577)] = 189229,
  [SMALL_STATE(5578)] = 189242,
  [SMALL_STATE(5579)] = 189255,
  [SMALL_STATE(5580)] = 189268,
  [SMALL_STATE(5581)] = 189281,
  [SMALL_STATE(5582)] = 189294,
  [SMALL_STATE(5583)] = 189307,
  [SMALL_STATE(5584)] = 189320,
  [SMALL_STATE(5585)] = 189333,
  [SMALL_STATE(5586)] = 189346,
  [SMALL_STATE(5587)] = 189359,
  [SMALL_STATE(5588)] = 189372,
  [SMALL_STATE(5589)] = 189385,
  [SMALL_STATE(5590)] = 189398,
  [SMALL_STATE(5591)] = 189411,
  [SMALL_STATE(5592)] = 189424,
  [SMALL_STATE(5593)] = 189437,
  [SMALL_STATE(5594)] = 189450,
  [SMALL_STATE(5595)] = 189463,
  [SMALL_STATE(5596)] = 189476,
  [SMALL_STATE(5597)] = 189489,
  [SMALL_STATE(5598)] = 189502,
  [SMALL_STATE(5599)] = 189515,
  [SMALL_STATE(5600)] = 189528,
  [SMALL_STATE(5601)] = 189541,
  [SMALL_STATE(5602)] = 189554,
  [SMALL_STATE(5603)] = 189567,
  [SMALL_STATE(5604)] = 189580,
  [SMALL_STATE(5605)] = 189593,
  [SMALL_STATE(5606)] = 189606,
  [SMALL_STATE(5607)] = 189619,
  [SMALL_STATE(5608)] = 189632,
  [SMALL_STATE(5609)] = 189645,
  [SMALL_STATE(5610)] = 189658,
  [SMALL_STATE(5611)] = 189671,
  [SMALL_STATE(5612)] = 189684,
  [SMALL_STATE(5613)] = 189697,
  [SMALL_STATE(5614)] = 189710,
  [SMALL_STATE(5615)] = 189723,
  [SMALL_STATE(5616)] = 189736,
  [SMALL_STATE(5617)] = 189749,
  [SMALL_STATE(5618)] = 189762,
  [SMALL_STATE(5619)] = 189775,
  [SMALL_STATE(5620)] = 189788,
  [SMALL_STATE(5621)] = 189801,
  [SMALL_STATE(5622)] = 189814,
  [SMALL_STATE(5623)] = 189827,
  [SMALL_STATE(5624)] = 189840,
  [SMALL_STATE(5625)] = 189853,
  [SMALL_STATE(5626)] = 189866,
  [SMALL_STATE(5627)] = 189879,
  [SMALL_STATE(5628)] = 189892,
  [SMALL_STATE(5629)] = 189905,
  [SMALL_STATE(5630)] = 189918,
  [SMALL_STATE(5631)] = 189931,
  [SMALL_STATE(5632)] = 189944,
  [SMALL_STATE(5633)] = 189957,
  [SMALL_STATE(5634)] = 189970,
  [SMALL_STATE(5635)] = 189983,
  [SMALL_STATE(5636)] = 189996,
  [SMALL_STATE(5637)] = 190009,
  [SMALL_STATE(5638)] = 190022,
  [SMALL_STATE(5639)] = 190035,
  [SMALL_STATE(5640)] = 190048,
  [SMALL_STATE(5641)] = 190061,
  [SMALL_STATE(5642)] = 190074,
  [SMALL_STATE(5643)] = 190087,
  [SMALL_STATE(5644)] = 190100,
  [SMALL_STATE(5645)] = 190113,
  [SMALL_STATE(5646)] = 190126,
  [SMALL_STATE(5647)] = 190139,
  [SMALL_STATE(5648)] = 190152,
  [SMALL_STATE(5649)] = 190165,
  [SMALL_STATE(5650)] = 190178,
  [SMALL_STATE(5651)] = 190191,
  [SMALL_STATE(5652)] = 190204,
  [SMALL_STATE(5653)] = 190217,
  [SMALL_STATE(5654)] = 190230,
  [SMALL_STATE(5655)] = 190243,
  [SMALL_STATE(5656)] = 190256,
  [SMALL_STATE(5657)] = 190269,
  [SMALL_STATE(5658)] = 190282,
  [SMALL_STATE(5659)] = 190295,
  [SMALL_STATE(5660)] = 190308,
  [SMALL_STATE(5661)] = 190321,
  [SMALL_STATE(5662)] = 190334,
  [SMALL_STATE(5663)] = 190347,
  [SMALL_STATE(5664)] = 190360,
  [SMALL_STATE(5665)] = 190373,
  [SMALL_STATE(5666)] = 190386,
  [SMALL_STATE(5667)] = 190399,
  [SMALL_STATE(5668)] = 190412,
  [SMALL_STATE(5669)] = 190425,
  [SMALL_STATE(5670)] = 190438,
  [SMALL_STATE(5671)] = 190451,
  [SMALL_STATE(5672)] = 190464,
  [SMALL_STATE(5673)] = 190477,
  [SMALL_STATE(5674)] = 190490,
  [SMALL_STATE(5675)] = 190503,
  [SMALL_STATE(5676)] = 190516,
  [SMALL_STATE(5677)] = 190529,
  [SMALL_STATE(5678)] = 190542,
  [SMALL_STATE(5679)] = 190555,
  [SMALL_STATE(5680)] = 190568,
  [SMALL_STATE(5681)] = 190581,
  [SMALL_STATE(5682)] = 190594,
  [SMALL_STATE(5683)] = 190607,
  [SMALL_STATE(5684)] = 190620,
  [SMALL_STATE(5685)] = 190633,
  [SMALL_STATE(5686)] = 190646,
  [SMALL_STATE(5687)] = 190659,
  [SMALL_STATE(5688)] = 190672,
  [SMALL_STATE(5689)] = 190685,
  [SMALL_STATE(5690)] = 190698,
  [SMALL_STATE(5691)] = 190711,
  [SMALL_STATE(5692)] = 190724,
  [SMALL_STATE(5693)] = 190737,
  [SMALL_STATE(5694)] = 190750,
  [SMALL_STATE(5695)] = 190763,
  [SMALL_STATE(5696)] = 190776,
  [SMALL_STATE(5697)] = 190789,
  [SMALL_STATE(5698)] = 190802,
  [SMALL_STATE(5699)] = 190815,
  [SMALL_STATE(5700)] = 190828,
  [SMALL_STATE(5701)] = 190841,
  [SMALL_STATE(5702)] = 190854,
  [SMALL_STATE(5703)] = 190867,
  [SMALL_STATE(5704)] = 190880,
  [SMALL_STATE(5705)] = 190893,
  [SMALL_STATE(5706)] = 190906,
  [SMALL_STATE(5707)] = 190919,
  [SMALL_STATE(5708)] = 190932,
  [SMALL_STATE(5709)] = 190945,
  [SMALL_STATE(5710)] = 190958,
  [SMALL_STATE(5711)] = 190971,
  [SMALL_STATE(5712)] = 190984,
  [SMALL_STATE(5713)] = 190997,
  [SMALL_STATE(5714)] = 191010,
  [SMALL_STATE(5715)] = 191023,
  [SMALL_STATE(5716)] = 191036,
  [SMALL_STATE(5717)] = 191049,
  [SMALL_STATE(5718)] = 191062,
  [SMALL_STATE(5719)] = 191075,
  [SMALL_STATE(5720)] = 191088,
  [SMALL_STATE(5721)] = 191101,
  [SMALL_STATE(5722)] = 191114,
  [SMALL_STATE(5723)] = 191127,
  [SMALL_STATE(5724)] = 191140,
  [SMALL_STATE(5725)] = 191153,
  [SMALL_STATE(5726)] = 191166,
  [SMALL_STATE(5727)] = 191179,
  [SMALL_STATE(5728)] = 191192,
  [SMALL_STATE(5729)] = 191205,
  [SMALL_STATE(5730)] = 191218,
  [SMALL_STATE(5731)] = 191231,
  [SMALL_STATE(5732)] = 191244,
  [SMALL_STATE(5733)] = 191257,
  [SMALL_STATE(5734)] = 191270,
  [SMALL_STATE(5735)] = 191283,
  [SMALL_STATE(5736)] = 191296,
  [SMALL_STATE(5737)] = 191309,
  [SMALL_STATE(5738)] = 191322,
  [SMALL_STATE(5739)] = 191335,
  [SMALL_STATE(5740)] = 191348,
  [SMALL_STATE(5741)] = 191361,
  [SMALL_STATE(5742)] = 191374,
  [SMALL_STATE(5743)] = 191387,
  [SMALL_STATE(5744)] = 191400,
  [SMALL_STATE(5745)] = 191413,
  [SMALL_STATE(5746)] = 191426,
  [SMALL_STATE(5747)] = 191439,
  [SMALL_STATE(5748)] = 191452,
  [SMALL_STATE(5749)] = 191465,
  [SMALL_STATE(5750)] = 191478,
  [SMALL_STATE(5751)] = 191491,
  [SMALL_STATE(5752)] = 191504,
  [SMALL_STATE(5753)] = 191517,
  [SMALL_STATE(5754)] = 191530,
  [SMALL_STATE(5755)] = 191543,
  [SMALL_STATE(5756)] = 191556,
  [SMALL_STATE(5757)] = 191569,
  [SMALL_STATE(5758)] = 191582,
  [SMALL_STATE(5759)] = 191595,
  [SMALL_STATE(5760)] = 191608,
  [SMALL_STATE(5761)] = 191621,
  [SMALL_STATE(5762)] = 191634,
  [SMALL_STATE(5763)] = 191647,
  [SMALL_STATE(5764)] = 191660,
  [SMALL_STATE(5765)] = 191673,
  [SMALL_STATE(5766)] = 191686,
  [SMALL_STATE(5767)] = 191699,
  [SMALL_STATE(5768)] = 191712,
  [SMALL_STATE(5769)] = 191725,
  [SMALL_STATE(5770)] = 191738,
  [SMALL_STATE(5771)] = 191751,
  [SMALL_STATE(5772)] = 191764,
  [SMALL_STATE(5773)] = 191777,
  [SMALL_STATE(5774)] = 191790,
  [SMALL_STATE(5775)] = 191803,
  [SMALL_STATE(5776)] = 191816,
  [SMALL_STATE(5777)] = 191829,
  [SMALL_STATE(5778)] = 191842,
  [SMALL_STATE(5779)] = 191855,
  [SMALL_STATE(5780)] = 191868,
  [SMALL_STATE(5781)] = 191881,
  [SMALL_STATE(5782)] = 191894,
  [SMALL_STATE(5783)] = 191907,
  [SMALL_STATE(5784)] = 191920,
  [SMALL_STATE(5785)] = 191933,
  [SMALL_STATE(5786)] = 191946,
  [SMALL_STATE(5787)] = 191959,
  [SMALL_STATE(5788)] = 191972,
  [SMALL_STATE(5789)] = 191985,
  [SMALL_STATE(5790)] = 191998,
  [SMALL_STATE(5791)] = 192011,
  [SMALL_STATE(5792)] = 192024,
  [SMALL_STATE(5793)] = 192037,
  [SMALL_STATE(5794)] = 192050,
  [SMALL_STATE(5795)] = 192063,
  [SMALL_STATE(5796)] = 192076,
  [SMALL_STATE(5797)] = 192089,
  [SMALL_STATE(5798)] = 192102,
  [SMALL_STATE(5799)] = 192115,
  [SMALL_STATE(5800)] = 192128,
  [SMALL_STATE(5801)] = 192141,
  [SMALL_STATE(5802)] = 192154,
  [SMALL_STATE(5803)] = 192167,
  [SMALL_STATE(5804)] = 192180,
  [SMALL_STATE(5805)] = 192193,
  [SMALL_STATE(5806)] = 192206,
  [SMALL_STATE(5807)] = 192219,
  [SMALL_STATE(5808)] = 192232,
  [SMALL_STATE(5809)] = 192245,
  [SMALL_STATE(5810)] = 192258,
  [SMALL_STATE(5811)] = 192271,
  [SMALL_STATE(5812)] = 192284,
  [SMALL_STATE(5813)] = 192297,
  [SMALL_STATE(5814)] = 192310,
  [SMALL_STATE(5815)] = 192323,
  [SMALL_STATE(5816)] = 192336,
  [SMALL_STATE(5817)] = 192349,
  [SMALL_STATE(5818)] = 192362,
  [SMALL_STATE(5819)] = 192375,
  [SMALL_STATE(5820)] = 192388,
  [SMALL_STATE(5821)] = 192401,
  [SMALL_STATE(5822)] = 192414,
  [SMALL_STATE(5823)] = 192427,
  [SMALL_STATE(5824)] = 192440,
  [SMALL_STATE(5825)] = 192453,
  [SMALL_STATE(5826)] = 192466,
  [SMALL_STATE(5827)] = 192479,
  [SMALL_STATE(5828)] = 192492,
  [SMALL_STATE(5829)] = 192505,
  [SMALL_STATE(5830)] = 192518,
  [SMALL_STATE(5831)] = 192531,
  [SMALL_STATE(5832)] = 192544,
  [SMALL_STATE(5833)] = 192557,
  [SMALL_STATE(5834)] = 192570,
  [SMALL_STATE(5835)] = 192583,
  [SMALL_STATE(5836)] = 192596,
  [SMALL_STATE(5837)] = 192609,
  [SMALL_STATE(5838)] = 192622,
  [SMALL_STATE(5839)] = 192635,
  [SMALL_STATE(5840)] = 192648,
  [SMALL_STATE(5841)] = 192661,
  [SMALL_STATE(5842)] = 192674,
  [SMALL_STATE(5843)] = 192687,
  [SMALL_STATE(5844)] = 192700,
  [SMALL_STATE(5845)] = 192713,
  [SMALL_STATE(5846)] = 192726,
  [SMALL_STATE(5847)] = 192739,
  [SMALL_STATE(5848)] = 192752,
  [SMALL_STATE(5849)] = 192765,
  [SMALL_STATE(5850)] = 192778,
  [SMALL_STATE(5851)] = 192791,
  [SMALL_STATE(5852)] = 192804,
  [SMALL_STATE(5853)] = 192817,
  [SMALL_STATE(5854)] = 192830,
  [SMALL_STATE(5855)] = 192843,
  [SMALL_STATE(5856)] = 192856,
  [SMALL_STATE(5857)] = 192869,
  [SMALL_STATE(5858)] = 192882,
  [SMALL_STATE(5859)] = 192895,
  [SMALL_STATE(5860)] = 192908,
  [SMALL_STATE(5861)] = 192921,
  [SMALL_STATE(5862)] = 192934,
  [SMALL_STATE(5863)] = 192947,
  [SMALL_STATE(5864)] = 192960,
  [SMALL_STATE(5865)] = 192973,
  [SMALL_STATE(5866)] = 192986,
  [SMALL_STATE(5867)] = 192999,
  [SMALL_STATE(5868)] = 193012,
  [SMALL_STATE(5869)] = 193025,
  [SMALL_STATE(5870)] = 193038,
  [SMALL_STATE(5871)] = 193051,
  [SMALL_STATE(5872)] = 193064,
  [SMALL_STATE(5873)] = 193077,
  [SMALL_STATE(5874)] = 193081,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5690),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5618),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5635),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2605),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4955),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4989),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lhs, 1, 0, 0),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lhs, 1, 0, 0),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5706),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lhs, 1, 0, 2),
  [179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lhs, 1, 0, 2),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2394),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5778),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2747),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2748),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1928),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4970),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4901),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4902),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2970),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5827),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2414),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_identifier_call, 1, 0, 4),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_identifier_call, 1, 0, 4),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 1, 0, 0),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield, 1, 0, 0),
  [419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return, 1, 0, 0),
  [421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return, 1, 0, 0),
  [423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 1, 0, 0),
  [425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 1, 0, 0),
  [427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_next, 1, 0, 0),
  [429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_next, 1, 0, 0),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5680),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5076),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5554),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5843),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2404),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2408),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4662),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2614),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5020),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2478),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable, 1, 0, 0),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable, 1, 0, 0),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2866),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5248),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5250),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2886),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5334),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5271),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4270),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4346),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4617),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4585),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5400),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5340),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4315),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4320),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4330),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2958),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4640),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4642),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4647),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4278),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4306),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4237),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2322),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2921),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4600),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4602),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4595),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5398),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_argument, 1, 0, 0),
  [883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_argument, 1, 0, 0),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1676),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 2, 0, 17),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 2, 0, 17),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5350),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4337),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4594),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4582),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4197),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3016),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2932),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4328),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5336),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4236),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5341),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5285),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4646),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5368),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4660),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5332),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5328),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2955),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2996),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3007),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5338),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5261),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 2),
  [1031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 2),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2325),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [1053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 1, 0, 0),
  [1055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 1, 0, 0),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [1077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1879),
  [1080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5618),
  [1083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(715),
  [1086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0),
  [1088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5635),
  [1091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2408),
  [1094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(326),
  [1097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5706),
  [1100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0),
  [1102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2029),
  [1105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1695),
  [1108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1943),
  [1111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2053),
  [1114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1949),
  [1117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1954),
  [1120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(49),
  [1123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(50),
  [1126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(51),
  [1129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(52),
  [1132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2171),
  [1135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2192),
  [1138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(385),
  [1141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(386),
  [1144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(390),
  [1147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(380),
  [1150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1939),
  [1153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(263),
  [1156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(399),
  [1159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1695),
  [1162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(191),
  [1165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(516),
  [1168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(517),
  [1171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(519),
  [1174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(526),
  [1177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2614),
  [1180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2616),
  [1183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2161),
  [1186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2055),
  [1189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1940),
  [1192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1934),
  [1195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1882),
  [1198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2259),
  [1201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(4503),
  [1204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2291),
  [1207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(4955),
  [1210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(4989),
  [1213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5077),
  [1216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(4959),
  [1219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(4890),
  [1222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(4912),
  [1225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(611),
  [1228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(5020),
  [1231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1694),
  [1234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(1934),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [1249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then, 2, 0, 0),
  [1251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_then, 1, 0, 0),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [1259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elsif, 3, 0, 64),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5382),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2873),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5385),
  [1301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else, 1, 0, 0),
  [1303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 4, 0, 93),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [1315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 2, 0, 0),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 3, 0, 72),
  [1345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue, 3, 0, 74),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5347),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [1357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_when, 4, 0, 88),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [1365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2763),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2772),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2718),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4990),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [1397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_in_clause, 3, 0, 68),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [1401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else, 2, 0, 0),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [1409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_when, 3, 0, 68),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [1431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_in_clause, 4, 0, 109),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [1435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ensure, 1, 0, 0),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5063),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5028),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5098),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5395),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5049),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2399),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5081),
  [1605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 0), SHIFT_REPEAT(2084),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [1610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5386),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [1618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [1624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5623),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [1636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [1648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [1650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [1686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4311),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5110),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [1726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [1734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5043),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2879),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [1844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [1862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2407),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [1868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [1900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [1904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [1908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [1914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [1916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4954),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [1928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [1930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [1982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [2000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [2028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [2034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [2036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [2044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__terminator, 1, 0, 0),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [2048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [2054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [2060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [2072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5082),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [2090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [2106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [2116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [2124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [2144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [2182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [2188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [2226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4976),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4981),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5348),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [2264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4926),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4995),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list_with_trailing_comma, 3, 0, 0),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 2, 0, 29),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [2316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list_with_trailing_comma, 2, 0, 0),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 2, 0, 28),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [2364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [2388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [2414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 2, 0, 29),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [2418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 2, 0, 28),
  [2420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 2, 0, 28),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_argument, 1, 0, 0),
  [2426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_argument, 1, 0, 0),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_argument, 1, 0, 0),
  [2430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_argument, 1, 0, 0),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forward_argument, 1, 0, 0),
  [2434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_forward_argument, 1, 0, 0),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [2476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [2490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5284),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5363),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5321),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_parameter, 2, 0, 30),
  [2556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_parameter, 2, 0, 30),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [2562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1, 0, 0),
  [2564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1, 0, 0),
  [2566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call, 3, 0, 49),
  [2568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scope_resolution, 3, 0, 51),
  [2570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scope_resolution, 3, 0, 51),
  [2572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call, 3, 0, 49),
  [2574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nonlocal_variable, 1, 0, 0),
  [2576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nonlocal_variable, 1, 0, 0),
  [2578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_identifier, 1, 0, 6),
  [2580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_identifier, 1, 0, 6),
  [2582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_identifier, 1, 0, 7),
  [2584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_identifier, 1, 0, 7),
  [2586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_suffix, 1, 0, 0),
  [2588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_suffix, 1, 0, 0),
  [2590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_suffix, 1, 0, 0),
  [2592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_suffix, 1, 0, 0),
  [2594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4173),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_parameter, 1, 0, 0),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2418),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [2606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_parameter, 1, 0, 0),
  [2608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_assignment, 1, 0, 0),
  [2610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4886),
  [2612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [2616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5147),
  [2618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5152),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5155),
  [2622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5161),
  [2624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5144),
  [2626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5146),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [2630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [2632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [2638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [2642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5526),
  [2648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5526),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4949),
  [2652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4693),
  [2654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4891),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [2658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4702),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4705),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5314),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5066),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5035),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4936),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [2686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant, 1, 0, 0),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4579),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [2708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mlhs, 3, 0, 0),
  [2710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mlhs, 3, 0, 0),
  [2712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mlhs, 2, 0, 0),
  [2714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mlhs, 2, 0, 0),
  [2716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_assignment, 1, 0, 0),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [2720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [2728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [2734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4786),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4965),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5008),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4379),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 2, 0, 77),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [2758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 2, 0, 77),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4350),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [2768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3312),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5067),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5036),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5037),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [2794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 2, 0, 28),
  [2796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 2, 0, 29),
  [2798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 2, 0, 29),
  [2800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4784),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4718),
  [2812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4652),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [2822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4575),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4667),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4992),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5022),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4866),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [2850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4624),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4455),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4541),
  [2862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4562),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3348),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4698),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [2880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4577),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4580),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4417),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4363),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4528),
  [2890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4555),
  [2892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4491),
  [2894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__chained_command_call, 3, 0, 49),
  [2896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__chained_command_call, 3, 0, 49),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4756),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [2908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__terminator, 1, 0, 0),
  [2910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scope_resolution, 2, 0, 14),
  [2912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scope_resolution, 2, 0, 14),
  [2914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant_resolution, 2, 0, 14),
  [2916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant_resolution, 2, 0, 14),
  [2918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statements_repeat1, 1, 0, 0),
  [2920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 1, 0, 0),
  [2922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant, 1, 0, 0),
  [2928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [2930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__keyword_variable, 1, 0, 0),
  [2932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_reference, 3, 0, 48),
  [2934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_reference, 3, 0, 48),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [2940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_reference, 4, 0, 48),
  [2942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_reference, 4, 0, 48),
  [2944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nil, 1, 0, 0),
  [2946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nil, 1, 0, 0),
  [2948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 0),
  [2950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [2952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 0),
  [2954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [2956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expr_basic, 1, 0, 0),
  [2958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, 0, 0),
  [2960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 0),
  [2962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary, 1, 0, 0),
  [2964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary, 1, 0, 0),
  [2966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [2970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 8, 0, 124),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 8, 0, 124),
  [2974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 5, 0, 115),
  [2976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 5, 0, 115),
  [2978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 5, 0, 117),
  [2980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 5, 0, 117),
  [2982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 4, 0, 111),
  [2984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 4, 0, 111),
  [2986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 5, 0, 0),
  [2992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 5, 0, 0),
  [2994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 2, 0, 0),
  [2996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 2, 0, 0),
  [2998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 6, 0, 120),
  [3000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 6, 0, 120),
  [3002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 6, 0, 121),
  [3004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 6, 0, 121),
  [3006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 7, 0, 122),
  [3008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 7, 0, 122),
  [3010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 7, 0, 123),
  [3012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 7, 0, 123),
  [3014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 4, 0, 0),
  [3016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 4, 0, 0),
  [3018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameters, 3, 0, 0),
  [3020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameters, 3, 0, 0),
  [3022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [3024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [3030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [3036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [3040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [3042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [3044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [3052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [3056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [3058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [3062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [3066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [3070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_range, 2, 0, 17),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4350),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [3086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [3090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [3094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [3098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [3102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [3106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chained_string, 2, 0, 0),
  [3112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_chained_string, 2, 0, 0),
  [3114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0),
  [3116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0),
  [3118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(4955),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_literal, 1, 0, 0),
  [3127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [3131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_numeric, 1, 0, 0),
  [3133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_numeric, 1, 0, 0),
  [3135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__int_or_float, 1, 0, 0),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__int_or_float, 1, 0, 0),
  [3139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [3151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [3159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [3161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redo, 1, 0, 0),
  [3163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_redo, 1, 0, 0),
  [3165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 8),
  [3167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 8),
  [3169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, 0, 50),
  [3171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 3, 0, 50),
  [3173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 18),
  [3175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 18),
  [3177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 20),
  [3179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 20),
  [3181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 23),
  [3183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 23),
  [3185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [3187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_retry, 1, 0, 0),
  [3189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_retry, 1, 0, 0),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [3193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [3197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_range, 2, 0, 17),
  [3199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [3201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 1, 0, 0),
  [3205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chained_string_repeat1, 1, 0, 0),
  [3207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 3, 0, 60),
  [3209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 3, 0, 60),
  [3211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 2, 0, 10),
  [3213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 2, 0, 10),
  [3215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, 0, 25),
  [3217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, 0, 25),
  [3219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rational, 2, 0, 0),
  [3221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rational, 2, 0, 0),
  [3223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_minus_pow, 2, 0, 12),
  [3225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unary_minus_pow, 2, 0, 12),
  [3227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary, 1, 0, 5),
  [3229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary, 1, 0, 5),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_statements, 2, 0, 0),
  [3233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_statements, 2, 0, 0),
  [3235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 62),
  [3237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 62),
  [3239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 14),
  [3241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 14),
  [3243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 62),
  [3245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 4, 0, 62),
  [3247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 5, 0, 55),
  [3249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 5, 0, 55),
  [3251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 3, 0, 0),
  [3253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 3, 0, 0),
  [3255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 2, 0, 31),
  [3257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 2, 0, 31),
  [3259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redo, 2, 0, 0),
  [3261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_redo, 2, 0, 0),
  [3263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, 0, 14),
  [3265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 4, 0, 14),
  [3267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [3269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [3271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 5, 0, 26),
  [3273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 5, 0, 26),
  [3275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_statements, 3, 0, 0),
  [3277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_statements, 3, 0, 0),
  [3279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 14),
  [3281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 14),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 4, 0, 0),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 4, 0, 0),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_method, 4, 0, 59),
  [3289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_method, 4, 0, 59),
  [3291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 3, 0, 14),
  [3293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 3, 0, 14),
  [3295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 5, 0, 56),
  [3297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 5, 0, 56),
  [3299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 5, 0, 27),
  [3301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 5, 0, 27),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 2, 0, 0),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 2, 0, 0),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [3309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body_expr, 2, 0, 16),
  [3313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__body_expr, 2, 0, 16),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 5, 0, 95),
  [3317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 5, 0, 95),
  [3319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, 0, 54),
  [3325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 3, 0, 54),
  [3327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 7, 0, 114),
  [3329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 7, 0, 114),
  [3331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 6, 0, 119),
  [3333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 6, 0, 119),
  [3335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2, 0, 0),
  [3337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2, 0, 0),
  [3339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [3341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_lambda, 1, 0, 0),
  [3343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 4, 0, 63),
  [3345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 4, 0, 63),
  [3347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 7, 0, 66),
  [3349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 7, 0, 66),
  [3351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 3, 0, 0),
  [3353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 3, 0, 0),
  [3355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 4, 0, 55),
  [3357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 4, 0, 55),
  [3359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, 0, 52),
  [3361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 3, 0, 52),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 4, 0, 64),
  [3365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 4, 0, 64),
  [3367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 3, 0, 61),
  [3369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 3, 0, 61),
  [3371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 5, 0, 0),
  [3373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 5, 0, 0),
  [3375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_next, 2, 0, 0),
  [3377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_next, 2, 0, 0),
  [3379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 3, 0, 26),
  [3381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 3, 0, 26),
  [3383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 3, 0, 0),
  [3385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 3, 0, 0),
  [3387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 4, 0, 80),
  [3389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 4, 0, 80),
  [3391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 4, 0, 60),
  [3393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 4, 0, 60),
  [3395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 4, 0, 81),
  [3397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 4, 0, 81),
  [3399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [3403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [3407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_class, 5, 0, 66),
  [3409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_class, 5, 0, 66),
  [3411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 82),
  [3413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 82),
  [3415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 3, 0, 27),
  [3417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 3, 0, 27),
  [3419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_literal, 2, 0, 11),
  [3425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_literal, 2, 0, 11),
  [3427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_unary, 2, 0, 11),
  [3429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_unary, 2, 0, 11),
  [3431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 21),
  [3437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 21),
  [3439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg, 1, 0, 0),
  [3441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg, 1, 0, 0),
  [3443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [3451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 83),
  [3453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 83),
  [3455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 4, 0, 63),
  [3457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 4, 0, 63),
  [3459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 4, 0, 64),
  [3461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 4, 0, 64),
  [3463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [3467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [3471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 2, 0, 0),
  [3473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 2, 0, 0),
  [3475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for, 4, 0, 65),
  [3477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for, 4, 0, 65),
  [3479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, 0, 66),
  [3481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, 0, 66),
  [3483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, 0, 33),
  [3485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, 0, 33),
  [3487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 4, 0, 69),
  [3489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 4, 0, 69),
  [3491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, 0, 85),
  [3493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, 0, 85),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 5, 0, 83),
  [3497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 5, 0, 83),
  [3499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 2, 0, 0),
  [3501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 2, 0, 0),
  [3503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_pattern, 2, 0, 0),
  [3505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 3, 0, 32),
  [3507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 3, 0, 32),
  [3509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 5, 0, 84),
  [3511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 5, 0, 84),
  [3513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_until, 3, 0, 32),
  [3515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_until, 3, 0, 32),
  [3517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 4, 0, 0),
  [3519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 4, 0, 0),
  [3521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 53),
  [3523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 3, 0, 53),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_assignment, 3, 0, 40),
  [3527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_assignment, 3, 0, 40),
  [3529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 3, 0, 33),
  [3531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 3, 0, 33),
  [3533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__numeric, 1, 0, 0),
  [3535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__numeric, 1, 0, 0),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 3, 0, 30),
  [3539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 3, 0, 30),
  [3541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0),
  [3543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1, 0, 0),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 4, 0, 26),
  [3547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 4, 0, 26),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method, 2, 0, 13),
  [3551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 2, 0, 13),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 3, 0, 0),
  [3555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 3, 0, 0),
  [3557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless, 5, 0, 85),
  [3559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless, 5, 0, 85),
  [3561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 3, 0, 0),
  [3563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 3, 0, 0),
  [3565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, 0, 66),
  [3567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, 0, 66),
  [3569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 5, 0, 86),
  [3571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 5, 0, 86),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_retry, 2, 0, 0),
  [3575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_retry, 2, 0, 0),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin, 4, 0, 0),
  [3579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin, 4, 0, 0),
  [3581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 4, 0, 0),
  [3583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 4, 0, 0),
  [3585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0),
  [3587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0),
  [3589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 16),
  [3591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 16),
  [3593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 2, 0, 0),
  [3595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 2, 0, 0),
  [3597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 2, 0, 16),
  [3599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 2, 0, 16),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 2, 0, 0),
  [3603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 2, 0, 0),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 75),
  [3607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 75),
  [3609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, 0, 33),
  [3611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, 0, 33),
  [3613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, 0, 37),
  [3615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 3, 0, 37),
  [3617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 3, 0, 75),
  [3619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 3, 0, 75),
  [3621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, 0, 0),
  [3623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, 0, 0),
  [3625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return, 2, 0, 0),
  [3627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return, 2, 0, 0),
  [3629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 3, 0, 16),
  [3631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 3, 0, 16),
  [3633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 5, 0, 90),
  [3635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 5, 0, 90),
  [3637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 5, 0, 91),
  [3639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 5, 0, 91),
  [3641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 5, 0, 0),
  [3643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 5, 0, 0),
  [3645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 4, 0, 56),
  [3647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 4, 0, 56),
  [3649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4, 0, 94),
  [3651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4, 0, 94),
  [3653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 94),
  [3655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 94),
  [3657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 75),
  [3659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 75),
  [3661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 95),
  [3663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 95),
  [3665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 3, 0, 0),
  [3667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 3, 0, 0),
  [3669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin, 3, 0, 0),
  [3671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin, 3, 0, 0),
  [3673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 4, 0, 96),
  [3675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 4, 0, 96),
  [3677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 2, 0, 0),
  [3679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield, 2, 0, 0),
  [3681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_array, 6, 0, 55),
  [3683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_array, 6, 0, 55),
  [3685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 19),
  [3687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 19),
  [3689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 4, 0, 27),
  [3691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 4, 0, 27),
  [3693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [3695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [3697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 2, 0, 0),
  [3699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 2, 0, 0),
  [3701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex, 2, 0, 0),
  [3703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex, 2, 0, 0),
  [3705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex, 2, 0, 22),
  [3707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_complex, 2, 0, 22),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 2, 0, 0),
  [3711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 2, 0, 0),
  [3713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_array, 6, 0, 56),
  [3715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_array, 6, 0, 56),
  [3717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary, 2, 0, 11),
  [3719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary, 2, 0, 11),
  [3721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delimited_symbol, 2, 0, 8),
  [3723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delimited_symbol, 2, 0, 8),
  [3725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_method, 6, 0, 102),
  [3727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_method, 6, 0, 102),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subshell, 2, 0, 9),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subshell, 2, 0, 9),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 4, 0, 79),
  [3735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 4, 0, 79),
  [3737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_rest, 5, 0, 103),
  [3743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_rest, 5, 0, 103),
  [3745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg, 1, 0, 1),
  [3747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg, 1, 0, 1),
  [3749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_singleton_class, 6, 0, 104),
  [3751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_singleton_class, 6, 0, 104),
  [3753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, 0, 105),
  [3755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, 0, 105),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin, 2, 0, 0),
  [3759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin, 2, 0, 0),
  [3761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash, 4, 0, 0),
  [3763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash, 4, 0, 0),
  [3765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 6, 0, 66),
  [3767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 6, 0, 66),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 6, 0, 106),
  [3771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 6, 0, 106),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 6, 0, 107),
  [3775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 6, 0, 107),
  [3777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delimited_symbol, 3, 0, 23),
  [3779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delimited_symbol, 3, 0, 23),
  [3781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case, 6, 0, 33),
  [3783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case, 6, 0, 33),
  [3785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_match, 6, 0, 110),
  [3787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_match, 6, 0, 110),
  [3789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subshell, 3, 0, 24),
  [3791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subshell, 3, 0, 24),
  [3793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 5, 0, 112),
  [3795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 5, 0, 112),
  [3797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_block, 5, 0, 113),
  [3799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_block, 5, 0, 113),
  [3801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, 0, 84),
  [3803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, 0, 84),
  [3805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [3809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [3811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [3821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [3827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [3831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [3839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4686),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [3845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4394),
  [3847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5497),
  [3849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4699),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4398),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [3865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [3871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [3877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [3879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [3897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [3915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [3925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(804),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [3972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [3976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_right_assignment_list, 2, 0, 0),
  [3978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_right_assignment_list, 2, 0, 0),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary, 3, 0, 40),
  [3984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary, 3, 0, 40),
  [3986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 2, 0, 15),
  [3988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 2, 0, 15),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [3992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [3996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional, 5, 0, 101),
  [3998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional, 5, 0, 101),
  [4000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_argument, 2, 0, 0),
  [4002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_argument, 2, 0, 0),
  [4004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [4014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pow, 3, 0, 40),
  [4016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pow, 3, 0, 40),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue_modifier_arg, 3, 0, 38),
  [4024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue_modifier_arg, 3, 0, 38),
  [4026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [4030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range, 3, 0, 41),
  [4032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range, 3, 0, 41),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3120),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1635),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [4048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [4052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [4090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [4102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(789),
  [4105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [4109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [4115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [4119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [4123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [4127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [4131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3164),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [4139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [4141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4775),
  [4143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4391),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [4147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [4151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [4155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [4157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [4159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [4177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [4185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [4191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [4197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [4215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4652),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [4227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [4237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [4241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(799),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [4250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [4254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [4256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [4258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [4276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [4282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4514),
  [4284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [4290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(813),
  [4293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4692),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4758),
  [4297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4758),
  [4299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4746),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [4309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3138),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [4313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3290),
  [4315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3289),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [4319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [4327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue_modifier_expression, 3, 0, 38),
  [4329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3090),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [4337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(808),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [4344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_argument, 2, 0, 0),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [4348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [4354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [4380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_argument, 2, 0, 0),
  [4382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 57),
  [4384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 58),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [4388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [4394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [4398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [4400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [4402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [4420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [4426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [4432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(794),
  [4435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [4439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [4441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [4443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [4459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [4461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [4469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(4970),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [4474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3094),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [4486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [4512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [4522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [4528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [4538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [4564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [4582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [4590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [4594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(805),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [4601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(802),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [4606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [4610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [4628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [4630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [4656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [4660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [4682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [4696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(785),
  [4699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [4707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [4709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [4713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [4719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(788),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [4726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [4732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [4738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [4744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [4748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [4756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4753),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4762),
  [4760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4762),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [4764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(809),
  [4767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [4769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [4773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [4775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [4781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(803),
  [4784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_argument, 2, 0, 0),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [4788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [4794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [4796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [4814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [4820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [4822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [4824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 58),
  [4826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [4828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 57),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [4832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [4836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [4838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue_modifier_expression, 3, 0, 38),
  [4840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4794),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4781),
  [4844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4781),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [4850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [4852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [4854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3085),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [4864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [4866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [4868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_name, 1, 0, 0),
  [4870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_name, 1, 0, 0),
  [4872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [4874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [4876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [4880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4729),
  [4882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4798),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [4886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_argument, 2, 0, 0),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [4890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [4896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [4898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [4904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [4916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [4922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [4926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [4928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [4932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [4934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [4936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [4954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [4960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(786),
  [4963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [4967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [4969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [4971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [4989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [5003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(796),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [5020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [5024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [5026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [5028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [5046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [5054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(807),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [5059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [5065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3122),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [5071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setter, 2, 0, 30),
  [5073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter, 2, 0, 30),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [5077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [5081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [5083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [5085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [5111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [5115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [5123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [5127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [5129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [5131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [5147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [5153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(793),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [5164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [5168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [5174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [5178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [5184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [5186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [5204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [5206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [5216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [5222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [5228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [5232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [5234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [5236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [5254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [5260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5103),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [5269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [5273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [5275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [5277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [5279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [5283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [5285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [5287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [5305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [5315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [5319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [5321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [5327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [5345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [5351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(810),
  [5354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [5356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(811),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [5363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [5367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [5369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [5371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [5389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [5397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(798),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [5402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(797),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [5407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [5411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [5413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [5415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [5433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [5441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5556),
  [5443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 3, 0, 0),
  [5445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 3, 0, 0),
  [5447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [5455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [5459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [5461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [5463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [5481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [5487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(792),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [5516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [5530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(790),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [5545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [5549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [5551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [5553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [5557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [5561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [5563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [5565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [5567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [5571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [5575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [5579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [5581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [5585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(814),
  [5588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 2, 0, 0),
  [5590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 2, 0, 0),
  [5592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [5596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [5598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [5600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [5618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [5624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [5632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [5650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [5656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [5660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [5662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [5664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [5682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [5688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [5690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [5692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [5704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [5712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [5730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(801),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [5735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(795),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [5746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [5750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [5752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [5754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [5772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [5780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [5788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [5792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [5794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [5806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [5816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [5820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [5822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [5824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [5842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [5864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exceptions, 1, 0, 0),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [5874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [5878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [5880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [5882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [5900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [5908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [5912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [5914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [5916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [5932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [5938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(812),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [5953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [5957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [5959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [5961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [5979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [5985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [5989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [5991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [5993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [6001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [6011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [6027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [6033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [6039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [6043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [6049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [6055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [6061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(806),
  [6064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [6076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [6080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [6082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [6084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [6102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [6108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [6112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [6114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [6126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [6130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(800),
  [6133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in, 2, 0, 0),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [6137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, 0, 76),
  [6139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_parameter, 3, 0, 76),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [6143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [6147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [6149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [6151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [6169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [6171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [6175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [6185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [6189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [6191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [6193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [6195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [6197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [6201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [6203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [6205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [6207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_parameter, 2, 0, 14),
  [6209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_parameter, 2, 0, 14),
  [6211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5559),
  [6213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_parameter, 3, 0, 76),
  [6215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_parameter, 3, 0, 76),
  [6217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [6219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [6221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [6223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [6225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [6247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [6251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [6255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [6261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [6283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [6285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [6287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [6293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5513),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [6297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [6301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [6303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_value, 1, 0, 0),
  [6305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_value, 1, 0, 0),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5569),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [6313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant, 1, 0, 47),
  [6315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant, 1, 0, 47),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [6331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [6351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [6353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [6357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [6363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [6367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constant_resolution, 3, 0, 51),
  [6369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_constant_resolution, 3, 0, 51),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [6373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5498),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [6383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [6385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [6387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [6389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [6395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5529),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5531),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5533),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5535),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5542),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5545),
  [6413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__keyword_variable, 1, 0, 0),
  [6415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_literal, 1, 0, 0),
  [6417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_lambda, 1, 0, 0),
  [6419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_primitive, 1, 0, 0),
  [6421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_primitive, 1, 0, 0),
  [6423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call_with_block, 3, 0, 52),
  [6425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call_with_block, 3, 0, 52),
  [6427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call_with_block, 3, 0, 54),
  [6429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call_with_block, 3, 0, 54),
  [6431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_pattern, 2, 0, 0),
  [6433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_range, 3, 0, 41),
  [6435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_range, 3, 0, 41),
  [6437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_value, 1, 0, 46),
  [6439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_value, 1, 0, 46),
  [6441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call, 2, 0, 18),
  [6443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call, 2, 0, 18),
  [6445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [6449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 98),
  [6451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 98),
  [6453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4, 0, 100),
  [6455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 4, 0, 100),
  [6457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, 0, 100),
  [6459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 3, 0, 100),
  [6461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [6463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [6465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_find_pattern, 4, 0, 100),
  [6467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_find_pattern, 4, 0, 100),
  [6469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, 0, 0),
  [6471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 3, 0, 0),
  [6473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_expr_basic, 1, 0, 0),
  [6475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_reference_pattern, 2, 0, 14),
  [6477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_reference_pattern, 2, 0, 14),
  [6479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_pattern, 4, 0, 100),
  [6481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_pattern, 4, 0, 100),
  [6483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_range, 2, 0, 15),
  [6485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_range, 2, 0, 15),
  [6487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [6489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_reference_pattern, 4, 0, 66),
  [6491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_reference_pattern, 4, 0, 66),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [6495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_call, 2, 0, 20),
  [6497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_call, 2, 0, 20),
  [6499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_pattern, 3, 0, 0),
  [6501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_pattern, 3, 0, 0),
  [6503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_find_pattern, 3, 0, 0),
  [6505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_find_pattern, 3, 0, 0),
  [6507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expr, 1, 0, 0),
  [6509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_expr, 1, 0, 0),
  [6511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_expr_alt, 1, 0, 0),
  [6513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_expr_alt, 1, 0, 0),
  [6515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5814),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [6519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [6521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 3, 0, 58),
  [6523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 3, 0, 58),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [6527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0),
  [6529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0),
  [6531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3, 0, 97),
  [6533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3, 0, 97),
  [6535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 3, 0, 57),
  [6537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword_pattern, 3, 0, 57),
  [6539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument, 1, 0, 0),
  [6541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument, 1, 0, 0),
  [6543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_command, 2, 0, 0),
  [6545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_command, 2, 0, 0),
  [6547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 44),
  [6549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 44),
  [6551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 45),
  [6553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 45),
  [6555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 28),
  [6557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 28),
  [6559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternative_pattern, 2, 0, 78),
  [6561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [6563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 1, 0, 0),
  [6565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 1, 0, 0),
  [6567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 29),
  [6569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 29),
  [6571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 3, 0, 42),
  [6573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_pattern, 3, 0, 42),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [6577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_unary, 2, 0, 11),
  [6579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_unary, 2, 0, 11),
  [6581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_operator_assignment, 3, 0, 40),
  [6583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_operator_assignment, 3, 0, 40),
  [6585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0),
  [6587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0),
  [6589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_command, 2, 0, 0),
  [6591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_command, 2, 0, 0),
  [6593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 99),
  [6595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 99), SHIFT_REPEAT(2137),
  [6598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_binary, 3, 0, 40),
  [6600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_binary, 3, 0, 40),
  [6602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 3),
  [6604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 3),
  [6606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__find_pattern_body, 4, 0, 0),
  [6608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__find_pattern_body, 4, 0, 0),
  [6610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_body, 4, 0, 0),
  [6612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_body, 4, 0, 0),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [6616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 3, 0, 0),
  [6618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 3, 0, 0),
  [6620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_nil, 2, 0, 0),
  [6622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_nil, 2, 0, 0),
  [6624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_assignment, 3, 0, 53),
  [6626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_assignment, 3, 0, 53),
  [6628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_parameter, 2, 0, 14),
  [6630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_parameter, 2, 0, 14),
  [6632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_command, 2, 0, 0),
  [6634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_command, 2, 0, 0),
  [6636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_pattern_any_rest, 1, 0, 0),
  [6638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_pattern_any_rest, 1, 0, 0),
  [6640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0),
  [6642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0),
  [6644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_test_pattern, 3, 0, 42),
  [6646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_test_pattern, 3, 0, 42),
  [6648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 43),
  [6650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 43),
  [6652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_next_command, 2, 0, 0),
  [6654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_next_command, 2, 0, 0),
  [6656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5568),
  [6658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5722),
  [6660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4434),
  [6662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_splat_parameter, 1, 0, 0),
  [6664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_splat_parameter, 1, 0, 0),
  [6666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4432),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [6670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4709),
  [6673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 2, 0, 0),
  [6675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [6677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(416),
  [6680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4431),
  [6682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 0),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [6690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_n, 1, 0, 0),
  [6692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_argument_list, 1, 0, 0),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [6696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2112),
  [6699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_argument_list, 2, 0, 0),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [6703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [6707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5278),
  [6709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [6711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0),
  [6713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0),
  [6715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5218),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [6719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [6721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [6723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_block, 4, 0, 0),
  [6725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_block, 4, 0, 0),
  [6727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [6731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [6735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [6737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias, 3, 0, 35),
  [6739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias, 3, 0, 35),
  [6741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin_block, 3, 0, 0),
  [6743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin_block, 3, 0, 0),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [6747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [6751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin_block, 4, 0, 0),
  [6753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin_block, 4, 0, 0),
  [6755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(421),
  [6758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_block, 3, 0, 0),
  [6760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end_block, 3, 0, 0),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [6766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [6768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 0, 0),
  [6770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 0, 0),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [6774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [6776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0), SHIFT_REPEAT(2611),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [6781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_undef, 2, 0, 0),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [6787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_undef, 3, 0, 0),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [6795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5709),
  [6803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_until_modifier, 3, 0, 39),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [6807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless_modifier, 3, 0, 39),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5794),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [6823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_modifier, 3, 0, 39),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [6829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 99),
  [6831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 99), SHIFT_REPEAT(2138),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [6836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternative_pattern, 2, 0, 78),
  [6838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue_modifier, 3, 0, 38),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [6844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_modifier, 3, 0, 39),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [6852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [6888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2109),
  [6891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_argument_list, 1, 0, 0),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [6901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 2, 0, 0),
  [6903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4731),
  [6906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 2, 0, 0),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [6910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_pattern_n, 1, 0, 0),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [6916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_top_expr_body, 1, 0, 0),
  [6918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_argument_list, 2, 0, 0),
  [6920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(425),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [6937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(419),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [6942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [6952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4706),
  [6954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4707),
  [6956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 99), SHIFT_REPEAT(2146),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [6963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_undef_repeat1, 2, 0, 0), SHIFT_REPEAT(2617),
  [6966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [6968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2574),
  [6970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_undef, 3, 0, 0),
  [6972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [6974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rescue_modifier, 3, 0, 38),
  [6976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [6978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_until_modifier, 3, 0, 39),
  [6980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_undef, 2, 0, 0),
  [6982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_modifier, 3, 0, 39),
  [6984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_modifier, 3, 0, 39),
  [6986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [6988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [6990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(427),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [6995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unless_modifier, 3, 0, 39),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [7017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [7021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [7023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 99), SHIFT_REPEAT(2144),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [7028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 2, 0, 0),
  [7030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [7032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternative_pattern_repeat1, 2, 0, 99), SHIFT_REPEAT(2143),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [7039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4716),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [7044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2116),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [7059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(429),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [7086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [7088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5013),
  [7090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5143),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [7096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [7100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5107),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [7104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5017),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5239),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [7110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5012),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [7118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5027),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [7124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(420),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [7129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4984),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [7137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5018),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [7143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5046),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [7147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4983),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [7157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4964),
  [7159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [7161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2100),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [7168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4730),
  [7171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(423),
  [7174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4948),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [7178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4952),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [7182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__hash_pattern_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4733),
  [7185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5005),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [7189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4999),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [7193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4956),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [7197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5011),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [7201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4978),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [7205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5029),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [7209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5033),
  [7211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [7215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5048),
  [7217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [7219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5776),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [7223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4869),
  [7225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [7227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5848),
  [7229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [7231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5614),
  [7233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [7241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [7245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__mlhs_repeat1, 2, 0, 0),
  [7247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4898),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [7251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5745),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [7255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(426),
  [7258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body_statement, 1, 0, 0),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [7262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [7264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4906),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [7268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4865),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [7272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 26),
  [7274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 26),
  [7276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5765),
  [7278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [7280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4868),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [7284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4918),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [7288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body_statement, 2, 0, 0),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [7292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5578),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [7296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(417),
  [7299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [7301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(334),
  [7304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0),
  [7306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5143),
  [7309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5143),
  [7312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0),
  [7314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5342),
  [7317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4928),
  [7319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [7321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4930),
  [7323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [7325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5781),
  [7327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [7329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0),
  [7331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(653),
  [7334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(256),
  [7337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(283),
  [7340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5749),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [7344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_pattern_n_repeat1, 2, 0, 0), SHIFT_REPEAT(2103),
  [7347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4938),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [7351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4939),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5277),
  [7355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5862),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [7359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5866),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5238),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [7365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_assignment, 2, 0, 0),
  [7367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 27),
  [7369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 27),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [7373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then, 3, 0, 0),
  [7375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5124),
  [7377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameter, 1, 0, 0),
  [7379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_parameter, 1, 0, 0),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [7383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_then, 2, 0, 0),
  [7385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [7387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5283),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [7397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0), SHIFT_REPEAT(329),
  [7400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0), SHIFT_REPEAT(5208),
  [7403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0),
  [7405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2, 0, 0), SHIFT_REPEAT(5317),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [7410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(314),
  [7413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5194),
  [7416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__literal_contents, 2, 0, 0), SHIFT_REPEAT(5283),
  [7419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(428),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [7466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exception_variable, 2, 0, 0),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4319),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5247),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [7524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(422),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [7535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5297),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [7545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chained_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5066),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [7552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5317),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [7562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5234),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [7582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5379),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [7614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5287),
  [7624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exceptions, 2, 0, 0),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [7628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_parameter, 2, 0, 14),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5266),
  [7634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter, 1, 0, 0),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [7640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forward_parameter, 1, 0, 0),
  [7642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, 0, 0),
  [7644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 0),
  [7646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exceptions_repeat1, 2, 0, 0), SHIFT_REPEAT(787),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [7661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__literal_contents, 1, 0, 0),
  [7663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__literal_contents, 1, 0, 0),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4747),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [7673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 2, 0, 0),
  [7675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 2, 0, 0),
  [7677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter, 1, 0, 36),
  [7679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [7685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_formal_parameter, 1, 0, 0),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [7697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(424),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [7706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mlhs, 1, 0, 0),
  [7708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_match_repeat1, 2, 0, 70),
  [7710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_match_repeat1, 2, 0, 70), SHIFT_REPEAT(1993),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5380),
  [7725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [7729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [7733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, 0, 0),
  [7735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 2, 0, 0), SHIFT_REPEAT(780),
  [7738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_guard, 2, 0, 64),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [7742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif, 3, 0, 63),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5383),
  [7748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 1, 0, 0),
  [7750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 1, 0, 0),
  [7752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__mlhs_repeat1, 2, 0, 0), SHIFT_REPEAT(1946),
  [7755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_when_repeat1, 2, 0, 89), SHIFT_REPEAT(782),
  [7758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_when_repeat1, 2, 0, 89),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [7766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unless_guard, 2, 0, 64),
  [7768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4563),
  [7771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4556),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [7778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list_with_trailing_comma, 1, 0, 0),
  [7780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [7782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 3, 0, 0),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [7786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bare_parameters, 2, 0, 0),
  [7788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_pattern_body, 1, 0, 0),
  [7790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [7792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(418),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5409),
  [7797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__body_statement_repeat1, 1, 0, 0),
  [7799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_when_repeat1, 2, 0, 68),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [7813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 3, 0, 71),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [7825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5551),
  [7827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 3, 0, 73),
  [7829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructured_left_assignment, 3, 0, 0),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [7835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [7837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 2, 0, 0),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [7845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 2, 0, 0),
  [7847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bare_parameters, 1, 0, 0),
  [7849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 2, 0, 16),
  [7851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rescue, 4, 0, 92),
  [7853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4552),
  [7856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ensure, 2, 0, 0),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [7860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [7866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [7868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [7872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hash_repeat1, 2, 0, 0),
  [7874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hash_repeat1, 2, 0, 0), SHIFT_REPEAT(763),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5462),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [7883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 0), SHIFT_REPEAT(5111),
  [7886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_array_repeat1, 2, 0, 0),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [7894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5025),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [7900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__guard, 1, 0, 0),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [7904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [7912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4625),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4982),
  [7916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [7920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in_clause, 3, 0, 67),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [7924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_repeat1, 1, 0, 0),
  [7926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [7930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [7940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_parameters_repeat1, 2, 0, 118), SHIFT_REPEAT(5734),
  [7943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_parameters_repeat1, 2, 0, 118),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [7947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [7949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in_clause, 4, 0, 108),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [7955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5047),
  [7957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5402),
  [7961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5403),
  [7963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [7971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [7979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when, 4, 0, 87),
  [7981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [7985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [7993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5686),
  [7997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5729),
  [7999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(4570),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [8008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 0), SHIFT_REPEAT(5113),
  [8011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_symbol_array_repeat1, 2, 0, 0),
  [8013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when, 3, 0, 67),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [8021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5003),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5021),
  [8033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_match_repeat1, 1, 0, 34),
  [8035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [8039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4331),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5031),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [8079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_left_assignment_list, 1, 0, 0),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [8101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_parameters_repeat1, 2, 0, 116),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5296),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [8205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [8207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [8211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5327),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [8225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5339),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [8251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5313),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [8255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [8259] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [8279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5373),
  [8295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [8297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3, 0, 0),
  [8299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [8303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [8323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [8331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [8333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5421),
  [8335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [8339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [8341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5282),
  [8343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body_statement, 1, 0, 0),
  [8345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [8347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [8349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [8351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [8353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [8355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [8357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [8359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [8361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [8363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [8365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [8367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [8369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [8371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [8373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [8375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [8377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [8381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [8383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [8389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5872),
  [8403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [8405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5443),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [8419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [8421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [8423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [8431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [8433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5442),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [8439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [8441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [8443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [8445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [8447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [8449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [8451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [8453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [8455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [8457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [8459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [8465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [8471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [8477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [8481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [8485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [8489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [8493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [8507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4322),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [8515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [8517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [8519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [8521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [8523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_body, 1, 0, 0),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [8527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [8537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [8539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [8541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [8545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [8549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [8551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [8555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [8559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [8561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [8563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [8567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5249),
  [8569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [8571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [8573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [8575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [8577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [8579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [8581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [8583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5286),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [8589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [8593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [8599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [8601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [8603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [8605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [8607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [8609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [8611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif, 4, 0, 84),
  [8613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [8615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elsif, 4, 0, 85),
  [8617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [8619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [8621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [8623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5365),
  [8627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [8629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [8631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [8633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [8635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [8637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [8639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [8641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [8643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [8645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [8647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [8649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [8651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [8653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [8655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5240),
  [8657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [8659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [8661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [8663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [8665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [8667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5372),
  [8669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [8673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [8675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [8677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [8679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [8681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [8685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [8701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [8703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [8705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5303),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5306),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [8725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, 0, 0),
  [8727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_body, 2, 0, 0),
  [8729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_body, 3, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__line_break = 0,
  ts_external_token__no_line_break = 1,
  ts_external_token_simple_symbol = 2,
  ts_external_token__string_start = 3,
  ts_external_token__symbol_start = 4,
  ts_external_token__subshell_start = 5,
  ts_external_token__regex_start = 6,
  ts_external_token__string_array_start = 7,
  ts_external_token__symbol_array_start = 8,
  ts_external_token__heredoc_body_start = 9,
  ts_external_token_string_content = 10,
  ts_external_token_heredoc_content = 11,
  ts_external_token__string_end = 12,
  ts_external_token_heredoc_end = 13,
  ts_external_token_heredoc_beginning = 14,
  ts_external_token_SLASH = 15,
  ts_external_token__block_ampersand = 16,
  ts_external_token__splat_star = 17,
  ts_external_token__unary_minus = 18,
  ts_external_token__unary_minus_num = 19,
  ts_external_token__binary_minus = 20,
  ts_external_token__binary_star = 21,
  ts_external_token__singleton_class_left_angle_left_langle = 22,
  ts_external_token_hash_key_symbol = 23,
  ts_external_token__identifier_suffix = 24,
  ts_external_token__constant_suffix = 25,
  ts_external_token__hash_splat_star_star = 26,
  ts_external_token__binary_star_star = 27,
  ts_external_token__element_reference_bracket = 28,
  ts_external_token__short_interpolation = 29,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__line_break] = sym__line_break,
  [ts_external_token__no_line_break] = sym__no_line_break,
  [ts_external_token_simple_symbol] = sym_simple_symbol,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__symbol_start] = sym__symbol_start,
  [ts_external_token__subshell_start] = sym__subshell_start,
  [ts_external_token__regex_start] = sym__regex_start,
  [ts_external_token__string_array_start] = sym__string_array_start,
  [ts_external_token__symbol_array_start] = sym__symbol_array_start,
  [ts_external_token__heredoc_body_start] = sym__heredoc_body_start,
  [ts_external_token_string_content] = sym_string_content,
  [ts_external_token_heredoc_content] = sym_heredoc_content,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token_heredoc_beginning] = sym_heredoc_beginning,
  [ts_external_token_SLASH] = anon_sym_SLASH,
  [ts_external_token__block_ampersand] = sym__block_ampersand,
  [ts_external_token__splat_star] = sym__splat_star,
  [ts_external_token__unary_minus] = sym__unary_minus,
  [ts_external_token__unary_minus_num] = sym__unary_minus_num,
  [ts_external_token__binary_minus] = sym__binary_minus,
  [ts_external_token__binary_star] = sym__binary_star,
  [ts_external_token__singleton_class_left_angle_left_langle] = sym__singleton_class_left_angle_left_langle,
  [ts_external_token_hash_key_symbol] = sym_hash_key_symbol,
  [ts_external_token__identifier_suffix] = sym__identifier_suffix,
  [ts_external_token__constant_suffix] = sym__constant_suffix,
  [ts_external_token__hash_splat_star_star] = sym__hash_splat_star_star,
  [ts_external_token__binary_star_star] = sym__binary_star_star,
  [ts_external_token__element_reference_bracket] = sym__element_reference_bracket,
  [ts_external_token__short_interpolation] = sym__short_interpolation,
};

static const bool ts_external_scanner_states[42][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__no_line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_string_content] = true,
    [ts_external_token_heredoc_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [2] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [3] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [4] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [5] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
  },
  [6] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [7] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [8] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [9] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
  },
  [10] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token_hash_key_symbol] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__hash_splat_star_star] = true,
  },
  [11] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [12] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [13] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [14] = {
    [ts_external_token__no_line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [15] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [16] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__no_line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [17] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [18] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [19] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [20] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [21] = {
    [ts_external_token__line_break] = true,
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
  },
  [22] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [23] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus_num] = true,
  },
  [24] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [25] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [26] = {
    [ts_external_token_simple_symbol] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [27] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [28] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [29] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [30] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__binary_star_star] = true,
  },
  [31] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [32] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
  },
  [33] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [34] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__identifier_suffix] = true,
    [ts_external_token__constant_suffix] = true,
  },
  [35] = {
    [ts_external_token__heredoc_body_start] = true,
  },
  [36] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [37] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_string_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [38] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_content] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [39] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__element_reference_bracket] = true,
  },
  [40] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_string_content] = true,
    [ts_external_token__short_interpolation] = true,
  },
  [41] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_end] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_ruby_external_scanner_create(void);
void tree_sitter_ruby_external_scanner_destroy(void *);
bool tree_sitter_ruby_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_ruby_external_scanner_serialize(void *, char *);
void tree_sitter_ruby_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_ruby(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_ruby_external_scanner_create,
      tree_sitter_ruby_external_scanner_destroy,
      tree_sitter_ruby_external_scanner_scan,
      tree_sitter_ruby_external_scanner_serialize,
      tree_sitter_ruby_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
